-- name=rm_chapel
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_chapel";
  --------------------------------------------------------------------------------------------
  private.dlg_action = "";
  private.dlg_lipsync = "";
  private.Init_Subroom();
  private.Init_Stainedglass();
  --------------------------------------------------------------------------------------------
  -- function get_feather () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_feather" ] = {
        type = "get",
        get_obj = "spr_altar_feather",
        room = private.room_objname,
        zz = "zz_altar",
        zz_gate = "gzz_chapel_altar"
    };
    --------------------------------------------------------------------------------------------
  local get_feather_inv = function ()
  
    interface.InventoryItemAdd( "inv_feather", "spr_altar_feather" );
  
  end;
  
  local get_feather_end = function ()
  
    ObjDelete( "gfx_altar_feather" );
    ObjDelete( "spr_altar_feather_sh" );
    
    if cmn.IsEventDone("get_clerksamulet") then
      ObjDelete( "gzz_chapel_altar" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_feather", get_feather_inv );
  cmn.AddSubscriber( "get_feather", get_feather_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_seal () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_seal" ] = {
        type = "get",
        get_obj = "spr_altar_seal",
        room = private.room_objname,
        zz = "zz_altar",
        zz_gate = "gzz_chapel_altar"
    };
    --------------------------------------------------------------------------------------------
  local get_seal_inv = function ()
  
    interface.InventoryItemAdd( "inv_seal", "spr_altar_seal" );
  
  end;
  
  local get_seal_end = function ()
  
    ObjDelete( "gfx_altar_seal" );
    ObjDelete( "spr_altar_seal_sh" );

    ObjDelete( "spr_chapel_altar_seal" );
  
  end;
  
  cmn.AddSubscriber( "get_seal", get_seal_inv );
  cmn.AddSubscriber( "get_seal", get_seal_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletbook3 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_amuletbook3" ] = {
        type = "get",
        get_obj = "spr_altar_amuletbook4",
        room = private.room_objname,
        zz = "zz_altar",
        zz_gate = "gzz_chapel_altar"
    };
    --------------------------------------------------------------------------------------------
  local get_amuletbook3_inv = function ()
  
    interface.InventoryItemAdd( "inv_amuletbook", "spr_altar_amuletbook4", function () cmn.GetMultyObject( 'amuletbook', 4 ); end );
  
  end;
  
  local get_amuletbook3_end = function ()
  
    ObjDelete( "gfx_altar_amuletbook4" );
    ObjDelete( "spr_altar_amuletbook4_sh" );

    ObjDelete( "spr_chapel_altar_amuletbook4_5" );
  
  end;
  
  cmn.AddSubscriber( "get_amuletbook3", get_amuletbook3_inv );
  cmn.AddSubscriber( "get_amuletbook3", get_amuletbook3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_clerksamulet () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_clerksamulet" ] = {
        type = "get",
        get_obj = "spr_altar_clerksamulet",
        room = private.room_objname,
        zz = "zz_altar",
        zz_gate = "gzz_chapel_altar"
    };
    --------------------------------------------------------------------------------------------
  local get_clerksamulet_inv = function ()
  
    interface.InventoryItemAdd( "inv_clerksamulet", "spr_altar_clerksamulet" );
  
  end;
  
  local get_clerksamulet_end = function ()
  
    ObjDelete( "gfx_altar_clerksamulet" );
    ObjDelete( "spr_altar_clerksamulet_sh" );

    
    if cmn.IsEventDone("get_feather") then
      ObjDelete( "gzz_chapel_altar" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_clerksamulet", get_clerksamulet_inv );
  cmn.AddSubscriber( "get_clerksamulet", get_clerksamulet_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_gravediggerfigurine () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_gravediggerfigurine" ] = {
        type = "get",
        get_obj = "spr_book_gravediggerfigurine",
        room = private.room_objname,
        zz = "zz_book",
        zz_gate = "gzz_chapel_book"
    };
    --------------------------------------------------------------------------------------------
  local get_gravediggerfigurine_inv = function ()
  
    if cmn.IsEventDone("win_stainedglass") then
      ObjDelete("spr_book_gravediggerfigurine");
      interface.InventoryItemAdd( "inv_gravediggerfigurine", "spr_book_gravediggerfigurine_2" );
    else 
      ObjDelete("spr_book_gravediggerfigurine_2");
      interface.InventoryItemAdd( "inv_gravediggerfigurine", "spr_book_gravediggerfigurine" );
    end;
  
  end;
  
  local get_gravediggerfigurine_end = function ()
  
    ObjDelete( "gfx_book_gravediggerfigurine" );
    ObjDelete( "spr_book_gravediggerfigurine_sh" );
    
    ObjDelete( "gfx_book_gravediggerfigurine_2" );
    ObjDelete( "spr_book_gravediggerfigurine_sh_2" );

    ObjDelete( "spr_chapel_book_gravediggerfigurine" );
  
  end;
  
  cmn.AddSubscriber( "get_gravediggerfigurine", get_gravediggerfigurine_inv );
  cmn.AddSubscriber( "get_gravediggerfigurine", get_gravediggerfigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stainedglassshard1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_stainedglassshard1" ] = {
        type = "get",
        get_obj = "spr_book_stainedglassshard1",
        room = private.room_objname,
        zz = "zz_book",
        zz_gate = "gzz_chapel_book"
    };
    --------------------------------------------------------------------------------------------
  local get_stainedglassshard1_inv = function ()
  
    interface.InventoryItemAdd( "inv_stainedglassshard", "spr_book_stainedglassshard1", function () cmn.GetMultyObject( 'stainedglassshard', 3 ); end );
  
  end;
  
  local get_stainedglassshard1_end = function ()
  
    ObjDelete( "gfx_book_stainedglassshard1" );
    ObjDelete( "spr_book_stainedglassshard1_sh" );
    
    ObjDelete( "spr_book_stainedglassshard1_2" );
    ObjDelete( "spr_book_stainedglassshard1_sh_2" );

    ObjDelete( "spr_chapel_book_stainedglassshard1" );
  
  end;
  
  cmn.AddSubscriber( "get_stainedglassshard1", get_stainedglassshard1_inv );
  cmn.AddSubscriber( "get_stainedglassshard1", get_stainedglassshard1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletbook2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_amuletbook2" ] = {
        type = "get",
        get_obj = "spr_stainedglass_amuletbook3",
        room = private.room_objname,
        zz = "zz_stainedglass",
        zz_gate = "gzz_chapel_stainedglass"
    };
    --------------------------------------------------------------------------------------------
  local get_amuletbook2_inv = function ()
  
    interface.InventoryItemAdd( "inv_amuletbook", "spr_stainedglass_amuletbook3", function () cmn.GetMultyObject( 'amuletbook', 4 ); end );
  
  end;
  
  local get_amuletbook2_end = function ()
  
    ObjDelete( "gfx_stainedglass_amuletbook3" );
    ObjDelete( "spr_stainedglass_amuletbook3_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_amuletbook2", get_amuletbook2_inv );
  cmn.AddSubscriber( "get_amuletbook2", get_amuletbook2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletbook4 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_amuletbook4" ] = {
        type = "get",
        get_obj = "spr_clerksdesk_amuletbook5",
        room = private.room_objname,
        zz = "zz_clerksdesk",
        zz_gate = "gzz_chapel_clerksdesk"
    };
    --------------------------------------------------------------------------------------------
  local get_amuletbook4_inv = function ()
  
    interface.InventoryItemAdd( "inv_amuletbook", "spr_clerksdesk_amuletbook5", function () cmn.GetMultyObject( 'amuletbook', 4 ); end );
  
  end;
  
  local get_amuletbook4_end = function ()
  
    ObjDelete( "gfx_clerksdesk_amuletbook5" );
    ObjDelete( "spr_clerksdesk_amuletbook5_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_amuletbook4", get_amuletbook4_inv );
  cmn.AddSubscriber( "get_amuletbook4", get_amuletbook4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ink () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_ink" ] = {
        type = "get",
        get_obj = "spr_clerksdesk_ink",
        room = private.room_objname,
        zz = "zz_clerksdesk",
        zz_gate = "gzz_chapel_clerksdesk"
    };
    --------------------------------------------------------------------------------------------
  local get_ink_inv = function ()
  
    interface.InventoryItemAdd( "inv_ink", "spr_clerksdesk_ink" );
  
  end;
  
  local get_ink_end = function ()
  
    ObjDelete( "gfx_clerksdesk_ink" );
    ObjDelete( "spr_clerksdesk_ink_sh" );
    ObjDelete( "spr_chapel_clerksdesk_ink" );
    
    if cmn.IsEventDone("get_stainedglassshard3") then
      ObjDelete( "gzz_chapel_clerksdesk" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_ink", get_ink_inv );
  cmn.AddSubscriber( "get_ink", get_ink_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_badge1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_badge1" ] = {
        type = "get",
        get_obj = "spr_clerksdesk_badge1",
        room = private.room_objname,
        zz = "zz_clerksdesk",
        zz_gate = "gzz_chapel_clerksdesk"
    };
    --------------------------------------------------------------------------------------------
  local get_badge1_inv = function ()
  
    interface.InventoryItemAdd( "inv_badge1", "spr_clerksdesk_badge1" );
  
  end;
  
  local get_badge1_end = function ()
  
    ObjDelete( "gfx_clerksdesk_badge1" );
    ObjDelete( "spr_clerksdesk_badge1_sh" );
    
    ObjDelete( "spr_chapel_clerksdesk_star" );
  
  end;
  
  cmn.AddSubscriber( "get_badge1", get_badge1_inv );
  cmn.AddSubscriber( "get_badge1", get_badge1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stainedglassshard3 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_stainedglassshard3" ] = {
        type = "get",
        get_obj = "spr_clerksdesk_stainedglassshard3",
        room = private.room_objname,
        zz = "zz_clerksdesk",
        zz_gate = "gzz_chapel_clerksdesk"
    };
    --------------------------------------------------------------------------------------------
  local get_stainedglassshard3_inv = function ()
  
    interface.InventoryItemAdd( "inv_stainedglassshard", "spr_clerksdesk_stainedglassshard3", function () cmn.GetMultyObject( 'stainedglassshard', 3 ); end );
  
  end;
  
  local get_stainedglassshard3_end = function ()
  
    ObjDelete( "gfx_clerksdesk_stainedglassshard3" );
    ObjDelete( "spr_clerksdesk_stainedglassshard3_sh" );

    ObjDelete( "spr_chapel_clerksdesk_stainedglassshard3" );
    
    if cmn.IsEventDone("get_ink") then
      ObjDelete( "gzz_chapel_clerksdesk" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_stainedglassshard3", get_stainedglassshard3_inv );
  cmn.AddSubscriber( "get_stainedglassshard3", get_stainedglassshard3_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_amuletbook1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_amuletbook1" ] = {
      type = "get",
      get_obj = "spr_chapel_amuletbook1",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_amuletbook1_inv = function ()
  
    interface.InventoryItemAdd( "inv_amuletbook", "spr_chapel_amuletbook1", function () cmn.GetMultyObject( 'amuletbook', 4 ); end );
  
  end;
  local get_amuletbook1_mid = function ()
  
    ObjDelete( "spr_chapel_amuletbook1_sh" );
    ObjDelete( "gfx_chapel_amuletbook1" );
  
  end;
  local get_amuletbook1_end = function ()
  
    ObjDelete( "obj_chapel_dialog_blackqueen0" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amuletbook1", get_amuletbook1_inv );
  cmn.AddSubscriber( "get_amuletbook1_inv", get_amuletbook1_inv, private.room_objname );
  cmn.AddSubscriber( "get_amuletbook1", get_amuletbook1_mid, private.room_objname );
  cmn.AddSubscriber( "get_amuletbook1_mid", get_amuletbook1_mid, private.room_objname );
  cmn.AddSubscriber( "get_amuletbook1", get_amuletbook1_end, private.room_objname );
  cmn.AddSubscriber( "get_amuletbook1_end", get_amuletbook1_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function use_scoopwithcoals () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_scoopwithcoals" ] = {
        type = "use",
        inv_obj = "inv_scoopwithcoals",
        use_place = "obj_altar_use_scoopwithcoals",
        room = private.room_objname,
        zz = "zz_altar",
        zz_gate = "gzz_chapel_altar"
    };
  --------------------------------------------------------------------------------------------
  local use_scoopwithcoals_inv = function ()
  
    interface.InventoryItemRemove( "inv_scoopwithcoals" );
  
  end;
  local use_scoopwithcoals_beg = function ()
  
    ObjDelete( "obj_altar_use_scoopwithcoals" );
  
  end;
  local use_scoopwithcoals_end = function ()
    
    ObjDelete( "anm_altar_use_scoop" );
    ObjDelete("anm_altar_box_touch");
    ObjDelete("anm_altar_box_open_1");

    ObjDelete( "spr_chapel_altar_cup" );
  
    ObjMultiSet( { {"obj_altar_in_box", { alp = 1, input = 1 }},
                   {"anm_altar_box_open", { alp = 1, frame = 300 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scoopwithcoals", use_scoopwithcoals_beg, private.room_objname );
  cmn.AddSubscriber( "use_scoopwithcoals", use_scoopwithcoals_inv );
  cmn.AddSubscriber( "use_scoopwithcoals", use_scoopwithcoals_end, private.room_objname );
  cmn.AddSubscriber( "use_scoopwithcoals_inv", use_scoopwithcoals_inv, private.room_objname );
  cmn.AddSubscriber( "use_scoopwithcoals_beg", use_scoopwithcoals_beg, private.room_objname );
  cmn.AddSubscriber( "use_scoopwithcoals_end", use_scoopwithcoals_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tin () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_tin" ] = {
        type = "use",
        inv_obj = "inv_tin",
        use_place = "obj_altar_use_tin",
        room = private.room_objname,
        zz = "zz_altar",
        zz_gate = "gzz_chapel_altar"
    };
  --------------------------------------------------------------------------------------------
  local use_tin_inv = function ()
  
    interface.InventoryItemRemove( "inv_tin" );
  
  end;
  local use_tin_beg = function ()
  
    ObjDelete( "obj_altar_use_tin" );
  
  end;
  local use_tin_end = function ()
    
    ObjDelete("anm_altar_use_tin");
  
    ObjMultiSet( { {"anm_altar_use_scoop", { alp = 1 }},
                   {"obj_altar_use_scoopwithcoals", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tin", use_tin_beg, private.room_objname );
  cmn.AddSubscriber( "use_tin", use_tin_inv );
  cmn.AddSubscriber( "use_tin", use_tin_end, private.room_objname );
  cmn.AddSubscriber( "use_tin_inv", use_tin_inv, private.room_objname );
  cmn.AddSubscriber( "use_tin_beg", use_tin_beg, private.room_objname );
  cmn.AddSubscriber( "use_tin_end", use_tin_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletbook () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_amuletbook" ] = {
        type = "use",
        inv_obj = "inv_amuletbook",
        use_place = "obj_book_use_amuletbook",
        room = private.room_objname,
        zz = "zz_book",
        zz_gate = "gzz_chapel_book"
    };
  --------------------------------------------------------------------------------------------
  local use_amuletbook_inv = function ()
  
    interface.InventoryItemRemove( "inv_amuletbook" );
  
  end;
  local use_amuletbook_beg = function ()
  
    ObjDelete( "obj_book_use_amuletbook" );
  
  end;
  local use_amuletbook_end = function ()
    
    ObjDelete("anm_book_closed_touch");
    ObjDelete("anm_book_use_amulets");
    
    ObjDelete("anm_book_closed_touch_2");
    ObjDelete("anm_book_use_amulets_2");

    ObjDelete( "spr_chapel_book_book_closed" );
    ObjDelete( "spr_chapel_book_book_closed_2" );
  
    ObjMultiSet( { {"spr_chapel_book_gravediggerfigurine", { alp = 1 }},
                   {"spr_chapel_book_stainedglassshard1", { alp = 1 }} } );
    
    if cmn.IsEventDone("win_stainedglass") then
      ObjDelete( "anm_book_open" );
      ObjDelete( "spr_chapel_book_book_opn" );
      ObjMultiSet( { {"obj_book_use_ink", { input = 1 }},
                     {"obj_book_use_feather", { input = 1 }},
                     {"anm_book_open_2", { input = 1, alp = 1, frame = 300 }},
                     {"spr_chapel_book_book_opn2", { alp = 1 }} } );
    else 
      ObjMultiSet( { {"anm_book_open", { input = 1, alp = 1, frame = 300 }},
                     {"obj_book_book_bbt", { input = 1 }},
                     {"spr_chapel_book_book_opn", { alp = 1 }} } );   
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amuletbook", use_amuletbook_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletbook", use_amuletbook_inv );
  cmn.AddSubscriber( "use_amuletbook", use_amuletbook_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletbook_inv", use_amuletbook_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletbook_beg", use_amuletbook_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletbook_end", use_amuletbook_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ink () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_ink" ] = {
        type = "use",
        inv_obj = "inv_ink",
        use_place = "obj_book_use_ink",
        room = private.room_objname,
        zz = "zz_book",
        zz_gate = "gzz_chapel_book"
    };
  --------------------------------------------------------------------------------------------
  local use_ink_inv = function ()
  
    interface.InventoryItemRemove( "inv_ink" );
  
  end;
  local use_ink_beg = function ()
  
    ObjDelete( "obj_book_use_ink" );

    ObjSet( "spr_chapel_book_ink", { alp = 1 } );

    if cmn.IsEventDone("use_feather") then

      ObjDelete( "spr_chapel_book_ink_cup" );
      ObjDelete( "spr_chapel_book_feather" );
      ObjDelete( "obj_chapel_pentagramm_bbt" );
  
      ObjMultiSet( {
        { "spr_chapel_book_ink_cup2", { alp = 1 } },
        { "spr_chapel_book_sign", { alp = 1 } }
      } );

    end;

  end;
  local use_ink_end = function ()
  
    if cmn.IsEventDone("use_feather") then

      ObjDelete( "obj_book_ink_and_feather" );
      ObjDelete("obj_chapel_dialog_blackqueen1");
      ObjDelete("gzz_chapel_book");

      ObjMultiSet( {
        { "anm_chapel_queen_activation", { frame = 400 } },
        { "obj_chapel_use_firenecklace", { alp = 1, input = true } },
        { "grm_chapel_worldoffire", { alp = 1, input = true } }
      } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_chapel_worldoffire_focus");
      end;

    else 
      ObjSet("anm_book_use_ink",  { alp = 1, frame = 300 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ink", use_ink_beg, private.room_objname );
  cmn.AddSubscriber( "use_ink", use_ink_inv );
  cmn.AddSubscriber( "use_ink", use_ink_end, private.room_objname );
  cmn.AddSubscriber( "use_ink_inv", use_ink_inv, private.room_objname );
  cmn.AddSubscriber( "use_ink_beg", use_ink_beg, private.room_objname );
  cmn.AddSubscriber( "use_ink_end", use_ink_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_feather () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_feather" ] = {
        type = "use",
        inv_obj = "inv_feather",
        use_place = "obj_book_use_feather",
        room = private.room_objname,
        zz = "zz_book",
        zz_gate = "gzz_chapel_book"
    };
  --------------------------------------------------------------------------------------------
  local use_feather_inv = function ()
  
    interface.InventoryItemRemove( "inv_feather" );
  
  end;
  local use_feather_beg = function ()
  
    ObjDelete( "obj_book_use_feather" );

    ObjSet( "spr_chapel_book_feather", { alp = 1 } );

    if cmn.IsEventDone("use_ink") then

      ObjDelete( "spr_chapel_book_ink_cup" );
      ObjDelete( "spr_chapel_book_feather" );
      ObjDelete( "obj_chapel_pentagramm_bbt" );
  
      ObjMultiSet( {
        { "spr_chapel_book_ink_cup2", { alp = 1 } },
        { "spr_chapel_book_sign", { alp = 1 } }
      } );

    end;
  
  end;
  local use_feather_end = function ()

    if cmn.IsEventDone("use_ink") then

      ObjDelete( "obj_book_ink_and_feather" );
      ObjDelete("obj_chapel_dialog_blackqueen1");
      ObjDelete("gzz_chapel_book");

      ObjMultiSet( {
        { "anm_chapel_queen_activation", { frame = 400 } },
        { "obj_chapel_use_firenecklace", { alp = 1, input = true } },
        { "grm_chapel_worldoffire", { alp = 1, input = true } }
      } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_chapel_worldoffire_focus");
      end;

    else 
      ObjSet("anm_book_use_feather",  { alp = 1, frame = 300 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_feather", use_feather_beg, private.room_objname );
  cmn.AddSubscriber( "use_feather", use_feather_inv );
  cmn.AddSubscriber( "use_feather", use_feather_end, private.room_objname );
  cmn.AddSubscriber( "use_feather_inv", use_feather_inv, private.room_objname );
  cmn.AddSubscriber( "use_feather_beg", use_feather_beg, private.room_objname );
  cmn.AddSubscriber( "use_feather_end", use_feather_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_stainedglassshard () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_stainedglassshard" ] = {
        type = "use",
        inv_obj = "inv_stainedglassshard",
        use_place = "obj_stainedglass_use_stainedglassshard",
        room = private.room_objname,
        zz = "zz_stainedglass",
        zz_gate = "gzz_chapel_stainedglass"
    };
  --------------------------------------------------------------------------------------------
  local use_stainedglassshard_inv = function ()
  
    interface.InventoryItemRemove( "inv_stainedglassshard" );
  
  end;
  local use_stainedglassshard_beg = function ()
  
    ObjDelete( "obj_stainedglass_use_stainedglassshard" );
    ObjDelete( "anm_stainedglass_glass_touch" );
    
    ObjMultiSet( { {"obj_stainedglass_window", { alp = 1 }},
                   {"obj_stainedglass_mosaic_parts", { alp = 1 }} } );
    
  end;
  local use_stainedglassshard_end = function ()
  
    ObjSet("obj_stainedglass_mosaic_parts",  { input = 1 });
    
    for i = 1, 3, 1 do
      ObjSet("spr_stainedglass_picture_"..private.zz_stainedglass.pics_for_use[i],  { alp = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_stainedglassshard", use_stainedglassshard_beg, private.room_objname );
  cmn.AddSubscriber( "use_stainedglassshard", use_stainedglassshard_inv );
  cmn.AddSubscriber( "use_stainedglassshard", use_stainedglassshard_end, private.room_objname );
  cmn.AddSubscriber( "use_stainedglassshard_inv", use_stainedglassshard_inv, private.room_objname );
  cmn.AddSubscriber( "use_stainedglassshard_beg", use_stainedglassshard_beg, private.room_objname );
  cmn.AddSubscriber( "use_stainedglassshard_end", use_stainedglassshard_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_seal () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_seal" ] = {
        type = "use",
        inv_obj = "inv_seal",
        use_place = "obj_clerksdesk_use_seal",
        room = private.room_objname,
        zz = "zz_clerksdesk",
        zz_gate = "gzz_chapel_clerksdesk"
    };
  --------------------------------------------------------------------------------------------
  local use_seal_inv = function ()
  
    interface.InventoryItemRemove( "inv_seal" );
  
  end;
  local use_seal_beg = function ()
  
    ObjDelete( "obj_clerksdesk_use_seal" );
    ObjDelete( "anm_clerksdesk_drawer_touch" );
  
  end;
  local use_seal_end = function ()
  
    ObjMultiSet( { {"anm_clerksdesk_drawer_open", { input = 1, alp = 1, frame = 300 }},
                   {"anm_clerksdesk_use_seal", { alp = 1, frame = 300, pos_z = 3 }},
                   {"spr_chapel_clerksdesk_secret_box", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_seal", use_seal_beg, private.room_objname );
  cmn.AddSubscriber( "use_seal", use_seal_inv );
  cmn.AddSubscriber( "use_seal", use_seal_end, private.room_objname );
  cmn.AddSubscriber( "use_seal_inv", use_seal_inv, private.room_objname );
  cmn.AddSubscriber( "use_seal_beg", use_seal_beg, private.room_objname );
  cmn.AddSubscriber( "use_seal_end", use_seal_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_clerksamulet () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_clerksamulet" ] = {
        type = "use",
        inv_obj = "inv_clerksamulet",
        use_place = "obj_clerksdesk_use_clerksamulet",
        room = private.room_objname,
        zz = "zz_clerksdesk",
        zz_gate = "gzz_chapel_clerksdesk"
    };
  --------------------------------------------------------------------------------------------
  local use_clerksamulet_inv = function ()
  
    interface.InventoryItemRemove( "inv_clerksamulet" );
  
  end;
  local use_clerksamulet_beg = function ()
  
    ObjDelete( "obj_clerksdesk_use_clerksamulet" );
    ObjDelete( "anm_clerksdesk_box_touch" );
  
  end;
  local use_clerksamulet_end = function ()

    ObjDelete( "spr_chapel_clerksdesk_cup" );

    ObjMultiSet( {
      { "spr_chapel_clerksdesk_opened_cup", { alp = 1 } },
      { "spr_chapel_clerksdesk_ink", { alp = 1 } },
      { "spr_chapel_clerksdesk_stainedglassshard3", { alp = 1 } },
      { "spr_chapel_clerksdesk_star", { alp = 1 } }
    } );
  
    ObjSet( "anm_clerksdesk_box_open", { input = 1, alp = 1, frame = 300 } );
    ObjDelete( "anm_clerksdesk_use_amulet" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_clerksamulet", use_clerksamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_clerksamulet", use_clerksamulet_inv );
  cmn.AddSubscriber( "use_clerksamulet", use_clerksamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_clerksamulet_inv", use_clerksamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_clerksamulet_beg", use_clerksamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_clerksamulet_end", use_clerksamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_firenecklace () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_firenecklace" ] = {
        type = "use",
        inv_obj = "inv_firenecklace",
        use_place = "obj_chapel_use_firenecklace",
        room = private.room_objname
    };
  --------------------------------------------------------------------------------------------
  local use_firenecklace_inv = function ()
  
    interface.InventoryItemRemove( "inv_firenecklace" );
  
  end;
  local use_firenecklace_beg = function ()
  
    ObjDelete( "obj_chapel_use_firenecklace" );
  
  end;
  local use_firenecklace_end = function ()
    
    ObjDelete("vid_chapel_dialog_blackqueen2_lipsync1");
    ObjDelete("vid_chapel_dialog_blackqueen2_lipsync2");
  
    ObjDelete( "obj_chapel_dialog_blackqueen2" );

    ObjMultiSet( {
      { "obj_chapel_use_crownofdarkness",  { alp = 1, input = 1 } },
      { "spr_chapel_black_queen_necklace", { alp = 1 } },
      { "spr_chapel_door_open", { alp = 1 } },
      { "gho_chapel_toys", { input = 1, alp = 1, active = 1 } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_firenecklace", use_firenecklace_beg, private.room_objname );
  cmn.AddSubscriber( "use_firenecklace", use_firenecklace_inv );
  cmn.AddSubscriber( "use_firenecklace", use_firenecklace_end, private.room_objname );
  cmn.AddSubscriber( "use_firenecklace_inv", use_firenecklace_inv, private.room_objname );
  cmn.AddSubscriber( "use_firenecklace_beg", use_firenecklace_beg, private.room_objname );
  cmn.AddSubscriber( "use_firenecklace_end", use_firenecklace_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crownofdarkness () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_crownofdarkness" ] = {
        type = "use",
        inv_obj = "inv_crownofdarkness",
        use_place = "obj_chapel_use_crownofdarkness",
        room = private.room_objname
    };
  --------------------------------------------------------------------------------------------
  local use_crownofdarkness_inv = function ()
  
    interface.InventoryItemRemove( "inv_crownofdarkness" );
    
    int_map_impl.BlockRoom( "rm_outsidechapel" );
    int_map_impl.BlockRoom( "rm_cemetery" );
    int_map_impl.BlockRoom( "rm_worldofdarkness" );
  
  end;
  local use_crownofdarkness_beg = function ()
  
    ObjDelete( "obj_chapel_use_crownofdarkness" );
  
  end;
  local use_crownofdarkness_end = function ()
  
    ObjDelete( "obj_chapel_dialog_blackqueen3" );
    ObjSet( "spr_chapel_queen_crown", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crownofdarkness", use_crownofdarkness_beg, private.room_objname );
  cmn.AddSubscriber( "use_crownofdarkness", use_crownofdarkness_inv );
  cmn.AddSubscriber( "use_crownofdarkness", use_crownofdarkness_end, private.room_objname );
  cmn.AddSubscriber( "use_crownofdarkness_inv", use_crownofdarkness_inv, private.room_objname );
  cmn.AddSubscriber( "use_crownofdarkness_beg", use_crownofdarkness_beg, private.room_objname );
  cmn.AddSubscriber( "use_crownofdarkness_end", use_crownofdarkness_end, private.room_objname );


  --------------------------------------------------------------------------------------------
  -- function opn_chapel () end;
  --------------------------------------------------------------------------------------------
  local opn_chapel_map = function ()
  
    int_map_impl.OpenRoom( "rm_chapel" );
    interface_impl.SetCurrentGlobalTask( 4 );
  
  end;
  local opn_chapel_loc = function ()
    
    ObjDelete("vid_chapel_dialog_blackqueen0_lipsync1");
    ObjDelete("vid_chapel_dialog_blackqueen0_lipsync2");
    
    ObjDelete("anm_chapel_dialog_blackqueen0_body");
    ObjDelete("anm_chapel_dialog_blackqueen0_hand_give");
  
    ObjAttach("obj_chapel_dialog_blackqueen0", "rm_chapel");
    
    ObjMultiSet( { {"obj_chapel_dialog_blackqueen0", { alp = 1, input = 1 }},
                   {"obj_chapel_dialog_blackqueen0_hand_2", { alp = 1, input = 1 }},
                   {"anm_chapel_dialog_blackqueen0_head", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_chapel", opn_chapel_map );
  cmn.AddSubscriber( "opn_chapel_map", opn_chapel_map );
  cmn.AddSubscriber( "opn_chapel", opn_chapel_loc, private.room_objname );
  cmn.AddSubscriber( "opn_chapel_loc", opn_chapel_loc, private.room_objname );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_book" );
  subroom.Define( "zz_stainedglass" );
  
  function zz_book.Close()
    
    cmn.HideNote( 0 );
    
    if cmn.IsEventDone("use_ink") and cmn.IsEventDone("use_feather") then
      ObjSet( "anm_chapel_queen_activation", { endtrig = function () public.dialog_queen_open( 1 ); end, playing = true } );
    end;
    
  end;
  
  function zz_stainedglass.PreOpen()
    
    if not(cmn.IsEventDone( "win_stainedglass" )) then
      private.zz_stainedglass.DrawScene();
    end;

  end;
  
  function zz_stainedglass.Open()
    
    if cmn.IsEventDone( "use_stainedglassshard" ) and not(cmn.IsEventDone( "win_stainedglass" )) then
      cmn.MiniGameShow();
      private.zz_stainedglass.CheckWin();
    end;

  end;
  
  function zz_stainedglass.PreClose()
    
    if cmn.IsEventDone("use_stainedglassshard") and not cmn.IsEventDone("win_stainedglass") then
      cmn.MiniGameHide("stainedglass");
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_stainedglass" ].state) then 
    private.zz_stainedglass.StartConditions();
  end;
  private.zz_stainedglass.state = ng_global.progress[ ng_global.currentprogress ][ "win_stainedglass" ].state;
  private.zz_stainedglass.state_pos = ng_global.progress[ ng_global.currentprogress ][ "win_stainedglass" ].state_pos;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_chapel();
  
  if cmn.IsEventDone("opn_chapel") and not cmn.IsEventDone("get_amuletbook1") then
    --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    common_impl.current_dialog = "obj_chapel_dialog_blackqueen0";
    ObjSet("anm_chapel_dialog_blackqueen0_hand_2",  { playing = 1 });
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level1/audio/env/aud_chapel_env");
  cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_chapel_env");
  
  if cmn.IsEventDone("use_ink") and cmn.IsEventDone("use_feather") and not cmn.IsEventDone("opn_worldoffire") or
  cmn.IsEventDone("use_crownofdarkness") then
    cmn.Lock( 1 );
    ObjSet("rm_chapel",  { color_r = 0, color_g = 0, color_b = 0 });
  else 
    ObjSet("rm_chapel",  { color_r = 1, color_g = 1, color_b = 1 });
  end;
  
  if not cmn.IsEventDone("opn_chapel") then
    cmn.Lock( 1 );
  end;
  
  --анимация морф-оъекта
  if cmn.IsCollectableAvailible(2) then
    private.AnimMorphObject();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_scoopwithcoals()

  local item = "inv_scoopwithcoals";

  if cmn.ApplyObj( item, "gzz_chapel_altar" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_altar" );

  elseif ( cmn.ApplyObj( item, "obj_altar_use_scoopwithcoals" ) and cmn.IsEventDone("use_tin") ) then

    cmn.CallEventHandler( "use_scoopwithcoals_inv" );
    cmn.CallEventHandler( "use_scoopwithcoals_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_scoopwithcoals" );
      cmn.CallEventHandler( "use_scoopwithcoals_end" );
    
    end;
    
    local anm_open = function ()
      
      ObjDelete("anm_altar_box_open_1");
      
      ObjMultiSet( { {"anm_altar_box_open",  { alp = 1, playing = 1, endtrig = func_after }},
                     {"obj_altar_in_box", { alp = 1 }} } );
      
    end;
    
    local anm_open_1 = function ()
      
      ObjDelete("anm_altar_use_scoop");
      ObjDelete("anm_altar_box_touch");

      ObjSet("anm_altar_box_open_1",  { alp = 1, playing = 1, endtrig = anm_open });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_put_coal_box_butterfly");

    ObjSet("anm_altar_use_scoop",  { alp = 1, playing = 1, endtrig = anm_open_1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_tin()

  local item = "inv_tin";

  if cmn.ApplyObj( item, "gzz_chapel_altar" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_altar" );

  elseif ( cmn.ApplyObj( item, "obj_altar_use_tin" ) ) then

    cmn.CallEventHandler( "use_tin_inv" );
    cmn.CallEventHandler( "use_tin_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_tin" );
      cmn.CallEventHandler( "use_tin_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_put_piece_box_butterfly");

    ObjSet("anm_altar_use_tin",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_amuletbook()

  local item = "inv_amuletbook";

  if cmn.ApplyObj( item, "gzz_chapel_book" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_book", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_book_use_amuletbook" ) and cmn.CheckMultiObject( "amuletbook", 4 ) ) then

    cmn.CallEventHandler( "use_amuletbook_inv" );
    cmn.CallEventHandler( "use_amuletbook_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_amuletbook" );
      cmn.CallEventHandler( "use_amuletbook_end" );
    
    end;
    
    local anm_open = function ()
      
      ObjDelete("anm_book_closed_touch");
      ObjDelete("anm_book_use_amulets");
      
      ObjDelete("anm_book_closed_touch_2");
      ObjDelete("anm_book_use_amulets_2");
      
      if not cmn.IsEventDone("win_stainedglass") then
        ObjSet("anm_book_open",  { alp = 1, playing = 1, endtrig = func_after });
      else 
        ObjSet("anm_book_open_2",  { alp = 1, playing = 1, endtrig = func_after });
      end;
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_pieces_book");

    if not cmn.IsEventDone("win_stainedglass") then
      ObjSet("anm_book_use_amulets",  { alp = 1, playing = 1, endtrig = anm_open });
    else 
      ObjSet("anm_book_use_amulets_2",  { alp = 1, playing = 1, endtrig = anm_open });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_ink()

  local item = "inv_ink";

  if cmn.ApplyObj( item, "gzz_chapel_book" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_book", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_book_use_ink" ) and cmn.IsEventDone("win_stainedglass") ) then

    cmn.CallEventHandler( "use_ink_inv" );
    cmn.CallEventHandler( "use_ink_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_ink" );
      
      if cmn.IsEventDone("use_feather") then
        cmn.Lock( 1 );
        private.dlg_action = "use_ink_end";
        common.CloseSubRoom();
      else 
        cmn.CallEventHandler( "use_ink_end" );
      end;
    
    end;
    
    local anm_book = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_put_pen_book");
      
      ObjDelete("obj_book_ink_and_feather");
      
      ObjAnimate("obj_book_ink_and_feather", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      ObjSet("anm_book_ink",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_put_liquid_book");

    if cmn.IsEventDone("use_feather") then
      ObjSet("anm_book_use_ink",  { alp = 1, playing = 1, endtrig = anm_book });
    else 
      ObjSet("anm_book_use_ink",  { alp = 1, playing = 1, endtrig = func_after });
    end;
   
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_feather()

  local item = "inv_feather";

  if cmn.ApplyObj( item, "gzz_chapel_book" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_book", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_book_use_feather" ) and cmn.IsEventDone("win_stainedglass") ) then

    cmn.CallEventHandler( "use_feather_inv" );
    cmn.CallEventHandler( "use_feather_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_feather" );
      
      if cmn.IsEventDone("use_ink") then
        cmn.Lock( 1 );
        private.dlg_action = "use_feather_end";
        common.CloseSubRoom();
      else 
        cmn.CallEventHandler( "use_feather_end" );
      end;
    
    end;

    local anm_book = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_put_pen_book");
      
      ObjDelete("obj_book_ink_and_feather");
      
      ObjAnimate("obj_book_ink_and_feather", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      ObjSet("anm_book_ink",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_put_pen_book_real");

    if cmn.IsEventDone("use_ink") then
      ObjSet("anm_book_use_feather",  { alp = 1, playing = 1, endtrig = anm_book });
    else 
      ObjSet("anm_book_use_feather",  { alp = 1, playing = 1, endtrig = func_after });
    end;
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_stainedglassshard()

  local item = "inv_stainedglassshard";

  if cmn.ApplyObj( item, "gzz_chapel_stainedglass" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_stainedglass" );

  elseif ( cmn.ApplyObj( item, "obj_stainedglass_use_stainedglassshard" ) and cmn.CheckMultiObject( "stainedglassshard", 3 ) ) then

    cmn.CallEventHandler( "use_stainedglassshard_inv" );
    cmn.CallEventHandler( "use_stainedglassshard_beg" );

    local func_after = function ()

      cmn.SetEventDone( "use_stainedglassshard" );
      cmn.CallEventHandler( "use_stainedglassshard_end" );
      
      private.zz_stainedglass.AnimStartGame();
    
    end;
    
    if not cmn.IsEventDone("get_amuletbook2") then
      public.get_amuletbook2();
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_pieces_broken_mirror");

    for i = 1, 3, 1 do
      ObjAnimate("spr_stainedglass_picture_"..private.zz_stainedglass.pics_for_use[i], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    end;
    
    ObjSet("tmr_stainedglass_game_timer",  { time = 1.5, playing = 1, endtrig = func_after });
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_seal()

  local item = "inv_seal";

  if cmn.ApplyObj( item, "gzz_chapel_clerksdesk" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_clerksdesk" );

  elseif ( cmn.ApplyObj( item, "obj_clerksdesk_use_seal" ) ) then

    cmn.CallEventHandler( "use_seal_inv" );
    cmn.CallEventHandler( "use_seal_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_seal" );
      cmn.CallEventHandler( "use_seal_end" );
    
    end;
    
    local func_seal = function ()
      ObjSet("anm_clerksdesk_use_seal",  { pos_z = 3 });
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_box_seal");

    ObjMultiSet( { {"anm_clerksdesk_drawer_open",  { alp = 1, playing = 1, endtrig = func_after }},
                   {"anm_clerksdesk_use_seal", { alp = 1, playing = 1 }},
                   {"tmr_clerksdesk_timer", { time = 0.5, playing = 1, endtrig = func_seal }} } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_clerksamulet()

  local item = "inv_clerksamulet";

  if cmn.ApplyObj( item, "gzz_chapel_clerksdesk" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_clerksdesk" );

  elseif ( cmn.ApplyObj( item, "obj_clerksdesk_use_clerksamulet" ) ) then

    cmn.CallEventHandler( "use_clerksamulet_inv" );
    cmn.CallEventHandler( "use_clerksamulet_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_clerksamulet" );
      cmn.CallEventHandler( "use_clerksamulet_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_obgect_down_left_box");

    ObjMultiSet( { {"anm_clerksdesk_box_open",  { alp = 1, playing = 1, endtrig = func_after }},
                   {"anm_clerksdesk_use_amulet", { alp = 1, playing = 1 }} } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_firenecklace()

  local item = "inv_firenecklace";

  if ( cmn.ApplyObj( item, "obj_chapel_use_firenecklace" ) ) then

    cmn.CallEventHandler( "use_firenecklace_inv" );
    cmn.CallEventHandler( "use_firenecklace_beg" );

    local func_after = function ()

      --cmn.Lock( 0 );

      cmn.SetEventDone( "use_firenecklace" );
      public.dialog_queen_open( 2 );
    
    end;

    cmn.Lock( 1 );

    func_after();

    --ObjAnimate( "spr_chapel_", "alp", 0, 0, func_after,
    --{
    --  0.0, 0, 0, 
    --  0.3, 0, 1
    --} );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_crownofdarkness()

  local item = "inv_crownofdarkness";

  if ( cmn.ApplyObj( item, "obj_chapel_use_crownofdarkness" ) ) then

    cmn.CallEventHandler( "use_crownofdarkness_inv" );
    cmn.CallEventHandler( "use_crownofdarkness_beg" );

    local func_after = function ()

      --cmn.Lock( 0 );

      cmn.SetEventDone( "use_crownofdarkness" );
      public.dialog_queen_open( 3 );
    
    end;

    cmn.Lock( 1 );

    func_after();

    --ObjAnimate( "spr_chapel_", "alp", 0, 0, func_after,
    --{
    --  0.0, 0, 0, 
    --  0.3, 0, 1
    --} );

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_feather()

  cmn.SetEventDone( "get_feather" );
  cmn.CallEventHandler( "get_feather" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_clerksamulet") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_seal()

  cmn.SetEventDone( "get_seal" );
  cmn.CallEventHandler( "get_seal" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_amuletbook3()

  cmn.SetEventDone( "get_amuletbook3" );
  cmn.CallEventHandler( "get_amuletbook3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_clerksamulet()

  cmn.SetEventDone( "get_clerksamulet" );
  cmn.CallEventHandler( "get_clerksamulet" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_feather") then
    common.CloseSubRoom();
  end;


end;
--------------------------------------------------------------------------------------------
function public.get_gravediggerfigurine()

  cmn.SetEventDone( "get_gravediggerfigurine" );
  cmn.CallEventHandler( "get_gravediggerfigurine" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_stainedglassshard1()

  cmn.SetEventDone( "get_stainedglassshard1" );
  cmn.CallEventHandler( "get_stainedglassshard1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_amuletbook2()

  cmn.SetEventDone( "get_amuletbook2" );
  cmn.CallEventHandler( "get_amuletbook2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_amuletbook4()

  cmn.SetEventDone( "get_amuletbook4" );
  cmn.CallEventHandler( "get_amuletbook4" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_ink()

  cmn.SetEventDone( "get_ink" );
  cmn.CallEventHandler( "get_ink" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if not cmn.IsEventDone("get_badge1") then
    cmn.SetEventDone( "get_badge1" );
    cmn.CallEventHandler( "get_badge1" );
  end;
  
  if cmn.IsEventDone("get_stainedglassshard3") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_badge1()

  cmn.SetEventDone( "get_badge1" );
  cmn.CallEventHandler( "get_badge1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
end;
--------------------------------------------------------------------------------------------
function public.get_stainedglassshard3()

  cmn.SetEventDone( "get_stainedglassshard3" );
  cmn.CallEventHandler( "get_stainedglassshard3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_ink") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_amuletbook1()
  
  --ObjSet("spr_chapel_amuletbook1",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_amuletbook1_end" );
    
    --common_impl.PlayBackgroundMusic();

  end;

  cmn.SetEventDone( "get_amuletbook1" );
  cmn.CallEventHandler( "get_amuletbook1_inv" );
  cmn.CallEventHandler( "get_amuletbook1_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.current_dialog = "";
  
  cmn.Lock(1);
  ObjAnimate("obj_chapel_dialog_blackqueen0", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.5, 0, 0 });

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_chapel()

  if not ( cmn.IsEventDone( "opn_chapel" ) ) then
    
    cmn.SetEventDone( "opn_chapel" );
    cmn.CallEventHandler("opn_chapel_map");
    
    --cmn.ShowBbt( "chapel_open" );
    --interface_impl.ShowGlobalTask();
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_random_env_2_mus_env");
    
    public.dialog_queen_open( 0 );
    
  end;
  
  if cmn.IsEventDone("use_ink") and cmn.IsEventDone("use_feather") and not cmn.IsEventDone("opn_worldoffire")  then
    
    local func_after_dlg = function ()

      cmn.GotoRoom("rm_worldoffire");

    end;
    
    cmn.Lock( 0 );
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level1/rm_chapel/vid_movement1", func_after_dlg, "assets/levels/level1/audio/mus/aud_return_mus");
    
  end;
  
  if cmn.IsEventDone("use_crownofdarkness") then
    
    local func_after_dlg = function ()

      cmn.Lock( 0 );
      cmn.GotoRoom("mg_mind");

    end;
    
    ObjSet("tmr_chapel_timer",  { alp = 0.5, playing = 1, endtrig = func_after_dlg });
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_2_1", { alp = 1 }},
                 {"spr_col_2_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_2_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_2_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_2_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_2_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_2_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_2_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_book()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_book_with_cells");
  
  cmn.ShowBbt( "obj_book_use_amuletbook" );
  
  if cmn.IsEventDone( "win_stainedglass" ) then
    ObjSet("anm_book_closed_touch_2",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  else
    ObjSet("anm_book_closed_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_altar_box()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_box_butterfly");
  
  cmn.ShowBbt( "obj_altar_use_tin" );
  
  if not cmn.IsEventDone("get_amuletbook3") or not cmn.IsEventDone("get_seal") then
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
    
    if not cmn.IsEventDone("get_amuletbook3") then
      cmn.SetEventDone( "get_amuletbook3" );
      cmn.CallEventHandler( "get_amuletbook3" );
    end;
    
    if not cmn.IsEventDone("get_seal") then
      cmn.SetEventDone( "get_seal" );
      cmn.CallEventHandler( "get_seal" );
    end;
    
  end;
  
  ObjSet("anm_altar_box_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_clerks_box()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_box_down_right");
  
  cmn.ShowBbt( "obj_clerksdesk_use_clerksamulet" );
  
  ObjSet("anm_clerksdesk_box_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_clerks_drawer()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_box_up_left");
  
  cmn.ShowBbt( "obj_clerksdesk_use_seal" );
  
  ObjSet("anm_clerksdesk_drawer_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_window()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_broken_mirror_chapel");
  
  cmn.ShowBbt( "obj_stainedglass_use_stainedglassshard" );
  
  ObjSet("anm_stainedglass_glass_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.dialog_queen_open( num )
  
  --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
  
  local func_after = function() private.dialog_queen1_beg(); end;
  if num == 2 then
    func_after = function() private.dialog_queen2_beg(); end;
  elseif num == 3 then
    func_after = function() private.dialog_queen3_beg(); end;
  elseif num == 0 then
    func_after = function() private.dialog_queen0_beg(); end;
  end;
  
  ObjAttach("obj_chapel_dialog_blackqueen"..num, "rm_chapel");
  ObjAnimate("obj_chapel_dialog_blackqueen"..num, "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_queen1_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "chapel", "blackqueen1", 2 );
  
  local dialog_end = function ()
    
    ObjSet("rm_chapel",  { color_r = 0, color_g = 0, color_b = 0 });
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( private.dlg_action );
    common_impl.current_dialog = "";
    cmn.GotoRoom("rm_worldoffire");
    
  end;
  
  local anm_hide = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_chapel_dialog_blackqueen1_lipsync1");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_chapel_dialog_blackqueen1_timer",  { playing = 0 }},
                   {"anm_chapel_dialog_blackqueen1_head", { alp = 1 }} } );
    
    --ObjAnimate("obj_chapel_dialog_blackqueen1", "alp", 0, 0, dialog_end, { 0, 0, 1,   0.5, 0, 0 });
    cmn.PlayFullscreenVideo( "assets/levels/level1/rm_chapel/vid_movement1", dialog_end, "assets/levels/level1/audio/mus/aud_return_mus");
    
  end;
  
  private.dlg_lipsync = "vid_chapel_dialog_blackqueen1_lipsync1";
  private.dlg_lipsync = "";

  cmn.ShowDlgBbt( "dlg_blackqueen1_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level1/audio/voc/aud_1_lvl_blackqueen_3_voc");

  ObjMultiSet( { {"tmr_chapel_dialog_blackqueen1_timer", { time = 8, playing = 1, endtrig = anm_hide }},
                 {"vid_chapel_dialog_blackqueen1_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = anm_hide }},
                 {"obj_character_dialog_continue", { event_mup = anm_hide }} } );
  
end; 
--------------------------------------------------------------------------------------------
function private.dialog_queen2_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "chapel", "blackqueen2", 2 );
  
  local dialog_end = function ()
    
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "use_firenecklace_end" );
    common_impl.current_dialog = "";
    
  end;
  
  local anm_door = function ()
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_chaper_door_back_opens");
    ObjAnimate("spr_chapel_door_open", "alp", 0, 0, dialog_end, { 0, 0, 0,   0.5, 0, 1 });
  end;
  
  local anm_hide = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_chapel_dialog_blackqueen2_lipsync2");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_chapel_dialog_blackqueen2_timer",  { playing = 0 }},
                   {"anm_chapel_dialog_blackqueen2_head", { alp = 1 }},
                   {"spr_chapel_black_queen_necklace", { alp = 1 }} } );
    
    ObjAnimate("obj_chapel_dialog_blackqueen2", "alp", 0, 0, anm_door, { 0, 0, 1,   0.6, 0, 0 });
    
  end;
  
  local queen_talks2 = function ()
  
    ObjDelete("vid_chapel_dialog_blackqueen2_lipsync1");
    ObjAttach("vid_chapel_dialog_blackqueen2_lipsync2", "obj_chapel_dialog_blackqueen2");
  
    cmn.ShowDlgBbt( "dlg_blackqueen2_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level1/audio/voc/aud_1_lvl_blackqueen_5_voc");
    private.dlg_lipsync = "vid_chapel_dialog_blackqueen2_lipsync2";
    
    ObjMultiSet( { {"tmr_chapel_dialog_blackqueen2_timer", { endtrig = anm_hide, time = 11, playing = 1 }},
                   --{"anm_chapel_dialog_blackqueen2_head", { alp = 0 }},
                   {"vid_chapel_dialog_blackqueen2_lipsync2", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_hide }},
                   {"obj_character_dialog_continue", { event_mup = anm_hide }} } );
  
  end;
                 
  private.dlg_lipsync = "vid_chapel_dialog_blackqueen2_lipsync1";
  private.dlg_lipsync = "";

  cmn.ShowDlgBbt( "dlg_blackqueen2_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level1/audio/voc/aud_1_lvl_blackqueen_4_voc");

  ObjMultiSet( { {"tmr_chapel_dialog_blackqueen2_timer", { time = 11, playing = 1, endtrig = queen_talks2 }},
                 {"vid_chapel_dialog_blackqueen2_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = queen_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = queen_talks2 }} } );
  
end; 
--------------------------------------------------------------------------------------------
function private.dialog_queen3_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "chapel", "blackqueen3", 2 );
  
  local dialog_end = function ()
    
    --ObjSet("rm_chapel",  { color_r = 0, color_g = 0, color_b = 0 });
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "use_crownofdarkness_end" );
    common_impl.current_dialog = "";
    cmn.GotoRoom("mg_mind");
    
  end;
  
  local anm_hide = function ()
    
    private.dlg_lipsync = "";
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_chapel_dialog_blackqueen3_timer",  { playing = 0 }},
                   {"spr_chapel_queen_crown", { alp = 1}} } );
    
    ObjAnimate("obj_chapel_dialog_blackqueen3", "alp", 0, 0, dialog_end, { 0, 0, 1,   0.6, 0, 0 });
    
  end;
  
  private.dlg_lipsync = "vid_chapel_dialog_blackqueen3_lipsync1";

  cmn.ShowDlgBbt( "dlg_blackqueen3_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level1/audio/voc/aud_1_lvl_blackqueen_6_voc");

  ObjMultiSet( { {"tmr_chapel_dialog_blackqueen3_timer", { time = 7, playing = 1, endtrig = anm_hide }},
                 {"vid_chapel_dialog_blackqueen3_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = anm_hide }},
                 {"obj_character_dialog_continue", { event_mup = anm_hide }} } );
  
end; 
--------------------------------------------------------------------------------------------
function private.dialog_queen0_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "chapel", "blackqueen0", 2 );
  
  local dialog_end = function ()
    
    cmn.Lock(0);
    cmn.CallEventHandler( "opn_chapel_loc" );
    
    cmn.ShowBbt( "chapel_open" );
    interface_impl.ShowGlobalTask();
    int_diary.AddDiarypage( 9 );
    
    ObjSet("anm_chapel_dialog_blackqueen0_hand_2",  { playing = 1 });
    
  end;
  
  local anm_give = function ()
    
    private.dlg_lipsync = "";
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_chapel_dialog_blackqueen0_timer",  { playing = 0 }},
                   {"anm_chapel_dialog_blackqueen0_head", { alp = 1 }},
                   {"anm_chapel_dialog_blackqueen0_body", { alp = 0, playing = 0 }},
                   {"anm_chapel_dialog_blackqueen0_hand_give", { alp = 1, playing = 1, endtrig = dialog_end }} } );
    
  end;
                 
  local queen_talks2 = function ()
  
    ObjDelete("vid_chapel_dialog_blackqueen0_lipsync1");
    ObjAttach("vid_chapel_dialog_blackqueen0_lipsync2", "obj_chapel_dialog_blackqueen0");
  
    cmn.ShowDlgBbt( "dlg_blackqueen0_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level1/audio/voc/aud_1_lvl_blackqueen_2_voc");
    private.dlg_lipsync = "vid_chapel_dialog_blackqueen0_lipsync2";
    
    ObjMultiSet( { {"tmr_chapel_dialog_blackqueen0_timer", { endtrig = anm_give, time = 8, playing = 1 }},
                   {"vid_chapel_dialog_blackqueen0_lipsync2", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_give }},
                   {"obj_character_dialog_continue", { event_mup = anm_give }} } );
  
  end;
  
  private.dlg_lipsync = "vid_chapel_dialog_blackqueen0_lipsync1";

  cmn.ShowDlgBbt( "dlg_blackqueen0_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level1/audio/voc/aud_1_lvl_blackqueen_1_voc");

  ObjMultiSet( { {"tmr_chapel_dialog_blackqueen0_timer", { time = 15, playing = 1, endtrig = queen_talks2 }},
                 {"vid_chapel_dialog_blackqueen0_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = queen_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = queen_talks2 }} } );
                 
end;
--------------------------------------------------------------------------------------------
function public.skip_dlg_blackqueen1()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  common_impl.current_dialog = "";
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( private.dlg_action );
    
    ObjSet("rm_chapel",  { color_r = 0, color_g = 0, color_b = 0 });
    cmn.GotoRoom("rm_worldoffire");
    
  end;
  
  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    private.dlg_lipsync = "";
  end;

  ObjMultiSet( { {"tmr_chapel_dialog_blackqueen1_timer",  { playing = 0 }},
                 {"anm_chapel_dialog_blackqueen1_head", { alp = 1 }} } );
  
  common_impl.CharacterDialogButtonsHide();
  
  --common_impl.PlayBackgroundMusic();
  
  cmn.PlayFullscreenVideo( "assets/levels/level1/rm_chapel/vid_movement1", func_after_dlg, "assets/levels/level1/audio/mus/aud_return_mus");
  
end;
--------------------------------------------------------------------------------------------
function public.skip_dlg_blackqueen2()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  common_impl.current_dialog = "";
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "use_firenecklace_end" );
    
  end;
  
  local anm_door = function ()
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_chaper_door_back_opens");
    ObjAnimate("spr_chapel_door_open", "alp", 0, 0, func_after_dlg, { 0, 0, 0,   0.5, 0, 1 });
  end;
  
  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    private.dlg_lipsync = "";
  end;

  ObjMultiSet( { {"tmr_chapel_dialog_blackqueen2_timer",  { playing = 0 }},
                 {"anm_chapel_dialog_blackqueen2_head", { alp = 1 }},
                 {"spr_chapel_black_queen_necklace", { alp = 1 }} } );
  
  common_impl.CharacterDialogButtonsHide();
  
  --common_impl.PlayBackgroundMusic();
  
  ObjAnimate("obj_chapel_dialog_blackqueen2", "alp", 0, 0, anm_door, { 0, 0, 1,   0.6, 0, 0 });
  
end;
--------------------------------------------------------------------------------------------
function public.skip_dlg_blackqueen3()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  common_impl.current_dialog = "";
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "use_crownofdarkness_end" );
    
    --ObjSet("rm_chapel",  { color_r = 0, color_g = 0, color_b = 0 });
    cmn.GotoRoom("mg_mind");
    
  end;
  
  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    --ObjDelete(private.dlg_lipsync);
    ObjSet(private.dlg_lipsync,  { playing = 0 });
    private.dlg_lipsync = "";
  end;

  ObjMultiSet( { {"tmr_chapel_dialog_blackqueen3_timer",  { playing = 0 }},
                 {"spr_chapel_queen_crown", { alp = 1}} } );
                   
  common_impl.CharacterDialogButtonsHide();
  
  --common_impl.PlayBackgroundMusic();
  
  ObjAnimate("obj_chapel_dialog_blackqueen3", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.6, 0, 0 });
  
end;
--------------------------------------------------------------------------------------------
function public.skip_dlg_blackqueen0()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "opn_chapel_loc" );
    
    cmn.ShowBbt( "chapel_open" );
    interface_impl.ShowGlobalTask();
    int_diary.AddDiarypage( 9 );
    
    ObjSet("anm_chapel_dialog_blackqueen0_hand_2",  { playing = 1 });
    
  end;
  
  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    --ObjDelete(private.dlg_lipsync);
    ObjSet(private.dlg_lipsync,  { playing = 0 });
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();
  
  --common_impl.PlayBackgroundMusic();
  
  ObjMultiSet( { {"tmr_chapel_dialog_blackqueen0_timer",  { playing = 0 }},
                 --{"anm_chapel_dialog_blackqueen0_head", { alp = 1 }},
                 {"anm_chapel_dialog_blackqueen0_body", { alp = 0, playing = 0 }},
                 {"anm_chapel_dialog_blackqueen0_hand_give", { alp = 1, playing = 1, endtrig = func_after_dlg }} } );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Stainedglass *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_stainedglass = {};
public.zz_stainedglass = {};

function private.Init_Stainedglass()
  
  private.zz_stainedglass.pics_for_use = { 6, 8, 9 };
  
  private.zz_stainedglass.start_state = {1, 5, 6, 7, 0, 2, 7, 4, 3, 1, 5};
  private.zz_stainedglass.pos_restrictions = { {-240, 240}, {-240, 240} };

  private.zz_stainedglass.pic_pos = {
    { {-188, -14}, {119, -195}, {191, -75}, {-177, 199}, {-127, -223}, {-221, 98},
      {178, 181}, {40, 220}, {-93, 211}, {-206, -152}, {191, 85} },
    { {46, -169}, {34, 110}, {-27, -68}, {-88, -118}, {92, -90}, {124, -164}, 
      {122, -7}, {109, 73}, {-94, 52}, {-31, 171}, {159, 142} }
  };
  -----------------------------------------------------------------------------------
  game.hint[ "win_stainedglass" ] = {
    type = "win",
    room = "rm_chapel",
    zz = "zz_stainedglass",
    zz_gate = "gzz_chapel_stainedglass"
  };
  -----------------------------------------------------------------------------------
  local win_stainedglass = function ()
    
    if cmn.IsEventDone( "win_stainedglass" ) then
  
      ObjDelete( "gzz_chapel_stainedglass" );
      ObjDelete( "spr_chapel_pentagramm_1" );
      ObjDelete( "spr_chapel_book_book_opn" );
      ObjDelete( "fx_chapel_p_window_1" );
      
      ObjDelete( "obj_book_book_bbt" );
      
      ObjMultiSet( { {"spr_book_back_2", { alp = 1 }},
                     {"spr_chapel_window_red", { alp = 1 }},
                     {"spr_chapel_window_red_2", { alp = 1 }},
                     {"spr_chapel_pentagramm_2", { alp = 1 }},
                     {"spr_book_note_small", { res = "assets/levels/level1/rm_chapel/zz_book/letter_red" }},
                     {"fx_chapel_p_window_2", { active = 1, visible = 1 }} } );
                     
      if cmn.IsEventDone("use_amuletbook") then
        ObjDelete( "anm_book_open" );
        ObjDelete( "spr_chapel_book_book_opn" );
        ObjMultiSet( { {"obj_book_use_ink", { input = 1 }},
                       {"obj_book_use_feather", { input = 1 }},
                       {"anm_book_open_2", { input = 1, alp = 1, frame = 300 }},
                       {"spr_chapel_book_book_opn2", { alp = 1 }} } );
      else 
        ObjDelete( "spr_chapel_book_book_closed" );
        ObjMultiSet( { {"anm_book_closed_touch", { alp = 0 }},
                       {"anm_book_closed_touch_2", { alp = 1 }},
                       {"spr_chapel_book_book_closed_2", { alp = 1 }} } );         
      end;
                     
    end;
  
  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_stainedglass", win_stainedglass, "rm_chapel" );

end;
--*********************************************************************************************************************
function private.zz_stainedglass.StartConditions()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_stainedglass" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_stainedglass" ].state = { { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }, 
                                                                                  { 1, 5, 6, 7, 0, 2, 7, 4, 3, 1, 5 } };
                                                                              
  ng_global.progress[ ng_global.currentprogress ][ "win_stainedglass" ].state_pos = { 
    {-188, -14}, {119, -195}, {191, -75}, {-177, 199}, {-127, -223}, {-221, 98},
    {178, 181}, {40, 220}, {-93, 211}, {-206, -152}, {191, 85}
  };
  
end;
-----------------------------------------------------------------------------------
function public.zz_stainedglass.Reset()
  
  local need_r = false;
  local k_ang = 0.785;

  for i = 1, #private.zz_stainedglass.state[1], 1 do

    if (private.zz_stainedglass.state_pos[i][1] ~= private.zz_stainedglass.pic_pos[1][i][1]) or (private.zz_stainedglass.state_pos[i][2] ~= private.zz_stainedglass.pic_pos[1][i][2]) then

      if not need_r then
        need_r = true;
      end;

      ObjAnimate("spr_stainedglass_picture_"..i, "pos_xy", 0, 0, "", { 0, 0, private.zz_stainedglass.state_pos[i][1], private.zz_stainedglass.state_pos[i][2],
                                                                 0.5, 0, private.zz_stainedglass.pic_pos[1][i][1], private.zz_stainedglass.pic_pos[1][i][2] });

    end;

    if (private.zz_stainedglass.state[2][i] ~= private.zz_stainedglass.start_state[i]) then

      if not need_r then
        need_r = true;
      end;

      local old_ang = -k_ang*private.zz_stainedglass.state[2][i];
      local new_ang = -k_ang*private.zz_stainedglass.start_state[i];

      ObjAnimate("spr_stainedglass_picture_"..i, "ang", 0, 0, "", { 0, 0, old_ang,   0.5, 0, new_ang });

    end;
    
    
    if (private.zz_stainedglass.state[1][i] == i) and (private.zz_stainedglass.state[2][i] == 0) then
      ObjAnimate("spr_stainedglass_picture_"..i.."_win", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    end;

  end;

  if need_r then

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_click_broken_mirror_1");

    private.zz_stainedglass.StartConditions();
    private.zz_stainedglass.state = ng_global.progress[ ng_global.currentprogress ][ "win_stainedglass" ].state;
    private.zz_stainedglass.state_pos = ng_global.progress[ ng_global.currentprogress ][ "win_stainedglass" ].state_pos;

    ObjSet("tmr_stainedglass_game_timer",  { time = 0.5, playing = 1, endtrig = function () cmn.Lock( 0 ); private.zz_stainedglass.DrawScene(); end });

  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_stainedglass.Skip()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_broken_mirror_hint");

  local k_ang = 0.785;

  ng_global.progress[ ng_global.currentprogress ][ "win_stainedglass" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_stainedglass" ].state = { 
    { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }, 
    { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 } 
  };

  ng_global.progress[ ng_global.currentprogress ][ "win_stainedglass" ].state_pos = { 
    {46, -169}, {34, 110}, {-27, -68}, {-88, -117}, {92, -90}, {124, -164}, 
    {121, -5}, {109, 73}, {-95, 53}, {-33, 169}, {156, 142}
  } ; 

  for i = 1, #private.zz_stainedglass.state[1], 1 do

    if (private.zz_stainedglass.state[1][i] ~= i) then

      ObjAnimate("spr_stainedglass_picture_"..i, "pos_xy", 0, 0, "", { 0, 0, private.zz_stainedglass.state_pos[i][1], private.zz_stainedglass.state_pos[i][2],
                                                                 0.5, 0, private.zz_stainedglass.pic_pos[2][i][1], private.zz_stainedglass.pic_pos[2][i][2] });

    end;

    if (private.zz_stainedglass.state[2][i] ~= 0) then

      local old_ang = -k_ang*private.zz_stainedglass.state[2][i];
      local new_ang = 0;

      ObjAnimate("spr_stainedglass_picture_"..i, "ang", 0, 0, "", { 0, 0, old_ang,   0.5, 0, new_ang });

    end;
    
    if (private.zz_stainedglass.state[1][i] ~= i) or (private.zz_stainedglass.state[2][i] ~= 0) then
      ObjAnimate("spr_stainedglass_picture_"..i.."_win", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    end;

  end;

  private.zz_stainedglass.state = ng_global.progress[ ng_global.currentprogress ][ "win_stainedglass" ].state;
  private.zz_stainedglass.state_pos = ng_global.progress[ ng_global.currentprogress ][ "win_stainedglass" ].state_pos;

  ObjSet("tmr_stainedglass_game_timer",  { time = 0.5, playing = 1, endtrig = function() private.zz_stainedglass.CheckWin(); end });
  
end;
-----------------------------------------------------------------------------------
function private.zz_stainedglass.AnimStartGame()
  
  local k_ang = 0.785;
  
  local func_after = function ()

    cmn.MiniGameShow();
    
    cmn.Lock(0);

    private.zz_stainedglass.DrawScene();

  end;
  
  for i = 1, #private.zz_stainedglass.state[1], 1 do

    local new_ang = -k_ang*private.zz_stainedglass.start_state[i];
    local old_ang = 0;

    ObjAnimate("spr_stainedglass_picture_"..i, "pos_xy", 0, 0, "", { 0, 0, private.zz_stainedglass.pic_pos[2][i][1], private.zz_stainedglass.pic_pos[2][i][2],
                                                               0.5, 0, private.zz_stainedglass.pic_pos[1][i][1], private.zz_stainedglass.pic_pos[1][i][2] });

    ObjAnimate("spr_stainedglass_picture_"..i, "ang", 0, 0, "", { 0, 0, old_ang,   0.5, 0, new_ang });
    ObjAnimate("spr_stainedglass_picture_"..i.."_win", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });

  end;
  
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_click_broken_mirror_1");
  
  ObjSet("tmr_stainedglass_game_timer",  { time = 0.5, playing = 1, endtrig = func_after });
  
end;
-----------------------------------------------------------------------------------
function private.zz_stainedglass.DrawScene()
  
  local k_ang = 0.785;

  if cmn.IsEventDone("use_stainedglassshard") then

    for i = 1, #private.zz_stainedglass.state[1], 1 do
    
      ObjMultiSet( { {"spr_stainedglass_picture_"..i, { ang = -k_ang*private.zz_stainedglass.state[2][i] }},
                     {"spr_stainedglass_picture_"..i.."_focus", { ang = -k_ang*private.zz_stainedglass.state[2][i] }},
                     {"spr_stainedglass_picture_"..i.."_drag", { ang = -k_ang*private.zz_stainedglass.state[2][i] }} } );

      if (private.zz_stainedglass.state[1][i] == i) then
        ObjMultiSet( { {"spr_stainedglass_picture_"..i, { pos_x = private.zz_stainedglass.pic_pos[2][i][1],  pos_y = private.zz_stainedglass.pic_pos[2][i][2] }},
                       {"spr_stainedglass_picture_"..i.."_focus", { pos_x = private.zz_stainedglass.pic_pos[2][i][1],  pos_y = private.zz_stainedglass.pic_pos[2][i][2] }},
                       {"spr_stainedglass_picture_"..i.."_drag", { pos_x = private.zz_stainedglass.pic_pos[2][i][1],  pos_y = private.zz_stainedglass.pic_pos[2][i][2] }} } );
      else 
        ObjMultiSet( { {"spr_stainedglass_picture_"..i, { pos_x = private.zz_stainedglass.state_pos[i][1],  pos_y = private.zz_stainedglass.state_pos[i][2] }},
                       {"spr_stainedglass_picture_"..i.."_focus", { pos_x = private.zz_stainedglass.state_pos[i][1],  pos_y = private.zz_stainedglass.state_pos[i][2] }},
                       {"spr_stainedglass_picture_"..i.."_drag", { pos_x = private.zz_stainedglass.state_pos[i][1],  pos_y = private.zz_stainedglass.state_pos[i][2] }} } );
      end;

      if (private.zz_stainedglass.state[1][i] == i) and (private.zz_stainedglass.state[2][i] == 0) then

        ObjSet("spr_stainedglass_picture_"..i.."_drag",  { input = 0 });
        ObjAttach("spr_stainedglass_picture_"..i, "obj_stainedglass_rihgt_place");
        ObjAttach("spr_stainedglass_picture_"..i.."_drag", "obj_stainedglass_mosaic_parts");
        
        ObjSet("spr_stainedglass_picture_"..i.."_win",  { alp = 1 });

      else 

        ObjSet("spr_stainedglass_picture_"..i.."_drag",  { input = 1 });
        ObjAttach("spr_stainedglass_picture_"..i, "obj_stainedglass_mosaic_parts");
        ObjAttach("spr_stainedglass_picture_"..i.."_drag", "obj_stainedglass_mosaic_parts");
        
        ObjSet("spr_stainedglass_picture_"..i.."_win",  { alp = 0 });

      end;

    end;

  else 

    for i = 1, #private.zz_stainedglass.state[1], 1 do

      ObjSet("spr_stainedglass_picture_"..i,  { ang = 0, pos_x = private.zz_stainedglass.pic_pos[2][i][1],  pos_y = private.zz_stainedglass.pic_pos[2][i][2] });

    end;
    
    for i = 1, 3, 1 do
      ObjSet("spr_stainedglass_picture_"..private.zz_stainedglass.pics_for_use[i],  { alp = 0 });
    end;

  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_stainedglass.FocusPic( num, inout )
  
  local obj = "spr_stainedglass_picture_"..num.."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_GET);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      --cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menter_ho");
    end;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });

end;
------------------------------------------------------------------------------
public.zz_stainedglass.drag_rotate = false;
function public.zz_stainedglass.StartDrag( num )

  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_broken_mirror_click");
  ObjAttach("spr_stainedglass_picture_"..num,  "obj_stainedglass_game_fly");
  public.zz_stainedglass.drag_rotate = true;
  ObjSet("tmr_stainedglass_mosaic_parts",{ time = 0.5, playing = true, endtrig = function()
    public.zz_stainedglass.timerEndStartDrag();
  end });
end;
function public.zz_stainedglass.timerEndStartDrag()
  public.zz_stainedglass.drag_rotate = false;
end;
------------------------------------------------------------------------------
function public.zz_stainedglass.OnDragPic( num )
  
  local curspos = GetZoomCursorPos();
  curspos[1] = math.floor(curspos[1]) - ObjGet("zz_stainedglass").pos_x;
  curspos[2] = math.floor(curspos[2]) - ObjGet("zz_stainedglass").pos_y;
  
  if (curspos[1] < private.zz_stainedglass.pos_restrictions[1][1]) then
    curspos[1] = private.zz_stainedglass.pos_restrictions[1][1];
  elseif (curspos[1] > private.zz_stainedglass.pos_restrictions[1][2]) then
    curspos[1] = private.zz_stainedglass.pos_restrictions[1][2];
  end;

  if (curspos[2] < private.zz_stainedglass.pos_restrictions[2][1]) then
    curspos[2] = private.zz_stainedglass.pos_restrictions[2][1];
  elseif (curspos[2] > private.zz_stainedglass.pos_restrictions[2][2]) then
    curspos[2] = private.zz_stainedglass.pos_restrictions[2][2];
  end;
  
  ObjMultiSet( { {"spr_stainedglass_picture_"..num.."_focus",  { pos_x = curspos[1], pos_y = curspos[2] }},
                 {"spr_stainedglass_picture_"..num,  { pos_x = curspos[1], pos_y = curspos[2]}} } );
  
end;
-----------------------------------------------------------------------------------
function public.zz_stainedglass.RotatePic( num )

  cmn.Lock(1);   
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_broken_mirror_turn");
  
  ObjAttach("spr_stainedglass_picture_"..num,  "obj_stainedglass_game_fly");

  local new_ang = private.zz_stainedglass.state[2][num] + 1;
  local old_ang = private.zz_stainedglass.state[2][num];

  if (new_ang == 8) then
    private.zz_stainedglass.state[2][num] = 0;
  else 
    private.zz_stainedglass.state[2][num] = new_ang;
  end;

  local func_after = function ()
    
    if (private.zz_stainedglass.state[1][num] == num) and (private.zz_stainedglass.state[2][num] == 0) then
      --cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/");
      ObjAttach("spr_stainedglass_picture_"..num,  "obj_stainedglass_rihgt_place");
      ObjAttach("spr_stainedglass_picture_"..num.."_drag",  "obj_stainedglass_rihgt_place");
      ObjSet("spr_stainedglass_picture_"..num.."_drag",  { input = 0 });
      ObjAnimate("spr_stainedglass_picture_"..num.."_win", "alp", 0, 0, private.zz_stainedglass.CheckWin, { 0, 0, 0,   0.5, 0, 1 });
    else 
      ObjAttach("spr_stainedglass_picture_"..num,  "obj_stainedglass_mosaic_parts");
      ObjAttach("spr_stainedglass_picture_"..num.."_drag",  "obj_stainedglass_mosaic_parts");
      private.zz_stainedglass.CheckWin();
    end;

  end;

  local k_ang = 0.785;
  
  ObjSet("spr_stainedglass_picture_"..num.."_drag",  { ang = -k_ang*new_ang });

  ObjAnimate("spr_stainedglass_picture_"..num, "ang", 0, 0, func_after, { 0, 0, -k_ang*old_ang,   0.3, 0, -k_ang*new_ang });
  ObjAnimate("spr_stainedglass_picture_"..num.."_focus", "ang", 0, 0, func_after, { 0, 0, -k_ang*old_ang,   0.3, 0, -k_ang*new_ang });

end;
------------------------------------------------------------------------------
function private.zz_stainedglass.CheckHit( px, py, num )

  local centr = {0, 0}; 
  local accuracy = 30;

  centr[1] = private.zz_stainedglass.pic_pos[2][num][1];
  centr[2] = private.zz_stainedglass.pic_pos[2][num][2];

  if ( (px - centr[1])^2 + (py - centr[2])^2 ) <= accuracy^2 then 

    return true;

  else

    return false;

  end; 

end;
------------------------------------------------------------------------------
function public.zz_stainedglass.DropPic( num )

  ObjAttach("spr_stainedglass_picture_"..num,  "obj_stainedglass_mosaic_parts");
  local pos = GetZoomCursorPos();
  if  tostring(GetPlatform()) == "android" then
    pos[2] = pos[2] - 100;
  elseif tostring(GetPlatform()) == "ios" then
    if port.isTablet() == 0 then
      pos[2] = pos[2] - 75;
    else
      pos[2] = pos[2] - 50;
    end;
  end;
  local px = pos[1] - ObjGet("zz_stainedglass").pos_x;
  local py = pos[2] - ObjGet("zz_stainedglass").pos_y;

  local old_place = 0;

  --если деталь где то стояла - освобождаем место
  for j = 1, #private.zz_stainedglass.state[1], 1 do

    if private.zz_stainedglass.state[1][j] == num then
       private.zz_stainedglass.state[1][j] = 0;
      old_place = j;
      break;
    end;

  end;

  if (private.zz_stainedglass.CheckHit(px, py, num)) then

    --ставим на занятое место
    if (private.zz_stainedglass.state[1][num] ~= 0) and ((private.zz_stainedglass.state[1][num] ~= num) or (private.zz_stainedglass.state[2][num] ~= 0)) then

      --DbgTrace("right occup");

      local old_pic = private.zz_stainedglass.state[1][num];
      private.zz_stainedglass.state[1][num] = num;

      if (old_place ~= 0) then
        private.zz_stainedglass.state[1][old_place] = old_pic;
      end;
      
      ObjMultiSet( { {"spr_stainedglass_picture_"..old_pic.."_focus", { pos_x = private.zz_stainedglass.state_pos[num][1],  pos_y = private.zz_stainedglass.state_pos[num][2] }},
                     {"spr_stainedglass_picture_"..old_pic.."_drag", { pos_x = private.zz_stainedglass.state_pos[num][1],  pos_y = private.zz_stainedglass.state_pos[num][2] }},
                     {"spr_stainedglass_picture_"..num.."_drag", { pos_x = private.zz_stainedglass.pic_pos[2][num][1],  pos_y = private.zz_stainedglass.pic_pos[2][num][2] }} } );

      cmn.Lock(1);  

      local func_after = function ()
        cmn.Lock(0);
        cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_broken_mirror_put");
      end;

      --DbgTrace(private.zz_stainedglass.state[2][num]);

      if private.zz_stainedglass.state[2][num] == 0 then
        func_after = "";
      end;

      ObjAnimate("spr_stainedglass_picture_"..old_pic, "pos_xy", 0, 0, func_after, { 0, 0, private.zz_stainedglass.state_pos[old_pic][1], private.zz_stainedglass.state_pos[old_pic][2],   0.3, 0, private.zz_stainedglass.state_pos[num][1], private.zz_stainedglass.state_pos[num][2] });
      ObjAnimate("spr_stainedglass_picture_"..num, "pos_xy", 0, 0, "", { 0, 0, px, py,   0.3, 0, private.zz_stainedglass.pic_pos[2][num][1], private.zz_stainedglass.pic_pos[2][num][2] });
      ObjAnimate("spr_stainedglass_picture_"..num.."_focus", "pos_xy", 0, 0, "", { 0, 0, px, py,   0.3, 0, private.zz_stainedglass.pic_pos[2][num][1], private.zz_stainedglass.pic_pos[2][num][2] });
      
      if (old_pic == i) and (private.zz_stainedglass.state[2][old_pic] == 0) then
        ObjAttach("spr_stainedglass_picture_"..old_pic, "obj_stainedglass_mosaic_parts");
      end;

      private.zz_stainedglass.state_pos[old_pic][1] = private.zz_stainedglass.state_pos[num][1];
      private.zz_stainedglass.state_pos[old_pic][2] = private.zz_stainedglass.state_pos[num][2];

      private.zz_stainedglass.state_pos[num][1] = private.zz_stainedglass.pic_pos[2][num][1];
      private.zz_stainedglass.state_pos[num][2] = private.zz_stainedglass.pic_pos[2][num][2];

    --ставим на верное место
    elseif (private.zz_stainedglass.state[1][num] == 0) then

      --DbgTrace("right vacant");

      local func_after = function ()
        cmn.Lock(0);
        cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_broken_mirror_put");
      end;
      
      if private.zz_stainedglass.state[2][num] == 0 then
        func_after = "";
      end;
      
      cmn.Lock(1); 
      
      private.zz_stainedglass.state[1][num] = num;
      
      private.zz_stainedglass.state_pos[num][1] = private.zz_stainedglass.pic_pos[2][num][1];
      private.zz_stainedglass.state_pos[num][2] = private.zz_stainedglass.pic_pos[2][num][2];
      
      ObjSet("spr_stainedglass_picture_"..num.."_drag",  { pos_x = private.zz_stainedglass.pic_pos[2][num][1], pos_y = private.zz_stainedglass.pic_pos[2][num][2] });
                     
      ObjAnimate("spr_stainedglass_picture_"..num, "pos_xy", 0, 0, func_after, { 0, 0, px, py,   0.3, 0, private.zz_stainedglass.pic_pos[2][num][1], private.zz_stainedglass.pic_pos[2][num][2] });
      ObjAnimate("spr_stainedglass_picture_"..num.."_focus", "pos_xy", 0, 0, "", { 0, 0, px, py,   0.3, 0, private.zz_stainedglass.pic_pos[2][num][1], private.zz_stainedglass.pic_pos[2][num][2] });
      
    end;

    if (private.zz_stainedglass.state[2][num] == 0) then
      
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_broken_mirror_put");

      ObjSet("tmr_stainedglass_game_timer",  { time = 0.5, playing = 1, endtrig = private.zz_stainedglass.CheckWin });
      ObjSet("spr_stainedglass_picture_"..num.."_drag",  { input = 0 });
      ObjAttach("spr_stainedglass_picture_"..num, "obj_stainedglass_rihgt_place");
      ObjAttach("spr_stainedglass_picture_"..num.."_drag", "obj_stainedglass_rihgt_place");
      
      ObjAnimate("spr_stainedglass_picture_"..num.."_win", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });

    end;

  else 

    local found = false;

    for i = 1, #private.zz_stainedglass.state[1], 1 do
  
      if (private.zz_stainedglass.CheckHit(px, py, i)) then

        found = true;

        --ставим на занятое место
        if (private.zz_stainedglass.state[1][i] ~= 0) and ((private.zz_stainedglass.state[1][i] ~= i) or (private.zz_stainedglass.state[2][i] ~= 0)) then
        --if (private.state[1][i] ~= 0) then

          --DbgTrace("wrong occup "..i);

          local old_pic = private.zz_stainedglass.state[1][i];
          private.zz_stainedglass.state[1][i] = num;

          if (old_place ~= 0) then
            private.zz_stainedglass.state[1][old_place] = old_pic;
          end;
          
          ObjMultiSet( { {"spr_stainedglass_picture_"..old_pic.."_focus", { pos_x = private.zz_stainedglass.state_pos[num][1],  pos_y = private.zz_stainedglass.state_pos[num][2] }},
                         {"spr_stainedglass_picture_"..old_pic.."_drag", { pos_x = private.zz_stainedglass.state_pos[num][1],  pos_y = private.zz_stainedglass.state_pos[num][2] }},
                         {"spr_stainedglass_picture_"..num.."_drag", { pos_x = private.zz_stainedglass.pic_pos[2][i][1],  pos_y = private.zz_stainedglass.pic_pos[2][i][2] }} } );

          cmn.Lock(1); 
         
          ObjAnimate("spr_stainedglass_picture_"..old_pic, "pos_xy", 0, 0, function () cmn.Lock(0); end, { 0, 0, private.zz_stainedglass.state_pos[old_pic][1], private.zz_stainedglass.state_pos[old_pic][2],   0.3, 0, private.zz_stainedglass.state_pos[num][1], private.zz_stainedglass.state_pos[num][2] });
          ObjAnimate("spr_stainedglass_picture_"..num, "pos_xy", 0, 0, "", { 0, 0, px, py,   0.3, 0, private.zz_stainedglass.pic_pos[2][i][1], private.zz_stainedglass.pic_pos[2][i][2] });
          ObjAnimate("spr_stainedglass_picture_"..num.."_focus", "pos_xy", 0, 0, "", { 0, 0, px, py,   0.3, 0, private.zz_stainedglass.pic_pos[2][i][1], private.zz_stainedglass.pic_pos[2][i][2] });
          
          if (old_pic == i) and (private.zz_stainedglass.state[2][old_pic] == 0) then
            ObjAttach("spr_stainedglass_picture_"..old_pic, "obj_stainedglass_mosaic_parts");
          end;

          private.zz_stainedglass.state_pos[old_pic][1] = private.zz_stainedglass.state_pos[num][1];
          private.zz_stainedglass.state_pos[old_pic][2] = private.zz_stainedglass.state_pos[num][2];

          --DbgTrace("x "..private.zz_stainedglass.state_pos[num][1].." y "..private.zz_stainedglass.state_pos[num][2]);

          private.zz_stainedglass.state_pos[num][1] = private.zz_stainedglass.pic_pos[2][i][1];
          private.zz_stainedglass.state_pos[num][2] = private.zz_stainedglass.pic_pos[2][i][2];

          --DbgTrace("x "..private.zz_stainedglass.state_pos[num][1].." y "..private.zz_stainedglass.state_pos[num][2]);

        elseif (private.zz_stainedglass.state[1][i] ~= 0) then
          
          cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_broken_mirror_put");

          ObjMultiSet( { {"spr_stainedglass_picture_"..num, { pos_x = private.zz_stainedglass.state_pos[num][1],  pos_y = private.zz_stainedglass.state_pos[num][2] }},
                         {"spr_stainedglass_picture_"..num.."_focus", { pos_x = private.zz_stainedglass.state_pos[num][1],  pos_y = private.zz_stainedglass.state_pos[num][2] }},
                         {"spr_stainedglass_picture_"..num.."_drag", { pos_x = private.zz_stainedglass.state_pos[num][1],  pos_y = private.zz_stainedglass.state_pos[num][2] }} } );

          ObjAttach("spr_stainedglass_picture_"..num, "obj_stainedglass_mosaic_parts");          

        --ставим на пустое неверное место
        elseif (private.zz_stainedglass.state[1][i] == 0) then

          --DbgTrace("wrong vacant");
          
          cmn.Lock(1); 

          local func_after = function ()
            cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_broken_mirror_put");
            cmn.Lock(0);
          end;
          
          private.zz_stainedglass.state[1][i] = num;
          
          private.zz_stainedglass.state_pos[num][1] = private.zz_stainedglass.pic_pos[2][i][1];
          private.zz_stainedglass.state_pos[num][2] = private.zz_stainedglass.pic_pos[2][i][2];
          
          ObjSet("spr_stainedglass_picture_"..num.."_drag",  { pos_x = private.zz_stainedglass.pic_pos[2][i][1], pos_y = private.zz_stainedglass.pic_pos[2][i][2] });
                         
          ObjAnimate("spr_stainedglass_picture_"..num, "pos_xy", 0, 0, func_after, { 0, 0, px, py,   0.3, 0, private.zz_stainedglass.pic_pos[2][i][1], private.zz_stainedglass.pic_pos[2][i][2] });
          ObjAnimate("spr_stainedglass_picture_"..num.."_focus", "pos_xy", 0, 0, func_after, { 0, 0, px, py,   0.3, 0, private.zz_stainedglass.pic_pos[2][i][1], private.zz_stainedglass.pic_pos[2][i][2] });

        end;

        break;

      end;
      
    end;

    --ставим куда попало
    if not(found) then
  
      local occup = false;

      local curspos = GetZoomCursorPos();
      curspos[1] = math.floor(curspos[1]) - ObjGet("zz_stainedglass").pos_x;
      curspos[2] = math.floor(curspos[2]) - ObjGet("zz_stainedglass").pos_y;

      local new_x = curspos[1];
      local new_y = curspos[2];

      if (new_x < private.zz_stainedglass.pos_restrictions[1][1]) then
        new_x = private.zz_stainedglass.pos_restrictions[1][1];
      elseif (new_x > private.zz_stainedglass.pos_restrictions[1][2]) then
        new_x = private.zz_stainedglass.pos_restrictions[1][2];
      end;

      if (new_y < private.zz_stainedglass.pos_restrictions[2][1]) then
        new_y = private.zz_stainedglass.pos_restrictions[2][1];
      elseif (new_y > private.zz_stainedglass.pos_restrictions[2][2]) then
        new_y = private.zz_stainedglass.pos_restrictions[2][2];
      end;

      --пустое место
      --if not(occup) then

        --DbgTrace("empty vacant");

        private.zz_stainedglass.state_pos[num][1] = new_x;
        private.zz_stainedglass.state_pos[num][2] = new_y;
        
        cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_broken_mirror_put");

        ObjMultiSet( { {"spr_stainedglass_picture_"..num, { pos_x = new_x,  pos_y = new_y }},
                       {"spr_stainedglass_picture_"..num.."_focus", { pos_x = new_x,  pos_y = new_y }},
                       {"spr_stainedglass_picture_"..num.."_drag", { pos_x = new_x,  pos_y = new_y }} } );

      --end;

    end;

  end;
                 
  if public.zz_stainedglass.drag_rotate == true then
    ObjSet("tmr_stainedglass_mosaic_parts",{ playing = false });
    public.zz_stainedglass.RotatePic( num );
  end;
                 
end;
-----------------------------------------------------------------------------------
function private.zz_stainedglass.CheckWin()
  
  local win_flag = true;

  for i = 1, #private.zz_stainedglass.state[1], 1 do

    if (private.zz_stainedglass.state[1][i] ~= i) or (private.zz_stainedglass.state[2][i] ~= 0) then

      win_flag = false;
      break;

    end;

  end;

  if win_flag then

    cmn.Lock(1);
    common_impl.PauseAchiev(1);

    local func_after = function ()

      cmn.MiniGameHide("stainedglass");
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_broken_mirror_win");
      ObjAnimate("spr_stainedglass_red_light", "alp", 0, 0, private.zz_stainedglass.Win, { 0, 0, 0,   0.5, 0, 1,   1, 0, 1 });

    end;

    ObjSet("tmr_stainedglass_game_timer",  { time = 1, playing = 1, endtrig = func_after });

  else

    cmn.Lock( 0 );

  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_stainedglass.Win()
  
  cmn.Lock( 0 );
  common_impl.PauseAchiev(0);
  
  cmn.ShowBbt( "chapel_after_red_light" );

  cmn.SetEventDone( "win_stainedglass" );
  cmn.CallEventHandler( "win_stainedglass" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_stainedglass" ].skip == 0 and ng_global.noskipgames[ "win_stainedglass" ] == nil then

    ng_global.noskipgames[ "win_stainedglass" ] = 1;
    common_impl.CheckAchiev("mg");

  end;
  
  common.CloseSubRoom();
  
end;
--*********************************************************************************************************************