-- name=rm_worldoffire
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_worldoffire";
  --------------------------------------------------------------------------------------------
  private.dlg_lipsync = "";
  private.Init_Subroom();
  private.Init_Mechanism();
  --------------------------------------------------------------------------------------------
  -- function get_pliers () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_pliers" ] = {
        type = "get",
        get_obj = "spr_fountain_pliers",
        room = private.room_objname,
        zz = "zz_fountain",
        zz_gate = "gzz_worldoffire_fountain"
    };
    --------------------------------------------------------------------------------------------
  local get_pliers_inv = function ()
  
    interface.InventoryItemAdd( "inv_pliers", "spr_fountain_pliers" );
  
  end;
  
  local get_pliers_end = function ()
  
    ObjDelete( "gfx_fountain_pliers" );
    ObjDelete( "spr_fountain_pliers_sh" );

    ObjDelete( "spr_worldoffire_fountain_pliers" );
  
  end;
  
  cmn.AddSubscriber( "get_pliers", get_pliers_inv );
  cmn.AddSubscriber( "get_pliers", get_pliers_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_healingpotion () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_healingpotion" ] = {
        type = "get",
        get_obj = "spr_fountain_healingpotion",
        room = private.room_objname,
        zz = "zz_fountain",
        zz_gate = "gzz_worldoffire_fountain"
    };
    --------------------------------------------------------------------------------------------
  local get_healingpotion_inv = function ()
  
    interface.InventoryItemAdd( "inv_healingpotion", "spr_fountain_healingpotion" );
  
  end;
  
  local get_healingpotion_end = function ()
  
    ObjDelete( "gfx_fountain_healingpotion" );
    if cmn.IsEventDone("get_detail3") and ObjGet("gzz_worldoffire_fountain") then
      ObjDelete( "gzz_worldoffire_fountain" );
    end;
  end;
  
  cmn.AddSubscriber( "get_healingpotion", get_healingpotion_inv );
  cmn.AddSubscriber( "get_healingpotion", get_healingpotion_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_detail3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_detail3" ] = {
      type = "get",
      get_obj = "spr_fountain_detail4",
      room = private.room_objname,
      zz = "zz_fountain",
      zz_gate = "gzz_worldoffire_fountain"
  };
  --------------------------------------------------------------------------------------------
  local get_detail3_inv = function ()
  
    interface.InventoryItemAdd( "inv_detail", "spr_fountain_detail4", function () cmn.GetMultyObject( 'detail', 3 ); end );
  
  end;
  
  local get_detail3_end = function ()
  
    ObjDelete( "gfx_fountain_detail4" );
    ObjDelete( "spr_fountain_detail4_sh" );

    ObjDelete( "spr_worldoffire_fountain_detail4" );
  
    if cmn.IsEventDone("get_healingpotion") and ObjGet("gzz_worldoffire_fountain") then
      ObjDelete( "gzz_worldoffire_fountain" );
    end;
    
  end;
  
  cmn.AddSubscriber( "get_detail3", get_detail3_inv );
  cmn.AddSubscriber( "get_detail3", get_detail3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletfire () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_amuletfire" ] = {
        type = "get",
        get_obj = "spr_fountain_amuletfire",
        room = private.room_objname,
        zz = "zz_fountain",
        zz_gate = "gzz_worldoffire_fountain"
    };
    --------------------------------------------------------------------------------------------
  local get_amuletfire_inv = function ()
  
    interface.InventoryItemAdd( "inv_amuletfire", "spr_fountain_amuletfire" );
  
  end;
  
  local get_amuletfire_end = function ()
  
    ObjDelete( "gfx_fountain_amuletfire" );
    ObjDelete( "spr_fountain_amuletfire_sh" );

    ObjDelete( "spr_worldoffire_fountain_amuletfire" );
  
  end;
  
  cmn.AddSubscriber( "get_amuletfire", get_amuletfire_inv );
  cmn.AddSubscriber( "get_amuletfire", get_amuletfire_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_totempart1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_totempart1" ] = {
        type = "get",
        get_obj = "spr_fountain_totempart2",
        room = private.room_objname,
        zz = "zz_fountain",
        zz_gate = "gzz_worldoffire_fountain"
    };
    --------------------------------------------------------------------------------------------
  local get_totempart1_inv = function ()
  
    interface.InventoryItemAdd( "inv_totempart", "spr_fountain_totempart2", function () cmn.GetMultyObject( 'totempart', 2 ); end );
  
  end;
  
  local get_totempart1_end = function ()
  
    ObjDelete( "gfx_fountain_totempart2" );
    ObjDelete( "spr_fountain_totempart2_sh" );

    ObjDelete( "spr_worldoffire_fountain_totempart2" );
  
  end;
  
  cmn.AddSubscriber( "get_totempart1", get_totempart1_inv );
  cmn.AddSubscriber( "get_totempart1", get_totempart1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletbag () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_amuletbag" ] = {
        type = "get",
        get_obj = "spr_stephen_amuletbag",
        room = private.room_objname,
        zz = "zz_stephen",
        zz_gate = "gzz_worldoffire_stephen"
    };
    --------------------------------------------------------------------------------------------
  local get_amuletbag_inv = function ()
  
    interface.InventoryItemAdd( "inv_amuletbag", "spr_stephen_amuletbag" );
    ObjSet("inv_stephensbag_star_light",  { alp = 1 });
  
  end;
  
  local get_amuletbag_end = function ()
  
    ObjDelete( "gfx_stephen_amuletbag" );
    ObjDelete( "spr_worldoffire_stephen_star_amulet" );
  
  end;
  
  cmn.AddSubscriber( "get_amuletbag", get_amuletbag_inv );
  cmn.AddSubscriber( "get_amuletbag", get_amuletbag_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crackedstone () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_crackedstone" ] = {
        type = "get",
        get_obj = "spr_stephen_crackedstone",
        room = private.room_objname,
        zz = "zz_stephen",
        zz_gate = "gzz_worldoffire_stephen"
    };
    --------------------------------------------------------------------------------------------
  local get_crackedstone_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_crackedstone", "spr_stephen_crackedstone" );
  
  end;
  
  local get_crackedstone_end = function ()
  
    ObjDelete( "gfx_stephen_crackedstone" );
    ObjDelete( "spr_stephen_crackedstone_sh" );

    ObjDelete( "spr_worldoffire_stephen_crackedstone" );
  
  end;
  
  cmn.AddSubscriber( "get_crackedstone", get_crackedstone_inv );
  cmn.AddSubscriber( "get_crackedstone", get_crackedstone_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pickaxe () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_pickaxe" ] = {
        type = "get",
        get_obj = "spr_mechanism_pickaxe",
        room = private.room_objname,
        zz = "zz_mechanism",
        zz_gate = "gzz_worldoffire_mechanism"
    };
    --------------------------------------------------------------------------------------------
  local get_pickaxe_inv = function ()
  
    interface.InventoryItemAdd( "inv_pickaxe", "spr_mechanism_pickaxe" );
  
  end;
  
  local get_pickaxe_end = function ()
  
    ObjDelete( "gfx_mechanism_pickaxe" );
    ObjDelete( "spr_mechanism_pickaxe_shadow" );

    ObjDelete( "spr_worldoffire_mechanism_pickaxe" );
  
  end;
  
  cmn.AddSubscriber( "get_pickaxe", get_pickaxe_inv );
  cmn.AddSubscriber( "get_pickaxe", get_pickaxe_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bowl () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_bowl" ] = {
        type = "get",
        get_obj = "spr_mechanism_bowl",
        room = private.room_objname,
        zz = "zz_mechanism",
        zz_gate = "gzz_worldoffire_mechanism"
    };
    --------------------------------------------------------------------------------------------
  local get_bowl_inv = function ()
  
    interface.InventoryItemAdd( "inv_bowl", "spr_mechanism_bowl" );
  
  end;
  
  local get_bowl_end = function ()
  
    ObjDelete( "gfx_mechanism_bowl" );
    ObjDelete( "spr_mechanism_bowl_shadow" );

    ObjDelete( "spr_worldoffire_mechanism_bowl" );
    
    if cmn.IsEventDone("get_totempart2") and cmn.IsEventDone("win_mechanism") then
      ObjSet("gzz_worldoffire_mechanism",  { active = 0, visible = 0 });
    end;
  
  end;
  
  cmn.AddSubscriber( "get_bowl", get_bowl_inv );
  cmn.AddSubscriber( "get_bowl", get_bowl_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_totempart2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_totempart2" ] = {
        type = "get",
        get_obj = "spr_mechanism_totempart3",
        room = private.room_objname,
        zz = "zz_mechanism",
        zz_gate = "gzz_worldoffire_mechanism"
    };
    --------------------------------------------------------------------------------------------
  local get_totempart2_inv = function ()
  
    interface.InventoryItemAdd( "inv_totempart", "spr_mechanism_totempart3", function () cmn.GetMultyObject( 'totempart', 2 ); end );
  
  end;
  
  local get_totempart2_end = function ()
  
    ObjDelete( "gfx_mechanism_totempart3" );
    ObjDelete( "spr_mechanism_totempart3_shadow" );

    ObjDelete( "spr_worldoffire_mechanism_totempart3" );
    
    if cmn.IsEventDone("get_bowl") and cmn.IsEventDone("win_mechanism") then
      ObjSet("gzz_worldoffire_mechanism",  { active = 0, visible = 0 });
    end;
  
  end;
  
  cmn.AddSubscriber( "get_totempart2", get_totempart2_inv );
  cmn.AddSubscriber( "get_totempart2", get_totempart2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amethystheart () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_amethystheart" ] = {
        type = "get",
        get_obj = "spr_totem_amethystheart",
        room = private.room_objname,
        zz = "zz_totem",
        zz_gate = "gzz_worldoffire_totem"
    };
    --------------------------------------------------------------------------------------------
  local get_amethystheart_inv = function ()
  
    interface.InventoryItemAdd( "inv_amethystheart", "spr_totem_amethystheart" );
  
  end;
  
  local get_amethystheart_end = function ()
  
    ObjDelete( "gfx_totem_amethystheart" );
    ObjDelete( "gzz_worldoffire_totem" );

    ObjDelete( "spr_worldoffire_totem_amethystheart" );
  
  end;
  
  cmn.AddSubscriber( "get_amethystheart", get_amethystheart_inv );
  cmn.AddSubscriber( "get_amethystheart", get_amethystheart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_detail2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_detail2" ] = {
      type = "get",
      get_obj = "spr_totem_detail3",
      room = private.room_objname,
      zz = "zz_totem",
      zz_gate = "gzz_worldoffire_totem"
  };
  --------------------------------------------------------------------------------------------
  local get_detail2_inv = function ()
  
    interface.InventoryItemAdd( "inv_detail", "spr_totem_detail3", function () cmn.GetMultyObject( 'detail', 3 ); end );
  
  end;
  
  local get_detail2_end = function ()
  
    ObjDelete( "gfx_totem_detail3" );
    ObjDelete( "spr_totem_detail3_sh" );

    ObjDelete( "spr_worldoffire_totem_detail3" );
  
  end;
  
  cmn.AddSubscriber( "get_detail2", get_detail2_inv );
  cmn.AddSubscriber( "get_detail2", get_detail2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_firenecklace () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_firenecklace" ] = {
      type = "get",
      get_obj = "spr_worldoffire_firenecklace",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_firenecklace_inv = function ()
    
    int_map_impl.BlockRoom( "rm_worldoffire" );
  
    interface.InventoryItemAdd( "inv_firenecklace", "spr_worldoffire_firenecklace" );
  
  end;
  local get_firenecklace_mid = function ()
  
    ObjDelete( "gfx_worldoffire_firenecklace" );
    ObjDelete( "spr_worldoffire_firenecklace_sh" );
  
  end;
  local get_firenecklace_end = function ()
  
    ObjDelete( "obj_worldoffire_dialog_stephen2" );
  
  end;
  local get_firenecklace_loc = function ()

    ObjDelete( "anm_chapel_queen_activation" );
    if port.isPortable() == 1 then
      port.GrmEventLightOff("grm_chapel_worldoffire_focus");
    end;
    ObjDelete( "grm_chapel_worldoffire" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_firenecklace", get_firenecklace_inv );
  cmn.AddSubscriber( "get_firenecklace_inv", get_firenecklace_inv, private.room_objname );
  cmn.AddSubscriber( "get_firenecklace", get_firenecklace_mid, private.room_objname );
  cmn.AddSubscriber( "get_firenecklace_mid", get_firenecklace_mid, private.room_objname );
  cmn.AddSubscriber( "get_firenecklace", get_firenecklace_end, private.room_objname );
  cmn.AddSubscriber( "get_firenecklace_end", get_firenecklace_end, private.room_objname );
  cmn.AddSubscriber( "get_firenecklace", get_firenecklace_loc, "rm_chapel" );
  cmn.AddSubscriber( "get_firenecklace_loc", get_firenecklace_loc, "rm_chapel" );

  --------------------------------------------------------------------------------------------
  -- function use_bowl () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_bowl" ] = {
        type = "use",
        inv_obj = "inv_bowl",
        use_place = "obj_fountain_use_bowl",
        room = private.room_objname,
        zz = "zz_fountain",
        zz_gate = "gzz_worldoffire_fountain"
    };
  --------------------------------------------------------------------------------------------
  local use_bowl_inv = function ()
  
    interface.InventoryItemRemove( "inv_bowl" );
  
  end;
  local use_bowl_beg = function ()
  
    ObjDelete( "obj_fountain_use_bowl" );
  
  end;
  local use_bowl_end = function ()
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bowl", use_bowl_beg, private.room_objname );
  cmn.AddSubscriber( "use_bowl", use_bowl_inv );
  cmn.AddSubscriber( "use_bowl", use_bowl_end, private.room_objname );
  cmn.AddSubscriber( "use_bowl_inv", use_bowl_inv, private.room_objname );
  cmn.AddSubscriber( "use_bowl_beg", use_bowl_beg, private.room_objname );
  cmn.AddSubscriber( "use_bowl_end", use_bowl_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_rubyheart () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_rubyheart" ] = {
        type = "use",
        inv_obj = "inv_rubyheart",
        use_place = "obj_fountain_use_rubyheart",
        room = private.room_objname,
        zz = "zz_fountain",
        zz_gate = "gzz_worldoffire_fountain"
    };
  --------------------------------------------------------------------------------------------
  local use_rubyheart_inv = function ()
  
    interface.InventoryItemRemove( "inv_rubyheart" );
  
  end;
  local use_rubyheart_beg = function ()
  
    ObjDelete( "obj_fountain_use_rubyheart" );
    ObjDelete( "anm_fountain_left_hand" );
  
  end;
  local use_rubyheart_end = function ()
  
    ObjMultiSet( {
      { "anm_fountain_use_rubyheart", { alp = 1, input = 1, frame = 300 } },
      { "spr_worldoffire_fountain_mouth_opened", { alp = 1 } },
      { "spr_worldoffire_fountain_rubyheart", { alp = 1 } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_rubyheart", use_rubyheart_beg, private.room_objname );
  cmn.AddSubscriber( "use_rubyheart", use_rubyheart_inv );
  cmn.AddSubscriber( "use_rubyheart", use_rubyheart_end, private.room_objname );
  cmn.AddSubscriber( "use_rubyheart_inv", use_rubyheart_inv, private.room_objname );
  cmn.AddSubscriber( "use_rubyheart_beg", use_rubyheart_beg, private.room_objname );
  cmn.AddSubscriber( "use_rubyheart_end", use_rubyheart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amethystheart () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_amethystheart" ] = {
        type = "use",
        inv_obj = "inv_amethystheart",
        use_place = "obj_fountain_use_amethystheart",
        room = private.room_objname,
        zz = "zz_fountain",
        zz_gate = "gzz_worldoffire_fountain"
    };
  --------------------------------------------------------------------------------------------
  local use_amethystheart_inv = function ()
  
    interface.InventoryItemRemove( "inv_amethystheart" );
  
  end;
  local use_amethystheart_beg = function ()
  
    ObjDelete( "obj_fountain_use_amethystheart" );
    ObjDelete( "anm_fountain_right_hand" );
  
  end;
  local use_amethystheart_end = function ()
    
    ObjDelete( "anm_fountain_thorns_1" );
    ObjDelete("vid_fountain_water_start");
    ObjAttach("vid_fountain_water_flaw", "obj_fountain_layer_6");

    ObjAttach("vid_worldoffire_fontain", "obj_worldoffire_fountain_base");
  
    ObjMultiSet( { {"anm_fountain_use_amethystheart", { alp = 1, frame = 300 }},
                   {"obj_fountain_use_bowl", { input = 1 }},
                   {"anm_fountain_thorns_2", { alp = 1 }},
                   {"spr_worldoffire_fountain_amethystheart", { alp = 1 }},
                   {"spr_worldoffire_fountain_water_1", { alp = 1 }},
                   {"spr_worldoffire_fountain_thorn2_leafes", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amethystheart", use_amethystheart_beg, private.room_objname );
  cmn.AddSubscriber( "use_amethystheart", use_amethystheart_inv );
  cmn.AddSubscriber( "use_amethystheart", use_amethystheart_end, private.room_objname );
  cmn.AddSubscriber( "use_amethystheart_inv", use_amethystheart_inv, private.room_objname );
  cmn.AddSubscriber( "use_amethystheart_beg", use_amethystheart_beg, private.room_objname );
  cmn.AddSubscriber( "use_amethystheart_end", use_amethystheart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pliers () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_pliers" ] = {
        type = "use",
        inv_obj = "inv_pliers",
        use_place = "obj_stephen_use_pliers",
        room = private.room_objname,
        zz = "zz_stephen",
        zz_gate = "gzz_worldoffire_stephen"
    };
  --------------------------------------------------------------------------------------------
  local use_pliers_inv = function ()
  
    interface.InventoryItemRemove( "inv_pliers" );
  
  end;
  local use_pliers_beg = function ()
  
    ObjDelete( "obj_stephen_use_pliers" );
  
  end;
  local use_pliers_end = function ()
    
    ObjSet( "anm_stephen_use_pliers", { animfunc = "func_use_pliers", endtrig = "", playing = false, frame = 69 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pliers", use_pliers_beg, private.room_objname );
  cmn.AddSubscriber( "use_pliers", use_pliers_inv );
  cmn.AddSubscriber( "use_pliers", use_pliers_end, private.room_objname );
  cmn.AddSubscriber( "use_pliers_inv", use_pliers_inv, private.room_objname );
  cmn.AddSubscriber( "use_pliers_beg", use_pliers_beg, private.room_objname );
  cmn.AddSubscriber( "use_pliers_end", use_pliers_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_healingpotion () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_healingpotion" ] = {
        type = "use",
        inv_obj = "inv_healingpotion",
        use_place = "obj_stephen_use_healingpotion",
        room = private.room_objname,
        zz = "zz_stephen",
        zz_gate = "gzz_worldoffire_stephen"
    };
  --------------------------------------------------------------------------------------------
  local use_healingpotion_inv = function ()
  
    interface.InventoryItemRemove( "inv_healingpotion" );
  
  end;
  local use_healingpotion_beg = function ()
  
    ObjDelete( "obj_stephen_use_healingpotion" );
  
  end;
  local use_healingpotion_end = function ()
  
    ObjDelete("anm_worldoffire_dialog_stephen2_hand_1");
    ObjDelete("anm_worldoffire_dialog_stephen2_hand_give");
    ObjDelete("vid_worldoffire_dialog_stephen2_lipsync1");
    
    ObjDelete("gzz_worldoffire_stephen");
    ObjAttach("obj_worldoffire_dialog_stephen2", "rm_worldoffire");
    
    ObjDelete( "spr_worldoffire_stephen_stephen_2" );
    ObjSet( "anm_worldoffire_stephen_disintegration", { alp = 1 } );
    
    ObjMultiSet( { {"obj_worldoffire_dialog_stephen2", { alp = 1, input = 1 }},
                   {"obj_worldoffire_dialog_stephen2_hand_2", { alp = 1, input = 1 }},
                   {"anm_worldoffire_dialog_stephen2_head", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_healingpotion", use_healingpotion_beg, private.room_objname );
  cmn.AddSubscriber( "use_healingpotion", use_healingpotion_inv );
  cmn.AddSubscriber( "use_healingpotion", use_healingpotion_end, private.room_objname );
  cmn.AddSubscriber( "use_healingpotion_inv", use_healingpotion_inv, private.room_objname );
  cmn.AddSubscriber( "use_healingpotion_beg", use_healingpotion_beg, private.room_objname );
  cmn.AddSubscriber( "use_healingpotion_end", use_healingpotion_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_detail () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_detail" ] = {
        type = "use",
        inv_obj = "inv_detail",
        use_place = "obj_mechanism_use_detail",
        room = private.room_objname,
        zz = "zz_mechanism",
        zz_gate = "gzz_worldoffire_mechanism"
    };
  --------------------------------------------------------------------------------------------
  local use_detail_inv = function ()
  
    interface.InventoryItemRemove( "inv_detail" );
  
  end;
  local use_detail_beg = function ()
  
    ObjDelete( "obj_mechanism_use_detail" );
  
  end;
  local use_detail_end = function ()

    ObjMultiSet( {
      { "spr_worldoffire_mechanism_blocks", { alp = 1 } },
      { "obj_mechanism_blocks_small", { alp = 1 } },
      { "gzz_mechanism_game", { active = true, input = true } }
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_detail", use_detail_beg, private.room_objname );
  cmn.AddSubscriber( "use_detail", use_detail_inv );
  cmn.AddSubscriber( "use_detail", use_detail_end, private.room_objname );
  cmn.AddSubscriber( "use_detail_inv", use_detail_inv, private.room_objname );
  cmn.AddSubscriber( "use_detail_beg", use_detail_beg, private.room_objname );
  cmn.AddSubscriber( "use_detail_end", use_detail_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletfire () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_amuletfire" ] = {
        type = "use",
        inv_obj = "inv_amuletfire",
        use_place = "obj_mechanism_use_amuletfire",
        room = private.room_objname,
        zz = "zz_mechanism",
        zz_gate = "gzz_worldoffire_mechanism"
    };
  --------------------------------------------------------------------------------------------
  local use_amuletfire_inv = function ()
  
    interface.InventoryItemRemove( "inv_amuletfire" );
  
  end;
  local use_amuletfire_beg = function ()
  
    ObjDelete( "obj_mechanism_use_amuletfire" );
  
  end;
  local use_amuletfire_end = function ()

    ObjDelete( "spr_worldoffire_mechanism_stash_cover" );
  
    ObjMultiSet( { {"spr_mechanism_bowl", { input = 1 }},
                   {"spr_mechanism_totempart3", { input = 1 }},
                   {"spr_worldoffire_mechanism_stash_cover_open", { alp = 1 }},
                   {"anm_mechanism_stash_cover", { animfunc = "func_open_stash_cover", frame = 90 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amuletfire", use_amuletfire_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletfire", use_amuletfire_inv );
  cmn.AddSubscriber( "use_amuletfire", use_amuletfire_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletfire_inv", use_amuletfire_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletfire_beg", use_amuletfire_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletfire_end", use_amuletfire_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pickaxe () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_pickaxe" ] = {
        type = "use",
        inv_obj = "inv_pickaxe",
        use_place = "obj_totem_use_pickaxe",
        room = private.room_objname,
        zz = "zz_totem",
        zz_gate = "gzz_worldoffire_totem"
    };
  --------------------------------------------------------------------------------------------
  local use_pickaxe_inv = function ()
  
    interface.InventoryItemRemove( "inv_pickaxe" );
  
  end;
  local use_pickaxe_beg = function ()
  
    ObjDelete( "obj_totem_use_pickaxe" );
    ObjDelete( "anm_totem_rock_touch" );
  
  end;
  local use_pickaxe_end = function ()
  
    ObjDelete( "anm_totem_use_pickaxe" );
    ObjDelete( "spr_worldoffire_totem_stones_1" );

    ObjMultiSet( {
      { "obj_totem_under_rock", { input = 1 } },
      { "spr_worldoffire_totem_stones_2", { alp = 1 } }
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pickaxe", use_pickaxe_beg, private.room_objname );
  cmn.AddSubscriber( "use_pickaxe", use_pickaxe_inv );
  cmn.AddSubscriber( "use_pickaxe", use_pickaxe_end, private.room_objname );
  cmn.AddSubscriber( "use_pickaxe_inv", use_pickaxe_inv, private.room_objname );
  cmn.AddSubscriber( "use_pickaxe_beg", use_pickaxe_beg, private.room_objname );
  cmn.AddSubscriber( "use_pickaxe_end", use_pickaxe_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_totempart () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_totempart" ] = {
        type = "use",
        inv_obj = "inv_totempart",
        use_place = "obj_totem_use_totempart",
        room = private.room_objname,
        zz = "zz_totem",
        zz_gate = "gzz_worldoffire_totem"
    };
  --------------------------------------------------------------------------------------------
  local use_totempart_inv = function ()
  
    interface.InventoryItemRemove( "inv_totempart" );
  
  end;
  local use_totempart_beg = function ()
  
    ObjDelete( "obj_totem_use_totempart" );
    ObjDelete( "anm_totem_totem_touch" );
  
  end;
  local use_totempart_end = function ()

    ObjDelete( "spr_worldoffire_totem_hands" );
  
    ObjMultiSet( { { "spr_totem_amethystheart", { input = 1 } },
                   { "spr_worldoffire_totem_hands_opened", { alp = 1 } },
                   { "spr_worldoffire_totem_amethystheart", { alp = 1 } },
                   { "anm_totem_use_parts", { alp = 1, frame = 90 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_totempart", use_totempart_beg, private.room_objname );
  cmn.AddSubscriber( "use_totempart", use_totempart_inv );
  cmn.AddSubscriber( "use_totempart", use_totempart_end, private.room_objname );
  cmn.AddSubscriber( "use_totempart_inv", use_totempart_inv, private.room_objname );
  cmn.AddSubscriber( "use_totempart_beg", use_totempart_beg, private.room_objname );
  cmn.AddSubscriber( "use_totempart_end", use_totempart_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function opn_worldoffire () end;
  --------------------------------------------------------------------------------------------
  local opn_worldoffire = function ()
  
    int_map_impl.OpenRoom( "rm_worldoffire" );
    
    interface_impl.SetCurrentGlobalTask( 5 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_worldoffire", opn_worldoffire );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_stephen" );
  subroom.Define( "zz_mechanism" );
  subroom.Define( "zz_fountain" );
  
  function zz_fountain.PreOpen()
    
    if cmn.IsEventDone("use_amethystheart") then
      cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_zz_fontain_env");
    end;
    
  end;
  
  function zz_fountain.PreClose()
    
    if cmn.IsEventDone("use_amethystheart") then
      cmn.StopAllEnv("assets/levels/level1/audio/env/aud_worldoffire_env");
      cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_worldoffire_env");
    end;
    
  end;
  
  function zz_stephen.Close()
    
    if cmn.IsEventDone("use_healingpotion") then
      --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
      ObjAttach("obj_worldoffire_dialog_stephen2", "rm_worldoffire");
      ObjAnimate("obj_worldoffire_dialog_stephen2", "alp", 0, 0, private.dialog_stephen2_beg, { 0, 0, 0,   0.5, 0, 1 });
    end;
    
  end;

  function zz_mechanism.PreClose()
    
    if cmn.IsEventDone( "use_detail" ) and not cmn.IsEventDone("win_mechanism") and private.zz_mechanism.is_open then
      cmn.MiniGameHide( "mechanism" );
      iOS_NeedDrag(1);
    end;
    
  end;
  
  function zz_mechanism.Close()

    cmn.HideNote( 0 );
    
    if cmn.IsEventDone( "use_detail" ) and not cmn.IsEventDone("win_mechanism") and private.zz_mechanism.is_open then
      ObjSet( "obj_mechanism_game", { alp = 0, input = false } );
      private.zz_mechanism.is_open = false;
    end;

  end;
  
end;
--*********************************************************************************************************************
function public.Load()

  if not ng_global.progress[ ng_global.currentprogress ][ "win_mechanism" ].state then 
    private.zz_mechanism.StartConditions();
  end;
  private.zz_mechanism.state = ng_global.progress[ ng_global.currentprogress ][ "win_mechanism" ].state;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_worldoffire();
  
  if not cmn.IsEventDone("win_mechanism") then
    private.play_fire_vid();
  end;
  
  if cmn.IsEventDone("use_healingpotion") and not cmn.IsEventDone("get_firenecklace") then
    --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    common_impl.current_dialog = "obj_worldoffire_dialog_stephen2";
    ObjSet("anm_worldoffire_dialog_stephen2_hand_2",  { playing = 1 });
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level1/audio/env/aud_worldoffire_env");
  cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_worldoffire_env");
  
  if cmn.IsEventDone("get_firenecklace") then
    cmn.Lock( 1 );
    ObjSet("rm_worldoffire",  { color_r = 0, color_g = 0, color_b = 0 });
  end;
  
  --анимация морф-оъекта
  if cmn.IsCollectableAvailible(1) then
    private.AnimMorphObject();
  end;

end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_bowl()

  local item = "inv_bowl";

  if cmn.ApplyObj( item, "gzz_worldoffire_fountain" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_fountain", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_fountain_use_bowl" ) and cmn.IsEventDone("use_amethystheart") ) then

    cmn.CallEventHandler( "use_bowl_inv" );
    cmn.CallEventHandler( "use_bowl_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_bowl" );
      cmn.CallEventHandler( "use_bowl_end" );
      
      public.get_healingpotion();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_fill_cup");

    ObjSet("anm_fountain_use_cup",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_rubyheart()

  local item = "inv_rubyheart";

  if cmn.ApplyObj( item, "gzz_worldoffire_fountain" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_fountain", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_fountain_use_rubyheart" ) ) then

    cmn.CallEventHandler( "use_rubyheart_inv" );
    cmn.CallEventHandler( "use_rubyheart_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_rubyheart" );
      cmn.CallEventHandler( "use_rubyheart_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_heart1_left_hand");

    ObjSet("anm_fountain_use_rubyheart",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_amethystheart()

  local item = "inv_amethystheart";

  if cmn.ApplyObj( item, "gzz_worldoffire_fountain" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_fountain", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_fountain_use_amethystheart" ) ) then

    cmn.CallEventHandler( "use_amethystheart_inv" );
    cmn.CallEventHandler( "use_amethystheart_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_amethystheart" );
      cmn.CallEventHandler( "use_amethystheart_end" );
    
    end;
    
    local anm_fountain = function ()
      
      cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_zz_fontain_env");
      
      ObjDelete("vid_fountain_water_start");
      ObjAttach("vid_fountain_water_flaw", "obj_fountain_layer_6");
      
      ObjAnimate("anm_fountain_thorns_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("anm_fountain_thorns_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;
    
    local anm_fountain_start = function ()
      
      ObjAttach("vid_fountain_water_start", "obj_fountain_layer_6");
      VidPlay("vid_fountain_water_start", anm_fountain);
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_heart2_left_hand");

    ObjSet("anm_fountain_use_amethystheart",  { alp = 1, playing = 1, endtrig = anm_fountain_start });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pliers()

  local item = "inv_pliers";

  if cmn.ApplyObj( item, "gzz_worldoffire_stephen" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_stephen" );

  elseif ( cmn.ApplyObj( item, "obj_stephen_use_pliers" ) ) then

    cmn.CallEventHandler( "use_pliers_inv" );
    cmn.CallEventHandler( "use_pliers_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_pliers" );
      cmn.CallEventHandler( "use_pliers_end" );
      
      public.get_amuletbag();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_take_star_for_bag");

    ObjSet("anm_stephen_use_pliers",  { animfunc = "func_use_pliers", alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_healingpotion()

  local item = "inv_healingpotion";

  if cmn.ApplyObj( item, "gzz_worldoffire_stephen" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_stephen" );

  elseif ( cmn.ApplyObj( item, "obj_stephen_use_healingpotion" ) and cmn.IsEventDone( "win_mechanism" ) ) then

    cmn.CallEventHandler( "use_healingpotion_inv" );
    cmn.CallEventHandler( "use_healingpotion_beg" );

    local func_after = function ()

      --cmn.Lock( 0 );

      cmn.SetEventDone( "use_healingpotion" );

      ObjDelete( "spr_worldoffire_stephen_stephen_2" );
      ObjSet( "anm_worldoffire_stephen_disintegration", { alp = 1 } );
      
      common.CloseSubRoom();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_take_stephen_cup");

    ObjSet( "anm_stephen_stephen", { animfunc = "func_use_hill_potion", endtrig = func_after, playing = true, frame = 0 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_detail()

  local item = "inv_detail";

  if cmn.ApplyObj( item, "gzz_worldoffire_mechanism" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_mechanism", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_mechanism_use_detail" ) and cmn.CheckMultiObject( "detail", 3 ) ) then

    cmn.CallEventHandler( "use_detail_inv" );
    cmn.CallEventHandler( "use_detail_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_detail" );
      cmn.CallEventHandler( "use_detail_end" );

      ObjMultiSet( {
        { "obj_mechanism_back", { pos_x = 0, pos_y = 0, scale_x = 1, scale_y = 1 } },
        { "obj_mechanism_game", { input = true } }
      } );

      cmn.MiniGameShow();
      iOS_NeedDrag(0);
      private.zz_mechanism.is_open = true;

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_seal_zz_mechanism");

    local func_game = function ()
      
      ObjAnimate( "obj_mechanism_game", "alp", 0, 0, func_after, { 0, 0, 0,    0.5, 0, 1 } );
      
    end;

    local anm_zoom = function ()
      
      ObjAnimate( "obj_mechanism_back", "scale_xy", 0, 0, func_game, { 0, 0, 1, 1,    0.8, 0, 1.5, 1.5 } );
      ObjAnimate( "obj_mechanism_back", "pos_xy", 0, 0, "", { 0, 0, 0, 0,    0.8, 0, -67, 125 } );
      
    end;

    private.zz_mechanism.DrawScene();

    ObjAnimate( "obj_mechanism_blocks_small", "alp", 0, 0, anm_zoom, { 0, 0, 0,   0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_amuletfire()

  local item = "inv_amuletfire";

  if cmn.ApplyObj( item, "gzz_worldoffire_mechanism" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_mechanism", false, false, true );

  elseif cmn.ApplyObj( item, "obj_mechanism_use_amuletfire" ) and not private.zz_mechanism.is_open then

    cmn.CallEventHandler( "use_amuletfire_inv" );
    cmn.CallEventHandler( "use_amuletfire_beg" );

    local func_after2 = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_amuletfire" );
      cmn.CallEventHandler( "use_amuletfire_end" );
    
    end;

    local func_after = function ()

      ObjSet( "anm_mechanism_stash_cover", { animfunc = "func_open_stash_cover", endtrig = func_after2, playing = true } );

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_missed_part2_zz_mechanism");

    ObjSet( "anm_mechanism_stash_cover", { animfunc = "func_use_fireamulet", endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pickaxe()

  local item = "inv_pickaxe";

  if cmn.ApplyObj( item, "gzz_worldoffire_totem" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_totem" );

  elseif ( cmn.ApplyObj( item, "obj_totem_use_pickaxe" ) ) then

    cmn.CallEventHandler( "use_pickaxe_inv" );
    cmn.CallEventHandler( "use_pickaxe_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_pickaxe" );
      cmn.CallEventHandler( "use_pickaxe_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_crash_stones_zz_totem");

    ObjSet( "anm_totem_use_pickaxe", { alp = 1, playing = 1, endtrig = func_after } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_totempart()

  local item = "inv_totempart";

  if cmn.ApplyObj( item, "gzz_worldoffire_totem" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_totem" );

  elseif ( cmn.ApplyObj( item, "obj_totem_use_totempart" ) and cmn.CheckMultiObject( "totempart", 2 ) and cmn.IsEventDone("use_pickaxe") ) then

    cmn.CallEventHandler( "use_totempart_inv" );
    cmn.CallEventHandler( "use_totempart_beg" );

    if ( not cmn.IsEventDone( "get_detail2" ) ) then
      public.get_detail2();
    end;

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_totempart" );
      cmn.CallEventHandler( "use_totempart_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_totem_parts");
                   
    ObjSet( "anm_totem_use_parts", { alp = 1, playing = 1, endtrig = func_after } );

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_pliers()

  cmn.SetEventDone( "get_pliers" );
  cmn.CallEventHandler( "get_pliers" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_healingpotion()
  
  ObjSet("spr_fountain_healingpotion",  { ang = 0.3546 });

  cmn.SetEventDone( "get_healingpotion" );
  cmn.CallEventHandler( "get_healingpotion" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_detail3()

  cmn.SetEventDone( "get_detail3" );
  cmn.CallEventHandler( "get_detail3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_amuletfire()

  cmn.SetEventDone( "get_amuletfire" );
  cmn.CallEventHandler( "get_amuletfire" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_totempart2()

  cmn.SetEventDone( "get_totempart1" );
  cmn.CallEventHandler( "get_totempart1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_amuletbag()

  cmn.SetEventDone( "get_amuletbag" );
  cmn.CallEventHandler( "get_amuletbag" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_crackedstone()

  cmn.SetEventDone( "get_crackedstone" );
  cmn.CallEventHandler( "get_crackedstone" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_pickaxe()

  cmn.SetEventDone( "get_pickaxe" );
  cmn.CallEventHandler( "get_pickaxe" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_bowl()

  cmn.SetEventDone( "get_bowl" );
  cmn.CallEventHandler( "get_bowl" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_totempart2") and cmn.IsEventDone("win_mechanism") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_totempart3()

  cmn.SetEventDone( "get_totempart2" );
  cmn.CallEventHandler( "get_totempart2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_bowl") and cmn.IsEventDone("win_mechanism") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_amethystheart()

  cmn.SetEventDone( "get_amethystheart" );
  cmn.CallEventHandler( "get_amethystheart" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_detail2()

  cmn.SetEventDone( "get_detail2" );
  cmn.CallEventHandler( "get_detail2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_firenecklace()
  
  cmn.Lock(1);
  
  ObjSet("spr_worldoffire_firenecklace",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  local func_after_dlg = function ()

    cmn.CallEventHandler( "get_firenecklace_end" );
    
    --common_impl.PlayBackgroundMusic();
    
    ObjSet("rm_worldoffire",  { color_r = 0, color_g = 0, color_b = 0 });
    cmn.GotoRoom("rm_chapel");

  end;

  local func_after2 = function ()
    cmn.StopAllEnv();
    cmn.Lock(0);
    cmn.PlayFullscreenVideo( "assets/levels/level1/rm_worldoffire/vid_return1", func_after_dlg, "assets/levels/level1/audio/mus/aud_return_mus");
  end;

  local func_after = function ()
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_stephed_dissapears");
    ObjSet( "anm_worldoffire_stephen_disintegration", { endtrig = func_after2, playing = true } );
  end;

  cmn.SetEventDone( "get_firenecklace" );
  cmn.CallEventHandler( "get_firenecklace_inv" );
  cmn.CallEventHandler( "get_firenecklace_mid" );
  cmn.CallEventHandler( "get_firenecklace_loc" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.current_dialog = "";

  ObjAnimate( "obj_worldoffire_dialog_stephen2", "alp", 0, 0, func_after, { 0, 0, 1,    0.5, 0, 0 } );
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_worldoffire()

  if not ( cmn.IsEventDone( "opn_worldoffire" ) ) then
    cmn.SetEventDone( "opn_worldoffire" );
    cmn.CallEventHandler("opn_worldoffire");
    cmn.ShowBbt( "worldoffire_open" );
    interface_impl.ShowGlobalTask();
  end;
  
  if cmn.IsEventDone("get_firenecklace") then
    
    local func_after_dlg = function ()

      cmn.GotoRoom("rm_chapel");

    end;
    
    cmn.Lock( 0 );
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level1/rm_worldoffire/vid_return1", func_after_dlg, "assets/levels/level1/audio/mus/aud_return_mus");
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_1_1", { alp = 1 }},
                 {"spr_col_1_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_1_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_1_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_1_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_1_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_1_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_1_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function private.play_fire_vid()
  
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_fire_sound_"..math.random(1,3));
  VidPlay("vid_worldoffire_fire", private.play_fire_vid);
  
end;
--------------------------------------------------------------------------------------------
function public.touch_totem_rock()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_stones_zz_totem");
  
  cmn.ShowBbt( "obj_totem_use_pickaxe" );
  
  ObjSet("anm_totem_rock_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_totem()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_totem");
  
  cmn.ShowBbt( "obj_totem_use_totempart" );
  
  ObjSet("anm_totem_totem_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_mechanism_cover()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_box_zz_mechanism");
  
  cmn.ShowBbt( "obj_mechanism_use_amuletfire" );
  
  ObjSet("anm_mechanism_stash_cover", { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_statue_hand_1()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_left_hand_monster");
  
  cmn.ShowBbt( "obj_fountain_use_rubyheart" );
  
  ObjSet("anm_fountain_left_hand",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_statue_hand_2()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_right_hand_monster");
  
  cmn.ShowBbt( "obj_fountain_use_amethystheart" );
  
  ObjSet("anm_fountain_right_hand",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_amuletbag()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_star_for_bag");
  
  cmn.ShowBbt( "obj_stephen_use_pliers" );
  
  ObjSet("anm_stephen_use_pliers", { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_stephen()
  
  cmn.ShowBbt( "obj_stephen_use_healingpotion" );
  
  if not cmn.IsEventDone("win_mechanism") then
  
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_claws_stephen");
    
    ObjSet("anm_stephen_mech_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
      
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_stephen2_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "worldoffire", "stephen2", 2 );
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "use_healingpotion_end" );
    int_diary.AddDiarypage( 10 );
    
    cmn.ShowBbt( "worldoffire_after_dialog" );
    ObjSet("anm_worldoffire_dialog_stephen2_hand_2",  { playing = 1 });
    
  end;
  
  local anm_give = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_worldoffire_dialog_stephen2_lipsync1");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_worldoffire_dialog_stephen2_timer",  { playing = 0 }},
                   {"anm_worldoffire_dialog_stephen2_head", { alp = 1 }},
                   {"anm_worldoffire_dialog_stephen2_hand_1", { alp = 0, playing = 0 }},
                   {"anm_worldoffire_dialog_stephen2_hand_give", { alp = 1, playing = 1, endtrig = dialog_end }} } );
    
  end;
  
  private.dlg_lipsync = "vid_worldoffire_dialog_stephen2_lipsync1";

  cmn.ShowDlgBbt( "dlg_stephen2_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level1/audio/voc/aud_stephen_worldoffire_1");

  ObjMultiSet( { {"tmr_worldoffire_dialog_stephen2_timer", { time = 20.5, playing = 1, endtrig = anm_give }},
                 {"vid_worldoffire_dialog_stephen2_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = anm_give }},
                 {"obj_character_dialog_continue", { event_mup = anm_give }} } );
  
end; 
--------------------------------------------------------------------------------------------
function public.skip_dlg_stephen2()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);

  local func_after_dlg = function ()

    cmn.Lock(0);
    
    cmn.CallEventHandler( "use_healingpotion_end" );
    cmn.ShowBbt( "worldoffire_after_dialog" );
    
    int_diary.AddDiarypage( 10 );
    
    ObjSet("anm_worldoffire_dialog_stephen2_hand_2",  { playing = 1 });
    
  end;

  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();

  ObjMultiSet( { {"tmr_worldoffire_dialog_stephen2_timer",  { playing = 0 }},
                 {"anm_worldoffire_dialog_stephen2_head", { alp = 1 }},
                 {"anm_worldoffire_dialog_stephen2_hand_1", { alp = 0, playing = 0 }},
                 {"anm_worldoffire_dialog_stephen2_hand_give", { alp = 1, playing = 1, endtrig = func_after_dlg }} } );
  
end; 
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Mechanism *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_mechanism = {};
public.zz_mechanism = {};

function private.Init_Mechanism()

  private.zz_mechanism.is_open = false;
  private.zz_mechanism.selected = { 2, 2 };
  private.zz_mechanism.start = {0,0};
  private.zz_mechanism.select_start = {0,0};
  private.zz_mechanism.direction = 0;

  --массив входов и выходов ячеек, { вход, выход }
  private.zz_mechanism.exits = {
    { 1, 3 }, { 2, 2 }, { 1, 1 },
    { 3, 1 }, { 2, 3 }, { 2, 1 },
    { 1, 2 }, { 3, 2 }, { 3, 3 }
  };
  --массив входов и выходов границы
  private.zz_mechanism.cover_exits_1 = { 2, 2, 3 };
  private.zz_mechanism.cover_exits_2 = { 2, 2, 3 };
  -----------------------------------------------------------------------------------
  game.hint[ "win_mechanism" ] = {
    type = "click",
    use_place = "gzz_mechanism_game",
    room = "rm_worldoffire",
    zz = "zz_mechanism",
    zz_gate = "gzz_worldoffire_mechanism"
  };
  -----------------------------------------------------------------------------------
  local win_mechanism = function ()

    if cmn.IsEventDone( "win_mechanism" ) then
      
      ObjDelete( "anm_stephen_mech_touch" );
      ObjDelete( "obj_mechanism_waters1" );
      ObjDelete( "obj_mechanism_game" );
      ObjDelete( "gzz_mechanism_game" );
      ObjDelete( "fx_stephen_fire" );

      ObjDelete( "spr_worldoffire_stephen_stephen_1" );
      ObjDelete( "fx_worldoffire_fog" );
      ObjDelete( "spr_worldoffire_stephen_spider_legs_1_closed" );
      
      ObjDelete( "vid_worldoffire_fire" );
      
      if cmn.IsEventDone("get_totempart2") and cmn.IsEventDone("get_bowl") then
        ObjSet("gzz_worldoffire_mechanism",  { active = 0, visible = 0 });
      end;

      ObjMultiSet( {
        { "obj_stephen_mech_open", { alp = 1 } },
        { "spr_stephen_mech_open_2", { alp = 1 } },
        { "obj_mechanism_waters2", { alp = 1 } },
        { "spr_worldoffire_stephen_spider_legs_2_opened", { alp = 1 } },
        { "spr_worldoffire_stephen_stephen_2", { alp = 1 } },
        { "anm_stephen_stephen", { animfunc = "func_anm_stephen2", frame = 0 } }
      } );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_mechanism", win_mechanism, "rm_worldoffire" );

end;
-----------------------------------------------------------------------------------
function public.zz_mechanism.OpenAnim()

  cmn.Lock( 1 );
  private.zz_mechanism.DrawScene();

  local func_after = function ()

    cmn.Lock( 0 );

    ObjMultiSet( {
      { "obj_mechanism_back", { pos_x = 0, pos_y = 0, scale_x = 1, scale_y = 1 } },
      { "obj_mechanism_game", { input = true } }
    } );

    cmn.MiniGameShow();
    iOS_NeedDrag(0);
    private.zz_mechanism.is_open = true;
    private.zz_mechanism.CheckWin();

  end;

  local func_game = function ()
    ObjAnimate( "obj_mechanism_game", "alp", 0, 0, func_after, { 0, 0, 0,    0.5, 0, 1 } );
  end;

  ObjAnimate( "obj_mechanism_back", "scale_xy", 0, 0, func_game, { 0, 0, 1, 1,    0.8, 0, 1.5, 1.5 } );
  ObjAnimate( "obj_mechanism_back", "pos_xy", 0, 0, "", { 0, 0, 0, 0,    0.8, 0, -67, 125 } );

end;
-----------------------------------------------------------------------------------
function private.zz_mechanism.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_mechanism" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_mechanism" ].state = {
    water = { 0, 0, 0 },
    map = {
      { 8, 2, 3 },
      { 4, 5, 6 },
      { 7, 1, 9 }
    }
  };

end;
-----------------------------------------------------------------------------------
function public.zz_mechanism.Reset()

  --DbgTrace( "***Reset" );

  for i = 1, 3, 1 do
    if ( private.zz_mechanism.state.water[i] == 1 ) then
      ObjAnimate( "spr_mechanism_water_"..i, "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );
      ObjAnimate( "anm_mechanism_water_flows_"..i, "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );
    end;
  end;

  private.zz_mechanism.StartConditions();
  private.zz_mechanism.state = ng_global.progress[ ng_global.currentprogress ][ "win_mechanism" ].state;

  ----------

  private.zz_mechanism.selected[1] = 2;
  private.zz_mechanism.selected[2] = 2;

  ----------
  local block_name;
  for i = 1, 3, 1 do
    for j = 1, 3, 1 do
      block_name = "spr_mechanism_block_"..private.zz_mechanism.state.map[i][j];
      ObjAnimate( block_name, "pos_xy", 0, 0, "", { 
        0.0, 0, ObjGet(block_name).pos_x, ObjGet(block_name).pos_y,
        0.2, 0, (-97+(j-1)*97), (-97+(i-1)*97)
      } );
    end;
  end;

  ObjAnimate( "obj_mechanism_window", "pos_xy", 0, 0, function () cmn.Lock( 0 ); end, { 
    0.0, 0, ObjGet("obj_mechanism_window").pos_x, ObjGet("obj_mechanism_window").pos_y,
    0.2, 0, 0, 0
  } );

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_zz_mechanism_click_reset");

end;
-----------------------------------------------------------------------------------
function public.zz_mechanism.Skip()

  --DbgTrace( "***Skip" );

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_zz_mechanism_click_skip");

  for i = 1, 3, 1 do
    if ( private.zz_mechanism.state.water[i] == 0 ) then

      ObjMultiSet( {
        { "spr_mechanism_water_"..i, { alp = 0 } },
        { "anm_mechanism_water_flows_"..i, { alp = 1, endtrig = "", playing = true, frame = 0 } }
      } );

    end;
  end;

  ng_global.progress[ ng_global.currentprogress ][ "win_mechanism" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_mechanism" ].state = {
    water = { 1, 1, 1 },
    map = {
      { 5, 2, 4 },
      { 9, 6, 3 },
      { 8, 7, 1 }
    }
  };
  private.zz_mechanism.state = ng_global.progress[ ng_global.currentprogress ][ "win_mechanism" ].state;

  local block_name;
  for i = 1, 3, 1 do
    for j = 1, 3, 1 do
      block_name = "spr_mechanism_block_"..private.zz_mechanism.state.map[i][j];
      ObjAnimate( block_name, "pos_xy", 0, 0, "", { 
        0.0, 0, ObjGet(block_name).pos_x, ObjGet(block_name).pos_y,
        0.2, 0, (-97+(j-1)*97), (-97+(i-1)*97)
      } );
    end;
  end;

  ObjSet( "tmr_mechanism_animlock", { time = 3, endtrig = private.zz_mechanism.CheckWin, playing = true } );

end;
-----------------------------------------------------------------------------------
function private.zz_mechanism.DrawScene()

  --DbgTrace( "***DrawScene" );

  for i = 1, 3, 1 do

    for j = 1, 3, 1 do
      ObjSet("spr_mechanism_block_"..private.zz_mechanism.state.map[i][j], { pos_x = -97+(j-1)*97, pos_y = -97+(i-1)*97 } );
    end;

    if ( private.zz_mechanism.state.water[i] == 1 ) then
      ObjMultiSet( {
        { "spr_mechanism_water_"..i, { alp = 0 } },
        { "anm_mechanism_water_flows_"..i, { alp = 1, frame = 132 } }
      } );
    end;

  end;

end;
-----------------------------------------------------------------------------------
function private.zz_mechanism.CheckWin()

  --DbgTrace( "***CheckWin" );

  cmn.Lock( 1 );

  local win_col = true;
  local anim_flag = false;

  for j = 1, 3, 1 do

    if ( private.zz_mechanism.state.water[j] == 0 ) then

      win_col = true;

      for i = 1, 2, 1 do

        if private.zz_mechanism.exits[ private.zz_mechanism.state.map[i][ j ] ][2]
        ~= private.zz_mechanism.exits[ private.zz_mechanism.state.map[i+1][ j ] ][1] then

          --DbgTrace(
          --  "block"..private.zz_mechanism.state.map[i][ j ].." "..
          --  private.zz_mechanism.exits[ private.zz_mechanism.state.map[i][ j ] ][2]..
          --  " ~= block"..private.zz_mechanism.state.map[i+1][ j ].." "..
          --  private.zz_mechanism.exits[ private.zz_mechanism.state.map[i+1][ j ] ][1]
          --);

          win_col = false;
          break;

        end;

      end;

      if win_col then

        --DbgTrace( "колонна"..j.." входы блоков совпадают" );

        if  ( private.zz_mechanism.cover_exits_1[j] == private.zz_mechanism.exits[ private.zz_mechanism.state.map[1][ j ] ][1] )
        and ( private.zz_mechanism.cover_exits_2[j] == private.zz_mechanism.exits[ private.zz_mechanism.state.map[3][ j ] ][2] ) then

          --DbgTrace( 
          --  "колонна "..j.." "..private.zz_mechanism.cover_exits_1[j].." == "..
          --  private.zz_mechanism.exits[ private.zz_mechanism.state.map[1][ j ] ][1].." и "..
          --  private.zz_mechanism.cover_exits_2[j].." == "..private.zz_mechanism.exits[ private.zz_mechanism.state.map[3][ j ] ][2]
          --);

          private.zz_mechanism.state.water[j] = 1;
          
          cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_zz_mechanism_liquid_goes");

          ObjMultiSet( {
            { "spr_mechanism_water_"..j, { alp = 0 } },
            { "anm_mechanism_water_flows_"..j, { alp = 1, playing = true, frame = 0 } }
          } );

          anim_flag = true;

        --else
        --  DbgTrace( 
        --    "колонна "..j.." "..private.zz_mechanism.cover_exits_1[j].." ~= "..
        --    private.zz_mechanism.exits[ private.zz_mechanism.state.map[1][ j ] ][1].." или "..
        --    private.zz_mechanism.cover_exits_2[j].." ~= "..private.zz_mechanism.exits[ private.zz_mechanism.state.map[3][ j ] ][2]
        --  );
        end;


      end;

    --else
    --  DbgTrace( "колонна"..j.." уже была собрана" );

    end;

  end;

  local win_flag = true;
  for j = 1, 3, 1 do
    if ( private.zz_mechanism.state.water[j] ~= 1 ) then
      win_flag = false;
    end;
  end;

  local func_after;
  if ( win_flag ) then

    func_after = function ()
      ObjAnimate( "obj_mechanism_game", "alp", 0, 0, private.zz_mechanism.Win, { 0, 0, 1,    0.5, 0, 0 } );
    end;

    --DbgTrace( "WWWWWIIIIINNNNNN" );

    ObjDelete( "obj_mechanism_waters1" );
    ObjSet( "obj_mechanism_waters2", { alp = 1 } );

    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("mechanism");

  else
    func_after = function () cmn.Lock( 0 ); end;
  end;

  if ( anim_flag ) then
    ObjSet( "tmr_mechanism_animlock", { time = 2.5, endtrig = func_after, playing = true } );
  else
    func_after();
  end;

end;
-----------------------------------------------------------------------------------
function private.zz_mechanism.Win()
  
  private.zz_mechanism.is_open = false;

  iOS_NeedDrag(1);
  
  cmn.Lock( 0 );
  
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_mechanism" );
  cmn.CallEventHandler( "win_mechanism" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_mechanism" ].skip == 0 and ng_global.noskipgames[ "win_mechanism" ] == nil then

    ng_global.noskipgames[ "win_mechanism" ] = 1;
    common_impl.CheckAchiev("mg");

  end;
  
  local func_after = function ()
    
    cmn.ShowBbt( "worldoffire_after_mechanism" );
    
  end;

  common.CloseSubRoom();
  cmn.PlayFullscreenVideo( "assets/levels/level1/rm_worldoffire/vid_trap_disable", func_after, "assets/levels/level1/audio/mus/aud_disable_trap_mus");
  
end;
-----------------------------------------------------------------------------------
function public.zz_mechanism.OnStartDrag()

  --DbgTrace( "***OnStartDrag" );
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_zz_mechanism_click_stuff");

  private.zz_mechanism.start = GetZoomCursorPos();

  private.zz_mechanism.select_start = {
    ObjGet("obj_mechanism_window").pos_x - private.zz_mechanism.start[1],
    ObjGet("obj_mechanism_window").pos_y - private.zz_mechanism.start[2]
  };

  private.zz_mechanism.direction = 0;

end;
-----------------------------------------------------------------------------------
function public.zz_mechanism.OnDrag()

  local curspos = GetZoomCursorPos();--GetObjPosByObj();

  --DbgTrace( "curspos "..curspos[1].." "..curspos[2] );
 
  if private.zz_mechanism.direction == 0 then
    if private.zz_mechanism.start[1] + 5 < curspos[1] or private.zz_mechanism.start[1] - 5 > curspos[1] then
      private.zz_mechanism.direction = 1;
    elseif private.zz_mechanism.start[2] + 5 < curspos[2] or private.zz_mechanism.start[2] - 5 > curspos[2] then
      private.zz_mechanism.direction = 2;
    end;
  end;

  local pos;

  if private.zz_mechanism.direction == 1 then
    pos = curspos[1] + private.zz_mechanism.select_start[1];
  elseif private.zz_mechanism.direction == 2 then
    pos = curspos[2]+private.zz_mechanism.select_start[2];
  else
    return;
  end;

  --DbgTrace( "pos = "..pos );

  if pos < -97 then
    pos = -97;
  elseif pos > 97 then
    pos = 97;
  end;

  if private.zz_mechanism.direction == 1 then
    ObjSet( "obj_mechanism_window", { pos_x = pos } );
  elseif private.zz_mechanism.direction == 2 then
    ObjSet( "obj_mechanism_window", { pos_y = pos } );
  end;

end;
-----------------------------------------------------------------------------------
function public.zz_mechanism.OnEndDrag()

  --DbgTrace( "***OnEndDrag" );
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_zz_mechanism_unclick_stuff");

  local start_pos = 0;
  local go_pos = 0;
  local dir = "x";

  if private.zz_mechanism.direction == 1 then
    start_pos = ObjGet("obj_mechanism_window").pos_x;
  elseif private.zz_mechanism.direction == 2 then
    start_pos = ObjGet("obj_mechanism_window").pos_y;
    dir = "y";
  else
    return;
  end;

  if start_pos < -48 then
    go_pos = -97;
    private.zz_mechanism.selected[private.zz_mechanism.direction] = 1;
  elseif start_pos > 48 then
    go_pos = 97;
    private.zz_mechanism.selected[private.zz_mechanism.direction] = 3;
  else
    go_pos = 0;
    private.zz_mechanism.selected[private.zz_mechanism.direction] = 2;
  end;

  cmn.Lock( 1 );

  ObjAnimate( "obj_mechanism_window", "pos_"..dir, 0, 0, function () cmn.Lock( 0 ); end, 
  { 
    0.0, 0, start_pos, 
    0.2, 2, go_pos
  } );

  --DbgTrace( "selected = "..private.zz_mechanism.selected[1].." "..private.zz_mechanism.selected[2] );

end;
-----------------------------------------------------------------------------------
function public.zz_mechanism.OnButtonClick(num)

  local selected = private.zz_mechanism.selected;

  --DbgTrace( "***OnButtonClick num = "..num );

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_zz_mechanism_click_arrow");

  ObjAnimate( "spr_mechanism_button"..num.."_select", "alp", 0, 0, "", { 0, 0, 0,    0.1, 0, 1,    0.2, 0, 0 } );

  if num == 1 then

    local temp_block = "spr_mechanism_block_"..private.zz_mechanism.state.map[ 1 ][ selected[1] ].."_temp";
    ObjClone( "spr_mechanism_block_"..private.zz_mechanism.state.map[ 1 ][ selected[1] ], "_temp", false, "obj_mechanism_blocks" );

    ObjAnimate( temp_block, "pos_y", 0, 0, function () ObjDelete( temp_block ); private.zz_mechanism.CheckWin(); end, { 
      0.0, 0, -97,
      0.2, 0, -194
    } );

    ObjAnimate( "spr_mechanism_block_"..private.zz_mechanism.state.map[ 1 ][ selected[1] ], "pos_y", 0, 0, "", { 
      0.0, 0, 194,
      0.2, 0, 97
    } );

    ObjAnimate( "spr_mechanism_block_"..private.zz_mechanism.state.map[ 2 ][ selected[1] ], "pos_y", 0, 0, "", { 
      0.0, 0, 0,
      0.2, 0, -97
    } );

    ObjAnimate( "spr_mechanism_block_"..private.zz_mechanism.state.map[ 3 ][ selected[1] ], "pos_y", 0, 0, "", { 
      0.0, 0, 97,
      0.2, 0, 0
    } );

    local sel_state = private.zz_mechanism.state.map[ 1 ][ selected[1] ];
    private.zz_mechanism.state.map[ 1 ][ selected[1] ] = private.zz_mechanism.state.map[ 2 ][ selected[1] ];
    private.zz_mechanism.state.map[ 2 ][ selected[1] ] = private.zz_mechanism.state.map[ 3 ][ selected[1] ];
    private.zz_mechanism.state.map[ 3 ][ selected[1] ] = sel_state;

  elseif num == 2 then

    local temp_block = "spr_mechanism_block_"..private.zz_mechanism.state.map[ selected[2] ][ 3 ].."_temp";
    ObjClone( "spr_mechanism_block_"..private.zz_mechanism.state.map[ selected[2] ][ 3 ], "_temp", false, "obj_mechanism_blocks" );

    ObjAnimate( temp_block, "pos_x", 0, 0, function () ObjDelete( temp_block ); private.zz_mechanism.CheckWin(); end, { 
      0.0, 0, 97,
      0.2, 0, 194
    } );

    ObjAnimate( "spr_mechanism_block_"..private.zz_mechanism.state.map[ selected[2] ][ 1 ], "pos_x", 0, 0, "", { 
      0.0, 0, -97,
      0.2, 0, 0
    } );

    ObjAnimate( "spr_mechanism_block_"..private.zz_mechanism.state.map[ selected[2] ][ 2 ], "pos_x", 0, 0, "", { 
      0.0, 0, 0,
      0.2, 0, 97
    } );

    ObjAnimate( "spr_mechanism_block_"..private.zz_mechanism.state.map[ selected[2] ][ 3 ], "pos_x", 0, 0, "", { 
      0.0, 0, -194,
      0.2, 0, -97
    } );

    local sel_state = private.zz_mechanism.state.map[ selected[2] ][ 3 ];
    private.zz_mechanism.state.map[ selected[2] ][ 3 ] = private.zz_mechanism.state.map[ selected[2] ][ 2 ];
    private.zz_mechanism.state.map[ selected[2] ][ 2 ] = private.zz_mechanism.state.map[ selected[2] ][ 1 ];
    private.zz_mechanism.state.map[ selected[2] ][ 1 ] = sel_state;


  elseif num == 3 then

    local temp_block = "spr_mechanism_block_"..private.zz_mechanism.state.map[ 3 ][ selected[1] ].."_temp";
    ObjClone( "spr_mechanism_block_"..private.zz_mechanism.state.map[ 3 ][ selected[1] ], "_temp", false, "obj_mechanism_blocks" );

    ObjAnimate( temp_block, "pos_y", 0, 0, function () ObjDelete( temp_block ); private.zz_mechanism.CheckWin(); end, { 
      0.0, 0, 97,
      0.2, 0, 194
    } );

    ObjAnimate( "spr_mechanism_block_"..private.zz_mechanism.state.map[ 1 ][ selected[1] ], "pos_y", 0, 0, "", { 
      0.0, 0, -97, 
      0.2, 0, 0
    } );

    ObjAnimate( "spr_mechanism_block_"..private.zz_mechanism.state.map[ 2 ][ selected[1] ], "pos_y", 0, 0, "", { 
      0.0, 0, 0,
      0.2, 0, 97
    } );


    ObjAnimate( "spr_mechanism_block_"..private.zz_mechanism.state.map[ 3 ][ selected[1] ], "pos_y", 0, 0, "", { 
      0.0, 0, -194,
      0.2, 0, -97
    } );

    local sel_state = private.zz_mechanism.state.map[ 3 ][ selected[1] ];
    private.zz_mechanism.state.map[ 3 ][ selected[1] ] = private.zz_mechanism.state.map[ 2 ][ selected[1] ];
    private.zz_mechanism.state.map[ 2 ][ selected[1] ] = private.zz_mechanism.state.map[ 1 ][ selected[1] ];
    private.zz_mechanism.state.map[ 1 ][ selected[1] ] = sel_state;


  elseif num == 4 then

    local temp_block = "spr_mechanism_block_"..private.zz_mechanism.state.map[ selected[2] ][ 1 ].."_temp";
    ObjClone( "spr_mechanism_block_"..private.zz_mechanism.state.map[ selected[2] ][ 1 ], "_temp", false, "obj_mechanism_blocks" );

    ObjAnimate( temp_block, "pos_x", 0, 0, function () ObjDelete( temp_block ); private.zz_mechanism.CheckWin(); end, { 
      0.0, 0, -97,
      0.2, 0, -194
    } );

    ObjAnimate( "spr_mechanism_block_"..private.zz_mechanism.state.map[ selected[2] ][ 1 ], "pos_x", 0, 0, "", { 
      0.0, 0, 194,
      0.2, 0, 97
    } );

    ObjAnimate( "spr_mechanism_block_"..private.zz_mechanism.state.map[ selected[2] ][ 2 ], "pos_x", 0, 0, "", { 
      0.0, 0, 0,
      0.2, 0, -97
    } );

    ObjAnimate( "spr_mechanism_block_"..private.zz_mechanism.state.map[ selected[2] ][ 3 ], "pos_x", 0, 0, "", { 
      0.0, 0, 97,
      0.2, 0, 0
    } );

    local sel_state = private.zz_mechanism.state.map[ selected[2] ][ 1 ];
    private.zz_mechanism.state.map[ selected[2] ][ 1 ] = private.zz_mechanism.state.map[ selected[2] ][ 2 ];
    private.zz_mechanism.state.map[ selected[2] ][ 2 ] = private.zz_mechanism.state.map[ selected[2] ][ 3 ];
    private.zz_mechanism.state.map[ selected[2] ][ 3 ] = sel_state;

  end;

end;
-----------------------------------------------------------------------------------
function public.zz_mechanism.Focus( num, inout )
  
  local obj = "spr_mechanism_button"..num.."_off";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_HAND);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_DEFAULT);
    tme = ( 1 - alf ) * 0.3;
  end;

  --ObjAnimate( obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout } );
  
end;
--*********************************************************************************************************************
