-- name=inventory2
--*********************************************************************************************************************
function public.Init()

  private.Init_Tablet();
  --------------------------------------------------------------------------------------------
  -- function get_code () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_code" ] = {
    type = "get",
    get_obj = "spr_complex_tablet_code",
    room ="int_complex_inv",
    zz = "inv_complex_tablet",
    zz_gate = "inv_tablet"
  };
  --------------------------------------------------------------------------------------------
  local get_code_inv = function ()
  
    interface.InventoryItemAdd( "inv_code", "spr_complex_tablet_code" );
    
    if (not cmn.IsEventDone("get_tabletpart2") or cmn.IsEventDone("use_tabletpart2")) and 
       (not cmn.IsEventDone("get_tabletpart1") or cmn.IsEventDone("use_tabletpart1")) and
        not(cmn.IsEventDone("use_tabletpart2") and cmn.IsEventDone("use_tabletpart1"))  then
      ObjSet("inv_tablet_star_light",  { alp = 0 });
    end;
    
    ObjDelete( "gfx_complex_tablet_code" );
    ObjDelete( "spr_complex_tablet_code_sh" );
  
  end;
  cmn.AddSubscriber( "get_code", get_code_inv );

  --------------------------------------------------------------------------------------------
  -- function use_tabletpart2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_tabletpart2" ] = {
    type = "use",
    inv_obj = "inv_tabletpart2",
    use_place = "obj_complex_tablet_use_tabletpart2",
    room = "int_complex_inv",
    zz = "inv_complex_tablet",
    zz_gate = "inv_tablet"
  };
  --------------------------------------------------------------------------------------------
  local use_tabletpart2_inv = function ()
  
    interface.InventoryItemRemove( "inv_tabletpart2" );
    
    if not cmn.IsEventDone("get_tabletpart1") then
      ObjSet("inv_tablet_star_light",  { alp = 0 });
    end;
  
  end;
  local use_tabletpart2_beg = function ()
  
    ObjDelete( "obj_complex_tablet_use_tabletpart2" );
  
  end;
  local use_tabletpart2_end = function ()
    
    ObjSet("anm_complex_tablet_tabletpart2",  { alp = 1, frame = 400 });
    
    if cmn.IsEventDone("use_tabletpart1") then
      ObjDelete( "anm_complex_tablet_loading" );
      ObjMultiSet( { {"obj_complex_tablet_game", { alp = 1 }},
                     {"obj_complex_tablet_game_interface", { alp = 1, input = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tabletpart2", use_tabletpart2_beg, "inv_complex_tablet" );
  cmn.AddSubscriber( "use_tabletpart2", use_tabletpart2_inv );
  cmn.AddSubscriber( "use_tabletpart2", use_tabletpart2_end, "inv_complex_tablet" );
  cmn.AddSubscriber( "use_tabletpart2_inv", use_tabletpart2_inv, "inv_complex_tablet" );
  cmn.AddSubscriber( "use_tabletpart2_beg", use_tabletpart2_beg, "inv_complex_tablet" );
  cmn.AddSubscriber( "use_tabletpart2_end", use_tabletpart2_end, "inv_complex_tablet" );
  --------------------------------------------------------------------------------------------
  -- function use_tabletpart1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_tabletpart1" ] = {
    type = "use",
    inv_obj = "inv_tabletpart1",
    use_place = "obj_complex_tablet_use_tabletpart1",
    room = "int_complex_inv",
    zz = "inv_complex_tablet",
    zz_gate = "inv_tablet"
  };
  --------------------------------------------------------------------------------------------
  local use_tabletpart1_inv = function ()
  
    interface.InventoryItemRemove( "inv_tabletpart1" );
    
    if not cmn.IsEventDone("get_tabletpart2") then
      ObjSet("inv_tablet_star_light",  { alp = 0 });
    end;
  
  end;
  local use_tabletpart1_beg = function ()
  
    ObjDelete( "obj_complex_tablet_use_tabletpart1" );
  
  end;
  local use_tabletpart1_end = function ()
    
    ObjDelete( "anm_complex_tablet_tabletpart1_out" );
    ObjSet("anm_complex_tablet_tabletpart1",  { alp = 1, frame = 400 });
    
    if cmn.IsEventDone("use_tabletpart2") then
      ObjDelete( "anm_complex_tablet_loading" );
      ObjMultiSet( { {"obj_complex_tablet_game", { alp = 1 }},
                     {"obj_complex_tablet_game_interface", { alp = 1, input = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tabletpart1", use_tabletpart1_beg, "inv_complex_tablet" );
  cmn.AddSubscriber( "use_tabletpart1", use_tabletpart1_inv );
  cmn.AddSubscriber( "use_tabletpart1", use_tabletpart1_end, "inv_complex_tablet" );
  cmn.AddSubscriber( "use_tabletpart1_inv", use_tabletpart1_inv, "inv_complex_tablet" );
  cmn.AddSubscriber( "use_tabletpart1_beg", use_tabletpart1_beg, "inv_complex_tablet" );
  cmn.AddSubscriber( "use_tabletpart1_end", use_tabletpart1_end, "inv_complex_tablet" );

  --------------------------------------------------------------------------------------------
  -- function get_fixedhacker () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_fixedhacker" ] = {
    type = "get",
    get_obj = "obj_complex_hacker_fixedhacker",
    room ="int_complex_inv",
    zz = "inv_complex_hacker",
    zz_gate = "inv_hacker"
  };
  --------------------------------------------------------------------------------------------
  local get_fixedhacker_inv = function ()
  
    interface.InventoryItemRemove( "inv_hacker" );
    interface.InventoryItemAdd( "inv_fixedhacker", "obj_complex_hacker_fixedhacker" );
    
    ObjDelete( "gfx_complex_hacker_fixedhacker" );
  
  end;
  cmn.AddSubscriber( "get_fixedhacker", get_fixedhacker_inv );

  --------------------------------------------------------------------------------------------
  -- function use_element () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_element" ] = {
    type = "use",
    inv_obj = "inv_element",
    use_place = "obj_complex_hacker_use_element",
    room = "int_complex_inv",
    zz = "inv_complex_hacker",
    zz_gate = "inv_hacker"
  };
  --------------------------------------------------------------------------------------------
  local use_element_inv = function ()
  
    interface.InventoryItemRemove( "inv_element" );
  
  end;
  local use_element_beg = function ()
  
    ObjDelete( "obj_complex_hacker_use_element" );
  
  end;
  local use_element_end = function ()
  
    ObjMultiSet( { {"obj_complex_hacker_fixedhacker", { input = 1 }},
                   {"obj_complex_hacker_detail_1", { alp = 1 }},
                   {"obj_complex_hacker_detail_2", { alp = 1 }},
                   {"obj_complex_hacker_detail_3", { alp = 1 }},
                   {"anm_complex_hacker_close", { frame = 300 }},
                   {"gfx_complex_hacker_fixedhacker", { active = 1, visible = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_element", use_element_beg, "inv_complex_hacker" );
  cmn.AddSubscriber( "use_element", use_element_inv );
  cmn.AddSubscriber( "use_element", use_element_end, "inv_complex_hacker" );
  cmn.AddSubscriber( "use_element_inv", use_element_inv, "inv_complex_hacker" );
  cmn.AddSubscriber( "use_element_beg", use_element_beg, "inv_complex_hacker" );
  cmn.AddSubscriber( "use_element_end", use_element_end, "inv_complex_hacker" );

  --------------------------------------------------------------------------------------------
  -- function get_mechanicparrot () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_mechanicparrot" ] = {
    type = "get",
    get_obj = "obj_complex_brokenmechanicparrot_mechanicparrot",
    room ="int_complex_inv",
    zz = "inv_complex_brokenmechanicparrot",
    zz_gate = "inv_brokenmechanicparrot"
  };
  --------------------------------------------------------------------------------------------
  local get_mechanicparrot_inv = function ()
  
    interface.InventoryItemRemove( "inv_brokenmechanicparrot" );
    interface.InventoryItemAdd( "inv_mechanicparrot", "obj_complex_brokenmechanicparrot_mechanicparrot" );
    
    ObjDelete( "gfx_complex_brokenmechanicparrot_mechanicparrot" );
  
  end;
  cmn.AddSubscriber( "get_mechanicparrot", get_mechanicparrot_inv );

  --------------------------------------------------------------------------------------------
  -- function use_fob () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_fob" ] = {
    type = "use",
    inv_obj = "inv_fob",
    use_place = "obj_complex_brokenmechanicparrot_use_fob",
    room = "int_complex_inv",
    zz = "inv_complex_brokenmechanicparrot",
    zz_gate = "inv_brokenmechanicparrot"
  };
  --------------------------------------------------------------------------------------------
  local use_fob_inv = function ()
  
    interface.InventoryItemRemove( "inv_fob" );
  
  end;
  local use_fob_beg = function ()
  
    ObjDelete( "obj_complex_brokenmechanicparrot_use_fob" );
  
  end;
  local use_fob_end = function ()
  
    ObjMultiSet( { {"obj_complex_brokenmechanicparrot_mechanicparrot", { alp = 1, input = 1 }},
                   {"anm_complex_brokenmechanicparrot_use_heart", { alp = 1, frame = 300 }},
                   {"gfx_complex_brokenmechanicparrot_mechanicparrot", { active = 1, visible = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fob", use_fob_beg, "inv_complex_brokenmechanicparrot" );
  cmn.AddSubscriber( "use_fob", use_fob_inv );
  cmn.AddSubscriber( "use_fob", use_fob_end, "inv_complex_brokenmechanicparrot" );
  cmn.AddSubscriber( "use_fob_inv", use_fob_inv, "inv_complex_brokenmechanicparrot" );
  cmn.AddSubscriber( "use_fob_beg", use_fob_beg, "inv_complex_brokenmechanicparrot" );
  cmn.AddSubscriber( "use_fob_end", use_fob_end, "inv_complex_brokenmechanicparrot" );

  --------------------------------------------------------------------------------------------
  -- function get_runoutenergyelement () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_runoutenergyelement" ] = {
    type = "get",
    get_obj = "spr_complex_gun_runoutenergyelement",
    room ="int_complex_inv",
    zz = "inv_complex_gun",
    zz_gate = "inv_gun"
  };
  --------------------------------------------------------------------------------------------
  local get_runoutenergyelement_inv = function ()
  
    interface.InventoryItemAdd( "inv_runoutenergyelement", "spr_complex_gun_runoutenergyelement" );
    
    ObjDelete( "gfx_complex_gun_runoutenergyelement" );
    ObjSet("obj_complex_gun_use_chargedenergyelement",  { input = 1 });
  
  end;
  cmn.AddSubscriber( "get_runoutenergyelement", get_runoutenergyelement_inv );
  --------------------------------------------------------------------------------------------
  -- function get_fob () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_fob" ] = {
    type = "get",
    get_obj = "spr_complex_gun_fob",
    room ="int_complex_inv",
    zz = "inv_complex_gun",
    zz_gate = "inv_gun"
  };
  --------------------------------------------------------------------------------------------
  local get_fob_inv = function ()
  
    interface.InventoryItemAdd( "inv_fob", "spr_complex_gun_fob" );
    ObjSet("inv_brokenmechanicparrot_star_light",  { alp = 1 });
    
    if (not cmn.IsEventDone("get_chargedenergyelement") or cmn.IsEventDone("use_chargedenergyelement")) and 
       (not cmn.IsEventDone("get_crystal") or cmn.IsEventDone("use_crystal")) and
        not(cmn.IsEventDone("use_chargedenergyelement") and cmn.IsEventDone("use_crystal"))  then
      ObjSet("inv_gun_star_light",  { alp = 0 });
    end;
    
    ObjDelete( "gfx_complex_gun_fob" );
  
  end;
  cmn.AddSubscriber( "get_fob", get_fob_inv );
  --------------------------------------------------------------------------------------------
  -- function get_blaster () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_blaster" ] = {
    type = "get",
    get_obj = "obj_complex_gun_get",
    room ="int_complex_inv",
    zz = "inv_complex_gun",
    zz_gate = "inv_gun"
  };
  --------------------------------------------------------------------------------------------
  local get_blaster_inv = function ()
  
    interface.InventoryItemRemove( "inv_gun" );
    interface.InventoryItemAdd( "inv_blaster", "obj_complex_gun_get" );
    
    ObjDelete( "gfx_complex_gun_blaster" );
  
  end;
  cmn.AddSubscriber( "get_blaster", get_blaster_inv );

  --------------------------------------------------------------------------------------------
  -- function use_chargedenergyelement () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_chargedenergyelement" ] = {
    type = "use",
    inv_obj = "inv_chargedenergyelement",
    use_place = "obj_complex_gun_use_chargedenergyelement",
    room = "int_complex_inv",
    zz = "inv_complex_gun",
    zz_gate = "inv_gun"
  };
  --------------------------------------------------------------------------------------------
  local use_chargedenergyelement_inv = function ()
  
    interface.InventoryItemRemove( "inv_chargedenergyelement" );
    
    if not cmn.IsEventDone("get_crystal") and cmn.IsEventDone("get_fob") then
      ObjSet("inv_gun_star_light",  { alp = 0 });
    end;
  
  end;
  local use_chargedenergyelement_beg = function ()
  
    ObjDelete( "obj_complex_gun_use_chargedenergyelement" );
  
  end;
  local use_chargedenergyelement_end = function ()
  
    if cmn.IsEventDone("use_crystal") then
      ObjDelete( "obj_complex_gun_after" );
      ObjMultiSet( { {"obj_complex_gun_get", { alp = 1, input = 1 }},
                     {"anm_complex_gun_end", { frame = 300 }},
                     {"gfx_complex_gun_blaster", { active = 1, visible = 1 }} } );
    else
      ObjSet("anm_complex_gun_energy",  { animfunc = "func_use_ergyelement", frame = 300 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chargedenergyelement", use_chargedenergyelement_beg, "inv_complex_gun" );
  cmn.AddSubscriber( "use_chargedenergyelement", use_chargedenergyelement_inv );
  cmn.AddSubscriber( "use_chargedenergyelement", use_chargedenergyelement_end, "inv_complex_gun" );
  cmn.AddSubscriber( "use_chargedenergyelement_inv", use_chargedenergyelement_inv, "inv_complex_gun" );
  cmn.AddSubscriber( "use_chargedenergyelement_beg", use_chargedenergyelement_beg, "inv_complex_gun" );
  cmn.AddSubscriber( "use_chargedenergyelement_end", use_chargedenergyelement_end, "inv_complex_gun" );
  --------------------------------------------------------------------------------------------
  -- function use_crystal () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_crystal" ] = {
    type = "use",
    inv_obj = "inv_crystal",
    use_place = "obj_complex_gun_use_crystal",
    room = "int_complex_inv",
    zz = "inv_complex_gun",
    zz_gate = "inv_gun"
  };
  --------------------------------------------------------------------------------------------
  local use_crystal_inv = function ()
  
    interface.InventoryItemRemove( "inv_crystal" );
    
    if not cmn.IsEventDone("get_chargedenergyelement") and cmn.IsEventDone("get_fob") then
      ObjSet("inv_gun_star_light",  { alp = 0 });
    end;
  
  end;
  local use_crystal_beg = function ()
  
    ObjDelete( "obj_complex_gun_use_crystal" );
  
  end;
  local use_crystal_end = function ()
  
    if cmn.IsEventDone("use_chargedenergyelement") then
      ObjDelete( "obj_complex_gun_after" );
      ObjMultiSet( { {"obj_complex_gun_get", { alp = 1, input = 1 }},
                     {"anm_complex_gun_end", { frame = 300 }},
                     {"gfx_complex_gun_blaster", { active = 1, visible = 1 }} } );
    else
      ObjSet("anm_complex_gun_crystal",  { animfunc = "func_use_crystal", frame = 300 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crystal", use_crystal_beg, "inv_complex_gun" );
  cmn.AddSubscriber( "use_crystal", use_crystal_inv );
  cmn.AddSubscriber( "use_crystal", use_crystal_end, "inv_complex_gun" );
  cmn.AddSubscriber( "use_crystal_inv", use_crystal_inv, "inv_complex_gun" );
  cmn.AddSubscriber( "use_crystal_beg", use_crystal_beg, "inv_complex_gun" );
  cmn.AddSubscriber( "use_crystal_end", use_crystal_end, "inv_complex_gun" );

  --------------------------------------------------------------------------------------------
  -- function get_manipulator () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_manipulator" ] = {
    type = "get",
    get_obj = "obj_complex_manipulatorbase_manipulator",
    room ="int_complex_inv",
    zz = "inv_complex_manipulatorbase",
    zz_gate = "inv_manipulatorbase"
  };
  --------------------------------------------------------------------------------------------
  local get_manipulator_inv = function ()
  
    interface.InventoryItemRemove( "inv_manipulatorbase" );
    interface.InventoryItemAdd( "inv_manipulator", "obj_complex_manipulatorbase_manipulator" );
    
    ObjDelete( "gfx_complex_manipulatorbase_manipulator" );
  
  end;
  cmn.AddSubscriber( "get_manipulator", get_manipulator_inv );

  --------------------------------------------------------------------------------------------
  -- function use_manipulatormodule () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_manipulatormodule" ] = {
    type = "use",
    inv_obj = "inv_manipulatormodule",
    use_place = "obj_complex_manipulatorbase_use_manipulatormodule",
    room = "int_complex_inv",
    zz = "inv_complex_manipulatorbase",
    zz_gate = "inv_manipulatorbase"
  };
  --------------------------------------------------------------------------------------------
  local use_manipulatormodule_inv = function ()
  
    interface.InventoryItemRemove( "inv_manipulatormodule" );
    
    if not cmn.IsEventDone("get_manipulatorclaw") then
      ObjSet("inv_manipulatorbase_star_light",  { alp = 0 });
    end;
  
  end;
  local use_manipulatormodule_beg = function ()
  
    ObjDelete( "obj_complex_manipulatorbase_use_manipulatormodule" );
  
  end;
  local use_manipulatormodule_end = function ()
  
    if cmn.IsEventDone("use_manipulatorclaw") then
      ObjDelete( "anm_complex_manipulatorbase_touch_1" );
      ObjDelete( "anm_complex_manipulatorbase_touch_2" );
      ObjMultiSet( { {"obj_complex_manipulatorbase_manipulator", { input = 1 }},
                     {"anm_complex_manipulatorbase_active", { alp = 1, frame = 300 }},
                     {"gfx_complex_manipulatorbase_manipulator", { active = 1, visible = 1 }} } );
    else
      ObjMultiSet( { {"obj_complex_manipulatorbase_mod", { alp = 1 }},
                     {"obj_complex_manipulatorbase_use_manipulatorclaw", { input = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_manipulatormodule", use_manipulatormodule_beg, "inv_complex_manipulatorbase" );
  cmn.AddSubscriber( "use_manipulatormodule", use_manipulatormodule_inv );
  cmn.AddSubscriber( "use_manipulatormodule", use_manipulatormodule_end, "inv_complex_manipulatorbase" );
  cmn.AddSubscriber( "use_manipulatormodule_inv", use_manipulatormodule_inv, "inv_complex_manipulatorbase" );
  cmn.AddSubscriber( "use_manipulatormodule_beg", use_manipulatormodule_beg, "inv_complex_manipulatorbase" );
  cmn.AddSubscriber( "use_manipulatormodule_end", use_manipulatormodule_end, "inv_complex_manipulatorbase" );
  --------------------------------------------------------------------------------------------
  -- function use_manipulatorclaw () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_manipulatorclaw" ] = {
    type = "use",
    inv_obj = "inv_manipulatorclaw",
    use_place = "obj_complex_manipulatorbase_use_manipulatorclaw",
    room = "int_complex_inv",
    zz = "inv_complex_manipulatorbase",
    zz_gate = "inv_manipulatorbase"
  };
  --------------------------------------------------------------------------------------------
  local use_manipulatorclaw_inv = function ()
  
    interface.InventoryItemRemove( "inv_manipulatorclaw" );
    
    if not cmn.IsEventDone("get_manipulatormodule") then
      ObjSet("inv_manipulatorbase_star_light",  { alp = 0 });
    end;
  
  end;
  local use_manipulatorclaw_beg = function ()
  
    ObjDelete( "obj_complex_manipulatorbase_use_manipulatorclaw" );
  
  end;
  local use_manipulatorclaw_end = function ()
  
    if cmn.IsEventDone("use_manipulatormodule") then
      ObjDelete( "anm_complex_manipulatorbase_touch_1" );
      ObjDelete( "anm_complex_manipulatorbase_touch_2" );
      ObjMultiSet( { {"obj_complex_manipulatorbase_manipulator", { input = 1 }},
                     {"anm_complex_manipulatorbase_active", { alp = 1, frame = 300 }},
                     {"gfx_complex_manipulatorbase_manipulator", { active = 1, visible = 1 }} } );
    else
      ObjSet("obj_complex_manipulatorbase_claw",  { alp = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_manipulatorclaw", use_manipulatorclaw_beg, "inv_complex_manipulatorbase" );
  cmn.AddSubscriber( "use_manipulatorclaw", use_manipulatorclaw_inv );
  cmn.AddSubscriber( "use_manipulatorclaw", use_manipulatorclaw_end, "inv_complex_manipulatorbase" );
  cmn.AddSubscriber( "use_manipulatorclaw_inv", use_manipulatorclaw_inv, "inv_complex_manipulatorbase" );
  cmn.AddSubscriber( "use_manipulatorclaw_beg", use_manipulatorclaw_beg, "inv_complex_manipulatorbase" );
  cmn.AddSubscriber( "use_manipulatorclaw_end", use_manipulatorclaw_end, "inv_complex_manipulatorbase" );

  --------------------------------------------------------------------------------------------
  -- function get_readybomb () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_readybomb" ] = {
    type = "get",
    get_obj = "obj_complex_bomb_readybomb",
    room ="int_complex_inv",
    zz = "inv_complex_bomb",
    zz_gate = "inv_bomb"
  };
  --------------------------------------------------------------------------------------------
  local get_readybomb_inv = function ()
  
    interface.InventoryItemRemove( "inv_bomb" );
    interface.InventoryItemAdd( "inv_readybomb", "obj_complex_bomb" );
    
    ObjDelete( "obj_complex_bomb_readybomb" );
  
  end;
  cmn.AddSubscriber( "get_readybomb", get_readybomb_inv );

  --------------------------------------------------------------------------------------------
  -- function use_bombpart () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_bombpart" ] = {
    type = "use",
    inv_obj = "inv_bombpart",
    use_place = "obj_complex_bomb_use_bombpart",
    room = "int_complex_inv",
    zz = "inv_complex_bomb",
    zz_gate = "inv_bomb"
  };
  --------------------------------------------------------------------------------------------
  local use_bombpart_inv = function ()
  
    interface.InventoryItemRemove( "inv_bombpart" );
  
  end;
  local use_bombpart_beg = function ()
  
    ObjDelete( "obj_complex_bomb_use_bombpart" );
    
  end;
  local use_bombpart_end = function ()

    ObjDelete( "txt_complex_bomb_error" );
    ObjDelete( "txt_complex_bomb_ready" );

    ObjMultiSet( { {"anm_complex_bomb_touch", { animfunc = "func_parts", frame = 300 } },
                   {"txt_complex_bomb_time", { alp = 1 } },
                   {"obj_complex_bomb_readybomb", { input = 1 } },
                   {"gfx_complex_bomb_readybomb", { active = 1, visible = 1 } } } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bombpart", use_bombpart_beg, "inv_complex_bomb" );
  cmn.AddSubscriber( "use_bombpart", use_bombpart_inv );
  cmn.AddSubscriber( "use_bombpart", use_bombpart_end, "inv_complex_bomb" );
  cmn.AddSubscriber( "use_bombpart_inv", use_bombpart_inv, "inv_complex_bomb" );
  cmn.AddSubscriber( "use_bombpart_beg", use_bombpart_beg, "inv_complex_bomb" );
  cmn.AddSubscriber( "use_bombpart_end", use_bombpart_end, "inv_complex_bomb" );

  --------------------------------------------------------------------------------------------
  -- function get_armorcabinetkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_armorcabinetkey" ] = {
    type = "get",
    get_obj = "spr_complex_bag_armorcabinetkey",
    room ="int_complex_inv",
    zz = "inv_complex_bag",
    zz_gate = "inv_bag"
  };
  --------------------------------------------------------------------------------------------
  local get_armorcabinetkey_inv = function ()
  
    if cmn.IsEventDone("get_turretmodule2") and cmn.IsEventDone("get_shipsymbol2") then
      interface.InventoryItemRemove( "inv_bag" );
    end;
    interface.InventoryItemAdd( "inv_armorcabinetkey", "spr_complex_bag_armorcabinetkey" );
    
    ObjDelete( "gfx_complex_bag_armorcabinetkey" );
    ObjDelete( "spr_complex_bag_armorcabinetkey_sh" );
  
  end;
  cmn.AddSubscriber( "get_armorcabinetkey", get_armorcabinetkey_inv );
  --------------------------------------------------------------------------------------------
  -- function get_shipsymbol2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_shipsymbol2" ] = {
    type = "get",
    get_obj = "spr_complex_bag_shipsymbol2",
    room ="int_complex_inv",
    zz = "inv_complex_bag",
    zz_gate = "inv_bag"
  };
  --------------------------------------------------------------------------------------------
  local get_shipsymbol2_inv = function ()
  
    if cmn.IsEventDone("get_turretmodule2") and cmn.IsEventDone("get_armorcabinetkey") then
      interface.InventoryItemRemove( "inv_bag" );
    end;
    interface.InventoryItemAdd( "inv_shipsymbol2", "spr_complex_bag_shipsymbol2" );
    
    ObjDelete( "gfx_complex_bag_shipsymbol2" );
    ObjDelete( "spr_complex_bag_shipsymbol2_sh" );
  
  end;
  cmn.AddSubscriber( "get_shipsymbol2", get_shipsymbol2_inv );
  --------------------------------------------------------------------------------------------
  -- function get_turretmodule2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_turretmodule2" ] = {
    type = "get",
    get_obj = "spr_complex_bag_turretmodule2",
    room ="int_complex_inv",
    zz = "inv_complex_bag",
    zz_gate = "inv_bag"
  };
  --------------------------------------------------------------------------------------------
  local get_turretmodule2_inv = function ()
  
    if cmn.IsEventDone("get_armorcabinetkey") and cmn.IsEventDone("get_shipsymbol2") then
      interface.InventoryItemRemove( "inv_bag" );
    end;
    interface.InventoryItemAdd( "inv_turretmodule2", "spr_complex_bag_turretmodule2" );
    
    ObjDelete( "gfx_complex_bag_turretmodule2" );
    ObjDelete( "spr_complex_bag_turretmodule2_sh" );
  
  end;
  cmn.AddSubscriber( "get_turretmodule2", get_turretmodule2_inv );

  --------------------------------------------------------------------------------------------
  -- function use_lvl2badge2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl2badge2" ] = {
    type = "use",
    inv_obj = "inv_lvl2badge2",
    use_place = "obj_complex_bag_use_lvl2badge2",
    room = "int_complex_inv",
    zz = "inv_complex_bag",
    zz_gate = "inv_bag"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl2badge2_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl2badge2" );
  
  end;
  local use_lvl2badge2_beg = function ()
  
    ObjDelete( "obj_complex_bag_use_lvl2badge2" );
  
  end;
  local use_lvl2badge2_end = function ()
  
    if cmn.IsEventDone("use_lvl2badge1") then
      ObjDelete( "anm_complex_bag_use_star" );
      ObjDelete( "anm_complex_bag_use_wing" );
      ObjSet( "anm_complex_bag_open", { input = 1, alp = 1, frame = 300 } );
    else 
      ObjSet( "anm_complex_bag_use_wing", { alp = 1, frame = 300 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl2badge2", use_lvl2badge2_beg, "inv_complex_bag" );
  cmn.AddSubscriber( "use_lvl2badge2", use_lvl2badge2_inv );
  cmn.AddSubscriber( "use_lvl2badge2", use_lvl2badge2_end, "inv_complex_bag" );
  cmn.AddSubscriber( "use_lvl2badge2_inv", use_lvl2badge2_inv, "inv_complex_bag" );
  cmn.AddSubscriber( "use_lvl2badge2_beg", use_lvl2badge2_beg, "inv_complex_bag" );
  cmn.AddSubscriber( "use_lvl2badge2_end", use_lvl2badge2_end, "inv_complex_bag" );
  --------------------------------------------------------------------------------------------
  -- function use_lvl2badge1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl2badge1" ] = {
    type = "use",
    inv_obj = "inv_lvl2badge1",
    use_place = "obj_complex_bag_use_lvl2badge1",
    room = "int_complex_inv",
    zz = "inv_complex_bag",
    zz_gate = "inv_bag"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl2badge1_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl2badge1" );
    
    if not cmn.IsEventDone("get_lvl2badge2") then
      ObjSet("inv_bag_star_light",  { alp = 0 });
    end;
  
  end;
  local use_lvl2badge1_beg = function ()
  
    ObjDelete( "obj_complex_bag_use_lvl2badge1" );
  
  end;
  local use_lvl2badge1_end = function ()
  
    if cmn.IsEventDone("use_lvl2badge2") then
      ObjDelete( "anm_complex_bag_use_star" );
      ObjDelete( "anm_complex_bag_use_wing" );
      ObjSet( "anm_complex_bag_open", { input = 1, alp = 1, frame = 300 } );
    else 
      ObjSet( "anm_complex_bag_use_star", { alp = 1, frame = 300 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl2badge1", use_lvl2badge1_beg, "inv_complex_bag" );
  cmn.AddSubscriber( "use_lvl2badge1", use_lvl2badge1_inv );
  cmn.AddSubscriber( "use_lvl2badge1", use_lvl2badge1_end, "inv_complex_bag" );
  cmn.AddSubscriber( "use_lvl2badge1_inv", use_lvl2badge1_inv, "inv_complex_bag" );
  cmn.AddSubscriber( "use_lvl2badge1_beg", use_lvl2badge1_beg, "inv_complex_bag" );
  cmn.AddSubscriber( "use_lvl2badge1_end", use_lvl2badge1_end, "inv_complex_bag" );
  
  --------------------------------------------------------------------------------------------
  -- function opn_gun () end;
  --------------------------------------------------------------------------------------------
  local opn_gun = function ()
  
    ObjDelete("anm_complex_gun_start");
    ObjSet("obj_complex_gun_after",  { alp = 1, input = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_gun", opn_gun, "inv_complex_gun" );

    --port.  fix
  if port.isPortable() == 1 then
    port.InventoryPopupInit("inventory2_hub");
    port.VideoResizeInRoom("inventory2");
  end;
  
end;
--*********************************************************************************************************************
-- function *** CLOSE FUNC *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.inv_complex_tablet_close()

  if not cmn.IsEventDone( "get_code" ) then
    
    cmn.SetEventDone( "get_code" );
    cmn.CallEventHandler( "get_code", "inv_complex_tablet" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;
  
  if cmn.IsEventDone("use_tabletpart1") and cmn.IsEventDone("use_tabletpart2") and not cmn.IsEventDone("win_tablet") then
    cmn.MiniGameHide("tablet");
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_hacker_close()

  if cmn.IsEventDone( "use_element" ) and not cmn.IsEventDone( "get_fixedhacker" ) then
    
    cmn.SetEventDone( "get_fixedhacker" );
    cmn.CallEventHandler( "get_fixedhacker", "inv_complex_hacker" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_brokenmechanicparrot_close()

  if cmn.IsEventDone( "use_fob" ) and not cmn.IsEventDone( "get_mechanicparrot" ) then
    
    cmn.SetEventDone( "get_mechanicparrot" );
    cmn.CallEventHandler( "get_mechanicparrot", "inv_complex_brokenmechanicparrot" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_bomb_close()

  if cmn.IsEventDone( "use_bombpart" ) and not cmn.IsEventDone( "get_readybomb" ) then
    
    cmn.SetEventDone( "get_readybomb" );
    cmn.CallEventHandler( "get_readybomb", "inv_complex_bomb" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_bag_close()

  if cmn.IsEventDone( "use_lvl2badge1" ) and cmn.IsEventDone( "use_lvl2badge2" )  then
    
    if not cmn.IsEventDone("get_armorcabinetkey") or not cmn.IsEventDone("get_shipsymbol2") or not cmn.IsEventDone("get_turretmodule2") then
      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
    end;
    
    if not cmn.IsEventDone("get_armorcabinetkey") then
      ObjSet("spr_complex_bag_armorcabinetkey",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });
      cmn.SetEventDone( "get_armorcabinetkey" );
      cmn.CallEventHandler( "get_armorcabinetkey", "inv_complex_bag" );
    end;
    
    if not cmn.IsEventDone("get_shipsymbol2") then
      cmn.SetEventDone( "get_shipsymbol2" );
      cmn.CallEventHandler( "get_shipsymbol2", "inv_complex_bag" );
    end;
    
    if not cmn.IsEventDone("get_turretmodule2") then
      cmn.SetEventDone( "get_turretmodule2" );
      cmn.CallEventHandler( "get_turretmodule2", "inv_complex_bag" );
    end;

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_manipulatorbase_close()

  if cmn.IsEventDone( "use_manipulatormodule" ) and cmn.IsEventDone( "use_manipulatorclaw" ) and not cmn.IsEventDone( "get_manipulator" ) then
    
    cmn.SetEventDone( "get_manipulator" );
    cmn.CallEventHandler( "get_manipulator", "inv_complex_manipulatorbase" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_gun_close()
  
  if not cmn.IsEventDone("get_fob") or not cmn.IsEventDone("get_runoutenergyelement") then
    
    if not cmn.IsEventDone("get_fob") then
      cmn.SetEventDone( "get_fob" );
      cmn.CallEventHandler( "get_fob", "inv_complex_gun" );
    end;
    
    if not cmn.IsEventDone("get_runoutenergyelement") then
      cmn.SetEventDone( "get_runoutenergyelement" );
      cmn.CallEventHandler( "get_runoutenergyelement", "inv_complex_gun" );
    end;

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;

  if cmn.IsEventDone( "use_chargedenergyelement" ) and cmn.IsEventDone( "use_crystal" ) and not cmn.IsEventDone( "get_blaster" ) then
    
    cmn.SetEventDone( "get_blaster" );
    cmn.CallEventHandler( "get_blaster", "inv_complex_gun" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_tabletpart2()

  local item = "inv_tabletpart2";

  if cmn.ObjIntersectCheck( item, "obj_complex_tablet_use_tabletpart2" ) then

    cmn.CallEventHandler( "use_tabletpart2_inv", "inv_complex_tablet" );
    cmn.CallEventHandler( "use_tabletpart2_beg", "inv_complex_tablet" );

    local func_after = function ()

      cmn.SetEventDone( "use_tabletpart2" );
      cmn.CallEventHandler( "use_tabletpart2_end", "inv_complex_tablet" );

      cmn.Lock( 0 );
      
      if cmn.IsEventDone("use_tabletpart1") then
        cmn.MiniGameShow('tablet');
      end;
    
    end;
    
    local anm_game_2 = function ()
      
      ObjSet("anm_complex_tablet_activate",  { playing = 1, endtrig = func_after });
      
    end;
    
    local anm_game = function ()
      
      ObjAnimate("obj_complex_tablet_game", "alp", 0, 0, anm_game_2, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("obj_complex_tablet_game_interface", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
    local anm_loading = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_inv_monitor_on");
      ObjSet("anm_complex_tablet_loading",  { alp = 1, playing = 1, endtrig = anm_game });
      
    end;
    
    if not cmn.IsEventDone( "get_code" ) then
    
      cmn.SetEventDone( "get_code" );
      cmn.CallEventHandler( "get_code", "inv_complex_tablet" );

      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_inv_insert_stuff_monitor");
    
    if cmn.IsEventDone("use_tabletpart1") then
      ObjSet("anm_complex_tablet_tabletpart2",  { alp = 1, playing = 1, endtrig = anm_loading });
    else 
      ObjSet("anm_complex_tablet_tabletpart2",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_tabletpart1()

  local item = "inv_tabletpart1";

  if cmn.ObjIntersectCheck( item, "obj_complex_tablet_use_tabletpart1" ) then

    cmn.CallEventHandler( "use_tabletpart1_inv", "inv_complex_tablet" );
    cmn.CallEventHandler( "use_tabletpart1_beg", "inv_complex_tablet" );

    local func_after = function ()

      cmn.SetEventDone( "use_tabletpart1" );
      cmn.CallEventHandler( "use_tabletpart1_end", "inv_complex_tablet" );

      cmn.Lock( 0 );
      
      if cmn.IsEventDone("use_tabletpart2") then
        cmn.MiniGameShow('tablet');
      end;
    
    end;
    
    local anm_game_2 = function ()
      
      ObjSet("anm_complex_tablet_activate",  { playing = 1, endtrig = func_after });
      
    end;
    
    local anm_game = function ()
      
      ObjAnimate("obj_complex_tablet_game", "alp", 0, 0, anm_game_2, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("obj_complex_tablet_game_interface", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
    local anm_loading = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_inv_monitor_on");
      ObjSet("anm_complex_tablet_loading",  { alp = 1, playing = 1, endtrig = anm_game });
      
    end;
    
    if not cmn.IsEventDone( "get_code" ) then
    
      cmn.SetEventDone( "get_code" );
      cmn.CallEventHandler( "get_code", "inv_complex_tablet" );

      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

    end;

    cmn.Lock( 1 );
    
    local anm_new = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_inv_insert_antenna");
      
      if cmn.IsEventDone("use_tabletpart2") then
        ObjSet("anm_complex_tablet_tabletpart1",  { alp = 1, playing = 1, endtrig = anm_loading });
      else 
        ObjSet("anm_complex_tablet_tabletpart1",  { alp = 1, playing = 1, endtrig = func_after });
      end;
      
    end;
    
    ObjSet("anm_complex_tablet_tabletpart1_out",  { alp = 1, playing = 1, endtrig = anm_new });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_element()

  local item = "inv_element";

  if cmn.ObjIntersectCheck( item, "obj_complex_hacker_use_element" ) and cmn.CheckMultiObject( "element", 3 ) then

    cmn.CallEventHandler( "use_element_inv", "inv_complex_hacker" );
    cmn.CallEventHandler( "use_element_beg", "inv_complex_hacker" );

    local func_after = function ()

      cmn.SetEventDone( "use_element" );
      cmn.CallEventHandler( "use_element_end", "inv_complex_hacker" );

      cmn.Lock( 0 );
    
    end;
    
    local anm_close = function ()
      
      ObjSet("anm_complex_hacker_close",  { playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_inv_insert_broken_phone");
    
    ObjAnimate("obj_complex_hacker_detail_1", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    
    ObjAnimate("obj_complex_hacker_detail_2", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 0,   0.6, 0, 1 });
    
    ObjAnimate("obj_complex_hacker_detail_3", "alp", 0, 0, anm_close, { 0, 0, 0,   0.6, 0, 0,   0.9, 0, 1,   1.2, 0, 1 });
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_fob()

  local item = "inv_fob";

  if cmn.ObjIntersectCheck( item, "obj_complex_brokenmechanicparrot_use_fob" ) then

    cmn.CallEventHandler( "use_fob_inv", "inv_complex_brokenmechanicparrot" );
    cmn.CallEventHandler( "use_fob_beg", "inv_complex_brokenmechanicparrot" );

    local func_after = function ()

      cmn.SetEventDone( "use_fob" );
      cmn.CallEventHandler( "use_fob_end", "inv_complex_brokenmechanicparrot" );

      cmn.Lock( 0 );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_inv_insert_parrot");
  
    ObjSet("anm_complex_brokenmechanicparrot_use_heart",  { alp = 1, playing = 1, endtrig = func_after });
  
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_chargedenergyelement()

  local item = "inv_chargedenergyelement";

  if cmn.ObjIntersectCheck( item, "obj_complex_gun_use_chargedenergyelement" ) then

    cmn.CallEventHandler( "use_chargedenergyelement_inv", "inv_complex_gun" );
    cmn.CallEventHandler( "use_chargedenergyelement_beg", "inv_complex_gun" );

    local func_after = function ()

      cmn.SetEventDone( "use_chargedenergyelement" );
      cmn.CallEventHandler( "use_chargedenergyelement_end", "inv_complex_gun" );

      cmn.Lock( 0 );
    
    end;
    
    local anm_charge = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_pistol_ready");
      
      ObjMultiSet( { {"obj_complex_gun_get", { alp = 1 }},
                     {"obj_complex_gun_after", { alp = 0 }},
                     {"anm_complex_gun_end", { alp = 1, playing = 1, endtrig = func_after }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_right_stuff_pistol");
    
    if cmn.IsEventDone("use_crystal") then
      ObjSet("anm_complex_gun_energy",  { animfunc = "func_use_ergyelement", frame = 0, playing = 1, endtrig = anm_charge });
    else 
      ObjSet("anm_complex_gun_energy",  { animfunc = "func_use_ergyelement", frame = 0, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_crystal()

  local item = "inv_crystal";

  if cmn.ObjIntersectCheck( item, "obj_complex_gun_use_crystal" ) then

    cmn.CallEventHandler( "use_crystal_inv", "inv_complex_gun" );
    cmn.CallEventHandler( "use_crystal_beg", "inv_complex_gun" );

    local func_after = function ()

      cmn.SetEventDone( "use_crystal" );
      cmn.CallEventHandler( "use_crystal_end", "inv_complex_gun" );

      cmn.Lock( 0 );
    
    end;

    local anm_charge = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_pistol_ready");
      
      ObjMultiSet( { {"obj_complex_gun_get", { alp = 1 }},
                     {"obj_complex_gun_after", { alp = 0 }},
                     {"anm_complex_gun_end", { alp = 1, playing = 1, endtrig = func_after }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_crystal_pistol");
    
    if cmn.IsEventDone("use_chargedenergyelement") then
      ObjSet("anm_complex_gun_crystal",  { animfunc = "func_use_crystal", frame = 0, playing = 1, endtrig = anm_charge });
    else 
      ObjSet("anm_complex_gun_crystal",  { animfunc = "func_use_crystal", frame = 0, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_manipulatormodule()

  local item = "inv_manipulatormodule";

  if cmn.ObjIntersectCheck( item, "obj_complex_manipulatorbase_use_manipulatormodule" ) then

    cmn.CallEventHandler( "use_manipulatormodule_inv", "inv_complex_manipulatorbase" );
    cmn.CallEventHandler( "use_manipulatormodule_beg", "inv_complex_manipulatorbase" );

    local func_after = function ()

      cmn.SetEventDone( "use_manipulatormodule" );
      cmn.CallEventHandler( "use_manipulatormodule_end", "inv_complex_manipulatorbase" );

      cmn.Lock( 0 );
    
    end;
    
    local anm_activate = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mech_catch_inv_ready");
      
      ObjDelete("anm_complex_manipulatorbase_touch_1");
      ObjSet("anm_complex_manipulatorbase_active",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_1_mech_catch_inv");
    
    if cmn.IsEventDone("use_manipulatorclaw") then
      ObjAnimate( "obj_complex_manipulatorbase_mod", "alp", 0, 0, anm_activate, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 } );
    else 
      ObjAnimate( "obj_complex_manipulatorbase_mod", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_manipulatorclaw()

  local item = "inv_manipulatorclaw";

  if cmn.ObjIntersectCheck( item, "obj_complex_manipulatorbase_use_manipulatorclaw" ) then

    cmn.CallEventHandler( "use_manipulatorclaw_inv", "inv_complex_manipulatorbase" );
    cmn.CallEventHandler( "use_manipulatorclaw_beg", "inv_complex_manipulatorbase" );

    local func_after = function ()

      cmn.SetEventDone( "use_manipulatorclaw" );
      cmn.CallEventHandler( "use_manipulatorclaw_end", "inv_complex_manipulatorbase" );

      cmn.Lock( 0 );
    
    end;
    
    local anm_activate = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mech_catch_inv_ready");
      
      ObjDelete("anm_complex_manipulatorbase_touch_1");
      ObjSet("anm_complex_manipulatorbase_active",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_2_mech_catch_inv");
    
    if cmn.IsEventDone("use_manipulatormodule") then
      ObjAnimate( "obj_complex_manipulatorbase_claw", "alp", 0, 0, anm_activate, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 } );
    else 
      ObjAnimate( "obj_complex_manipulatorbase_claw", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bombpart()

  local item = "inv_bombpart";

  if cmn.ObjIntersectCheck( item, "obj_complex_bomb_use_bombpart" ) and cmn.CheckMultiObject( "bombpart", 3 ) then

    cmn.CallEventHandler( "use_bombpart_inv", "inv_complex_bomb" );
    cmn.CallEventHandler( "use_bombpart_beg", "inv_complex_bomb" );

    local func_after = function ()

      cmn.SetEventDone( "use_bombpart" );
      cmn.CallEventHandler( "use_bombpart_end", "inv_complex_bomb" );

      cmn.Lock( 0 );
    
    end;
    
    local anm_charge = function ()
      
      ObjAnimate("txt_complex_bomb_error", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });

      ObjAnimate("txt_complex_bomb_ready", "alp", 0, 0, "", 
        { 0, 0, 0,   0.3, 0, 1,   0.5, 0, 0.2,   0.7, 0, 1,   0.9, 0, 0.2,   1.1, 0, 1,   1.4, 0, 0 });
      
      ObjAnimate("txt_complex_bomb_time", "alp", 0, 0, func_after, { 0, 0, 0,   1.1, 0, 0,   1.4, 0, 1 });
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_bomb_parts");

    ObjSet( "anm_complex_bomb_touch", { animfunc = "func_parts", endtrig = anm_charge, playing = true } );
  
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl2badge2()

  local item = "inv_lvl2badge2";

  if cmn.ObjIntersectCheck( item, "obj_complex_bag_use_lvl2badge2" ) then

    cmn.CallEventHandler( "use_lvl2badge2_inv", "inv_complex_bag" );
    cmn.CallEventHandler( "use_lvl2badge2_beg", "inv_complex_bag" );

    local func_after = function ()

      cmn.SetEventDone( "use_lvl2badge2" );
      cmn.CallEventHandler( "use_lvl2badge2_end", "inv_complex_bag" );

      cmn.Lock( 0 );
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_bag_inv_1_opens");
      ObjSet("anm_complex_bag_open",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_bag_inv_1_insert_2");
    
    if cmn.IsEventDone("use_lvl2badge1") then
      ObjSet("anm_complex_bag_use_wing",  { alp = 1, playing = 1, endtrig = anm_open });
    else 
      ObjSet("anm_complex_bag_use_wing",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl2badge1()

  local item = "inv_lvl2badge1";

  if cmn.ObjIntersectCheck( item, "obj_complex_bag_use_lvl2badge1" ) then

    cmn.CallEventHandler( "use_lvl2badge1_inv", "inv_complex_bag" );
    cmn.CallEventHandler( "use_lvl2badge1_beg", "inv_complex_bag" );

    local func_after = function ()

      cmn.SetEventDone( "use_lvl2badge1" );
      cmn.CallEventHandler( "use_lvl2badge1_end", "inv_complex_bag" );

      cmn.Lock( 0 );
    
    end;

    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_bag_inv_1_opens");
      ObjSet("anm_complex_bag_open",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_bag_inv_1_insert_1");
    
    if cmn.IsEventDone("use_lvl2badge2") then
      ObjSet("anm_complex_bag_use_star",  { alp = 1, playing = 1, endtrig = anm_open });
    else 
      ObjSet("anm_complex_bag_use_star",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_code()

  cmn.SetEventDone( "get_code" );
  cmn.CallEventHandler( "get_code", "inv_complex_tablet" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_fixedhacker()

  cmn.SetEventDone( "get_fixedhacker" );
  cmn.CallEventHandler( "get_fixedhacker", "inv_complex_hacker" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_mechanicparrot()

  cmn.SetEventDone( "get_mechanicparrot" );
  cmn.CallEventHandler( "get_mechanicparrot", "inv_complex_mechanicparrot" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_runoutenergyelement()

  cmn.SetEventDone( "get_runoutenergyelement" );
  cmn.CallEventHandler( "get_runoutenergyelement", "inv_complex_gun" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_fob()

  cmn.SetEventDone( "get_fob" );
  cmn.CallEventHandler( "get_fob", "inv_complex_gun" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_blaster()

  cmn.SetEventDone( "get_blaster" );
  cmn.CallEventHandler( "get_blaster", "inv_complex_gun" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_manipulator()

  cmn.SetEventDone( "get_manipulator" );
  cmn.CallEventHandler( "get_manipulator", "inv_complex_manipulatorbase" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_readybomb()

  cmn.SetEventDone( "get_readybomb" );
  cmn.CallEventHandler( "get_readybomb", "inv_complex_bomb" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_armorcabinetkey()
  
  ObjSet("spr_complex_bag_armorcabinetkey",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_armorcabinetkey" );
  cmn.CallEventHandler( "get_armorcabinetkey", "inv_complex_bag" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_turretmodule2") and cmn.IsEventDone("get_shipsymbol2") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_shipsymbol2()
  
  cmn.SetEventDone( "get_shipsymbol2" );
  cmn.CallEventHandler( "get_shipsymbol2", "inv_complex_bag" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_turretmodule2") and cmn.IsEventDone("get_armorcabinetkey") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_turretmodule2()
  
  cmn.SetEventDone( "get_turretmodule2" );
  cmn.CallEventHandler( "get_turretmodule2", "inv_complex_bag" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_shipsymbol2") and cmn.IsEventDone("get_armorcabinetkey") then
    common_impl.HideComplexItem();
  end;

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.open_gun()
  
  common_impl.ShowComplexItem( "gun" );
  
  if not cmn.IsEventDone("opn_gun") then
    
    local func_after = function ()
      
      cmn.Lock(0);
      cmn.CallEventHandler("opn_gun", "inv_complex_gun");
      
    end;
    
    cmn.Lock(1);
    cmn.SetEventDone("opn_gun");
    
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_click_laset_pistol");
    
    ObjSet("anm_complex_gun_start",  { playing = 1, endtrig = func_after });
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.opn_tablet()
  
  --for mmg
  if not( ng_global.progress[ "std" ][ "win_tablet" ].state ) then
    private.complex_tablet.StartConditions();
  end;
  private.complex_tablet.state = ng_global.progress[ "std" ][ "win_tablet" ].state;
  
  private.complex_tablet.DrawScene();

  if cmn.IsEventDone("use_tabletpart1") and cmn.IsEventDone("use_tabletpart2") and not cmn.IsEventDone("win_tablet") then
    cmn.MiniGameShow('tablet');
    private.complex_tablet.CheckWin();
  end;
  
  common_impl.ShowComplexItem( 'tablet' );

end;
--------------------------------------------------------------------------------------------
function public.touch_parrot()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_inv_parrot");
  
  cmn.ShowBbt( "obj_complex_brokenmechanicparrot_use_fob" );
  
  ObjSet("anm_complex_brokenmechanicparrot_mechanicparrot",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_hacker()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_inv_broken_phone");
  
  cmn.ShowBbt( "obj_complex_hacker_use_element" );
  
  ObjSet("anm_complex_hacker_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_gun_crystal()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_pitsol_crystal");
  
  cmn.ShowBbt( "obj_complex_gun_use_crystal" );
  
  ObjSet("anm_complex_gun_crystal",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_gun_energy()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_pistol_right");
  
  cmn.ShowBbt( "obj_complex_gun_use_crystal" );
  
  ObjSet("anm_complex_gun_energy",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_bag()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_bag_inv_1");
  
  cmn.ShowBbt( "obj_complex_bag_use_lvl2badge" );
  
  ObjSet("anm_complex_bag_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
  ObjAnimate("anm_complex_bag_use_star", "pos_y", 0, 0, "", { 0, 0, -384,   0.3, 0, -381,   0.6, 0, -384 });
  ObjAnimate("anm_complex_bag_use_wing", "pos_y", 0, 0, "", { 0, 0, -384,   0.3, 0, -381,   0.6, 0, -384 });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_bomb()
  
  cmn.Lock(1);

  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_bomb_error");
  
  cmn.ShowBbt( "obj_complex_bomb_use_bombpart" );

  ObjAnimate("txt_complex_bomb_error", "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 1,   0.2, 0, 0,    0.4, 0, 1,     0.6, 0, 0,    0.8, 0, 1 });
  --ObjSet( "anm_complex_bomb_touch", { endtrig = function() cmn.Lock(0); end, playing = true } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_manipulator( num )
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_mech_catch_inv");
  
  if num == 1 then
  
    cmn.ShowBbt( "obj_complex_manipulatorbase_use_manipulatorclaw" );
    
    ObjSet("anm_complex_manipulatorbase_touch_1",  { playing = 1, endtrig = function() cmn.Lock(0); end });
      
  else
      
    cmn.ShowBbt( "obj_complex_manipulatorbase_use_manipulatorclaw" );
    
    local func_after = function ()
      
      cmn.Lock(0);
      
      ObjMultiSet( { {"anm_complex_manipulatorbase_touch_2",  { alp = 0 }},
                     {"anm_complex_manipulatorbase_touch_1", { alp = 1 }} } );
      
    end;
    
    ObjMultiSet( { {"anm_complex_manipulatorbase_touch_2",  { alp = 1, playing = 1, endtrig = func_after }},
                   {"anm_complex_manipulatorbase_touch_1", { alp = 0 }} } );
      
  end;
  
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Tablet *** () end;
--*********************************************************************************************************************
--********************************************************************************************************************
private.complex_tablet = {};
public.complex_tablet = {};

function private.Init_Tablet()
  
  private.complex_tablet.start_pos = {2, 1};
  private.complex_tablet.win_pos = {4, 1};
  
  private.complex_tablet.boxes_order = {3, 2, 1};
  
  private.complex_tablet.anims_no_box = {
    {"hand_down", "hand_up_2"}, {"activate", "no"}, {"activate", "no"}, {"hand_down_2", "hand_up"}
  };
  
  private.complex_tablet.anims_with_box = {
    {"down_2", "up"}, {"down", "up_2"}
  };
  
  private.complex_tablet.claw_pos = {
    { {-582, -367, 0.02, 0.6}, {-693, -383, 0.04, 0.7}, {-558, -334, 0.06, 0.6} }, {-693, -405, 0, 1}, {-319, -344, 0, 0.7}
  };
  private.complex_tablet.move_side = 1;
  
  -----------------------------------------------------------------------------------
  game.hint[ "win_tablet" ] = {
    type = "win",
    room ="int_complex_inv",
    zz = "inv_complex_tablet",
    zz_gate = "inv_tablet"
  };
  -----------------------------------------------------------------------------------
  local win_tablet_inv = function ()

    if cmn.IsEventDone( "win_tablet" ) then
      
      interface.InventoryItemRemove( "inv_tablet" );
                     
    end;

  end;
  local win_tablet_mid = function ()

    if cmn.IsEventDone( "win_tablet" ) then
      
      ObjSet("obj_complex_tablet_game_interface",  { input = 0 });
                     
    end;

  end;
  local win_tablet_loc = function ()

    if cmn.IsEventDone( "win_tablet" ) then
      
      ObjDelete("obj_cargosection_boxes_1");
      ObjDelete("anm_cargosection_claw_1");
      ObjDelete("obj_cargosection_grate_bbt");
      
      ObjMultiSet( { {"gzz_cargosection_grate", { input = 1, alp = 1, active = 1 }},
                     {"spr_cargosection_box_2_1", { alp = 1 }},
                     {"spr_cargosection_box_2_2", { alp = 1 }},
                     {"spr_cargosection_box_2_3", { alp = 1 }},
                     {"anm_cargosection_claw_2", { alp = 1 }} } );
                     
    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_tablet", win_tablet_inv );
  cmn.AddSubscriber( "win_tablet_inv", win_tablet_inv );
  cmn.AddSubscriber( "win_tablet", win_tablet_mid, "inv_complex_tablet" );
  cmn.AddSubscriber( "win_tablet_mid", win_tablet_mid, "inv_complex_tablet" );
  cmn.AddSubscriber( "win_tablet", win_tablet_loc, "rm_cargosection" );
  cmn.AddSubscriber( "win_tablet_loc", win_tablet_loc, "rm_cargosection" );

end;
--********************************************************************************************************************
function private.complex_tablet.StartConditions()

  ng_global.progress[ "std" ][ "win_tablet" ].skip = 0;
  ng_global.progress[ "std" ][ "win_tablet" ].state = { {0, 0, 0}, {2, 1, 0} }; 

end;
-----------------------------------------------------------------------------------
function public.complex_tablet.Reset()
  
  local need_r = false;
  local count = private.complex_tablet.CountBoxes();
  local claw = private.complex_tablet.state[2];
  private.complex_tablet.move_side = 1;
  
  for i = 1, 3, 1 do
    
    if private.complex_tablet.state[1][i] == 1 and private.complex_tablet.state[2][3] ~= i then
      
      if not need_r then
        need_r = true;
      end;
      
      ObjAnimate("spr_complex_tablet_box_"..i.."_1", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 0,   0.6, 0, 1 });
      ObjAnimate("spr_complex_tablet_box_"..i.."_sh", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 0,   0.6, 0, 1 });
      
    end;
    
  end;
  
  if private.complex_tablet.state[2][3] > 0 then
    
    if not need_r then
      need_r = true;
    end;
    
    ObjAnimate("spr_complex_tablet_box_"..private.complex_tablet.boxes_order[count+1].."_1", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 0,   0.6, 0, 1 });
    ObjAnimate("spr_complex_tablet_box_"..private.complex_tablet.boxes_order[count+1].."_sh", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 0,   0.6, 0, 1 });
    
  end;
  
  for i = count, 1, -1 do
    
    ObjAnimate("spr_complex_tablet_box_end_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 1,   0.6, 0, 0 });
    
  end;
  
  if private.complex_tablet.start_pos[1] ~= private.complex_tablet.state[2][1] or private.complex_tablet.start_pos[2] ~= private.complex_tablet.state[2][2]
  or private.complex_tablet.state[2][3] ~= 0 then
    
    if not need_r then
      need_r = true;
    end;
    
    local anm_claw = function ()
      private.complex_tablet.SetClaw();
      ObjAnimate("anm_complex_tablet_activate", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    end;
      
    if claw[3] == 0 and (claw[1] == 2 or claw[1] == 3) then
      ObjAnimate("anm_complex_tablet_activate", "alp", 0, 0, anm_claw, { 0, 0, 1,   0.3, 0, 0 });
    else 
      ObjAnimate("anm_complex_tablet_claw", "alp", 0, 0, anm_claw, { 0, 0, 1,   0.3, 0, 0 });
    end;
    
  end;
  
  local butts = private.complex_tablet.CheckButtons();
  
  for i = 2, 3, 1 do
    
    if butts[i] == 1 then
      ObjAnimate("spr_complex_tablet_button_move_"..i.."_on", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    end;
    
  end;
  
  if need_r then
    
    cmn.Lock( 1 );
    
    private.complex_tablet.StartConditions();
  
    private.complex_tablet.state = ng_global.progress[ "std" ][ "win_tablet" ].state;
    ObjSet("tmr_complex_tablet_game_timer",  { time = 0.6, playing = 1, endtrig = function () cmn.Lock( 0 ); private.complex_tablet.DrawScene(); end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.complex_tablet.Skip()
  
  cmn.Lock( 1 );
  
  ng_global.progress[ "std" ][ "win_tablet" ].skip = 1;
  ng_global.progress[ "std" ][ "win_tablet" ].state = { {1, 1, 1}, {4, 1, 0} }; 
  
  local count = private.complex_tablet.CountBoxes();
  local claw = private.complex_tablet.state[2];
  
  for i = 1, 3, 1 do
    
    if private.complex_tablet.state[1][i] == 0 and private.complex_tablet.state[2][3] ~= i then
      
      ObjAnimate("spr_complex_tablet_box_"..i.."_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      ObjAnimate("spr_complex_tablet_box_"..i.."_sh", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  end;
  
  for i = count+1, 3, 1 do
    
    ObjAnimate("spr_complex_tablet_box_end_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 0,   0.6, 0, 1 });
    
  end;
  
  if private.complex_tablet.win_pos[1] ~= private.complex_tablet.state[2][1] or private.complex_tablet.win_pos[2] ~= private.complex_tablet.state[2][2]
  or private.complex_tablet.state[2][3] ~= 0 then
    local anm_claw = function ()
      private.complex_tablet.SetClaw();
      ObjAnimate("anm_complex_tablet_claw", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    end;
    if claw[3] == 0 and (claw[1] == 2 or claw[1] == 3) then
      ObjAnimate("anm_complex_tablet_activate", "alp", 0, 0, anm_claw, { 0, 0, 1,   0.3, 0, 0 });
    else 
      ObjAnimate("anm_complex_tablet_claw", "alp", 0, 0, anm_claw, { 0, 0, 1,   0.3, 0, 0 });
    end;
  end;
  
  private.complex_tablet.state = ng_global.progress[ "std" ][ "win_tablet" ].state;
  ObjSet("tmr_complex_tablet_game_timer",  { time = 0.6, playing = 1, endtrig = private.complex_tablet.CheckWin });
  
end;
-----------------------------------------------------------------------------------
function private.complex_tablet.DrawScene()
  
  local count = private.complex_tablet.CountBoxes();
  
  for i = 1, 3, 1 do
    
    if private.complex_tablet.state[1][i] == 1 then
      ObjMultiSet( { {"spr_complex_tablet_box_"..i.."_1", { alp = 0 }},
                     {"spr_complex_tablet_box_"..i.."_sh", { alp = 0 }} } );
    end;
    
  end;
                 
  if private.complex_tablet.state[2][3] ~= 0 then
    ObjMultiSet( { {"spr_complex_tablet_box_"..private.complex_tablet.boxes_order[count+1].."_1", { alp = 0 }},
                   {"spr_complex_tablet_box_"..private.complex_tablet.boxes_order[count+1].."_sh", { alp = 0 }} } );
  end;
  
  for i = count, 1, -1 do
    ObjSet("spr_complex_tablet_box_end_"..i,  { alp = 1 });
  end;
  
  if (private.complex_tablet.state[2][3] == 1 or private.complex_tablet.state[2][1] == 1 or private.complex_tablet.state[2][2] == 2)
  and count > 0 then
    ObjSet("anm_complex_tablet_claw",  { pos_z = 15 });
  else 
    ObjSet("anm_complex_tablet_claw",  { pos_z = 5 });
  end;
                 
  private.complex_tablet.SetClaw();
  
  local butts = private.complex_tablet.CheckButtons();
  
  for i = 1, #butts, 1 do
    
    ObjMultiSet( { {"obj_complex_tablet_button_move_"..i, { input = butts[i] }},
                   {"spr_complex_tablet_button_move_"..i.."_on", { alp = butts[i] }} } );
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.complex_tablet.SetClaw()
  
  local count = private.complex_tablet.CountBoxes();
  
  local claw = private.complex_tablet.state[2];
  local new_num = private.complex_tablet.boxes_order[count+1];
  
  if count == 3 then
    count = 2;
  end;
  
  if claw[3] == 0 and claw[1] == 4 then
    if count == 1 then
      new_num = 1;
    elseif count == 3 then
      new_num = 3;
    elseif count == 2 then
      new_num = 2;
    end;
  elseif claw[3] == 1 and claw[1] == 2 then
    --if count+1 == 2 then
    --  new_num = 1;
    --elseif count+1 == 3 then
    --  new_num = 2;
    --end;
    --DbgTrace((count+1).." "..new_num);
  end;
  
  if claw[3] == 0 then
    
    if claw[1] == 2 or claw[1] == 3 then
      ObjMultiSet( { {"anm_complex_tablet_claw", { alp = 0, frame = 0 }},
                     {"anm_complex_tablet_activate", { alp = 1 }} } );
    else 
      ObjMultiSet( { {"anm_complex_tablet_claw", { alp = 1, animfunc = "func_box_"..new_num.."_"..private.complex_tablet.anims_no_box[ claw[1] ][ claw[2] ], frame = 0 }},
                     {"anm_complex_tablet_activate", { alp = 0 }} } );
      --if claw[1] == 4 then
      --  ObjSet("anm_complex_tablet_claw",  { frame = 400 });
      --else 
      --  ObjSet("anm_complex_tablet_claw",  { frame = 0 });
      --end;
    end;
              
  else
    
    ObjMultiSet( { {"anm_complex_tablet_claw", { alp = 1, animfunc = "func_box_"..new_num.."_"..private.complex_tablet.anims_with_box[ claw[1] ][ claw[2] ], frame = 0 }},
                   {"anm_complex_tablet_activate", { alp = 0, frame = 0 }} } );           
                  
  end; 
                 
  local claw_p = claw[1];
  if claw[1] == 4 then
    claw_p = 1;
  end;
  
  if claw_p == 1 then
    
    local ind2 = count+1;
    if ind2 > 3 then
      ind2 = 3;
    end;
    
    ObjSet("anm_complex_tablet_activate",  { 
      pos_x = private.complex_tablet.claw_pos[claw_p][ ind2 ][1],
      pos_y = private.complex_tablet.claw_pos[claw_p][ ind2 ][2],
      ang = private.complex_tablet.claw_pos[claw_p][ ind2 ][3],
      scale_x = private.complex_tablet.claw_pos[claw_p][ ind2 ][4],
      scale_y = private.complex_tablet.claw_pos[claw_p][ ind2 ][4]
    });
    
  else 
    ObjSet("anm_complex_tablet_activate",  { 
      pos_x = private.complex_tablet.claw_pos[claw_p][1],
      pos_y = private.complex_tablet.claw_pos[claw_p][2],
      ang = private.complex_tablet.claw_pos[claw_p][3],
      scale_x = private.complex_tablet.claw_pos[claw_p][4],
      scale_y = private.complex_tablet.claw_pos[claw_p][4]
    });
  end;
  
end;
-----------------------------------------------------------------------------------
function private.complex_tablet.CheckButtons()
  
  local butts = {1, 1, 1};
  local claw = private.complex_tablet.state[2];
  
  if claw[3] == 0 and ( claw[1] ~= 1 and claw[1] ~= 4 ) then
    butts[2] = 0;
  end;
  
  if claw[2] == 2 then
    butts[1] = 0;
  end;
  
  if claw[2] == 1 or ( claw[3] == 0 and claw[1] == 4 ) then
    butts[3] = 0;
  end;
  
  return butts;
  
end;
-----------------------------------------------------------------------------------
function public.complex_tablet.MoveClaw( typ )
  
  local old_butts = private.complex_tablet.CheckButtons();
  
  cmn.Lock( 1 );
  
  if typ == 1 then
    private.complex_tablet.MoveSide( old_butts );
  elseif typ == 2 then
    private.complex_tablet.MoveUpDown( old_butts );
  else 
    private.complex_tablet.PickUp();
  end;
  
end;
-----------------------------------------------------------------------------------
function public.complex_tablet.FocusButton( typ, inout )
  
  local obj = "spr_complex_tablet_button_move_"..typ.."_focus";
  
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      --cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/");
    end;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function private.complex_tablet.MoveSide( old_butts )
  
  local count = private.complex_tablet.CountBoxes();
  local claw = private.complex_tablet.state[2];
  local old_state = private.complex_tablet.state[2][1];
  
  local new = 0;
  if old_state+private.complex_tablet.move_side > 3 or old_state+private.complex_tablet.move_side < 1 then
    private.complex_tablet.move_side = -private.complex_tablet.move_side;
  end;
  new = old_state+private.complex_tablet.move_side;
  
  if claw[3] == 0 and claw[1] ~= 4 then
    
    local claw_p = claw[1];
    if claw[1] == 4 then
      claw_p = 1;
    end;
    
    local old_pos = {0, 0, 0, 0};
    local new_pos = {0, 0, 0, 0};
    
    if claw_p == 1 then
      
      local ind2 = count+1;
      if ind2 > 3 then
        ind2 = 3;
      end;
      
      for i = 1, 4, 1 do
        old_pos[i] = private.complex_tablet.claw_pos[claw_p][ ind2 ][i];
      end;
      
      ObjSet("anm_complex_tablet_activate",  { 
        pos_x = private.complex_tablet.claw_pos[claw_p][ ind2 ][1],
        pos_y = private.complex_tablet.claw_pos[claw_p][ ind2 ][2],
        ang = private.complex_tablet.claw_pos[claw_p][ ind2 ][3],
        scale_x = private.complex_tablet.claw_pos[claw_p][ ind2 ][4],
        scale_y = private.complex_tablet.claw_pos[claw_p][ ind2 ][4]
      });
      
    else 
      
      for i = 1, 4, 1 do
        old_pos[i] = private.complex_tablet.claw_pos[claw_p][i];
      end;
      
      ObjSet("anm_complex_tablet_activate",  { 
        pos_x = private.complex_tablet.claw_pos[claw_p][1],
        pos_y = private.complex_tablet.claw_pos[claw_p][2],
        ang = private.complex_tablet.claw_pos[claw_p][3],
        scale_x = private.complex_tablet.claw_pos[claw_p][4],
        scale_y = private.complex_tablet.claw_pos[claw_p][4]
      });
      
    end;
    
    if new == 1 then
      local ind2 = count+1;
      if ind2 > 3 then
        ind2 = 3;
      end;
      for i = 1, 4, 1 do
        new_pos[i] = private.complex_tablet.claw_pos[new][ ind2 ][i];
      end;
    else 
      for i = 1, 4, 1 do
        new_pos[i] = private.complex_tablet.claw_pos[new][i];
      end;
    end;
    
    private.complex_tablet.state[2][1] = new;
    
    local anm_end = function ()
      
      private.complex_tablet.SetClaw();
      
      if new == 1 then
        ObjAnimate("anm_complex_tablet_activate", "alp", 0, 0, function() cmn.Lock( 0 ); end, { 0, 0, 1,   0.2, 0, 0 });
        ObjAnimate("anm_complex_tablet_claw", "alp", 0, 0, "", { 0, 0, 0,   0.2, 0, 1 });
      else 
        cmn.Lock( 0 );
      end;
      
    end;
    
    local butts = private.complex_tablet.CheckButtons();
      
    for i = 1, 3, 1 do
      
      if butts[i] ~= old_butts[i] then
        ObjSet("obj_complex_tablet_button_move_"..i,  { input = butts[i] });
        ObjAnimate("spr_complex_tablet_button_move_"..i.."_on", "alp", 0, 0, "", { 0, 0, old_butts[i],   0.3, 0, butts[i] });
      end;
      
    end;
    
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_mech_middle");
    
    if old_state == 1 then
      ObjAnimate("anm_complex_tablet_activate", "alp", 0, 0, "", { 0, 0, 0,   0.1, 0, 1 });
      ObjAnimate("anm_complex_tablet_claw", "alp", 0, 0, "", { 0, 0, 1,   0.1, 0, 0 });
    end;
    
    ObjAnimate("anm_complex_tablet_activate", "pos_xy", 0, 0, anm_end, { 0, 0, old_pos[1], old_pos[2],   1, 0, new_pos[1], new_pos[2] });
    ObjAnimate("anm_complex_tablet_activate", "scale_xy", 0, 0, "", { 0, 0, old_pos[4], old_pos[4],   1, 0, new_pos[4], new_pos[4] });
    ObjAnimate("anm_complex_tablet_activate", "ang", 0, 0, "", { 0, 0, old_pos[3],   1, 0, new_pos[3] });
    
  elseif claw[3] == 0 and claw[1] == 4 then
    
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_mech_goes_left_corner");
    
    new = 1;
    private.complex_tablet.state[2][1] = new;
    
    local anim_name = "func_box_3_hand_to_box_2";
    if count == 2 then
      anim_name = "func_box_2_hand_to_box_1";
    end;
    
    local butts = private.complex_tablet.CheckButtons();
      
    for i = 1, 3, 1 do
      
      if butts[i] ~= old_butts[i] then
        ObjSet("obj_complex_tablet_button_move_"..i,  { input = butts[i] });
        ObjAnimate("spr_complex_tablet_button_move_"..i.."_on", "alp", 0, 0, "", { 0, 0, old_butts[i],   0.3, 0, butts[i] });
      end;
      
    end;
    
    ObjSet("anm_complex_tablet_claw",  { animfunc = anim_name, frame = 0, playing = 1, endtrig = function() cmn.Lock( 0 ); end });
    
  else 
      
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_mech_goes_left_corner");
    
    local anim_name = "func_box_"..private.complex_tablet.boxes_order[count+1].."_move";
    
    if private.complex_tablet.state[2][1] == 2 then
      anim_name = anim_name.."_2";
      private.complex_tablet.state[2][1] = 1;
    else 
      private.complex_tablet.state[2][1] = 2;
    end;
    
    local butts = private.complex_tablet.CheckButtons();
      
    for i = 1, 3, 1 do
      
      if butts[i] ~= old_butts[i] then
        ObjSet("obj_complex_tablet_button_move_"..i,  { input = butts[i] });
        ObjAnimate("spr_complex_tablet_button_move_"..i.."_on", "alp", 0, 0, "", { 0, 0, old_butts[i],   0.3, 0, butts[i] });
      end;
      
    end;
    
    ObjSet("anm_complex_tablet_claw",  { animfunc = anim_name, frame = 0, playing = 1, endtrig = function() cmn.Lock( 0 ); end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.complex_tablet.MoveUpDown( old_butts )
  
  local count = private.complex_tablet.CountBoxes();
  local new_num = private.complex_tablet.boxes_order[count+1];
  
  local anim_name = "func_box_";
  local claw = private.complex_tablet.state[2];
  
  if claw[2] == 1 then
    
    claw[2] = 2;
    
    if claw[3] == 0 and claw[1] == 1 then
      anim_name = anim_name..new_num.."_".."hand_down";
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_mech_goes_down_1");
    elseif claw[3] == 0 and claw[1] == 4 then
      if count == 1 then
        new_num = 1;
      elseif count == 3 then
        new_num = 3;
      elseif count == 2 then
        new_num = 2;
      end;
      anim_name = anim_name..new_num.."_".."hand_down_2";
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_mech_left_corner_goes_down");
    elseif claw[3] == 1 and claw[1] == 2 then
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_mech_goes_down_1");
      anim_name = anim_name..new_num.."_".."down";
    elseif claw[3] == 1 and claw[1] == 1 then
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_mech_goes_down_1");
      anim_name = anim_name..new_num.."_".."down_2";
    end;
    
  else 
    
    claw[2] = 1;
    
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_mech_goes_up");
    
    if claw[3] == 0 and claw[1] == 1 then
      anim_name = anim_name..new_num.."_".."hand_up_2";
    elseif claw[3] == 0 and claw[1] == 4 then
      if count == 1 then
        new_num = 1;
      elseif count == 3 then
        new_num = 3;
      elseif count == 2 then
        new_num = 2;
      end;
      anim_name = anim_name..new_num.."_".."hand_up";
    elseif claw[3] == 1 and claw[1] == 2 then
      anim_name = anim_name..new_num.."_".."up_2";
    elseif claw[3] == 1 and claw[1] == 1 then
      anim_name = anim_name..new_num.."_".."up";
    end;
    
  end;
  
  local butts = private.complex_tablet.CheckButtons();
      
  for i = 1, 3, 1 do
    
    if butts[i] ~= old_butts[i] then
      ObjSet("obj_complex_tablet_button_move_"..i,  { input = butts[i] });
      ObjAnimate("spr_complex_tablet_button_move_"..i.."_on", "alp", 0, 0, "", { 0, 0, old_butts[i],   0.3, 0, butts[i] });
    end;
    
  end;
  
  local func_after = function ()
    
    private.complex_tablet.DrawScene();
    cmn.Lock( 0 );
    --ObjSet("anm_complex_tablet_claw",  { pos_z = 5 });
    
  end;
  
  if claw[1] == 1 and count > 0 then
    ObjSet("anm_complex_tablet_claw",  { pos_z = 15 });
  end;
  
  ObjSet("anm_complex_tablet_claw",  { animfunc = anim_name, frame = 0, playing = 1, endtrig = func_after });
  
end;
-----------------------------------------------------------------------------------
function private.complex_tablet.PickUp()
  
  local count = private.complex_tablet.CountBoxes();
  local anim_name = "func_box_"..private.complex_tablet.boxes_order[count+1].."_";
  local claw = private.complex_tablet.state[2];
  local check = 0;
  
  if claw[3] == 0 and claw[1] == 1 then
    claw[3] = 1;
    anim_name = anim_name.."pickup";
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_mech_catch");
  elseif claw[3] == 1 and claw[1] == 1 then
    claw[3] = 0;
    anim_name = anim_name.."pickdown_2";
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_mech_catch_goes_up");
  elseif claw[3] == 1 and claw[1] == 2 then
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_mech_left_corner_put");
    claw[3] = 0;
    check = 1;
    local new_num = private.complex_tablet.boxes_order[count+1];
    private.complex_tablet.state[2][1] = 4;
    private.complex_tablet.state[1][ private.complex_tablet.boxes_order[count+1] ] = 1;
    if count+1 == 2 then
      new_num = 2;
    elseif count+1 == 3 then
      new_num = 3;
    elseif count+1 == 1 then
      new_num = 1;
    end;
    anim_name = "func_box_"..new_num.."_pickdown";
  --elseif claw[3] == 0 and claw[1] == 2 then
  --  claw[3] = 0;
  --  anim_name = anim_name.."pickdown_2";
  end;
  
  local func_check = function ()
    
    private.complex_tablet.DrawScene();
    
    count = private.complex_tablet.CountBoxes();
    if count == 3 then
      ObjSet("anm_complex_tablet_claw",  { animfunc = "func_box_3_hand_up", frame = 0, playing = 1, endtrig = private.complex_tablet.CheckWin });
    else 
      private.complex_tablet.CheckWin();
    end;
    
  end;
  
  if count > 0 or claw[1] == 1 then
    ObjSet("anm_complex_tablet_claw",  { pos_z = 15 });
  end;
  
  if claw[3] == 0 and claw[1] == 1 then
    ObjMultiSet( { {"spr_complex_tablet_box_"..private.complex_tablet.boxes_order[count+1].."_1", { alp = 1 }},
                   {"spr_complex_tablet_box_"..private.complex_tablet.boxes_order[count+1].."_sh", { alp = 1 }} } );
  elseif claw[3] == 0 and claw[1] == 4 then
    ObjSet("spr_complex_tablet_box_end_"..count+1,  { alp = 1 });
  end;
  
  if check then
    ObjSet("obj_complex_tablet_button_move_3",  { input = 0 });
    ObjAnimate("spr_complex_tablet_button_move_3_on", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  end;
  
  ObjSet("anm_complex_tablet_claw",  { animfunc = anim_name, frame = 0, playing = 1, endtrig = func_check });
  
end;
-----------------------------------------------------------------------------------
function private.complex_tablet.CountBoxes()
  
  local count = 0
  
  for i = 1, 3, 1 do
    
    if private.complex_tablet.state[1][i] == 1 then
      count = count + 1;
    end;
    
  end;
  
  return count;
  
end;
-----------------------------------------------------------------------------------
function private.complex_tablet.CheckWin()
  
  if private.complex_tablet.CountBoxes() == 3 then
    
    cmn.Lock( 1 );
    
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("tablet");
    
    --cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
    
    ObjSet("tmr_complex_tablet_game_timer",  { time = 1, playing = 1, endtrig = private.complex_tablet.Win });
    
  else
    cmn.Lock( 0 );
  end;
  
end;
-----------------------------------------------------------------------------------
function private.complex_tablet.Win()
  
  common_impl.PauseAchiev(0);
  
  cmn.SetEventDone( "win_tablet" );
  cmn.CallEventHandler( "win_tablet_inv", "inv_complex_tablet" );
  cmn.CallEventHandler( "win_tablet_mid", "inv_complex_tablet" );
  cmn.CallEventHandler( "win_tablet_loc", "rm_cargosection" );

  if ng_global.progress[ "std" ][ "win_tablet" ].skip == 0 and ng_global.noskipgames[ "win_tablet" ] == nil then

    ng_global.noskipgames[ "win_tablet" ] = 1;
    common_impl.CheckAchiev("mg");

  end;

  cmn.Lock(0);
  common_impl.HideComplexItem();
  
end;
--************************************************************************************************************