-- name=rm_accomodations
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_accomodations";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Pilotbed();
  --------------------------------------------------------------------------------------------
  -- function get_amuletcabinet1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_amuletcabinet1" ] = {
    type = "get",
    get_obj = "spr_pilotbed_amuletcabinet1",
    room = private.room_objname,
    zz = "zz_pilotbed",
    zz_gate = "gzz_accomodations_pilotbed"
  };
  --------------------------------------------------------------------------------------------
  local get_amuletcabinet1_inv = function ()
  
    interface.InventoryItemAdd( "inv_amuletcabinet1", "spr_pilotbed_amuletcabinet1" );
  
  end;
  local get_amuletcabinet1_end = function ()
  
    ObjDelete( "gfx_pilotbed_amuletcabinet1" );
    ObjDelete( "spr_pilotbed_amuletcabinet1_shadow" );
    
    ObjDelete( "spr_accomodations_bed_amulet" );
  
  end;
  
  cmn.AddSubscriber( "get_amuletcabinet1", get_amuletcabinet1_inv );
  cmn.AddSubscriber( "get_amuletcabinet1", get_amuletcabinet1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokenmechanicparrot () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_brokenmechanicparrot" ] = {
    type = "get",
    get_obj = "spr_pilotbed_brokenmechanicparrot",
    room = private.room_objname,
    zz = "zz_pilotbed",
    zz_gate = "gzz_accomodations_pilotbed"
  };
  --------------------------------------------------------------------------------------------
  local get_brokenmechanicparrot_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_brokenmechanicparrot", "spr_pilotbed_brokenmechanicparrot" );
  
  end;
  local get_brokenmechanicparrot_end = function ()
  
    ObjDelete( "gfx_pilotbed_brokenmechanicparrot" );
    ObjDelete( "spr_pilotbed_brokenmechanicparrot_shadow" );
    
    ObjDelete( "spr_accomodations_bed_parrot" );
  
  end;
  
  cmn.AddSubscriber( "get_brokenmechanicparrot", get_brokenmechanicparrot_inv );
  cmn.AddSubscriber( "get_brokenmechanicparrot", get_brokenmechanicparrot_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_emptybottle () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_emptybottle" ] = {
    type = "get",
    get_obj = "spr_pilotbed_emptybottle",
    room = private.room_objname,
    zz = "zz_pilotbed",
    zz_gate = "gzz_accomodations_pilotbed"
  };
  --------------------------------------------------------------------------------------------
  local get_emptybottle_inv = function ()
  
    interface.InventoryItemAdd( "inv_emptybottle", "spr_pilotbed_emptybottle" );
  
  end;
  local get_emptybottle_end = function ()
  
    ObjDelete( "gfx_pilotbed_emptybottle" );
    ObjDelete( "spr_pilotbed_emptybottle_shadow" );
    
    ObjDelete( "spr_accomodations_bed_bag_bottle" );
  
  end;
  
  cmn.AddSubscriber( "get_emptybottle", get_emptybottle_inv );
  cmn.AddSubscriber( "get_emptybottle", get_emptybottle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brain () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_brain" ] = {
    type = "get",
    get_obj = "spr_pilotbed_brain",
    room = private.room_objname,
    zz = "zz_pilotbed",
    zz_gate = "gzz_accomodations_pilotbed"
  };
  --------------------------------------------------------------------------------------------
  local get_brain_inv = function ()
  
    interface.InventoryItemAdd( "inv_brain", "spr_pilotbed_brain" );
  
  end;
  local get_brain_end = function ()
  
    ObjDelete( "gfx_pilotbed_brain" );
    ObjDelete( "gzz_accomodations_pilotbed" );
    ObjDelete( "spr_accomodations_bed_box_2" );
    
    ObjSet("spr_accomodations_bed_box_3",  { alp = 1 });
  
  end;
  
  cmn.AddSubscriber( "get_brain", get_brain_inv );
  cmn.AddSubscriber( "get_brain", get_brain_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_element2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_element2" ] = {
    type = "get",
    get_obj = "spr_pilotbed_element2",
    room = private.room_objname,
    zz = "zz_pilotbed",
    zz_gate = "gzz_accomodations_pilotbed"
  };
  --------------------------------------------------------------------------------------------
  local get_element2_inv = function ()
  
    interface.InventoryItemAdd( "inv_element", "spr_pilotbed_element2", function () cmn.GetMultyObject( 'element', 3 ); end );
      
    if cmn.CheckMultiObject( "element", 3 ) then
      ObjSet("inv_hacker_star_light",  { alp = 1 });
    end;
  
  end;
  local get_element2_end = function ()
  
    ObjDelete( "gfx_pilotbed_element2" );
    ObjDelete( "spr_pilotbed_element2_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_element2", get_element2_inv );
  cmn.AddSubscriber( "get_element2", get_element2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tool () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_tool" ] = {
    type = "get",
    get_obj = "spr_desk_tool",
    room = private.room_objname,
    zz = "zz_desk",
    zz_gate = "gzz_accomodations_desk"
  };
  --------------------------------------------------------------------------------------------
  local get_tool_inv = function ()
  
    interface.InventoryItemAdd( "inv_tool", "spr_desk_tool" );
  
  end;
  local get_tool_end = function ()
  
    ObjDelete( "gfx_desk_tool" );
    ObjDelete( "spr_desk_tool_sh" );
    
    ObjDelete( "spr_accomodations_desk_tool" );
    
    if cmn.IsEventDone("get_bombpart3") then
      ObjSet("gzz_accomodations_desk",  { active = 0, alp = 0 });
    end;
  
  end;
  
  cmn.AddSubscriber( "get_tool", get_tool_inv );
  cmn.AddSubscriber( "get_tool", get_tool_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl2knife () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl2knife" ] = {
    type = "get",
    get_obj = "spr_desk_lvl2knife",
    room = private.room_objname,
    zz = "zz_desk",
    zz_gate = "gzz_accomodations_desk"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl2knife_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl2knife", "spr_desk_lvl2knife" );
  
  end;
  local get_lvl2knife_end = function ()
  
    ObjDelete( "gfx_desk_lvl2knife" );
    ObjDelete( "spr_desk_lvl2knife_sh" );
    ObjDelete( "spr_desk_knife_bl" );
    
    ObjDelete( "spr_accomodations_desk_knife" );
  
  end;
  
  cmn.AddSubscriber( "get_lvl2knife", get_lvl2knife_inv );
  cmn.AddSubscriber( "get_lvl2knife", get_lvl2knife_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bombpart3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_bombpart3" ] = {
    type = "get",
    get_obj = "spr_desk_bombpart3",
    room = private.room_objname,
    zz = "zz_desk",
    zz_gate = "gzz_accomodations_desk"
  };
  --------------------------------------------------------------------------------------------
  local get_bombpart3_inv = function ()
  
    interface.InventoryItemAdd( "inv_bombpart", "spr_desk_bombpart3", function () cmn.GetMultyObject( 'bombpart', 3 ); end );
    int_map_impl.DecreaseRoomTasks("rm_accomodations");
      
    if cmn.CheckMultiObject( "bombpart", 3 ) then
      ObjSet("inv_bomb_star_light",  { alp = 1 });
    end;
  
  end;
  local get_bombpart3_end = function ()
  
    ObjDelete( "gfx_desk_bombpart3" );
    ObjDelete( "spr_desk_bombpart3_sh" );
    
    ObjDelete( "spr_accomodations_desk_bomb" );
    
    if cmn.IsEventDone("get_tool") then
      ObjSet("gzz_accomodations_desk",  { active = 0, alp = 0 });
    end;
  
  end;
  
  cmn.AddSubscriber( "get_bombpart3", get_bombpart3_inv );
  cmn.AddSubscriber( "get_bombpart3", get_bombpart3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_codemodule () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_codemodule" ] = {
    type = "get",
    get_obj = "spr_spaceship_codemodule",
    room = private.room_objname,
    zz = "zz_spaceship",
    zz_gate = "gzz_accomodations_spaceship"
  };
  --------------------------------------------------------------------------------------------
  local get_codemodule_inv = function ()
  
    interface.InventoryItemAdd( "inv_codemodule", "spr_spaceship_codemodule" );
  
  end;
  local get_codemodule_end = function ()
  
    ObjDelete( "spr_spaceship_codemodule_shadow" );
    ObjDelete( "gfx_spaceship_codemodule" );
    
    ObjDelete( "spr_accomodations_ship_code" );
    ObjDelete( "gzz_accomodations_spaceship" );
  
  end;
  
  cmn.AddSubscriber( "get_codemodule", get_codemodule_inv );
  cmn.AddSubscriber( "get_codemodule", get_codemodule_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletcabinet2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_amuletcabinet2" ] = {
    type = "get",
    get_obj = "spr_spaceship_amuletcabinet2",
    room = private.room_objname,
    zz = "zz_spaceship",
    zz_gate = "gzz_accomodations_spaceship"
  };
  --------------------------------------------------------------------------------------------
  local get_amuletcabinet2_inv = function ()
  
    interface.InventoryItemAdd( "inv_amuletcabinet2", "spr_spaceship_amuletcabinet2" );
  
  end;
  local get_amuletcabinet2_end = function ()
  
    ObjDelete( "gfx_spaceship_amuletcabinet2" );
    ObjDelete( "spr_spaceship_amuletcabinet2_shadow" );
    
    ObjDelete( "spr_accomodations_ship_amulet" );
  
  end;
  
  cmn.AddSubscriber( "get_amuletcabinet2", get_amuletcabinet2_inv );
  cmn.AddSubscriber( "get_amuletcabinet2", get_amuletcabinet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_communicationmodule () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_communicationmodule" ] = {
    type = "get",
    get_obj = "spr_cabinet_communicationmodule",
    room = private.room_objname,
    zz = "zz_cabinet",
    zz_gate = "gzz_accomodations_cabinet"
  };
  --------------------------------------------------------------------------------------------
  local get_communicationmodule_inv = function ()
  
    interface.InventoryItemAdd( "inv_communicationmodule", "spr_cabinet_communicationmodule" );
  
  end;
  local get_communicationmodule_end = function ()
  
    ObjDelete( "gfx_cabinet_communicationmodule" );
    ObjDelete( "spr_cabinet_communicationmodule_sh" );
    
    ObjDelete( "spr_accomodations_cabinet_module" );
  
  end;
  
  cmn.AddSubscriber( "get_communicationmodule", get_communicationmodule_inv );
  cmn.AddSubscriber( "get_communicationmodule", get_communicationmodule_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_button () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_button" ] = {
    type = "get",
    get_obj = "spr_cabinet_button",
    room = private.room_objname,
    zz = "zz_cabinet",
    zz_gate = "gzz_accomodations_cabinet"
  };
  --------------------------------------------------------------------------------------------
  local get_button_inv = function ()
  
    interface.InventoryItemAdd( "inv_button", "spr_cabinet_button" );
  
  end;
  local get_button_end = function ()
  
    ObjDelete( "gfx_cabinet_button" );
    ObjDelete( "spr_cabinet_button_sh" );
    
    ObjDelete( "spr_accomodations_cabinet_button" );
  
  end;
  
  cmn.AddSubscriber( "get_button", get_button_inv );
  cmn.AddSubscriber( "get_button", get_button_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_eye () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_eye" ] = {
    type = "get",
    get_obj = "spr_cabinet_eye",
    room = private.room_objname,
    zz = "zz_cabinet",
    zz_gate = "gzz_accomodations_cabinet"
  };
  --------------------------------------------------------------------------------------------
  local get_eye_inv = function ()
  
    interface.InventoryItemAdd( "inv_eye", "spr_cabinet_eye" );
    int_map_impl.DecreaseRoomTasks("rm_accomodations");
  
  end;
  local get_eye_end = function ()
  
    ObjDelete( "gfx_cabinet_eye" );
    ObjDelete( "spr_cabinet_eye_sh" );
    
    ObjDelete( "spr_accomodations_cabinet_eye" );
    ObjDelete( "gzz_accomodations_cabinet" );
  
  end;
  
  cmn.AddSubscriber( "get_eye", get_eye_inv );
  cmn.AddSubscriber( "get_eye", get_eye_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_lvl2knife () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl2knife" ] = {
    type = "use",
    inv_obj = "inv_lvl2knife",
    use_place = "obj_pilotbed_use_lvl2knife",
    room = private.room_objname,
    zz = "zz_pilotbed",
    zz_gate = "gzz_accomodations_pilotbed"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl2knife_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl2knife" );
  
  end;
  local use_lvl2knife_beg = function ()
  
    ObjDelete( "obj_pilotbed_use_lvl2knife" );

    ObjSet( "anm_pilotbed_bag", { alp = 1 } );
  
  end;
  local use_lvl2knife_end = function ()

    ObjMultiSet( { {"anm_pilotbed_bag", { animfunc = "func_boxbottle_clk", input = true }},
                   {"spr_accomodations_bed_bag_open", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl2knife", use_lvl2knife_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl2knife", use_lvl2knife_inv );
  cmn.AddSubscriber( "use_lvl2knife", use_lvl2knife_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl2knife_inv", use_lvl2knife_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl2knife_beg", use_lvl2knife_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl2knife_end", use_lvl2knife_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_captainsign () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_captainsign" ] = {
    type = "use",
    inv_obj = "inv_captainsign",
    use_place = "obj_pilotbed_use_captainsign",
    room = private.room_objname,
    zz = "zz_pilotbed",
    zz_gate = "gzz_accomodations_pilotbed"
  };
  --------------------------------------------------------------------------------------------
  local use_captainsign_inv = function ()
  
    interface.InventoryItemRemove( "inv_captainsign" );
  
  end;
  local use_captainsign_beg = function ()
  
    ObjDelete( "obj_pilotbed_use_captainsign" );

    ObjMultiSet( {
    { "obj_pilotbed_brokenmechanicparrot", { anim_tag = "tag_brokenmechanicparrot" } },
    { "spr_pilotbed_brokenmechanicparrot", { anim_tag = "tag_brokenmechanicparrot" } },
    { "obj_pilotbed_brokenmechanicparrot_shadow", { anim_tag = "tag_brokenmechanicparrot_shadow" } }
  } );
  
  end;
  local use_captainsign_end = function ()
  
    ObjMultiSet( {
      { "spr_pilotbed_emptybottle", { input = true } },
      { "anm_pilotbed_bag", { animfunc = "func_knife_use1", frame = 300 } },
      {"spr_accomodations_bed_bag_box_open", { alp = 1 }}
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_captainsign", use_captainsign_beg, private.room_objname );
  cmn.AddSubscriber( "use_captainsign", use_captainsign_inv );
  cmn.AddSubscriber( "use_captainsign", use_captainsign_end, private.room_objname );
  cmn.AddSubscriber( "use_captainsign_inv", use_captainsign_inv, private.room_objname );
  cmn.AddSubscriber( "use_captainsign_beg", use_captainsign_beg, private.room_objname );
  cmn.AddSubscriber( "use_captainsign_end", use_captainsign_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_codemodule () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_codemodule" ] = {
    type = "use",
    inv_obj = "inv_codemodule",
    use_place = "obj_pilotbed_use_codemodule",
    room = private.room_objname,
    zz = "zz_pilotbed",
    zz_gate = "gzz_accomodations_pilotbed"
  };
  --------------------------------------------------------------------------------------------
  local use_codemodule_inv = function ()
  
    interface.InventoryItemRemove( "inv_codemodule" );
  
  end;
  local use_codemodule_beg = function ()
  
    ObjDelete( "obj_pilotbed_use_codemodule" );
  
  end;
  local use_codemodule_end = function ()
  
    ObjMultiSet( { {"anm_pilotbed_box", { animfunc = "func_box_opn", frame = 0 }},
                   {"gzz_pilotbed_game", { active = true, input = true }},
                   {"spr_accomodations_bed_module", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_codemodule", use_codemodule_beg, private.room_objname );
  cmn.AddSubscriber( "use_codemodule", use_codemodule_inv );
  cmn.AddSubscriber( "use_codemodule", use_codemodule_end, private.room_objname );
  cmn.AddSubscriber( "use_codemodule_inv", use_codemodule_inv, private.room_objname );
  cmn.AddSubscriber( "use_codemodule_beg", use_codemodule_beg, private.room_objname );
  cmn.AddSubscriber( "use_codemodule_end", use_codemodule_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_coordinates () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_coordinates" ] = {
    type = "use",
    inv_obj = "inv_coordinates",
    use_place = "obj_desk_use_coordinates",
    room = private.room_objname,
    zz = "zz_desk",
    zz_gate = "gzz_accomodations_desk"
  };
  --------------------------------------------------------------------------------------------
  local use_coordinates_inv = function ()
  
    interface.InventoryItemRemove( "inv_coordinates" );
  
  end;
  local use_coordinates_beg = function ()
  
    ObjDelete( "obj_desk_use_coordinates" );
  
  end;
  local use_coordinates_end = function ()
    
    ObjMultiSet( { {"spr_desk_coordinates", { alp = 1 }},
                   {"spr_accomodations_desk_coordinates", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_communicationmodule") then
      ObjDelete( "spr_desk_screen_text_1" );
      ObjDelete( "spr_accomodations_desk_text_1" );
      ObjDelete( "obj_desk_screen_code" );
      ObjDelete( "obj_desk_screen_call" );
      ObjMultiSet( { {"spr_desk_screen_text_2", { alp = 1 }},
                     {"spr_accomodations_desk_text_2", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_coordinates", use_coordinates_beg, private.room_objname );
  cmn.AddSubscriber( "use_coordinates", use_coordinates_inv );
  cmn.AddSubscriber( "use_coordinates", use_coordinates_end, private.room_objname );
  cmn.AddSubscriber( "use_coordinates_inv", use_coordinates_inv, private.room_objname );
  cmn.AddSubscriber( "use_coordinates_beg", use_coordinates_beg, private.room_objname );
  cmn.AddSubscriber( "use_coordinates_end", use_coordinates_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_communicationmodule () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_communicationmodule" ] = {
    type = "use",
    inv_obj = "inv_communicationmodule",
    use_place = "obj_desk_use_communicationmodule",
    room = private.room_objname,
    zz = "zz_desk",
    zz_gate = "gzz_accomodations_desk"
  };
  --------------------------------------------------------------------------------------------
  local use_communicationmodule_inv = function ()
  
    interface.InventoryItemRemove( "inv_communicationmodule" );
  
  end;
  local use_communicationmodule_beg = function ()
  
    ObjDelete( "obj_desk_use_communicationmodule" );
  
  end;
  local use_communicationmodule_end = function ()
    
    ObjMultiSet( { {"obj_desk_pc_part", { alp = 1 }},
                   {"spr_accomodations_desk_module", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_coordinates") then
      ObjDelete( "spr_desk_screen_text_1" );
      ObjDelete( "spr_accomodations_desk_text_1" );
      ObjDelete( "obj_desk_screen_code" );
      ObjDelete( "obj_desk_screen_call" );
      ObjMultiSet( { {"spr_desk_screen_text_2", { alp = 1 }},
                     {"spr_accomodations_desk_text_2", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_communicationmodule", use_communicationmodule_beg, private.room_objname );
  cmn.AddSubscriber( "use_communicationmodule", use_communicationmodule_inv );
  cmn.AddSubscriber( "use_communicationmodule", use_communicationmodule_end, private.room_objname );
  cmn.AddSubscriber( "use_communicationmodule_inv", use_communicationmodule_inv, private.room_objname );
  cmn.AddSubscriber( "use_communicationmodule_beg", use_communicationmodule_beg, private.room_objname );
  cmn.AddSubscriber( "use_communicationmodule_end", use_communicationmodule_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mechanicparrot () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_mechanicparrot" ] = {
    type = "use",
    inv_obj = "inv_mechanicparrot",
    use_place = "obj_desk_use_mechanicparrot",
    room = private.room_objname,
    zz = "zz_desk",
    zz_gate = "gzz_accomodations_desk"
  };
  --------------------------------------------------------------------------------------------
  local use_mechanicparrot_inv = function ()
  
    interface.InventoryItemRemove( "inv_mechanicparrot" );
  
  end;
  local use_mechanicparrot_beg = function ()
  
    ObjDelete( "obj_desk_use_mechanicparrot" );
    ObjDelete( "anm_desk_safe_touch" );
  
  end;
  local use_mechanicparrot_end = function ()
    
    ObjDelete( "anm_desk_use_mechanicparrot" );
    ObjDelete( "spr_accomodations_desk_safe_1" );
  
    ObjMultiSet( { {"anm_desk_use_mechanicparrot_2",  { alp = 1, input = 1, frame = 300 }},
                   {"spr_accomodations_desk_safe_2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mechanicparrot", use_mechanicparrot_beg, private.room_objname );
  cmn.AddSubscriber( "use_mechanicparrot", use_mechanicparrot_inv );
  cmn.AddSubscriber( "use_mechanicparrot", use_mechanicparrot_end, private.room_objname );
  cmn.AddSubscriber( "use_mechanicparrot_inv", use_mechanicparrot_inv, private.room_objname );
  cmn.AddSubscriber( "use_mechanicparrot_beg", use_mechanicparrot_beg, private.room_objname );
  cmn.AddSubscriber( "use_mechanicparrot_end", use_mechanicparrot_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_button () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_button" ] = {
    type = "use",
    inv_obj = "inv_button",
    use_place = "obj_spaceship_use_button",
    room = private.room_objname,
    zz = "zz_spaceship",
    zz_gate = "gzz_accomodations_spaceship"
  };
  --------------------------------------------------------------------------------------------
  local use_button_inv = function ()
  
    interface.InventoryItemRemove( "inv_button" );
  
  end;
  local use_button_beg = function ()
  
    ObjDelete( "obj_spaceship_use_button" );
    ObjDelete( "spr_accomodations_ship_wing" );
    ObjDelete( "spr_accomodations_ship_head" );
    
    if cmn.IsEventDone("use_shippart1") then
      ObjSet( "spr_accomodations_ship_wing_2", { alp = 1 } );
    end;
    
    if cmn.IsEventDone("use_shippart2") then
      ObjSet( "spr_accomodations_ship_head_2", { alp = 1 } );
    end;
    
    ObjMultiSet( { {"spr_accomodations_ship_light", { alp = 1 }},
                   {"fx_accomodations_p_window", { active = 1, visible = 1 }} } );
  
  end;
  local use_button_end = function ()

    ObjDelete( "spr_spaceship_ship_base" );
    ObjDelete( "spr_spaceship_shippart_1" );
    ObjDelete("spr_spaceship_shippart_2_1");
    ObjDelete("spr_spaceship_note_small_1");
    ObjDelete("spr_accomodations_ship_dark");

    ObjMultiSet( {
      { "gho_accomodations_stars", { input = 1, alp = 1, active = 1 } },
      { "anm_accomodations_window_open", { frame = 300 } },
      { "spr_spaceship_ship_base_2", { alp = 1 } },
      { "spr_spaceship_shippart_1_2", { alp = 1 } },
      { "spr_spaceship_button", { alp = 1 } },
      { "spr_spaceship_back_2", { alp = 1 } },
      { "spr_spaceship_note_small_2", { alp = 1, input = 1 } }
    } );
    
    if cmn.IsEventDone("use_shippart1") then
      ObjSet( "spr_spaceship_shippart_2_2", { alp = 1 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_button", use_button_beg, private.room_objname );
  cmn.AddSubscriber( "use_button", use_button_inv );
  cmn.AddSubscriber( "use_button", use_button_end, private.room_objname );
  cmn.AddSubscriber( "use_button_inv", use_button_inv, private.room_objname );
  cmn.AddSubscriber( "use_button_beg", use_button_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_end", use_button_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_shippart1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_shippart1" ] = {
    type = "use",
    inv_obj = "inv_shippart1",
    use_place = "obj_spaceship_use_shippart1",
    room = private.room_objname,
    zz = "zz_spaceship",
    zz_gate = "gzz_accomodations_spaceship"
  };
  --------------------------------------------------------------------------------------------
  local use_shippart1_inv = function ()
  
    interface.InventoryItemRemove( "inv_shippart1" );
  
  end;
  local use_shippart1_beg = function ()
  
    ObjDelete( "obj_spaceship_use_shippart1" );
  
  end;
  local use_shippart1_end = function ()
    
    if cmn.IsEventDone("use_button") then
      ObjMultiSet( { {"spr_spaceship_shippart_2_2", { alp = 1 }},
                     {"spr_accomodations_ship_wing_2", { alp = 1 }} } );
    else 
      ObjMultiSet( { {"spr_spaceship_shippart_2_1", { alp = 1 }},
                     {"spr_accomodations_ship_wing", { alp = 1 }} } );
    end;
  
    if cmn.IsEventDone("use_shippart2") then
      ObjMultiSet( {
        { "spr_spaceship_codemodule", { input = true } },
        { "anm_spaceship_open_shelf", { frame = 300 } },
        {"spr_accomodations_ship_open", { alp = 1 }}
      } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_shippart1", use_shippart1_beg, private.room_objname );
  cmn.AddSubscriber( "use_shippart1", use_shippart1_inv );
  cmn.AddSubscriber( "use_shippart1", use_shippart1_end, private.room_objname );
  cmn.AddSubscriber( "use_shippart1_inv", use_shippart1_inv, private.room_objname );
  cmn.AddSubscriber( "use_shippart1_beg", use_shippart1_beg, private.room_objname );
  cmn.AddSubscriber( "use_shippart1_end", use_shippart1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_shippart2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_shippart2" ] = {
    type = "use",
    inv_obj = "inv_shippart2",
    use_place = "obj_spaceship_use_shippart2",
    room = private.room_objname,
    zz = "zz_spaceship",
    zz_gate = "gzz_accomodations_spaceship"
  };
  --------------------------------------------------------------------------------------------
  local use_shippart2_inv = function ()
  
    interface.InventoryItemRemove( "inv_shippart2" );
  
  end;
  local use_shippart2_beg = function ()
  
    ObjDelete( "obj_spaceship_use_shippart2" );
  
  end;
  local use_shippart2_end = function ()

    ObjSet("obj_spaceship_shippart_1",  { alp = 1 });
                   
    if cmn.IsEventDone("use_button") then
      ObjSet("spr_accomodations_ship_head_2",  { alp = 1 });
    else 
      ObjSet("spr_accomodations_ship_head",  { alp = 1 });
    end;
  
    if cmn.IsEventDone("use_shippart1") then
      ObjMultiSet( {
        { "spr_spaceship_codemodule", { input = true } },
        { "anm_spaceship_open_shelf", { frame = 300 } },
        {"spr_accomodations_ship_open", { alp = 1 }}
      } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_shippart2", use_shippart2_beg, private.room_objname );
  cmn.AddSubscriber( "use_shippart2", use_shippart2_inv );
  cmn.AddSubscriber( "use_shippart2", use_shippart2_end, private.room_objname );
  cmn.AddSubscriber( "use_shippart2_inv", use_shippart2_inv, private.room_objname );
  cmn.AddSubscriber( "use_shippart2_beg", use_shippart2_beg, private.room_objname );
  cmn.AddSubscriber( "use_shippart2_end", use_shippart2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletcabinet1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_amuletcabinet1" ] = {
    type = "use",
    inv_obj = "inv_amuletcabinet1",
    use_place = "obj_cabinet_use_amuletcabinet1",
    room = private.room_objname,
    zz = "zz_cabinet",
    zz_gate = "gzz_accomodations_cabinet"
  };
  --------------------------------------------------------------------------------------------
  local use_amuletcabinet1_inv = function ()
  
    interface.InventoryItemRemove( "inv_amuletcabinet1" );
  
  end;
  local use_amuletcabinet1_beg = function ()
  
    ObjDelete( "obj_cabinet_use_amuletcabinet1" );
  
  end;
  local use_amuletcabinet1_end = function ()
  
    if cmn.IsEventDone("use_amuletcabinet2") then
      ObjMultiSet( { {"obj_cabinet_inside", { alp = 1, input = 1 }},
                     {"spr_cabinet_back_2", { alp = 1 }},
                     {"spr_accomodations_cabinet_open", { alp = 1 }} } );
      ObjDelete( "anm_cabinet_doors_open" );
      ObjDelete( "anm_cabinet_doors_touch" );
      ObjDelete( "obj_cabinet_lock" );
      ObjDelete( "anm_cabinet_amulet_1" );
      ObjDelete( "anm_cabinet_amulet_2" );
      ObjDelete( "obj_accomodations_cabinet_closed" );
    else 
      ObjMultiSet( { {"anm_cabinet_amulet_1", { alp = 1, frame = 0, animfunc = "func_clk_amulet2" }},
                     {"spr_accomodations_cabinet_amulet1", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amuletcabinet1", use_amuletcabinet1_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletcabinet1", use_amuletcabinet1_inv );
  cmn.AddSubscriber( "use_amuletcabinet1", use_amuletcabinet1_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletcabinet1_inv", use_amuletcabinet1_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletcabinet1_beg", use_amuletcabinet1_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletcabinet1_end", use_amuletcabinet1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletcabinet2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_amuletcabinet2" ] = {
    type = "use",
    inv_obj = "inv_amuletcabinet2",
    use_place = "obj_cabinet_use_amuletcabinet2",
    room = private.room_objname,
    zz = "zz_cabinet",
    zz_gate = "gzz_accomodations_cabinet"
  };
  --------------------------------------------------------------------------------------------
  local use_amuletcabinet2_inv = function ()
  
    interface.InventoryItemRemove( "inv_amuletcabinet2" );
  
  end;
  local use_amuletcabinet2_beg = function ()
  
    ObjDelete( "obj_cabinet_use_amuletcabinet2" );
  
  end;
  local use_amuletcabinet2_end = function ()
  
    if cmn.IsEventDone("use_amuletcabinet1") then
      ObjMultiSet( { {"obj_cabinet_inside", { alp = 1, input = 1 }},
                     {"spr_cabinet_back_2", { alp = 1 }},
                     {"spr_accomodations_cabinet_open", { alp = 1 }} } );
      ObjDelete( "anm_cabinet_doors_open" );
      ObjDelete( "anm_cabinet_doors_touch" );
      ObjDelete( "obj_cabinet_lock" );
      ObjDelete( "anm_cabinet_amulet_1" );
      ObjDelete( "anm_cabinet_amulet_2" );
      ObjDelete( "obj_accomodations_cabinet_closed" );
    else 
      ObjMultiSet( { {"anm_cabinet_amulet_2", { alp = 1, frame = 0, animfunc = "func_clk_amulet1" }},
                     {"spr_accomodations_cabinet_amulet2", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amuletcabinet2", use_amuletcabinet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletcabinet2", use_amuletcabinet2_inv );
  cmn.AddSubscriber( "use_amuletcabinet2", use_amuletcabinet2_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletcabinet2_inv", use_amuletcabinet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletcabinet2_beg", use_amuletcabinet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletcabinet2_end", use_amuletcabinet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_display () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_display" ] = {
    type = "use",
    inv_obj = "inv_display",
    use_place = "obj_cabinet_use_display",
    room = private.room_objname,
    zz = "zz_cabinet",
    zz_gate = "gzz_accomodations_cabinet"
  };
  --------------------------------------------------------------------------------------------
  local use_display_inv = function ()
  
    interface.InventoryItemRemove( "inv_display" );
  
  end;
  local use_display_beg = function ()
  
    ObjDelete( "obj_cabinet_use_display" );
    ObjDelete( "anm_cabinet_safe_touch" );
    ObjSet("obj_cabinet_in_safe",  { alp = 1 });
  
  end;
  local use_display_end = function ()
    
    ObjDelete( "spr_accomodations_cabinet_display_1" );
  
    ObjMultiSet( { {"obj_cabinet_in_safe", { input = 1 }},
                   {"anm_cabinet_use_display", { alp = 1, frame = 300 }},
                   {"spr_accomodations_cabinet_display_2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_display", use_display_beg, private.room_objname );
  cmn.AddSubscriber( "use_display", use_display_inv );
  cmn.AddSubscriber( "use_display", use_display_end, private.room_objname );
  cmn.AddSubscriber( "use_display_inv", use_display_inv, private.room_objname );
  cmn.AddSubscriber( "use_display_beg", use_display_beg, private.room_objname );
  cmn.AddSubscriber( "use_display_end", use_display_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_accomodations () end;
  --------------------------------------------------------------------------------------------
  local opn_accomodations = function ()
  
    int_map_impl.OpenRoom( "rm_accomodations" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_accomodations", opn_accomodations );
  --------------------------------------------------------------------------------------------
  -- function opn_accomodationsdoor () end;
  --------------------------------------------------------------------------------------------
  local opn_accomodationsdoor = function ()
    
    ObjDelete("obj_accomodations_door_touch");
  
    ObjMultiSet( { {"anm_accomodations_door",  { frame = 400, animfunc = "anm_open_doors" }},
                   {"grm_accomodations_corridor", { alp = 1, input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_accomodationsdoor", opn_accomodationsdoor, private.room_objname );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_spaceship" );
  subroom.Define( "zz_pilotbed" );
  subroom.Define( "zz_desk" );
  
  function zz_spaceship.Close()
    
    cmn.HideNote( 0 );
    
    if cmn.IsEventDone("use_button") and not cmn.IsEventDone("opn_accomodationswindow") then
      
      local func_after = function ()
        
        cmn.Lock( 0 );
        cmn.CallEventHandler("use_button_end");
        
      end;
      
      cmn.SetEventDone("opn_accomodationswindow");
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_loc_window_opens");
      ObjSet("anm_accomodations_window_open",  { playing = 1, endtrig = func_after });
      
    end;
    
  end;

  function zz_pilotbed.Close()
    
    if cmn.IsEventDone( "use_codemodule" ) and not cmn.IsEventDone("win_pilotbed") and private.zz_pilotbed.is_open then
      ObjSet( "spr_pilotbed_back_2", { alp = 0, input = false } );
      game.hint.win_pilotbed.use_place = "gzz_pilotbed_game";
      private.zz_pilotbed.is_open = false;
    end;

  end;
  
  function zz_desk.Close()
    
    cmn.HideNote( 0 );
    
    if cmn.IsEventDone("use_communicationmodule") and cmn.IsEventDone("use_coordinates") and not cmn.IsEventDone("opn_accomodationsdoor") then
      
      local func_after = function ()
        
        cmn.Lock( 0 );
        int_diary.AddDiarypage( 13 );
        cmn.CallEventHandler("opn_accomodationsdoor");
        
      end;
      
      cmn.SetEventDone("opn_accomodationsdoor");
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_loc_door_opens_1");
      ObjSet("anm_accomodations_door",  { frame = 0, animfunc = "anm_open_doors", playing = 1, endtrig = func_after });
      
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load()

  if not ng_global.progress[ ng_global.currentprogress ][ "win_pilotbed" ].state then 
    private.zz_pilotbed.StartConditions();
  end;
  private.zz_pilotbed.state = ng_global.progress[ ng_global.currentprogress ][ "win_pilotbed" ].state;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_accomodations();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level2/audio/env/aud_rm_accomodations_env");
  cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_rm_accomodations_env");
  
  if cmn.IsEventDone("use_communicationmodule") and cmn.IsEventDone("use_coordinates") and not cmn.IsEventDone("opn_accomodationsdoor") then
    cmn.Lock( 1 );
  end;
  
  --анимация морф-оъекта
  if cmn.IsCollectableAvailible(8) then
    private.AnimMorphObject();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_lvl2knife()

  local item = "inv_lvl2knife";

  if cmn.ApplyObj( item, "gzz_accomodations_pilotbed" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_pilotbed" );

  elseif ( cmn.ApplyObj( item, "obj_pilotbed_use_lvl2knife" ) ) then

    cmn.CallEventHandler( "use_lvl2knife_inv" );
    cmn.CallEventHandler( "use_lvl2knife_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl2knife" );
      cmn.CallEventHandler( "use_lvl2knife_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_cut_knife_junk");

    ObjSet( "anm_pilotbed_bag", { endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_captainsign()

  local item = "inv_captainsign";

  if cmn.ApplyObj( item, "gzz_accomodations_pilotbed" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_pilotbed" );

  elseif ( cmn.ApplyObj( item, "obj_pilotbed_use_captainsign" ) and cmn.IsEventDone("use_lvl2knife") ) then

    cmn.CallEventHandler( "use_captainsign_inv" );
    cmn.CallEventHandler( "use_captainsign_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_captainsign" );
      cmn.CallEventHandler( "use_captainsign_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_box_junk");

    ObjSet( "anm_pilotbed_bag", { animfunc = "func_knife_use1", endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_codemodule()

  local item = "inv_codemodule";

  if cmn.ApplyObj( item, "gzz_accomodations_pilotbed" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_pilotbed" );

  elseif ( cmn.ApplyObj( item, "obj_pilotbed_use_codemodule" ) ) then

    cmn.CallEventHandler( "use_codemodule_inv" );
    cmn.CallEventHandler( "use_codemodule_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_codemodule" );
      cmn.CallEventHandler( "use_codemodule_end" );

      ObjMultiSet( {
        { "spr_pilotbed_back_1", { pos_x = 0, pos_y = 0, scale_x = 1, scale_y = 1 } },
        { "spr_pilotbed_back_2", { input = true } }
      } );

      private.zz_pilotbed.is_open = true;
      game.hint.win_pilotbed.use_place = "spr_pilotbed_simbol_"..( private.zz_pilotbed.right_simbols[ private.zz_pilotbed.state[1] + 1 ] );
    
    end;

    local func_game = function ()
      
      ObjAnimate( "spr_pilotbed_back_2", "alp", 0, 0, func_after, { 0, 0, 0,    0.5, 0, 1 } );
      
    end;

    local anm_zoom = function ()
      
      ObjAnimate( "spr_pilotbed_back_1", "scale_xy", 0, 0, func_game, { 0, 0, 1, 1,    0.8, 0, 1.5, 1.5 } );
      ObjAnimate( "spr_pilotbed_back_1", "pos_xy", 0, 0, "", { 0, 0, 0, 0,    0.8, 0, 13, 125 } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insertbox_thing");

    private.zz_pilotbed.DrawScene();

    ObjSet( "anm_pilotbed_box", { animfunc = "func_module_use", endtrig = anm_zoom, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_coordinates()

  local item = "inv_coordinates";

  if cmn.ApplyObj( item, "gzz_accomodations_desk" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_desk", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_desk_use_coordinates" ) ) then

    cmn.CallEventHandler( "use_coordinates_inv" );
    cmn.CallEventHandler( "use_coordinates_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_coordinates" );
      cmn.CallEventHandler( "use_coordinates_end" );
      
    end;
    
    local anm_call = function ()
      
      private.stein_call( "use_coordinates" );
      
    end;      

    if not cmn.IsEventDone("get_bombpart3") then
      public.get_bombpart3();
    end;    
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_put_star_numeral_comp");
    
    if cmn.IsEventDone("use_communicationmodule") then
      ObjAnimate( "spr_desk_coordinates", "alp", 0, 0, anm_call, { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 1 } );
    else
      ObjAnimate( "spr_desk_coordinates", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_communicationmodule()

  local item = "inv_communicationmodule";

  if cmn.ApplyObj( item, "gzz_accomodations_desk" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_desk", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_desk_use_communicationmodule" ) ) then

    cmn.CallEventHandler( "use_communicationmodule_inv" );
    cmn.CallEventHandler( "use_communicationmodule_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_communicationmodule" );
      cmn.CallEventHandler( "use_communicationmodule_end" );
      
    end;
    
    local anm_call = function ()
      
      private.stein_call( "use_communicationmodule" );
      
    end; 
    
    if not cmn.IsEventDone("get_bombpart3") then
      public.get_bombpart3();
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_stuff_desk");
    
    if cmn.IsEventDone("use_coordinates") then
      ObjAnimate( "obj_desk_pc_part", "alp", 0, 0, anm_call, { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 1 } );
    else
      ObjAnimate( "obj_desk_pc_part", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_mechanicparrot()

  local item = "inv_mechanicparrot";

  if cmn.ApplyObj( item, "gzz_accomodations_desk" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_desk", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_desk_use_mechanicparrot" ) ) then

    cmn.CallEventHandler( "use_mechanicparrot_inv" );
    cmn.CallEventHandler( "use_mechanicparrot_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_mechanicparrot" );
      cmn.CallEventHandler( "use_mechanicparrot_end" );
    
    end;
    
    local anm_2 = function ()
      
      ObjDelete("anm_desk_use_mechanicparrot");
      
      ObjSet("anm_desk_use_mechanicparrot_2",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_put_parrot");

    ObjSet("anm_desk_use_mechanicparrot",  { alp = 1, playing = 1, endtrig = anm_2 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_button()

  local item = "inv_button";

  if cmn.ApplyObj( item, "gzz_accomodations_spaceship" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_spaceship", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_spaceship_use_button" ) ) then

    cmn.CallEventHandler( "use_button_inv" );
    cmn.CallEventHandler( "use_button_beg" );

    local func_after2 = function ()

      cmn.SetEventDone( "use_button" );
      
      common.CloseSubRoom();
    
    end;

    local func_after = function ()

      ObjAnimate( "spr_spaceship_back_2", "alp", 0, 0, "", { 0, 0, 0,    0.5, 0, 1 } );

      ObjAnimate( "spr_spaceship_ship_base",   "alp", 0, 0, "", { 0, 0, 1,    0.5, 0, 0 } );
      ObjAnimate( "spr_spaceship_ship_base_2", "alp", 0, 0, "", { 0, 0, 0,    0.5, 0, 1 } );
      
      ObjAnimate( "spr_spaceship_note_small_1",   "alp", 0, 0, "", { 0, 0, 1,    0.5, 0, 0 } );
      ObjAnimate( "spr_spaceship_note_small_2", "alp", 0, 0, "", { 0, 0, 0,    0.5, 0, 1 } );

      ObjAnimate( "spr_spaceship_shippart_1",   "alp", 0, 0, "", { 0, 0, 1,    0.5, 0, 0 } );
      ObjAnimate( "spr_spaceship_shippart_1_2", "alp", 0, 0, func_after2, { 0, 0, 0,    0.5, 0, 1 } );
      
      if cmn.IsEventDone("use_shippart1") then
        ObjAnimate( "spr_spaceship_shippart_2_2", "alp", 0, 0, "", { 0, 0, 0,    0.5, 0, 1 } );
        ObjAnimate( "spr_spaceship_shippart_2_1", "alp", 0, 0, "", { 0, 0, 1,    0.5, 0, 0 } );
      end;
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_stuff_below_rocket");

    ObjAnimate( "spr_spaceship_button", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );

    ObjAnimate( "spr_spaceship_button", "pos_y", 0, 0, func_after, { 0, 0, 120,    0.3, 0, 120,    0.45, 0, 122,    0.6, 0, 120 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_shippart1()

  local item = "inv_shippart1";

  if cmn.ApplyObj( item, "gzz_accomodations_spaceship" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_spaceship", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_spaceship_use_shippart1" ) ) then

    cmn.CallEventHandler( "use_shippart1_inv" );
    cmn.CallEventHandler( "use_shippart1_beg" );

    local func_after2 = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_shippart1" );
      cmn.CallEventHandler( "use_shippart1_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_wing_rocket");

    local func_after = func_after2;

    if cmn.IsEventDone("use_shippart2") then
      func_after = function ()
        cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_rocket_hidden_cell_opens");
        ObjSet( "anm_spaceship_open_shelf", { endtrig = func_after2, playing = true } );
      end;
    end;

    if cmn.IsEventDone("use_button") then
      ObjAnimate( "spr_spaceship_shippart_2_2", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    else 
      ObjAnimate( "spr_spaceship_shippart_2_1", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_shippart2()

  local item = "inv_shippart2";

  if cmn.ApplyObj( item, "gzz_accomodations_spaceship" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_spaceship", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_spaceship_use_shippart2" ) ) then

    cmn.CallEventHandler( "use_shippart2_inv" );
    cmn.CallEventHandler( "use_shippart2_beg" );

    local func_after2 = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_shippart2" );
      cmn.CallEventHandler( "use_shippart2_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_rocket_head");

    local func_after = func_after2;

    if cmn.IsEventDone("use_shippart1") then
      func_after = function ()
        cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_rocket_hidden_cell_opens");
        ObjSet( "anm_spaceship_open_shelf", { endtrig = func_after2, playing = true } );
      end;
    end;

    ObjAnimate( "obj_spaceship_shippart_1", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_amuletcabinet1()

  local item = "inv_amuletcabinet1";

  if cmn.ApplyObj( item, "gzz_accomodations_cabinet" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_cabinet" );

  elseif ( cmn.ApplyObj( item, "obj_cabinet_use_amuletcabinet1" ) ) then

    cmn.CallEventHandler( "use_amuletcabinet1_inv" );
    cmn.CallEventHandler( "use_amuletcabinet1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_amuletcabinet1" );
      cmn.CallEventHandler( "use_amuletcabinet1_end" );
    
    end;
    
    local anm_open_2 = function ()
      
      ObjAnimate("anm_cabinet_doors_open", "alp", 0, 0, func_after, { 0, 0, 1,   0.3, 0, 0 });
      ObjAnimate("spr_cabinet_back_2", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    local anm_open_end = function ()
      
      ObjDelete("anm_cabinet_amulet_1");
      ObjDelete("anm_cabinet_amulet_2");
      ObjDelete("obj_cabinet_lock");
      
      ObjSet("anm_cabinet_doors_open",  { alp = 1, playing = 1, endtrig = anm_open_2 });
      
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_metal_cupboard_opens");
      
      ObjDelete("anm_cabinet_doors_touch");
      
      ObjMultiSet( { {"obj_cabinet_lock", { alp = 1 }},
                     {"anm_cabinet_lock_open", { alp = 1, playing = 1, endtrig = anm_open_end }},
                     {"obj_cabinet_inside", { alp = 1 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_left_metal_cupboard");

    if cmn.IsEventDone("use_amuletcabinet2") then
      ObjSet("anm_cabinet_amulet_1",  { alp = 1, playing = 1, endtrig = anm_open });
    else 
      ObjSet("anm_cabinet_amulet_1",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_amuletcabinet2()

  local item = "inv_amuletcabinet2";

  if cmn.ApplyObj( item, "gzz_accomodations_cabinet" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_cabinet" );

  elseif ( cmn.ApplyObj( item, "obj_cabinet_use_amuletcabinet2" ) ) then

    cmn.CallEventHandler( "use_amuletcabinet2_inv" );
    cmn.CallEventHandler( "use_amuletcabinet2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_amuletcabinet2" );
      cmn.CallEventHandler( "use_amuletcabinet2_end" );
    
    end;
    
    local anm_open_2 = function ()
      
      ObjAnimate("anm_cabinet_doors_open", "alp", 0, 0, func_after, { 0, 0, 1,   0.3, 0, 0 });
      ObjAnimate("spr_cabinet_back_2", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    local anm_open_end = function ()
      
      ObjDelete("anm_cabinet_amulet_1");
      ObjDelete("anm_cabinet_amulet_2");
      ObjDelete("obj_cabinet_lock");
      
      ObjSet("anm_cabinet_doors_open",  { alp = 1, playing = 1, endtrig = anm_open_2 });
      
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_metal_cupboard_opens");
      
      ObjDelete("anm_cabinet_doors_touch");
      
      ObjMultiSet( { {"obj_cabinet_lock", { alp = 1 }},
                     {"anm_cabinet_lock_open", { alp = 1, playing = 1, endtrig = anm_open_end }},
                     {"obj_cabinet_inside", { alp = 1 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_right_metal_cupboard");

    if cmn.IsEventDone("use_amuletcabinet1") then
      ObjSet("anm_cabinet_amulet_2",  { alp = 1, playing = 1, endtrig = anm_open });
    else 
      ObjSet("anm_cabinet_amulet_2",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_display()

  local item = "inv_display";

  if cmn.ApplyObj( item, "gzz_accomodations_cabinet" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_cabinet" );

  elseif ( cmn.ApplyObj( item, "obj_cabinet_use_display" ) and cmn.IsEventDone("use_amuletcabinet1") and cmn.IsEventDone("use_amuletcabinet2") ) then

    cmn.CallEventHandler( "use_display_inv" );
    cmn.CallEventHandler( "use_display_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_display" );
      cmn.CallEventHandler( "use_display_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_missed_pars_hidden");

    ObjSet("anm_cabinet_use_display",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_amuletcabinet1()

  cmn.SetEventDone( "get_amuletcabinet1" );
  cmn.CallEventHandler( "get_amuletcabinet1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_brokenmechanicparrot()

  cmn.SetEventDone( "get_brokenmechanicparrot" );
  cmn.CallEventHandler( "get_brokenmechanicparrot" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_emptybottle()

  cmn.SetEventDone( "get_emptybottle" );
  cmn.CallEventHandler( "get_emptybottle" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_brain()

  cmn.SetEventDone( "get_brain" );
  cmn.CallEventHandler( "get_brain" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_element2()

  cmn.SetEventDone( "get_element2" );
  cmn.CallEventHandler( "get_element2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_tool()

  cmn.SetEventDone( "get_tool" );
  cmn.CallEventHandler( "get_tool" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_bombpart3") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_lvl2knife()

  cmn.SetEventDone( "get_lvl2knife" );
  cmn.CallEventHandler( "get_lvl2knife" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_bombpart3()

  cmn.SetEventDone( "get_bombpart3" );
  cmn.CallEventHandler( "get_bombpart3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_tool") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_codemodule()

  cmn.SetEventDone( "get_codemodule" );
  cmn.CallEventHandler( "get_codemodule" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_amuletcabinet2()

  cmn.SetEventDone( "get_amuletcabinet2" );
  cmn.CallEventHandler( "get_amuletcabinet2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_communicationmodule()

  cmn.SetEventDone( "get_communicationmodule" );
  cmn.CallEventHandler( "get_communicationmodule" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_button()

  cmn.SetEventDone( "get_button" );
  cmn.CallEventHandler( "get_button" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_eye()

  cmn.SetEventDone( "get_eye" );
  cmn.CallEventHandler( "get_eye" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_accomodations()

  if not ( cmn.IsEventDone( "opn_accomodations" ) ) then
    cmn.SetEventDone( "opn_accomodations" );
    cmn.CallEventHandler("opn_accomodations");
    cmn.ShowBbt( "accomodations_open" );
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_random_env_3_mus_env");
  end;
  
  if cmn.IsEventDone("use_communicationmodule") and cmn.IsEventDone("use_coordinates") and not cmn.IsEventDone("opn_accomodationsdoor") then
      
    local func_after = function ()
      
      cmn.Lock( 0 );
      int_diary.AddDiarypage( 13 );
      cmn.CallEventHandler("opn_accomodationsdoor");
      
    end;
    
    cmn.SetEventDone("opn_accomodationsdoor");
    
    --cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_loc_window_opens");
    ObjSet("anm_accomodations_door",  { frame = 0, animfunc = "anm_open_doors", playing = 1, endtrig = func_after });
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_8_1", { alp = 1 }},
                 {"spr_col_8_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_8_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_8_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_8_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_8_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_8_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_8_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function private.stein_call( event_name )
  
  port.TapDown(30);
  
  local func_after = function ()

    --cmn.Lock( 0 );
    --int_diary.AddDiarypage( 13 );

    cmn.SetEventDone( event_name );
    cmn.CallEventHandler( event_name.."_end" );
    
    if cmn.IsEventDone("use_communicationmodule") and cmn.IsEventDone("use_coordinates") then
      common.CloseSubRoom();
    end;
  
  end;
  
  local anm_door = function ()
    
    int_blackbartext.Hide();
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_numeral_comp_stein_door_opens");
    
    ObjAnimate("obj_desk_screen_call", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_desk_screen_text_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 0,   0.6, 0, 1,   1, 0, 1  });
    
  end;
  
  local anm_call_3 = function ()
    
    cmn.ShowDlgBbt( "desk_stein_voc_3" );
    
    ObjSet("tmr_desk_timer",  { time = 7, playing = 1, endtrig = anm_door });
    
  end;
  
  local anm_call_2 = function ()
    
    cmn.ShowDlgBbt( "desk_stein_voc_2" );
    
    ObjSet("tmr_desk_timer",  { time = 9, playing = 1, endtrig = anm_call_3 });
    
  end;
  
  local anm_call = function ()
    
    cmn.ShowDlgBbt( "desk_stein_voc_1" );
    cmn.PlayAudio("voc", "assets/levels/level2/audio/voc/aud_2_lvl_victor_1_voc");
    cmn.PlayAudio("snd", "assets/levels/level2/audio/mus/aud_vid_steincall_mus");
    
    ObjMultiSet( { {"vid_desk_screen_call",  { playing = 1 }},
                   {"tmr_desk_timer", { time = 9, playing = 1, endtrig = anm_call_2 }} } );
    
    --ObjMultiSet( { {"anm_desk_screen_call",  { playing = 1 }},
    --               {"tmr_desk_timer", { time = 5, playing = 1, endtrig = anm_call_2 }} } );
    
  end;
                 
  local anm_call_atart = function ()
    
    ObjAttach("vid_desk_screen_call", "obj_desk_screen_call");
    
    ObjAnimate("spr_desk_screen_text_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("obj_desk_screen_code", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("obj_desk_screen_call", "alp", 0, 0, anm_call, { 0, 0, 0,   0.3, 0, 0,   0.6, 0, 1  });
    
  end;
                 
  local anm_code = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_numeral_comp_stein");
    
    ObjAnimate("obj_desk_screen_code_1", "alp", 0, 0, "", { 0, 0, 0,   0.2, 0, 1 });
    ObjAnimate("obj_desk_screen_code_2", "alp", 0, 0, "", { 0, 0, 0,   0.2, 0, 0,   0.4, 0, 1 });
    ObjAnimate("obj_desk_screen_code_3", "alp", 0, 0, "", { 0, 0, 0,   0.4, 0, 0,   0.6, 0, 1 });
    ObjAnimate("obj_desk_screen_code_4", "alp", 0, 0, "", { 0, 0, 0,   0.6, 0, 0,   0.8, 0, 1 });
    ObjAnimate("obj_desk_screen_code_5", "alp", 0, 0, "", { 0, 0, 0,   0.8, 0, 0,   1, 0, 1 });
    ObjAnimate("obj_desk_screen_code_6", "alp", 0, 0, anm_call_atart, { 0, 0, 0,   1, 0, 0,   1.2, 0, 1,   1.5, 0, 1 });
    
  end;
  
  anm_code();
  
end;
--------------------------------------------------------------------------------------------
function public.touch_pilotbed_bag()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_junk");
  
  cmn.ShowBbt( "obj_pilotbed_use_lvl2knife" );
  
  ObjSet( "anm_pilotbed_bag_clk", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_pilotbed_boxbottle()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_box_inside_junk");
  
  cmn.ShowBbt( "obj_pilotbed_use_captainsign" );
  
  ObjSet( "anm_pilotbed_bag", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_pilotbed_boxbrain()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_box_pilotbed");
  
  cmn.ShowBbt( "obj_pilotbed_use_codemodule" );
  
  ObjSet( "anm_pilotbed_box", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_cabinet()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_metal_cuppboard");
  
  cmn.ShowBbt( "obj_cabinet_use_amuletcabinet" );
  
  ObjSet( "anm_cabinet_doors_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
    
  if cmn.IsEventDone("use_amuletcabinet1") then
    ObjSet( "anm_cabinet_amulet_1", { playing = 1 } );
  end;
    
  if cmn.IsEventDone("use_amuletcabinet2") then
    ObjSet( "anm_cabinet_amulet_2", { playing = 1 } );
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_cabinet_safe()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_zz_cabiten_stuff");
  
  cmn.ShowBbt( "obj_cabinet_use_display" );
  
  ObjSet( "anm_cabinet_safe_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_desk_safe()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_zz_desk_left");
  
  cmn.ShowBbt( "obj_desk_use_mechanicparrot" );
  
  ObjSet( "anm_desk_safe_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_desk_pc()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_comp_enter_code_zz_desk");
  
  cmn.ShowBbt( "obj_desk_use_coordinates" );
  
  ObjAnimate("spr_desk_screen_text_1", "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 1,   0.2, 0, 0,    0.4, 0, 1,     0.6, 0, 0,    0.8, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function public.bigdoor_touch()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_rm_accomodation_door");
  
  cmn.ShowBbt( "obj_accomodations_door_touch" );
  
  ObjSet( "anm_accomodations_door", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Pilotbed *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_pilotbed = {};
public.zz_pilotbed = {};

function private.Init_Pilotbed()

  private.zz_pilotbed.is_open = false;

  private.zz_pilotbed.right_simbols = { 1, 3, 5, 8 };

  -----------------------------------------------------------------------------------
  game.hint[ "win_pilotbed" ] = {
    type = "click",
    use_place = "gzz_pilotbed_game",
    room = "rm_accomodations",
    zz = "zz_pilotbed",
    zz_gate = "gzz_accomodations_pilotbed"
  };
  -----------------------------------------------------------------------------------
  local win_pilotbed = function ()

    if cmn.IsEventDone( "win_pilotbed" ) then

      ObjDelete( "spr_pilotbed_back_2" );
      ObjDelete( "gzz_pilotbed_game" );
      ObjDelete( "spr_accomodations_bed_box_1" );

      ObjMultiSet( {
        { "anm_pilotbed_box", { frame = 72 } },
        { "spr_pilotbed_brain", { input = true } },
        { "spr_accomodations_bed_box_2", { alp = 1 } }
      } );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_pilotbed", win_pilotbed, "rm_accomodations" );

end;
-----------------------------------------------------------------------------------
function public.zz_pilotbed.OpenAnim()

  cmn.Lock( 1 );
  private.zz_pilotbed.DrawScene();

  local func_after = function ()

    cmn.Lock( 0 );

    ObjMultiSet( {
      { "spr_pilotbed_back_1", { pos_x = 0, pos_y = 0, scale_x = 1, scale_y = 1 } },
      { "spr_pilotbed_back_2", { input = true } }
    } );

    private.zz_pilotbed.is_open = true;
    private.zz_pilotbed.CheckWin();

  end;

  local func_game = function ()
    ObjAnimate( "spr_pilotbed_back_2", "alp", 0, 0, func_after, { 0, 0, 0,    0.5, 0, 1 } );
  end;

  ObjAnimate( "spr_pilotbed_back_1", "scale_xy", 0, 0, func_game, { 0, 0, 1, 1,    0.8, 0, 1.5, 1.5 } );
  ObjAnimate( "spr_pilotbed_back_1", "pos_xy", 0, 0, "", { 0, 0, 0, 0,    0.8, 0, 13, 125 } );

end;
-----------------------------------------------------------------------------------
function private.zz_pilotbed.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_pilotbed" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_pilotbed" ].state = { 0 };

end;
-----------------------------------------------------------------------------------
function private.zz_pilotbed.DrawScene()

  --DbgTrace( "***DrawScene" );

  for i = 1, private.zz_pilotbed.state[1], 1 do
    ObjSet( "spr_pilotbed_simbol_"..private.zz_pilotbed.right_simbols[i], { alp = 1, input = false } );
  end;

end;
-----------------------------------------------------------------------------------
function private.zz_pilotbed.CheckWin()

  --DbgTrace( "***CheckWin" );

  if ( private.zz_pilotbed.state[1] == 4 ) then

    cmn.Lock( 1 );

    --DbgTrace( "WWWWWWWWIIIIIIIIIIIIINNNNNNNN" );

    ObjAnimate( "spr_pilotbed_back_2", "alp", 0, 0,
      function ()
        cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_dox_opens_where");
        ObjSet( "anm_pilotbed_box", { endtrig = private.zz_pilotbed.Win, playing = true } );
      end,
      { 0, 0, 1,    0.5, 0, 1,    1, 0, 0 }
    );

  else

    game.hint.win_pilotbed.use_place = "spr_pilotbed_simbol_"..( private.zz_pilotbed.right_simbols[ private.zz_pilotbed.state[1] + 1 ] );
    cmn.Lock( 0 );

  end;

end;
-----------------------------------------------------------------------------------
function private.zz_pilotbed.Win()

  cmn.Lock( 0 );
  
  private.zz_pilotbed.is_open = false;

  cmn.SetEventDone( "win_pilotbed" );
  cmn.CallEventHandler( "win_pilotbed" );

end;
-----------------------------------------------------------------------------------
function public.zz_pilotbed.ClickSimbol( num )

  --DbgTrace( "***ClickSimbol "..num );

  cmn.Lock( 1 );

  if ( num == private.zz_pilotbed.right_simbols[ private.zz_pilotbed.state[1] + 1 ] ) then
    
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_ieroglyphs_click_right");

    private.zz_pilotbed.state[1] = private.zz_pilotbed.state[1] + 1;

    ObjSet( "spr_pilotbed_simbol_"..num, { input = false } );
    ObjAnimate( "spr_pilotbed_simbol_"..num, "alp", 0, 0, private.zz_pilotbed.CheckWin, { 0, 0, 0,    0.3, 0, 1 } );

  else
    
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_ieroglyphs_click_wrong");

    for i = 1, private.zz_pilotbed.state[1], 1 do
      ObjSet( "spr_pilotbed_simbol_"..private.zz_pilotbed.right_simbols[i], { input = true } );
      ObjAnimate( "spr_pilotbed_simbol_"..private.zz_pilotbed.right_simbols[i], "alp", 0, 0, "",
        { 0, 0, 1,    0.15, 0, 1,    0.3, 0, 0,    0.45, 0, 1,    0.6, 0, 0 }
      );
    end;

    ObjAnimate( "spr_pilotbed_simbol_"..num, "alp", 0, 0, function () cmn.Lock( 0 ); end,
      { 0, 0, 0,    0.15, 0, 1,    0.3, 0, 0,    0.45, 0, 1,    0.6, 0, 0 } 
    );

    private.zz_pilotbed.state[1] = 0;

    game.hint.win_pilotbed.use_place = "spr_pilotbed_simbol_"..( private.zz_pilotbed.right_simbols[ private.zz_pilotbed.state[1] + 1 ] );

  end;

end