-- name=rm_armory
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_armory";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Weaponcabinet();
  --------------------------------------------------------------------------------------------
  -- function get_weaponbase () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_weaponbase" ] = {
    type = "get",
    get_obj = "spr_weaponcabinet_weaponbase",
    room = private.room_objname,
    zz = "zz_weaponcabinet",
    zz_gate = "gzz_armory_weaponcabinet"
  };
  --------------------------------------------------------------------------------------------
  local get_weaponbase_inv = function ()
  
    interface.InventoryItemAdd( "inv_weaponbase", "spr_weaponcabinet_weaponbase" );
  
  end;
  local get_weaponbase_end = function ()
  
    ObjDelete( "gfx_weaponcabinet_weaponbase" );
    ObjDelete( "spr_weaponcabinet_weaponbase_sh" );
    ObjDelete( "gzz_armory_weaponcabinet" );
    ObjDelete( "spr_armory_cabinet_weapon" );
  
  end;
  
  cmn.AddSubscriber( "get_weaponbase", get_weaponbase_inv );
  cmn.AddSubscriber( "get_weaponbase", get_weaponbase_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_list () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_list" ] = {
    type = "get",
    get_obj = "spr_weapontable_list",
    room = private.room_objname,
    zz = "zz_weapontable",
    zz_gate = "gzz_armory_weapontable"
  };
  --------------------------------------------------------------------------------------------
  local get_list_inv = function ()
  
    interface.InventoryItemAdd( "inv_list", "spr_weapontable_list" );
  
  end;
  local get_list_end = function ()
  
    ObjDelete( "gfx_weapontable_list" );
    ObjDelete( "spr_weapontable_list_sh" );
  
    ObjDelete( "spr_armory_table_list" );
    
  end;
  
  cmn.AddSubscriber( "get_list", get_list_inv );
  cmn.AddSubscriber( "get_list", get_list_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl2hammer () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl2hammer" ] = {
    type = "get",
    get_obj = "spr_weapontable_lvl2hammer",
    room = private.room_objname,
    zz = "zz_weapontable",
    zz_gate = "gzz_armory_weapontable"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl2hammer_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl2hammer", "spr_weapontable_lvl2hammer" );
  
  end;
  local get_lvl2hammer_end = function ()
  
    ObjDelete( "gfx_weapontable_lvl2hammer" );
    ObjDelete( "spr_weapontable_lvl2hammer_sh" );
    
    ObjDelete( "spr_armory_table_hammer" );
  
  end;
  
  cmn.AddSubscriber( "get_lvl2hammer", get_lvl2hammer_inv );
  cmn.AddSubscriber( "get_lvl2hammer", get_lvl2hammer_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bracelet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_bracelet" ] = {
    type = "get",
    get_obj = "spr_armorcabinet_bracelet",
    room = private.room_objname,
    zz = "zz_armorcabinet",
    zz_gate = "gzz_armory_armorcabinet"
  };
  --------------------------------------------------------------------------------------------
  local get_bracelet_inv = function ()
  
    interface.InventoryItemAdd( "inv_bracelet", "spr_armorcabinet_bracelet" );
  
  end;
  local get_bracelet_end = function ()
  
    ObjDelete( "gfx_armorcabinet_bracelet" );
    ObjDelete( "spr_armorcabinet_bracelet_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_bracelet", get_bracelet_inv );
  cmn.AddSubscriber( "get_bracelet", get_bracelet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pressuresuit () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_pressuresuit" ] = {
    type = "get",
    get_obj = "spr_armorcabinet_pressuresuit",
    room = private.room_objname,
    zz = "zz_armorcabinet",
    zz_gate = "gzz_armory_armorcabinet"
  };
  --------------------------------------------------------------------------------------------
  local get_pressuresuit_inv = function ()
  
    interface.InventoryItemAdd( "inv_pressuresuit", "spr_armorcabinet_pressuresuit_fly" );
  
  end;
  local get_pressuresuit_end = function ()
  
    ObjDelete( "spr_armorcabinet_pressuresuit" );
    ObjDelete( "spr_armorcabinet_pressuresuit_sh" );
    
    ObjDelete( "spr_armory_cabinet_spacesuit" );
    ObjDelete( "obj_armory_cabinet_2" );
    
    ObjSet("obj_armorcabinet_use_defensesign",  { input = 1 });
    
    if cmn.IsEventDone("get_turretmodule") then
      ObjDelete( "gzz_armory_armorcabinet" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_pressuresuit", get_pressuresuit_inv );
  cmn.AddSubscriber( "get_pressuresuit", get_pressuresuit_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_turretmodule () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_turretmodule" ] = {
    type = "get",
    get_obj = "spr_armorcabinet_turretmodule",
    room = private.room_objname,
    zz = "zz_armorcabinet",
    zz_gate = "gzz_armory_armorcabinet"
  };
  --------------------------------------------------------------------------------------------
  local get_turretmodule_inv = function ()
  
    interface.InventoryItemAdd( "inv_turretmodule", "spr_armorcabinet_turretmodule" );
    int_map_impl.DecreaseRoomTasks("rm_armory");
  
  end;
  local get_turretmodule_end = function ()
  
    ObjDelete( "gfx_armorcabinet_turretmodule" );
    ObjDelete( "spr_armorcabinet_turretmodule_sh" );
    
    ObjDelete( "spr_armory_cabinet_module" );
    
    if cmn.IsEventDone("get_pressuresuit") then
      ObjDelete( "gzz_armory_armorcabinet" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_turretmodule", get_turretmodule_inv );
  cmn.AddSubscriber( "get_turretmodule", get_turretmodule_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_accesstoweaponcodes () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_accesstoweaponcodes" ] = {
    type = "use",
    inv_obj = "inv_accesstoweaponcodes",
    use_place = "obj_weaponcabinet_use_accesstoweaponcodes",
    room = private.room_objname,
    zz = "zz_weaponcabinet",
    zz_gate = "gzz_armory_weaponcabinet"
  };
  --------------------------------------------------------------------------------------------
  local use_accesstoweaponcodes_inv = function ()
  
    interface.InventoryItemRemove( "inv_accesstoweaponcodes" );
  
  end;
  local use_accesstoweaponcodes_beg = function ()
  
    ObjDelete( "obj_weaponcabinet_use_accesstoweaponcodes" );
  
  end;
  local use_accesstoweaponcodes_end = function ()
  
    ObjMultiSet( { {"spr_weaponcabinet_codes", { alp = 1, input = 1 }},
                   {"obj_weaponcabinet_game", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_accesstoweaponcodes", use_accesstoweaponcodes_beg, private.room_objname );
  cmn.AddSubscriber( "use_accesstoweaponcodes", use_accesstoweaponcodes_inv );
  cmn.AddSubscriber( "use_accesstoweaponcodes", use_accesstoweaponcodes_end, private.room_objname );
  cmn.AddSubscriber( "use_accesstoweaponcodes_inv", use_accesstoweaponcodes_inv, private.room_objname );
  cmn.AddSubscriber( "use_accesstoweaponcodes_beg", use_accesstoweaponcodes_beg, private.room_objname );
  cmn.AddSubscriber( "use_accesstoweaponcodes_end", use_accesstoweaponcodes_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spareparts () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_spareparts" ] = {
    type = "use",
    inv_obj = "inv_spareparts",
    use_place = "obj_weapontable_use_spareparts",
    room = private.room_objname,
    zz = "zz_weapontable",
    zz_gate = "gzz_armory_weapontable"
  };
  --------------------------------------------------------------------------------------------
  local use_spareparts_inv = function ()
  
    interface.InventoryItemRemove( "inv_spareparts" );
  
  end;
  local use_spareparts_beg = function ()
  
    ObjDelete( "obj_weapontable_use_spareparts" );
  
  end;
  local use_spareparts_end = function ()
    
    ObjMultiSet( { {"obj_weapontable_spareparts", { alp = 1 }},
                   {"spr_armory_table_parts", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_weaponbase") then
      ObjSet( "gho_armory_onarmortable", { input = 1, alp = 1, active = 1 } );
      ObjDelete("gzz_armory_weapontable");
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_spareparts", use_spareparts_beg, private.room_objname );
  cmn.AddSubscriber( "use_spareparts", use_spareparts_inv );
  cmn.AddSubscriber( "use_spareparts", use_spareparts_end, private.room_objname );
  cmn.AddSubscriber( "use_spareparts_inv", use_spareparts_inv, private.room_objname );
  cmn.AddSubscriber( "use_spareparts_beg", use_spareparts_beg, private.room_objname );
  cmn.AddSubscriber( "use_spareparts_end", use_spareparts_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_weaponbase () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_weaponbase" ] = {
    type = "use",
    inv_obj = "inv_weaponbase",
    use_place = "obj_weapontable_use_weaponbase",
    room = private.room_objname,
    zz = "zz_weapontable",
    zz_gate = "gzz_armory_weapontable"
  };
  --------------------------------------------------------------------------------------------
  local use_weaponbase_inv = function ()
  
    interface.InventoryItemRemove( "inv_weaponbase" );
  
  end;
  local use_weaponbase_beg = function ()
  
    ObjDelete( "obj_weapontable_use_weaponbase" );
  
  end;
  local use_weaponbase_end = function ()
    
    ObjMultiSet( { {"obj_weapontable_weaponbase", { alp = 1 }},
                   {"spr_armory_table_weapon", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_spareparts") then
      ObjSet( "gho_armory_onarmortable", { input = 1, alp = 1, active = 1 } );
      ObjDelete("gzz_armory_weapontable");
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_weaponbase", use_weaponbase_beg, private.room_objname );
  cmn.AddSubscriber( "use_weaponbase", use_weaponbase_inv );
  cmn.AddSubscriber( "use_weaponbase", use_weaponbase_end, private.room_objname );
  cmn.AddSubscriber( "use_weaponbase_inv", use_weaponbase_inv, private.room_objname );
  cmn.AddSubscriber( "use_weaponbase_beg", use_weaponbase_beg, private.room_objname );
  cmn.AddSubscriber( "use_weaponbase_end", use_weaponbase_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl2hammer () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl2hammer" ] = {
    type = "use",
    inv_obj = "inv_lvl2hammer",
    use_place = "obj_armorcabinet_use_lvl2hammer",
    room = private.room_objname,
    zz = "zz_armorcabinet",
    zz_gate = "gzz_armory_armorcabinet"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl2hammer_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl2hammer" );
  
  end;
  local use_lvl2hammer_beg = function ()
  
    ObjDelete( "obj_armorcabinet_use_lvl2hammer" );
  
  end;
  local use_lvl2hammer_end = function ()
    
    ObjDelete( "anm_armorcabinet_use_hammer" );
    ObjDelete( "spr_armory_cabinet_dorr_glass_1" );
  
    ObjMultiSet( { {"anm_armorcabinet_door_touch", { alp = 1, frame = 0, animfunc = "func_door_clk_broken_glass" }},
                   {"spr_armorcabinet_bracelet", { input = 1 }},
                   {"spr_armory_cabinet_dorr_glass_2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl2hammer", use_lvl2hammer_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl2hammer", use_lvl2hammer_inv );
  cmn.AddSubscriber( "use_lvl2hammer", use_lvl2hammer_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl2hammer_inv", use_lvl2hammer_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl2hammer_beg", use_lvl2hammer_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl2hammer_end", use_lvl2hammer_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_armorcabinetkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_armorcabinetkey" ] = {
    type = "use",
    inv_obj = "inv_armorcabinetkey",
    use_place = "obj_armorcabinet_use_armorcabinetkey",
    room = private.room_objname,
    zz = "zz_armorcabinet",
    zz_gate = "gzz_armory_armorcabinet"
  };
  --------------------------------------------------------------------------------------------
  local use_armorcabinetkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_armorcabinetkey" );
  
  end;
  local use_armorcabinetkey_beg = function ()
  
    ObjDelete( "obj_armorcabinet_use_armorcabinetkey" );
    ObjDelete( "anm_armorcabinet_door_touch" );
  
  end;
  local use_armorcabinetkey_end = function ()
    
    ObjDelete( "spr_armory_cabinet_dorr_glass_2" );
    ObjDelete( "spr_armory_cabinet_closed" );
  
    ObjMultiSet( { {"anm_armorcabinet_use_card", { alp = 1, frame = 400 }},
                   {"spr_armorcabinet_pressuresuit", { input = 1 }},
                   {"spr_armory_cabinet_open", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_armorcabinetkey", use_armorcabinetkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_armorcabinetkey", use_armorcabinetkey_inv );
  cmn.AddSubscriber( "use_armorcabinetkey", use_armorcabinetkey_end, private.room_objname );
  cmn.AddSubscriber( "use_armorcabinetkey_inv", use_armorcabinetkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_armorcabinetkey_beg", use_armorcabinetkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_armorcabinetkey_end", use_armorcabinetkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_defensesign () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_defensesign" ] = {
    type = "use",
    inv_obj = "inv_defensesign",
    use_place = "obj_armorcabinet_use_defensesign",
    room = private.room_objname,
    zz = "zz_armorcabinet",
    zz_gate = "gzz_armory_armorcabinet"
  };
  --------------------------------------------------------------------------------------------
  local use_defensesign_inv = function ()
  
    interface.InventoryItemRemove( "inv_defensesign" );
  
  end;
  local use_defensesign_beg = function ()
  
    ObjDelete( "obj_armorcabinet_use_defensesign" );
    ObjSet( "obj_armorcabinet_in_box", { alp = 1 } );
  
  end;
  local use_defensesign_end = function ()
  
    ObjDelete( "anm_armorcabinet_box" );
    ObjDelete( "spr_armory_cabinet_door" );
    ObjSet( "obj_armorcabinet_in_box", { input = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_defensesign", use_defensesign_beg, private.room_objname );
  cmn.AddSubscriber( "use_defensesign", use_defensesign_inv );
  cmn.AddSubscriber( "use_defensesign", use_defensesign_end, private.room_objname );
  cmn.AddSubscriber( "use_defensesign_inv", use_defensesign_inv, private.room_objname );
  cmn.AddSubscriber( "use_defensesign_beg", use_defensesign_beg, private.room_objname );
  cmn.AddSubscriber( "use_defensesign_end", use_defensesign_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_armory () end;
  --------------------------------------------------------------------------------------------
  local opn_armory = function ()
  
    int_map_impl.OpenRoom( "rm_armory" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_armory", opn_armory );
  --------------------------------------------------------------------------------------------
  -- function opn_armoryafterhangar () end;
  --------------------------------------------------------------------------------------------
  local opn_armoryafterhangar = function ()
  
    ObjDelete( "anm_armory_jean_1" );
    ObjDelete( "anm_armory_jean_take_suit" );
    ObjDelete( "tmr_armory_timer" );
    ObjDelete( "obj_armory_cabinet_2" );
    
    ObjSet( "anm_armory_jean_2", { alp = 1 } );
  
  end;
  local opn_armoryafterhangar_deck = function ()
  
    ObjDelete( "anm_maindeck_jean_2_1" );
    ObjDelete( "anm_maindeck_jean_2_2" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_armoryafterhangar", opn_armoryafterhangar, private.room_objname );
  cmn.AddSubscriber( "opn_armoryafterhangar", opn_armoryafterhangar_deck, "rm_maindeck" );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_weaponcabinet" );
  subroom.Define( "zz_weapontable" );

  function zz_weapontable.Close()
    cmn.HideNote( 0 );
  end;

  function zz_weaponcabinet.PreOpen()
    
    if not(cmn.IsEventDone( "win_weaponcabinet" )) then
      private.zz_weaponcabinet.DrawScene();
    end;

  end;
  
  function zz_weaponcabinet.Open()
    
    if cmn.IsEventDone( "use_accesstoweaponcodes" ) and not(cmn.IsEventDone( "win_weaponcabinet" )) then
      cmn.MiniGameShow();
      private.zz_weaponcabinet.CheckWin();
    end;

  end;
  
  function zz_weaponcabinet.PreClose()
    
    if cmn.IsEventDone("use_accesstoweaponcodes") and not cmn.IsEventDone("win_weaponcabinet") then
      cmn.MiniGameHide("weaponcabinet");
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_weaponcabinet" ].state) then 
    private.zz_weaponcabinet.StartConditions();
  end;
  
  private.zz_weaponcabinet.state = ng_global.progress[ ng_global.currentprogress ][ "win_weaponcabinet" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_armory();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level2/audio/env/aud_rm_armory_env");
  cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_rm_armory_env");
  
  if cmn.IsEventDone("opn_hangar") and not cmn.IsEventDone("opn_armoryafterhangar") then
    cmn.Lock( 1 );
    ObjSet("anm_armory_jean_1",  { alp = 1, playing = 1 });
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_accesstoweaponcodes()

  local item = "inv_accesstoweaponcodes";

  if cmn.ApplyObj( item, "gzz_armory_weaponcabinet" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_weaponcabinet", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_weaponcabinet_use_accesstoweaponcodes" ) ) then

    cmn.CallEventHandler( "use_accesstoweaponcodes_inv" );
    cmn.CallEventHandler( "use_accesstoweaponcodes_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_accesstoweaponcodes" );
      cmn.CallEventHandler( "use_accesstoweaponcodes_end" );
      
      cmn.MiniGameShow();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_put_paper_ieroglyphs");

    ObjAnimate( "spr_weaponcabinet_codes", "alp", 0, 0, func_after, { 0, 0, 0,    0.5, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_spareparts()

  local item = "inv_spareparts";

  if cmn.ApplyObj( item, "gzz_armory_weapontable" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_weapontable", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_weapontable_use_spareparts" ) ) then

    cmn.CallEventHandler( "use_spareparts_inv" );
    cmn.CallEventHandler( "use_spareparts_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_spareparts" );
      cmn.CallEventHandler( "use_spareparts_end" );
      
      if cmn.IsEventDone("use_weaponbase") then
        common.CloseSubRoom();
      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_put_details_table");

    ObjAnimate( "obj_weapontable_spareparts", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_weaponbase()

  local item = "inv_weaponbase";

  if cmn.ApplyObj( item, "gzz_armory_weapontable" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_weapontable", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_weapontable_use_weaponbase" ) ) then

    cmn.CallEventHandler( "use_weaponbase_inv" );
    cmn.CallEventHandler( "use_weaponbase_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_weaponbase" );
      cmn.CallEventHandler( "use_weaponbase_end" );
      
      if cmn.IsEventDone("use_spareparts") then
        common.CloseSubRoom();
      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_put_details_pistol_table");

    ObjAnimate( "obj_weapontable_weaponbase", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl2hammer()

  local item = "inv_lvl2hammer";

  if cmn.ApplyObj( item, "gzz_armory_armorcabinet" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_armorcabinet" );

  elseif ( cmn.ApplyObj( item, "obj_armorcabinet_use_lvl2hammer" ) ) then

    cmn.CallEventHandler( "use_lvl2hammer_inv" );
    cmn.CallEventHandler( "use_lvl2hammer_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl2hammer" );
      cmn.CallEventHandler( "use_lvl2hammer_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_broke_hammer_glass");
    
    ObjMultiSet( { {"anm_armorcabinet_use_hammer", { alp = 1, playing = 1, endtrig = func_after }},
                   {"anm_armorcabinet_door_touch", { alp = 0 }} } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_armorcabinetkey()

  local item = "inv_armorcabinetkey";

  if cmn.ApplyObj( item, "gzz_armory_armorcabinet" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_armorcabinet" );

  elseif ( cmn.ApplyObj( item, "obj_armorcabinet_use_armorcabinetkey" ) ) then

    cmn.CallEventHandler( "use_armorcabinetkey_inv" );
    cmn.CallEventHandler( "use_armorcabinetkey_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_armorcabinetkey" );
      cmn.CallEventHandler( "use_armorcabinetkey_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_thing_capsule_1");

    ObjSet("anm_armorcabinet_use_card",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_defensesign()

  local item = "inv_defensesign";

  if cmn.ApplyObj( item, "gzz_armory_armorcabinet" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_armorcabinet" );

  elseif ( cmn.ApplyObj( item, "obj_armorcabinet_use_defensesign" ) ) then

    cmn.CallEventHandler( "use_defensesign_inv" );
    cmn.CallEventHandler( "use_defensesign_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_defensesign" );
      cmn.CallEventHandler( "use_defensesign_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_mask_zz_armorcabinet");

    ObjSet("anm_armorcabinet_box",  { frame = 0, animfunc = "func_box_open", playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_weaponbase()

  cmn.SetEventDone( "get_weaponbase" );
  cmn.CallEventHandler( "get_weaponbase" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_list()

  cmn.SetEventDone( "get_list" );
  cmn.CallEventHandler( "get_list" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_lvl2hammer()

  cmn.SetEventDone( "get_lvl2hammer" );
  cmn.CallEventHandler( "get_lvl2hammer" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_bracelet()
  
  ObjSet("spr_armorcabinet_bracelet_2",  { alp = 1 });

  cmn.SetEventDone( "get_bracelet" );
  cmn.CallEventHandler( "get_bracelet" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_pressuresuit()
  
  ObjSet("spr_armorcabinet_pressuresuit_fly",  { alp = 1 });

  cmn.SetEventDone( "get_pressuresuit" );
  cmn.CallEventHandler( "get_pressuresuit" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_turretmodule") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_turretmodule()

  cmn.SetEventDone( "get_turretmodule" );
  cmn.CallEventHandler( "get_turretmodule" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_pressuresuit") then
    common.CloseSubRoom();
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_armory()

  if not ( cmn.IsEventDone( "opn_armory" ) ) then
    cmn.SetEventDone( "opn_armory" );
    cmn.CallEventHandler("opn_armory");
    cmn.ShowBbt( "armory_open" );
  end;
  
  if cmn.IsEventDone("opn_hangar") and not cmn.IsEventDone("opn_armoryafterhangar") then
    
    local func_after = function ()
      
      cmn.Lock( 0 );
      cmn.CallEventHandler("opn_armoryafterhangar");
      
    end;
    
    local anm_take = function ()
      
      int_blackbartext.Hide();
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_scafandr_wear_jean");
      
      ObjMultiSet( { {"anm_armory_jean_take_suit", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_armory_jean_1", { alp = 0 }},
                     {"obj_armory_cabinet_2", { alp = 0 }} } );
      
    end;
    
    cmn.SetEventDone("opn_armoryafterhangar");
    cmn.ShowDlgBbt( "jean_armory_phrase" );
    cmn.PlayAudio("voc", "assets/levels/level2/audio/voc/aud_2_lvl_jean_10_voc");
    
    ObjMultiSet( { {"tmr_armory_timer",  { time = 10, playing = 1, endtrig = anm_take }},
                   {"vid_armory_jean_1_lipsync", { playing = 1 }} } );
    
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_cabinet()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_ieroglyphs_zz_weaponcabiner");
  
  cmn.ShowBbt( "obj_weaponcabinet_use_accesstoweaponcodes" );
  
  ObjSet("anm_weaponcabinet_code_wrong",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_armory_cabinet( num )
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_cell_suite");
  
  if num == 1 then
    cmn.ShowBbt( "obj_armorcabinet_use_lvl2hammer" );
  else 
    cmn.ShowBbt( "obj_armorcabinet_use_armorcabinetkey" );
  end;
  
  ObjSet("anm_armorcabinet_door_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_armory_safe()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_cell_armor");
  
  cmn.ShowBbt( "obj_armorcabinet_use_defensesign" );
  
  ObjSet("anm_armorcabinet_box",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Weaponcabinet *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_weaponcabinet = {};
public.zz_weaponcabinet = {};
public.zz_weaponcabinet.old_drop_pos = {};
function private.Init_Weaponcabinet()
    
  private.zz_weaponcabinet.wrong_spots = {
    {0, 1, 1, 1, 1, 0}, {0, 0, 0, 0, 0, 0}, {0, 1, 0, 1, 0, 0},
    {0, 1, 0, 0, 0, 0}, {0, 1, 1, 1, 0, 1}, {1, 1, 1, 1, 1, 0}
  };
  private.zz_weaponcabinet.plate_pos = {
    {-2, -164}, {-2, -108}, {-2, -51}, {-2, 6}, {-2, 62}, {-2, 120}
  };
  private.zz_weaponcabinet.start_state = { 2, 5, 1, 6, 4, 3 };
  
  private.zz_weaponcabinet.current_stone = 0;
  private.zz_weaponcabinet.vacant_place = 0;
  -----------------------------------------------------------------------------------
  game.hint[ "win_weaponcabinet" ] = {
    type = "win",
    room = "rm_armory",
    zz = "zz_weaponcabinet",
    zz_gate = "gzz_armory_weaponcabinet"
  };
  -----------------------------------------------------------------------------------
  local win_weaponcabinet = function ()

    if cmn.IsEventDone( "win_weaponcabinet" ) then
      
      ObjDelete( "anm_weaponcabinet_window" );
      ObjDelete( "anm_weaponcabinet_code_wrong" );
      ObjDelete( "anm_weaponcabinet_window_open" );
      ObjDelete( "obj_weaponcabinet_game" );
      ObjDelete( "spr_weaponcabinet_codes" );
      
      ObjDelete( "spr_armory_cabinet_glass" );
      
      ObjSet("spr_weaponcabinet_weaponbase",  { input = 1 });

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_weaponcabinet", win_weaponcabinet, "rm_armory" );

end;
--*********************************************************************************************************************
function private.zz_weaponcabinet.StartConditions()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_weaponcabinet" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_weaponcabinet" ].state = { 2, 5, 1, 6, 4, 3 };
  
end;
-----------------------------------------------------------------------------------
function public.zz_weaponcabinet.Reset()
  
  local need_r = false;
  local max_tme = 0;
  
  for i = 1, #private.zz_weaponcabinet.state, 1 do
    
    if private.zz_weaponcabinet.state[i] ~= private.zz_weaponcabinet.start_state[i] then
      
      if not need_r then
        need_r = true;
      end;
      
      local pos = 0;
      for j = 1, 6, 1 do
        
        if private.zz_weaponcabinet.start_state[j] == private.zz_weaponcabinet.state[i] then
          pos = j;
          break;
        end;
        
      end;
      
      local point_a, point_b = {}, {};
      point_a[1] = private.zz_weaponcabinet.plate_pos[ i ][1];
      point_a[2] = private.zz_weaponcabinet.plate_pos[ i ][2];
      point_b[1] = private.zz_weaponcabinet.plate_pos[ pos ][1];
      point_b[2] = private.zz_weaponcabinet.plate_pos[ pos ][2];
      local len = common_impl.math.FindSegmentLength( point_a, point_b );
      local tme = 0.003 * len;
      
      if tme > 0.4 then
        tme = 0.4;
      elseif tme < 0.1 then
        tme = 0.1;
      end;
      
      if tme > max_tme then
        max_tme = tme;
      end;
      
      ObjAnimate("spr_weaponcabinet_plate_"..private.zz_weaponcabinet.state[i], "pos_xy", 0, 0, "", { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] } );
      
    end;
    
  end;
  
  if need_r then
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_ieroglyphs_insert");
    private.zz_weaponcabinet.StartConditions();
    private.zz_weaponcabinet.state = ng_global.progress[ ng_global.currentprogress ][ "win_weaponcabinet" ].state;
    
    ObjSet("tmr_weaponcabinet_timer",  { time = max_tme, playing = 1, endtrig = function() cmn.Lock(0); end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_weaponcabinet.Skip()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_ieroglyphs_insert");
  local max_tme = 0;
  
  ng_global.progress[ ng_global.currentprogress ][ "win_weaponcabinet" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_weaponcabinet" ].state = { 1, 2, 3, 4, 5, 6 };
  
  for i = 1, #private.zz_weaponcabinet.state, 1 do
    
    if private.zz_weaponcabinet.state[i] ~= i then
      
      local point_a, point_b = {}, {};
      point_a[1] = private.zz_weaponcabinet.plate_pos[ i ][1];
      point_a[2] = private.zz_weaponcabinet.plate_pos[ i ][2];
      point_b[1] = private.zz_weaponcabinet.plate_pos[ private.zz_weaponcabinet.state[i] ][1];
      point_b[2] = private.zz_weaponcabinet.plate_pos[ private.zz_weaponcabinet.state[i] ][2];
      local len = common_impl.math.FindSegmentLength( point_a, point_b );
      local tme = 0.003 * len;
      
      if tme > 0.4 then
        tme = 0.4;
      elseif tme < 0.1 then
        tme = 0.1;
      end;
      
      if tme > max_tme then
        max_tme = tme;
      end;
      
      ObjAnimate("spr_weaponcabinet_plate_"..private.zz_weaponcabinet.state[i], "pos_xy", 0, 0, "", { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] } );
      
    end;
    
  end;
  
  private.zz_weaponcabinet.state = ng_global.progress[ ng_global.currentprogress ][ "win_weaponcabinet" ].state;
    
  ObjSet("tmr_weaponcabinet_timer",  { time = max_tme, playing = 1, endtrig = private.zz_weaponcabinet.CheckWin });
  
end;
-----------------------------------------------------------------------------------
function private.zz_weaponcabinet.DrawScene()
  
  for i = 1, #private.zz_weaponcabinet.state, 1 do
    
    ObjSet("spr_weaponcabinet_plate_"..private.zz_weaponcabinet.state[i],  
    { pos_x = private.zz_weaponcabinet.plate_pos[i][1], pos_y = private.zz_weaponcabinet.plate_pos[i][2] });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_weaponcabinet.FocusPlate( num, inout )
  
  local obj = "spr_weaponcabinet_plate_"..num.."_on";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_GET);
    tme = ( 1 - alf ) * 0.3;
  end;

  --ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.zz_weaponcabinet.StartDrag( num, two_step )
  
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_ieroglyphs_klick");
  
  if private.zz_weaponcabinet.current_stone == 0 then
    
    private.zz_weaponcabinet.vacant_place = private.zz_weaponcabinet.FindInd( num );
    
  end;
  
  private.zz_weaponcabinet.current_stone = num;
  
  public.zz_weaponcabinet.FocusPlate( num, 0 );
  
  if (not two_step) then
    ObjStartDrag("obj_weaponcabinet_game_drag");
  end;
  ObjAttach("spr_weaponcabinet_plate_"..num, "obj_weaponcabinet_game_fly");
  
end;
-----------------------------------------------------------------------------------
function public.zz_weaponcabinet.DragPlate()
  
  local curspos = GetZoomCursorPos();
  curspos[1] = math.floor(curspos[1] - ObjGet("zz_weaponcabinet").pos_x);
  curspos[2] = math.floor(curspos[2] - ObjGet("zz_weaponcabinet").pos_y);
  
  if curspos[1] > 225 then
    curspos[1] = 225;
  elseif curspos[1] < -225 then
    curspos[1] = -225;
  end;
  
  if curspos[2] > 230 then
    curspos[2] = 230;
  elseif curspos[2] < -230 then
    curspos[2] = -230;
  end;
  
  ObjSet("spr_weaponcabinet_plate_"..private.zz_weaponcabinet.current_stone,  { pos_x = curspos[1], pos_y = curspos[2] });
  
end;
-----------------------------------------------------------------------------------
function public.zz_weaponcabinet.DropPlate(two_step)
  
  cmn.Lock(1);
  
  local curspos = GetZoomCursorPos();
  if  tostring(GetPlatform()) == "android" then
    curspos[2] = curspos[2] - 100;
  elseif tostring(GetPlatform()) == "ios" then
    if port.isTablet() == 0 then
      curspos[2] = curspos[2] - 75;
    else
      curspos[2] = curspos[2] - 50;
    end;
  end;
  
  if two_step then
    curspos[1] = public.zz_weaponcabinet.old_drop_pos[1];
    curspos[2] = public.zz_weaponcabinet.old_drop_pos[2];
    curspos[1] = curspos[1] - 100;
  else
    public.zz_weaponcabinet.old_drop_pos[1] = curspos[1];
    public.zz_weaponcabinet.old_drop_pos[2] = curspos[2];
  end;
  
  curspos[1] = math.floor(curspos[1] - ObjGet("zz_weaponcabinet").pos_x);
  curspos[2] = math.floor(curspos[2] - ObjGet("zz_weaponcabinet").pos_y);
  
  if curspos[1] > 225 then
    curspos[1] = 225;
  elseif curspos[1] < -225 then
    curspos[1] = -225;
  end;
  
  if curspos[2] > 230 then
    curspos[2] = 230;
  elseif curspos[2] < -230 then
    curspos[2] = -230;
  end;
  
  local pos = 0;
  local num = private.zz_weaponcabinet.current_stone;
  
  for i = 1, 6, 1 do

    if (curspos[1] > private.zz_weaponcabinet.plate_pos[i][1] - 20) and (curspos[1] < private.zz_weaponcabinet.plate_pos[i][1] + 20) and 
       (curspos[2] > private.zz_weaponcabinet.plate_pos[i][2] - 20) and (curspos[2] < private.zz_weaponcabinet.plate_pos[i][2] + 20) then

      pos = i;
      break;
    end;

  end;
  
  if pos == 0 or pos == private.zz_weaponcabinet.vacant_place then
    
    pos = private.zz_weaponcabinet.vacant_place;
    
    private.zz_weaponcabinet.current_stone = 0;
    private.zz_weaponcabinet.vacant_place = 0;
    
    local point_a, point_b = {}, {};
    point_a[1] = curspos[1];
    point_a[2] = curspos[2];
    point_b[1] = private.zz_weaponcabinet.plate_pos[ pos ][1];
    point_b[2] = private.zz_weaponcabinet.plate_pos[ pos ][2];
    local len = common_impl.math.FindSegmentLength( point_a, point_b );
    local tme = 0.003 * len;
    
    if tme > 0.4 then
      tme = 0.4;
    elseif tme < 0.1 then
      tme = 0.1;
    end;
    
    ObjAnimate("spr_weaponcabinet_plate_"..num, "pos_xy", 0, 0, 
      function() 
        cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_ieroglyphs_insert");
        private.zz_weaponcabinet.CheckStone( num, 0 ); 
      end, 
      { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] }
    );
    
  else 
    
    private.zz_weaponcabinet.current_stone = private.zz_weaponcabinet.state[ pos ];
    private.zz_weaponcabinet.state[ pos ] = num;
    private.zz_weaponcabinet.state[ private.zz_weaponcabinet.vacant_place ] = private.zz_weaponcabinet.current_stone;
    
    local point_a, point_b = {}, {};
    point_a[1] = curspos[1];
    point_a[2] = curspos[2];
    point_b[1] = private.zz_weaponcabinet.plate_pos[ pos ][1];
    point_b[2] = private.zz_weaponcabinet.plate_pos[ pos ][2];
    local len = common_impl.math.FindSegmentLength( point_a, point_b );
    local tme = 0.002 * len;
    
    if tme > 0.4 then
      tme = 0.4;
    elseif tme < 0.1 then
      tme = 0.1;
    end;
    
    ObjAnimate("spr_weaponcabinet_plate_"..num, "pos_xy", 0, 0, 
      function() 
        cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_ieroglyphs_insert");
        private.zz_weaponcabinet.CheckStone( num, private.zz_weaponcabinet.current_stone ); 
      end, 
      { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] }
    );
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_weaponcabinet.CheckStone( num1, num2 )
  
  num2 = num2 or 0;
  
  ObjAttach("spr_weaponcabinet_plate_"..num1, "obj_weaponcabinet_game");
  
  if num2 > 0 then
    cmn.Lock(0);
    public.zz_weaponcabinet.StartDrag( num2, true );
    public.zz_weaponcabinet.DropPlate(true);
  else 
    private.zz_weaponcabinet.CheckWin();
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_weaponcabinet.FindInd( num )
  
  local ind = 0;
  
  for i = 1, #private.zz_weaponcabinet.state, 1 do
    
    if private.zz_weaponcabinet.state[i] == num then
      ind = i;
      break;
    end;
    
  end;
  
  return ind;
  
end;
-----------------------------------------------------------------------------------
function private.zz_weaponcabinet.CheckWin()
  
  local win_flag = true;
  
  for i = 1, #private.zz_weaponcabinet.state, 1 do
    
    if private.zz_weaponcabinet.wrong_spots[ private.zz_weaponcabinet.state[i] ][i] == 1 then
      win_flag = false;
      break;
    end;
    
  end;
  
  if win_flag then
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_ieroglyphs_win");
    
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("weaponcabinet");
    
    local anm_open_2 = function ()
      
      ObjDelete( "anm_weaponcabinet_window" );
      ObjDelete( "anm_weaponcabinet_code_wrong" );
      
      ObjSet("anm_weaponcabinet_window_open",  { frame = 0, animfunc = "func_window_open_1", playing = 1, endtrig = private.zz_weaponcabinet.Win });
      
    end;
    
    local anm_open_1 = function ()
    
      ObjDelete( "obj_weaponcabinet_game" );
      ObjSet("anm_weaponcabinet_window_open",  { alp = 1, playing = 1, endtrig = anm_open_2 });
      
    end;
    
    ObjAnimate("spr_weaponcabinet_codes", "alp", 0, 0, anm_open_1, { 0, 0, 1,   1, 0, 1,   1.5, 0, 0 });
    
  else 
    cmn.Lock( 0 );
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_weaponcabinet.Win()
  
  cmn.Lock( 0 );
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_weaponcabinet" );
  cmn.CallEventHandler( "win_weaponcabinet" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_weaponcabinet" ].skip == 0 and ng_global.noskipgames[ "win_weaponcabinet" ] == nil then

    ng_global.noskipgames[ "win_weaponcabinet" ] = 1;
    common_impl.CheckAchiev("mg");

  end;
  
end;
--*****************************************************************************************************************