-- name=rm_cargosection
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_cargosection";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Controlpanel();
  private.Init_Junk();
  --------------------------------------------------------------------------------------------
  -- function get_cutterbase () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_cutterbase" ] = {
    type = "get",
    get_obj = "spr_grate_cutterbase",
    room = private.room_objname,
    zz = "zz_grate",
    zz_gate = "gzz_cargosection_grate"
  };
  --------------------------------------------------------------------------------------------
  local get_cutterbase_inv = function ()
  
    interface.InventoryItemAdd( "inv_cutterbase", "spr_grate_cutterbase" );
  
  end;
  local get_cutterbase_end = function ()
  
    ObjDelete( "gfx_grate_cutterbase" );
    ObjDelete( "spr_grate_cutterbase_sh" );
    
    ObjDelete( "spr_cargosection_grate_cutter" );
  
  end;
  
  cmn.AddSubscriber( "get_cutterbase", get_cutterbase_inv );
  cmn.AddSubscriber( "get_cutterbase", get_cutterbase_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_accesscard () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_accesscard" ] = {
    type = "get",
    get_obj = "spr_grate_accesscard",
    room = private.room_objname,
    zz = "zz_grate",
    zz_gate = "gzz_cargosection_grate"
  };
  --------------------------------------------------------------------------------------------
  local get_accesscard_inv = function ()
  
    interface.InventoryItemAdd( "inv_accesscard", "spr_grate_accesscard" );
  
  end;
  local get_accesscard_end = function ()
  
    ObjDelete( "gfx_grate_accesscard" );
    ObjDelete( "spr_grate_accesscard_sh" );
    
    ObjDelete( "spr_cargosection_grate_card" );
  
  end;
  
  cmn.AddSubscriber( "get_accesscard", get_accesscard_inv );
  cmn.AddSubscriber( "get_accesscard", get_accesscard_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ventilationscheme () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_ventilationscheme" ] = {
    type = "get",
    get_obj = "spr_controlpanel_ventilationscheme",
    room = private.room_objname,
    zz = "zz_controlpanel",
    zz_gate = "gzz_cargosection_controlpanel"
  };
  --------------------------------------------------------------------------------------------
  local get_ventilationscheme_inv = function ()
  
    interface.InventoryItemAdd( "inv_ventilationscheme", "spr_controlpanel_ventilationscheme" );
  
  end;
  local get_ventilationscheme_end = function ()
  
    ObjDelete( "gfx_controlpanel_ventilationscheme" );
    
    ObjDelete( "spr_cargosection_control_map" );
    ObjSet( "gzz_cargosection_controlpanel", { alp = 0 } );
  
  end;
  
  cmn.AddSubscriber( "get_ventilationscheme", get_ventilationscheme_inv );
  cmn.AddSubscriber( "get_ventilationscheme", get_ventilationscheme_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tabletpart2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_tabletpart2" ] = {
    type = "get",
    get_obj = "spr_controlpanel_tabletpart2",
    room = private.room_objname,
    zz = "zz_controlpanel",
    zz_gate = "gzz_cargosection_controlpanel"
  };
  --------------------------------------------------------------------------------------------
  local get_tabletpart2_inv = function ()
  
    interface.InventoryItemAdd( "inv_tabletpart2", "spr_controlpanel_tabletpart2" );
    ObjSet("inv_tablet_star_light",  { alp = 1 });
  
  end;
  local get_tabletpart2_end = function ()
  
    ObjDelete( "gfx_controlpanel_tabletpart2" );
    ObjDelete( "spr_controlpanel_tabletpart2_sh" );
    ObjDelete( "spr_cargosection_control_part" );
  
  end;
  
  cmn.AddSubscriber( "get_tabletpart2", get_tabletpart2_inv );
  cmn.AddSubscriber( "get_tabletpart2", get_tabletpart2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tablet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_tablet" ] = {
    type = "get",
    get_obj = "spr_cargo_tablet",
    room = private.room_objname,
    zz = "zz_cargo",
    zz_gate = "gzz_cargosection_cargo"
  };
  --------------------------------------------------------------------------------------------
  local get_tablet_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_tablet", "spr_cargo_tablet" );
  
  end;
  local get_tablet_end = function ()
  
    ObjDelete( "gfx_cargo_tablet" );
    ObjDelete( "spr_cargo_tablet_sh" );
    ObjDelete( "spr_cargosection_cargo_tablet" );
  
  end;
  
  cmn.AddSubscriber( "get_tablet", get_tablet_inv );
  cmn.AddSubscriber( "get_tablet", get_tablet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wrench () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_wrench" ] = {
    type = "get",
    get_obj = "spr_cargo_wrench",
    room = private.room_objname,
    zz = "zz_cargo",
    zz_gate = "gzz_cargosection_cargo"
  };
  --------------------------------------------------------------------------------------------
  local get_wrench_inv = function ()
  
    interface.InventoryItemAdd( "inv_wrench", "spr_cargo_wrench" );
  
  end;
  local get_wrench_end = function ()
  
    ObjDelete( "gfx_cargo_wrench" );
    ObjDelete( "spr_cargosection_cargo_wrench" );
  
  end;
  
  cmn.AddSubscriber( "get_wrench", get_wrench_inv );
  cmn.AddSubscriber( "get_wrench", get_wrench_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hacker () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_hacker" ] = {
    type = "get",
    get_obj = "spr_junk_hacker",
    room = private.room_objname,
    zz = "zz_junk",
    zz_gate = "gzz_cargosection_junk"
  };
  --------------------------------------------------------------------------------------------
  local get_hacker_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_hacker", "spr_junk_hacker" );
  
  end;
  local get_hacker_end = function ()
  
    ObjDelete( "gfx_junk_hacker" );
    ObjDelete( "spr_junk_hacker_shadow" );
    ObjDelete( "spr_cargosection_junk_element" );
  
  end;
  
  cmn.AddSubscriber( "get_hacker", get_hacker_inv );
  cmn.AddSubscriber( "get_hacker", get_hacker_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_chargedenergyelement () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_chargedenergyelement" ] = {
    type = "get",
    get_obj = "spr_cargo_chargedenergyelement",
    room = private.room_objname,
    zz = "zz_cargo",
    zz_gate = "gzz_cargosection_cargo"
  };
  --------------------------------------------------------------------------------------------
  local get_chargedenergyelement_inv = function ()
  
    interface.InventoryItemAdd( "inv_chargedenergyelement", "spr_cargo_chargedenergyelement" );
    ObjSet("inv_gun_star_light",  { alp = 1 });
  
  end;
  local get_chargedenergyelement_end = function ()
  
    ObjDelete( "gfx_cargo_chargedenergyelement" );
    ObjDelete( "spr_cargosection_cargo_battery" );

    ObjSet( "gzz_cargosection_cargo", { active = 0, input = true, alp = 0 } );
  
  end;
  
  cmn.AddSubscriber( "get_chargedenergyelement", get_chargedenergyelement_inv );
  cmn.AddSubscriber( "get_chargedenergyelement", get_chargedenergyelement_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_plasmaticcutter () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_plasmaticcutter" ] = {
    type = "get",
    get_obj = "obj_junk_plasmaticcutter",
    room = private.room_objname,
    zz = "zz_junk",
    zz_gate = "gzz_cargosection_junk"
  };
  --------------------------------------------------------------------------------------------
  local get_plasmaticcutter_inv = function ()
  
    interface.InventoryItemAdd( "inv_plasmaticcutter", "obj_junk_plasmaticcutter" );
  
  end;
  local get_plasmaticcutter_end = function ()
  
    ObjDelete( "gfx_junk_plasmaticcutter" );
  
  end;
  
  cmn.AddSubscriber( "get_plasmaticcutter", get_plasmaticcutter_inv );
  cmn.AddSubscriber( "get_plasmaticcutter", get_plasmaticcutter_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tabletpart1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_tabletpart1" ] = {
    type = "get",
    get_obj = "spr_junk_tabletpart1",
    room = private.room_objname,
    zz = "zz_junk",
    zz_gate = "gzz_cargosection_junk"
  };
  --------------------------------------------------------------------------------------------
  local get_tabletpart1_inv = function ()
  
    interface.InventoryItemAdd( "inv_tabletpart1", "spr_junk_tabletpart1" );
    ObjSet("inv_tablet_star_light",  { alp = 1 });
  
  end;
  local get_tabletpart1_end = function ()
  
    ObjDelete( "gfx_junk_tabletpart1" );
    ObjDelete( "spr_junk_tabletpart1_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_tabletpart1", get_tabletpart1_inv );
  cmn.AddSubscriber( "get_tabletpart1", get_tabletpart1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_spareparts () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_spareparts" ] = {
    type = "get",
    get_obj = "spr_junk_spareparts",
    room = private.room_objname,
    zz = "zz_junk",
    zz_gate = "gzz_cargosection_junk"
  };
  --------------------------------------------------------------------------------------------
  local get_spareparts_inv = function ()
  
    interface.InventoryItemAdd( "inv_spareparts", "spr_junk_spareparts" );
    int_map_impl.DecreaseRoomTasks("rm_cargosection");
  
  end;
  local get_spareparts_end = function ()
  
    ObjDelete( "gfx_junk_spareparts" );
    ObjDelete( "gzz_cargosection_junk" );

    ObjDelete( "spr_junk_spareparts_shadow" );
    ObjDelete( "spr_junk_spareparts_glow" );
  
  end;
  
  cmn.AddSubscriber( "get_spareparts", get_spareparts_inv );
  cmn.AddSubscriber( "get_spareparts", get_spareparts_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_squarekey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_squarekey" ] = {
    type = "get",
    get_obj = "spr_junk_squarekey",
    room = private.room_objname,
    zz = "zz_junk",
    zz_gate = "gzz_cargosection_junk"
  };
  --------------------------------------------------------------------------------------------
  local get_squarekey_inv = function ()
  
    interface.InventoryItemAdd( "inv_squarekey", "spr_junk_squarekey" );
  
  end;
  local get_squarekey_end = function ()
  
    ObjDelete( "gfx_junk_squarekey" );
    ObjDelete( "spr_junk_squarekey_sh" );

  end;
  
  cmn.AddSubscriber( "get_squarekey", get_squarekey_inv );
  cmn.AddSubscriber( "get_squarekey", get_squarekey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_element1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_element1" ] = {
    type = "get",
    get_obj = "spr_cargo_element1",
    room = private.room_objname,
    zz = "zz_cargo",
    zz_gate = "gzz_cargosection_cargo"
  };
  --------------------------------------------------------------------------------------------
  local get_element1_inv = function ()
  
    interface.InventoryItemAdd( "inv_element", "spr_cargo_element1", function () cmn.GetMultyObject( 'element', 3 ); end );
    
    if cmn.CheckMultiObject( "element", 3 ) then
      ObjSet("inv_hacker_star_light",  { alp = 1 });
    end;
  
  end;
  local get_element1_end = function ()
  
    ObjDelete( "gfx_cargo_element1" );
    ObjDelete( "spr_cargo_element1_sh" );
    
    ObjDelete( "spr_cargosection_cargo_hacker" );
  
  end;
  
  cmn.AddSubscriber( "get_element1", get_element1_inv );
  cmn.AddSubscriber( "get_element1", get_element1_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_plasmaticcutter () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_plasmaticcutter" ] = {
    type = "use",
    inv_obj = "inv_plasmaticcutter",
    use_place = "obj_grate_use_plasmaticcutter",
    room = private.room_objname,
    zz = "zz_grate",
    zz_gate = "gzz_cargosection_grate"
  };
  --------------------------------------------------------------------------------------------
  local use_plasmaticcutter_inv = function ()
  
    interface.InventoryItemRemove( "inv_plasmaticcutter" );
  
  end;
  local use_plasmaticcutter_beg = function ()
  
    ObjDelete( "obj_grate_use_plasmaticcutter" );
    ObjDelete( "anm_grate_grid_touch" );
    --ObjDelete( "spr_grate_overlap" );
  
  end;
  local use_plasmaticcutter_end = function ()
    
    ObjDelete( "spr_cargosection_grate_grid" );
    ObjDelete( "anm_grate_use_plasmaticcutter" );
  
    --ObjMultiSet( { {"obj_grate_use_ventilationscheme", { alp = 1, input = 1 }},
    --               {"anm_grate_use_plasmaticcutter", { alp = 1, frame = 400 }} } );
                   

    if cmn.IsEventDone("use_ventilationscheme") then
      ObjDelete( "gzz_cargosection_grate" );
      ObjSet( "gmg_cargosection_ventilation", { input = 1, alp = 1, active = 1 } );
    else 
      ObjSet("obj_grate_use_ventilationscheme",  { input = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_plasmaticcutter", use_plasmaticcutter_beg, private.room_objname );
  cmn.AddSubscriber( "use_plasmaticcutter", use_plasmaticcutter_inv );
  cmn.AddSubscriber( "use_plasmaticcutter", use_plasmaticcutter_end, private.room_objname );
  cmn.AddSubscriber( "use_plasmaticcutter_inv", use_plasmaticcutter_inv, private.room_objname );
  cmn.AddSubscriber( "use_plasmaticcutter_beg", use_plasmaticcutter_beg, private.room_objname );
  cmn.AddSubscriber( "use_plasmaticcutter_end", use_plasmaticcutter_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ventilationscheme () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_ventilationscheme" ] = {
    type = "use",
    inv_obj = "inv_ventilationscheme",
    use_place = "obj_grate_use_ventilationscheme",
    room = private.room_objname,
    zz = "zz_grate",
    zz_gate = "gzz_cargosection_grate"
  };
  --------------------------------------------------------------------------------------------
  local use_ventilationscheme_inv = function ()
  
    interface.InventoryItemRemove( "inv_ventilationscheme" );
  
  end;
  local use_ventilationscheme_beg = function ()
  
    ObjDelete( "obj_grate_use_ventilationscheme" );
  
  end;
  local use_ventilationscheme_end = function ()
    
    ObjSet("obj_grate_vent_map",  { alp = 1 });

    if cmn.IsEventDone("use_plasmaticcutter") then
      ObjDelete( "gzz_cargosection_grate" );
      ObjSet( "gmg_cargosection_ventilation", { input = 1, alp = 1, active = 1 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ventilationscheme", use_ventilationscheme_beg, private.room_objname );
  cmn.AddSubscriber( "use_ventilationscheme", use_ventilationscheme_inv );
  cmn.AddSubscriber( "use_ventilationscheme", use_ventilationscheme_end, private.room_objname );
  cmn.AddSubscriber( "use_ventilationscheme_inv", use_ventilationscheme_inv, private.room_objname );
  cmn.AddSubscriber( "use_ventilationscheme_beg", use_ventilationscheme_beg, private.room_objname );
  cmn.AddSubscriber( "use_ventilationscheme_end", use_ventilationscheme_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_accesscard () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_accesscard" ] = {
    type = "use",
    inv_obj = "inv_accesscard",
    use_place = "obj_controlpanel_use_accesscard",
    room = private.room_objname,
    zz = "zz_controlpanel",
    zz_gate = "gzz_cargosection_controlpanel"
  };
  --------------------------------------------------------------------------------------------
  local use_accesscard_inv = function ()
  
    interface.InventoryItemRemove( "inv_accesscard" );
  
  end;
  local use_accesscard_beg = function ()
  
    ObjDelete( "obj_controlpanel_use_accesscard" );
  
  end;
  local use_accesscard_end = function ()
  
    ObjMultiSet( { {"anm_controlpanel_use_card", { frame = 300 }},
                   {"spr_controlpanel_button_vent", { color_r = 1, color_g = 1, color_b = 1 }},
                   {"spr_cargosection_control_card", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_accesscard", use_accesscard_beg, private.room_objname );
  cmn.AddSubscriber( "use_accesscard", use_accesscard_inv );
  cmn.AddSubscriber( "use_accesscard", use_accesscard_end, private.room_objname );
  cmn.AddSubscriber( "use_accesscard_inv", use_accesscard_inv, private.room_objname );
  cmn.AddSubscriber( "use_accesscard_beg", use_accesscard_beg, private.room_objname );
  cmn.AddSubscriber( "use_accesscard_end", use_accesscard_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_code () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_code" ] = {
    type = "use",
    inv_obj = "inv_code",
    use_place = "obj_controlpanel_use_code",
    room = private.room_objname,
    zz = "zz_controlpanel",
    zz_gate = "gzz_cargosection_controlpanel"
  };
  --------------------------------------------------------------------------------------------
  local use_code_inv = function ()
  
    interface.InventoryItemRemove( "inv_code" );
  
  end;
  local use_code_beg = function ()
  
    ObjDelete( "obj_controlpanel_use_code" );
  
  end;
  local use_code_end = function ()
  
    ObjMultiSet( { {"obj_controlpanel_buttons", { input = 1 }},
                   {"obj_controlpanel_code_hint", { alp = 1 }},
                   {"spr_cargosection_control_code", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_code", use_code_beg, private.room_objname );
  cmn.AddSubscriber( "use_code", use_code_inv );
  cmn.AddSubscriber( "use_code", use_code_end, private.room_objname );
  cmn.AddSubscriber( "use_code_inv", use_code_inv, private.room_objname );
  cmn.AddSubscriber( "use_code_beg", use_code_beg, private.room_objname );
  cmn.AddSubscriber( "use_code_end", use_code_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_acid () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_acid" ] = {
    type = "use",
    inv_obj = "inv_acid",
    use_place = "obj_cargo_use_acid",
    room = private.room_objname,
    zz = "zz_cargo",
    zz_gate = "gzz_cargosection_cargo"
  };
  --------------------------------------------------------------------------------------------
  local use_acid_inv = function ()
  
    interface.InventoryItemRemove( "inv_acid" );
  
  end;
  local use_acid_beg = function ()
  
    ObjDelete( "obj_cargo_use_acid" );
  
  end;
  local use_acid_end = function ()
  
    ObjMultiSet( { {"anm_cargo_use_acid", { input = 1, alp = 1, frame = 400 }},
                   {"spr_cargosection_cargo_hole_1", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_acid", use_acid_beg, private.room_objname );
  cmn.AddSubscriber( "use_acid", use_acid_inv );
  cmn.AddSubscriber( "use_acid", use_acid_end, private.room_objname );
  cmn.AddSubscriber( "use_acid_inv", use_acid_inv, private.room_objname );
  cmn.AddSubscriber( "use_acid_beg", use_acid_beg, private.room_objname );
  cmn.AddSubscriber( "use_acid_end", use_acid_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tool () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_toolcargo" ] = {
    type = "use",
    inv_obj = "inv_tool",
    use_place = "obj_cargo_use_tool",
    room = private.room_objname,
    zz = "zz_cargo",
    zz_gate = "gzz_cargosection_cargo"
  };
  --------------------------------------------------------------------------------------------
  game.hint[ "use_toolrobot" ] = {
    type = "use",
    inv_obj = "inv_tool",
    use_place = "obj_robot_use_tool",
    room = "rm_corridor",
    zz = "zz_robot",
    zz_gate = "gzz_corridor_robot"
  };
  --------------------------------------------------------------------------------------------
  local use_toolcargo_inv = function ()
  
    if ( cmn.IsEventDone( "use_toolrobot" ) ) then
      interface.InventoryItemRemove( "inv_tool" );
    end;
  
  end;
  local use_toolcargo_beg = function ()
  
    ObjDelete("obj_cargo_use_tool");
  
  end;
  local use_toolcargo_end = function ()
  
    ObjMultiSet( { {"anm_cargo_use_tool", { input = 1, alp = 1, frame = 800 }},
                   {"obj_cargo_use_runoutenergyelement", { input = 1 }},
                   {"spr_cargosection_cargo_hole_2", { alp = 1 }} } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_toolcargo", use_toolcargo_beg, private.room_objname );
  cmn.AddSubscriber( "use_toolcargo", use_toolcargo_inv );
  cmn.AddSubscriber( "use_toolcargo", use_toolcargo_end, private.room_objname );
  cmn.AddSubscriber( "use_toolcargo_inv", use_toolcargo_inv, private.room_objname );
  cmn.AddSubscriber( "use_toolcargo_beg", use_toolcargo_beg, private.room_objname );
  cmn.AddSubscriber( "use_toolcargo_end", use_toolcargo_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  local use_toolrobot_inv = function ()
  
    if ( cmn.IsEventDone( "use_toolcargo" ) ) then
      interface.InventoryItemRemove( "inv_tool" );
    end;
  
  end;
  local use_toolrobot_beg = function ()
  
    ObjDelete( "obj_robot_use_tool" );
    ObjDelete( "anm_robot_crustal_touch" );
  
  end;
  local use_toolrobot_end = function ()

    ObjMultiSet( {
      { "anm_robot_crustal_open", { input = 1, alp = 1, frame = 400 } },
      { "spr_corridor_robot_metal", { alp = 1 } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_toolrobot", use_toolrobot_beg, "rm_corridor" );
  cmn.AddSubscriber( "use_toolrobot", use_toolrobot_inv );
  cmn.AddSubscriber( "use_toolrobot", use_toolrobot_end, "rm_corridor" );
  cmn.AddSubscriber( "use_toolrobot_inv", use_toolrobot_inv, "rm_corridor" );
  cmn.AddSubscriber( "use_toolrobot_beg", use_toolrobot_beg, "rm_corridor" );
  cmn.AddSubscriber( "use_toolrobot_end", use_toolrobot_end, "rm_corridor" );
  --------------------------------------------------------------------------------------------
  -- function use_runoutenergyelement () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_runoutenergyelement" ] = {
    type = "use",
    inv_obj = "inv_runoutenergyelement",
    use_place = "obj_cargo_use_runoutenergyelement",
    room = private.room_objname,
    zz = "zz_cargo",
    zz_gate = "gzz_cargosection_cargo"
  };
  --------------------------------------------------------------------------------------------
  local use_runoutenergyelement_inv = function ()
  
    interface.InventoryItemRemove( "inv_runoutenergyelement" );
  
  end;
  local use_runoutenergyelement_beg = function ()
  
    ObjDelete( "obj_cargo_use_runoutenergyelement" );
    ObjDelete( "anm_cargo_energy_light" );
  
  end;
  local use_runoutenergyelement_end = function ()
  
    ObjDelete( "anm_cargo_use_battery" );
    ObjDelete( "spr_cargosection_cargo_energy" );

    ObjMultiSet( { {"spr_cargo_chargedenergyelement", { input = 1, alp = 1 }},
                   {"spr_cargosection_cargo_battery", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_runoutenergyelement", use_runoutenergyelement_beg, private.room_objname );
  cmn.AddSubscriber( "use_runoutenergyelement", use_runoutenergyelement_inv );
  cmn.AddSubscriber( "use_runoutenergyelement", use_runoutenergyelement_end, private.room_objname );
  cmn.AddSubscriber( "use_runoutenergyelement_inv", use_runoutenergyelement_inv, private.room_objname );
  cmn.AddSubscriber( "use_runoutenergyelement_beg", use_runoutenergyelement_beg, private.room_objname );
  cmn.AddSubscriber( "use_runoutenergyelement_end", use_runoutenergyelement_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cutterbase () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_cutterbase" ] = {
    type = "use",
    inv_obj = "inv_cutterbase",
    use_place = "obj_junk_use_cutterbase",
    room = private.room_objname,
    zz = "zz_junk",
    zz_gate = "gzz_cargosection_junk"
  };
  --------------------------------------------------------------------------------------------
  local use_cutterbase_inv = function ()
  
    interface.InventoryItemRemove( "inv_cutterbase" );
  
  end;
  local use_cutterbase_beg = function ()
  
    ObjDelete( "obj_junk_use_cutterbase" );
  
  end;
  local use_cutterbase_end = function ()
  
    ObjMultiSet( {
      { "anm_junk_plasmaticcutter", { frame = 300 } },
      { "spr_junk_mho_interface", { alp = 1 } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cutterbase", use_cutterbase_beg, private.room_objname );
  cmn.AddSubscriber( "use_cutterbase", use_cutterbase_inv );
  cmn.AddSubscriber( "use_cutterbase", use_cutterbase_end, private.room_objname );
  cmn.AddSubscriber( "use_cutterbase_inv", use_cutterbase_inv, private.room_objname );
  cmn.AddSubscriber( "use_cutterbase_beg", use_cutterbase_beg, private.room_objname );
  cmn.AddSubscriber( "use_cutterbase_end", use_cutterbase_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wrench () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_wrench" ] = {
    type = "use",
    inv_obj = "inv_wrench",
    use_place = "obj_junk_use_wrench",
    room = private.room_objname,
    zz = "zz_junk",
    zz_gate = "gzz_cargosection_junk"
  };
  --------------------------------------------------------------------------------------------
  local use_wrench_inv = function ()
  
    interface.InventoryItemRemove( "inv_wrench" );
  
  end;
  local use_wrench_beg = function ()
  
    ObjDelete( "obj_junk_use_wrench" );

    ObjMultiSet( {
      { "obj_junk_hacker_shadow", { anim_tag = "tag_hacker_shadow1" } },
      { "obj_junk_hacker", { anim_tag = "tag_hacker1" } },
      { "spr_junk_hacker", { anim_tag = "tag_hacker1" } }
    } );
  
  end;
  local use_wrench_end = function ()

    ObjDelete( "spr_cargosection_junk_panel" );

    ObjMultiSet( {
      { "spr_junk_tabletpart1", { input = true, alp = 1 } },
      { "anm_junk_door", { animfunc = "func_door_opn", frame = 300 } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wrench", use_wrench_beg, private.room_objname );
  cmn.AddSubscriber( "use_wrench", use_wrench_inv );
  cmn.AddSubscriber( "use_wrench", use_wrench_end, private.room_objname );
  cmn.AddSubscriber( "use_wrench_inv", use_wrench_inv, private.room_objname );
  cmn.AddSubscriber( "use_wrench_beg", use_wrench_beg, private.room_objname );
  cmn.AddSubscriber( "use_wrench_end", use_wrench_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_list () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_list" ] = {
    type = "use",
    inv_obj = "inv_list",
    use_place = "obj_junk_use_list",
    room = private.room_objname,
    zz = "zz_junk",
    zz_gate = "gzz_cargosection_junk"
  };
  --------------------------------------------------------------------------------------------
  local use_list_inv = function ()
  
    interface.InventoryItemRemove( "inv_list" );
  
  end;
  local use_list_beg = function ()
  
    ObjDelete( "obj_junk_use_list" );
  
  end;
  local use_list_end = function ()
  
    ObjMultiSet( {
      { "spr_junk_spareparts", { input = true } },
      { "gfx_junk_spareparts", { active = true } },
      { "spr_junk_paper", { alp = 1 } },
      { "spr_junk_spareparts_glow", { alp = 1 } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_list", use_list_beg, private.room_objname );
  cmn.AddSubscriber( "use_list", use_list_inv );
  cmn.AddSubscriber( "use_list", use_list_end, private.room_objname );
  cmn.AddSubscriber( "use_list_inv", use_list_inv, private.room_objname );
  cmn.AddSubscriber( "use_list_beg", use_list_beg, private.room_objname );
  cmn.AddSubscriber( "use_list_end", use_list_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_pressbutton () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_pressbutton" ] = {
    type = "click",
    use_place = "obj_cargosection_clk_pressbutton",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local clk_pressbutton_beg = function ()
  
    ObjDelete( "obj_cargosection_clk_pressbutton" );
  
  end;
  local clk_pressbutton_end = function ()

    ObjDelete( "spr_cargosection_back_2" );
    ObjSet( "obj_cargosection_gates", { alp = 1, input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_pressbutton", clk_pressbutton_beg, private.room_objname );
  cmn.AddSubscriber( "clk_pressbutton", clk_pressbutton_end, private.room_objname );
  cmn.AddSubscriber( "clk_pressbutton_beg", clk_pressbutton_beg, private.room_objname );
  cmn.AddSubscriber( "clk_pressbutton_end", clk_pressbutton_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_activatejunk () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_activatejunk" ] = {
    type = "click",
    use_place = "spr_controlpanel_button_tools",
    room = private.room_objname,
    zz = "zz_controlpanel",
    zz_gate = "gzz_cargosection_controlpanel"
  };
  --------------------------------------------------------------------------------------------
  local clk_activatejunk_beg = function ()
  
    ObjSet("spr_controlpanel_button_tools",  { input = 0 });
  
  end;
  local clk_activatejunk_end = function ()

    ObjMultiSet( { {"gzz_cargosection_junk", { alp = 1, input = 1, active = 1 }},
                   {"spr_controlpanel_button_tools", { color_r = 0.5, color_g = 0.5, color_b = 0.5 }},
                   {"obj_cargosection_junk", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_activatejunk", clk_activatejunk_beg, private.room_objname );
  cmn.AddSubscriber( "clk_activatejunk", clk_activatejunk_end, private.room_objname );
  cmn.AddSubscriber( "clk_activatejunk_beg", clk_activatejunk_beg, private.room_objname );
  cmn.AddSubscriber( "clk_activatejunk_end", clk_activatejunk_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_printventmap () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_printventmap" ] = {
    type = "click",
    use_place = "spr_controlpanel_button_vent",
    room = private.room_objname,
    zz = "zz_controlpanel",
    zz_gate = "gzz_cargosection_controlpanel"
  };
  --------------------------------------------------------------------------------------------
  local clk_printventmap_beg = function ()
  
    ObjSet("spr_controlpanel_button_vent",  { input = 0 });
  
  end;
  local clk_printventmap_end = function ()

    ObjMultiSet( { {"anm_controlpanel_print", { alp = 1, frame = 300 }},
                   {"spr_controlpanel_button_vent", { color_r = 0.5, color_g = 0.5, color_b = 0.5 }},
                   {"spr_cargosection_control_map", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_printventmap", clk_printventmap_beg, private.room_objname );
  cmn.AddSubscriber( "clk_printventmap", clk_printventmap_end, private.room_objname );
  cmn.AddSubscriber( "clk_printventmap_beg", clk_printventmap_beg, private.room_objname );
  cmn.AddSubscriber( "clk_printventmap_end", clk_printventmap_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function beg_level2 () end;
  --------------------------------------------------------------------------------------------
  local beg_level2 = function ()
  
    int_map_impl.OpenRoom( "rm_cargosection" );
    interface.InventoryItemAdd( "inv_lvl2badge1" );
    interface.InventoryItemAdd( "inv_shippart1" );
    interface.InventoryItemAdd( "inv_lvl2lense" );
    
    ObjSet("inv_bag_star_light",  { alp = 1 });
    
    interface_impl.SetCurrentGlobalTask( 7 );
    int_diary.SetVisibleHands( 3 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "beg_level2", beg_level2 );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_controlpanel" );
  subroom.Define( "zz_junk" );
  subroom.Define( "zz_cargo" );

  function zz_controlpanel.PreOpen()
    
    if cmn.IsEventDone("use_code") and not cmn.IsEventDone("win_controlpanel") then
      private.zz_controlpanel.DrawScene();
    end;
    
  end;
  
  function zz_controlpanel.Open()
    
    if cmn.IsEventDone("use_code") and not cmn.IsEventDone("win_controlpanel") then
      cmn.MiniGameShow();
      private.zz_controlpanel.CheckWin();
    end;
    
  end;
  
  function zz_controlpanel.PreClose()
    
    if cmn.IsEventDone("use_code") and not cmn.IsEventDone("win_controlpanel") then
      cmn.MiniGameHide("controlpanel");
    end;
    
  end;
  
  function zz_junk.PreOpen()
    
    if cmn.IsEventDone("use_cutterbase") and not cmn.IsEventDone("win_junk") then

      private.zz_junk.DrawScene();

      if private.zz_junk.CheckWin() then
        cmn.Lock( 1 );
        private.zz_junk.Win();
      end;

    end;
    
  end;
  
  function zz_controlpanel.Close()
    
    cmn.HideNote( 0 );
    
    if cmn.IsEventDone("clk_activatejunk") and not cmn.IsEventDone("opn_cargosectionjunk") then
      
      local func_after = function ()
        
        cmn.Lock( 0 );
        cmn.CallEventHandler( "clk_activatejunk_end" );
        
      end;
      
      cmn.SetEventDone("opn_cargosectionjunk");

      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_zz_controlpanel_door_opens");
      ObjAnimate("obj_cargosection_junk", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });

    end;
    
  end;

  function zz_cargo.Close()
    cmn.HideNote( 0 );
  end;

end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_controlpanel" ].state) then 
    private.zz_controlpanel.StartConditions();
  end;
  private.zz_controlpanel.state = ng_global.progress[ ng_global.currentprogress ][ "win_controlpanel" ].state;
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_junk" ].state) then 
    private.zz_junk.StartConditions();
  end;
  private.zz_junk.state = ng_global.progress[ ng_global.currentprogress ][ "win_junk" ].state;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_cargosection();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  if not ( cmn.IsEventDone( "beg_level2" ) ) then
    
    cmn.CallEventHandler("beg_level2");
    
    cmn.Lock(1);
    cmn.StopAllEnv();
    
    interface.WidgetSetVisible( "InterfaceWidget_Inventory", false, false );
    interface.WidgetSetInput( "InterfaceWidget_Inventory", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnHint", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnHint", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnGuide", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnGuide", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnMenu", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnMenu", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnMap", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnMap", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_ButtonDiary", false, false );
    interface.WidgetSetInput( "InterfaceWidget_ButtonDiary", 0 );

    ObjSet("rm_cargosection",  { color_r = 0, color_g = 0, color_b = 0 });
    
  else
    
    cmn.StopAllEnv("assets/levels/level2/audio/env/aud_rm_cargosection_env");
    cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_rm_cargosection_env");
    
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_plasmaticcutter()

  local item = "inv_plasmaticcutter";

  if cmn.ApplyObj( item, "gzz_cargosection_grate" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_grate" );

  elseif ( cmn.ApplyObj( item, "obj_grate_use_plasmaticcutter" ) ) then

    cmn.CallEventHandler( "use_plasmaticcutter_inv" );
    cmn.CallEventHandler( "use_plasmaticcutter_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_plasmaticcutter" );
      cmn.CallEventHandler( "use_plasmaticcutter_end" );
      
      if cmn.IsEventDone( "use_ventilationscheme" ) then
        cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_moment_ventilation_in");
        common.CloseSubRoom();
        cmn.GotoRoom("mg_ventilation");
      end;
    
    end;
    
    local anm_end = function ()
      ObjSet("spr_grate_overlap",  { alp = 1 });
      ObjAnimate("anm_grate_use_plasmaticcutter", "alp", 0, 0, func_after, { 0, 0, 1,   0.3, 0, 0 });
    end;
    
    if not cmn.IsEventDone("get_accesscard") then
      public.get_accesscard();
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_cut_cage");

    ObjMultiSet( { {"anm_grate_use_plasmaticcutter",  { alp = 1, playing = 1, endtrig = anm_end }},
                   {"spr_grate_overlap", { alp = 0 }} } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_ventilationscheme()

  local item = "inv_ventilationscheme";

  if cmn.ApplyObj( item, "gzz_cargosection_grate" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_grate" );

  elseif ( cmn.ApplyObj( item, "obj_grate_use_ventilationscheme" ) ) then

    cmn.CallEventHandler( "use_ventilationscheme_inv" );
    cmn.CallEventHandler( "use_ventilationscheme_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_ventilationscheme" );
      cmn.CallEventHandler( "use_ventilationscheme_end" );

      if cmn.IsEventDone( "use_plasmaticcutter" ) then
        cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_moment_ventilation_in");
        common.CloseSubRoom();
        cmn.GotoRoom("mg_ventilation");
      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_put_paper_cage");

    ObjAnimate("obj_grate_vent_map", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_accesscard()

  local item = "inv_accesscard";

  if cmn.ApplyObj( item, "gzz_cargosection_controlpanel" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_controlpanel", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_controlpanel_use_accesscard" ) ) then

    cmn.CallEventHandler( "use_accesscard_inv" );
    cmn.CallEventHandler( "use_accesscard_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_accesscard" );
      cmn.CallEventHandler( "use_accesscard_end" );
      
    end;
    
    local anm_act = function ()
      
      ObjAnimate("spr_controlpanel_button_vent", "color_r", 0, 0, func_after, { 0, 0, 0.5,   0.5, 0, 1 });
      ObjAnimate("spr_controlpanel_button_vent", "color_g", 0, 0, "", { 0, 0, 0.5,   0.5, 0, 1 });
      ObjAnimate("spr_controlpanel_button_vent", "color_b", 0, 0, "", { 0, 0, 0.5,   0.5, 0, 1 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_card_monitor_1");

    ObjSet("anm_controlpanel_use_card",  { alp = 1, playing = 1, endtrig = anm_act });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_code()

  local item = "inv_code";

  if cmn.ApplyObj( item, "gzz_cargosection_controlpanel" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_controlpanel", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_controlpanel_use_code" ) ) then

    cmn.CallEventHandler( "use_code_inv" );
    cmn.CallEventHandler( "use_code_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_code" );
      cmn.CallEventHandler( "use_code_end" );
      
      cmn.MiniGameShow();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_put_paper_monitor");

    ObjAnimate( "obj_controlpanel_code_hint", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_acid()

  local item = "inv_acid";

  if cmn.ApplyObj( item, "gzz_cargosection_cargo" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_cargo", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_cargo_use_acid" ) ) then

    cmn.CallEventHandler( "use_acid_inv" );
    cmn.CallEventHandler( "use_acid_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_acid" );
      cmn.CallEventHandler( "use_acid_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_spill_acid");

    ObjSet("anm_cargo_use_acid",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_tool()

  local item = "inv_tool";

  if cmn.ApplyObj( item, "gzz_cargosection_cargo" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_cargo", false, false, true );

  elseif cmn.ApplyObj( item, "gzz_corridor_robot" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_robot", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_cargo_use_tool" ) ) then

    cmn.CallEventHandler( "use_toolcargo_inv" );
    cmn.CallEventHandler( "use_toolcargo_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_toolcargo" );
      cmn.CallEventHandler( "use_toolcargo_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_parrot_use_open");

    ObjSet("anm_cargo_use_tool",  { alp = 1, playing = 1, endtrig = func_after });

  elseif ( cmn.ApplyObj( item, "obj_robot_use_tool" ) and cmn.IsEventDone("use_screwdriverrobot") ) then

    cmn.CallEventHandler( "use_toolrobot_inv" );
    cmn.CallEventHandler( "use_toolrobot_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_toolrobot" );
      cmn.CallEventHandler( "use_toolrobot_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_laser_green_crystal");

    ObjSet("anm_robot_crustal_open",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_runoutenergyelement()

  local item = "inv_runoutenergyelement";

  if cmn.ApplyObj( item, "gzz_cargosection_cargo" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_cargo", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_cargo_use_runoutenergyelement" ) and cmn.IsEventDone("use_toolcargo") ) then

    cmn.CallEventHandler( "use_runoutenergyelement_inv" );
    cmn.CallEventHandler( "use_runoutenergyelement_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_runoutenergyelement" );
      cmn.CallEventHandler( "use_runoutenergyelement_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_battery_box");

    ObjSet("anm_cargo_use_battery",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_cutterbase()

  local item = "inv_cutterbase";

  if cmn.ApplyObj( item, "gzz_cargosection_junk" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_junk" );

  elseif ( cmn.ApplyObj( item, "obj_junk_use_cutterbase" ) ) then

    cmn.CallEventHandler( "use_cutterbase_inv" );
    cmn.CallEventHandler( "use_cutterbase_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_cutterbase" );
      cmn.CallEventHandler( "use_cutterbase_end" );

      private.zz_junk.DrawScene();
    
    end;

    local func_anim = function ()
      ObjAnimate( "spr_junk_mho_interface", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );
    end;
    
    if not cmn.IsEventDone("get_squarekey") then
      public.get_squarekey();
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_laser_zz_junk");

    ObjSet( "anm_junk_plasmaticcutter", { endtrig = func_anim, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_wrench()

  local item = "inv_wrench";

  if cmn.ApplyObj( item, "gzz_cargosection_junk" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_junk" );

  elseif ( cmn.ApplyObj( item, "obj_junk_use_wrench" ) ) then

    cmn.CallEventHandler( "use_wrench_inv" );
    cmn.CallEventHandler( "use_wrench_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_wrench" );
      cmn.CallEventHandler( "use_wrench_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_unscrew_zzjunk");

    ObjSet( "anm_junk_door", { animfunc = "func_door_opn", endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_list()

  local item = "inv_list";

  if cmn.ApplyObj( item, "gzz_cargosection_junk" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_junk" );

  elseif ( cmn.ApplyObj( item, "obj_junk_use_list" ) ) then

    cmn.CallEventHandler( "use_list_inv" );
    cmn.CallEventHandler( "use_list_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_list" );
      cmn.CallEventHandler( "use_list_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_zz_junk_put_paper_2");

    ObjAnimate( "spr_junk_paper", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
    ObjAnimate( "spr_junk_spareparts_glow", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_cutterbase()

  cmn.SetEventDone( "get_cutterbase" );
  cmn.CallEventHandler( "get_cutterbase" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_accesscard()

  cmn.SetEventDone( "get_accesscard" );
  cmn.CallEventHandler( "get_accesscard" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_ventilationscheme()

  cmn.SetEventDone( "get_ventilationscheme" );
  cmn.CallEventHandler( "get_ventilationscheme" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_tabletpart2()

  cmn.SetEventDone( "get_tabletpart2" );
  cmn.CallEventHandler( "get_tabletpart2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_tablet()

  cmn.SetEventDone( "get_tablet" );
  cmn.CallEventHandler( "get_tablet" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_wrench()

  cmn.SetEventDone( "get_wrench" );
  cmn.CallEventHandler( "get_wrench" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_hacker()
  
  cmn.SetEventDone( "get_hacker" );
  cmn.CallEventHandler( "get_hacker" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_chargedenergyelement()
  
  ObjSet("anm_cargo_energy_light_2",  { alp = 1 });

  cmn.SetEventDone( "get_chargedenergyelement" );
  cmn.CallEventHandler( "get_chargedenergyelement" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_plasmaticcutter()

  cmn.SetEventDone( "get_plasmaticcutter" );
  cmn.CallEventHandler( "get_plasmaticcutter" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_tabletpart1()

  cmn.SetEventDone( "get_tabletpart1" );
  cmn.CallEventHandler( "get_tabletpart1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_spareparts()

  cmn.SetEventDone( "get_spareparts" );
  cmn.CallEventHandler( "get_spareparts" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_element1()

  cmn.SetEventDone( "get_element1" );
  cmn.CallEventHandler( "get_element1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_squarekey()

  cmn.SetEventDone( "get_squarekey" );
  cmn.CallEventHandler( "get_squarekey" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_pressbutton()

  cmn.CallEventHandler( "clk_pressbutton_beg" );

  local func_after = function ()
    
    cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_rm_cargosection_env");

    cmn.SetEventDone( "clk_pressbutton" );
    cmn.CallEventHandler( "clk_pressbutton_end" );
    
    cmn.ShowBbt( "cargosection_after_intro" );
  
  end;
  
  cmn.StopAllEnv();
  cmn.PlayFullscreenVideo( "assets/levels/level2/rm_cargosection/vid_lvl2intro", func_after, "assets/levels/level2/audio/mus/aud_intro2lvl_mus" );

end;
--------------------------------------------------------------------------------------------
function public.clk_activatejunk()

  cmn.CallEventHandler( "clk_activatejunk_beg" );

  local func_after = function ()
    
    --cmn.Lock( 0 );

    cmn.SetEventDone( "clk_activatejunk" );
    --cmn.CallEventHandler( "clk_activatejunk_end" );
    
    common.CloseSubRoom();
  
  end;
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_click_near_cooler_monitor");
  
  ObjAnimate("spr_controlpanel_button_tools", "color_r", 0, 0, func_after, { 0, 0, 1,   0.3, 0, 0.5 });
  ObjAnimate("spr_controlpanel_button_tools", "color_g", 0, 0, "", { 0, 0, 1,   0.3, 0, 0.5 });
  ObjAnimate("spr_controlpanel_button_tools", "color_b", 0, 0, "", { 0, 0, 1,   0.3, 0, 0.5 });

end;
--------------------------------------------------------------------------------------------
function public.clk_printventmap()
  
  if cmn.IsEventDone("use_accesscard") then

    cmn.CallEventHandler( "clk_printventmap_beg" );

    local func_after = function ()
      
      cmn.Lock( 0 );

      cmn.SetEventDone( "clk_printventmap" );
      cmn.CallEventHandler( "clk_printventmap_end" );
      
      public.get_ventilationscheme();
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_monitor_paper_appears");
    
    ObjAnimate("spr_controlpanel_button_vent", "color_r", 0, 0, "", { 0, 0, 1,   0.3, 0, 0.5 });
    ObjAnimate("spr_controlpanel_button_vent", "color_g", 0, 0, "", { 0, 0, 1,   0.3, 0, 0.5 });
    ObjAnimate("spr_controlpanel_button_vent", "color_b", 0, 0, "", { 0, 0, 1,   0.3, 0, 0.5 });
    
    ObjSet("anm_controlpanel_print",  { alp = 1, playing = 1, endtrig = func_after });
    
  else 
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_click_cooler_monitor");
  
    cmn.ShowBbt( "obj_controlpanel_use_accesscard" );
    
    ObjAnimate("spr_controlpanel_button_vent_wrong", "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 0,   0.3, 0, 1,    0.6, 0, 0,     0.9, 0, 1,    1.2, 0, 0 });
    
  end;

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_cargosection()

  if not ( cmn.IsEventDone( "beg_level2" ) ) then
    
    local func_after = function ()

      ObjSet("rm_cargosection",  { color_r = 1, color_g = 1, color_b = 1 });
    
      cmn.ShowBbt( "cargosection_open" );
      interface_impl.ShowGlobalTask();
      int_diary.AddDiarypage( 12 );
      
      cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_rm_cargosection_env");
      
      interface.WidgetSetVisible( "InterfaceWidget_Inventory", true, true );
      interface.WidgetSetInput( "InterfaceWidget_Inventory", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnHint", true, true );
      interface.WidgetSetInput( "InterfaceWidget_BtnHint", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnGuide", true, true );
      interface.WidgetSetInput( "InterfaceWidget_BtnGuide", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnMenu", true, true );
      interface.WidgetSetInput( "InterfaceWidget_BtnMenu", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnMap", true, true );
      interface.WidgetSetInput( "InterfaceWidget_BtnMap", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_ButtonDiary", true, true );
      interface.WidgetSetInput( "InterfaceWidget_ButtonDiary", 1 );
      
    end;
    
    cmn.Lock(0);
    
    cmn.SetEventDone( "beg_level2" );
    
    cmn.PlayFullscreenVideo( "assets/levels/level2/rm_cargosection/vid_lvl2transfer", func_after, "assets/levels/level2/audio/mus/aud_lvl2transfer_mus");
    
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_grate()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_cage_1");
  
  cmn.ShowBbt( "obj_grate_use_plasmaticcutter" );
  
  ObjSet("anm_grate_grid_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_panel()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_monitor_enter_code");
  
  cmn.ShowBbt( "obj_controlpanel_use_code" );
  
  ObjAnimate("txt_controlpanel_enter_code", "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 1,   0.3, 0, 0,    0.6, 0, 1,     0.9, 0, 0,    1.2, 0, 1 });
    
end;
--------------------------------------------------------------------------------------------
function public.touch_junk_door()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_zzjunk");
  
  cmn.ShowBbt( "obj_junk_use_wrench" );
  
  ObjSet( "anm_junk_door", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--*********************************************************************************************************************
-- function *** MHO_Junk *** () end;
--*********************************************************************************************************************
private.zz_junk = {};
public.zz_junk = {};

function private.Init_Junk()

  --------------------------------------------------------------------------------------------
  game.hint[ "win_junk" ] = {
    type = "click",
    use_place = "spr_junk_detail_1",
    room = "rm_cargosection",
    zz = "zz_junk",
    zz_gate = "gzz_cargosection_junk"
  };
  -----------------------------------------------------------------------------------
  local win_junk = function ()
    
    if cmn.IsEventDone("win_junk") then

      ObjDelete( "spr_junk_detail_1" );
      ObjDelete( "spr_junk_detail_5" );
      ObjDelete( "spr_junk_detail_6" );
      ObjDelete( "spr_junk_detail_1_shadow" );
      ObjDelete( "spr_junk_detail_5_shadow" );
      ObjDelete( "spr_junk_detail_6_shadow" );

      ObjDelete( "obj_junk_details_hub" );
      ObjDelete( "spr_junk_mho_interface" );

      ObjMultiSet( {
        { "obj_junk_plasmaticcutter", { input = true } },
        { "gfx_junk_plasmaticcutter", { active = true } },
        { "obj_junk_use_list", { input = true } },
        { "spr_cargosection_junk_after_ho", { alp = 1 } }
      } );
  
      for i = 1, 7, 1 do
        ObjSet( "spr_junk_plasmaticcutter"..i, { alp = 1 } );
      end;
  
    end;
  
  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_junk", win_junk, "rm_cargosection" );

end;
------------------------------------------------------------------------------
function private.zz_junk.StartConditions()

  ng_global.progress[ "std" ][ "win_junk" ].state = { false, false, false, false, false, false, false };

end;
-----------------------------------------------------------------------------------
function private.zz_junk.DrawScene()

  if private.zz_junk.draw_scene then
    return;
  end;
  private.zz_junk.draw_scene = true;

  --DbgTrace( "***DrawScene" );

  for i = 1, 7, 1 do
    if not private.zz_junk.state[i] then
      --DbgTrace( "hint = "..i );
      game.hint.win_junk.use_place = "spr_junk_detail_"..i;
      break;
    end;
  end;

  local not_find_det_sum = 0;

  for i = 1, 7, 1 do

    if not private.zz_junk.state[i] then

      --DbgTrace( i );

      not_find_det_sum = not_find_det_sum + 1;

      ObjSet( "spr_junk_detail_"..i, { input = true } );

    else

      ObjMultiSet( {
        { "spr_junk_detail_"..i, { input = false, alp = 0 } },
        { "spr_junk_detail_"..i.."_shadow", { alp = 0 } },
        { "spr_junk_plasmaticcutter"..i, { alp = 1 } },
        { "spr_junk_sil_"..i, { alp = 0 } },
        { "obj_junk_sil_"..i, { pos_x = 0 } }
      } );

    end;

    if not_find_det_sum == 5 then
      break;
    end;

  end;

end;
-----------------------------------------------------------------------------------
function public.zz_junk.FindDet( num )

  --DbgTrace( "***FindDet: num == "..num );
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_mmg1_click_1");

  private.zz_junk.state[num] = true;

  for i = 1, 7, 1 do
    if not private.zz_junk.state[i] then
      --DbgTrace( "hint = "..i );
      game.hint.win_junk.use_place = "spr_junk_detail_"..i;
      break;
    end;
  end;

  local func_after = "";
  if private.zz_junk.CheckWin() then
    cmn.Lock( 1 );
    func_after = private.zz_junk.Win;
  end;

  local det_name1 = "spr_junk_detail_"..num;
  local det_name2 = "spr_junk_plasmaticcutter"..num;
  local sil_name = "spr_junk_sil_"..num;
  local sil_obj_name = "obj_junk_sil_"..num;

  local start_pos = GetObjPosByObj( det_name1, "zz_junk" );
  local end_pos = GetObjPosByObj( det_name2, "zz_junk" );

  --DbgTrace( start_pos[1]..","..start_pos[2].." -> "..end_pos[1]..","..end_pos[2] );

  ObjSet( det_name1, { input = false } );

  ObjAttach( det_name1, "obj_junk_details_hub" );

  ObjAnimate( det_name1, "pos_xy", 0, 0, "", { 0, 0, start_pos[1], start_pos[2],    0.3, 0, end_pos[1], end_pos[2] } );

  ObjAnimate( det_name1,               "alp", 0, 0, func_after, { 0, 0, 1,    0.3, 0, 1,    0.6, 0, 0 } );
  ObjAnimate( det_name1.."_shadow",    "alp", 0, 0, "", { 0, 0, 1,    0.1, 0, 0 } );

  ObjAnimate( "spr_junk_plasmaticcutter"..num, "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );

  ObjAnimate( sil_name, "alp", 0, 0, "",       { 0, 0, 1,      0.15, 0, 0 } );
  ObjAnimate( sil_obj_name, "pos_x", 0, 0, "", { 0, 0, 100,    0.15, 0, 100,    0.45, 0, 0 } );

end;
-----------------------------------------------------------------------------------
function private.zz_junk.CheckWin()

  --DbgTrace( "***CheckWin" );

  local not_find_det_sum = 0;

  for i = 1, 7, 1 do

    if not private.zz_junk.state[i] then

      --DbgTrace( i );

      not_find_det_sum = not_find_det_sum + 1;

      if ( not_find_det_sum == 5 ) then
        --DbgTrace( "true" );
        ObjSet( "spr_junk_detail_"..i, { input = true } );
      end;

    end;

  end;

  if not_find_det_sum == 0 then
    --DbgTrace( "WWWWWWWIIIIIINNNNNNN" );
    return true;
  end;

end;
-----------------------------------------------------------------------------------
function private.zz_junk.Win()

  cmn.SetEventDone( "win_junk" );

  local func_after = function ()

    cmn.CallEventHandler( "win_junk" );
    cmn.Lock( 0 );

  end;

  ObjAnimate( "spr_junk_mho_interface", "alp", 0, 0, func_after, { 0, 0, 1,    0.5, 0, 1,    0.8, 0, 0 } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Controlpanel *** () end;
--*********************************************************************************************************************
--********************************************************************************************************************
private.zz_controlpanel = {};
public.zz_controlpanel = {};

function private.Init_Controlpanel()

  private.right_code = { 3, 1, 2, 7, 5 };
  --------------------------------------------------------------------------------------------
  game.hint[ "win_controlpanel" ] = {
    type = "click",
    use_place = "spr_controlpanel_button_3",
    room = "rm_cargosection",
    zz = "zz_controlpanel",
    zz_gate = "gzz_cargosection_controlpanel"
  };
  -----------------------------------------------------------------------------------
  local win_controlpanel = function ()
    
    if cmn.IsEventDone("win_controlpanel") then
  
      ObjDelete("obj_controlpanel_screen_1");
      ObjDelete("obj_controlpanel_buttons_press");
      ObjDelete("spr_cargosection_control_enter");
      
      ObjMultiSet( { {"obj_controlpanel_screen_2", { alp = 1, input = 1 }},
                     {"obj_controlpanel_use_accesscard", { input = 1 }},
                     {"spr_cargosection_control_files", { alp = 1 }} } );
                     
    end;
  
  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_controlpanel", win_controlpanel, "rm_cargosection" );

end;
--********************************************************************************************************************
function private.zz_controlpanel.StartConditions()

  ng_global.progress[ "std" ][ "win_controlpanel" ].skip = 0;
  ng_global.progress[ "std" ][ "win_controlpanel" ].state = { 1, { 0, 0, 0, 0, 0 } }; --current code

end;
-----------------------------------------------------------------------------------
function public.zz_controlpanel.Reset()
  
  if private.zz_controlpanel.state[1] > 1 then
    
    cmn.Lock( 1 );
    ng_global.progress[ "std" ][ "win_controlpanel" ].state = { 1, { 0, 0, 0, 0, 0 } };
    
    local func_after = function ()

      cmn.Lock(0);

      for i = 1, 5, 1 do
  
        ObjSet("txt_controlpanel_code_"..i,  { alp = 0, text = "" });
        
      end;

      ObjSet("obj_controlpanel_code",  { alp = 1 });

    end;

    --game.hint[ "win_controlpanel" ].use_place = "spr_controlpanel_button_3";
    private.zz_controlpanel.state = ng_global.progress[ "std" ][ "win_controlpanel" ].state;

    ObjAnimate("obj_controlpanel_code", "alp", 0, 0, func_after, { 0, 1, 1,   0.3, 1, 0 });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_controlpanel.Skip()
  
  cmn.Lock( 1 );
  
  ng_global.progress[ "std" ][ "win_controlpanel" ].skip = 1;
  ng_global.progress[ "std" ][ "win_controlpanel" ].state = { 6, { 3, 1, 2, 7, 5 } };
  
  for i = private.zz_controlpanel.state[1], 5, 1 do
  
    ObjSet("txt_controlpanel_code_"..i,  { text = private.right_code[i], alp = 0 });
    ObjAnimate("txt_controlpanel_code_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    
  end;
  
  private.zz_controlpanel.state = ng_global.progress[ "std" ][ "win_controlpanel" ].state;
  ObjSet("tmr_controlpanel_timer",  { time = 0.5, playing = 1, endtrig = private.zz_controlpanel.CheckWin });
  
end;
-----------------------------------------------------------------------------------
function private.zz_controlpanel.DrawScene()
  
  if private.zz_controlpanel.state[1] >= 6 then
  --  game.hint[ "win_controlpanel" ].use_place = "spr_controlpanel_button_"..private.right_code[ private.zz_controlpanel.state[1] ];
  --else 
    ObjSet("obj_controlpanel_buttons_press",  { input = 0 });
  end;

  for i = 1, private.zz_controlpanel.state[1]-1, 1 do
  
    ObjSet("txt_controlpanel_code_"..i,  { text = private.zz_controlpanel.state[2][i], alp = 1 });
    
  end;

  for i = private.zz_controlpanel.state[1], 5, 1 do
  
    ObjSet("txt_controlpanel_code_"..i,  { alp = 0 });
    
  end;

end;
------------------------------------------------------------------------------
function public.zz_controlpanel.FocusBut( butt, inout )
  
  local obj = "spr_controlpanel_button_"..butt.."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      --cmn.PlayAudio("snd", "assets/levels/level2/mg_onmagicstone/audio/aud_xx_menter_stone");
    end;
  end;

  --ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.zz_controlpanel.ClickBut( num )
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_click_monitor");
  --cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_click_numearl_"..math.random(1,3));

  local cur_num = private.zz_controlpanel.state[1];

  private.zz_controlpanel.state[2][cur_num] = num;
  private.zz_controlpanel.state[1] = private.zz_controlpanel.state[1] + 1;

  ObjSet("txt_controlpanel_code_"..cur_num,  { text = private.zz_controlpanel.state[2][cur_num] });

  if private.zz_controlpanel.state[2][cur_num] == private.right_code[cur_num] then
    --cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/"");
  else 
    --cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/");
  end;

  ObjAnimate("txt_controlpanel_code_"..cur_num, "alp", 0, 0, function () private.zz_controlpanel.CheckWin(cur_num) end, { 0, 0, 0,   0.3, 0, 1 });
      
  local obj = "spr_controlpanel_button_"..num;
  local alf = ObjGet(obj).alp;
  
  tme = ( 1 - alf ) * 0.15;
  
  ObjAnimate(obj, "alp", 0, 0, "", { 0, 0, alf,   tme, 0, 1,   tme+0.15, 0, 0 });

end;
-----------------------------------------------------------------------------------
function private.zz_controlpanel.CheckWin(pos)
  
  pos = pos or false;
  
  if not pos then
    pos = private.zz_controlpanel.state[1]-1;
  end;
  
  if private.zz_controlpanel.state[1] == 6 and private.zz_controlpanel.state[2][pos] == private.right_code[pos] then
    
    cmn.Lock(1);
    
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("controlpanel");
    
    private.zz_controlpanel.Win();
    
  elseif pos > 0 and  private.zz_controlpanel.state[2][pos] ~= private.right_code[pos] then
    
    cmn.Lock(1);

    local func_after = function ()

      cmn.Lock(0);

      for i = 1, 5, 1 do
  
        ObjSet("txt_controlpanel_code_"..i,  { alp = 0, text = "" });
        
      end;

      ObjSet("obj_controlpanel_code",  { alp = 1 });

    end;

    --game.hint[ "win_controlpanel" ].use_place = "spr_controlpanel_button_3";
    private.zz_controlpanel.state[1] = 1;

    for i = 1, 5, 1 do

      private.zz_controlpanel.state[2][i] = 0;
      
    end;

    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_click_wrong_number");
    ObjAnimate("obj_controlpanel_code", "alp", 0, 0, func_after, { 0, 1, 1,   0.2, 1, 0,  0.4, 1, 1,   0.6, 1, 0,  0.8, 1, 1,    1, 1, 0,   1.2, 1, 1,  1.5, 1, 0 });

  elseif pos then

    --game.hint[ "win_controlpanel" ].use_place = "spr_controlpanel_button_"..private.right_code[pos+1];
    cmn.Lock(0);

  end;

end;
-----------------------------------------------------------------------------------
function private.zz_controlpanel.Win()

  local func_after = function ()

    cmn.SetEventDone( "win_controlpanel" );
    cmn.CallEventHandler( "win_controlpanel" );
    
    cmn.Lock( 0 );
    common_impl.PauseAchiev(0);
    
    if ng_global.progress[ ng_global.currentprogress ][ "win_controlpanel" ].skip == 0 and ng_global.noskipgames[ "win_controlpanel" ] == nil then

      ng_global.noskipgames[ "win_controlpanel" ] = 1;
      common_impl.CheckAchiev("mg");

    end;

  end;

  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_win_comb_monitor");
  
  ObjAnimate("obj_controlpanel_screen_1", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 1,  1, 0, 0 });
  ObjAnimate("obj_controlpanel_screen_2", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 0,  1, 0, 1 });

end;
--*********************************************************************************************************************