-- name=rm_medicalsection
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_medicalsection";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.laser_event = "";
  --------------------------------------------------------------------------------------------
  -- function get_scalpel () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_scalpel" ] = {
    type = "get",
    get_obj = "spr_laser_scalpel",
    room = private.room_objname,
    zz = "zz_laser",
    zz_gate = "gzz_medicalsection_laser"
  };
  --------------------------------------------------------------------------------------------
  local get_scalpel_inv = function ()
  
    interface.InventoryItemAdd( "inv_scalpel", "spr_laser_scalpel" );
  
  end;
  local get_scalpel_end = function ()
  
    ObjDelete( "gfx_laser_scalpel" );
    ObjDelete( "spr_laser_scalpel_sh" );
    ObjDelete( "spr_medicalsection_laser_scalpel" );
    
  end;
  
  cmn.AddSubscriber( "get_scalpel", get_scalpel_inv );
  cmn.AddSubscriber( "get_scalpel", get_scalpel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tongs () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_tongs" ] = {
    type = "get",
    get_obj = "spr_lab_tongs",
    room = private.room_objname,
    zz = "zz_lab",
    zz_gate = "gzz_medicalsection_lab"
  };
  --------------------------------------------------------------------------------------------
  local get_tongs_inv = function ()
  
    interface.InventoryItemAdd( "inv_tongs", "spr_lab_tongs" );
  
  end;
  local get_tongs_end = function ()
  
    ObjDelete( "gfx_lab_tongs" );
    ObjDelete( "spr_lab_tongs_sh" );
    ObjDelete( "spr_medicalsection_lab_tongs" );
  
  end;
  
  cmn.AddSubscriber( "get_tongs", get_tongs_inv );
  cmn.AddSubscriber( "get_tongs", get_tongs_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_penicillin () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_penicillin" ] = {
    type = "get",
    get_obj = "spr_lab_penicillin",
    room = private.room_objname,
    zz = "zz_lab",
    zz_gate = "gzz_medicalsection_lab"
  };
  --------------------------------------------------------------------------------------------
  local get_penicillin_inv = function ()
  
    interface.InventoryItemAdd( "inv_penicillin", "spr_lab_penicillin" );
  
  end;
  local get_penicillin_end = function ()
  
    ObjDelete( "gfx_lab_penicillin" );
    ObjAttach("obj_lab_penicilin", "anm_lab_use_plant");
    ObjAttach("obj_lab_penicilin_2", "anm_lab_use_plant");
    ObjAttach("obj_lab_penicilin_sh", "anm_lab_use_plant");
    
    ObjDelete( "spr_medicalsection_lab_cup" );

    if cmn.IsEventDone( "get_bombpart2" ) then
      ObjSet("gzz_medicalsection_lab",  { active = 0, alp = 0 });
    end;
  
  end;
  
  cmn.AddSubscriber( "get_penicillin", get_penicillin_inv );
  cmn.AddSubscriber( "get_penicillin", get_penicillin_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bombpart2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_bombpart2" ] = {
    type = "get",
    get_obj = "spr_lab_bombpart2",
    room = private.room_objname,
    zz = "zz_lab",
    zz_gate = "gzz_medicalsection_lab"
  };
  --------------------------------------------------------------------------------------------
  local get_bombpart2_inv = function ()
  
    interface.InventoryItemAdd( "inv_bombpart", "spr_lab_bombpart2", function () cmn.GetMultyObject( 'bombpart', 3 ); end );
    int_map_impl.DecreaseRoomTasks("rm_medicalsection");
    
    if cmn.CheckMultiObject( "bombpart", 3 ) then
      ObjSet("inv_bomb_star_light",  { alp = 1 });
    end;
  
  end;
  local get_bombpart2_end = function ()
  
    ObjDelete( "gfx_lab_bombpart2" );
    ObjDelete( "spr_lab_bombpart2_sh" );
    ObjDelete( "spr_medicalsection_lab_bomb" );

    if cmn.IsEventDone( "get_penicillin" ) then
      ObjSet("gzz_medicalsection_lab",  { active = 0, alp = 0 });
    end;
  
  end;
  
  cmn.AddSubscriber( "get_bombpart2", get_bombpart2_inv );
  cmn.AddSubscriber( "get_bombpart2", get_bombpart2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_triangularkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_triangularkey" ] = {
    type = "get",
    get_obj = "spr_capsule_triangularkey",
    room = private.room_objname,
    zz = "zz_capsule",
    zz_gate = "gzz_medicalsection_capsule"
  };
  --------------------------------------------------------------------------------------------
  local get_triangularkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_triangularkey", "spr_capsule_triangularkey" );
  
  end;
  local get_triangularkey_end = function ()
  
    ObjDelete( "gfx_capsule_triangularkey" );
    ObjDelete( "spr_capsule_triangularkey_sh" );
    ObjDelete( "spr_medicalsection_capsule_key" );
  
  end;
  
  cmn.AddSubscriber( "get_triangularkey", get_triangularkey_inv );
  cmn.AddSubscriber( "get_triangularkey", get_triangularkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gas () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_gas" ] = {
    type = "get",
    get_obj = "spr_plant_gas",
    room = private.room_objname,
    zz = "zz_plant",
    zz_gate = "gzz_medicalsection_plant"
  };
  --------------------------------------------------------------------------------------------
  local get_gas_inv = function ()
  
    interface.InventoryItemAdd( "inv_gas", "spr_plant_gas" );
  
  end;
  local get_gas_end = function ()
  
    ObjDelete( "gfx_plant_gas" );
    ObjDelete( "spr_plant_gas_sh" );
    ObjDelete( "spr_medicalsection_plant_gas" );

    ObjSet("gzz_medicalsection_plant",  { active = 0, alp = 0 });
  
  end;
  
  cmn.AddSubscriber( "get_gas", get_gas_inv );
  cmn.AddSubscriber( "get_gas", get_gas_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_plantpart () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_plantpart" ] = {
    type = "get",
    get_obj = "spr_plant_plantpart",
    room = private.room_objname,
    zz = "zz_plant",
    zz_gate = "gzz_medicalsection_plant"
  };
  --------------------------------------------------------------------------------------------
  local get_plantpart_inv = function ()
  
    interface.InventoryItemAdd( "inv_plantpart", "spr_plant_plantpart" );
  
  end;
  local get_plantpart_end = function ()
  
    ObjDelete( "gfx_plant_plantpart" );
    ObjDelete( "anm_plant_use_scalpel" );
    ObjDelete( "spr_medicalsection_plant_part_1" );
  
  end;
  
  cmn.AddSubscriber( "get_plantpart", get_plantpart_inv );
  cmn.AddSubscriber( "get_plantpart", get_plantpart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_doctorsnamebadge () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_doctorsnamebadge" ] = {
    type = "get",
    get_obj = "spr_plant_doctorsnamebadge",
    room = private.room_objname,
    zz = "zz_plant",
    zz_gate = "gzz_medicalsection_plant"
  };
  --------------------------------------------------------------------------------------------
  local get_doctorsnamebadge_inv = function ()
  
    interface.InventoryItemAdd( "inv_doctorsnamebadge", "spr_plant_doctorsnamebadge" );
  
  end;
  local get_doctorsnamebadge_end = function ()
  
    ObjDelete( "gfx_plant_doctorsnamebadge" );
    ObjDelete( "anm_plant_use_tongs" );
    ObjDelete( "spr_medicalsection_plant_badge" );
  
  end;
  
  cmn.AddSubscriber( "get_doctorsnamebadge", get_doctorsnamebadge_inv );
  cmn.AddSubscriber( "get_doctorsnamebadge", get_doctorsnamebadge_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_gun () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_gun" ] = {
      type = "get",
      get_obj = "spr_medicalsection_gun",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_gun_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_gun", "spr_medicalsection_gun" );
  
  end;
  local get_gun_mid = function ()
  
    ObjDelete( "gfx_medicalsection_gun" );
    ObjDelete( "spr_medicalsection_gun_sh" );
    
  end;
  local get_gun_end = function ()
  
    ObjDelete( "obj_medicalsection_dialog_jean2" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_gun", get_gun_inv );
  cmn.AddSubscriber( "get_gun_inv", get_gun_inv, private.room_objname );
  cmn.AddSubscriber( "get_gun", get_gun_mid, private.room_objname );
  cmn.AddSubscriber( "get_gun_mid", get_gun_mid, private.room_objname );
  cmn.AddSubscriber( "get_gun", get_gun_end, private.room_objname );
  cmn.AddSubscriber( "get_gun_end", get_gun_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_triangularkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_triangularkey" ] = {
    type = "use",
    inv_obj = "inv_triangularkey",
    use_place = "obj_laser_use_triangularkey",
    room = private.room_objname,
    zz = "zz_laser",
    zz_gate = "gzz_medicalsection_laser"
  };
  --------------------------------------------------------------------------------------------
  local use_triangularkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_triangularkey" );
  
  end;
  local use_triangularkey_beg = function ()
  
    ObjDelete( "obj_laser_use_triangularkey" );
  
  end;
  local use_triangularkey_end = function ()
  
    ObjMultiSet( { {"anm_laser_front",  { frame = 300, animfunc = "func_use_key" }},
                   {"obj_laser_inside", { alp = 1, input = 1 }},
                   {"spr_medicalsection_laser_open", { alp = 1 }} } );
  
  end;
  local use_triangularkey_loc = function ()

    ObjMultiSet( {
      { "spr_corridor_medicalsection_opened_door", { alp = 1 } },
      { "spr_corridor_medicalsection_old_gas", { alp = 1 } }
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_triangularkey", use_triangularkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_triangularkey", use_triangularkey_inv );
  cmn.AddSubscriber( "use_triangularkey", use_triangularkey_end, private.room_objname );
  cmn.AddSubscriber( "use_triangularkey", use_triangularkey_loc, "rm_corridor" );
  cmn.AddSubscriber( "use_triangularkey_inv", use_triangularkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_triangularkey_beg", use_triangularkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_triangularkey_end", use_triangularkey_end, private.room_objname );
  cmn.AddSubscriber( "use_triangularkey_loc", use_triangularkey_loc, "rm_corridor" );
  --------------------------------------------------------------------------------------------
  -- function use_gas () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_gas" ] = {
    type = "use",
    inv_obj = "inv_gas",
    use_place = "obj_laser_use_gas",
    room = private.room_objname,
    zz = "zz_laser",
    zz_gate = "gzz_medicalsection_laser"
  };
  --------------------------------------------------------------------------------------------
  local use_gas_inv = function ()
  
    interface.InventoryItemRemove( "inv_gas" );
    int_map_impl.DecreaseRoomTasks("rm_medicalsection");
  
  end;
  local use_gas_beg = function ()
  
    ObjDelete( "obj_laser_use_gas" );
    
    if cmn.IsEventDone( "use_lvl2lense" ) then
      ObjDelete( "gzz_medicalsection_laser" );
    end;
  
  end;
  local use_gas_end = function ()
    
    ObjDelete( "spr_medicalsection_laser_gas_1" );
    ObjSet("spr_medicalsection_laser_gas_2",  { alp = 1 });
  
    if cmn.IsEventDone( "use_lvl2lense" ) then
      ObjDelete( "vid_medicalsection_laser_active" );
      ObjMultiSet( {
        { "grm_medicalsection_maindeck", { input = true, alp = 1 } },
        { "spr_medicalsection_hole", { alp = 1 } }
      } );
    else 
      ObjSet("anm_laser_gas",  { frame = 300, animfunc = "func_use_gas" });
    end;
  
  end;
  local use_gas_loc = function ()

    ObjDelete( "spr_corridor_medicalsection_old_gas" );

    ObjSet( "spr_corridor_medicalsection_gas", { alp = 1 } );

    if cmn.IsEventDone( "use_lvl2lense" ) then
      ObjSet( "spr_corridor_medicalsection_hole", { alp = 1 } );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gas", use_gas_beg, private.room_objname );
  cmn.AddSubscriber( "use_gas", use_gas_inv );
  cmn.AddSubscriber( "use_gas", use_gas_end, private.room_objname );
  cmn.AddSubscriber( "use_gas", use_gas_loc, "rm_corridor" );
  cmn.AddSubscriber( "use_gas_inv", use_gas_inv, private.room_objname );
  cmn.AddSubscriber( "use_gas_beg", use_gas_beg, private.room_objname );
  cmn.AddSubscriber( "use_gas_end", use_gas_end, private.room_objname );
  cmn.AddSubscriber( "use_gas_loc", use_gas_loc, "rm_corridor" );
  --------------------------------------------------------------------------------------------
  -- function use_lvl2lense () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl2lense" ] = {
    type = "use",
    inv_obj = "inv_lvl2lense",
    use_place = "obj_laser_use_lvl2lense",
    room = private.room_objname,
    zz = "zz_laser",
    zz_gate = "gzz_medicalsection_laser"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl2lense_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl2lense" );
    int_map_impl.DecreaseRoomTasks("rm_medicalsection");
  
  end;
  local use_lvl2lense_beg = function ()
  
    ObjDelete( "obj_laser_use_lvl2lense" );
    
    if cmn.IsEventDone( "use_gas" ) then
      ObjDelete( "gzz_medicalsection_laser" );
    end;
  
  end;
  local use_lvl2lense_end = function ()
    
    ObjDelete( "spr_medicalsection_laser_lense_1" );
    ObjSet("spr_medicalsection_laser_lense_2",  { alp = 1 });
  
    if cmn.IsEventDone( "use_gas" ) then
      ObjDelete( "vid_medicalsection_laser_active" );
      ObjMultiSet( {
        { "grm_medicalsection_maindeck", { input = true, alp = 1 } },
        { "spr_medicalsection_hole", { alp = 1 } }
      } );
    else 
      ObjSet("anm_laser_lense",  { frame = 300, animfunc = "func_use_glass" });
    end;
  
  end;
  local use_lvl2lense_loc = function ()

    if cmn.IsEventDone( "use_gas" ) then
      ObjSet( "spr_corridor_medicalsection_hole", { alp = 1 } );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl2lense", use_lvl2lense_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl2lense", use_lvl2lense_inv );
  cmn.AddSubscriber( "use_lvl2lense", use_lvl2lense_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl2lense", use_lvl2lense_loc, "rm_corridor" );
  cmn.AddSubscriber( "use_lvl2lense_inv", use_lvl2lense_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl2lense_beg", use_lvl2lense_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl2lense_end", use_lvl2lense_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl2lense_loc", use_lvl2lense_loc, "rm_corridor" );
  --------------------------------------------------------------------------------------------
  -- function use_plantpart () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_plantpart" ] = {
    type = "use",
    inv_obj = "inv_plantpart",
    use_place = "obj_lab_use_plantpart",
    room = private.room_objname,
    zz = "zz_lab",
    zz_gate = "gzz_medicalsection_lab"
  };
  --------------------------------------------------------------------------------------------
  local use_plantpart_inv = function ()
  
    interface.InventoryItemRemove( "inv_plantpart" );
  
  end;
  local use_plantpart_beg = function ()
  
    ObjDelete( "obj_lab_use_plantpart" );
    ObjDelete( "anm_lab_touch" );
  
  end;
  local use_plantpart_end = function ()
  
    ObjMultiSet( { {"anm_lab_use_plant", { alp = 1, frame = 300 }},
                   {"spr_lab_penicillin", { input = 1 }},
                   {"gfx_lab_penicillin", { active = 1, visible = 1 }},
                   {"spr_medicalsection_lab_cure", { alp = 1 }},
                   {"spr_medicalsection_lab_plant", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_plantpart", use_plantpart_beg, private.room_objname );
  cmn.AddSubscriber( "use_plantpart", use_plantpart_inv );
  cmn.AddSubscriber( "use_plantpart", use_plantpart_end, private.room_objname );
  cmn.AddSubscriber( "use_plantpart_inv", use_plantpart_inv, private.room_objname );
  cmn.AddSubscriber( "use_plantpart_beg", use_plantpart_beg, private.room_objname );
  cmn.AddSubscriber( "use_plantpart_end", use_plantpart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_penicillin () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_penicillin" ] = {
    type = "use",
    inv_obj = "inv_penicillin",
    use_place = "obj_capsule_use_penicillin",
    room = private.room_objname,
    zz = "zz_capsule",
    zz_gate = "gzz_medicalsection_capsule"
  };
  --------------------------------------------------------------------------------------------
  local use_penicillin_inv = function ()
  
    interface.InventoryItemRemove( "inv_penicillin" );

  end;
  local use_penicillin_beg = function ()
  
    ObjDelete( "obj_capsule_use_penicillin" );
    ObjDelete( "anm_capsule_hose_touch" );
    ObjDelete( "spr_capsule_hose_bl_1" );
    ObjDelete( "gzz_medicalsection_capsule" );
    
    ObjSet("spr_medicalsection_capsule_glass_2",  { alp = 1 });
  
  end;
  local use_penicillin_end = function ()
    
    ObjDelete( "anm_medicalsection_jean_1" );
  
    ObjMultiSet( { {"gmg_medicalsection_incapsule",  { active = 1, input = 1, alp = 1 }},
                   {"spr_medicalsection_capsule_mg", { alp = 1 }},
                   {"anm_medicalsection_jean_tocapsule", { alp = 1, frame = 400 }},
                   {"obj_medicalsection_capsule", { alp = 0 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_penicillin", use_penicillin_beg, private.room_objname );
  cmn.AddSubscriber( "use_penicillin", use_penicillin_inv );
  cmn.AddSubscriber( "use_penicillin", use_penicillin_end, private.room_objname );
  cmn.AddSubscriber( "use_penicillin_inv", use_penicillin_inv, private.room_objname );
  cmn.AddSubscriber( "use_penicillin_beg", use_penicillin_beg, private.room_objname );
  cmn.AddSubscriber( "use_penicillin_end", use_penicillin_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_doctorsnamebadge () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_doctorsnamebadge" ] = {
    type = "use",
    inv_obj = "inv_doctorsnamebadge",
    use_place = "obj_capsule_use_doctorsnamebadge",
    room = private.room_objname,
    zz = "zz_capsule",
    zz_gate = "gzz_medicalsection_capsule"
  };
  --------------------------------------------------------------------------------------------
  local use_doctorsnamebadge_inv = function ()
  
    interface.InventoryItemRemove( "inv_doctorsnamebadge" );
  
  end;
  local use_doctorsnamebadge_beg = function ()
  
    ObjDelete( "obj_capsule_use_doctorsnamebadge" );
    ObjDelete( "anm_capsule_door_touch" );
    ObjSet("obj_capsule_open",  { alp = 1 });
  
  end;
  local use_doctorsnamebadge_end = function ()
    
    ObjDelete( "spr_medicalsection_capsule_closed" );
  
    ObjMultiSet( { {"anm_capsule_use_card", { alp = 1, frame = 400 }},
                   {"obj_capsule_open", { input = 1 }},
                   {"spr_medicalsection_capsule_badge", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_doctorsnamebadge", use_doctorsnamebadge_beg, private.room_objname );
  cmn.AddSubscriber( "use_doctorsnamebadge", use_doctorsnamebadge_inv );
  cmn.AddSubscriber( "use_doctorsnamebadge", use_doctorsnamebadge_end, private.room_objname );
  cmn.AddSubscriber( "use_doctorsnamebadge_inv", use_doctorsnamebadge_inv, private.room_objname );
  cmn.AddSubscriber( "use_doctorsnamebadge_beg", use_doctorsnamebadge_beg, private.room_objname );
  cmn.AddSubscriber( "use_doctorsnamebadge_end", use_doctorsnamebadge_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_scalpel () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_scalpel" ] = {
    type = "use",
    inv_obj = "inv_scalpel",
    use_place = "obj_plant_use_scalpel",
    room = private.room_objname,
    zz = "zz_plant",
    zz_gate = "gzz_medicalsection_plant"
  };
  --------------------------------------------------------------------------------------------
  local use_scalpel_inv = function ()
  
    interface.InventoryItemRemove( "inv_scalpel" );
  
  end;
  local use_scalpel_beg = function ()
  
    ObjDelete( "obj_plant_use_scalpel" );
    ObjDelete( "anm_plant_part_touch" );
  
  end;
  local use_scalpel_end = function ()
  
    --ObjSet( "spr_plant_plantpart", { input = 1, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scalpel", use_scalpel_beg, private.room_objname );
  cmn.AddSubscriber( "use_scalpel", use_scalpel_inv );
  cmn.AddSubscriber( "use_scalpel", use_scalpel_end, private.room_objname );
  cmn.AddSubscriber( "use_scalpel_inv", use_scalpel_inv, private.room_objname );
  cmn.AddSubscriber( "use_scalpel_beg", use_scalpel_beg, private.room_objname );
  cmn.AddSubscriber( "use_scalpel_end", use_scalpel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tongs () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_tongs" ] = {
    type = "use",
    inv_obj = "inv_tongs",
    use_place = "obj_plant_use_tongs",
    room = private.room_objname,
    zz = "zz_plant",
    zz_gate = "gzz_medicalsection_plant"
  };
  --------------------------------------------------------------------------------------------
  local use_tongs_inv = function ()
  
    interface.InventoryItemRemove( "inv_tongs" );
  
  end;
  local use_tongs_beg = function ()
  
    ObjDelete( "obj_plant_use_tongs" );
    ObjDelete( "anm_plant_badge_touch" );
  
  end;
  local use_tongs_end = function ()
  
    --ObjSet( "spr_plant_doctorsnamebadge", { input = 1, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tongs", use_tongs_beg, private.room_objname );
  cmn.AddSubscriber( "use_tongs", use_tongs_inv );
  cmn.AddSubscriber( "use_tongs", use_tongs_end, private.room_objname );
  cmn.AddSubscriber( "use_tongs_inv", use_tongs_inv, private.room_objname );
  cmn.AddSubscriber( "use_tongs_beg", use_tongs_beg, private.room_objname );
  cmn.AddSubscriber( "use_tongs_end", use_tongs_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_blaster () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_blaster" ] = {
    type = "use",
    inv_obj = "inv_blaster",
    use_place = "obj_plant_use_blaster",
    room = private.room_objname,
    zz = "zz_plant",
    zz_gate = "gzz_medicalsection_plant"
  };
  --------------------------------------------------------------------------------------------
  local use_blaster_inv = function ()
  
    interface.InventoryItemRemove( "inv_blaster" );
  
  end;
  local use_blaster_beg = function ()
  
    ObjDelete( "obj_plant_use_blaster" );
    ObjDelete( "anm_plant_gas_touch" );
    ObjDelete( "anm_plant_plant" );
    ObjDelete( "anm_plant_plant_2" );
  
  end;
  local use_blaster_end = function ()
    
    ObjDelete( "anm_medicalsection_plant" );
  
    ObjMultiSet( { {"spr_plant_gas", { input = 1 }},
                   {"anm_plant_use_gun", { alp = 1, frame = 300 }},
                   {"anm_medicalsection_plant_2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_blaster", use_blaster_beg, private.room_objname );
  cmn.AddSubscriber( "use_blaster", use_blaster_inv );
  cmn.AddSubscriber( "use_blaster", use_blaster_end, private.room_objname );
  cmn.AddSubscriber( "use_blaster_inv", use_blaster_inv, private.room_objname );
  cmn.AddSubscriber( "use_blaster_beg", use_blaster_beg, private.room_objname );
  cmn.AddSubscriber( "use_blaster_end", use_blaster_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_takeoldglassout () end;
  --------------------------------------------------------------------------------------------
  local clk_takeoldglassout = function ()
    
    ObjDelete("anm_capsule_glass_out");
    ObjDelete("obj_capsule_clk_takeoldglassout");
    ObjDelete("spr_medicalsection_capsule_glass_1");
  
    ObjMultiSet( { {"anm_capsule_hose_touch",  { alp = 1 }},
                   {"obj_capsule_use_penicillin",  { input = 1 }},
                   {"spr_capsule_hose_bl_1",  { alp = 1 }} } );
  
  end;
  cmn.AddSubscriber( "clk_takeoldglassout", clk_takeoldglassout, "rm_medicalsection" );

  --------------------------------------------------------------------------------------------
  -- function opn_medicalsection () end;
  --------------------------------------------------------------------------------------------
  local opn_medicalsection = function ()
  
    int_map_impl.OpenRoom( "rm_medicalsection" );
    ObjDelete("anm_corridor_jean");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_medicalsection", opn_medicalsection );
  --------------------------------------------------------------------------------------------
  -- function opn_medicalsectiondlg () end;
  --------------------------------------------------------------------------------------------
  local opn_medicalsectiondlg = function ()
    
    ObjDelete("vid_medicalsection_dialog_jean2_lipsync1");
    ObjDelete("vid_medicalsection_dialog_jean2_lipsync2");
    
    ObjDelete("anm_medicalsection_dialog_jean2_hand_1");
    ObjDelete("anm_medicalsection_dialog_jean2_give");
  
    ObjAttach("obj_medicalsection_dialog_jean2", "rm_medicalsection");
  
    ObjMultiSet( { {"obj_medicalsection_dialog_jean2", { alp = 1, input = 1 }},
                   {"obj_medicalsection_dialog_jean2_hand_2", { alp = 1, input = 1 }},
                   {"anm_medicalsection_dialog_jean2_head", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_medicalsectiondlg", opn_medicalsectiondlg, private.room_objname );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_laser" );
  subroom.Define( "zz_lab" );
  subroom.Define( "zz_plant" );
  subroom.Define( "zz_capsule" );
  
  function zz_laser.PreClose()
    
    if cmn.IsEventDone("use_gas") and cmn.IsEventDone("use_lvl2lense") then
      ObjAttach("vid_medicalsection_laser_active", "rm_medicalsection");
      ObjMultiSet( { {"spr_medicalsection_laser", { alp = 0 }},
                     {"obj_medicalsection_laser", { alp = 0 }} } );
    end;
    
  end;
  
  function zz_laser.Close()
    
    cmn.HideNote( 0 );
    
    if cmn.IsEventDone("use_gas") and cmn.IsEventDone("use_lvl2lense") then
      
      local func_after = function ()
        
        cmn.CallEventHandler(private.laser_event);
        cmn.Lock( 0 );

        if private.laser_event == "use_gas_end" then
          cmn.CallEventHandler( "use_gas_loc" );
        else
          cmn.CallEventHandler( "use_lvl2lense_loc" );
        end;
        
      end;
      
      local anm_vid = function ()
        
        ObjAnimate("vid_medicalsection_laser_active", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
        
        ObjMultiSet( { {"spr_medicalsection_laser", { alp = 1 }},
                       {"spr_medicalsection_hole", { alp = 1 }},
                       {"obj_medicalsection_laser", { alp = 1 }} } );
        
      end;
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_laser_wall_crash");               
      VidPlay("vid_medicalsection_laser_active", anm_vid);
      
    end;
    
  end;
  
  function zz_lab.Close()
    cmn.HideNote( 0 );
  end;
  
  function zz_plant.PreOpen()
    if not cmn.IsEventDone("use_blaster") then
      cmn.StopAllEnv("assets/levels/level2/audio/env/aud_loop_zz_plant_monster");
      cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_loop_zz_plant_monster");
      cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_rm_medicalsection_env");
    end;
  end;
  
  function zz_plant.PreClose()
    if not cmn.IsEventDone("use_blaster") then
      cmn.StopAllEnv("assets/levels/level2/audio/env/aud_loop_loc_monster");
      cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_loop_loc_monster");
      cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_rm_medicalsection_env");
    end;
  end;
  
  function zz_plant.Close()
    cmn.HideNote( 0 );
  end;
  
  function zz_capsule.Close()
    
    if cmn.IsEventDone("use_penicillin") then
      
      local func_after = function ()
        
        cmn.Lock( 0 );
        cmn.CallEventHandler( "use_penicillin_end" );
        cmn.GotoRoom("mg_incapsule");
        
      end;
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_jean_goes_capsule");
      ObjSet("anm_medicalsection_jean_tocapsule", { alp = 1, playing = 1, endtrig = func_after });
                     
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_medicalsection();
  
  if cmn.IsEventDone("opn_medicalsectiondlg") and not cmn.IsEventDone("get_gun") then
    --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    common_impl.current_dialog = "obj_medicalsection_dialog_jean2";
    ObjSet("anm_medicalsection_dialog_jean2_end",  { playing = 1 });
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level2/audio/env/aud_rm_medicalsection_env");
  cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_rm_medicalsection_env");
  
  if not cmn.IsEventDone("use_blaster") then
    cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_loop_loc_monster");
  end;

end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_triangularkey()

  local item = "inv_triangularkey";

  if cmn.ApplyObj( item, "gzz_medicalsection_laser" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_laser", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_laser_use_triangularkey" ) ) then

    cmn.CallEventHandler( "use_triangularkey_inv" );
    cmn.CallEventHandler( "use_triangularkey_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_triangularkey" );
      cmn.CallEventHandler( "use_triangularkey_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_open_yellow_door");

    ObjMultiSet( { {"anm_laser_front",  { frame = 0, animfunc = "func_use_key", playing = 1, endtrig = func_after }},
                   {"obj_laser_inside", { alp = 1 }} } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_gas()

  local item = "inv_gas";

  if cmn.ApplyObj( item, "gzz_medicalsection_laser" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_laser", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_laser_use_gas" ) and cmn.IsEventDone("use_triangularkey") ) then

    cmn.CallEventHandler( "use_gas_inv" );
    cmn.CallEventHandler( "use_gas_beg" );

    local func_after = function ()

      cmn.SetEventDone( "use_gas" );
      
      if cmn.IsEventDone( "use_lvl2lense" ) then
        private.laser_event = "use_gas_end";
        common.CloseSubRoom();
      else 
        cmn.Lock( 0 );
        cmn.CallEventHandler( "use_gas_end" );
        cmn.CallEventHandler( "use_gas_loc" );
      end;

    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_change_balloon");

    ObjSet("anm_laser_gas",  { frame = 0, animfunc = "func_use_gas", playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl2lense()

  local item = "inv_lvl2lense";

  if cmn.ApplyObj( item, "gzz_medicalsection_laser" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_laser", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_laser_use_lvl2lense" ) and cmn.IsEventDone("use_triangularkey") ) then

    cmn.CallEventHandler( "use_lvl2lense_inv" );
    cmn.CallEventHandler( "use_lvl2lense_beg" );

    local func_after = function ()

      cmn.SetEventDone( "use_lvl2lense" );
      
      if cmn.IsEventDone( "use_gas" ) then
        private.laser_event = "use_lvl2lense_end";
        common.CloseSubRoom();
      else 
        cmn.Lock( 0 );
        cmn.CallEventHandler( "use_lvl2lense_end" );
        cmn.CallEventHandler( "use_lvl2lense_loc" );
      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_replace_broken_glass");

    ObjSet("anm_laser_lense",  { frame = 0, animfunc = "func_use_glass", playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_plantpart()

  local item = "inv_plantpart";

  if cmn.ApplyObj( item, "gzz_medicalsection_lab" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_lab", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_lab_use_plantpart" ) ) then

    cmn.CallEventHandler( "use_plantpart_inv" );
    cmn.CallEventHandler( "use_plantpart_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_plantpart" );
      cmn.CallEventHandler( "use_plantpart_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_zz_lab_colb_insert");

    ObjSet("anm_lab_use_plant",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_penicillin()

  local item = "inv_penicillin";

  if cmn.ApplyObj( item, "gzz_medicalsection_capsule" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_capsule" );

  elseif ( cmn.ApplyObj( item, "obj_capsule_use_penicillin" ) and cmn.IsEventDone("use_doctorsnamebadge") ) then

    cmn.CallEventHandler( "use_penicillin_inv" );
    
    if cmn.IsEventDone("clk_takeoldglassout") then
      private.use_penicillin_end();
    else 
      public.clk_takeoldglassout(2);
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function private.use_penicillin_end()

  cmn.CallEventHandler( "use_penicillin_beg" );

  local func_after = function ()

    --cmn.Lock( 0 );

    cmn.SetEventDone( "use_penicillin" );
    --cmn.CallEventHandler( "use_penicillin_end" );

    ObjMultiSet( { {"anm_medicalsection_jean_tocapsule", { alp = 1 }},
                   {"anm_medicalsection_jean_1", { alp = 0 }},
                   {"obj_medicalsection_capsule", { alp = 0 }},
                   {"spr_medicalsection_capsule_mg", { alp = 1 }} } );
    
    common.CloseSubRoom();
    
  end;
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_green_colb_insert");

  ObjSet("anm_capsule_use_penicilin",  { alp = 1, playing = 1, endtrig = func_after });

end;
--------------------------------------------------------------------------------------------
function public.use_doctorsnamebadge()

  local item = "inv_doctorsnamebadge";

  if cmn.ApplyObj( item, "gzz_medicalsection_capsule" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_capsule" );

  elseif ( cmn.ApplyObj( item, "obj_capsule_use_doctorsnamebadge" ) ) then

    cmn.CallEventHandler( "use_doctorsnamebadge_inv" );
    cmn.CallEventHandler( "use_doctorsnamebadge_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_doctorsnamebadge" );
      cmn.CallEventHandler( "use_doctorsnamebadge_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_zz_capsule_insert_box");
    
    ObjSet("anm_capsule_use_card",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_scalpel()

  local item = "inv_scalpel";

  if cmn.ApplyObj( item, "gzz_medicalsection_plant" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_plant", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_plant_use_scalpel" ) ) then

    cmn.CallEventHandler( "use_scalpel_inv" );
    cmn.CallEventHandler( "use_scalpel_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_scalpel" );
      cmn.CallEventHandler( "use_scalpel_end" );
      
      public.get_plantpart();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_cut_plant_knife");

    ObjSet("anm_plant_use_scalpel",  { alp = 1, playing = 1, endtrig = func_after });
    
  elseif ( cmn.ApplyObj( item, "obj_robot_use_tool" ) ) then
    
    cmn.Lock( 1 );
    cmn.ShowBbt( "robot_use_scalpel" );
    ObjAnimate("obj_robot_use_tool", "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 1,   0.3, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_tongs()

  local item = "inv_tongs";

  if cmn.ApplyObj( item, "gzz_medicalsection_plant" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_plant", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_plant_use_tongs" ) ) then

    cmn.CallEventHandler( "use_tongs_inv" );
    cmn.CallEventHandler( "use_tongs_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_tongs" );
      cmn.CallEventHandler( "use_tongs_end" );
      
      public.get_doctorsnamebadge();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_take_stuff_plant");

    ObjSet("anm_plant_use_tongs",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_blaster()

  local item = "inv_blaster";

  if cmn.ApplyObj( item, "gzz_medicalsection_plant" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_plant", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_plant_use_blaster" ) ) then

    cmn.CallEventHandler( "use_blaster_inv" );
    cmn.CallEventHandler( "use_blaster_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_blaster" );
      cmn.CallEventHandler( "use_blaster_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.StopAllEnv("assets/levels/level2/audio/env/aud_rm_medicalsection_env");
    cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_rm_medicalsection_env");
    
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_shot_monster_pistol");

    ObjSet("anm_plant_use_gun",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_scalpel()

  cmn.SetEventDone( "get_scalpel" );
  cmn.CallEventHandler( "get_scalpel" );

  iOS_RateMe();
  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_tongs()

  cmn.SetEventDone( "get_tongs" );
  cmn.CallEventHandler( "get_tongs" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_penicillin()
  
  ObjSet("spr_lab_penicillin",  { alp = 1 });

  cmn.SetEventDone( "get_penicillin" );
  cmn.CallEventHandler( "get_penicillin" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  if cmn.IsEventDone( "get_bombpart2" ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_bombpart2()

  cmn.SetEventDone( "get_bombpart2" );
  cmn.CallEventHandler( "get_bombpart2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  if cmn.IsEventDone( "get_penicillin" ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_triangularkey()

  cmn.SetEventDone( "get_triangularkey" );
  cmn.CallEventHandler( "get_triangularkey" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_gas()

  cmn.SetEventDone( "get_gas" );
  cmn.CallEventHandler( "get_gas" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_plantpart()

  cmn.SetEventDone( "get_plantpart" );
  cmn.CallEventHandler( "get_plantpart" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_doctorsnamebadge()
  
  ObjSet("spr_plant_doctorsnamebadge",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_doctorsnamebadge" );
  cmn.CallEventHandler( "get_doctorsnamebadge" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_gun()
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_gun_end" );
    
    --common_impl.PlayBackgroundMusic();

  end;

  cmn.SetEventDone( "get_gun" );
  cmn.CallEventHandler( "get_gun_inv" );
  cmn.CallEventHandler( "get_gun_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.current_dialog = "";
  
  cmn.Lock(1);
  ObjAnimate("obj_medicalsection_dialog_jean2", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.5, 0, 0 });

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_takeoldglassout( num )
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_zz_capsule_take");

  local func_after = function ()

    cmn.SetEventDone( "clk_takeoldglassout" );
    cmn.CallEventHandler( "clk_takeoldglassout" );

    if num == 1 then
      cmn.Lock(0);
    else 
      private.use_penicillin_end();
    end;
    
  end;
  
  ObjSet("anm_capsule_glass_out",  { alp = 1, playing = 1, endtrig = func_after });
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_medicalsection()

  if not ( cmn.IsEventDone( "opn_medicalsection" ) ) then
    cmn.SetEventDone( "opn_medicalsection" );
    cmn.CallEventHandler("opn_medicalsection");
    cmn.ShowBbt( "medicalsection_open" );
  end;
  
  if cmn.IsEventDone("win_incapsule") and not ( cmn.IsEventDone( "opn_medicalsectiondlg" ) ) then
    cmn.SetEventDone( "opn_medicalsectiondlg" );
    ObjAttach("obj_medicalsection_dialog_jean2", "rm_medicalsection");
    ObjAnimate("obj_medicalsection_dialog_jean2", "alp", 0, 0, private.dialog_jean2_beg, { 0, 0, 0,   0.5, 0, 1 });
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_plant_badge()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_plant_right_hand");
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    ObjMultiSet( { {"anm_plant_plant_2", { alp = 1, playing = 1 }},
                   {"anm_plant_badge_touch", { alp = 0 }} } );
    
  end;
  
  cmn.ShowBbt( "obj_plant_use_tongs" );
  
  ObjMultiSet( { {"anm_plant_badge_touch", { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_plant_plant_2", { alp = 0, playing = 0 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_plant_part()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_death_plant_1");
  
  cmn.ShowBbt( "obj_plant_use_scalpel" );
  
  ObjSet( "anm_plant_part_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_plant_gas()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_plant_right_hand");
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    ObjMultiSet( { {"anm_plant_plant", { alp = 1, playing = 1 }},
                   {"anm_plant_gas_touch", { alp = 0 }} } );
    
  end;
  
  cmn.ShowBbt( "obj_plant_use_blaster" );
  
  ObjMultiSet( { {"anm_plant_gas_touch", { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_plant_plant", { alp = 0, playing = 0 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_laser_door()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_yellow_door");
  
  cmn.ShowBbt( "obj_laser_use_triangularkey" );
  
  ObjSet( "anm_laser_front", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_laser_lense()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_broken_glass");
  
  cmn.ShowBbt( "obj_laser_use_lvl2lense" );
  
  ObjSet( "anm_laser_lense", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_laser_gas()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_broken_ballone");
  
  cmn.ShowBbt( "obj_laser_use_gas" );
  
  ObjSet( "anm_laser_gas", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_capsule_door()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_zz_capsule_box");
  
  cmn.ShowBbt( "obj_capsule_use_doctorsnamebadge" );
  
  ObjSet( "anm_capsule_door_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_capsule_tank()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_zz_capsule_cell");
  
  cmn.ShowBbt( "obj_capsule_use_penicillin" );
  
  ObjSet( "anm_capsule_hose_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_lab()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_zz_lab_colb");
  
  cmn.ShowBbt( "obj_lab_use_plantpart" );
  
  ObjSet( "anm_lab_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_jean2_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "medicalsection", "jean2", 2 );
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "opn_medicalsectiondlg" );
    
    cmn.ShowBbt( "medicalsection_after_dialog" );
    interface_impl.ShowGlobalTask();
    int_diary.AddDiarypage( 14 );
    
  end;
  
  local anm_give = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_medicalsection_dialog_jean2_lipsync2");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjAnimate("anm_medicalsection_dialog_jean2_hand_1", "alp", 0, 0, "", { 0, 0, 1,   0.16, 0, 1,   0.3, 0, 0 });
    
    ObjMultiSet( { {"tmr_medicalsection_dialog_jean2_timer",  { playing = 0 }},
                   {"anm_medicalsection_dialog_jean2_give", { alp = 1, playing = 1, endtrig = dialog_end }},
                   {"anm_medicalsection_dialog_jean2_head", { alp = 1 }} } );
    
  end;
  
  local jean_talks2 = function ()
  
    ObjDelete("vid_medicalsection_dialog_jean2_lipsync1");
    ObjAttach("vid_medicalsection_dialog_jean2_lipsync2", "obj_medicalsection_dialog_jean2");
  
    cmn.ShowDlgBbt( "dlg_jean2_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level2/audio/voc/aud_2_lvl_jean_4_voc");
    
    private.dlg_lipsync = "vid_medicalsection_dialog_jean2_lipsync2";
    
    ObjMultiSet( { {"tmr_medicalsection_dialog_jean2_timer", { endtrig = anm_give, time = 4, playing = 1 }},
                   {"vid_medicalsection_dialog_jean2_lipsync2", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_give }},
                   {"obj_character_dialog_continue", { event_mup = anm_give }} } );
  
  end;

  private.dlg_lipsync = "vid_medicalsection_dialog_jean2_lipsync1";

  cmn.ShowDlgBbt( "dlg_jean2_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level2/audio/voc/aud_2_lvl_jean_3_voc");

  ObjMultiSet( { {"tmr_medicalsection_dialog_jean2_timer", { time = 11, playing = 1, endtrig = jean_talks2 }},
                 {"vid_medicalsection_dialog_jean2_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = jean_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = jean_talks2 }} } );
  
end; 
--------------------------------------------------------------------------------------------
function public.skip_dlg_jean2()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "opn_medicalsectiondlg" );
    cmn.ShowBbt( "medicalsection_after_dialog" );
    interface_impl.ShowGlobalTask();
    int_diary.AddDiarypage( 14 );
    
  end;
  
  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    ObjSet("anm_medicalsection_dialog_jean2_head",  { alp = 1 });
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();
  
  --common_impl.PlayBackgroundMusic();
  
  ObjAnimate("anm_medicalsection_dialog_jean2_hand_1", "alp", 0, 0, "", { 0, 0, 1,   0.16, 0, 1,   0.3, 0, 0 });
  
  ObjMultiSet( { {"tmr_medicalsection_dialog_jean2_timer",  { playing = 0 }},
                 {"anm_medicalsection_dialog_jean2_give", { alp = 1, playing = 1, endtrig = func_after_dlg }} } );
  
end;
--*********************************************************************************************************************