-- name=level3

function public.Start ( param )

  game.play_hint_aud = false;

  interface.WidgetAdd( InterfaceWidget_Pause, 1800 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 10 );
  interface.WidgetAdd( InterfaceWidget_BtnGuide, 6 );

  interface.WidgetAdd( InterfaceWidget_BtnHint, 4  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 5 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 6 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 7 );

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 0 );

  interface.WidgetAdd( InterfaceWidget_TaskHeader, 1 );
  interface.WidgetAdd( InterfaceWidget_Inventory, 2 );
  --interface.WidgetAdd( InterfaceWidget_TaskPanel );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 3, "assets/interface/int_taskpanel");

  interface.WidgetAdd( InterfaceWidget_Effects, 50 );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 4 );

  interface.WidgetAdd( InterfaceWidget_DialogHo, 260 );

  interface.ButtonLockAdd();

  interface.WidgetAdd( InterfaceWidget_ItemPanel, 3, "assets/interface/int_itempanel" );
  interface.WidgetAdd( InterfaceWidget_Popup, 250 );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog );

  interface.WidgetAdd( InterfaceWidget_DialogVideo, 300 );
  --interface.WidgetAdd( InterfaceWidget_DialogStory );
  --interface.WidgetAdd( InterfaceWidget_DialogCharacter, 900 );

  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial, 310 );

  interface.WidgetAdd( InterfaceWidget_Map, 200 );

  interface.PanelNotificationAdd();
  interface.ComplexInvAdd();
  interface_impl.DialogHintAdd();
  
  interface_impl.GlobalTaskAdd();
  
  interface_impl.DiaryAdd();
  
  ------------------------------------------------------
  if IsCollectorsEdition() or IsSurveyEdition() then
  
    if IsCollectorsEdition() then
  
      ModLoad( "assets/levels/menu/rm_achievements/mod_achievements" );
      rm_achievements.Init();
    
      ModLoad( "assets/levels/menu/rm_collectable/mod_collectable" );
      rm_collectable.Init();
      
      ModLoad( "assets/levels/menu/rm_secretroom/mod_secretroom" );
      rm_secretroom.Init();
      
      interface_impl.PopupAchievementAdd();
      
    end;

    interface_impl.AchievAdd();
    
    interface_impl.BonusAdd();
  
  end;
  ------------------------------------------------------
  if IsCollectorsEdition() then
  
    interface.WidgetAdd( InterfaceWidget_StrategyGuide );
  
  end;
  ------------------------------------------------------
  
  --переменная для того, чтобы из титров не выкидывало в меню
  public.in_progress = true;
  --
  private.Init();
  --
  int_map_impl.CreateRooms( "level3" );

  ModLoad( "assets/levels/level3/mod_inventory3" );
  inventory3.Init();
  
  ModLoad( "assets/levels/menu/rm_endroom/mod_endroom" );
  rm_endroom.Init();
  
  ModLoad( "assets/levels/menu/rm_credits/mod_credits" );
  rm_credits.Init();

  common.LevelLoad( "level3", "std", "ho_apartment3", param );
  ng_global.progress[ "std" ].common.gamestart = true;
  
  common_impl.AddAvailibleMusic( 3 );
  common_impl.AddAvailibleMusic( 4 );
  common_impl.AddAvailibleMusic( 6 );
  common_impl.AddAvailibleMusic( 7 );
  common_impl.AddAvailibleMusic( 8 );
  common_impl.PlayBackgroundMusic();
  
  common_impl.StartCountGameTime(1);

  common_impl.DialogCustomUpdate();
  interface_impl.RemoveFlowersTotal();
  cmn.RemoveCollectable();
  
  int_button_diary.DiaryCheckNewMessage();
  
  int_button_map_impl.MapSetActive();

  game.play_hint_aud = true;

  common_impl.is_in_map = 0;

end;
    
function private.Init ()

  game.room_names =
  {
     "rm_office"
    ,"rm_laboratory"
    ,"rm_debughall"
    ,"rm_apocalypse1"
    ,"rm_apocalypse2"
    ,"rm_apocalypse3"
    
    ,"mg_tosecuritypanel"
    ,"mg_onmuseumdoors"
    ,"mg_device"
    ,"mg_aion"
    
    ,"ho_apartment3"
    ,"ho_destroyedrobot"
    ,"ho_installation"
  };
  
  --имена диалогов с подбором предмета (для удаления gfx в кастом моде)
  game.dlg_witems_names =
  {
    "obj_office_dialog_victor1",
    "obj_apocalypse3_dialog_naya1",
    "obj_apocalypse3_dialog_naya2"
  };

-- 1 - открыта
-- 2 - таски выполнены
-- 3 - кол-во тасков
-- 4 блокирована
  game.map_rooms = {
    
    [ "rm_office" ]      =  { 0, 0, 1, 0, 2 },
    [ "rm_laboratory" ]  =  { 0, 0, 1, 0, 3 },
    [ "rm_debughall" ]   =  { 0, 0, 1, 0, 3 },
    [ "rm_apocalypse1" ] =  { 0, 0, 1, 0, 3 },
    [ "rm_apocalypse2" ] =  { 0, 0, 2, 0, 2 },
    [ "rm_apocalypse3" ] =  { 0, 0, 99, 0, 3 },
    [ "mg_aion" ] =  { 0, 0, 99, 0, 1 }
    
  };
  
  --таблица с координатами открытия зз
  game.zz_end_pos = {
    
    [ "zz_panel3" ] = {530, 330},
    [ "zz_machine" ] = {360, 370},
    [ "zz_receptiondesk" ] = {490, 370},
    [ "zz_securitypanel" ] = {660, 360},
    
    [ "zz_labcomputer" ] = {480, 330},
    [ "zz_labdesk" ] = {360, 370},
    [ "zz_prototype" ] = {600, 360},
    [ "zz_generator" ] = {330, 340},
    
    [ "zz_vrcapsule" ] = {350, 360},
    [ "zz_pyramide" ] = {700, 320},
    [ "zz_hallsafe" ] = {330, 320},
    
    [ "zz_oldcar" ] = {460, 340},
    [ "zz_debris" ] = {580, 330},
    [ "zz_motocycle" ] = {620, 370},
    [ "zz_bench" ] = {360, 360},
    
    [ "zz_fracture" ] = {630, 340},
    [ "zz_oldfountain" ] = {330, 370},
    [ "zz_policevan" ] = {520, 360},
    [ "zz_museumdoors" ] = {480, 330},
    
    [ "zz_sarcophagus" ] = {300, 340},
    [ "zz_showcase" ] = {690, 350},
    [ "zz_showpiece" ] = {420, 370}
  
  };

  --таблицы для динамического хинта
  --таблица для юзов на предметы, получаемые в хо и мультиюзов
  game.progress_multyuse =
  {
    {"use_magnet", "win_destroyedrobot"},
    {"use_fang", "win_installation"},
    
    {"use_prunersdebris", "get_pruners"},
    {"use_prunersmoto", "get_pruners"},
    
    {"use_goreseye1", "get_goreseye"},
    {"use_goreseye2", "get_goreseye"},
    {"use_goreseye3", "get_goreseye"},
    {"use_goreseye4", "get_goreseye"}
  
  };

  --таблица на мультипредметы с количеством их частей
  game.progress_multyobj =
  {
    {"use_boxpart", 4},
    {"use_lvl3button", 3},
    {"use_coin", 3},
    {"use_securityemblem", 3},
    {"use_zodiacsign", 4}
  };

  --таблица на юзы, разблокирующиеся другими юзами или кликами
  game.progress_blockeduse =
  {
    {"get_securityemblem2", "clk_labslighton"},
    {"get_coin3", "clk_labslighton"},
    {"get_hacksaw", "clk_labslighton"},
    {"get_programm", "clk_labslighton"},
    {"get_design", "clk_labslighton"},
    {"get_masterswitch", "clk_labslighton"},
    {"get_tumbler1", "clk_labslighton"},
    {"use_lvl3wires", "clk_labslighton"},
    {"clk_labslighton", "use_generatorbutton"},
    
    {"win_destroyedrobot", "opn_robotready"},
    
    {"use_workingjack", "use_prunersdebris"},
    {"use_roundhandle", "use_crowbar"},
    {"use_skullamulet", "use_crowbar"},
    {"clk_oldcarhandle", "use_canofgasoline"},
    {"clk_adjusthook", "clk_oldcarhandle"},
    
    {"use_museumheart", "use_spideramulet"},
    {"use_policebadge", "use_diamond"},
    {"use_flashlight", "use_bowlofwater"},
    {"use_lvl3gun", "use_flashlight"},
    {"use_stoneoflight", "use_bowlofwater"},
    {"use_fang", "win_device"},
    {"use_pattern1", "use_moonsunemblems"},
    {"use_pattern2", "use_moonsunemblems"},
    {"use_pattern3", "use_moonsunemblems"},
    
    {"win_installation", "use_warriors"},
    
    {"use_nayaspicture", "use_hacksaw2"}
  };

  game.progress_names =
  {
     "beg_level3"
    ,"win_apartment3"
    
    ,"opn_office"
    ,"clk_officefirstclk"
    ,"get_nayaspicture"
    ,"get_microchip"
    ,"get_repairbox"
    ,"get_lvl3button3"
    ,"get_magnetkey"
    ,"get_securityemblem3"
    ,"use_magnetkey"
    ,"get_lvl3button1"
    ,"get_lvl3wires"
    ,"get_lvl3button2"
    ,"get_coin1"
    ,"use_lvl3button"
    ,"get_masterkey"
    ,"use_microchip"
    ,"use_masterkey"
    ,"win_panel3"
    
    ,"opn_laboratory"
    
    ,"opn_debughall"
    ,"get_case"
    ,"get_repairamulet1"
    
    ,"get_repairamulet2"
    ,"use_repairamulet1"
    ,"use_repairamulet2"
    ,"get_generatorbutton"
    ,"get_lockedcard"
    ,"use_generatorbutton"
    ,"clk_labslighton"
    ,"opn_laboratorylight"
    
    ,"get_securityemblem2"
    ,"get_programm"
    ,"get_coin3"
    ,"get_hacksaw"
    ,"get_design"
    ,"use_programm"
    ,"get_unchargedbattery"
    ,"get_masterswitch"
    ,"get_tumbler1"
    ,"clk_worldnucleus"
    ,"use_masterswitch"
    ,"use_unchargedbattery"
    ,"get_chargedbattery"
    ,"use_chargedbattery"
    ,"get_securityemblem1"
    ,"use_securityemblem"
    ,"win_tosecuritypanel"
    ,"get_baton"
    ,"get_coin2"
    ,"get_sawblade"
    ,"use_baton"
    ,"use_design"
    ,"use_lvl3wires"
    ,"win_labdesk"
    ,"get_lvl3weapon"
    ,"use_coin"
    ,"get_flashcard"
    ,"use_flashcard"
    ,"get_flashcardwithskills"
    ,"use_flashcardwithskills"
    ,"use_lvl3weapon"
    ,"opn_robotready"
    
    ,"win_destroyedrobot"
    ,"use_magnet"
    ,"get_lvl3screw"
    ,"use_sawblade"
    ,"use_lvl3screw"
    ,"get_hacksaw2"
    ,"use_hacksaw2"
    ,"get_tumbler2"
    ,"use_tumbler1"
    ,"use_tumbler2"
    ,"get_glove"
    ,"use_glove"
    ,"get_victorspicture"
    ,"use_victorspicture"
    ,"use_nayaspicture"
    ,"get_disk"
    ,"get_reader"
    ,"use_reader"
    ,"use_lockedcard"
    ,"get_capsuleactivator"
    ,"use_capsuleactivator"
    ,"get_money"
    ,"clk_oldnucleus"
    ,"use_money"
    ,"get_pyramid"
    ,"use_pyramid"
    ,"win_pyramide"
    ,"get_worldnucleus"
    
    ,"use_disk"
    ,"use_worldnucleus"
    ,"get_aionsworld"
    ,"use_aionsworld"
    
    ,"opn_apocalypse1"
    ,"get_pruners"
    ,"opn_debris"
    ,"get_jack"
    ,"use_prunersmoto"
    ,"get_jackpart1"
    ,"get_pattern3"
    ,"get_carkey"
    ,"use_carkey"
    ,"get_jackpart2"
    ,"get_lvl3wrench"
    ,"use_jackpart1"
    ,"use_jackpart2"
    ,"get_workingjack"
    ,"use_prunersdebris"
    ,"get_emptycan"
    ,"use_workingjack"
    ,"get_crowbar"
    ,"use_crowbar"
    ,"get_hose"
    ,"get_pandorasbox"
    ,"get_warrior1"
    ,"use_lvl3wrench"
    ,"use_hose"
    ,"use_emptycan"
    ,"get_canofgasoline"
    ,"clk_opencartank"
    ,"use_canofgasoline"
    ,"clk_oldcarhandle"
    ,"opn_apocalypse1hook2"
    ,"clk_adjusthook"
    ,"opn_apocalypse1hook"
    
    ,"opn_apocalypse2"
    ,"get_lvl3bowl"
    ,"use_lvl3bowl"
    ,"get_bowlofwater"
    ,"use_bowlofwater"
    ,"get_diamond"
    ,"use_diamond"
    ,"get_lvl3bag"
    ,"get_mask3"
    ,"get_roundhandle"
    ,"use_roundhandle"
    ,"get_spideramulet"
    ,"use_spideramulet"
    ,"get_oilcan"
    ,"use_oilcan"
    ,"get_lvl3oil"
    ,"use_lvl3oil"
    ,"get_flashlight"
    ,"get_policebadge"
    ,"use_policebadge"
    ,"get_lvl3gun"
    ,"use_flashlight"
    ,"use_lvl3gun"
    ,"win_fracture"
    ,"get_museumheart"
    ,"use_museumheart"
    ,"win_onmuseumdoors"
    
    ,"opn_apocalypse3"
    ,"clk_dlgnayastart"
    ,"get_figurine"
    ,"get_boxpart1"
    ,"get_pattern1"
    ,"get_sunemblem"
    ,"get_scoopnet"
    ,"get_mask4"
    ,"use_scoopnet"
    ,"get_moonemblem"
    ,"get_boxpart2"
    ,"use_sunemblem"
    ,"use_moonemblem"
    ,"use_moonsunemblems"
    ,"get_mask1"
    ,"get_tuningfork"
    ,"use_tuningfork"
    ,"get_boxpart3"
    ,"get_skullamulet"
    ,"use_skullamulet"
    ,"get_tweezers"
    
    ,"use_tweezers"
    ,"get_pattern2"
    ,"use_pattern1"
    ,"use_pattern2"
    ,"use_pattern3"
    ,"get_lvl3valve"
    ,"use_lvl3valve"
    ,"get_boxpart4"
    ,"use_boxpart"
    ,"win_pandorasbox"
    ,"get_stoneoflight"
    ,"clk_stoneoflight"
    ,"use_stoneoflight"
    ,"get_mask2"
    ,"use_mask1"
    ,"use_mask2"
    ,"use_mask3"
    ,"use_mask4"
    ,"get_warrior2"
    ,"get_heart"
    ,"use_heart"
    ,"get_goreseye"
    ,"use_warrior1"
    ,"use_warrior2"
    ,"use_warriors"
    ,"win_installation"
    
    ,"use_goreseye1"
    ,"get_zodiacsign1"
    ,"use_goreseye2"
    ,"get_zodiacsign2"
    ,"use_goreseye3"
    ,"get_zodiacsign3"
    ,"use_goreseye4"
    ,"get_zodiacsign4"
    ,"use_zodiacsign"
    ,"win_device"
    ,"use_fang"
    
    ,"opn_debughallaftervr"
    ,"opn_aion"
    ,"win_aion"
    ,"clk_chooseending"
    
    ,"tutor_24"
    ,"tutor_25"
    ,"tutor_26"
    
  };
  
  game.relations = {};

end;

function Test ()
    
  local profiles = GetProfileList();

  local cheater = false;

  for i = 1, #profiles, 1 do

    if ( profiles[ i ] == "CHEATER" ) then

      cheater = true;

    end;

  end;

  AddProfile( "CHEATER" );
  SetCurrentProfile( "CHEATER" );

  if ( not cheater ) then

    ng_global.gamemode = 0;
    ng_global.currentprogress = "std";
    ng_global.progress = {};
    ng_global.progress[ "std" ] = {};
    ng_global.progress[ "std" ].common = {};
    ng_global.progress[ "std" ].common.hinttimer = 0;

    SaveProfiles();

  end;

end;
