-- name=rm_laboratory
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_laboratory";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Labdesk();
  --------------------------------------------------------------------------------------------
  -- function get_chargedbattery () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_chargedbattery" ] = {
    type = "get",
    get_obj = "spr_generator_chargedbattery",
    room = private.room_objname,
    zz = "zz_generator",
    zz_gate = "gzz_laboratory_generator"
  };
  --------------------------------------------------------------------------------------------
  local get_chargedbattery_inv = function ()
  
    interface.InventoryItemAdd( "inv_chargedbattery", "spr_generator_chargedbattery" );
  
  end;
  local get_chargedbattery_end = function ()
  
    ObjDelete( "anm_generator_battery" );
    ObjDelete( "spr_laboratory_generator_battery" );
  
  end;
  
  cmn.AddSubscriber( "get_chargedbattery", get_chargedbattery_inv );
  cmn.AddSubscriber( "get_chargedbattery", get_chargedbattery_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_repairamulet2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_repairamulet2" ] = {
    type = "get",
    get_obj = "spr_generator_repairamulet2",
    room = private.room_objname,
    zz = "zz_generator",
    zz_gate = "gzz_laboratory_generator"
  };
  --------------------------------------------------------------------------------------------
  local get_repairamulet2_inv = function ()
  
    interface.InventoryItemAdd( "inv_repairamulet2", "spr_generator_repairamulet2" );
    ObjSet("inv_repairbox_star_light",  { alp = 1 });
  
  end;
  local get_repairamulet2_end = function ()
  
    ObjDelete( "gfx_generator_repairamulet2" );
    ObjDelete( "spr_generator_repairamulet2_sh" );
    
    ObjDelete( "spr_laboratory_generator_wires" );
  
  end;
  
  cmn.AddSubscriber( "get_repairamulet2", get_repairamulet2_inv );
  cmn.AddSubscriber( "get_repairamulet2", get_repairamulet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_victorspicture () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_victorspicture" ] = {
    type = "get",
    get_obj = "spr_generator_victorspicture",
    room = private.room_objname,
    zz = "zz_generator",
    zz_gate = "gzz_laboratory_generator"
  };
  --------------------------------------------------------------------------------------------
  local get_victorspicture_inv = function ()
  
    interface.InventoryItemAdd( "inv_victorspicture", "spr_generator_victorspicture" );
  
  end;
  local get_victorspicture_end = function ()
  
    ObjDelete( "gfx_generator_victorspicture" );
    ObjDelete( "spr_generator_victorspicture_sh" );
    
    ObjDelete( "spr_laboratory_generator_handle_2" );
    ObjDelete( "gzz_laboratory_generator" );
  
  end;
  
  cmn.AddSubscriber( "get_victorspicture", get_victorspicture_inv );
  cmn.AddSubscriber( "get_victorspicture", get_victorspicture_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_securityemblem2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_securityemblem2" ] = {
    type = "get",
    get_obj = "spr_labdesk_securityemblem2",
    room = private.room_objname,
    zz = "zz_labdesk",
    zz_gate = "gzz_laboratory_labdesk"
  };
  --------------------------------------------------------------------------------------------
  local get_securityemblem2_inv = function ()
  
    interface.InventoryItemAdd( "inv_securityemblem", "spr_labdesk_securityemblem2", function () cmn.GetMultyObject( 'securityemblem', 3 ); end );
  
  end;
  local get_securityemblem2_end = function ()
  
    ObjDelete( "gfx_labdesk_securityemblem2" );
    ObjDelete( "spr_labdesk_securityemblem2_sh" );
    
    ObjDelete( "spr_laboratory_desk_sign" );
    
  end;
  
  cmn.AddSubscriber( "get_securityemblem2", get_securityemblem2_inv );
  cmn.AddSubscriber( "get_securityemblem2", get_securityemblem2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_programm () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_programm" ] = {
    type = "get",
    get_obj = "spr_labdesk_programm",
    room = private.room_objname,
    zz = "zz_labdesk",
    zz_gate = "gzz_laboratory_labdesk"
  };
  --------------------------------------------------------------------------------------------
  local get_programm_inv = function ()
  
    interface.InventoryItemAdd( "inv_programm", "spr_labdesk_programm" );
  
  end;
  local get_programm_end = function ()
  
    ObjDelete( "gfx_labdesk_programm" );
    ObjDelete( "spr_labdesk_programm_sh" );
    
    ObjDelete( "spr_laboratory_desk_programm" );
  
  end;
  
  cmn.AddSubscriber( "get_programm", get_programm_inv );
  cmn.AddSubscriber( "get_programm", get_programm_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coin3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_coin3" ] = {
    type = "get",
    get_obj = "spr_labdesk_coin3",
    room = private.room_objname,
    zz = "zz_labdesk",
    zz_gate = "gzz_laboratory_labdesk"
  };
  --------------------------------------------------------------------------------------------
  local get_coin3_inv = function ()
  
    interface.InventoryItemAdd( "inv_coin", "spr_labdesk_coin3", function () cmn.GetMultyObject( 'coin', 3 ); end );
  
  end;
  local get_coin3_end = function ()
  
    ObjDelete( "gfx_labdesk_coin3" );
    ObjDelete( "spr_labdesk_coin3_sh" );
    
    ObjDelete( "spr_laboratory_desk_coin" );
  
  end;
  
  cmn.AddSubscriber( "get_coin3", get_coin3_inv );
  cmn.AddSubscriber( "get_coin3", get_coin3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hacksaw () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_hacksaw" ] = {
    type = "get",
    get_obj = "spr_labdesk_hacksaw",
    room = private.room_objname,
    zz = "zz_labdesk",
    zz_gate = "gzz_laboratory_labdesk"
  };
  --------------------------------------------------------------------------------------------
  local get_hacksaw_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_hacksaw", "spr_labdesk_hacksaw" );
  
  end;
  local get_hacksaw_end = function ()
  
    ObjDelete( "gfx_labdesk_hacksaw" );
    ObjDelete( "spr_labdesk_hacksaw_sh" );
    
    ObjDelete( "spr_laboratory_desk_saw" );
  
  end;
  
  cmn.AddSubscriber( "get_hacksaw", get_hacksaw_inv );
  cmn.AddSubscriber( "get_hacksaw", get_hacksaw_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl3weapon () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl3weapon" ] = {
    type = "get",
    get_obj = "anm_labdesk_sword_on",
    room = private.room_objname,
    zz = "zz_labdesk",
    zz_gate = "gzz_laboratory_labdesk"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl3weapon_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl3weapon", "anm_labdesk_sword_on" );
  
  end;
  local get_lvl3weapon_end = function ()
  
    ObjDelete( "gfx_labdesk_lvl3weapon" );
    
    ObjDelete( "gzz_laboratory_labdesk" );
    ObjDelete( "spr_laboratory_desk_baton_2" );
  
  end;
  
  cmn.AddSubscriber( "get_lvl3weapon", get_lvl3weapon_inv );
  cmn.AddSubscriber( "get_lvl3weapon", get_lvl3weapon_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_securityemblem1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_securityemblem1" ] = {
    type = "get",
    get_obj = "spr_prototype_securityemblem1",
    room = private.room_objname,
    zz = "zz_prototype",
    zz_gate = "gzz_laboratory_prototype"
  };
  --------------------------------------------------------------------------------------------
  local get_securityemblem1_inv = function ()
  
    interface.InventoryItemAdd( "inv_securityemblem", "spr_prototype_securityemblem1", function () cmn.GetMultyObject( 'securityemblem', 3 ); end );
  
  end;
  local get_securityemblem1_end = function ()
  
    ObjDelete( "gfx_prototype_securityemblem1" );
    ObjDelete( "anm_prototype_robot_alive_2" );
    ObjDelete( "spr_laboratory_robot_sign" );
    
    ObjMultiSet( { {"anm_prototype_hand_2_touch", { alp = 1 }},
                   {"obj_prototype_use_lvl3weapon", { input = 1 }} } );
  
  end;
  
  cmn.AddSubscriber( "get_securityemblem1", get_securityemblem1_inv );
  cmn.AddSubscriber( "get_securityemblem1", get_securityemblem1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_unchargedbattery () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_unchargedbattery" ] = {
    type = "get",
    get_obj = "spr_prototype_unchargedbattery",
    room = private.room_objname,
    zz = "zz_prototype",
    zz_gate = "gzz_laboratory_prototype"
  };
  --------------------------------------------------------------------------------------------
  local get_unchargedbattery_inv = function ()
  
    interface.InventoryItemAdd( "inv_unchargedbattery", "spr_prototype_unchargedbattery" );
  
  end;
  local get_unchargedbattery_end = function ()
  
    ObjDelete( "gfx_prototype_unchargedbattery" );
    ObjDelete( "spr_laboratory_robot_battery_1" );
    
    ObjMultiSet( { {"obj_prototype_use_chargedbattery",  { input = 1 }},
                   {"spr_laboratory_robot_battery_2", { alp = 1 }} } );
  
  end;
  
  cmn.AddSubscriber( "get_unchargedbattery", get_unchargedbattery_inv );
  cmn.AddSubscriber( "get_unchargedbattery", get_unchargedbattery_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_design () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_design" ] = {
    type = "get",
    get_obj = "spr_prototype_design",
    room = private.room_objname,
    zz = "zz_prototype",
    zz_gate = "gzz_laboratory_prototype"
  };
  --------------------------------------------------------------------------------------------
  local get_design_inv = function ()
  
    if not cmn.IsEventDone("use_chargedbattery") then
      ObjDelete( "spr_prototype_design_2" );
      interface.InventoryItemAdd( "inv_design", "spr_prototype_design" );
    else 
      interface.InventoryItemAdd( "inv_design", "spr_prototype_design_2" );
    end;
  
  end;
  local get_design_end = function ()
  
    ObjDelete( "gfx_prototype_design" );
    ObjDelete( "spr_prototype_design_sh" );
    
    ObjDelete( "gfx_prototype_design_2" );
    ObjDelete( "spr_prototype_design_sh_2" );
    
    ObjDelete( "spr_laboratory_robot_scheme" );
  
  end;
  
  cmn.AddSubscriber( "get_design", get_design_inv );
  cmn.AddSubscriber( "get_design", get_design_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tumbler1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_tumbler1" ] = {
    type = "get",
    get_obj = "spr_labcomputer_tumbler1",
    room = private.room_objname,
    zz = "zz_labcomputer",
    zz_gate = "gzz_laboratory_labcomputer"
  };
  --------------------------------------------------------------------------------------------
  local get_tumbler1_inv = function ()
  
    interface.InventoryItemAdd( "inv_tumbler1", "spr_labcomputer_tumbler1" );
    ObjSet("inv_case_star_light",  { alp = 1 });
  
  end;
  local get_tumbler1_end = function ()
  
    ObjDelete( "gfx_labcomputer_tumbler1" );
    ObjDelete( "spr_labcomputer_tumbler1_sh" );
    
    ObjDelete( "spr_laboratory_pc_sign" );
  
  end;
  
  cmn.AddSubscriber( "get_tumbler1", get_tumbler1_inv );
  cmn.AddSubscriber( "get_tumbler1", get_tumbler1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_masterswitch () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_masterswitch" ] = {
    type = "get",
    get_obj = "spr_labcomputer_masterswitch",
    room = private.room_objname,
    zz = "zz_labcomputer",
    zz_gate = "gzz_laboratory_labcomputer"
  };
  --------------------------------------------------------------------------------------------
  local get_masterswitch_inv = function ()
  
    interface.InventoryItemAdd( "inv_masterswitch", "spr_labcomputer_masterswitch" );
  
  end;
  local get_masterswitch_end = function ()
  
    ObjDelete( "gfx_labcomputer_masterswitch" );
    ObjDelete( "spr_labcomputer_masterswitch_sh" );
    
    ObjDelete( "spr_laboratory_pc_switch" );
  
  end;
  
  cmn.AddSubscriber( "get_masterswitch", get_masterswitch_inv );
  cmn.AddSubscriber( "get_masterswitch", get_masterswitch_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_flashcardwithskills () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_flashcardwithskills" ] = {
    type = "get",
    get_obj = "spr_labcomputer_flashcardwithskills",
    room = private.room_objname,
    zz = "zz_labcomputer",
    zz_gate = "gzz_laboratory_labcomputer"
  };
  --------------------------------------------------------------------------------------------
  local get_flashcardwithskills_inv = function ()
  
    interface.InventoryItemAdd( "inv_flashcardwithskills", "spr_labcomputer_flashcardwithskills" );
  
  end;
  local get_flashcardwithskills_end = function ()
  
    ObjDelete( "gfx_labcomputer_flashcardwithskills" );
    ObjDelete( "spr_laboratory_pc_flashdrive" );
  
  end;
  
  cmn.AddSubscriber( "get_flashcardwithskills", get_flashcardwithskills_inv );
  cmn.AddSubscriber( "get_flashcardwithskills", get_flashcardwithskills_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_aionsworld () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_aionsworld" ] = {
    type = "get",
    get_obj = "obj_labcomputer_aionsworld",
    room = private.room_objname,
    zz = "zz_labcomputer",
    zz_gate = "gzz_laboratory_labcomputer"
  };
  --------------------------------------------------------------------------------------------
  local get_aionsworld_inv = function ()
  
    interface.InventoryItemAdd( "inv_aionsworld", "obj_labcomputer_aionsworld" );
    int_map_impl.DecreaseRoomTasks("rm_laboratory");
  
  end;
  local get_aionsworld_end = function ()
  
    ObjDelete( "gfx_labcomputer_aionsworld" );
    
    ObjDelete( "gzz_laboratory_labcomputer" );
    ObjDelete( "spr_laboratory_pc_ball_2" );
  
  end;
  
  cmn.AddSubscriber( "get_aionsworld", get_aionsworld_inv );
  cmn.AddSubscriber( "get_aionsworld", get_aionsworld_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_generatorbutton () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_generatorbutton" ] = {
    type = "use",
    inv_obj = "inv_generatorbutton",
    use_place = "obj_generator_use_generatorbutton",
    room = private.room_objname,
    zz = "zz_generator",
    zz_gate = "gzz_laboratory_generator"
  };
  --------------------------------------------------------------------------------------------
  local use_generatorbutton_inv = function ()
  
    interface.InventoryItemRemove( "inv_generatorbutton" );
  
  end;
  local use_generatorbutton_beg = function ()
  
    ObjDelete( "obj_generator_use_generatorbutton" );
  
  end;
  local use_generatorbutton_end = function ()
    
    ObjMultiSet( { {"spr_generator_button_1",  { alp = 1, input = 1 }},
                   {"spr_laboratory_generator_button_1", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_generatorbutton", use_generatorbutton_beg, private.room_objname );
  cmn.AddSubscriber( "use_generatorbutton", use_generatorbutton_inv );
  cmn.AddSubscriber( "use_generatorbutton", use_generatorbutton_end, private.room_objname );
  cmn.AddSubscriber( "use_generatorbutton_inv", use_generatorbutton_inv, private.room_objname );
  cmn.AddSubscriber( "use_generatorbutton_beg", use_generatorbutton_beg, private.room_objname );
  cmn.AddSubscriber( "use_generatorbutton_end", use_generatorbutton_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_masterswitch () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_masterswitch" ] = {
    type = "use",
    inv_obj = "inv_masterswitch",
    use_place = "obj_generator_use_masterswitch",
    room = private.room_objname,
    zz = "zz_generator",
    zz_gate = "gzz_laboratory_generator"
  };
  --------------------------------------------------------------------------------------------
  local use_masterswitch_inv = function ()
  
    interface.InventoryItemRemove( "inv_masterswitch" );
  
  end;
  local use_masterswitch_beg = function ()
  
    ObjDelete( "obj_generator_use_masterswitch" );
    
  end;
  local use_masterswitch_end = function ()
    
    ObjSet("spr_laboratory_generator_switch",  { alp = 1 });
  
    if ( cmn.IsEventDone( "use_unchargedbattery" ) ) then
      ObjMultiSet( { {"anm_generator_switch", { animfunc = "func_use_handle2", frame = 300 }},
                     {"spr_generator_chargedbattery", { input = 1 }},
                     {"gfx_generator_chargedbattery", { active = 1, visible = 1 }} } );
    else
      ObjSet("anm_generator_switch",  { animfunc = "func_clk_handle", frame = 0, playing = 0 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_masterswitch", use_masterswitch_beg, private.room_objname );
  cmn.AddSubscriber( "use_masterswitch", use_masterswitch_inv );
  cmn.AddSubscriber( "use_masterswitch", use_masterswitch_end, private.room_objname );
  cmn.AddSubscriber( "use_masterswitch_inv", use_masterswitch_inv, private.room_objname );
  cmn.AddSubscriber( "use_masterswitch_beg", use_masterswitch_beg, private.room_objname );
  cmn.AddSubscriber( "use_masterswitch_end", use_masterswitch_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_unchargedbattery () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_unchargedbattery" ] = {
    type = "use",
    inv_obj = "inv_unchargedbattery",
    use_place = "obj_generator_use_unchargedbattery",
    room = private.room_objname,
    zz = "zz_generator",
    zz_gate = "gzz_laboratory_generator"
  };
  --------------------------------------------------------------------------------------------
  local use_unchargedbattery_inv = function ()
  
    interface.InventoryItemRemove( "inv_unchargedbattery" );
  
  end;
  local use_unchargedbattery_beg = function ()
  
    ObjDelete( "obj_generator_use_unchargedbattery" );
  
  end;
  local use_unchargedbattery_end = function ()
    
    ObjMultiSet( { {"anm_generator_battery",  { animfunc = "func_clk_battery", frame = 0, playing = 0 }},
                   {"spr_laboratory_generator_battery", { alp = 1 }} } );
  
    if ( cmn.IsEventDone( "use_masterswitch" ) ) then
      ObjMultiSet( { {"anm_generator_switch", { animfunc = "func_use_handle2", frame = 300 }},
                     {"spr_generator_chargedbattery", { input = 1 }},
                     {"gfx_generator_chargedbattery", { active = 1, visible = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_unchargedbattery", use_unchargedbattery_beg, private.room_objname );
  cmn.AddSubscriber( "use_unchargedbattery", use_unchargedbattery_inv );
  cmn.AddSubscriber( "use_unchargedbattery", use_unchargedbattery_end, private.room_objname );
  cmn.AddSubscriber( "use_unchargedbattery_inv", use_unchargedbattery_inv, private.room_objname );
  cmn.AddSubscriber( "use_unchargedbattery_beg", use_unchargedbattery_beg, private.room_objname );
  cmn.AddSubscriber( "use_unchargedbattery_end", use_unchargedbattery_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_glove () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_glove" ] = {
    type = "use",
    inv_obj = "inv_glove",
    use_place = "obj_generator_use_glove",
    room = private.room_objname,
    zz = "zz_generator",
    zz_gate = "gzz_laboratory_generator"
  };
  --------------------------------------------------------------------------------------------
  local use_glove_inv = function ()
  
    interface.InventoryItemRemove( "inv_glove" );
  
  end;
  local use_glove_beg = function ()
  
    ObjDelete( "obj_generator_use_glove" );
    ObjDelete( "anm_generator_handle_touch" );
  
  end;
  local use_glove_end = function ()
  
    ObjSet( "anm_generator_use_glove", { alp = 1, frame = 300 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_glove", use_glove_beg, private.room_objname );
  cmn.AddSubscriber( "use_glove", use_glove_inv );
  cmn.AddSubscriber( "use_glove", use_glove_end, private.room_objname );
  cmn.AddSubscriber( "use_glove_inv", use_glove_inv, private.room_objname );
  cmn.AddSubscriber( "use_glove_beg", use_glove_beg, private.room_objname );
  cmn.AddSubscriber( "use_glove_end", use_glove_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_baton () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_baton" ] = {
    type = "use",
    inv_obj = "inv_baton",
    use_place = "obj_labdesk_use_baton",
    room = private.room_objname,
    zz = "zz_labdesk",
    zz_gate = "gzz_laboratory_labdesk"
  };
  --------------------------------------------------------------------------------------------
  local use_baton_inv = function ()
  
    interface.InventoryItemRemove( "inv_baton" );
  
  end;
  local use_baton_beg = function ()
  
  
  end;
  local use_baton_end = function ()

    ObjDelete( "obj_labdesk_use_baton" );

    ObjMultiSet( {
      { "obj_labdesk_screw", { alp = 1 } },
      { "obj_labdesk_sword", { alp = 1 } },
      { "spr_laboratory_desk_baton", { alp = 1 } }
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_baton", use_baton_beg, private.room_objname );
  cmn.AddSubscriber( "use_baton", use_baton_inv );
  cmn.AddSubscriber( "use_baton", use_baton_end, private.room_objname );
  cmn.AddSubscriber( "use_baton_inv", use_baton_inv, private.room_objname );
  cmn.AddSubscriber( "use_baton_beg", use_baton_beg, private.room_objname );
  cmn.AddSubscriber( "use_baton_end", use_baton_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl3wires () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl3wires" ] = {
    type = "use",
    inv_obj = "inv_lvl3wires",
    use_place = "obj_labdesk_use_lvl3wires",
    room = private.room_objname,
    zz = "zz_labdesk",
    zz_gate = "gzz_laboratory_labdesk"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl3wires_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl3wires" );
  
  end;
  local use_lvl3wires_beg = function ()

  
  end;
  local use_lvl3wires_end = function ()

    ObjDelete( "obj_labdesk_use_lvl3wires" );

    ObjMultiSet( { {"obj_labdesk_wire", { alp = 1 }},
                   {"spr_laboratory_desk_wires", { alp = 1 }} } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl3wires", use_lvl3wires_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl3wires", use_lvl3wires_inv );
  cmn.AddSubscriber( "use_lvl3wires", use_lvl3wires_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl3wires_inv", use_lvl3wires_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl3wires_beg", use_lvl3wires_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl3wires_end", use_lvl3wires_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_design () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_design" ] = {
    type = "use",
    inv_obj = "inv_design",
    use_place = "obj_labdesk_use_design",
    room = private.room_objname,
    zz = "zz_labdesk",
    zz_gate = "gzz_laboratory_labdesk"
  };
  --------------------------------------------------------------------------------------------
  local use_design_inv = function ()
  
    interface.InventoryItemRemove( "inv_design" );
  
  end;
  local use_design_beg = function ()
  
  
  end;
  local use_design_end = function ()
  
    ObjDelete( "obj_labdesk_use_design" );

    ObjMultiSet( {
      { "spr_labdesk_paper", { alp = 1 } },
      { "spr_labdesk_paper_shadow", { alp = 1 } },
      { "spr_laboratory_desk_scheme", { alp = 1 } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_design", use_design_beg, private.room_objname );
  cmn.AddSubscriber( "use_design", use_design_inv );
  cmn.AddSubscriber( "use_design", use_design_end, private.room_objname );
  cmn.AddSubscriber( "use_design_inv", use_design_inv, private.room_objname );
  cmn.AddSubscriber( "use_design_beg", use_design_beg, private.room_objname );
  cmn.AddSubscriber( "use_design_end", use_design_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chargedbattery () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_chargedbattery" ] = {
    type = "use",
    inv_obj = "inv_chargedbattery",
    use_place = "obj_prototype_use_chargedbattery",
    room = private.room_objname,
    zz = "zz_prototype",
    zz_gate = "gzz_laboratory_prototype"
  };
  --------------------------------------------------------------------------------------------
  local use_chargedbattery_inv = function ()
  
    interface.InventoryItemRemove( "inv_chargedbattery" );
  
  end;
  local use_chargedbattery_beg = function ()
  
    ObjDelete( "obj_prototype_use_chargedbattery" );
  
  end;
  local use_chargedbattery_end = function ()
  
    ObjDelete( "obj_prototype_robot_1" );
    ObjDelete( "spr_laboratory_robot_battery_2" );

    ObjMultiSet( { {"anm_prototype_robot_alive", { alp = 1, input = 1, frame = 400 }},
                   {"anm_prototype_robot_alive_2", { alp = 1, input = 1, frame = 400 }} } );
    
    if not cmn.IsEventDone("get_design") then
      game.hint[ "get_design" ].get_obj = "spr_prototype_design_2";
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chargedbattery", use_chargedbattery_beg, private.room_objname );
  cmn.AddSubscriber( "use_chargedbattery", use_chargedbattery_inv );
  cmn.AddSubscriber( "use_chargedbattery", use_chargedbattery_end, private.room_objname );
  cmn.AddSubscriber( "use_chargedbattery_inv", use_chargedbattery_inv, private.room_objname );
  cmn.AddSubscriber( "use_chargedbattery_beg", use_chargedbattery_beg, private.room_objname );
  cmn.AddSubscriber( "use_chargedbattery_end", use_chargedbattery_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_programm () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_programm" ] = {
    type = "use",
    inv_obj = "inv_programm",
    use_place = "obj_prototype_use_programm",
    room = private.room_objname,
    zz = "zz_prototype",
    zz_gate = "gzz_laboratory_prototype"
  };
  --------------------------------------------------------------------------------------------
  local use_programm_inv = function ()
  
    interface.InventoryItemRemove( "inv_programm" );
  
  end;
  local use_programm_beg = function ()
  
    ObjDelete( "obj_prototype_use_programm" );
  
  end;
  local use_programm_end = function ()
  
    ObjMultiSet( { {"obj_prototype_battery_open", { alp = 1, input = 1 }},
                   {"anm_prototype_battery_touch", { alp = 0 }},
                   {"spr_laboratory_robot_battery_1", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_programm", use_programm_beg, private.room_objname );
  cmn.AddSubscriber( "use_programm", use_programm_inv );
  cmn.AddSubscriber( "use_programm", use_programm_end, private.room_objname );
  cmn.AddSubscriber( "use_programm_inv", use_programm_inv, private.room_objname );
  cmn.AddSubscriber( "use_programm_beg", use_programm_beg, private.room_objname );
  cmn.AddSubscriber( "use_programm_end", use_programm_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl3weapon () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl3weapon" ] = {
    type = "use",
    inv_obj = "inv_lvl3weapon",
    use_place = "obj_prototype_use_lvl3weapon",
    room = private.room_objname,
    zz = "zz_prototype",
    zz_gate = "gzz_laboratory_prototype"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl3weapon_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl3weapon" );
  
  end;
  local use_lvl3weapon_beg = function ()
  
    ObjDelete( "obj_prototype_use_lvl3weapon" );
  
  end;
  local use_lvl3weapon_end = function ()
    
    ObjMultiSet( { {"obj_prototype_weapon", { alp = 1 }},
                   {"spr_laboratory_robot_weapon", { alp = 1 }} } );
  
    if ( cmn.IsEventDone( "use_flashcardwithskills" ) ) then
      ObjDelete( "gzz_laboratory_prototype" );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl3weapon", use_lvl3weapon_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl3weapon", use_lvl3weapon_inv );
  cmn.AddSubscriber( "use_lvl3weapon", use_lvl3weapon_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl3weapon_inv", use_lvl3weapon_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl3weapon_beg", use_lvl3weapon_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl3weapon_end", use_lvl3weapon_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_flashcardwithskills () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_flashcardwithskills" ] = {
    type = "use",
    inv_obj = "inv_flashcardwithskills",
    use_place = "obj_prototype_use_flashcardwithskills",
    room = private.room_objname,
    zz = "zz_prototype",
    zz_gate = "gzz_laboratory_prototype"
  };
  --------------------------------------------------------------------------------------------
  local use_flashcardwithskills_inv = function ()
  
    interface.InventoryItemRemove( "inv_flashcardwithskills" );
  
  end;
  local use_flashcardwithskills_beg = function ()
  
    ObjDelete( "obj_prototype_use_flashcardwithskills" );
  
  end;
  local use_flashcardwithskills_end = function ()
    
    ObjMultiSet( { {"anm_prototype_use_flashdrive",  { alp = 1, frame = 300 }},
                   {"spr_laboratory_robot_flash", { alp = 1 }} } );
  
    if ( cmn.IsEventDone( "use_lvl3weapon" ) ) then
      ObjDelete( "gzz_laboratory_prototype" );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_flashcardwithskills", use_flashcardwithskills_beg, private.room_objname );
  cmn.AddSubscriber( "use_flashcardwithskills", use_flashcardwithskills_inv );
  cmn.AddSubscriber( "use_flashcardwithskills", use_flashcardwithskills_end, private.room_objname );
  cmn.AddSubscriber( "use_flashcardwithskills_inv", use_flashcardwithskills_inv, private.room_objname );
  cmn.AddSubscriber( "use_flashcardwithskills_beg", use_flashcardwithskills_beg, private.room_objname );
  cmn.AddSubscriber( "use_flashcardwithskills_end", use_flashcardwithskills_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_flashcard () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_flashcard" ] = {
    type = "use",
    inv_obj = "inv_flashcard",
    use_place = "obj_labcomputer_use_flashcard",
    room = private.room_objname,
    zz = "zz_labcomputer",
    zz_gate = "gzz_laboratory_labcomputer"
  };
  --------------------------------------------------------------------------------------------
  local use_flashcard_inv = function ()
  
    interface.InventoryItemRemove( "inv_flashcard" );
  
  end;
  local use_flashcard_beg = function ()
  
    ObjDelete( "obj_labcomputer_use_flashcard" );
  
  end;
  local use_flashcard_end = function ()
  
    ObjDelete( "spr_labcomputer_screen_1" );
    
    ObjMultiSet( { {"spr_labcomputer_flashcardwithskills", { input = 1, alp = 1, pos_x = 123, pos_y = -206 }},
                   {"gfx_labcomputer_flashcardwithskills", { active = 1, visible = 1 }},
                   {"spr_laboratory_pc_flashdrive", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_flashcard", use_flashcard_beg, private.room_objname );
  cmn.AddSubscriber( "use_flashcard", use_flashcard_inv );
  cmn.AddSubscriber( "use_flashcard", use_flashcard_end, private.room_objname );
  cmn.AddSubscriber( "use_flashcard_inv", use_flashcard_inv, private.room_objname );
  cmn.AddSubscriber( "use_flashcard_beg", use_flashcard_beg, private.room_objname );
  cmn.AddSubscriber( "use_flashcard_end", use_flashcard_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_disk () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_disk" ] = {
    type = "use",
    inv_obj = "inv_disk",
    use_place = "obj_labcomputer_use_disk",
    room = private.room_objname,
    zz = "zz_labcomputer",
    zz_gate = "gzz_laboratory_labcomputer"
  };
  --------------------------------------------------------------------------------------------
  local use_disk_inv = function ()
  
    interface.InventoryItemRemove( "inv_disk" );
  
  end;
  local use_disk_beg = function ()
  
    ObjDelete( "obj_labcomputer_use_disk" );
  
  end;
  local use_disk_end = function ()
  
    ObjMultiSet( { {"anm_labcomputer_disk_use",  { alp = 1, frame = 300 }},
                   {"spr_laboratory_pc_disk", { alp = 1 }} } );

    if ( cmn.IsEventDone( "use_worldnucleus" ) ) then
      ObjMultiSet( { {"anm_labcomputer_aionsworls", { frame = 400 }},
                     {"gfx_labcomputer_aionsworld", { active = 1, visible = 1 }},
                     {"obj_labcomputer_aionsworld", { input = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_disk", use_disk_beg, private.room_objname );
  cmn.AddSubscriber( "use_disk", use_disk_inv );
  cmn.AddSubscriber( "use_disk", use_disk_end, private.room_objname );
  cmn.AddSubscriber( "use_disk_inv", use_disk_inv, private.room_objname );
  cmn.AddSubscriber( "use_disk_beg", use_disk_beg, private.room_objname );
  cmn.AddSubscriber( "use_disk_end", use_disk_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_worldnucleus () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_worldnucleus" ] = {
    type = "use",
    inv_obj = "inv_worldnucleus",
    use_place = "obj_labcomputer_use_worldnucleus",
    room = private.room_objname,
    zz = "zz_labcomputer",
    zz_gate = "gzz_laboratory_labcomputer"
  };
  --------------------------------------------------------------------------------------------
  local use_worldnucleus_inv = function ()
  
    interface.InventoryItemRemove( "inv_worldnucleus" );
  
  end;
  local use_worldnucleus_beg = function ()
  
    ObjDelete( "obj_labcomputer_use_worldnucleus" );
  
  end;
  local use_worldnucleus_end = function ()
  
    ObjMultiSet( { {"obj_labcomputer_aionsworld",  { alp = 1 }},
                   {"spr_laboratory_pc_ball_2", { alp = 1 }} } );

    if ( cmn.IsEventDone( "use_disk" ) ) then
      ObjMultiSet( { {"anm_labcomputer_aionsworls", { frame = 400 }},
                     {"gfx_labcomputer_aionsworld", { active = 1, visible = 1 }},
                     {"obj_labcomputer_aionsworld", { input = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_worldnucleus", use_worldnucleus_beg, private.room_objname );
  cmn.AddSubscriber( "use_worldnucleus", use_worldnucleus_inv );
  cmn.AddSubscriber( "use_worldnucleus", use_worldnucleus_end, private.room_objname );
  cmn.AddSubscriber( "use_worldnucleus_inv", use_worldnucleus_inv, private.room_objname );
  cmn.AddSubscriber( "use_worldnucleus_beg", use_worldnucleus_beg, private.room_objname );
  cmn.AddSubscriber( "use_worldnucleus_end", use_worldnucleus_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_robotready () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "opn_robotready" ] = {
    type = "click",
    use_place = "obj_laboratory_dialog_robot",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local opn_robotready_task = function ()
    interface_impl.SetCurrentGlobalTask( 15 );
  end;
  local opn_robotready_end = function ()

    ObjDelete("obj_laboratory_dialog_robot");
    ObjDelete("obj_laboratory_prototype");
    ObjDelete("spr_laboratory_hall_robot_2");
    
    ObjSet("spr_laboratory_hall_robot_3",  { alp = 1 });

  end;
  local opn_robotready_loc = function ()
    
    ObjDelete("obj_debughall_robot_bbt");
    ObjDelete("obj_debughall_robot");

    ObjMultiSet( {
      { "gho_debughall_destroyedrobot", { alp = 1, input = true, active = true } },
      { "gzz_debughall_hallsafe", { alp = 1, input = true, active = true } },
      { "gzz_debughall_vrcapsule", { alp = 1, input = true, active = true } },
      { "gzz_debughall_pyramide", { alp = 1, input = true, active = true } },
      { "spr_debughall_robot_crashed", { alp = 1 } },
      { "spr_bonus_34", { input = 1, pos_z = 95 } },
      { "spr_bonus_35", { input = 1, pos_z = 95 } }
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_robotready", opn_robotready_end, private.room_objname );
  cmn.AddSubscriber( "opn_robotready", opn_robotready_loc, "rm_debughall" );
  cmn.AddSubscriber( "opn_robotready", opn_robotready_task );
  
  --------------------------------------------------------------------------------------------
  -- function clk_labslighton () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_labslighton" ] = {
    type = "click",
    use_place = "spr_generator_button_1",
    room = private.room_objname,
    zz = "zz_generator",
    zz_gate = "gzz_laboratory_generator"
  };
  --------------------------------------------------------------------------------------------
  local clk_labslighton_tsk = function ()
    common_impl.ChangeRoomMiniback( "rm_laboratory", 2 );
  end;
  local clk_labslighton = function ()
    
    ObjAttach("vid_laboratory_generator_3", "obj_laboratory_generator");

    ObjDelete("spr_laboratory_back_2");
    ObjDelete("spr_generator_button_1");
    ObjDelete("spr_laboratory_generator_button_1");
    ObjDelete("spr_laboratory_generator_handle");
    
    ObjMultiSet( {
      { "gzz_laboratory_labdesk", { alp = 1, input = true, active = true } },
      { "gzz_laboratory_prototype", { alp = 1, input = true, active = true } },
      { "gzz_laboratory_labcomputer", { alp = 1, input = true, active = true } },
      { "spr_generator_chargedbattery_back_2", { alp = 1 } },
      { "anm_generator_handle_touch", { animfunc = "func_clk_safehandle" } },
      { "anm_generator_switch", { alp = 1 } },
      { "anm_generator_battery", { alp = 1 } },
      { "spr_generator_button_2", { alp = 1 } },
      { "spr_laboratory_generator_button_2", { alp = 1 } },
      { "spr_bonus_32", { input = 1, pos_z = 95 } },
      { "spr_bonus_33", { input = 1, pos_z = 95 } },
      { "obj_col_9", { input = 1, pos_z = 95 } },
      { "spr_laboratory_generator_handle_2", { alp = 1 } }
    } );
  
  end;
  local clk_labslighton_preloc = function ()
    
    ObjDelete("spr_office_door_open_1");
    ObjSet("spr_office_door_open_2",  { alp = 1 });
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_labslighton", clk_labslighton, private.room_objname );
  cmn.AddSubscriber( "clk_labslighton", clk_labslighton_preloc, "rm_office" );
  cmn.AddSubscriber( "clk_labslighton", clk_labslighton_tsk );
  --------------------------------------------------------------------------------------------
  -- function clk_worldnucleus () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_worldnucleus" ] = {
      type = "click",
      use_place = "obj_labcomputer_clk_worldnucleus",
      room = private.room_objname,
      zz = "zz_labcomputer",
      zz_gate = "gzz_laboratory_labcomputer"
  };
  --------------------------------------------------------------------------------------------
  local clk_worldnucleus = function ()
  
    ObjSet("obj_labcomputer_use_worldnucleus",  { input = 1 });

    ObjDelete( "obj_labcomputer_clk_worldnucleus" );
    ObjDelete( "spr_labcomputer_broken_ball" );
    
    ObjDelete( "spr_laboratory_pc_ball_1" );

  end;
  
  cmn.AddSubscriber( "clk_worldnucleus", clk_worldnucleus, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_laboratory () end;
  --------------------------------------------------------------------------------------------
  local opn_laboratory = function ()
  
    int_map_impl.OpenRoom( "rm_laboratory" );
    common_impl.ChangeRoomMiniback( "rm_laboratory", false );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_laboratory", opn_laboratory );
  
end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_prototype" );
  subroom.Define( "zz_generator" );
  subroom.Define( "zz_labdesk" );
  
  function zz_prototype.Close()
    
    cmn.HideNote( 0 );
    
    if cmn.IsEventDone("use_lvl3weapon") and cmn.IsEventDone("use_flashcardwithskills") and not cmn.IsEventDone("opn_robotready") then
      
      private.opn_robot_dialog();
      
    end;
    
  end;
  
  function zz_generator.PreOpen()
    
    cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_electric_field_env");
    
  end;
  
  function zz_generator.PreClose()
    
    cmn.StopAllEnv("assets/levels/level3/audio/env/aud_rm_laboratory_env");
    cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_laboratory_env");
    
    if cmn.IsEventDone("clk_labslighton") then
      cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_moment_fan_loc_env");
    end;
    
  end;
  
  function zz_generator.Close()
    
    if cmn.IsEventDone("clk_labslighton") and not cmn.IsEventDone("opn_laboratorylight") then
      
      local func_after = function ()
        
        cmn.Lock( 0 );
        cmn.CallEventHandler( "clk_labslighton" );
        cmn.ShowBbt( "laboratory_after_light" );
        
        if cmn.IsCollectableAvailible(9) then
          private.AnimMorphObject();
        end;
        
      end;
      
      local anm_light = function ()
      
        ObjDelete("vid_laboratory_generator_1");
        
        ObjAttach("vid_laboratory_generator_2", "spr_laboratory_back_2");
        ObjSet("vid_laboratory_generator_2",  { playing = 1 });
        
        ObjAttach("vid_laboratory_generator_3", "obj_laboratory_generator");
        ObjSet("vid_laboratory_generator_3",  { playing = 1 });
        
        ObjAnimate("spr_laboratory_back_2", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
        ObjAnimate("spr_laboratory_generator_handle", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
        ObjAnimate("spr_laboratory_generator_handle_2", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
        
      end;
      
      cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_moment_fan_loc_env");
      
      cmn.SetEventDone("opn_laboratorylight");
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_loc_air");
      VidPlay("vid_laboratory_generator_1", anm_light);
      
    end;
    
  end;

  function zz_labdesk.PreOpen()
    
    if cmn.IsEventDone( "use_baton" ) and cmn.IsEventDone( "use_lvl3wires" ) and cmn.IsEventDone( "use_design" ) 
    and not cmn.IsEventDone( "win_labdesk" ) then
      cmn.MiniGameShow();
      private.zz_labdesk.DrawScene();
    end;

  end;
  
  function zz_labdesk.PreClose()
    
    if cmn.IsEventDone( "use_baton" ) and cmn.IsEventDone( "use_lvl3wires" ) and cmn.IsEventDone( "use_design" )
    and not cmn.IsEventDone( "win_labdesk" ) then
      cmn.MiniGameHide( "labdesk" );
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load()

  if not(ng_global.progress[ ng_global.currentprogress ][ "win_labdesk" ].state) then 
    private.zz_labdesk.StartConditions();
  end;
  private.zz_labdesk.state = ng_global.progress[ ng_global.currentprogress ][ "win_labdesk" ].state;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_laboratory();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level3/audio/env/aud_rm_laboratory_env");
  cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_laboratory_env");
  
  if cmn.IsEventDone("clk_labslighton") then
    cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_moment_fan_loc_env");
  end;
  
  ObjSet("rm_laboratory",  { color_r = 1, color_g = 1, color_b = 1 });
  
  if cmn.IsEventDone("use_lvl3weapon") and cmn.IsEventDone("use_flashcardwithskills") and not cmn.IsEventDone("opn_robotready") then
    cmn.Lock( 1 );
  end;
  
  if cmn.IsEventDone("clk_labslighton") then
    ObjSet("vid_laboratory_generator_3",  { playing = 1 });
  end;

  --анимация морф-оъекта
  if cmn.IsEventDone("clk_labslighton") and cmn.IsCollectableAvailible(9) then
    private.AnimMorphObject();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_generatorbutton()

  local item = "inv_generatorbutton";

  if cmn.ApplyObj( item, "gzz_laboratory_generator" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_generator" );

  elseif ( cmn.ApplyObj( item, "obj_generator_use_generatorbutton" ) ) then

    cmn.CallEventHandler( "use_generatorbutton_inv" );
    cmn.CallEventHandler( "use_generatorbutton_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_generatorbutton" );
      cmn.CallEventHandler( "use_generatorbutton_end" );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_button_zz_generator");

    ObjAnimate("spr_generator_button_1", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_masterswitch()

  local item = "inv_masterswitch";

  if cmn.ApplyObj( item, "gzz_laboratory_generator" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_generator" );

  elseif ( cmn.ApplyObj( item, "obj_generator_use_masterswitch" ) ) then

    cmn.CallEventHandler( "use_masterswitch_inv" );
    cmn.CallEventHandler( "use_masterswitch_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_masterswitch" );
      cmn.CallEventHandler( "use_masterswitch_end" );
    
    end;
    
    local anm_charge = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_lever_zz_generator");
      ObjSet("anm_generator_switch",  { frame = 0, animfunc = "func_use_handle2", playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_lever_hole_1");

    if cmn.IsEventDone("use_unchargedbattery") then
      ObjSet("anm_generator_switch",  { alp = 1, playing = 1, endtrig = anm_charge });
    else 
      ObjSet("anm_generator_switch",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_unchargedbattery()

  local item = "inv_unchargedbattery";

  if cmn.ApplyObj( item, "gzz_laboratory_generator" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_generator" );

  elseif ( cmn.ApplyObj( item, "obj_generator_use_unchargedbattery" ) ) then

    cmn.CallEventHandler( "use_unchargedbattery_inv" );
    cmn.CallEventHandler( "use_unchargedbattery_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_unchargedbattery" );
      cmn.CallEventHandler( "use_unchargedbattery_end" );
    
    end;

    local anm_charge = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_lever_zz_generator");
      ObjSet("anm_generator_switch",  { frame = 0, animfunc = "func_use_handle2", playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_battery_hole");

    if cmn.IsEventDone("use_masterswitch") then
      ObjSet("anm_generator_battery",  { alp = 1, playing = 1, endtrig = anm_charge });
    else 
      ObjSet("anm_generator_battery",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_glove()

  local item = "inv_glove";

  if cmn.ApplyObj( item, "gzz_laboratory_generator" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_generator" );

  elseif ( cmn.ApplyObj( item, "obj_generator_use_glove" ) ) then

    cmn.CallEventHandler( "use_glove_inv" );
    cmn.CallEventHandler( "use_glove_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_glove" );
      cmn.CallEventHandler( "use_glove_end" );
      
      public.get_victorspicture();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_take_magnet_field");

    ObjSet("anm_generator_use_glove",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_baton()

  local item = "inv_baton";

  if cmn.ApplyObj( item, "gzz_laboratory_labdesk" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_labdesk", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_labdesk_use_baton" ) ) then

    cmn.CallEventHandler( "use_baton_inv" );
    cmn.CallEventHandler( "use_baton_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_baton" );
      cmn.CallEventHandler( "use_baton_end" );

      if ( cmn.IsEventDone( "use_design" ) and cmn.IsEventDone( "use_lvl3wires" ) ) then
        cmn.MiniGameShow();
        private.zz_labdesk.DrawScene();
      end;
    
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio( "snd", "assets/levels/level3/audio/sfx/aud_mmg_zz_labdesk_put_stick" );

    ObjAnimate( "obj_labdesk_screw", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
    ObjAnimate( "obj_labdesk_sword", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl3wires()

  local item = "inv_lvl3wires";

  if cmn.ApplyObj( item, "gzz_laboratory_labdesk" ) and cmn.IsEventDone("use_electricianskey") then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_labdesk", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_labdesk_use_lvl3wires" ) ) then

    cmn.CallEventHandler( "use_lvl3wires_inv" );
    cmn.CallEventHandler( "use_lvl3wires_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl3wires" );
      cmn.CallEventHandler( "use_lvl3wires_end" );

      if ( cmn.IsEventDone( "use_baton" ) and cmn.IsEventDone( "use_design" ) ) then
        cmn.MiniGameShow();
        private.zz_labdesk.DrawScene();
      end;
    
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio( "snd", "assets/levels/level3/audio/sfx/aud_mmg_zz_labdesk_put_wires_table" );

    ObjAnimate( "obj_labdesk_wire", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_design()

  local item = "inv_design";

  if cmn.ApplyObj( item, "gzz_laboratory_labdesk" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_labdesk", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_labdesk_use_design" ) ) then

    cmn.CallEventHandler( "use_design_inv" );
    cmn.CallEventHandler( "use_design_beg" );

    if not cmn.IsEventDone("get_hacksaw") or not cmn.IsEventDone("get_securityemblem2") then
      
      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
      
      if not cmn.IsEventDone("get_hacksaw") then
        cmn.SetEventDone( "get_hacksaw" );
        cmn.CallEventHandler( "get_hacksaw" );
      end;
      
      if not cmn.IsEventDone("get_securityemblem2") then
        cmn.SetEventDone( "get_securityemblem2" );
        cmn.CallEventHandler( "get_securityemblem2" );
      end;
      
    end;

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_design" );
      cmn.CallEventHandler( "use_design_end" );

      if ( cmn.IsEventDone( "use_baton" ) and cmn.IsEventDone( "use_lvl3wires" ) ) then
        cmn.MiniGameShow();
        private.zz_labdesk.DrawScene();
      end;
    
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio( "snd", "assets/levels/level3/audio/sfx/aud_mmg_zz_labdesk_put_paper" );

    ObjAnimate( "spr_labdesk_paper", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
    ObjAnimate( "spr_labdesk_paper_shadow", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_chargedbattery()

  local item = "inv_chargedbattery";

  if cmn.ApplyObj( item, "gzz_laboratory_prototype" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_prototype", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_prototype_use_chargedbattery" ) ) then

    cmn.CallEventHandler( "use_chargedbattery_inv" );
    cmn.CallEventHandler( "use_chargedbattery_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_chargedbattery" );
      cmn.CallEventHandler( "use_chargedbattery_end" );
    
    end;
    
    local anm_alive = function ()
      
      ObjMultiSet( { {"anm_prototype_robot_alive", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_prototype_robot_alive_2", { alp = 1, playing = 1 }},
                     {"obj_prototype_robot_1", { alp = 0 }} } );
      
    end;
    
    local anm_close = function ()
      
      ObjAnimate("obj_prototype_battery_open", "alp", 0, 0, anm_alive, { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("anm_prototype_battery_touch", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_battery_robot");

    ObjAnimate( "spr_prototype_chargedbattery", "alp", 0, 0, anm_close, { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_programm()

  local item = "inv_programm";

  if cmn.ApplyObj( item, "gzz_laboratory_prototype" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_prototype", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_prototype_use_programm" ) ) then

    cmn.CallEventHandler( "use_programm_inv" );
    cmn.CallEventHandler( "use_programm_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_programm" );
      cmn.CallEventHandler( "use_programm_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_robot_insert_disk_1");
    
    local anm_open = function ()
      
      ObjAnimate("obj_prototype_battery_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("anm_prototype_battery_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;

    ObjSet("anm_prototype_use_programm",  { alp = 1, playing = 1, endtrig = anm_open });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl3weapon()

  local item = "inv_lvl3weapon";

  if cmn.ApplyObj( item, "gzz_laboratory_prototype" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_prototype", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_prototype_use_lvl3weapon" ) ) then

    cmn.CallEventHandler( "use_lvl3weapon_inv" );
    cmn.CallEventHandler( "use_lvl3weapon_beg" );

    local func_after = function ()

      cmn.SetEventDone( "use_lvl3weapon" );
      cmn.CallEventHandler( "use_lvl3weapon_end" );
      
      if cmn.IsEventDone( "use_flashcardwithskills" ) then
        common.CloseSubRoom();
      else 
        cmn.Lock( 0 );
      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_take_pistol_robot");
    
    ObjAnimate("obj_prototype_weapon", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_flashcardwithskills()

  local item = "inv_flashcardwithskills";

  if cmn.ApplyObj( item, "gzz_laboratory_prototype" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_prototype", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_prototype_use_flashcardwithskills" ) ) then

    cmn.CallEventHandler( "use_flashcardwithskills_inv" );
    cmn.CallEventHandler( "use_flashcardwithskills_beg" );

    local func_after = function ()

      cmn.SetEventDone( "use_flashcardwithskills" );
      cmn.CallEventHandler( "use_flashcardwithskills_end" );
      
      if cmn.IsEventDone( "use_lvl3weapon" ) then
        common.CloseSubRoom();
      else 
        cmn.Lock( 0 );
      end;

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_flash_robot");
    
    local anm_insert = function ()
      ObjSet("anm_prototype_use_flashdrive",  { playing = 1, endtrig = func_after });
    end;
    
    ObjAnimate("anm_prototype_use_flashdrive", "alp", 0, 0, anm_insert, { 0, 0, 0,   0.3, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_flashcard()

  local item = "inv_flashcard";

  if cmn.ApplyObj( item, "gzz_laboratory_labcomputer" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_labcomputer" );

  elseif ( cmn.ApplyObj( item, "obj_labcomputer_use_flashcard" ) ) then

    cmn.CallEventHandler( "use_flashcard_inv" );
    cmn.CallEventHandler( "use_flashcard_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_flashcard" );
      cmn.CallEventHandler( "use_flashcard_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_flash_monitor");
    
    local anm_load_end = function ()
      ObjAnimate("anm_labcomputer_loading", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
    end;
    
    local anm_load = function ()
      ObjDelete("spr_labcomputer_screen_1");
      ObjSet("anm_labcomputer_loading",  { alp = 1, playing = 1, endtrig = anm_load_end });
    end;
    
    local anm_move = function ()
      ObjAnimate("spr_labcomputer_flashcardwithskills", "pos_xy", 0, 0, anm_load, { 0, 0, 197, -188,   0.6, 0, 123, -206 });
    end;

    ObjAnimate( "spr_labcomputer_flashcardwithskills", "alp", 0, 0, anm_move, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_disk()

  local item = "inv_disk";

  if cmn.ApplyObj( item, "gzz_laboratory_labcomputer" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_labcomputer" );

  elseif ( cmn.ApplyObj( item, "obj_labcomputer_use_disk" ) ) then

    cmn.CallEventHandler( "use_disk_inv" );
    cmn.CallEventHandler( "use_disk_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_disk" );
      cmn.CallEventHandler( "use_disk_end" );
    
    end;
    
    local anm_ball = function ()
      ObjAnimate("anm_labcomputer_loading", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjSet("anm_labcomputer_aionsworls",  { playing = 1, endtrig = func_after });
    end;
    
    local anm_load = function ()
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zz_labcomputer_upload");
      ObjSet("anm_labcomputer_loading",  { alp = 1, playing = 1, endtrig = anm_ball });
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_disk_zz_labcomputer");

    if ( cmn.IsEventDone( "use_worldnucleus" ) ) then
      ObjSet("anm_labcomputer_disk_use",  { alp = 1, playing = 1, endtrig = anm_load });
    else 
      ObjSet("anm_labcomputer_disk_use",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_worldnucleus()

  local item = "inv_worldnucleus";

  if cmn.ApplyObj( item, "gzz_laboratory_labcomputer" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_labcomputer" );

  elseif ( cmn.ApplyObj( item, "obj_labcomputer_use_worldnucleus" ) and cmn.IsEventDone("clk_worldnucleus") ) then

    cmn.CallEventHandler( "use_worldnucleus_inv" );
    private.use_worldnucleus_end();
    
  elseif ( cmn.ApplyObj( item, "obj_labcomputer_use_worldnucleus" ) and not cmn.IsEventDone("clk_worldnucleus") ) then

    cmn.CallEventHandler( "use_worldnucleus_inv" );
    public.clk_worldnucleus(2);

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function private.use_worldnucleus_end()

  cmn.CallEventHandler( "use_worldnucleus_beg" );

  local func_after = function ()

    cmn.Lock( 0 );

    cmn.SetEventDone( "use_worldnucleus" );
    cmn.CallEventHandler( "use_worldnucleus_end" );
  
  end;
  
  local anm_ball = function ()
    ObjAnimate("anm_labcomputer_loading", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    ObjSet("anm_labcomputer_aionsworls",  { playing = 1, endtrig = func_after });
  end;
  
  local anm_load = function ()
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zz_labcomputer_upload");
    ObjSet("anm_labcomputer_loading",  { alp = 1, playing = 1, endtrig = anm_ball });
  end;
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_ball_stuff");

  if ( cmn.IsEventDone( "use_disk" ) ) then
    ObjAnimate( "obj_labcomputer_aionsworld", "alp", 0, 0, anm_load, { 0, 0, 0,    0.3, 0, 1,    0.5, 0, 1 } );
  else 
    ObjAnimate( "obj_labcomputer_aionsworld", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_chargedbattery()
  
  ObjSet("spr_generator_chargedbattery",  { alp = 1 });

  cmn.SetEventDone( "get_chargedbattery" );
  cmn.CallEventHandler( "get_chargedbattery" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_repairamulet2()

  cmn.SetEventDone( "get_repairamulet2" );
  cmn.CallEventHandler( "get_repairamulet2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_victorspicture()

  cmn.SetEventDone( "get_victorspicture" );
  cmn.CallEventHandler( "get_victorspicture" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_securityemblem2()

  cmn.SetEventDone( "get_securityemblem2" );
  cmn.CallEventHandler( "get_securityemblem2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_programm()

  cmn.SetEventDone( "get_programm" );
  cmn.CallEventHandler( "get_programm" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_coin3()

  cmn.SetEventDone( "get_coin3" );
  cmn.CallEventHandler( "get_coin3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_hacksaw()

  cmn.SetEventDone( "get_hacksaw" );
  cmn.CallEventHandler( "get_hacksaw" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_lvl3weapon()

  cmn.SetEventDone( "get_lvl3weapon" );
  cmn.CallEventHandler( "get_lvl3weapon" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_securityemblem1()

  cmn.SetEventDone( "get_securityemblem1" );
  cmn.CallEventHandler( "get_securityemblem1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_unchargedbattery()

  cmn.SetEventDone( "get_unchargedbattery" );
  cmn.CallEventHandler( "get_unchargedbattery" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_design()

  cmn.SetEventDone( "get_design" );
  cmn.CallEventHandler( "get_design" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_tumbler1()

  cmn.SetEventDone( "get_tumbler1" );
  cmn.CallEventHandler( "get_tumbler1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_masterswitch()

  cmn.SetEventDone( "get_masterswitch" );
  cmn.CallEventHandler( "get_masterswitch" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_flashcardwithskills()

  cmn.SetEventDone( "get_flashcardwithskills" );
  cmn.CallEventHandler( "get_flashcardwithskills" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_aionsworld()

  cmn.SetEventDone( "get_aionsworld" );
  cmn.CallEventHandler( "get_aionsworld" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_coin3()

  cmn.SetEventDone( "get_coin3" );
  cmn.CallEventHandler( "get_coin3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_labslighton()

  local func_after = function ()
    
    --cmn.Lock( 0 );

    cmn.SetEventDone( "clk_labslighton" );
    
    common.CloseSubRoom();
  
  end;
  
  ObjDelete("spr_laboratory_generator_button_1");
  ObjSet("spr_laboratory_generator_button_2",  { alp = 1 });
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_click_red_button_light");
  
  ObjAnimate("spr_generator_button_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
  ObjAnimate("spr_generator_button_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });

end;
--------------------------------------------------------------------------------------------
function public.clk_worldnucleus(num)

  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_take_broken_ball");

  local func_after = function ()

    cmn.SetEventDone( "clk_worldnucleus" );
    cmn.CallEventHandler( "clk_worldnucleus" );

    if num == 1 then
      cmn.Lock(0);
    else 
      private.use_worldnucleus_end();
    end;

  end;
  
  ObjAnimate("spr_labcomputer_broken_ball", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_laboratory()

  if not ( cmn.IsEventDone( "opn_laboratory" ) ) then
    cmn.SetEventDone( "opn_laboratory" );
    cmn.CallEventHandler("opn_laboratory");
    cmn.ShowBbt( "laboratory_open" );
  end;
  
  if cmn.IsEventDone("use_lvl3weapon") and cmn.IsEventDone("use_flashcardwithskills") and not cmn.IsEventDone("opn_robotready") then
    private.opn_robot_dialog();
  end;

end;
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_9_1", { alp = 1 }},
                 {"spr_col_9_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_9_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_9_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_9_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_9_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_9_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_9_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_generator_door()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_zz_generator_1");

  cmn.ShowBbt( "obj_generator_use_electricianskey" );
  
  ObjSet( "anm_generator_door", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_generator_electricity()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_zz_generator_1_magnet_field");

  cmn.ShowBbt( "obj_generator_use_glove" );
  
  ObjSet( "anm_generator_handle_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_generator_switch()
  
  cmn.ShowBbt( "obj_generator_use_masterswitch" );
  
  if cmn.IsEventDone("use_unchargedbattery") then
  
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_lever_zz_generator");
    
    ObjSet( "anm_generator_battery", { playing = 1, endtrig = function() cmn.Lock(0); end } );
      
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_generator_battery()
  
  cmn.ShowBbt( "obj_generator_use_unchargedbattery" );
  
  if cmn.IsEventDone("use_masterswitch") then
  
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_lever_2_zz_generator");
    
    ObjSet( "anm_generator_switch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
      
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_computer_screen()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_flash_drive");

  cmn.ShowBbt( "obj_labcomputer_use_flashcard" );
  
  ObjAnimate("txt_labcomputer_screen_1", "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 1,   0.2, 0, 0,    0.4, 0, 1,     0.6, 0, 0,    0.8, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_computer_stand()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_for_ball");

  cmn.ShowBbt( "obj_labcomputer_use_worldnucleus" );
  
  ObjSet( "anm_labcomputer_stand_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_prototype_programm()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_left_robot");

  cmn.ShowBbt( "obj_prototype_use_programm" );
  
  ObjSet( "anm_prototype_battery_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_prototype_battery()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_robot_head");

  cmn.ShowBbt( "obj_prototype_use_chargedbattery" );
  
  ObjMultiSet( { {"anm_prototype_head", { playing = 1 }},
                 {"anm_prototype_hand_1", { playing = 1, endtrig = function() cmn.Lock(0); end }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_prototype_flash()
  
  cmn.ShowBbt( "obj_prototype_use_flashcardwithskills" );
  
  if not cmn.IsEventDone("use_chargedbattery") then
  
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_robot_head");

    ObjSet( "anm_prototype_head", { playing = 1, endtrig = function() cmn.Lock(0); end } );
      
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_prototype_hand()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_robot_hand");

  cmn.ShowBbt( "obj_prototype_use_lvl3weapon" );
  
  ObjSet( "anm_prototype_hand_2_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function private.opn_robot_dialog()
  
  cmn.SetEventDone("opn_robotready");

  ObjAttach("obj_laboratory_dialog_robot", "rm_laboratory");
  ObjAnimate("obj_laboratory_dialog_robot", "alp", 0, 0, private.dialog_robot_beg, { 0, 0, 0,   0.5, 0, 1 });

end;
--------------------------------------------------------------------------------------------
function private.dialog_robot_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "laboratory", "robot", 2 );
  
  local func_after = function ()
    
    cmn.CallEventHandler( "opn_robotready" );
    
    ObjSet("rm_laboratory",  { color_r = 0, color_g = 0, color_b = 0 });
    cmn.GotoRoom("rm_debughall");
    
    cmn.ShowBbt( "debughall_after_robotattack" );
    interface_impl.ShowGlobalTask();
    int_diary.AddDiarypage( 18 );
    
  end;
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    --cmn.CallEventHandler( "opn_robotready" );
    common_impl.current_dialog = "";
    
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level3/rm_laboratory/vid_robotattack", func_after, "assets/levels/level3/audio/mus/aud_vid_robotattack_mus" );
    
  end;
  
  local anm_hide = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_laboratory_dialog_robot_lipsync2");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_laboratory_dialog_robot_timer",  { playing = 0 }},
                   {"spr_laboratory_dialog_robot_head", { alp = 1 }} } );
    
    ObjAnimate("obj_laboratory_dialog_robot", "alp", 0, 0, dialog_end, { 0, 0, 1,   0.6, 0, 0 });
    
  end;
  
  local robot_talks2 = function ()
  
    ObjDelete("vid_laboratory_dialog_robot_lipsync1");
    ObjAttach("vid_laboratory_dialog_robot_lipsync2", "obj_laboratory_dialog_robot");
  
    cmn.ShowDlgBbt( "dlg_robot_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_robot_2_voc");
    
    private.dlg_lipsync = "vid_laboratory_dialog_robot_lipsync2";
    
    ObjMultiSet( { {"tmr_laboratory_dialog_robot_timer", { endtrig = anm_hide, time = 8, playing = 1 }},
                   {"vid_laboratory_dialog_robot_lipsync2", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_hide }},
                   {"obj_character_dialog_continue", { event_mup = anm_hide }} } );
  
  end;
  
  private.dlg_lipsync = "vid_laboratory_dialog_robot_lipsync1";

  cmn.ShowDlgBbt( "dlg_robot_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_robot_1_voc");

  ObjMultiSet( { {"tmr_laboratory_dialog_robot_timer", { time = 6, playing = 1, endtrig = robot_talks2 }},
                 {"vid_laboratory_dialog_robot_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = robot_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = robot_talks2 }} } );
  
end; 
--------------------------------------------------------------------------------------------
function public.skip_dlg_robot()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  common_impl.current_dialog = "";
  
  local func_after = function ()
    
    cmn.CallEventHandler( "opn_robotready" );
    
    ObjSet("rm_laboratory",  { color_r = 0, color_g = 0, color_b = 0 });
    cmn.GotoRoom("rm_debughall");
    
    cmn.ShowBbt( "debughall_after_robotattack" );
    interface_impl.ShowGlobalTask();
    int_diary.AddDiarypage( 18 );
    
  end;
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    --cmn.CallEventHandler( "opn_robotready" );
    
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level3/rm_laboratory/vid_robotattack", func_after, "assets/levels/level3/audio/mus/aud_vid_robotattack_mus" );
    
  end;
  
  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    ObjSet("spr_laboratory_dialog_robot_head",  { alp = 1 });
    private.dlg_lipsync = "";
  end;

  ObjSet("tmr_laboratory_dialog_robot_timer",  { playing = 0 });
  
  common_impl.CharacterDialogButtonsHide();
  
  --common_impl.PlayBackgroundMusic();
  
  ObjAnimate("obj_laboratory_dialog_robot", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.6, 0, 0 });
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Labdesk *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_labdesk = {};
public.zz_labdesk = {};

function private.Init_Labdesk()

  private.zz_labdesk.labdesk_progress = {
    "use_labdesk_screwdriver1",
    "clk_labdesk_baton",

    "clk_labdesk_batoncover1",
    "clk_labdesk_magnifier",
    "use_labdesk_wire",
    "win_labdesk_magnifier",
    "clk_labdesk_batoncover2",

    "use_labdesk_bladehandl",
    "use_labdesk_blade",
    "use_labdesk_screw",
    "use_labdesk_screwdriver2"
  };

  private.zz_labdesk.wire_cover_win_pos = {3,1,2};

  -----------------------------------------------------------------------------------
  game.hint[ "win_labdesk" ] = {
    type = "win",
    room = "rm_laboratory",
    zz = "zz_labdesk",
    zz_gate = "gzz_laboratory_labdesk"
  };
  -----------------------------------------------------------------------------------
  local win_labdesk = function ()

    if cmn.IsEventDone( "win_labdesk" ) then
      
      ObjDelete( "obj_labdesk_game2" );
      ObjDelete( "obj_labdesk_game" );
      ObjDelete( "obj_labdesk_blade_handl" );
      ObjDelete( "obj_labdesk_draghub" );
      
      ObjDelete( "spr_laboratory_desk_wires" );
      ObjDelete( "spr_laboratory_desk_baton" );
      ObjDelete( "spr_laboratory_desk_blade_1" );
      ObjDelete( "spr_laboratory_desk_blade_2" );
      ObjDelete( "spr_laboratory_desk_screws" );
      ObjDelete( "spr_laboratory_desk_handle" );

      ObjMultiSet( {
        { "anm_labdesk_sword_on", { input = true, alp = 1, animfunc = "func_sword", endtrig = "", playing = true } },
        { "gfx_labdesk_lvl3weapon", { active = true } },
        { "spr_laboratory_desk_baton_2", { alp = 1 } }
      } );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_labdesk", win_labdesk, "rm_laboratory" );

end;
-----------------------------------------------------------------------------------
function private.zz_labdesk.StartConditions()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_labdesk" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_labdesk" ].state = { 
    events = {  --события
      use_labdesk_screwdriver1 = false,
      clk_labdesk_baton = false,

      clk_labdesk_batoncover1 = false,
      clk_labdesk_magnifier = false,
      use_labdesk_wire = false,
      win_labdesk_magnifier = false,
      clk_labdesk_batoncover2 = false,

      use_labdesk_bladehandl = false,
      use_labdesk_blade = false,
      use_labdesk_screw = false,
      use_labdesk_screwdriver2 = false
    },
    wire_pos = {2,3,1},
    last_cover = 0
  };
  
end;
-----------------------------------------------------------------------------------
function public.zz_labdesk.Reset()

  if not private.zz_labdesk.state.events[ private.zz_labdesk.labdesk_progress[1] ] then
    return;
  end;

  cmn.Lock( 1 );

  --DbgTrace( "***Reset" );

  local old_state = private.zz_labdesk.state;

  local func_after = function () 

    for i = 1, 3, 1 do
      if private.zz_labdesk.state.wire_pos[i] ~= old_state.wire_pos[i] then
        ObjSet( "spr_labdesk_wire_"..old_state.wire_pos[i]..i, { alp = 0 } );
      end;
    end;

    if old_state.last_cover ~= 0 then
      ObjMultiSet( {
        { "spr_labdesk_wire_"..old_state.wire_pos[old_state.last_cover]..old_state.last_cover.."b", { alp = 0 } },
        { "anm_labdesk_wire_cover_"..old_state.last_cover, { animfunc = "func_wire_cover_"..old_state.last_cover.."_open", frame = 0 } }
      } );
    end;

    private.zz_labdesk.DrawScene(true);

    ObjAnimate( "anm_labdesk_use_magnifier_1", "alp", 0, 0, "", { 0, 0, 0,    0.5, 0, 1 } );
    ObjAnimate( "anm_labdesk_use_magnifier_2", "alp", 0, 0, "", { 0, 0, 0,    0.5, 0, 1 } );

    ObjAnimate( "obj_labdesk_game2", "alp", 0, 0, "", { 0, 0, 0,    0.5, 0, 1 } );
    ObjAnimate( "obj_labdesk_game", "alp", 0, 0, "", { 0, 0, 0,    0.5, 0, 1 } );
    ObjAnimate( "obj_labdesk_blade_handl", "alp", 0, 0, function () cmn.Lock( 0 ); end, { 0, 0, 0,    0.5, 0, 1 } );

  end;

  if not private.zz_labdesk.state.events.use_labdesk_bladehandl then
    ObjAnimate( "obj_labdesk_blade_handl", "alp", 0, 0, "", { 0, 0, 1,    0.5, 0, 0 } );
  end;

  private.zz_labdesk.StartConditions();
  private.zz_labdesk.state = ng_global.progress[ ng_global.currentprogress ][ "win_labdesk" ].state;

  ObjAnimate( "anm_labdesk_use_magnifier_1", "alp", 0, 0, "", { 0, 0, 1,    0.5, 0, 0 } );
  ObjAnimate( "anm_labdesk_use_magnifier_2", "alp", 0, 0, "", { 0, 0, 1,    0.5, 0, 0 } );

  ObjAnimate( "obj_labdesk_game2", "alp", 0, 0, "", { 0, 0, 1,    0.5, 0, 0 } );
  ObjAnimate( "obj_labdesk_game", "alp", 0, 0, func_after, { 0, 0, 1,    0.5, 0, 0 } );

end;
-----------------------------------------------------------------------------------
function public.zz_labdesk.Skip()

  --DbgTrace( "***Skip" );

  cmn.Lock( 1 );

  ng_global.progress[ ng_global.currentprogress ][ "win_labdesk" ].skip = 1;

  cmn.MiniGameHide("labdesk");
  cmn.SetEventDone( "win_labdesk" );

  local func_after = function ()
    ObjSet( "anm_labdesk_sword_on", { endtrig = private.zz_labdesk.Win, playing = true } );
  end;

  if private.zz_labdesk.state.events.clk_labdesk_magnifier
  and not private.zz_labdesk.state.events.win_labdesk_magnifier then

    local func_magnifier = function ()
      ObjMultiSet( {
        { "anm_labdesk_use_magnifier_1", { animfunc = "func_use_magnifier_1", frame = 0 } },
        { "anm_labdesk_use_magnifier_2", { animfunc = "func_use_magnifier_2", frame = 0 } }
      } );

      ObjAnimate( "anm_labdesk_use_magnifier_1", "alp", 0, 0, "", { 0, 0, 0,    0.5, 0, 1 } );
      ObjAnimate( "anm_labdesk_use_magnifier_2", "alp", 0, 0, "", { 0, 0, 0,    0.5, 0, 1 } );
    end;

    ObjAnimate( "anm_labdesk_use_magnifier_1", "alp", 0, 0, "", { 0, 0, 1,    0.5, 0, 0 } );
    ObjAnimate( "anm_labdesk_use_magnifier_2", "alp", 0, 0, func_magnifier, { 0, 0, 1,    0.5, 0, 0 } );

  end;

  if not private.zz_labdesk.state.events.use_labdesk_bladehandl then
    ObjAnimate( "obj_labdesk_blade_handl", "alp", 0, 0, "", { 0, 0, 1,    0.5, 0, 0 } );
  end;

  ObjAnimate( "obj_labdesk_game2", "alp", 0, 0, "", { 0, 0, 1,    0.5, 0, 0 } );
  ObjAnimate( "obj_labdesk_game", "alp", 0, 0, "", { 0, 0, 1,    0.5, 0, 0 } );

  ObjAnimate( "anm_labdesk_sword_on", "alp", 0, 0, func_after, { 0, 0, 0,    0.5, 0, 0,    1, 0, 1 } );

end;
-----------------------------------------------------------------------------------
function private.zz_labdesk.DrawScene(is_reset)

  if private.zz_labdesk.draw_scene and not is_reset then
    return;
  end;
  private.zz_labdesk.draw_scene = true;

  for i = 1, #private.zz_labdesk.labdesk_progress, 1 do

    --DbgTrace(
    --  private.zz_labdesk.labdesk_progress[i].." == "..tostring(private.zz_labdesk.state.events[ private.zz_labdesk.labdesk_progress[i] ])
    --);

    if ( private.zz_labdesk.state.events[ private.zz_labdesk.labdesk_progress[i] ] ) then
      if ( private.zz_labdesk[ private.zz_labdesk.labdesk_progress[i].."_end"] ) then
        private.zz_labdesk[ private.zz_labdesk.labdesk_progress[i].."_end"]();
      end;
    else
      if ( private.zz_labdesk[ private.zz_labdesk.labdesk_progress[i].."_start"] ) then
        private.zz_labdesk[ private.zz_labdesk.labdesk_progress[i].."_start"]();
      end;
    end;

  end;

  local win_cover_sum = 0;

  for i = 1, 3, 1 do

    if private.zz_labdesk.state.last_cover == i then
      ObjMultiSet( {
        { "spr_labdesk_wire_"..private.zz_labdesk.state.wire_pos[i]..i.."b", { alp = 1 } },
        { "spr_labdesk_wire_"..private.zz_labdesk.state.wire_pos[i]..i, { alp = 0 } },
        { "anm_labdesk_wire_cover_"..i, { animfunc = "func_wire_cover_"..i.."_close", frame = 0 } }
      } );
    else
      ObjMultiSet( {
        { "spr_labdesk_wire_"..private.zz_labdesk.state.wire_pos[i]..i.."b", { alp = 0 } },
        { "spr_labdesk_wire_"..private.zz_labdesk.state.wire_pos[i]..i, { alp = 1 } },
        { "anm_labdesk_wire_cover_"..i, { animfunc = "func_wire_cover_"..i.."_open", frame = 0 } }
      } );
    end;

    if private.zz_labdesk.state.wire_pos[i] == private.zz_labdesk.wire_cover_win_pos[i] then
      win_cover_sum = win_cover_sum + 1;
      ObjMultiSet( {
        { "obj_labdesk_wire_cover_"..i, { input = false } },
        { "spr_labdesk_red_lamp"..i, { alp = 0 } },
        { "spr_labdesk_green_lamp"..i, { alp = 1 } }
      } );
    else
      ObjMultiSet( {
        { "spr_labdesk_red_lamp"..i, { alp = 1 } },
        { "spr_labdesk_green_lamp"..i, { alp = 0 } }
      } );
    end;

  end;

  if win_cover_sum == 3 and not private.zz_labdesk.state.events.win_labdesk_magnifier then
    cmn.Lock( 1 );
    private.zz_labdesk.check_wire_cover();
  end;


end;
-----------------------------------------------------------------------------------
function private.zz_labdesk.CheckWin()

end;
-----------------------------------------------------------------------------------
function private.zz_labdesk.Win()
  
  cmn.Lock( 0 );

  cmn.SetEventDone( "win_labdesk" );
  cmn.CallEventHandler( "win_labdesk" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_labdesk" ].skip == 0 and ng_global.noskipgames[ "win_labdesk" ] == nil then

    ng_global.noskipgames[ "win_labdesk" ] = 1;
    common_impl.CheckAchiev("mg");

  end;
  
end;
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------
function private.zz_labdesk.ItemDropFlyBackAnim( item )

  --DbgTrace( "***ItemDropFlyBackAnim" );

  cmn.Lock( 1 );

  local func_after = function () 
    if item == "obj_labdesk_screw" then
      ObjAttach( item, "obj_labdesk_game" ); 
    elseif item == "obj_labdesk_blade_handl" then
      ObjAttach( item, "zz_labdesk" ); 
    else
      ObjAttach( item, "obj_labdesk_game2" ); 
    end;

    cmn.Lock( 0 );
  end;

  local curspos = GetObjPosByObj( item, "obj_labdesk_draghub" );
  local item_pos = { ObjGet( item ).pos_x, ObjGet( item ).pos_y };

  --DbgTrace( curspos[1].." "..curspos[2].." -> "..item_pos[1].." "..item_pos[2] );

  if item == "obj_labdesk_blade" then
    ObjAnimate( "spr_labdesk_blade_2_shadow", "alp", 0, 0, "", { 0, 0, 0,    0.25, 0, 0,    0.3, 0, 1 } );
    ObjAnimate( "spr_labdesk_blade_1_shadow", "alp", 0, 0, "", { 0, 0, 0,    0.25, 0, 0,    0.3, 0, 1 } );
  elseif item == "obj_labdesk_screw" then
    ObjAnimate( "spr_labdesk_screw_1_shadow", "alp", 0, 0, "", { 0, 0, 0,    0.25, 0, 0,    0.3, 0, 1 } );
    ObjAnimate( "spr_labdesk_screw_2_shadow", "alp", 0, 0, "", { 0, 0, 0,    0.25, 0, 0,    0.3, 0, 1 } );
  else
    ObjAnimate( item.."_shadow", "alp", 0, 0, "", { 0, 0, 0,    0.25, 0, 0,    0.3, 0, 1 } );
  end;

  ObjAnimate( item, "pos_xy", 0, 0, func_after, { 
    0,   0, curspos[1],  curspos[2],    
    0.3, 0, item_pos[1], item_pos[2] 
  } );

end;
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------use_labdesk_screwdriver1
function public.zz_labdesk.use_labdesk_screwdriver1_start_drag()
  ObjSet( "spr_labdesk_screwdriver_shadow", { alp = 0 } );
  ObjAttach( "spr_labdesk_screwdriver", "obj_labdesk_draghub" );
end;
function private.zz_labdesk.use_labdesk_screwdriver1_start()
  --DbgTrace( "***use_labdesk_screwdriver1_start" );
  ObjMultiSet( { { "spr_labdesk_screwdriver", { alp = 1, input = true } },
                 { "anm_labdesk_use_screwdriver", { frame = 0 } },
                 { "obj_labdesk_screw", { pos_z = 61, input = false } },
                 { "obj_labdesk_baton_clk", { input = false } },
                 { "spr_labdesk_screwdriver_shadow", { alp = 1 } } } );
end;
--function private.zz_labdesk.use_labdesk_screwdriver2_start()
--  DbgTrace( "***use_labdesk_screwdriver2_start" );
--  ObjMultiSet( { { "spr_labdesk_screwdriver", { alp = 1, input = true } },
--                 { "anm_labdesk_use_screwdriver_2", { frame = 0 } },
--                 { "spr_labdesk_screwdriver_shadow", { alp = 1 } } } );
--end;
function public.zz_labdesk.use_labdesk_screwdriver1()

  --DbgTrace( "***use_labdesk_screwdriver1" );

  if ( cmn.ApplyObj( "spr_labdesk_screwdriver", "obj_labdesk_sword_use" ) and not private.zz_labdesk.state.events.use_labdesk_screwdriver1 ) then

    private.zz_labdesk.state.events.use_labdesk_screwdriver1 = true;

    cmn.PlayAudio( "snd", "assets/levels/level3/audio/sfx/aud_mmg_zz_labdesk_unscrew" );

    cmn.Lock( 1 );

    local func_after = function ()
      ObjAnimate( "spr_labdesk_screwdriver_shadow", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
      ObjAnimate( "spr_labdesk_screwdriver", "alp", 0, 0, function () cmn.Lock( 0 ); private.zz_labdesk.use_labdesk_screwdriver1_end() end, { 0, 0, 0,    0.3, 0, 1 } );
    end;
    
    ObjAttach( "spr_labdesk_screwdriver", "obj_labdesk_game2" );
    ObjMultiSet( {
      { "spr_labdesk_screwdriver", { alp = 0 } },
      { "anm_labdesk_use_screwdriver", { endtrig = func_after, playing = true } }
    } );

  elseif ( cmn.ApplyObj( "spr_labdesk_screwdriver", "obj_labdesk_bladehandl_use" ) and private.zz_labdesk.state.events.use_labdesk_screw ) then

    private.zz_labdesk.state.events.use_labdesk_screwdriver2 = true;

    cmn.PlayAudio( "snd", "assets/levels/level3/audio/sfx/aud_mmg_zz_labdesk_screw_again" );

    cmn.MiniGameHide("labdesk");
    cmn.SetEventDone( "win_labdesk" );

    cmn.Lock( 1 );

    local func_after2 = function ()
      ObjSet( "anm_labdesk_sword_on", { animfunc = "func_sword", endtrig = "", playing = true } );
      private.zz_labdesk.Win();
    end;

    local func_after = function ()
      ObjMultiSet( {
        { "obj_labdesk_sword", { alp = 0 } },
        { "anm_labdesk_use_screwdriver_2", { alp = 0 } },
        { "anm_labdesk_sword_on", { endtrig = func_after2, playing = true, alp = 1 } }
      } );
    end;
    
    ObjAttach( "spr_labdesk_screwdriver", "obj_labdesk_game2" );
    ObjMultiSet( {
      { "spr_labdesk_screwdriver", { alp = 0, input = false } },
      { "anm_labdesk_use_screwdriver_2", { endtrig = func_after, playing = true } }
    } );

  else
    cmn.WrongApply();  
    private.zz_labdesk.ItemDropFlyBackAnim( "spr_labdesk_screwdriver" );
  end;

end;
function private.zz_labdesk.use_labdesk_screwdriver1_end()
  --DbgTrace( "***use_labdesk_screwdriver1_end" );
  ObjMultiSet( { { "spr_labdesk_screwdriver", { alp = 1, input = true } },
                 { "anm_labdesk_use_screwdriver", { frame = 300 } },
                 { "obj_labdesk_screw", { pos_z = 0, input = true } },
                 { "spr_labdesk_screwdriver_shadow", { alp = 1 } },
                 { "obj_labdesk_baton_clk", { input = true } } } );
end;
function private.zz_labdesk.use_labdesk_screwdriver2_end()
  --DbgTrace( "***use_labdesk_screwdriver2_end" );
  ObjMultiSet( { { "spr_labdesk_screwdriver", { alp = 0, input = false } },
                 { "anm_labdesk_use_screwdriver_2", { alp = 0 } },
                 { "obj_labdesk_sword", { alp = 0 } },
                 { "anm_labdesk_sword_on", { animfunc = "func_sword", endtrig = "", playing = true, alp = 1 } },
                 { "spr_labdesk_screwdriver_shadow", { alp = 0 } } } );
end;
-----------------------------------------------------------------------------------clk_labdesk_baton
-----------------------------------------------------------------------------------
function private.zz_labdesk.clk_labdesk_baton_start()
  --DbgTrace( "***clk_labdesk_baton_start" );
  ObjMultiSet( {
    { "anm_labdesk_open_baton", { frame = 0 } },
    { "obj_labdesk_batoncover1_clk", { input = false } }
  } );
end;
function public.zz_labdesk.clk_labdesk_baton()

  --DbgTrace( "***clk_labdesk_baton" );

  cmn.Lock( 1 );

  private.zz_labdesk.state.events.clk_labdesk_baton = true;

  cmn.PlayAudio( "snd", "assets/levels/level3/audio/sfx/aud_mmg_zz_labdesk_take_off_1" );

  ObjSet( "anm_labdesk_open_baton", { endtrig = 
    function () cmn.Lock( 0 ); private.zz_labdesk.clk_labdesk_baton_end() end, playing = true
  } );

end;
function private.zz_labdesk.clk_labdesk_baton_end()
  --DbgTrace( "***clk_labdesk_baton_end" );
  ObjMultiSet( {
    { "anm_labdesk_open_baton", { frame = 300 } },
    { "obj_labdesk_baton_clk", { input = false } },
    { "obj_labdesk_batoncover1_clk", { input = true } }
  } );
end;
-----------------------------------------------------------------------------------clk_labdesk_batoncover1
-----------------------------------------------------------------------------------
function private.zz_labdesk.clk_labdesk_batoncover1_start()
  --DbgTrace( "***clk_labdesk_batoncover1_start" );
  ObjMultiSet( {
    { "anm_labdesk_open_baton_cover", { animfunc = "func_open_baton_handl_cover", frame = 0 } },
    { "obj_labdesk_magnifier_clk", { input = false } }
  } );
end;
function public.zz_labdesk.clk_labdesk_batoncover1()

  --DbgTrace( "***clk_labdesk_batoncover1" );

  cmn.Lock( 1 );

  private.zz_labdesk.state.events.clk_labdesk_batoncover1 = true;

  cmn.PlayAudio( "snd", "assets/levels/level3/audio/sfx/aud_mmg_zz_labdesk_take_off_2" );

  ObjSet( "anm_labdesk_open_baton_cover", { endtrig = 
    function () cmn.Lock( 0 ); private.zz_labdesk.clk_labdesk_batoncover1_end() end, playing = true
  } );

end;
function private.zz_labdesk.clk_labdesk_batoncover1_end()
  --DbgTrace( "***clk_labdesk_batoncover1_end" );
  ObjMultiSet( {
    { "anm_labdesk_open_baton_cover", { animfunc = "func_close_baton_handl_cover", frame = 0 } },
    { "obj_labdesk_batoncover1_clk", { input = false } },
    { "obj_labdesk_magnifier_clk", { input = true } }
  } );
end;
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------clk_labdesk_magnifier
function private.zz_labdesk.clk_labdesk_magnifier_start()
  --DbgTrace( "***clk_labdesk_magnifier_start" );
  ObjMultiSet( {
    { "anm_labdesk_use_magnifier_1", { animfunc = "func_use_magnifier_1", frame = 0 } },
    { "anm_labdesk_use_magnifier_2", { animfunc = "func_use_magnifier_2", frame = 0 } },
    { "obj_labdesk_chip", { input = false, alp = 0 } },
    { "obj_labdesk_wire", { pos_z = 4 } }
  } );
end;
function public.zz_labdesk.clk_labdesk_magnifier()

  --DbgTrace( "***clk_labdesk_magnifier" );

  cmn.Lock( 1 );

  private.zz_labdesk.state.events.clk_labdesk_magnifier = true;

  cmn.PlayAudio( "snd", "assets/levels/level3/audio/sfx/aud_mmg_zz_labdesk_clock_loupe" );

  local func_after = function ()
    ObjAnimate( "obj_labdesk_chip", "alp", 0, 0, function () cmn.Lock( 0 ); private.zz_labdesk.clk_labdesk_magnifier_end() end, { 0, 0, 0,    0.3, 0, 1 } );
  end;

  ObjMultiSet( {
    { "anm_labdesk_use_magnifier_2", { playing = true } },
    { "anm_labdesk_use_magnifier_1", { endtrig = func_after, playing = true } }
  } );

end;
function private.zz_labdesk.clk_labdesk_magnifier_end()
  --DbgTrace( "***clk_labdesk_magnifier_end" );
  ObjMultiSet( {
    { "anm_labdesk_use_magnifier_1", { animfunc = "func_off_magnifier_1", frame = 0 } },
    { "anm_labdesk_use_magnifier_2", { animfunc = "func_off_magnifier_2", frame = 0 } },
    { "obj_labdesk_magnifier_clk", { input = false } },
    { "obj_labdesk_chip", { input = true, alp = 1 } },
    { "obj_labdesk_wire", { pos_z = 70 } }
  } );
end;
-----------------------------------------------------------------------------------use_labdesk_wire
-----------------------------------------------------------------------------------
function public.zz_labdesk.use_labdesk_wire_start_drag()
  ObjSet( "obj_labdesk_wire_shadow", { alp = 0 } );
  ObjAttach( "obj_labdesk_wire", "obj_labdesk_draghub" );
end;
function private.zz_labdesk.use_labdesk_wire_start()
  --DbgTrace( "***use_labdesk_wire_start" );
  ObjMultiSet( { { "obj_labdesk_wire", { alp = 1, input = true } },
                 { "obj_labdesk_wires", { alp = 0 } },
                 { "obj_labdesk_wire_shadow", { alp = 1 } },
                 { "obj_labdesk_wire_cover_1", { input = false } },
                 { "obj_labdesk_wire_cover_2", { input = false } },
                 { "obj_labdesk_wire_cover_3", { input = false } } } );
end;
function public.zz_labdesk.use_labdesk_wire()

  --DbgTrace( "***use_labdesk_wire" );

  if ( cmn.ApplyObj( "obj_labdesk_wire", "spr_labdesk_chip" ) and private.zz_labdesk.state.events.clk_labdesk_magnifier ) then

    private.zz_labdesk.state.events.use_labdesk_wire = true;

    cmn.PlayAudio( "snd", "assets/levels/level3/audio/sfx/aud_mmg_zz_labdesk_insert_wires" );

    cmn.Lock( 1 );
    
    ObjAttach( "obj_labdesk_wire", "obj_labdesk_game2" );
    ObjSet( "obj_labdesk_wire", { alp = 0 } );
    ObjAnimate( "obj_labdesk_wires", "alp", 0, 0, function () cmn.Lock( 0 ); private.zz_labdesk.use_labdesk_wire_end() end, { 0, 0, 0,    0.3, 0, 1 } );

  else
    cmn.WrongApply();  
    private.zz_labdesk.ItemDropFlyBackAnim( "obj_labdesk_wire" );
  end;

end;
function private.zz_labdesk.use_labdesk_wire_end()
  --DbgTrace( "***use_labdesk_wire_end" );
  ObjMultiSet( { { "obj_labdesk_wires", { alp = 1 } },
                 { "obj_labdesk_wire", { alp = 0, input = false } },
                 { "obj_labdesk_wire_shadow", { alp = 0 } },
                 { "obj_labdesk_wire_cover_1", { input = true } },
                 { "obj_labdesk_wire_cover_2", { input = true } },
                 { "obj_labdesk_wire_cover_3", { input = true } } } );
end;
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------win_labdesk_magnifier
function private.zz_labdesk.win_labdesk_magnifier_start()
  --DbgTrace( "***win_labdesk_magnifier_start" );
  ObjSet( "spr_labdesk_baton_wires", { alp = 0 } );
end;
function private.zz_labdesk.win_labdesk_magnifier_end()
  --DbgTrace( "***win_labdesk_magnifier_end" );
  ObjMultiSet( {
    { "anm_labdesk_use_magnifier_1", { frame = 300 } },
    { "anm_labdesk_use_magnifier_2", { frame = 300 } },
    { "obj_labdesk_chip", { input = false, alp = 0 } },
    { "spr_labdesk_baton_wires", { alp = 1 } },
    { "obj_labdesk_batoncover2_clk", { input = true } }
  } );
end;

function public.zz_labdesk.click_wire_cover( num )

  cmn.Lock( 1 );

  --DbgTrace( "***click_wire_cover "..num );

  if ( private.zz_labdesk.state.last_cover == 0 ) then

    private.zz_labdesk.state.last_cover = num;

    cmn.PlayAudio( "snd", "assets/levels/level3/audio/sfx/aud_mmg_zz_labdesk_unclick_wires" );

    ObjSet( "anm_labdesk_wire_cover_"..num, { animfunc = "func_wire_cover_"..num.."_open", frame = 0, playing = true } );

    ObjAnimate( "spr_labdesk_wire_"..private.zz_labdesk.state.wire_pos[num]..num, "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "spr_labdesk_wire_"..private.zz_labdesk.state.wire_pos[num]..num.."b", "alp", 0, 0, 
      function () cmn.Lock( 0 ); end, { 0, 0, 0,    0.3, 0, 1 } );

  else

    if ( private.zz_labdesk.state.last_cover == num ) then

      cmn.PlayAudio( "snd", "assets/levels/level3/audio/sfx/aud_mmg_zz_labdesk_click_wires" );

      ObjSet( "anm_labdesk_wire_cover_"..num, { animfunc = "func_wire_cover_"..num.."_close", frame = 0, playing = true } );

      ObjAnimate( "spr_labdesk_wire_"..private.zz_labdesk.state.wire_pos[num]..num, "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
      ObjAnimate( "spr_labdesk_wire_"..private.zz_labdesk.state.wire_pos[num]..num.."b", "alp", 0, 0, 
        function () cmn.Lock( 0 ); end, { 0, 0, 1,    0.3, 0, 0 } );

    else

      local last_cover = private.zz_labdesk.state.last_cover;
      local last_cover_state = private.zz_labdesk.state.wire_pos[last_cover];

      local func_after = function ()

        cmn.PlayAudio( "snd", "assets/levels/level3/audio/sfx/aud_mmg_zz_labdesk_click_wires" );

        ObjSet( "anm_labdesk_wire_cover_"..num, { animfunc = "func_wire_cover_"..num.."_close", frame = 0, playing = true } );
        ObjSet( "anm_labdesk_wire_cover_"..last_cover, { animfunc = "func_wire_cover_"..last_cover.."_close", frame = 0, playing = true } );

        ObjAnimate( "spr_labdesk_wire_"..last_cover_state..last_cover.."b", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );

        ObjAnimate( "spr_labdesk_wire_"..private.zz_labdesk.state.wire_pos[last_cover]..last_cover, "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );

        ObjAnimate( "spr_labdesk_wire_"..private.zz_labdesk.state.wire_pos[num]..num, "alp", 0, 0, 
          private.zz_labdesk.check_wire_cover, { 0, 0, 0,    0.3, 0, 1 } );

        if private.zz_labdesk.state.wire_pos[num] == private.zz_labdesk.wire_cover_win_pos[num] then
          ObjSet( "obj_labdesk_wire_cover_"..num, { input = false } );
          ObjAnimate( "spr_labdesk_red_lamp"..num, "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
          ObjAnimate( "spr_labdesk_green_lamp"..num, "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
        end;

        if private.zz_labdesk.state.wire_pos[last_cover] == private.zz_labdesk.wire_cover_win_pos[last_cover] then
          ObjSet( "obj_labdesk_wire_cover_"..last_cover, { input = false } );
          ObjAnimate( "spr_labdesk_red_lamp"..last_cover, "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
          ObjAnimate( "spr_labdesk_green_lamp"..last_cover, "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
        end;

      end;

      cmn.PlayAudio( "snd", "assets/levels/level3/audio/sfx/aud_mmg_zz_labdesk_unclick_wires" );

      ObjSet( "anm_labdesk_wire_cover_"..num, { animfunc = "func_wire_cover_"..num.."_open", frame = 0, playing = true } );

      ObjAnimate( "spr_labdesk_wire_"..private.zz_labdesk.state.wire_pos[num]..num, "alp", 0, 0, func_after, { 0, 0, 1,    0.3, 0, 0 } );
      ObjAnimate( "spr_labdesk_wire_"..private.zz_labdesk.state.wire_pos[num]..num.."b", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1,    0.3, 0, 0 } );

      private.zz_labdesk.state.wire_pos[last_cover] = private.zz_labdesk.state.wire_pos[num];
      private.zz_labdesk.state.wire_pos[num] = last_cover_state;

    end;

    private.zz_labdesk.state.last_cover = 0;

  end;

end;

function private.zz_labdesk.check_wire_cover()

  for i = 1, 3, 1 do
    if private.zz_labdesk.state.wire_pos[i] ~= private.zz_labdesk.wire_cover_win_pos[i] then
      cmn.Lock( 0 );
      return;
    end;
  end;

  local func_after = function ()
    ObjSet( "anm_labdesk_use_magnifier_1", { 
      endtrig =  function () 
        cmn.Lock( 0 );
        private.zz_labdesk.win_labdesk_magnifier_end();
      end, 
      playing = true 
    } );
    ObjSet( "anm_labdesk_use_magnifier_2", { playing = true } );
  end;

  private.zz_labdesk.state.events.win_labdesk_magnifier = true;

  ObjSet( "spr_labdesk_baton_wires", { alp = 1 } );
  ObjAnimate( "obj_labdesk_chip", "alp", 0, 0, func_after, { 0, 0, 1,    0.3, 0, 1,    0.6, 0, 0 } );

  cmn.PlayAudio( "snd", "assets/levels/level3/audio/sfx/aud_mmg_zz_labdesk_lamp_goes" );

end;
-----------------------------------------------------------------------------------clk_labdesk_batoncover2
-----------------------------------------------------------------------------------
function private.zz_labdesk.clk_labdesk_batoncover2_start()
  --DbgTrace( "***clk_labdesk_batoncover2_start" );
  ObjSet( "anm_labdesk_open_baton_cover", { frame = 0 } );
end;
function public.zz_labdesk.clk_labdesk_batoncover2()

  --DbgTrace( "***clk_labdesk_batoncover2" );

  cmn.Lock( 1 );

  private.zz_labdesk.state.events.clk_labdesk_batoncover2 = true;

  ObjSet( "anm_labdesk_open_baton_cover", { endtrig = 
    function () cmn.Lock( 0 ); private.zz_labdesk.clk_labdesk_batoncover2_end() end, playing = true
  } );

  cmn.PlayAudio( "snd", "assets/levels/level3/audio/sfx/aud_mmg_zz_labdesk_close_stick" );

end;
function private.zz_labdesk.clk_labdesk_batoncover2_end()
  --DbgTrace( "***clk_labdesk_batoncover2_end" );
  ObjMultiSet( {
    { "anm_labdesk_open_baton_cover", { frame = 300 } },
    { "obj_labdesk_batoncover2_clk", { input = false } }
  } );
end;
-----------------------------------------------------------------------------------use_labdesk_bladehandl
-----------------------------------------------------------------------------------
function public.zz_labdesk.use_labdesk_bladehandl_start_drag()
  ObjSet( "obj_labdesk_blade_handl_shadow", { alp = 0 } );
  ObjAttach( "obj_labdesk_blade_handl", "obj_labdesk_draghub" );
end;
function private.zz_labdesk.use_labdesk_bladehandl_start()
  --DbgTrace( "***use_labdesk_bladehandl_start" );
  ObjMultiSet( { { "obj_labdesk_blade_handl", { alp = 1, input = true } },
                 { "anm_labdesk_use_blade_handl", { frame = 0 } },
                 { "anm_labdesk_use_blade_handl_2", { frame = 0 } },
                 { "obj_labdesk_blade_handl_shadow", { alp = 1 } } } );
end;
function public.zz_labdesk.use_labdesk_bladehandl()

  --DbgTrace( "***use_labdesk_bladehandl" );

  if ( cmn.ApplyObj( "obj_labdesk_blade_handl", "obj_labdesk_sword_use" ) and private.zz_labdesk.state.events.clk_labdesk_batoncover2 ) then

    private.zz_labdesk.state.events.use_labdesk_bladehandl = true;

    cmn.PlayAudio( "snd", "assets/levels/level3/audio/sfx/aud_mmg_zz_labdesk_implant_handle" );

    cmn.Lock( 1 );
    
    ObjAttach( "obj_labdesk_blade_handl", "zz_labdesk" );

    ObjMultiSet( {
      { "obj_labdesk_blade_handl", { alp = 0, input = false } },
      { "anm_labdesk_use_blade_handl_2", { playing = true } },
      { "anm_labdesk_use_blade_handl", { endtrig = function () cmn.Lock( 0 ); end, playing = true } }
    } );

  else
    cmn.WrongApply();  
    private.zz_labdesk.ItemDropFlyBackAnim( "obj_labdesk_blade_handl" );
  end;

end;
function private.zz_labdesk.use_labdesk_bladehandl_end()
  --DbgTrace( "***use_labdesk_bladehandl_end" );
  ObjMultiSet( { { "obj_labdesk_blade_handl", { alp = 0, input = false } },
                 { "anm_labdesk_use_blade_handl", { frame = 300 } },
                 { "anm_labdesk_use_blade_handl_2", { frame = 300 } },
                 { "obj_labdesk_blade_handl_shadow", { alp = 0 } } } );
end;
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------use_labdesk_blade
function public.zz_labdesk.use_labdesk_blade_start_drag()
  ObjSet( "spr_labdesk_blade_2_shadow", { alp = 0 } );
  ObjSet( "spr_labdesk_blade_1_shadow", { alp = 0 } );
  ObjAttach( "obj_labdesk_blade", "obj_labdesk_draghub" );
end;
function private.zz_labdesk.use_labdesk_blade_start()
  --DbgTrace( "***use_labdesk_blade_start" );
  ObjMultiSet( { { "obj_labdesk_blade", { alp = 1, input = true } },
                 { "anm_labdesk_use_blade", { frame = 0 } },
                 { "spr_labdesk_blade_2_shadow", { alp = 1 } },
                 { "spr_labdesk_blade_1_shadow", { alp = 1 } } } );
end;
function public.zz_labdesk.use_labdesk_blade()

  --DbgTrace( "***use_labdesk_blade" );

  if ( cmn.ApplyObj( "obj_labdesk_blade", "obj_labdesk_sword_use" ) and private.zz_labdesk.state.events.use_labdesk_bladehandl ) then

    private.zz_labdesk.state.events.use_labdesk_blade = true;

    cmn.PlayAudio( "snd", "assets/levels/level3/audio/sfx/aud_mmg_zz_labdesk_implant_blade" );

    cmn.Lock( 1 );
    
    ObjAttach( "obj_labdesk_blade", "obj_labdesk_game2" );

    ObjMultiSet( {
      { "obj_labdesk_blade", { alp = 0, input = false } },
      { "anm_labdesk_use_blade", { endtrig = function () cmn.Lock( 0 ); end, playing = true } }
    } );

  else
    cmn.WrongApply();  
    private.zz_labdesk.ItemDropFlyBackAnim( "obj_labdesk_blade" );
  end;

end;
function private.zz_labdesk.use_labdesk_blade_end()
  --DbgTrace( "***use_labdesk_blade_end" );
  ObjMultiSet( { { "obj_labdesk_blade", { alp = 0, input = false } },
                 { "anm_labdesk_use_blade", { frame = 300 } },
                 { "spr_labdesk_blade_2_shadow", { alp = 0 } },
                 { "spr_labdesk_blade_1_shadow", { alp = 0 } } } );
end;
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------use_labdesk_screw
function public.zz_labdesk.use_labdesk_screw_start_drag()
  ObjMultiSet( {
    { "spr_labdesk_screw_1_shadow", { alp = 0 } },
    { "spr_labdesk_screw_2_shadow", { alp = 0 } }
  } );
  ObjAttach( "obj_labdesk_screw", "obj_labdesk_draghub" );
end;
function private.zz_labdesk.use_labdesk_screw_start()
  --DbgTrace( "***use_labdesk_screw_start" );
  ObjMultiSet( { { "anm_labdesk_use_screw_1", { frame = 0 } },
                 { "anm_labdesk_use_screw_2", { frame = 0 } },
                 { "obj_labdesk_screw", { alp = 1 } },
                 { "anm_labdesk_use_screwdriver_2", { alp = 0 } },
                 { "spr_labdesk_screw_1_shadow", { alp = 1 } },
                 { "spr_labdesk_screw_2_shadow", { alp = 1 } } } );
end;
function public.zz_labdesk.use_labdesk_screw()

  --DbgTrace( "***use_labdesk_screw" );

  if ( cmn.ApplyObj( "obj_labdesk_screw", "obj_labdesk_bladehandl_use" ) and private.zz_labdesk.state.events.use_labdesk_blade ) then

    private.zz_labdesk.state.events.use_labdesk_screw = true;

    cmn.PlayAudio( "snd", "assets/levels/level3/audio/sfx/aud_mmg_zz_labdesk_fix_screw" );

    cmn.Lock( 1 );
    
    ObjAttach( "obj_labdesk_screw", "obj_labdesk_game" );

    ObjMultiSet( {
      { "obj_labdesk_screw", { alp = 0, input = false } },
      { "anm_labdesk_use_screw_1", { playing = true } },
      { "anm_labdesk_use_screw_2", { endtrig = function () private.zz_labdesk.use_labdesk_screw_end(); cmn.Lock( 0 ); end, playing = true } }
    } );

  else
    cmn.WrongApply();  
    private.zz_labdesk.ItemDropFlyBackAnim( "obj_labdesk_screw" );
  end;

end;
function private.zz_labdesk.use_labdesk_screw_end()
  --DbgTrace( "***use_labdesk_screw_end" );
  ObjMultiSet( { { "obj_labdesk_screw", { alp = 0, input = false } },
                 { "anm_labdesk_use_screw_1", { frame = 0 } },
                 { "anm_labdesk_use_screw_2", { frame = 0 } },
                 { "anm_labdesk_use_screwdriver_2", { alp = 1 } } } );
end;
--*********************************************************************************************************************
