-- name=inventory4
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  -- function get_ropehook () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_ropehook" ] = {
    type = "get",
    get_obj = "obj_complex_lvl4rope_ropehook",
    room ="int_complex_inv",
    zz = "inv_complex_lvl4rope",
    zz_gate = "inv_lvl4rope"
  };
  --------------------------------------------------------------------------------------------
  local get_ropehook_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl4rope" );
    interface.InventoryItemAdd( "inv_ropehook", "obj_complex_lvl4rope_ropehook" );
    
    ObjDelete( "gfx_complex_lvl4rope_ropehook" );
  
  end;
  cmn.AddSubscriber( "get_ropehook", get_ropehook_inv );

  --------------------------------------------------------------------------------------------
  -- function use_lvl4hook () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl4hook" ] = {
    type = "use",
    inv_obj = "inv_lvl4hook",
    use_place = "obj_complex_lvl4rope_use_lvl4hook",
    room = "int_complex_inv",
    zz = "inv_complex_lvl4rope",
    zz_gate = "inv_lvl4rope"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl4hook_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl4hook" );
  
  end;
  local use_lvl4hook_beg = function ()
  
    ObjDelete( "obj_complex_lvl4rope_use_lvl4hook" );
    ObjDelete( "anm_complex_lvl4rope_rope_touch" );
  
  end;
  local use_lvl4hook_end = function ()
  
    ObjMultiSet( { {"obj_complex_lvl4rope_ropehook", { input = 1 }},
                   {"anm_complex_lvl4rope_use_hook", { alp = 1, frame = 300 }},
                   {"gfx_complex_lvl4rope_ropehook", { active = 1, visible = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl4hook", use_lvl4hook_beg, "inv_complex_lvl4rope" );
  cmn.AddSubscriber( "use_lvl4hook", use_lvl4hook_inv );
  cmn.AddSubscriber( "use_lvl4hook", use_lvl4hook_end, "inv_complex_lvl4rope" );
  cmn.AddSubscriber( "use_lvl4hook_inv", use_lvl4hook_inv, "inv_complex_lvl4rope" );
  cmn.AddSubscriber( "use_lvl4hook_beg", use_lvl4hook_beg, "inv_complex_lvl4rope" );
  cmn.AddSubscriber( "use_lvl4hook_end", use_lvl4hook_end, "inv_complex_lvl4rope" );

  --------------------------------------------------------------------------------------------
  -- function get_feather2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_feather2" ] = {
    type = "get",
    get_obj = "spr_complex_egg_feather2",
    room ="int_complex_inv",
    zz = "inv_complex_egg",
    zz_gate = "inv_egg"
  };
  --------------------------------------------------------------------------------------------
  local get_feather2_inv = function ()
  
    interface.InventoryItemAdd( "inv_feather2", "spr_complex_egg_feather2" );
    
    if not cmn.IsEventDone("get_emerald") or cmn.IsEventDone("use_emerald") then
      ObjSet("inv_egg_star_light",  { alp = 0 });
    end;
    
    ObjDelete( "gfx_complex_egg_feather2" );
    ObjDelete( "spr_complex_egg_feather2_sh" );
    ObjDelete( "spr_complex_egg_feather2_sh_2" );
  
  end;
  cmn.AddSubscriber( "get_feather2", get_feather2_inv );
  --------------------------------------------------------------------------------------------
  -- function get_snowflake () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_snowflake" ] = {
    type = "get",
    get_obj = "spr_complex_egg_snowflake",
    room ="int_complex_inv",
    zz = "inv_complex_egg",
    zz_gate = "inv_egg"
  };
  --------------------------------------------------------------------------------------------
  local get_snowflake_inv = function ()
  
    interface.InventoryItemRemove( "inv_egg" );
    interface.InventoryItemAdd( "inv_snowflake", "spr_complex_egg_snowflake" );
    
    ObjDelete( "gfx_complex_egg_snowflake" );
    ObjDelete( "spr_complex_egg_snowflake_sh" );
  
  end;
  cmn.AddSubscriber( "get_snowflake", get_snowflake_inv );

  --------------------------------------------------------------------------------------------
  -- function use_emerald () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_emerald" ] = {
    type = "use",
    inv_obj = "inv_emerald",
    use_place = "obj_complex_egg_use_emerald",
    room = "int_complex_inv",
    zz = "inv_complex_egg",
    zz_gate = "inv_egg"
  };
  --------------------------------------------------------------------------------------------
  local use_emerald_inv = function ()
  
    interface.InventoryItemRemove( "inv_emerald" );
    
    if (not cmn.IsEventDone("get_ruby") or cmn.IsEventDone("use_ruby")) and 
       (not cmn.IsEventDone("get_sapphire") or cmn.IsEventDone("use_sapphire")) and 
       (not cmn.IsEventDone("win_inboxes") or cmn.IsEventDone("use_amethyst")) and
        not(cmn.IsEventDone("use_ruby") and cmn.IsEventDone("use_sapphire") and cmn.IsEventDone("use_amethyst"))  then
      ObjSet("inv_egg_star_light",  { alp = 0 });
    end;
  
  end;
  local use_emerald_beg = function ()
  
    ObjDelete( "obj_complex_egg_use_emerald" );
  
  end;
  local use_emerald_end = function ()
    
    ObjDelete("anm_complex_egg_use_emerald");
  
    if cmn.IsEventDone("use_amethyst") and cmn.IsEventDone("use_sapphire") and cmn.IsEventDone("use_ruby") then
      ObjDelete("obj_complex_egg_1");
      ObjMultiSet( { {"anm_complex_egg_open", { input = 1, alp = 1, frame = 300 }},
                     {"spr_complex_egg_base", { alp = 1 }} } );
    else 
      ObjSet( "spr_complex_egg_emerald", { alp = 1 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_emerald", use_emerald_beg, "inv_complex_egg" );
  cmn.AddSubscriber( "use_emerald", use_emerald_inv );
  cmn.AddSubscriber( "use_emerald", use_emerald_end, "inv_complex_egg" );
  cmn.AddSubscriber( "use_emerald_inv", use_emerald_inv, "inv_complex_egg" );
  cmn.AddSubscriber( "use_emerald_beg", use_emerald_beg, "inv_complex_egg" );
  cmn.AddSubscriber( "use_emerald_end", use_emerald_end, "inv_complex_egg" );
  --------------------------------------------------------------------------------------------
  -- function use_ruby () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_ruby" ] = {
    type = "use",
    inv_obj = "inv_ruby",
    use_place = "obj_complex_egg_use_ruby",
    room = "int_complex_inv",
    zz = "inv_complex_egg",
    zz_gate = "inv_egg"
  };
  --------------------------------------------------------------------------------------------
  local use_ruby_inv = function ()
  
    interface.InventoryItemRemove( "inv_ruby" );
    
    if (not cmn.IsEventDone("get_emerald") or cmn.IsEventDone("use_emerald")) and 
       (not cmn.IsEventDone("get_sapphire") or cmn.IsEventDone("use_sapphire")) and 
       (not cmn.IsEventDone("win_inboxes") or cmn.IsEventDone("use_amethyst")) and
        not(cmn.IsEventDone("use_emerald") and cmn.IsEventDone("use_sapphire") and cmn.IsEventDone("use_amethyst"))  then
      ObjSet("inv_egg_star_light",  { alp = 0 });
    end;
  
  end;
  local use_ruby_beg = function ()
  
    ObjDelete( "obj_complex_egg_use_ruby" );
  
  end;
  local use_ruby_end = function ()
    
    ObjDelete("anm_complex_egg_use_ruby");
  
    if cmn.IsEventDone("use_amethyst") and cmn.IsEventDone("use_sapphire") and cmn.IsEventDone("use_emerald") then
      ObjDelete("obj_complex_egg_1");
      ObjMultiSet( { {"anm_complex_egg_open", { input = 1, alp = 1, frame = 300 }},
                     {"spr_complex_egg_base", { alp = 1 }} } );
    else 
      ObjSet( "spr_complex_egg_ruby", { alp = 1 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ruby", use_ruby_beg, "inv_complex_egg" );
  cmn.AddSubscriber( "use_ruby", use_ruby_inv );
  cmn.AddSubscriber( "use_ruby", use_ruby_end, "inv_complex_egg" );
  cmn.AddSubscriber( "use_ruby_inv", use_ruby_inv, "inv_complex_egg" );
  cmn.AddSubscriber( "use_ruby_beg", use_ruby_beg, "inv_complex_egg" );
  cmn.AddSubscriber( "use_ruby_end", use_ruby_end, "inv_complex_egg" );
  --------------------------------------------------------------------------------------------
  -- function use_sapphire () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_sapphire" ] = {
    type = "use",
    inv_obj = "inv_sapphire",
    use_place = "obj_complex_egg_use_sapphire",
    room = "int_complex_inv",
    zz = "inv_complex_egg",
    zz_gate = "inv_egg"
  };
  --------------------------------------------------------------------------------------------
  local use_sapphire_inv = function ()
  
    interface.InventoryItemRemove( "inv_sapphire" );
    
    if (not cmn.IsEventDone("get_emerald") or cmn.IsEventDone("use_emerald")) and 
       (not cmn.IsEventDone("get_ruby") or cmn.IsEventDone("use_ruby")) and 
       (not cmn.IsEventDone("win_inboxes") or cmn.IsEventDone("use_amethyst")) and
        not(cmn.IsEventDone("use_emerald") and cmn.IsEventDone("use_ruby") and cmn.IsEventDone("use_amethyst"))  then
      ObjSet("inv_egg_star_light",  { alp = 0 });
    end;
  
  end;
  local use_sapphire_beg = function ()
  
    ObjDelete( "obj_complex_egg_use_sapphire" );
  
  end;
  local use_sapphire_end = function ()
    
    ObjDelete("anm_complex_egg_use_sapphire");
  
    if cmn.IsEventDone("use_amethyst") and cmn.IsEventDone("use_ruby") and cmn.IsEventDone("use_emerald") then
      ObjDelete("obj_complex_egg_1");
      ObjMultiSet( { {"anm_complex_egg_open", { input = 1, alp = 1, frame = 300 }},
                     {"spr_complex_egg_base", { alp = 1 }} } );
    else 
      ObjSet( "spr_complex_egg_sapphire", { alp = 1 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sapphire", use_sapphire_beg, "inv_complex_egg" );
  cmn.AddSubscriber( "use_sapphire", use_sapphire_inv );
  cmn.AddSubscriber( "use_sapphire", use_sapphire_end, "inv_complex_egg" );
  cmn.AddSubscriber( "use_sapphire_inv", use_sapphire_inv, "inv_complex_egg" );
  cmn.AddSubscriber( "use_sapphire_beg", use_sapphire_beg, "inv_complex_egg" );
  cmn.AddSubscriber( "use_sapphire_end", use_sapphire_end, "inv_complex_egg" );
  --------------------------------------------------------------------------------------------
  -- function use_amethyst () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_amethyst" ] = {
    type = "use",
    inv_obj = "inv_amethyst",
    use_place = "obj_complex_egg_use_amethyst",
    room = "int_complex_inv",
    zz = "inv_complex_egg",
    zz_gate = "inv_egg"
  };
  --------------------------------------------------------------------------------------------
  local use_amethyst_inv = function ()
  
    interface.InventoryItemRemove( "inv_amethyst" );
    
    if (not cmn.IsEventDone("get_emerald") or cmn.IsEventDone("use_emerald")) and 
       (not cmn.IsEventDone("get_ruby") or cmn.IsEventDone("use_ruby")) and 
       (not cmn.IsEventDone("get_sapphire") or cmn.IsEventDone("use_sapphire")) and
        not(cmn.IsEventDone("use_emerald") and cmn.IsEventDone("use_ruby") and cmn.IsEventDone("use_sapphire"))  then
      ObjSet("inv_egg_star_light",  { alp = 0 });
    end;
  
  end;
  local use_amethyst_beg = function ()
  
    ObjDelete( "obj_complex_egg_use_amethyst" );
  
  end;
  local use_amethyst_end = function ()
    
    ObjDelete("anm_complex_egg_use_amethyst");
  
    if cmn.IsEventDone("use_sapphire") and cmn.IsEventDone("use_ruby") and cmn.IsEventDone("use_emerald") then
      ObjDelete("obj_complex_egg_1");
      ObjMultiSet( { {"anm_complex_egg_open", { input = 1, alp = 1, frame = 300 }},
                     {"spr_complex_egg_base", { alp = 1 }} } );
    else 
      ObjSet( "spr_complex_egg_amethyst", { alp = 1 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amethyst", use_amethyst_beg, "inv_complex_egg" );
  cmn.AddSubscriber( "use_amethyst", use_amethyst_inv );
  cmn.AddSubscriber( "use_amethyst", use_amethyst_end, "inv_complex_egg" );
  cmn.AddSubscriber( "use_amethyst_inv", use_amethyst_inv, "inv_complex_egg" );
  cmn.AddSubscriber( "use_amethyst_beg", use_amethyst_beg, "inv_complex_egg" );
  cmn.AddSubscriber( "use_amethyst_end", use_amethyst_end, "inv_complex_egg" );
  
  --------------------------------------------------------------------------------------------
  -- function get_guidingtorch () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_guidingtorch" ] = {
    type = "get",
    get_obj = "obj_complex_torch_guidingtorch",
    room ="int_complex_inv",
    zz = "inv_complex_torch",
    zz_gate = "inv_torch"
  };
  --------------------------------------------------------------------------------------------
  local get_guidingtorch_inv = function ()
  
    interface.InventoryItemRemove( "inv_torch" );
    interface.InventoryItemAdd( "inv_guidingtorch", "obj_complex_torch_guidingtorch" );
    
    ObjDelete( "gfx_complex_torch_guidingtorch" );
  
  end;
  cmn.AddSubscriber( "get_guidingtorch", get_guidingtorch_inv );
  --------------------------------------------------------------------------------------------
  -- function get_shovelhandle () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_shovelhandle" ] = {
    type = "get",
    get_obj = "spr_complex_torch_shovelhandle",
    room ="int_complex_inv",
    zz = "inv_complex_torch",
    zz_gate = "inv_torch"
  };
  --------------------------------------------------------------------------------------------
  local get_shovelhandle_inv = function ()
  
    interface.InventoryItemAdd( "inv_shovelhandle", "spr_complex_torch_shovelhandle" );
    
    if not cmn.IsEventDone("get_littlemirror") or cmn.IsEventDone("use_littlemirror") then
      ObjSet("inv_torch_star_light",  { alp = 0 });
    end;
    
    ObjDelete( "gfx_complex_torch_shovelhandle" );
    ObjDelete( "spr_complex_torch_shovelhandle_sh" );
    ObjDelete( "spr_complex_torch_shovelhandle_bl" );
  
  end;
  cmn.AddSubscriber( "get_shovelhandle", get_shovelhandle_inv );

  --------------------------------------------------------------------------------------------
  -- function use_littlefire () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_littlefire" ] = {
    type = "use",
    inv_obj = "inv_littlefire",
    use_place = "obj_complex_torch_use_littlefire",
    room = "int_complex_inv",
    zz = "inv_complex_torch",
    zz_gate = "inv_torch"
  };
  --------------------------------------------------------------------------------------------
  local use_littlefire_inv = function ()
  
    interface.InventoryItemRemove( "inv_littlefire" );
  
  end;
  local use_littlefire_beg = function ()
  
    ObjDelete( "obj_complex_torch_use_littlefire" );
  
  end;
  local use_littlefire_end = function ()
    
    ObjSet("anm_complex_torch_use_fire",  { alp = 1, frame = 300 });
  
    if cmn.IsEventDone("use_littlemirror") then
      ObjDelete( "anm_complex_torch_open" );
      ObjMultiSet( { {"obj_complex_torch_guidingtorch", { input = 1 }},
                     {"gfx_complex_torch_guidingtorch", { active = 1, visible = 1 }},
                     {"anm_complex_torch_close", { alp = 1, frame = 300 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_littlefire", use_littlefire_beg, "inv_complex_torch" );
  cmn.AddSubscriber( "use_littlefire", use_littlefire_inv );
  cmn.AddSubscriber( "use_littlefire", use_littlefire_end, "inv_complex_torch" );
  cmn.AddSubscriber( "use_littlefire_inv", use_littlefire_inv, "inv_complex_torch" );
  cmn.AddSubscriber( "use_littlefire_beg", use_littlefire_beg, "inv_complex_torch" );
  cmn.AddSubscriber( "use_littlefire_end", use_littlefire_end, "inv_complex_torch" );
  --------------------------------------------------------------------------------------------
  -- function use_littlemirror () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_littlemirror" ] = {
    type = "use",
    inv_obj = "inv_littlemirror",
    use_place = "obj_complex_torch_use_littlemirror",
    room = "int_complex_inv",
    zz = "inv_complex_torch",
    zz_gate = "inv_torch"
  };
  --------------------------------------------------------------------------------------------
  local use_littlemirror_inv = function ()
  
    interface.InventoryItemRemove( "inv_littlemirror" );
    if not cmn.IsEventDone("win_intent") then
      ObjSet("inv_torch_star_light",  { alp = 0 });
    end;
  
  end;
  local use_littlemirror_beg = function ()
  
    ObjDelete( "obj_complex_torch_use_littlemirror" );
  
  end;
  local use_littlemirror_end = function ()
    
    ObjSet("anm_complex_torch_use_mirror",  { frame = 300 });
  
    if cmn.IsEventDone("use_littlefire") then
      ObjDelete( "anm_complex_torch_open" );
      ObjMultiSet( { {"obj_complex_torch_guidingtorch", { input = 1 }},
                     {"gfx_complex_torch_guidingtorch", { active = 1, visible = 1 }},
                     {"anm_complex_torch_close", { alp = 1, frame = 300 }} } );
    else 
      ObjSet("obj_complex_torch_use_littlefire",  { input = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_littlemirror", use_littlemirror_beg, "inv_complex_torch" );
  cmn.AddSubscriber( "use_littlemirror", use_littlemirror_inv );
  cmn.AddSubscriber( "use_littlemirror", use_littlemirror_end, "inv_complex_torch" );
  cmn.AddSubscriber( "use_littlemirror_inv", use_littlemirror_inv, "inv_complex_torch" );
  cmn.AddSubscriber( "use_littlemirror_beg", use_littlemirror_beg, "inv_complex_torch" );
  cmn.AddSubscriber( "use_littlemirror_end", use_littlemirror_end, "inv_complex_torch" );
  --------------------------------------------------------------------------------------------
  -- function clk_opentorch () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_opentorch" ] = {
    type = "click",
    use_place = "obj_complex_torch_clk_opentorch",
    room = "int_complex_inv",
    zz = "inv_complex_torch",
    zz_gate = "inv_torch"
  };
  --------------------------------------------------------------------------------------------
  local clk_opentorch = function ()
  
    ObjDelete( "obj_complex_torch_clk_opentorch" );
    
    ObjMultiSet( { {"anm_complex_torch_open", { frame = 300, pos_z = 2 }},
                   {"obj_complex_torch_clk_littlemirror", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_opentorch", clk_opentorch, "inv_complex_torch" );
  --------------------------------------------------------------------------------------------
  -- function clk_littlemirror () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_littlemirror" ] = {
    type = "click",
    use_place = "obj_complex_torch_clk_littlemirror",
    room = "int_complex_inv",
    zz = "inv_complex_torch",
    zz_gate = "inv_torch"
  };
  --------------------------------------------------------------------------------------------
  local clk_littlemirror_inv = function ()
    if not cmn.IsEventDone("get_littlemirror") then
      ObjSet("inv_torch_star_light",  { alp = 0 });
    end;
  end;
  local clk_littlemirror = function ()
  
    ObjDelete( "obj_complex_torch_clk_littlemirror" );
    ObjDelete( "anm_complex_torch_old_mirror" );
    
    ObjMultiSet( { {"anm_complex_torch_use_mirror", { alp = 1 }},
                   {"obj_complex_torch_use_littlemirror", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_littlemirror", clk_littlemirror, "inv_complex_torch" );
  cmn.AddSubscriber( "clk_littlemirror", clk_littlemirror_inv );

  --------------------------------------------------------------------------------------------
  -- function get_clothbutton2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_clothbutton2" ] = {
    type = "get",
    get_obj = "spr_complex_diary_clothbutton2",
    room ="int_complex_inv",
    zz = "inv_complex_diary",
    zz_gate = "inv_diary"
  };
  --------------------------------------------------------------------------------------------
  local get_clothbutton2_inv = function ()
  
    interface.InventoryItemAdd( "inv_clothbutton", "spr_complex_diary_clothbutton2", function () cmn.GetMultyObject( 'clothbutton', 2 ); end );
      
    if not cmn.IsEventDone("get_codewheel") then
      ObjSet("inv_diary_star_light",  { alp = 0 });
    end;
    
    ObjDelete( "gfx_complex_diary_clothbutton2" );
    ObjDelete( "spr_complex_diary_clothbutton2_sh" );
  
  end;
  cmn.AddSubscriber( "get_clothbutton2", get_clothbutton2_inv );
  --------------------------------------------------------------------------------------------
  -- function get_fireamulet2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_fireamulet2" ] = {
    type = "get",
    get_obj = "spr_complex_diary_fireamulet2",
    room ="int_complex_inv",
    zz = "inv_complex_diary",
    zz_gate = "inv_diary"
  };
  --------------------------------------------------------------------------------------------
  local get_fireamulet2_inv = function ()
  
    interface.InventoryItemRemove( "inv_diary" );
    interface.InventoryItemAdd( "inv_fireamulet2", "spr_complex_diary_fireamulet2" );
    
    ObjDelete( "gfx_complex_diary_fireamulet2" );
    ObjDelete( "spr_complex_diary_fireamulet2_sh" );
  
  end;
  cmn.AddSubscriber( "get_fireamulet2", get_fireamulet2_inv );

  --------------------------------------------------------------------------------------------
  -- function use_codewheel () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_codewheel" ] = {
    type = "use",
    inv_obj = "inv_codewheel",
    use_place = "obj_complex_diary_use_codewheel",
    room = "int_complex_inv",
    zz = "inv_complex_diary",
    zz_gate = "inv_diary"
  };
  --------------------------------------------------------------------------------------------
  local use_codewheel_inv = function ()
  
    interface.InventoryItemRemove( "inv_codewheel" );
    
  end;
  local use_codewheel_beg = function ()
  
    ObjDelete( "obj_complex_diary_use_codewheel" );
    ObjDelete( "obj_complex_diary_1" );
  
  end;
  local use_codewheel_end = function ()
  
    ObjSet( "anm_complex_diary_open", { input = 1, alp = 1, frame = 300 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_codewheel", use_codewheel_beg, "inv_complex_diary" );
  cmn.AddSubscriber( "use_codewheel", use_codewheel_inv );
  cmn.AddSubscriber( "use_codewheel", use_codewheel_end, "inv_complex_diary" );
  cmn.AddSubscriber( "use_codewheel_inv", use_codewheel_inv, "inv_complex_diary" );
  cmn.AddSubscriber( "use_codewheel_beg", use_codewheel_beg, "inv_complex_diary" );
  cmn.AddSubscriber( "use_codewheel_end", use_codewheel_end, "inv_complex_diary" );

  --------------------------------------------------------------------------------------------
  -- function get_toysoldier () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_toysoldier" ] = {
    type = "get",
    get_obj = "obj_complex_soldier_toysoldier",
    room ="int_complex_inv",
    zz = "inv_complex_soldier",
    zz_gate = "inv_soldier"
  };
  --------------------------------------------------------------------------------------------
  local get_toysoldier_inv = function ()
  
    interface.InventoryItemRemove( "inv_soldier" );
    interface.InventoryItemAdd( "inv_toysoldier", "obj_complex_soldier_toysoldier" );
    
    ObjDelete( "gfx_complex_soldier_toysoldier" );
  
  end;
  cmn.AddSubscriber( "get_toysoldier", get_toysoldier_inv );

  --------------------------------------------------------------------------------------------
  -- function use_soldierpart () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_soldierpart" ] = {
    type = "use",
    inv_obj = "inv_soldierpart",
    use_place = "obj_complex_soldier_use_soldierpart",
    room = "int_complex_inv",
    zz = "inv_complex_soldier",
    zz_gate = "inv_soldier"
  };
  --------------------------------------------------------------------------------------------
  local use_soldierpart_inv = function ()
  
    interface.InventoryItemRemove( "inv_soldierpart" );
  
  end;
  local use_soldierpart_beg = function ()
  
    ObjDelete( "obj_complex_soldier_use_soldierpart" );
  
  end;
  local use_soldierpart_end = function ()
  
    ObjMultiSet( { {"anm_complex_soldier_toysoldier",  { animfunc = "func_use_parts", frame = 300 }},
                   {"obj_complex_soldier_toysoldier", { input = 1 }},
                   {"gfx_complex_soldier_toysoldier", { active = 1, visible = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_soldierpart", use_soldierpart_beg, "inv_complex_soldier" );
  cmn.AddSubscriber( "use_soldierpart", use_soldierpart_inv );
  cmn.AddSubscriber( "use_soldierpart", use_soldierpart_end, "inv_complex_soldier" );
  cmn.AddSubscriber( "use_soldierpart_inv", use_soldierpart_inv, "inv_complex_soldier" );
  cmn.AddSubscriber( "use_soldierpart_beg", use_soldierpart_beg, "inv_complex_soldier" );
  cmn.AddSubscriber( "use_soldierpart_end", use_soldierpart_end, "inv_complex_soldier" );

  --------------------------------------------------------------------------------------------
  -- function get_fixedflashlight () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_fixedflashlight" ] = {
    type = "get",
    get_obj = "obj_complex_lvl4flashlight_fixedflashlight",
    room ="int_complex_inv",
    zz = "inv_complex_lvl4flashlight",
    zz_gate = "inv_lvl4flashlight"
  };
  --------------------------------------------------------------------------------------------
  local get_fixedflashlight_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl4flashlight" );
    interface.InventoryItemAdd( "inv_fixedflashlight", "obj_complex_lvl4flashlight_fixedflashlight" );
    
    ObjDelete( "gfx_complex_lvl4flashlight_fixedflashlight" );
  
  end;
  cmn.AddSubscriber( "get_fixedflashlight", get_fixedflashlight_inv );

  --------------------------------------------------------------------------------------------
  -- function use_battery3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_battery3" ] = {
    type = "use",
    inv_obj = "inv_battery3",
    use_place = "obj_complex_lvl4flashlight_use_battery3",
    room = "int_complex_inv",
    zz = "inv_complex_lvl4flashlight",
    zz_gate = "inv_lvl4flashlight"
  };
  --------------------------------------------------------------------------------------------
  local use_battery3_inv = function ()
  
    interface.InventoryItemRemove( "inv_battery3" );
    
    if (not cmn.IsEventDone("get_battery1") or cmn.IsEventDone("use_battery1")) and 
       (not cmn.IsEventDone("get_battery2") or cmn.IsEventDone("use_battery2")) and 
       (not cmn.IsEventDone("get_lvl4bulb") or cmn.IsEventDone("use_lvl4bulb")) and
        not(cmn.IsEventDone("use_battery1") and cmn.IsEventDone("use_battery2") and cmn.IsEventDone("use_lvl4bulb"))  then
      ObjSet("inv_lvl4flashlight_star_light",  { alp = 0 });
    end;
  
  end;
  local use_battery3_beg = function ()
  
    ObjDelete( "obj_complex_lvl4flashlight_use_battery3" );
  
  end;
  local use_battery3_end = function ()
    
    ObjSet("anm_complex_lvl4flashlight_use_battery_3",  { pos_z = 7, frame = 300 });
    
    if cmn.IsEventDone("use_battery1") and cmn.IsEventDone("use_battery2") then
      ObjSet("anm_complex_lvl4flashlight_close",  { frame = 300 });
    end;
  
    if cmn.IsEventDone("use_battery1") and cmn.IsEventDone("use_battery2") and cmn.IsEventDone("use_lvl4bulb") then
      ObjDelete( "anm_complex_lvl4flashlight_touch" );
      ObjMultiSet( { {"obj_complex_lvl4flashlight_fixedflashlight", { input = 1 }},
                     {"anm_complex_lvl4flashlight_fixedflashlight", { alp = 1, frame = 300 }},
                     {"gfx_complex_lvl4flashlight_fixedflashlight", { active = 1, visible = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_battery3", use_battery3_beg, "inv_complex_lvl4flashlight" );
  cmn.AddSubscriber( "use_battery3", use_battery3_inv );
  cmn.AddSubscriber( "use_battery3", use_battery3_end, "inv_complex_lvl4flashlight" );
  cmn.AddSubscriber( "use_battery3_inv", use_battery3_inv, "inv_complex_lvl4flashlight" );
  cmn.AddSubscriber( "use_battery3_beg", use_battery3_beg, "inv_complex_lvl4flashlight" );
  cmn.AddSubscriber( "use_battery3_end", use_battery3_end, "inv_complex_lvl4flashlight" );
  --------------------------------------------------------------------------------------------
  -- function use_battery1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_battery1" ] = {
    type = "use",
    inv_obj = "inv_battery1",
    use_place = "obj_complex_lvl4flashlight_use_battery1",
    room = "int_complex_inv",
    zz = "inv_complex_lvl4flashlight",
    zz_gate = "inv_lvl4flashlight"
  };
  --------------------------------------------------------------------------------------------
  local use_battery1_inv = function ()
  
    interface.InventoryItemRemove( "inv_battery1" );
    
    if (not cmn.IsEventDone("get_battery3") or cmn.IsEventDone("use_battery3")) and 
       (not cmn.IsEventDone("get_battery2") or cmn.IsEventDone("use_battery2")) and 
       (not cmn.IsEventDone("get_lvl4bulb") or cmn.IsEventDone("use_lvl4bulb")) and
        not(cmn.IsEventDone("use_battery3") and cmn.IsEventDone("use_battery2") and cmn.IsEventDone("use_lvl4bulb"))  then
      ObjSet("inv_lvl4flashlight_star_light",  { alp = 0 });
    end;
  
  end;
  local use_battery1_beg = function ()
  
    ObjDelete( "obj_complex_lvl4flashlight_use_battery1" );
  
  end;
  local use_battery1_end = function ()
    
    ObjSet("anm_complex_lvl4flashlight_use_battery_1",  { pos_z = 5, frame = 300 });
    
    if cmn.IsEventDone("use_battery3") and cmn.IsEventDone("use_battery2") then
      ObjSet("anm_complex_lvl4flashlight_close",  { frame = 300 });
    end;
  
    if cmn.IsEventDone("use_battery3") and cmn.IsEventDone("use_battery2") and cmn.IsEventDone("use_lvl4bulb") then
      ObjDelete( "anm_complex_lvl4flashlight_touch" );
      ObjMultiSet( { {"obj_complex_lvl4flashlight_fixedflashlight", { input = 1 }},
                     {"anm_complex_lvl4flashlight_fixedflashlight", { alp = 1, frame = 300 }},
                     {"gfx_complex_lvl4flashlight_fixedflashlight", { active = 1, visible = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_battery1", use_battery1_beg, "inv_complex_lvl4flashlight" );
  cmn.AddSubscriber( "use_battery1", use_battery1_inv );
  cmn.AddSubscriber( "use_battery1", use_battery1_end, "inv_complex_lvl4flashlight" );
  cmn.AddSubscriber( "use_battery1_inv", use_battery1_inv, "inv_complex_lvl4flashlight" );
  cmn.AddSubscriber( "use_battery1_beg", use_battery1_beg, "inv_complex_lvl4flashlight" );
  cmn.AddSubscriber( "use_battery1_end", use_battery1_end, "inv_complex_lvl4flashlight" );
  --------------------------------------------------------------------------------------------
  -- function use_battery2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_battery2" ] = {
    type = "use",
    inv_obj = "inv_battery2",
    use_place = "obj_complex_lvl4flashlight_use_battery2",
    room = "int_complex_inv",
    zz = "inv_complex_lvl4flashlight",
    zz_gate = "inv_lvl4flashlight"
  };
  --------------------------------------------------------------------------------------------
  local use_battery2_inv = function ()
  
    interface.InventoryItemRemove( "inv_battery2" );
    
    if (not cmn.IsEventDone("get_battery1") or cmn.IsEventDone("use_battery1")) and 
       (not cmn.IsEventDone("get_battery3") or cmn.IsEventDone("use_battery3")) and 
       (not cmn.IsEventDone("get_lvl4bulb") or cmn.IsEventDone("use_lvl4bulb")) and
        not(cmn.IsEventDone("use_battery1") and cmn.IsEventDone("use_battery3") and cmn.IsEventDone("use_lvl4bulb"))  then
      ObjSet("inv_lvl4flashlight_star_light",  { alp = 0 });
    end;
  
  end;
  local use_battery2_beg = function ()
  
    ObjDelete( "obj_complex_lvl4flashlight_use_battery2" );
  
  end;
  local use_battery2_end = function ()
    
    ObjSet("anm_complex_lvl4flashlight_use_battery_2",  { pos_z = 6, frame = 300 });
    
    if cmn.IsEventDone("use_battery1") and cmn.IsEventDone("use_battery3") then
      ObjSet("anm_complex_lvl4flashlight_close",  { frame = 300 });
    end;
  
    if cmn.IsEventDone("use_battery3") and cmn.IsEventDone("use_battery1") and cmn.IsEventDone("use_lvl4bulb") then
      ObjDelete( "anm_complex_lvl4flashlight_touch" );
      ObjMultiSet( { {"obj_complex_lvl4flashlight_fixedflashlight", { input = 1 }},
                     {"anm_complex_lvl4flashlight_fixedflashlight", { alp = 1, frame = 300 }},
                     {"gfx_complex_lvl4flashlight_fixedflashlight", { active = 1, visible = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_battery2", use_battery2_beg, "inv_complex_lvl4flashlight" );
  cmn.AddSubscriber( "use_battery2", use_battery2_inv );
  cmn.AddSubscriber( "use_battery2", use_battery2_end, "inv_complex_lvl4flashlight" );
  cmn.AddSubscriber( "use_battery2_inv", use_battery2_inv, "inv_complex_lvl4flashlight" );
  cmn.AddSubscriber( "use_battery2_beg", use_battery2_beg, "inv_complex_lvl4flashlight" );
  cmn.AddSubscriber( "use_battery2_end", use_battery2_end, "inv_complex_lvl4flashlight" );
  --------------------------------------------------------------------------------------------
  -- function use_lvl4bulb () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl4bulb" ] = {
    type = "use",
    inv_obj = "inv_lvl4bulb",
    use_place = "obj_complex_lvl4flashlight_use_lvl4bulb",
    room = "int_complex_inv",
    zz = "inv_complex_lvl4flashlight",
    zz_gate = "inv_lvl4flashlight"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl4bulb_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl4bulb" );
    
    if (not cmn.IsEventDone("get_battery1") or cmn.IsEventDone("use_battery1")) and 
       (not cmn.IsEventDone("get_battery2") or cmn.IsEventDone("use_battery2")) and 
       (not cmn.IsEventDone("get_battery3") or cmn.IsEventDone("use_battery3")) and
        not(cmn.IsEventDone("use_battery1") and cmn.IsEventDone("use_battery2") and cmn.IsEventDone("use_battery3"))  then
      ObjSet("inv_lvl4flashlight_star_light",  { alp = 0 });
    end;
  
  end;
  local use_lvl4bulb_beg = function ()
  
    ObjDelete( "obj_complex_lvl4flashlight_use_lvl4bulb" );
  
  end;
  local use_lvl4bulb_end = function ()
    
    ObjSet("anm_complex_lvl4flashlight_use_bulb",  { frame = 300 });
  
    if cmn.IsEventDone("use_battery3") and cmn.IsEventDone("use_battery2") and cmn.IsEventDone("use_battery1") then
      ObjDelete( "anm_complex_lvl4flashlight_touch" );
      ObjMultiSet( { {"obj_complex_lvl4flashlight_fixedflashlight", { input = 1 }},
                     {"anm_complex_lvl4flashlight_fixedflashlight", { alp = 1, frame = 300 }},
                     {"gfx_complex_lvl4flashlight_fixedflashlight", { active = 1, visible = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl4bulb", use_lvl4bulb_beg, "inv_complex_lvl4flashlight" );
  cmn.AddSubscriber( "use_lvl4bulb", use_lvl4bulb_inv );
  cmn.AddSubscriber( "use_lvl4bulb", use_lvl4bulb_end, "inv_complex_lvl4flashlight" );
  cmn.AddSubscriber( "use_lvl4bulb_inv", use_lvl4bulb_inv, "inv_complex_lvl4flashlight" );
  cmn.AddSubscriber( "use_lvl4bulb_beg", use_lvl4bulb_beg, "inv_complex_lvl4flashlight" );
  cmn.AddSubscriber( "use_lvl4bulb_end", use_lvl4bulb_end, "inv_complex_lvl4flashlight" );
  
  --------------------------------------------------------------------------------------------
  -- function clk_lvl4bulb () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_lvl4bulb" ] = {
    type = "click",
    use_place = "obj_complex_lvl4flashlight_clk_lvl4bulb",
    room = "int_complex_inv",
    zz = "inv_complex_lvl4flashlight",
    zz_gate = "inv_lvl4flashlight"
  };
  --------------------------------------------------------------------------------------------
  local clk_lvl4bulb_inv = function ()
    
    if (not cmn.IsEventDone("get_battery1") or cmn.IsEventDone("use_battery1")) and 
       (not cmn.IsEventDone("get_battery2") or cmn.IsEventDone("use_battery2")) and 
       (not cmn.IsEventDone("get_battery3") or cmn.IsEventDone("use_battery3")) and
       (not cmn.IsEventDone("get_lvl4bulb") or cmn.IsEventDone("use_lvl4bulb")) and
        not(cmn.IsEventDone("use_battery1") and cmn.IsEventDone("use_battery2") and cmn.IsEventDone("use_battery3") and cmn.IsEventDone("use_lvl4bulb"))  then
      ObjSet("inv_lvl4flashlight_star_light",  { alp = 0 });
    end;
    
  end;
  local clk_lvl4bulb_beg = function ()
  
    ObjDelete( "obj_complex_lvl4flashlight_clk_lvl4bulb" );
  
  end;
  local clk_lvl4bulb_end = function ()
  
    ObjDelete( "anm_complex_lvl4flashlight_bulb_out" );
    
    ObjMultiSet( { {"anm_complex_lvl4flashlight_use_bulb", { alp = 1 }},
                   {"obj_complex_lvl4flashlight_use_lvl4bulb", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_lvl4bulb", clk_lvl4bulb_beg, "inv_complex_lvl4flashlight" );
  cmn.AddSubscriber( "clk_lvl4bulb", clk_lvl4bulb_end, "inv_complex_lvl4flashlight" );
  cmn.AddSubscriber( "clk_lvl4bulb", clk_lvl4bulb_inv );
  cmn.AddSubscriber( "clk_lvl4bulb_beg", clk_lvl4bulb_beg, "inv_complex_lvl4flashlight" );
  cmn.AddSubscriber( "clk_lvl4bulb_end", clk_lvl4bulb_end, "inv_complex_lvl4flashlight" );
  cmn.AddSubscriber( "clk_lvl4bulb_inv", clk_lvl4bulb_inv );

  --port.  fix
  if port.isPortable() == 1 then
    port.InventoryPopupInit("inventory4_hub");
    port.VideoResizeInRoom("inventory4");
  end;
  
end;
--*********************************************************************************************************************
-- function *** CLOSE FUNC *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.inv_complex_lvl4rope_close()

  if cmn.IsEventDone("use_lvl4hook") and not cmn.IsEventDone("get_ropehook") then
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
    
    cmn.SetEventDone( "get_ropehook" );
    cmn.CallEventHandler( "get_ropehook", "inv_complex_lvl4rope" );
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_egg_close()

  if not cmn.IsEventDone( "get_feather2" ) then
    
    cmn.SetEventDone( "get_feather2" );
    cmn.CallEventHandler( "get_feather2", "inv_complex_egg" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;
  
  if cmn.IsEventDone("use_emerald") and cmn.IsEventDone("use_ruby") and cmn.IsEventDone("use_sapphire")
  and cmn.IsEventDone("use_amethyst") and not cmn.IsEventDone("get_snowflake") then
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
    
    cmn.SetEventDone( "get_snowflake" );
    cmn.CallEventHandler( "get_snowflake", "inv_complex_egg" );
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_torch_close()
  
  if not cmn.IsEventDone( "get_shovelhandle" ) then
    
    cmn.SetEventDone( "get_shovelhandle" );
    cmn.CallEventHandler( "get_shovelhandle", "inv_complex_torch" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;

  if cmn.IsEventDone("use_littlefire") and cmn.IsEventDone("use_littlemirror") and not cmn.IsEventDone("get_guidingtorch") then
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
    
    cmn.SetEventDone( "get_guidingtorch" );
    cmn.CallEventHandler( "get_guidingtorch", "inv_complex_torch" );
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_diary_close()
  
  if not cmn.IsEventDone( "get_clothbutton2" ) then
    
    cmn.SetEventDone( "get_clothbutton2" );
    cmn.CallEventHandler( "get_clothbutton2", "inv_complex_diary" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;

  if cmn.IsEventDone("use_codewheel") and not cmn.IsEventDone("get_fireamulet2") then
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
    
    cmn.SetEventDone( "get_fireamulet2" );
    cmn.CallEventHandler( "get_fireamulet2", "inv_complex_diary" );
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_soldier_close()

  if cmn.IsEventDone("use_soldierpart") and not cmn.IsEventDone("get_toysoldier") then
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
    
    cmn.SetEventDone( "get_toysoldier" );
    cmn.CallEventHandler( "get_toysoldier", "inv_complex_soldier" );
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_lvl4flashlight_close()

  if cmn.IsEventDone("use_battery1") and cmn.IsEventDone("use_battery2") and cmn.IsEventDone("use_battery3")
  and cmn.IsEventDone("use_lvl4bulb") and not cmn.IsEventDone("get_fixedflashlight") then
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
    
    cmn.SetEventDone( "get_fixedflashlight" );
    cmn.CallEventHandler( "get_fixedflashlight", "inv_complex_lvl4flashlight" );
    
  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_lvl4hook()

  local item = "inv_lvl4hook";

  if cmn.ObjIntersectCheck( item, "obj_complex_lvl4rope_use_lvl4hook" ) then

    cmn.CallEventHandler( "use_lvl4hook_inv", "inv_complex_lvl4rope" );
    cmn.CallEventHandler( "use_lvl4hook_beg", "inv_complex_lvl4rope" );

    local func_after = function ()

      cmn.SetEventDone( "use_lvl4hook" );
      cmn.CallEventHandler( "use_lvl4hook_end", "inv_complex_lvl4rope" );

      cmn.Lock( 0 );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_wear_hook");
  
    ObjSet("anm_complex_lvl4rope_use_hook",  { alp = 1, playing = 1, endtrig = func_after });
  
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_emerald()

  local item = "inv_emerald";

  if cmn.ObjIntersectCheck( item, "obj_complex_egg_use_emerald" ) then

    cmn.CallEventHandler( "use_emerald_inv", "inv_complex_egg" );
    cmn.CallEventHandler( "use_emerald_beg", "inv_complex_egg" );

    local func_after = function ()

      cmn.SetEventDone( "use_emerald" );
      cmn.CallEventHandler( "use_emerald_end", "inv_complex_egg" );

      cmn.Lock( 0 );
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_egg_opens");
      
      ObjDelete("obj_complex_egg_1");
      ObjMultiSet( { {"anm_complex_egg_open",  { alp = 1, playing = 1, endtrig = func_after }},
                     {"spr_complex_egg_base", { alp = 1 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_egg_insert_crystal");
  
    if cmn.IsEventDone("use_amethyst") and cmn.IsEventDone("use_sapphire") and cmn.IsEventDone("use_ruby") then
      ObjSet("anm_complex_egg_use_emerald",  { alp = 1, playing = 1, endtrig = anm_open });
    else
      ObjSet("anm_complex_egg_use_emerald",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_ruby()

  local item = "inv_ruby";

  if cmn.ObjIntersectCheck( item, "obj_complex_egg_use_ruby" ) then

    cmn.CallEventHandler( "use_ruby_inv", "inv_complex_egg" );
    cmn.CallEventHandler( "use_ruby_beg", "inv_complex_egg" );

    local func_after = function ()

      cmn.SetEventDone( "use_ruby" );
      cmn.CallEventHandler( "use_ruby_end", "inv_complex_egg" );

      cmn.Lock( 0 );
    
    end;

    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_egg_opens");
      
      ObjDelete("obj_complex_egg_1");
      ObjMultiSet( { {"anm_complex_egg_open",  { alp = 1, playing = 1, endtrig = func_after }},
                     {"spr_complex_egg_base", { alp = 1 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_egg_insert_crystal");
  
    if cmn.IsEventDone("use_amethyst") and cmn.IsEventDone("use_sapphire") and cmn.IsEventDone("use_emerald") then
      ObjSet("anm_complex_egg_use_ruby",  { alp = 1, playing = 1, endtrig = anm_open });
    else
      ObjSet("anm_complex_egg_use_ruby",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_sapphire()

  local item = "inv_sapphire";

  if cmn.ObjIntersectCheck( item, "obj_complex_egg_use_sapphire" ) then

    cmn.CallEventHandler( "use_sapphire_inv", "inv_complex_egg" );
    cmn.CallEventHandler( "use_sapphire_beg", "inv_complex_egg" );

    local func_after = function ()

      cmn.SetEventDone( "use_sapphire" );
      cmn.CallEventHandler( "use_sapphire_end", "inv_complex_egg" );

      cmn.Lock( 0 );
    
    end;

    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_egg_opens");
      
      ObjDelete("obj_complex_egg_1");
      ObjMultiSet( { {"anm_complex_egg_open",  { alp = 1, playing = 1, endtrig = func_after }},
                     {"spr_complex_egg_base", { alp = 1 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_egg_insert_crystal");
  
    if cmn.IsEventDone("use_amethyst") and cmn.IsEventDone("use_ruby") and cmn.IsEventDone("use_emerald") then
      ObjSet("anm_complex_egg_use_sapphire",  { alp = 1, playing = 1, endtrig = anm_open });
    else
      ObjSet("anm_complex_egg_use_sapphire",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_amethyst()

  local item = "inv_amethyst";

  if cmn.ObjIntersectCheck( item, "obj_complex_egg_use_amethyst" ) then

    cmn.CallEventHandler( "use_amethyst_inv", "inv_complex_egg" );
    cmn.CallEventHandler( "use_amethyst_beg", "inv_complex_egg" );

    local func_after = function ()

      cmn.SetEventDone( "use_amethyst" );
      cmn.CallEventHandler( "use_amethyst_end", "inv_complex_egg" );

      cmn.Lock( 0 );
    
    end;

    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_egg_opens");
      
      ObjDelete("obj_complex_egg_1");
      ObjMultiSet( { {"anm_complex_egg_open",  { alp = 1, playing = 1, endtrig = func_after }},
                     {"spr_complex_egg_base", { alp = 1 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_egg_insert_crystal");
  
    if cmn.IsEventDone("use_sapphire") and cmn.IsEventDone("use_ruby") and cmn.IsEventDone("use_emerald") then
      ObjSet("anm_complex_egg_use_amethyst",  { alp = 1, playing = 1, endtrig = anm_open });
    else
      ObjSet("anm_complex_egg_use_amethyst",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_littlefire()

  local item = "inv_littlefire";

  if cmn.ObjIntersectCheck( item, "obj_complex_torch_use_littlefire" ) and cmn.IsEventDone("clk_opentorch") then

    cmn.CallEventHandler( "use_littlefire_inv", "inv_complex_torch" );
    cmn.CallEventHandler( "use_littlefire_beg", "inv_complex_torch" );

    local func_after = function ()

      cmn.SetEventDone( "use_littlefire" );
      cmn.CallEventHandler( "use_littlefire_end", "inv_complex_torch" );

      cmn.Lock( 0 );
    
    end;
    
    local anm_torch = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_light_close");
      
      ObjDelete("anm_complex_torch_open");
      ObjSet("anm_complex_torch_close",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_insert_light");
  
    if cmn.IsEventDone("use_littlemirror") then
      ObjSet("anm_complex_torch_use_fire",  { alp = 1, playing = 1, endtrig = anm_torch });
    else
      ObjSet("anm_complex_torch_use_fire",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_littlemirror()

  local item = "inv_littlemirror";

  if cmn.ObjIntersectCheck( item, "obj_complex_torch_use_littlemirror" ) and cmn.IsEventDone("clk_littlemirror") and cmn.IsEventDone("clk_opentorch") then

    cmn.CallEventHandler( "use_littlemirror_inv", "inv_complex_torch" );
    private.use_littlemirror_end();
    
  elseif cmn.ObjIntersectCheck( item, "obj_complex_torch_use_littlemirror" ) and not cmn.IsEventDone("clk_littlemirror") and cmn.IsEventDone("clk_opentorch") then

    cmn.CallEventHandler( "use_littlemirror_inv", "inv_complex_torch" );
    public.clk_littlemirror(2);

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function private.use_littlemirror_end()
  
  cmn.CallEventHandler( "use_littlemirror_beg", "inv_complex_torch" );

  local func_after = function ()

    cmn.SetEventDone( "use_littlemirror" );
    cmn.CallEventHandler( "use_littlemirror_end", "inv_complex_torch" );

    cmn.Lock( 0 );
  
  end;
  
  local anm_torch = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_light_close");
    
    ObjDelete("anm_complex_torch_open");
    ObjSet("anm_complex_torch_close",  { alp = 1, playing = 1, endtrig = func_after });
    
  end;

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_insert_new_lamp");

  if cmn.IsEventDone("use_littlefire") then
    ObjSet("anm_complex_torch_use_mirror",  { alp = 1, playing = 1, endtrig = anm_torch });
  else
    ObjSet("anm_complex_torch_use_mirror",  { alp = 1, playing = 1, endtrig = func_after });
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.use_codewheel()

  local item = "inv_codewheel";

  if cmn.ObjIntersectCheck( item, "obj_complex_diary_use_codewheel" ) then
    
    if not cmn.IsEventDone("get_clothbutton2") then
      public.get_clothbutton2();
    end;

    cmn.CallEventHandler( "use_codewheel_inv", "inv_complex_diary" );
    cmn.CallEventHandler( "use_codewheel_beg", "inv_complex_diary" );

    local func_after = function ()

      cmn.SetEventDone( "use_codewheel" );
      cmn.CallEventHandler( "use_codewheel_end", "inv_complex_diary" );

      cmn.Lock( 0 );
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_butterfly_diary");
  
    ObjSet("anm_complex_diary_open",  { alp = 1, playing = 1, endtrig = func_after });
  
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_soldierpart()

  local item = "inv_soldierpart";

  if cmn.ObjIntersectCheck( item, "obj_complex_soldier_use_soldierpart" ) then

    cmn.CallEventHandler( "use_soldierpart_inv", "inv_complex_soldier" );
    cmn.CallEventHandler( "use_soldierpart_beg", "inv_complex_soldier" );

    local func_after = function ()

      cmn.SetEventDone( "use_soldierpart" );
      cmn.CallEventHandler( "use_soldierpart_end", "inv_complex_soldier" );

      cmn.Lock( 0 );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_solider_take_stuffs");
  
    ObjSet("anm_complex_soldier_toysoldier",  { animfunc = "func_use_parts", frame = 0, playing = 1, endtrig = func_after });
  
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_battery3()

  local item = "inv_battery3";

  if cmn.ObjIntersectCheck( item, "obj_complex_lvl4flashlight_use_battery3" ) then

    cmn.CallEventHandler( "use_battery3_inv", "inv_complex_lvl4flashlight" );
    cmn.CallEventHandler( "use_battery3_beg", "inv_complex_lvl4flashlight" );

    local func_after = function ()

      cmn.SetEventDone( "use_battery3" );
      cmn.CallEventHandler( "use_battery3_end", "inv_complex_lvl4flashlight" );

      cmn.Lock( 0 );
    
    end;

    local anm_light = function ()
    
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_lamp_light");
    
      ObjDelete("anm_complex_lvl4flashlight_touch");
      ObjSet("anm_complex_lvl4flashlight_fixedflashlight",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;
    
    local anm_close = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_lamp_close");
      
      ObjSet("anm_complex_lvl4flashlight_use_battery_3",  { pos_z = 7 });
      
      if cmn.IsEventDone("use_lvl4bulb") then
        ObjSet("anm_complex_lvl4flashlight_close",  { playing = 1, endtrig = anm_light });
      else 
        ObjSet("anm_complex_lvl4flashlight_close",  { playing = 1, endtrig = func_after });
      end;
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_insert_battery_lamp");
  
    if cmn.IsEventDone("use_battery2") and cmn.IsEventDone("use_battery1") then
      ObjSet("anm_complex_lvl4flashlight_use_battery_3",  { playing = 1, endtrig = anm_close });
    else
      ObjSet("anm_complex_lvl4flashlight_use_battery_3",  { playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_battery1()

  local item = "inv_battery1";

  if cmn.ObjIntersectCheck( item, "obj_complex_lvl4flashlight_use_battery1" ) then

    cmn.CallEventHandler( "use_battery1_inv", "inv_complex_lvl4flashlight" );
    cmn.CallEventHandler( "use_battery1_beg", "inv_complex_lvl4flashlight" );

    local func_after = function ()

      cmn.SetEventDone( "use_battery1" );
      cmn.CallEventHandler( "use_battery1_end", "inv_complex_lvl4flashlight" );

      cmn.Lock( 0 );
    
    end;

    local anm_light = function ()
    
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_lamp_light");
    
      ObjDelete("anm_complex_lvl4flashlight_touch");
      ObjSet("anm_complex_lvl4flashlight_fixedflashlight",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;
    
    local anm_close = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_lamp_close");
      
      ObjSet("anm_complex_lvl4flashlight_use_battery_1",  { pos_z = 5 });
      
      if cmn.IsEventDone("use_lvl4bulb") then
        ObjSet("anm_complex_lvl4flashlight_close",  { playing = 1, endtrig = anm_light });
      else 
        ObjSet("anm_complex_lvl4flashlight_close",  { playing = 1, endtrig = func_after });
      end;
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_insert_battery_lamp");
  
    if cmn.IsEventDone("use_battery3") and cmn.IsEventDone("use_battery2") then
      ObjSet("anm_complex_lvl4flashlight_use_battery_1",  { playing = 1, endtrig = anm_close });
    else
      ObjSet("anm_complex_lvl4flashlight_use_battery_1",  { playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_battery2()

  local item = "inv_battery2";

  if cmn.ObjIntersectCheck( item, "obj_complex_lvl4flashlight_use_battery2" ) then

    cmn.CallEventHandler( "use_battery2_inv", "inv_complex_lvl4flashlight" );
    cmn.CallEventHandler( "use_battery2_beg", "inv_complex_lvl4flashlight" );

    local func_after = function ()

      cmn.SetEventDone( "use_battery2" );
      cmn.CallEventHandler( "use_battery2_end", "inv_complex_lvl4flashlight" );

      cmn.Lock( 0 );
    
    end;
    
    local anm_light = function ()
    
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_lamp_light");
    
      ObjDelete("anm_complex_lvl4flashlight_touch");
      ObjSet("anm_complex_lvl4flashlight_fixedflashlight",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;
    
    local anm_close = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_lamp_close");
      
      ObjSet("anm_complex_lvl4flashlight_use_battery_2",  { pos_z = 6 });
      
      if cmn.IsEventDone("use_lvl4bulb") then
        ObjSet("anm_complex_lvl4flashlight_close",  { playing = 1, endtrig = anm_light });
      else 
        ObjSet("anm_complex_lvl4flashlight_close",  { playing = 1, endtrig = func_after });
      end;
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_insert_battery_lamp");
  
    if cmn.IsEventDone("use_battery3") and cmn.IsEventDone("use_battery1") then
      ObjSet("anm_complex_lvl4flashlight_use_battery_2",  { playing = 1, endtrig = anm_close });
    else
      ObjSet("anm_complex_lvl4flashlight_use_battery_2",  { playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl4bulb()

  local item = "inv_lvl4bulb";

  if cmn.ObjIntersectCheck( item, "obj_complex_lvl4flashlight_use_lvl4bulb" ) and cmn.IsEventDone("clk_lvl4bulb") then

    cmn.CallEventHandler( "use_lvl4bulb_inv", "inv_complex_lvl4flashlight" );
    private.use_lvl4bulb_end();
    
  elseif cmn.ObjIntersectCheck( item, "obj_complex_lvl4flashlight_use_lvl4bulb" ) and not cmn.IsEventDone("clk_lvl4bulb") then

    cmn.CallEventHandler( "use_lvl4bulb_inv", "inv_complex_lvl4flashlight" );
    public.clk_lvl4bulb(2);

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function private.use_lvl4bulb_end()
  
  cmn.CallEventHandler( "use_lvl4bulb_beg", "inv_complex_lvl4flashlight" );

  local func_after = function ()

    cmn.SetEventDone( "use_lvl4bulb" );
    cmn.CallEventHandler( "use_lvl4bulb_end", "inv_complex_lvl4flashlight" );

    cmn.Lock( 0 );
  
  end;
  
  local anm_light = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_lamp_light");
    
    ObjDelete("anm_complex_lvl4flashlight_touch");
    ObjSet("anm_complex_lvl4flashlight_fixedflashlight",  { alp = 1, playing = 1, endtrig = func_after });
    
  end;

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_insert_new_lamp_2");

  if cmn.IsEventDone("use_battery3") and cmn.IsEventDone("use_battery2") and cmn.IsEventDone("use_battery1") then
    ObjSet("anm_complex_lvl4flashlight_use_bulb",  { alp = 1, playing = 1, endtrig = anm_light });
  else
    ObjSet("anm_complex_lvl4flashlight_use_bulb",  { alp = 1, playing = 1, endtrig = func_after });
    end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_ropehook()

  cmn.SetEventDone( "get_ropehook" );
  cmn.CallEventHandler( "get_ropehook", "inv_complex_lvl4rope" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_feather2()
  
  ObjSet("spr_complex_egg_feather2",  { pos_x = 0, drawoff_x = 0 });

  cmn.SetEventDone( "get_feather2" );
  cmn.CallEventHandler( "get_feather2", "inv_complex_egg" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_snowflake()

  cmn.SetEventDone( "get_snowflake" );
  cmn.CallEventHandler( "get_snowflake", "inv_complex_egg" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_guidingtorch()

  cmn.SetEventDone( "get_guidingtorch" );
  cmn.CallEventHandler( "get_guidingtorch", "inv_complex_torch" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_shovelhandle()

  cmn.SetEventDone( "get_shovelhandle" );
  cmn.CallEventHandler( "get_shovelhandle", "inv_complex_torch" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_clothbutton2()

  cmn.SetEventDone( "get_clothbutton2" );
  cmn.CallEventHandler( "get_clothbutton2", "inv_complex_diary" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_fireamulet2()

  cmn.SetEventDone( "get_fireamulet2" );
  cmn.CallEventHandler( "get_fireamulet2", "inv_complex_diary" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_toysoldier()

  cmn.SetEventDone( "get_toysoldier" );
  cmn.CallEventHandler( "get_toysoldier", "inv_complex_soldier" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_fixedflashlight()

  cmn.SetEventDone( "get_fixedflashlight" );
  cmn.CallEventHandler( "get_fixedflashlight", "inv_complex_lvl4flashlight" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.HideComplexItem();

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_opentorch()

  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_click_lamp_open");

  local func_after = function ()

    cmn.SetEventDone( "clk_opentorch" );
    cmn.CallEventHandler( "clk_opentorch", "inv_complex_torch" );

    cmn.Lock(0);

  end;
  
  ObjSet("anm_complex_torch_open",  { alp = 1, playing = 1, endtrig = func_after });
  
end;
--------------------------------------------------------------------------------------------
function public.clk_littlemirror(num)

  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_click_lamp_take");

  local func_after = function ()

    cmn.SetEventDone( "clk_littlemirror" );
    cmn.CallEventHandler( "clk_littlemirror", "inv_complex_torch" );

    if num == 1 then
      cmn.Lock(0);
    else 
      private.use_littlemirror_end();
    end;

  end;
  
  ObjSet("anm_complex_torch_old_mirror",  { alp = 1, playing = 1, endtrig = func_after });
  
end;
--------------------------------------------------------------------------------------------
function public.clk_lvl4bulb(num)

  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_lamp_take_old");
  
  cmn.CallEventHandler( "clk_lvl4bulb_inv", "inv_complex_lvl4flashlight" );
  cmn.CallEventHandler( "clk_lvl4bulb_beg", "inv_complex_lvl4flashlight" );

  local func_after = function ()

    cmn.SetEventDone( "clk_lvl4bulb" );
    cmn.CallEventHandler( "clk_lvl4bulb_end", "inv_complex_lvl4flashlight" );

    if num == 1 then
      cmn.Lock(0);
    else 
      private.use_lvl4bulb_end();
    end;

  end;
  
  ObjSet("anm_complex_lvl4flashlight_bulb_out",  { alp = 1, playing = 1, endtrig = func_after });
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.touch_egg()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_inv_egg");

  cmn.ShowBbt( "obj_complex_egg_use_gem" );
  
  ObjSet( "anm_complex_egg_touch", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_rope()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_inv_rope");

  cmn.ShowBbt( "obj_complex_lvl4rope_use_lvl4hook" );
  
  ObjSet( "anm_complex_lvl4rope_rope_touch", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_diary()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_inv_pink_book");

  cmn.ShowBbt( "obj_complex_diary_use_codewheel" );
  
  ObjSet( "anm_complex_diary_touch", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_soldier()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_inv_solider");

  cmn.ShowBbt( "obj_complex_soldier_use_soldierpart" );
  
  ObjSet( "anm_complex_soldier_toysoldier", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_flashlight( num )
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_inv_xx_lamp");

  if num == 1 then
    cmn.ShowBbt( "obj_complex_lvl4flashlight_use_battery" );
  else 
    cmn.ShowBbt( "obj_complex_lvl4flashlight_use_lvl4bulb" );
  end;
  
  ObjSet( "anm_complex_lvl4flashlight_touch", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--*********************************************************************************************************************
