-- name=rm_cellar
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_cellar";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Electricbox();
  --------------------------------------------------------------------------------------------
  -- function get_lvl4screwdriver () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl4screwdriver" ] = {
    type = "get",
    get_obj = "spr_electricbox_lvl4screwdriver",
    room = private.room_objname,
    zz = "zz_electricbox",
    zz_gate = "gzz_cellar_electricbox"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl4screwdriver_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl4screwdriver", "spr_electricbox_lvl4screwdriver" );
  
  end;
  local get_lvl4screwdriver_end = function ()
  
    ObjDelete( "gfx_electricbox_lvl4screwdriver" );
    ObjDelete( "spr_electricbox_lvl4screwdriver_sh" );

    ObjDelete( "spr_cellar_electricbox_lvl4screwdriver" );
  
  end;
  
  cmn.AddSubscriber( "get_lvl4screwdriver", get_lvl4screwdriver_inv );
  cmn.AddSubscriber( "get_lvl4screwdriver", get_lvl4screwdriver_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bone () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_bone" ] = {
    type = "get",
    get_obj = "spr_gamingmachine_bone",
    room = private.room_objname,
    zz = "zz_gamingmachine",
    zz_gate = "gzz_cellar_gamingmachine"
  };
  --------------------------------------------------------------------------------------------
  local get_bone_inv = function ()
  
    interface.InventoryItemAdd( "inv_bone", "spr_gamingmachine_bone" );
  
  end;
  local get_bone_end = function ()
  
    ObjDelete( "gfx_gamingmachine_bone" );
    ObjDelete( "spr_gamingmachine_bone_sh" );

    ObjDelete( "spr_cellar_gamingmachine_bone" );
  
  end;
  
  cmn.AddSubscriber( "get_bone", get_bone_inv );
  cmn.AddSubscriber( "get_bone", get_bone_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_recipe () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_recipe" ] = {
    type = "get",
    get_obj = "spr_nayasdesk_recipe",
    room = private.room_objname,
    zz = "zz_nayasdesk",
    zz_gate = "gzz_cellar_nayasdesk"
  };
  --------------------------------------------------------------------------------------------
  local get_recipe_inv = function ()
  
    interface.InventoryItemAdd( "inv_recipe", "spr_nayasdesk_recipe" );
  
  end;
  local get_recipe_end = function ()
  
    ObjDelete( "gfx_nayasdesk_recipe" );
    ObjDelete( "spr_nayasdesk_recipe_sh" );

    ObjDelete( "spr_cellar_nayadesk_recipe" );
  
  end;
  
  cmn.AddSubscriber( "get_recipe", get_recipe_inv );
  cmn.AddSubscriber( "get_recipe", get_recipe_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_potion () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_potion" ] = {
    type = "get",
    get_obj = "spr_nayasdesk_potion",
    room = private.room_objname,
    zz = "zz_nayasdesk",
    zz_gate = "gzz_cellar_nayasdesk"
  };
  --------------------------------------------------------------------------------------------
  local get_potion_inv = function ()
  
    interface.InventoryItemAdd( "inv_potion", "spr_nayasdesk_potion" );
  
  end;
  local get_potion_end = function ()
  
    ObjDelete( "gfx_nayasdesk_potion" );
    ObjDelete( "spr_nayasdesk_potion_sh" );
    ObjDelete( "spr_nayasdesk_potion_2" );
    ObjDelete( "spr_nayasdesk_potion_3" );
    ObjDelete( "spr_nayasdesk_potion_4" );

    ObjDelete( "spr_cellar_nayadesk_bottle2" );

    ObjSet("gzz_cellar_nayasdesk",  { active = 0, visible = 0 });
  
  end;
  
  cmn.AddSubscriber( "get_potion", get_potion_inv );
  cmn.AddSubscriber( "get_potion", get_potion_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_machinepart2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_machinepart2" ] = {
    type = "get",
    get_obj = "spr_nayasdesk_machinepart2",
    room = private.room_objname,
    zz = "zz_nayasdesk",
    zz_gate = "gzz_cellar_nayasdesk"
  };
  --------------------------------------------------------------------------------------------
  local get_machinepart2_inv = function ()
  
    interface.InventoryItemAdd( "inv_machinepart2", "spr_nayasdesk_machinepart2" );
  
  end;
  local get_machinepart2_end = function ()
  
    ObjDelete( "gfx_nayasdesk_machinepart2" );
    ObjDelete( "spr_nayasdesk_machinepart2_sh" );

    ObjDelete( "spr_cellar_nayadesk_machinepart2" );
  
  end;
  
  cmn.AddSubscriber( "get_machinepart2", get_machinepart2_inv );
  cmn.AddSubscriber( "get_machinepart2", get_machinepart2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl4flashlight () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl4flashlight" ] = {
    type = "get",
    get_obj = "spr_nayasdesk_lvl4flashlight",
    room = private.room_objname,
    zz = "zz_nayasdesk",
    zz_gate = "gzz_cellar_nayasdesk"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl4flashlight_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_lvl4flashlight", "spr_nayasdesk_lvl4flashlight" );
  
  end;
  local get_lvl4flashlight_end = function ()
  
    ObjDelete( "gfx_nayasdesk_lvl4flashlight" );
    ObjDelete( "spr_nayasdesk_lvl4flashlight_sh" );

    ObjDelete( "spr_cellar_nayadesk_lvl4flashlight" );
  
  end;
  
  cmn.AddSubscriber( "get_lvl4flashlight", get_lvl4flashlight_inv );
  cmn.AddSubscriber( "get_lvl4flashlight", get_lvl4flashlight_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_seeds () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_seeds" ] = {
    type = "get",
    get_obj = "spr_chest_seeds",
    room = private.room_objname,
    zz = "zz_chest",
    zz_gate = "gzz_cellar_chest"
  };
  --------------------------------------------------------------------------------------------
  local get_seeds_inv = function ()
  
    interface.InventoryItemAdd( "inv_seeds", "spr_chest_seeds" );
  
  end;
  local get_seeds_end = function ()
  
    ObjDelete( "gfx_chest_seeds" );
    ObjDelete( "spr_chest_seeds_sh" );

    ObjDelete( "spr_cellar_chest_seeds" );
  
  end;
  
  cmn.AddSubscriber( "get_seeds", get_seeds_inv );
  cmn.AddSubscriber( "get_seeds", get_seeds_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_battery3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_battery3" ] = {
    type = "get",
    get_obj = "spr_chest_battery3",
    room = private.room_objname,
    zz = "zz_chest",
    zz_gate = "gzz_cellar_chest"
  };
  --------------------------------------------------------------------------------------------
  local get_battery3_inv = function ()
  
    interface.InventoryItemAdd( "inv_battery3", "spr_chest_battery3" );
    ObjSet( "inv_lvl4flashlight_star_light", { alp = 1 } );
  
  end;
  local get_battery3_end = function ()
  
    ObjDelete( "gfx_chest_battery3" );
    ObjDelete( "spr_chest_battery3_sh" );

    ObjDelete( "spr_cellar_chest_battery" );
  
  end;
  
  cmn.AddSubscriber( "get_battery3", get_battery3_inv );
  cmn.AddSubscriber( "get_battery3", get_battery3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl4wire () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl4wire" ] = {
    type = "get",
    get_obj = "spr_chest_lvl4wire",
    room = private.room_objname,
    zz = "zz_chest",
    zz_gate = "gzz_cellar_chest"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl4wire_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl4wire", "spr_chest_lvl4wire" );
  
  end;
  local get_lvl4wire_end = function ()
  
    ObjDelete( "gfx_chest_lvl4wire" );
    ObjDelete( "spr_chest_lvl4wire_sh" );

    ObjDelete( "spr_cellar_chest_wire" );
  
  end;
  
  cmn.AddSubscriber( "get_lvl4wire", get_lvl4wire_inv );
  cmn.AddSubscriber( "get_lvl4wire", get_lvl4wire_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_heartpart3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_heartpart3" ] = {
    type = "get",
    get_obj = "spr_chest_heartpart3",
    room = private.room_objname,
    zz = "zz_chest",
    zz_gate = "gzz_cellar_chest"
  };
  --------------------------------------------------------------------------------------------
  local get_heartpart3_inv = function ()
  
    interface.InventoryItemAdd( "inv_heartpart3", "spr_chest_heartpart3" );
    int_map_impl.DecreaseRoomTasks("rm_cellar");
  
  end;
  local get_heartpart3_end = function ()
  
    ObjDelete( "gfx_chest_heartpart3" );
    ObjDelete( "spr_chest_heartpart3_sh" );
    ObjDelete( "gzz_cellar_chest" );

    ObjDelete( "spr_cellar_chest_heartpart" );
  
  end;
  
  cmn.AddSubscriber( "get_heartpart3", get_heartpart3_inv );
  cmn.AddSubscriber( "get_heartpart3", get_heartpart3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_letter7 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_letter7" ] = {
    type = "get",
    get_obj = "spr_cellar_letter7",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_letter7_inv = function ()
  
    interface.InventoryItemAdd( "inv_letter", "spr_cellar_letter7", function () cmn.GetMultyObject( 'letter', 9 ); end );
    int_map_impl.DecreaseRoomTasks("rm_cellar");
  
  end;
  local get_letter7_end = function ()
  
    ObjDelete( "gfx_cellar_letter7" );
    ObjDelete( "spr_cellar_letter7_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_letter7", get_letter7_inv );
  cmn.AddSubscriber( "get_letter7", get_letter7_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_fuse1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_fuse1" ] = {
    type = "use",
    inv_obj = "inv_fuse1",
    use_place = "obj_electricbox_use_fuse1",
    room = private.room_objname,
    zz = "zz_electricbox",
    zz_gate = "gzz_cellar_electricbox"
  };
  --------------------------------------------------------------------------------------------
  local use_fuse1_inv = function ()
  
    interface.InventoryItemRemove( "inv_fuse1" );
  
  end;
  local use_fuse1_beg = function ()
  
    ObjDelete( "obj_electricbox_use_fuse1" );
  
  end;
  local use_fuse1_end = function ()

    ObjSet( "spr_cellar_electricbox_fuse1", { alp = 1 } );

    if ( cmn.IsEventDone( "use_fuse2" ) ) then
      ObjDelete( "anm_electricbox_use_fuse_2" );
      ObjDelete( "anm_electricbox_use_fuse_1" );
      ObjMultiSet( { {"anm_electricbox_fuses_burn", { alp = 1 }},
                     {"obj_electricbox_game", { input = 1 }} } );
    else
      ObjSet("anm_electricbox_use_fuse_1",  { alp = 1, frame = 300, pos_z = 2 });
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fuse1", use_fuse1_beg, private.room_objname );
  cmn.AddSubscriber( "use_fuse1", use_fuse1_inv );
  cmn.AddSubscriber( "use_fuse1", use_fuse1_end, private.room_objname );
  cmn.AddSubscriber( "use_fuse1_inv", use_fuse1_inv, private.room_objname );
  cmn.AddSubscriber( "use_fuse1_beg", use_fuse1_beg, private.room_objname );
  cmn.AddSubscriber( "use_fuse1_end", use_fuse1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fuse2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_fuse2" ] = {
    type = "use",
    inv_obj = "inv_fuse2",
    use_place = "obj_electricbox_use_fuse2",
    room = private.room_objname,
    zz = "zz_electricbox",
    zz_gate = "gzz_cellar_electricbox"
  };
  --------------------------------------------------------------------------------------------
  local use_fuse2_inv = function ()
  
    interface.InventoryItemRemove( "inv_fuse2" );
  
  end;
  local use_fuse2_beg = function ()
  
    ObjDelete( "obj_electricbox_use_fuse2" );
  
  end;
  local use_fuse2_end = function ()

    ObjSet( "spr_cellar_electricbox_fuse2", { alp = 1 } );

    if ( cmn.IsEventDone( "use_fuse1" ) ) then
      ObjDelete( "anm_electricbox_use_fuse_2" );
      ObjDelete( "anm_electricbox_use_fuse_1" );
      ObjMultiSet( { {"anm_electricbox_fuses_burn", { alp = 1 }},
                     {"obj_electricbox_game", { input = 1 }} } );
    else
      ObjSet("anm_electricbox_use_fuse_2",  { alp = 1, frame = 300, pos_z = 2 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fuse2", use_fuse2_beg, private.room_objname );
  cmn.AddSubscriber( "use_fuse2", use_fuse2_inv );
  cmn.AddSubscriber( "use_fuse2", use_fuse2_end, private.room_objname );
  cmn.AddSubscriber( "use_fuse2_inv", use_fuse2_inv, private.room_objname );
  cmn.AddSubscriber( "use_fuse2_beg", use_fuse2_beg, private.room_objname );
  cmn.AddSubscriber( "use_fuse2_end", use_fuse2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_machinepart1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_machinepart1" ] = {
    type = "use",
    inv_obj = "inv_machinepart1",
    use_place = "obj_gamingmachine_use_machinepart1",
    room = private.room_objname,
    zz = "zz_gamingmachine",
    zz_gate = "gzz_cellar_gamingmachine"
  };
  --------------------------------------------------------------------------------------------
  local use_machinepart1_inv = function ()
  
    interface.InventoryItemRemove( "inv_machinepart1" );
  
  end;
  local use_machinepart1_beg = function ()
  
    ObjDelete( "obj_gamingmachine_use_machinepart1" );
  
  end;
  local use_machinepart1_end = function ()

    ObjMultiSet( {
      { "anm_gamingmachine_part_1", { frame = 0, animfunc = "func_clk_machinepart_1" } },
      { "spr_cellar_gamingmachine_machinepart_1", { alp = 1 } }
    } );
  
    if ( cmn.IsEventDone( "use_machinepart2" ) ) then

      ObjDelete( "gzz_cellar_gamingmachine" );

      ObjMultiSet( {
        { "gmg_cellar_ingamingmachine", { alp = 1, input = true, active = true } },
        { "spr_cellar_gamingmachine_tv_mg", { alp = 1 } }
      } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_machinepart1", use_machinepart1_beg, private.room_objname );
  cmn.AddSubscriber( "use_machinepart1", use_machinepart1_inv );
  cmn.AddSubscriber( "use_machinepart1", use_machinepart1_end, private.room_objname );
  cmn.AddSubscriber( "use_machinepart1_inv", use_machinepart1_inv, private.room_objname );
  cmn.AddSubscriber( "use_machinepart1_beg", use_machinepart1_beg, private.room_objname );
  cmn.AddSubscriber( "use_machinepart1_end", use_machinepart1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_machinepart2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_machinepart2" ] = {
    type = "use",
    inv_obj = "inv_machinepart2",
    use_place = "obj_gamingmachine_use_machinepart2",
    room = private.room_objname,
    zz = "zz_gamingmachine",
    zz_gate = "gzz_cellar_gamingmachine"
  };
  --------------------------------------------------------------------------------------------
  local use_machinepart2_inv = function ()
  
    interface.InventoryItemRemove( "inv_machinepart2" );
  
  end;
  local use_machinepart2_beg = function ()
  
    ObjDelete( "obj_gamingmachine_use_machinepart2" );
  
  end;
  local use_machinepart2_end = function ()

    ObjMultiSet( {
      { "anm_gamingmachine_part_2",  { frame = 0, animfunc = "func_clk_machinepart_2" } },
      { "spr_cellar_gamingmachine_machinepart_2", { alp = 1 } }
    } );
  
    if ( cmn.IsEventDone( "use_machinepart1" ) ) then

      ObjDelete( "gzz_cellar_gamingmachine" );

      ObjMultiSet( {
        { "gmg_cellar_ingamingmachine", { alp = 1, input = true, active = true } },
        { "spr_cellar_gamingmachine_tv_mg", { alp = 1 } }
      } );

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_machinepart2", use_machinepart2_beg, private.room_objname );
  cmn.AddSubscriber( "use_machinepart2", use_machinepart2_inv );
  cmn.AddSubscriber( "use_machinepart2", use_machinepart2_end, private.room_objname );
  cmn.AddSubscriber( "use_machinepart2_inv", use_machinepart2_inv, private.room_objname );
  cmn.AddSubscriber( "use_machinepart2_beg", use_machinepart2_beg, private.room_objname );
  cmn.AddSubscriber( "use_machinepart2_end", use_machinepart2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ingredients4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_ingredients4" ] = {
    type = "use",
    inv_obj = "inv_ingredients4",
    use_place = "obj_nayasdesk_use_ingredients4",
    room = private.room_objname,
    zz = "zz_nayasdesk",
    zz_gate = "gzz_cellar_nayasdesk"
  };
  --------------------------------------------------------------------------------------------
  local use_ingredients4_inv = function ()
  
    interface.InventoryItemRemove( "inv_ingredients4" );
  
  end;
  local use_ingredients4_beg = function ()
  
    ObjDelete( "obj_nayasdesk_use_ingredients4" );
    ObjMultiSet( { {"anm_nayasdesk_use_ingredients",  { animfunc = "func_use_ingredient_4", frame = 0 }},
                   {"spr_nayasdesk_ingredients1", { anim_tag = "tag_ingredients_17" }},
                   {"spr_nayasdesk_ingredients2", { anim_tag = "tag_ingredients_20" }},
                   {"spr_nayasdesk_ingredients3", { anim_tag = "tag_ingredients_6"}},
                   {"spr_nayasdesk_ingredients4", { alp = 0 }} } );
          
     for i = 1, 4, 1 do
       
       if i ~= 4 then
         if cmn.IsEventDone( "use_ingredients"..i ) then
           ObjSet("spr_nayasdesk_ingredients"..i ,  { alp = 1 });
         else 
           ObjSet("spr_nayasdesk_ingredients"..i ,  { alp = 0 });
         end;
       end;
       
     end;         
  
  end;
  local use_ingredients4_end = function ()

    ObjSet( "spr_cellar_nayadesk_ingredients_4", { alp = 1 } );

    if cmn.IsEventDone( "use_ingredients1" ) and cmn.IsEventDone( "use_ingredients2" ) and cmn.IsEventDone( "use_ingredients3" ) then
      ObjDelete("spr_nayasdesk_device");
      ObjDelete("anm_nayasdesk_glass_touch");
      ObjDelete("anm_nayasdesk_use_ingredients");
      ObjSet( "anm_nayasdesk_potion", { input = 1, alp = 1, frame = 300 } );
      ObjDelete( "obj_cellar_nayadesk_ingredients" );
      ObjDelete( "spr_cellar_nayadesk_bottle1" );
      ObjSet( "spr_cellar_nayadesk_bottle2", { alp = 1 } );
    else 
      ObjSet("anm_nayasdesk_use_ingredients",  { frame = 300 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ingredients4", use_ingredients4_beg, private.room_objname );
  cmn.AddSubscriber( "use_ingredients4", use_ingredients4_inv );
  cmn.AddSubscriber( "use_ingredients4", use_ingredients4_end, private.room_objname );
  cmn.AddSubscriber( "use_ingredients4_inv", use_ingredients4_inv, private.room_objname );
  cmn.AddSubscriber( "use_ingredients4_beg", use_ingredients4_beg, private.room_objname );
  cmn.AddSubscriber( "use_ingredients4_end", use_ingredients4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ingredients3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_ingredients3" ] = {
    type = "use",
    inv_obj = "inv_ingredients3",
    use_place = "obj_nayasdesk_use_ingredients3",
    room = private.room_objname,
    zz = "zz_nayasdesk",
    zz_gate = "gzz_cellar_nayasdesk"
  };
  --------------------------------------------------------------------------------------------
  local use_ingredients3_inv = function ()
  
    interface.InventoryItemRemove( "inv_ingredients3" );
  
  end;
  local use_ingredients3_beg = function ()
  
    ObjDelete( "obj_nayasdesk_use_ingredients3" );
    ObjMultiSet( { {"anm_nayasdesk_use_ingredients",  { animfunc = "func_use_ingredient_3", frame = 0 }},
                   {"spr_nayasdesk_ingredients1", { anim_tag = "tag_ingredients_2" }},
                   {"spr_nayasdesk_ingredients2", { anim_tag = "tag_ingredients_19" }},
                   {"spr_nayasdesk_ingredients3", { alp = 0 }},
                   {"spr_nayasdesk_ingredients4", { anim_tag = "tag_ingredients_12" }} } );
          
     for i = 1, 4, 1 do
       
       if i ~= 3 then
         if cmn.IsEventDone( "use_ingredients"..i ) then
           ObjSet("spr_nayasdesk_ingredients"..i ,  { alp = 1 });
         else 
           ObjSet("spr_nayasdesk_ingredients"..i ,  { alp = 0 });
         end;
       end;
       
     end;         
  
  end;
  local use_ingredients3_end = function ()

    ObjSet( "spr_cellar_nayadesk_ingredients_3", { alp = 1 } );

    if cmn.IsEventDone( "use_ingredients1" ) and cmn.IsEventDone( "use_ingredients2" ) and cmn.IsEventDone( "use_ingredients4" ) then
      ObjDelete("spr_nayasdesk_device");
      ObjDelete("anm_nayasdesk_glass_touch");
      ObjDelete("anm_nayasdesk_use_ingredients");
      ObjSet( "anm_nayasdesk_potion", { input = 1, alp = 1, frame = 300  } );
      ObjDelete( "obj_cellar_nayadesk_ingredients" );
      ObjDelete( "spr_cellar_nayadesk_bottle1" );
      ObjSet( "spr_cellar_nayadesk_bottle2", { alp = 1 } );
    else 
      ObjSet("anm_nayasdesk_use_ingredients",  { frame = 300 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ingredients3", use_ingredients3_beg, private.room_objname );
  cmn.AddSubscriber( "use_ingredients3", use_ingredients3_inv );
  cmn.AddSubscriber( "use_ingredients3", use_ingredients3_end, private.room_objname );
  cmn.AddSubscriber( "use_ingredients3_inv", use_ingredients3_inv, private.room_objname );
  cmn.AddSubscriber( "use_ingredients3_beg", use_ingredients3_beg, private.room_objname );
  cmn.AddSubscriber( "use_ingredients3_end", use_ingredients3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ingredients2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_ingredients2" ] = {
    type = "use",
    inv_obj = "inv_ingredients2",
    use_place = "obj_nayasdesk_use_ingredients2",
    room = private.room_objname,
    zz = "zz_nayasdesk",
    zz_gate = "gzz_cellar_nayasdesk"
  };
  --------------------------------------------------------------------------------------------
  local use_ingredients2_inv = function ()
  
    interface.InventoryItemRemove( "inv_ingredients2" );
  
  end;
  local use_ingredients2_beg = function ()
  
    ObjDelete( "obj_nayasdesk_use_ingredients2" );
    ObjMultiSet( { {"anm_nayasdesk_use_ingredients",  { animfunc = "func_use_ingredient_2", frame = 0 }},
                   {"spr_nayasdesk_ingredients1", { anim_tag = "tag_ingredients_2" }},
                   {"spr_nayasdesk_ingredients2", { alp = 0 }},
                   {"spr_nayasdesk_ingredients3", { anim_tag = "tag_ingredients_16" }},
                   {"spr_nayasdesk_ingredients4", { anim_tag = "tag_ingredients_14" }} } );
          
     for i = 1, 4, 1 do
       
       if i ~= 2 then
         if cmn.IsEventDone( "use_ingredients"..i ) then
           ObjSet("spr_nayasdesk_ingredients"..i ,  { alp = 1 });
         else 
           ObjSet("spr_nayasdesk_ingredients"..i ,  { alp = 0 });
         end;
       end;
       
     end;         
  
  end;
  local use_ingredients2_end = function ()

    ObjSet( "spr_cellar_nayadesk_ingredients_2", { alp = 1 } );

    if cmn.IsEventDone( "use_ingredients1" ) and cmn.IsEventDone( "use_ingredients3" ) and cmn.IsEventDone( "use_ingredients4" ) then
      ObjDelete("spr_nayasdesk_device");
      ObjDelete("anm_nayasdesk_glass_touch");
      ObjDelete("anm_nayasdesk_use_ingredients");
      ObjSet( "anm_nayasdesk_potion", { input = 1, alp = 1, frame = 300  } );
      ObjDelete( "obj_cellar_nayadesk_ingredients" );
      ObjDelete( "spr_cellar_nayadesk_bottle1" );
      ObjSet( "spr_cellar_nayadesk_bottle2", { alp = 1 } );
    else 
      ObjSet("anm_nayasdesk_use_ingredients",  { frame = 300 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ingredients2", use_ingredients2_beg, private.room_objname );
  cmn.AddSubscriber( "use_ingredients2", use_ingredients2_inv );
  cmn.AddSubscriber( "use_ingredients2", use_ingredients2_end, private.room_objname );
  cmn.AddSubscriber( "use_ingredients2_inv", use_ingredients2_inv, private.room_objname );
  cmn.AddSubscriber( "use_ingredients2_beg", use_ingredients2_beg, private.room_objname );
  cmn.AddSubscriber( "use_ingredients2_end", use_ingredients2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ingredients1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_ingredients1" ] = {
    type = "use",
    inv_obj = "inv_ingredients1",
    use_place = "obj_nayasdesk_use_ingredients1",
    room = private.room_objname,
    zz = "zz_nayasdesk",
    zz_gate = "gzz_cellar_nayasdesk"
  };
  --------------------------------------------------------------------------------------------
  local use_ingredients1_inv = function ()
  
    interface.InventoryItemRemove( "inv_ingredients1" );
  
  end;
  local use_ingredients1_beg = function ()
  
    ObjDelete( "obj_nayasdesk_use_ingredients1" );
    ObjMultiSet( { {"anm_nayasdesk_use_ingredients",  { animfunc = "func_use_ingredient_1", frame = 0 }},
                   {"spr_nayasdesk_ingredients1", { alp = 0 }},
                   {"spr_nayasdesk_ingredients2", { anim_tag = "tag_ingredients_18" }},
                   {"spr_nayasdesk_ingredients3", { anim_tag = "tag_ingredients_15" }},
                   {"spr_nayasdesk_ingredients4", { anim_tag = "tag_ingredients_13" }} } );
          
     for i = 1, 4, 1 do
       
       if i ~= 1 then
         if cmn.IsEventDone( "use_ingredients"..i ) then
           ObjSet("spr_nayasdesk_ingredients"..i ,  { alp = 1 });
         else 
           ObjSet("spr_nayasdesk_ingredients"..i ,  { alp = 0 });
         end;
       end;
       
     end;         
  
  end;
  local use_ingredients1_end = function ()

    ObjSet( "spr_cellar_nayadesk_ingredients_1", { alp = 1 } );

    if cmn.IsEventDone( "use_ingredients2" ) and cmn.IsEventDone( "use_ingredients3" ) and cmn.IsEventDone( "use_ingredients4" ) then
      ObjDelete("spr_nayasdesk_device");
      ObjDelete("anm_nayasdesk_glass_touch");
      ObjDelete("anm_nayasdesk_use_ingredients");
      ObjSet( "anm_nayasdesk_potion", { input = 1, alp = 1, frame = 300  } );
      ObjDelete( "obj_cellar_nayadesk_ingredients" );
      ObjDelete( "spr_cellar_nayadesk_bottle1" );
      ObjSet( "spr_cellar_nayadesk_bottle2", { alp = 1 } );
    else 
      ObjSet("anm_nayasdesk_use_ingredients",  { frame = 300 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ingredients1", use_ingredients1_beg, private.room_objname );
  cmn.AddSubscriber( "use_ingredients1", use_ingredients1_inv );
  cmn.AddSubscriber( "use_ingredients1", use_ingredients1_end, private.room_objname );
  cmn.AddSubscriber( "use_ingredients1_inv", use_ingredients1_inv, private.room_objname );
  cmn.AddSubscriber( "use_ingredients1_beg", use_ingredients1_beg, private.room_objname );
  cmn.AddSubscriber( "use_ingredients1_end", use_ingredients1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_drawerhandle () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_drawerhandle" ] = {
    type = "use",
    inv_obj = "inv_drawerhandle",
    use_place = "obj_nayasdesk_use_drawerhandle",
    room = private.room_objname,
    zz = "zz_nayasdesk",
    zz_gate = "gzz_cellar_nayasdesk"
  };
  --------------------------------------------------------------------------------------------
  local use_drawerhandle_inv = function ()
  
    interface.InventoryItemRemove( "inv_drawerhandle" );
  
  end;
  local use_drawerhandle_beg = function ()
  
    ObjDelete( "obj_nayasdesk_use_drawerhandle" );
    ObjDelete( "anm_nayasdesk_drawer_touch" );
  
  end;
  local use_drawerhandle_end = function ()

    ObjDelete( "spr_cellar_nayadesk_box_closed" );
  
    ObjMultiSet( {
      { "anm_nayasdesk_use_handle", { input = 1, alp = 1, frame = 300 } },
      { "obj_cellar_nayadesk_box_opn", { alp = 1 } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_drawerhandle", use_drawerhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_drawerhandle", use_drawerhandle_inv );
  cmn.AddSubscriber( "use_drawerhandle", use_drawerhandle_end, private.room_objname );
  cmn.AddSubscriber( "use_drawerhandle_inv", use_drawerhandle_inv, private.room_objname );
  cmn.AddSubscriber( "use_drawerhandle_beg", use_drawerhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_drawerhandle_end", use_drawerhandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_letter () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_letter" ] = {
    type = "use",
    inv_obj = "inv_letter",
    use_place = "obj_chest_use_letter",
    room = private.room_objname,
    zz = "zz_chest",
    zz_gate = "gzz_cellar_chest"
  };
  --------------------------------------------------------------------------------------------
  local use_letter_inv = function ()
  
    interface.InventoryItemRemove( "inv_letter" );
  
  end;
  local use_letter_beg = function ()
  
     ObjDelete( "obj_chest_use_letter" );
     ObjDelete( "anm_chest_box_touch" );
  
  end;
  local use_letter_end = function ()
    
    ObjDelete( "anm_chest_use_letters" );

    ObjMultiSet( { {"anm_chest_use_pollish", { alp = 1 }},
                   {"obj_chest_use_polish", { input = 1 }},
                   {"spr_cellar_chest_oldletters", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_letter", use_letter_beg, private.room_objname );
  cmn.AddSubscriber( "use_letter", use_letter_inv );
  cmn.AddSubscriber( "use_letter", use_letter_end, private.room_objname );
  cmn.AddSubscriber( "use_letter_inv", use_letter_inv, private.room_objname );
  cmn.AddSubscriber( "use_letter_beg", use_letter_beg, private.room_objname );
  cmn.AddSubscriber( "use_letter_end", use_letter_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chestkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_chestkey" ] = {
    type = "use",
    inv_obj = "inv_chestkey",
    use_place = "obj_chest_use_chestkey",
    room = private.room_objname,
    zz = "zz_chest",
    zz_gate = "gzz_cellar_chest"
  };
  --------------------------------------------------------------------------------------------
  local use_chestkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_chestkey" );
  
  end;
  local use_chestkey_beg = function ()
  
    ObjDelete( "obj_chest_use_chestkey" );
    ObjDelete( "anm_chest_chest_touch" );
    ObjSet("obj_chest_inside",  { alp = 1 });
  
  end;
  local use_chestkey_end = function ()

    ObjDelete( "spr_cellar_chest_closed" );

    ObjMultiSet( {
      { "obj_chest_inside", { input = 1 } },
      { "spr_cellar_chest_opn", { alp = 1 } },
      { "anm_chest_use_key", { alp = 1, frame = 300 } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chestkey", use_chestkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_chestkey", use_chestkey_inv );
  cmn.AddSubscriber( "use_chestkey", use_chestkey_end, private.room_objname );
  cmn.AddSubscriber( "use_chestkey_inv", use_chestkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_chestkey_beg", use_chestkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_chestkey_end", use_chestkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_polish () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_polish" ] = {
    type = "use",
    inv_obj = "inv_polish",
    use_place = "obj_chest_use_polish",
    room = private.room_objname,
    zz = "zz_chest",
    zz_gate = "gzz_cellar_chest"
  };
  --------------------------------------------------------------------------------------------
  local use_polish_inv = function ()
  
    interface.InventoryItemRemove( "inv_polish" );
  
  end;
  local use_polish_beg = function ()
  
    ObjDelete( "obj_chest_use_polish" );
  
  end;
  local use_polish_end = function ()

    ObjDelete( "spr_cellar_chest_box_closed" );
    ObjDelete( "spr_cellar_chest_oldletters" );

    ObjMultiSet( {
      { "anm_chest_use_pollish", { alp = 1, input = 1, frame = 300 } },
      { "spr_cellar_chest_box_opn", { alp = 1 } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_polish", use_polish_beg, private.room_objname );
  cmn.AddSubscriber( "use_polish", use_polish_inv );
  cmn.AddSubscriber( "use_polish", use_polish_end, private.room_objname );
  cmn.AddSubscriber( "use_polish_inv", use_polish_inv, private.room_objname );
  cmn.AddSubscriber( "use_polish_beg", use_polish_beg, private.room_objname );
  cmn.AddSubscriber( "use_polish_end", use_polish_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_oldfuses () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_oldfuses" ] = {
      type = "click",
      use_place = "obj_electricbox_clk_oldfuses",
      room = private.room_objname,
      zz = "zz_electricbox",
      zz_gate = "gzz_cellar_electricbox"
  };
  --------------------------------------------------------------------------------------------
  local clk_oldfuses = function ()
  
    ObjMultiSet( { {"obj_electricbox_use_fuse1", { input = 1 }},
                   {"obj_electricbox_use_fuse2", { input = 1 }} } );

    ObjDelete( "obj_electricbox_clk_oldfuses" );
    ObjDelete( "anm_electricbox_old_fuses" );

    ObjDelete( "spr_cellar_electricbox_brokenfuse" );

  end;
  
  cmn.AddSubscriber( "clk_oldfuses", clk_oldfuses, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_cellar () end;
  --------------------------------------------------------------------------------------------
  local opn_cellar = function ()
  
    int_map_impl.OpenRoom( "rm_cellar" );
    common_impl.ChangeRoomMiniback( "rm_cellar", false );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_cellar", opn_cellar );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_electricbox" );
  subroom.Define( "zz_nayasdesk" );
  
  function zz_electricbox.PreOpen()
    
    if not(cmn.IsEventDone( "win_electricbox" )) then
      SndStop("assets/levels/level4/audio/sfx/aud_rm_cellar_sparks", 0.5);
      ObjSet("tmr_cellar_timer_light",  { playing = 0 });
      private.zz_electricbox.DrawScene();
    end;

  end;
  
  function zz_electricbox.Open()
    
    if cmn.IsEventDone( "use_fuse1" ) and cmn.IsEventDone("use_fuse2") and not(cmn.IsEventDone( "win_electricbox" )) then
      cmn.MiniGameShow();
      private.zz_electricbox.CheckWin();
    end;

  end;
  
  function zz_electricbox.PreClose()
    
    if not(cmn.IsEventDone( "win_electricbox" )) then
      ObjSet("anm_cellar_darkness",  { frame = 0 });
    end;
    
    if cmn.IsEventDone( "use_fuse1" ) and cmn.IsEventDone("use_fuse2") and not cmn.IsEventDone("win_electricbox") then
      cmn.MiniGameHide("electricbox");
    end;
    
  end;
  
  function zz_electricbox.Close()
    
    if not(cmn.IsEventDone( "win_electricbox" )) then
      private.play_electric_sound();
    end;
    
    if cmn.IsEventDone("win_electricbox") and not cmn.IsEventDone("opn_cellarlight") then
      
      local func_after = function ()
        
        cmn.Lock( 0 );
        common_impl.PauseAchiev(0);
        
        cmn.CallEventHandler( "win_electricbox_end" );
        cmn.ShowBbt( "cellar_after_light" );
        
      end;
      
      cmn.SetEventDone("opn_cellarlight");
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_light_appear_loc");
      SndStop("assets/levels/level4/audio/sfx/aud_rm_cellar_sparks", 0.5);
      
      ObjAnimate("obj_cellar_dark", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
      
    end;
    
  end;
  
  function zz_nayasdesk.Close()
    cmn.HideNote( 0 );
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_electricbox" ].state) then 
    private.zz_electricbox.StartConditions();
  end;
  
  private.zz_electricbox.state = ng_global.progress[ ng_global.currentprogress ][ "win_electricbox" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_cellar();
  
  if not cmn.IsEventDone("win_electricbox") then
    private.play_electric_sound();
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level4/audio/env/aud_rm_cellar_env");
  cmn.PlayAudio("env", "assets/levels/level4/audio/env/aud_rm_cellar_env");
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
  
  if not cmn.IsEventDone("win_electricbox") then
    SndStop("assets/levels/level4/audio/sfx/aud_rm_cellar_sparks", 0.5);
  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_fuse1()

  local item = "inv_fuse1";

  if cmn.ApplyObj( item, "gzz_cellar_electricbox" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_electricbox" );

  elseif ( cmn.ApplyObj( item, "obj_electricbox_use_fuse1" ) and cmn.IsEventDone("clk_oldfuses") ) then

    cmn.CallEventHandler( "use_fuse1_inv" );
    private.use_fuse1_end();
    
  elseif ( cmn.ApplyObj( item, "obj_electricbox_use_fuse1" ) and not cmn.IsEventDone("clk_oldfuses") ) then

    cmn.CallEventHandler( "use_fuse1_inv" );
    public.clk_oldfuses(2, 1);

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function private.use_fuse1_end()
  
  cmn.CallEventHandler( "use_fuse1_beg" );

  local func_after = function ()

    cmn.Lock( 0 );

    cmn.SetEventDone( "use_fuse1" );
    cmn.CallEventHandler( "use_fuse1_end" );

    if ( cmn.IsEventDone( "use_fuse2" ) ) then
      cmn.MiniGameShow();
    end;

  end;

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_new_transistor");

  ObjSet("anm_electricbox_use_fuse_1",  { alp = 1, playing = 1, endtrig = func_after });
  
end;
--------------------------------------------------------------------------------------------
function public.use_fuse2()

  local item = "inv_fuse2";

  if cmn.ApplyObj( item, "gzz_cellar_electricbox" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_electricbox" );

  elseif ( cmn.ApplyObj( item, "obj_electricbox_use_fuse2" ) and cmn.IsEventDone("clk_oldfuses") ) then

    cmn.CallEventHandler( "use_fuse2_inv" );
    private.use_fuse2_end();
    
  elseif ( cmn.ApplyObj( item, "obj_electricbox_use_fuse2" ) and not cmn.IsEventDone("clk_oldfuses") ) then

    cmn.CallEventHandler( "use_fuse2_inv" );
    public.clk_oldfuses(2, 2);

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function private.use_fuse2_end()
  
  cmn.CallEventHandler( "use_fuse2_beg" );

  local func_after = function ()

    cmn.Lock( 0 );

    cmn.SetEventDone( "use_fuse2" );
    cmn.CallEventHandler( "use_fuse2_end" );

    if ( cmn.IsEventDone( "use_fuse1" ) ) then
      cmn.MiniGameShow();
    end;

  end;

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_new_transistor");

  ObjSet("anm_electricbox_use_fuse_2",  { alp = 1, playing = 1, endtrig = func_after });
  
end;
--------------------------------------------------------------------------------------------
function public.use_machinepart1()

  local item = "inv_machinepart1";

  if cmn.ApplyObj( item, "gzz_cellar_gamingmachine" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_gamingmachine" );

  elseif ( cmn.ApplyObj( item, "obj_gamingmachine_use_machinepart1" ) ) then

    cmn.CallEventHandler( "use_machinepart1_inv" );
    cmn.CallEventHandler( "use_machinepart1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_machinepart1" );
      cmn.CallEventHandler( "use_machinepart1_end" );

      if ( cmn.IsEventDone( "use_machinepart2" ) ) then
        common.CloseSubRoom();
        cmn.GotoRoom("mg_ingamingmachine");
      end;

    end;
    
    local anm_complete = function ()
      ObjSet("anm_gamingmachine_complete",  { alp = 1, playing = 1, endtrig = func_after });
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_machine_insert_lever_right");

    if ( cmn.IsEventDone( "use_machinepart2" ) ) then
      ObjSet("anm_gamingmachine_part_1",  { alp = 1, playing = 1, endtrig = anm_complete });
    else 
      ObjSet("anm_gamingmachine_part_1",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_machinepart2()

  local item = "inv_machinepart2";

  if cmn.ApplyObj( item, "gzz_cellar_gamingmachine" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_gamingmachine" );

  elseif ( cmn.ApplyObj( item, "obj_gamingmachine_use_machinepart2" ) ) then

    cmn.CallEventHandler( "use_machinepart2_inv" );
    cmn.CallEventHandler( "use_machinepart2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_machinepart2" );
      cmn.CallEventHandler( "use_machinepart2_end" );

      if ( cmn.IsEventDone( "use_machinepart1" ) ) then
        common.CloseSubRoom();
        cmn.GotoRoom("mg_ingamingmachine");
      end;
    
    end;
    
    local anm_complete = function ()
      ObjSet("anm_gamingmachine_complete",  { alp = 1, playing = 1, endtrig = func_after });
    end;

    cmn.Lock( 1 );

    if ( cmn.IsEventDone( "use_machinepart1" ) ) then
      ObjSet("anm_gamingmachine_part_2",  { alp = 1, playing = 1, endtrig = anm_complete });
    else 
      ObjSet("anm_gamingmachine_part_2",  { alp = 1, playing = 1, endtrig = func_after });
    end;

    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_zz_gamingmachine_insert_button");

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_ingredients4()

  local item = "inv_ingredients4";

  if cmn.ApplyObj( item, "gzz_cellar_nayasdesk" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_nayasdesk", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_nayasdesk_use_ingredients4" ) ) then

    cmn.CallEventHandler( "use_ingredients4_inv" );
    cmn.CallEventHandler( "use_ingredients4_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_ingredients4" );
      cmn.CallEventHandler( "use_ingredients4_end" );
    
    end;

    local anm_potion = function ()
      
      if cmn.IsEventDone("use_ingredients1") and cmn.IsEventDone("use_ingredients2") and cmn.IsEventDone("use_ingredients3") then
        cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_colb_warm");
        ObjDelete("spr_nayasdesk_device");
        ObjDelete("anm_nayasdesk_glass_touch");
        ObjDelete("anm_nayasdesk_use_ingredients");
        ObjSet("anm_nayasdesk_potion",  { alp = 1, playing = 1, endtrig = func_after });
      else 
        func_after();
      end;
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_put_colb_stuff");

    ObjSet("anm_nayasdesk_use_ingredients",  { frame = 0, playing = 1, endtrig = anm_potion });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_ingredients3()

  local item = "inv_ingredients3";

  if cmn.ApplyObj( item, "gzz_cellar_nayasdesk" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_nayasdesk", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_nayasdesk_use_ingredients3" ) ) then

    cmn.CallEventHandler( "use_ingredients3_inv" );
    cmn.CallEventHandler( "use_ingredients3_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_ingredients3" );
      cmn.CallEventHandler( "use_ingredients3_end" );
    
    end;

    local anm_potion = function ()
      
      if cmn.IsEventDone("use_ingredients1") and cmn.IsEventDone("use_ingredients2") and cmn.IsEventDone("use_ingredients4") then
        cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_colb_warm");
        ObjDelete("spr_nayasdesk_device");
        ObjDelete("anm_nayasdesk_glass_touch");
        ObjDelete("anm_nayasdesk_use_ingredients");
        ObjSet("anm_nayasdesk_potion",  { alp = 1, playing = 1, endtrig = func_after });
      else 
        func_after();
      end;
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_put_colb_stuff");

    ObjSet("anm_nayasdesk_use_ingredients",  { frame = 0, playing = 1, endtrig = anm_potion });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_ingredients2()

  local item = "inv_ingredients2";

  if cmn.ApplyObj( item, "gzz_cellar_nayasdesk" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_nayasdesk", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_nayasdesk_use_ingredients2" ) ) then

    cmn.CallEventHandler( "use_ingredients2_inv" );
    cmn.CallEventHandler( "use_ingredients2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_ingredients2" );
      cmn.CallEventHandler( "use_ingredients2_end" );
    
    end;

    local anm_potion = function ()
      
      if cmn.IsEventDone("use_ingredients1") and cmn.IsEventDone("use_ingredients3") and cmn.IsEventDone("use_ingredients4") then
        cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_colb_warm");
        ObjDelete("spr_nayasdesk_device");
        ObjDelete("anm_nayasdesk_glass_touch");
        ObjDelete("anm_nayasdesk_use_ingredients");
        ObjSet("anm_nayasdesk_potion",  { alp = 1, playing = 1, endtrig = func_after });
      else 
        func_after();
      end;
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_put_colb_stuff");

    ObjSet("anm_nayasdesk_use_ingredients",  { frame = 0, playing = 1, endtrig = anm_potion });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_ingredients1()

  local item = "inv_ingredients1";

  if cmn.ApplyObj( item, "gzz_cellar_nayasdesk" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_nayasdesk", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_nayasdesk_use_ingredients1" ) ) then

    cmn.CallEventHandler( "use_ingredients1_inv" );
    cmn.CallEventHandler( "use_ingredients1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_ingredients1" );
      cmn.CallEventHandler( "use_ingredients1_end" );
    
    end;
    
    local anm_potion = function ()
      
      if cmn.IsEventDone("use_ingredients2") and cmn.IsEventDone("use_ingredients3") and cmn.IsEventDone("use_ingredients4") then
        cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_colb_warm");
        ObjDelete("spr_nayasdesk_device");
        ObjDelete("anm_nayasdesk_glass_touch");
        ObjDelete("anm_nayasdesk_use_ingredients");
        ObjSet("anm_nayasdesk_potion",  { alp = 1, playing = 1, endtrig = func_after });
      else 
        func_after();
      end;
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_put_colb_stuff");

    ObjSet("anm_nayasdesk_use_ingredients",  { frame = 0, playing = 1, endtrig = anm_potion });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_drawerhandle()

  local item = "inv_drawerhandle";

  if cmn.ApplyObj( item, "gzz_cellar_nayasdesk" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_nayasdesk", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_nayasdesk_use_drawerhandle" ) ) then

    cmn.CallEventHandler( "use_drawerhandle_inv" );
    cmn.CallEventHandler( "use_drawerhandle_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_drawerhandle" );
      cmn.CallEventHandler( "use_drawerhandle_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_zz_nayasdesk_opens");

    ObjSet("anm_nayasdesk_use_handle",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_letter()

  local item = "inv_letter";

  if cmn.ApplyObj( item, "gzz_cellar_chest" ) and cmn.IsEventDone("win_electricbox") then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_chest" );

  elseif ( cmn.ApplyObj( item, "obj_chest_use_letter" ) and cmn.CheckMultiObject( "letter", 9 ) and cmn.IsEventDone( "use_chestkey" ) ) then
    
    if not cmn.IsEventDone("get_lvl4wire") or not cmn.IsEventDone("get_seeds") then
      
      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
      
      if not cmn.IsEventDone("get_lvl4wire") then
        cmn.SetEventDone( "get_lvl4wire" );
        cmn.CallEventHandler( "get_lvl4wire" );
      end;
      
      if not cmn.IsEventDone("get_seeds") then
        cmn.SetEventDone( "get_seeds" );
        cmn.CallEventHandler( "get_seeds" );
      end;
      
    end;
    
    cmn.CallEventHandler( "use_letter_inv" );
    cmn.CallEventHandler( "use_letter_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_letter" );
      cmn.CallEventHandler( "use_letter_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_zz_chest_stones");
    
    ObjSet("anm_chest_use_letters",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_chestkey()

  local item = "inv_chestkey";

  if cmn.ApplyObj( item, "gzz_cellar_chest" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_chest" );

  elseif ( cmn.ApplyObj( item, "obj_chest_use_chestkey" ) ) then

    cmn.CallEventHandler( "use_chestkey_inv" );
    cmn.CallEventHandler( "use_chestkey_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_chestkey" );
      cmn.CallEventHandler( "use_chestkey_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_key_chest_zz_chest");

    ObjSet("anm_chest_use_key",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_polish()

  local item = "inv_polish";

  if cmn.ApplyObj( item, "gzz_cellar_chest" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_chest" );

  elseif ( cmn.ApplyObj( item, "obj_chest_use_polish" ) and cmn.IsEventDone( "use_letter" ) ) then

    cmn.CallEventHandler( "use_polish_inv" );
    cmn.CallEventHandler( "use_polish_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_polish" );
      cmn.CallEventHandler( "use_polish_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_zz_chest_powder");

    ObjSet("anm_chest_use_pollish",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_lvl4screwdriver()

  cmn.SetEventDone( "get_lvl4screwdriver" );
  cmn.CallEventHandler( "get_lvl4screwdriver" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_bone()

  cmn.SetEventDone( "get_bone" );
  cmn.CallEventHandler( "get_bone" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_recipe()

  cmn.SetEventDone( "get_recipe" );
  cmn.CallEventHandler( "get_recipe" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_potion()
  
  ObjSet("obj_nayasdesk_potion_inside",  { alp = 1 });

  cmn.SetEventDone( "get_potion" );
  cmn.CallEventHandler( "get_potion" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_machinepart2()

  cmn.SetEventDone( "get_machinepart2" );
  cmn.CallEventHandler( "get_machinepart2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_lvl4flashlight()

  cmn.SetEventDone( "get_lvl4flashlight" );
  cmn.CallEventHandler( "get_lvl4flashlight" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_seeds()

  cmn.SetEventDone( "get_seeds" );
  cmn.CallEventHandler( "get_seeds" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_battery3()

  cmn.SetEventDone( "get_battery3" );
  cmn.CallEventHandler( "get_battery3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_lvl4wire()

  cmn.SetEventDone( "get_lvl4wire" );
  cmn.CallEventHandler( "get_lvl4wire" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_heartpart3()

  cmn.SetEventDone( "get_heartpart3" );
  cmn.CallEventHandler( "get_heartpart3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_letter7()

  cmn.SetEventDone( "get_letter7" );
  cmn.CallEventHandler( "get_letter7" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_oldfuses( num, fuse )

  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_take_broken_transistors");

  local func_after = function ()

    cmn.SetEventDone( "clk_oldfuses" );
    cmn.CallEventHandler( "clk_oldfuses" );

    if num == 1 then
      cmn.Lock(0);
    elseif fuse == 1 then
      private.use_fuse1_end();
    elseif fuse == 2 then
      private.use_fuse2_end();
    end;

  end;
  
  ObjSet("anm_electricbox_old_fuses",  { playing = 1, endtrig = func_after });
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_cellar()

  if not ( cmn.IsEventDone( "opn_cellar" ) ) then
    cmn.SetEventDone( "opn_cellar" );
    cmn.CallEventHandler("opn_cellar");
    cmn.ShowBbt( "cellar_open" );
  end;

end;
--------------------------------------------------------------------------------------------
function private.play_electric_sound()
  
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_rm_cellar_sparks");
  ObjSet("tmr_cellar_timer_light",  { time = 8.5, playing = 1, endtrig = private.play_electric_sound });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_electricbox()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_electricbox");

  cmn.ShowBbt( "obj_electricbox_use_fuse" );
  
  ObjAnimate("obj_electricbox_screen", "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 1,   0.2, 0, 0,    0.4, 0, 1,     0.6, 0, 0,    0.8, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_desk_drawer()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_zz_nayadesk_box");

  cmn.ShowBbt( "obj_nayasdesk_use_drawerhandle" );
  
  ObjSet( "anm_nayasdesk_drawer_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_desk_potion()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_zz_nayadesk_colb");

  cmn.ShowBbt( "obj_nayasdesk_use_ingredients" );
  
  ObjSet( "anm_nayasdesk_glass_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_gamingmachine()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_zz_gamingmachine_left");

  cmn.ShowBbt( "obj_gamingmachine_use_machinepart" );
  
  ObjSet( "anm_gamingmachine_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
    
  if cmn.IsEventDone("use_machinepart1") then
    ObjSet( "anm_gamingmachine_part_1", { playing = 1 } );
  end;
    
  if cmn.IsEventDone("use_machinepart2") then
    ObjSet( "anm_gamingmachine_part_2", { playing = 1 } );
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_chest()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_zz_chest_chest");

  cmn.ShowBbt( "obj_chest_use_chestkey" );
  
  ObjSet( "anm_chest_chest_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_chest_box()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_zz_chest_stuff");

  cmn.ShowBbt( "obj_chest_use_letter" );
  
  ObjSet( "anm_chest_box_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Electricbox *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_electricbox = {};
public.zz_electricbox = {};

function private.Init_Electricbox()
  
  private.zz_electricbox.start_state = { 1, 0, 1, 1, 0, 0 };
  private.zz_electricbox.win_state = { 0, 1, 0, 1, 1, 0 };
  
  private.zz_electricbox.stable = {31, 33};
  private.zz_electricbox.switches = {1, 5, 7, 17, 11, 13};
  -----------------------------------------------------------------------------------
  game.hint[ "win_electricbox" ] = {
    type = "win",
    room = "rm_cellar",
    zz = "zz_electricbox",
    zz_gate = "gzz_cellar_electricbox"
  };
  -----------------------------------------------------------------------------------
  local win_electricbox_tsk = function ()
    if cmn.IsEventDone( "win_electricbox" ) then
      common_impl.ChangeRoomMiniback( "rm_cellar", 2 );
    end;
  end;
  local win_electricbox_mid = function ()

    if cmn.IsEventDone( "win_electricbox" ) then
      
      ObjDelete( "gzz_cellar_electricbox" );
      ObjDelete("tmr_cellar_timer_light");

      ObjMultiSet( {
        { "gzz_cellar_gamingmachine", { alp = 1, input = true, active = true } },
        { "gzz_cellar_nayasdesk", { alp = 1, input = true, active = true } },
        { "gzz_cellar_chest", { alp = 1, input = true, active = true } },
        { "obj_electricbox_game", { input = false } },
        { "spr_bonus_56", { input = 1, pos_z = 95 } }
      } );

    end;

  end;
  local win_electricbox_end = function ()

    if cmn.IsEventDone( "win_electricbox" ) then
      
      ObjDelete( "obj_cellar_dark" );

      ObjSet( "spr_cellar_letter7", { input = true } );

    end;

  end;
  local win_electricbox_loc = function ()

    if cmn.IsEventDone( "win_electricbox" ) then

      ObjDelete( "spr_nearhouse_nearcellar_cellar_off" );

      ObjSet( "spr_nearhouse_nearcellar_cellar_on", { alp = 1 } );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_electricbox", win_electricbox_mid, "rm_cellar" );
  cmn.AddSubscriber( "win_electricbox", win_electricbox_end, "rm_cellar" );
  cmn.AddSubscriber( "win_electricbox", win_electricbox_loc, "rm_nearhouse" );
  cmn.AddSubscriber( "win_electricbox_mid", win_electricbox_mid, "rm_cellar" );
  cmn.AddSubscriber( "win_electricbox_end", win_electricbox_end, "rm_cellar" );
  cmn.AddSubscriber( "win_electricbox_loc", win_electricbox_loc, "rm_nearhouse" );
  cmn.AddSubscriber( "win_electricbox", win_electricbox_tsk );
  cmn.AddSubscriber( "win_electricbox_tsk", win_electricbox_tsk );
  
end;
--*********************************************************************************************************************
function private.zz_electricbox.StartConditions()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_electricbox" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_electricbox" ].state = { 1, 0, 1, 1, 0, 0 };
  
end;
-----------------------------------------------------------------------------------
function public.zz_electricbox.Reset()
  
  local need_r = false;
  
  for i = 1, 6, 1 do
    
    if private.zz_electricbox.state[i] ~= private.zz_electricbox.start_state[i] then
      
      if not need_r then
        need_r = true;
      end;
      
      ObjMultiSet( { {"spr_electricbox_switch_"..i.."_"..private.zz_electricbox.start_state[i].."_focus", { alp = 0 }},
                     {"spr_electricbox_switch_"..i.."_"..private.zz_electricbox.state[i].."_focus", { alp = 0 }} } );
      
      ObjAnimate("spr_electricbox_switch_"..i.."_"..private.zz_electricbox.start_state[i], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("spr_electricbox_switch_"..i.."_"..private.zz_electricbox.state[i], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  end;
  
  local func_after = function ()
    
    local count = private.zz_electricbox.CountVoltage();
    ObjSet("txt_electricbox_screen_power",  { text = count });
    cmn.Lock( 0 );
    
  end;
  
  if need_r then
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_electricbox_reset");
    private.zz_electricbox.StartConditions();
    private.zz_electricbox.state = ng_global.progress[ ng_global.currentprogress ][ "win_electricbox" ].state;
    
    ObjSet("tmr_electricbox_timer",  { time = 0.4, playing = 1, endtrig = func_after });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_electricbox.Skip()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_electricbox_click");
  
  ng_global.progress[ ng_global.currentprogress ][ "win_electricbox" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_electricbox" ].state = { 0, 1, 0, 1, 1, 0 };
  
  for i = 1, 6, 1 do
    
    if private.zz_electricbox.state[i] ~= private.zz_electricbox.win_state[i] then
      
      ObjMultiSet( { {"spr_electricbox_switch_"..i.."_"..private.zz_electricbox.win_state[i].."_focus", { alp = 0 }},
                     {"spr_electricbox_switch_"..i.."_"..private.zz_electricbox.state[i].."_focus", { alp = 0 }} } );
      
      ObjAnimate("spr_electricbox_switch_"..i.."_"..private.zz_electricbox.win_state[i], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("spr_electricbox_switch_"..i.."_"..private.zz_electricbox.state[i], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  end;
  
  local func_after = function ()
    
    local count = private.zz_electricbox.CountVoltage();
    ObjSet("txt_electricbox_screen_power",  { text = count });
    private.zz_electricbox.CheckWin();
    
  end;
  
  private.zz_electricbox.state = ng_global.progress[ ng_global.currentprogress ][ "win_electricbox" ].state;
  ObjSet("tmr_electricbox_timer",  { time = 0.4, playing = 1, endtrig = func_after });
  
end;
-----------------------------------------------------------------------------------
function private.zz_electricbox.DrawScene()
  
  local count = private.zz_electricbox.CountVoltage();
  ObjSet("txt_electricbox_screen_power",  { text = count });
  
  for i = 1, 6, 1 do
    
    if private.zz_electricbox.state[i] == 1 then
      ObjMultiSet( { {"spr_electricbox_switch_"..i.."_1", { alp = 1 }},
                     {"spr_electricbox_switch_"..i.."_0", { alp = 0 }} } );
    else
      ObjMultiSet( { {"spr_electricbox_switch_"..i.."_1", { alp = 0 }},
                     {"spr_electricbox_switch_"..i.."_0", { alp = 1 }} } );
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_electricbox.FocusSwitch( num, inout )
  
  local obj = "spr_electricbox_switch_"..num.."_"..private.zz_electricbox.state[num].."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_electricbox_arrow_"..math.random(1, 3));
    end;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.zz_electricbox.ClickSwitch( num )
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_electricbox_click");
  
  local old = private.zz_electricbox.state[ num ];
  local new = 1;
  if old == 1 then
    new = 0;
  end;
  
  local old_count = private.zz_electricbox.CountVoltage();
  private.zz_electricbox.state[ num ] = new;
  local new_count = private.zz_electricbox.CountVoltage();
  
  local func_after = function ()
    
    ObjSet("txt_electricbox_screen_power",  { text = new_count });
    private.zz_electricbox.CheckWin();
    
  end;
  
  ObjAnimate("spr_electricbox_switch_"..num.."_"..new, "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
  ObjAnimate("spr_electricbox_switch_"..num.."_"..old, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
end;
-----------------------------------------------------------------------------------
function private.zz_electricbox.CountVoltage()
  
  local count = 0;
  
  for i = 1, 6, 1 do
    
    if private.zz_electricbox.state[i] == 1 then
      count = count + private.zz_electricbox.switches[i];
    end;
    
  end;
  
  return count;
  
end;
-----------------------------------------------------------------------------------
function private.zz_electricbox.CheckWin()
  
  local count = private.zz_electricbox.CountVoltage();
  
  if count >= private.zz_electricbox.stable[1] and count <= private.zz_electricbox.stable[2] then
    
    cmn.Lock( 1 );
    
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_electricbox_right");
    
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("electricbox");
    
    local anm_win = function ()
      
      ObjAnimate("spr_electricbox_screen_red", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("spr_electricbox_screen_green", "alp", 0, 0, private.zz_electricbox.Win, { 0, 0, 0,   0.5, 0, 1,   1, 0, 1 });
      
    end;

    cmn.Lock( 1 );

    ObjSet("tmr_electricbox_timer",  { time = 1, playing = 1, endtrig = anm_win });
    
  elseif count > private.zz_electricbox.stable[2] then
    
    cmn.Lock( 1 );
    
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_electricbox_wrong");
    
    ObjSet("anm_electricbox_fuses_burn",  { playing = 1, endtrig = public.zz_electricbox.Reset });
    
  else
    cmn.Lock(0);
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_electricbox.Win()
  
  --cmn.Lock( 0 );
  --common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_electricbox" );
  cmn.CallEventHandler( "win_electricbox_mid" );
  cmn.CallEventHandler( "win_electricbox_loc" );
  cmn.CallEventHandler("win_electricbox_tsk");

  if ng_global.progress[ ng_global.currentprogress ][ "win_electricbox" ].skip == 0 and ng_global.noskipgames[ "win_electricbox" ] == nil then

    ng_global.noskipgames[ "win_electricbox" ] = 1;
    common_impl.CheckAchiev("mg");

  end;
  
  common.CloseSubRoom();
  
end;
--****************************************************************************************************************