-- name=rm_forest
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_forest";
  --------------------------------------------------------------------------------------------
  private.dlg_lipsync = "";
  private.Init_Subroom();
  private.Init_Stump();
  --------------------------------------------------------------------------------------------
  -- function get_torch () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_torch" ] = {
    type = "get",
    get_obj = "spr_stump_torch",
    room = private.room_objname,
    zz = "zz_stump",
    zz_gate = "gzz_forest_stump"
  };
  --------------------------------------------------------------------------------------------
  local get_torch_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_torch", "spr_stump_torch" );
  
  end;
  local get_torch_end = function ()
  
    ObjDelete( "gfx_stump_torch" );

    ObjDelete( "spr_forest_stumb_torch" );
  
  end;
  
  cmn.AddSubscriber( "get_torch", get_torch_inv );
  cmn.AddSubscriber( "get_torch", get_torch_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ingredients4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_ingredients4" ] = {
    type = "get",
    get_obj = "spr_stump_ingredients4",
    room = private.room_objname,
    zz = "zz_stump",
    zz_gate = "gzz_forest_stump"
  };
  --------------------------------------------------------------------------------------------
  local get_ingredients4_inv = function ()
  
    interface.InventoryItemAdd( "inv_ingredients4", "spr_stump_ingredients4" );
  
  end;
  local get_ingredients4_end = function ()
  
    ObjDelete( "gfx_stump_ingredients4" );
    ObjDelete( "anm_stump_use_recipe" );

    ObjDelete( "spr_forest_stumb_ingredient_4" );
  
  end;
  
  cmn.AddSubscriber( "get_ingredients4", get_ingredients4_inv );
  cmn.AddSubscriber( "get_ingredients4", get_ingredients4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mushroom () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_mushroom" ] = {
    type = "get",
    get_obj = "spr_stump_mushroom",
    room = private.room_objname,
    zz = "zz_stump",
    zz_gate = "gzz_forest_stump"
  };
  --------------------------------------------------------------------------------------------
  local get_mushroom_inv = function ()
  
    interface.InventoryItemAdd( "inv_mushroom", "spr_stump_mushroom" );
  
  end;
  local get_mushroom_end = function ()
  
    ObjDelete( "gfx_stump_mushroom" );
    ObjDelete( "anm_stump_use_potion" );
    ObjDelete( "gzz_forest_stump" );

    ObjDelete( "spr_forest_stumb_mushroom2" );
  
  end;
  
  cmn.AddSubscriber( "get_mushroom", get_mushroom_inv );
  cmn.AddSubscriber( "get_mushroom", get_mushroom_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_angel2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_angel2" ] = {
    type = "get",
    get_obj = "spr_stump_angel2",
    room = private.room_objname,
    zz = "zz_stump",
    zz_gate = "gzz_forest_stump"
  };
  --------------------------------------------------------------------------------------------
  local get_angel2_inv = function ()
  
    interface.InventoryItemAdd( "inv_angel2", "spr_stump_angel2" );
    int_map_impl.DecreaseRoomTasks("rm_forest");
  
  end;
  local get_angel2_end = function ()
  
    ObjDelete( "gfx_stump_angel2" );
    ObjDelete( "spr_stump_angel2_sh" );

    ObjDelete( "spr_forest_stumb_angel" );
  
  end;
  
  cmn.AddSubscriber( "get_angel2", get_angel2_inv );
  cmn.AddSubscriber( "get_angel2", get_angel2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_zipper () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_zipper" ] = {
    type = "get",
    get_obj = "spr_burrow_zipper",
    room = private.room_objname,
    zz = "zz_burrow",
    zz_gate = "gzz_forest_burrow"
  };
  --------------------------------------------------------------------------------------------
  local get_zipper_inv = function ()
  
    interface.InventoryItemAdd( "inv_zipper", "spr_burrow_zipper" );
  
  end;
  local get_zipper_end = function ()
  
    ObjDelete( "gfx_burrow_zipper" );
    ObjDelete( "spr_forest_burrow_zipper" );
  
  end;
  
  cmn.AddSubscriber( "get_zipper", get_zipper_inv );
  cmn.AddSubscriber( "get_zipper", get_zipper_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_needdle () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_needdle" ] = {
    type = "get",
    get_obj = "spr_burrow_needdle",
    room = private.room_objname,
    zz = "zz_burrow",
    zz_gate = "gzz_forest_burrow"
  };
  --------------------------------------------------------------------------------------------
  local get_needdle_inv = function ()
  
    interface.InventoryItemAdd( "inv_needdle", "spr_burrow_needdle" );
  
  end;
  local get_needdle_end = function ()
  
    ObjDelete( "gfx_burrow_needdle" );
    ObjDelete( "anm_burrow_use_apple" );
    ObjSet( "anm_burrow_hedgehog_2", { alp = 1 } );
  
  end;
  
  cmn.AddSubscriber( "get_needdle", get_needdle_inv );
  cmn.AddSubscriber( "get_needdle", get_needdle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ingredients3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_ingredients3" ] = {
    type = "get",
    get_obj = "spr_burrow_ingredients3",
    room = private.room_objname,
    zz = "zz_burrow",
    zz_gate = "gzz_forest_burrow"
  };
  --------------------------------------------------------------------------------------------
  local get_ingredients3_inv = function ()
  
    interface.InventoryItemAdd( "inv_ingredients3", "spr_burrow_ingredients3" );
  
  end;
  local get_ingredients3_end = function ()
  
    ObjDelete( "gfx_burrow_ingredients3" );
    ObjDelete( "anm_burrow_use_recipe" );
    ObjSet( "anm_burrow_ingredient_2", { alp = 1 } );
  
  end;
  
  cmn.AddSubscriber( "get_ingredients3", get_ingredients3_inv );
  cmn.AddSubscriber( "get_ingredients3", get_ingredients3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_chestkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_chestkey" ] = {
    type = "get",
    get_obj = "spr_burrow_chestkey",
    room = private.room_objname,
    zz = "zz_burrow",
    zz_gate = "gzz_forest_burrow"
  };
  --------------------------------------------------------------------------------------------
  local get_chestkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_chestkey", "spr_burrow_chestkey" );
    int_map_impl.DecreaseRoomTasks("rm_forest");
  
  end;
  local get_chestkey_end = function ()
  
    ObjDelete( "gfx_burrow_chestkey" );
    ObjDelete( "spr_burrow_chestkey_sh" );
    ObjDelete( "gzz_forest_burrow" );

    ObjDelete( "spr_forest_burrow_chestkey" );
  
  end;
  
  cmn.AddSubscriber( "get_chestkey", get_chestkey_inv );
  cmn.AddSubscriber( "get_chestkey", get_chestkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_spade () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_spade" ] = {
    type = "get",
    get_obj = "spr_bonfire_spade",
    room = private.room_objname,
    zz = "zz_bonfire",
    zz_gate = "gzz_forest_bonfire"
  };
  --------------------------------------------------------------------------------------------
  local get_spade_inv = function ()
  
    interface.InventoryItemAdd( "inv_spade", "spr_bonfire_spade" );
  
  end;
  local get_spade_end = function ()
  
    ObjDelete( "gfx_bonfire_spade" );
    ObjDelete( "anm_bonfire_use_handle" );

    ObjDelete( "spr_forest_bonfire_shovel_base" );
  
  end;
  
  cmn.AddSubscriber( "get_spade", get_spade_inv );
  cmn.AddSubscriber( "get_spade", get_spade_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_clothbutton1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_clothbutton1" ] = {
    type = "get",
    get_obj = "spr_bonfire_clothbutton1",
    room = private.room_objname,
    zz = "zz_bonfire",
    zz_gate = "gzz_forest_bonfire"
  };
  --------------------------------------------------------------------------------------------
  local get_clothbutton1_inv = function ()
  
    interface.InventoryItemAdd( "inv_clothbutton", "spr_bonfire_clothbutton1", function () cmn.GetMultyObject( 'clothbutton', 2 ); end );
  
  end;
  local get_clothbutton1_end = function ()
  
    ObjDelete( "gfx_bonfire_clothbutton1" );
    ObjDelete( "anm_bonfire_use_shard" );

    ObjDelete( "spr_forest_bonfire_button" );
  
  end;
  
  cmn.AddSubscriber( "get_clothbutton1", get_clothbutton1_inv );
  cmn.AddSubscriber( "get_clothbutton1", get_clothbutton1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_diary () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_diary" ] = {
    type = "get",
    get_obj = "spr_bonfire_diary",
    room = private.room_objname,
    zz = "zz_bonfire",
    zz_gate = "gzz_forest_bonfire"
  };
  --------------------------------------------------------------------------------------------
  local get_diary_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_diary", "spr_bonfire_diary" );
  
  end;
  local get_diary_end = function ()
  
    ObjDelete( "gfx_bonfire_diary" );
    ObjDelete( "spr_bonfire_diary_sh" );

    ObjDelete( "spr_forest_bonfire_diary" );
  
  end;
  
  cmn.AddSubscriber( "get_diary", get_diary_inv );
  cmn.AddSubscriber( "get_diary", get_diary_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl4button () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl4button" ] = {
    type = "get",
    get_obj = "spr_bonfire_lvl4button",
    room = private.room_objname,
    zz = "zz_bonfire",
    zz_gate = "gzz_forest_bonfire"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl4button_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl4button", "spr_bonfire_lvl4button" );
  
  end;
  local get_lvl4button_end = function ()
  
    ObjDelete( "gfx_bonfire_lvl4button" );

    ObjDelete( "spr_forest_bonfire_radiobutton" );
    
    if cmn.IsEventDone("get_fuse1") then
      ObjSet("gzz_forest_bonfire",  { active = 0, visible = 0 });
    end;
  
  end;
  
  cmn.AddSubscriber( "get_lvl4button", get_lvl4button_inv );
  cmn.AddSubscriber( "get_lvl4button", get_lvl4button_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fuse1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_fuse1" ] = {
    type = "get",
    get_obj = "spr_bonfire_fuse1",
    room = private.room_objname,
    zz = "zz_bonfire",
    zz_gate = "gzz_forest_bonfire"
  };
  --------------------------------------------------------------------------------------------
  local get_fuse1_inv = function ()
  
    interface.InventoryItemAdd( "inv_fuse1", "spr_bonfire_fuse1" );
  
  end;
  local get_fuse1_end = function ()
  
    ObjDelete( "gfx_bonfire_fuse1" );
    ObjDelete( "spr_bonfire_fuse1_sh" );

    ObjDelete( "spr_forest_bonfire_fuse" );
    
    if cmn.IsEventDone("get_lvl4button") then
      ObjSet("gzz_forest_bonfire",  { active = 0, visible = 0 });
    end;
  
  end;
  
  cmn.AddSubscriber( "get_fuse1", get_fuse1_inv );
  cmn.AddSubscriber( "get_fuse1", get_fuse1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gloves () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_gloves" ] = {
    type = "get",
    get_obj = "spr_tent_gloves",
    room = private.room_objname,
    zz = "zz_tent",
    zz_gate = "gzz_forest_tent"
  };
  --------------------------------------------------------------------------------------------
  local get_gloves_inv = function ()
  
    interface.InventoryItemAdd( "inv_gloves", "spr_tent_gloves" );
  
  end;
  local get_gloves_end = function ()
  
    ObjDelete( "gfx_tent_gloves" );
    ObjDelete( "spr_tent_gloves_sh" );

    ObjDelete( "spr_forest_tent_glove" );
  
  end;
  
  cmn.AddSubscriber( "get_gloves", get_gloves_inv );
  cmn.AddSubscriber( "get_gloves", get_gloves_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_battery1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_battery1" ] = {
    type = "get",
    get_obj = "spr_tent_battery1",
    room = private.room_objname,
    zz = "zz_tent",
    zz_gate = "gzz_forest_tent"
  };
  --------------------------------------------------------------------------------------------
  local get_battery1_inv = function ()
  
    interface.InventoryItemAdd( "inv_battery1", "spr_tent_battery1" );
    ObjSet( "inv_lvl4flashlight_star_light", { alp = 1 } );
  
  end;
  local get_battery1_end = function ()
  
    ObjDelete( "gfx_tent_battery1" );
    ObjDelete( "spr_tent_battery1_sh" );

    ObjDelete( "spr_forest_tent_battery1" );
  
  end;
  
  cmn.AddSubscriber( "get_battery1", get_battery1_inv );
  cmn.AddSubscriber( "get_battery1", get_battery1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_letter3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_letter3" ] = {
    type = "get",
    get_obj = "spr_forest_letter3",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_letter3_inv = function ()
  
    interface.InventoryItemAdd( "inv_letter", "spr_forest_letter3", function () cmn.GetMultyObject( 'letter', 9 ); end );
    int_map_impl.DecreaseRoomTasks("rm_forest");
  
  end;
  local get_letter3_end = function ()
  
    ObjDelete( "gfx_forest_letter3" );
    ObjDelete( "spr_forest_letter3_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_letter3", get_letter3_inv );
  cmn.AddSubscriber( "get_letter3", get_letter3_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_littlemirror () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_littlemirror" ] = {
      type = "get",
      get_obj = "spr_forest_littlemirror",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_littlemirror_inv = function ()
  
    interface.InventoryItemAdd( "inv_littlemirror", "spr_forest_littlemirror" );
    ObjSet("inv_torch_star_light",  { alp = 1 });
  
  end;
  local get_littlemirror_mid = function ()
  
    ObjDelete( "gfx_forest_littlemirror" );
    ObjDelete( "spr_forest_littlemirror_sh" );
    
  end;
  local get_littlemirror_end = function ()
  
    ObjDelete( "obj_forest_dialog_stephen" );
    ObjDelete( "anm_forest_stephen_out" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_littlemirror", get_littlemirror_inv );
  cmn.AddSubscriber( "get_littlemirror_inv", get_littlemirror_inv, private.room_objname );
  cmn.AddSubscriber( "get_littlemirror", get_littlemirror_mid, private.room_objname );
  cmn.AddSubscriber( "get_littlemirror_mid", get_littlemirror_mid, private.room_objname );
  cmn.AddSubscriber( "get_littlemirror", get_littlemirror_end, private.room_objname );
  cmn.AddSubscriber( "get_littlemirror_end", get_littlemirror_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_gloves () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_gloves" ] = {
    type = "use",
    inv_obj = "inv_gloves",
    use_place = "obj_stump_use_gloves",
    room = private.room_objname,
    zz = "zz_stump",
    zz_gate = "gzz_forest_stump"
  };
  --------------------------------------------------------------------------------------------
  local use_gloves_inv = function ()
  
    interface.InventoryItemRemove( "inv_gloves" );
  
  end;
  local use_gloves_beg = function ()
  
    ObjDelete( "obj_stump_use_gloves" );
  
  end;
  local use_gloves_end = function ()
    
    ObjDelete( "anm_stump_use_glove" );
  
    ObjMultiSet( { {"spr_stump_game_glove", { alp = 1 }},
                   {"anm_stump_thorns_touch", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gloves", use_gloves_beg, private.room_objname );
  cmn.AddSubscriber( "use_gloves", use_gloves_inv );
  cmn.AddSubscriber( "use_gloves", use_gloves_end, private.room_objname );
  cmn.AddSubscriber( "use_gloves_inv", use_gloves_inv, private.room_objname );
  cmn.AddSubscriber( "use_gloves_beg", use_gloves_beg, private.room_objname );
  cmn.AddSubscriber( "use_gloves_end", use_gloves_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_recipe () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_recipe1" ] = {
    type = "use",
    inv_obj = "inv_recipe",
    use_place = "obj_lvl4firtree_use_recipe",
    room = "rm_inhouse",
    zz = "zz_lvl4firtree",
    zz_gate = "gzz_inhouse_lvl4firtree"
  };
  --------------------------------------------------------------------------------------------
  game.hint[ "use_recipe2" ] = {
    type = "use",
    inv_obj = "inv_recipe",
    use_place = "obj_flowerbed_use_recipe",
    room = "rm_nearhouse",
    zz = "zz_flowerbed",
    zz_gate = "gzz_nearhouse_flowerbed"
  };
  --------------------------------------------------------------------------------------------
  game.hint[ "use_recipe4" ] = {
    type = "use",
    inv_obj = "inv_recipe",
    use_place = "obj_stump_use_recipe",
    room = private.room_objname,
    zz = "zz_stump",
    zz_gate = "gzz_forest_stump"
  };
  --------------------------------------------------------------------------------------------
  local use_recipe1_inv = function ()
  
    if cmn.IsEventDone("use_recipe2") and cmn.IsEventDone("use_recipe4") and cmn.IsEventDone("use_recipe3") then
      interface.InventoryItemRemove( "inv_recipe" );
    end;
  
  end;
  local use_recipe1_beg = function ()
  
    ObjDelete( "obj_lvl4firtree_use_recipe" );
    ObjDelete( "spr_lvl4firtree_ingredients1_1" );
  
  end;
  local use_recipe1_end = function ()
  
    ObjDelete( "anm_lvl4firtree_use_recipe" );
  
  end;
  
  local use_recipe2_inv = function ()
  
    if cmn.IsEventDone("use_recipe1") and cmn.IsEventDone("use_recipe4") and cmn.IsEventDone("use_recipe3") then
      interface.InventoryItemRemove( "inv_recipe" );
    end;
  
  end;
  local use_recipe2_beg = function ()
  
    ObjDelete( "obj_flowerbed_use_recipe" );
  
  end;
  local use_recipe2_end = function ()
  
    ObjSet( "anm_flowerbed_use_recipe", { frame = 300 } );
  
  end;
  
  local use_recipe4_inv = function ()
  
    if cmn.IsEventDone("use_recipe1") and cmn.IsEventDone("use_recipe2") and cmn.IsEventDone("use_recipe3") then
      interface.InventoryItemRemove( "inv_recipe" );
    end;
  
  end;
  local use_recipe4_beg = function ()
  
    ObjDelete( "obj_stump_use_recipe" );
    ObjDelete( "anm_stump_ingridient" );
  
  end;
  local use_recipe4_end = function ()
  
    --ObjSet( "spr_stump_ingredients4", { input = 1, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_recipe1", use_recipe1_beg, "rm_inhouse" );
  cmn.AddSubscriber( "use_recipe1", use_recipe1_inv );
  cmn.AddSubscriber( "use_recipe1", use_recipe1_end, "rm_inhouse" );
  cmn.AddSubscriber( "use_recipe1_inv", use_recipe1_inv, "rm_inhouse" );
  cmn.AddSubscriber( "use_recipe1_beg", use_recipe1_beg, "rm_inhouse" );
  cmn.AddSubscriber( "use_recipe1_end", use_recipe1_end, "rm_inhouse" );
  
  cmn.AddSubscriber( "use_recipe2", use_recipe2_beg, "rm_nearhouse" );
  cmn.AddSubscriber( "use_recipe2", use_recipe2_inv );
  cmn.AddSubscriber( "use_recipe2", use_recipe2_end, "rm_nearhouse" );
  cmn.AddSubscriber( "use_recipe2_inv", use_recipe2_inv, "rm_nearhouse" );
  cmn.AddSubscriber( "use_recipe2_beg", use_recipe2_beg, "rm_nearhouse" );
  cmn.AddSubscriber( "use_recipe2_end", use_recipe2_end, "rm_nearhouse" );
  
  cmn.AddSubscriber( "use_recipe4", use_recipe4_beg, private.room_objname );
  cmn.AddSubscriber( "use_recipe4", use_recipe4_inv );
  cmn.AddSubscriber( "use_recipe4", use_recipe4_end, private.room_objname );
  cmn.AddSubscriber( "use_recipe4_inv", use_recipe4_inv, private.room_objname );
  cmn.AddSubscriber( "use_recipe4_beg", use_recipe4_beg, private.room_objname );
  cmn.AddSubscriber( "use_recipe4_end", use_recipe4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_potionstump () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_potionstump" ] = {
    type = "use",
    inv_obj = "inv_potion",
    use_place = "obj_stump_use_potion",
    room = private.room_objname,
    zz = "zz_stump",
    zz_gate = "gzz_forest_stump"
  };
  --------------------------------------------------------------------------------------------
  game.hint[ "use_potionflowerbed" ] = {
    type = "use",
    inv_obj = "inv_potion",
    use_place = "obj_flowerbed_use_potion",
    room = "rm_nearhouse",
    zz = "zz_flowerbed",
    zz_gate = "gzz_nearhouse_flowerbed"
  };
  --------------------------------------------------------------------------------------------
  local use_potion_inv1 = function ()
  
    if cmn.IsEventDone("use_potionflowerbed") then
      interface.InventoryItemRemove( "inv_potion" );
    end;
  
  end;
  local use_potion_beg1 = function ()
  
    ObjDelete( "obj_stump_use_potion" );
    ObjDelete( "anm_stump_mushroom_touch" );
  
  end;
  local use_potion_end1 = function ()

    ObjDelete( "spr_forest_stumb_mushroom1" );
  
    ObjMultiSet( {
      { "anm_stump_use_potion", { input = 1, alp = 1, frame = 300 } },
      { "spr_forest_stumb_mushroom2", { alp = 1 } }
    } );
  
  end;
  
  local use_potion_inv2 = function ()
  
    if cmn.IsEventDone("use_potionstump") then
      interface.InventoryItemRemove( "inv_potion" );
    end;
  
  end;
  local use_potion_beg2 = function ()
  
    ObjDelete( "obj_flowerbed_use_potion" );
  
  end;
  local use_potion_end2 = function ()
  
    if cmn.IsEventDone("use_seeds") then

      ObjDelete( "gzz_nearhouse_flowerbed" );

      ObjDelete( "anm_nearhouse_tree_growup" );

      ObjMultiSet( {
        { "grm_nearhouse_attic", { input = 1, alp = 1 } },
        { "anm_nearhouse_tree", { frame = 0, alp = 1 } }
      } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_nearhouse_attic_focus");
      end;
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_potionstump", use_potion_beg1, private.room_objname );
  cmn.AddSubscriber( "use_potionstump", use_potion_inv1 );
  cmn.AddSubscriber( "use_potionstump", use_potion_end1, private.room_objname );
  cmn.AddSubscriber( "use_potion_inv1", use_potion_inv1, private.room_objname );
  cmn.AddSubscriber( "use_potion_beg1", use_potion_beg1, private.room_objname );
  cmn.AddSubscriber( "use_potion_end1", use_potion_end1, private.room_objname );
  
  cmn.AddSubscriber( "use_potionflowerbed", use_potion_beg2, "rm_nearhouse" );
  cmn.AddSubscriber( "use_potionflowerbed", use_potion_inv2 );
  cmn.AddSubscriber( "use_potionflowerbed", use_potion_end2, "rm_nearhouse" );
  cmn.AddSubscriber( "use_potion_inv2", use_potion_inv2, "rm_nearhouse" );
  cmn.AddSubscriber( "use_potion_beg2", use_potion_beg2, "rm_nearhouse" );
  cmn.AddSubscriber( "use_potion_end2", use_potion_end2, "rm_nearhouse" );
  --------------------------------------------------------------------------------------------
  -- function use_recipe3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_recipe3" ] = {
    type = "use",
    inv_obj = "inv_recipe",
    use_place = "obj_burrow_use_recipe",
    room = private.room_objname,
    zz = "zz_burrow",
    zz_gate = "gzz_forest_burrow"
  };
  --------------------------------------------------------------------------------------------
  local use_recipe3_inv = function ()
  
    if cmn.IsEventDone("use_recipe1") and cmn.IsEventDone("use_recipe2") and cmn.IsEventDone("use_recipe4") then
      interface.InventoryItemRemove( "inv_recipe" );
    end;
  
  end;
  local use_recipe3_beg = function ()
  
    ObjDelete( "obj_burrow_use_recipe" );
    ObjDelete( "anm_burrow_ingredient" );
  
  end;
  local use_recipe3_end = function ()
  
    --ObjSet( "anm_burrow_use_recipe", { alp = 1, frame = 300, pos_z = 6 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_recipe3", use_recipe3_beg, private.room_objname );
  cmn.AddSubscriber( "use_recipe3", use_recipe3_inv );
  cmn.AddSubscriber( "use_recipe3", use_recipe3_end, private.room_objname );
  cmn.AddSubscriber( "use_recipe3_inv", use_recipe3_inv, private.room_objname );
  cmn.AddSubscriber( "use_recipe3_beg", use_recipe3_beg, private.room_objname );
  cmn.AddSubscriber( "use_recipe3_end", use_recipe3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mushroom () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_mushroom" ] = {
    type = "use",
    inv_obj = "inv_mushroom",
    use_place = "obj_burrow_use_mushroom",
    room = private.room_objname,
    zz = "zz_burrow",
    zz_gate = "gzz_forest_burrow"
  };
  --------------------------------------------------------------------------------------------
  local use_mushroom_inv = function ()
  
    interface.InventoryItemRemove( "inv_mushroom" );
  
  end;
  local use_mushroom_beg = function ()
  
    ObjDelete( "obj_burrow_use_mushroom" );
    ObjDelete( "anm_burrow_hedgehog_2" );
    ObjDelete( "anm_burrow_hedgehog_touch" );
  
  end;
  local use_mushroom_end = function ()

    ObjDelete( "obj_forest_burrow_hedgehog1" );
  
    ObjMultiSet( {
      { "anm_burrow_use_mushroom", { input = 1, alp = 1, frame = 300, pos_z = 2 } },
      { "spr_forest_burrow_hedgehog2", { alp = 1 } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mushroom", use_mushroom_beg, private.room_objname );
  cmn.AddSubscriber( "use_mushroom", use_mushroom_inv );
  cmn.AddSubscriber( "use_mushroom", use_mushroom_end, private.room_objname );
  cmn.AddSubscriber( "use_mushroom_inv", use_mushroom_inv, private.room_objname );
  cmn.AddSubscriber( "use_mushroom_beg", use_mushroom_beg, private.room_objname );
  cmn.AddSubscriber( "use_mushroom_end", use_mushroom_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spade () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_spade" ] = {
    type = "use",
    inv_obj = "inv_spade",
    use_place = "obj_burrow_use_spade",
    room = private.room_objname,
    zz = "zz_burrow",
    zz_gate = "gzz_forest_burrow"
  };
  --------------------------------------------------------------------------------------------
  local use_spade_inv = function ()
  
    interface.InventoryItemRemove( "inv_spade" );
  
  end;
  local use_spade_beg = function ()
  
    ObjDelete( "obj_burrow_use_spade" );
    ObjDelete( "anm_burrow_ground_touch" );
  
  end;
  local use_spade_end = function ()

    ObjDelete( "spr_forest_burrow_cup_hole" );
  
    ObjMultiSet( {
      { "anm_burrow_use_shovel", { input = 1, alp = 1, frame = 300, pos_z = 3 } },
      { "spr_forest_burrow_ground", { alp = 1 } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_spade", use_spade_beg, private.room_objname );
  cmn.AddSubscriber( "use_spade", use_spade_inv );
  cmn.AddSubscriber( "use_spade", use_spade_end, private.room_objname );
  cmn.AddSubscriber( "use_spade_inv", use_spade_inv, private.room_objname );
  cmn.AddSubscriber( "use_spade_beg", use_spade_beg, private.room_objname );
  cmn.AddSubscriber( "use_spade_end", use_spade_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_apple () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_apple" ] = {
    type = "use",
    inv_obj = "inv_apple",
    use_place = "obj_burrow_use_apple",
    room = private.room_objname,
    zz = "zz_burrow",
    zz_gate = "gzz_forest_burrow"
  };
  --------------------------------------------------------------------------------------------
  local use_apple_inv = function ()
  
    interface.InventoryItemRemove( "inv_apple" );
  
  end;
  local use_apple_beg = function ()
  
    ObjDelete( "obj_burrow_use_apple" );
    ObjDelete( "anm_burrow_hedgehog" );
  
  end;
  local use_apple_end = function ()

    ObjMultiSet( { {"obj_burrow_use_mushroom",  { input = 1 }},
                   {"anm_burrow_hedgehog_touch", { frame = 0, animfunc = "func_clk_hedgehog_2" }},
                   {"spr_forest_burrow_apple", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_apple", use_apple_beg, private.room_objname );
  cmn.AddSubscriber( "use_apple", use_apple_inv );
  cmn.AddSubscriber( "use_apple", use_apple_end, private.room_objname );
  cmn.AddSubscriber( "use_apple_inv", use_apple_inv, private.room_objname );
  cmn.AddSubscriber( "use_apple_beg", use_apple_beg, private.room_objname );
  cmn.AddSubscriber( "use_apple_end", use_apple_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_shovelhandle () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_shovelhandle" ] = {
    type = "use",
    inv_obj = "inv_shovelhandle",
    use_place = "obj_bonfire_use_shovelhandle",
    room = private.room_objname,
    zz = "zz_bonfire",
    zz_gate = "gzz_forest_bonfire"
  };
  --------------------------------------------------------------------------------------------
  local use_shovelhandle_inv = function ()
  
    interface.InventoryItemRemove( "inv_shovelhandle" );
  
  end;
  local use_shovelhandle_beg = function ()
  
    ObjDelete( "obj_bonfire_use_shovelhandle" );
    ObjDelete( "anm_bonfire_shovel_touch" )
  
  end;
  local use_shovelhandle_end = function ()
  
    --ObjSet( "spr_bonfire_spade", { input = 1, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_shovelhandle", use_shovelhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_shovelhandle", use_shovelhandle_inv );
  cmn.AddSubscriber( "use_shovelhandle", use_shovelhandle_end, private.room_objname );
  cmn.AddSubscriber( "use_shovelhandle_inv", use_shovelhandle_inv, private.room_objname );
  cmn.AddSubscriber( "use_shovelhandle_beg", use_shovelhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_shovelhandle_end", use_shovelhandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_glassshard () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_glassshard" ] = {
    type = "use",
    inv_obj = "inv_glassshard",
    use_place = "obj_bonfire_use_glassshard",
    room = private.room_objname,
    zz = "zz_bonfire",
    zz_gate = "gzz_forest_bonfire"
  };
  --------------------------------------------------------------------------------------------
  local use_glassshard_inv = function ()
  
    interface.InventoryItemRemove( "inv_glassshard" );
  
  end;
  local use_glassshard_beg = function ()
  
    ObjDelete( "obj_bonfire_use_glassshard" );
    ObjDelete( "anm_bonfire_button_touch" );
  
  end;
  local use_glassshard_end = function ()
  
    --ObjSet( "spr_bonfire_clothbutton1", { input = 1, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_glassshard", use_glassshard_beg, private.room_objname );
  cmn.AddSubscriber( "use_glassshard", use_glassshard_inv );
  cmn.AddSubscriber( "use_glassshard", use_glassshard_end, private.room_objname );
  cmn.AddSubscriber( "use_glassshard_inv", use_glassshard_inv, private.room_objname );
  cmn.AddSubscriber( "use_glassshard_beg", use_glassshard_beg, private.room_objname );
  cmn.AddSubscriber( "use_glassshard_end", use_glassshard_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl4screwdriver () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl4screwdriver" ] = {
    type = "use",
    inv_obj = "inv_lvl4screwdriver",
    use_place = "obj_bonfire_use_lvl4screwdriver",
    room = private.room_objname,
    zz = "zz_bonfire",
    zz_gate = "gzz_forest_bonfire"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl4screwdriver_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl4screwdriver" );
  
  end;
  local use_lvl4screwdriver_beg = function ()
  
    ObjDelete( "obj_bonfire_use_lvl4screwdriver" );
    ObjDelete( "anm_bonfire_radio_touch" );
    ObjSet("obj_bonfire_radio",  { alp = 1 });
  
  end;
  local use_lvl4screwdriver_end = function ()
  
    ObjDelete( "anm_bonfire_use_screwdriver" );
    ObjDelete( "spr_forest_bonfire_radiodoor" );

    ObjSet( "obj_bonfire_radio", { input = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl4screwdriver", use_lvl4screwdriver_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4screwdriver", use_lvl4screwdriver_inv );
  cmn.AddSubscriber( "use_lvl4screwdriver", use_lvl4screwdriver_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl4screwdriver_inv", use_lvl4screwdriver_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl4screwdriver_beg", use_lvl4screwdriver_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4screwdriver_end", use_lvl4screwdriver_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_zipper () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_zipper" ] = {
    type = "use",
    inv_obj = "inv_zipper",
    use_place = "obj_tent_use_zipper",
    room = private.room_objname,
    zz = "zz_tent",
    zz_gate = "gzz_forest_tent"
  };
  --------------------------------------------------------------------------------------------
  local use_zipper_inv = function ()
  
    interface.InventoryItemRemove( "inv_zipper" );
  
  end;
  local use_zipper_beg = function ()
  
    ObjDelete( "obj_tent_use_zipper" );
    ObjDelete( "anm_tent_tent_touch" );
  
  end;
  local use_zipper_end = function ()
  
    ObjDelete( "gzz_forest_tent" );
    ObjSet( "gho_forest_intent", { input = 1, alp = 1, active = 1 } );

    ObjDelete( "obj_forest_tent_door" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_zipper", use_zipper_beg, private.room_objname );
  cmn.AddSubscriber( "use_zipper", use_zipper_inv );
  cmn.AddSubscriber( "use_zipper", use_zipper_end, private.room_objname );
  cmn.AddSubscriber( "use_zipper_inv", use_zipper_inv, private.room_objname );
  cmn.AddSubscriber( "use_zipper_beg", use_zipper_beg, private.room_objname );
  cmn.AddSubscriber( "use_zipper_end", use_zipper_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_guidingtorch () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_guidingtorch" ] = {
    type = "use",
    inv_obj = "inv_guidingtorch",
    use_place = "obj_forest_use_guidingtorch",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local use_guidingtorch_inv = function ()
  
    interface.InventoryItemRemove( "inv_guidingtorch" );
  
  end;
  local use_guidingtorch_beg = function ()
  
    ObjDelete( "obj_forest_use_guidingtorch" );
  
  end;
  local use_guidingtorch_end = function ()
  
    ObjMultiSet( { {"grm_forest_nearhouse", { alp = 1, input = 1 }},
                   {"spr_forest_torch_light", { alp = 1 }} } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_forest_nearhouse_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_guidingtorch", use_guidingtorch_beg, private.room_objname );
  cmn.AddSubscriber( "use_guidingtorch", use_guidingtorch_inv );
  cmn.AddSubscriber( "use_guidingtorch", use_guidingtorch_end, private.room_objname );
  cmn.AddSubscriber( "use_guidingtorch_inv", use_guidingtorch_inv, private.room_objname );
  cmn.AddSubscriber( "use_guidingtorch_beg", use_guidingtorch_beg, private.room_objname );
  cmn.AddSubscriber( "use_guidingtorch_end", use_guidingtorch_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_forestfirst () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_forestfirst" ] = {
    type = "click",
    use_place = "obj_forest_clk_forestfirst",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local clk_forestfirst_beg = function ()
  
    ObjDelete( "obj_forest_clk_forestfirst" );
  
  end;
  local clk_forestfirst_end = function ()
    
    ObjDelete( "anm_forest_dialog_stephen_hand_1" );
    ObjDelete( "anm_forest_dialog_stephen_hand_give" );
    
    ObjDelete( "vid_forest_dialog_stephen_lipsync" );
    ObjDelete( "anm_forest_stephen" );
    
    ObjAttach("obj_forest_dialog_stephen", "rm_forest");
    
    ObjMultiSet( { {"obj_forest_dialog_stephen", { alp = 1, input = 1 }},
                   {"obj_forest_dialog_stephen_hand_2", { alp = 1, input = 1 }},
                   {"obj_forest_use_guidingtorch", { alp = 1, input = 1 }},
                   {"anm_forest_stephen_out", { alp = 1 }},
                   {"anm_forest_dialog_stephen_head", { alp = 1 }} } );

    ObjMultiSet( {
      { "gzz_forest_stump", { event_mdown = "cmn.GotoSubRoomMDown( 'forest_stump' );", event_mup = "cmn.GotoSubRoomMUp( 'forest_stump', 'zz_stump', false, true );" } },
      { "gzz_forest_burrow", { event_mdown = "cmn.GotoSubRoomMDown( 'forest_burrow' );", event_mup = "cmn.GotoSubRoomMUp( 'forest_burrow', 'zz_burrow' );" } },
      { "gzz_forest_bonfire", { event_mdown = "cmn.GotoSubRoomMDown( 'forest_bonfire' );", event_mup = "cmn.GotoSubRoomMUp( 'forest_bonfire', 'zz_bonfire', false, true );" } },
      { "gzz_forest_tent", { event_mdown = "cmn.GotoSubRoomMDown( 'forest_tent' );", event_mup = "cmn.GotoSubRoomMUp( 'forest_tent', 'zz_tent' );" } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_forestfirst", clk_forestfirst_beg, private.room_objname );
  cmn.AddSubscriber( "clk_forestfirst", clk_forestfirst_end, private.room_objname );
  cmn.AddSubscriber( "clk_forestfirst_beg", clk_forestfirst_beg, private.room_objname );
  cmn.AddSubscriber( "clk_forestfirst_end", clk_forestfirst_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_forest () end;
  --------------------------------------------------------------------------------------------
  local opn_forest = function ()
  
    int_map_impl.OpenRoom( "rm_forest" );
    interface_impl.SetCurrentGlobalTask( 21 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_forest", opn_forest );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_stump" );
  subroom.Define( "zz_burrow" );
  subroom.Define( "zz_bonfire" );
  
  function zz_burrow.PreOpen()
    
    if cmn.IsEventDone( "use_recipe3" ) then
      ObjSet( "anm_burrow_ingredient_2", { playing = 1 } );
    end;
    
    if cmn.IsEventDone( "use_apple" ) and not cmn.IsEventDone("use_mushroom") then
      ObjSet( "anm_burrow_hedgehog_2", { playing = 1 } );
    end;

  end;
  
  function zz_stump.PreOpen()
    
    if not(cmn.IsEventDone( "win_stump" )) then
      private.zz_stump.DrawScene();
    end;

  end;
  
  function zz_stump.Open()
    
    if cmn.IsEventDone( "use_gloves" ) and not(cmn.IsEventDone( "win_stump" )) then
      cmn.MiniGameShow();
      private.zz_stump.CheckWin();
    end;

  end;
  
  function zz_stump.PreClose()
    
    if cmn.IsEventDone( "use_gloves" ) and not cmn.IsEventDone("win_stump") then
      cmn.MiniGameHide("stump");
    end;
    
  end;
  
  function zz_bonfire.PreOpen()
    
    cmn.PlayAudio("env", "assets/levels/level4/audio/env/aud_zz_bonfire_env");
    
  end;
  
  function zz_bonfire.PreClose()
    
    cmn.StopAllEnv("assets/levels/level4/audio/env/aud_rm_forest_env");
    cmn.PlayAudio("env", "assets/levels/level4/audio/env/aud_rm_forest_env");
    
  end;
  
  function zz_bonfire.Close()
    cmn.HideNote( 0 );
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_stump" ].state) then 
    private.zz_stump.StartConditions();
  end;
  
  private.zz_stump.state = ng_global.progress[ ng_global.currentprogress ][ "win_stump" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_forest();
  
  if cmn.IsEventDone("clk_forestfirst") and not cmn.IsEventDone("get_littlemirror") then
    --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    common_impl.current_dialog = "obj_forest_dialog_stephen";
    ObjSet("anm_forest_dialog_stephen_hand_2",  { playing = 1 });
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level4/audio/env/aud_rm_forest_env");
  cmn.PlayAudio("env", "assets/levels/level4/audio/env/aud_rm_forest_env");
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_gloves()

  local item = "inv_gloves";

  if cmn.ApplyObj( item, "gzz_forest_stump" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_stump", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_stump_use_gloves" ) ) then

    cmn.CallEventHandler( "use_gloves_inv" );
    cmn.CallEventHandler( "use_gloves_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_gloves" );
      cmn.CallEventHandler( "use_gloves_end" );
      
      cmn.MiniGameShow();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_use_glove_leaves");

    ObjSet("anm_stump_use_glove",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_recipe()

  local item = "inv_recipe";

  if cmn.ApplyObj( item, "gzz_inhouse_lvl4firtree" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_lvl4firtree" );

  elseif ( cmn.ApplyObj( item, "obj_lvl4firtree_use_recipe" ) ) then

    cmn.CallEventHandler( "use_recipe1_inv" );
    cmn.CallEventHandler( "use_recipe1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_recipe1" );
      cmn.CallEventHandler( "use_recipe1_end" );
      
      rm_inhouse.get_ingredients1();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_paper_put_tree");

    ObjMultiSet( { {"anm_lvl4firtree_use_recipe", { alp = 1, playing = 1, endtrig = func_after }},
                   {"obj_lvl4firtree_ingredients1", { alp = 1 }},
                   {"anm_lvl4firtree_ingredient", { playing = 1 }} } );

  elseif cmn.ApplyObj( item, "gzz_nearhouse_flowerbed" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_flowerbed", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_flowerbed_use_recipe" ) ) then

    cmn.CallEventHandler( "use_recipe2_inv" );
    cmn.CallEventHandler( "use_recipe2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_recipe2" );
      cmn.CallEventHandler( "use_recipe2_end" );
      
      rm_nearhouse.get_ingredients2();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_paper_put_flower");

    ObjSet("anm_flowerbed_use_recipe",  { alp = 1, playing = 1, endtrig = func_after });

  elseif cmn.ApplyObj( item, "gzz_forest_stump" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_stump", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_stump_use_recipe" ) and cmn.IsEventDone("use_gloves") ) then

    cmn.CallEventHandler( "use_recipe4_inv" );
    cmn.CallEventHandler( "use_recipe4_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_recipe4" );
      cmn.CallEventHandler( "use_recipe4_end" );
      
      public.get_ingredients4();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_paper_put_stump");

    ObjSet("anm_stump_use_recipe",  { alp = 1, playing = 1, endtrig = func_after });

  elseif cmn.ApplyObj( item, "gzz_forest_burrow" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_burrow" );

  elseif ( cmn.ApplyObj( item, "obj_burrow_use_recipe" ) ) then

    cmn.CallEventHandler( "use_recipe3_inv" );
    cmn.CallEventHandler( "use_recipe3_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_recipe3" );
      cmn.CallEventHandler( "use_recipe3_end" );
      
      public.get_ingredients3();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_paper_put_animal");

    ObjSet("anm_burrow_use_recipe",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_potion()

  local item = "inv_potion";

  if cmn.ApplyObj( item, "gzz_forest_stump" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_stump", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_stump_use_potion" ) and cmn.IsEventDone("use_gloves") ) then

    cmn.CallEventHandler( "use_potion_inv1" );
    cmn.CallEventHandler( "use_potion_beg1" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_potionstump" );
      cmn.CallEventHandler( "use_potion_end1" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_drip_mushroom");

    ObjSet("anm_stump_use_potion",  { alp = 1, playing = 1, endtrig = func_after });

  elseif cmn.ApplyObj( item, "gzz_nearhouse_flowerbed" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_flowerbed", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_flowerbed_use_potion" ) and cmn.IsEventDone("use_seeds") ) then

    cmn.CallEventHandler( "use_potion_inv2" );
    cmn.CallEventHandler( "use_potion_beg2" );

    local func_after = function ()
      
      cmn.SetEventDone( "use_potionflowerbed" );
      common.CloseSubRoom();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_drip_ground_grow");

    ObjSet("anm_flowerbed_use_potion",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_mushroom()

  local item = "inv_mushroom";

  if cmn.ApplyObj( item, "gzz_forest_burrow" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_burrow" );

  elseif ( cmn.ApplyObj( item, "obj_burrow_use_mushroom" ) ) then

    cmn.CallEventHandler( "use_mushroom_inv" );
    cmn.CallEventHandler( "use_mushroom_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_mushroom" );
      cmn.CallEventHandler( "use_mushroom_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_take_mushroom_animal");

    ObjSet("anm_burrow_use_mushroom",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_spade()

  local item = "inv_spade";

  if cmn.ApplyObj( item, "gzz_forest_burrow" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_burrow" );

  elseif ( cmn.ApplyObj( item, "obj_burrow_use_spade" ) ) then

    cmn.CallEventHandler( "use_spade_inv" );
    cmn.CallEventHandler( "use_spade_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_spade" );
      cmn.CallEventHandler( "use_spade_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_dig_showel");

    ObjSet("anm_burrow_use_shovel",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_apple()

  local item = "inv_apple";

  if cmn.ApplyObj( item, "gzz_forest_burrow" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_burrow" );

  elseif ( cmn.ApplyObj( item, "obj_burrow_use_apple" ) ) then

    cmn.CallEventHandler( "use_apple_inv" );
    cmn.CallEventHandler( "use_apple_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_apple" );
      cmn.CallEventHandler( "use_apple_end" );
      
      public.get_needdle();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_take_apple");

    ObjSet("anm_burrow_use_apple",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_shovelhandle()

  local item = "inv_shovelhandle";

  if cmn.ApplyObj( item, "gzz_forest_bonfire" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_bonfire", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_bonfire_use_shovelhandle" ) ) then

    cmn.CallEventHandler( "use_shovelhandle_inv" );
    cmn.CallEventHandler( "use_shovelhandle_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_shovelhandle" );
      cmn.CallEventHandler( "use_shovelhandle_end" );
      
      public.get_spade();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_stick_shovel");

    ObjSet("anm_bonfire_use_handle",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_glassshard()

  local item = "inv_glassshard";

  if cmn.ApplyObj( item, "gzz_forest_bonfire" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_bonfire", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_bonfire_use_glassshard" ) ) then

    cmn.CallEventHandler( "use_glassshard_inv" );
    cmn.CallEventHandler( "use_glassshard_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_glassshard" );
      cmn.CallEventHandler( "use_glassshard_end" );
      
      public.get_clothbutton1();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_cut_button");

    ObjSet("anm_bonfire_use_shard",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl4screwdriver()

  local item = "inv_lvl4screwdriver";

  if cmn.ApplyObj( item, "gzz_forest_bonfire" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_bonfire", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_bonfire_use_lvl4screwdriver" ) ) then

    cmn.CallEventHandler( "use_lvl4screwdriver_inv" );
    cmn.CallEventHandler( "use_lvl4screwdriver_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl4screwdriver" );
      cmn.CallEventHandler( "use_lvl4screwdriver_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_open_radio");

    ObjSet("anm_bonfire_use_screwdriver",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_zipper()

  local item = "inv_zipper";

  if cmn.ApplyObj( item, "gzz_forest_tent" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_tent" );

  elseif ( cmn.ApplyObj( item, "obj_tent_use_zipper" ) ) then

    cmn.CallEventHandler( "use_zipper_inv" );
    cmn.CallEventHandler( "use_zipper_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_zipper" );
      cmn.CallEventHandler( "use_zipper_end" );
      
      common.CloseSubRoom();
    
    end;
    
    if not cmn.IsEventDone("get_battery1") then
      public.get_battery1();
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_open_tent");

    ObjSet("anm_tent_use_zipper",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_guidingtorch()

  local item = "inv_guidingtorch";

  if ( cmn.ApplyObj( item, "obj_forest_use_guidingtorch" ) ) then

    cmn.CallEventHandler( "use_guidingtorch_inv" );
    cmn.CallEventHandler( "use_guidingtorch_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_guidingtorch" );
      cmn.CallEventHandler( "use_guidingtorch_end" );
    
    end;

    cmn.Lock( 1 );

    ObjAnimate( "spr_forest_torch_light", "alp", 0, 0, func_after, { 0, 0, 0,    0.5, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_torch()

  cmn.SetEventDone( "get_torch" );
  cmn.CallEventHandler( "get_torch" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_ingredients4()
  
  ObjSet("spr_stump_ingredients4",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_ingredients4" );
  cmn.CallEventHandler( "get_ingredients4" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_mushroom()

  cmn.SetEventDone( "get_mushroom" );
  cmn.CallEventHandler( "get_mushroom" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_angel2()

  cmn.SetEventDone( "get_angel2" );
  cmn.CallEventHandler( "get_angel2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_zipper()

  cmn.SetEventDone( "get_zipper" );
  cmn.CallEventHandler( "get_zipper" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_needdle()
  
  ObjSet( "anm_burrow_hedgehog_2", { playing = 1 } );

  cmn.SetEventDone( "get_needdle" );
  cmn.CallEventHandler( "get_needdle" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_ingredients3()
  
  ObjSet( "anm_burrow_ingredient_2", { playing = 1 } );

  cmn.SetEventDone( "get_ingredients3" );
  cmn.CallEventHandler( "get_ingredients3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_chestkey()
  
  ObjSet("spr_burrow_chestkey",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_chestkey" );
  cmn.CallEventHandler( "get_chestkey" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_spade()
  
  ObjSet( "spr_bonfire_spade", { alp = 1 } );

  cmn.SetEventDone( "get_spade" );
  cmn.CallEventHandler( "get_spade" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_clothbutton1()

  cmn.SetEventDone( "get_clothbutton1" );
  cmn.CallEventHandler( "get_clothbutton1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_diary()
  
  local func_after = function ()
    cmn.ShowBbt( "forest_after_flashback" );
    int_diary.AddDiarypage( 24 );
  end;

  cmn.SetEventDone( "get_diary" );
  cmn.CallEventHandler( "get_diary" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  cmn.PlayFullscreenVideo( "assets/levels/level4/rm_forest/vid_lvl4flashback", func_after, "assets/levels/level4/audio/mus/aud_vid_lvl4flashback_mus", "assets/levels/level4/audio/voc/aud_4_lvl_naya_2_voc");

end;
--------------------------------------------------------------------------------------------
function public.get_lvl4button()

  cmn.SetEventDone( "get_lvl4button" );
  cmn.CallEventHandler( "get_lvl4button" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_fuse1") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_fuse1()

  cmn.SetEventDone( "get_fuse1" );
  cmn.CallEventHandler( "get_fuse1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_lvl4button") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_gloves()

  cmn.SetEventDone( "get_gloves" );
  cmn.CallEventHandler( "get_gloves" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_battery1()

  cmn.SetEventDone( "get_battery1" );
  cmn.CallEventHandler( "get_battery1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_letter3()

  cmn.SetEventDone( "get_letter3" );
  cmn.CallEventHandler( "get_letter3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_littlemirror()
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_littlemirror_end" );
    
    --common_impl.PlayBackgroundMusic();

  end;
  
  local anm_out = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_stephen_diss");
    ObjSet("anm_forest_stephen_out",  { playing = 1, endtrig = func_after_dlg });
    
  end;

  cmn.SetEventDone( "get_littlemirror" );
  cmn.CallEventHandler( "get_littlemirror_inv" );
  cmn.CallEventHandler( "get_littlemirror_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.current_dialog = "";
  
  cmn.Lock(1);
  ObjAnimate("obj_forest_dialog_stephen", "alp", 0, 0, anm_out, { 0, 0, 1,   0.5, 0, 0 });

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_forestfirst()

  cmn.CallEventHandler( "clk_forestfirst_beg" );
  cmn.SetEventDone( "clk_forestfirst" );
    
  ObjAttach("obj_forest_dialog_stephen", "rm_forest");
  ObjAnimate("obj_forest_dialog_stephen", "alp", 0, 0, private.dialog_stephen_beg, { 0, 0, 0,   0.5, 0, 1 });

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_forest()

  if not ( cmn.IsEventDone( "opn_forest" ) ) then
    cmn.SetEventDone( "opn_forest" );
    cmn.CallEventHandler("opn_forest");
    cmn.ShowBbt( "forest_open" );
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_tent()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_tent");

  cmn.ShowBbt( "obj_tent_use_zipper" );
  
  ObjSet( "anm_tent_tent_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_stump_mushroom()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_spore");

  cmn.ShowBbt( "obj_stump_use_potion" );
  
  ObjSet( "anm_stump_mushroom_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_stump_thorns()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_barbed_leaves");

  cmn.ShowBbt( "obj_stump_use_gloves" );
  
  ObjSet( "anm_stump_thorns_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_burrow_ground()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_ground_zz_burrow");

  cmn.ShowBbt( "obj_burrow_use_spade" );
  
  ObjSet( "anm_burrow_ground_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_burrow_hedgehog_1()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_hedgehog");
  
  local func_after = function ()
    
    cmn.Lock( 0 );
    
    ObjMultiSet( { {"anm_burrow_hedgehog_touch", { alp = 0 }},
                   {"anm_burrow_hedgehog", { alp = 1, playing = 1 }} } );
    
  end;

  cmn.ShowBbt( "obj_burrow_use_apple" );
  
  ObjMultiSet( { {"anm_burrow_hedgehog_touch", { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_burrow_hedgehog", { alp = 0, playing = 0 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_burrow_hedgehog_2()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_hedgehog");
  
  local func_after = function ()
    
    cmn.Lock( 0 );
    
    ObjMultiSet( { {"anm_burrow_hedgehog_touch", { alp = 0 }},
                   {"anm_burrow_hedgehog_2", { alp = 1, playing = 1 }} } );
    
  end;

  cmn.ShowBbt( "obj_burrow_use_mushroom" );
  
  ObjMultiSet( { {"anm_burrow_hedgehog_touch", { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_burrow_hedgehog_2", { alp = 0, playing = 0 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_bonfire_shovel()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_part_shovel");

  cmn.ShowBbt( "obj_bonfire_use_shovelhandle" );
  
  ObjSet( "anm_bonfire_shovel_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_bonfire_button()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_button");

  cmn.ShowBbt( "obj_bonfire_use_glassshard" );
  
  ObjSet( "anm_bonfire_button_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_bonfire_radio()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_radio");

  cmn.ShowBbt( "obj_bonfire_use_lvl4screwdriver" );
  
  ObjSet( "anm_bonfire_radio_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_stephen_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "forest", "stephen", 2 );
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "clk_forestfirst_end" );

    cmn.ShowBbt( "forest_after_dialog" );
    interface_impl.ShowGlobalTask();
    
    ObjSet("anm_forest_dialog_stephen_hand_2",  { playing = 1 });
    
  end;
  
  local anm_hand = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_forest_dialog_stephen_lipsync");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjDelete("anm_forest_dialog_stephen_hand_1");
    
    ObjMultiSet( { {"tmr_forest_dialog_stephen_timer", { playing = 0 }},
                   {"anm_forest_dialog_stephen_hand_give", { alp = 1, playing = 1, endtrig = dialog_end }},
                   {"anm_forest_dialog_stephen_head", { alp = 1 }} } );
    
  end;
                 
  private.dlg_lipsync = "vid_forest_dialog_stephen_lipsync";

  cmn.ShowDlgBbt( "dlg_forest_stephen_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level4/audio/voc/aud_4_lvl_stephen_3_voc");

  ObjMultiSet( { {"tmr_forest_dialog_stephen_timer", { time = 11, playing = 1, endtrig = anm_hand }},
                 {"vid_forest_dialog_stephen_lipsync", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = anm_hand }},
                 {"obj_character_dialog_continue", { event_mup = anm_hand }} } );
  
end; 
--------------------------------------------------------------------------------------------
function public.skip_dlg_stephen()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "clk_forestfirst_end" );

    cmn.ShowBbt( "forest_after_dialog" );
    interface_impl.ShowGlobalTask();
    
    ObjSet("anm_forest_dialog_stephen_hand_2",  { playing = 1 });
    
  end;
  
  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    ObjSet("anm_forest_dialog_stephen_head",  { alp = 1 });
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();
  
  --common_impl.PlayBackgroundMusic();
  
  ObjDelete("anm_forest_dialog_stephen_hand_1");
    
  ObjMultiSet( { {"tmr_forest_dialog_stephen_timer", { playing = 0 }},
                 {"anm_forest_dialog_stephen_hand_give", { alp = 1, playing = 1, endtrig = func_after_dlg }} } );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Stump *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_stump = {};
public.zz_stump = {};

function private.Init_Stump()
  
  private.zz_stump.glove_pos = {
    {-213, 195}, {-139, 138}, {-180, 86}, {-182, -55}, {-180, -172}, {-50, -175},
    {77, -173}, {184, -182}, {117, -112}, {188, -77}, {61, -65}, {-67, -58}, {-81, 71}, {62, 56}, {176, 72}, {-60, 187}, {86, 194}
  };
  
  private.zz_stump.connect = {
    { {2, 1.64}, {12, 0.11}, {15, -1.34} }, { {1, -1.5}, {3, 0.98} }, { {4, 0.93}, {2, -2.19}, {11, -0.61}, {12, -1.45} }, { {3, -2.19}, {5, -0.62} },
    { {6, -0.62}, {4, 2.52}, {10, -1.5} }, { {5, 2.52}, {7, -0.62}, {8, -1.55} }, { {6, 2.6}, {8, -3.05}, {9, -2.19} }, { {6, 1.48}, {7, 0.19}, {9, -1.1}, {10, -3.02} },
    { {7, 0.95}, {8, 2.03}, {13, -2.9}, {14, -2.19} }, { {8, 0.1}, {5, 1.85}, {11, 2.64}, {12, -2.9} }, { {3, 2.47}, {10, -0.6} }, { {1, -2.9}, {3, 1.61}, {10, 0} },
    { {9, 0.2}, {14, -0.66}, {15, -3.03} }, { {9, 0.79}, {13, 2.47}, {16, -2.67} }, { {1, 2.08}, {13, 0.23}, {16, -0.67} }, { {14, 0.3}, {15, 2.46} }
  };
  
  private.zz_stump.new_thorn = 0;
  private.zz_stump.thornes_down = {};
  -----------------------------------------------------------------------------------
  game.hint[ "win_stump" ] = {
    type = "win",
    room = "rm_forest",
    zz = "zz_stump",
    zz_gate = "gzz_forest_stump"
  };
  -----------------------------------------------------------------------------------
  local win_stump = function ()

    if cmn.IsEventDone( "win_stump" ) then
      ObjDelete("obj_stump_layer_2");
      ObjDelete("obj_stump_layer_3");
      ObjSet("obj_stump_under_bush",  { input = 1 });

      ObjDelete( "spr_forest_stumb_mmg" );
    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_stump", win_stump, "rm_forest" );
  
end;
--*********************************************************************************************************************
function private.zz_stump.StartConditions()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_stump" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_stump" ].state = { {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1}, 1, 0, 0 };
  
end;
-----------------------------------------------------------------------------------
function public.zz_stump.Reset()
  
  local tme = 0;
  
  for i = 1, #private.zz_stump.state[1], 1 do
    
    if private.zz_stump.state[1][i] ~= 1 then
      
      if tme == 0 then
        tme = 0.3;
      end;
      
      ObjAnimate("spr_stump_thorn_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
  end;
  
  if private.zz_stump.state[2] > 1 then
    
    tme = 0.6;
    
    local func_after = function ()
      
      ObjSet("spr_stump_game_glove",  { pos_x = private.zz_stump.glove_pos[1][1], pos_y = private.zz_stump.glove_pos[1][2], ang = 0 });
      ObjAnimate("spr_stump_game_glove", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    ObjAnimate("spr_stump_game_glove", "alp", 0, 0, func_after, { 0, 0, 1,   0.3, 0, 0 });
    
  end;
  
  if tme > 0 then
    
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_barbed_leaves_reset");
    
    private.zz_stump.StartConditions();
    private.zz_stump.state = ng_global.progress[ ng_global.currentprogress ][ "win_stump" ].state;
    
    ObjSet("tmr_stump_timer",  { time = tme, playing = 1, endtrig = function() cmn.Lock(0); private.zz_stump.CheckInput(); end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_stump.Skip()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_barbed_leaves_skip");
  
  ng_global.progress[ ng_global.currentprogress ][ "win_stump" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_stump" ].state = { {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 1, 0, 0 };
  
  for i = 1, #private.zz_stump.state[1], 1 do
    
    if private.zz_stump.state[1][i] ~= 0 then
      
      ObjAnimate("spr_stump_thorn_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  end;
  
  private.zz_stump.state = ng_global.progress[ ng_global.currentprogress ][ "win_stump" ].state;
  ObjSet("tmr_stump_timer",  { time = 0.3, playing = 1, endtrig = private.zz_stump.CheckWin });
  
end;
-----------------------------------------------------------------------------------
function private.zz_stump.DrawScene()
  
  for i = 1, #private.zz_stump.state[1], 1 do
    
    if private.zz_stump.state[1][i] == 0 then
      ObjSet("spr_stump_thorn_"..i,  { alp = 0 });
    end;
    
  end;
  
  ObjSet("spr_stump_game_glove",  { 
    pos_x = private.zz_stump.glove_pos[ private.zz_stump.state[2] ][1], 
    pos_y = private.zz_stump.glove_pos[ private.zz_stump.state[2] ][2], 
    ang = private.zz_stump.state[4]
  });
  
  private.zz_stump.CheckInput();
  
end;
-----------------------------------------------------------------------------------
function public.zz_stump.FocusThorn( num, inout )
  
  if inout == 1 then
    SetCursor( CURSOR_HAND );
  else 
    SetCursor( CURSOR_DEFAULT );
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_stump.ClickThorn( num )
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_barbed_leaves_click");
  
  local old_pos = private.zz_stump.state[2];
    
  private.zz_stump.state[2] = num + 1;
  private.zz_stump.state[3] = private.zz_stump.state[3] + 1;
  
  local old_ang = private.zz_stump.state[4];
  private.zz_stump.state[4] = private.zz_stump.FindAngle( old_pos );
  
  local need_anm = false;
  
  if private.zz_stump.state[1][num] == 1 then
    
    need_anm = true;
    private.zz_stump.state[1][num] = 0;
    
  end;
  
  if private.zz_stump.state[3] == 3 then
    
    private.zz_stump.state[3] = 0;
    private.zz_stump.CheckInput();
    
    local thorn = math.random(1, #private.zz_stump.thornes_down);
    private.zz_stump.new_thorn = private.zz_stump.thornes_down[ thorn ];
    private.zz_stump.state[1][ private.zz_stump.new_thorn ] = 1;
    
  end;
  
  local anm_end = function ()
    
    if need_anm then
      ObjAnimate("spr_stump_thorn_"..num, "alp", 0, 0, private.zz_stump.CheckWin, { 0, 0, 1,   0.3, 0, 0 });
    else 
      private.zz_stump.CheckWin();
    end;
    
  end;
  
  local anm_glove = function ()
    
    local point_a, point_b = {}, {};
    point_a[1] = private.zz_stump.glove_pos[old_pos][1];
    point_a[2] = private.zz_stump.glove_pos[old_pos][2];
    point_b[1] = private.zz_stump.glove_pos[ private.zz_stump.state[2] ][1];
    point_b[2] = private.zz_stump.glove_pos[ private.zz_stump.state[2] ][2];
    local len = common_impl.math.FindSegmentLength( point_a, point_b );
    local tme = 0.004 * len;
    
    if tme < 0.1 then
      tme = 0.1;
    elseif tme > 0.5 then
      tme = 0.5;
    end;
    
    ObjAnimate("spr_stump_game_glove", "pos_xy", 0, 0, anm_end, { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] });
    
  end;
  
  if old_ang ~= private.zz_stump.state[4] then
    ObjAnimate("spr_stump_game_glove", "ang", 0, 0, anm_glove, { 0, 0, old_ang,   0.3, 0, private.zz_stump.state[4] });
  else 
    anm_glove();
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_stump.FindAngle( old_pos )
  
  local new_pos = private.zz_stump.state[2];
  local ind = 0;
  local ang = 0;
  
  if old_pos > 1 then
  
    for i = 1, #private.zz_stump.connect[old_pos-1], 1 do
      
      if private.zz_stump.connect[old_pos-1][i][1] == new_pos-1 then
        ind = i;
        break;
      end;
      
    end;
    
    if ind > 0 then
      ang = private.zz_stump.connect[old_pos-1][ind][2];
    end;
    
  end;
  
  return ang;
  
end;
-----------------------------------------------------------------------------------
function private.zz_stump.CheckInput()
  
  private.zz_stump.thornes_down = {};
  
  for i = 1, #private.zz_stump.state[1], 1 do
    
    if private.zz_stump.state[1][i] == 0 and private.zz_stump.state[2] ~= i+1 then
      table.insert( private.zz_stump.thornes_down, i );
    end;
    
    ObjSet("obj_stump_thorn_"..i,  { input = 0 });
    
  end;
  
  if private.zz_stump.state[2] == 1 then
    ObjSet("obj_stump_thorn_1",  { input = 1 });
  else 
    
    local place = private.zz_stump.state[2]-1;
    
    for i = 1, #private.zz_stump.connect[place], 1 do
      
      ObjSet("obj_stump_thorn_"..private.zz_stump.connect[place][i][1],  { input = 1 });
      
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_stump.RestoreThorn()
  
  if private.zz_stump.new_thorn > 0 then
    
    local num = private.zz_stump.new_thorn;
    private.zz_stump.new_thorn = 0;
    
    ObjAnimate("spr_stump_thorn_"..num, "alp", 0, 0, function() private.zz_stump.CheckInput(); cmn.Lock(0); end, { 0, 0, 0,   0.3, 0, 1 });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_stump.CheckWin()
  
  local win_flag = true;
  
  for i = 1, #private.zz_stump.state[1], 1 do
    
    if private.zz_stump.state[1][i] ~= 0 then
      win_flag = false;
      break;
    end;
    
  end;
  
  if private.zz_stump.new_thorn > 0 then
    
    private.zz_stump.RestoreThorn();
  
  elseif win_flag then
    
    cmn.Lock( 1 );
    
    --cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/");
    
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("stump");
    
    local anm_win = function ()
      
      ObjAnimate("obj_stump_layer_2", "alp", 0, 0, private.zz_stump.Win, { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("obj_stump_layer_3", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;
    
    cmn.Lock( 1 );

    ObjSet("tmr_stump_timer",  { time = 1, playing = 1, endtrig = anm_win });
    
  else
    private.zz_stump.CheckInput();
    cmn.Lock(0);
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_stump.Win()
  
  cmn.Lock( 0 );
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_stump" );
  cmn.CallEventHandler( "win_stump" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_stump" ].skip == 0 and ng_global.noskipgames[ "win_stump" ] == nil then

    ng_global.noskipgames[ "win_stump" ] = 1;
    common_impl.CheckAchiev("mg");

  end;
  
end;
--*******************************************************************************************************************