-- name=rm_inhouse
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_inhouse";
  --------------------------------------------------------------------------------------------
  private.dlg_lipsync = "";
  private.Init_Subroom();
  private.Init_Hearth();
  private.Init_Table();
  --------------------------------------------------------------------------------------------
  -- function get_toyfishingpole () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_toyfishingpole" ] = {
    type = "get",
    get_obj = "spr_lvl4firtree_toyfishingpole",
    room = private.room_objname,
    zz = "zz_lvl4firtree",
    zz_gate = "gzz_inhouse_lvl4firtree"
  };
  --------------------------------------------------------------------------------------------
  local get_toyfishingpole_inv = function ()
  
    interface.InventoryItemAdd( "inv_toyfishingpole", "spr_lvl4firtree_toyfishingpole" );
  
  end;
  local get_toyfishingpole_end = function ()
  
    ObjDelete( "gfx_lvl4firtree_toyfishingpole" );
    ObjDelete( "spr_lvl4firtree_toyfishingpole_sh" );

    ObjDelete( "spr_inhouse_lvl4firtree_toy_fishing" );
  
  end;
  
  cmn.AddSubscriber( "get_toyfishingpole", get_toyfishingpole_inv );
  cmn.AddSubscriber( "get_toyfishingpole", get_toyfishingpole_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ingredients1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_ingredients1" ] = {
    type = "get",
    get_obj = "obj_lvl4firtree_ingredients1",
    room = private.room_objname,
    zz = "zz_lvl4firtree",
    zz_gate = "gzz_inhouse_lvl4firtree"
  };
  --------------------------------------------------------------------------------------------
  local get_ingredients1_inv = function ()
  
    interface.InventoryItemAdd( "inv_ingredients1", "obj_lvl4firtree_ingredients1" );
  
  end;
  local get_ingredients1_end = function ()
  
    ObjDelete( "gfx_lvl4firtree_ingredients1" );
    ObjDelete( "spr_lvl4firtree_ingredients1_1_sh" );

    ObjDelete( "spr_inhouse_lvl4firtree_lump" );
  
  end;
  
  cmn.AddSubscriber( "get_ingredients1", get_ingredients1_inv );
  cmn.AddSubscriber( "get_ingredients1", get_ingredients1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_soldierpart () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_soldierpart" ] = {
    type = "get",
    get_obj = "spr_lvl4firtree_soldierpart",
    room = private.room_objname,
    zz = "zz_lvl4firtree",
    zz_gate = "gzz_inhouse_lvl4firtree"
  };
  --------------------------------------------------------------------------------------------
  local get_soldierpart_inv = function ()
  
    interface.InventoryItemAdd( "inv_soldierpart", "spr_lvl4firtree_soldierpart" );
    ObjSet("inv_soldier_star_light",  { alp = 1 });
  
  end;
  local get_soldierpart_end = function ()
  
    ObjDelete( "gfx_lvl4firtree_soldierpart" );
    ObjDelete( "spr_lvl4firtree_soldierpart_sh" );
    ObjDelete( "spr_lvl4firtree_soldierpart_sh_2" );
    ObjDelete( "spr_lvl4firtree_soldierpart_sh_3" );
    
    ObjSet("spr_lvl4firtree_deer2",  { input = 1 });
    
    if cmn.IsEventDone("get_deer2") then
      ObjDelete( "gzz_inhouse_lvl4firtree" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_soldierpart", get_soldierpart_inv );
  cmn.AddSubscriber( "get_soldierpart", get_soldierpart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_deer2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_deer2" ] = {
    type = "get",
    get_obj = "spr_lvl4firtree_deer2",
    room = private.room_objname,
    zz = "zz_lvl4firtree",
    zz_gate = "gzz_inhouse_lvl4firtree"
  };
  --------------------------------------------------------------------------------------------
  local get_deer2_inv = function ()
  
    interface.InventoryItemAdd( "inv_deer2", "spr_lvl4firtree_deer2" );
  
  end;
  local get_deer2_end = function ()
  
    ObjDelete( "gfx_lvl4firtree_deer2" );
    ObjDelete( "spr_lvl4firtree_deer2_sh" );
    
    if cmn.IsEventDone("get_soldierpart") then
      ObjDelete( "gzz_inhouse_lvl4firtree" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_deer2", get_deer2_inv );
  cmn.AddSubscriber( "get_deer2", get_deer2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ruby () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_ruby" ] = {
    type = "get",
    get_obj = "spr_hearth_ruby",
    room = private.room_objname,
    zz = "zz_hearth",
    zz_gate = "gzz_inhouse_hearth"
  };
  --------------------------------------------------------------------------------------------
  local get_ruby_inv = function ()
  
    interface.InventoryItemAdd( "inv_ruby", "spr_hearth_ruby" );
    ObjSet("inv_egg_star_light",  { alp = 1 });
  
  end;
  local get_ruby_end = function ()
  
    ObjDelete( "gfx_hearth_ruby" );
    ObjDelete( "spr_hearth_ruby_sh" );

    ObjDelete( "spr_inhouse_hearth_ruby" );
  
  end;
  
  cmn.AddSubscriber( "get_ruby", get_ruby_inv );
  cmn.AddSubscriber( "get_ruby", get_ruby_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cellarkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_cellarkey" ] = {
    type = "get",
    get_obj = "spr_hearth_cellarkey",
    room = private.room_objname,
    zz = "zz_hearth",
    zz_gate = "gzz_inhouse_hearth"
  };
  --------------------------------------------------------------------------------------------
  local get_cellarkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_cellarkey", "spr_hearth_cellarkey" );
  
  end;
  local get_cellarkey_end = function ()
  
    ObjDelete( "gfx_hearth_cellarkey" );
    ObjDelete( "spr_hearth_cellarkey_sh" );

    ObjDelete( "spr_inhouse_hearth_key" );
  
  end;
  
  cmn.AddSubscriber( "get_cellarkey", get_cellarkey_inv );
  cmn.AddSubscriber( "get_cellarkey", get_cellarkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_giftamulet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_giftamulet" ] = {
    type = "get",
    get_obj = "spr_hearth_giftamulet",
    room = private.room_objname,
    zz = "zz_hearth",
    zz_gate = "gzz_inhouse_hearth"
  };
  --------------------------------------------------------------------------------------------
  local get_giftamulet_inv = function ()
  
    interface.InventoryItemAdd( "inv_giftamulet", "spr_hearth_giftamulet" );
  
  end;
  local get_giftamulet_end = function ()
  
    ObjDelete( "gfx_hearth_giftamulet" );

    ObjDelete( "spr_inhouse_hearth_amulet_gift" );
    
    if cmn.IsEventDone("get_windupkey") then
      ObjDelete( "gzz_inhouse_hearth" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_giftamulet", get_giftamulet_inv );
  cmn.AddSubscriber( "get_giftamulet", get_giftamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_windupkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_windupkey" ] = {
    type = "get",
    get_obj = "spr_hearth_windupkey",
    room = private.room_objname,
    zz = "zz_hearth",
    zz_gate = "gzz_inhouse_hearth"
  };
  --------------------------------------------------------------------------------------------
  local get_windupkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_windupkey", "spr_hearth_windupkey" );
  
  end;
  local get_windupkey_end = function ()
  
    ObjDelete( "gfx_hearth_windupkey" );
    ObjDelete( "spr_hearth_windupkey_sh" );

    ObjDelete( "spr_inhouse_hearth_windupkey" );
    
    if cmn.IsEventDone("get_giftamulet") then
      ObjDelete( "gzz_inhouse_hearth" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_windupkey", get_windupkey_inv );
  cmn.AddSubscriber( "get_windupkey", get_windupkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_scissors () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_scissors" ] = {
    type = "get",
    get_obj = "spr_table_scissors",
    room = private.room_objname,
    zz = "zz_table",
    zz_gate = "gzz_inhouse_table"
  };
  --------------------------------------------------------------------------------------------
  local get_scissors_inv = function ()
  
    interface.InventoryItemAdd( "inv_scissors", "spr_table_scissors" );
  
  end;
  local get_scissors_end = function ()
  
    ObjDelete( "gfx_table_scissors" );
    ObjDelete( "spr_table_scissors_sh" );

    ObjDelete( "spr_inhouse_table_scissors" );
  
  end;
  
  cmn.AddSubscriber( "get_scissors", get_scissors_inv );
  cmn.AddSubscriber( "get_scissors", get_scissors_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_musicnote2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_musicnote2" ] = {
    type = "get",
    get_obj = "spr_table_musicnote2",
    room = private.room_objname,
    zz = "zz_table",
    zz_gate = "gzz_inhouse_table"
  };
  --------------------------------------------------------------------------------------------
  local get_musicnote2_inv = function ()
  
    interface.InventoryItemAdd( "inv_musicnote2", "spr_table_musicnote2" );
  
  end;
  local get_musicnote2_end = function ()
  
    ObjDelete( "gfx_table_musicnote2" );
    ObjDelete( "spr_table_musicnote2_sh" );

    ObjDelete( "spr_inhouse_table_note" );
  
  end;
  
  cmn.AddSubscriber( "get_musicnote2", get_musicnote2_inv );
  cmn.AddSubscriber( "get_musicnote2", get_musicnote2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_heartpart4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_heartpart4" ] = {
    type = "get",
    get_obj = "spr_table_heartpart4",
    room = private.room_objname,
    zz = "zz_table",
    zz_gate = "gzz_inhouse_table"
  };
  --------------------------------------------------------------------------------------------
  local get_heartpart4_inv = function ()
  
    interface.InventoryItemAdd( "inv_heartpart4", "spr_table_heartpart4" );
    int_map_impl.DecreaseRoomTasks("rm_inhouse");
  
  end;
  local get_heartpart4_end = function ()
  
    ObjDelete( "gfx_table_heartpart4" );
    --ObjDelete( "gzz_inhouse_table" );
    ObjSet("gzz_inhouse_table",  { active = 0, visible = 0 });

    ObjDelete( "spr_inhouse_table_heart_part" );
  
  end;
  
  cmn.AddSubscriber( "get_heartpart4", get_heartpart4_inv );
  cmn.AddSubscriber( "get_heartpart4", get_heartpart4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fireamulet3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_fireamulet3" ] = {
    type = "get",
    get_obj = "spr_tvset_fireamulet3",
    room = private.room_objname,
    zz = "zz_tvset",
    zz_gate = "gzz_inhouse_tvset"
  };
  --------------------------------------------------------------------------------------------
  local get_fireamulet3_inv = function ()
  
    interface.InventoryItemAdd( "inv_fireamulet3", "spr_tvset_fireamulet3" );
  
  end;
  local get_fireamulet3_end = function ()
  
    ObjDelete( "gfx_tvset_fireamulet3" );
    ObjDelete( "spr_tvset_fireamulet3_sh" );

    ObjDelete( "spr_inhouse_tvset_fire_amulet_3" );
  
  end;
  
  cmn.AddSubscriber( "get_fireamulet3", get_fireamulet3_inv );
  cmn.AddSubscriber( "get_fireamulet3", get_fireamulet3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fuse2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_fuse2" ] = {
    type = "get",
    get_obj = "spr_tvset_fuse2",
    room = private.room_objname,
    zz = "zz_tvset",
    zz_gate = "gzz_inhouse_tvset"
  };
  --------------------------------------------------------------------------------------------
  local get_fuse2_inv = function ()
  
    interface.InventoryItemAdd( "inv_fuse2", "spr_tvset_fuse2" );
  
  end;
  local get_fuse2_end = function ()
  
    ObjDelete( "gfx_tvset_fuse2" );
    ObjDelete( "anm_tvset_use_button" );
    ObjMultiSet( { {"anm_tvset_use_tape", { alp = 1 }},
                   {"anm_tvset_button_touch", { alp = 1 }},
                   {"spr_inhouse_tvset_door_close", { alp = 1 }} } );

    ObjDelete( "spr_inhouse_tvset_fuse" );
  
  end;
  
  cmn.AddSubscriber( "get_fuse2", get_fuse2_inv );
  cmn.AddSubscriber( "get_fuse2", get_fuse2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_letter6 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_letter6" ] = {
    type = "get",
    get_obj = "spr_inhouse_letter6",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_letter6_inv = function ()
  
    interface.InventoryItemAdd( "inv_letter", "spr_inhouse_letter6", function () cmn.GetMultyObject( 'letter', 9 ); end );
    int_map_impl.DecreaseRoomTasks("rm_inhouse");
  
  end;
  local get_letter6_end = function ()
  
    ObjDelete( "gfx_inhouse_letter6" );
    ObjDelete( "spr_inhouse_letter6_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_letter6", get_letter6_inv );
  cmn.AddSubscriber( "get_letter6", get_letter6_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_soldier () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_soldier" ] = {
      type = "get",
      get_obj = "spr_inhouse_soldier",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_soldier_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_soldier", "spr_inhouse_soldier" );
  
  end;
  local get_soldier_mid = function ()
  
    ObjDelete( "gfx_inhouse_soldier" );
    ObjDelete( "spr_inhouse_soldier_sh" );
    
  end;
  local get_soldier_end = function ()
  
    ObjDelete( "obj_inhouse_dialog_victor1" );
    ObjDelete( "anm_inhouse_victor_out" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_soldier", get_soldier_inv );
  cmn.AddSubscriber( "get_soldier_inv", get_soldier_inv, private.room_objname );
  cmn.AddSubscriber( "get_soldier", get_soldier_mid, private.room_objname );
  cmn.AddSubscriber( "get_soldier_mid", get_soldier_mid, private.room_objname );
  cmn.AddSubscriber( "get_soldier", get_soldier_end, private.room_objname );
  cmn.AddSubscriber( "get_soldier_end", get_soldier_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_scissors () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_scissors" ] = {
    type = "use",
    inv_obj = "inv_scissors",
    use_place = "obj_lvl4firtree_use_scissors",
    room = private.room_objname,
    zz = "zz_lvl4firtree",
    zz_gate = "gzz_inhouse_lvl4firtree"
  };
  --------------------------------------------------------------------------------------------
  local use_scissors_inv = function ()
  
    interface.InventoryItemRemove( "inv_scissors" );
  
  end;
  local use_scissors_beg = function ()
  
    ObjDelete( "obj_lvl4firtree_use_scissors" );
    ObjDelete("anm_lvl4firtree_gift_1_touch");
    ObjSet( "obj_lvl4firtree_gift_1", { alp = 1 } );
  
  end;
  local use_scissors_end = function ()
    
    ObjDelete("anm_lvl4firtree_use_scissors");
    ObjDelete("anm_lvl4firtree_gift_1_open");

    ObjDelete( "spr_inhouse_lvl4firtree_gift_cover_close_1" );
  
    ObjSet( "obj_lvl4firtree_gift_1", { input = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scissors", use_scissors_beg, private.room_objname );
  cmn.AddSubscriber( "use_scissors", use_scissors_inv );
  cmn.AddSubscriber( "use_scissors", use_scissors_end, private.room_objname );
  cmn.AddSubscriber( "use_scissors_inv", use_scissors_inv, private.room_objname );
  cmn.AddSubscriber( "use_scissors_beg", use_scissors_beg, private.room_objname );
  cmn.AddSubscriber( "use_scissors_end", use_scissors_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_giftamulet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_giftamulet" ] = {
    type = "use",
    inv_obj = "inv_giftamulet",
    use_place = "obj_lvl4firtree_use_giftamulet",
    room = private.room_objname,
    zz = "zz_lvl4firtree",
    zz_gate = "gzz_inhouse_lvl4firtree"
  };
  --------------------------------------------------------------------------------------------
  local use_giftamulet_inv = function ()
  
    interface.InventoryItemRemove( "inv_giftamulet" );
  
  end;
  local use_giftamulet_beg = function ()
  
    ObjDelete( "obj_lvl4firtree_use_giftamulet" );
    ObjSet( "obj_lvl4firtree_gift_2", { alp = 1 } );
  
  end;
  local use_giftamulet_end = function ()
    
    ObjDelete("anm_lvl4firtree_gift_2_touch");
    ObjDelete("anm_lvl4firtree_gift_2_open");

    ObjDelete( "spr_inhouse_lvl4firtree_gift_cover_close_2" );
  
    ObjSet( "obj_lvl4firtree_gift_2", { input = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_giftamulet", use_giftamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_giftamulet", use_giftamulet_inv );
  cmn.AddSubscriber( "use_giftamulet", use_giftamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_giftamulet_inv", use_giftamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_giftamulet_beg", use_giftamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_giftamulet_end", use_giftamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fireamulet1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_fireamulet1" ] = {
    type = "use",
    inv_obj = "inv_fireamulet1",
    use_place = "obj_hearth_use_fireamulet1",
    room = private.room_objname,
    zz = "zz_hearth",
    zz_gate = "gzz_inhouse_hearth"
  };
  --------------------------------------------------------------------------------------------
  local use_fireamulet1_inv = function ()
  
    interface.InventoryItemRemove( "inv_fireamulet1" );
  
  end;
  local use_fireamulet1_beg = function ()
  
    ObjDelete( "obj_hearth_use_fireamulet1" );
  
  end;
  local use_fireamulet1_end = function ()
    
    ObjMultiSet( {
      { "obj_hearth_amulet_2", { alp = 1 } },
      { "spr_inhouse_hearth_stone_3", { alp = 1 } }
    } );
  
    if cmn.IsEventDone("use_fireamulet3") and cmn.IsEventDone("use_fireamulet2") then
      ObjSet( "obj_hearth_game", { input = 1 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fireamulet1", use_fireamulet1_beg, private.room_objname );
  cmn.AddSubscriber( "use_fireamulet1", use_fireamulet1_inv );
  cmn.AddSubscriber( "use_fireamulet1", use_fireamulet1_end, private.room_objname );
  cmn.AddSubscriber( "use_fireamulet1_inv", use_fireamulet1_inv, private.room_objname );
  cmn.AddSubscriber( "use_fireamulet1_beg", use_fireamulet1_beg, private.room_objname );
  cmn.AddSubscriber( "use_fireamulet1_end", use_fireamulet1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fireamulet2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_fireamulet2" ] = {
    type = "use",
    inv_obj = "inv_fireamulet2",
    use_place = "obj_hearth_use_fireamulet2",
    room = private.room_objname,
    zz = "zz_hearth",
    zz_gate = "gzz_inhouse_hearth"
  };
  --------------------------------------------------------------------------------------------
  local use_fireamulet2_inv = function ()
  
    interface.InventoryItemRemove( "inv_fireamulet2" );
  
  end;
  local use_fireamulet2_beg = function ()
  
    ObjDelete( "obj_hearth_use_fireamulet2" );
  
  end;
  local use_fireamulet2_end = function ()
    
    ObjMultiSet( {
      { "obj_hearth_amulet_6", { alp = 1 } },
      { "spr_inhouse_hearth_stone_1", { alp = 1 } }
    } );
  
    if cmn.IsEventDone("use_fireamulet1") and cmn.IsEventDone("use_fireamulet3") then
      ObjSet( "obj_hearth_game", { input = 1 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fireamulet2", use_fireamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_fireamulet2", use_fireamulet2_inv );
  cmn.AddSubscriber( "use_fireamulet2", use_fireamulet2_end, private.room_objname );
  cmn.AddSubscriber( "use_fireamulet2_inv", use_fireamulet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_fireamulet2_beg", use_fireamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_fireamulet2_end", use_fireamulet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fireamulet3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_fireamulet3" ] = {
    type = "use",
    inv_obj = "inv_fireamulet3",
    use_place = "obj_hearth_use_fireamulet3",
    room = private.room_objname,
    zz = "zz_hearth",
    zz_gate = "gzz_inhouse_hearth"
  };
  --------------------------------------------------------------------------------------------
  local use_fireamulet3_inv = function ()
  
    interface.InventoryItemRemove( "inv_fireamulet3" );
  
  end;
  local use_fireamulet3_beg = function ()
  
    ObjDelete( "obj_hearth_use_fireamulet3" );
  
  end;
  local use_fireamulet3_end = function ()
    
    ObjMultiSet( {
      { "obj_hearth_amulet_7", { alp = 1 } },
      { "spr_inhouse_hearth_stone_2", { alp = 1 } }
    } );
  
    if cmn.IsEventDone("use_fireamulet1") and cmn.IsEventDone("use_fireamulet2") then
      ObjSet( "obj_hearth_game", { input = 1 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fireamulet3", use_fireamulet3_beg, private.room_objname );
  cmn.AddSubscriber( "use_fireamulet3", use_fireamulet3_inv );
  cmn.AddSubscriber( "use_fireamulet3", use_fireamulet3_end, private.room_objname );
  cmn.AddSubscriber( "use_fireamulet3_inv", use_fireamulet3_inv, private.room_objname );
  cmn.AddSubscriber( "use_fireamulet3_beg", use_fireamulet3_beg, private.room_objname );
  cmn.AddSubscriber( "use_fireamulet3_end", use_fireamulet3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hearthamulet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_hearthamulet" ] = {
    type = "use",
    inv_obj = "inv_hearthamulet",
    use_place = "obj_hearth_use_hearthamulet",
    room = private.room_objname,
    zz = "zz_hearth",
    zz_gate = "gzz_inhouse_hearth"
  };
  --------------------------------------------------------------------------------------------
  local use_hearthamulet_inv = function ()
  
    interface.InventoryItemRemove( "inv_hearthamulet" );
  
  end;
  local use_hearthamulet_beg = function ()
  
    ObjDelete( "obj_hearth_use_hearthamulet" );
    ObjDelete( "anm_hearth_safe_touch" );
    ObjSet("obj_hearth_safe",  { alp = 1 });
  
  end;
  local use_hearthamulet_end = function ()

    ObjDelete( "spr_inhouse_hearth_safe_door_close" );
  
    ObjMultiSet( { {"obj_hearth_safe", { input = 1 }},
                   {"anm_hearth_safe_open", { alp = 1, frame = 300 }},
                   {"spr_inhouse_hearth_safe_door_open", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hearthamulet", use_hearthamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_hearthamulet", use_hearthamulet_inv );
  cmn.AddSubscriber( "use_hearthamulet", use_hearthamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_hearthamulet_inv", use_hearthamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_hearthamulet_beg", use_hearthamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_hearthamulet_end", use_hearthamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_snowflake () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_snowflake" ] = {
    type = "use",
    inv_obj = "inv_snowflake",
    use_place = "obj_table_use_snowflake",
    room = private.room_objname,
    zz = "zz_table",
    zz_gate = "gzz_inhouse_table"
  };
  --------------------------------------------------------------------------------------------
  local use_snowflake_inv = function ()
  
    interface.InventoryItemRemove( "inv_snowflake" );
  
  end;
  local use_snowflake_beg = function ()
  
    ObjDelete( "obj_table_use_snowflake" );
  
  end;
  local use_snowflake_end = function ()
    
    ObjDelete( "anm_table_globe_touch" );

    ObjDelete( "spr_inhouse_table_glass_ball_cover_close" );
  
    ObjMultiSet( { {"spr_table_globe_open", { alp = 1 }},
                   {"anm_table_use_snowflake", { alp = 1, frame = 300 }},
                   {"spr_table_heartpart4", { input = 1 }},
                   {"spr_inhouse_table_snowflake", { alp = 1 }},
                   {"spr_inhouse_table_glass_ball_cover_open", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_snowflake", use_snowflake_beg, private.room_objname );
  cmn.AddSubscriber( "use_snowflake", use_snowflake_inv );
  cmn.AddSubscriber( "use_snowflake", use_snowflake_end, private.room_objname );
  cmn.AddSubscriber( "use_snowflake_inv", use_snowflake_inv, private.room_objname );
  cmn.AddSubscriber( "use_snowflake_beg", use_snowflake_beg, private.room_objname );
  cmn.AddSubscriber( "use_snowflake_end", use_snowflake_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_developer () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_developer" ] = {
    type = "use",
    inv_obj = "inv_developer",
    use_place = "obj_table_use_developer",
    room = private.room_objname,
    zz = "zz_table",
    zz_gate = "gzz_inhouse_table"
  };
  --------------------------------------------------------------------------------------------
  local use_developer_inv = function ()
  
    interface.InventoryItemRemove( "inv_developer" );
  
  end;
  local use_developer_beg = function ()
  
    ObjDelete( "obj_table_use_developer" );
    ObjDelete( "obj_table_box_touch" );
  
  end;
  local use_developer_end = function ()
  
    ObjMultiSet( { {"anm_table_use_developer", { frame = 300, alp = 1, pos_z = 4 }},
                   {"obj_table_game", { input = 1 }},
                   {"spr_inhouse_table_nomber", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_developer", use_developer_beg, private.room_objname );
  cmn.AddSubscriber( "use_developer", use_developer_inv );
  cmn.AddSubscriber( "use_developer", use_developer_end, private.room_objname );
  cmn.AddSubscriber( "use_developer_inv", use_developer_inv, private.room_objname );
  cmn.AddSubscriber( "use_developer_beg", use_developer_beg, private.room_objname );
  cmn.AddSubscriber( "use_developer_end", use_developer_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl4button () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl4button" ] = {
    type = "use",
    inv_obj = "inv_lvl4button",
    use_place = "obj_tvset_use_lvl4button",
    room = private.room_objname,
    zz = "zz_tvset",
    zz_gate = "gzz_inhouse_tvset"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl4button_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl4button" );
  
  end;
  local use_lvl4button_beg = function ()
  
    ObjDelete( "obj_tvset_use_lvl4button" );
    ObjDelete( "anm_tvset_fuse_touch" );
  
  end;
  local use_lvl4button_end = function ()
  
    ObjMultiSet( {
      { "obj_tvset_use_vhstape", { input = 1 } },
      { "spr_inhouse_tvset_button", { alp = 1 } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl4button", use_lvl4button_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4button", use_lvl4button_inv );
  cmn.AddSubscriber( "use_lvl4button", use_lvl4button_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl4button_inv", use_lvl4button_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl4button_beg", use_lvl4button_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4button_end", use_lvl4button_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_vhstape () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_vhstape" ] = {
    type = "use",
    inv_obj = "inv_vhstape",
    use_place = "obj_tvset_use_vhstape",
    room = private.room_objname,
    zz = "zz_tvset",
    zz_gate = "gzz_inhouse_tvset"
  };
  --------------------------------------------------------------------------------------------
  local use_vhstape_inv = function ()
  
    interface.InventoryItemRemove( "inv_vhstape" );
  
  end;
  local use_vhstape_beg = function ()
  
    ObjDelete( "obj_tvset_use_vhstape" );
    ObjDelete( "anm_tvset_button_touch" );
  
  end;
  local use_vhstape_end = function ()
  
    ObjDelete( "gzz_inhouse_tvset" );
    ObjDelete( "anm_inhouse_tvset_1" );

    ObjMultiSet( { {"gho_inhouse_ontvset", { input = 1, alp = 1, active = 1 }},
                   {"anm_inhouse_tvset_2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_vhstape", use_vhstape_beg, private.room_objname );
  cmn.AddSubscriber( "use_vhstape", use_vhstape_inv );
  cmn.AddSubscriber( "use_vhstape", use_vhstape_end, private.room_objname );
  cmn.AddSubscriber( "use_vhstape_inv", use_vhstape_inv, private.room_objname );
  cmn.AddSubscriber( "use_vhstape_beg", use_vhstape_beg, private.room_objname );
  cmn.AddSubscriber( "use_vhstape_end", use_vhstape_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_inhousefirst () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_inhousefirst" ] = {
    type = "click",
    use_place = "obj_inhouse_clk_inhousefirst",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local clk_inhousefirst_task = function ()
    
  end;
  local clk_inhousefirst_beg = function ()
  
    ObjDelete( "obj_inhouse_clk_inhousefirst" );
  
  end;
  local clk_inhousefirst_end = function ()
    
    ObjDelete( "anm_inhouse_victor" );
    ObjDelete( "anm_inhouse_dialog_victor1_hand_give" );
    
    ObjDelete( "vid_inhouse_dialog_victor1_lipsync1" );
    ObjDelete( "vid_inhouse_dialog_victor1_lipsync2" );
    ObjDelete( "vid_inhouse_dialog_victor1_lipsync3" );
    
    ObjAttach("obj_inhouse_dialog_victor1", "rm_inhouse");
    
    ObjMultiSet( { {"obj_inhouse_dialog_victor1", { alp = 1, input = 1 }},
                   {"obj_inhouse_dialog_victor1_hand_2", { alp = 1, input = 1 }},
                   {"anm_inhouse_victor_out", { alp = 1 }},
                   {"obj_inhouse_dialog_victor1_head", { alp = 1 }} } );

    ObjMultiSet( {
      { "gzz_inhouse_lvl4firtree", { event_mdown = "cmn.GotoSubRoomMDown( 'inhouse_lvl4firtree' );", event_mup = "cmn.GotoSubRoomMUp( 'inhouse_lvl4firtree', 'zz_lvl4firtree' );" } },
      { "gzz_inhouse_hearth", { event_mdown = "cmn.GotoSubRoomMDown( 'inhouse_hearth' );", event_mup = "cmn.GotoSubRoomMUp( 'inhouse_hearth', 'zz_hearth' );" } },
      { "gzz_inhouse_table", { event_mdown = "cmn.GotoSubRoomMDown( 'inhouse_table' );", event_mup = "cmn.GotoSubRoomMUp( 'inhouse_table', 'zz_table', false, true );" } },
      { "gzz_inhouse_tvset", { event_mdown = "cmn.GotoSubRoomMDown( 'inhouse_tvset' );", event_mup = "cmn.GotoSubRoomMUp( 'inhouse_tvset', 'zz_tvset' );" } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_inhousefirst", clk_inhousefirst_beg, private.room_objname );
  cmn.AddSubscriber( "clk_inhousefirst", clk_inhousefirst_end, private.room_objname );
  cmn.AddSubscriber( "clk_inhousefirst_beg", clk_inhousefirst_beg, private.room_objname );
  cmn.AddSubscriber( "clk_inhousefirst_end", clk_inhousefirst_end, private.room_objname );
  cmn.AddSubscriber( "clk_inhousefirst_task", clk_inhousefirst_task );
  cmn.AddSubscriber( "clk_inhousefirst", clk_inhousefirst_task );
  
  --------------------------------------------------------------------------------------------
  -- function opn_inhouse () end;
  --------------------------------------------------------------------------------------------
  local opn_inhouse = function ()
  
    int_map_impl.OpenRoom( "rm_inhouse" );
    interface_impl.SetCurrentGlobalTask( 23 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_inhouse", opn_inhouse );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_hearth" );
  subroom.Define( "zz_table" );
  
  function zz_hearth.PreOpen()
    
    if not(cmn.IsEventDone( "win_hearth" )) then
      private.zz_hearth.DrawScene();
      if private.zz_hearth.state[9] == 1 then
        cmn.Lock(1);
      end;
    end;

  end;
  
  function zz_hearth.Open()
    
    if cmn.IsEventDone( "use_fireamulet1" ) and cmn.IsEventDone("use_fireamulet2") and cmn.IsEventDone("use_fireamulet3") and not(cmn.IsEventDone( "win_hearth" )) then
      cmn.MiniGameShow();
      if private.zz_hearth.state[9] == 1 then
        public.zz_hearth.ClickPlay();
      end;
    end;

  end;
  
  function zz_hearth.PreClose()
    
    if cmn.IsEventDone( "use_fireamulet1" ) and cmn.IsEventDone("use_fireamulet2") and cmn.IsEventDone("use_fireamulet3") and not cmn.IsEventDone("win_hearth") then
      cmn.MiniGameHide("hearth");
    end;
    
  end;
  
  function zz_table.PreOpen()
    
    if not(cmn.IsEventDone( "win_table" )) then
      private.zz_table.DrawScene();
    end;

  end;
  
  function zz_table.Open()
    
    if not(cmn.IsEventDone( "win_table" )) then
      private.zz_table.CheckWin();
    end;

  end;
  
  function zz_table.Close()
    cmn.HideNote( 0 );
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_hearth" ].state) then 
    private.zz_hearth.StartConditions();
  end;
  
  private.zz_hearth.state = ng_global.progress[ ng_global.currentprogress ][ "win_hearth" ].state;
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_table" ].state) then 
    private.zz_table.StartConditions();
  end;
  
  private.zz_table.state = ng_global.progress[ ng_global.currentprogress ][ "win_table" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_inhouse();
  
  if cmn.IsEventDone("clk_inhousefirst") and not cmn.IsEventDone("get_soldier") then
    --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    common_impl.current_dialog = "obj_inhouse_dialog_victor1";
    ObjSet("anm_inhouse_dialog_victor1_hand_2",  { playing = 1 });
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level4/audio/env/aud_rm_inhouse_env");
  cmn.PlayAudio("env", "assets/levels/level4/audio/env/aud_rm_inhouse_env");
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_scissors()

  local item = "inv_scissors";

  if cmn.ApplyObj( item, "gzz_inhouse_lvl4firtree" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_lvl4firtree" );

  elseif ( cmn.ApplyObj( item, "obj_lvl4firtree_use_scissors" ) ) then

    cmn.CallEventHandler( "use_scissors_inv" );
    cmn.CallEventHandler( "use_scissors_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_scissors" );
      cmn.CallEventHandler( "use_scissors_end" );
    
    end;
    
    local anm_open = function ()
      
      ObjDelete("anm_lvl4firtree_use_scissors");
      ObjSet("anm_lvl4firtree_gift_1_open",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_zz_lvl4firtree_cut_left");

    ObjSet("anm_lvl4firtree_use_scissors",  { alp = 1, playing = 1, endtrig = anm_open });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_giftamulet()

  local item = "inv_giftamulet";

  if cmn.ApplyObj( item, "gzz_inhouse_lvl4firtree" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_lvl4firtree" );

  elseif ( cmn.ApplyObj( item, "obj_lvl4firtree_use_giftamulet" ) ) then

    cmn.CallEventHandler( "use_giftamulet_inv" );
    cmn.CallEventHandler( "use_giftamulet_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_giftamulet" );
      cmn.CallEventHandler( "use_giftamulet_end" );
    
    end;
    
    local anm_open = function ()
      
      ObjDelete("anm_lvl4firtree_gift_2_touch");
      ObjSet("anm_lvl4firtree_gift_2_open",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_zz_lvl4firtree_opens");

    ObjSet("anm_lvl4firtree_gift_2_touch",  { frame = 0, animfunc = "anm_amulet_gift", playing = 1, endtrig = anm_open });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_fireamulet1()

  local item = "inv_fireamulet1";

  if cmn.ApplyObj( item, "gzz_inhouse_hearth" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_hearth" );

  elseif ( cmn.ApplyObj( item, "obj_hearth_use_fireamulet1" ) ) then

    cmn.CallEventHandler( "use_fireamulet1_inv" );
    cmn.CallEventHandler( "use_fireamulet1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_fireamulet1" );
      cmn.CallEventHandler( "use_fireamulet1_end" );
      
      if cmn.IsEventDone("use_fireamulet2") and cmn.IsEventDone("use_fireamulet3") then
        cmn.MiniGameShow();
      end;
    
    end;
    
    if cmn.IsEventDone("use_fireamulet2") and cmn.IsEventDone("use_fireamulet3") and not cmn.IsEventDone("get_ruby") then
      public.get_ruby();
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_zz_hearth_stuff_for_mmg");
    
    ObjAnimate( "obj_hearth_amulet_2", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_fireamulet2()

  local item = "inv_fireamulet2";

  if cmn.ApplyObj( item, "gzz_inhouse_hearth" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_hearth" );

  elseif ( cmn.ApplyObj( item, "obj_hearth_use_fireamulet2" ) ) then

    cmn.CallEventHandler( "use_fireamulet2_inv" );
    cmn.CallEventHandler( "use_fireamulet2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_fireamulet2" );
      cmn.CallEventHandler( "use_fireamulet2_end" );
      
      if cmn.IsEventDone("use_fireamulet1") and cmn.IsEventDone("use_fireamulet3") then
        cmn.MiniGameShow();
      end;
    
    end;
    
    if cmn.IsEventDone("use_fireamulet1") and cmn.IsEventDone("use_fireamulet3") and not cmn.IsEventDone("get_ruby") then
      public.get_ruby();
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_zz_hearth_stuff_for_mmg");
    
    ObjAnimate( "obj_hearth_amulet_6", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_fireamulet3()

  local item = "inv_fireamulet3";

  if cmn.ApplyObj( item, "gzz_inhouse_hearth" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_hearth" );

  elseif ( cmn.ApplyObj( item, "obj_hearth_use_fireamulet3" ) ) then

    cmn.CallEventHandler( "use_fireamulet3_inv" );
    cmn.CallEventHandler( "use_fireamulet3_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_fireamulet3" );
      cmn.CallEventHandler( "use_fireamulet3_end" );
      
      if cmn.IsEventDone("use_fireamulet1") and cmn.IsEventDone("use_fireamulet2") then
        cmn.MiniGameShow();
      end;
    
    end;
    
    if cmn.IsEventDone("use_fireamulet1") and cmn.IsEventDone("use_fireamulet2") and not cmn.IsEventDone("get_ruby") then
      public.get_ruby();
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_zz_hearth_stuff_for_mmg");
    
    ObjAnimate( "obj_hearth_amulet_7", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_hearthamulet()

  local item = "inv_hearthamulet";

  if cmn.ApplyObj( item, "gzz_inhouse_hearth" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_hearth" );

  elseif ( cmn.ApplyObj( item, "obj_hearth_use_hearthamulet" ) ) then

    cmn.CallEventHandler( "use_hearthamulet_inv" );
    cmn.CallEventHandler( "use_hearthamulet_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_hearthamulet" );
      cmn.CallEventHandler( "use_hearthamulet_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_fireplace_stuff");

    ObjSet("anm_hearth_safe_open",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_snowflake()

  local item = "inv_snowflake";

  if cmn.ApplyObj( item, "gzz_inhouse_table" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_table", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_table_use_snowflake" ) ) then

    cmn.CallEventHandler( "use_snowflake_inv" );
    cmn.CallEventHandler( "use_snowflake_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_snowflake" );
      cmn.CallEventHandler( "use_snowflake_end" );
    
    end;
    
    local anm_open = function ()
      
      ObjAnimate("spr_table_globe_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("anm_table_globe_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_snow_ball_opens");

    ObjSet("anm_table_use_snowflake",  { alp = 1, playing = 1, endtrig = anm_open });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_developer()

  local item = "inv_developer";

  if cmn.ApplyObj( item, "gzz_inhouse_table" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_table", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_table_use_developer" ) ) then

    cmn.CallEventHandler( "use_developer_inv" );
    cmn.CallEventHandler( "use_developer_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_developer" );
      cmn.CallEventHandler( "use_developer_end" );
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_zz_table_brush");

    ObjSet("anm_table_use_developer",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl4button()

  local item = "inv_lvl4button";

  if cmn.ApplyObj( item, "gzz_inhouse_tvset" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_tvset" );

  elseif ( cmn.ApplyObj( item, "obj_tvset_use_lvl4button" ) ) then

    cmn.CallEventHandler( "use_lvl4button_inv" );
    cmn.CallEventHandler( "use_lvl4button_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl4button" );
      cmn.CallEventHandler( "use_lvl4button_end" );
      
      public.get_fuse2();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_video_play");

    ObjSet("anm_tvset_use_button",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_vhstape()

  local item = "inv_vhstape";

  if cmn.ApplyObj( item, "gzz_inhouse_tvset" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_tvset" );

  elseif ( cmn.ApplyObj( item, "obj_tvset_use_vhstape" ) ) then

    cmn.CallEventHandler( "use_vhstape_inv" );
    cmn.CallEventHandler( "use_vhstape_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_vhstape" );
      cmn.CallEventHandler( "use_vhstape_end" );
      
      common.CloseSubRoom();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_tv_cassette");

    ObjSet("anm_tvset_use_tape",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_toyfishingpole()

  cmn.SetEventDone( "get_toyfishingpole" );
  cmn.CallEventHandler( "get_toyfishingpole" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_ingredients1()

  cmn.SetEventDone( "get_ingredients1" );
  cmn.CallEventHandler( "get_ingredients1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_soldierpart()

  cmn.SetEventDone( "get_soldierpart" );
  cmn.CallEventHandler( "get_soldierpart" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_deer2") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_deer2()

  cmn.SetEventDone( "get_deer2" );
  cmn.CallEventHandler( "get_deer2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_soldierpart") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_ruby()

  cmn.SetEventDone( "get_ruby" );
  cmn.CallEventHandler( "get_ruby" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_cellarkey()

  cmn.SetEventDone( "get_cellarkey" );
  cmn.CallEventHandler( "get_cellarkey" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_giftamulet()

  cmn.SetEventDone( "get_giftamulet" );
  cmn.CallEventHandler( "get_giftamulet" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_windupkey") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_windupkey()

  cmn.SetEventDone( "get_windupkey" );
  cmn.CallEventHandler( "get_windupkey" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_giftamulet") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_scissors()

  cmn.SetEventDone( "get_scissors" );
  cmn.CallEventHandler( "get_scissors" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_musicnote2()
  
  ObjSet("spr_table_musicnote2",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_musicnote2" );
  cmn.CallEventHandler( "get_musicnote2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_heartpart4()

  cmn.SetEventDone( "get_heartpart4" );
  cmn.CallEventHandler( "get_heartpart4" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_fireamulet3()

  cmn.SetEventDone( "get_fireamulet3" );
  cmn.CallEventHandler( "get_fireamulet3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_fuse2()

  cmn.SetEventDone( "get_fuse2" );
  cmn.CallEventHandler( "get_fuse2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_letter6()

  cmn.SetEventDone( "get_letter6" );
  cmn.CallEventHandler( "get_letter6" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_soldier()
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_soldier_end" );
    
    --common_impl.PlayBackgroundMusic();

  end;
  
  local anm_out = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_victor_diss");
    ObjSet("anm_inhouse_victor_out",  { playing = 1, endtrig = func_after_dlg });
    
  end;

  cmn.SetEventDone( "get_soldier" );
  cmn.CallEventHandler( "get_soldier_inv" );
  cmn.CallEventHandler( "get_soldier_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.current_dialog = "";
  
  cmn.Lock(1);
  ObjAnimate("obj_inhouse_dialog_victor1", "alp", 0, 0, anm_out, { 0, 0, 1,   0.5, 0, 0 });

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_inhousefirst()

  cmn.CallEventHandler( "clk_inhousefirst_beg" );
  cmn.SetEventDone( "clk_inhousefirst" );
    
  ObjAttach("obj_inhouse_dialog_victor1", "rm_inhouse");
  ObjAnimate("obj_inhouse_dialog_victor1", "alp", 0, 0, private.dialog_victor1_beg, { 0, 0, 0,   0.5, 0, 1 });

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_inhouse()

  if not ( cmn.IsEventDone( "opn_inhouse" ) ) then
    cmn.SetEventDone( "opn_inhouse" );
    cmn.CallEventHandler("opn_inhouse");
    cmn.ShowBbt( "inhouse_open" );
    cmn.PlayAudio("mus", "assets/levels/level4/audio/mus/aud_christmas_inhouse_first_appear_mus", 0, false, 51);
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_tree_gift_1()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_zz_lvl4firtree_left");

  cmn.ShowBbt( "obj_lvl4firtree_use_scissors" );
  
  ObjSet( "anm_lvl4firtree_gift_1_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_tree_gift_2()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_zz_lvl4firtree_right");

  cmn.ShowBbt( "obj_lvl4firtree_use_giftamulet" );
  
  ObjSet( "anm_lvl4firtree_gift_2_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_tree()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_zz_lvl4firtree_tree");

  cmn.ShowBbt( "obj_lvl4firtree_use_recipe" );
  
  ObjSet( "anm_lvl4firtree_tree_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_hearth_gate()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_zz_hearth_future");

  cmn.ShowBbt( "obj_hearth_use_fireamulet" );
  
  ObjAnimate("anm_hearth_ring_cover", "ang", 0, 0, "", { 0, 0, 0,   0.4, 0, 0.16,   0.8, 0, 0 });
  ObjAnimate("spr_hearth_button_play_focus", "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 0,   0.2, 0, 1,    0.4, 0, 0,     0.6, 0, 1,    0.8, 0, 0 });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_hearth_safe()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_zz_hearth_fireplace");

  cmn.ShowBbt( "obj_hearth_use_hearthamulet" );
  
  ObjSet( "anm_hearth_safe_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_table_globe()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_zz_table_ball");

  cmn.ShowBbt( "obj_table_use_snowflake" );
  
  ObjSet( "anm_table_globe_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_table_box()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_zz_table_box");

  cmn.ShowBbt( "obj_table_box_touch" );
  
  ObjSet( "anm_table_box_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_table_bird()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_zz_table_bird");

  --cmn.ShowBbt( "obj_table_bird_touch" );
  
  ObjSet( "anm_table_box_2", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_tv_fuse()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_video_stuff");

  cmn.ShowBbt( "obj_tvset_use_lvl4button" );
  
  ObjSet( "anm_tvset_fuse_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_tv_button()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_video_play");

  cmn.ShowBbt( "obj_tvset_use_vhstape" );
  
  ObjSet( "anm_tvset_button_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_victor1_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "inhouse", "victor1", 2 );
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "clk_inhousefirst_end" );
    cmn.CallEventHandler("clk_inhousefirst_task");

    cmn.ShowBbt( "inhouse_after_dialog" );
    int_diary.AddDiarypage( 26 );
    interface_impl.ShowGlobalTask();
    
    ObjSet("anm_inhouse_dialog_victor1_hand_2",  { playing = 1 });
    
  end;
  
  local anm_hand = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_inhouse_dialog_victor1_lipsync3");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_inhouse_dialog_victor1_timer",  { playing = 0 }},
                   {"anm_inhouse_dialog_victor1_hand_give", { alp = 1, playing = 1, endtrig = dialog_end }},
                   {"obj_inhouse_dialog_victor1_head", { alp = 1 }} } );
    
  end;
                 
  local victor_talks3 = function ()
  
    ObjDelete("vid_inhouse_dialog_victor1_lipsync2");
    ObjAttach("vid_inhouse_dialog_victor1_lipsync3", "obj_inhouse_dialog_victor1_victor");
  
    cmn.ShowDlgBbt( "dlg_inhouse_victor1_phrase_3" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level4/audio/voc/aud_4_lvl_victor_5_voc");
    
    private.dlg_lipsync = "vid_inhouse_dialog_victor1_lipsync3";
    
    ObjMultiSet( { {"tmr_inhouse_dialog_victor1_timer", { endtrig = anm_hand, time = 4, playing = 1 }},
                   {"vid_inhouse_dialog_victor1_lipsync3", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_hand }},
                   {"obj_character_dialog_continue", { event_mup = anm_hand }} } );
  
  end;
                 
  local victor_talks2 = function ()
  
    ObjDelete("vid_inhouse_dialog_victor1_lipsync1");
    ObjAttach("vid_inhouse_dialog_victor1_lipsync2", "obj_inhouse_dialog_victor1_victor");
  
    cmn.ShowDlgBbt( "dlg_inhouse_victor1_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level4/audio/voc/aud_4_lvl_victor_4_voc");
    
    private.dlg_lipsync = "vid_inhouse_dialog_victor1_lipsync2";
    
    ObjMultiSet( { {"tmr_inhouse_dialog_victor1_timer", { endtrig = victor_talks3, time = 5, playing = 1 }},
                   {"vid_inhouse_dialog_victor1_lipsync2", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = victor_talks3 }},
                   {"obj_character_dialog_continue", { event_mup = victor_talks3 }} } );
  
  end;

  private.dlg_lipsync = "vid_inhouse_dialog_victor1_lipsync1";

  cmn.ShowDlgBbt( "dlg_inhouse_victor1_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level4/audio/voc/aud_4_lvl_victor_3_voc");

  ObjMultiSet( { {"tmr_inhouse_dialog_victor1_timer", { time = 11, playing = 1, endtrig = victor_talks2 }},
                 {"vid_inhouse_dialog_victor1_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = victor_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = victor_talks2 }} } );
  
end; 
--------------------------------------------------------------------------------------------
function public.skip_dlg_victor1()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "clk_inhousefirst_end" );
    cmn.CallEventHandler("clk_inhousefirst_task");

    cmn.ShowBbt( "inhouse_after_dialog" );
    int_diary.AddDiarypage( 26 );
    interface_impl.ShowGlobalTask();
    
    ObjSet("anm_inhouse_dialog_victor1_hand_2",  { playing = 1 });
    
  end;
  
  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    ObjSet("obj_inhouse_dialog_victor1_head",  { alp = 1 });
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();
  
  --common_impl.PlayBackgroundMusic();
  
  ObjMultiSet( { {"tmr_inhouse_dialog_victor1_timer",  { playing = 0 }},
                 {"anm_inhouse_dialog_victor1_hand_give", { alp = 1, playing = 1, endtrig = func_after_dlg }} } );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Hearth *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_hearth = {};
public.zz_hearth = {};

function private.Init_Hearth()
  
  private.zz_hearth.win_state = { 3, 6, 1, 5, 7, 4, 8, 2 };
  private.zz_hearth.start_state = { 3, 3, 3, 3, 3, 3, 3, 3 };
  
  private.zz_hearth.in_play = false;
  private.zz_hearth.anim_time = 0.5;
  -----------------------------------------------------------------------------------
  game.hint[ "win_hearth" ] = {
    type = "win",
    room = "rm_inhouse",
    zz = "zz_hearth",
    zz_gate = "gzz_inhouse_hearth"
  };
  -----------------------------------------------------------------------------------
  local win_hearth = function ()

    if cmn.IsEventDone( "win_hearth" ) then

      ObjDelete("obj_hearth_gates");
      ObjDelete("obj_hearth_game");

      ObjMultiSet( {
        { "obj_hearth_inside", { input = 1 } },
        { "spr_inhouse_hearth_gate_open", { alp = 1 } }
      } );

      ObjDelete( "obj_inhouse_hearth_gate_close" );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_hearth", win_hearth, "rm_inhouse" );
  
end;

--*********************************************************************************************************************
function private.zz_hearth.StartConditions()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_hearth" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_hearth" ].state = { 3, 3, 3, 3, 3, 3, 3, 3, 0 };
  
end;
-----------------------------------------------------------------------------------
function public.zz_hearth.Reset()
  
  local need_r = false;
  
  for i = 1, 8, 1 do
    
    if private.zz_hearth.state[i] ~= private.zz_hearth.start_state[i] then
      
      if not need_r then
        need_r = true;
      end;
      
      ObjMultiSet( { {"spr_hearth_amulet_"..i.."_"..private.zz_hearth.state[i], { input = 0 }},
                     {"spr_hearth_amulet_"..i.."_"..private.zz_hearth.start_state[i], { input = 1 }} } );
  
      ObjAnimate("spr_hearth_amulet_"..i.."_"..private.zz_hearth.state[i], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      ObjAnimate("spr_hearth_amulet_"..i.."_"..private.zz_hearth.start_state[i], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
  end;
  
  if need_r then
    
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_zz_hearth_click");
    
    private.zz_hearth.StartConditions();
    private.zz_hearth.state = ng_global.progress[ ng_global.currentprogress ][ "win_hearth" ].state;
    
    ObjSet("tmr_hearth_timer",  { time = 0.3, playing = 1, endtrig = function() cmn.Lock(0); end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_hearth.Skip()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_zz_hearth_click");
  
  ng_global.progress[ ng_global.currentprogress ][ "win_hearth" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_hearth" ].state = { 3, 6, 1, 5, 7, 4, 8, 2, 1 };
  
  for i = 1, 8, 1 do
    
    if private.zz_hearth.state[i] ~= private.zz_hearth.win_state[i] then
      
      ObjMultiSet( { {"spr_hearth_amulet_"..i.."_"..private.zz_hearth.state[i], { input = 0 }},
                     {"spr_hearth_amulet_"..i.."_"..private.zz_hearth.win_state[i], { input = 1 }} } );
  
      ObjAnimate("spr_hearth_amulet_"..i.."_"..private.zz_hearth.state[i], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      ObjAnimate("spr_hearth_amulet_"..i.."_"..private.zz_hearth.win_state[i], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
  end;
  
  private.zz_hearth.state = ng_global.progress[ ng_global.currentprogress ][ "win_hearth" ].state;
  ObjSet("tmr_hearth_timer",  { time = 0.3, playing = 1, endtrig = public.zz_hearth.ClickPlay });
  
end;
-----------------------------------------------------------------------------------
function private.zz_hearth.DrawScene()
  
  for i = 1, 8, 1 do
    for j = 1, 8, 1 do
      
      if private.zz_hearth.state[i] == j then
        ObjSet("spr_hearth_amulet_"..i.."_"..j,  { alp = 1, input = 1 });
      else 
        ObjSet("spr_hearth_amulet_"..i.."_"..j,  { alp = 0, input = 0 });
      end;
      
    end;
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_hearth.FocusPlay( inout )
  
  local obj = "spr_hearth_button_play_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.zz_hearth.ClickPlay()
  
  cmn.Lock(1);
  private.zz_hearth.in_play = true;
  
  if private.zz_hearth.CheckWin() then
    private.zz_hearth.state[9] = 1;
  end;
  
  private.zz_hearth.PlayMainAnim( 1 );
  
end;
-----------------------------------------------------------------------------------
function private.zz_hearth.PlayMainAnim( num )
  
  if private.zz_hearth.state[num] == private.zz_hearth.win_state[num] then
    
    local move_ring = function ()
      
      if num < 8 then
        cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_zz_hearth_click_right_"..math.random(1, 3));
        ObjAnimate("obj_hearth_game_ring", "ang", 0, 0, function() private.zz_hearth.PlayMainAnim( num+1 ) end, { 0, 0, (num-1)*(math.pi/4),   private.zz_hearth.anim_time, 0, num*(math.pi/4) });
      else
        private.zz_hearth.WinAnim();    
      end;
      
    end;
    
    ObjAnimate("spr_hearth_amulet_"..num.."_"..private.zz_hearth.state[num].."_focus", "alp", 0, 0, move_ring, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });
    
  else 
    
    private.zz_hearth.ResetRing( num );
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_hearth.ResetRing( num )
  
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_zz_hearth_click_wrong");
  
  private.zz_hearth.in_play = false;
  
  for i = 1, num - 1, 1 do
    ObjAnimate("spr_hearth_amulet_"..i.."_"..private.zz_hearth.state[i].."_focus", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  end;
  
  local tme = 0.3*(num-1);
  
  ObjAnimate("obj_hearth_game_ring", "ang", 0, 0, function() cmn.Lock(0); end, { 0, 0, (num-1)*(math.pi/4),   0.5, 0, (num-1)*(math.pi/4),   tme+0.5, 0, 0 });
  
end;
-----------------------------------------------------------------------------------
function public.zz_hearth.FocusAmulet( num, state, inout )
  
  local obj = "spr_hearth_amulet_"..num.."_"..state.."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.zz_hearth.ChangeAmulet( num )
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_zz_hearth_click");
  
  local old = private.zz_hearth.state[num];
  local new = old + 1;
  if new > 8 then
    new = 1;
  end;
  
  private.zz_hearth.state[num] = new;
  
  ObjMultiSet( { {"spr_hearth_amulet_"..num.."_"..old, { input = 0 }},
                 {"spr_hearth_amulet_"..num.."_"..new, { input = 1 }} } );
  
  ObjAnimate("spr_hearth_amulet_"..num.."_"..old, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  ObjAnimate("spr_hearth_amulet_"..num.."_"..new, "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 0,   0.3, 0, 1 });
  
end;
-----------------------------------------------------------------------------------
function private.zz_hearth.CheckWin()
  
  local check = true;
  
  for i = 1, 8, 1 do
    
    if private.zz_hearth.state[i] ~= private.zz_hearth.win_state[i] then
      check = false;
      break;
    end;
    
  end;
  
  return check;
  
end;
-----------------------------------------------------------------------------------
function private.zz_hearth.WinAnim()
  
  private.zz_hearth.in_play = false;
  
  cmn.Lock( 1 );
  
  common_impl.PauseAchiev(1);
  cmn.MiniGameHide("hearth");
  
  local anm_open = function ()
    
    ObjAnimate("obj_hearth_gates", "alp", 0, 0, private.zz_hearth.Win, { 0, 0, 1,   0.3, 0, 1,   0.6, 0, 0 });
    ObjAnimate("spr_hearth_gate_1", "pos_x", 0, 0, "", { 0, 0, -147,   0.6, 0, -300 });
    ObjAnimate("spr_hearth_gate_2", "pos_x", 0, 0, "", { 0, 0, 146,   0.6, 0, 300 });
    
  end;
  
  local anm_win = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_zz_hearth_open_gates");
    ObjAnimate("obj_hearth_game", "alp", 0, 0, anm_open, { 0, 0, 1,   0.5, 0, 0 });
    
  end;
  
  ObjSet("tmr_hearth_timer",  { time = 1, playing = 1, endtrig = anm_win });
    
end;
-----------------------------------------------------------------------------------
function private.zz_hearth.Win()
  
  cmn.Lock( 0 );
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_hearth" );
  cmn.CallEventHandler( "win_hearth" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_hearth" ].skip == 0 and ng_global.noskipgames[ "win_hearth" ] == nil then

    ng_global.noskipgames[ "win_hearth" ] = 1;
    common_impl.CheckAchiev("mg");

  end;
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Table *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_table = {};
public.zz_table = {};

function private.Init_Table()
  
  private.zz_table.right_code = { 5, 3, 7 };
  --------------------------------------------------------------------------------------------
  game.hint[ "win_table" ] = {
    type = "click",
    use_place = "obj_table_clk_code_hint_1",
    room = "rm_inhouse",
    zz = "zz_table",
    zz_gate = "gzz_inhouse_table"
  };
  -----------------------------------------------------------------------------------
  local win_table = function ()

    if cmn.IsEventDone( "win_table" ) then

      --ObjAttach("obj_table_game", "anm_table_box_open");
      ObjDelete("anm_table_box_touch");
      ObjDelete("anm_table_box_open");

      ObjDelete( "spr_inhouse_table_box_cover_close" );
      
      ObjMultiSet( { {"anm_table_box_2", { alp = 1, input = 1 }},
                     {"obj_table_box_touch_2", { input = 1 }},
                     {"spr_inhouse_table_box_cover_open", { alp = 1 }} } );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_table", win_table, "rm_inhouse" );
  
end;
--********************************************************************************************************************
function private.zz_table.StartConditions()

  ng_global.progress[ "ext" ][ "win_table" ].state = { 0, 0, 0 }; --current code

end;
-----------------------------------------------------------------------------------
function private.zz_table.DrawScene()

  for i = 1, 3, 1 do
    
    if private.zz_table.state[i] == private.zz_table.right_code[i] then
      ObjSet("obj_table_clk_code_"..i,  { input = 0 });
    end;
    
    for j = 0, 9, 1 do
      
      if private.zz_table.state[i] == j then
        ObjSet("spr_table_numbers_"..i.."_"..j,  { alp = 1 });
      else 
        ObjSet("spr_table_numbers_"..i.."_"..j,  { alp = 0 });
      end;
      
    end;
    
  end;

end;
-----------------------------------------------------------------------------------
function public.zz_table.ClickCode( num )

  cmn.Lock( 1 );
  
  private.zz_table.state[num] = private.zz_table.state[num] + 1;
  
  if private.zz_table.state[num] == private.zz_table.right_code[num] then
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_click_zz_table_2");
    ObjSet("obj_table_clk_code_"..num,  { input = 0 });
  else
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_click_zz_table_1");
  end;
  
  ObjAnimate("spr_table_numbers_"..num.."_"..private.zz_table.state[num], "alp", 0, 0, private.zz_table.CheckWin, { 0, 0, 0,   0.3, 0, 1 });
  ObjAnimate("spr_table_numbers_"..num.."_"..(private.zz_table.state[num]-1), "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
end;
-----------------------------------------------------------------------------------
function private.zz_table.CheckWin()
  
  local win_flag = true;
  
  for i = 1, 3, 1 do
    
    if private.zz_table.state[i] == private.zz_table.right_code[i] then
      ObjSet("obj_table_clk_code_hint_"..i,  { input = 0 });
    end;
    
  end;
  
  for i = 1, 3, 1 do
    
    if private.zz_table.state[i] ~= private.zz_table.right_code[i] then
      win_flag = false;
      game.hint[ "win_table" ].use_place = "obj_table_clk_code_hint_"..i;
      break;
    end;
    
  end;
  
  if win_flag then
    
    cmn.Lock( 1 );
    private.zz_table.Win();
    
  else 
    cmn.Lock( 0 );
  end;

end;
-----------------------------------------------------------------------------------
function private.zz_table.Win()

  cmn.SetEventDone( "win_table" );

  local func_after = function ()

    cmn.CallEventHandler( "win_table" );

    cmn.Lock(0);

  end;

  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_zz_table_open_box_bird");

  ObjAttach("obj_table_game", "anm_table_box_open");
  ObjDelete("anm_table_box_touch");
  
  ObjMultiSet( { {"obj_table_game", { pos_x = -64, pos_y = 42 }},
                 {"anm_table_box_open",  { alp = 1, playing = 1, endtrig = func_after }} } );

end;
--****************************************************************************************************************