-- name=rm_oldcemetery
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_oldcemetery";
  --------------------------------------------------------------------------------------------
  private.dlg_lipsync = "";

  private.Init_Subroom();
  private.Init_Tree();
  --------------------------------------------------------------------------------------------
  -- function get_mirrorshard2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_mirrorshard2" ] = {
    type = "get",
    get_obj = "spr_tree_mirrorshard2",
    room = private.room_objname,
    zz = "zz_tree",
    zz_gate = "gzz_oldcemetery_tree"
  };
  --------------------------------------------------------------------------------------------
  local get_mirrorshard2_inv = function ()
  
    interface.InventoryItemAdd( "inv_mirrorshard2", "spr_tree_mirrorshard2" );
  
  end;
  local get_mirrorshard2_end = function ()
  
    ObjDelete( "gfx_tree_mirrorshard2" );
    ObjDelete( "spr_tree_mirrorshard2_sh" );
    
    if cmn.IsEventDone("get_deer1") and cmn.IsEventDone("get_ravenfigurine") then
      ObjDelete( "gzz_oldcemetery_tree" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_mirrorshard2", get_mirrorshard2_inv );
  cmn.AddSubscriber( "get_mirrorshard2", get_mirrorshard2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_basreliefpart1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_basreliefpart1" ] = {
    type = "get",
    get_obj = "spr_tree_basreliefpart1",
    room = private.room_objname,
    zz = "zz_tree",
    zz_gate = "gzz_oldcemetery_tree"
  };
  --------------------------------------------------------------------------------------------
  local get_basreliefpart1_inv = function ()
  
    interface.InventoryItemAdd( "inv_basreliefpart1", "spr_tree_basreliefpart1" );
  
  end;
  local get_basreliefpart1_end = function ()
  
    ObjDelete( "gfx_tree_basreliefpart1" );
    ObjDelete( "spr_tree_basreliefpart1_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_basreliefpart1", get_basreliefpart1_inv );
  cmn.AddSubscriber( "get_basreliefpart1", get_basreliefpart1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ravenfigurine () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_ravenfigurine" ] = {
    type = "get",
    get_obj = "spr_tree_ravenfigurine",
    room = private.room_objname,
    zz = "zz_tree",
    zz_gate = "gzz_oldcemetery_tree"
  };
  --------------------------------------------------------------------------------------------
  local get_ravenfigurine_inv = function ()
  
    interface.InventoryItemAdd( "inv_ravenfigurine", "spr_tree_ravenfigurine" );
  
  end;
  local get_ravenfigurine_end = function ()
  
    ObjDelete( "gfx_tree_ravenfigurine" );
    ObjDelete( "spr_tree_ravenfigurine_sh" );
    
    if cmn.IsEventDone("get_deer1") and cmn.IsEventDone("get_mirrorshard2") then
      ObjDelete( "gzz_oldcemetery_tree" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_ravenfigurine", get_ravenfigurine_inv );
  cmn.AddSubscriber( "get_ravenfigurine", get_ravenfigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_deer1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_deer1" ] = {
    type = "get",
    get_obj = "spr_tree_deer1",
    room = private.room_objname,
    zz = "zz_tree",
    zz_gate = "gzz_oldcemetery_tree"
  };
  --------------------------------------------------------------------------------------------
  local get_deer1_inv = function ()
  
    interface.InventoryItemAdd( "inv_deer1", "spr_tree_deer1" );
    int_map_impl.DecreaseRoomTasks("rm_oldcemetery");
  
  end;
  local get_deer1_end = function ()
  
    ObjDelete( "gfx_tree_deer1" );
    ObjDelete( "spr_tree_deer1_sh" );
    ObjDelete( "spr_oldcemetery_tree_deer" );
    
    if cmn.IsEventDone("get_ravenfigurine") and cmn.IsEventDone("get_mirrorshard2") then
      ObjDelete( "gzz_oldcemetery_tree" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_deer1", get_deer1_inv );
  cmn.AddSubscriber( "get_deer1", get_deer1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl4pickaxe () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl4pickaxe" ] = {
    type = "get",
    get_obj = "spr_ruins_lvl4pickaxe",
    room = private.room_objname,
    zz = "zz_ruins",
    zz_gate = "gzz_oldcemetery_ruins"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl4pickaxe_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl4pickaxe", "spr_ruins_lvl4pickaxe" );
  
  end;
  local get_lvl4pickaxe_end = function ()
  
    ObjDelete( "anm_ruins_use_handle" );
  
  end;
  
  cmn.AddSubscriber( "get_lvl4pickaxe", get_lvl4pickaxe_inv );
  cmn.AddSubscriber( "get_lvl4pickaxe", get_lvl4pickaxe_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mirrorshard3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_mirrorshard3" ] = {
    type = "get",
    get_obj = "spr_ruins_mirrorshard3",
    room = private.room_objname,
    zz = "zz_ruins",
    zz_gate = "gzz_oldcemetery_ruins"
  };
  --------------------------------------------------------------------------------------------
  local get_mirrorshard3_inv = function ()
  
    interface.InventoryItemAdd( "inv_mirrorshard3", "spr_ruins_mirrorshard3" );
    int_map_impl.DecreaseRoomTasks("rm_oldcemetery");
  
  end;
  local get_mirrorshard3_end = function ()
  
    ObjDelete( "gfx_ruins_mirrorshard3" );
    ObjDelete( "spr_ruins_mirrorshard3_sh" );
    
    if cmn.IsEventDone("get_emerald") then
      ObjDelete( "gzz_oldcemetery_ruins" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_mirrorshard3", get_mirrorshard3_inv );
  cmn.AddSubscriber( "get_mirrorshard3", get_mirrorshard3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_emerald () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_emerald" ] = {
    type = "get",
    get_obj = "spr_ruins_emerald",
    room = private.room_objname,
    zz = "zz_ruins",
    zz_gate = "gzz_oldcemetery_ruins"
  };
  --------------------------------------------------------------------------------------------
  local get_emerald_inv = function ()
  
    interface.InventoryItemAdd( "inv_emerald", "spr_ruins_emerald" );
    int_map_impl.DecreaseRoomTasks("rm_oldcemetery");
    ObjSet("inv_egg_star_light",  { alp = 1 });
  
  end;
  local get_emerald_end = function ()
  
    ObjDelete( "gfx_ruins_emerald" );
    ObjDelete( "spr_ruins_emerald_sh" );
    
    if cmn.IsEventDone("get_mirrorshard3") then
      ObjDelete( "gzz_oldcemetery_ruins" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_emerald", get_emerald_inv );
  cmn.AddSubscriber( "get_emerald", get_emerald_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_statuering2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_statuering2" ] = {
    type = "get",
    get_obj = "spr_tomb_statuering2",
    room = private.room_objname,
    zz = "zz_tomb",
    zz_gate = "gzz_oldcemetery_tomb"
  };
  --------------------------------------------------------------------------------------------
  local get_statuering2_inv = function ()
  
    interface.InventoryItemAdd( "inv_statuering2", "spr_tomb_statuering2" );
  
  end;
  local get_statuering2_end = function ()
  
    ObjDelete( "gfx_tomb_statuering2" );
    ObjDelete( "spr_tomb_statuering2_sh" );
    
    if cmn.IsEventDone("get_musicnote1") and cmn.IsEventDone("get_sword") then
      ObjDelete( "gzz_oldcemetery_tomb" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_statuering2", get_statuering2_inv );
  cmn.AddSubscriber( "get_statuering2", get_statuering2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sword () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_sword" ] = {
    type = "get",
    get_obj = "spr_tomb_sword_2",
    room = private.room_objname,
    zz = "zz_tomb",
    zz_gate = "gzz_oldcemetery_tomb"
  };
  --------------------------------------------------------------------------------------------
  local get_sword_inv = function ()
  
    interface.InventoryItemAdd( "inv_sword", "spr_tomb_sword_2" );
  
  end;
  local get_sword_end = function ()
  
    ObjDelete( "spr_tomb_sword" );
    ObjDelete( "spr_tomb_sword_sh" );
    ObjDelete( "spr_oldcemetery_crypt_sword" );
    
    if cmn.IsEventDone("get_musicnote1") and cmn.IsEventDone("get_statuering2") then
      ObjDelete( "gzz_oldcemetery_tomb" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_sword", get_sword_inv );
  cmn.AddSubscriber( "get_sword", get_sword_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_musicnote1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_musicnote1" ] = {
    type = "get",
    get_obj = "spr_tomb_musicnote1",
    room = private.room_objname,
    zz = "zz_tomb",
    zz_gate = "gzz_oldcemetery_tomb"
  };
  --------------------------------------------------------------------------------------------
  local get_musicnote1_inv = function ()
  
    interface.InventoryItemAdd( "inv_musicnote1", "spr_tomb_musicnote1" );
  
  end;
  local get_musicnote1_end = function ()
  
    ObjDelete( "gfx_tomb_musicnote1" );
    ObjDelete( "spr_tomb_musicnote1_sh" );
    ObjDelete( "spr_oldcemetery_crypt_note" );
    
    if cmn.IsEventDone("get_sword") and cmn.IsEventDone("get_statuering2") then
      ObjDelete( "gzz_oldcemetery_tomb" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_musicnote1", get_musicnote1_inv );
  cmn.AddSubscriber( "get_musicnote1", get_musicnote1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fullwateringcan () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_fullwateringcan" ] = {
    type = "get",
    get_obj = "spr_oldcemetery_fullwateringcan",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_fullwateringcan_inv = function ()
  
    interface.InventoryItemAdd( "inv_fullwateringcan", "spr_oldcemetery_fullwateringcan" );
    int_map_impl.DecreaseRoomTasks("rm_oldcemetery");
  
  end;
  local get_fullwateringcan_end = function ()
  
    ObjDelete( "gfx_oldcemetery_fullwateringcan" );
    ObjDelete( "anm_oldcemetery_use_can" );
  
  end;
  
  cmn.AddSubscriber( "get_fullwateringcan", get_fullwateringcan_inv );
  cmn.AddSubscriber( "get_fullwateringcan", get_fullwateringcan_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_letter2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_letter2" ] = {
    type = "get",
    get_obj = "spr_oldcemetery_letter2",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_letter2_inv = function ()
  
    interface.InventoryItemAdd( "inv_letter", "spr_oldcemetery_letter2", function () cmn.GetMultyObject( 'letter', 9 ); end );
    int_map_impl.DecreaseRoomTasks("rm_oldcemetery");
  
  end;
  local get_letter2_end = function ()
  
    ObjDelete( "gfx_oldcemetery_letter2" );
    ObjDelete( "spr_oldcemetery_letter2_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_letter2", get_letter2_inv );
  cmn.AddSubscriber( "get_letter2", get_letter2_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_floweramulet2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_floweramulet2" ] = {
    type = "use",
    inv_obj = "inv_floweramulet2",
    use_place = "obj_tree_use_floweramulet2",
    room = private.room_objname,
    zz = "zz_tree",
    zz_gate = "gzz_oldcemetery_tree"
  };
  --------------------------------------------------------------------------------------------
  local use_floweramulet2_inv = function ()
  
    interface.InventoryItemRemove( "inv_floweramulet2" );
  
  end;
  local use_floweramulet2_beg = function ()
  
    ObjDelete( "obj_tree_use_floweramulet2" );
    
    if cmn.IsEventDone("use_floweramulet1") and cmn.IsEventDone("use_floweramulet3") then
      ObjSet( "obj_tree_inside", { alp = 1 } );
    end;
  
  end;
  local use_floweramulet2_end = function ()
  
    if cmn.IsEventDone("use_floweramulet1") and cmn.IsEventDone("use_floweramulet3") then
      ObjDelete( "anm_tree_touch" );
      ObjDelete( "anm_tree_open" );
      ObjDelete( "spr_oldcemetery_tree_closed" );
      ObjSet( "obj_tree_inside", { input = 1 } );
    else 
      ObjMultiSet( { {"spr_tree_flower_amulet_2", { alp = 1 }},
                     {"spr_oldcemetery_tree_flower_2", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_floweramulet2", use_floweramulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_floweramulet2", use_floweramulet2_inv );
  cmn.AddSubscriber( "use_floweramulet2", use_floweramulet2_end, private.room_objname );
  cmn.AddSubscriber( "use_floweramulet2_inv", use_floweramulet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_floweramulet2_beg", use_floweramulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_floweramulet2_end", use_floweramulet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_feather1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_feather1" ] = {
    type = "use",
    inv_obj = "inv_feather1",
    use_place = "obj_tree_use_feather1",
    room = private.room_objname,
    zz = "zz_tree",
    zz_gate = "gzz_oldcemetery_tree"
  };
  --------------------------------------------------------------------------------------------
  local use_feather1_inv = function ()
  
    interface.InventoryItemRemove( "inv_feather1" );
  
  end;
  local use_feather1_beg = function ()
  
    ObjDelete( "obj_tree_use_feather1" );
  
  end;
  local use_feather1_end = function ()
    
    ObjMultiSet( { {"obj_tree_feather_3", { alp = 1 }},
                   {"spr_tree_raven_feather_1", { alp = 1}} } );
  
    if cmn.IsEventDone("use_feather2")  then
      ObjAttach("anm_tree_raven", "zz_tree");
      ObjSet("anm_tree_raven",  { input = 1, pos_z = 8 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_feather1", use_feather1_beg, private.room_objname );
  cmn.AddSubscriber( "use_feather1", use_feather1_inv );
  cmn.AddSubscriber( "use_feather1", use_feather1_end, private.room_objname );
  cmn.AddSubscriber( "use_feather1_inv", use_feather1_inv, private.room_objname );
  cmn.AddSubscriber( "use_feather1_beg", use_feather1_beg, private.room_objname );
  cmn.AddSubscriber( "use_feather1_end", use_feather1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_floweramulet3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_floweramulet3" ] = {
    type = "use",
    inv_obj = "inv_floweramulet3",
    use_place = "obj_tree_use_floweramulet3",
    room = private.room_objname,
    zz = "zz_tree",
    zz_gate = "gzz_oldcemetery_tree"
  };
  --------------------------------------------------------------------------------------------
  local use_floweramulet3_inv = function ()
  
    interface.InventoryItemRemove( "inv_floweramulet3" );
  
  end;
  local use_floweramulet3_beg = function ()
  
    ObjDelete( "obj_tree_use_floweramulet3" );
    
    if cmn.IsEventDone("use_floweramulet1") and cmn.IsEventDone("use_floweramulet2") then
      ObjSet( "obj_tree_inside", { alp = 1 } );
    end;
  
  end;
  local use_floweramulet3_end = function ()
  
    if cmn.IsEventDone("use_floweramulet1") and cmn.IsEventDone("use_floweramulet2") then
      ObjDelete( "anm_tree_touch" );
      ObjDelete( "anm_tree_open" );
      ObjDelete( "spr_oldcemetery_tree_closed" );
      ObjSet( "obj_tree_inside", { input = 1 } );
    else 
      ObjMultiSet( { {"spr_tree_flower_amulet_3", { alp = 1 }},
                     {"spr_oldcemetery_tree_flower_3", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_floweramulet3", use_floweramulet3_beg, private.room_objname );
  cmn.AddSubscriber( "use_floweramulet3", use_floweramulet3_inv );
  cmn.AddSubscriber( "use_floweramulet3", use_floweramulet3_end, private.room_objname );
  cmn.AddSubscriber( "use_floweramulet3_inv", use_floweramulet3_inv, private.room_objname );
  cmn.AddSubscriber( "use_floweramulet3_beg", use_floweramulet3_beg, private.room_objname );
  cmn.AddSubscriber( "use_floweramulet3_end", use_floweramulet3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_floweramulet1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_floweramulet1" ] = {
    type = "use",
    inv_obj = "inv_floweramulet1",
    use_place = "obj_tree_use_floweramulet1",
    room = private.room_objname,
    zz = "zz_tree",
    zz_gate = "gzz_oldcemetery_tree"
  };
  --------------------------------------------------------------------------------------------
  local use_floweramulet1_inv = function ()
  
    interface.InventoryItemRemove( "inv_floweramulet1" );
  
  end;
  local use_floweramulet1_beg = function ()
  
    ObjDelete( "obj_tree_use_floweramulet1" );
    
    if cmn.IsEventDone("use_floweramulet3") and cmn.IsEventDone("use_floweramulet2") then
      ObjSet( "obj_tree_inside", { alp = 1 } );
    end;
  
  end;
  local use_floweramulet1_end = function ()
  
    if cmn.IsEventDone("use_floweramulet3") and cmn.IsEventDone("use_floweramulet2") then
      ObjDelete( "anm_tree_touch" );
      ObjDelete( "anm_tree_open" );
      ObjDelete( "spr_oldcemetery_tree_closed" );
      ObjSet( "obj_tree_inside", { input = 1 } );
    else 
      ObjMultiSet( { {"spr_tree_flower_amulet_1", { alp = 1 }},
                     {"spr_oldcemetery_tree_flower_1", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_floweramulet1", use_floweramulet1_beg, private.room_objname );
  cmn.AddSubscriber( "use_floweramulet1", use_floweramulet1_inv );
  cmn.AddSubscriber( "use_floweramulet1", use_floweramulet1_end, private.room_objname );
  cmn.AddSubscriber( "use_floweramulet1_inv", use_floweramulet1_inv, private.room_objname );
  cmn.AddSubscriber( "use_floweramulet1_beg", use_floweramulet1_beg, private.room_objname );
  cmn.AddSubscriber( "use_floweramulet1_end", use_floweramulet1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_feather2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_feather2" ] = {
    type = "use",
    inv_obj = "inv_feather2",
    use_place = "obj_tree_use_feather2",
    room = private.room_objname,
    zz = "zz_tree",
    zz_gate = "gzz_oldcemetery_tree"
  };
  --------------------------------------------------------------------------------------------
  local use_feather2_inv = function ()
  
    interface.InventoryItemRemove( "inv_feather2" );
  
  end;
  local use_feather2_beg = function ()
  
    ObjDelete( "obj_tree_use_feather2" );
  
  end;
  local use_feather2_end = function ()
    
    ObjMultiSet( { {"obj_tree_feather_7", { alp = 1 }},
                   {"spr_tree_raven_feather_2", { alp = 1}} } );
  
    if cmn.IsEventDone("use_feather1")  then
      ObjAttach("anm_tree_raven", "zz_tree");
      ObjSet("anm_tree_raven",  { input = 1, pos_z = 8 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_feather2", use_feather2_beg, private.room_objname );
  cmn.AddSubscriber( "use_feather2", use_feather2_inv );
  cmn.AddSubscriber( "use_feather2", use_feather2_end, private.room_objname );
  cmn.AddSubscriber( "use_feather2_inv", use_feather2_inv, private.room_objname );
  cmn.AddSubscriber( "use_feather2_beg", use_feather2_beg, private.room_objname );
  cmn.AddSubscriber( "use_feather2_end", use_feather2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_stick () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_stick" ] = {
    type = "use",
    inv_obj = "inv_stick",
    use_place = "obj_ruins_use_stick",
    room = private.room_objname,
    zz = "zz_ruins",
    zz_gate = "gzz_oldcemetery_ruins"
  };
  --------------------------------------------------------------------------------------------
  local use_stick_inv = function ()
  
    interface.InventoryItemRemove( "inv_stick" );
  
  end;
  local use_stick_beg = function ()
  
    ObjDelete( "obj_ruins_use_stick" );
    ObjDelete( "anm_ruins_axe_touch" );
  
  end;
  local use_stick_end = function ()
  
    --ObjSet( "spr_ruins_lvl4pickaxe", { input = 1, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_stick", use_stick_beg, private.room_objname );
  cmn.AddSubscriber( "use_stick", use_stick_inv );
  cmn.AddSubscriber( "use_stick", use_stick_end, private.room_objname );
  cmn.AddSubscriber( "use_stick_inv", use_stick_inv, private.room_objname );
  cmn.AddSubscriber( "use_stick_beg", use_stick_beg, private.room_objname );
  cmn.AddSubscriber( "use_stick_end", use_stick_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sword () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_sword" ] = {
    type = "use",
    inv_obj = "inv_sword",
    use_place = "obj_ruins_use_sword",
    room = private.room_objname,
    zz = "zz_ruins",
    zz_gate = "gzz_oldcemetery_ruins"
  };
  --------------------------------------------------------------------------------------------
  local use_sword_inv = function ()
  
    interface.InventoryItemRemove( "inv_sword" );
  
  end;
  local use_sword_beg = function ()
  
    ObjDelete( "obj_ruins_use_sword" );
    ObjDelete( "anm_ruins_sphere" );
    ObjDelete( "spr_ruins_front" );
  
  end;
  local use_sword_end = function ()
  
    ObjDelete( "spr_oldcemetery_ruins_ball" );
    ObjSet( "anm_ruins_use_sword", { input = 1, alp = 1, frame = 300 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sword", use_sword_beg, private.room_objname );
  cmn.AddSubscriber( "use_sword", use_sword_inv );
  cmn.AddSubscriber( "use_sword", use_sword_end, private.room_objname );
  cmn.AddSubscriber( "use_sword_inv", use_sword_inv, private.room_objname );
  cmn.AddSubscriber( "use_sword_beg", use_sword_beg, private.room_objname );
  cmn.AddSubscriber( "use_sword_end", use_sword_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_shield () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_shield" ] = {
    type = "use",
    inv_obj = "inv_shield",
    use_place = "obj_tomb_use_shield",
    room = private.room_objname,
    zz = "zz_tomb",
    zz_gate = "gzz_oldcemetery_tomb"
  };
  --------------------------------------------------------------------------------------------
  local use_shield_inv = function ()
  
    interface.InventoryItemRemove( "inv_shield" );
  
  end;
  local use_shield_beg = function ()
  
    ObjDelete( "obj_tomb_use_shield" );
    ObjDelete( "anm_tomb_touch_cover" );
    ObjSet( "obj_tomb_inside", { alp = 1 } );
  
  end;
  local use_shield_end = function ()
  
    ObjDelete( "anm_tomb_cover_open" );
    ObjDelete( "spr_oldcemetery_crypt_closed" );
    
    ObjMultiSet( { {"obj_tomb_inside", { input = 1 }},
                   {"spr_oldcemetery_crypt_open", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_shield", use_shield_beg, private.room_objname );
  cmn.AddSubscriber( "use_shield", use_shield_inv );
  cmn.AddSubscriber( "use_shield", use_shield_end, private.room_objname );
  cmn.AddSubscriber( "use_shield_inv", use_shield_inv, private.room_objname );
  cmn.AddSubscriber( "use_shield_beg", use_shield_beg, private.room_objname );
  cmn.AddSubscriber( "use_shield_end", use_shield_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crown () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_crown" ] = {
    type = "use",
    inv_obj = "inv_crown",
    use_place = "obj_tomb_use_crown",
    room = private.room_objname,
    zz = "zz_tomb",
    zz_gate = "gzz_oldcemetery_tomb"
  };
  --------------------------------------------------------------------------------------------
  local use_crown_inv = function ()
  
    interface.InventoryItemRemove( "inv_crown" );
  
  end;
  local use_crown_beg = function ()
  
    ObjDelete( "obj_tomb_use_crown" );
  
  end;
  local use_crown_end = function ()
    
    ObjDelete( "anm_tomb_sword_touch" );
    ObjDelete( "spr_oldcemetery_crypt_hands" );
  
    ObjMultiSet( { {"anm_tomb_use_crown", { alp = 1, frame = 300 }},
                   {"anm_tomb_sword_give", { alp = 1, input = 1, frame = 300 }},
                   {"spr_oldcemetery_crypt_crown", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crown", use_crown_beg, private.room_objname );
  cmn.AddSubscriber( "use_crown", use_crown_inv );
  cmn.AddSubscriber( "use_crown", use_crown_end, private.room_objname );
  cmn.AddSubscriber( "use_crown_inv", use_crown_inv, private.room_objname );
  cmn.AddSubscriber( "use_crown_beg", use_crown_beg, private.room_objname );
  cmn.AddSubscriber( "use_crown_end", use_crown_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_guidingline () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_guidingline" ] = {
    type = "use",
    inv_obj = "inv_guidingline",
    use_place = "obj_oldcemetery_use_guidingline",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local use_guidingline_inv = function ()
  
    interface.InventoryItemRemove( "inv_guidingline" );
    int_map_impl.DecreaseRoomTasks("rm_oldcemetery");
  
  end;
  local use_guidingline_beg = function ()
  
    ObjDelete( "obj_oldcemetery_use_guidingline" );
  
  end;
  local use_guidingline_end = function ()
  
    ObjDelete( "vid_oldcemetery_use_guidingline" );
    
    ObjMultiSet( { {"grm_oldcemetery_forest", { alp = 1, input = 1 }},
                   {"spr_oldcemetery_forest_line", { alp = 1 }} } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_oldcemetery_forest_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_guidingline", use_guidingline_beg, private.room_objname );
  cmn.AddSubscriber( "use_guidingline", use_guidingline_inv );
  cmn.AddSubscriber( "use_guidingline", use_guidingline_end, private.room_objname );
  cmn.AddSubscriber( "use_guidingline_inv", use_guidingline_inv, private.room_objname );
  cmn.AddSubscriber( "use_guidingline_beg", use_guidingline_beg, private.room_objname );
  cmn.AddSubscriber( "use_guidingline_end", use_guidingline_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wateringcan () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_wateringcan" ] = {
    type = "use",
    inv_obj = "inv_wateringcan",
    use_place = "obj_oldcemetery_use_wateringcan",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local use_wateringcan_inv = function ()
  
    interface.InventoryItemRemove( "inv_wateringcan" );
  
  end;
  local use_wateringcan_beg = function ()
  
    ObjDelete( "obj_oldcemetery_use_wateringcan" );
  
  end;
  local use_wateringcan_end = function ()
  
    ObjSet( "spr_oldcemetery_fullwateringcan", { input = 1, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wateringcan", use_wateringcan_beg, private.room_objname );
  cmn.AddSubscriber( "use_wateringcan", use_wateringcan_inv );
  cmn.AddSubscriber( "use_wateringcan", use_wateringcan_end, private.room_objname );
  cmn.AddSubscriber( "use_wateringcan_inv", use_wateringcan_inv, private.room_objname );
  cmn.AddSubscriber( "use_wateringcan_beg", use_wateringcan_beg, private.room_objname );
  cmn.AddSubscriber( "use_wateringcan_end", use_wateringcan_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_oldcemetery () end;
  --------------------------------------------------------------------------------------------
  local opn_oldcemetery = function ()
  
    int_map_impl.OpenRoom( "rm_oldcemetery" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_oldcemetery", opn_oldcemetery );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_tree" );
  subroom.Define( "zz_ruins" );
  
  function zz_tree.PreOpen()
    
    if cmn.IsEventDone( "use_feather1" ) and cmn.IsEventDone("use_feather2") and not(cmn.IsEventDone( "win_tree" )) then
      private.zz_tree.DrawScene();
    end;

  end;
  
  function zz_tree.Open()
    
    if cmn.IsEventDone( "use_feather1" ) and cmn.IsEventDone("use_feather2") and not(cmn.IsEventDone( "win_tree" )) then
      cmn.MiniGameShow();
      private.zz_tree.CheckWin();
    end;

  end;
  
  function zz_tree.PreClose()
    
    if cmn.IsEventDone( "use_feather1" ) and cmn.IsEventDone("use_feather2") and not cmn.IsEventDone("win_tree") then
      cmn.MiniGameHide("tree");
    end;
    
  end;
  
  function zz_ruins.PreOpen()
    
    if not cmn.IsEventDone("use_sword") then
      cmn.PlayAudio("env", "assets/levels/level4/audio/env/aud_zz_ruins_env");
    end;
    
  end;
  
  function zz_ruins.PreClose()
    
    if not cmn.IsEventDone("use_sword") then
      cmn.StopAllEnv("assets/levels/level4/audio/env/aud_rm_oldcemetry_env");
      cmn.PlayAudio("env", "assets/levels/level4/audio/env/aud_rm_oldcemetry_env");
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_tree" ].state) then 
    private.zz_tree.StartConditions();
  end;
  
  private.zz_tree.state = ng_global.progress[ ng_global.currentprogress ][ "win_tree" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_oldcemetery();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level4/audio/env/aud_rm_oldcemetry_env");
  cmn.PlayAudio("env", "assets/levels/level4/audio/env/aud_rm_oldcemetry_env");
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_floweramulet2()

  local item = "inv_floweramulet2";

  if cmn.ApplyObj( item, "gzz_oldcemetery_tree" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_tree" );

  elseif ( cmn.ApplyObj( item, "obj_tree_use_floweramulet2" ) ) then

    cmn.CallEventHandler( "use_floweramulet2_inv" );
    cmn.CallEventHandler( "use_floweramulet2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_floweramulet2" );
      cmn.CallEventHandler( "use_floweramulet2_end" );
      
      if cmn.IsEventDone("use_floweramulet1") and cmn.IsEventDone("use_floweramulet3") then
        cmn.SetEventDone("use_floweramulets");
      end;
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_tree_opens");
      
      ObjDelete("anm_tree_touch");
      ObjSet("anm_tree_open",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_stone_flower");

    if cmn.IsEventDone("use_floweramulet1") and cmn.IsEventDone("use_floweramulet3") then
      ObjAnimate( "spr_tree_flower_amulet_2", "alp", 0, 0, anm_open, { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_tree_flower_amulet_2", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_feather1()

  local item = "inv_feather1";

  if cmn.ApplyObj( item, "gzz_oldcemetery_tree" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_tree" );

  elseif ( cmn.ApplyObj( item, "obj_tree_use_feather1" ) and cmn.IsEventDone("use_floweramulets") ) then

    cmn.CallEventHandler( "use_feather1_inv" );
    cmn.CallEventHandler( "use_feather1_beg" );

    local func_after = function ()

      cmn.SetEventDone( "use_feather1" );
      --cmn.CallEventHandler( "use_feather1_end" );
      
      if cmn.IsEventDone("use_feather2") then
        private.zz_tree.GameStart(1);
      else 
        cmn.Lock( 0 );
        cmn.CallEventHandler( "use_feather1_end" );
      end;
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_crow_pen");
    
    ObjAnimate( "obj_tree_feather_3", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_floweramulet3()

  local item = "inv_floweramulet3";

  if cmn.ApplyObj( item, "gzz_oldcemetery_tree" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_tree" );

  elseif ( cmn.ApplyObj( item, "obj_tree_use_floweramulet3" ) ) then

    cmn.CallEventHandler( "use_floweramulet3_inv" );
    cmn.CallEventHandler( "use_floweramulet3_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_floweramulet3" );
      cmn.CallEventHandler( "use_floweramulet3_end" );
      
      if cmn.IsEventDone("use_floweramulet1") and cmn.IsEventDone("use_floweramulet2") then
        cmn.SetEventDone("use_floweramulets");
      end;
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_tree_opens");
      
      ObjDelete("anm_tree_touch");
      ObjSet("anm_tree_open",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_stone_flower");

    if cmn.IsEventDone("use_floweramulet1") and cmn.IsEventDone("use_floweramulet2") then
      ObjAnimate( "spr_tree_flower_amulet_3", "alp", 0, 0, anm_open, { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_tree_flower_amulet_3", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_floweramulet1()

  local item = "inv_floweramulet1";

  if cmn.ApplyObj( item, "gzz_oldcemetery_tree" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_tree" );

  elseif ( cmn.ApplyObj( item, "obj_tree_use_floweramulet1" ) ) then

    cmn.CallEventHandler( "use_floweramulet1_inv" );
    cmn.CallEventHandler( "use_floweramulet1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_floweramulet1" );
      cmn.CallEventHandler( "use_floweramulet1_end" );
      
      if cmn.IsEventDone("use_floweramulet3") and cmn.IsEventDone("use_floweramulet2") then
        cmn.SetEventDone("use_floweramulets");
      end;
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_tree_opens");
      
      ObjDelete("anm_tree_touch");
      ObjSet("anm_tree_open",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_stone_flower");

    if cmn.IsEventDone("use_floweramulet3") and cmn.IsEventDone("use_floweramulet2") then
      ObjAnimate( "spr_tree_flower_amulet_1", "alp", 0, 0, anm_open, { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_tree_flower_amulet_1", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_feather2()

  local item = "inv_feather2";

  if cmn.ApplyObj( item, "gzz_oldcemetery_tree" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_tree" );

  elseif ( cmn.ApplyObj( item, "obj_tree_use_feather2" ) and cmn.IsEventDone("use_floweramulets") ) then

    cmn.CallEventHandler( "use_feather2_inv" );
    cmn.CallEventHandler( "use_feather2_beg" );

    local func_after = function ()

      cmn.SetEventDone( "use_feather2" );
      --cmn.CallEventHandler( "use_feather2_end" );
      
      if cmn.IsEventDone("use_feather1") then
        private.zz_tree.GameStart(2);
      else 
        cmn.Lock( 0 );
        cmn.CallEventHandler( "use_feather2_end" );
      end;
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_crow_pen");
    
    ObjAnimate( "obj_tree_feather_7", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_stick()

  local item = "inv_stick";

  if cmn.ApplyObj( item, "gzz_oldcemetery_ruins" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_ruins" );

  elseif ( cmn.ApplyObj( item, "obj_ruins_use_stick" ) ) then

    cmn.CallEventHandler( "use_stick_inv" );
    cmn.CallEventHandler( "use_stick_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_stick" );
      cmn.CallEventHandler( "use_stick_end" );
      
      public.get_lvl4pickaxe();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_stick");

    ObjSet("anm_ruins_use_handle",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_sword()

  local item = "inv_sword";

  if cmn.ApplyObj( item, "gzz_oldcemetery_ruins" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_ruins" );

  elseif ( cmn.ApplyObj( item, "obj_ruins_use_sword" ) ) then

    cmn.CallEventHandler( "use_sword_inv" );
    cmn.CallEventHandler( "use_sword_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_sword" );
      cmn.CallEventHandler( "use_sword_end" );
    
    end;
    
    cmn.StopAllEnv("assets/levels/level4/audio/env/aud_rm_oldcemetry_env");
    cmn.PlayAudio("env", "assets/levels/level4/audio/env/aud_rm_oldcemetry_env");

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_hack_bubble");

    ObjSet("anm_ruins_use_sword",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_shield()

  local item = "inv_shield";

  if cmn.ApplyObj( item, "gzz_oldcemetery_tomb" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_tomb" );

  elseif ( cmn.ApplyObj( item, "obj_tomb_use_shield" ) ) then
    
    if not cmn.IsEventDone("get_musicnote1") then
      public.get_musicnote1();
    end;

    cmn.CallEventHandler( "use_shield_inv" );
    cmn.CallEventHandler( "use_shield_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_shield" );
      cmn.CallEventHandler( "use_shield_end" );
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_shield_coffin");

    ObjSet("anm_tomb_cover_open",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_crown()

  local item = "inv_crown";

  if cmn.ApplyObj( item, "gzz_oldcemetery_tomb" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_tomb" );

  elseif ( cmn.ApplyObj( item, "obj_tomb_use_crown" ) and cmn.IsEventDone("use_shield") ) then

    cmn.CallEventHandler( "use_crown_inv" );
    cmn.CallEventHandler( "use_crown_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_crown" );
      cmn.CallEventHandler( "use_crown_end" );
    
    end;
    
    local anm_sword = function ()
      
      ObjDelete("anm_tomb_sword_touch");
      ObjSet("anm_tomb_sword_give",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_wear_crown_sword");

    ObjSet("anm_tomb_use_crown",  { alp = 1, playing = 1, endtrig = anm_sword });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_guidingline()

  local item = "inv_guidingline";

  if ( cmn.ApplyObj( item, "obj_oldcemetery_use_guidingline" ) ) then

    cmn.CallEventHandler( "use_guidingline_inv" );
    cmn.CallEventHandler( "use_guidingline_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_guidingline" );
      cmn.CallEventHandler( "use_guidingline_end" );
    
    end;

    cmn.Lock( 1 );

    ObjAttach("vid_oldcemetery_use_guidingline", "rm_oldcemetery");
    VidPlay("vid_oldcemetery_use_guidingline", func_after);

    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_glomerulus_1");

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_wateringcan()

  local item = "inv_wateringcan";

  if ( cmn.ApplyObj( item, "obj_oldcemetery_use_wateringcan" ) ) then

    cmn.CallEventHandler( "use_wateringcan_inv" );
    cmn.CallEventHandler( "use_wateringcan_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_wateringcan" );
      cmn.CallEventHandler( "use_wateringcan_end" );
      
      public.get_fullwateringcan();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_fill_cup_water");

    ObjSet("anm_oldcemetery_use_can",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_mirrorshard2()

  cmn.SetEventDone( "get_mirrorshard2" );
  cmn.CallEventHandler( "get_mirrorshard2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_deer1") and cmn.IsEventDone("get_ravenfigurine") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_basreliefpart1()

  cmn.SetEventDone( "get_basreliefpart1" );
  cmn.CallEventHandler( "get_basreliefpart1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_ravenfigurine()
  
  ObjSet("spr_tree_ravenfigurine",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_ravenfigurine" );
  cmn.CallEventHandler( "get_ravenfigurine" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_deer1") and cmn.IsEventDone("get_mirrorshard2") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_deer1()

  cmn.SetEventDone( "get_deer1" );
  cmn.CallEventHandler( "get_deer1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_ravenfigurine") and cmn.IsEventDone("get_mirrorshard2") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_lvl4pickaxe()
  
  ObjSet("spr_ruins_lvl4pickaxe",  { alp = 1 });

  cmn.SetEventDone( "get_lvl4pickaxe" );
  cmn.CallEventHandler( "get_lvl4pickaxe" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_mirrorshard3()
  
  ObjSet("spr_ruins_mirrorshard3",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_mirrorshard3" );
  cmn.CallEventHandler( "get_mirrorshard3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_emerald") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_emerald()

  cmn.SetEventDone( "get_emerald" );
  cmn.CallEventHandler( "get_emerald" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_mirrorshard3") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_statuering2()

  cmn.SetEventDone( "get_statuering2" );
  cmn.CallEventHandler( "get_statuering2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_sword") and cmn.IsEventDone("get_musicnote1") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_sword()
  
  ObjSet("spr_tomb_sword_2",  { alp = 1 });

  cmn.SetEventDone( "get_sword" );
  cmn.CallEventHandler( "get_sword" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_statuering2") and cmn.IsEventDone("get_musicnote1") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_musicnote1()
  
  ObjSet("spr_tomb_musicnote1",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_musicnote1" );
  cmn.CallEventHandler( "get_musicnote1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_sword") and cmn.IsEventDone("get_statuering2") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_fullwateringcan()

  cmn.SetEventDone( "get_fullwateringcan" );
  cmn.CallEventHandler( "get_fullwateringcan" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_letter2()

  cmn.SetEventDone( "get_letter2" );
  cmn.CallEventHandler( "get_letter2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_oldcemetery()

  if not ( cmn.IsEventDone( "opn_oldcemetery" ) ) then
    cmn.SetEventDone( "opn_oldcemetery" );
    cmn.CallEventHandler("opn_oldcemetery");
    cmn.ShowBbt( "oldcemetery_open" );
    cmn.PlayAudio("mus", "assets/levels/level1/audio/mus/aud_mus_scare_1", 0, false, 123);
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_tree_hole()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_closed_tree");

  cmn.ShowBbt( "obj_tree_use_floweramulet" );
  
  ObjSet( "anm_tree_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_tree_raven()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_crow_tree_"..math.random(1,3));

  cmn.ShowBbt( "obj_tree_use_feather" );
  
  local func_after = function ()
    
    cmn.Lock( 0 );
    ObjMultiSet( { {"anm_tree_raven", { alp = 1, playing = 1 }},
                   {"anm_tree_raven_touch", { alp = 0 }} } );
    
  end;
  
  ObjMultiSet( { {"anm_tree_raven", { alp = 0, playing = 0 }},
                 {"anm_tree_raven_touch", { alp = 1, playing = 1, endtrig = func_after }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_tomb_cover()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_coffin_shield");

  cmn.ShowBbt( "obj_tomb_use_shield" );
  
  ObjSet( "anm_tomb_touch_cover", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_tomb_skeleton()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_coffin_bones");

  cmn.ShowBbt( "obj_tomb_use_crown" );
  
  ObjSet( "anm_tomb_sword_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_ruins_pick()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_squeak_stick");

  cmn.ShowBbt( "obj_ruins_use_stick" );
  
  ObjSet( "anm_ruins_axe_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Tree *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_tree = {};
public.zz_tree = {};

function private.Init_Tree()
  
  private.zz_tree.current = 0;
  private.zz_tree.place = 0;
  private.zz_tree.start = { 8, 7, 5, 2, 4, 3, 1, 6 };
  
  private.zz_tree.feather_pos = {
    {-117, 46}, {-140, 44}, {-165, 42}, {-188, 24}, {130, 59}, {148, 47}, {167, 46}, {197, 39}
  };
  
  private.zz_tree.feather_ang = { 0, -0.28, -0.4, -0.62, 0, -0.28, -0.4, -0.62 };
  -----------------------------------------------------------------------------------
  game.hint[ "win_tree" ] = {
    type = "win",
    room = "rm_oldcemetery",
    zz = "zz_tree",
    zz_gate = "gzz_oldcemetery_tree"
  };
  -----------------------------------------------------------------------------------
  local win_tree = function ()

    if cmn.IsEventDone( "win_tree" ) then
      
      ObjDelete( "anm_tree_raven" );
      ObjDelete( "spr_oldcemetery_tree_crow" );
      ObjDelete( "anm_tree_raven_touch" );
      ObjMultiSet( { {"anm_tree_raven_to_figure", { alp = 1, input = 1, frame = 300 }},
                     {"spr_tree_mirrorshard2", { input = 1 }} } );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_tree", win_tree, "rm_oldcemetery" );
  
end;
--*********************************************************************************************************************
function private.zz_tree.StartConditions()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_tree" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_tree" ].state = { 8, 7, 5, 2, 4, 3, 1, 6 };
  
end;
-----------------------------------------------------------------------------------
function public.zz_tree.Reset()
  
  local need_r = false;
  local table_r = {};
  
  for i = 1, 8, 1 do
    
    if private.zz_tree.state[i] ~= private.zz_tree.start[i] then
      
      if not need_r then
        need_r = true;
      end;
      
      table.insert( table_r, private.zz_tree.state[i] );
      ObjAnimate("spr_tree_feather_"..private.zz_tree.state[i], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  end;
  
  local anm_end = function ()
    
    for i = 1, #table_r, 1 do
      
      local pos = 0;
      for j = 1, 8, 1 do
        
        if private.zz_tree.start[j] == table_r[i] then
          pos = j;
          break;
        end;
        
      end;
      
      if table_r[i] > 4 then
        typ = table_r[i]-4;
      else 
        typ = table_r[i];
      end;
      
      ObjAttach("spr_tree_feather_"..table_r[i], "obj_tree_feather_"..pos.."_"..typ);
      ObjAnimate("spr_tree_feather_"..table_r[i], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    ObjSet("tmr_tree_timer",  { time = 0.3, playing = 1, endtrig = function() cmn.Lock(0); end });
    
  end;
  
  if need_r then
    
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_crow_reset");
    
    private.zz_tree.StartConditions()
    private.zz_tree.state = ng_global.progress[ ng_global.currentprogress ][ "win_tree" ].state;
    
    ObjSet("tmr_tree_timer",  { time = 0.3, playing = 1, endtrig = anm_end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_tree.Skip()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_crow_take");
  
  ng_global.progress[ ng_global.currentprogress ][ "win_tree" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_tree" ].state = { 1, 2, 3, 4, 5, 6, 7, 8 };
  
  local table_r = {};
  
  for i = 1, 8, 1 do
    
    if private.zz_tree.state[i] ~= i then
      
      table.insert( table_r, private.zz_tree.state[i] );
      ObjAnimate("spr_tree_feather_"..private.zz_tree.state[i], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  end;
  
  local anm_end = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_crow_insert");
    
    for i = 1, #table_r, 1 do
      
      if table_r[i] > 4 then
        typ = table_r[i]-4;
      else 
        typ = table_r[i];
      end;
      
      ObjAttach("spr_tree_feather_"..table_r[i], "obj_tree_feather_"..table_r[i].."_"..typ);
      ObjAnimate("spr_tree_feather_"..table_r[i], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    ObjSet("tmr_tree_timer",  { time = 0.3, playing = 1, endtrig = private.zz_tree.CheckWin });
    
  end;
  
  private.zz_tree.state = ng_global.progress[ ng_global.currentprogress ][ "win_tree" ].state;
    
  ObjSet("tmr_tree_timer",  { time = 0.3, playing = 1, endtrig = anm_end });
  
end;
-----------------------------------------------------------------------------------
function private.zz_tree.GameStart( feather )
  
  local func_after = function ()
    
    cmn.Lock( 0 );
    cmn.MiniGameShow();
    
  end;
  
  local anm_change = function ()
    
    cmn.CallEventHandler( "use_feather"..feather.."_end" );
    
    local typ = 0;
  
    for i = 1, 8, 1 do
      
      if private.zz_tree.state[i] > 4 then
        typ = private.zz_tree.state[i]-4;
      else 
        typ = private.zz_tree.state[i];
      end;
      
      ObjAttach("spr_tree_feather_"..private.zz_tree.state[i], "obj_tree_feather_"..i.."_"..typ);
      ObjAnimate("spr_tree_feather_"..private.zz_tree.state[i], "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
    ObjSet("tmr_tree_timer",  { time = 0.5, playing = 1, endtrig = func_after });
  
  end;
  
  local anm_dis = function ()
  
    for i = 1, 8, 1 do
      ObjAnimate("spr_tree_feather_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    end;
    
    ObjSet("tmr_tree_timer",  { time = 0.5, playing = 1, endtrig = anm_change });
  
  end;
  
  ObjSet("tmr_tree_timer",  { time = 0.5, playing = 1, endtrig = anm_dis });
  
end;
-----------------------------------------------------------------------------------
function private.zz_tree.DrawScene()
  
  local typ = 0;
  
  for i = 1, 8, 1 do
    
    if private.zz_tree.state[i] > 4 then
      typ = private.zz_tree.state[i]-4;
    else 
      typ = private.zz_tree.state[i];
    end;
    
    ObjAttach("spr_tree_feather_"..private.zz_tree.state[i], "obj_tree_feather_"..i.."_"..typ);
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_tree.FocusFeather( num, inout, act )
  
  local obj = "spr_tree_feather_"..num.."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    
    if act == 1 then
      SetCursor(CURSOR_DEFAULT);
    else
      private.zz_tree.place = 0;
    end;
    
    tme = alf * 0.3;
    
  else 
    
    if act == 1 then
      SetCursor(CURSOR_GET);
    else
      private.zz_tree.place = num;
    end;
    
    tme = ( 1 - alf ) * 0.3;
    
  end;
  
  
  if act ~= 0 then
    ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  end;
end;
-----------------------------------------------------------------------------------
function public.zz_tree.TakeFeather( num )
  
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_crow_take");
  
  local curspos = GetZoomCursorPos();
  curspos[1] = math.floor(curspos[1] - ObjGet("zz_tree").pos_x);
  curspos[2] = math.floor(curspos[2] - ObjGet("zz_tree").pos_y);
  
  private.zz_tree.current = num;
  
  ObjSet("spr_tree_feather_"..num,  { pos_x = curspos[1], pos_y = curspos[2], ang = private.zz_tree.feather_ang[num] });
  ObjAttach("spr_tree_feather_"..num, "obj_tree_fly");
  ObjStartDrag("obj_tree_drag");
  
  public.zz_tree.FocusFeather( num, 0, 1 );
  
  private.zz_tree.current_feather = num;
  
end;
-----------------------------------------------------------------------------------
function public.zz_tree.DragFeather()
  
  local num = private.zz_tree.current;
  
  local curspos = GetZoomCursorPos();
  curspos[1] = math.floor(curspos[1] - ObjGet("zz_tree").pos_x);
  curspos[2] = math.floor(curspos[2] - ObjGet("zz_tree").pos_y);
  
  if curspos[1] > 230 then
    curspos[1] = 230;
  elseif curspos[1] < -230 then
    curspos[1] = -230;
  end;
  
  if curspos[2] > 230 then
    curspos[2] = 230;
  elseif curspos[2] < -230 then
    curspos[2] = -230;
  end;
  
  ObjSet("spr_tree_feather_"..num,  { pos_x = curspos[1], pos_y = curspos[2] });
  
end;
-----------------------------------------------------------------------------------
function public.zz_tree.DopFeather(poss)
  
  local curspos = poss or GetZoomCursorPos();
  if  tostring(GetPlatform()) == "android" then
      curspos[2] = curspos[2] - 100;
    elseif tostring(GetPlatform()) == "ios" then
      if port.isTablet() == 0 then
        curspos[2] = curspos[2] - 75;
      else
        curspos[2] = curspos[2] - 50;
      end;
    end;
  curspos[1] = math.floor(curspos[1] - ObjGet("zz_tree").pos_x);
  curspos[2] = math.floor(curspos[2] - ObjGet("zz_tree").pos_y);
  
  if curspos[1] > 230 then
    curspos[1] = 230;
  elseif curspos[1] < -230 then
    curspos[1] = -230;
  end;
  
  if curspos[2] > 230 then
    curspos[2] = 230;
  elseif curspos[2] < -230 then
    curspos[2] = -230;
  end;
  
  local num = private.zz_tree.current;
  local place = private.zz_tree.place;
  local ind = 0;
  
  DbgTrace("num:"..tostring(num).." place:"..tostring(place));
  
  if place > 0 then
    ind = private.zz_tree.FindInd( place );
  end;
  
  private.zz_tree.current = 0;
  private.zz_tree.place = 0;
  
  local old_ind = private.zz_tree.FindInd( num );
  local typ = num;
  
  local point_a, point_b = {}, {};
  point_a[1] = curspos[1];
  point_a[2] = curspos[2];
  
  if num > 4 then
    typ = num-4;
  end;
  
  if ind > 0 then
    point_b[1] = private.zz_tree.feather_pos[ind][1];
    point_b[2] = private.zz_tree.feather_pos[ind][2];
  else 
    point_b[1] = private.zz_tree.feather_pos[old_ind][1];
    point_b[2] = private.zz_tree.feather_pos[old_ind][2];
  end;
  
  local len = common_impl.math.FindSegmentLength( point_a, point_b );
  local tme = 0.001 * len;
  
  if tme < 0.1 then
    tme = 0.1;
  elseif tme > 0.4 then
    tme = 0.4;
  end;
  
  if ind == 0 or ind == old_ind then
    
    cmn.Lock(1);
    
    local func_after = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_crow_insert");
      
      ObjSet("spr_tree_feather_"..num,  { pos_x = 0, pos_y = 0, ang = 0 });
      ObjAttach("spr_tree_feather_"..num, "obj_tree_feather_"..old_ind.."_"..typ);
      
      private.zz_tree.CheckWin();
      
    end;
    
    ObjAnimate("spr_tree_feather_"..num, "pos_xy", 0, 0, func_after, 
    { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] });
    
  else 
    
    cmn.Lock(1);
    
    private.zz_tree.state[old_ind] = place;
    private.zz_tree.state[ind] = num;
    
    local func_after = function ()
      
      cmn.Lock(0);
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_crow_insert");
  
      ObjSet("spr_tree_feather_"..num,  { pos_x = 0, pos_y = 0, ang = 0 });
      ObjAttach("spr_tree_feather_"..num, "obj_tree_feather_"..ind.."_"..typ);
      
      --public.zz_tree.TakeFeather( place );
      private.zz_tree.current = place;
      public.zz_tree.DopFeather({point_a[1]+ObjGet("zz_tree").pos_x,point_a[2]-100+ ObjGet("zz_tree").pos_y});
      
    end;
    
    ObjAnimate("spr_tree_feather_"..num, "pos_xy", 0, 0, func_after, 
    { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_tree.FindInd( num )
  
  local ind = 0;
  
  for i = 1, 8, 1 do
    
    if private.zz_tree.state[i] == num then
      ind = i;
      break;
    end;
    
  end;
  
  return ind;
  
end;
-----------------------------------------------------------------------------------
function private.zz_tree.CheckWin()
  
  local win_flag = true;
  for i = 1, 8, 1 do
    if private.zz_tree.state[i] ~= i and private.zz_tree.state[i] ~= i-4 and private.zz_tree.state[i] ~= i+4
      then
      public.zz_tree.FocusFeather(private.zz_tree.state[i],0,1);
    else
      public.zz_tree.FocusFeather(private.zz_tree.state[i],1,1);
    end;
  end;
  
  for i = 1, 8, 1 do
    
    if private.zz_tree.state[i] ~= i and private.zz_tree.state[i] ~= i-4 and private.zz_tree.state[i] ~= i+4 then
      win_flag = false;
      break;
    end;
    
  end;
  
  if win_flag then
    
    cmn.Lock( 1 );
    
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_crow_win");
    
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("tree");
    
    local anm_win = function ()
      
      ObjDelete("anm_tree_raven");
      ObjSet("anm_tree_raven_to_figure",  { alp = 1, playing = 1, endtrig = private.zz_tree.Win });
      
    end;

    cmn.Lock( 1 );

    ObjSet("tmr_tree_timer",  { time = 1, playing = 1, endtrig = anm_win });
    
  else
    cmn.Lock(0);
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_tree.Win()
  
  cmn.Lock( 0 );
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_tree" );
  cmn.CallEventHandler( "win_tree" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_tree" ].skip == 0 and ng_global.noskipgames[ "win_tree" ] == nil then

    ng_global.noskipgames[ "win_tree" ] = 1;
    common_impl.CheckAchiev("mg");

  end;
  
end;
--********************************************************************************************************************