-- name=inventory1
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  -- function get_sharpdagger () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_sharpdagger" ] = {

      type = "get",
      get_obj = "spr_complex_dagger_sharpdagger",
      room = "int_complex_inv",
      zz = "inv_complex_dagger",
      zz_gate = "inv_dagger"
  };
  --------------------------------------------------------------------------------------------
  local get_sharpdagger_inv = function ()

    interface.InventoryItemRemove( "inv_dagger" );
    interface.InventoryItemAdd( "inv_sharpdagger", "spr_complex_dagger_sharpdagger" );

    ObjDelete("gfx_complex_dagger_sharpdagger");
    ObjDelete("anm_complex_dagger_action");

  end;
  cmn.AddSubscriber( "get_sharpdagger", get_sharpdagger_inv );
  --------------------------------------------------------------------------------------------
  -- function get_deathfigurine () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_deathfigurine" ] = {

      type = "get",
      get_obj = "spr_complex_stephensbag_deathfigurine",
      room = "int_complex_inv",
      zz = "inv_complex_stephensbag",
      zz_gate = "inv_stephensbag"
  };
  --------------------------------------------------------------------------------------------
  local get_deathfigurine_inv = function ()

    interface.InventoryItemAdd( "inv_deathfigurine", "spr_complex_stephensbag_deathfigurine" );

    ObjDelete("gfx_complex_stephensbag_deathfigurine");
    ObjDelete("spr_complex_stephensbag_deathfigurine_sh");
    
    ObjSet("inv_stephensbag_star_light",  { alp = 0 });
    ObjDelete("spr_complex_stephensbag_amuletbook1_bl");
    
  end;
  cmn.AddSubscriber( "get_deathfigurine", get_deathfigurine_inv );

  --------------------------------------------------------------------------------------------
  -- function get_magnifier () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_magnifier" ] = {

      type = "get",
      get_obj = "spr_complex_stephensbag_magnifier",
      room = "int_complex_inv",
      zz = "inv_complex_stephensbag",
      zz_gate = "inv_stephensbag"
  };
  --------------------------------------------------------------------------------------------
  local get_magnifier_inv = function ()

    if cmn.IsEventDone("get_pipe") then
      interface.InventoryItemRemove( "inv_stephensbag" );
    end;
    interface.InventoryItemAdd( "inv_magnifier", "spr_complex_stephensbag_magnifier" );
    
    ObjSet("inv_crackedstone_star_light",  { alp = 1 });

    ObjDelete("gfx_complex_stephensbag_magnifier");
    ObjDelete("spr_complex_stephensbag_magnifier_sh");

  end;
  cmn.AddSubscriber( "get_magnifier", get_magnifier_inv );
  --------------------------------------------------------------------------------------------
  -- function get_pipe () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_pipe" ] = {

      type = "get",
      get_obj = "spr_complex_stephensbag_pipe",
      room = "int_complex_inv",
      zz = "inv_complex_stephensbag",
      zz_gate = "inv_stephensbag"
  };
  --------------------------------------------------------------------------------------------
  local get_pipe_inv = function ()

    if cmn.IsEventDone("get_magnifier") then
      interface.InventoryItemRemove( "inv_stephensbag" );
    end;
    interface.InventoryItemAdd( "inv_pipe", "spr_complex_stephensbag_pipe" );
    
    ObjSet("inv_crackedstone_star_light",  { alp = 1 });

    ObjDelete("gfx_complex_stephensbag_pipe");
    ObjDelete("spr_complex_stephensbag_pipe_sh");

  end;
  cmn.AddSubscriber( "get_pipe", get_pipe_inv );
  --------------------------------------------------------------------------------------------
  -- function get_shippart () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_shippart" ] = {

      type = "get",
      get_obj = "spr_complex_stephensbag_shippart",
      room = "int_complex_inv",
      zz = "inv_complex_stephensbag",
      zz_gate = "inv_stephensbag"
  };
  --------------------------------------------------------------------------------------------
  local get_shippart_inv = function ()

    interface.InventoryItemAdd( "inv_shippart", "spr_complex_stephensbag_shippart" );

    ObjDelete("gfx_complex_stephensbag_shippart");
    ObjDelete("spr_complex_stephensbag_shippart_sh");

  end;
  cmn.AddSubscriber( "get_shippart", get_shippart_inv );
  --------------------------------------------------------------------------------------------
  -- function get_gargoylepart1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_gargoylepart1" ] = {

      type = "get",
      get_obj = "spr_complex_puppet_gargoylepart1",
      room = "int_complex_inv",
      zz = "inv_complex_puppet",
      zz_gate = "inv_puppet"
  };
  --------------------------------------------------------------------------------------------
  local get_gargoylepart1_inv = function ()

    interface.InventoryItemAdd( "inv_gargoylepart", "spr_complex_puppet_gargoylepart1", function () cmn.GetMultyObject( 'gargoylepart', 3 ); end );
    
    if (not cmn.IsEventDone("get_puppethead") or cmn.IsEventDone("use_puppethead")) and (not cmn.IsEventDone("get_puppetarm") or cmn.IsEventDone("use_puppetarm")) then
      ObjSet("inv_puppet_star_light",  { alp = 0 });
    end;
      
    ObjDelete("gfx_complex_puppet_gargoylepart1");
    ObjDelete("spr_complex_puppet_gargoylepart1_sh");

  end;
  cmn.AddSubscriber( "get_gargoylepart1", get_gargoylepart1_inv );
  --------------------------------------------------------------------------------------------
  -- function get_fixedpuppet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_fixedpuppet" ] = {

      type = "get",
      get_obj = "obj_complex_puppet_fixedpuppet",
      room = "int_complex_inv",
      zz = "inv_complex_puppet",
      zz_gate = "inv_puppet"
  };
  --------------------------------------------------------------------------------------------
  local get_fixedpuppet_inv = function ()

    interface.InventoryItemRemove( "inv_puppet" );
    interface.InventoryItemAdd( "inv_fixedpuppet", "obj_complex_puppet_fixedpuppet" );

    ObjDelete("gfx_complex_puppet_fixedpuppet");

  end;
  cmn.AddSubscriber( "get_fixedpuppet", get_fixedpuppet_inv );
  --------------------------------------------------------------------------------------------
  -- function get_igrune () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_igrune" ] = {

      type = "get",
      get_obj = "spr_complex_spider_igrune",
      room = "int_complex_inv",
      zz = "inv_complex_spider",
      zz_gate = "inv_spider"
  };
  --------------------------------------------------------------------------------------------
  local get_igrune_inv = function ()
    
    interface.InventoryItemAdd( "inv_igrune", "spr_complex_spider_igrune" );
    ObjSet("inv_spider_star_light",  { alp = 0 });

    ObjDelete("gfx_complex_spider_igrune");
    ObjDelete("spr_complex_spider_igrune_bl");
    ObjDelete("spr_complex_spider_igrune_bl_2");

  end;
  cmn.AddSubscriber( "get_igrune", get_igrune_inv );
  --------------------------------------------------------------------------------------------
  -- function get_webspider () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_webspider" ] = {

      type = "get",
      get_obj = "obj_complex_spider_webspider",
      room = "int_complex_inv",
      zz = "inv_complex_spider",
      zz_gate = "inv_spider"
  };
  --------------------------------------------------------------------------------------------
  local get_webspider_inv = function ()

    interface.InventoryItemRemove( "inv_spider" );
    interface.InventoryItemAdd( "inv_webspider", "obj_complex_spider_webspider" );

    ObjDelete("gfx_complex_spider_webspider");

  end;
  cmn.AddSubscriber( "get_webspider", get_webspider_inv );
  --------------------------------------------------------------------------------------------
  -- function get_detail1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_detail1" ] = {

      type = "get",
      get_obj = "spr_complex_crackedstone_detail2",
      room = "int_complex_inv",
      zz = "inv_complex_crackedstone",
      zz_gate = "inv_crackedstone"
  };
  --------------------------------------------------------------------------------------------
  local get_detail1_inv = function ()

    interface.InventoryItemAdd( "inv_detail", "spr_complex_crackedstone_detail2", function () cmn.GetMultyObject( 'detail', 3 ); end  );
    ObjSet("inv_crackedstone_star_light",  { alp = 0 });

    ObjDelete("gfx_complex_crackedstone_detail2");
    ObjDelete( "spr_complex_crackedstone_detail2_shadow" );

  end;
  cmn.AddSubscriber( "get_detail1", get_detail1_inv );
  --------------------------------------------------------------------------------------------
  -- function get_rubyheart () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_rubyheart" ] = {

      type = "get",
      get_obj = "spr_complex_crackedstone_rubyheart",
      room = "int_complex_inv",
      zz = "inv_complex_crackedstone",
      zz_gate = "inv_crackedstone"
  };
  --------------------------------------------------------------------------------------------
  local get_rubyheart_inv = function ()

    interface.InventoryItemRemove( "inv_crackedstone" );
    interface.InventoryItemAdd( "inv_rubyheart", "spr_complex_crackedstone_rubyheart" );

    ObjDelete("gfx_complex_crackedstone_rubyheart");
    ObjDelete("spr_complex_crackedstone_rubyheart_shadow");

  end;
  cmn.AddSubscriber( "get_rubyheart", get_rubyheart_inv );
  --------------------------------------------------------------------------------------------
  -- function get_photo () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_photo" ] = {

      type = "get",
      get_obj = "obj_complex_photobasis_photo",
      room = "int_complex_inv",
      zz = "inv_complex_photobasis",
      zz_gate = "inv_photobasis"
  };
  --------------------------------------------------------------------------------------------
  local get_photo_inv = function ()

    interface.InventoryItemRemove( "inv_photobasis" );
    interface.InventoryItemAdd( "inv_photo", "obj_complex_photobasis_photo" );

    ObjDelete("gfx_complex_photobasis_photo");

  end;
  cmn.AddSubscriber( "get_photo", get_photo_inv );
  --------------------------------------------------------------------------------------------
  -- function get_resin () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_resin" ] = {
        type = "get",
        get_obj = "obj_complex_bottlewithresin_resin",
        room = "int_complex_inv",
        zz = "inv_complex_bottlewithresin",
        zz_gate = "inv_bottlewithresin"
    };
    --------------------------------------------------------------------------------------------
  local get_resin_inv = function ()
  
    interface.InventoryItemAdd( "inv_resin", "obj_complex_bottlewithresin_resin" );
    interface.InventoryItemRemove( "inv_bottlewithresin" );
    
    ObjDelete("gfx_complex_bottlewithresin_resin");
  
  end;
  cmn.AddSubscriber( "get_resin", get_resin_inv );

  
  --------------------------------------------------------------------------------------------
  -- function use_oil () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_oil" ] = {

      type = "use",
      inv_obj = "inv_oil",
      use_place = "obj_complex_dagger_use_oil",
      room = "int_complex_inv",
      zz = "inv_complex_dagger",
      zz_gate = "inv_dagger"
  };
  --------------------------------------------------------------------------------------------
  local use_oil_inv = function ()

    interface.InventoryItemRemove( "inv_oil" );

  end;
  local use_oil_beg = function ()

    ObjDelete( "obj_complex_dagger_use_oil" );

  end;
  local use_oil_end = function ()

    ObjMultiSet( { {"anm_complex_dagger_action", { animfunc = "func_take_dagger", frame = 300 }},
                   {"spr_complex_dagger_sharpdagger", { input = 1 }},
                   {"gfx_complex_dagger_sharpdagger", { alp = 1, active = 1 }} } );
    
  end;
  cmn.AddSubscriber( "use_oil", use_oil_inv );
  cmn.AddSubscriber( "use_oil", use_oil_beg, "inv_complex_dagger" );
  cmn.AddSubscriber( "use_oil", use_oil_end, "inv_complex_dagger" );
  cmn.AddSubscriber( "use_oil_inv", use_oil_inv );
  cmn.AddSubscriber( "use_oil_beg", use_oil_beg, "inv_complex_dagger" );
  cmn.AddSubscriber( "use_oil_end", use_oil_end, "inv_complex_dagger" );
  --------------------------------------------------------------------------------------------
  -- function use_amuletbag () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_amuletbag" ] = {

      type = "use",
      inv_obj = "inv_amuletbag",
      use_place = "obj_complex_stephensbag_use_amuletbag",
      room = "int_complex_inv",
      zz = "inv_complex_stephensbag",
      zz_gate = "inv_stephensbag"
  };
  --------------------------------------------------------------------------------------------
  local use_amuletbag_inv = function ()

    interface.InventoryItemRemove( "inv_amuletbag" );

  end;
  local use_amuletbag_beg = function ()

    ObjDelete( "obj_complex_stephensbag_use_amuletbag" );
    ObjDelete( "anm_complex_stephensbag_bag_touch" );

  end;
  local use_amuletbag_end = function ()

    ObjSet("anm_complex_stephensbag_bag_open",  { alp = 1, input = 1, frame = 400 });
    
  end;
  cmn.AddSubscriber( "use_amuletbag", use_amuletbag_inv );
  cmn.AddSubscriber( "use_amuletbag", use_amuletbag_beg, "inv_complex_stephensbag" );
  cmn.AddSubscriber( "use_amuletbag", use_amuletbag_end, "inv_complex_stephensbag" );
  cmn.AddSubscriber( "use_amuletbag_inv", use_amuletbag_inv );
  cmn.AddSubscriber( "use_amuletbag_beg", use_amuletbag_beg, "inv_complex_stephensbag" );
  cmn.AddSubscriber( "use_amuletbag_end", use_amuletbag_end, "inv_complex_stephensbag" );
  --------------------------------------------------------------------------------------------
  -- function use_puppetarm () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_puppetarm" ] = {

      type = "use",
      inv_obj = "inv_puppetarm",
      use_place = "obj_complex_puppet_use_puppetarm",
      room = "int_complex_inv",
      zz = "inv_complex_puppet",
      zz_gate = "inv_puppet"
  };
  --------------------------------------------------------------------------------------------
  local use_puppetarm_inv = function ()

    interface.InventoryItemRemove( "inv_puppetarm" );
    
    if (not cmn.IsEventDone("get_puppethead") or cmn.IsEventDone("use_puppethead")) and 
       (not cmn.IsEventDone("get_thread") or cmn.IsEventDone("use_thread")) and
        not(cmn.IsEventDone("use_puppethead") and cmn.IsEventDone("use_thread"))  then
      ObjSet("inv_puppet_star_light",  { alp = 0 });
    end;

  end;
  local use_puppetarm_beg = function ()

    ObjDelete( "obj_complex_puppet_use_puppetarm" );
    ObjSet("spr_complex_puppet_hand_1",  { alp = 1 });
    
  end;
  local use_puppetarm_end = function ()
    
    ObjDelete( "anm_complex_puppet_use_hand" );
    
    if cmn.IsEventDone("use_puppethead") then
      ObjSet("obj_complex_puppet_use_thread",  { input = 1 });
    else 
      ObjSet("spr_complex_puppet_hand_2",  { alp = 1 });
    end;
    
    if cmn.IsEventDone("use_puppethead") and cmn.IsEventDone("use_thread") then
      ObjDelete("spr_complex_puppet_strings_1");
      ObjMultiSet( { {"spr_complex_puppet_threads", { alp = 1 }},
                     {"obj_complex_puppet_fixedpuppet", { input = 1 }},
                     {"gfx_complex_puppet_fixedpuppet", { alp = 1, active = 1 }} } );
    end;
    
  end;
  cmn.AddSubscriber( "use_puppetarm", use_puppetarm_inv );
  cmn.AddSubscriber( "use_puppetarm", use_puppetarm_beg, "inv_complex_puppet" );
  cmn.AddSubscriber( "use_puppetarm", use_puppetarm_end, "inv_complex_puppet" );
  cmn.AddSubscriber( "use_puppetarm_inv", use_puppetarm_inv );
  cmn.AddSubscriber( "use_puppetarm_beg", use_puppetarm_beg, "inv_complex_puppet" );
  cmn.AddSubscriber( "use_puppetarm_end", use_puppetarm_end, "inv_complex_puppet" );
  --------------------------------------------------------------------------------------------
  -- function use_puppethead () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_puppethead" ] = {

      type = "use",
      inv_obj = "inv_puppethead",
      use_place = "obj_complex_puppet_use_puppethead",
      room = "int_complex_inv",
      zz = "inv_complex_puppet",
      zz_gate = "inv_puppet"
  };
  --------------------------------------------------------------------------------------------
  local use_puppethead_inv = function ()

    interface.InventoryItemRemove( "inv_puppethead" );
    
    if (not cmn.IsEventDone("get_puppetarm") or cmn.IsEventDone("use_puppetarm")) and 
       (not cmn.IsEventDone("get_thread") or cmn.IsEventDone("use_thread")) and
        not(cmn.IsEventDone("use_puppetarm") and cmn.IsEventDone("use_thread"))  then
      ObjSet("inv_puppet_star_light",  { alp = 0 });
    end;

  end;
  local use_puppethead_beg = function ()

    ObjDelete( "obj_complex_puppet_use_puppethead" );
    
    ObjMultiSet( { {"spr_complex_puppet_head_1", { alp = 1 }},
                   {"spr_complex_puppet_head_2", { alp = 1 }},
                   {"spr_complex_puppet_head_3", { alp = 1 }} } );
    
  end;
  local use_puppethead_end = function ()
    
    ObjDelete( "anm_complex_puppet_use_head" );

    if cmn.IsEventDone("use_puppetarm") then
      ObjSet("obj_complex_puppet_use_thread",  { input = 1 });
    else 
      ObjMultiSet( { {"spr_complex_puppet_head_4", { alp = 1 }},
                     {"spr_complex_puppet_head_5", { alp = 1 }},
                     {"spr_complex_puppet_head_6", { alp = 1 }} } );
    end;
                   
    if cmn.IsEventDone("use_puppetarm") and cmn.IsEventDone("use_thread") then
      ObjDelete("spr_complex_puppet_strings_1");
      ObjMultiSet( { {"spr_complex_puppet_threads", { alp = 1 }},
                     {"obj_complex_puppet_fixedpuppet", { input = 1 }},
                     {"gfx_complex_puppet_fixedpuppet", { alp = 1, active = 1 }} } );
    end;
    
  end;
  cmn.AddSubscriber( "use_puppethead", use_puppethead_inv );
  cmn.AddSubscriber( "use_puppethead", use_puppethead_beg, "inv_complex_puppet" );
  cmn.AddSubscriber( "use_puppethead", use_puppethead_end, "inv_complex_puppet" );
  cmn.AddSubscriber( "use_puppethead_inv", use_puppethead_inv );
  cmn.AddSubscriber( "use_puppethead_beg", use_puppethead_beg, "inv_complex_puppet" );
  cmn.AddSubscriber( "use_puppethead_end", use_puppethead_end, "inv_complex_puppet" );
  --------------------------------------------------------------------------------------------
  -- function use_thread () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_thread" ] = {

      type = "use",
      inv_obj = "inv_thread",
      use_place = "obj_complex_puppet_use_thread",
      room = "int_complex_inv",
      zz = "inv_complex_puppet",
      zz_gate = "inv_puppet"
  };
  --------------------------------------------------------------------------------------------
  local use_thread_inv = function ()

    interface.InventoryItemRemove( "inv_thread" );
    
    if (not cmn.IsEventDone("get_puppetarm") or cmn.IsEventDone("use_puppetarm")) and 
       (not cmn.IsEventDone("get_puppethead") or cmn.IsEventDone("use_puppethead")) and
        not(cmn.IsEventDone("use_puppetarm") and cmn.IsEventDone("use_puppethead"))  then
      ObjSet("inv_puppet_star_light",  { alp = 0 });
    end;

  end;
  local use_thread_beg = function ()

    ObjDelete( "obj_complex_puppet_use_thread" );

  end;
  local use_thread_end = function ()
    
    if cmn.IsEventDone("use_puppetarm") and cmn.IsEventDone("use_puppethead") then
      ObjDelete("spr_complex_puppet_strings_1");
      ObjMultiSet( { {"spr_complex_puppet_threads", { alp = 1 }},
                     {"obj_complex_puppet_fixedpuppet", { input = 1 }},
                     {"gfx_complex_puppet_fixedpuppet", { alp = 1, active = 1 }} } );
    else
      ObjSet("spr_complex_puppet_strings_1",  { alp = 1 });               
    end;
    
  end;
  cmn.AddSubscriber( "use_thread", use_thread_inv );
  cmn.AddSubscriber( "use_thread", use_thread_beg, "inv_complex_puppet" );
  cmn.AddSubscriber( "use_thread", use_thread_end, "inv_complex_puppet" );
  cmn.AddSubscriber( "use_thread_inv", use_thread_inv );
  cmn.AddSubscriber( "use_thread_beg", use_thread_beg, "inv_complex_puppet" );
  cmn.AddSubscriber( "use_thread_end", use_thread_end, "inv_complex_puppet" );
  --------------------------------------------------------------------------------------------
  -- function use_paw1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_paw1" ] = {

      type = "use",
      inv_obj = "inv_paw1",
      use_place = "obj_complex_spider_use_paw1",
      room = "int_complex_inv",
      zz = "inv_complex_spider",
      zz_gate = "inv_spider"
  };
  --------------------------------------------------------------------------------------------
  local use_paw1_inv = function ()

    interface.InventoryItemRemove( "inv_paw1" );
    
    if (not cmn.IsEventDone("get_paw2") or cmn.IsEventDone("use_paw2")) and 
       (not cmn.IsEventDone("get_dog") or cmn.IsEventDone("use_dog")) and
        not(cmn.IsEventDone("use_paw2") and cmn.IsEventDone("use_dog"))  then
      ObjSet("inv_spider_star_light",  { alp = 0 });
    end;

  end;
  local use_paw1_beg = function ()

    ObjDelete( "obj_complex_spider_use_paw1" );

  end;
  local use_paw1_end = function ()
    
    ObjSet("anm_complex_spider_paw_1",  { frame = 0, animfunc = "func_clk_leg_1" });

    if cmn.IsEventDone("use_paw2") and cmn.IsEventDone("use_dog") then
      ObjMultiSet( { {"obj_complex_spider_webspider", { input = 1 }},
                     {"gfx_complex_spider_webspider", { active = 1, visible = 1 }} } );
    end;
    
  end;
  cmn.AddSubscriber( "use_paw1", use_paw1_inv );
  cmn.AddSubscriber( "use_paw1", use_paw1_beg, "inv_complex_spider" );
  cmn.AddSubscriber( "use_paw1", use_paw1_end, "inv_complex_spider" );
  cmn.AddSubscriber( "use_paw1_inv", use_paw1_inv );
  cmn.AddSubscriber( "use_paw1_beg", use_paw1_beg, "inv_complex_spider" );
  cmn.AddSubscriber( "use_paw1_end", use_paw1_end, "inv_complex_spider" );
  --------------------------------------------------------------------------------------------
  -- function use_paw2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_paw2" ] = {

      type = "use",
      inv_obj = "inv_paw2",
      use_place = "obj_complex_spider_use_paw2",
      room = "int_complex_inv",
      zz = "inv_complex_spider",
      zz_gate = "inv_spider"
  };
  --------------------------------------------------------------------------------------------
  local use_paw2_inv = function ()

    interface.InventoryItemRemove( "inv_paw2" );
    
    if (not cmn.IsEventDone("get_paw1") or cmn.IsEventDone("use_paw1")) and 
       (not cmn.IsEventDone("get_dog") or cmn.IsEventDone("use_dog")) and
       not(cmn.IsEventDone("use_paw1") and cmn.IsEventDone("use_dog"))  then
      ObjSet("inv_spider_star_light",  { alp = 0 });
    end;

  end;
  local use_paw2_beg = function ()

    ObjDelete( "obj_complex_spider_use_paw2" );

  end;
  local use_paw2_end = function ()
    
    ObjSet("anm_complex_spider_paw_2",  { frame = 0, animfunc = "func_clk_leg_2" });

    if cmn.IsEventDone("use_paw1") and cmn.IsEventDone("use_dog") then
      ObjMultiSet( { {"obj_complex_spider_webspider", { input = 1 }},
                     {"gfx_complex_spider_webspider", { active = 1, visible = 1 }} } );
    end;
    
  end;
  cmn.AddSubscriber( "use_paw2", use_paw2_inv );
  cmn.AddSubscriber( "use_paw2", use_paw2_beg, "inv_complex_spider" );
  cmn.AddSubscriber( "use_paw2", use_paw2_end, "inv_complex_spider" );
  cmn.AddSubscriber( "use_paw2_inv", use_paw2_inv );
  cmn.AddSubscriber( "use_paw2_beg", use_paw2_beg, "inv_complex_spider" );
  cmn.AddSubscriber( "use_paw2_end", use_paw2_end, "inv_complex_spider" );
  --------------------------------------------------------------------------------------------
  -- function use_dog () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_dog" ] = {

      type = "use",
      inv_obj = "inv_dog",
      use_place = "obj_complex_spider_use_dog",
      room = "int_complex_inv",
      zz = "inv_complex_spider",
      zz_gate = "inv_spider"
  };
  --------------------------------------------------------------------------------------------
  local use_dog_inv = function ()

    interface.InventoryItemRemove( "inv_dog" );
    
    if (not cmn.IsEventDone("get_paw2") or cmn.IsEventDone("use_paw2")) and 
       (not cmn.IsEventDone("get_paw1") or cmn.IsEventDone("use_paw1")) and
        not(cmn.IsEventDone("use_paw2") and cmn.IsEventDone("use_paw1"))  then
      ObjSet("inv_spider_star_light",  { alp = 0 });
    end;

  end;
  local use_dog_beg = function ()

    ObjDelete( "obj_complex_spider_use_dog" );

  end;
  local use_dog_end = function ()
    
    ObjSet("obj_complex_spider_at",  { alp = 1 });

    if cmn.IsEventDone("use_paw1") and cmn.IsEventDone("use_paw2") then
      ObjMultiSet( { {"obj_complex_spider_webspider", { input = 1 }},
                     {"gfx_complex_spider_webspider", { active = 1, visible = 1 }} } );
    end;
    
  end;
  cmn.AddSubscriber( "use_dog", use_dog_inv );
  cmn.AddSubscriber( "use_dog", use_dog_beg, "inv_complex_spider" );
  cmn.AddSubscriber( "use_dog", use_dog_end, "inv_complex_spider" );
  cmn.AddSubscriber( "use_dog_inv", use_dog_inv );
  cmn.AddSubscriber( "use_dog_beg", use_dog_beg, "inv_complex_spider" );
  cmn.AddSubscriber( "use_dog_end", use_dog_end, "inv_complex_spider" );
  --------------------------------------------------------------------------------------------
  -- function use_magnifier () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_magnifier" ] = {

      type = "use",
      inv_obj = "inv_magnifier",
      use_place = "obj_complex_crackedstone_use_magnifier",
      room = "int_complex_inv",
      zz = "inv_complex_crackedstone",
      zz_gate = "inv_crackedstone"
  };
  --------------------------------------------------------------------------------------------
  local use_magnifier_inv = function ()

    interface.InventoryItemRemove( "inv_magnifier" );
    
    if not cmn.IsEventDone("get_pipe") then
      ObjSet("inv_crackedstone_star_light",  { alp = 0 });
    end;

  end;
  local use_magnifier_beg = function ()

    ObjDelete( "obj_complex_crackedstone_use_magnifier" );

    ObjMultiSet( {
      { "obj_complex_crackedstone_grid", { input = true } },
      { "spr_complex_crackedstone_magnifer", { input = true } }
    } );

  end;
  local use_magnifier_end = function ()

    ObjMultiSet( {
      { "spr_complex_crackedstone_magnifer", { alp = 1 } },
      { "anm_complex_crackedstone_grid", { frame = 118 } }
    } );
    
  end;
  cmn.AddSubscriber( "use_magnifier", use_magnifier_inv );
  cmn.AddSubscriber( "use_magnifier", use_magnifier_beg, "inv_complex_crackedstone" );
  cmn.AddSubscriber( "use_magnifier", use_magnifier_end, "inv_complex_crackedstone" );
  cmn.AddSubscriber( "use_magnifier_inv", use_magnifier_inv );
  cmn.AddSubscriber( "use_magnifier_beg", use_magnifier_beg, "inv_complex_crackedstone" );
  cmn.AddSubscriber( "use_magnifier_end", use_magnifier_end, "inv_complex_crackedstone" );
  --------------------------------------------------------------------------------------------
  -- function use_dragmagnifier1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_dragmagnifier1" ] = {
      type = "use",
      inv_obj = "spr_complex_crackedstone_magnifer",
      use_place = "spr_complex_crackedstone_select1",
      room = "int_complex_inv",
      zz = "inv_complex_crackedstone",
      zz_gate = "inv_crackedstone"
  };
  --------------------------------------------------------------------------------------------
  local use_dragmagnifier1 = function ()
    ObjSet( "spr_complex_crackedstone_select1", { alp = 1 } );
  end;
  cmn.AddSubscriber( "use_dragmagnifier1", use_dragmagnifier1, "inv_complex_crackedstone" );
  --------------------------------------------------------------------------------------------
  -- function use_dragmagnifier2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_dragmagnifier2" ] = {
      type = "use",
      inv_obj = "spr_complex_crackedstone_magnifer",
      use_place = "spr_complex_crackedstone_select2",
      room = "int_complex_inv",
      zz = "inv_complex_crackedstone",
      zz_gate = "inv_crackedstone"
  };
  --------------------------------------------------------------------------------------------
  local use_dragmagnifier2 = function ()
    ObjSet( "spr_complex_crackedstone_select2", { alp = 1 } );
  end;
  cmn.AddSubscriber( "use_dragmagnifier2", use_dragmagnifier2, "inv_complex_crackedstone" );
  --------------------------------------------------------------------------------------------
  -- function use_dragmagnifier3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_dragmagnifier3" ] = {
      type = "use",
      inv_obj = "spr_complex_crackedstone_magnifer",
      use_place = "spr_complex_crackedstone_select3",
      room = "int_complex_inv",
      zz = "inv_complex_crackedstone",
      zz_gate = "inv_crackedstone"
  };
  --------------------------------------------------------------------------------------------
  local use_dragmagnifier3 = function ()
    ObjSet( "spr_complex_crackedstone_select3", { alp = 1 } );
  end;
  cmn.AddSubscriber( "use_dragmagnifier3", use_dragmagnifier3, "inv_complex_crackedstone" );
  --------------------------------------------------------------------------------------------
  -- function use_dragmagnifier4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_dragmagnifier4" ] = {
      type = "use",
      inv_obj = "spr_complex_crackedstone_magnifer",
      use_place = "spr_complex_crackedstone_select4",
      room = "int_complex_inv",
      zz = "inv_complex_crackedstone",
      zz_gate = "inv_crackedstone"
  };
  --------------------------------------------------------------------------------------------
  local use_dragmagnifier4 = function ()

    ObjSet( "spr_complex_crackedstone_select4", { alp = 1 } );

    if ( cmn.IsEventDone( "use_dragmagnifier1" ) and cmn.IsEventDone( "use_dragmagnifier2" )
    and  cmn.IsEventDone( "use_dragmagnifier3" ) and cmn.IsEventDone( "use_dragmagnifier4" ) ) then
      ObjDelete( "spr_complex_crackedstone_magnifer" );
      ObjSet( "obj_complex_crackedstone_use_pipe", { input = true } );
    end;

  end;
  cmn.AddSubscriber( "use_dragmagnifier4", use_dragmagnifier4, "inv_complex_crackedstone" );
  --------------------------------------------------------------------------------------------
  -- function use_pipe () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_pipe" ] = {

      type = "use",
      inv_obj = "inv_pipe",
      use_place = "obj_complex_crackedstone_use_pipe",
      room = "int_complex_inv",
      zz = "inv_complex_crackedstone",
      zz_gate = "inv_crackedstone"
  };
  --------------------------------------------------------------------------------------------
  local use_pipe_inv = function ()

    interface.InventoryItemRemove( "inv_pipe" );
    
    if not cmn.IsEventDone("get_magnifier") then
      ObjSet("inv_crackedstone_star_light",  { alp = 0 });
    end;

  end;
  local use_pipe_beg = function ()

    ObjDelete( "obj_complex_crackedstone_use_pipe" );

  end;
  local use_pipe_end = function ()

    if ( cmn.IsEventDone( "use_dragmagnifier1" ) and cmn.IsEventDone( "use_dragmagnifier2" )
    and  cmn.IsEventDone( "use_dragmagnifier3" ) and cmn.IsEventDone( "use_dragmagnifier4" ) ) then

      ObjDelete( "obj_complex_crackedstone_grid" );
      ObjDelete( "anm_complex_crackedstone_stone_clk" );
      ObjDelete( "spr_complex_crackedstone_pipe" );

      ObjSet( "spr_complex_crackedstone_rubyheart", { input = 1 } );

    else

      ObjSet( "spr_complex_crackedstone_pipe", { alp = 1 } );

    end;

  end;
  cmn.AddSubscriber( "use_pipe", use_pipe_inv );
  cmn.AddSubscriber( "use_pipe", use_pipe_beg, "inv_complex_crackedstone" );
  cmn.AddSubscriber( "use_pipe", use_pipe_end, "inv_complex_crackedstone" );
  cmn.AddSubscriber( "use_pipe_inv", use_pipe_inv );
  cmn.AddSubscriber( "use_pipe_beg", use_pipe_beg, "inv_complex_crackedstone" );
  cmn.AddSubscriber( "use_pipe_end", use_pipe_end, "inv_complex_crackedstone" );
  --------------------------------------------------------------------------------------------
  -- function use_photopart1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_photopart1" ] = {

      type = "use",
      inv_obj = "inv_photopart1",
      use_place = "obj_complex_photobasis_use_photopart1",
      room = "int_complex_inv",
      zz = "inv_complex_photobasis",
      zz_gate = "inv_photobasis"
  };
  --------------------------------------------------------------------------------------------
  local use_photopart1_inv = function ()

    interface.InventoryItemRemove( "inv_photopart1" );
    
    if (not cmn.IsEventDone("get_photopart2") or cmn.IsEventDone("use_photopart2")) and 
       (not cmn.IsEventDone("get_photopart3") or cmn.IsEventDone("use_photopart3")) and 
       (not cmn.IsEventDone("get_photopart4") or cmn.IsEventDone("use_photopart4")) and
        not(cmn.IsEventDone("use_photopart2") and cmn.IsEventDone("use_photopart3") and cmn.IsEventDone("use_photopart4"))  then
      ObjSet("inv_photobasis_star_light",  { alp = 0 });
    end;

  end;
  local use_photopart1_beg = function ()

    ObjDelete( "obj_complex_photobasis_use_photopart1" );

  end;
  local use_photopart1_end = function ()
    
    ObjSet("obj_complex_photobasis_photo_part_1",  { alp = 1 });

    if cmn.IsEventDone("use_photopart2") and cmn.IsEventDone("use_photopart2") and cmn.IsEventDone("use_photopart4") then 
      ObjMultiSet( { {"obj_complex_photobasis_photo", { input = 1 }},
                     {"gfx_complex_photobasis_photo", { active = 1, visible = 1 }} } );
    end;
    
  end;
  cmn.AddSubscriber( "use_photopart1", use_photopart1_inv );
  cmn.AddSubscriber( "use_photopart1", use_photopart1_beg, "inv_complex_photobasis" );
  cmn.AddSubscriber( "use_photopart1", use_photopart1_end, "inv_complex_photobasis" );
  cmn.AddSubscriber( "use_photopart1_inv", use_photopart1_inv );
  cmn.AddSubscriber( "use_photopart1_beg", use_photopart1_beg, "inv_complex_photobasis" );
  cmn.AddSubscriber( "use_photopart1_end", use_photopart1_end, "inv_complex_photobasis" );
  --------------------------------------------------------------------------------------------
  -- function use_photopart2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_photopart2" ] = {

      type = "use",
      inv_obj = "inv_photopart2",
      use_place = "obj_complex_photobasis_use_photopart2",
      room = "int_complex_inv",
      zz = "inv_complex_photobasis",
      zz_gate = "inv_photobasis"
  };
  --------------------------------------------------------------------------------------------
  local use_photopart2_inv = function ()

    interface.InventoryItemRemove( "inv_photopart2" );
    
    if (not cmn.IsEventDone("get_photopart1") or cmn.IsEventDone("use_photopart1")) and 
       (not cmn.IsEventDone("get_photopart3") or cmn.IsEventDone("use_photopart3")) and 
       (not cmn.IsEventDone("get_photopart4") or cmn.IsEventDone("use_photopart4")) and
        not(cmn.IsEventDone("use_photopart1") and cmn.IsEventDone("use_photopart3") and cmn.IsEventDone("use_photopart4"))  then
      ObjSet("inv_photobasis_star_light",  { alp = 0 });
    end;

  end;
  local use_photopart2_beg = function ()

    ObjDelete( "obj_complex_photobasis_use_photopart2" );

  end;
  local use_photopart2_end = function ()
    
    ObjSet("obj_complex_photobasis_photo_part_2",  { alp = 1 });

    if cmn.IsEventDone("use_photopart1") and cmn.IsEventDone("use_photopart3") and cmn.IsEventDone("use_photopart4") then 
      ObjMultiSet( { {"obj_complex_photobasis_photo", { input = 1 }},
                     {"gfx_complex_photobasis_photo", { active = 1, visible = 1 }} } );
    end;
    
  end;
  cmn.AddSubscriber( "use_photopart2", use_photopart2_inv );
  cmn.AddSubscriber( "use_photopart2", use_photopart2_beg, "inv_complex_photobasis" );
  cmn.AddSubscriber( "use_photopart2", use_photopart2_end, "inv_complex_photobasis" );
  cmn.AddSubscriber( "use_photopart2_inv", use_photopart2_inv );
  cmn.AddSubscriber( "use_photopart2_beg", use_photopart2_beg, "inv_complex_photobasis" );
  cmn.AddSubscriber( "use_photopart2_end", use_photopart2_end, "inv_complex_photobasis" );
  --------------------------------------------------------------------------------------------
  -- function use_photopart3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_photopart3" ] = {

      type = "use",
      inv_obj = "inv_photopart3",
      use_place = "obj_complex_photobasis_use_photopart3",
      room = "int_complex_inv",
      zz = "inv_complex_photobasis",
      zz_gate = "inv_photobasis"
  };
  --------------------------------------------------------------------------------------------
  local use_photopart3_inv = function ()

    interface.InventoryItemRemove( "inv_photopart3" );
    
    if (not cmn.IsEventDone("get_photopart1") or cmn.IsEventDone("use_photopart1")) and 
       (not cmn.IsEventDone("get_photopart2") or cmn.IsEventDone("use_photopart2")) and 
       (not cmn.IsEventDone("get_photopart4") or cmn.IsEventDone("use_photopart4")) and
        not(cmn.IsEventDone("use_photopart1") and cmn.IsEventDone("use_photopart2") and cmn.IsEventDone("use_photopart4"))  then
      ObjSet("inv_photobasis_star_light",  { alp = 0 });
    end;

  end;
  local use_photopart3_beg = function ()

    ObjDelete( "obj_complex_photobasis_use_photopart3" );

  end;
  local use_photopart3_end = function ()
    
    ObjSet("obj_complex_photobasis_photo_part_3",  { alp = 1 });

    if cmn.IsEventDone("use_photopart2") and cmn.IsEventDone("use_photopart1") and cmn.IsEventDone("use_photopart4") then 
      ObjMultiSet( { {"obj_complex_photobasis_photo", { input = 1 }},
                     {"gfx_complex_photobasis_photo", { active = 1, visible = 1 }} } );
    end;
    
  end;
  cmn.AddSubscriber( "use_photopart3", use_photopart3_inv );
  cmn.AddSubscriber( "use_photopart3", use_photopart3_beg, "inv_complex_photobasis" );
  cmn.AddSubscriber( "use_photopart3", use_photopart3_end, "inv_complex_photobasis" );
  cmn.AddSubscriber( "use_photopart3_inv", use_photopart3_inv );
  cmn.AddSubscriber( "use_photopart3_beg", use_photopart3_beg, "inv_complex_photobasis" );
  cmn.AddSubscriber( "use_photopart3_end", use_photopart3_end, "inv_complex_photobasis" );
  --------------------------------------------------------------------------------------------
  -- function use_photopart4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_photopart4" ] = {

      type = "use",
      inv_obj = "inv_photopart4",
      use_place = "obj_complex_photobasis_use_photopart4",
      room = "int_complex_inv",
      zz = "inv_complex_photobasis",
      zz_gate = "inv_photobasis"
  };
  --------------------------------------------------------------------------------------------
  local use_photopart4_inv = function ()

    interface.InventoryItemRemove( "inv_photopart4" );
    
    if (not cmn.IsEventDone("get_photopart1") or cmn.IsEventDone("use_photopart1")) and 
       (not cmn.IsEventDone("get_photopart2") or cmn.IsEventDone("use_photopart2")) and 
       (not cmn.IsEventDone("get_photopart3") or cmn.IsEventDone("use_photopart3")) and
        not(cmn.IsEventDone("use_photopart1") and cmn.IsEventDone("use_photopart2") and cmn.IsEventDone("use_photopart3"))  then
      ObjSet("inv_photobasis_star_light",  { alp = 0 });
    end;

  end;
  local use_photopart4_beg = function ()

    ObjDelete( "obj_complex_photobasis_use_photopart4" );

  end;
  local use_photopart4_end = function ()
    
    ObjSet("obj_complex_photobasis_photo_part_4",  { alp = 1 });

    if cmn.IsEventDone("use_photopart2") and cmn.IsEventDone("use_photopart3") and cmn.IsEventDone("use_photopart1") then 
      ObjMultiSet( { {"obj_complex_photobasis_photo", { input = 1 }},
                     {"gfx_complex_photobasis_photo", { active = 1, visible = 1 }} } );
    end;
    
  end;
  cmn.AddSubscriber( "use_photopart4", use_photopart4_inv );
  cmn.AddSubscriber( "use_photopart4", use_photopart4_beg, "inv_complex_photobasis" );
  cmn.AddSubscriber( "use_photopart4", use_photopart4_end, "inv_complex_photobasis" );
  cmn.AddSubscriber( "use_photopart4_inv", use_photopart4_inv );
  cmn.AddSubscriber( "use_photopart4_beg", use_photopart4_beg, "inv_complex_photobasis" );
  cmn.AddSubscriber( "use_photopart4_end", use_photopart4_end, "inv_complex_photobasis" );
  --------------------------------------------------------------------------------------------
  -- function use_pigfigurine () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_pigfigurine" ] = {
        type = "use",
        inv_obj = "inv_pigfigurine",
        use_place = "obj_complex_bottlewithresin_use_pigfigurine",
        room = "int_complex_inv",
        zz = "inv_complex_bottlewithresin",
        zz_gate = "inv_bottlewithresin"
    };
  --------------------------------------------------------------------------------------------
  local use_pigfigurine_inv = function ()
  
    interface.InventoryItemRemove( "inv_pigfigurine" );
  
  end;
  local use_pigfigurine_beg = function ()
  
    ObjDelete( "obj_complex_bottlewithresin_use_pigfigurine" );
    ObjDelete( "anm_complex_bottlewithresin_touch" );
  
  end;
  local use_pigfigurine_end = function ()
  
    ObjDelete( "obj_complex_bottlewithresin_brush" );
    
    ObjMultiSet( { {"anm_complex_bottlewithresin_brush", { alp = 1, frame = 300 }},
                   {"obj_complex_bottlewithresin_resin", { input = 1 }},
                   {"gfx_complex_bottlewithresin_resin", { active = 1, visible = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pigfigurine", use_pigfigurine_beg, "inv_complex_bottlewithresin" );
  cmn.AddSubscriber( "use_pigfigurine", use_pigfigurine_inv );
  cmn.AddSubscriber( "use_pigfigurine", use_pigfigurine_end, "inv_complex_bottlewithresin" );
  cmn.AddSubscriber( "use_pigfigurine_inv", use_pigfigurine_inv, "inv_complex_bottlewithresin" );
  cmn.AddSubscriber( "use_pigfigurine_beg", use_pigfigurine_beg, "inv_complex_bottlewithresin" );
  cmn.AddSubscriber( "use_pigfigurine_end", use_pigfigurine_end, "inv_complex_bottlewithresin" );
  
  --port.  fix
  if port.isPortable() == 1 then
    port.InventoryPopupInit("inventory1_hub");
    port.VideoResizeInRoom("inventory1");
  end;
  
end;
--*********************************************************************************************************************
-- function *** CLOSE FUNC *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.inv_complex_dagger_close()

  if cmn.IsEventDone( "use_oil" ) and not cmn.IsEventDone( "get_sharpdagger" ) then
    
    ObjSet("spr_complex_dagger_sharpdagger",  { alp = 1 });
    
    cmn.SetEventDone( "get_sharpdagger" );
    cmn.CallEventHandler( "get_sharpdagger", "inv_complex_dagger" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_stephensbag_close()
  
  if not cmn.IsEventDone("get_deathfigurine")  then
    
    cmn.SetEventDone( "get_deathfigurine" );
    cmn.CallEventHandler( "get_deathfigurine", "inv_complex_stephensbag" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;

  if cmn.IsEventDone( "use_amuletbag" ) and ( not cmn.IsEventDone("get_magnifier") or not cmn.IsEventDone("get_pipe") ) then
    
    if not cmn.IsEventDone("get_magnifier") then
      cmn.SetEventDone( "get_magnifier" );
      cmn.CallEventHandler( "get_magnifier", "inv_complex_stephensbag" );
    end;
    
    if not cmn.IsEventDone("get_pipe") then
      cmn.SetEventDone( "get_pipe" );
      cmn.CallEventHandler( "get_pipe", "inv_complex_stephensbag" );
    end;
    
    if not cmn.IsEventDone("get_shippart") then
      cmn.SetEventDone( "get_shippart" );
      cmn.CallEventHandler( "get_shippart", "inv_complex_stephensbag" );
    end;

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_puppet_close()
  
  if not cmn.IsEventDone("get_gargoylepart1") then
    
    cmn.SetEventDone( "get_gargoylepart1" );
    cmn.CallEventHandler( "get_gargoylepart1", "inv_complex_puppet" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;

  if cmn.IsEventDone("use_puppetarm") and cmn.IsEventDone("use_puppethead") and cmn.IsEventDone("use_thread") and not cmn.IsEventDone( "get_fixedpuppet" ) then
    
    cmn.SetEventDone( "get_fixedpuppet" );
    cmn.CallEventHandler( "get_fixedpuppet", "inv_complex_puppet" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_spider_close()
  
  if not cmn.IsEventDone("get_igrune") then
    
    cmn.SetEventDone( "get_igrune" );
    cmn.CallEventHandler( "get_igrune", "inv_complex_spider" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;

  if cmn.IsEventDone("use_paw1") and cmn.IsEventDone("use_paw2") and cmn.IsEventDone("use_dog") and not cmn.IsEventDone( "get_webspider" ) then
    
    cmn.SetEventDone( "get_webspider" );
    cmn.CallEventHandler( "get_webspider", "inv_complex_spider" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_crackedstone_close()
  
  if not cmn.IsEventDone("get_detail1") then
    
    cmn.SetEventDone( "get_detail1" );
    cmn.CallEventHandler( "get_detail1", "inv_complex_crackedstone" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;

  if cmn.IsEventDone("use_magnifier") and cmn.IsEventDone("use_pipe") and not cmn.IsEventDone( "get_rubyheart" ) then
    
    cmn.SetEventDone( "get_rubyheart" );
    cmn.CallEventHandler( "get_rubyheart", "inv_complex_crackedstone" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_photobasis_close()
  
  if cmn.IsEventDone("use_photopart1") and cmn.IsEventDone("use_photopart2") and cmn.IsEventDone("use_photopart3") 
  and cmn.IsEventDone("use_photopart4") and not cmn.IsEventDone( "get_photo" ) then
    
    cmn.SetEventDone( "get_photo" );
    cmn.CallEventHandler( "get_photo", "inv_complex_photobasis" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_phone_close()
  
  if not(cmn.IsEventDone("clk_takecall")) then
    SndStop("assets/levels/level1/audio/sfx/aud_phone_calling", 1);
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_bottlewithresin_close()

  if cmn.IsEventDone( "use_pigfigurine" ) and not cmn.IsEventDone( "get_resin" ) then
    
    cmn.SetEventDone( "get_resin" );
    cmn.CallEventHandler( "get_resin", "inv_complex_bottlewithresin" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_oil()

  local item = "inv_oil";

  if cmn.ObjIntersectCheck( item, "obj_complex_dagger_use_oil" ) then

    cmn.CallEventHandler( "use_oil_inv", "inv_complex_dagger" );
    cmn.CallEventHandler( "use_oil_beg", "inv_complex_dagger" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_oil" );
      cmn.CallEventHandler( "use_oil_end", "inv_complex_dagger" );
      
    end;
    
    local anim_out = function ()
      
      ObjSet("anm_complex_dagger_action",  { animfunc = "func_take_dagger", frame = 0, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_spill_oil_dagger");

    ObjSet("anm_complex_dagger_action",  { animfunc = "func_use_oil", frame = 0, playing = 1, endtrig = anim_out });

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_amuletbag()

  local item = "inv_amuletbag";

  if cmn.ObjIntersectCheck( item, "obj_complex_stephensbag_use_amuletbag" ) then

    cmn.CallEventHandler( "use_amuletbag_inv", "inv_complex_stephensbag" );
    cmn.CallEventHandler( "use_amuletbag_beg", "inv_complex_stephensbag" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_amuletbag" );
      cmn.CallEventHandler( "use_amuletbag_end", "inv_complex_stephensbag" );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_star_bag");

    ObjSet("anm_complex_stephensbag_bag_open",  { alp = 1, playing = 1, endtrig = func_after });

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_puppetarm()

  local item = "inv_puppetarm";

  if cmn.ObjIntersectCheck( item, "obj_complex_puppet_use_puppetarm" ) then

    cmn.CallEventHandler( "use_puppetarm_inv", "inv_complex_puppet" );
    cmn.CallEventHandler( "use_puppetarm_beg", "inv_complex_puppet" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_puppetarm" );
      cmn.CallEventHandler( "use_puppetarm_end", "inv_complex_puppet" );
      
      ObjSet("anm_complex_puppet_touch",  { alp = 1 });
      
      if cmn.IsEventDone("use_puppethead") then
        cmn.SetEventDone("use_puppetparts");
      end;
      
    end;
    
    local anm_thread = function ()
      
      ObjDelete("anm_complex_puppet_use_hand");
      ObjSet("anm_complex_puppet_touch",  { alp = 1 });
      
      ObjAnimate("spr_complex_puppet_strings_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      ObjAnimate("spr_complex_puppet_threads", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 0,   0.6, 0, 1 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_arm_puppet");
    
    if cmn.IsEventDone("use_thread") and cmn.IsEventDone("use_puppethead") then

      ObjMultiSet( { {"anm_complex_puppet_use_hand", { alp = 1, playing = 1, endtrig = anm_thread }},
                     {"anm_complex_puppet_touch", { alp = 0 }} } );
                     
    else 
                     
      ObjMultiSet( { {"anm_complex_puppet_use_hand", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_complex_puppet_touch", { alp = 0 }} } );
                     
    end;

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_puppethead()

  local item = "inv_puppethead";

  if cmn.ObjIntersectCheck( item, "obj_complex_puppet_use_puppethead" ) then

    cmn.CallEventHandler( "use_puppethead_inv", "inv_complex_puppet" );
    cmn.CallEventHandler( "use_puppethead_beg", "inv_complex_puppet" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_puppethead" );
      cmn.CallEventHandler( "use_puppethead_end", "inv_complex_puppet" );
      
      ObjSet("anm_complex_puppet_touch",  { alp = 1 });
      
      if cmn.IsEventDone("use_puppetarm") then
        cmn.SetEventDone("use_puppetparts");
      end;
      
    end;
    
    local anm_thread = function ()
      
      ObjDelete("anm_complex_puppet_use_head");
      ObjSet("anm_complex_puppet_touch",  { alp = 1 });
      
      ObjAnimate("spr_complex_puppet_strings_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      ObjAnimate("spr_complex_puppet_threads", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 0,   0.6, 0, 1 });
      
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_use_puppethead_puppet");
    
    if cmn.IsEventDone("use_thread") and cmn.IsEventDone("use_puppetarm") then

      ObjMultiSet( { {"anm_complex_puppet_use_head", { alp = 1, playing = 1, endtrig = anm_thread }},
                     {"anm_complex_puppet_touch", { alp = 0 }} } );
                     
    else 
                     
      ObjMultiSet( { {"anm_complex_puppet_use_head", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_complex_puppet_touch", { alp = 0 }} } );
                     
    end;

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_thread()

  local item = "inv_thread";

  if cmn.ObjIntersectCheck( item, "obj_complex_puppet_use_thread" ) then

    cmn.CallEventHandler( "use_thread_inv", "inv_complex_puppet" );
    cmn.CallEventHandler( "use_thread_beg", "inv_complex_puppet" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_thread" );
      cmn.CallEventHandler( "use_thread_end", "inv_complex_puppet" );
      
    end;

    cmn.Lock( 1 );
    
    if cmn.IsEventDone("use_puppetarm") and cmn.IsEventDone("use_puppethead") then
      
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_use_thread_puppet");
      ObjAnimate("spr_complex_puppet_threads", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
      
    else 
      
      ObjAnimate("spr_complex_puppet_strings_1", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
      
    end;

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_dog()
  
  local item = "inv_dog";

  if cmn.ObjIntersectCheck( item, "obj_complex_spider_use_dog" ) then

    cmn.CallEventHandler( "use_dog_inv", "inv_complex_spider" );
    cmn.CallEventHandler( "use_dog_beg", "inv_complex_spider" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_dog" );
      cmn.CallEventHandler( "use_dog_end", "inv_complex_spider" );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_spider_a");
    
    ObjAnimate( "obj_complex_spider_at", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );

  else
    
    cmn.WrongApply();  

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.use_paw1()
  
  local item = "inv_paw1";

  if cmn.ObjIntersectCheck( item, "obj_complex_spider_use_paw1" ) then

    cmn.CallEventHandler( "use_paw1_inv", "inv_complex_spider" );
    cmn.CallEventHandler( "use_paw1_beg", "inv_complex_spider" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_paw1" );
      cmn.CallEventHandler( "use_paw1_end", "inv_complex_spider" );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_leg_spider_a");

    ObjSet("anm_complex_spider_paw_1",  { alp = 1, playing = 1, endtrig = func_after });

  else
    
    cmn.WrongApply();  

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.use_paw2()
  
  local item = "inv_paw2";

  if cmn.ObjIntersectCheck( item, "obj_complex_spider_use_paw2" ) then

    cmn.CallEventHandler( "use_paw2_inv", "inv_complex_spider" );
    cmn.CallEventHandler( "use_paw2_beg", "inv_complex_spider" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_paw2" );
      cmn.CallEventHandler( "use_paw2_end", "inv_complex_spider" );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_leg_spider_a");

    ObjSet("anm_complex_spider_paw_2",  { alp = 1, playing = 1, endtrig = func_after });

  else
    
    cmn.WrongApply();  

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.use_magnifier()
  
  local item = "inv_magnifier";

  if cmn.ObjIntersectCheck( item, "obj_complex_crackedstone_use_magnifier" ) then

    cmn.CallEventHandler( "use_magnifier_inv", "inv_complex_crackedstone" );
    cmn.CallEventHandler( "use_magnifier_beg", "inv_complex_crackedstone" );

    if ( not cmn.IsEventDone( "get_detail1" ) ) then
      public.get_detail1();
    end;

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_magnifier" );
      --cmn.CallEventHandler( "use_magnifier_end", "inv_complex_crackedstone" );

      ObjStartDrag( "spr_complex_crackedstone_magnifer" );

      ObjAnimate( "spr_complex_crackedstone_magnifer", "alp", 0, 0, "", { 0, 0, 0,    0.15, 0, 1 } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_use_loupe_stone_lava");

    ObjSet( "anm_complex_crackedstone_grid", { endtrig = func_after, playing = true } );

  else
    
    cmn.WrongApply();  

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.use_dragmagnifier( num )

  if ( not private.drag_magnifer ) or ( cmn.IsEventDone( "use_dragmagnifier"..num ) ) then
    return;
  end;

  cmn.SetEventDone( "use_dragmagnifier"..num );
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_find_lack_stone_lava");

  ObjAnimate( "spr_complex_crackedstone_select"..num, "alp", 0, 0, "", { 0, 0, 0,    0.15, 0, 1 } );

  if ( cmn.IsEventDone( "use_dragmagnifier1" ) and cmn.IsEventDone( "use_dragmagnifier2" )
  and  cmn.IsEventDone( "use_dragmagnifier3" ) and cmn.IsEventDone( "use_dragmagnifier4" ) ) then

    cmn.Lock( 1 );

    local pos_xy = GetObjPosByObj( "spr_complex_crackedstone_magnifer", "inv_complex_crackedstone" );

    ObjStopDrag();

    ObjMultiSet( {
      { "obj_complex_crackedstone_use_pipe", { input = true } },
      { "spr_complex_crackedstone_magnifer", { input = false, pos_x = pos_xy[1], pos_y = pos_xy[2] } }
    } );

    local func_after = function ()

      if cmn.IsEventDone( "use_pipe" ) then
        public.use_pipe();
      else
        cmn.Lock( 0 );
      end;

    end;

    ObjAnimate( "spr_complex_crackedstone_magnifer", "alp", 0, 0, func_after, { 0, 0, 1,    0.5, 0, 1,    0.8, 0, 0 } );

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pipe()
  
  local item = "inv_pipe";

  if cmn.ObjIntersectCheck( item, "obj_complex_crackedstone_use_pipe" ) or cmn.IsEventDone( "use_pipe" ) then

    if not cmn.IsEventDone( "use_pipe" ) then
      cmn.CallEventHandler( "use_pipe_inv", "inv_complex_crackedstone" );
      cmn.CallEventHandler( "use_pipe_beg", "inv_complex_crackedstone" );
    end;

    local func_after2 = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_pipe" );
      cmn.CallEventHandler( "use_pipe_end", "inv_complex_crackedstone" );
      
    end;

    local func_after = function ()
      ObjDelete( "spr_complex_crackedstone_pipe" );
      ObjSet( "anm_complex_crackedstone_stone_clk", { animfunc = "func_pipe_use", endtrig = func_after2, playing = true } );
    end;

    cmn.Lock( 1 );

    if ( cmn.IsEventDone( "use_dragmagnifier1" ) and cmn.IsEventDone( "use_dragmagnifier2" )
    and  cmn.IsEventDone( "use_dragmagnifier3" ) and cmn.IsEventDone( "use_dragmagnifier4" ) ) then

      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_use_tube_stone_lava");

      ObjAnimate( "obj_complex_crackedstone_grid", "alp", 0, 0, func_after, { 0, 0, 1,    0.3, 0, 0 } );

    else

      ObjAnimate( "spr_complex_crackedstone_pipe", "alp", 0, 0, func_after2, { 0, 0, 0,    0.3, 0, 1 } );

    end;

  else
    
    cmn.WrongApply();  

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.use_photopart1()
  
  local item = "inv_photopart1";

  if cmn.ObjIntersectCheck( item, "obj_complex_photobasis_use_photopart1" ) then

    cmn.CallEventHandler( "use_photopart1_inv", "inv_complex_photobasis" );
    cmn.CallEventHandler( "use_photopart1_beg", "inv_complex_photobasis" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_photopart1" );
      cmn.CallEventHandler( "use_photopart1_end", "inv_complex_photobasis" );
      
      if cmn.IsEventDone("use_photopart2") and cmn.IsEventDone("use_photopart3") and cmn.IsEventDone("use_photopart4") then
        cmn.ShowBbt( "complex_photobasis_photo_completed" );
      end;
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_piece_picture");

    ObjAnimate( "obj_complex_photobasis_photo_part_1", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );

  else
    
    cmn.WrongApply();  

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.use_photopart2()
  
  local item = "inv_photopart2";

  if cmn.ObjIntersectCheck( item, "obj_complex_photobasis_use_photopart2" ) then

    cmn.CallEventHandler( "use_photopart2_inv", "inv_complex_photobasis" );
    cmn.CallEventHandler( "use_photopart2_beg", "inv_complex_photobasis" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_photopart2" );
      cmn.CallEventHandler( "use_photopart2_end", "inv_complex_photobasis" );
      
      if cmn.IsEventDone("use_photopart1") and cmn.IsEventDone("use_photopart3") and cmn.IsEventDone("use_photopart4") then
        cmn.ShowBbt( "complex_photobasis_photo_completed" );
      end;
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_piece_picture");

    ObjAnimate( "obj_complex_photobasis_photo_part_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );

  else
    
    cmn.WrongApply();  

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.use_photopart3()
  
  local item = "inv_photopart3";

  if cmn.ObjIntersectCheck( item, "obj_complex_photobasis_use_photopart3" ) then

    cmn.CallEventHandler( "use_photopart3_inv", "inv_complex_photobasis" );
    cmn.CallEventHandler( "use_photopart3_beg", "inv_complex_photobasis" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_photopart3" );
      cmn.CallEventHandler( "use_photopart3_end", "inv_complex_photobasis" );
      
      if cmn.IsEventDone("use_photopart2") and cmn.IsEventDone("use_photopart1") and cmn.IsEventDone("use_photopart4") then
        cmn.ShowBbt( "complex_photobasis_photo_completed" );
      end;
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_piece_picture");

    ObjAnimate( "obj_complex_photobasis_photo_part_3", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );

  else
    
    cmn.WrongApply();  

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.use_photopart4()
  
  local item = "inv_photopart4";

  if cmn.ObjIntersectCheck( item, "obj_complex_photobasis_use_photopart4" ) then

    cmn.CallEventHandler( "use_photopart4_inv", "inv_complex_photobasis" );
    cmn.CallEventHandler( "use_photopart4_beg", "inv_complex_photobasis" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_photopart4" );
      cmn.CallEventHandler( "use_photopart4_end", "inv_complex_photobasis" );
      
      if cmn.IsEventDone("use_photopart2") and cmn.IsEventDone("use_photopart3") and cmn.IsEventDone("use_photopart1") then
        cmn.ShowBbt( "complex_photobasis_photo_completed" );
      end;
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_piece_picture");

    ObjAnimate( "obj_complex_photobasis_photo_part_4", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );

  else
    
    cmn.WrongApply();  

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.use_pigfigurine()

  local item = "inv_pigfigurine";

  if cmn.ObjIntersectCheck( item, "obj_complex_bottlewithresin_use_pigfigurine" ) then

    cmn.CallEventHandler( "use_pigfigurine_inv", "inv_complex_bottlewithresin" );
    cmn.CallEventHandler( "use_pigfigurine_beg", "inv_complex_bottlewithresin" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_pigfigurine" );
      cmn.CallEventHandler( "use_pigfigurine_end", "inv_complex_bottlewithresin" );
      
    end;
    
    local anm_brush = function ()
      
      ObjDelete( "obj_complex_bottlewithresin_brush" );
      
      ObjMultiSet( { {"anm_complex_bottlewithresin_brush", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_complex_bottlewithresin_use_pig", { alp = 0 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_take_cap_bottle_1");

    ObjSet("anm_complex_bottlewithresin_use_pig",  { alp = 1, playing = 1, endtrig = anm_brush });

  else
    
    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_sharpdagger()
  
  ObjSet("spr_complex_dagger_sharpdagger",  { alp = 1 });

  cmn.SetEventDone( "get_sharpdagger" );
  cmn.CallEventHandler( "get_sharpdagger", "inv_complex_dagger" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_deathfigurine()

  cmn.SetEventDone( "get_deathfigurine" );
  cmn.CallEventHandler( "get_deathfigurine", "inv_complex_stephensbag" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_magnifier()

  cmn.SetEventDone( "get_magnifier" );
  cmn.CallEventHandler( "get_magnifier", "inv_complex_stephensbag" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if not cmn.IsEventDone("get_shippart") then
    cmn.SetEventDone( "get_shippart" );
    cmn.CallEventHandler( "get_shippart", "inv_complex_stephensbag" );
  end;

  if cmn.IsEventDone("get_pipe") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_pipe()

  cmn.SetEventDone( "get_pipe" );
  cmn.CallEventHandler( "get_pipe", "inv_complex_stephensbag" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if not cmn.IsEventDone("get_shippart") then
    cmn.SetEventDone( "get_shippart" );
    cmn.CallEventHandler( "get_shippart", "inv_complex_stephensbag" );
  end;

  if cmn.IsEventDone("get_magnifier") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_shippart()

  cmn.SetEventDone( "get_shippart" );
  cmn.CallEventHandler( "get_shippart", "inv_complex_stephensbag" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_gargoylepart1()

  cmn.SetEventDone( "get_gargoylepart1" );
  cmn.CallEventHandler( "get_gargoylepart1", "inv_complex_puppet" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_fixedpuppet()

  cmn.SetEventDone( "get_fixedpuppet" );
  cmn.CallEventHandler( "get_fixedpuppet", "inv_complex_puppet" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_igrune()

  cmn.SetEventDone( "get_igrune" );
  cmn.CallEventHandler( "get_igrune", "inv_complex_spider" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_webspider()

  cmn.SetEventDone( "get_webspider" );
  cmn.CallEventHandler( "get_webspider", "inv_complex_spider" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_detail1()

  cmn.SetEventDone( "get_detail1" );
  cmn.CallEventHandler( "get_detail1", "inv_complex_crackedstone" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_rubyheart()

  cmn.SetEventDone( "get_rubyheart" );
  cmn.CallEventHandler( "get_rubyheart", "inv_complex_crackedstone" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_photo()

  cmn.SetEventDone( "get_photo" );
  cmn.CallEventHandler( "get_photo", "inv_complex_photobasis" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_resin()
  
  cmn.SetEventDone( "get_resin" );
  cmn.CallEventHandler( "get_resin", "inv_complex_bottlewithresin" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.open_dagger()

  if interface.GetCurrentComplexInv() == "" and not(cmn.IsEventDone("tutor_9")) then

    ObjSet("obj_tutorial_tutor_8",  { input = 0 });

    interface.InventoryAutoHideLoad();

    if (int_inventory.GetAutohide()) then
      int_inventory.Hide( false );
    end;

    cmn.TutorialShow( "tutor_9", 0, 512, 384 );

  end;
  
  common_impl.ShowComplexItem( "dagger" );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_dagger()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_dagger_inventory");
  
  cmn.ShowBbt( "obj_complex_dagger_use_oil" );
  
  ObjSet("anm_complex_dagger_action",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_stephensbag()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_bag_1");
  
  cmn.ShowBbt( "obj_complex_stephensbag_use_amuletbag" );
  
  if not cmn.IsEventDone("get_deathfigurine") then
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
    
    cmn.SetEventDone( "get_deathfigurine" );
    cmn.CallEventHandler( "get_deathfigurine" );
    
  end;
  
  ObjSet("anm_complex_stephensbag_bag_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_puppet( num )
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_puppet");
  
  if num == 1 then
    cmn.ShowBbt( "obj_complex_puppet_use_puppethead" );
  elseif num == 2 then
    cmn.ShowBbt( "obj_complex_puppet_use_puppethead" );
  elseif num == 3 then
    cmn.ShowBbt( "obj_complex_puppet_use_thread" );
  end;
  
  ObjSet("anm_complex_puppet_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_spider( num )
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_spider_a");
  
  if num == 1 then
    cmn.ShowBbt( "obj_complex_spider_use_paw" );
  elseif num == 2 then
    cmn.ShowBbt( "obj_complex_spider_use_dog" );
  end;
  
  if not cmn.IsEventDone("get_igrune") then
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
    cmn.SetEventDone( "get_igrune" );
    cmn.CallEventHandler( "get_igrune" );
  end;
  
  ObjSet("anm_complex_spider_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
  if cmn.IsEventDone("use_paw1") then
    ObjSet("anm_complex_spider_paw_1",  { playing = 1 });
  end;
  
  if cmn.IsEventDone("use_paw2") then
    ObjSet("anm_complex_spider_paw_2",  { playing = 1 });
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_photo()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_picture_inventory");
  
  cmn.ShowBbt( "obj_complex_photobasis_use_photopart" );
  
  ObjSet("anm_complex_photobasis_photo_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_bottle()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_bottle_1");
  
  cmn.ShowBbt( "obj_complex_bottlewithresin_use_pigfigurine" );
  
  ObjSet("anm_complex_bottlewithresin_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_crackedstone()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_stone_lava");
  
  cmn.ShowBbt( "obj_complex_crackedstone_use_magnifier" );
  
  ObjSet( "anm_complex_crackedstone_stone_clk", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.startdrag_magnifer()

  SetCursor( CURSOR_NULL );

  private.drag_magnifer = true;

end;
--------------------------------------------------------------------------------------------
function public.dropdrag_magnifer()

  SetCursor( CURSOR_DEFAULT );

  private.drag_magnifer = false;

end;
--*********************************************************************************************************************
