-- name=rm_apartment
--*********************************************************************************************************************
function public.Init()

  --cmn.TutorialShow( "tutor_115", 0, 512, 340, arrows );
  
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_apartment";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Computer();
  private.Init_Lvl1desk();
  private.light_borders = { {2, 1043}, {176, 596} };
  --------------------------------------------------------------------------------------------
  -- function get_documentation () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_documentation" ] = {
        type = "get",
        get_obj = "spr_lvl1desk_documentation",
        room = private.room_objname,
        zz = "zz_lvl1desk",
        zz_gate = "gzz_apartment_lvl1desk"
    };
    --------------------------------------------------------------------------------------------
  local get_documentation_inv = function ()
  
    interface.InventoryItemAdd( "inv_documentation", "spr_lvl1desk_documentation" );
  
  end;
  
  local get_documentation_end = function ()
  
    ObjDelete( "gfx_lvl1desk_documentation" );
    ObjDelete( "spr_lvl1desk_documentation_sh" );
    
    ObjDelete( "gzz_apartment_lvl1desk" );
    ObjDelete( "spr_apartment_desk_docs" );
    
    ObjDelete( "obj_apartment_door_bbt" );
    
    ObjMultiSet( { {"anm_apartment_door_knock", { alp = 1 }},
                   {"obj_apartment_clk_opendoordelivery", { input = 1 }} } );
  
  end;
  
  cmn.AddSubscriber( "get_documentation", get_documentation_inv );
  cmn.AddSubscriber( "get_documentation", get_documentation_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_password () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_password" ] = {
        type = "get",
        get_obj = "spr_computer_password",
        room = private.room_objname,
        zz = "zz_computer",
        zz_gate = "gzz_apartment_computer"
    };
    --------------------------------------------------------------------------------------------
  local get_password_inv = function ()
  
    interface.InventoryItemAdd( "inv_password", "spr_computer_password" );
  
  end;
  
  local get_password_end = function ()
  
    ObjDelete( "gfx_computer_password" );
    ObjDelete( "spr_computer_password_sh" );
    
    ObjDelete( "gzz_apartment_computer" );
    ObjDelete( "spr_apartment_pc_code" );
  
  end;
  
  cmn.AddSubscriber( "get_password", get_password_inv );
  cmn.AddSubscriber( "get_password", get_password_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_square1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_square1" ] = {
        type = "get",
        get_obj = "spr_computer_square1",
        room = private.room_objname,
        zz = "zz_computer",
        zz_gate = "gzz_apartment_computer"
    };
    --------------------------------------------------------------------------------------------
  local get_square1_inv = function ()
  
    interface.InventoryItemAdd( "inv_square", "spr_computer_square1", function () cmn.GetMultyObject( 'square', 3 ); end );
  
  end;
  
  local get_square1_end = function ()
  
    ObjDelete( "gfx_computer_square1" );
    ObjDelete( "spr_apartment_pc_square" );
  
  end;
  
  cmn.AddSubscriber( "get_square1", get_square1_inv );
  cmn.AddSubscriber( "get_square1", get_square1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_square2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_square2" ] = {
        type = "get",
        get_obj = "spr_nightstand_letter",
        room = private.room_objname,
        zz = "zz_nightstand",
        zz_gate = "gzz_apartment_nightstand"
    };
    --------------------------------------------------------------------------------------------
  local get_square2_inv = function ()
  
    interface.InventoryItemAdd( "inv_square", "spr_nightstand_square2", function () cmn.GetMultyObject( 'square', 3 ); end );
  
  end;
  
  local get_square2_end = function ()
  
    ObjDelete( "gfx_nightstand_square2" );
    ObjDelete( "spr_nightstand_square2_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_square2", get_square2_inv );
  cmn.AddSubscriber( "get_square2", get_square2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_square3 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_square3" ] = {
        type = "get",
        get_obj = "spr_lvl1desk_square3",
        room = private.room_objname,
        zz = "zz_lvl1desk",
        zz_gate = "gzz_apartment_lvl1desk"
    };
    --------------------------------------------------------------------------------------------
  local get_square3_inv = function ()
  
    interface.InventoryItemAdd( "inv_square", "spr_lvl1desk_square3", function () cmn.GetMultyObject( 'square', 3 ); end );
  
  end;
  
  local get_square3_end = function ()
  
    ObjDelete( "gfx_lvl1desk_square3" );
    ObjDelete( "spr_lvl1desk_square3_sh" );
    
    ObjDelete( "spr_apartment_desk_square" );
  
  end;
  
  cmn.AddSubscriber( "get_square3", get_square3_inv );
  cmn.AddSubscriber( "get_square3", get_square3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_router () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_router" ] = {
        type = "get",
        get_obj = "spr_nightstand_router",
        room = private.room_objname,
        zz = "zz_nightstand",
        zz_gate = "gzz_apartment_nightstand"
    };
    --------------------------------------------------------------------------------------------
  local get_router_inv = function ()
  
    interface.InventoryItemAdd( "inv_router", "spr_nightstand_router" );
  
  end;
  
  local get_router_end = function ()
  
    ObjDelete( "gfx_nightstand_router" );
    ObjDelete( "spr_nightstand_router_sh" );
    
    ObjSet("gzz_apartment_nightstand",  { active = 0, alp = 0 });
  
  end;
  
  cmn.AddSubscriber( "get_router", get_router_inv );
  cmn.AddSubscriber( "get_router", get_router_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_getphone () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "clk_getphone" ] = {
      type = "click",
      use_place = "spr_apartment_phone",
      room = private.room_objname
    };
    --------------------------------------------------------------------------------------------
  local clk_getphone = function ()
  
    ObjDelete( "spr_apartment_phone" );
    ObjDelete( "spr_apartment_phone_sh" );
    
    ObjAttach("obj_apartment_phone", "rm_apartment");
    ObjSet("obj_apartment_phone",  { alp = 1, input = 1 });
  
  end;
  
  cmn.AddSubscriber( "clk_getphone", clk_getphone, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_router () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_router" ] = {
        type = "use",
        inv_obj = "inv_router",
        use_place = "obj_computer_use_router",
        room = private.room_objname,
        zz = "zz_computer",
        zz_gate = "gzz_apartment_computer"
    };
  --------------------------------------------------------------------------------------------
  local use_router_inv = function ()
  
    interface.InventoryItemRemove( "inv_router" );
  
  end;
  local use_router_beg = function ()
  
    ObjDelete( "obj_computer_use_router" );
    ObjSet("spr_computer_brochures",  { pos_z = 1 });
  
  end;
  local use_router_end = function ()
    
    ObjDelete( "spr_apartment_pc_router_old_2" );
    ObjDelete( "spr_apartment_pc_no_signal" );
    
    ObjDelete( "txt_computer_pc_error_2" );
    ObjDelete( "txt_computer_pc_no_signal" );
    
    ObjMultiSet( { {"obj_computer_clk_startchat", { input = 1, alp = 1 }},
                   {"spr_apartment_pc_elephant", { alp = 1 }},
                   {"spr_apartment_pc_router_new", { alp = 1 }},
                   {"spr_computer_router_on", { alp = 1 }},
                   {"anm_computer_icon", { alp = 1 }},
                   {"anm_computer_use_router", { frame = 400 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_router", use_router_beg, private.room_objname );
  cmn.AddSubscriber( "use_router", use_router_inv );
  cmn.AddSubscriber( "use_router", use_router_end, private.room_objname );
  cmn.AddSubscriber( "use_router_inv", use_router_inv, private.room_objname );
  cmn.AddSubscriber( "use_router_beg", use_router_beg, private.room_objname );
  cmn.AddSubscriber( "use_router_end", use_router_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_password () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_password" ] = {
        type = "use",
        inv_obj = "inv_password",
        use_place = "obj_lvl1desk_use_password",
        room = private.room_objname,
        zz = "zz_lvl1desk",
        zz_gate = "gzz_apartment_lvl1desk"
    };
  --------------------------------------------------------------------------------------------
  local use_password_inv = function ()
  
    interface.InventoryItemRemove( "inv_password" );
  
  end;
  local use_password_beg = function ()
  
    ObjDelete( "obj_lvl1desk_use_password" );
    
  end;
  local use_password_end = function ()
  
    ObjMultiSet( { {"obj_lvl1desk_game", { input = 1 }},
                   {"obj_lvl1desk_code_hint", { alp = 1 }},
                   {"spr_apartment_desk_code", { alp = 1 }} } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_password", use_password_beg, private.room_objname );
  cmn.AddSubscriber( "use_password", use_password_inv );
  cmn.AddSubscriber( "use_password", use_password_end, private.room_objname );
  cmn.AddSubscriber( "use_password_inv", use_password_inv, private.room_objname );
  cmn.AddSubscriber( "use_password_beg", use_password_beg, private.room_objname );
  cmn.AddSubscriber( "use_password_end", use_password_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_square () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_square" ] = {
        type = "use",
        inv_obj = "inv_square",
        use_place = "obj_safe_use_square",
        room = private.room_objname,
        zz = "zz_safe",
        zz_gate = "gzz_apartment_safe"
    };
  --------------------------------------------------------------------------------------------
  local use_square_inv = function ()
  
    interface.InventoryItemRemove( "inv_square" );
  
  end;
  local use_square_beg = function ()
  
    ObjDelete( "obj_safe_use_square" );
    ObjDelete( "anm_safe_touch" );
  
  end;
  local use_square_end = function ()
    
    ObjDelete( "gzz_apartment_safe" );

    ObjMultiSet( { {"gho_apartment_balcony", { input = 1, alp = 1, active = 1 }},
                   {"spr_apartment_safe_open", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_square", use_square_beg, private.room_objname );
  cmn.AddSubscriber( "use_square", use_square_inv );
  cmn.AddSubscriber( "use_square", use_square_end, private.room_objname );
  cmn.AddSubscriber( "use_square_inv", use_square_inv, private.room_objname );
  cmn.AddSubscriber( "use_square_beg", use_square_beg, private.room_objname );
  cmn.AddSubscriber( "use_square_end", use_square_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_standkey () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_standkey" ] = {
        type = "use",
        inv_obj = "inv_standkey",
        use_place = "obj_nightstand_use_standkey",
        room = private.room_objname,
        zz = "zz_nightstand",
        zz_gate = "gzz_apartment_nightstand"
    };
  --------------------------------------------------------------------------------------------
  local use_standkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_standkey" );
  
  end;
  local use_standkey_beg = function ()
  
    ObjDelete( "obj_nightstand_use_standkey" );
    ObjDelete( "anm_nightstand_drawer_touch" );
  
  end;
  local use_standkey_end = function ()
    
    ObjMultiSet( { {"anm_nightstand_drawer_open", { input = 1, alp = 1, frame = 300 }},
                   {"spr_apartment_stand_drawer", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_standkey", use_standkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_standkey", use_standkey_inv );
  cmn.AddSubscriber( "use_standkey", use_standkey_end, private.room_objname );
  cmn.AddSubscriber( "use_standkey_inv", use_standkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_standkey_beg", use_standkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_standkey_end", use_standkey_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_documentation () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_documentation" ] = {
    type = "use",
    inv_obj = "inv_documentation",
    use_place = "obj_apartment_use_documentation",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local use_documentation_inv = function ()
  
    interface.InventoryItemRemove( "inv_documentation" );
  
  end;
  local use_documentation_beg = function ()
  
    ObjDelete( "obj_apartment_use_documentation" );

  end;
  local use_documentation_end = function ()
  
    ObjDelete( "anm_apartment_capsule" );
    ObjDelete( "anm_apartment_capsule_3" );
    ObjDelete( "anm_apartment_capsule_4" );

    ObjMultiSet( { {"gmg_apartment_returning", { input = 1, alp = 1, active = 1 }},
                   {"anm_apartment_capsule_2", { alp = 1 }} } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_documentation", use_documentation_inv );
  cmn.AddSubscriber( "use_documentation_inv", use_documentation_inv );
  cmn.AddSubscriber( "use_documentation", use_documentation_beg, private.room_objname );
  cmn.AddSubscriber( "use_documentation", use_documentation_end, private.room_objname );
  cmn.AddSubscriber( "use_documentation_beg", use_documentation_beg, private.room_objname );
  cmn.AddSubscriber( "use_documentation_end", use_documentation_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_startchat () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_startchat" ] = {
    type = "click",
    use_place = "obj_computer_clk_startchat",
    room = private.room_objname,
    zz = "zz_computer",
    zz_gate = "gzz_apartment_computer"
  };
  --------------------------------------------------------------------------------------------
  local clk_startchat_beg = function ()
  
    ObjDelete( "obj_computer_clk_startchat" );
  
  end;
  local clk_startchat_end = function ()
  
    ObjDelete( "anm_computer_icon" );
    ObjDelete( "spr_apartment_pc_elephant" );
    
    ObjMultiSet( { {"spr_apartment_pc_chat", { alp = 1 }},
                   {"spr_computer_chat_after", { alp = 1 }},
                   {"gzz_computer_chat", { input = 1, active = 1, visible = 1 }} } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_startchat", clk_startchat_beg, private.room_objname );
  cmn.AddSubscriber( "clk_startchat", clk_startchat_end, private.room_objname );
  cmn.AddSubscriber( "clk_startchat_beg", clk_startchat_beg, private.room_objname );
  cmn.AddSubscriber( "clk_startchat_end", clk_startchat_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_framedphoto () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_framedphoto" ] = {
    type = "click",
    use_place = "obj_lvl1desk_clk_framedphoto",
    room = private.room_objname,
    zz = "zz_lvl1desk",
    zz_gate = "gzz_apartment_lvl1desk"
  };
  --------------------------------------------------------------------------------------------
  local clk_framedphoto = function ()
  
    ObjDelete( "obj_lvl1desk_clk_framedphoto" );
    ObjDelete( "spr_apartment_desk_photo" );
    
    ObjMultiSet( { {"anm_lvl1desk_photo",  { frame = 300 }},
                   {"obj_lvl1desk_square", { alp = 1, input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_framedphoto", clk_framedphoto, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_takecall () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_takecall" ] = {
      type = "click",
      use_place = "obj_complex_phone_clk_takecall",
      room = "rm_apartment"
  };
  --------------------------------------------------------------------------------------------
  local clk_takecall_tsk = function ()
    common_impl.ChangeRoomMiniback( "rm_apartment", false );
  end;
  local clk_takecall_beg = function ()
  
    ObjDelete( "obj_complex_phone_clk_takecall" );
  
  end;
  local clk_takecall_end = function ()
    
    ObjDelete( "obj_apartment_phone" );
    ObjDelete( "spr_apartment_back_2" );
    ObjDelete( "spr_apartment_darkness_1" );
    
    ObjDelete( "spr_apartment_pc_router_old_1" );
    ObjDelete( "spr_apartment_pc_brochures" );
    
    ObjMultiSet( { {"spr_apartment_pc_router_old_2", { alp = 1 }},
                   {"spr_apartment_pc_brochures_2", { alp = 1 }},
                   {"spr_apartment_capsule_bl", { alp = 1 }},
                   {"spr_apartment_capsule_bl_2", { alp = 1 }},
                   {"obj_apartment_light", { alp = 1 }},
                   {"anm_apartment_door_knock", { alp = 1 }},
                   {"spr_bonus_1", { alp = 1, input = 1 }},
                   {"spr_bonus_2", { alp = 1, input = 1 }},
                   {"gzz_apartment_computer", { alp = 1, input = 1, active = 1 }},
                   {"gzz_apartment_nightstand", { alp = 1, input = 1, active = 1 }},
                   {"gzz_apartment_safe", { alp = 1, input = 1, active = 1 }},
                   {"gzz_apartment_lvl1desk", { alp = 1, input = 1, active = 1 }},
                   {"spr_apartment_darkness_2", { alp = 0.6 }},
                   {"obj_apartment_door_bbt", { input = 1 }} } );

  end;
  cmn.AddSubscriber( "clk_takecall", clk_takecall_beg, "rm_apartment" );
  cmn.AddSubscriber( "clk_takecall", clk_takecall_end, "rm_apartment" );
  cmn.AddSubscriber( "clk_takecall_beg", clk_takecall_beg, "rm_apartment" );
  cmn.AddSubscriber( "clk_takecall_end", clk_takecall_end, "rm_apartment" );
  cmn.AddSubscriber( "clk_takecall", clk_takecall_tsk );
  cmn.AddSubscriber( "clk_takecall_tsk", clk_takecall_tsk );
  
  --------------------------------------------------------------------------------------------
  -- function clk_readbrochures () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_readbrochures" ] = {
      type = "click",
      use_place = "spr_nightstand_brochures_3",
      room = "rm_apartment",
      zz = "zz_nightstand",
      zz_gate = "gzz_apartment_nightstand"
  };
  --------------------------------------------------------------------------------------------
  local clk_readbrochures = function ()
    
    ObjDelete("spr_apartment_stand_liflets_1");
  
    ObjMultiSet( { {"spr_nightstand_brochures_1",  { pos_x = -100, pos_y = -97 }},
                   {"spr_nightstand_brochures_2",  { pos_x = 245, pos_y = -122 }},
                   {"spr_nightstand_brochures_3",  { pos_x = 220, pos_y = -110 }},
                   {"spr_nightstand_letter",  { input = 1, alp = 1 }},
                   {"spr_apartment_stand_liflets_2",  { alp = 1 }} } );
  
  end;
  cmn.AddSubscriber( "clk_readbrochures", clk_readbrochures, "rm_apartment" );
  
  --------------------------------------------------------------------------------------------
  -- function clk_opendoordelivery () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_opendoordelivery" ] = {
      type = "click",
      use_place = "obj_apartment_clk_opendoordelivery",
      room = "rm_apartment"
  };
  --------------------------------------------------------------------------------------------
  local clk_opendoordelivery = function ()
    
    ObjDelete("obj_apartment_clk_opendoordelivery");
    ObjDelete("anm_apartment_door_knock");
  
    ObjMultiSet( { {"anm_apartment_capsule",  { alp = 1, animfunc = "func_porter" }},
                   {"spr_apartment_door_open", { alp = 1 }},
                   {"obj_apartment_use_documentation", { input = 1 }} } );
  
  end;
  cmn.AddSubscriber( "clk_opendoordelivery", clk_opendoordelivery, "rm_apartment" );
  
  --------------------------------------------------------------------------------------------
  -- function clk_opencapsule () end;
  --------------------------------------------------------------------------------------------
  local clk_opencapsule = function ()
  
    ObjMultiSet( { {"anm_apartment_capsule_2",  { frame = 300 }},
                   {"gmg_apartment_returning",  { event_mdown = function() cmn.GotoRoomMDown( "apartment_returning" ); end,
                                                  event_mup = function() cmn.GotoRoomMUp( "apartment_returning", "mg_returning" ); end }} } );
  
  end;
  cmn.AddSubscriber( "clk_opencapsule", clk_opencapsule, "rm_apartment" );
  
  --------------------------------------------------------------------------------------------
  -- function opn_apartmentdelivery () end;
  --------------------------------------------------------------------------------------------
  local opn_apartmentdelivery = function ()
  
    --ObjMultiSet( { {"anm_apartment_capsule",  { animfunc = "func_porter" }},
    --               {"spr_apartment_door_open", { alp = 1 }} } );
  
  end;
  cmn.AddSubscriber( "opn_apartmentdelivery", opn_apartmentdelivery, "rm_apartment" );
  
  --------------------------------------------------------------------------------------------
  -- function beg_level1 () end;
  --------------------------------------------------------------------------------------------
  local beg_level1 = function ()
  
    int_map_impl.OpenRoom( "rm_apartment" );
    interface_impl.SetCurrentGlobalTask( 1 );
    int_diary.SetVisibleHands( 1 );
    common_impl.ChangeRoomMiniback( "rm_apartment", 2 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "beg_level1", beg_level1 );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_lvl1desk" );
  subroom.Define( "zz_nightstand" );
  subroom.Define( "zz_computer" );
  subroom.Define( "zz_safe" );
  
  function zz_computer.PreOpen()
    
    if cmn.IsEventDone( "clk_startchat" ) and not(cmn.IsEventDone( "win_computer" )) then
      private.zz_computer.DrawScene();
    end;
    
    if cmn.IsEventDone("use_router") and not cmn.IsEventDone("clk_startchat") then
      PlaySfx("assets/levels/level1/audio/sfx/aud_elephant_games_monitor", 1, "", 1);
    end;

  end;
  
  function zz_computer.Open()
    
    if not cmn.IsEventDone("opn_computer") then
      cmn.SetEventDone("opn_computer");
      cmn.ShowBbt( "computer_open" );
    end;
    
    --if cmn.IsEventDone( "clk_startchat" ) and not(cmn.IsEventDone( "win_computer" )) then
    --  cmn.MiniGameShow();
    --  private.zz_computer.CheckWin();
    --end;

  end;
  
  function zz_computer.PreClose()
    
    if cmn.IsEventDone("clk_startchat") and not cmn.IsEventDone("win_computer") then
      private.zz_computer.active = 0;
      cmn.MiniGameHide("computer");
    end;
    
    if cmn.IsEventDone("use_router") and not cmn.IsEventDone("clk_startchat") then
      SndStop("assets/levels/level1/audio/sfx/aud_elephant_games_monitor", 1);
    end;
    
    if not cmn.IsEventDone("tutor_115") and ng_global.bonus[1] ~= 1 then
      local arrows = { { pos_x = 416, pos_y = -80, ang = -1.0 } };
      cmn.TutorialShow( "tutor_115", 0, 300, 400, arrows );
    end;
  end;
  function zz_nightstand.PreClose()
    
    if common_impl.GetCurrentNote() == "obj_nightstand_letter" and not cmn.IsEventDone("get_square2") then
      public.get_square2();
    end;
    
  end;
  
  function zz_nightstand.Close()
    
    cmn.HideNote( 0 );
    
  end;
  
  function zz_computer.Close()
    
    cmn.HideNote( 0 );
    
    if cmn.IsEventDone("clk_startchat") and not cmn.IsEventDone("win_computer") then
      ObjDetach("ted_computer_message");
      ObjMultiSet( { {"obj_computer_chat", { alp = 0, input = 0 }},
                     {"ted_computer_message", { input = 0 }} } );
    end;
    
  end;
                 
  function zz_lvl1desk.PreOpen()
    
    if cmn.IsEventDone("use_password") and not cmn.IsEventDone("win_lvl1desk") then
      private.zz_lvl1desk.DrawScene();
    end;
    
  end;
                 
  function zz_lvl1desk.Open()
    
    if cmn.IsEventDone("use_password") and not cmn.IsEventDone("win_lvl1desk") then
      private.zz_lvl1desk.CheckWin();
    end;
    
  end;
  
  function zz_lvl1desk.Close()
    
    if cmn.IsEventDone("get_documentation") and not cmn.IsEventDone("opn_apartmentdelivery") then
      
      cmn.SetEventDone("opn_apartmentdelivery");
      --cmn.CallEventHandler( "get_documentation_end" );
      
      local func_after = function ()
        
        cmn.Lock( 0 );
        common_impl.PauseAchiev(0);
        cmn.CallEventHandler("opn_apartmentdelivery");
        cmn.ShowBbt( "apartment_intercome_call" );
        
      end;
      
      local anm_change = function ()
        
        ObjMultiSet( { {"anm_apartment_capsule",  { frame = 0, animfunc = "func_porter", playing = 1 }},
                       {"spr_apartment_door_open", { alp = 1 }} } );
        
      end;
                     
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_loc_anim_door_knock");
      
      ObjAnimate("rm_apartment", "scale_xy", 0, 0, func_after, { 0, 0, 1, 1,   0.7, 0, 2, 2,    1.7, 0, 2, 2,    2.4, 0, 1, 1 });
      ObjAnimate("rm_apartment", "pos_xy", 0, 0, "", { 0, 0, 0, 0,   0.7, 0, 74, -183,    1.7, 0, 74, -183,    2.4, 0, 0, 0 });
      
    end;
    
  end;
  
  function zz_safe.PreOpen()
    
    if cmn.CheckMultiObject( "square", 3 ) and not cmn.IsEventDone("tutor_4") then
    
      if not(( ng_global.gamemode < 1 ) or ( ng_global.gamemode == 3 and ng_global.custom_gamemode.tutorial == 1 )) then
        cmn.SetEventDone("opn_safe");
      end;
      
    elseif cmn.IsEventDone("tutor_4") and not cmn.IsEventDone("opn_safe") then
      
      cmn.SetEventDone("opn_safe");
      
    end;
    
  end;
  
  function zz_safe.Open()
    
    if ( ng_global.gamemode < 1 ) or ( ng_global.gamemode == 3 and ng_global.custom_gamemode.tutorial == 1 ) then
    
      if not cmn.IsEventDone("tutor_4") then
        
        if cmn.CheckMultiObject( "square", 3 ) and not cmn.IsEventDone("opn_safe") then

          local func_after = function ()
            cmn.SetEventDone("opn_safe");
          end;

          ObjSet("tmr_safe_timer",  { time = 0.31, playing = 1, endtrig = func_after });

        end;
        
        if cmn.CheckMultiObject( "square", 3 ) and not cmn.IsEventDone("use_square") and not(common_impl.go_acievements) then
        
          public.ShowTutor4();

        end;
        
      end;
      
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_computer" ].state) then 
    private.zz_computer.StartConditions();
  end;

  private.zz_computer.state = ng_global.progress[ ng_global.currentprogress ][ "win_computer" ].state;
  
  private.zz_computer.player_name = GetCurrentProfile();
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_lvl1desk" ].state) then 
    private.zz_lvl1desk.StartConditions();
  end;

  private.zz_lvl1desk.state = ng_global.progress[ ng_global.currentprogress ][ "win_lvl1desk" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_apartment();
  
  if cmn.IsEventDone("clk_getphone") and not(cmn.IsEventDone("clk_takecall")) then

    private.anm_phone_call();

  end;
  
  if cmn.IsEventDone("clk_opendoordelivery") and not cmn.IsEventDone("use_documentation") then
    ObjSet("anm_apartment_capsule",  { playing = 1 });
  end;
  
  if cmn.IsEventDone("get_documentation") and not cmn.IsEventDone("clk_opendoordelivery") then
    ObjSet("anm_apartment_door_knock",  { playing = 1 });
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()
  
  if not cmn.IsEventDone("clk_getphone") then
    
    ObjSet("spr_apartment_phone_light",  { alp = 1 });
    ObjAnimate("spr_apartment_phone_light", "alp", 1, 0, "", { 0, 0, 1,   0.4, 0, 0,     0.8, 0, 0,    1.2, 0, 1 });
    
  end;
  
  if cmn.IsEventDone("beg_level1") and not(cmn.IsEventDone("clk_getphone")) then

    PlaySfx("assets/levels/level1/audio/sfx/aud_phone_calling_loc", 1, "", 1);
    
  elseif cmn.IsEventDone("clk_getphone") and not(cmn.IsEventDone("clk_takecall")) then

    PlaySfx("assets/levels/level1/audio/sfx/aud_phone_calling", 1, "", 1);

  end;
  
  if cmn.IsEventDone("clk_getphone") and not(cmn.IsEventDone("clk_takecall")) then

    private.anm_phone_call();

  end;
  
  --if cmn.IsEventDone("win_computer") and not cmn.IsEventDone("clk_answerintercom") then
  --  PlaySfx("assets/levels/level1/audio/sfx/aud_ohomephone_calls_loc", 1, "", 1);
  --end;
  
  if not ( cmn.IsEventDone( "beg_level1" ) ) then

    cmn.Lock(1);
    cmn.StopAllEnv();
    
    interface.WidgetSetVisible( "InterfaceWidget_Inventory", false, false );
    interface.WidgetSetInput( "InterfaceWidget_Inventory", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnHint", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnHint", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnGuide", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnGuide", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnMenu", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnMenu", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_BtnMap", false, false );
    interface.WidgetSetInput( "InterfaceWidget_BtnMap", 0 );
    interface.WidgetSetVisible( "InterfaceWidget_ButtonDiary", false, false );
    interface.WidgetSetInput( "InterfaceWidget_ButtonDiary", 0 );

    ObjSet("rm_apartment",  { color_r = 0, color_g = 0, color_b = 0 });
    
  else
    
    cmn.StopAllEnv("assets/levels/level1/audio/env/aud_apartment_env");
    cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_apartment_env");
    
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_router()

  local item = "inv_router";

  if cmn.ApplyObj( item, "gzz_apartment_computer" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_computer" );

  elseif ( cmn.ApplyObj( item, "obj_computer_use_router" ) ) then

    cmn.CallEventHandler( "use_router_inv" );
    cmn.CallEventHandler( "use_router_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_router" );
      cmn.CallEventHandler( "use_router_end" );
      
      PlaySfx("assets/levels/level1/audio/sfx/aud_elephant_games_monitor", 1, "", 1);
      
    end;
    
    local anm_pc_on = function ()
      
      ObjAnimate("spr_computer_router_on", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("anm_computer_icon", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 0,   0.8, 0, 1 });
      
      ObjAnimate("txt_computer_pc_no_signal", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 1,   0.8, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_use_router_apartment");

    ObjSet("anm_computer_use_router",  { alp = 1, playing = 1, endtrig = anm_pc_on });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_password()

  local item = "inv_password";

  if cmn.ApplyObj( item, "gzz_apartment_lvl1desk" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_lvl1desk", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_lvl1desk_use_password" ) ) then
    
    cmn.CallEventHandler( "use_password_inv" );
    cmn.CallEventHandler( "use_password_beg" );

    local func_after = function ()
      
      cmn.Lock( 0 );

      cmn.SetEventDone( "use_password" );
      cmn.CallEventHandler("use_password_end");
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_put_paper_zz_nightstand");

    ObjAnimate("obj_lvl1desk_code_hint", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });

  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_standkey()

  local item = "inv_standkey";

  if cmn.ApplyObj( item, "gzz_apartment_nightstand" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_nightstand", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_nightstand_use_standkey" ) ) then
    
    cmn.CallEventHandler( "use_standkey_inv" );
    cmn.CallEventHandler( "use_standkey_beg" );

    local func_after = function ()
      
      cmn.Lock( 0 );

      cmn.SetEventDone( "use_standkey" );
      cmn.CallEventHandler("use_standkey_end");
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_open_box_key");

    ObjSet("anm_nightstand_drawer_open",  { alp = 1, playing = 1, endtrig = func_after });
    
  else
    
    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_square()

  local item = "inv_square";
  interface.PopupHide();

  if cmn.ApplyObj( item, "gzz_apartment_safe" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_safe" );

  elseif ( cmn.ApplyObj( item, "obj_safe_use_square" ) and cmn.IsEventDone("opn_safe") and cmn.CheckMultiObject( "square", 3 ) ) then
    
    if (( ng_global.gamemode < 1 ) or ( ng_global.gamemode == 3 and ng_global.custom_gamemode.tutorial == 1 ))
    and not cmn.IsEventDone( "tutor_4" ) and common_impl.tutorial.current == "tutor_4" then
      --DbgTrace( "показывается тутор 4" );
      common_impl.Tutorial_Click( "empty" );
    end;

    cmn.CallEventHandler( "use_square_inv" );
    cmn.CallEventHandler( "use_square_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_square" );
      cmn.CallEventHandler( "use_square_end" );
      
      common.CloseSubRoom();
      
      local arrows = { { pos_x = -140, pos_y = -100, ang = 0.66 } };
      cmn.TutorialShow( "tutor_5", 0, 560, 400, arrows );
    
    end;

    cmn.Lock( 1 );

    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_safe_3_stuff");

    ObjSet("anm_safe_use_square",  { alp = 1, playing = 1, endtrig = func_after });
  
  else
    
    if (( ng_global.gamemode < 1 ) or ( ng_global.gamemode == 3 and ng_global.custom_gamemode.tutorial == 1 ))
      and not cmn.IsEventDone( "tutor_4" ) and common_impl.tutorial.current == "tutor_4" and cmn.IsEventDone("opn_safe") then
      --DbgTrace( "показывается тутор 4" );
      common_impl.Tutorial_Click( "empty" );
    end;

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_documentation()

  local item = "inv_documentation";

  if ( cmn.ApplyObj( item, "obj_apartment_use_documentation" ) and cmn.IsEventDone("clk_opendoordelivery") ) then
    
    cmn.CallEventHandler( "use_documentation_inv" );
    cmn.CallEventHandler( "use_documentation_beg" );

    local func_after = function ()
      
      cmn.Lock( 0 );

      cmn.SetEventDone( "use_documentation" );
      cmn.CallEventHandler("use_documentation_end");
      
      cmn.ShowBbt( "apartment_after_delivery" );
      int_diary.AddDiarypage( 5 );
    
    end;
    
    local anm_man = function ()
      
      ObjMultiSet( { {"anm_apartment_man",  { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_apartment_capsule_2", { alp = 1 }},
                     {"anm_apartment_capsule_3", { alp = 0 }} } );
      
    end;
                   
    local anm_capsule = function ()
      
      ObjMultiSet( { {"anm_apartment_capsule_3", { alp = 1, frame = 0, playing = 1, endtrig = anm_man }},
                     {"anm_apartment_capsule_4", { alp = 0 }} } );
      
    end;
                   
    local anm_enter = function ()
      ObjSet("anm_apartment_capsule_4",  { playing = 1, endtrig = anm_capsule });
    end;
    
    local anm_change = function ()
      
      ObjAnimate("anm_apartment_capsule", "alp", 0, 0, anm_enter, { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("anm_apartment_capsule_4", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_capsule_enters");

    ObjSet("anm_apartment_capsule",  { animfunc = "func_porter_give_doc", frame = 0, playing = 1, endtrig = anm_change });

  else
    
    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_router()
  
  ObjSet("spr_nightstand_router",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_router" );
  cmn.CallEventHandler( "get_router" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_documentation()
  
  ObjSet("anm_apartment_door_knock",  { playing = 1 });
  
  cmn.Lock( 1 );

  cmn.SetEventDone( "get_documentation" );
  cmn.CallEventHandler( "get_documentation" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_password()

  cmn.SetEventDone( "get_password" );
  cmn.CallEventHandler( "get_password" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_square1()

  cmn.SetEventDone( "get_square1" );
  cmn.CallEventHandler( "get_square1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_square2()

  cmn.SetEventDone( "get_square2" );
  cmn.CallEventHandler( "get_square2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_square3()

  cmn.SetEventDone( "get_square3" );
  cmn.CallEventHandler( "get_square3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_phone()
  
  ObjStopAnimate("spr_apartment_phone_light", "alp");
  
  local func_after = function ()

    cmn.SetEventDone( "clk_getphone" );
    cmn.CallEventHandler( "clk_getphone" );
    
    cmn.Lock( 0 );
    
  end;

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  SndStop("assets/levels/level1/audio/sfx/aud_phone_calling_loc", 1);
  PlaySfx("assets/levels/level1/audio/sfx/aud_phone_calling", 1, "", 1);
  
  cmn.Lock( 1 );
  
  ObjAttach("obj_apartment_phone", "rm_apartment");
  
  private.anm_phone_call();
  
  ObjAnimate("obj_apartment_phone", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
  ObjAnimate("spr_apartment_phone", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  ObjAnimate("spr_apartment_phone_sh", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_startchat()

  cmn.CallEventHandler( "clk_startchat_beg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_startchat" );
    --cmn.CallEventHandler( "clk_startchat_end" );
    
    public.zz_computer.OpenMg( 1 );

  end;
  
  --cmn.PlayAudio("snd", "assets/levels/level1/rm_apartment/audio/");
  cmn.Lock( 1 );
  SndStop("assets/levels/level1/audio/sfx/aud_elephant_games_monitor", 1);
  
  --ObjAnimate("spr_computer_chat_after", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
  ObjAnimate("anm_computer_icon", "alp", 0, 0, func_after, { 0, 0, 1,   0.3, 0, 0 });

end;
--------------------------------------------------------------------------------------------
function public.clk_framedphoto()
  
  cmn.SetEventDone( "clk_framedphoto" );

  local func_after = function ()

    --cmn.SetEventDone( "clk_framedphoto" );
    cmn.CallEventHandler( "clk_framedphoto" );
    
    cmn.ShowBbt( "lvl1desk_after_flashback" );
    
    cmn.Lock(0);
    
  end;
  
  local anm_pic = function ()
    
    cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_apartment_env");

    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_click_photo_diss");
    
    ObjSet("anm_lvl1desk_photo",  { alp = 1, playing = 1, endtrig = func_after });
    
    ObjAnimate("obj_lvl1desk_square", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    
  end;
  
  cmn.StopAllEnv();
  cmn.PlayFullscreenVideo( "assets/levels/level1/rm_apartment/zz_lvl1desk/vid_flashback", anm_pic, "assets/levels/level1/audio/mus/aud_flashback_mus", "assets/levels/level1/audio/voc/aud_1_lvl_vid_flashback_1_voc");

end;
--------------------------------------------------------------------------------------------
function public.clk_takecall()

  cmn.Lock(1);
  cmn.CallEventHandler( "clk_takecall_beg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_takecall" );
    cmn.CallEventHandler( "clk_takecall_end" );
    cmn.CallEventHandler( "clk_takecall_tsk" );
    
    cmn.Lock(0);
    cmn.ShowBbt( "apartment_after_light" );
    
    if not cmn.IsEventDone("tutor_2") then
    
      local arrows = { { pos_x = 160, pos_y = 170, ang = -2.4 } };

      cmn.TutorialShow( "tutor_2", 0, 300, 200, arrows );
      
    end;

  end;
  
  local anm_light = function ()
    
    cmn.PlayAudio("mus", "assets/levels/level1/audio/mus/aud_lights_up_mus", 0, false, 127);
      
    ObjAnimate("spr_apartment_back_2", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
    ObjAnimate("spr_apartment_darkness_1", "alp", 0, 0, "", { 0, 0, 0.6,   0.5, 0, 0 });
    
    ObjAnimate("spr_apartment_pc_router_old_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    ObjAnimate("spr_apartment_pc_router_old_2", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    
    ObjAnimate("spr_apartment_pc_brochures", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    ObjAnimate("spr_apartment_pc_brochures_2", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    
    ObjAnimate("spr_apartment_capsule_bl", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    ObjAnimate("spr_apartment_capsule_bl_2", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    ObjAnimate("obj_apartment_light", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    ObjAnimate("anm_apartment_door_knock", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    
    ObjAnimate("spr_bonus_1", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    ObjAnimate("spr_bonus_2", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    
  end;
  
  local phone_away = function ()
    
    int_blackbartext.Hide();
    ObjAnimate("obj_apartment_phone", "alp", 0, 0, anm_light, { 0, 0, 1,   0.5, 0, 0 });
    
  end;
  
  local anm_call = function ()
    
    cmn.ShowDlgBbt( "complex_phone_stranger_voc_1" );
    cmn.PlayAudio("voc", "assets/levels/level1/audio/voc/aud_1_lvl_stephen_1_voc");
    
    ObjMultiSet( { {"anm_complex_phone_dialing",  { playing = 1 }},
                   {"tmr_complex_phone_timer", { time = 8, playing = 1, endtrig = phone_away }} } );
    
  end;
  
  SndStop("assets/levels/level1/audio/sfx/aud_phone_calling", 1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_click_phone");
  
  ObjStopAnimate("txt_complex_phone_call_text_1", "alp");
  ObjAnimate("txt_complex_phone_call_text_1", "alp", 0, 0, "", { 0, 0, ObjGet("txt_complex_phone_call_text_1").alp,   0.2, 0, 1 });

  ObjAnimate("obj_complex_phone_call_2", "alp", 0, 0, anm_call, { 0, 0, 0,   0.8, 0, 0,   1.2, 0, 1 });
  ObjAnimate("spr_complex_phone_answer", "alp", 0, 0, "", { 0, 0, 1,   0.8, 0, 1,   1.2, 0, 0 });
  
  ObjAnimate("spr_complex_phone_decline", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  
  ObjAnimate("spr_complex_phone_answer", "pos_xy", 0, 0, "", { 0, 0, 54, 98,   0.8, 0, 129, 36 });

end;
--------------------------------------------------------------------------------------------
function public.clk_opencapsule()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_capsule_go_mg");

  local func_after = function ()

    cmn.SetEventDone( "clk_opencapsule" );
    cmn.CallEventHandler( "clk_opencapsule" );

    cmn.Lock(0);
    cmn.GotoRoom("mg_returning");
    
  end;
  
  ObjSet("anm_apartment_capsule_2",  { alp = 1, playing = 1, endtrig = func_after });
  
end;
--------------------------------------------------------------------------------------------
function public.clk_opendoordelivery()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_man_goes_capsule");

  local func_after = function ()

    cmn.SetEventDone( "clk_opendoordelivery" );
    cmn.CallEventHandler( "clk_opendoordelivery" );

    cmn.Lock(0);
    
  end;
  
  ObjDelete("anm_apartment_door_knock");
  ObjSet("anm_apartment_capsule",  { alp = 1, playing = 1, endtrig = func_after });
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_apartment()

  if not ( cmn.IsEventDone( "beg_level1" ) ) then
    
    local func_after = function ()

      ObjSet("rm_apartment",  { color_r = 1, color_g = 1, color_b = 1 });
      
      cmn.ShowBbt( "apartment_open" );
      interface_impl.ShowGlobalTask();

      cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_apartment_env");
      cmn.PlayAudio("mus", "assets/levels/level1/audio/mus/aud_scare_begin_mus", 0, false, 113);
      
      --interface.WidgetSetVisible( "InterfaceWidget_Inventory", false, false );
      --interface.WidgetSetInput( "InterfaceWidget_Inventory", 0 );
      
      interface.WidgetSetVisible( "InterfaceWidget_Inventory", true, true );
      interface.WidgetSetInput( "InterfaceWidget_Inventory", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnHint", true, true );
      interface.WidgetSetInput( "InterfaceWidget_BtnHint", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnGuide", true, true );
      interface.WidgetSetInput( "InterfaceWidget_BtnGuide", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnMenu", true, true );
      interface.WidgetSetInput( "InterfaceWidget_BtnMenu", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_BtnMap", true, true );
      interface.WidgetSetInput( "InterfaceWidget_BtnMap", 1 );
      interface.WidgetSetVisible( "InterfaceWidget_ButtonDiary", true, true );
      interface.WidgetSetInput( "InterfaceWidget_ButtonDiary", 1 );
      
      cmn.TutorialShow("tutor_enable");
    
      PlaySfx("assets/levels/level1/audio/sfx/aud_phone_calling_loc", 1, "", 1);
      
      int_diary.AddDiarypage( 1 );
      int_diary.AddDiarypage( 2 );
      int_diary.AddDiarypage( 3 );
      int_diary.AddDiarypage( 4 );
      
    end;

    cmn.Lock(0);
    
    cmn.SetEventDone( "beg_level1" );
    cmn.CallEventHandler("beg_level1");
    
    cmn.PlayFullscreenVideo( "assets/levels/level1/rm_apartment/vid_intro", func_after, "assets/levels/level1/audio/mus/aud_apartment_intro_vid", "assets/levels/level1/audio/voc/aud_announcer_1");
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.anm_phone_call()
  
  --PlaySfx("assets/levels/level1/audio/sfx/aud_phone_calling", 1, "", 1);
  
  ObjSet("txt_complex_phone_call_text_1",  { alp = 1 });
  ObjAnimate("txt_complex_phone_call_text_1", "alp", 1, 0, "", { 0, 0, 1,   0.4, 0, 0,     0.8, 0, 0,    1.2, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function public.open_computer_note()
  
  if not cmn.IsEventDone("clk_readbrochures") then
    cmn.Lock( 1 );
    cmn.SetEventDone("clk_readbrochures");
    ObjSet("tmr_nightstand_timer",  { time = 0.3, playing = 1, endtrig = function() cmn.Lock( 0 ); cmn.CallEventHandler("clk_readbrochures"); end });
  end;
    
  ObjMultiSet( { {"spr_nightstand_note_1", { alp = 1, input = 1 }},
                 {"spr_nightstand_note_2", { alp = 1, input = 0 }} } );
  
  cmn.ShowNote( "obj_nightstand_note", false, "assets/levels/level1/audio/sfx/aud_paper_table_1", true );
  
end;
--------------------------------------------------------------------------------------------
function public.turn_note_page(num)

  local pg1 = num;
  local pg2 = num+1;

  local func_after = function ()

    cmn.Lock(0);

    ObjMultiSet( { {"spr_nightstand_note_"..pg1, { input = 0 }},
                   {"spr_nightstand_note_"..pg2, { input = 1 }} } );

  end;

  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_paper_table_2");

  ObjAnimate("spr_nightstand_note_"..pg1, "alp", 0, 0, func_after, { 0, 0, 1,   0.3, 0, 0 });

end;
--------------------------------------------------------------------------------------------
function public.close_pc_note()
  
  cmn.HideNote( 1 );
  
end;
--------------------------------------------------------------------------------------------
function public.open_jean_letter()
  
  cmn.ShowNote( "obj_nightstand_letter", false, false, true );
  game.hint[ "get_square2" ].get_obj = "spr_nightstand_square2";
  
end;
--------------------------------------------------------------------------------------------
function public.close_jean_letter()
  
  cmn.HideNote( 1 );
  
  if not cmn.IsEventDone("get_square2") then
    public.get_square2();
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_router()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_no_signal");
  
  cmn.ShowBbt( "obj_computer_use_router" );
  
  ObjAnimate("txt_computer_pc_no_signal", "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 1,   0.3, 0, 0,    0.6, 0, 1,     0.9, 0, 0,    1.2, 0, 1 });
    
  ObjAnimate("txt_computer_pc_error_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0,    0.6, 0, 1,     0.9, 0, 0,    1.2, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_desk_box()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_zz_lvldesk_phone");
  
  cmn.ShowBbt( "obj_lvl1desk_use_password" );
  
  ObjSet("anm_lvl1desk_box_touch",  { alp = 1, playing = 1, endtrig = function() cmn.Lock(0); end });
    
  ObjAnimate("obj_lvl1desk_game", "pos_y", 0, 0, "", { 0, 0, 0,   0.15, 0, -2,   0.3, 0, 0 });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_stand_drawer()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_box_nightstand");
  
  cmn.ShowBbt( "obj_nightstand_use_standkey" );
  
  ObjSet("anm_nightstand_drawer_touch",  { alp = 1, playing = 1, endtrig = function() cmn.Lock(0); end });
    
end;
--------------------------------------------------------------------------------------------
function public.touch_safe()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_zz_safe");
  
  cmn.ShowBbt( "obj_safe_use_square" );
  
  ObjSet("anm_safe_touch",  { alp = 1, playing = 1, endtrig = function() cmn.Lock(0); end });
    
end;
--------------------------------------------------------------------------------------------
function public.touch_delivery_guy()
  
  cmn.Lock(1);
  --cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/");
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    ObjSet("anm_apartment_capsule",  { animfunc = "func_porter", frame = 0, playing = 1 });
    
  end;
  
  cmn.ShowBbt( "obj_apartment_use_documentation" );
  
  ObjSet("anm_apartment_capsule",  { animfunc = "func_klick_porter", frame = 0, playing = 1, endtrig = func_after });
  
end;
--------------------------------------------------------------------------------------------
function public.ShowTutor4()
  
  if ( ng_global.gamemode < 1 ) or ( ng_global.gamemode == 3 and ng_global.custom_gamemode.tutorial == 1 ) then

    interface.InventoryAutoHideSave();

    if int_inventory.GetAutohide() then
      int_inventory.SetAutohide(false);
      int_inventory.Show( true );
    end;

  end;

  local carkey_pos = GetObjPosByObj("hub_int_inventory_square");
  local px = 0;

  if ObjGet("hub_int_inventory_square") then
    px = math.floor(carkey_pos[1]);
  end;
    
  ObjSet("obj_tutorial_tutor_4_2",  { pos_x = px, pos_y = 718 });

  local arrows = { { pos_x = -50, pos_y = -140, ang = 0 }, { pos_x = px - 570, pos_y = 140, ang = 2.58 } };

  if int_inventory.GetDraggingObject() then
    arrows = { { pos_x = -50, pos_y = -140, ang = 0 } };
  end;

  cmn.TutorialShow( "tutor_4", 0, 600, 500, arrows );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Computer *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_computer = {};
public.zz_computer = {};

function private.Init_Computer()
  
  private.zz_computer.typing_dev = 2;
  private.zz_computer.typing_size = 22;
  private.zz_computer.chat_win_size = {165, 60};
  private.zz_computer.window_max = 170;
  private.zz_computer.prev_text = "";
  private.zz_computer.right_number = "76";
  private.zz_computer.icon_size = 45;
  
  private.zz_computer.active = 0;
  -----------------------------------------------------------------------------------
  game.hint[ "win_computer" ] = {
    type = "click",
    use_place = "gzz_computer_chat",
    room = "rm_apartment",
    zz = "zz_computer",
    zz_gate = "gzz_apartment_computer"
  };
  -----------------------------------------------------------------------------------
  local win_computer = function ()

    if cmn.IsEventDone( "win_computer" ) then
      
      ObjDelete( "obj_computer_chat" );
      ObjDelete( "gzz_computer_chat" );
      
      ObjMultiSet( { {"anm_computer_password_print",  { frame = 400, input = 1 }},
                     {"spr_apartment_pc_code", { alp = 1 }} } );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_computer", win_computer, "rm_apartment" );

end;
--*********************************************************************************************************************
function public.zz_computer.OpenMg( num )

  cmn.Lock( 1 );

  port.TapDown(2.0);
  
  local func_after = function ()
    
    if num == 1 then
      
      cmn.CallEventHandler( "clk_startchat_end" );
      private.zz_computer.ShowMessage();
    
      if not(cmn.IsEventDone("tutor_13")) then

        local arrows = { { pos_x = 320, pos_y = 0, ang = -1.57 }, { pos_x = 300, pos_y = 120, ang = -2.6 } };

        if ( GetWideScreen() ) then

          ObjMultiSet( { {"obj_tutorial_tutor_13", { pos_x = -600 }},
                         {"obj_tutorial_tutor_13_1", { pos_x = 1127 }} } );

          arrows[1] = { pos_x = 400, pos_y = 0, ang = -1.57 };

          cmn.TutorialShow( "tutor_13", 0, 600, 511, arrows );

        else 

          ObjMultiSet( { {"obj_tutorial_tutor_13", { pos_x = -512 }},
                         {"obj_tutorial_tutor_13_1", { pos_x = 956 }} } );

          arrows[2] = { pos_x = 400, pos_y = 120, ang = -2.6 };

          cmn.TutorialShow( "tutor_13", 0, 512, 511, arrows );

        end;

      end;
      
    end;
    
    ObjAttach("ted_computer_message", "obj_computer_message");
    
    cmn.MiniGameShow();
    private.zz_computer.CheckWin();

    ObjMultiSet( { {"obj_computer_chat", { alp = 1, input = 1 }},
                   {"obj_computer_back", { pos_y = 0, scale_x = 1, scale_y = 1 }} } );

  end;
  
  local show_mmg = function ()
  
    ObjAnimate( "obj_computer_chat", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 } );
  
  end;
  
  private.zz_computer.active = 1;
  
  if num == 2 then

    ObjAnimate( "obj_computer_back", "scale_xy", 0, 0, "", { 0,0,1,1,   0.3,0,1,1,    1.5,0,1.4,1.4 } );
    ObjAnimate( "obj_computer_back", "pos_y",   0, 0, show_mmg, { 0,0,0,   0.3,0,0,    1.5,0,111 } );
    
  else 
    show_mmg();
  end;

end;
--*********************************************************************************************************************
function private.zz_computer.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_computer" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_computer" ].state = { 1, 0, {}, { {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0} }, 0 }; 
  --[1] - stage, [2] - started, [3] - player texts, [4] - pos_y of messages, [5] - tries of number
  
end;
-----------------------------------------------------------------------------------
function public.zz_computer.Reset()
  
  if private.zz_computer.state[1] > 1 or private.zz_computer.state[2] > 0 then
    
    cmn.Lock( 1 );
    private.zz_computer.ClearTextEdit();
    ObjSet("ted_computer_message",  { input = 0 });
    
    local stage = private.zz_computer.state[1];
    
    for i = 1, private.zz_computer.state[1], 1 do
      
      ObjAnimate("obj_computer_message_"..i.."_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
      if i < private.zz_computer.state[1] then
        ObjAnimate("obj_computer_message_"..i.."_2", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      end;
      
    end;
    
    private.zz_computer.StartConditions();
    private.zz_computer.state = ng_global.progress[ ng_global.currentprogress ][ "win_computer" ].state;
    
    ObjSet("tmr_computer_timer",  { time = 0.5, playing = 1, endtrig = function() private.zz_computer.ClearTexts(stage); end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_computer.Skip()
  
  cmn.MiniGameHide("computer");
  
  cmn.SetEventDone( "win_computer" );
  
  cmn.Lock( 1 );
  
  ObjSet("ted_computer_message",  { input = 0 });
  
  ng_global.progress[ ng_global.currentprogress ][ "win_computer" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_computer" ].state = { 6, 0, {}, { {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0} }, 0 }; 
  
  --cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
  
  ObjSet("tmr_computer_timer",  { time = 0.5, playing = 1, endtrig = private.zz_computer.Win });
  
end;
-----------------------------------------------------------------------------------
function private.zz_computer.ClearTexts( endparam )
  
  for i = 1, endparam, 1 do
    
    ObjSet("txt_computer_chat_message_"..i.."_1",  { text = "" });
    
    if i < endparam then
      ObjSet("txt_computer_chat_message_"..i.."_2",  { text = "" });
    end;
    
  end;
  
  private.zz_computer.ShowMessage();
  
end;
-----------------------------------------------------------------------------------
function private.zz_computer.DrawScene()
  
  local text_size, size_m, old_size_m = 0, 0, 0;
  local endparam = private.zz_computer.state[1]-1+private.zz_computer.state[2];
  local flag = false;
  
  local text_size_h = 0;
  local text_size_w = 0;
  
  local spr_size = {0, 0};
  
  if private.zz_computer.state[1] > 5 then
    ObjSet("ted_computer_message",  { input = 0 });
    endparam = 5;
    flag = true;
  end;
  
  for i = 1, endparam, 1 do
    
    if i > 1 then
      ObjSet("txt_computer_chat_message_"..i.."_1",  { text = StringGet("str_computer_chat_message_"..i) });
    else 
      local new_text = StringGet("str_computer_chat_message_1_1").." "..private.zz_computer.player_name..StringGet("str_computer_chat_message_1_2");
      ObjSet("txt_computer_chat_message_"..i.."_1",  { text = new_text });
    end;
    
    if i < endparam or flag or private.zz_computer.state[2] == 0 then
      ObjSet("txt_computer_chat_message_"..i.."_2",  { text = private.zz_computer.state[3][i] });
    end;
    
  end;
  
  for i = endparam, 1, -1 do
    
    if i < endparam or flag or private.zz_computer.state[2] == 0 then
      
      size_m = ObjGet("txt_computer_chat_message_"..i.."_2").draw_height;
      old_size_m = private.zz_computer.state[4][ i ][2];
      
      text_size_w = ObjGet("txt_computer_chat_message_"..i.."_2").draw_width;
    
      spr_size[1] = text_size_w/private.zz_computer.chat_win_size[1];
      spr_size[2] = size_m/private.zz_computer.chat_win_size[2];
      
      ObjMultiSet( { {"obj_computer_message_"..i.."_2",  { pos_y = old_size_m, alp = 1 }},
                     {"spr_computer_message_"..i.."_2",  { scale_x = -spr_size[1], scale_y = spr_size[2] }} } );
      
    end;
    
    size_m = ObjGet("txt_computer_chat_message_"..i.."_1").draw_height;
    old_size_m = private.zz_computer.state[4][ i ][1];
    --text_size = text_size + size_m + 10;
    
    text_size_w = ObjGet("txt_computer_chat_message_"..i.."_1").draw_width;
    
    spr_size[1] = text_size_w/private.zz_computer.chat_win_size[1];
    spr_size[2] = size_m/private.zz_computer.chat_win_size[2];
    
    ObjMultiSet( { {"obj_computer_message_"..i.."_1",  { pos_y = old_size_m, alp = 1 }},
                   {"spr_computer_message_"..i.."_1",  { scale_x = spr_size[1], scale_y = spr_size[2] }} } );
    
  end;
  
  --if private.zz_computer.state[1] <= 5 and private.zz_computer.state[2] == 0 then
  --  cmn.Lock( 1 );
  --  ObjSet("ted_computer_message",  { input = 0 });
  --  private.zz_computer.ShowMessage();
  --end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_computer.GetNewTextPos( prev_num, prev_type )
  
  local step = 15;
  if prev_num > 1 then
    step = 30;
  end;
  local prev = ObjGet("txt_computer_chat_message_"..prev_num.."_"..prev_type).draw_height;
  
  if prev < private.zz_computer.icon_size then
    prev = private.zz_computer.icon_size;
  end;
  
  local new_pos = ObjGet("obj_computer_message_"..prev_num.."_"..prev_type).pos_y + prev + step;
  
  --DbgTrace(new_pos)
  return new_pos;
  
end;
-----------------------------------------------------------------------------------
function private.zz_computer.MoveTexts( dev, stage, flag )
  
  flag = flag or false;
  
  local new_pos = 0
  local step = 1;
  
  if flag then
    step = 0;
  end;
  
  --DbgTrace("dev "..dev)
  
  for i = 1, stage, 1 do
    
    new_pos = private.zz_computer.state[4][ i ][1] - dev;
    --DbgTrace("mess "..i.." new "..new_pos)
    private.zz_computer.state[4][ i ][1] = new_pos;
    ObjAnimate("obj_computer_message_"..i.."_1", "pos_y", 0, 0, "", { 0, 0, new_pos+dev,   0.3, 0, new_pos });
    
  end;

  for i = 1, stage-step, 1 do
    
    new_pos = private.zz_computer.state[4][ i ][2] - dev;
    --DbgTrace("ans "..i.." new "..new_pos)
    private.zz_computer.state[4][ i ][2] = new_pos;
    ObjAnimate("obj_computer_message_"..i.."_2", "pos_y", 0, 0, "", { 0, 0, new_pos+dev,   0.3, 0, new_pos });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_computer.ShowMessage()
  
  ObjSet("ted_computer_message",  { input = 0 });
  
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_opponent_writes_message");
  
  local new_pos = 0;
  local dev = 0;
  
  if private.zz_computer.state[1] > 1 then
    --new_pos = private.zz_computer.GetTextSize( 1, private.zz_computer.state[1], true );
    new_pos = private.zz_computer.GetNewTextPos( private.zz_computer.state[1]-1, 2 );
  end;
  
  if new_pos + private.zz_computer.typing_size > private.zz_computer.window_max then
    new_pos = private.zz_computer.window_max - private.zz_computer.typing_size;
    dev = private.zz_computer.typing_size + 15;
  end;
  
  if dev > 0 then 
    private.zz_computer.MoveTexts( dev, private.zz_computer.state[1]-1, true );
  end;
  
  ObjSet("spr_computer_message_typing",  { pos_y = new_pos + private.zz_computer.typing_dev });
                 
  if private.zz_computer.state[1] == 1 then
    
    local new_text = StringGet("str_computer_chat_message_1_1").." "..private.zz_computer.player_name..StringGet("str_computer_chat_message_1_2");
    ObjSet("txt_computer_chat_message_"..private.zz_computer.state[1].."_1",  { text = new_text });
    
  else
    
    ObjSet("txt_computer_chat_message_"..private.zz_computer.state[1].."_1",  { text = StringGet("str_computer_chat_message_"..private.zz_computer.state[1]) });
    
  end;
  
  local text_size_h = ObjGet("txt_computer_chat_message_"..private.zz_computer.state[1].."_1").draw_height;
  local text_size_w = ObjGet("txt_computer_chat_message_"..private.zz_computer.state[1].."_1").draw_width;
  
  local spr_size = {0, 0};
  spr_size[1] = text_size_w/private.zz_computer.chat_win_size[1];
  spr_size[2] = text_size_h/private.zz_computer.chat_win_size[2];
  
  if new_pos + text_size_h > private.zz_computer.window_max then
    dev = new_pos + text_size_h - private.zz_computer.window_max + 15;
    --DbgTrace(dev.." "..new_pos.." "..text_size_h)
    new_pos = private.zz_computer.window_max - text_size_h;
  end;
  
  local anm_new_mess = function ()
    
    local func_after = function ()
      cmn.Lock(0);
      private.zz_computer.state[2] = 1;
      ObjSet("ted_computer_message",  { input = 1 });
    end;
    
    if dev > 0 then 
      private.zz_computer.MoveTexts( dev, private.zz_computer.state[1]-1, true );
    end;
    
    ObjAnimate("obj_computer_message_"..private.zz_computer.state[1].."_1", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    
  end;
  
  private.zz_computer.state[4][ private.zz_computer.state[1] ][1] = new_pos;
    
  ObjMultiSet( { {"spr_computer_message_"..private.zz_computer.state[1].."_1",  { scale_x = spr_size[1], scale_y = spr_size[2] }},
                 {"obj_computer_message_"..private.zz_computer.state[1].."_1", { pos_y = new_pos }} } );
  
  ObjAnimate("spr_computer_message_typing", "alp", 0, 0, anm_new_mess, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 0,  0.9, 0, 1,  1.2, 0, 0,  1.5, 0, 1,  1.8, 0, 0 });
  
end;
-----------------------------------------------------------------------------------
function public.zz_computer.SendMessage()
  
  local message = ObjGet("ted_computer_message").text;
  
  port.TapDown(2.0);
  
  if utf8.len(message) > 0 and ( private.zz_computer.state[1] < 5 
  or message == private.zz_computer.right_number or message == StringGet("str_computer_chat_right_number") ) then
  
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_click_enter");
    
    ObjSet("ted_computer_message",  { input = 0 });
    
    local stage = private.zz_computer.state[1];
    
    private.zz_computer.state[1] = private.zz_computer.state[1] + 1;
    private.zz_computer.state[2] = 0;
    
    --local new_pos = private.zz_computer.GetTextSize( 1, stage, true );
    local new_pos = private.zz_computer.GetNewTextPos( stage, 1 );
    local dev = 0;
    
    table.insert(private.zz_computer.state[3], message);
    
    private.zz_computer.ClearTextEdit();
    
    ObjSet("txt_computer_chat_message_"..stage.."_2",  { text = message });

    local text_size_h = ObjGet("txt_computer_chat_message_"..stage.."_2").draw_height;
    local text_size_w = ObjGet("txt_computer_chat_message_"..stage.."_2").draw_width;
    
    local spr_size = {0, 0};
    spr_size[1] = text_size_w/private.zz_computer.chat_win_size[1];
    spr_size[2] = text_size_h/private.zz_computer.chat_win_size[2];
    
    if spr_size[1] < 1 then
      spr_size[1] = spr_size[1] + 0.1;
    end;
    
    if new_pos + text_size_h > private.zz_computer.window_max then
      new_pos = private.zz_computer.window_max - text_size_h;
      dev = text_size_h + 30;
    end;
    
    private.zz_computer.state[4][ stage ][2] = new_pos;
    
    ObjMultiSet( { {"spr_computer_message_"..stage.."_2",  { scale_x = -spr_size[1], scale_y = spr_size[2] }},
                   {"obj_computer_message_"..stage.."_2", { pos_y = new_pos }} } );
      
    if dev > 0 then             
      private.zz_computer.MoveTexts( dev, stage );
    end;
    
    ObjAnimate("obj_computer_message_"..stage.."_2", "alp", 0, 0, function() private.zz_computer.CheckWin(true); end, { 0, 0, 0,   0.3, 0, 1 });
      
  elseif private.zz_computer.state[1] == 5 
  and message ~= private.zz_computer.right_number and message ~= StringGet("str_computer_chat_right_number") then
  
    private.zz_computer.state[5] = private.zz_computer.state[5] + 1;
    
    cmn.ShowBbt( "computer_wrong_apartment_number" );
    
    --if private.zz_computer.state[5] % 3 ~= 0 then
    --  cmn.ShowBbt( "computer_wrong_apartment_number" );
    --else 
    --  cmn.ShowDlgBbt( "apartment_ai_voc_2", 1 );
    --  SndStop("assets/levels/level1/audio/voc/aud_ai_number", 0.5);
    --  cmn.PlayAudio("voc", "assets/levels/level1/audio/voc/aud_ai_number");
    --end;
    
  end;

  if (( ng_global.gamemode < 1 ) or ( ng_global.gamemode == 3 and ng_global.custom_gamemode.tutorial == 1 ))
  and not cmn.IsEventDone( "tutor_12" ) and common_impl.tutorial.current == "tutor_12" then
  --DbgTrace( "показывается тутор 12" );
    common_impl.Tutorial_Click( "empty" );
  end;
  
  if (( ng_global.gamemode < 1 ) or ( ng_global.gamemode == 3 and ng_global.custom_gamemode.tutorial == 1 ))
  and not cmn.IsEventDone( "tutor_13" ) and common_impl.tutorial.current == "tutor_13" then
  --DbgTrace( "показывается тутор 13" );
    common_impl.Tutorial_Click( "empty" );
  end;
  
end;
------------------------------------------------------------------------------
function public.zz_computer.FocusButton( butt, inout )
  
  local obj = "spr_computer_button_"..butt.."_on";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      --cmn.PlayAudio("snd", "assets/levels/level2/mg_onmagicstone/audio/aud_xx_menter_stone");
    end;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
------------------------------------------------------------------------------
function public.zz_computer.ClickButton( text_add )
  
  local new_text = ObjGet("ted_computer_message").text;
  private.zz_computer.prev_text = new_text;
  
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_click_buttons_"..math.random(1, 3));
  
  if ng.textedit.Length("ted_computer_message") < 100 then
  
    if type( text_add ) == "number" or text_add == " " then
      new_text = new_text..text_add;
    else 
      new_text = new_text..StringGet("str_computer_button_"..text_add);
    end;
    
    ObjSet("ted_computer_message",  { text = new_text });
    
  end;
  
end;
------------------------------------------------------------------------------
function private.zz_computer.ClearTextEdit()

  ObjSet( 'ted_computer_message',  { text = ""} );

  local object_params = ObjGet( "ted_computer_message" );--удаляем и создаем новый textedit с дубликата
  --костыль для указания верного положения "палочки" при очистке строки
  ObjDelete("ted_computer_message");
  ObjCreate( "ted_computer_message", "textedit" );
  ObjSet( "ted_computer_message", object_params );

  ObjAttach("ted_computer_message", "obj_computer_message");

end;
------------------------------------------------------------------------------
function public.zz_computer.ClearTextEditByOne()
  
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_click_buttons_"..math.random(1, 3));
  private.zz_computer.ClearTextEdit();

--  local cur_text = ObjGet( "ted_computer_message" ).text;
--  --local len = ng.textedit.Length("ted_computer_message");
--  local len = utf8.len( cur_text );
--  
--  --DbgTrace(len)
--  
--  if len > 0 then
--    
--    ObjSet("ted_computer_message",  { text = "" });
--  
--    cur_text = ne.utf8.Sub( cur_text, 1, len-1 );
--    
--    local object_params = ObjGet( "ted_computer_message" );--здесь то же самое
--
--    ObjDelete("ted_computer_message");
--
--    ObjCreate( "ted_computer_message", "textedit" );
--    ObjSet( "ted_computer_message", object_params );
--
--    ObjAttach("ted_computer_message", "obj_computer_message");
--    
--    ObjSet( "ted_computer_message",  { text = cur_text } );
--    
--  end;

end;
-----------------------------------------------------------------------------------
function private.zz_computer.CheckWin( ingame )
  
  ingame = ingame or false;
  
  if private.zz_computer.state[1] > 4 then
    
    cmn.Lock( 1 );
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("computer");
    
    --cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_win_mmg" );
    
    ObjSet("tmr_computer_timer",  { time = 1, playing = 1, endtrig = private.zz_computer.Win });
    
  elseif ingame then
    
    private.zz_computer.ShowMessage();
    
  elseif private.zz_computer.state[2] == 0 then
    
    cmn.Lock( 1 );
    ObjSet("ted_computer_message",  { input = 0 });
    private.zz_computer.ShowMessage();
    
  else 
    
    cmn.Lock( 0 );
    ObjSet("ted_computer_message",  { input = 1 });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_computer.Win()
  
  --cmn.Lock( 0 );
  --common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_computer" );
  --cmn.CallEventHandler( "win_computer" );
  
  ObjSet("spr_computer_password",  { alp = 1 });
  ObjDelete( "gzz_computer_chat" );
  
  local func_after = function ()
    cmn.Lock( 0 );
    common_impl.PauseAchiev(0);
    cmn.CallEventHandler( "win_computer" );
  end;
  
  local anm_print = function ()
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_2793_paper");
    ObjSet("anm_computer_password_print",  { playing = 1, endtrig = func_after });
  end;
  
  ObjDelete("ted_computer_message");
  ObjAnimate("obj_computer_chat", "alp", 0, 0, anm_print, { 0, 0, 1,   0.5, 0, 0 });

  if ng_global.progress[ ng_global.currentprogress ][ "win_computer" ].skip == 0 and ng_global.noskipgames[ "win_computer" ] == nil then

    ng_global.noskipgames[ "win_computer" ] = 1;
    common_impl.CheckAchiev("mg");

  end;
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Lvl1desk *** () end;
--*********************************************************************************************************************
--********************************************************************************************************************
private.zz_lvl1desk = {};
public.zz_lvl1desk = {};

function private.Init_Lvl1desk()

  private.right_code = { 2, 7, 9, 3 };
  --------------------------------------------------------------------------------------------
  game.hint[ "win_lvl1desk" ] = {
    type = "click",
    use_place = "spr_lvl1desk_button_2",
    room = "rm_apartment",
    zz = "zz_lvl1desk",
    zz_gate = "gzz_apartment_lvl1desk"
  };
  -----------------------------------------------------------------------------------
  local win_lvl1desk = function ()
    
    if cmn.IsEventDone("win_lvl1desk") then
  
      ObjDelete( "obj_lvl1desk_game" );
      ObjDelete( "anm_lvl1desk_box_touch" );
      ObjDelete( "spr_apartment_desk_box_1" );
      
      ObjMultiSet( { {"spr_lvl1desk_box_open", { alp = 1 }},
                     {"obj_lvl1desk_in_box", { alp = 1, input = 1 }},
                     {"spr_apartment_desk_box_2", { alp = 1 }} } );
                     
    end;
  
  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_lvl1desk", win_lvl1desk, "rm_apartment" );

end;
--********************************************************************************************************************
function private.zz_lvl1desk.StartConditions()

  ng_global.progress[ "std" ][ "win_lvl1desk" ].state = { 1, { 0, 0, 0, 0 } }; --current code

end;
-----------------------------------------------------------------------------------
function private.zz_lvl1desk.DrawScene()

  if private.zz_lvl1desk.state[1] < 5 then
    game.hint[ "win_lvl1desk" ].use_place = "spr_lvl1desk_button_"..private.right_code[ private.zz_lvl1desk.state[1] ];
  else 
    ObjSet("obj_lvl1desk_game",  { input = 0 });
  end;

  for i = 1, private.zz_lvl1desk.state[1]-1, 1 do
  
    ObjSet("txt_lvl1desk_code_"..i,  { text = private.zz_lvl1desk.state[2][i], alp = 1 });
    
  end;

  for i = private.zz_lvl1desk.state[1], 4, 1 do
  
    ObjSet("txt_lvl1desk_code_"..i,  { alp = 0 });
    
  end;

end;
------------------------------------------------------------------------------
function public.zz_lvl1desk.FocusButton( butt, inout )
  
  local obj = "spr_lvl1desk_button_"..butt.."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      --cmn.PlayAudio("snd", "assets/levels/level1/audio/");
    end;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.zz_lvl1desk.ClickButton( num )
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_click_numearl_"..math.random(1,3));

  local cur_num = private.zz_lvl1desk.state[1];

  private.zz_lvl1desk.state[2][cur_num] = num;
  private.zz_lvl1desk.state[1] = private.zz_lvl1desk.state[1] + 1;

  ObjSet("txt_lvl1desk_code_"..cur_num,  { text = private.zz_lvl1desk.state[2][cur_num] });

  if private.zz_lvl1desk.state[2][cur_num] == private.right_code[cur_num] then
    --cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/"");
  else 
    --cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/");
  end;

  ObjAnimate("txt_lvl1desk_code_"..cur_num, "alp", 0, 0, function () private.zz_lvl1desk.CheckWin(cur_num) end, { 0, 0, 0,   0.3, 0, 1 });
      
  
  local obj = "spr_lvl1desk_button_"..num;
  local alf = ObjGet(obj).alp;
  
  tme = ( 1 - alf ) * 0.15;
  
  ObjAnimate(obj, "alp", 0, 0, "", { 0, 0, alf,   tme, 0, 0,   tme+0.15, 0, 1 });

end;
-----------------------------------------------------------------------------------
function private.zz_lvl1desk.CheckWin(pos)
  
  pos = pos or false;
  
  if not pos then
    pos = private.zz_lvl1desk.state[1]-1;
  end;
  
  if private.zz_lvl1desk.state[1] == 5 and private.zz_lvl1desk.state[2][pos] == private.right_code[pos] then
    
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_right_comb_numeral_1");
    
    ObjAnimate("obj_lvl1desk_code", "alp", 0, 0, private.zz_lvl1desk.Win, { 0, 0, 1,   0.4, 0, 1,  0.7, 0, 0 });
    ObjAnimate("spr_lvl1desk_light_green", "alp", 0, 0, "", { 0, 0, 0,   0.4, 0, 0,  0.7, 0, 1 });

  elseif pos > 0 and  private.zz_lvl1desk.state[2][pos] ~= private.right_code[pos] then
    
    cmn.Lock(1);

    local func_after = function ()

      cmn.Lock(0);

      for i = 1, 4, 1 do
  
        ObjSet("txt_lvl1desk_code_"..i,  { alp = 0, text = "" });
        
      end;

      ObjSet("obj_lvl1desk_code",  { alp = 1 });

    end;

    game.hint[ "win_lvl1desk" ].use_place = "spr_lvl1desk_button_2";
    private.zz_lvl1desk.state[1] = 1;

    for i = 1, 4, 1 do

      private.zz_lvl1desk.state[2][i] = 0;
      
    end;

    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_wrong_comb_numeral_1");
    
    ObjAnimate("spr_lvl1desk_light_red", "alp", 0, 0, "", { 0, 1, 0,  0.4, 1, 1,   0.6, 1, 0,  0.8, 1, 1,    1, 1, 0,   1.2, 1, 1,  1.5, 1, 0 });
    ObjAnimate("obj_lvl1desk_code", "alp", 0, 0, func_after, { 0, 1, 1,   0.2, 1, 0,  0.4, 1, 1,   0.6, 1, 0,  0.8, 1, 1,    1, 1, 0,   1.2, 1, 1,  1.5, 1, 0 });

  elseif pos then

    game.hint[ "win_lvl1desk" ].use_place = "spr_lvl1desk_button_"..private.right_code[pos+1];
    cmn.Lock(0);

  end;

end;
-----------------------------------------------------------------------------------
function private.zz_lvl1desk.Win()

  cmn.SetEventDone( "win_lvl1desk" );

  local func_after = function ()

    cmn.CallEventHandler( "win_lvl1desk" );

    cmn.Lock( 0 );

  end;

  --cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_right_comb_numeral_1");
  
  ObjSet("obj_lvl1desk_in_box",  { alp = 1 });

  ObjAnimate("spr_lvl1desk_box_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
  ObjAnimate("anm_lvl1desk_box_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  ObjAnimate("obj_lvl1desk_game", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  
end;
--******************************************************************************************************************