-- name=rm_cemetery
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_cemetery";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.dlg_lipsync = "";
  --------------------------------------------------------------------------------------------
  -- function get_hook () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_hook" ] = {
        type = "get",
        get_obj = "spr_scarecrow_hook_fly",
        room = private.room_objname,
        zz = "zz_scarecrow",
        zz_gate = "gzz_cemetery_scarecrow"
    };
    --------------------------------------------------------------------------------------------
  local get_hook_inv = function ()
  
    interface.InventoryItemAdd( "inv_hook", "spr_scarecrow_hook_fly" );
  
  end;
  
  local get_hook_end = function ()
  
    ObjDelete( "spr_scarecrow_hook" );
    ObjDelete( "spr_scarecrow_hook_sh" );
    
    ObjDelete( "spr_cemetery_scarecrow_hook" );
  
  end;
  
  cmn.AddSubscriber( "get_hook", get_hook_inv );
  cmn.AddSubscriber( "get_hook", get_hook_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_rope () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_rope" ] = {
        type = "get",
        get_obj = "spr_scarecrow_rope",
        room = private.room_objname,
        zz = "zz_scarecrow",
        zz_gate = "gzz_cemetery_scarecrow"
    };
    --------------------------------------------------------------------------------------------
  local get_rope_inv = function ()
  
    interface.InventoryItemAdd( "inv_rope", "spr_scarecrow_rope" );
  
  end;
  
  local get_rope_end = function ()
  
    ObjDelete( "gfx_scarecrow_rope" );
    ObjDelete( "anm_scarecrow_rope_cut" );
    
    ObjDelete( "spr_cemetery_scarecrow_rope" );
    ObjDelete( "spr_cemetery_scarecrow_head" );
  
  end;
  
  cmn.AddSubscriber( "get_rope", get_rope_inv );
  cmn.AddSubscriber( "get_rope", get_rope_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_dateofdeath () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_dateofdeath" ] = {
        type = "get",
        get_obj = "spr_scarecrow_dateofdeath",
        room = private.room_objname,
        zz = "zz_scarecrow",
        zz_gate = "gzz_cemetery_scarecrow"
    };
    --------------------------------------------------------------------------------------------
  local get_dateofdeath_inv = function ()
  
    interface.InventoryItemAdd( "inv_dateofdeath", "spr_scarecrow_dateofdeath" );
  
  end;
  
  local get_dateofdeath_end = function ()
  
    ObjDelete( "gfx_scarecrow_dateofdeath" );
    ObjDelete( "spr_scarecrow_dateofdeath_sh" );
    
    ObjDelete( "spr_cemetery_scarecrow_date" );
    ObjDelete( "gzz_cemetery_scarecrow" );
  
  end;
  
  cmn.AddSubscriber( "get_dateofdeath", get_dateofdeath_inv );
  cmn.AddSubscriber( "get_dateofdeath", get_dateofdeath_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_paw1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_paw1" ] = {
        type = "get",
        get_obj = "spr_scarecrow_paw1_fly",
        room = private.room_objname,
        zz = "zz_scarecrow",
        zz_gate = "gzz_cemetery_scarecrow"
    };
    --------------------------------------------------------------------------------------------
  local get_paw1_inv = function ()
  
    interface.InventoryItemAdd( "inv_paw1", "spr_scarecrow_paw1_fly" );
    ObjSet("inv_spider_star_light",  { alp = 1 });
  
  end;
  
  local get_paw1_end = function ()
  
    ObjDelete( "spr_scarecrow_paw1" );
    ObjDelete( "spr_scarecrow_paw1_sh" );
    
    ObjDelete( "spr_cemetery_scarecrow_paw" );
  
  end;
  
  cmn.AddSubscriber( "get_paw1", get_paw1_inv );
  cmn.AddSubscriber( "get_paw1", get_paw1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bluelight () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_bluelight" ] = {
        type = "get",
        get_obj = "obj_gardenbed_bluelight_hint",
        room = private.room_objname,
        zz = "zz_gardenbed",
        zz_gate = "gzz_cemetery_gardenbed"
    };
    --------------------------------------------------------------------------------------------
  local get_bluelight_inv = function ()
  
    interface.InventoryItemAdd( "inv_bluelight", "spr_gardenbed_bluelight" );
    int_map_impl.DecreaseRoomTasks("rm_cemetery");
  
  end;
  
  local get_bluelight_end = function ()
  
    ObjDelete( "gfx_gardenbed_bluelight" );
    ObjDelete( "spr_gardenbed_bluelight_sh" );
    ObjDelete( "obj_gardenbed_bluelight_hint" );
    
    ObjDelete( "gzz_cemetery_gardenbed" );
    ObjDelete( "spr_cemetery_garden_light" );
  
  end;
  
  cmn.AddSubscriber( "get_bluelight", get_bluelight_inv );
  cmn.AddSubscriber( "get_bluelight", get_bluelight_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pumpkin () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_pumpkin" ] = {
        type = "get",
        get_obj = "spr_gardenbed_pumpkin",
        room = private.room_objname,
        zz = "zz_gardenbed",
        zz_gate = "gzz_cemetery_gardenbed"
    };
    --------------------------------------------------------------------------------------------
  local get_pumpkin_inv = function ()
  
    interface.InventoryItemAdd( "inv_pumpkin", "spr_gardenbed_pumpkin" );
  
  end;
  
  local get_pumpkin_end = function ()
  
    ObjDelete( "gfx_gardenbed_pumpkin" );
    
    ObjDelete( "spr_cemetery_garden_pumpkin" );
    ObjSet("spr_cemetery_garden_leaves_2",  { alp = 1 });
  
  end;
  
  cmn.AddSubscriber( "get_pumpkin", get_pumpkin_inv );
  cmn.AddSubscriber( "get_pumpkin", get_pumpkin_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bucket () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_bucket" ] = {
        type = "get",
        get_obj = "spr_gardenbed_bucket_fly",
        room = private.room_objname,
        zz = "zz_gardenbed",
        zz_gate = "gzz_cemetery_gardenbed"
    };
    --------------------------------------------------------------------------------------------
  local get_bucket_inv = function ()
  
    interface.InventoryItemAdd( "inv_bucket", "spr_gardenbed_bucket_fly" );
  
  end;
  
  local get_bucket_end = function ()
  
    ObjDelete( "anm_gardenbed_bucket_fix" );
    ObjSet("obj_gardenbed_use_scoop",  { input = 1 });
    
    ObjDelete( "spr_cemetery_garden_bucket_2" );
  
  end;
  
  cmn.AddSubscriber( "get_bucket", get_bucket_inv );
  cmn.AddSubscriber( "get_bucket", get_bucket_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_glenrune () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_glenrune" ] = {
        type = "get",
        get_obj = "spr_gardenbed_glenrune",
        room = private.room_objname,
        zz = "zz_gardenbed",
        zz_gate = "gzz_cemetery_gardenbed"
    };
    --------------------------------------------------------------------------------------------
  local get_glenrune_inv = function ()
  
    interface.InventoryItemAdd( "inv_glenrune", "spr_gardenbed_glenrune" );
  
  end;
  
  local get_glenrune_end = function ()
  
    ObjDelete( "gfx_gardenbed_glenrune" );
    ObjDelete( "spr_gardenbed_glenrune_sh" );
    
    ObjDelete( "spr_cemetery_garden_rune" );
  
  end;
  
  cmn.AddSubscriber( "get_glenrune", get_glenrune_inv );
  cmn.AddSubscriber( "get_glenrune", get_glenrune_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_paw2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_paw2" ] = {
        type = "get",
        get_obj = "spr_gardenbed_paw2",
        room = private.room_objname,
        zz = "zz_gardenbed",
        zz_gate = "gzz_cemetery_gardenbed"
    };
    --------------------------------------------------------------------------------------------
  local get_paw2_inv = function ()
  
    interface.InventoryItemAdd( "inv_paw2", "spr_gardenbed_paw2" );
    ObjSet("inv_spider_star_light",  { alp = 1 });
  
  end;
  
  local get_paw2_end = function ()
  
    ObjDelete( "gfx_gardenbed_paw2" );
    ObjDelete( "spr_gardenbed_paw2_sh" );
    
    ObjDelete( "spr_cemetery_garden_paw" );
  
  end;
  
  cmn.AddSubscriber( "get_paw2", get_paw2_inv );
  cmn.AddSubscriber( "get_paw2", get_paw2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gargoylepart3 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_gargoylepart3" ] = {
        type = "get",
        get_obj = "spr_grave_gargoylepart3",
        room = private.room_objname,
        zz = "zz_grave",
        zz_gate = "gzz_cemetery_grave"
    };
    --------------------------------------------------------------------------------------------
  local get_gargoylepart3_inv = function ()
  
    interface.InventoryItemAdd( "inv_gargoylepart", "spr_grave_gargoylepart3", function () cmn.GetMultyObject( 'gargoylepart', 3 ); end );
  
  end;
  
  local get_gargoylepart3_end = function ()
  
    ObjDelete( "gfx_grave_gargoylepart3" );
    ObjDelete( "spr_grave_gargoylepart3_sh" );
    
    ObjDelete( "spr_cemetery_grave_paw" );
  
  end;
  
  cmn.AddSubscriber( "get_gargoylepart3", get_gargoylepart3_inv );
  cmn.AddSubscriber( "get_gargoylepart3", get_gargoylepart3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lense () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_lense" ] = {
        type = "get",
        get_obj = "spr_grave_lense",
        room = private.room_objname,
        zz = "zz_grave",
        zz_gate = "gzz_cemetery_grave"
    };
    --------------------------------------------------------------------------------------------
  local get_lense_inv = function ()
  
    interface.InventoryItemAdd( "inv_lense", "spr_grave_lense" );
  
  end;
  
  local get_lense_end = function ()
  
    ObjDelete( "gfx_grave_lense" );
    ObjDelete( "spr_grave_lense_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_lense", get_lense_inv );
  cmn.AddSubscriber( "get_lense", get_lense_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_puppetarm () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_puppetarm" ] = {
        type = "get",
        get_obj = "spr_grave_puppetarm",
        room = private.room_objname,
        zz = "zz_grave",
        zz_gate = "gzz_cemetery_grave"
    };
    --------------------------------------------------------------------------------------------
  local get_puppetarm_inv = function ()
  
    interface.InventoryItemAdd( "inv_puppetarm", "spr_grave_puppetarm" );
    ObjSet("inv_puppet_star_light",  { alp = 1 });
  
  end;
  
  local get_puppetarm_end = function ()
  
    ObjDelete( "gfx_grave_puppetarm" );
    ObjDelete( "spr_grave_puppetarm_sh" );
    
    ObjDelete( "spr_cemetery_grave_arm" );
    
    if cmn.IsEventDone("get_puppethead") and cmn.IsEventDone("get_photopart1") then
      ObjDelete( "gzz_cemetery_grave" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_puppetarm", get_puppetarm_inv );
  cmn.AddSubscriber( "get_puppetarm", get_puppetarm_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_puppethead () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_puppethead" ] = {
        type = "get",
        get_obj = "spr_grave_puppethead",
        room = private.room_objname,
        zz = "zz_grave",
        zz_gate = "gzz_cemetery_grave"
    };
    --------------------------------------------------------------------------------------------
  local get_puppethead_inv = function ()
  
    interface.InventoryItemAdd( "inv_puppethead", "spr_grave_puppethead" );
    ObjSet("inv_puppet_star_light",  { alp = 1 });
  
  end;
  
  local get_puppethead_end = function ()
  
    ObjDelete( "gfx_grave_puppethead" );
    ObjDelete( "spr_grave_puppethead_sh" );
    
    ObjDelete( "spr_cemetery_grave_head" );
    
    if cmn.IsEventDone("get_puppetarm") and cmn.IsEventDone("get_photopart1") then
      ObjDelete( "gzz_cemetery_grave" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_puppethead", get_puppethead_inv );
  cmn.AddSubscriber( "get_puppethead", get_puppethead_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_photopart1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_photopart1" ] = {
        type = "get",
        get_obj = "spr_grave_photopart1",
        room = private.room_objname,
        zz = "zz_grave",
        zz_gate = "gzz_cemetery_grave"
    };
    --------------------------------------------------------------------------------------------
  local get_photopart1_inv = function ()
  
    interface.InventoryItemAdd( "inv_photopart1", "spr_grave_photopart1" );
    ObjSet("inv_photobasis_star_light",  { alp = 1 });
  
  end;
  
  local get_photopart1_end = function ()
  
    ObjDelete( "gfx_grave_photopart1" );
    ObjDelete( "spr_grave_photopart1_sh" );
    
    ObjDelete( "spr_cemetery_grave_photo" );
    
    if cmn.IsEventDone("get_puppetarm") and cmn.IsEventDone("get_puppethead") then
      ObjDelete( "gzz_cemetery_grave" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_photopart1", get_photopart1_inv );
  cmn.AddSubscriber( "get_photopart1", get_photopart1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pigfigurine () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_pigfigurine" ] = {
        type = "get",
        get_obj = "spr_well_pigfigurine",
        room = private.room_objname,
        zz = "zz_well",
        zz_gate = "gzz_cemetery_well"
    };
    --------------------------------------------------------------------------------------------
  local get_pigfigurine_inv = function ()
  
    interface.InventoryItemAdd( "inv_pigfigurine", "spr_well_pigfigurine" );
    ObjSet("inv_bottlewithresin_star_light",  { alp = 1 });
  
  end;
  
  local get_pigfigurine_end = function ()
  
    ObjDelete( "gfx_well_pigfigurine" );
    ObjDelete( "anm_well_use_hook" );
    
  end;
  
  cmn.AddSubscriber( "get_pigfigurine", get_pigfigurine_inv );
  cmn.AddSubscriber( "get_pigfigurine", get_pigfigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_water () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_water" ] = {
        type = "get",
        get_obj = "spr_well_water",
        room = private.room_objname,
        zz = "zz_well",
        zz_gate = "gzz_cemetery_well"
    };
    --------------------------------------------------------------------------------------------
  local get_water_inv = function ()
  
    interface.InventoryItemAdd( "inv_water", "spr_well_water" );
  
  end;
  
  local get_water_end = function ()
  
    ObjDelete( "gfx_well_water" );
    ObjDelete( "spr_well_water_sh" );
    
    ObjDelete( "spr_cemetery_well_bucket" );
  
  end;
  
  cmn.AddSubscriber( "get_water", get_water_inv );
  cmn.AddSubscriber( "get_water", get_water_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gargoylepart2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_gargoylepart2" ] = {
        type = "get",
        get_obj = "spr_well_gargoylepart2",
        room = private.room_objname,
        zz = "zz_well",
        zz_gate = "gzz_cemetery_well"
    };
    --------------------------------------------------------------------------------------------
  local get_gargoylepart2_inv = function ()
  
    interface.InventoryItemAdd( "inv_gargoylepart", "spr_well_gargoylepart2", function () cmn.GetMultyObject( 'gargoylepart', 3 ); end );
  
  end;
  
  local get_gargoylepart2_end = function ()
  
    ObjDelete( "gfx_well_gargoylepart2" );
    --ObjDelete( "gzz_cemetery_well" );
  
  end;
  
  cmn.AddSubscriber( "get_gargoylepart2", get_gargoylepart2_inv );
  cmn.AddSubscriber( "get_gargoylepart2", get_gargoylepart2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_dog () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_dog" ] = {
        type = "get",
        get_obj = "spr_well_dog",
        room = private.room_objname,
        zz = "zz_well",
        zz_gate = "gzz_cemetery_well"
    };
    --------------------------------------------------------------------------------------------
  local get_dog_inv = function ()
  
    interface.InventoryItemAdd( "inv_dog", "spr_well_dog" );
    ObjSet("inv_spider_star_light",  { alp = 1 });
  
  end;
  
  local get_dog_end = function ()
  
    ObjDelete( "gfx_well_dog" );
    ObjDelete( "spr_well_dog_sh" );
    
    ObjDelete( "gzz_cemetery_well" );
  
  end;
  
  cmn.AddSubscriber( "get_dog", get_dog_inv );
  cmn.AddSubscriber( "get_dog", get_dog_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_puppet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_puppet" ] = {
      type = "get",
      get_obj = "obj_cemetery_puppet_hint",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_puppet_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_puppet", "spr_cemetery_puppet" );
  
  end;
  local get_puppet_mid = function ()
  
    ObjDelete( "gfx_cemetery_puppet" );
    ObjDelete( "anm_cemetery_naya_1" );
    
    ObjSet("anm_cemetery_naya_2",  { alp = 1 });
  
  end;
  local get_puppet_end = function ()
  
    ObjDelete( "obj_cemetery_dialog_naya1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_puppet", get_puppet_inv );
  cmn.AddSubscriber( "get_puppet_inv", get_puppet_inv, private.room_objname );
  cmn.AddSubscriber( "get_puppet", get_puppet_mid, private.room_objname );
  cmn.AddSubscriber( "get_puppet_mid", get_puppet_mid, private.room_objname );
  cmn.AddSubscriber( "get_puppet", get_puppet_end, private.room_objname );
  cmn.AddSubscriber( "get_puppet_end", get_puppet_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_pumpkin () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_pumpkin" ] = {
        type = "use",
        inv_obj = "inv_pumpkin",
        use_place = "obj_scarecrow_use_pumpkin",
        room = private.room_objname,
        zz = "zz_scarecrow",
        zz_gate = "gzz_cemetery_scarecrow"
    };
  --------------------------------------------------------------------------------------------
  local use_pumpkin_inv = function ()
  
    interface.InventoryItemRemove( "inv_pumpkin" );
  
  end;
  local use_pumpkin_beg = function ()
  
    ObjDelete( "obj_scarecrow_use_pumpkin" );
    ObjDelete( "anm_scarecrow_scarecrow_2" );
  
  end;
  local use_pumpkin_end = function ()
    
    ObjDelete( "spr_cemetery_scarecrow_hand_2" );
  
    ObjMultiSet( { {"anm_scarecrow_use_pumpkin", { input = 1, alp = 1, frame = 400 }},
                   {"spr_cemetery_scarecrow_pumpkin", { alp = 1 }},
                   {"spr_cemetery_scarecrow_date", { alp = 1 }},
                   {"spr_cemetery_scarecrow_hand_2_2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pumpkin", use_pumpkin_beg, private.room_objname );
  cmn.AddSubscriber( "use_pumpkin", use_pumpkin_inv );
  cmn.AddSubscriber( "use_pumpkin", use_pumpkin_end, private.room_objname );
  cmn.AddSubscriber( "use_pumpkin_inv", use_pumpkin_inv, private.room_objname );
  cmn.AddSubscriber( "use_pumpkin_beg", use_pumpkin_beg, private.room_objname );
  cmn.AddSubscriber( "use_pumpkin_end", use_pumpkin_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function use_resin () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_resin" ] = {
        type = "use",
        inv_obj = "inv_resin",
        use_place = "obj_gardenbed_use_resin",
        room = private.room_objname,
        zz = "zz_gardenbed",
        zz_gate = "gzz_cemetery_gardenbed"
    };
  --------------------------------------------------------------------------------------------
  local use_resin_inv = function ()
  
    interface.InventoryItemRemove( "inv_resin" );
  
  end;
  local use_resin_beg = function ()
  
    ObjDelete( "obj_gardenbed_use_resin" );
  
  end;
  local use_resin_end = function ()
  
    ObjDelete( "anm_gardenbed_bucket_touch" );
    ObjDelete( "obj_gardenbed_bucket_objects" );
    
    ObjMultiSet( { {"anm_gardenbed_bucket_fix", { input = 1, alp = 1, frame = 300 }},
                   {"spr_cemetery_garden_bucket_2", { alp = 1 }} } );
    
    ObjDelete( "spr_cemetery_garden_bucket_1" );
    ObjDelete( "spr_cemetery_garden_ring_1" );
    ObjDelete( "spr_cemetery_garden_resin" );
    ObjDelete( "spr_cemetery_garden_ring_2" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_resin", use_resin_beg, private.room_objname );
  cmn.AddSubscriber( "use_resin", use_resin_inv );
  cmn.AddSubscriber( "use_resin", use_resin_end, private.room_objname );
  cmn.AddSubscriber( "use_resin_inv", use_resin_inv, private.room_objname );
  cmn.AddSubscriber( "use_resin_beg", use_resin_beg, private.room_objname );
  cmn.AddSubscriber( "use_resin_end", use_resin_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_seedsskull () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_seedsskull" ] = {
        type = "use",
        inv_obj = "inv_seedsskull",
        use_place = "obj_gardenbed_use_seedsskull",
        room = private.room_objname,
        zz = "zz_gardenbed",
        zz_gate = "gzz_cemetery_gardenbed"
    };
  --------------------------------------------------------------------------------------------
  local use_seedsskull_inv = function ()
  
    interface.InventoryItemRemove( "inv_seedsskull" );
  
  end;
  local use_seedsskull_beg = function ()
  
    ObjDelete( "obj_gardenbed_use_seedsskull" );
  
  end;
  local use_seedsskull_end = function ()
  
    ObjMultiSet( { {"anm_gardenbed_use_seeds", { alp = 1, frame = 300 }},
                   {"obj_gardenbed_use_water", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_seedsskull", use_seedsskull_beg, private.room_objname );
  cmn.AddSubscriber( "use_seedsskull", use_seedsskull_inv );
  cmn.AddSubscriber( "use_seedsskull", use_seedsskull_end, private.room_objname );
  cmn.AddSubscriber( "use_seedsskull_inv", use_seedsskull_inv, private.room_objname );
  cmn.AddSubscriber( "use_seedsskull_beg", use_seedsskull_beg, private.room_objname );
  cmn.AddSubscriber( "use_seedsskull_end", use_seedsskull_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_water () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_water" ] = {
        type = "use",
        inv_obj = "inv_water",
        use_place = "obj_gardenbed_use_water",
        room = private.room_objname,
        zz = "zz_gardenbed",
        zz_gate = "gzz_cemetery_gardenbed"
    };
  --------------------------------------------------------------------------------------------
  local use_water_inv = function ()
  
    interface.InventoryItemRemove( "inv_water" );
  
  end;
  local use_water_beg = function ()
  
    ObjDelete( "obj_gardenbed_use_water" );
  
  end;
  local use_water_end = function ()
    
    ObjDelete( "anm_gardenbed_use_seeds" );
    ObjDelete( "anm_gardenbed_use_water" );
    ObjDelete( "anm_gardenbed_bigground_touch" );
  
    ObjMultiSet( { {"anm_gardenbed_pumpkin_grow",  { alp = 1, input = 1, frame = 300 }},
                   {"obj_cemetery_garden_pumpkin", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_water", use_water_beg, private.room_objname );
  cmn.AddSubscriber( "use_water", use_water_inv );
  cmn.AddSubscriber( "use_water", use_water_end, private.room_objname );
  cmn.AddSubscriber( "use_water_inv", use_water_inv, private.room_objname );
  cmn.AddSubscriber( "use_water_beg", use_water_beg, private.room_objname );
  cmn.AddSubscriber( "use_water_end", use_water_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_dateofdeath () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_dateofdeath" ] = {
        type = "use",
        inv_obj = "inv_dateofdeath",
        use_place = "obj_grave_use_dateofdeath",
        room = private.room_objname,
        zz = "zz_grave",
        zz_gate = "gzz_cemetery_grave"
    };
  --------------------------------------------------------------------------------------------
  local use_dateofdeath_inv = function ()
  
    interface.InventoryItemRemove( "inv_dateofdeath" );
  
  end;
  local use_dateofdeath_beg = function ()
  
    ObjDelete( "obj_grave_use_dateofdeath" );
    ObjDelete( "obj_grave_plate_touch" );
    ObjDelete( "anm_grave_plate_touch" );
  
  end;
  local use_dateofdeath_end = function ()
    
    ObjDelete( "spr_cemetery_grave_cover" );
  
    ObjMultiSet( { {"obj_grave_hideout", { alp = 1, input = 1 }},
                   {"anm_grave_use_date", { alp = 1, frame = 300 }},
                   {"spr_cemetery_grave_date", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_dateofdeath", use_dateofdeath_beg, private.room_objname );
  cmn.AddSubscriber( "use_dateofdeath", use_dateofdeath_inv );
  cmn.AddSubscriber( "use_dateofdeath", use_dateofdeath_end, private.room_objname );
  cmn.AddSubscriber( "use_dateofdeath_inv", use_dateofdeath_inv, private.room_objname );
  cmn.AddSubscriber( "use_dateofdeath_beg", use_dateofdeath_beg, private.room_objname );
  cmn.AddSubscriber( "use_dateofdeath_end", use_dateofdeath_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hook () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_hook" ] = {
        type = "use",
        inv_obj = "inv_hook",
        use_place = "obj_well_use_hook",
        room = private.room_objname,
        zz = "zz_well",
        zz_gate = "gzz_cemetery_well"
    };
  --------------------------------------------------------------------------------------------
  local use_hook_inv = function ()
  
    interface.InventoryItemRemove( "inv_hook" );
  
  end;
  local use_hook_beg = function ()
  
    ObjDelete( "obj_well_use_hook" );
    ObjDelete( "anm_well_pig_touch" );
  
  end;
  local use_hook_end = function ()
  
    ObjDelete( "anm_well_use_hook_2" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hook", use_hook_beg, private.room_objname );
  cmn.AddSubscriber( "use_hook", use_hook_inv );
  cmn.AddSubscriber( "use_hook", use_hook_end, private.room_objname );
  cmn.AddSubscriber( "use_hook_inv", use_hook_inv, private.room_objname );
  cmn.AddSubscriber( "use_hook_beg", use_hook_beg, private.room_objname );
  cmn.AddSubscriber( "use_hook_end", use_hook_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_rope () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_rope" ] = {
        type = "use",
        inv_obj = "inv_rope",
        use_place = "obj_well_use_rope",
        room = private.room_objname,
        zz = "zz_well",
        zz_gate = "gzz_cemetery_well"
    };
  --------------------------------------------------------------------------------------------
  local use_rope_inv = function ()
  
    interface.InventoryItemRemove( "inv_rope" );
  
  end;
  local use_rope_beg = function ()
  
    ObjDelete( "obj_well_use_rope" );
  
  end;
  local use_rope_end = function ()
  
    ObjMultiSet( { {"anm_well_rope", { alp = 1, frame = 0, animfunc = "func_clk_rope", pos_z = 21 }},
                   {"obj_well_use_bucket", { input = 1 }},
                   {"spr_well_rope_2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_rope", use_rope_beg, private.room_objname );
  cmn.AddSubscriber( "use_rope", use_rope_inv );
  cmn.AddSubscriber( "use_rope", use_rope_end, private.room_objname );
  cmn.AddSubscriber( "use_rope_inv", use_rope_inv, private.room_objname );
  cmn.AddSubscriber( "use_rope_beg", use_rope_beg, private.room_objname );
  cmn.AddSubscriber( "use_rope_end", use_rope_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bucket () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_bucket" ] = {
        type = "use",
        inv_obj = "inv_bucket",
        use_place = "obj_well_use_bucket",
        room = private.room_objname,
        zz = "zz_well",
        zz_gate = "gzz_cemetery_well"
    };
  --------------------------------------------------------------------------------------------
  local use_bucket_inv = function ()
  
    interface.InventoryItemRemove( "inv_bucket" );
  
  end;
  local use_bucket_beg = function ()
  
    ObjDelete( "obj_well_use_bucket" );
  
  end;
  local use_bucket_end = function ()
  
    ObjDelete( "anm_well_use_bucket" );
    ObjDelete( "anm_well_use_bucket_2" );
    ObjDelete( "spr_well_gargoyle_down" );
    
    ObjMultiSet( { {"obj_well_full_bucket", { alp = 1, input = 1 }},
                   {"anm_well_rope", { alp = 1 }},
                   {"spr_well_wood", { alp = 1 }},
                   {"obj_well_water_down", { alp = 1 }},
                   {"spr_cemetery_well_bucket", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bucket", use_bucket_beg, private.room_objname );
  cmn.AddSubscriber( "use_bucket", use_bucket_inv );
  cmn.AddSubscriber( "use_bucket", use_bucket_end, private.room_objname );
  cmn.AddSubscriber( "use_bucket_inv", use_bucket_inv, private.room_objname );
  cmn.AddSubscriber( "use_bucket_beg", use_bucket_beg, private.room_objname );
  cmn.AddSubscriber( "use_bucket_end", use_bucket_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_glenrune () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_glenrune" ] = {
        type = "use",
        inv_obj = "inv_glenrune",
        use_place = "obj_well_use_glenrune",
        room = private.room_objname,
        zz = "zz_well",
        zz_gate = "gzz_cemetery_well"
    };
  --------------------------------------------------------------------------------------------
  local use_glenrune_inv = function ()
  
    interface.InventoryItemRemove( "inv_glenrune" );
  
  end;
  local use_glenrune_beg = function ()
  
    ObjDelete( "obj_well_use_glenrune" );
  
  end;
  local use_glenrune_end = function ()
  
    if cmn.IsEventDone("use_igrune") then
      ObjDelete( "anm_well_runes_touch" );
      ObjDelete( "anm_well_runes_touch_1" );
      ObjDelete( "anm_well_runes_touch_2" );
      ObjSet("anm_well_use_runes",  { alp = 1, input = 1, frame = 300 });
      
      ObjDelete( "spr_cemetery_well_rune_1" );
      ObjDelete( "spr_cemetery_well_rune_2" );
    else 
      ObjMultiSet( { {"anm_well_runes_touch_1", { alp = 1 }},
                     {"spr_cemetery_well_rune_1", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_glenrune", use_glenrune_beg, private.room_objname );
  cmn.AddSubscriber( "use_glenrune", use_glenrune_inv );
  cmn.AddSubscriber( "use_glenrune", use_glenrune_end, private.room_objname );
  cmn.AddSubscriber( "use_glenrune_inv", use_glenrune_inv, private.room_objname );
  cmn.AddSubscriber( "use_glenrune_beg", use_glenrune_beg, private.room_objname );
  cmn.AddSubscriber( "use_glenrune_end", use_glenrune_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_igrune () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_igrune" ] = {
        type = "use",
        inv_obj = "inv_igrune",
        use_place = "obj_well_use_igrune",
        room = private.room_objname,
        zz = "zz_well",
        zz_gate = "gzz_cemetery_well"
    };
  --------------------------------------------------------------------------------------------
  local use_igrune_inv = function ()
  
    interface.InventoryItemRemove( "inv_igrune" );
  
  end;
  local use_igrune_beg = function ()
  
    ObjDelete( "obj_well_use_igrune" );
  
  end;
  local use_igrune_end = function ()
  
    if cmn.IsEventDone("use_glenrune") then
      ObjDelete( "anm_well_runes_touch" );
      ObjDelete( "anm_well_runes_touch_1" );
      ObjDelete( "anm_well_runes_touch_2" );
      ObjSet("anm_well_use_runes",  { alp = 1, input = 1, frame = 300 });
      
      ObjDelete( "spr_cemetery_well_rune_1" );
      ObjDelete( "spr_cemetery_well_rune_2" );
    else 
      ObjMultiSet( { {"anm_well_runes_touch_2", { alp = 1 }},
                     {"spr_cemetery_well_rune_2", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_igrune", use_igrune_beg, private.room_objname );
  cmn.AddSubscriber( "use_igrune", use_igrune_inv );
  cmn.AddSubscriber( "use_igrune", use_igrune_end, private.room_objname );
  cmn.AddSubscriber( "use_igrune_inv", use_igrune_inv, private.room_objname );
  cmn.AddSubscriber( "use_igrune_beg", use_igrune_beg, private.room_objname );
  cmn.AddSubscriber( "use_igrune_end", use_igrune_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fixedpuppet () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_fixedpuppet" ] = {
        type = "use",
        inv_obj = "inv_fixedpuppet",
        use_place = "obj_cemetery_use_fixedpuppet",
        room = private.room_objname
    };
  --------------------------------------------------------------------------------------------
  local use_fixedpuppet_inv = function ()
  
    interface.InventoryItemRemove( "inv_fixedpuppet" );
  
  end;
  local use_fixedpuppet_beg = function ()
  
    ObjDelete( "obj_cemetery_use_fixedpuppet" );
  
  end;
  local use_fixedpuppet_mid = function ()
    
    ObjDelete( "anm_cemetery_naya_2" );
  
  end;
  local use_fixedpuppet_end = function ()
    
    ObjDelete( "obj_cemetery_dialog_naya2" );
    --ObjDelete( "anm_cemetery_naya_disappear" );
    ObjDelete( "anm_cemetery_naya_open_door" );
    
    ObjMultiSet( { {"gho_cemetery_crypt", { input = 1, alp = 1, active = 1 }},
                   {"spr_cemetery_crypt_open", { alp = 1 }},
                   {"anm_cemetery_naya_disappear", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fixedpuppet", use_fixedpuppet_beg, private.room_objname );
  cmn.AddSubscriber( "use_fixedpuppet", use_fixedpuppet_inv );
  cmn.AddSubscriber( "use_fixedpuppet", use_fixedpuppet_end, private.room_objname );
  cmn.AddSubscriber( "use_fixedpuppet_inv", use_fixedpuppet_inv, private.room_objname );
  cmn.AddSubscriber( "use_fixedpuppet_beg", use_fixedpuppet_beg, private.room_objname );
  cmn.AddSubscriber( "use_fixedpuppet_end", use_fixedpuppet_end, private.room_objname );
  cmn.AddSubscriber( "use_fixedpuppet", use_fixedpuppet_mid, private.room_objname );
  cmn.AddSubscriber( "use_fixedpuppet_mid", use_fixedpuppet_mid, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_cemeteryfirst () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_cemeteryfirst" ] = {
    type = "click",
    use_place = "obj_cemetery_clk_cemeteryfirst",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local clk_cemeteryfirst = function ()
    
    ObjAttach("obj_cemetery_dialog_naya1", "rm_cemetery");
    
    ObjDelete( "anm_cemetery_dialog_naya1_hands_1" );
    ObjDelete( "anm_cemetery_dialog_naya1_hand_give" );
  
    ObjDelete( "vid_cemetery_dialog_naya1_lipsync1" );
    ObjDelete( "vid_cemetery_dialog_naya1_lipsync2" );
    
    ObjMultiSet( { {"obj_cemetery_dialog_naya1", { alp = 1, input = 1 }},
                   {"obj_cemetery_dialog_naya1_hand_2", { alp = 1, input = 1 }},
                   {"anm_cemetery_dialog_naya1_hand_left", { alp = 1 }},
                   {"anm_cemetery_dialog_naya1_head", { alp = 1 }},
                   {"obj_cemetery_use_fixedpuppet", { alp = 1, input = 1 }},
                   {"gzz_cemetery_scarecrow", { event_mdown = function() cmn.GotoSubRoomMDown( "cemetery_scarecrow" ); end, event_mup = function() cmn.GotoSubRoomMUp( "cemetery_scarecrow", "zz_scarecrow" ); end } },
                   {"gzz_cemetery_well", { event_mdown = function() cmn.GotoSubRoomMDown( "cemetery_well" ); end, event_mup = function() cmn.GotoSubRoomMUp( "cemetery_well", "zz_well" ); end } },
                   {"gzz_cemetery_gardenbed", { event_mdown = function() cmn.GotoSubRoomMDown( "cemetery_gardenbed" ); end, event_mup = function() cmn.GotoSubRoomMUp( "cemetery_gardenbed", "zz_gardenbed" ); end } },
                   {"gzz_cemetery_grave", { event_mdown = function() cmn.GotoSubRoomMDown( "cemetery_grave" ); end, event_mup = function() cmn.GotoSubRoomMUp( "cemetery_grave", "zz_grave" ); end } } } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_cemeteryfirst", clk_cemeteryfirst, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_cemetery () end;
  --------------------------------------------------------------------------------------------
  local opn_cemetery = function ()
  
    int_map_impl.OpenRoom( "rm_cemetery" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_cemetery", opn_cemetery );
  --------------------------------------------------------------------------------------------
  -- function opn_cemeteryafterho () end;
  --------------------------------------------------------------------------------------------
  local opn_cemeteryafterho = function ()
  
    ObjDelete("anm_cemetery_naya_disappear");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_cemeteryafterho", opn_cemeteryafterho );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_grave" );
  
  function zz_grave.Open()
    
    if not cmn.IsEventDone("opn_grave") then
      cmn.SetEventDone("opn_grave");
      cmn.ShowBbt( "grave_open" );
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_cemetery();
  
  if cmn.IsEventDone("clk_cemeteryfirst") and not cmn.IsEventDone("get_puppet") then
    --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    common_impl.current_dialog = "obj_cemetery_dialog_naya1";
    ObjMultiSet( { {"anm_cemetery_dialog_naya1_hand_left", { playing = 1 }},
                   {"anm_cemetery_dialog_naya1_hand_2", { playing = 1 }} } );
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level1/audio/env/aud_cemetery_env");
  cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_cemetery_env");
  
  if not cmn.IsEventDone("opn_cemetery") or ( cmn.IsEventDone("win_crypt") and not cmn.IsEventDone("opn_cemeteryafterho") ) then
    cmn.Lock(1);
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_pumpkin()

  local item = "inv_pumpkin";

  if cmn.ApplyObj( item, "gzz_cemetery_scarecrow" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_scarecrow" );

  elseif ( cmn.ApplyObj( item, "obj_scarecrow_use_pumpkin" ) ) then

    cmn.CallEventHandler( "use_pumpkin_inv" );
    cmn.CallEventHandler( "use_pumpkin_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_pumpkin" );
      cmn.CallEventHandler( "use_pumpkin_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_use_pumpkin_cemetery");

    ObjSet("anm_scarecrow_use_pumpkin",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_resin()

  local item = "inv_resin";

  if cmn.ApplyObj( item, "gzz_cemetery_gardenbed" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_gardenbed" );

  elseif ( cmn.ApplyObj( item, "obj_gardenbed_use_resin" ) ) then

    cmn.CallEventHandler( "use_resin_inv" );
    cmn.CallEventHandler( "use_resin_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_resin" );
      cmn.CallEventHandler( "use_resin_end" );
    
    end;

    local anm_bucket_fix = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_smear_bucket");
      
      ObjAnimate("obj_gardenbed_bucket_objects", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      ObjMultiSet( { {"anm_gardenbed_bucket_fix", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_gardenbed_bucket_touch", { alp = 0 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_take_oil_bucket");

    ObjAnimate("obj_gardenbed_bucket_brush", "alp", 0, 0, anm_bucket_fix, { 0, 0, 0,   0.3, 0, 1,   0.5, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_seedsskull()

  local item = "inv_seedsskull";

  if cmn.ApplyObj( item, "gzz_cemetery_gardenbed" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_gardenbed" );

  elseif ( cmn.ApplyObj( item, "obj_gardenbed_use_seedsskull" ) ) then

    cmn.CallEventHandler( "use_seedsskull_inv" );
    cmn.CallEventHandler( "use_seedsskull_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_seedsskull" );
      cmn.CallEventHandler( "use_seedsskull_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_put_seed_in_earch");

    ObjSet("anm_gardenbed_use_seeds",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_water()

  local item = "inv_water";

  if cmn.ApplyObj( item, "gzz_cemetery_gardenbed" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_gardenbed" );

  elseif ( cmn.ApplyObj( item, "obj_gardenbed_use_water" ) and cmn.IsEventDone("use_seedsskull") ) then

    cmn.CallEventHandler( "use_water_inv" );
    cmn.CallEventHandler( "use_water_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_water" );
      cmn.CallEventHandler( "use_water_end" );
    
    end;
    
    local anm_pumpkin = function ()
      
      ObjAnimate("anm_gardenbed_pumpkin_grow", "alp", 0, 0, "", { 0, 0, 0,   0.2, 0, 1 });
      ObjAnimate("anm_gardenbed_use_seeds", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0 });
      ObjAnimate("anm_gardenbed_bigground_touch", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0 });
      
      ObjSet("anm_gardenbed_pumpkin_grow",  { playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_use_water_cemetery");

    ObjSet("anm_gardenbed_use_water",  { alp = 1, playing = 1, endtrig = anm_pumpkin });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_dateofdeath()

  local item = "inv_dateofdeath";

  if cmn.ApplyObj( item, "gzz_cemetery_grave" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_grave" );

  elseif ( cmn.ApplyObj( item, "obj_grave_use_dateofdeath" ) ) then

    cmn.CallEventHandler( "use_dateofdeath_inv" );
    cmn.CallEventHandler( "use_dateofdeath_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_dateofdeath" );
      cmn.CallEventHandler( "use_dateofdeath_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_use_dateofdeath_cemetery");

    ObjMultiSet( { {"anm_grave_use_date",  { alp = 1, playing = 1, endtrig = func_after }},
                   {"obj_grave_hideout", { alp = 1 }} } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_hook()

  local item = "inv_hook";

  if cmn.ApplyObj( item, "gzz_cemetery_well" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_well" );

  elseif ( cmn.ApplyObj( item, "obj_well_use_hook" ) ) then

    cmn.CallEventHandler( "use_hook_inv" );
    cmn.CallEventHandler( "use_hook_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_hook" );
      cmn.CallEventHandler( "use_hook_end" );
      
      public.get_pigfigurine();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_use_hook_cemetery");

    ObjMultiSet( { {"anm_well_use_hook", { alp = 1, playing = 1, endtrig = func_after }},
                   {"anm_well_use_hook_2", { alp = 1, playing = 1 }} } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_rope()

  local item = "inv_rope";

  if cmn.ApplyObj( item, "gzz_cemetery_well" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_well" );

  elseif ( cmn.ApplyObj( item, "obj_well_use_rope" ) ) then

    cmn.CallEventHandler( "use_rope_inv" );
    cmn.CallEventHandler( "use_rope_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_rope" );
      cmn.CallEventHandler( "use_rope_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_rope_in_well");

    ObjSet("anm_well_rope",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bucket()

  local item = "inv_bucket";

  if cmn.ApplyObj( item, "gzz_cemetery_well" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_well" );

  elseif ( cmn.ApplyObj( item, "obj_well_use_bucket" ) and cmn.IsEventDone("use_rope") ) then

    cmn.CallEventHandler( "use_bucket_inv" );
    cmn.CallEventHandler( "use_bucket_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_bucket" );
      cmn.CallEventHandler( "use_bucket_end" );
    
    end;
    
    local anm_out = function ()
      
      ObjDelete("spr_well_gargoyle_down");
      
      ObjAnimate("spr_well_wood", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("anm_well_rope", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("obj_well_full_bucket", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
      ObjAnimate("anm_well_use_bucket", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
    local anm_in = function ()
      
      ObjMultiSet( { {"anm_well_use_bucket",  { frame = 0, animfunc = "func_use_rope_bucket", playing = 1, endtrig = anm_out }},
                     {"spr_well_wood", { alp = 0 }},
                     {"obj_well_water_down", { alp = 0 }},
                     {"anm_well_use_bucket_2", { alp = 1, playing = 1 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_bucket_well");

    ObjMultiSet( { {"anm_well_use_bucket",  { alp = 1, playing = 1, endtrig = anm_in }},
                   {"anm_well_rope", { alp = 0 }} } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_glenrune()

  local item = "inv_glenrune";

  if cmn.ApplyObj( item, "gzz_cemetery_well" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_well" );

  elseif ( cmn.ApplyObj( item, "obj_well_use_glenrune" ) ) then

    cmn.CallEventHandler( "use_glenrune_inv" );
    cmn.CallEventHandler( "use_glenrune_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_glenrune" );
      cmn.CallEventHandler( "use_glenrune_end" );
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_open_hidden_cell_stone");
      
      ObjDelete( "anm_well_runes_touch" );
      ObjDelete( "anm_well_runes_touch_1" );
      ObjDelete( "anm_well_runes_touch_2" );
      ObjSet("anm_well_use_runes",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_stone_in_well");

    if cmn.IsEventDone("use_igrune") then
      ObjAnimate("anm_well_runes_touch_1", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });
    else 
      ObjAnimate("anm_well_runes_touch_1", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_igrune()

  local item = "inv_igrune";

  if cmn.ApplyObj( item, "gzz_cemetery_well" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_well" );

  elseif ( cmn.ApplyObj( item, "obj_well_use_igrune" ) ) then

    cmn.CallEventHandler( "use_igrune_inv" );
    cmn.CallEventHandler( "use_igrune_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_igrune" );
      cmn.CallEventHandler( "use_igrune_end" );
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_open_hidden_cell_stone");
      
      ObjDelete( "anm_well_runes_touch" );
      ObjDelete( "anm_well_runes_touch_1" );
      ObjDelete( "anm_well_runes_touch_2" );
      ObjSet("anm_well_use_runes",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_stone_in_well");

    if cmn.IsEventDone("use_glenrune") then
      ObjAnimate("anm_well_runes_touch_2", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });
    else 
      ObjAnimate("anm_well_runes_touch_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_fixedpuppet()

  local item = "inv_fixedpuppet";

  if ( cmn.ApplyObj( item, "obj_cemetery_use_fixedpuppet" ) ) then

    cmn.CallEventHandler( "use_fixedpuppet_inv" );
    cmn.CallEventHandler( "use_fixedpuppet_beg" );

    local func_after = function ()

      --cmn.Lock( 0 );

      cmn.SetEventDone( "use_fixedpuppet" );
      --cmn.CallEventHandler( "use_fixedpuppet_end" );
      
      public.dialog_naya_open( 2 );
    
    end;

    --cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_use_fixedpuppet_cemetery");

    func_after();

    --ObjAnimate( "spr_cemetery_", "alp", 0, 0, func_after,
    --{
    --  0.0, 0, 0, 
    --  0.3, 0, 1
    --} );

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_hook()
  
  ObjSet("spr_scarecrow_hook_fly",  { alp = 1 });
  
  cmn.SetEventDone( "get_hook" );
  cmn.CallEventHandler( "get_hook" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_rope()

  cmn.SetEventDone( "get_rope" );
  cmn.CallEventHandler( "get_rope" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_dateofdeath()

  cmn.SetEventDone( "get_dateofdeath" );
  cmn.CallEventHandler( "get_dateofdeath" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_paw1()
  
  ObjSet("spr_scarecrow_paw1_fly",  { alp = 1 });
  
  cmn.SetEventDone( "get_paw1" );
  cmn.CallEventHandler( "get_paw1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_bluelight()

  cmn.SetEventDone( "get_bluelight" );
  cmn.CallEventHandler( "get_bluelight" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_pumpkin()

  cmn.SetEventDone( "get_pumpkin" );
  cmn.CallEventHandler( "get_pumpkin" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
end;
--------------------------------------------------------------------------------------------
function public.get_bucket()
  
  ObjSet("spr_gardenbed_bucket_fly",  { alp = 1 });

  cmn.SetEventDone( "get_bucket" );
  cmn.CallEventHandler( "get_bucket" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_glenrune()

  cmn.SetEventDone( "get_glenrune" );
  cmn.CallEventHandler( "get_glenrune" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_paw2()

  cmn.SetEventDone( "get_paw2" );
  cmn.CallEventHandler( "get_paw2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_gargoylepart3()

  cmn.SetEventDone( "get_gargoylepart3" );
  cmn.CallEventHandler( "get_gargoylepart3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if not cmn.IsEventDone("get_lense") then
    cmn.SetEventDone( "get_lense" );
    cmn.CallEventHandler( "get_lense" );
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_lense()

  cmn.SetEventDone( "get_lense" );
  cmn.CallEventHandler( "get_lense" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_puppetarm()

  cmn.SetEventDone( "get_puppetarm" );
  cmn.CallEventHandler( "get_puppetarm" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_puppethead") and cmn.IsEventDone("get_photopart1") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_puppethead()

  cmn.SetEventDone( "get_puppethead" );
  cmn.CallEventHandler( "get_puppethead" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if not cmn.IsEventDone("get_photopart1") then
    cmn.SetEventDone( "get_photopart1" );
    cmn.CallEventHandler( "get_photopart1" );
  end;
  
  if cmn.IsEventDone("get_puppetarm") and cmn.IsEventDone("get_photopart1") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_photopart1()

  cmn.SetEventDone( "get_photopart1" );
  cmn.CallEventHandler( "get_photopart1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_puppetarm") and cmn.IsEventDone("get_puppethead") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_pigfigurine()

  cmn.SetEventDone( "get_pigfigurine" );
  cmn.CallEventHandler( "get_pigfigurine" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_water()
  
  cmn.SetEventDone( "get_water" );
  cmn.CallEventHandler( "get_water" );
  
  public.get_gargoylepart2();

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_gargoylepart2()

  cmn.SetEventDone( "get_gargoylepart2" );
  cmn.CallEventHandler( "get_gargoylepart2" );
  
  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_dog()

  cmn.SetEventDone( "get_dog" );
  cmn.CallEventHandler( "get_dog" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_puppet()
  
  ObjSet("spr_cemetery_puppet",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_puppet_end" );
    
    --common_impl.PlayBackgroundMusic();

  end;

  cmn.SetEventDone( "get_puppet" );
  cmn.CallEventHandler( "get_puppet_inv" );
  cmn.CallEventHandler( "get_puppet_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.current_dialog = "";
  
  cmn.Lock(1);
  ObjAnimate("obj_cemetery_dialog_naya1", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.5, 0, 0 });

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_cemeteryfirst()
  
  cmn.SetEventDone("clk_cemeteryfirst");
  public.dialog_naya_open( 1 );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_cemetery()

  if not ( cmn.IsEventDone( "opn_cemetery" ) ) then
    
    local func_after = function ()
    
      cmn.Lock(0);
      cmn.CallEventHandler("opn_cemetery");
      cmn.ShowBbt( "cemetery_open" );
      
      local arrows = { { pos_x = -260, pos_y = 220, ang = 2.6 } };
      cmn.TutorialShow( "tutor_10", 0, 450, 384, arrows );
      
    end;
    
    cmn.SetEventDone( "opn_cemetery" );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_first_appear_rm_cemetry");
    
    cmn.PlayAudio("mus", "assets/levels/level1/audio/mus/aud_mus_scare_1", 0, false, 123);
    
    ObjAnimate("rm_cemetery", "pos_xy", 0, 0, "", { 0, 0, 0, 0,   0.7, 0, -1030, -315,   1.6, 1, -1020, -315,   2.2, 1, -1020, -300,   3, 1, -1016, -300,   
     4, 2, -439, -158,   4.6, 2, -426, -158,    5.2, 1, -426, -152,   6, 1, -440, -152,      7, 0, 0, 0 });
    ObjAnimate( "rm_cemetery", "scale_xy", 0, 0, func_after, { 0, 0, 1, 1,   0.7, 0, 2, 2,   3, 1, 2, 2,   3.5, 1, 1.7, 1.7,
     4, 2, 2, 2,    6, 2, 2, 2,    7, 1, 1, 1 } );
    
  end;
  
  if cmn.IsEventDone("win_crypt") and not cmn.IsEventDone("opn_cemeteryafterho") then
    
    local func_after = function ()
      
      cmn.CallEventHandler("opn_cemeteryafterho");
      cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_cemetery_env");
      
      int_diary.AddDiarypage( 8 );
      cmn.ShowBbt( "cemetery_after_nayaandqueen" );
      
    end;
    
    cmn.Lock(0);
    cmn.SetEventDone("opn_cemeteryafterho");
    
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level1/rm_cemetery/vid_nayaandqueen", func_after, "assets/levels/level1/audio/mus/aud_nayasqueen_mus", "assets/levels/level1/audio/voc/aud_1_lvl_nayasqueen_voc");
    
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_scare_rope()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_rope_on_scarecrow");
  
  local func_after = function ()
    
    cmn.Lock(0);
    ObjSet("anm_scarecrow_rope",  { frame = 0, animfunc = "func_anm_loop", playing = 1 });
    
  end;
  
  cmn.ShowBbt( "obj_scarecrow_use_sharpdagger" );
  
  ObjSet("anm_scarecrow_rope",  { frame = 0, animfunc = "func_clk_rope", playing = 1, endtrig = func_after });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_scare_head()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_scarecrow_without_head");
  
  local func_after = function ()
    
    cmn.Lock(0);
    ObjSet("anm_scarecrow_scarecrow_2",  { frame = 0, animfunc = "func_anm_after_fire", playing = 1 });
    
  end;
  
  cmn.ShowBbt( "obj_scarecrow_use_pumpkin" );
  
  ObjSet("anm_scarecrow_scarecrow_2",  { frame = 0, animfunc = "func_clk_after_fire", playing = 1, endtrig = func_after });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_well_pig()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_animal_in_well");
  
  cmn.ShowBbt( "obj_well_use_hook" );
  
  ObjSet("anm_well_pig_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_well_rope()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_rope_in_well");
  
  cmn.ShowBbt( "obj_well_use_bucket" );
  
  ObjSet("anm_well_rope",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_well_runes()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_stone_in_well");
  
  cmn.ShowBbt( "obj_well_use_glenrune" );
  
  ObjSet("anm_well_runes_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
  if cmn.IsEventDone("use_glenrune") then
    ObjSet("anm_well_runes_touch_1",  { playing = 1 });
  end;
  
  if cmn.IsEventDone("use_igrune") then
    ObjSet("anm_well_runes_touch_2",  { playing = 1 });
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_garden_bucket( num )
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_bucket_1");
  
  cmn.ShowBbt( "obj_gardenbed_use_resin" );
  
  ObjSet("anm_gardenbed_bucket_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_garden_hill()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_earch_1");
  
  cmn.ShowBbt( "obj_gardenbed_use_scoop" );
  
  ObjSet("anm_gardenbed_ground_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_garden_pit( num )
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_earch_1");
  
  if num == 1 then
    cmn.ShowBbt( "obj_gardenbed_use_seedsskull" );
  else 
    cmn.ShowBbt( "obj_gardenbed_use_water" );
  end;
  
  ObjSet("anm_gardenbed_bigground_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_grave()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_coffin");
  
  cmn.ShowBbt( "obj_grave_plate_touch" );
  
  ObjSet("anm_grave_plate_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.dialog_naya_open( num )
  
  --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
  
  local func_after = function() private.dialog_naya1_beg(); end;
  if num == 2 then
    func_after = function() private.dialog_naya2_beg(); end;
  end;
  
  ObjAttach("obj_cemetery_dialog_naya"..num, "rm_cemetery");
  ObjAnimate("obj_cemetery_dialog_naya"..num, "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_naya1_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "cemetery", "naya1", 2 );
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "clk_cemeteryfirst" );
    cmn.ShowBbt( "cemetery_after_dialog_1" );
    
    ObjMultiSet( { {"anm_cemetery_dialog_naya1_hand_left", { playing = 1 }},
                   {"anm_cemetery_dialog_naya1_hand_2", { playing = 1 }} } );
    
  end;
  
  local anm_hand = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_cemetery_dialog_naya1_lipsync2");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_cemetery_dialog_naya1_timer",  { playing = 0 }},
                   {"anm_cemetery_dialog_naya1_head", { alp = 1 }},
                   {"anm_cemetery_dialog_naya1_hands_1", { alp = 0, playing = 0 }},
                   {"anm_cemetery_dialog_naya1_hand_give", { alp = 1, playing = 1, endtrig = dialog_end }} } );
    
  end;
  
  local naya_talks2 = function ()
  
    ObjDelete("vid_cemetery_dialog_naya1_lipsync1");
    ObjAttach("vid_cemetery_dialog_naya1_lipsync2", "obj_cemetery_dialog_naya1_naya");
  
    cmn.ShowDlgBbt( "dlg_naya1_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level1/audio/voc/aud_1_lvl_naya_2_voc");
    
    private.dlg_lipsync = "vid_cemetery_dialog_naya1_lipsync2";
    
    ObjMultiSet( { {"tmr_cemetery_dialog_naya1_timer", { endtrig = anm_hand, time = 7, playing = 1 }},
                   {"vid_cemetery_dialog_naya1_lipsync2", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_hand }},
                   {"obj_character_dialog_continue", { event_mup = anm_hand }} } );
  
  end;

  private.dlg_lipsync = "vid_cemetery_dialog_naya1_lipsync1";

  cmn.ShowDlgBbt( "dlg_naya1_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level1/audio/voc/aud_1_lvl_naya_1_voc");

  ObjMultiSet( { {"tmr_cemetery_dialog_naya1_timer", { time = 8, playing = 1, endtrig = naya_talks2 }},
                 {"vid_cemetery_dialog_naya1_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = naya_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = naya_talks2 }} } );
  
end; 
--------------------------------------------------------------------------------------------
function private.dialog_naya2_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "cemetery", "naya2", 2 );
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "use_fixedpuppet_end" );
    common_impl.current_dialog = "";
    
    cmn.ShowBbt( "cemetery_after_dialog_2" );
    
  end;
  
  --local anm_naya_2 = function ()
  --  
  --  ObjMultiSet( { {"anm_cemetery_naya_disappear",  { alp = 1, playing = 1, endtrig = dialog_end }},
  --                 {"spr_cemetery_crypt_open", { alp = 1 }},
  --                 {"anm_cemetery_naya_open_door", { alp = 0 }} } );
  --  
  --end;
  
  local anm_naya_1 = function ()
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_naya_goes_to_ho");
    ObjSet("anm_cemetery_naya_open_door",  { playing = 1, endtrig = dialog_end });
  end;
  
  local anm_hide = function ()
    
    private.dlg_lipsync = "";
    --ObjDelete("vid_cemetery_dialog_naya2_lipsync2");
    
    cmn.CallEventHandler("use_fixedpuppet_mid");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_cemetery_dialog_naya2_timer",  { playing = 0 }},
                   {"anm_cemetery_naya_open_door", { alp = 1 }} } );
    
    ObjAnimate("obj_cemetery_dialog_naya2", "alp", 0, 0, anm_naya_1, { 0, 0, 1,   0.5, 0, 0 });
    
  end;
  
  local naya_talks2 = function ()
  
    ObjDelete("vid_cemetery_dialog_naya2_lipsync1");
    ObjAttach("vid_cemetery_dialog_naya2_lipsync2", "obj_cemetery_dialog_naya2_naya");
  
    cmn.ShowDlgBbt( "dlg_naya2_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level1/audio/voc/aud_1_lvl_naya_4_voc");
    
    private.dlg_lipsync = "vid_cemetery_dialog_naya2_lipsync2";
    
    ObjMultiSet( { {"tmr_cemetery_dialog_naya2_timer", { endtrig = anm_hide, time = 5, playing = 1 }},
                   {"vid_cemetery_dialog_naya2_lipsync2", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_hide }},
                   {"obj_character_dialog_continue", { event_mup = anm_hide }} } );
  
  end;

  private.dlg_lipsync = "vid_cemetery_dialog_naya2_lipsync1";

  cmn.ShowDlgBbt( "dlg_naya2_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level1/audio/voc/aud_1_lvl_naya_3_voc");

  ObjMultiSet( { {"tmr_cemetery_dialog_naya2_timer", { time = 5, playing = 1, endtrig = naya_talks2 }},
                 {"vid_cemetery_dialog_naya2_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = naya_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = naya_talks2 }} } );
  
end; 
--------------------------------------------------------------------------------------------
function public.skip_dlg_naya1()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);

  local func_after_dlg = function ()

    cmn.Lock(0);
    
    cmn.CallEventHandler( "clk_cemeteryfirst" );
    cmn.ShowBbt( "cemetery_after_dialog_1" );
    
    ObjMultiSet( { {"anm_cemetery_dialog_naya1_hand_left", { playing = 1 }},
                   {"anm_cemetery_dialog_naya1_hand_2", { playing = 1 }} } );
    
  end;

  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();

  ObjMultiSet( { {"tmr_cemetery_dialog_naya1_timer",  { playing = 0 }},
                 {"anm_cemetery_dialog_naya1_head", { alp = 1 }},
                 {"anm_cemetery_dialog_naya1_hands_1", { alp = 0, playing = 0 }},
                 {"anm_cemetery_dialog_naya1_hand_give", { alp = 1, playing = 1, endtrig = func_after_dlg }} } );
  
end;  
--------------------------------------------------------------------------------------------
function public.skip_dlg_naya2()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  common_impl.current_dialog = "";
  
  cmn.CallEventHandler("use_fixedpuppet_mid");

  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "use_fixedpuppet_end" );
    cmn.ShowBbt( "cemetery_after_dialog_2" );
    
  end;
  
  --local anm_naya_2 = function ()
  --  
  --  ObjMultiSet( { {"anm_cemetery_naya_disappear",  { alp = 1, playing = 1, endtrig = func_after_dlg }},
  --                 {"spr_cemetery_crypt_open", { alp = 1 }},
  --                 {"anm_cemetery_naya_open_door", { alp = 0 }} } );
  --  
  --end;
  
  local anm_naya_1 = function ()
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_naya_goes_to_ho");
    ObjSet("anm_cemetery_naya_open_door",  { playing = 1, endtrig = func_after_dlg });
  end;
  
  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    --ObjDelete(private.dlg_lipsync);
    private.dlg_lipsync = "";
  end;

  ObjMultiSet( { {"tmr_cemetery_dialog_naya2_timer",  { playing = 0 }},
                 {"anm_cemetery_naya_open_door", { alp = 1 }} } );
  
  common_impl.CharacterDialogButtonsHide();
  
  --common_impl.PlayBackgroundMusic();
  
  ObjAnimate("obj_cemetery_dialog_naya2", "alp", 0, 0, anm_naya_1, { 0, 0, 1,   0.5, 0, 0 });
  
end;
--*********************************************************************************************************************
