-- name=rm_outsidechapel
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_outsidechapel";
  --------------------------------------------------------------------------------------------
  private.dlg_lipsync = "";
  private.Init_Subroom();
  private.Init_Gallows();
  private.Init_Fencegates();
  private.Init_Gates();
  --------------------------------------------------------------------------------------------
  -- function get_hammer () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_hammer" ] = {
        type = "get",
        get_obj = "obj_gargoyle_hammer",
        room = private.room_objname,
        zz = "zz_gargoyle",
        zz_gate = "gzz_outsidechapel_gargoyle"
    };
    --------------------------------------------------------------------------------------------
  local get_hammer_inv = function ()
  
    interface.InventoryItemAdd( "inv_hammer", "obj_gargoyle_hammer" );
  
  end;
  
  local get_hammer_end = function ()
  
    ObjDelete( "gfx_gargoyle_hammer" );
    ObjDelete( "spr_outsidechapel_gargoyle_hammer_2" );
    --ObjSet("spr_gargoyle_head",  { pos_z = 10 });
    ObjDelete( "spr_gargoyle_head" );
  
  end;
  
  cmn.AddSubscriber( "get_hammer", get_hammer_inv );
  cmn.AddSubscriber( "get_hammer", get_hammer_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_rod () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_rod" ] = {
        type = "get",
        get_obj = "spr_gargoyle_rod",
        room = private.room_objname,
        zz = "zz_gargoyle",
        zz_gate = "gzz_outsidechapel_gargoyle"
    };
    --------------------------------------------------------------------------------------------
  local get_rod_inv = function ()
  
    interface.InventoryItemAdd( "inv_rod", "spr_gargoyle_rod" );
  
  end;
  
  local get_rod_end = function ()
  
    ObjDelete( "gfx_gargoyle_rod" );
    ObjDelete( "spr_gargoyle_rod_sh" );
    
    ObjDelete( "spr_outsidechapel_gargoyle_rod" );
  
  end;
  
  cmn.AddSubscriber( "get_rod", get_rod_inv );
  cmn.AddSubscriber( "get_rod", get_rod_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_seedsskull () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_seedsskull" ] = {
        type = "get",
        get_obj = "spr_gargoyle_seedsskull",
        room = private.room_objname,
        zz = "zz_gargoyle",
        zz_gate = "gzz_outsidechapel_gargoyle"
    };
    --------------------------------------------------------------------------------------------
  local get_seedsskull_inv = function ()
  
    interface.InventoryItemAdd( "inv_seedsskull", "spr_gargoyle_seedsskull" );
  
  end;
  
  local get_seedsskull_end = function ()
  
    ObjDelete( "gfx_gargoyle_seedsskull" );
    ObjDelete( "spr_gargoyle_seedsskull_sh" );
    
    ObjDelete( "spr_outsidechapel_gargoyle_seeds" );
  
  end;
  
  cmn.AddSubscriber( "get_seedsskull", get_seedsskull_inv );
  cmn.AddSubscriber( "get_seedsskull", get_seedsskull_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_thread () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_thread" ] = {
        type = "get",
        get_obj = "spr_gargoyle_thread",
        room = private.room_objname,
        zz = "zz_gargoyle",
        zz_gate = "gzz_outsidechapel_gargoyle"
    };
    --------------------------------------------------------------------------------------------
  local get_thread_inv = function ()
  
    interface.InventoryItemAdd( "inv_thread", "spr_gargoyle_thread" );
    ObjSet("inv_puppet_star_light",  { alp = 1 });
  
  end;
  
  local get_thread_end = function ()
  
    ObjDelete( "gfx_gargoyle_thread" );
    ObjDelete( "spr_gargoyle_thread_sh" );
    
    ObjDelete( "spr_outsidechapel_gargoyle_thread" );
  
  end;
  
  cmn.AddSubscriber( "get_thread", get_thread_inv );
  cmn.AddSubscriber( "get_thread", get_thread_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tin () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_tin" ] = {
        type = "get",
        get_obj = "spr_gargoyle_tin",
        room = private.room_objname,
        zz = "zz_gargoyle",
        zz_gate = "gzz_outsidechapel_gargoyle"
    };
    --------------------------------------------------------------------------------------------
  local get_tin_inv = function ()
  
    interface.InventoryItemAdd( "inv_tin", "spr_gargoyle_tin" );
    int_map_impl.DecreaseRoomTasks("rm_outsidechapel");
  
  end;
  
  local get_tin_end = function ()
  
    ObjDelete( "gfx_gargoyle_tin" );
    ObjDelete( "spr_gargoyle_tin_sh" );
    
    ObjDelete( "spr_outsidechapel_gargoyle_tin" );
    ObjDelete( "gzz_outsidechapel_gargoyle" );
  
  end;
  
  cmn.AddSubscriber( "get_tin", get_tin_inv );
  cmn.AddSubscriber( "get_tin", get_tin_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ancientsign () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_ancientsign" ] = {
        type = "get",
        get_obj = "spr_gallows_ancientsign",
        room = private.room_objname,
        zz = "zz_gallows",
        zz_gate = "gzz_outsidechapel_gallows"
    };
    --------------------------------------------------------------------------------------------
  local get_ancientsign_inv = function ()
  
    interface.InventoryItemAdd( "inv_ancientsign", "spr_gallows_ancientsign" );
  
  end;
  local get_ancientsign_mid = function ()
  
    ObjDelete( "gfx_gallows_ancientsign" );
    ObjDelete( "spr_gallows_amulet_part" );
    
    ObjDelete( "gzz_outsidechapel_gallows_2" );
    ObjDelete( "spr_outsidechapel_gallows_skeleton_3" );
    
    ObjSet("gzz_outsidechapel_gallows",  { alp = 0, active = 0 });
  
  end;
  local get_ancientsign_end = function ()
  
    ObjDelete( "anm_gallows_skeleton_fall" );
    ObjDelete( "anm_gallows_mech_active" );
    ObjSet("anm_outsidechapel_gallows_skeleton_4",  { alp = 1, frame = 300 });
  
  end;
  
  cmn.AddSubscriber( "get_ancientsign", get_ancientsign_inv );
  cmn.AddSubscriber( "get_ancientsign", get_ancientsign_mid, private.room_objname );
  cmn.AddSubscriber( "get_ancientsign", get_ancientsign_end, private.room_objname );
  cmn.AddSubscriber( "get_ancientsign_inv", get_ancientsign_inv );
  cmn.AddSubscriber( "get_ancientsign_mid", get_ancientsign_mid, private.room_objname );
  cmn.AddSubscriber( "get_ancientsign_end", get_ancientsign_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_dagger () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_dagger" ] = {
        type = "get",
        get_obj = "spr_gallows_dagger",
        room = private.room_objname,
        zz = "zz_gallows",
        zz_gate = "gzz_outsidechapel_gallows"
    };
    --------------------------------------------------------------------------------------------
  local get_dagger_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_dagger", "spr_gallows_dagger" );
  
  end;
  
  local get_dagger_end = function ()
  
    ObjDelete( "gfx_gallows_dagger" );
    ObjDelete( "spr_gallows_dagger_sh" );
    ObjDelete( "spr_gallows_ring1_bl" );
    
    ObjDelete( "spr_outsidechapel_gallows_dagger" );
    
  end;
  
  cmn.AddSubscriber( "get_dagger", get_dagger_inv );
  cmn.AddSubscriber( "get_dagger", get_dagger_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_smallwheel () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_smallwheel" ] = {
        type = "get",
        get_obj = "spr_fencegate_smallwheel",
        room = private.room_objname,
        zz = "zz_fencegate",
        zz_gate = "gzz_outsidechapel_fencegate"
    };
    --------------------------------------------------------------------------------------------
  local get_smallwheel_inv = function ()
  
    interface.InventoryItemAdd( "inv_smallwheel", "spr_fencegate_smallwheel" );
  
  end;
  
  local get_smallwheel_end = function ()
  
    ObjDelete( "gfx_fencegate_smallwheel" );
    ObjDelete( "spr_fencegate_smallwheel_sh" );
    
    ObjDelete( "spr_outsidechapel_fence_wheel" );
  
  end;
  
  cmn.AddSubscriber( "get_smallwheel", get_smallwheel_inv );
  cmn.AddSubscriber( "get_smallwheel", get_smallwheel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_chain () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_chain" ] = {
        type = "get",
        get_obj = "spr_fencegate_chain",
        room = private.room_objname,
        zz = "zz_fencegate",
        zz_gate = "gzz_outsidechapel_fencegate"
    };
    --------------------------------------------------------------------------------------------
  local get_chain_inv = function ()
  
    interface.InventoryItemAdd( "inv_chain", "spr_fencegate_chain" );
  
  end;
  
  local get_chain_end = function ()
  
    ObjDelete( "gfx_fencegate_chain" );
    ObjDelete( "amm_fencegate_use_file" );
    
    ObjDelete( "spr_outsidechapel_fence_chain" );
  
  end;
  
  cmn.AddSubscriber( "get_chain", get_chain_inv );
  cmn.AddSubscriber( "get_chain", get_chain_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_valve () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_valve" ] = {
        type = "get",
        get_obj = "spr_fencegate_valve",
        room = private.room_objname,
        zz = "zz_fencegate",
        zz_gate = "gzz_outsidechapel_fencegate"
    };
    --------------------------------------------------------------------------------------------
  local get_valve_inv = function ()
  
    interface.InventoryItemAdd( "inv_valve", "spr_fencegate_valve" );
  
  end;
  
  local get_valve_end = function ()
  
    ObjDelete( "gfx_fencegate_valve" );
    ObjDelete( "spr_fencegate_valve_sh" );
    
    ObjDelete( "spr_outsidechapel_fence_valve" );
  
  end;
  
  cmn.AddSubscriber( "get_valve", get_valve_inv );
  cmn.AddSubscriber( "get_valve", get_valve_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_adjuster () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_adjuster" ] = {
        type = "get",
        get_obj = "spr_forge_adjuster_fly",
        room = private.room_objname,
        zz = "zz_forge",
        zz_gate = "gzz_outsidechapel_forge"
    };
    --------------------------------------------------------------------------------------------
  local get_adjuster_inv = function ()
  
    interface.InventoryItemAdd( "inv_adjuster", "spr_forge_adjuster_fly" );
  
  end;
  
  local get_adjuster_end = function ()
  
    ObjDelete( "spr_forge_adjuster" );
    ObjDelete( "spr_forge_adjuster_sh" );
    
    ObjDelete( "spr_outsidechapel_forge_adjuster" );
  
  end;
  
  cmn.AddSubscriber( "get_adjuster", get_adjuster_inv );
  cmn.AddSubscriber( "get_adjuster", get_adjuster_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_oil () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_oil" ] = {
        type = "get",
        get_obj = "spr_forge_oil",
        room = private.room_objname,
        zz = "zz_forge",
        zz_gate = "gzz_outsidechapel_forge"
    };
    --------------------------------------------------------------------------------------------
  local get_oil_inv = function ()
  
    interface.InventoryItemAdd( "inv_oil", "spr_forge_oil" );
    ObjSet("inv_dagger_star_light",  { alp = 1 });
  
  end;
  
  local get_oil_end = function ()
  
    ObjDelete( "gfx_forge_oil" );
    ObjDelete( "spr_forge_oil_sh" );
    
    ObjDelete( "spr_outsidechapel_forge_bottle_2" );
  
  end;
  
  cmn.AddSubscriber( "get_oil", get_oil_inv );
  cmn.AddSubscriber( "get_oil", get_oil_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bottlewithresin () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_bottlewithresin" ] = {
        type = "get",
        get_obj = "spr_forge_resin",
        room = private.room_objname,
        zz = "zz_forge",
        zz_gate = "gzz_outsidechapel_forge"
    };
    --------------------------------------------------------------------------------------------
  local get_bottlewithresin_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_bottlewithresin", "spr_forge_resin" );
  
  end;
  
  local get_bottlewithresin_end = function ()
  
    ObjDelete( "gfx_forge_resin" );
    ObjDelete( "spr_forge_resin_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_bottlewithresin", get_bottlewithresin_inv );
  cmn.AddSubscriber( "get_bottlewithresin", get_bottlewithresin_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_scoopwithcoals () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_scoopwithcoals" ] = {
        type = "get",
        get_obj = "spr_forge_scoopwithcoals",
        room = private.room_objname,
        zz = "zz_forge",
        zz_gate = "gzz_outsidechapel_forge"
    };
    --------------------------------------------------------------------------------------------
  local get_scoopwithcoals_inv = function ()
  
    interface.InventoryItemAdd( "inv_scoopwithcoals", "spr_forge_scoop_coals_1" );
    int_map_impl.DecreaseRoomTasks("rm_outsidechapel");
  
  end;
  
  local get_scoopwithcoals_end = function ()
  
    ObjDelete( "spr_forge_scoopwithcoals" );
    ObjDelete( "anm_forge_use_scoop" );
    
    ObjDelete( "gzz_outsidechapel_forge" );
  
  end;
  
  cmn.AddSubscriber( "get_scoopwithcoals", get_scoopwithcoals_inv );
  cmn.AddSubscriber( "get_scoopwithcoals", get_scoopwithcoals_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bigwheel () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_bigwheel" ] = {
        type = "get",
        get_obj = "spr_ivy_bigwheel",
        room = private.room_objname,
        zz = "zz_ivy",
        zz_gate = "gzz_outsidechapel_ivy"
    };
    --------------------------------------------------------------------------------------------
  local get_bigwheel_inv = function ()
  
    interface.InventoryItemAdd( "inv_bigwheel", "spr_ivy_bigwheel" );
  
  end;
  
  local get_bigwheel_end = function ()
  
    ObjDelete( "gfx_ivy_bigwheel" );
    ObjDelete( "spr_ivy_bigwheel_sh" );
    
    ObjDelete( "spr_outsidechapel_ivy_wheel" );
  
  end;
  
  cmn.AddSubscriber( "get_bigwheel", get_bigwheel_inv );
  cmn.AddSubscriber( "get_bigwheel", get_bigwheel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_scoop () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_scoop" ] = {
        type = "get",
        get_obj = "spr_ivy_scoop",
        room = private.room_objname,
        zz = "zz_ivy",
        zz_gate = "gzz_outsidechapel_ivy"
    };
    --------------------------------------------------------------------------------------------
  local get_scoop_inv = function ()
  
    interface.InventoryItemAdd( "inv_scoop", "spr_ivy_scoop" );
  
  end;
  
  local get_scoop_end = function ()
  
    ObjDelete( "gfx_ivy_scoop" );
    ObjDelete( "spr_ivy_scoop_sh" );
    
    ObjDelete( "spr_outsidechapel_ivy_scoop" );
    
    if cmn.IsEventDone("get_stainedglassshard2") then
      --ObjDelete( "gzz_outsidechapel_ivy" );
      ObjSet("gzz_outsidechapel_ivy",  { active = 0, visible = 0 });
    end;
  
  end;
  
  cmn.AddSubscriber( "get_scoop", get_scoop_inv );
  cmn.AddSubscriber( "get_scoop", get_scoop_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_file () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_file" ] = {
        type = "get",
        get_obj = "spr_ivy_file",
        room = private.room_objname,
        zz = "zz_ivy",
        zz_gate = "gzz_outsidechapel_ivy"
    };
    --------------------------------------------------------------------------------------------
  local get_file_inv = function ()
  
    interface.InventoryItemAdd( "inv_file", "spr_ivy_file" );
  
  end;
  
  local get_file_end = function ()
  
    ObjDelete( "gfx_ivy_file" );
    ObjDelete( "spr_ivy_file_sh" );
    
    ObjDelete( "spr_outsidechapel_ivy_file" );
  
  end;
  
  cmn.AddSubscriber( "get_file", get_file_inv );
  cmn.AddSubscriber( "get_file", get_file_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hammerhandle () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_hammerhandle" ] = {
        type = "get",
        get_obj = "spr_ivy_hammerhandle",
        room = private.room_objname,
        zz = "zz_ivy",
        zz_gate = "gzz_outsidechapel_ivy"
    };
    --------------------------------------------------------------------------------------------
  local get_hammerhandle_inv = function ()
  
    interface.InventoryItemAdd( "inv_hammerhandle", "spr_ivy_hammerhandle" );
  
  end;
  
  local get_hammerhandle_end = function ()
  
    ObjDelete( "gfx_ivy_hammerhandle" );
    ObjDelete( "spr_ivy_hammerhandle_sh" );
    
    ObjDelete( "spr_outsidechapel_ivy_handle" );
  
  end;
  
  cmn.AddSubscriber( "get_hammerhandle", get_hammerhandle_inv );
  cmn.AddSubscriber( "get_hammerhandle", get_hammerhandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stainedglassshard2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_stainedglassshard2" ] = {
        type = "get",
        get_obj = "spr_ivy_stainedglassshard2",
        room = private.room_objname,
        zz = "zz_ivy",
        zz_gate = "gzz_outsidechapel_ivy"
    };
    --------------------------------------------------------------------------------------------
  local get_stainedglassshard2_inv = function ()
  
    interface.InventoryItemAdd( "inv_stainedglassshard", "spr_ivy_stainedglassshard2", function () cmn.GetMultyObject( 'stainedglassshard', 3 ); end );
    int_map_impl.DecreaseRoomTasks("rm_outsidechapel");
      
  end;
  
  local get_stainedglassshard2_end = function ()
  
    ObjDelete( "gfx_ivy_stainedglassshard2" );
    ObjDelete( "spr_ivy_stainedglassshard2_sh" );
    
    ObjDelete( "spr_outsidechapel_ivy_shard" );
    
    if cmn.IsEventDone("get_scoop") then
      --ObjDelete( "gzz_outsidechapel_ivy" );
      ObjSet("gzz_outsidechapel_ivy",  { active = 0, visible = 0 });
    end;
  
  end;
  
  cmn.AddSubscriber( "get_stainedglassshard2", get_stainedglassshard2_inv );
  cmn.AddSubscriber( "get_stainedglassshard2", get_stainedglassshard2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stephensbag () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_stephensbag" ] = {
        type = "get",
        get_obj = "spr_gates_stephensbag",
        room = private.room_objname,
        zz = "zz_gates",
        zz_gate = "gzz_outsidechapel_gates"
    };
    --------------------------------------------------------------------------------------------
  local get_stephensbag_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_stephensbag", "spr_gates_stephensbag" );
  
  end;
  
  local get_stephensbag_end = function ()
  
    ObjDelete( "gfx_gates_stephensbag" );
    ObjDelete( "spr_gates_stephensbag_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_stephensbag", get_stephensbag_inv );
  cmn.AddSubscriber( "get_stephensbag", get_stephensbag_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_debugger () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_debugger" ] = {
      type = "get",
      get_obj = "spr_outsidechapel_map",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_debugger_inv = function ()
  
    int_button_map_impl.MapSetActive( "spr_outsidechapel_map" );
  
  end;
  local get_debugger_mid = function ()
  
    ObjDelete( "gfx_outsidechapel_map" );
    ObjDelete( "spr_outsidechapel_map_sh" );
  
  end;
  local get_debugger_end = function ()
  
    ObjDelete( "obj_outsidechapel_dialog_stephen1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_debugger", get_debugger_inv );
  cmn.AddSubscriber( "get_debugger_inv", get_debugger_inv, private.room_objname );
  cmn.AddSubscriber( "get_debugger", get_debugger_mid, private.room_objname );
  cmn.AddSubscriber( "get_debugger_mid", get_debugger_mid, private.room_objname );
  cmn.AddSubscriber( "get_debugger", get_debugger_end, private.room_objname );
  cmn.AddSubscriber( "get_debugger_end", get_debugger_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_hammerhandle () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_hammerhandle" ] = {
        type = "use",
        inv_obj = "inv_hammerhandle",
        use_place = "obj_gargoyle_use_hammerhandle",
        room = private.room_objname,
        zz = "zz_gargoyle",
        zz_gate = "gzz_outsidechapel_gargoyle"
    };
  --------------------------------------------------------------------------------------------
  local use_hammerhandle_inv = function ()
  
    interface.InventoryItemRemove( "inv_hammerhandle" );
  
  end;
  local use_hammerhandle_beg = function ()
  
    ObjDelete( "obj_gargoyle_use_hammerhandle" );
    ObjDelete( "anm_gargoyle_hammer_touch" );
  
  end;
  local use_hammerhandle_end = function ()
  
    ObjDelete( "spr_outsidechapel_gargoyle_hammer" );
    ObjSet( "spr_outsidechapel_gargoyle_hammer_2", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hammerhandle", use_hammerhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammerhandle", use_hammerhandle_inv );
  cmn.AddSubscriber( "use_hammerhandle", use_hammerhandle_end, private.room_objname );
  cmn.AddSubscriber( "use_hammerhandle_inv", use_hammerhandle_inv, private.room_objname );
  cmn.AddSubscriber( "use_hammerhandle_beg", use_hammerhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammerhandle_end", use_hammerhandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gargoylepart () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_gargoylepart" ] = {
        type = "use",
        inv_obj = "inv_gargoylepart",
        use_place = "obj_gargoyle_use_gargoylepart",
        room = private.room_objname,
        zz = "zz_gargoyle",
        zz_gate = "gzz_outsidechapel_gargoyle"
    };
  --------------------------------------------------------------------------------------------
  local use_gargoylepart_inv = function ()
  
    interface.InventoryItemRemove( "inv_gargoylepart" );
  
  end;
  local use_gargoylepart_beg = function ()
  
    ObjDelete( "obj_gargoyle_use_gargoylepart" );
    ObjDelete( "anm_gargoyle_parts_touch" );
    ObjDelete( "anm_gargoyle_door_touch" );
    ObjDelete( "obj_gargoyle_door_touch" );
  
  end;
  local use_gargoylepart_end = function ()
    
    ObjDelete( "spr_outsidechapel_gargoyle_cover" );
  
    ObjMultiSet( { {"obj_gargoyle_niche", { alp = 1, input = 1 }},
                   {"anm_gargoyle_use_parts", { alp = 1, frame = 300 }},
                   {"obj_gargoyle_use_bluelight", { input = 1 }},
                   {"spr_outsidechapel_gargoyle_parts", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gargoylepart", use_gargoylepart_beg, private.room_objname );
  cmn.AddSubscriber( "use_gargoylepart", use_gargoylepart_inv );
  cmn.AddSubscriber( "use_gargoylepart", use_gargoylepart_end, private.room_objname );
  cmn.AddSubscriber( "use_gargoylepart_inv", use_gargoylepart_inv, private.room_objname );
  cmn.AddSubscriber( "use_gargoylepart_beg", use_gargoylepart_beg, private.room_objname );
  cmn.AddSubscriber( "use_gargoylepart_end", use_gargoylepart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bluelight () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_bluelight" ] = {
        type = "use",
        inv_obj = "inv_bluelight",
        use_place = "obj_gargoyle_use_bluelight",
        room = private.room_objname,
        zz = "zz_gargoyle",
        zz_gate = "gzz_outsidechapel_gargoyle"
    };
  --------------------------------------------------------------------------------------------
  local use_bluelight_inv = function ()
  
    interface.InventoryItemRemove( "inv_bluelight" );
  
  end;
  local use_bluelight_beg = function ()
  
    ObjDelete( "obj_gargoyle_use_bluelight" );
    ObjDelete( "anm_gargoyle_use_parts" );
  
  end;
  local use_bluelight_end = function ()
  
    --ObjAttach("anm_gargoyle_bluelight", "anm_gargoyle_use_light");
    
    ObjMultiSet( { {"anm_gargoyle_use_light", { input = 1, alp = 1, frame = 300 }},
                   --{"spr_outsidechapel_gargoyle_mouth", { alp = 1 }},
                   {"spr_outsidechapel_gargoyle_light", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bluelight", use_bluelight_beg, private.room_objname );
  cmn.AddSubscriber( "use_bluelight", use_bluelight_inv );
  cmn.AddSubscriber( "use_bluelight", use_bluelight_end, private.room_objname );
  cmn.AddSubscriber( "use_bluelight_inv", use_bluelight_inv, private.room_objname );
  cmn.AddSubscriber( "use_bluelight_beg", use_bluelight_beg, private.room_objname );
  cmn.AddSubscriber( "use_bluelight_end", use_bluelight_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_smallwheel () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_smallwheel" ] = {
        type = "use",
        inv_obj = "inv_smallwheel",
        use_place = "obj_gallows_use_smallwheel",
        room = private.room_objname,
        zz = "zz_gallows",
        zz_gate = "gzz_outsidechapel_gallows"
    };
  --------------------------------------------------------------------------------------------
  local use_smallwheel_inv = function ()
  
    interface.InventoryItemRemove( "inv_smallwheel" );
  
  end;
  local use_smallwheel_beg = function ()
  
    ObjDelete( "obj_gallows_use_smallwheel" );
  
  end;
  local use_smallwheel_end = function ()
    
    ObjSet("spr_outsidechapel_gallows_smallwheel",  { alp = 1 });
    
    if cmn.IsEventDone("use_bigwheel") then
        ObjSet("obj_gallows_use_chain",  { input = 1 });
      end;
      ObjMultiSet( { {"spr_gallows_smallwheel_1", { alp = 1 }},
                     {"spr_gallows_smallwheel_2", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_bigwheel") and cmn.IsEventDone("use_chain") and cmn.IsEventDone("use_adjuster") then
      ObjDelete("anm_gallows_skeleton");
      ObjDelete("obj_gallows_skeleton_bbt");
      ObjDelete("obj_outsidechapel_gallows_skeleton_1");
      ObjDelete("anm_gallows_mech_active_1");
      ObjMultiSet( { {"anm_gallows_mech_active", { input = 1, alp = 1 }},
                     {"obj_gallows_hop_interface", { alp = 1, input = 1 }},
                     {"spr_outsidechapel_gallows_skeleton_2", { alp = 1 }},
                     {"gzz_outsidechapel_gallows_2", { input = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_smallwheel", use_smallwheel_beg, private.room_objname );
  cmn.AddSubscriber( "use_smallwheel", use_smallwheel_inv );
  cmn.AddSubscriber( "use_smallwheel", use_smallwheel_end, private.room_objname );
  cmn.AddSubscriber( "use_smallwheel_inv", use_smallwheel_inv, private.room_objname );
  cmn.AddSubscriber( "use_smallwheel_beg", use_smallwheel_beg, private.room_objname );
  cmn.AddSubscriber( "use_smallwheel_end", use_smallwheel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bigwheel () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_bigwheel" ] = {
        type = "use",
        inv_obj = "inv_bigwheel",
        use_place = "obj_gallows_use_bigwheel",
        room = private.room_objname,
        zz = "zz_gallows",
        zz_gate = "gzz_outsidechapel_gallows"
    };
  --------------------------------------------------------------------------------------------
  local use_bigwheel_inv = function ()
  
    interface.InventoryItemRemove( "inv_bigwheel" );
  
  end;
  local use_bigwheel_beg = function ()
  
    ObjDelete( "obj_gallows_use_bigwheel" );
  
  end;
  local use_bigwheel_end = function ()
    
    ObjSet("spr_outsidechapel_gallows_bigwheel",  { alp = 1 });
    
    if cmn.IsEventDone("use_smallwheel") then
      ObjSet("obj_gallows_use_chain",  { input = 1 });
    end;
    ObjMultiSet( { {"spr_gallows_bigwheel_1", { alp = 1 }},
                   {"spr_gallows_bigwheel_2", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_smallwheel") and cmn.IsEventDone("use_chain") and cmn.IsEventDone("use_adjuster") then
      ObjDelete("anm_gallows_skeleton");
      ObjDelete("obj_gallows_skeleton_bbt");
      ObjDelete("obj_outsidechapel_gallows_skeleton_1");
      ObjDelete("anm_gallows_mech_active_1");
      ObjMultiSet( { {"anm_gallows_mech_active", { input = 1, alp = 1 }},
                     {"obj_gallows_hop_interface", { alp = 1, input = 1 }},
                     {"spr_outsidechapel_gallows_skeleton_2", { alp = 1 }},
                     {"gzz_outsidechapel_gallows_2", { input = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bigwheel", use_bigwheel_beg, private.room_objname );
  cmn.AddSubscriber( "use_bigwheel", use_bigwheel_inv );
  cmn.AddSubscriber( "use_bigwheel", use_bigwheel_end, private.room_objname );
  cmn.AddSubscriber( "use_bigwheel_inv", use_bigwheel_inv, private.room_objname );
  cmn.AddSubscriber( "use_bigwheel_beg", use_bigwheel_beg, private.room_objname );
  cmn.AddSubscriber( "use_bigwheel_end", use_bigwheel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chain () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_chain" ] = {
        type = "use",
        inv_obj = "inv_chain",
        use_place = "obj_gallows_use_chain",
        room = private.room_objname,
        zz = "zz_gallows",
        zz_gate = "gzz_outsidechapel_gallows"
    };
  --------------------------------------------------------------------------------------------
  local use_chain_inv = function ()
  
    interface.InventoryItemRemove( "inv_chain" );
  
  end;
  local use_chain_beg = function ()
  
    ObjDelete( "obj_gallows_use_chain" );
  
  end;
  local use_chain_end = function ()
    
    ObjDelete( "anm_gallows_chain_use" );
    
    ObjMultiSet( { {"spr_outsidechapel_gallows_chain_1", { alp = 1 }},
                   {"spr_outsidechapel_gallows_chain_2", { alp = 1 }},
                   {"spr_gallows_chain_1", { alp = 1 }},
                   {"spr_gallows_chain_2", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_smallwheel") and cmn.IsEventDone("use_bigwheel") and cmn.IsEventDone("use_adjuster") then
      ObjDelete("anm_gallows_skeleton");
      ObjDelete("obj_gallows_skeleton_bbt");
      ObjDelete("obj_outsidechapel_gallows_skeleton_1");
      ObjDelete("anm_gallows_mech_active_1");
      ObjMultiSet( { {"anm_gallows_mech_active", { input = 1, alp = 1 }},
                     {"obj_gallows_hop_interface", { alp = 1, input = 1 }},
                     {"spr_outsidechapel_gallows_skeleton_2", { alp = 1 }},
                     {"gzz_outsidechapel_gallows_2", { input = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chain", use_chain_beg, private.room_objname );
  cmn.AddSubscriber( "use_chain", use_chain_inv );
  cmn.AddSubscriber( "use_chain", use_chain_end, private.room_objname );
  cmn.AddSubscriber( "use_chain_inv", use_chain_inv, private.room_objname );
  cmn.AddSubscriber( "use_chain_beg", use_chain_beg, private.room_objname );
  cmn.AddSubscriber( "use_chain_end", use_chain_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_adjuster () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_adjuster" ] = {
        type = "use",
        inv_obj = "inv_adjuster",
        use_place = "obj_gallows_use_adjuster",
        room = private.room_objname,
        zz = "zz_gallows",
        zz_gate = "gzz_outsidechapel_gallows"
    };
  --------------------------------------------------------------------------------------------
  local use_adjuster_inv = function ()
  
    interface.InventoryItemRemove( "inv_adjuster" );
  
  end;
  local use_adjuster_beg = function ()
  
    ObjDelete( "obj_gallows_use_adjuster" );
  
  end;
  local use_adjuster_end = function ()
    
    ObjSet("spr_outsidechapel_gallows_adjuster",  { alp = 1 });
    
    ObjMultiSet( { {"spr_gallows_handle", { alp = 1 }},
                   {"spr_gallows_handle_sh", { alp = 1 }} } );
    if not cmn.IsEventDone("use_chain") then
      ObjMultiSet( { {"spr_gallows_handle_1", { alp = 1 }},
                     {"spr_gallows_handle_sh_1", { alp = 1 }} } );
    end;
  
    if cmn.IsEventDone("use_smallwheel") and cmn.IsEventDone("use_chain") and cmn.IsEventDone("use_bigwheel") then
      ObjDelete("anm_gallows_skeleton");
      ObjDelete("obj_gallows_skeleton_bbt");
      ObjDelete("obj_outsidechapel_gallows_skeleton_1");
      ObjDelete("anm_gallows_mech_active_1");
      ObjMultiSet( { {"anm_gallows_mech_active", { input = 1, alp = 1 }},
                     {"obj_gallows_hop_interface", { alp = 1, input = 1 }},
                     {"spr_outsidechapel_gallows_skeleton_2", { alp = 1 }},
                     {"gzz_outsidechapel_gallows_2", { input = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_adjuster", use_adjuster_beg, private.room_objname );
  cmn.AddSubscriber( "use_adjuster", use_adjuster_inv );
  cmn.AddSubscriber( "use_adjuster", use_adjuster_end, private.room_objname );
  cmn.AddSubscriber( "use_adjuster_inv", use_adjuster_inv, private.room_objname );
  cmn.AddSubscriber( "use_adjuster_beg", use_adjuster_beg, private.room_objname );
  cmn.AddSubscriber( "use_adjuster_end", use_adjuster_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sharpdagger () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_sharpdaggerfence" ] = {
        type = "use",
        inv_obj = "inv_sharpdagger",
        use_place = "obj_fencegate_use_sharpdagger",
        room = private.room_objname,
        zz = "zz_fencegate",
        zz_gate = "gzz_outsidechapel_fencegate"
    };
    game.hint[ "use_sharpdaggerivy" ] = {
        type = "use",
        inv_obj = "inv_sharpdagger",
        use_place = "obj_ivy_use_sharpdagger",
        room = private.room_objname,
        zz = "zz_ivy",
        zz_gate = "gzz_outsidechapel_ivy"
    };
    game.hint[ "use_sharpdaggerscarecrow" ] = {
        type = "use",
        inv_obj = "inv_sharpdagger",
        use_place = "obj_scarecrow_use_sharpdagger",
        room = "rm_cemetery",
        zz = "zz_scarecrow",
        zz_gate = "gzz_cemetery_scarecrow"
    };
  --------------------------------------------------------------------------------------------
  local use_sharpdagger_inv1 = function ()
  
    if cmn.IsEventDone("use_sharpdaggerivy") and cmn.IsEventDone("use_sharpdaggerscarecrow") then
      interface.InventoryItemRemove( "inv_sharpdagger" );
    end;
  
  end;
  local use_sharpdagger_beg1 = function ()
  
    ObjDelete( "obj_fencegate_use_sharpdagger" );
    ObjDelete( "amm_fencegate_touch_ivy" );
  
  end;
  local use_sharpdagger_end1 = function ()
    
    ObjDelete( "spr_outsidechapel_fence_ivy" );
  
    ObjMultiSet( { {"obj_fencegate_under_ivy", { input = 1}},
                   {"amm_fencegate_use_dagger", { alp = 1, frame = 300 }},
                   {"spr_outsidechapel_fence_ivy_2", { alp = 1 }} } );
  
  end;
   
  local use_sharpdagger_inv2 = function ()
  
    if cmn.IsEventDone("use_sharpdaggerfence") and cmn.IsEventDone("use_sharpdaggerscarecrow") then
      interface.InventoryItemRemove( "inv_sharpdagger" );
    end;
  
  end;
  local use_sharpdagger_beg2 = function ()
  
    ObjDelete( "obj_ivy_use_sharpdagger" );
    ObjDelete( "anm_ivy_bush" );
    ObjDelete( "anm_ivy_bush_touch" );
    
    ObjSet("spr_ivy_bush",  { alp = 1 });
  
  end;
  local use_sharpdagger_end2 = function ()
  
    ObjMultiSet( { {"anm_ivy_use_dagger", { alp = 1, frame = 300 }},
                   {"obj_ivy_under_ivy", { input = 1, alp = 1 }},
                   {"obj_outsidechapel_ivy_cut", { alp = 1 }} } );
  
  end;
  
  local use_sharpdagger_inv3 = function ()
  
    if cmn.IsEventDone("use_sharpdaggerfence") and cmn.IsEventDone("use_sharpdaggerivy") then
      interface.InventoryItemRemove( "inv_sharpdagger" );
    end;
  
  end;
  local use_sharpdagger_beg3 = function ()
  
    ObjDelete( "obj_scarecrow_use_sharpdagger" );
    ObjDelete( "anm_scarecrow_rope" );
  
  end;
  local use_sharpdagger_end3 = function ()
  
    ObjDelete( "anm_scarecrow_scarecrow" );
    ObjDelete( "vid_scarecrow_jumpscare" );

    ObjMultiSet( { {"anm_scarecrow_scarecrow_2", { alp = 1 }},
                   {"obj_scarecrow_use_pumpkin", { input = 1 }} } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sharpdaggerfence", use_sharpdagger_beg1, private.room_objname );
  cmn.AddSubscriber( "use_sharpdaggerfence", use_sharpdagger_inv1 );
  cmn.AddSubscriber( "use_sharpdaggerfence", use_sharpdagger_end1, private.room_objname );
  cmn.AddSubscriber( "use_sharpdagger_inv1", use_sharpdagger_inv1, private.room_objname );
  cmn.AddSubscriber( "use_sharpdagger_beg1", use_sharpdagger_beg1, private.room_objname );
  cmn.AddSubscriber( "use_sharpdagger_end1", use_sharpdagger_end1, private.room_objname );
  
  cmn.AddSubscriber( "use_sharpdaggerivy", use_sharpdagger_beg2, private.room_objname );
  cmn.AddSubscriber( "use_sharpdaggerivy", use_sharpdagger_inv2 );
  cmn.AddSubscriber( "use_sharpdaggerivy", use_sharpdagger_end2, private.room_objname );
  cmn.AddSubscriber( "use_sharpdagger_inv2", use_sharpdagger_inv2, private.room_objname );
  cmn.AddSubscriber( "use_sharpdagger_beg2", use_sharpdagger_beg2, private.room_objname );
  cmn.AddSubscriber( "use_sharpdagger_end2", use_sharpdagger_end2, private.room_objname );
  
  cmn.AddSubscriber( "use_sharpdaggerscarecrow", use_sharpdagger_beg3, "rm_cemetery" );
  cmn.AddSubscriber( "use_sharpdaggerscarecrow", use_sharpdagger_inv3 );
  cmn.AddSubscriber( "use_sharpdaggerscarecrow", use_sharpdagger_end3, "rm_cemetery" );
  cmn.AddSubscriber( "use_sharpdagger_inv3", use_sharpdagger_inv3, "rm_cemetery" );
  cmn.AddSubscriber( "use_sharpdagger_beg3", use_sharpdagger_beg3, "rm_cemetery");
  cmn.AddSubscriber( "use_sharpdagger_end3", use_sharpdagger_end3, "rm_cemetery" );
  --------------------------------------------------------------------------------------------
  -- function use_file () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_file" ] = {
        type = "use",
        inv_obj = "inv_file",
        use_place = "obj_fencegate_use_file",
        room = private.room_objname,
        zz = "zz_fencegate",
        zz_gate = "gzz_outsidechapel_fencegate"
    };
  --------------------------------------------------------------------------------------------
  local use_file_inv = function ()
  
    interface.InventoryItemRemove( "inv_file" );
  
  end;
  local use_file_beg = function ()
  
    ObjDelete( "obj_fencegate_use_file" );
    ObjDelete( "amm_fencegate_touch_chain" );
    ObjDelete( "obj_fencegate_chain_1" );
  
  end;
  local use_file_end = function ()
    
    ObjDelete( "anm_fencegate_panel_open" );
  
    ObjMultiSet( { {"obj_fencegate_game", { input = 1 }},
                   {"spr_outsidechapel_fence_game", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_file", use_file_beg, private.room_objname );
  cmn.AddSubscriber( "use_file", use_file_inv );
  cmn.AddSubscriber( "use_file", use_file_end, private.room_objname );
  cmn.AddSubscriber( "use_file_inv", use_file_inv, private.room_objname );
  cmn.AddSubscriber( "use_file_beg", use_file_beg, private.room_objname );
  cmn.AddSubscriber( "use_file_end", use_file_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_deathfigurine () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_deathfigurine" ] = {
        type = "use",
        inv_obj = "inv_deathfigurine",
        use_place = "obj_fencegate_use_deathfigurine",
        room = private.room_objname,
        zz = "zz_fencegate",
        zz_gate = "gzz_outsidechapel_fencegate"
    };
  --------------------------------------------------------------------------------------------
  local use_deathfigurine_inv = function ()
  
    interface.InventoryItemRemove( "inv_deathfigurine" );
  
  end;
  local use_deathfigurine_beg = function ()
  
    ObjDelete( "obj_fencegate_use_deathfigurine" );
  
  end;
  local use_deathfigurine_end = function ()
    
    ObjDelete( "spr_fencegate_death_3_sh" );
  
    ObjMultiSet( { {"spr_fencegate_death_3", { alp = 1 }},
                   {"obj_fencegate_game_play", { input = 1 }},
                   {"spr_outsidechapel_fence_death", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_deathfigurine", use_deathfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_deathfigurine", use_deathfigurine_inv );
  cmn.AddSubscriber( "use_deathfigurine", use_deathfigurine_end, private.room_objname );
  cmn.AddSubscriber( "use_deathfigurine_inv", use_deathfigurine_inv, private.room_objname );
  cmn.AddSubscriber( "use_deathfigurine_beg", use_deathfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_deathfigurine_end", use_deathfigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_valve () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_valve" ] = {
        type = "use",
        inv_obj = "inv_valve",
        use_place = "obj_forge_use_valve",
        room = private.room_objname,
        zz = "zz_forge",
        zz_gate = "gzz_outsidechapel_forge"
    };
  --------------------------------------------------------------------------------------------
  local use_valve_inv = function ()
  
    interface.InventoryItemRemove( "inv_valve" );
  
  end;
  local use_valve_beg = function ()
  
    ObjDelete( "obj_forge_use_valve" );
    ObjDelete( "anm_forge_oil_touch" );
  
  end;
  local use_valve_end = function ()
    
    ObjAttach("obj_forge_oil_anm", "anm_forge_use_valve");
    ObjAttach("obj_forge_oil_anm_sh", "anm_forge_use_valve");
    
    ObjDelete( "spr_outsidechapel_forge_bottle_1" );
  
    ObjMultiSet( { {"anm_forge_use_valve", { alp = 1, frame = 300 }},
                   {"obj_forge_oil", { alp = 1, input = 1 }},
                   {"gfx_forge_oil", { alp = 1, active = 1 }},
                   {"spr_forge_oil", { res = "assets/levels/level1/rm_outsidechapel/zz_forge/oil" }},
                   {"spr_outsidechapel_forge_bottle_2", { alp = 1 }},
                   {"spr_outsidechapel_forge_valve", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_valve", use_valve_beg, private.room_objname );
  cmn.AddSubscriber( "use_valve", use_valve_inv );
  cmn.AddSubscriber( "use_valve", use_valve_end, private.room_objname );
  cmn.AddSubscriber( "use_valve_inv", use_valve_inv, private.room_objname );
  cmn.AddSubscriber( "use_valve_beg", use_valve_beg, private.room_objname );
  cmn.AddSubscriber( "use_valve_end", use_valve_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hammer () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_hammer" ] = {
        type = "use",
        inv_obj = "inv_hammer",
        use_place = "obj_forge_use_hammer",
        room = private.room_objname,
        zz = "zz_forge",
        zz_gate = "gzz_outsidechapel_forge"
    };
  --------------------------------------------------------------------------------------------
  local use_hammer_inv = function ()
  
    interface.InventoryItemRemove( "inv_hammer" );
  
  end;
  local use_hammer_beg = function ()
  
    ObjDelete( "obj_forge_use_hammer" );
  
  end;
  local use_hammer_end = function ()
  
    if cmn.IsEventDone("use_rod") then
      ObjMultiSet( { {"anm_forge_make_adjuster", { input = 1, alp = 1, frame = 400 }},
                     {"spr_outsidechapel_forge_adjuster", { alp = 1 }} } );
      ObjDelete( "anm_forge_rod" );
      ObjDelete( "anm_forge_hammer" );
      ObjDelete( "spr_outsidechapel_forge_rod" );
      ObjDelete( "spr_outsidechapel_forge_hammer" );
    else 
      ObjMultiSet( { {"anm_forge_hammer", { alp = 1, frame = 0, animfunc = "func_clk_hammer" }},
                     {"spr_outsidechapel_forge_hammer", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hammer", use_hammer_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammer", use_hammer_inv );
  cmn.AddSubscriber( "use_hammer", use_hammer_end, private.room_objname );
  cmn.AddSubscriber( "use_hammer_inv", use_hammer_inv, private.room_objname );
  cmn.AddSubscriber( "use_hammer_beg", use_hammer_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammer_end", use_hammer_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_rod () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_rod" ] = {
        type = "use",
        inv_obj = "inv_rod",
        use_place = "obj_forge_use_rod",
        room = private.room_objname,
        zz = "zz_forge",
        zz_gate = "gzz_outsidechapel_forge"
    };
  --------------------------------------------------------------------------------------------
  local use_rod_inv = function ()
  
    interface.InventoryItemRemove( "inv_rod" );
  
  end;
  local use_rod_beg = function ()
  
    ObjDelete( "obj_forge_use_rod" );
  
  end;
  local use_rod_end = function ()
  
    if cmn.IsEventDone("use_hammer") then
      ObjMultiSet( { {"anm_forge_make_adjuster", { input = 1, alp = 1, frame = 400 }},
                     {"spr_outsidechapel_forge_adjuster", { alp = 1 }} } );
      ObjDelete( "anm_forge_rod" );
      ObjDelete( "anm_forge_hammer" );
      ObjDelete( "spr_outsidechapel_forge_rod" );
      ObjDelete( "spr_outsidechapel_forge_hammer" );
    else 
      ObjMultiSet( { {"obj_forge_use_hammer", { alp = 1, input = 1 }},
                     {"anm_forge_rod", { alp = 1, frame = 0, animfunc = "func_clk_rod" }},
                     {"spr_outsidechapel_forge_rod", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_rod", use_rod_beg, private.room_objname );
  cmn.AddSubscriber( "use_rod", use_rod_inv );
  cmn.AddSubscriber( "use_rod", use_rod_end, private.room_objname );
  cmn.AddSubscriber( "use_rod_inv", use_rod_inv, private.room_objname );
  cmn.AddSubscriber( "use_rod_beg", use_rod_beg, private.room_objname );
  cmn.AddSubscriber( "use_rod_end", use_rod_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_scoop () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_scoopforge" ] = {
      type = "use",
      inv_obj = "inv_scoop",
      use_place = "obj_forge_use_scoop",
      room = private.room_objname,
      zz = "zz_forge",
      zz_gate = "gzz_outsidechapel_forge"
  };
  game.hint[ "use_scoopgarden" ] = {
      type = "use",
      inv_obj = "inv_scoop",
      use_place = "obj_gardenbed_use_scoop",
      room = "rm_cemetery",
      zz = "zz_gardenbed",
      zz_gate = "gzz_cemetery_gardenbed"
  };
  --------------------------------------------------------------------------------------------
  local use_scoop_inv1 = function ()
  
    if cmn.IsEventDone("use_scoopgarden") then
      interface.InventoryItemRemove( "inv_scoop" );
    end;
  
  end;
  local use_scoop_beg1 = function ()
  
    ObjDelete( "obj_forge_use_scoop" );
    ObjDelete( "anm_forge_coals_touch" );
  
  end;
  local use_scoop_end1 = function ()
  
    --ObjSet( "anm_forge_use_scoop", { frame = 300, alp = 1 } );
  
  end;
  
  local use_scoop_inv2 = function ()
  
    if cmn.IsEventDone("use_scoopforge") then
      interface.InventoryItemRemove( "inv_scoop" );
    end;
  
  end;
  local use_scoop_beg2 = function ()
  
    ObjDelete( "obj_gardenbed_use_scoop" );
    ObjDelete( "anm_gardenbed_ground_touch" );
  
  end;
  local use_scoop_end2 = function ()
    
    ObjDelete( "spr_cemetery_garden_hill" );
  
    ObjMultiSet( { {"anm_gardenbed_use_scoop", { input = 1, alp = 1, frame = 300 }},
                   {"spr_cemetery_garden_hole", { alp = 1 }},
                   {"spr_cemetery_garden_light", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scoopforge", use_scoop_beg1, private.room_objname );
  cmn.AddSubscriber( "use_scoopforge", use_scoop_inv1 );
  cmn.AddSubscriber( "use_scoopforge", use_scoop_end1, private.room_objname );
  cmn.AddSubscriber( "use_scoop_inv1", use_scoop_inv1, private.room_objname );
  cmn.AddSubscriber( "use_scoop_beg1", use_scoop_beg1, private.room_objname );
  cmn.AddSubscriber( "use_scoop_end1", use_scoop_end1, private.room_objname );
  
  cmn.AddSubscriber( "use_scoopgarden", use_scoop_inv2 );
  cmn.AddSubscriber( "use_scoop_inv2", use_scoop_inv2, "rm_cemetery" );
  cmn.AddSubscriber( "use_scoopgarden", use_scoop_beg2, "rm_cemetery" );
  cmn.AddSubscriber( "use_scoopgarden", use_scoop_end2, "rm_cemetery" );
  cmn.AddSubscriber( "use_scoop_beg2", use_scoop_beg2, "rm_cemetery" );
  cmn.AddSubscriber( "use_scoop_end2", use_scoop_end2, "rm_cemetery" );
  --------------------------------------------------------------------------------------------
  -- function use_gravediggerfigurine () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_gravediggerfigurine" ] = {
        type = "use",
        inv_obj = "inv_gravediggerfigurine",
        use_place = "obj_ivy_use_gravediggerfigurine",
        room = private.room_objname,
        zz = "zz_ivy",
        zz_gate = "gzz_outsidechapel_ivy"
    };
  --------------------------------------------------------------------------------------------
  local use_gravediggerfigurine_inv = function ()
  
    interface.InventoryItemRemove( "inv_gravediggerfigurine" );
  
  end;
  local use_gravediggerfigurine_beg = function ()
  
    ObjDelete( "obj_ivy_use_gravediggerfigurine" );
    ObjDelete( "anm_ivy_box_touch" );
  
  end;
  local use_gravediggerfigurine_end = function ()
  
    ObjMultiSet( { {"anm_ivy_use_figurine", { input = 1, alp = 1, frame = 300 }},
                   {"spr_outsidechapel_ivy_box_2", { alp = 1 }} } );
    
    ObjDelete( "anm_ivy_use_figurine_2" );
    ObjDelete( "spr_outsidechapel_ivy_box_1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gravediggerfigurine", use_gravediggerfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_gravediggerfigurine", use_gravediggerfigurine_inv );
  cmn.AddSubscriber( "use_gravediggerfigurine", use_gravediggerfigurine_end, private.room_objname );
  cmn.AddSubscriber( "use_gravediggerfigurine_inv", use_gravediggerfigurine_inv, private.room_objname );
  cmn.AddSubscriber( "use_gravediggerfigurine_beg", use_gravediggerfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_gravediggerfigurine_end", use_gravediggerfigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_scythe () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_scythe" ] = {
        type = "use",
        inv_obj = "inv_scythe",
        use_place = "obj_gates_use_scythe",
        room = private.room_objname,
        zz = "zz_gates",
        zz_gate = "gzz_outsidechapel_gates"
    };
  --------------------------------------------------------------------------------------------
  local use_scythe_inv = function ()
  
    interface.InventoryItemRemove( "inv_scythe" );
  
  end;
  local use_scythe_beg = function ()
  
    ObjDelete( "obj_gates_use_scythe" );
  
  end;
  local use_scythe_end = function ()
  
    ObjMultiSet( { { "obj_gates_scythe", { alp = 1 } },
                   { "obj_gates_game",   { alp = 1, input = true } },
                   { "spr_gates_back_2",   { alp = 1 } },
                   { "spr_outsidechapel_gates_scythe",   { alp = 1 } } } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scythe", use_scythe_beg, private.room_objname );
  cmn.AddSubscriber( "use_scythe", use_scythe_inv );
  cmn.AddSubscriber( "use_scythe", use_scythe_end, private.room_objname );
  cmn.AddSubscriber( "use_scythe_inv", use_scythe_inv, private.room_objname );
  cmn.AddSubscriber( "use_scythe_beg", use_scythe_beg, private.room_objname );
  cmn.AddSubscriber( "use_scythe_end", use_scythe_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ancientsign () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_ancientsign" ] = {
        type = "use",
        inv_obj = "inv_ancientsign",
        use_place = "obj_outsidechapel_use_ancientsign",
        room = private.room_objname
    };
  --------------------------------------------------------------------------------------------
  local use_ancientsign_inv = function ()
  
    interface.InventoryItemRemove( "inv_ancientsign" );
    interface_impl.SetCurrentGlobalTask( 3 );
  
  end;
  local use_ancientsign_beg = function ()
  
    ObjDelete( "obj_outsidechapel_use_ancientsign" );
  
  end;
  local use_ancientsign_end = function ()
    
    ObjDelete( "obj_outsidechapel_stephen" );
  
    ObjMultiSet( { {"anm_outsidechapel_gates_death", { alp = 1 }},
                   {"gzz_outsidechapel_gates", { alp = 1, input = 1, active = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ancientsign", use_ancientsign_beg, private.room_objname );
  cmn.AddSubscriber( "use_ancientsign", use_ancientsign_inv );
  cmn.AddSubscriber( "use_ancientsign", use_ancientsign_end, private.room_objname );
  cmn.AddSubscriber( "use_ancientsign_inv", use_ancientsign_inv, private.room_objname );
  cmn.AddSubscriber( "use_ancientsign_beg", use_ancientsign_beg, private.room_objname );
  cmn.AddSubscriber( "use_ancientsign_end", use_ancientsign_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_outsidechapelfirst () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_outsidechapelfirst" ] = {
    type = "click",
    use_place = "obj_outsidechapel_clk_outsidechapelfirst",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local clk_outsidechapelfirst = function ()
    
    ObjDelete("obj_outsidechapel_clk_outsidechapelfirst");
    ObjDelete("anm_outsidechapel_dialog_stephen1_hand_1");
    ObjDelete("anm_outsidechapel_dialog_stephen1_hand_give");
    ObjDelete("vid_outsidechapel_dialog_stephen1_lipsync1");
    ObjDelete("vid_outsidechapel_dialog_stephen1_lipsync2");
    ObjDelete("vid_outsidechapel_dialog_stephen1_lipsync3");
    
    ObjDelete("anm_outsidechapel_stephen_2");
    
    ObjAttach("obj_outsidechapel_dialog_stephen1", "rm_outsidechapel");
    
    ObjMultiSet( { { "obj_outsidechapel_use_ancientsign", { input = 1, alp = 1 } },
                   { "anm_outsidechapel_dialog_stephen1_head", { alp = 1 } },
                   { "obj_outsidechapel_dialog_stephen1", { input = 1, alp = 1 } },
                   { "obj_outsidechapel_dialog_stephen1_hand_2", { input = 1, alp = 1 } },
                   { "anm_outsidechapel_stephen", { alp = 1 } },
                   { "gzz_outsidechapel_gargoyle", { event_mdown = function() cmn.GotoSubRoomMDown( "outsidechapel_gargoyle" ); end, event_mup = function() cmn.GotoSubRoomMUp( "outsidechapel_gargoyle", "zz_gargoyle", false, true ); end } },
                   { "gzz_outsidechapel_fencegate", { event_mdown = function() cmn.GotoSubRoomMDown( "outsidechapel_fencegate" ); end, event_mup = function() cmn.GotoSubRoomMUp( "outsidechapel_fencegate", "zz_fencegate" ); end } },
                   { "gzz_outsidechapel_forge", { event_mdown = function() cmn.GotoSubRoomMDown( "outsidechapel_forge" ); end, event_mup = function() cmn.GotoSubRoomMUp( "outsidechapel_forge", "zz_forge" ); end } },
                   { "gzz_outsidechapel_ivy", { event_mdown = function() cmn.GotoSubRoomMDown( "outsidechapel_ivy" ); end, event_mup = function() cmn.GotoSubRoomMUp( "outsidechapel_ivy", "zz_ivy", false, true ); end } },
                   { "gzz_outsidechapel_gallows", { event_mdown = function() cmn.GotoSubRoomMDown( "outsidechapel_gallows" ); end, event_mup = function() cmn.GotoSubRoomMUp( "outsidechapel_gallows", "zz_gallows", false, true ); end } } } );
                   
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_outsidechapelfirst", clk_outsidechapelfirst, private.room_objname );


  --------------------------------------------------------------------------------------------
  -- function opn_outsidechapel () end;
  --------------------------------------------------------------------------------------------
  local opn_outsidechapel = function ()
  
    int_map_impl.BlockRoom( "rm_apartment" );
    int_map_impl.OpenRoom( "rm_outsidechapel" );
    interface_impl.SetCurrentGlobalTask( 2 );
    int_diary.SetVisibleHands( 2 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_outsidechapel", opn_outsidechapel );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_gallows" );
  subroom.Define( "zz_fencegate" );
  subroom.Define( "zz_gates" );
  subroom.Define( "zz_forge" );
  subroom.Define( "zz_ivy" );
  subroom.Define( "zz_gargoyle" );
  
  function zz_ivy.Close()
    
    cmn.HideNote( 0 );
    
  end;
  
  function zz_forge.PreOpen()
    
    cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_loop_fireplace_env");
    
  end;
  
  function zz_forge.PreClose()
    
    cmn.StopAllEnv("assets/levels/level1/audio/env/aud_outsidechapel_env");
    cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_outsidechapel_env");
    
  end;
  
  function zz_gallows.PreOpen()
    
    if not cmn.IsEventDone("use_smallwheel") or not cmn.IsEventDone("use_bigwheel") or not cmn.IsEventDone("use_chain") or not cmn.IsEventDone("use_adjuster") then
      cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_loop_skeleton_env");
    end;
    
    if not cmn.IsEventDone("win_gallows") then
      private.zz_gallows.DrawScene();
    end;
    
    if cmn.IsEventDone("use_smallwheel") and cmn.IsEventDone("use_bigwheel") and cmn.IsEventDone("use_chain") and cmn.IsEventDone("use_adjuster") then
      ObjSet("anm_gallows_mech_active",  { playing = 1 });
    end;

  end;
  
  function zz_gallows.PreClose()
    
    if not cmn.IsEventDone("use_smallwheel") or not cmn.IsEventDone("use_bigwheel") or not cmn.IsEventDone("use_chain") or not cmn.IsEventDone("use_adjuster") then
      cmn.StopAllEnv("assets/levels/level1/audio/env/aud_outsidechapel_env");
      cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_outsidechapel_env");
    end;
    
  end;
  
  function zz_gallows.Close()
    
    cmn.HideNote( 0 );
    
    for i = 1, 7, 1 do
      
      ObjStopAnimate("spr_gallows_sign_"..i, "pos_xy");
      ObjStopAnimate("spr_gallows_sign_"..i, "alp");
      ObjStopAnimate("spr_gallows_ancientsign_"..i, "alp");
      
    end;
    
    if cmn.IsEventDone("get_ancientsign") and not cmn.IsEventDone("opn_outsidechapelskeletonfall") then
      
      cmn.SetEventDone("opn_outsidechapelskeletonfall");
      
      local func_after = function ()
        cmn.Lock( 0 );
        cmn.CallEventHandler("get_ancientsign_end");
      end;
      
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_win_mmg_skeleton_loc");
      ObjSet("anm_outsidechapel_gallows_skeleton_4",  { playing = 1, endtrig = func_after });
      
    end;
    
  end;
  
  function zz_fencegate.PreOpen()
    
    if not(cmn.IsEventDone( "win_fencegate" )) then
      private.zz_fencegate.CheckInput();
    end;
    
    if cmn.IsEventDone( "use_deathfigurine" ) and not(cmn.IsEventDone( "win_fencegate" )) then
      private.zz_fencegate.DrawScene();
    end;

  end;
  
  function zz_fencegate.Open()
    
    if cmn.IsEventDone( "use_deathfigurine" ) and not(cmn.IsEventDone( "win_fencegate" )) then
      cmn.MiniGameShow();
      private.zz_fencegate.CheckWin();
    end;

  end;
  
  function zz_fencegate.PreClose()
    
    if cmn.IsEventDone("use_deathfigurine") and not cmn.IsEventDone("win_fencegate") then
      cmn.MiniGameHide("fencegate");
    end;
    
  end;
  
  function zz_gates.PreOpen()
    
    if cmn.IsEventDone( "use_scythe" ) and not cmn.IsEventDone( "win_gates" ) then
      cmn.MiniGameShow();
      private.zz_gates.CheckWin();
      private.zz_gates.DrawScene();
    end;

  end;
  
  function zz_gates.PreClose()
    
    if cmn.IsEventDone( "use_scythe" ) and not cmn.IsEventDone("win_gates") then
      cmn.MiniGameHide( "gates" );
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_gallows" ].found) then 
    private.zz_gallows.StartConditions();
  end;
  private.zz_gallows.found = ng_global.progress[ ng_global.currentprogress ][ "win_gallows" ].found;
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_fencegate" ].state) then 
    private.zz_fencegate.StartConditions();
  end;
  private.zz_fencegate.state = ng_global.progress[ ng_global.currentprogress ][ "win_fencegate" ].state;

  if not(ng_global.progress[ ng_global.currentprogress ][ "win_gates" ].state) then 
    private.zz_gates.StartConditions();
  end;
  private.zz_gates.state = ng_global.progress[ ng_global.currentprogress ][ "win_gates" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_outsidechapel();
  
  if cmn.IsEventDone("clk_outsidechapelfirst") and not cmn.IsEventDone("get_debugger") then
    --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    common_impl.current_dialog = "obj_outsidechapel_dialog_stephen1";
    ObjSet("anm_outsidechapel_dialog_stephen1_hand_2",  { playing = 1 });
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level1/audio/env/aud_outsidechapel_env");
  cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_outsidechapel_env");
  
end;
--*********************************************************************************************************************
function public.Close()
  
  cmn.HideNote( 0 );
  
end;
--*********************************************************************************************************************
function public.PreClose()
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_hammerhandle()

  local item = "inv_hammerhandle";

  if cmn.ApplyObj( item, "gzz_outsidechapel_gargoyle" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_gargoyle", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_gargoyle_use_hammerhandle" ) ) then

    cmn.CallEventHandler( "use_hammerhandle_inv" );
    cmn.CallEventHandler( "use_hammerhandle_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_hammerhandle" );
      cmn.CallEventHandler( "use_hammerhandle_end" );
      
      public.get_hammer();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_use_hammerhandle_outsidechapel");

    ObjSet("anm_gargoyle_use_handle",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_gargoylepart()

  local item = "inv_gargoylepart";

  if cmn.ApplyObj( item, "gzz_outsidechapel_gargoyle" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_gargoyle", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_gargoyle_use_gargoylepart" ) and cmn.CheckMultiObject( "gargoylepart", 3 ) ) then

    cmn.CallEventHandler( "use_gargoylepart_inv" );
    cmn.CallEventHandler( "use_gargoylepart_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_gargoylepart" );
      cmn.CallEventHandler( "use_gargoylepart_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_use_gargoylepart_outsidechapel");

    ObjMultiSet( { {"anm_gargoyle_use_parts",  { alp = 1, playing = 1, endtrig = func_after }},
                   {"obj_gargoyle_niche", { alp = 1 }} } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bluelight()

  local item = "inv_bluelight";

  if cmn.ApplyObj( item, "gzz_outsidechapel_gargoyle" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_gargoyle", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_gargoyle_use_bluelight" ) ) then

    cmn.CallEventHandler( "use_bluelight_inv" );
    cmn.CallEventHandler( "use_bluelight_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_bluelight" );
      cmn.CallEventHandler( "use_bluelight_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_monster_fireball");

    ObjSet("anm_gargoyle_use_light",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_smallwheel()

  local item = "inv_smallwheel";

  if cmn.ApplyObj( item, "gzz_outsidechapel_gallows" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_gallows", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_gallows_use_smallwheel" ) ) then

    cmn.CallEventHandler( "use_smallwheel_inv" );
    cmn.CallEventHandler( "use_smallwheel_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_smallwheel" );
      cmn.CallEventHandler( "use_smallwheel_end" );
      
      if cmn.IsEventDone("use_bigwheel") then
        cmn.SetEventDone("use_bothwheels");
      end;
    
    end;
    
    local anm_panel = function ()
      
      cmn.StopAllEnv("assets/levels/level1/audio/env/aud_outsidechapel_env");
      cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_outsidechapel_env");
      
      cmn.ShowBbt( "gallows_after_skeleton_down" );
      ObjAnimate("obj_gallows_hop_interface", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      
      ObjMultiSet( { {"anm_gallows_mech_active", { alp = 1, playing = 1 }},
                     {"anm_gallows_mech_active_1", { alp = 0 }},
                     {"anm_gallows_mech_touch", { alp = 1 }} } );
      
    end;
    
    local anm_mech = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_chain_works");
      
      ObjDelete("anm_gallows_skeleton");
      
      ObjMultiSet( { {"anm_gallows_mech_active_1",  { alp = 1, playing = 1, endtrig = anm_panel }},
                     {"anm_gallows_mech_touch", { alp = 0 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_mech_2");

    if cmn.IsEventDone("use_bigwheel") and cmn.IsEventDone("use_adjuster") and cmn.IsEventDone("use_chain") then
      ObjAnimate("spr_gallows_smallwheel_1", "alp", 0, 0, anm_mech, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1  });
      ObjAnimate("spr_gallows_smallwheel_2", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1  });
    else 
      ObjAnimate("spr_gallows_smallwheel_1", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("spr_gallows_smallwheel_2", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    end;
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bigwheel()

  local item = "inv_bigwheel";

  if cmn.ApplyObj( item, "gzz_outsidechapel_gallows" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_gallows", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_gallows_use_bigwheel" ) ) then

    cmn.CallEventHandler( "use_bigwheel_inv" );
    cmn.CallEventHandler( "use_bigwheel_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_bigwheel" );
      cmn.CallEventHandler( "use_bigwheel_end" );
      
      if cmn.IsEventDone("use_smallwheel") then
        cmn.SetEventDone("use_bothwheels");
      end;
    
    end;
    
    local anm_panel = function ()
      
      cmn.StopAllEnv("assets/levels/level1/audio/env/aud_outsidechapel_env");
      cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_outsidechapel_env");
      
      cmn.ShowBbt( "gallows_after_skeleton_down" );
      ObjAnimate("obj_gallows_hop_interface", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      
      ObjMultiSet( { {"anm_gallows_mech_active", { alp = 1, playing = 1 }},
                     {"anm_gallows_mech_active_1", { alp = 0 }},
                     {"anm_gallows_mech_touch", { alp = 1 }} } );
      
    end;
    
    local anm_mech = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_chain_works");
      
      ObjDelete("anm_gallows_skeleton");
      
      ObjMultiSet( { {"anm_gallows_mech_active_1",  { alp = 1, playing = 1, endtrig = anm_panel }},
                     {"anm_gallows_mech_touch", { alp = 0 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_mech_1");

    if cmn.IsEventDone("use_smallwheel") and cmn.IsEventDone("use_adjuster") and cmn.IsEventDone("use_chain") then
      ObjAnimate("spr_gallows_bigwheel_1", "alp", 0, 0, anm_mech, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1  });
      ObjAnimate("spr_gallows_bigwheel_2", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1  });
    else 
      ObjAnimate("spr_gallows_bigwheel_1", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("spr_gallows_bigwheel_2", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_chain()

  local item = "inv_chain";

  if cmn.ApplyObj( item, "gzz_outsidechapel_gallows" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_gallows", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_gallows_use_chain" ) and cmn.IsEventDone("use_smallwheel") and cmn.IsEventDone("use_bigwheel") ) then

    cmn.CallEventHandler( "use_chain_inv" );
    cmn.CallEventHandler( "use_chain_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_chain" );
      cmn.CallEventHandler( "use_chain_end" );
      
      if not( cmn.IsEventDone("use_smallwheel") and cmn.IsEventDone("use_adjuster") and cmn.IsEventDone("use_bigwheel") ) then
        ObjSet("anm_gallows_mech_touch",  { alp = 1 });
      end;
    
    end;
    
    local anm_panel = function ()
      
      cmn.StopAllEnv("assets/levels/level1/audio/env/aud_outsidechapel_env");
      cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_outsidechapel_env");
      
      cmn.ShowBbt( "gallows_after_skeleton_down" );
      ObjAnimate("obj_gallows_hop_interface", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      
      ObjMultiSet( { {"anm_gallows_mech_active", { alp = 1, playing = 1 }},
                     {"anm_gallows_mech_active_1", { alp = 0 }},
                     {"anm_gallows_mech_touch", { alp = 1 }} } );
      
    end;
    
    local anm_mech = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_chain_works");
      
      ObjDelete("anm_gallows_skeleton");
      
      ObjMultiSet( { {"anm_gallows_mech_active_1",  { alp = 1, playing = 1, endtrig = anm_panel }},
                     {"anm_gallows_mech_touch", { alp = 0 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_use_chain_outsidechapel");

    if cmn.IsEventDone("use_smallwheel") and cmn.IsEventDone("use_adjuster") and cmn.IsEventDone("use_bigwheel") then
      ObjMultiSet( { {"anm_gallows_mech_touch", { alp = 0 }},
                     {"anm_gallows_chain_use", { alp = 1, playing = 1, endtrig = anm_mech }} } );
    else 
      ObjMultiSet( { {"anm_gallows_mech_touch", { alp = 0 }},
                     {"anm_gallows_chain_use", { alp = 1, playing = 1, endtrig = func_after }} } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_adjuster()

  local item = "inv_adjuster";

  if cmn.ApplyObj( item, "gzz_outsidechapel_gallows" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_gallows", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_gallows_use_adjuster" ) ) then

    cmn.CallEventHandler( "use_adjuster_inv" );
    cmn.CallEventHandler( "use_adjuster_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_adjuster" );
      cmn.CallEventHandler( "use_adjuster_end" );
    
    end;
    
    local anm_panel = function ()
      
      cmn.StopAllEnv("assets/levels/level1/audio/env/aud_outsidechapel_env");
      cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_outsidechapel_env");
      
      cmn.ShowBbt( "gallows_after_skeleton_down" );
      ObjAnimate("obj_gallows_hop_interface", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      
      ObjMultiSet( { {"anm_gallows_mech_active", { alp = 1, playing = 1 }},
                     {"anm_gallows_mech_active_1", { alp = 0 }},
                     {"anm_gallows_mech_touch", { alp = 1 }} } );
      
    end;
    
    local anm_mech = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_chain_works");
      
      ObjDelete("anm_gallows_skeleton");
      
      ObjMultiSet( { {"anm_gallows_mech_active_1",  { alp = 1, playing = 1, endtrig = anm_panel }},
                     {"anm_gallows_mech_touch", { alp = 0 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_use_adjuster_outsidechapel");

    if cmn.IsEventDone("use_smallwheel") and cmn.IsEventDone("use_chain") and cmn.IsEventDone("use_bigwheel") then
      ObjAnimate("spr_gallows_handle", "alp", 0, 0, anm_mech, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1  });
      ObjAnimate("spr_gallows_handle_sh", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1  });
    else 
      ObjAnimate("spr_gallows_handle", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("spr_gallows_handle_sh", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_sharpdagger()

  local item = "inv_sharpdagger";

  if cmn.ApplyObj( item, "gzz_outsidechapel_fencegate" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_fencegate" );

  elseif ( cmn.ApplyObj( item, "obj_fencegate_use_sharpdagger" ) ) then

    cmn.CallEventHandler( "use_sharpdagger_inv1" );
    cmn.CallEventHandler( "use_sharpdagger_beg1" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_sharpdaggerfence" );
      cmn.CallEventHandler( "use_sharpdagger_end1" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_cut_leaves_by_dagger");
    
    if not cmn.IsEventDone("get_valve") then
      cmn.SetEventDone( "get_valve" );
      cmn.CallEventHandler( "get_valve" );
    end;

    ObjSet("amm_fencegate_use_dagger",  { alp = 1, playing = 1, endtrig = func_after });
  
  elseif cmn.ApplyObj( item, "gzz_outsidechapel_ivy" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_ivy", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_ivy_use_sharpdagger" ) ) then

    cmn.CallEventHandler( "use_sharpdagger_inv2" );
    cmn.CallEventHandler( "use_sharpdagger_beg2" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_sharpdaggerivy" );
      cmn.CallEventHandler( "use_sharpdagger_end2" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_use_dagger_1");

    ObjSet("anm_ivy_use_dagger",  { alp = 1, playing = 1, endtrig = func_after });
    ObjAnimate("obj_ivy_under_ivy", "alp", 0, 0, "", { 0, 0, 0,   1.3, 0, 0,    1.7, 0, 1 });
  
  elseif cmn.ApplyObj( item, "gzz_cemetery_scarecrow" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_scarecrow" );

  elseif ( cmn.ApplyObj( item, "obj_scarecrow_use_sharpdagger" ) ) then
    
    if not cmn.IsEventDone("get_hook") or not cmn.IsEventDone("get_paw1") then
      
      --cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_get_inv_sfx" );
      
      if not cmn.IsEventDone("get_hook") then
        ObjSet("spr_scarecrow_hook_fly",  { alp = 1 });
        cmn.SetEventDone( "get_hook" );
        cmn.CallEventHandler( "get_hook" );
      end;
      
      if not cmn.IsEventDone("get_paw1") then
        ObjSet("spr_scarecrow_paw1_fly",  { alp = 1 });
        cmn.SetEventDone( "get_paw1" );
        cmn.CallEventHandler( "get_paw1" );
      end;
      
    end;

    cmn.CallEventHandler( "use_sharpdagger_inv3" );
    cmn.CallEventHandler( "use_sharpdagger_beg3" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_sharpdaggerscarecrow" );
      cmn.SetEventDone( "get_rope" );
      cmn.CallEventHandler( "use_sharpdagger_end3" );
      
      cmn.ShowBbt( "scarecrow_after_jumpscare" );
      
    end;
    
    local jumpscare = function ()
      
      --DbgTrace("jumpscare")
      
      local func_hide = function ()
        ObjSet("anm_scarecrow_scarecrow_2",  { alp = 1 });
        ObjAnimate("vid_scarecrow_jumpscare", "alp", 0, 0, func_after, { 0, 0, 1,   0.3, 0, 0 });
      end;
      
      local func_play = function ()
        ObjDelete("anm_scarecrow_scarecrow");
        VidPlay("vid_scarecrow_jumpscare", func_hide);
      end;
      
      cmn.CallEventHandler( "get_rope" );
      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
      
      ObjAttach("vid_scarecrow_jumpscare", "zz_scarecrow");
      ObjAnimate("vid_scarecrow_jumpscare", "alp", 0, 0, func_play, { 0, 0, 0,   0.3, 0, 1 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_cut_rope_and_head_burn");
    
    ObjAttach("anm_scarecrow_rope_cut", "obj_scarecrow_rope_in");
    ObjSet("anm_scarecrow_rope_cut",  { alp = 1, playing = 1, endtrig = jumpscare });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_file()

  local item = "inv_file";

  if cmn.ApplyObj( item, "gzz_outsidechapel_fencegate" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_fencegate" );

  elseif ( cmn.ApplyObj( item, "obj_fencegate_use_file" ) and cmn.IsEventDone("use_sharpdaggerfence") ) then

    cmn.CallEventHandler( "use_file_inv" );
    cmn.CallEventHandler( "use_file_beg" );
    
    local func_after = function ()

      cmn.Lock( 0 );

      cmn.CallEventHandler( "use_file_end" );
      
    end;

    local anm_game = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_game_death_appears");

      cmn.SetEventDone( "use_file" );
      public.get_chain();
      
      ObjSet("anm_fencegate_panel_open",  { playing = 1, endtrig = func_after });
    
    end;
    
    if not cmn.IsEventDone("get_smallwheel") then
      cmn.SetEventDone( "get_smallwheel" );
      cmn.CallEventHandler( "get_smallwheel" );
      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_destroy_chain");
    
    ObjSet("amm_fencegate_use_file",  { alp = 1, playing = 1, endtrig = anm_game });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_deathfigurine()

  local item = "inv_deathfigurine";

  if cmn.ApplyObj( item, "gzz_outsidechapel_fencegate" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_fencegate" );

  elseif ( cmn.ApplyObj( item, "obj_fencegate_use_deathfigurine" ) and cmn.IsEventDone("use_file") ) then

    cmn.CallEventHandler( "use_deathfigurine_inv" );
    cmn.CallEventHandler( "use_deathfigurine_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_deathfigurine" );
      cmn.CallEventHandler( "use_deathfigurine_end" );
      
      cmn.MiniGameShow();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_death_insert_obgect");

    ObjAnimate("spr_fencegate_death_3", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_valve()

  local item = "inv_valve";

  if cmn.ApplyObj( item, "gzz_outsidechapel_forge" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_forge" );

  elseif ( cmn.ApplyObj( item, "obj_forge_use_valve" ) ) then

    cmn.CallEventHandler( "use_valve_inv" );
    cmn.CallEventHandler( "use_valve_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_valve" );
      cmn.CallEventHandler( "use_valve_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_barrel");

    ObjMultiSet( { {"anm_forge_use_valve", { alp = 1, playing = 1, endtrig = func_after }},
                   {"obj_forge_oil", { alp = 0 }} } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_hammer()

  local item = "inv_hammer";

  if cmn.ApplyObj( item, "gzz_outsidechapel_forge" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_forge" );

  elseif ( cmn.ApplyObj( item, "obj_forge_use_hammer" ) ) then

    cmn.CallEventHandler( "use_hammer_inv" );
    cmn.CallEventHandler( "use_hammer_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_hammer" );
      cmn.CallEventHandler( "use_hammer_end" );
    
    end;
    
    local anm_anvil = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_make_thing_for_mechanism");
      
      ObjMultiSet( { {"anm_forge_make_adjuster", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_forge_hammer", { alp = 0 }},
                     {"anm_forge_rod", { alp = 0 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_put_hammer_forge");

    if cmn.IsEventDone("use_rod") then
      ObjSet("anm_forge_hammer",  { alp = 1, playing = 1, endtrig = anm_anvil });
    else 
      ObjSet("anm_forge_hammer",  { alp = 1, playing = 1, endtrig = func_after });
    end;
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_rod()

  local item = "inv_rod";

  if cmn.ApplyObj( item, "gzz_outsidechapel_forge" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_forge" );

  elseif ( cmn.ApplyObj( item, "obj_forge_use_rod" ) ) then

    cmn.CallEventHandler( "use_rod_inv" );
    cmn.CallEventHandler( "use_rod_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_rod" );
      cmn.CallEventHandler( "use_rod_end" );
    
    end;
    
    local anm_anvil = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_make_thing_for_mechanism");
      
      ObjMultiSet( { {"anm_forge_make_adjuster", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_forge_rod", { alp = 0 }},
                     {"anm_forge_hammer", { alp = 0 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_put_in_forge");

    if cmn.IsEventDone("use_hammer") then
      ObjSet("anm_forge_rod",  { alp = 1, playing = 1, endtrig = anm_anvil });
    else 
      ObjSet("anm_forge_rod",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_scoop()

  local item = "inv_scoop";

  if cmn.ApplyObj( item, "gzz_outsidechapel_forge" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_forge" );

  elseif ( cmn.ApplyObj( item, "obj_forge_use_scoop" ) ) then

    cmn.CallEventHandler( "use_scoop_inv1" );
    cmn.CallEventHandler( "use_scoop_beg1" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_scoopforge" );
      cmn.CallEventHandler( "use_scoop_end1" );
      
      public.get_scoopwithcoals();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_take_coal_shovel");

    ObjSet("anm_forge_use_scoop",  { alp = 1, playing = 1, endtrig = func_after });
  
  elseif cmn.ApplyObj( item, "gzz_cemetery_gardenbed" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_gardenbed" );

  elseif ( cmn.ApplyObj( item, "obj_gardenbed_use_scoop" ) ) then

    cmn.CallEventHandler( "use_scoop_inv2" );
    cmn.CallEventHandler( "use_scoop_beg2" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_scoopgarden" );
      cmn.CallEventHandler( "use_scoop_end2" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_take_ground");

    ObjSet("anm_gardenbed_use_scoop",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_gravediggerfigurine()

  local item = "inv_gravediggerfigurine";

  if cmn.ApplyObj( item, "gzz_outsidechapel_ivy" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_ivy", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_ivy_use_gravediggerfigurine" ) ) then

    cmn.CallEventHandler( "use_gravediggerfigurine_inv" );
    cmn.CallEventHandler( "use_gravediggerfigurine_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_gravediggerfigurine" );
      cmn.CallEventHandler( "use_gravediggerfigurine_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_figure_man_box");

    ObjMultiSet( { {"anm_ivy_use_figurine",  { alp = 1, playing = 1, endtrig = func_after }},
                   {"anm_ivy_use_figurine_2",  { alp = 1, playing = 1 }} } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_scythe()

  local item = "inv_scythe";

  if cmn.ApplyObj( item, "gzz_outsidechapel_gates" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_gates", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_gates_use_scythe" ) ) then

    cmn.CallEventHandler( "use_scythe_inv" );
    cmn.CallEventHandler( "use_scythe_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_scythe" );
      cmn.CallEventHandler( "use_scythe_end" );
      
      ObjSet("obj_gates_back",  { pos_x = 0, pos_y = 0, scale_x = 1, scale_y = 1 });
      
      cmn.MiniGameShow();
    
    end;
    
    local func_game = function ()
      
      ObjAnimate( "obj_gates_game", "alp", 0, 0, func_after, { 0, 0, 0,    0.5, 0, 1 } );
      ObjAnimate( "spr_gates_back_2", "alp", 0, 0, "", { 0, 0, 0,    0.5, 0, 1 } );
      
    end;
    
    local anm_zoom = function ()
      
      ObjAnimate( "obj_gates_back", "scale_xy", 0, 0, func_game, { 0, 0, 1, 1,    0.8, 0, 1.5, 1.5 } );
      ObjAnimate( "obj_gates_back", "pos_xy", 0, 0, "", { 0, 0, 0, 0,    0.8, 0, -34, 84 } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_scythe");

    ObjAnimate("obj_gates_scythe", "alp", 0, 0, anm_zoom, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_ancientsign()

  local item = "inv_ancientsign";

  if ( cmn.ApplyObj( item, "obj_outsidechapel_use_ancientsign" ) ) then

    cmn.CallEventHandler( "use_ancientsign_inv" );
    cmn.CallEventHandler( "use_ancientsign_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_ancientsign" );
      cmn.CallEventHandler( "use_ancientsign_end" );
      
      cmn.ShowBbt( "outsidechapel_after_kidnapping" );
      int_diary.AddDiarypage( 7 );
      
      interface_impl.ShowGlobalTask();
      cmn.PlayAudio("mus", "assets/levels/common/audio/aud_danger_low_mus", 0, false, 96);
    
    end;

    cmn.PlayFullscreenVideo( "assets/levels/level1/rm_outsidechapel/vid_kidnapping", func_after, "assets/levels/level1/audio/mus/aud_outsidechapel_kidnapping_vid", "assets/levels/level1/audio/voc/aud_stephen_kidnapping_1");

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_hammer()

  cmn.SetEventDone( "get_hammer" );
  cmn.CallEventHandler( "get_hammer" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_rod()

  cmn.SetEventDone( "get_rod" );
  cmn.CallEventHandler( "get_rod" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_seedsskull()

  cmn.SetEventDone( "get_seedsskull" );
  cmn.CallEventHandler( "get_seedsskull" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_thread()

  cmn.SetEventDone( "get_thread" );
  cmn.CallEventHandler( "get_thread" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_tin()

  cmn.SetEventDone( "get_tin" );
  cmn.CallEventHandler( "get_tin" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_ancientsign()
  
  local func_after = function ()
    
    common.CloseSubRoom();
    --cmn.Lock( 0 );
    ObjSet("anm_outsidechapel_gallows_skeleton_4",  { alp = 1 });
    
    ObjAnimate("anm_gallows_skeleton_fall", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    
  end;
  
  ObjMultiSet( { {"spr_gallows_ancientsign",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 }},
                 {"obj_gallows_ancientsign_parts", { pos_x = 6, pos_y = 4 }} } );

  cmn.SetEventDone( "get_ancientsign" );
  cmn.CallEventHandler( "get_ancientsign_inv" );
  cmn.CallEventHandler( "get_ancientsign_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_win_mmg_skeleton_zz");
  
  ObjMultiSet( { {"anm_gallows_skeleton_fall", { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_gallows_mech_active", { alp = 0 }} } );

end;
--------------------------------------------------------------------------------------------
function public.get_dagger()

  cmn.SetEventDone( "get_dagger" );
  cmn.CallEventHandler( "get_dagger" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  ObjAttach("tmr_outsidechapel_tutor_timer", "cmn_timers");
  ObjSet("tmr_outsidechapel_tutor_timer",  { time = 0.8, playing = 1, endtrig = private.ShowTutor8 });
  
end;
--------------------------------------------------------------------------------------------
function public.get_smallwheel()

  cmn.SetEventDone( "get_smallwheel" );
  cmn.CallEventHandler( "get_smallwheel" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_chain()
  
  ObjSet("spr_fencegate_chain",  { alp = 1 });

  cmn.SetEventDone( "get_chain" );
  cmn.CallEventHandler( "get_chain" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_valve()

  cmn.SetEventDone( "get_valve" );
  cmn.CallEventHandler( "get_valve" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_adjuster()
  
  ObjSet("spr_forge_adjuster_fly",  { alp = 1 });
  
  cmn.SetEventDone( "get_adjuster" );
  cmn.CallEventHandler( "get_adjuster" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_oil()

  cmn.SetEventDone( "get_oil" );
  cmn.CallEventHandler( "get_oil" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_bottlewithresin()
  
  cmn.SetEventDone( "get_bottlewithresin" );
  cmn.CallEventHandler( "get_bottlewithresin" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_scoopwithcoals()
  
  ObjSet("spr_forge_scoopwithcoals",  { alp = 1 });

  cmn.SetEventDone( "get_scoopwithcoals" );
  cmn.CallEventHandler( "get_scoopwithcoals" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_bigwheel()

  cmn.SetEventDone( "get_bigwheel" );
  cmn.CallEventHandler( "get_bigwheel" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_scoop()

  cmn.SetEventDone( "get_scoop" );
  cmn.CallEventHandler( "get_scoop" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_stainedglassshard2") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_file()

  cmn.SetEventDone( "get_file" );
  cmn.CallEventHandler( "get_file" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_hammerhandle()

  cmn.SetEventDone( "get_hammerhandle" );
  cmn.CallEventHandler( "get_hammerhandle" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_stainedglassshard2()

  cmn.SetEventDone( "get_stainedglassshard2" );
  cmn.CallEventHandler( "get_stainedglassshard2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_scoop") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_stephensbag()

  cmn.SetEventDone( "get_stephensbag" );
  cmn.CallEventHandler( "get_stephensbag" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
end;
--------------------------------------------------------------------------------------------
function public.get_debugger()
  
  local pos = GetObjPosByObj( "spr_outsidechapel_map" );
  ObjSet( "spr_outsidechapel_map", { pos_x = pos[1] + 171, pos_y = pos[2] } );

  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_debugger_end" );
    
    --common_impl.PlayBackgroundMusic();
    cmn.ShowBbt( "outsidechapel_after_dialog" );

  end;

  cmn.SetEventDone( "get_debugger" );
  --cmn.CallEventHandler( "get_debugger_inv" );
  cmn.CallEventHandler( "get_debugger_mid" );
  
  int_button_map_impl.MapActivate( "spr_outsidechapel_map", function() cmn.CallEventHandler( "get_debugger_inv" ); end );
  
  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.current_dialog = "";
  
  cmn.Lock(1);
  ObjAnimate("obj_outsidechapel_dialog_stephen1", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.5, 0, 0 });

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function public.clk_outsidechapelfirst()
  
  cmn.SetEventDone("clk_outsidechapelfirst");
  cmn.Lock( 1 );
  
  --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
  
  ObjAttach("obj_outsidechapel_dialog_stephen1", "rm_outsidechapel");
  ObjAnimate("obj_outsidechapel_dialog_stephen1", "alp", 0, 0, private.dialog_stephen1_beg, { 0, 0, 0,   0.5, 0, 1 });
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_outsidechapel()

  if not ( cmn.IsEventDone( "opn_outsidechapel" ) ) then
    
    cmn.SetEventDone( "opn_outsidechapel" );
    cmn.CallEventHandler("opn_outsidechapel");
    
    cmn.ShowBbt( "outsidechapel_open" );
    interface_impl.ShowGlobalTask();
    
    local play_next_mus = function ()
      cmn.PlayAudio("mus", "assets/levels/level1/audio/mus/aud_first_appear_mus", 0, false, 76);
    end;
    
    cmn.PlayAudio("mus", "assets/levels/level1/audio/mus/aud_scare_begin_mus", 0, false, 113);
    ObjSet("tmr_common_music_back",  { time = 113, playing = 1, endtrig = play_next_mus });
    
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_gallows( num )
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_big_mech");
  
  cmn.ShowBbt( "obj_gallows_use_mechanismparts" );
  
  ObjSet("anm_gallows_mech_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_fence_ivy()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_leaves");
  
  cmn.ShowBbt( "obj_fencegate_use_sharpdagger" );
  
  ObjSet("amm_fencegate_touch_ivy",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_fence_chain()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_chain_1");
  
  cmn.ShowBbt( "obj_fencegate_use_file" );
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    ObjMultiSet( { {"amm_fencegate_touch_chain",  { alp = 0 }},
                   {"obj_fencegate_chain_1", { alp = 1 }} } );
    
  end;
  
  ObjMultiSet( { {"amm_fencegate_touch_chain",  { alp = 1, playing = 1, endtrig = func_after }},
                 {"obj_fencegate_chain_1", { alp = 0 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.gargoyle_door_touch()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_under_monster");
  
  cmn.ShowBbt( "obj_gargoyle_door_touch" );
  
  ObjSet("anm_gargoyle_door_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.gargoyle_parts_touch()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_monster_arm");
  
  cmn.ShowBbt( "obj_gargoyle_use_gargoylepart" );
  
  ObjSet("anm_gargoyle_parts_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.gargoyle_hammer_touch()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_hammer_in_monster");
  
  cmn.ShowBbt( "obj_gargoyle_use_hammerhandle" );
  
  ObjSet("anm_gargoyle_hammer_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.gates_touch()
  
  local func_after = function ()
    
    cmn.Lock(0);
    ObjSet("anm_gates_door",  { animfunc = "func_death_bckg", frame = 0, playing = 1, endtrig = "" });
    
  end;
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_skeleton_in_robe");
  
  cmn.ShowBbt( "obj_gates_use_scythe" );
  
  ObjSet("anm_gates_door",  { animfunc = "func_death_clk", frame = 0, playing = 1, endtrig = func_after });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_forge_coals()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_coal");
  
  cmn.ShowBbt( "obj_forge_use_scoop" );
  
  ObjSet("anm_forge_coals_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_forge_bottle()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_bottle_with_black_liquid");
  
  cmn.ShowBbt( "obj_forge_use_pigfigurine" );
  
  ObjSet("anm_forge_resin_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_forge_oil()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_barrel");
  
  cmn.ShowBbt( "obj_forge_use_valve" );
  
  ObjSet("anm_forge_oil_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_forge_anvil()
  
  if not cmn.IsEventDone("use_rod") then
    cmn.ShowBbt( "obj_forge_use_rod" );
  else 
    cmn.ShowBbt( "obj_forge_use_hammer" );
  end;
  
  if cmn.IsEventDone("use_rod") then
  
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_iron_forge");
    
    ObjSet("anm_forge_rod",  { playing = 1, endtrig = function() cmn.Lock(0); end });
      
  elseif cmn.IsEventDone("use_hammer") then
  
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_hammer_forge");
    
    ObjSet("anm_forge_hammer",  { playing = 1, endtrig = function() cmn.Lock(0); end });
      
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_ivy_bush()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_ivy_use_sharpdagger" );
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    ObjMultiSet( { {"anm_ivy_bush_touch", { alp = 0 }},
                   {"anm_ivy_bush", { alp = 1, playing = 1 }} } );
    
  end;
  
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_leaves_zz_ivy");
  
  ObjMultiSet( { {"anm_ivy_bush_touch", { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_ivy_bush", { alp = 0, playing = 0 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_ivy_box()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_box_zz_ivy");
  
  cmn.ShowBbt( "obj_ivy_use_gravediggerfigurine" );
  
  if not cmn.IsEventDone("get_file") or not cmn.IsEventDone("get_bigwheel") then
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
    
    if not cmn.IsEventDone("get_file") then
      cmn.SetEventDone( "get_file" );
      cmn.CallEventHandler( "get_file" );
    end;
    
    if not cmn.IsEventDone("get_bigwheel") then
      cmn.SetEventDone( "get_bigwheel" );
      cmn.CallEventHandler( "get_bigwheel" );
    end;
    
  end;
  
  ObjSet("anm_ivy_box_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function private.ShowTutor8()

  ObjAttach("tmr_outsidechapel_tutor_timer", "rm_outsidechapel");

  if not( cmn.IsEventDone( "tutor_8" )) and (ObjGet("hub_int_inventory_dagger")) then

    interface.InventoryAutoHideSave();

    if int_inventory.GetAutohide() then
      int_inventory.SetAutohide(false);
      int_inventory.Show( true );
    end;
    
    local dagger_pos = GetObjPosByObj("hub_int_inventory_dagger");
    local px = 0;

    if ObjGet("hub_int_inventory_dagger") then
      px = math.floor(dagger_pos[1]);
    end;
      
    ObjMultiSet( { {"obj_tutorial_tutor_8", { pos_x = -px }},
                   {"obj_tutorial_tutor_8_1", { pos_x = px }} } );

    local arrows = { { pos_x = 0, pos_y = 160, ang = 3.14 } };
    cmn.TutorialShow( "tutor_8", 0, px, 450, arrows );

  end;

end;
--------------------------------------------------------------------------------------------
function private.dialog_stephen1_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "outsidechapel", "stephen1", 2 );
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "clk_outsidechapelfirst" );
    int_diary.AddDiarypage( 6 );
    
    ObjSet("anm_outsidechapel_dialog_stephen1_hand_2",  { playing = 1 });
    
  end;
  
  local anm_give = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_outsidechapel_dialog_stephen1_lipsync3");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_outsidechapel_dialog_stephen1_timer",  { playing = 0 }},
                   {"anm_outsidechapel_dialog_stephen1_head", { alp = 1 }},
                   {"anm_outsidechapel_dialog_stephen1_hand_1", { alp = 0, playing = 0 }},
                   {"anm_outsidechapel_dialog_stephen1_hand_give", { alp = 1, playing = 1, endtrig = dialog_end }} } );
    
  end;
  
  local stephen_talks3 = function ()
  
    ObjDelete("vid_outsidechapel_dialog_stephen1_lipsync2");
    ObjAttach("vid_outsidechapel_dialog_stephen1_lipsync3", "obj_outsidechapel_dialog_stephen1");
  
    cmn.ShowDlgBbt( "dlg_stephen1_phrase_3" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level1/audio/voc/aud_1_lvl_stephen_4_voc");
    private.dlg_lipsync = "vid_outsidechapel_dialog_stephen1_lipsync3";
    
    ObjMultiSet( { {"tmr_outsidechapel_dialog_stephen1_timer", { endtrig = anm_give, time = 3, playing = 1 }},
                   {"vid_outsidechapel_dialog_stephen1_lipsync3", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_give }},
                   {"obj_character_dialog_continue", { event_mup = anm_give }} } );
  
  end;
  
  local stephen_talks2 = function ()
  
    ObjDelete("vid_outsidechapel_dialog_stephen1_lipsync1");
    ObjAttach("vid_outsidechapel_dialog_stephen1_lipsync2", "obj_outsidechapel_dialog_stephen1");
  
    cmn.ShowDlgBbt( "dlg_stephen1_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level1/audio/voc/aud_1_lvl_stephen_3_voc");
    private.dlg_lipsync = "vid_outsidechapel_dialog_stephen1_lipsync2";
    
    ObjMultiSet( { {"tmr_outsidechapel_dialog_stephen1_timer", { endtrig = stephen_talks3, time = 8, playing = 1 }},
                   {"vid_outsidechapel_dialog_stephen1_lipsync2", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = stephen_talks3 }},
                   {"obj_character_dialog_continue", { event_mup = stephen_talks3 }} } );
  
  end;

  private.dlg_lipsync = "vid_outsidechapel_dialog_stephen1_lipsync1";

  cmn.ShowDlgBbt( "dlg_stephen1_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level1/audio/voc/aud_1_lvl_stephen_2_voc");

  ObjMultiSet( { {"tmr_outsidechapel_dialog_stephen1_timer", { time = 5, playing = 1, endtrig = stephen_talks2 }},
                 {"vid_outsidechapel_dialog_stephen1_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = stephen_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = stephen_talks2 }} } );
  
end; 
--------------------------------------------------------------------------------------------
function public.skip_dlg_stephen1()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);

  local func_after_dlg = function ()

    cmn.Lock(0);
    
    cmn.CallEventHandler( "clk_outsidechapelfirst" );
    int_diary.AddDiarypage( 6 );
    
    ObjSet("anm_outsidechapel_dialog_stephen1_hand_2",  { playing = 1 });
    
  end;

  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();

  ObjMultiSet( { {"tmr_outsidechapel_dialog_stephen1_timer",  { playing = 0 }},
                 {"anm_outsidechapel_dialog_stephen1_head", { alp = 1 }},
                 {"anm_outsidechapel_dialog_stephen1_hand_1", { alp = 0, playing = 0 }},
                 {"anm_outsidechapel_dialog_stephen1_hand_give", { alp = 1, playing = 1, endtrig = func_after_dlg }} } );
  
end;  
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MHO_Gallows *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_gallows = {};
public.zz_gallows = {};

function private.Init_Gallows()
  
  -----------------------------------------------------------------------------------
  game.hint[ "win_gallows" ] = {
    type = "click",
    use_place = "spr_gallows_sign_1",
    room = "rm_outsidechapel",
    zz = "zz_gallows",
    zz_gate = "gzz_outsidechapel_gallows"
  };
  -----------------------------------------------------------------------------------
  local win_gallows = function ()

    if cmn.IsEventDone( "win_gallows" ) then
      
      ObjDelete( "obj_gallows_hop_interface" );
      ObjDelete( "obj_gallows_amulet_fly" );
      
      ObjDelete( "spr_outsidechapel_gallows_skeleton_2" );
      
      for i = 1, 7, 1 do
        ObjDelete("spr_gallows_sign_"..i);
        ObjSet("spr_gallows_ancientsign_"..i,  { alp = 1 });
      end;
      
      ObjMultiSet( { {"spr_gallows_ancientsign", { input = 1 }},
                     {"gfx_gallows_ancientsign", { alp = 1, active = 1 }},
                     {"spr_outsidechapel_gallows_skeleton_3", { alp = 1 }} } );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_gallows", win_gallows, "rm_outsidechapel" );
  
end;
--*********************************************************************************************************************
function private.zz_gallows.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_gallows" ].found = { 0, 0, 0, 0, 0, 0, 0 }; 
  
end;
-----------------------------------------------------------------------------------
function public.zz_gallows.FoundPart( num )
  
  private.zz_gallows.found[num] = 1;
  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_mmg1_click_1");
  
  ObjSet("txt_gallows_hop_text",  { text = "x "..private.zz_gallows.CheckCount() });
  private.zz_gallows.CheckHint();
  
  local pos = GetObjPosByObj("spr_gallows_sign_"..num, "zz_gallows");
  
  if private.zz_gallows.CheckWin() then
    cmn.Lock( 1 );
    ObjSet("tmr_gallows_timer",  { time = 0.7, playing = 1, endtrig = private.zz_gallows.Win });
  end;
  
  ObjAttach("spr_gallows_sign_"..num, "obj_gallows_amulet_fly");
  ObjSet("spr_gallows_sign_"..num,  { pos_x = pos[1], input = pos[2] });
  
  ObjAnimate("spr_gallows_sign_"..num, "pos_xy", 0, 0, function() private.zz_gallows.FlyEnd( num ); end, { 0, 0, pos[1], pos[2],   0.4, 0, 29, -48 });
  
end;
-----------------------------------------------------------------------------------
function private.zz_gallows.CheckHint()
  
  local vacant = 1;
  
  for i = 1, 7, 1 do
    
    if private.zz_gallows.found[i] == 0 then
      vacant = i;
      break;
    end;
    
  end;
  
  game.hint[ "win_gallows" ].use_place = "spr_gallows_sign_"..vacant;
  
end;
-----------------------------------------------------------------------------------
function private.zz_gallows.CheckCount()
  
  local count = 0;
  
  for i = 1, 7, 1 do
    
    if private.zz_gallows.found[i] == 0 then
      count = count + 1;
    end;
    
  end;
  
  return count;
  
end;
-----------------------------------------------------------------------------------
function private.zz_gallows.FlyEnd( num )
  
  ObjAnimate("spr_gallows_sign_"..num, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  ObjAnimate("spr_gallows_ancientsign_"..num, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
  
end;
-----------------------------------------------------------------------------------
function private.zz_gallows.DrawScene()
  
  for i = 1, 7, 1 do
    
    if private.zz_gallows.found[i] == 0 then
      ObjMultiSet( { {"spr_gallows_sign_"..i, { alp = 1, input = 1 }},
                     {"spr_gallows_ancientsign_"..i, { alp = 0 }} } );
    else 
      ObjMultiSet( { {"spr_gallows_sign_"..i, { alp = 0, input = 0 }},
                     {"spr_gallows_ancientsign_"..i, { alp = 1 }} } );              
    end;
    
  end;
                 
  if not cmn.IsEventDone("win_gallows") then
    private.zz_gallows.CheckHint();
    ObjSet("txt_gallows_hop_text",  { text = "x "..private.zz_gallows.CheckCount() });
  end;
                 
  if not cmn.IsEventDone("win_gallows") and private.zz_gallows.CheckWin() then
    cmn.Lock( 1 );
    private.zz_gallows.Win();
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_gallows.CheckWin()
  
  local win_flag = true;
  
  for i = 1, 7, 1 do
    
    if private.zz_gallows.found[i] == 0 then
      win_flag = false;
      break;
    end;
    
  end;
  
  return win_flag;
  
end;
-----------------------------------------------------------------------------------
function private.zz_gallows.Win()
  
  local func_after = function ()
    
    cmn.SetEventDone("win_gallows");
    cmn.CallEventHandler("win_gallows");
    
    cmn.Lock( 0 );
  
  end;
  
  ObjAnimate("obj_gallows_hop_interface", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Gates *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_gates = {};
public.zz_gates = {};

function private.Init_Gates()

  -----------------------------------------------------------------------------------
  game.hint[ "win_gates" ] = {
    type = "win",
    room = "rm_outsidechapel",
    zz = "zz_gates",
    zz_gate = "gzz_outsidechapel_gates"
  };
  -----------------------------------------------------------------------------------
  local win_gates = function ()

    if cmn.IsEventDone( "win_gates" ) then
      
      ObjDelete( "gzz_outsidechapel_gates" );
      --ObjDelete( "spr_outsidechapel_gates_closed" );
      ObjDelete( "anm_outsidechapel_gates_death" );
      
      
      ObjMultiSet( { {"gmg_outsidechapel_cobweb", { alp = 1, input = 1, active = 1 }},
                     {"spr_outsidechapel_gates_web", { alp = 1 }} } );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_gates", win_gates, "rm_outsidechapel" );

end;
-----------------------------------------------------------------------------------
function private.zz_gates.StartConditions()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_gates" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_gates" ].state = { 0, { true, true, true, true, true } };
  
end;
-----------------------------------------------------------------------------------
function public.zz_gates.Reset()

  --DbgTrace( "***Reset" );

  cmn.Lock( 1 );

  local reset_flag = false;

  for i = 1, 5, 1 do
    if not private.zz_gates.state[2][i] then

      reset_flag = true;
      private.zz_gates.state[2][i] = true;

      ObjSet( "spr_gates_finger"..i, { input = true } );

      ObjAnimate( "spr_gates_finger"..i,                   "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
      ObjAnimate( "spr_gates_finger"..i.."_closed_shadow", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
      ObjAnimate( "spr_gates_finger"..i.."_closed",        "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );

    end;
  end;

  if ( private.zz_gates.state[1] ~= 0 ) then

    reset_flag = true;

    local old_state_num = private.zz_gates.state[1];
    local old_state1 = math.modf( private.zz_gates.state[1] / 10 ) ;
    old_state1 = math.abs( old_state1 );
    --old_state2 = math.ceil( math.abs( old_state2 * 10 ) );
    local old_state2 = math.abs( private.zz_gates.state[1] ) % 10;

    private.zz_gates.state[1] = 0;

    --DbgTrace( "old_state == "..old_state1.." "..old_state2 );
    --DbgTrace( "state[1] = "..private.zz_gates.state[1].."\n" );

    local func_after = function ()

      if ( old_state_num < 0 ) then

        ObjAnimate( "spr_gates_minus", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
        ObjMultiSet( { { "obj_gates_numbers1", { pos_x = -140 } },
                       { "obj_gates_numbers2", { pos_x = -109 } } } );

      end;

      ObjAnimate( "spr_gates_numbers1_0",       "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
      ObjAnimate( "spr_gates_numbers2_0",       "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );

    end;

    ObjAnimate( "spr_gates_numbers1_"..old_state1, "alp", 0, 0, func_after, { 0, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "spr_gates_numbers2_"..old_state2, "alp", 0, 0, "",         { 0, 0, 1,    0.3, 0, 0 } );

  end;

  if ( reset_flag ) then
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_skeleton_wrong_comb");
    ObjSet( "tmr_gates_animlock", { time = 0.6, endtrig = function () cmn.Lock( 0 ); end, playing = true } );
  else
    cmn.Lock( 0 );
  end;

end;
-----------------------------------------------------------------------------------
function public.zz_gates.Skip()

  --DbgTrace( "***Skip" );

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_skeleton_click_finger_1");

  ng_global.progress[ ng_global.currentprogress ][ "win_gates" ].skip = 1;

  for i = 1, 5, 1 do
    if private.zz_gates.state[2][i] then

      private.zz_gates.state[2][i] = false;

      ObjSet( "spr_gates_finger"..i, { input = false } );

      ObjAnimate( "spr_gates_finger"..i,                   "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
      ObjAnimate( "spr_gates_finger"..i.."_closed_shadow", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
      ObjAnimate( "spr_gates_finger"..i.."_closed",        "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );

    end;
  end;

  if ( private.zz_gates.state[1] ~= 27 ) then

    local old_state_num = private.zz_gates.state[1];
    local old_state1 = math.modf( private.zz_gates.state[1] / 10 ) ;
    old_state1 = math.abs( old_state1 );
    --old_state2 = math.ceil( math.abs( old_state2 * 10 ) );
    local old_state2 = math.abs( private.zz_gates.state[1] ) % 10;

    private.zz_gates.state[1] = 27;

    --DbgTrace( "old_state == "..old_state1.." "..old_state2 );
    --DbgTrace( "state[1] = "..private.zz_gates.state[1].."\n" );

    local func_after = function ()

      if ( old_state_num < 0 ) then

        ObjAnimate( "spr_gates_minus", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
        ObjMultiSet( { { "obj_gates_numbers1", { pos_x = -140 } },
                       { "obj_gates_numbers2", { pos_x = -109 } } } );

      end;

      ObjAnimate( "spr_gates_numbers1_2",       "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
      ObjAnimate( "spr_gates_numbers2_7",       "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );

    end;

    ObjAnimate( "spr_gates_numbers1_"..old_state1, "alp", 0, 0, func_after, { 0, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "spr_gates_numbers2_"..old_state2, "alp", 0, 0, "",         { 0, 0, 1,    0.3, 0, 0 } );

  end;

  ObjSet( "tmr_gates_animlock", { time = 0.6, endtrig = private.zz_gates.CheckWin, playing = true } );

end;
-----------------------------------------------------------------------------------
function private.zz_gates.DrawScene()

  for i = 1, 5, 1 do
    if ( not private.zz_gates.state[2][i] ) then

      ObjMultiSet( { { "spr_gates_finger"..i, { input = false, alp = 0 } },
                     { "spr_gates_finger"..i.."_closed_shadow", { alp = 1 } },
                     { "spr_gates_finger"..i.."_closed", { alp = 1 } } } );

    end;
  end;

  if ( private.zz_gates.state[1] ~= 0 ) then

    local old_state1 = math.modf( private.zz_gates.state[1] / 10 ) ;
    old_state1 = math.abs( old_state1 );
    --old_state2 = math.ceil( math.abs( old_state2 * 10 ) );
    local old_state2 = math.abs( private.zz_gates.state[1] ) % 10;

    ObjMultiSet( { { "spr_gates_numbers1_0", { alp = 0 } },
                   { "spr_gates_numbers2_0", { alp = 0 } },
                   { "spr_gates_numbers1_"..old_state1, { alp = 1 } },
                   { "spr_gates_numbers2_"..old_state2, { alp = 1 } } } );

    if ( private.zz_gates.state[1] < 0 ) then

      ObjMultiSet( { { "obj_gates_numbers1", { pos_x = -136 } },
                     { "spr_gates_minus", { alp = 1 } },
                     { "obj_gates_numbers2", { pos_x = -106 } } } );

    end;

  end;

end;
-----------------------------------------------------------------------------------
function private.zz_gates.CheckWin()

  --DbgTrace( "***CheckWin" );

  if private.zz_gates.state[1] ~= 27 then

    local go_reset = true;
    
    for i = 1, 5, 1 do
      if private.zz_gates.state[2][i] then
        go_reset = false;
        break;
      end;
    end;

    if ( go_reset ) then
      public.zz_gates.Reset();
    else
      cmn.Lock( 0 );
    end;

    return;

  end;

  --DbgTrace( "WWWWWIIIIINNNNNN" );
  
  cmn.Lock( 1 );
  common_impl.PauseAchiev(1);
  cmn.MiniGameHide("gates");
  
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_win_mmg_skeleton");

  local func_after = function ()

    ObjSet( "anm_gates_door", { playing = 1, endtrig = private.zz_gates.Win } );

  end;

  ObjMultiSet( { { "anm_gates_door", { animfunc = "func_door_open", frame = 0, playing = 0 } },
                 { "obj_gates_scythe", { alp = 0 } } } );

  ObjAnimate( "obj_gates_game", "alp", 0, 0, func_after, { 0, 0, 1,    0.5, 0, 1,    1, 0, 0 } );
  ObjAnimate( "spr_gates_back_2", "alp", 0, 0, "", { 0, 0, 1,    0.5, 0, 1,    1, 0, 0 } );

end;
-----------------------------------------------------------------------------------
function private.zz_gates.Win()
  
  cmn.Lock( 0 );
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_gates" );
  cmn.CallEventHandler( "win_gates" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_gates" ].skip == 0 and ng_global.noskipgames[ "win_gates" ] == nil then

    ng_global.noskipgames[ "win_gates" ] = 1;
    common_impl.CheckAchiev("mg");

  end;
  
  common.CloseSubRoom();
  cmn.GotoRoom("mg_cobweb");
  
end;
-----------------------------------------------------------------------------------
function public.zz_gates.FocusFinger( num, inout )
  
  local obj = "spr_gates_finger"..num.."_glow";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
  end;

  --ObjAnimate( obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout } );
  
end;
-----------------------------------------------------------------------------------
function public.zz_gates.ClickFinger( num )

  --DbgTrace( "***ClickFinger: num = "..num );

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_skeleton_click_finger_1");

  private.zz_gates.state[2][num] = false;

  local old_state_num = private.zz_gates.state[1];
  local old_state1 = math.modf( private.zz_gates.state[1] / 10 ) ;
  old_state1 = math.abs( old_state1 );
  --old_state2 = math.ceil( math.abs( old_state2 * 10 ) );
  local old_state2 = math.abs( private.zz_gates.state[1] ) % 10;

  --DbgTrace( "old_state == "..old_state1.." "..old_state2 );

  if     num == 1 then
    private.zz_gates.state[1] = private.zz_gates.state[1] * 2;
  elseif num == 2 then
    private.zz_gates.state[1] = private.zz_gates.state[1] + 4;
  elseif num == 3 then
    private.zz_gates.state[1] = private.zz_gates.state[1] + 10;
  elseif num == 4 then
    private.zz_gates.state[1] = private.zz_gates.state[1] - 3;
  elseif num == 5 then
    private.zz_gates.state[1] = private.zz_gates.state[1] + 1;
  end;

  local new_state1 = math.modf( private.zz_gates.state[1] / 10 ) ;
  new_state1 = math.abs( new_state1 );
  --new_state2 = math.ceil( math.abs( new_state2 * 10 ) );
  local new_state2 = math.abs( private.zz_gates.state[1] ) % 10;

  --DbgTrace( "state[1] = "..private.zz_gates.state[1] );
  --DbgTrace( "new_state == "..new_state1.." "..new_state2.."\n" );

  local func_after = function ()

    if ( old_state_num >= 0 ) and ( private.zz_gates.state[1] < 0 ) then

      ObjAnimate( "spr_gates_minus", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
      ObjMultiSet( { { "obj_gates_numbers1", { pos_x = -136 } },
                     { "obj_gates_numbers2", { pos_x = -106 } } } );

    elseif ( old_state_num < 0 ) and ( private.zz_gates.state[1] >= 0 ) then

      ObjAnimate( "spr_gates_minus", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
      ObjMultiSet( { { "obj_gates_numbers1", { pos_x = -140 } },
                     { "obj_gates_numbers2", { pos_x = -109 } } } );

    end;

    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_skeleton_figure_appears");               

    ObjAnimate( "spr_gates_numbers1_"..new_state1,       "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
    ObjAnimate( "spr_gates_numbers2_"..new_state2,       "alp", 0, 0, private.zz_gates.CheckWin, { 0, 0, 0,    0.3, 0, 1 } );

  end;

  ObjAnimate( "spr_gates_numbers1_"..old_state1, "alp", 0, 0, func_after, { 0, 0, 1,    0.3, 0, 0,    0.8, 0, 0 } );
  ObjAnimate( "spr_gates_numbers2_"..old_state2, "alp", 0, 0, "",         { 0, 0, 1,    0.3, 0, 0 } );
  ObjAnimate( "spr_gates_numbers3_"..num,        "alp", 0, 0, "",         { 0, 0, 0,    0.3, 0, 1,    0.8, 0, 1,    1.1, 0, 0 } );



  ObjSet( "spr_gates_finger"..num, { input = false } );

  ObjAnimate( "spr_gates_finger"..num,                   "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
  ObjAnimate( "spr_gates_finger"..num.."_closed_shadow", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
  ObjAnimate( "spr_gates_finger"..num.."_closed",        "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Fencegates *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_fencegate = {};
public.zz_fencegate = {};

function private.Init_Fencegates()
  
  private.zz_fencegate.fig_pos = { { {-150, -56}, {-186, -4}, {-122, 31} }, { {174, -10}, {90, 20}, {154, 47} } };
  private.zz_fencegate.death_dev = -20;
  private.zz_fencegate.fig_types = { "death", "man" };
  private.zz_fencegate.fig_z = { 2, 4, 6 };
  private.zz_fencegate.fig_boat_pos = -58;
  private.zz_fencegate.fig_chosen = 0;
  private.zz_fencegate.fig_names = { {"death_figurine"}, {"stiven", "queen", "naya"} };
  
  private.zz_fencegate.boat_pos = { -137, 8 };
  
  private.zz_fencegate.start_state = { { {2, 1}, {2, 2}, {2, 3} }, { {1, 1}, {1, 2}, {1, 3} }, { {0, 0}, {0, 0} } };
  private.zz_fencegate.win_state = { { {1, 1}, {1, 2}, {1, 3} }, { {2, 1}, {2, 2}, {2, 3} }, { {0, 0}, {0, 0} } };
  -----------------------------------------------------------------------------------
  game.hint[ "win_fencegate" ] = {
    type = "win",
    room = "rm_outsidechapel",
    zz = "zz_fencegate",
    zz_gate = "gzz_outsidechapel_fencegate"
  };
  -----------------------------------------------------------------------------------
  local win_fencegate = function ()

    if cmn.IsEventDone( "win_fencegate" ) then
      
      ObjDelete( "obj_fencegate_game" );
      ObjDelete( "gzz_outsidechapel_fencegate" );
      ObjDelete( "obj_outsidechapel_fence" );
      
      ObjMultiSet( { {"grm_outsidechapel_cemetery", { alp = 1, input = 1 }},
                     {"spr_outsidechapel_fence_open", { alp = 1 }} } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_outsidechapel_cemetery_focus");
      end;
    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_fencegate", win_fencegate, "rm_outsidechapel" );

end;
--*********************************************************************************************************************
function private.zz_fencegate.StartConditions()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_fencegate" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_fencegate" ].state = { { {2, 1}, {2, 2}, {2, 3} }, { {1, 1}, {1, 2}, {1, 3} }, { {0, 0}, {0, 0} }, 2 }; 
  --[1-2] - figures on each coast: [1] - type, [2] - num
  --[3] - figures in a boat, [4] - boat pos
  
end;
-----------------------------------------------------------------------------------
function public.zz_fencegate.Reset()
  
  local need_r = false;
  local for_reset = {}; 
  
  for i = 1, 2, 1 do
    for j = 1, 3, 1 do
      
      if private.zz_fencegate.state[i][j][1] ~= 0 and ( private.zz_fencegate.state[i][j][1] ~= private.zz_fencegate.start_state[i][j][1]
      or private.zz_fencegate.state[i][j][2] ~= private.zz_fencegate.start_state[i][j][2] ) then
      
        if not need_r then
          need_r = true;
        end;
        
        typ = private.zz_fencegate.state[i][j][1];
        fig = private.zz_fencegate.state[i][j][2];
        dev = 0;
        
        if typ == 1 then
          dev = private.zz_fencegate.death_dev;
        end;
        
        table.insert( for_reset, {} );
        for_reset[#for_reset][1] = private.zz_fencegate.state[i][j][1];
        for_reset[#for_reset][2] = private.zz_fencegate.state[i][j][2];
        
        local ind = {1, 1};
        for a = 1, 2, 1 do
          for b = 1, 3, 1 do
            
            if private.zz_fencegate.start_state[a][b][1] == private.zz_fencegate.state[i][j][1]
            and private.zz_fencegate.start_state[a][b][2] == private.zz_fencegate.state[i][j][2] then
              ind[1] = a;
              ind[2] = b;
              break;
            end;
            
          end;
        end;
        for_reset[#for_reset][3] = ind[1];
        for_reset[#for_reset][4] = ind[2];
        
        ObjAnimate("spr_fencegate_"..private.zz_fencegate.fig_types[typ].."_"..fig, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
        
      end;
      
    end;
  end;
  
  for i = 1, 2, 1 do
    
    if private.zz_fencegate.state[3][i][1] ~= 0 then
      
      if not need_r then
        need_r = true;
      end;
      
      typ = private.zz_fencegate.state[3][i][1];
      fig = private.zz_fencegate.state[3][i][2];
      dev = 0;
      
      local name;
      if typ == 1 then
        name = private.zz_fencegate.fig_names[1][1];
      else 
        name = private.zz_fencegate.fig_names[2][fig];
      end;
      
      if typ == 1 then
        dev = private.zz_fencegate.death_dev;
      end;
      
      table.insert( for_reset, {} );
      for_reset[#for_reset][1] = private.zz_fencegate.state[3][i][1];
      for_reset[#for_reset][2] = private.zz_fencegate.state[3][i][2];
      
      local ind = {1, 1};
      for a = 1, 2, 1 do
        for b = 1, 3, 1 do
          
          if private.zz_fencegate.start_state[a][b][1] == private.zz_fencegate.state[3][i][1]
          and private.zz_fencegate.start_state[a][b][2] == private.zz_fencegate.state[3][i][2] then
            ind[1] = a;
            ind[2] = b;
            break;
          end;
          
        end;
      end;
      for_reset[#for_reset][3] = ind[1];
      for_reset[#for_reset][4] = ind[2];
      
      ObjAnimate("spr_fencegate_boat_fig_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  end;
  
  local anm_end = function ()
    
    local typ, fig, dev, side, place = 0, 0, 0, 0, 0;
    
    for i = 1, #for_reset, 1 do
      
      typ = for_reset[i][1];
      fig = for_reset[i][2];
      side = for_reset[i][3];
      place = for_reset[i][4];
      dev = 0;
        
      if typ == 1 then
        dev = private.zz_fencegate.death_dev;
      end;
      
      --DbgTrace(private.zz_fencegate.fig_types[typ].." "..fig.." "..side.." "..place);
      
      ObjSet("spr_fencegate_"..private.zz_fencegate.fig_types[typ].."_"..fig,  { 
        pos_x = private.zz_fencegate.fig_pos[side][place][1],
        pos_y = private.zz_fencegate.fig_pos[side][place][2] + dev,
        pos_z = private.zz_fencegate.fig_z[place];
      });
      
      ObjAnimate("spr_fencegate_"..private.zz_fencegate.fig_types[typ].."_"..fig, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    ObjSet("tmr_fencegate_timer",  { time = 0.3, playing = 1, endtrig = function() cmn.Lock( 0 ); private.zz_fencegate.DrawScene(); end });
    
  end;
  
  if private.zz_fencegate.fig_chosen ~= 0 then
    ObjAnimate("spr_fencegate_boat_fig_"..private.zz_fencegate.fig_chosen.."_select", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    private.zz_fencegate.fig_chosen = 0;
  end;
  
  if private.zz_fencegate.state[4] ~= 2 then
    
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_death_go");
    
    ObjAnimate("obj_fencegate_boat", "pos_x", 0, 0, "", { 0, 0, private.zz_fencegate.boat_pos[ private.zz_fencegate.state[4] ],   0.5, 0, private.zz_fencegate.boat_pos[ 2 ] });
    
    if not need_r then
      private.zz_fencegate.state[4] = 2;
      cmn.Lock( 1 );
      ObjSet("tmr_fencegate_timer",  { time = 0.5, playing = 1, endtrig = function() cmn.Lock( 0 ); private.zz_fencegate.DrawScene(); end });
    end;
    
  end;
  
  if need_r then
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_death_insert_obgect");
    
    private.zz_fencegate.StartConditions();
    private.zz_fencegate.state = ng_global.progress[ ng_global.currentprogress ][ "win_fencegate" ].state;
    
    ObjSet("tmr_fencegate_timer",  { time = 0.3, playing = 1, endtrig = anm_end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_fencegate.Skip()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_death_insert_obgect");
  
  ng_global.progress[ ng_global.currentprogress ][ "win_fencegate" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_fencegate" ].state = { { {1, 1}, {1, 2}, {1, 3} }, { {2, 1}, {2, 2}, {2, 3} }, { {0, 0}, {0, 0} }, 2 }; 
  
  local for_reset = {}; 
  
  for i = 1, 2, 1 do
    for j = 1, 3, 1 do
      
      if private.zz_fencegate.state[i][j][1] ~= 0 and ( private.zz_fencegate.state[i][j][1] ~= private.zz_fencegate.win_state[i][j][1]
      or private.zz_fencegate.state[i][j][2] ~= private.zz_fencegate.win_state[i][j][2] ) then
      
        typ = private.zz_fencegate.state[i][j][1];
        fig = private.zz_fencegate.state[i][j][2];
        dev = 0;
        
        if typ == 1 then
          dev = private.zz_fencegate.death_dev;
        end;
        
        table.insert( for_reset, {} );
        for_reset[#for_reset][1] = private.zz_fencegate.state[i][j][1];
        for_reset[#for_reset][2] = private.zz_fencegate.state[i][j][2];
        
        local ind = {1, 1};
        for a = 1, 2, 1 do
          for b = 1, 3, 1 do
            
            if private.zz_fencegate.win_state[a][b][1] == private.zz_fencegate.state[i][j][1]
            and private.zz_fencegate.win_state[a][b][2] == private.zz_fencegate.state[i][j][2] then
              ind[1] = a;
              ind[2] = b;
              break;
            end;
            
          end;
        end;
        for_reset[#for_reset][3] = ind[1];
        for_reset[#for_reset][4] = ind[2];
        
        ObjAnimate("spr_fencegate_"..private.zz_fencegate.fig_types[typ].."_"..fig, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
        
      end;
      
    end;
  end;
  
  if private.zz_fencegate.fig_chosen ~= 0 then
    ObjAnimate("spr_fencegate_boat_fig_"..private.zz_fencegate.fig_chosen.."_select", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  end;
  
  for i = 1, 2, 1 do
    
    if private.zz_fencegate.state[3][i][1] ~= 0 then
      
      typ = private.zz_fencegate.state[3][i][1];
      fig = private.zz_fencegate.state[3][i][2];
      dev = 0;
      
      local name;
      if typ == 1 then
        name = private.zz_fencegate.fig_names[1][1];
      else 
        name = private.zz_fencegate.fig_names[2][fig];
      end;
      
      if typ == 1 then
        dev = private.zz_fencegate.death_dev;
      end;
      
      table.insert( for_reset, {} );
      for_reset[#for_reset][1] = private.zz_fencegate.state[3][i][1];
      for_reset[#for_reset][2] = private.zz_fencegate.state[3][i][2];
      
      local ind = {1, 1};
      for a = 1, 2, 1 do
        for b = 1, 3, 1 do
          
          if private.zz_fencegate.win_state[a][b][1] == private.zz_fencegate.state[3][i][1]
          and private.zz_fencegate.win_state[a][b][2] == private.zz_fencegate.state[3][i][2] then
            ind[1] = a;
            ind[2] = b;
            break;
          end;
          
        end;
      end;
      for_reset[#for_reset][3] = ind[1];
      for_reset[#for_reset][4] = ind[2];
      
      ObjAnimate("spr_fencegate_boat_fig_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  end;
  
  local anm_end = function ()
    
    local typ, fig, dev, side, place = 0, 0, 0, 0, 0;
    
    for i = 1, #for_reset, 1 do
      
      typ = for_reset[i][1];
      fig = for_reset[i][2];
      side = for_reset[i][3];
      place = for_reset[i][4];
      dev = 0;
        
      if typ == 1 then
        dev = private.zz_fencegate.death_dev;
      end;
      
      ObjSet("spr_fencegate_"..private.zz_fencegate.fig_types[typ].."_"..fig,  { 
        pos_x = private.zz_fencegate.fig_pos[side][place][1],
        pos_y = private.zz_fencegate.fig_pos[side][place][2] + dev,
        pos_z = private.zz_fencegate.fig_z[place];
      });
      
      ObjAnimate("spr_fencegate_"..private.zz_fencegate.fig_types[typ].."_"..fig, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    ObjSet("tmr_fencegate_timer",  { time = 0.3, playing = 1, endtrig = private.zz_fencegate.CheckWin });
    
  end;
  
  private.zz_fencegate.state = ng_global.progress[ ng_global.currentprogress ][ "win_fencegate" ].state;
  
  ObjSet("tmr_fencegate_timer",  { time = 0.3, playing = 1, endtrig = anm_end });
    
end;
-----------------------------------------------------------------------------------
function private.zz_fencegate.DrawScene()
  
  local typ, fig, dev, dev2 = 0, 0, 0, {0, 0};
  
  for i = 1, 2, 1 do
    for j = 1, 3, 1 do
      
      if private.zz_fencegate.state[i][j][1] ~= 0 then
        
        typ = private.zz_fencegate.state[i][j][1];
        fig = private.zz_fencegate.state[i][j][2];
        dev = 0;
        
        if typ == 1 then
          dev = private.zz_fencegate.death_dev;
        end;
        
        ObjSet("spr_fencegate_"..private.zz_fencegate.fig_types[typ].."_"..fig,  { 
          alp = 1,
          pos_x = private.zz_fencegate.fig_pos[i][j][1],
          pos_y = private.zz_fencegate.fig_pos[i][j][2] + dev,
          pos_z = private.zz_fencegate.fig_z[j];
        });
        
      end;
      
    end;
  end;
  
  ObjSet("obj_fencegate_boat",  { pos_x = private.zz_fencegate.boat_pos[ private.zz_fencegate.state[4] ] });
  
  for i = 1, 2, 1 do
    
    if private.zz_fencegate.state[3][i][1] ~= 0 then
      
      typ = private.zz_fencegate.state[3][i][1];
      fig = private.zz_fencegate.state[3][i][2];
      dev, dev2 = 0, {0, 0};
      
      local name;
      if typ == 1 then
        name = private.zz_fencegate.fig_names[1][1];
      else 
        name = private.zz_fencegate.fig_names[2][fig];
      end;
      
      if typ == 1 then
        dev = private.zz_fencegate.death_dev;
        dev2[1] = 1;
        dev2[2] = 2;
      end;
      
      ObjSet("spr_fencegate_boat_fig_"..i,  { 
        alp = 1, input = 1,
        res = "assets/levels/level1/rm_outsidechapel/zz_fencegate/mmg/"..name,
        pos_y = private.zz_fencegate.fig_boat_pos + dev 
      });
      
      ObjSet("spr_fencegate_boat_fig_"..i.."_select",  { 
        res = "assets/levels/level1/rm_outsidechapel/zz_fencegate/mmg/"..name,
        alp = 0
      });
      
      ObjSet("spr_fencegate_boat_fig_"..i.."_focus",  { 
        res = "assets/levels/level1/rm_outsidechapel/zz_fencegate/mmg/"..name.."2",
        pos_x = dev2[1], 
        pos_y = dev2[2],
        alp = 0
      });
      
      ObjSet("spr_fencegate_"..private.zz_fencegate.fig_types[typ].."_"..fig,  { alp = 0, input = 0 });
      
    else 
      
      ObjSet("spr_fencegate_boat_fig_"..i,  { alp = 0, input = 0, res = "" });
      
    end;
    
  end;
  
  private.zz_fencegate.CheckInput();
  
end;
-----------------------------------------------------------------------------------
function public.zz_fencegate.FocusElement( name, inout )
  
  local obj = "spr_fencegate_"..name.."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      --cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/");
    end;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.zz_fencegate.ChooseFigure( typ, num )
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_death_insert_obgect");
  
  if private.zz_fencegate.fig_chosen == 0 then
    
    local place = 1;
    if private.zz_fencegate.state[3][1][1] ~= 0 then
      place = 2;
    end;
    
    private.zz_fencegate.state[3][place][1] = typ;
    private.zz_fencegate.state[3][place][2] = num;
    
    local ind = private.zz_fencegate.FindInd( typ, num );
    private.zz_fencegate.state[ ind[1] ][ ind[2] ][1] = 0;
    private.zz_fencegate.state[ ind[1] ][ ind[2] ][2] = 0;
    
    local name;
    if typ == 1 then
      name = private.zz_fencegate.fig_names[1][1];
    else 
      name = private.zz_fencegate.fig_names[2][num];
    end;
    
    local dev, dev2 = 0, {0, 0};
    
    if typ == 1 then
      dev = private.zz_fencegate.death_dev;
      dev2[1] = 1;
      dev2[2] = 2;
    end;
    
    ObjSet("spr_fencegate_boat_fig_"..place,  { 
      input = 1,
      res = "assets/levels/level1/rm_outsidechapel/zz_fencegate/mmg/"..name,
      pos_y = private.zz_fencegate.fig_boat_pos + dev 
    });
    
    ObjSet("spr_fencegate_boat_fig_"..place.."_select",  { 
      res = "assets/levels/level1/rm_outsidechapel/zz_fencegate/mmg/"..name,
      alp = 0
    });
    
    ObjSet("spr_fencegate_boat_fig_"..place.."_focus",  { 
      res = "assets/levels/level1/rm_outsidechapel/zz_fencegate/mmg/"..name.."2",
      pos_x = dev2[1], 
      pos_y = dev2[2],
      alp = 0
    });
    
    ObjSet("spr_fencegate_"..private.zz_fencegate.fig_types[typ].."_"..num,  { input = 0 });
    
    ObjAnimate("spr_fencegate_"..private.zz_fencegate.fig_types[typ].."_"..num, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_fencegate_boat_fig_"..place, "alp", 0, 0, private.zz_fencegate.CheckWin, { 0, 0, 0,   0.3, 0, 0,   0.6, 0, 1 });
    
  else 
    
    local ind = private.zz_fencegate.FindInd( typ, num );
    
    local chosen = private.zz_fencegate.fig_chosen;
    private.zz_fencegate.fig_chosen = 0;
    
    local typ2 = private.zz_fencegate.state[3][chosen][1];
    local fig2 = private.zz_fencegate.state[3][chosen][2];
    
    private.zz_fencegate.state[3][chosen][1] = typ;
    private.zz_fencegate.state[3][chosen][2] = num;
    
    private.zz_fencegate.state[ private.zz_fencegate.state[4] ][ ind[2] ][1] = typ2;
    private.zz_fencegate.state[ private.zz_fencegate.state[4] ][ ind[2] ][2] = fig2;
    
    ObjAnimate("spr_fencegate_boat_fig_"..chosen.."_select", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    
    local func_after = function ()
        
      local dev, dev2, dev3 = 0, {0, 0}, 0;
        
      if typ2 == 1 then
        dev = private.zz_fencegate.death_dev;
      end;
      
      local name;
      if typ == 1 then
        name = private.zz_fencegate.fig_names[1][1];
      else 
        name = private.zz_fencegate.fig_names[2][num];
      end;
      
      if typ == 1 then
        dev3 = private.zz_fencegate.death_dev;
        dev2[1] = 1;
        dev2[2] = 2;
      end;
      
      ObjSet("spr_fencegate_"..private.zz_fencegate.fig_types[typ2].."_"..fig2,  { 
        pos_x = private.zz_fencegate.fig_pos[ private.zz_fencegate.state[4] ][ ind[2] ][1],
        pos_y = private.zz_fencegate.fig_pos[ private.zz_fencegate.state[4] ][ ind[2] ][2] + dev,
        pos_z = private.zz_fencegate.fig_z[ ind[2] ];
      });
      
      ObjSet("spr_fencegate_boat_fig_"..chosen,  { 
        alp = 1, input = 1,
        res = "assets/levels/level1/rm_outsidechapel/zz_fencegate/mmg/"..name,
        pos_y = private.zz_fencegate.fig_boat_pos + dev3 
      });
      
      ObjSet("spr_fencegate_boat_fig_"..chosen.."_select",  { 
        res = "assets/levels/level1/rm_outsidechapel/zz_fencegate/mmg/"..name,
        alp = 0
      });
      
      ObjSet("spr_fencegate_boat_fig_"..chosen.."_focus",  { 
        res = "assets/levels/level1/rm_outsidechapel/zz_fencegate/mmg/"..name.."2",
        pos_x = dev2[1], 
        pos_y = dev2[2],
        alp = 0
      });
      
      ObjAnimate("spr_fencegate_"..private.zz_fencegate.fig_types[typ2].."_"..fig2, "alp", 0, 0, private.zz_fencegate.CheckWin, { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("spr_fencegate_boat_fig_"..chosen, "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    ObjSet("spr_fencegate_"..private.zz_fencegate.fig_types[typ].."_"..num,  { input = 0 });
    
    ObjAnimate("spr_fencegate_boat_fig_"..chosen, "alp", 0, 0, func_after, { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_fencegate_"..private.zz_fencegate.fig_types[typ].."_"..num, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_fencegate.ChooseBoatFigure( num )
  
  cmn.Lock( 1 );
  
  local vacant = 0;
  
  for i = 1, 3, 1 do
    
    if private.zz_fencegate.state[ private.zz_fencegate.state[4] ][i][1] == 0 then
      vacant = i;
    end;
    
  end;
  
  local typ = private.zz_fencegate.state[3][num][1];
  local fig = private.zz_fencegate.state[3][num][2];
  
  if vacant > 0 then
    
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_death_take_off_obgect");
    
    private.zz_fencegate.state[3][num][1] = 0;
    private.zz_fencegate.state[3][num][2] = 0;
    
    private.zz_fencegate.state[ private.zz_fencegate.state[4] ][vacant][1] = typ;
    private.zz_fencegate.state[ private.zz_fencegate.state[4] ][vacant][2] = fig;
    
    local func_after = function ()
        
      local dev = 0;
        
      if typ == 1 then
        dev = private.zz_fencegate.death_dev;
      end;
      
      ObjSet("spr_fencegate_"..private.zz_fencegate.fig_types[typ].."_"..fig,  { 
        pos_x = private.zz_fencegate.fig_pos[ private.zz_fencegate.state[4] ][vacant][1],
        pos_y = private.zz_fencegate.fig_pos[ private.zz_fencegate.state[4] ][vacant][2] + dev,
        pos_z = private.zz_fencegate.fig_z[vacant];
      });
      
      ObjAnimate("spr_fencegate_"..private.zz_fencegate.fig_types[typ].."_"..fig, "alp", 0, 0, private.zz_fencegate.CheckWin, { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    ObjSet("spr_fencegate_boat_fig_"..num,  { input = 0 });
    ObjAnimate("spr_fencegate_boat_fig_"..num, "alp", 0, 0, func_after, { 0, 0, 1,   0.3, 0, 0 });
    
  else 
    
    if private.zz_fencegate.fig_chosen ~= num then
    
      local func_after = function ()
        
        for i = 1, 3, 1 do
          
          local typ = private.zz_fencegate.state[ private.zz_fencegate.state[4] ][i][1];
          ObjSet("spr_fencegate_"..private.zz_fencegate.fig_types[typ].."_"..private.zz_fencegate.state[ private.zz_fencegate.state[4] ][i][2],  { input = 1 });
          
        end;
        
        cmn.Lock( 0 );
        
      end;
      
      if private.zz_fencegate.fig_chosen ~= 0 then
        ObjAnimate("spr_fencegate_boat_fig_"..private.zz_fencegate.fig_chosen.."_select", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      end;
      
      private.zz_fencegate.fig_chosen = num;
      ObjAnimate("spr_fencegate_boat_fig_"..num.."_select", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
      
    else 
      
      local func_after = function ()
        
        for i = 1, 3, 1 do
          
          local typ = private.zz_fencegate.state[ private.zz_fencegate.state[4] ][i][1];
          ObjSet("spr_fencegate_"..private.zz_fencegate.fig_types[typ].."_"..private.zz_fencegate.state[ private.zz_fencegate.state[4] ][i][2],  { input = 0 });
          
        end;
        
        cmn.Lock( 0 );
        
      end;
      
      private.zz_fencegate.fig_chosen = 0;
      ObjAnimate("spr_fencegate_boat_fig_"..num.."_select", "alp", 0, 0, func_after, { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_fencegate.UseBoat()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_death_go");
  
  local pos1 = private.zz_fencegate.boat_pos[ private.zz_fencegate.state[4] ];
  local pos2;
  if private.zz_fencegate.state[4] == 1 then
    private.zz_fencegate.state[4] = 2;
    pos2 = private.zz_fencegate.boat_pos[ 2 ];
  else 
    private.zz_fencegate.state[4] = 1;
    pos2 = private.zz_fencegate.boat_pos[ 1 ];
  end;
  
  if private.zz_fencegate.fig_chosen ~= 0 then
    ObjAnimate("spr_fencegate_boat_fig_"..private.zz_fencegate.fig_chosen.."_select", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    private.zz_fencegate.fig_chosen = 0;
  end;
  
  ObjAnimate("obj_fencegate_boat", "pos_x", 0, 0, private.zz_fencegate.CheckWin, { 0, 0, pos1,   0.5, 0, pos2 });
  
end;
-----------------------------------------------------------------------------------
function private.zz_fencegate.FindInd( typ, num )
  
  local ind = {1, 1};
  
  for a = 1, 2, 1 do
    for b = 1, 3, 1 do
      
      if private.zz_fencegate.state[a][b][1] == typ
      and private.zz_fencegate.state[a][b][2] == num then
        ind[1] = a;
        ind[2] = b;
        break;
      end;
      
    end;
  end;
  
  return ind;
  
end;
-----------------------------------------------------------------------------------
function private.zz_fencegate.CheckInput()
  
  local check_boat = false;
  local typ, fig, dev = 0, 0, 0;
  
  if private.zz_fencegate.state[3][1][1] ~= 0 and private.zz_fencegate.state[3][2][1] ~= 0 then
    check_boat = true;
  end;
  
  if private.zz_fencegate.state[3][1][1] ~= 0 or private.zz_fencegate.state[3][2][1] ~= 0 then
    ObjSet("spr_fencegate_game_go",  { input = 1 });
  else 
    ObjSet("spr_fencegate_game_go",  { input = 0 });
  end;
  
  if not check_boat then
  
    for i = 1, 2, 1 do
      for j = 1, 3, 1 do
        
        typ = private.zz_fencegate.state[i][j][1];
        fig = private.zz_fencegate.state[i][j][2];
        dev = 0;
        
        if typ == 1 then
          dev = private.zz_fencegate.death_dev;
        end;
        
        if typ ~= 0 then
          
          if private.zz_fencegate.state[4] == i then
            ObjSet("spr_fencegate_"..private.zz_fencegate.fig_types[typ].."_"..fig,  { input = 1 });
          else 
            ObjSet("spr_fencegate_"..private.zz_fencegate.fig_types[typ].."_"..fig,  { input = 0 });
          end;
          
        end;
        
      end;
    end;
    
  else
    
    for i = 1, 2, 1 do
      for j = 1, 3, 1 do
        
        typ = private.zz_fencegate.state[i][j][1];
        fig = private.zz_fencegate.state[i][j][2];
        dev = 0;
        
        if typ == 1 then
          dev = private.zz_fencegate.death_dev;
        end;
        
        if typ ~= 0 then
          ObjSet("spr_fencegate_"..private.zz_fencegate.fig_types[typ].."_"..fig,  { input = 0 });
        end;
        
      end;
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_fencegate.CheckDeath()
  
  local count  = { {0, 0}, {0, 0} };
  
  for i = 1, 2, 1 do
    for j = 1, 3, 1 do
      
      if private.zz_fencegate.state[i][j][1] == 1 then
        count[i][1] = count[i][1] + 1;
      elseif private.zz_fencegate.state[i][j][1] == 2 then
        count[i][2] = count[i][2] + 1;
      end;
      
    end;
  end;
  
  for i = 1, 2, 1 do
    
    if private.zz_fencegate.state[3][i][1] == 1 then
      count[ private.zz_fencegate.state[4] ][1] = count[ private.zz_fencegate.state[4] ][1] + 1;
    elseif private.zz_fencegate.state[3][i][1] == 2 then
      count[ private.zz_fencegate.state[4] ][2] = count[ private.zz_fencegate.state[4] ][2] + 1;
    end;
    
  end;
  
  if ( count[1][2] > 0 and count[1][1] > count[1][2] ) or ( count[2][2] > 0 and count[2][1] > count[2][2] ) then
    
    cmn.Lock( 1 );
    ObjSet("tmr_fencegate_timer",  { time = 0.5, playing = 1, endtrig = public.zz_fencegate.Reset });
    
  else 
    private.zz_fencegate.CheckInput();
    cmn.Lock( 0 );
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_fencegate.CheckWin()
  
  local win_flag = true;
  
  for i = 1, 2, 1 do
    
    for j = 1, 3, 1 do
      
      if private.zz_fencegate.state[i][j][1] ~= i then
        win_flag = false;
        break;
      end;
      
    end;
    
    if not win_flag then
      break;
    end;
    
  end;
  
  if win_flag then
    
    cmn.Lock( 1 );
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("fencegate");
    
    local anm_open = function ()
      
      ObjSet("amm_fencegate_gate_open",  { playing = 1, endtrig = private.zz_fencegate.Win });
      
    end;
    
    local anm_1 = function ()
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_death_win");
      ObjAnimate("obj_fencegate_game", "pos_x", 0, 0, anm_open, { 0, 0, 0,   0.5, 0, -512 });
      ObjAnimate("spr_fencegate_frame", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
    end;
    
    ObjAnimate("obj_fencegate_game", "pos_x", 0, 0, anm_1, { 0, 0, 0,   1.5, 0, 0 });
    --ObjAnimate("spr_fencegate_frame", "pos_x", 0, 0, "", { 0, 0, 0,   1.5, 0, 0,   2.5, 0, -512 });
    
  else 
    private.zz_fencegate.CheckDeath();
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_fencegate.Win()
  
  cmn.Lock( 0 );
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_fencegate" );
  cmn.CallEventHandler( "win_fencegate" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_fencegate" ].skip == 0 and ng_global.noskipgames[ "win_fencegate" ] == nil then

    ng_global.noskipgames[ "win_fencegate" ] = 1;
    common_impl.CheckAchiev("mg");

  end;
  
  common.CloseSubRoom();
  
end;
--******************************************************************************************************