-- name=rm_worldofdarkness
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_worldofdarkness";
  --------------------------------------------------------------------------------------------
  private.dlg_lipsync = "";
  private.Init_Subroom();
  private.Init_Wardrobe();
  private.Init_Firtree();
  
  private.tv_anims = {1, 2, 3};
  private.tv_anims_ed = {1, 2, 3};
  --------------------------------------------------------------------------------------------
  -- function get_bulb () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_bulb" ] = {
        type = "get",
        get_obj = "spr_firtree_bulb",
        room = private.room_objname,
        zz = "zz_firtree",
        zz_gate = "gzz_worldofdarkness_firtree"
    };
    --------------------------------------------------------------------------------------------
  local get_bulb_inv = function ()
  
    interface.InventoryItemAdd( "inv_bulb", "spr_firtree_bulb" );
  
  end;
  
  local get_bulb_end = function ()
  
    ObjDelete( "gfx_firtree_bulb" );
    ObjDelete( "spr_firtree_bulb_sh" );
    ObjDelete( "spr_worldofdarkness_firtree_bulb" );
    
    if cmn.IsEventDone("get_photopart2") then
      ObjDelete( "gzz_worldofdarkness_firtree" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_bulb", get_bulb_inv );
  cmn.AddSubscriber( "get_bulb", get_bulb_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_photopart2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_photopart2" ] = {
        type = "get",
        get_obj = "spr_firtree_photopart2",
        room = private.room_objname,
        zz = "zz_firtree",
        zz_gate = "gzz_worldofdarkness_firtree"
    };
    --------------------------------------------------------------------------------------------
  local get_photopart2_inv = function ()
  
    interface.InventoryItemAdd( "inv_photopart2", "spr_firtree_photopart2" );
    ObjSet("inv_photobasis_star_light",  { alp = 1 });
  
  end;
  
  local get_photopart2_end = function ()
  
    ObjDelete( "gfx_firtree_photopart2" );
    ObjDelete( "spr_firtree_photopart2_sh" );

    ObjDelete( "spr_worldofdarkness_firtree_photo" );
    
    if cmn.IsEventDone("get_bulb") then
      ObjDelete( "gzz_worldofdarkness_firtree" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_photopart2", get_photopart2_inv );
  cmn.AddSubscriber( "get_photopart2", get_photopart2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_photopart4 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_photopart4" ] = {
        type = "get",
        get_obj = "spr_wardrobe_photopart4",
        room = private.room_objname,
        zz = "zz_wardrobe",
        zz_gate = "gzz_worldofdarkness_wardrobe"
    };
    --------------------------------------------------------------------------------------------
  local get_photopart4_inv = function ()
  
    interface.InventoryItemAdd( "inv_photopart4", "spr_wardrobe_photopart4" );
    ObjSet("inv_photobasis_star_light",  { alp = 1 });
  
  end;
  
  local get_photopart4_end = function ()
  
    ObjDelete( "gfx_wardrobe_photopart4" );
    ObjDelete( "spr_wardrobe_photopart4_sh" );
    
    ObjDelete( "spr_worldofdarkness_wardrobe_photo" );
    ObjDelete( "gzz_worldofdarkness_wardrobe" );
  
  end;
  
  cmn.AddSubscriber( "get_photopart4", get_photopart4_inv );
  cmn.AddSubscriber( "get_photopart4", get_photopart4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_photobasis () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_photobasis" ] = {
        type = "get",
        get_obj = "spr_monster_photobasis",
        room = private.room_objname,
        zz = "zz_monster",
        zz_gate = "gzz_worldofdarkness_monster"
    };
    --------------------------------------------------------------------------------------------
  local get_photobasis_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_photobasis", "spr_monster_photobasis" );
  
  end;
  
  local get_photobasis_end = function ()
  
    ObjDelete( "gfx_monster_photobasis" );
    ObjDelete( "spr_monster_photobasis_sh" );
  
    ObjDelete( "spr_worldofdarkness_monster_photobasis" );

  end;
  
  cmn.AddSubscriber( "get_photobasis", get_photobasis_inv );
  cmn.AddSubscriber( "get_photobasis", get_photobasis_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_switch () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_switch" ] = {
        type = "get",
        get_obj = "spr_monster_switch",
        room = private.room_objname,
        zz = "zz_monster",
        zz_gate = "gzz_worldofdarkness_monster"
    };
    --------------------------------------------------------------------------------------------
  local get_switch_inv = function ()
  
    interface.InventoryItemAdd( "inv_switch", "spr_monster_switch" );
  
  end;
  
  local get_switch_end = function ()
  
    ObjDelete( "gfx_monster_switch" );
    ObjDelete( "spr_monster_switch_sh" );
  
    ObjDelete( "spr_worldofdarkness_monster_switch" );

  end;
  
  cmn.AddSubscriber( "get_switch", get_switch_inv );
  cmn.AddSubscriber( "get_switch", get_switch_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lamp () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_lamp" ] = {
        type = "get",
        get_obj = "spr_bed_lamp",
        room = private.room_objname,
        zz = "zz_bed",
        zz_gate = "gzz_worldofdarkness_bed"
    };
    --------------------------------------------------------------------------------------------
  local get_lamp_inv = function ()
  
    interface.InventoryItemAdd( "inv_lamp", "spr_bed_lamp" );
  
  end;
  
  local get_lamp_end = function ()
  
    ObjDelete( "gfx_bed_lamp" );
    ObjDelete( "spr_bed_lamp_sh" );

    ObjDelete( "spr_worldofdarkness_bed_shadow" );
    ObjDelete( "obj_worldofdarkness_bed_lamp" );
    
    ObjSet("obj_bed_under_lamp",  { alp = 1, input = 1 });
    
    if cmn.IsEventDone("get_key") and cmn.IsEventDone("get_photopart3") then
      ObjDelete( "gzz_worldofdarkness_bed" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_lamp", get_lamp_inv );
  cmn.AddSubscriber( "get_lamp", get_lamp_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_key () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_key" ] = {
        type = "get",
        get_obj = "spr_bed_key",
        room = private.room_objname,
        zz = "zz_bed",
        zz_gate = "gzz_worldofdarkness_bed"
    };
    --------------------------------------------------------------------------------------------
  local get_key_inv = function ()
  
    interface.InventoryItemAdd( "inv_key", "spr_bed_key" );
  
  end;
  
  local get_key_end = function ()
  
    ObjDelete( "gfx_bed_key" );
    ObjDelete( "spr_bed_key_sh" );

    ObjDelete( "spr_worldofdarkness_bed_key" );
    
    if cmn.IsEventDone("get_lamp") and cmn.IsEventDone("get_photopart3") then
      ObjDelete( "gzz_worldofdarkness_bed" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_key", get_key_inv );
  cmn.AddSubscriber( "get_key", get_key_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_photopart3 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_photopart3" ] = {
        type = "get",
        get_obj = "spr_bed_photopart3",
        room = private.room_objname,
        zz = "zz_bed",
        zz_gate = "gzz_worldofdarkness_bed"
    };
    --------------------------------------------------------------------------------------------
  local get_photopart3_inv = function ()
  
    interface.InventoryItemAdd( "inv_photopart3", "spr_bed_photopart3" );
    ObjSet("inv_photobasis_star_light",  { alp = 1 });
  
  end;
  
  local get_photopart3_end = function ()
  
    ObjDelete( "gfx_bed_photopart3" );
    ObjDelete( "spr_bed_photopart3_sh" );
    ObjDelete( "spr_worldofdarkness_bed_photopart3" );
    
    if cmn.IsEventDone("get_key") and cmn.IsEventDone("get_lamp") then
      ObjDelete( "gzz_worldofdarkness_bed" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_photopart3", get_photopart3_inv );
  cmn.AddSubscriber( "get_photopart3", get_photopart3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crownofdarkness () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "get_crownofdarkness" ] = {
        type = "get",
        get_obj = "spr_worldofdarkness_crownofdarkness",
        room = private.room_objname
    };
    --------------------------------------------------------------------------------------------
  local get_crownofdarkness_inv = function ()
    
    interface.InventoryItemAdd( "inv_crownofdarkness", "spr_worldofdarkness_crownofdarkness" );
    int_map_impl.DecreaseRoomTasks("rm_worldofdarkness");
  
  end;
  local get_crownofdarkness_mid = function ()
  
    ObjDelete( "gfx_worldofdarkness_crownofdarkness" );
  
  end;
  local get_crownofdarkness_end = function ()
  
    ObjDelete( "obj_worldofdarkness_dialog_naya3" );
  
  end;
  
  cmn.AddSubscriber( "get_crownofdarkness", get_crownofdarkness_inv );
  cmn.AddSubscriber( "get_crownofdarkness", get_crownofdarkness_mid, private.room_objname );
  cmn.AddSubscriber( "get_crownofdarkness", get_crownofdarkness_end, private.room_objname );
  cmn.AddSubscriber( "get_crownofdarkness_inv", get_crownofdarkness_inv );
  cmn.AddSubscriber( "get_crownofdarkness_mid", get_crownofdarkness_mid, private.room_objname );
  cmn.AddSubscriber( "get_crownofdarkness_end", get_crownofdarkness_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_switch () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_switch" ] = {
        type = "use",
        inv_obj = "inv_switch",
        use_place = "obj_firtree_use_switch",
        room = private.room_objname,
        zz = "zz_firtree",
        zz_gate = "gzz_worldofdarkness_firtree"
    };
  --------------------------------------------------------------------------------------------
  local use_switch_inv = function ()
  
    interface.InventoryItemRemove( "inv_switch" );
  
  end;
  local use_switch_beg = function ()
  
    ObjDelete( "obj_firtree_use_switch" );
  
  end;
  local use_switch_end = function ()
  
    ObjMultiSet( { {"obj_firtree_game", { alp = 1, input = 1 }},
                   {"anm_firtree_use_switch", { alp = 1, frame = 300 }},
                   {"spr_worldofdarkness_firtree_switch_on", { alp = 1 }},
                   {"spr_worldofdarkness_firtree_lights", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_switch", use_switch_beg, private.room_objname );
  cmn.AddSubscriber( "use_switch", use_switch_inv );
  cmn.AddSubscriber( "use_switch", use_switch_end, private.room_objname );
  cmn.AddSubscriber( "use_switch_inv", use_switch_inv, private.room_objname );
  cmn.AddSubscriber( "use_switch_beg", use_switch_beg, private.room_objname );
  cmn.AddSubscriber( "use_switch_end", use_switch_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lamp () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_lamp" ] = {
        type = "use",
        inv_obj = "inv_lamp",
        use_place = "obj_wardrobe_use_lamp",
        room = private.room_objname,
        zz = "zz_wardrobe",
        zz_gate = "gzz_worldofdarkness_wardrobe"
    };
  --------------------------------------------------------------------------------------------
  local use_lamp_inv = function ()
  
    interface.InventoryItemRemove( "inv_lamp" );
  
  end;
  local use_lamp_beg = function ()
  
    ObjDelete( "obj_wardrobe_use_lamp" );
    ObjSet("obj_wardrobe_back_1",  { alp = 1 });
  
  end;
  local use_lamp_end = function ()
  
    ObjDelete( "vid_wardrobe_back_2" );
    ObjDelete( "vid_wardrobe_shadow_gone" );
    ObjDelete( "spr_worldofdarkness_wardrobe_open_1" );
    ObjDelete( "anm_worldofdarkness_darkness_in_wardrobe" );
    
    ObjMultiSet( { {"obj_wardrobe_game", { input = 1 }},
                   {"obj_wardrobe_hop_interface", { alp = 1, input = 1 }},
                   {"obj_worldofdarkness_wardrobe_open_2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lamp", use_lamp_beg, private.room_objname );
  cmn.AddSubscriber( "use_lamp", use_lamp_inv );
  cmn.AddSubscriber( "use_lamp", use_lamp_end, private.room_objname );
  cmn.AddSubscriber( "use_lamp_inv", use_lamp_inv, private.room_objname );
  cmn.AddSubscriber( "use_lamp_beg", use_lamp_beg, private.room_objname );
  cmn.AddSubscriber( "use_lamp_end", use_lamp_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_key () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_key" ] = {
        type = "use",
        inv_obj = "inv_key",
        use_place = "obj_wardrobe_use_key",
        room = private.room_objname,
        zz = "zz_wardrobe",
        zz_gate = "gzz_worldofdarkness_wardrobe"
    };
  --------------------------------------------------------------------------------------------
  local use_key_inv = function ()
  
    interface.InventoryItemRemove( "inv_key" );
  
  end;
  local use_key_beg = function ()
  
    ObjDelete( "obj_wardrobe_use_key" );
  
  end;
  local use_key_end = function ()
    
    ObjAttach("vid_wardrobe_back_2", "zz_wardrobe");
    
    ObjDelete( "anm_worldofdarkness_firefly_wradrobe" );
    ObjDelete( "anm_wardrobe_door" );
    ObjDelete( "anm_wardrobe_firefly" );
    
    ObjDelete( "vid_wardrobe_shadow" );
    
    ObjMultiSet( { {"obj_wardrobe_use_lamp", { input = 1 }},
                   {"spr_worldofdarkness_wardrobe_open_1", { alp = 1 }},
                   {"anm_worldofdarkness_darkness_in_wardrobe", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_key", use_key_beg, private.room_objname );
  cmn.AddSubscriber( "use_key", use_key_inv );
  cmn.AddSubscriber( "use_key", use_key_end, private.room_objname );
  cmn.AddSubscriber( "use_key_inv", use_key_inv, private.room_objname );
  cmn.AddSubscriber( "use_key_beg", use_key_beg, private.room_objname );
  cmn.AddSubscriber( "use_key_end", use_key_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_photo () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_photo" ] = {
        type = "use",
        inv_obj = "inv_photo",
        use_place = "obj_monster_use_photo",
        room = private.room_objname,
        zz = "zz_monster",
        zz_gate = "gzz_worldofdarkness_monster"
    };
  --------------------------------------------------------------------------------------------
  local use_photo_inv = function ()
  
    interface.InventoryItemRemove( "inv_photo" );
  
  end;
  local use_photo_beg = function ()
  
    ObjDelete( "obj_monster_use_photo" );
    ObjDelete( "anm_monster_monster" );
    ObjDelete( "anm_monster_monster_touch" );

    ObjDelete( "anm_worldofdarkness_naya" );
  
  end;
  local use_photo_mid = function ()
    
    ObjDelete( "gzz_worldofdarkness_monster" );
    ObjSet("anm_worldofdarkness_naya_2",  { alp = 1 });
  
  end;
  local use_photo_end = function ()
    
    ObjDelete( "anm_worldofdarkness_dialog_naya3_hands_1" );
    ObjDelete( "anm_worldofdarkness_dialog_naya3_hand_give" );
    ObjDelete( "vid_worldofdarkness_dialog_naya3_lipsync1" );
    ObjDelete( "vid_worldofdarkness_dialog_naya3_lipsync2" );
    
    ObjAttach("obj_worldofdarkness_dialog_naya3", "rm_worldofdarkness");
    ObjMultiSet( { {"obj_worldofdarkness_dialog_naya3", { alp = 1, input = 1 }},
                   {"obj_worldofdarkness_dialog_naya3_hand_2", { alp = 1, input = 1 }},
                   {"anm_worldofdarkness_dialog_naya3_head", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_photo", use_photo_beg, private.room_objname );
  cmn.AddSubscriber( "use_photo", use_photo_inv );
  cmn.AddSubscriber( "use_photo", use_photo_end, private.room_objname );
  cmn.AddSubscriber( "use_photo_inv", use_photo_inv, private.room_objname );
  cmn.AddSubscriber( "use_photo_beg", use_photo_beg, private.room_objname );
  cmn.AddSubscriber( "use_photo_end", use_photo_end, private.room_objname );
  cmn.AddSubscriber( "use_photo", use_photo_mid, private.room_objname );
  cmn.AddSubscriber( "use_photo_mid", use_photo_mid, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bulb () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_bulb" ] = {
        type = "use",
        inv_obj = "inv_bulb",
        use_place = "obj_bed_use_bulb",
        room = private.room_objname,
        zz = "zz_bed",
        zz_gate = "gzz_worldofdarkness_bed"
    };
  --------------------------------------------------------------------------------------------
  local use_bulb_inv = function ()
  
    interface.InventoryItemRemove( "inv_bulb" );
  
  end;
  local use_bulb_beg = function ()
  
    ObjDelete( "obj_bed_use_bulb" );
    
  end;
  local use_bulb_end = function ()
    
    ObjDelete("anm_bed_lamp_touch");
    ObjDelete( "spr_worldofdarkness_bed_lamp_1" );
    
    ObjMultiSet( { {"anm_bed_use_bulb", { alp = 1, frame = 300, pos_z = 2 }},
                   {"obj_bed_pieces", { input = 1 }},
                   {"spr_worldofdarkness_bed_lamp_2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bulb", use_bulb_beg, private.room_objname );
  cmn.AddSubscriber( "use_bulb", use_bulb_inv );
  cmn.AddSubscriber( "use_bulb", use_bulb_end, private.room_objname );
  cmn.AddSubscriber( "use_bulb_inv", use_bulb_inv, private.room_objname );
  cmn.AddSubscriber( "use_bulb_beg", use_bulb_beg, private.room_objname );
  cmn.AddSubscriber( "use_bulb_end", use_bulb_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function use_bedlamppart1 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_bedlamppart1" ] = {
        type = "use",
        inv_obj = "spr_bed_part_1",
        use_place = "obj_bed_use_lamp_parts",
        room = private.room_objname,
        zz = "zz_bed",
        zz_gate = "gzz_worldofdarkness_bed"
    };
  --------------------------------------------------------------------------------------------
  local use_bedlamppart1_beg = function ()
  
    if cmn.IsEventDone("use_bedlamppart2") then
      ObjDelete( "obj_bed_use_lamp_parts" );
    end;
    
    ObjDelete( "spr_bed_part_1_sh" );
    ObjDelete( "spr_bed_part_1" );
    
  end;
  local use_bedlamppart1_end = function ()
    
    ObjMultiSet( { {"spr_bed_lamp_part_1", { alp = 1 }},
                   {"spr_worldofdarkness_bed_lamp_complete_1", { alp = 1 }} } );

    ObjDelete( "spr_worldofdarkness_bed_lamp_part1" );
    
    if cmn.IsEventDone("use_bedlamppart2") then
      ObjMultiSet( { {"spr_bed_lamp", { input = 1 }},
                     {"gfx_bed_lamp", { active = 1, visible = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bedlamppart1", use_bedlamppart1_beg, private.room_objname );
  cmn.AddSubscriber( "use_bedlamppart1", use_bedlamppart1_end, private.room_objname );
  cmn.AddSubscriber( "use_bedlamppart1_beg", use_bedlamppart1_beg, private.room_objname );
  cmn.AddSubscriber( "use_bedlamppart1_end", use_bedlamppart1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bedlamppart2 () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "use_bedlamppart2" ] = {
        type = "use",
        inv_obj = "spr_bed_part_2",
        use_place = "obj_bed_use_lamp_parts",
        room = private.room_objname,
        zz = "zz_bed",
        zz_gate = "gzz_worldofdarkness_bed"
    };
  --------------------------------------------------------------------------------------------
  local use_bedlamppart2_beg = function ()
  
    if cmn.IsEventDone("use_bedlamppart1") then
      ObjDelete( "obj_bed_use_lamp_parts" );
    end;
    
    ObjDelete( "spr_bed_part_2_sh" );
    ObjDelete( "spr_bed_part_2" );
    
  end;
  local use_bedlamppart2_end = function ()
    
    ObjMultiSet( { {"spr_bed_lamp_part_2", { alp = 1 }},
                   {"spr_worldofdarkness_bed_lamp_complete_2", { alp = 1 }} } );

    ObjDelete( "spr_worldofdarkness_bed_lamp_part2" );
    
    if cmn.IsEventDone("use_bedlamppart1") then
      ObjMultiSet( { {"spr_bed_lamp", { input = 1 }},
                     {"gfx_bed_lamp", { active = 1, visible = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bedlamppart2", use_bedlamppart2_beg, private.room_objname );
  cmn.AddSubscriber( "use_bedlamppart2", use_bedlamppart2_end, private.room_objname );
  cmn.AddSubscriber( "use_bedlamppart2_beg", use_bedlamppart2_beg, private.room_objname );
  cmn.AddSubscriber( "use_bedlamppart2_end", use_bedlamppart2_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_oldbulbout () end;
  --------------------------------------------------------------------------------------------
    game.hint[ "clk_oldbulbout" ] = {
        type = "click",
        use_place = "obj_bed_clk_bulb",
        room = private.room_objname,
        zz = "zz_bed",
        zz_gate = "gzz_worldofdarkness_bed"
    };
    --------------------------------------------------------------------------------------------
  local clk_oldbulbout = function ()
  
    ObjSet("obj_bed_use_bulb",  { input = 1 });

    ObjDelete( "anm_bed_lamp_touch" );
    ObjDelete( "obj_bed_clk_bulb" );

    ObjDelete( "spr_worldofdarkness_bed_broken_bulb" );

  end;
  
  cmn.AddSubscriber( "clk_oldbulbout", clk_oldbulbout, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function opn_worldofdarkness () end;
  --------------------------------------------------------------------------------------------
  local opn_worldofdarkness_map = function ()
  
    int_map_impl.OpenRoom( "rm_worldofdarkness" );
  
  end;
  local opn_worldofdarkness_loc = function ()
  
    ObjMultiSet( { {"anm_worldofdarkness_fireflies", { animfunc = "func_fyrefly", frame = 0 }},
                   {"anm_worldofdarkness_firefly_wradrobe", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_worldofdarkness", opn_worldofdarkness_map );
  cmn.AddSubscriber( "opn_worldofdarkness", opn_worldofdarkness_loc, private.room_objname );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_monster" );
  subroom.Define( "zz_firtree" );
  subroom.Define( "zz_wardrobe" );
  subroom.Define( "zz_bed" );
  
  function zz_monster.Close()
    
    if cmn.IsEventDone("use_photo") then
      --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
      ObjAttach("obj_worldofdarkness_dialog_naya3", "rm_worldofdarkness");
      ObjAnimate("obj_worldofdarkness_dialog_naya3", "alp", 0, 0, private.dialog_naya3_beg, { 0, 0, 0,   0.5, 0, 1 });
    end;
    
  end;
  
  function zz_firtree.PreOpen()
    
    if not cmn.IsEventDone( "win_firtree" ) then
      private.zz_firtree.DrawScene();
    end;
    
  end;
  
  function zz_firtree.Open()
    
    if cmn.IsEventDone( "use_switch" ) and not(cmn.IsEventDone( "win_firtree" )) then
      cmn.MiniGameShow();
      private.zz_firtree.CheckWin();
    end;

  end;
  
  function zz_firtree.PreClose()
    
    if cmn.IsEventDone( "use_switch" ) and not(cmn.IsEventDone( "win_firtree" )) then
      cmn.MiniGameHide("firtree");
    end;
    
  end;
  
  function zz_wardrobe.PreOpen()
    
    private.zz_wardrobe.DrawScene();
    
    if cmn.IsEventDone("use_key") then
      cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_loop_monster_env");
    end;
    
  end;
  
  function zz_wardrobe.Open()
    
    if cmn.IsEventDone( "use_lamp" ) and not(cmn.IsEventDone( "win_wardrobe" )) then
      private.zz_wardrobe.CheckWin();
    end;

  end;
  
  function zz_wardrobe.PreClose()
    
    if cmn.IsEventDone("use_key") then
      cmn.StopAllEnv("assets/levels/level1/audio/env/aud_worldofdarkness_env");
      cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_worldofdarkness_env");
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_wardrobe" ].state) then 
    private.zz_wardrobe.StartConditions();
  end;
  private.zz_wardrobe.state = ng_global.progress[ ng_global.currentprogress ][ "win_wardrobe" ].state;
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_firtree" ].state) then 
    private.zz_firtree.StartConditions();
  end;
  private.zz_firtree.state = ng_global.progress[ ng_global.currentprogress ][ "win_firtree" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_worldofdarkness();
  
  if cmn.IsEventDone("use_photo") and not cmn.IsEventDone("get_crownofdarkness") then
    --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    common_impl.current_dialog = "obj_worldofdarkness_dialog_naya3";
    ObjSet("anm_worldofdarkness_dialog_naya3_hands_2",  { playing = 1 });
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  if not ( cmn.IsEventDone( "opn_worldofdarkness" ) ) then
    cmn.Lock( 1 );
  else 
    ObjMultiSet( { {"anm_worldofdarkness_fireflies", { playing = 1 }},
                   {"anm_worldofdarkness_firefly_wradrobe", { playing = 1 }} } );
  end;
  
  cmn.StopAllEnv("assets/levels/level1/audio/env/aud_worldofdarkness_env");
  cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_worldofdarkness_env");
  
  private.tv_anims_play();
  
  --анимация морф-оъекта
  if cmn.IsCollectableAvailible(3) then
    private.AnimMorphObject();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_switch()

  local item = "inv_switch";

  if cmn.ApplyObj( item, "gzz_worldofdarkness_firtree" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_firtree" );

  elseif ( cmn.ApplyObj( item, "obj_firtree_use_switch" ) ) then

    cmn.CallEventHandler( "use_switch_inv" );
    cmn.CallEventHandler( "use_switch_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_switch" );
      cmn.CallEventHandler( "use_switch_end" );
      
      cmn.MiniGameShow();
    
    end;
    
    local anm_lights = function ()
      
      ObjAnimate( "obj_firtree_game", "alp", 0, 0, func_after, { 0, 0, 0,    0.5, 0, 0.7,   0.8, 0, 0.5,  1.1, 0, 1  } );
      
    end;
    
    local anm_switch = function ()
      
      ObjSet("anm_firtree_use_switch",  { alp = 1, playing = 1, endtrig = anm_lights });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_arm_lamp");

    ObjAnimate("anm_firtree_use_switch", "alp", 0, 0, anm_switch, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lamp()

  local item = "inv_lamp";

  if cmn.ApplyObj( item, "gzz_worldofdarkness_wardrobe" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_wardrobe" );

  elseif ( cmn.ApplyObj( item, "obj_wardrobe_use_lamp" ) and cmn.IsEventDone("use_key") ) then

    cmn.CallEventHandler( "use_lamp_inv" );
    cmn.CallEventHandler( "use_lamp_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lamp" );
      cmn.CallEventHandler( "use_lamp_end" );
      
    end;
    
    local anm_interface = function ()
      
      cmn.StopAllEnv("assets/levels/level1/audio/env/aud_worldofdarkness_env");
      cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_worldofdarkness_env");
      
      ObjAnimate("obj_wardrobe_hop_interface", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
    local vid_play = function ()
      
      local anm_vid = function ()
        
        ObjAnimate("vid_wardrobe_shadow_gone", "alp", 0, 0, anm_interface, { 0, 0, 1,   0.5, 0, 0 });
        
      end;
      
      ObjDelete("vid_wardrobe_back_2");
      
      VidPlay("vid_wardrobe_shadow_gone", anm_vid);
      
    end;
    
    ObjAttach("vid_wardrobe_shadow_gone", "zz_wardrobe");

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_take_thing_to_monster");

    ObjAnimate("vid_wardrobe_shadow_gone", "alp", 0, 0, vid_play, { 0, 0, 0,   0.5, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_key()

  local item = "inv_key";

  if cmn.ApplyObj( item, "gzz_worldofdarkness_wardrobe" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_wardrobe" );

  elseif ( cmn.ApplyObj( item, "obj_wardrobe_use_key" ) ) then

    cmn.CallEventHandler( "use_key_inv" );
    cmn.CallEventHandler( "use_key_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_key" );
      cmn.CallEventHandler( "use_key_end" );
    
    end;
    
    local anm_jumpscare = function ()
      
      cmn.PlayAudio("env", "assets/levels/level1/audio/env/aud_loop_monster_env");
      
      --change
      ObjAnimate("anm_wardrobe_firefly", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      VidPlay("vid_wardrobe_shadow", func_after);
      
    end;
    
    ObjAttach("vid_wardrobe_shadow", "zz_wardrobe");

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_key_door_cupboard");

    ObjMultiSet( { {"anm_wardrobe_door",  { animfunc = "func_use_key", frame = 0, playing = 1, endtrig = anm_jumpscare }},
                   {"spr_wardrobe_back_2", { alp = 1 }} } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_photo()

  local item = "inv_photo";

  if cmn.ApplyObj( item, "gzz_worldofdarkness_monster" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_monster" );

  elseif ( cmn.ApplyObj( item, "obj_monster_use_photo" ) ) then

    cmn.CallEventHandler( "use_photo_inv" );
    cmn.CallEventHandler( "use_photo_beg" );

    local func_after = function ()

      --cmn.Lock( 0 );

      cmn.SetEventDone( "use_photo" );
      cmn.CallEventHandler( "use_photo_mid" );
      
      common.CloseSubRoom();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_take_picture_to_girl");

    ObjSet("anm_monster_monster_morph",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bulb()

  local item = "inv_bulb";

  if cmn.ApplyObj( item, "gzz_worldofdarkness_bed" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_bed" );

  elseif ( cmn.ApplyObj( item, "obj_bed_use_bulb" ) and cmn.IsEventDone("clk_oldbulbout") ) then

    cmn.CallEventHandler( "use_bulb_inv" );
    private.use_bulb_end();
    
  elseif ( cmn.ApplyObj( item, "obj_bed_use_bulb" ) and not cmn.IsEventDone("clk_oldbulbout") ) then

    cmn.CallEventHandler( "use_bulb_inv" );
    public.clk_oldbulbout(2);

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function private.use_bulb_end()

  cmn.CallEventHandler( "use_bulb_beg" );

  local func_after = function ()

    cmn.Lock( 0 );

    cmn.SetEventDone( "use_bulb" );
    cmn.CallEventHandler( "use_bulb_end" );
  
  end;
  
  local anm_lamp_2 = function ()
    
    ObjSet("anm_bed_use_bulb",  { pos_z = 2 });
    
  end;

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_change_broken_lamp_picture");

  ObjMultiSet( { {"anm_bed_use_bulb",  { alp = 1, playing = 1, endtrig = func_after }},
                 {"tmr_bed_timer", { time = 0.9, playing = 1, endtrig = anm_lamp_2 }} } );

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_bulb()

  cmn.SetEventDone( "get_bulb" );
  cmn.CallEventHandler( "get_bulb" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_photopart2") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_photopart2()

  cmn.SetEventDone( "get_photopart2" );
  cmn.CallEventHandler( "get_photopart2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_bulb") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_photopart4()

  cmn.SetEventDone( "get_photopart4" );
  cmn.CallEventHandler( "get_photopart4" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_photobasis()

  cmn.SetEventDone( "get_photobasis" );
  cmn.CallEventHandler( "get_photobasis" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_switch()

  cmn.SetEventDone( "get_switch" );
  cmn.CallEventHandler( "get_switch" );
  
  iOS_RateMe();
  
  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_lamp()

  cmn.SetEventDone( "get_lamp" );
  cmn.CallEventHandler( "get_lamp" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_key") and cmn.IsEventDone("get_photopart3") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_key()
  
  cmn.SetEventDone( "get_key" );
  cmn.CallEventHandler( "get_key" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_lamp") and cmn.IsEventDone("get_photopart3") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_photopart3()

  cmn.SetEventDone( "get_photopart3" );
  cmn.CallEventHandler( "get_photopart3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_key") and cmn.IsEventDone("get_lamp") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_crownofdarkness()
  
  local func_after = function ()
    
    cmn.Lock( 0 );
    
    cmn.CallEventHandler( "get_crownofdarkness_end" );

    --common_impl.PlayBackgroundMusic();
    
    int_diary.AddDiarypage( 11 );

  end;

  cmn.SetEventDone( "get_crownofdarkness" );
  cmn.CallEventHandler( "get_crownofdarkness_inv" );
  cmn.CallEventHandler( "get_crownofdarkness_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  common_impl.current_dialog = "";
  
  cmn.Lock( 1 );
  ObjAnimate("obj_worldofdarkness_dialog_naya3", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_oldbulbout(num)

  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_take_broken_lamp");

  local func_after = function ()

    cmn.SetEventDone( "clk_oldbulbout" );
    cmn.CallEventHandler( "clk_oldbulbout" );

    if num == 1 then
      cmn.Lock(0);
    else 
      private.use_bulb_end();
    end;

  end;
  
  local anm_lamp_2 = function ()
    
    ObjSet("anm_bed_lamp_touch",  { pos_z = 10 });
    
  end;

  ObjMultiSet( { {"anm_bed_lamp_touch",  { alp = 1, playing = 1, endtrig = func_after }},
                 {"tmr_bed_timer", { time = 0.5, playing = 1, endtrig = anm_lamp_2 }} } );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_worldofdarkness()

  if not ( cmn.IsEventDone( "opn_worldofdarkness" ) ) then
    
    local func_after = function ()
      
      cmn.Lock( 0 );
      cmn.CallEventHandler("opn_worldofdarkness");
      cmn.ShowBbt( "worldofdarkness_open" );
      
      interface_impl.ShowGlobalTask();
      
      ObjMultiSet( { {"anm_worldofdarkness_fireflies", { playing = 1 }},
                     {"anm_worldofdarkness_firefly_wradrobe", { playing = 1 }} } );
      
    end;
    
    cmn.SetEventDone( "opn_worldofdarkness" );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_firefly_anim");
    
    ObjSet("anm_worldofdarkness_fireflies",  { alp = 1, playing = 1, endtrig = func_after });
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_3_1", { alp = 1 }},
                 {"spr_col_3_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_3_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_3_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_3_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_3_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_3_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_3_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function private.tv_anims_play()
  
  local tme = math.random(10, 20);
  
  if #private.tv_anims_ed == 0 then
    for i = 1, #private.tv_anims, 1 do
      private.tv_anims_ed[i] = private.tv_anims[i];
    end;
  end;
  
  local anim = math.random(1, #private.tv_anims_ed);
  table.remove(private.tv_anims_ed, anim);
  
  local end_anim = function ()
    
    ObjSet("fx_worldofdarkness_tv_"..anim,  { active = 0, visible = 0 });
    ObjDetach("fx_worldofdarkness_tv_"..anim);
    
    private.tv_anims_play();
    
  end;
                 
  ObjAttach("fx_worldofdarkness_tv_"..anim, "rm_worldofdarkness");

  ObjMultiSet( { {"tmr_worldofdarkness_timer", { time = tme, playing = 1, endtrig = end_anim }},
                 {"fx_worldofdarkness_tv_"..anim, { active = 1, visible = 1 }}} );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_wardrobe()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_door_claws");
  
  cmn.ShowBbt( "obj_wardrobe_use_key" );
  
  ObjSet("anm_wardrobe_door",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_lamp()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_xx_broken_picture");
  
  cmn.ShowBbt( "obj_bed_use_bulb" );
  
  ObjSet("anm_bed_lamp_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_monster()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_girl_monster");
  
  cmn.ShowBbt( "obj_monster_use_photo" );
  
  local func_after = function ()
    
    cmn.Lock(0);
    
    ObjMultiSet( { {"anm_monster_monster", { alp = 1, playing = 1 }},
                   {"anm_monster_monster_touch", { alp = 0} } } );
    
  end;
  
  ObjMultiSet( { {"anm_monster_monster_touch", { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_monster_monster", { alp = 0, playing = 0 } } } );
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_naya3_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "worldofdarkness", "naya3", 2 );
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "use_photo_end" );
    
    cmn.ShowBbt( "worldofdarkness_after_dialog" );
    
    ObjSet("anm_worldofdarkness_dialog_naya3_hands_2",  { playing = 1 });
    
  end;
  
  local anm_hide = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_worldofdarkness_dialog_naya3_lipsync2");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_worldofdarkness_dialog_naya3_timer",  { playing = 0 }},
                   {"anm_worldofdarkness_dialog_naya3_head", { alp = 1 }},
                   {"anm_worldofdarkness_dialog_naya3_hands_1", { alp = 0, playing = 0 }},
                   {"anm_worldofdarkness_dialog_naya3_hand_give", { alp = 1, playing = 1, endtrig = dialog_end }} } );
    
  end;
  
  local naya_talks2 = function ()
  
    ObjDelete("vid_worldofdarkness_dialog_naya3_lipsync1");
    ObjAttach("vid_worldofdarkness_dialog_naya3_lipsync2", "obj_worldofdarkness_dialog_naya3");
  
    cmn.ShowDlgBbt( "dlg_naya3_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level1/audio/voc/aud_1_lvl_naya_6_voc");
    private.dlg_lipsync = "vid_worldofdarkness_dialog_naya3_lipsync2";
    
    ObjMultiSet( { {"tmr_worldofdarkness_dialog_naya3_timer", { endtrig = anm_hide, time = 4, playing = 1 }},
                   {"anm_worldofdarkness_dialog_naya3_head", { alp = 0 }},
                   {"vid_worldofdarkness_dialog_naya3_lipsync2", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_hide }},
                   {"obj_character_dialog_continue", { event_mup = anm_hide }} } );
  
  end;
                 
  private.dlg_lipsync = "vid_worldofdarkness_dialog_naya3_lipsync1";

  cmn.ShowDlgBbt( "dlg_naya3_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level1/audio/voc/aud_1_lvl_naya_5_voc");

  ObjMultiSet( { {"tmr_worldofdarkness_dialog_naya3_timer", { time = 7, playing = 1, endtrig = naya_talks2 }},
                 {"vid_worldofdarkness_dialog_naya3_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = naya_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = naya_talks2 }} } );
  
end; 
--------------------------------------------------------------------------------------------
function public.skip_dlg_naya3()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "use_photo_end" );
    cmn.ShowBbt( "worldofdarkness_after_dialog" );
    
    ObjSet("anm_worldofdarkness_dialog_naya3_hands_2",  { playing = 1 });
    
  end;
  
  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();
  
  --common_impl.PlayBackgroundMusic();
  
  ObjMultiSet( { {"tmr_worldofdarkness_dialog_naya3_timer",  { playing = 0 }},
                 {"anm_worldofdarkness_dialog_naya3_head", { alp = 1 }},
                 {"anm_worldofdarkness_dialog_naya3_hands_1", { alp = 0, playing = 0 }},
                 {"anm_worldofdarkness_dialog_naya3_hand_give", { alp = 1, playing = 1, endtrig = func_after_dlg }} } );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Wardrobe *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_wardrobe = {};
public.zz_wardrobe = {};

function private.Init_Wardrobe()
  
  private.zz_wardrobe.chosen = {0, 0};
  private.zz_wardrobe.pos = {
    { {196, 199}, {-54, -208}, {71, -5} },
    { {95, 174}, {-143, -49}, {-24, 62} },
    { {20, -49}, {-146, -199}, {-63, -124} },
    { {-12, 42}, {-129, -133}, {-70, -45} },
    { {28, 135}, {-50, -26}, {-11, 54} },
    { {50, 174}, {-43, -118}, {4, 28} }
  };
  -----------------------------------------------------------------------------------
  game.hint[ "win_wardrobe" ] = {
    type = "use",
    inv_obj = "spr_wardrobe_pair_1_1",
    use_place = "spr_wardrobe_pair_1_2",
    room = "rm_worldofdarkness",
    zz = "zz_wardrobe",
    zz_gate = "gzz_worldofdarkness_wardrobe"
  };
  -----------------------------------------------------------------------------------
  local win_wardrobe = function ()
    
    if cmn.IsEventDone( "win_wardrobe" ) then
      
      ObjDelete( "obj_wardrobe_hop_interface" );
      ObjDelete( "obj_wardrobe_game_fly" );
  
      ObjDelete( "spr_worldofdarkness_wardrobe_mmg_items" );
      ObjDelete( "spr_worldofdarkness_wardrobe_toys" );
      
      ObjSet("anm_wardrobe_game_win",  { input = 1, frame = 300 });

      --ObjMultiSet( { {"anm_wardrobe_game_win",  { input = 1, frame = 300 }},
      --               {"spr_worldofdarkness_wardrobe_toys_2", { alp = 1 }} } );
                     
    end;
  
  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_wardrobe", win_wardrobe, "rm_worldofdarkness" );
  
end;
--*********************************************************************************************************************
function private.zz_wardrobe.StartConditions()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_wardrobe" ].state = { 0, 0, 0, 0, 0, 0 }; --found pairs
  
end;
-----------------------------------------------------------------------------------
function private.zz_wardrobe.DrawScene()
  
  for i = 1, #private.zz_wardrobe.state, 1 do
    
    if private.zz_wardrobe.chosen[1] == i then
      local second = 1;
      if private.zz_wardrobe.chosen[2] == 1 then
        second = 2;
      end;
      ObjAttach("spr_wardrobe_pair_"..private.zz_wardrobe.chosen[1].."_"..private.zz_wardrobe.chosen[2], "obj_wardrobe_game_fly");
      ObjAttach("spr_wardrobe_pair_"..i.."_"..second, "obj_wardrobe_game");
    else 
      ObjAttach("spr_wardrobe_pair_"..i.."_1", "obj_wardrobe_game");
      ObjAttach("spr_wardrobe_pair_"..i.."_2", "obj_wardrobe_game");
    end;
    
    if private.zz_wardrobe.state[i] == 0 then
      ObjMultiSet( { {"spr_wardrobe_pair_"..i.."_1", { alp = 1, input = 1 }},
                     {"spr_wardrobe_pair_"..i.."_2", { alp = 1, input = 1 }} } );
    else 
      ObjMultiSet( { {"spr_wardrobe_pair_"..i.."_1", { alp = 0, input = 0 }},
                     {"spr_wardrobe_pair_"..i.."_2", { alp = 0, input = 0 }},
                     {"spr_wardrobe_pair_"..i.."_1_sh", { alp = 0 }},
                     {"spr_wardrobe_pair_"..i.."_2_sh", { alp = 0 }} } );
    end;            
    
  end;
                 
  if not cmn.IsEventDone("win_wardrobe") then
    private.zz_wardrobe.CheckHint();
    ObjSet("txt_wardrobe_hop_text_2",  { text = "x "..private.zz_wardrobe.CheckCount() });
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_wardrobe.ChooseItem( pair, num )
  
  cmn.Lock( 1 );
  
  if private.zz_wardrobe.chosen[1] ~= 0 then

    --cancel selection
    if private.zz_wardrobe.chosen[1] == pair and private.zz_wardrobe.chosen[2] == num then
      
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_things_click");

      private.zz_wardrobe.chosen = {0, 0};
      private.zz_wardrobe.CheckHint();
      private.zz_wardrobe.SelectAnim( pair, num, 0 );
      
      ObjSet("tmr_wardrobe_game_timer",  { time = 0.3, playing = 1, endtrig = function () cmn.Lock( 0 ); end });

    --found pair
    elseif private.zz_wardrobe.chosen[1] == pair then
    
      local old = {};
      old[1] = private.zz_wardrobe.chosen[1];
      old[2] = private.zz_wardrobe.chosen[2];
      
      private.zz_wardrobe.chosen = {0, 0};
      private.zz_wardrobe.CheckHint();
      private.zz_wardrobe.FoundPair( pair );
      
      ObjAnimate("spr_wardrobe_pair_"..old[1].."_"..old[2].."_focus", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0 });
      ObjAnimate("spr_wardrobe_pair_"..old[1].."_"..old[2], "scale_xy", 0, 0, "", { 0, 0, 1.2, 1.2,   0.2, 0, 1, 1 });
      
    else 
      
      cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_things_wrong");
      
      local old = {};
      old[1] = private.zz_wardrobe.chosen[1];
      old[2] = private.zz_wardrobe.chosen[2];
      private.zz_wardrobe.chosen[1] = pair;
      private.zz_wardrobe.chosen[2] = num;
      
      private.zz_wardrobe.CheckHint();
      
      private.zz_wardrobe.SelectAnim( old[1], old[2], 0 );
      private.zz_wardrobe.SelectAnim( pair, num, 1 );
      
      ObjSet("tmr_wardrobe_game_timer",  { time = 0.3, playing = 1, endtrig = function () cmn.Lock( 0 ); end });

    end;

  --first selected
  else 
  
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_things_click");
    
    private.zz_wardrobe.chosen[1] = pair;
    private.zz_wardrobe.chosen[2] = num;
    
    private.zz_wardrobe.CheckHint();
    
    private.zz_wardrobe.SelectAnim( pair, num, 1 );
    
    ObjSet("tmr_wardrobe_game_timer",  { time = 0.3, playing = 1, endtrig = function () cmn.Lock( 0 ); end });

  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_wardrobe.SelectAnim( pair, num, inout )
  
  local obj = "spr_wardrobe_pair_"..pair.."_"..num;
  
  if inout == 0 then
    
    ObjAttach(obj, "obj_wardrobe_game");
    
    ObjAnimate(obj.."_focus", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate(obj, "scale_xy", 0, 0, "", { 0, 0, 1.2, 1.2,   0.3, 0, 1, 1 });
    
  else 
    
    ObjAttach(obj, "obj_wardrobe_game_fly");
    
    ObjAnimate(obj.."_focus", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    ObjAnimate(obj, "scale_xy", 0, 0, "", { 0, 0, 1, 1,   0.3, 0, 1.2, 1.2 });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_wardrobe.FoundPair( pair )
  
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_things_divide");
  
  private.zz_wardrobe.state[ pair ] = 1;
  
  private.zz_wardrobe.CheckHint();
  ObjSet("txt_wardrobe_hop_text_2",  { text = "x "..private.zz_wardrobe.CheckCount() });
  
  ObjMultiSet( { {"spr_wardrobe_pair_"..pair.."_1", { input = 0 }},
                 {"spr_wardrobe_pair_"..pair.."_2", { input = 0 }} } );
  
  ObjAttach("spr_wardrobe_pair_"..pair.."_1", "obj_wardrobe_game_fly");
  ObjAttach("spr_wardrobe_pair_"..pair.."_2", "obj_wardrobe_game_fly");
  
  ObjAnimate("spr_wardrobe_pair_"..pair.."_1_sh", "alp", 0, 0, "", { 0, 0, 1,   0.1, 0, 0 });
  ObjAnimate("spr_wardrobe_pair_"..pair.."_2_sh", "alp", 0, 0, "", { 0, 0, 1,   0.1, 0, 0 });
  
  ObjAnimate("spr_wardrobe_pair_"..pair.."_1", "alp", 0, 0, private.zz_wardrobe.CheckWin, { 0, 0, 1,   0.4, 0, 1,  0.7, 0, 0 });
  ObjAnimate("spr_wardrobe_pair_"..pair.."_2", "alp", 0, 0, "", { 0, 0, 1,   0.4, 0, 1,  0.7, 0, 0 });
  
  ObjAnimate("spr_wardrobe_pair_"..pair.."_1", "pos_xy", 0, 0, "", { 
    0, 0, private.zz_wardrobe.pos[pair][1][1], private.zz_wardrobe.pos[pair][1][2],
  0.4, 0, private.zz_wardrobe.pos[pair][3][1], private.zz_wardrobe.pos[pair][3][2] });
  
  ObjAnimate("spr_wardrobe_pair_"..pair.."_2", "pos_xy", 0, 0, "", { 
    0, 0, private.zz_wardrobe.pos[pair][2][1], private.zz_wardrobe.pos[pair][2][2],
  0.4, 0, private.zz_wardrobe.pos[pair][3][1], private.zz_wardrobe.pos[pair][3][2] });
  
end;
-----------------------------------------------------------------------------------
function public.zz_wardrobe.FocusItem( pair, num, inout )
  
--  local obj = "spr_wardrobe_pair_"..pair.."_"..num.."_focus";
--  
--  local alf = ObjGet( obj ).alp;
--  local tme = 0;
--  
--  if inout == 0 then
--    SetCursor(CURSOR_DEFAULT);
--    tme = alf * 0.3;
--  else 
--    SetCursor(CURSOR_HAND);
--    tme = ( 1 - alf ) * 0.3;
--  end;
--  
--  --DbgTrace(private.zz_wardrobe.chosen[1].." "..pair);
--  --DbgTrace(private.zz_wardrobe.chosen[2].." "..num);
--  
--  if private.zz_wardrobe.chosen[1] ~= pair or private.zz_wardrobe.chosen[2] ~= num then
--
--    ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
--    
--  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_wardrobe.CheckHint()
  
  local vacant = 1;
  
  for i = 1, 6, 1 do
    
    if private.zz_wardrobe.state[i] == 0 then
      vacant = i;
      break;
    end;
    
  end;
  
  if private.zz_wardrobe.chosen[1] == 0 then
  
    game.hint[ "win_wardrobe" ].type = "use";
    game.hint[ "win_wardrobe" ].inv_obj = "spr_wardrobe_pair_"..vacant.."_1";
    game.hint[ "win_wardrobe" ].use_place = "spr_wardrobe_pair_"..vacant.."_2";
    
  else 
    
    local num2 = 2;
    if private.zz_wardrobe.chosen[2] == 2 then
      num2 = 1;
    end;
    
    game.hint[ "win_wardrobe" ].type = "click";
    game.hint[ "win_wardrobe" ].use_place = "spr_wardrobe_pair_"..private.zz_wardrobe.chosen[1].."_"..num2;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_wardrobe.CheckCount()
  
  local count = 0;
  
  for i = 1, 6, 1 do
    
    if private.zz_wardrobe.state[i] == 0 then
      count = count + 1;
    end;
    
  end;
  
  return count;
  
end;
-----------------------------------------------------------------------------------
function private.zz_wardrobe.CheckWin()
  
  local win_flag = true;

  for i = 1, #private.zz_wardrobe.state, 1 do

    if private.zz_wardrobe.state[i] == 0 then

      win_flag = false;
      break;

    end;

  end;

  if win_flag then

    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_win_mmg_things");
    
    local anm_win = function ()
      
      ObjSet("anm_wardrobe_game_win",  { playing = 1, endtrig = private.zz_wardrobe.Win });
      
    end;

    ObjAnimate("obj_wardrobe_hop_interface", "alp", 0, 0, anm_win, { 0, 0, 1,   0.5, 0, 0 });

  else

    cmn.Lock( 0 );

  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_wardrobe.Win()
  
  cmn.Lock( 0 );
  
  cmn.SetEventDone( "win_wardrobe" );
  cmn.CallEventHandler( "win_wardrobe" );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Firtree *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_firtree = {};
public.zz_firtree = {};

function private.Init_Firtree()
  
  private.zz_firtree.connect = {
    {2, 13}, {1, 3}, {2, 4}, {3, 5}, {4, 6},
    {5, 7}, {6, 8}, {7, 9}, {8, 10}, {9},
    {12}, {11, 13}, {12}
  };
  private.zz_firtree.start_state = { 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0 };
  -----------------------------------------------------------------------------------
  game.hint[ "win_firtree" ] = {
    type = "win",
    room = "rm_worldofdarkness",
    zz = "zz_firtree",
    zz_gate = "gzz_worldofdarkness_firtree"
  };
  -----------------------------------------------------------------------------------
  local win_firtree = function ()
    
    if cmn.IsEventDone( "win_firtree" ) then

      ObjMultiSet( {
        { "anm_firtree_bulbs",  { alp = 1, input = 1, frame = 300 } },
        { "spr_worldofdarkness_firtree_debris", { alp = 1 } },
        { "spr_worldofdarkness_firtree_photo", { alp = 1 } },
        { "spr_worldofdarkness_firtree_bulb", { alp = 1 } },
        { "spr_worldofdarkness_firtree_bulbs_off", { alp = 1 } }
      } );
  
      ObjDelete("obj_firtree_game");

      ObjDelete( "spr_worldofdarkness_firtree_bulbs" );
      ObjDelete( "spr_worldofdarkness_firtree_lights" );
                     
    end;
  
  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_firtree", win_firtree, "rm_worldofdarkness" );
  
end;
--*********************************************************************************************************************
function private.zz_firtree.StartConditions()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_firtree" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_firtree" ].state = { 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0 }; --lights on
  
end;
-----------------------------------------------------------------------------------
function public.zz_firtree.Reset()
  
  local need_r = false;
  
  for i = 1, #private.zz_firtree.state, 1 do
    
    if private.zz_firtree.state[i] ~= private.zz_firtree.start_state[i] then
      
      if not need_r then
        need_r = true;
      end;
      
      ObjAnimate("spr_firtree_bulb_"..i, "alp", 0, 0, "", { 0, 0, private.zz_firtree.state[i],   0.3, 0, private.zz_firtree.start_state[i] });
      
    end;
    
  end;
  
  if need_r then
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_tree_click");
    private.zz_firtree.StartConditions();
    
    private.zz_firtree.state = ng_global.progress[ ng_global.currentprogress ][ "win_firtree" ].state;
    ObjSet("tmr_firtree_game_timer",  { time = 0.5, playing = 1, endtrig = function() cmn.Lock( 0 ); end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_firtree.Skip()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_tree_click");
  
  ng_global.progress[ ng_global.currentprogress ][ "win_firtree" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_firtree" ].state = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 };
  
  for i = 1, #private.zz_firtree.state, 1 do
    
    if private.zz_firtree.state[i] == 0 then
      ObjAnimate("spr_firtree_bulb_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    end;
    
  end;
  
  private.zz_firtree.state = ng_global.progress[ ng_global.currentprogress ][ "win_firtree" ].state;
  ObjSet("tmr_firtree_game_timer",  { time = 0.5, playing = 1, endtrig = private.zz_firtree.CheckWin });
  
end;
-----------------------------------------------------------------------------------
function private.zz_firtree.DrawScene()
  
  for i = 1, #private.zz_firtree.state, 1 do
    
    if private.zz_firtree.state[i] == 0 then
      ObjSet("spr_firtree_bulb_"..i,  { alp = 0 });
    else 
      ObjSet("spr_firtree_bulb_"..i,  { alp = 1 });
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_firtree.FocusBulb( num, inout )
  
  local obj = "spr_firtree_bulb_"..num.."_focus";
  
  local alf = ObjGet( obj ).alp;
  local tme = 0;
  
  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
  end;
  
  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.zz_firtree.ChooseBulb( num )
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_tree_click");
  
  local change = {};
  change[1] = {};
  change[1][1] = num;
  change[1][2] = private.zz_firtree.state[num];
  
  if private.zz_firtree.state[num] == 1 then
    change[1][3] = 0;
    private.zz_firtree.state[num] = 0;
  else 
    change[1][3] = 1;
    private.zz_firtree.state[num] = 1;
  end;
  
  for i = 1, #private.zz_firtree.connect[num], 1 do
    
    table.insert( change, {} );
    local len = #change;
    change[len] = {};
    change[len][1] = private.zz_firtree.connect[num][i];
    change[len][2] = private.zz_firtree.state[ private.zz_firtree.connect[num][i] ];
    
    if private.zz_firtree.state[ private.zz_firtree.connect[num][i] ] == 0 then
      change[len][3] = 1;
      private.zz_firtree.state[ private.zz_firtree.connect[num][i] ] = 1;
    else 
      change[len][3] = 0;
      private.zz_firtree.state[ private.zz_firtree.connect[num][i] ] = 0;
    end;
      
  end;
  
  for i = 1, #change, 1 do
    
    ObjAnimate("spr_firtree_bulb_"..change[i][1], "alp", 0, 0, "", { 0, 0, change[i][2],   0.3, 0, change[i][3] });
    
  end;
  
  ObjSet("tmr_firtree_game_timer",  { alp = 1, playing = 1, endtrig = private.zz_firtree.CheckWin });
  
end;
-----------------------------------------------------------------------------------
function private.zz_firtree.CheckWin()
  
  local win_flag = true;

  for i = 1, #private.zz_firtree.state, 1 do

    if private.zz_firtree.state[i] == 0 then

      win_flag = false;
      break;

    end;

  end;

  if win_flag then

    cmn.Lock(1);
    common_impl.PauseAchiev(1);
    
    cmn.MiniGameHide("firtree");
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_mmg_tree_win");
    
    local func_after = function ()
      
      ObjSet("anm_firtree_bulbs",  { alp = 1, playing = 1, endtrig = private.zz_firtree.Win });
      
    end;

    ObjAnimate( "obj_firtree_game", "alp", 0, 0, func_after, { 0, 0, 1,    0.5, 0, 0.5,   0.8, 0, 0.7,  1.1, 0, 0  } );

  else

    cmn.Lock( 0 );

  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_firtree.Win()
  
  cmn.Lock( 0 );
  common_impl.PauseAchiev(0);
  
  cmn.SetEventDone( "win_firtree" );
  cmn.CallEventHandler( "win_firtree" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_firtree" ].skip == 0 and ng_global.noskipgames[ "win_firtree" ] == nil then

    ng_global.noskipgames[ "win_firtree" ] = 1;
    common_impl.CheckAchiev("mg");

  end;
  
end;
--****************************************************************************************************************
public.zz_bed = {};

-----------------------------------------------------------------------------------
function public.zz_bed.StartDrag( num )
  
  cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_broken_mirror_click");
  
  ObjAttach("spr_bed_part_"..num, "obj_bed_pieces_fly");
  ObjAnimate("spr_bed_part_"..num.."_sh", "alp", 0, 0, "", { 0, 0, 1,   0.15, 0, 0 });
  
end;
-----------------------------------------------------------------------------------
function public.zz_bed.UsePart( num )
  
  item = "spr_bed_part_"..num;

  if ( cmn.ApplyObj( item, "obj_bed_use_lamp_parts" ) ) then

    cmn.CallEventHandler( "use_bedlamppart"..num.."_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_bedlamppart"..num );
      cmn.CallEventHandler( "use_bedlamppart"..num.."_end" );

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level1/audio/sfx/aud_insert_piece_lamp_"..num);
    
    ObjAnimate("spr_bed_lamp_part_"..num, "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    
  else 

    cmn.WrongApply();
    ObjAttach(item, "obj_bed_pieces");
    ObjAnimate(item.."_sh", "alp", 0, 0, "", { 0, 0, 0,   0.15, 0, 1 });

  end;
  
end;
--****************************************************************************************************************