-- name=rm_corridor
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_corridor";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Scanner();
  --------------------------------------------------------------------------------------------
  -- function get_captainsign () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_captainsign" ] = {
    type = "get",
    get_obj = "spr_armorydoor_captainsign",
    room = private.room_objname,
    zz = "zz_armorydoor",
    zz_gate = "gzz_corridor_armorydoor"
  };
  --------------------------------------------------------------------------------------------
  local get_captainsign_inv = function ()
  
    interface.InventoryItemAdd( "inv_captainsign", "spr_armorydoor_captainsign" );
  
  end;
  local get_captainsign_end = function ()
  
    ObjDelete( "gfx_armorydoor_captainsign" );
    ObjDelete( "spr_armorydoor_captainsign_sh" );
    ObjDelete( "spr_armorydoor_captainsign_bl" );

    ObjDelete( "spr_corridor_armorydoor_captainsign" );
  
  end;
  
  cmn.AddSubscriber( "get_captainsign", get_captainsign_inv );
  cmn.AddSubscriber( "get_captainsign", get_captainsign_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_acid () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_acid" ] = {
    type = "get",
    get_obj = "obj_holeincovering_acid",
    room = private.room_objname,
    zz = "zz_holeincovering",
    zz_gate = "gzz_corridor_holeincovering"
  };
  --------------------------------------------------------------------------------------------
  local get_acid_inv = function ()
  
    interface.InventoryItemAdd( "inv_acid", "obj_holeincovering_acid" );
  
  end;
  local get_acid_end = function ()
  
  end;
  
  cmn.AddSubscriber( "get_acid", get_acid_inv );
  cmn.AddSubscriber( "get_acid", get_acid_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_shippart2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_shippart2" ] = {
    type = "get",
    get_obj = "spr_holeincovering_shippart2",
    room = private.room_objname,
    zz = "zz_holeincovering",
    zz_gate = "gzz_corridor_holeincovering"
  };
  --------------------------------------------------------------------------------------------
  local get_shippart2_inv = function ()
  
    interface.InventoryItemAdd( "inv_shippart2", "spr_holeincovering_shippart2" );
    int_map_impl.DecreaseRoomTasks("rm_corridor");
  
  end;
  local get_shippart2_end = function ()
  
    ObjDelete( "gfx_holeincovering_shippart2" );
    ObjDelete( "gzz_corridor_holeincovering" );
  
  end;
  
  cmn.AddSubscriber( "get_shippart2", get_shippart2_inv );
  cmn.AddSubscriber( "get_shippart2", get_shippart2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_adhesivetape () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_adhesivetape" ] = {
    type = "get",
    get_obj = "spr_holeincovering_adhesivetape",
    room = private.room_objname,
    zz = "zz_holeincovering",
    zz_gate = "gzz_corridor_holeincovering"
  };
  --------------------------------------------------------------------------------------------
  local get_adhesivetape_inv = function ()
  
    interface.InventoryItemAdd( "inv_adhesivetape", "spr_holeincovering_adhesivetape" );
  
  end;
  local get_adhesivetape_end = function ()
  
    ObjDelete( "gfx_holeincovering_adhesivetape" );
    ObjDelete( "spr_holeincovering_adhesivetape_sh" );

    ObjDelete( "spr_corridor_holeincovering_tape" );
  
  end;
  
  cmn.AddSubscriber( "get_adhesivetape", get_adhesivetape_inv );
  cmn.AddSubscriber( "get_adhesivetape", get_adhesivetape_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_element3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_element3" ] = {
    type = "get",
    get_obj = "spr_robot_element3",
    room = private.room_objname,
    zz = "zz_robot",
    zz_gate = "gzz_corridor_robot"
  };
  --------------------------------------------------------------------------------------------
  local get_element3_inv = function ()
  
    interface.InventoryItemAdd( "inv_element", "spr_robot_element3", function () cmn.GetMultyObject( 'element', 3 ); end );
    
    if cmn.CheckMultiObject( "element", 3 ) then
      ObjSet("inv_hacker_star_light",  { alp = 1 });
    end;
  
  end;
  local get_element3_end = function ()
  
    ObjDelete( "gfx_robot_element3" );
    ObjDelete( "spr_robot_element3_sh" );

    ObjDelete( "spr_corridor_robot_detail_03" );
  
  end;
  
  cmn.AddSubscriber( "get_element3", get_element3_inv );
  cmn.AddSubscriber( "get_element3", get_element3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wires () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_wires" ] = {
    type = "get",
    get_obj = "spr_robot_wires",
    room = private.room_objname,
    zz = "zz_robot",
    zz_gate = "gzz_corridor_robot"
  };
  --------------------------------------------------------------------------------------------
  local get_wires_inv = function ()
  
    interface.InventoryItemAdd( "inv_wires", "spr_robot_wires" );
  
  end;
  local get_wires_end = function ()
  
    ObjDelete( "gfx_robot_wires" );
    ObjDelete( "spr_corridor_robot_wires" );
  
  end;
  
  cmn.AddSubscriber( "get_wires", get_wires_inv );
  cmn.AddSubscriber( "get_wires", get_wires_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crystal () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_crystal" ] = {
    type = "get",
    get_obj = "spr_robot_crystal",
    room = private.room_objname,
    zz = "zz_robot",
    zz_gate = "gzz_corridor_robot"
  };
  --------------------------------------------------------------------------------------------
  local get_crystal_inv = function ()
  
    interface.InventoryItemAdd( "inv_crystal", "spr_robot_crystal" );
    ObjSet("inv_gun_star_light",  { alp = 1 });
  
  end;
  local get_crystal_end = function ()
  
    ObjDelete( "gfx_robot_crystal" );
    ObjSet("gzz_corridor_robot",  { active = 0, alp = 0 });

    ObjDelete( "spr_corridor_robot_crystal" );
  
  end;
  
  cmn.AddSubscriber( "get_crystal", get_crystal_inv );
  cmn.AddSubscriber( "get_crystal", get_crystal_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_screwdriver () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_screwdriver" ] = {
      type = "get",
      get_obj = "spr_corridor_screwdriver",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_screwdriver_inv = function ()
  
    interface.InventoryItemAdd( "inv_screwdriver", "spr_corridor_screwdriver" );
  
  end;
  local get_screwdriver_mid = function ()
  
    ObjDelete( "gfx_corridor_screwdriver" );
    ObjDelete( "spr_corridor_screwdriver_sh" );
    
  end;
  local get_screwdriver_end = function ()
  
    ObjDelete( "obj_corridor_dialog_jean1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_screwdriver", get_screwdriver_inv );
  cmn.AddSubscriber( "get_screwdriver_inv", get_screwdriver_inv, private.room_objname );
  cmn.AddSubscriber( "get_screwdriver", get_screwdriver_mid, private.room_objname );
  cmn.AddSubscriber( "get_screwdriver_mid", get_screwdriver_mid, private.room_objname );
  cmn.AddSubscriber( "get_screwdriver", get_screwdriver_end, private.room_objname );
  cmn.AddSubscriber( "get_screwdriver_end", get_screwdriver_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_fixedhacker () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_fixedhacker" ] = {
    type = "use",
    inv_obj = "inv_fixedhacker",
    use_place = "obj_scanner_use_fixedhacker",
    room = private.room_objname,
    zz = "zz_scanner",
    zz_gate = "gzz_corridor_scanner"
  };
  --------------------------------------------------------------------------------------------
  local use_fixedhacker_inv = function ()
  
    interface.InventoryItemRemove( "inv_fixedhacker" );
  
  end;
  local use_fixedhacker_beg = function ()
  
    ObjDelete( "obj_scanner_use_fixedhacker" );
    ObjDelete( "anm_scanner_wires_touch" );
  
  end;
  local use_fixedhacker_end = function ()
  
    ObjMultiSet( { {"anm_scanner_use_hacker", { alp = 1, frame = 300 }},
                   {"obj_scanner_game", { alp = 1, input = 1 }},
                   {"spr_corridor_scaner_fixedhacker", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fixedhacker", use_fixedhacker_beg, private.room_objname );
  cmn.AddSubscriber( "use_fixedhacker", use_fixedhacker_inv );
  cmn.AddSubscriber( "use_fixedhacker", use_fixedhacker_end, private.room_objname );
  cmn.AddSubscriber( "use_fixedhacker_inv", use_fixedhacker_inv, private.room_objname );
  cmn.AddSubscriber( "use_fixedhacker_beg", use_fixedhacker_beg, private.room_objname );
  cmn.AddSubscriber( "use_fixedhacker_end", use_fixedhacker_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screwdriver () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_screwdriverrobot" ] = {
    type = "use",
    inv_obj = "inv_screwdriver",
    use_place = "obj_robot_use_screwdriver",
    room = private.room_objname,
    zz = "zz_robot",
    zz_gate = "gzz_corridor_robot"
  };
  --------------------------------------------------------------------------------------------
  game.hint[ "use_screwdriverscanner" ] = {
    type = "use",
    inv_obj = "inv_screwdriver",
    use_place = "obj_scanner_use_screwdriver",
    room = private.room_objname,
    zz = "zz_scanner",
    zz_gate = "gzz_corridor_scanner"
  };
  --------------------------------------------------------------------------------------------

  local use_screwdriverrobot_inv = function ()
  
    if ( cmn.IsEventDone( "use_screwdriverscanner" ) ) then
      interface.InventoryItemRemove( "inv_screwdriver" );
    end;
  
  end;
  local use_screwdriverrobot_beg = function ()
  
    ObjDelete( "obj_robot_use_screwdriver" );
    ObjDelete( "anm_robot_touch" );
    ObjSet("obj_robot_inside",  { alp = 1 });
  
  end;
  local use_screwdriverrobot_end = function ()
  
    ObjDelete( "anm_robot_use_screwdriver" );
    ObjSet( "obj_robot_inside", { input = 1 } );

    ObjDelete( "spr_corridor_robot_cover" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_screwdriverrobot", use_screwdriverrobot_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriverrobot", use_screwdriverrobot_inv );
  cmn.AddSubscriber( "use_screwdriverrobot", use_screwdriverrobot_end, private.room_objname );
  cmn.AddSubscriber( "use_screwdriverrobot_inv", use_screwdriverrobot_inv, private.room_objname );
  cmn.AddSubscriber( "use_screwdriverrobot_beg", use_screwdriverrobot_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriverrobot_end", use_screwdriverrobot_end, private.room_objname );
  --------------------------------------------------------------------------------------------

  local use_screwdriverscanner_inv = function ()
  
    if ( cmn.IsEventDone( "use_screwdriverrobot" ) ) then
      interface.InventoryItemRemove( "inv_screwdriver" );
    end;
  
  end;
  local use_screwdriverscanner_beg = function ()
  
    ObjDelete( "obj_scanner_use_screwdriver" );
    ObjDelete( "anm_scanner_cover_touch" );
    
  
  end;
  local use_screwdriverscanner_end = function ()

    ObjDelete( "spr_corridor_scaner_panel" );
  
    ObjDelete( "anm_scanner_use_screwdriver" );
    ObjSet("obj_scanner_use_wires",  { input = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_screwdriverscanner", use_screwdriverscanner_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriverscanner", use_screwdriverscanner_inv );
  cmn.AddSubscriber( "use_screwdriverscanner", use_screwdriverscanner_end, private.room_objname );
  cmn.AddSubscriber( "use_screwdriverscanner_inv", use_screwdriverscanner_inv, private.room_objname );
  cmn.AddSubscriber( "use_screwdriverscanner_beg", use_screwdriverscanner_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriverscanner_end", use_screwdriverscanner_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wires () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_wires" ] = {
    type = "use",
    inv_obj = "inv_wires",
    use_place = "obj_scanner_use_wires",
    room = private.room_objname,
    zz = "zz_scanner",
    zz_gate = "gzz_corridor_scanner"
  };
  --------------------------------------------------------------------------------------------
  local use_wires_inv = function ()
  
    interface.InventoryItemRemove( "inv_wires" );
  
  end;
  local use_wires_beg = function ()
  
    ObjDelete( "obj_scanner_use_wires" );
  
  end;
  local use_wires_end = function ()
  
    ObjMultiSet( { {"anm_scanner_use_wires", { alp = 1, frame = 300 }},
                   {"obj_scanner_use_adhesivetape", { input = 1 }},
                   {"spr_corridor_scaner_wire_2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wires", use_wires_beg, private.room_objname );
  cmn.AddSubscriber( "use_wires", use_wires_inv );
  cmn.AddSubscriber( "use_wires", use_wires_end, private.room_objname );
  cmn.AddSubscriber( "use_wires_inv", use_wires_inv, private.room_objname );
  cmn.AddSubscriber( "use_wires_beg", use_wires_beg, private.room_objname );
  cmn.AddSubscriber( "use_wires_end", use_wires_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_adhesivetape () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_adhesivetape" ] = {
    type = "use",
    inv_obj = "inv_adhesivetape",
    use_place = "obj_scanner_use_adhesivetape",
    room = private.room_objname,
    zz = "zz_scanner",
    zz_gate = "gzz_corridor_scanner"
  };
  --------------------------------------------------------------------------------------------
  local use_adhesivetape_inv = function ()
  
    interface.InventoryItemRemove( "inv_adhesivetape" );
  
  end;
  local use_adhesivetape_beg = function ()
  
    ObjDelete( "obj_scanner_use_adhesivetape" );
    ObjDelete( "anm_scanner_use_wires" );
    ObjSet("spr_corridor_scaner_lock", { alp = 1 });
  
  end;
  local use_adhesivetape_end = function ()
    
    ObjDelete( "anm_scanner_use_tape" );

    ObjDelete( "spr_corridor_armorydoor_door_dark" );
    ObjDelete( "spr_corridor_armorydoor_captainsign_dark" );
    
    ObjMultiSet( { {"anm_scanner_wires_touch", { alp = 1 }},
                   {"obj_scanner_use_fixedhacker", { input = 1 }},
                   {"spr_corridor_armorydoor_door_light", { alp = 1 }},
                   {"spr_corridor_armorydoor_captainsign", { alp = 1 }},
                   {"gzz_corridor_armorydoor", { alp = 1, input = 1, active = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_adhesivetape", use_adhesivetape_beg, private.room_objname );
  cmn.AddSubscriber( "use_adhesivetape", use_adhesivetape_inv );
  cmn.AddSubscriber( "use_adhesivetape", use_adhesivetape_end, private.room_objname );
  cmn.AddSubscriber( "use_adhesivetape_inv", use_adhesivetape_inv, private.room_objname );
  cmn.AddSubscriber( "use_adhesivetape_beg", use_adhesivetape_beg, private.room_objname );
  cmn.AddSubscriber( "use_adhesivetape_end", use_adhesivetape_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_readybomb () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_readybomb" ] = {
    type = "use",
    inv_obj = "inv_readybomb",
    use_place = "obj_armorydoor_use_readybomb",
    room = private.room_objname,
    zz = "zz_armorydoor",
    zz_gate = "gzz_corridor_armorydoor"
  };
  --------------------------------------------------------------------------------------------
  local use_readybomb_inv = function ()
  
    interface.InventoryItemRemove( "inv_readybomb" );
    int_map_impl.DecreaseRoomTasks("rm_corridor");
  
  end;
  local use_readybomb_beg = function ()
  
    ObjDelete( "obj_armorydoor_use_readybomb" );
  
  end;
  local use_readybomb_end = function ()
  
    ObjDelete( "gzz_corridor_armorydoor" );

    ObjDelete( "spr_corridor_armorydoor_door_light" );

    ObjMultiSet( {
      { "grm_corridor_armory", { input = true, alp = 1 } },
      { "spr_corridor_armorydoor_door_opn", { alp = 1 } }
    } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_corridor_armory_focus");
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_readybomb", use_readybomb_beg, private.room_objname );
  cmn.AddSubscriber( "use_readybomb", use_readybomb_inv );
  cmn.AddSubscriber( "use_readybomb", use_readybomb_end, private.room_objname );
  cmn.AddSubscriber( "use_readybomb_inv", use_readybomb_inv, private.room_objname );
  cmn.AddSubscriber( "use_readybomb_beg", use_readybomb_beg, private.room_objname );
  cmn.AddSubscriber( "use_readybomb_end", use_readybomb_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_emptybottle () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_emptybottle" ] = {
    type = "use",
    inv_obj = "inv_emptybottle",
    use_place = "obj_holeincovering_use_emptybottle",
    room = private.room_objname,
    zz = "zz_holeincovering",
    zz_gate = "gzz_corridor_holeincovering"
  };
  --------------------------------------------------------------------------------------------
  local use_emptybottle_inv = function ()
  
    interface.InventoryItemRemove( "inv_emptybottle" );
  
  end;
  local use_emptybottle_beg = function ()
  
    ObjDelete( "obj_holeincovering_use_emptybottle" );
  
  end;
  local use_emptybottle_end = function ()
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_emptybottle", use_emptybottle_beg, private.room_objname );
  cmn.AddSubscriber( "use_emptybottle", use_emptybottle_inv );
  cmn.AddSubscriber( "use_emptybottle", use_emptybottle_end, private.room_objname );
  cmn.AddSubscriber( "use_emptybottle_inv", use_emptybottle_inv, private.room_objname );
  cmn.AddSubscriber( "use_emptybottle_beg", use_emptybottle_beg, private.room_objname );
  cmn.AddSubscriber( "use_emptybottle_end", use_emptybottle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_manipulator () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_manipulator" ] = {
    type = "use",
    inv_obj = "inv_manipulator",
    use_place = "obj_holeincovering_use_manipulator",
    room = private.room_objname,
    zz = "zz_holeincovering",
    zz_gate = "gzz_corridor_holeincovering"
  };
  --------------------------------------------------------------------------------------------
  local use_manipulator_inv = function ()
  
    interface.InventoryItemRemove( "inv_manipulator" );
  
  end;
  local use_manipulator_beg = function ()
  
    ObjDelete( "obj_holeincovering_use_manipulator" );
  
  end;
  local use_manipulator_end = function ()
  
    ObjDelete( "anm_holeincovering_manipulator_use" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_manipulator", use_manipulator_beg, private.room_objname );
  cmn.AddSubscriber( "use_manipulator", use_manipulator_inv );
  cmn.AddSubscriber( "use_manipulator", use_manipulator_end, private.room_objname );
  cmn.AddSubscriber( "use_manipulator_inv", use_manipulator_inv, private.room_objname );
  cmn.AddSubscriber( "use_manipulator_beg", use_manipulator_beg, private.room_objname );
  cmn.AddSubscriber( "use_manipulator_end", use_manipulator_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_corridorfirst () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_corridorfirst" ] = {
    type = "click",
    use_place = "obj_corridor_clk_corridorfirst",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local clk_corridorfirst_task = function ()
    interface_impl.SetCurrentGlobalTask( 8 );
  end;
  local clk_corridorfirst_beg = function ()
  
    ObjDelete( "obj_corridor_clk_corridorfirst" );
  
  end;
  local clk_corridorfirst_end = function ()
    
    ObjAttach("obj_corridor_dialog_jean1", "rm_corridor");
    
    ObjDelete( "vid_corridor_dialog_jean1_lipsync1" );
    ObjDelete( "vid_corridor_dialog_jean1_lipsync2" );
    
    ObjDelete( "anm_corridor_dialog_jean1_hand_1" );
    ObjDelete( "anm_corridor_dialog_jean1_give" );
  
    ObjMultiSet( { {"obj_corridor_dialog_jean1", { alp = 1, input = 1 }},
                   {"obj_corridor_dialog_jean1_hand_2", { alp = 1, input = 1 }},
                   {"spr_corridor_holeincovering_hole", { alp = 1 }},
                   {"anm_corridor_dialog_jean1_head", { alp = 1 }} } );

    ObjMultiSet( {
      { "gzz_corridor_scanner", { event_mdown = "cmn.GotoSubRoomMDown( 'corridor_scanner' );", event_mup = "cmn.GotoSubRoomMUp( 'corridor_scanner', 'zz_scanner' );" } },
      { "gzz_corridor_holeincovering", { event_mdown = "cmn.GotoSubRoomMDown( 'corridor_holeincovering' );", event_mup = "cmn.GotoSubRoomMUp( 'corridor_holeincovering', 'zz_holeincovering' );" } },
      { "gzz_corridor_robot", { event_mdown = "cmn.GotoSubRoomMDown( 'corridor_robot' );", event_mup = "cmn.GotoSubRoomMUp( 'corridor_robot', 'zz_robot', false, true );" } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_corridorfirst", clk_corridorfirst_beg, private.room_objname );
  cmn.AddSubscriber( "clk_corridorfirst", clk_corridorfirst_end, private.room_objname );
  cmn.AddSubscriber( "clk_corridorfirst_beg", clk_corridorfirst_beg, private.room_objname );
  cmn.AddSubscriber( "clk_corridorfirst_end", clk_corridorfirst_end, private.room_objname );
  cmn.AddSubscriber( "clk_corridorfirst", clk_corridorfirst_task );
  cmn.AddSubscriber( "clk_corridorfirst_task", clk_corridorfirst_task );

  --------------------------------------------------------------------------------------------
  -- function opn_corridor () end;
  --------------------------------------------------------------------------------------------
  local opn_corridor = function ()
  
    int_map_impl.OpenRoom( "rm_corridor" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_corridor", opn_corridor );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_scanner" );
  subroom.Define( "zz_robot" );
  subroom.Define( "zz_holeincovering" );
  
  function zz_robot.Close()
    cmn.HideNote( 0 );
  end;
  
  function zz_scanner.PreOpen()
    
    if not(cmn.IsEventDone( "win_scanner" )) then
      private.zz_scanner.DrawScene();
    end;

  end;
  
  function zz_scanner.Open()
    
    if cmn.IsEventDone( "use_fixedhacker" ) and not(cmn.IsEventDone( "win_scanner" )) then
      cmn.MiniGameShow();
      private.zz_scanner.CheckWin();
    end;

  end;
  
  function zz_scanner.PreClose()
    
    if cmn.IsEventDone("use_fixedhacker") and not cmn.IsEventDone("win_scanner") then
      cmn.MiniGameHide("scanner");
    end;
    
  end;
  
  function zz_scanner.Close()
    
    if cmn.IsEventDone("use_adhesivetape") and not cmn.IsEventDone("opn_corridordoor") then
      
      local func_after = function ()
        
        cmn.Lock( 0 );
        cmn.CallEventHandler( "use_adhesivetape_end" );
        
      end;
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_rm_corridor_door_light");

      cmn.SetEventDone("opn_corridordoor");
      
      ObjAnimate("spr_corridor_armorydoor_door_light", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("spr_corridor_armorydoor_door_dark", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
      ObjAnimate("spr_corridor_armorydoor_captainsign", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("spr_corridor_armorydoor_captainsign_dark", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });

    end;
    
  end;
  
  function zz_holeincovering.PreOpen()
    cmn.StopAllEnv("assets/levels/level2/audio/env/aud_loop_zz_holeincovering_acid");
    cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_loop_zz_holeincovering_acid");
  end;
  
  function zz_holeincovering.PreClose()
    cmn.StopAllEnv();
    --cmn.PlayAudio("env", "assets/levels/level2/audio/env/");
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_scanner" ].state) then 
    private.zz_scanner.StartConditions();
  end;
  
  private.zz_scanner.state = ng_global.progress[ ng_global.currentprogress ][ "win_scanner" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_corridor();
  
  if cmn.IsEventDone("clk_corridorfirst") and not cmn.IsEventDone("get_screwdriver") then
    --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    common_impl.current_dialog = "obj_corridor_dialog_jean1";
    ObjSet("anm_corridor_dialog_jean1_end",  { playing = 1 });
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level2/audio/env/aud_rm_corridor_env");
  cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_rm_corridor_env");
  
  --анимация морф-оъекта
  if cmn.IsCollectableAvailible(5) then
    private.AnimMorphObject();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_fixedhacker()

  local item = "inv_fixedhacker";

  if cmn.ApplyObj( item, "gzz_corridor_scanner" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_scanner" );

  elseif ( cmn.ApplyObj( item, "obj_scanner_use_fixedhacker" ) and cmn.IsEventDone("use_wires") ) then

    cmn.CallEventHandler( "use_fixedhacker_inv" );
    cmn.CallEventHandler( "use_fixedhacker_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_fixedhacker" );
      cmn.CallEventHandler( "use_fixedhacker_end" );

      cmn.MiniGameShow();
    
    end;
    
    local anm_game = function ()
      
      ObjAnimate("obj_scanner_game", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 0,   0.8, 0, 1 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_zz_scanner_phone");

    ObjSet("anm_scanner_use_hacker",  { alp = 1, playing = 1, endtrig = anm_game });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_screwdriver()

  local item = "inv_screwdriver";

  if cmn.ApplyObj( item, "gzz_corridor_robot" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_robot", false, false, true );

  elseif cmn.ApplyObj( item, "gzz_corridor_scanner" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_scanner" );

  elseif ( cmn.ApplyObj( item, "obj_robot_use_screwdriver" ) ) then

    cmn.CallEventHandler( "use_screwdriverrobot_inv" );
    cmn.CallEventHandler( "use_screwdriverrobot_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_screwdriverrobot" );
      cmn.CallEventHandler( "use_screwdriverrobot_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_zz_robot_open_box");

    ObjSet("anm_robot_use_screwdriver",  { alp = 1, playing = 1, endtrig = func_after });

  elseif ( cmn.ApplyObj( item, "obj_scanner_use_screwdriver" ) ) then

    cmn.CallEventHandler( "use_screwdriverscanner_inv" );
    cmn.CallEventHandler( "use_screwdriverscanner_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_screwdriverscanner" );
      cmn.CallEventHandler( "use_screwdriverscanner_end" );

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_zz_scanner_open_panel");

    ObjSet("anm_scanner_use_screwdriver",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_wires()

  local item = "inv_wires";

  if cmn.ApplyObj( item, "gzz_corridor_scanner" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_scanner" );

  elseif ( cmn.ApplyObj( item, "obj_scanner_use_wires" ) and cmn.IsEventDone("use_screwdriverscanner") ) then

    cmn.CallEventHandler( "use_wires_inv" );
    cmn.CallEventHandler( "use_wires_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_wires" );
      cmn.CallEventHandler( "use_wires_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_zz_scanner_insert_wire");

    ObjSet("anm_scanner_use_wires",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_adhesivetape()

  local item = "inv_adhesivetape";

  if cmn.ApplyObj( item, "gzz_corridor_scanner" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_scanner" );

  elseif ( cmn.ApplyObj( item, "obj_scanner_use_adhesivetape" ) and cmn.IsEventDone("use_wires") ) then

    cmn.CallEventHandler( "use_adhesivetape_inv" );
    cmn.CallEventHandler( "use_adhesivetape_beg" );

    local func_after = function ()

      --cmn.Lock( 0 );

      cmn.SetEventDone( "use_adhesivetape" );
      --cmn.CallEventHandler( "use_adhesivetape_end" );
      
      common.CloseSubRoom();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_zz_scanner_fix");

    ObjSet("anm_scanner_use_tape",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_readybomb()

  local item = "inv_readybomb";

  if cmn.ApplyObj( item, "gzz_corridor_armorydoor" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_armorydoor" );

  elseif ( cmn.ApplyObj( item, "obj_armorydoor_use_readybomb" ) ) then

    cmn.CallEventHandler( "use_readybomb_inv" );
    cmn.CallEventHandler( "use_readybomb_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_readybomb" );
      cmn.CallEventHandler( "use_readybomb_end" );

      common.CloseSubRoom();
      cmn.PlayFullscreenVideo( "assets/levels/level2/rm_corridor/vid_doorexplosion", "", "" );
    
    end;
    
    local anim_time_5 = function ()
      ObjSet("spr_armorydoor_readybomb_time",  { res = "assets/levels/level2/rm_corridor/zz_armorydoor/txt_bomb0" });
      ObjAnimate("spr_armorydoor_readybomb_time", "alp", 0, 0, func_after, { 0, 0, 1,   0.2, 0, 0,    0.4, 0, 1,     0.6, 0, 0,    0.8, 0, 1 });
    end
    
    local anim_time_4 = function ()
      ObjMultiSet( { {"spr_armorydoor_readybomb_time",  { res = "assets/levels/level2/rm_corridor/zz_armorydoor/txt_bomb1" }},
                     {"tmr_armorydoor_timer", { time = 0.5, playing = 1, endtrig = anim_time_5 }} } );
    end
    
    local anim_time_3 = function ()
      ObjMultiSet( { {"spr_armorydoor_readybomb_time",  { res = "assets/levels/level2/rm_corridor/zz_armorydoor/txt_bomb2" }},
                     {"tmr_armorydoor_timer", { time = 0.5, playing = 1, endtrig = anim_time_4 }} } );
    end
    
    local anim_time_2 = function ()
      ObjMultiSet( { {"spr_armorydoor_readybomb_time",  { res = "assets/levels/level2/rm_corridor/zz_armorydoor/txt_bomb3" }},
                     {"tmr_armorydoor_timer", { time = 0.5, playing = 1, endtrig = anim_time_3 }} } );
    end
    
    local anim_time_1 = function ()
      ObjMultiSet( { {"spr_armorydoor_readybomb_time",  { res = "assets/levels/level2/rm_corridor/zz_armorydoor/txt_bomb4" }},
                     {"tmr_armorydoor_timer", { time = 0.5, playing = 1, endtrig = anim_time_2 }} } );
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_bomb_broken_door");

    ObjAnimate( "obj_armorydoor_readybomb", "alp", 0, 0, anim_time_1, { 0, 0, 0,    0.5, 0, 1,    0.8, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_emptybottle()

  local item = "inv_emptybottle";

  if cmn.ApplyObj( item, "gzz_corridor_holeincovering" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_holeincovering" );

  elseif ( cmn.ApplyObj( item, "obj_holeincovering_use_emptybottle" ) ) then

    cmn.CallEventHandler( "use_emptybottle_inv" );
    cmn.CallEventHandler( "use_emptybottle_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      public.get_acid();

      cmn.SetEventDone( "use_emptybottle" );
      cmn.CallEventHandler( "use_emptybottle_end" );
          
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_fill_bottle_acid");

    ObjSet( "anm_holeincovering_emptybottle_use", { endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_manipulator()

  local item = "inv_manipulator";

  if cmn.ApplyObj( item, "gzz_corridor_holeincovering" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_holeincovering" );

  elseif ( cmn.ApplyObj( item, "obj_holeincovering_use_manipulator" ) ) then

    cmn.CallEventHandler( "use_manipulator_inv" );
    cmn.CallEventHandler( "use_manipulator_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      public.get_shippart2();

      cmn.SetEventDone( "use_manipulator" );
      cmn.CallEventHandler( "use_manipulator_end" );
      
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mech_catch_part_rocket");

    ObjSet( "anm_holeincovering_manipulator_use", { endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_captainsign()

  cmn.SetEventDone( "get_captainsign" );
  cmn.CallEventHandler( "get_captainsign" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_acid()

  cmn.SetEventDone( "get_acid" );
  cmn.CallEventHandler( "get_acid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_shippart2()

  cmn.SetEventDone( "get_shippart2" );
  cmn.CallEventHandler( "get_shippart2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_adhesivetape()

  cmn.SetEventDone( "get_adhesivetape" );
  cmn.CallEventHandler( "get_adhesivetape" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_element3()

  cmn.SetEventDone( "get_element3" );
  cmn.CallEventHandler( "get_element3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_wires()

  cmn.SetEventDone( "get_wires" );
  cmn.CallEventHandler( "get_wires" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_crystal()

  cmn.SetEventDone( "get_crystal" );
  cmn.CallEventHandler( "get_crystal" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_screwdriver()
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_screwdriver_end" );
    
    --common_impl.PlayBackgroundMusic();

  end;

  cmn.SetEventDone( "get_screwdriver" );
  cmn.CallEventHandler( "get_screwdriver_inv" );
  cmn.CallEventHandler( "get_screwdriver_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.current_dialog = "";
  
  cmn.Lock(1);
  ObjAnimate("obj_corridor_dialog_jean1", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.5, 0, 0 });

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_corridorfirst()

  cmn.CallEventHandler( "clk_corridorfirst_beg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_corridorfirst" );
    
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_random_env_8_mus_env");
    
    ObjAttach("obj_corridor_dialog_jean1", "rm_corridor");
    ObjAnimate("obj_corridor_dialog_jean1", "alp", 0, 0, private.dialog_jean1_beg, { 0, 0, 0,   0.5, 0, 1 });

  end;
  
  cmn.PlayFullscreenVideo( "assets/levels/level2/rm_corridor/vid_attack", func_after,"assets/levels/level2/audio/mus/aud_attack_vid_mus" );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_corridor()

  if not ( cmn.IsEventDone( "opn_corridor" ) ) then
    cmn.SetEventDone( "opn_corridor" );
    cmn.CallEventHandler("opn_corridor");
    cmn.ShowBbt( "corridor_open" );
  end;

end;
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_5_1", { alp = 1 }},
                 {"spr_col_5_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_5_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_5_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_5_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_5_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_5_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_5_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_armorydoor()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_broken_door_armory");
  
  if not cmn.IsEventDone("get_captainsign") then
    public.get_captainsign();
  end;
  
  cmn.ShowBbt( "obj_armorydoor_use_readybomb" );
  
  ObjSet( "anm_armorydoor_door_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_robot_cover()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_zz_robot_stuff_some");
  
  cmn.ShowBbt( "obj_robot_use_screwdriver" );
  
  ObjSet( "anm_robot_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_robot_crystal()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_zz_robot_crystal_inside");
  
  cmn.ShowBbt( "obj_robot_use_tool" );
  
  ObjSet( "anm_robot_crustal_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_scanner_cover()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_zz_scanner_xx_panel");
  
  cmn.ShowBbt( "obj_scanner_use_screwdriver" );
  
  ObjSet( "anm_scanner_cover_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_scanner_wires()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_zz_scanner_locked");
  
  cmn.ShowBbt( "obj_scanner_use_fixedhacker" );
  
  ObjSet( "anm_scanner_wires_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  ObjAnimate("txt_scanner_wires_text", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0,    0.4, 0, 1,     0.6, 0, 0,    0.8, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_jean1_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "corridor", "jean1", 2 );
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "clk_corridorfirst_end" );
    cmn.CallEventHandler("clk_corridorfirst_task");
    
    cmn.ShowBbt( "corridor_after_dialog" );
    interface_impl.ShowGlobalTask();
    
    ObjSet("anm_corridor_dialog_jean1_end",  { playing = 1 });
    
  end;
  
  local anm_give = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_corridor_dialog_jean1_lipsync2");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjAnimate("anm_corridor_dialog_jean1_hand_1", "alp", 0, 0, "", { 0, 0, 1,   0.16, 0, 1,   0.3, 0, 0 });
    
    ObjMultiSet( { {"tmr_corridor_dialog_jean1_timer",  { playing = 0 }},
                   {"anm_corridor_dialog_jean1_give", { alp = 1, playing = 1, endtrig = dialog_end }},
                   {"anm_corridor_dialog_jean1_head", { alp = 1 }} } );
    
  end;
  
  local jean_talks2 = function ()
  
    ObjDelete("vid_corridor_dialog_jean1_lipsync1");
    ObjAttach("vid_corridor_dialog_jean1_lipsync2", "obj_corridor_dialog_jean1_pos");
  
    cmn.ShowDlgBbt( "dlg_jean1_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level2/audio/voc/aud_2_lvl_jean_2_voc");
    
    private.dlg_lipsync = "vid_corridor_dialog_jean1_lipsync2";
    
    ObjMultiSet( { {"tmr_corridor_dialog_jean1_timer", { endtrig = anm_give, time = 4, playing = 1 }},
                   {"vid_corridor_dialog_jean1_lipsync2", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_give }},
                   {"obj_character_dialog_continue", { event_mup = anm_give }} } );
  
  end;

  private.dlg_lipsync = "vid_corridor_dialog_jean1_lipsync1";

  cmn.ShowDlgBbt( "dlg_jean1_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level2/audio/voc/aud_2_lvl_jean_1_voc");

  ObjMultiSet( { {"tmr_corridor_dialog_jean1_timer", { time = 8, playing = 1, endtrig = jean_talks2 }},
                 {"vid_corridor_dialog_jean1_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = jean_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = jean_talks2 }} } );
  
end; 
--------------------------------------------------------------------------------------------
function public.skip_dlg_jean1()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "clk_corridorfirst_end" );
    cmn.CallEventHandler("clk_corridorfirst_task");
    cmn.ShowBbt( "corridor_after_dialog" );
    interface_impl.ShowGlobalTask();
    
    ObjSet("anm_corridor_dialog_jean1_end",  { playing = 1 });
    
  end;
  
  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    ObjSet("anm_corridor_dialog_jean1_head",  { alp = 1 });
    private.dlg_lipsync = "";
  end;

  
  common_impl.CharacterDialogButtonsHide();
  
  --common_impl.PlayBackgroundMusic();
  
  ObjAnimate("anm_corridor_dialog_jean1_hand_1", "alp", 0, 0, "", { 0, 0, 1,   0.16, 0, 1,   0.3, 0, 0 });
  
  ObjMultiSet( { {"tmr_corridor_dialog_jean1_timer",  { playing = 0 }},
                 {"anm_corridor_dialog_jean1_give", { alp = 1, playing = 1, endtrig = func_after_dlg }} } );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Scanner *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_scanner = {};
public.zz_scanner = {};

function private.Init_Scanner()
  
  private.zz_scanner.current_stone = 0;
  private.zz_scanner.vacant_place = 0;
  private.zz_scanner.step = 0.5;
  
  private.zz_scanner.win_state = { {4, 2, 1, 3}, {2, 4, 1, 3}, {6, 2, 4, 3, 7, 1, 5} };
  
  private.zz_scanner.key_pos = { { {1, 1}, {2, 7} }, { {1, 1}, {1, 7} }, { {2, 1}, {2, 7} } };
  
  private.zz_scanner.plate_pos = {
    { {-80, -30}, {-80, 220}, {162, 34}, {162, 157} },
    { {-80, -91}, {-80, 96}, {162, -154}, {162, 34} },
    { {-80, -154}, {-80, 34}, {-80, 157}, {-80, 220}, {162, -91}, {162, -30}, {162, 96} }
  };
  
  private.zz_scanner.key_code_pos = {
    {-191, 51}, {-154, -91, -30, 34, 96, 157, 220}
  };
  
  private.zz_scanner.code_way = {
    { { 1, 1, 0, -1, 1, 1, 0 }, { 1, 1, 1, 0, 1, 0, 1 } },
    { { 1, 0, -1, 1, 0, 1, 1 }, { 0, 1, 1, 0, -1, 1, 1 } },
    { { 0, -1, 1, 0, 1, 0, 0 }, { 1, 0, 0, 1, 0, -1, 1 } }
  };
  
  private.zz_scanner.code_butt = {
    { { 0, 0, 1, 0, 0, 0, 2 }, { 0, 0, 0, 3, 0, 4, 0 } },
    { { 0, 1, 0, 0, 2, 0, 0 }, { 3, 0, 0, 4, 0, 0, 0 } },
    { { 1, 0, 0, 2, 0, 3, 4 }, { 0, 5, 6, 0, 7, 0, 0 } }
  };
  
  private.zz_scanner.button_type = {
    { {2, 1}, {1, 1}, {1, -1}, {1, 1} },
    { {0}, {1, 1}, {1, -1}, {2, 1} },
    { {2, 1}, {0}, {1, 1}, {2, 1}, {1, -1}, {0}, {2, 1} }
  };
  
  private.zz_scanner.walked = {};
  -----------------------------------------------------------------------------------
  game.hint[ "win_scanner" ] = {
    type = "win",
    room = "rm_corridor",
    zz = "zz_scanner",
    zz_gate = "gzz_corridor_scanner"
  };
  -----------------------------------------------------------------------------------
  local win_scanner = function ()

    if cmn.IsEventDone( "win_scanner" ) then
      
      ObjDelete( "obj_scanner_game" );
      ObjDelete( "gzz_corridor_scanner" );
      
      ObjMultiSet( {
        { "grm_corridor_medicalsection", { input = 1, alp = 1 } },
        { "spr_corridor_scaner_door_opn", { alp = 1 } }
      } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_corridor_medicalsection_focus");
      end;

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_scanner", win_scanner, "rm_corridor" );
  
end;
--*********************************************************************************************************************
function private.zz_scanner.StartConditions()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_scanner" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_scanner" ].state = { {1, 2, 3, 4}, {1, 2, 3, 4}, {1, 2, 3, 4, 5, 6, 7}, 1, {1, 1} };
  
end;
-----------------------------------------------------------------------------------
function public.zz_scanner.Reset()
  
  local need_r = false;
  local need_anm = {};
  
  for i = 1, #private.zz_scanner.state[ private.zz_scanner.state[4] ], 1 do
    
    local num = private.zz_scanner.state[ private.zz_scanner.state[4] ][i];
    
    if num ~= i then
      
      if not need_r then
        need_r = true;
      end;
      
      table.insert( need_anm, num );
      
      ObjAnimate("spr_scanner_button_"..private.zz_scanner.state[4].."_"..num, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  end;
  
  local anm_end = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mg_scaner_insert");
    
    for i = 1, #need_anm, 1 do
      
      ObjSet("spr_scanner_button_"..private.zz_scanner.state[4].."_"..need_anm[i],  { 
        pos_x = private.zz_scanner.plate_pos[ private.zz_scanner.state[4] ][ need_anm[i] ][1],
        pos_y = private.zz_scanner.plate_pos[ private.zz_scanner.state[4] ][ need_anm[i] ][2]
      });
      ObjAnimate("spr_scanner_button_"..private.zz_scanner.state[4].."_"..need_anm[i], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    ObjSet("tmr_scanner_timer",  { time = 0.3, playing = 1, endtrig = function() cmn.Lock(0); end });
    
  end;
  
  if need_r then
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mg_scaner_take");
    
    private.zz_scanner.state[5][1] = private.zz_scanner.key_pos[ private.zz_scanner.state[4] ][1][1];
    private.zz_scanner.state[5][2] = private.zz_scanner.key_pos[ private.zz_scanner.state[4] ][1][2];
    
    for i = 1, #private.zz_scanner.state[ private.zz_scanner.state[4] ], 1 do
      
      private.zz_scanner.state[ private.zz_scanner.state[4] ][i] = i;
      
    end;
    
    ObjSet("tmr_scanner_timer",  { time = 0.3, playing = 1, endtrig = anm_end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_scanner.Skip()
  
  local need_anm = {};
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mg_scaner_take");
  
  ng_global.progress[ ng_global.currentprogress ][ "win_scanner" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_scanner" ].state = { {4, 2, 1, 3}, {2, 4, 1, 3}, {6, 2, 4, 3, 7, 1, 5}, 3, {2, 7} };
  
  private.zz_scanner.state[5][1] = private.zz_scanner.key_pos[ private.zz_scanner.state[4] ][2][1];
  private.zz_scanner.state[5][2] = private.zz_scanner.key_pos[ private.zz_scanner.state[4] ][2][2];
  
  for i = 1, #private.zz_scanner.state[ private.zz_scanner.state[4] ], 1 do
    
    local num = private.zz_scanner.state[ private.zz_scanner.state[4] ][i];
    
    if num ~= private.zz_scanner.win_state[ private.zz_scanner.state[4] ][i] then
      
      local pl = {0, 0};
      pl[1] = num;
      
      for j = 1, #private.zz_scanner.win_state[ private.zz_scanner.state[4] ], 1 do
        
        if private.zz_scanner.win_state[ private.zz_scanner.state[4] ][j] == num then
          pl[2] = j;
          break;
        end;
        
      end;
      
      table.insert( need_anm, pl );
      
      ObjAnimate("spr_scanner_button_"..private.zz_scanner.state[4].."_"..num, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  end;
  
  local anm_win = function ()
    
    for i = private.zz_scanner.state[4], 2, 1 do
      ObjAnimate("spr_scanner_stage_done_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.4, 0, 0,   0.8, 0, 1 });
    end;
    
    private.zz_scanner.state = ng_global.progress[ ng_global.currentprogress ][ "win_scanner" ].state;
    private.zz_scanner.state[5][1] = private.zz_scanner.key_pos[ 3 ][2][1];
    private.zz_scanner.state[5][2] = private.zz_scanner.key_pos[ 3 ][2][2];
    
    private.zz_scanner.CheckWin();
    
  end;
  
  local anm_key = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mg_scaner_insert");
    
    for i = 1, #need_anm, 1 do
      
      ObjSet("spr_scanner_button_"..private.zz_scanner.state[4].."_"..need_anm[i][1],  { 
        pos_x = private.zz_scanner.plate_pos[ private.zz_scanner.state[4] ][ need_anm[i][2] ][1],
        pos_y = private.zz_scanner.plate_pos[ private.zz_scanner.state[4] ][ need_anm[i][2] ][2]
      });
      ObjAnimate("spr_scanner_button_"..private.zz_scanner.state[4].."_"..need_anm[i][1], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    ObjSet("spr_scanner_key_"..private.zz_scanner.state[4],  {
      pos_x = private.zz_scanner.key_code_pos[1][ private.zz_scanner.state[5][1] ],
      pos_y = private.zz_scanner.key_code_pos[2][ private.zz_scanner.state[5][2] ]
    });
    ObjAnimate("spr_scanner_key_"..private.zz_scanner.state[4], "alp", 0, 0, anm_win, { 0, 0, 0,   0.3, 0, 1 });
    
  end;
  
  ObjAnimate("spr_scanner_key_"..private.zz_scanner.state[4], "alp", 0, 0, anm_key, { 0, 0, 1,   0.3, 0, 0 });
  
end;
-----------------------------------------------------------------------------------
function private.zz_scanner.DrawScene()
  
  for i = 1, #private.zz_scanner.state[ private.zz_scanner.state[4] ], 1 do
    
    local num = private.zz_scanner.state[ private.zz_scanner.state[4] ][i];
    ObjSet("spr_scanner_button_"..private.zz_scanner.state[4].."_"..num,  { 
      pos_x = private.zz_scanner.plate_pos[ private.zz_scanner.state[4] ][ i ][1],
      pos_y = private.zz_scanner.plate_pos[ private.zz_scanner.state[4] ][ i ][2]
    });
    
  end;
  
  for i = 1, 3, 1 do
    
    if i == private.zz_scanner.state[4] then
      ObjSet("obj_scanner_stage_"..i,  { alp = 1, input = 1 });
    else 
      ObjSet("obj_scanner_stage_"..i,  { alp = 0, input = 0 });
    end;
    
  end;
  
  for i = 1, private.zz_scanner.state[4]-1, 1 do
    ObjSet("spr_scanner_stage_done_"..i,  { alp = 1});
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_scanner.FocusStart( inout )
  
  local obj = "spr_scanner_start_"..private.zz_scanner.state[4].."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.zz_scanner.StartCode()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mg_scaner_start");
  
  private.zz_scanner.walked = {};
  
  local c_p = {0, 0};
  c_p[1] = private.zz_scanner.state[5][1];
  c_p[2] = private.zz_scanner.state[5][2];
  
  private.zz_scanner.FindEndPos();
  
  --private.zz_scanner.walked = {};
  
  ObjSet("tmr_scanner_timer",  { time = private.zz_scanner.step, playing = 1, endtrig = function() private.zz_scanner.ExecuteCode(c_p); end });
  
end;
-----------------------------------------------------------------------------------
function private.zz_scanner.ExecuteCode(c_p)
  
  local new_pos = private.zz_scanner.FindEndPosRec( c_p, 1, true );
  
  ObjSet("spr_scanner_key_"..private.zz_scanner.state[4],  {
    pos_x = private.zz_scanner.key_code_pos[1][ new_pos[1] ],
    pos_y = private.zz_scanner.key_code_pos[2][ new_pos[2] ]
  });
  
  if private.zz_scanner.code_way[ private.zz_scanner.state[4] ][ new_pos[1] ][ new_pos[2] ] == -1 then
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mg_scaner_error");
  else 
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mg_scaner_move");
  end;
  
  if new_pos[1] == private.zz_scanner.state[5][1] and new_pos[2] == private.zz_scanner.state[5][2] then
    
    private.zz_scanner.CheckWin();
    
  else 
    
    ObjSet("tmr_scanner_timer",  { time = private.zz_scanner.step, playing = 1, endtrig = function() private.zz_scanner.ExecuteCode(new_pos); end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_scanner.FocusButton( num, inout )
  
  local obj = "spr_scanner_button_"..private.zz_scanner.state[4].."_"..num.."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_GET);
    tme = ( 1 - alf ) * 0.3;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.zz_scanner.StartDrag( num )
  
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mg_scaner_take");
  
  if private.zz_scanner.current_stone == 0 then
    
    private.zz_scanner.vacant_place = private.zz_scanner.FindInd( private.zz_scanner.state[4], num );
    
  end;
  
  private.zz_scanner.current_stone = num;
  
  public.zz_scanner.FocusButton( num, 0 );
  
  ObjStartDrag("obj_scanner_game_drag");
  
  ObjAttach("spr_scanner_button_"..private.zz_scanner.state[4].."_"..num, "obj_scanner_game_fly");
  
end;
-----------------------------------------------------------------------------------
function public.zz_scanner.DragButton()
  
  local curspos = GetZoomCursorPos();
  curspos[1] = math.floor(curspos[1] - ObjGet("zz_scanner").pos_x);
  curspos[2] = math.floor(curspos[2] - ObjGet("zz_scanner").pos_y);
  
  if curspos[1] > 230 then
    curspos[1] = 230;
  elseif curspos[1] < -230 then
    curspos[1] = -230;
  end;
  
  if curspos[2] > 230 then
    curspos[2] = 230;
  elseif curspos[2] < -230 then
    curspos[2] = -230;
  end;
  
  ObjSet("spr_scanner_button_"..private.zz_scanner.state[4].."_"..private.zz_scanner.current_stone,  { pos_x = curspos[1], pos_y = curspos[2] });
  
end;
-----------------------------------------------------------------------------------
function public.zz_scanner.DropButton(old_pos)
  
  cmn.Lock(1);
  
  local curspos = old_pos or GetZoomCursorPos();
  if  tostring(GetPlatform()) == "android" then
    curspos[2] = curspos[2] - 100;
  elseif tostring(GetPlatform()) == "ios" then
    if port.isTablet() == 0 then
      curspos[2] = curspos[2] - 75;
    else
      curspos[2] = curspos[2] - 50;
    end;
  end;
    
  curspos[1] = math.floor(curspos[1] - ObjGet("zz_scanner").pos_x);
  curspos[2] = math.floor(curspos[2] - ObjGet("zz_scanner").pos_y);
  
  if curspos[1] > 230 then
    curspos[1] = 230;
  elseif curspos[1] < -230 then
    curspos[1] = -230;
  end;
  
  if curspos[2] > 230 then
    curspos[2] = 230;
  elseif curspos[2] < -230 then
    curspos[2] = -230;
  end;
  
  local pos = 0;
  local num = private.zz_scanner.current_stone;
  
  for i = 1, #private.zz_scanner.state[ private.zz_scanner.state[4] ], 1 do

    if (curspos[1] > private.zz_scanner.plate_pos[ private.zz_scanner.state[4] ][i][1] - 20) and (curspos[1] < private.zz_scanner.plate_pos[ private.zz_scanner.state[4] ][i][1] + 20) and 
       (curspos[2] > private.zz_scanner.plate_pos[ private.zz_scanner.state[4] ][i][2] - 20) and (curspos[2] < private.zz_scanner.plate_pos[ private.zz_scanner.state[4] ][i][2] + 20) then

      pos = i;
      break;
    end;

  end;
  
  if pos == 0 or pos == private.zz_scanner.vacant_place then
    
    pos = private.zz_scanner.vacant_place;
    
    private.zz_scanner.current_stone = 0;
    private.zz_scanner.vacant_place = 0;
    
    local point_a, point_b = {}, {};
    point_a[1] = curspos[1];
    point_a[2] = curspos[2];
    point_b[1] = private.zz_scanner.plate_pos[ private.zz_scanner.state[4] ][ pos ][1];
    point_b[2] = private.zz_scanner.plate_pos[ private.zz_scanner.state[4] ][ pos ][2];
    local len = common_impl.math.FindSegmentLength( point_a, point_b );
    local tme = 0.003 * len;
    
    if tme > 0.4 then
      tme = 0.4;
    elseif tme < 0.1 then
      tme = 0.1;
    end;
    
    ObjAnimate("spr_scanner_button_"..private.zz_scanner.state[4].."_"..num, "pos_xy", 0, 0, 
      function() 
        cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mg_scaner_insert");
        private.zz_scanner.CheckStone( num, 0 ); 
      end, 
      { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] }
    );
    
  else 
    
    private.zz_scanner.current_stone = private.zz_scanner.state[ private.zz_scanner.state[4] ][ pos ];
    private.zz_scanner.state[ private.zz_scanner.state[4] ][ pos ] = num;
    private.zz_scanner.state[ private.zz_scanner.state[4] ][ private.zz_scanner.vacant_place ] = private.zz_scanner.current_stone;
    
    local point_a, point_b = {}, {};
    point_a[1] = curspos[1];
    point_a[2] = curspos[2];
    point_b[1] = private.zz_scanner.plate_pos[ private.zz_scanner.state[4] ][ pos ][1];
    point_b[2] = private.zz_scanner.plate_pos[ private.zz_scanner.state[4] ][ pos ][2];
    local len = common_impl.math.FindSegmentLength( point_a, point_b );
    local tme = 0.002 * len;
    
    if tme > 0.4 then
      tme = 0.4;
    elseif tme < 0.1 then
      tme = 0.1;
    end;
    
    private.old_pos = { point_b[1]+ ObjGet("zz_scanner").pos_x, point_b[2] - 60 + ObjGet("zz_scanner").pos_y };
    
    ObjAnimate("spr_scanner_button_"..private.zz_scanner.state[4].."_"..num, "pos_xy", 0, 0, 
      function() 
        cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mg_scaner_insert");
        private.zz_scanner.CheckStone( num, private.zz_scanner.current_stone ); 
      end, 
      { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] }
    );
    
   

      
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_scanner.CheckStone( num1, num2 )
  
  num2 = num2 or 0;
  
  ObjAttach("spr_scanner_button_"..private.zz_scanner.state[4].."_"..num1, "obj_scanner_stage_"..private.zz_scanner.state[4]);
  
  cmn.Lock(0);
  
  if num2 > 0 then
    
    port.TapDownTimer(0.25,function()
      ObjAttach("spr_scanner_button_"..private.zz_scanner.state[4].."_"..num2, "obj_scanner_game_fly");
      private.zz_scanner.current_stone = num2;
      public.zz_scanner.FocusButton( num2, 0 );
      public.zz_scanner.DropButton(private.old_pos);
    end);
    --public.zz_scanner.StartDrag( num2 );
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_scanner.FindEndPos()
  
  local c_p = {0, 0};
  c_p[1] = private.zz_scanner.state[5][1];
  c_p[2] = private.zz_scanner.state[5][2];
  
  private.zz_scanner.walked = {};
  private.zz_scanner.FindEndPosRec( c_p, 1 );
  
end;
-----------------------------------------------------------------------------------
function private.zz_scanner.FindEndPosRec( cur_pos, dir, next_pos )
  
  next_pos = next_pos or false;
  
  local new = {0, 0};
  new[1] = cur_pos[1];
  new[2] = cur_pos[2];
  local stop = false;
  local win_flag = false;
  
  if private.zz_scanner.code_way[ private.zz_scanner.state[4] ][ cur_pos[1] ][ cur_pos[2] ] == 1 then
    
    new[2] = new[2] + dir;
    if new[2] < 1 then
      new[2] = 7;
      new[1] = new[1]-1;
    elseif new[2] > 7 then
      new[2] = 1;
      new[1] = new[1]+1;
    end;
    
    if new[1] < 1 or new[1] > 2 then
      stop = true;
    else 
      cur_pos[1] = new[1];
      cur_pos[2] = new[2];
    end;
    
  elseif private.zz_scanner.code_way[ private.zz_scanner.state[4] ][ cur_pos[1] ][ cur_pos[2] ] == -1 then
    
    stop = true;
    
  elseif private.zz_scanner.code_way[ private.zz_scanner.state[4] ][ cur_pos[1] ][ cur_pos[2] ] == 0 then
    
    local stage = private.zz_scanner.state[4];
    local butt = private.zz_scanner.state[ stage ][ private.zz_scanner.code_butt[ private.zz_scanner.state[4] ][ cur_pos[1] ][ cur_pos[2] ] ];
    
    if private.zz_scanner.button_type[ stage ][ butt ][1] == 0 then
      stop = true;
    else 
      
      local ind = 1;
      if private.zz_scanner.button_type[ stage ][ butt ][1] == 2 then
        ind = 2;
      end;
      local dir2 = private.zz_scanner.button_type[ stage ][ butt ][2];
      
      new[ind] = new[ind] + dir2;
      if ind == 2 and dir2 < 0 then
        dir = dir2;
      end;
      
      if new[2] < 1 then
        new[2] = 7;
        new[1] = new[1]-1;
      elseif new[2] > 7 then
        new[2] = 1;
        new[1] = new[1]+1;
      end;
      
      if new[1] < 1 or new[1] > 2 then
        stop = true;
      else 
        cur_pos[1] = new[1];
        cur_pos[2] = new[2];
      end;
      
    end;
    
  end;
  
  if cur_pos[1] == private.zz_scanner.key_pos[ private.zz_scanner.state[4] ][2][1]
  and cur_pos[2] == private.zz_scanner.key_pos[ private.zz_scanner.state[4] ][2][2] then
    private.zz_scanner.state[5][1] = cur_pos[1];
    private.zz_scanner.state[5][2] = cur_pos[2];
    stop = true;
    win_flag = true;
  end;
  
  --DbgTrace(cur_pos[1].." "..cur_pos[2])
  
  --if not next_pos then
  --  
  --  DbgTrace(cur_pos[1].." "..cur_pos[2])
  --
  --  local double = false;
  --  
  --  for i = 1, #private.zz_scanner.walked, 1 do
  --    
  --    if private.zz_scanner.walked[i][1] == cur_pos[1] and private.zz_scanner.walked[i][2] == cur_pos[2] then
  --      stop = true;
  --      double = true;
  --      break;
  --    end;
  --    
  --  end;
  --  
  --  if not double then
  --    DbgTrace(cur_pos[1].." "..cur_pos[2]);
  --    table.insert( private.zz_scanner.walked, cur_pos );
  --  end;
  --  
  --else 
  --  
  --  if private.zz_scanner.walked[ #private.zz_scanner.walked ][1] == cur_pos[1]
  --  and private.zz_scanner.walked[ #private.zz_scanner.walked ][2] == cur_pos[2] then
  --    stop = true;
  --  end;
  --  
  --end;
  
  if next_pos then
    
    if stop then
    
      if win_flag then
        return cur_pos;
      else
        local c_p = {0, 0};
        c_p[1] = private.zz_scanner.state[5][1];
        c_p[2] = private.zz_scanner.state[5][2];
        return c_p;
      end;
      
    else 
      
      return cur_pos;
      
    end;
    
  elseif not stop then
    private.zz_scanner.FindEndPosRec( cur_pos, dir, next_pos );
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_scanner.FindInd( stage, num )
  
  local ind = 0;
  
  for i = 1, #private.zz_scanner.state[ stage ], 1 do
    
    if private.zz_scanner.state[ stage ][i] == num then
      ind = i;
      break;
    end;
    
  end;
  
  return ind;
  
end;
-----------------------------------------------------------------------------------
function private.zz_scanner.CheckWin()
  
  local win_flag = false;
  
  --DbgTrace("CheckWin")
  
  if private.zz_scanner.state[5][1] == private.zz_scanner.key_pos[ private.zz_scanner.state[4] ][2][1]
  and private.zz_scanner.state[5][2] == private.zz_scanner.key_pos[ private.zz_scanner.state[4] ][2][2] then
    win_flag = true;
  end;
  
  if win_flag then
    
    cmn.Lock( 1 );
    
    if private.zz_scanner.state[4] == 3 then
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mg_scaner_win");
    
      common_impl.PauseAchiev(1);
      cmn.MiniGameHide("scanner");
      
      local anm_win_end = function ()
        
        ObjSet("txt_scanner_hacker_text_1", { text = StringGet("str_scanner_open") });
        
        ObjAnimate("txt_scanner_hacker_text_1", "alp", 0, 0, private.zz_scanner.Win, { 0, 0, 0,   0.3, 0, 1,    0.8, 0, 1 });
        
      end;
      
      local anm_win_2 = function ()
        
        cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_anim_door_open_scanner");
        ObjAnimate("txt_scanner_hacker_text_1", "alp", 0, 0, anm_win_end, { 0, 0, 1,   0.3, 0, 0 });
        
      end;
      
      local anm_win = function ()
        
        ObjSet("txt_scanner_hacker_text_2", { text = StringGet("str_scanner_open") });
        
        ObjAnimate("txt_scanner_game_open", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
        ObjAnimate("txt_scanner_game_lock", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
        
        ObjAnimate("obj_scanner_game", "alp", 0, 0, anm_win_2, { 0, 0, 1,   1, 0, 1,   1.5, 0, 0 });
        --ObjAnimate("txt_scanner_hacker_text_1", "alp", 0, 0, anm_win_end, { 0, 0, 1,   1.5, 0, 1,   1.8, 0, 0 });
        
      end;
      
      ObjAnimate("spr_scanner_stage_done_"..private.zz_scanner.state[4], "alp", 0, 0, anm_win, { 0, 0, 0,   0.4, 0, 0,   0.8, 0, 1,   1.2, 0, 1 });
      
    else 
      
      private.zz_scanner.state[4] = private.zz_scanner.state[4] + 1;
      private.zz_scanner.state[5][1] = private.zz_scanner.key_pos[ private.zz_scanner.state[4] ][1][1];
      private.zz_scanner.state[5][2] = private.zz_scanner.key_pos[ private.zz_scanner.state[4] ][1][2];
      
      private.zz_scanner.walked = {};
      
      local change_stage = function ()
        
        ObjMultiSet( { {"obj_scanner_stage_"..(private.zz_scanner.state[4]-1), { input = 0 }},
                       {"obj_scanner_stage_"..private.zz_scanner.state[4], { input = 1 }} } );
      
        ObjAnimate("obj_scanner_stage_"..private.zz_scanner.state[4], "alp", 0, 0, function () cmn.Lock(0); end, { 0, 0, 0,   0.5, 0, 1 });
        ObjAnimate("obj_scanner_stage_"..(private.zz_scanner.state[4]-1), "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
        
      end;
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mg_scaner_right_key");
      
      ObjAnimate("spr_scanner_stage_done_"..(private.zz_scanner.state[4]-1), "alp", 0, 0, change_stage, { 0, 0, 0,   0.4, 0, 0,   0.8, 0, 1 });
      
    end;
    
  else 
    cmn.Lock( 0 );
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_scanner.Win()
  
  cmn.Lock( 0 );
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_scanner" );
  cmn.CallEventHandler( "win_scanner" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_scanner" ].skip == 0 and ng_global.noskipgames[ "win_scanner" ] == nil then

    ng_global.noskipgames[ "win_scanner" ] = 1;
    common_impl.CheckAchiev("mg");

  end;
  
  common.CloseSubRoom();
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mg_scaner_loc_open_door");
  
end;
--***************************************************************************************************************