-- name=rm_hangar
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_hangar";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Turret();
  private.Init_Connectingmodule();
  --------------------------------------------------------------------------------------------
  -- function get_shipsymbol () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_shipsymbol" ] = {
    type = "get",
    get_obj = "spr_turret_shipsymbol",
    room = private.room_objname,
    zz = "zz_turret",
    zz_gate = "gzz_hangar_turret"
  };
  --------------------------------------------------------------------------------------------
  local get_shipsymbol_inv = function ()
  
    interface.InventoryItemAdd( "inv_shipsymbol", "spr_turret_shipsymbol" );
  
  end;
  local get_shipsymbol_end = function ()
  
    ObjDelete( "gfx_turret_shipsymbol" );
    ObjDelete( "spr_turret_shipsymbol_shadow" );
    ObjDelete( "spr_hangar_turret_amulet" );
  
  end;
  
  cmn.AddSubscriber( "get_shipsymbol", get_shipsymbol_inv );
  cmn.AddSubscriber( "get_shipsymbol", get_shipsymbol_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_defensesign () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_defensesign" ] = {
    type = "get",
    get_obj = "spr_connectingmodule_defensesign",
    room = private.room_objname,
    zz = "zz_connectingmodule",
    zz_gate = "gzz_hangar_connectingmodule"
  };
  --------------------------------------------------------------------------------------------
  local get_defensesign_inv = function ()
  
    interface.InventoryItemAdd( "inv_defensesign", "spr_connectingmodule_defensesign" );
  
  end;
  local get_defensesign_end = function ()
  
    ObjDelete( "gfx_connectingmodule_defensesign" );
    ObjDelete( "spr_connectingmodule_defensesign_shadow" );

    if cmn.IsEventDone( "win_connectingmodule" ) then
      ObjDelete( "gzz_hangar_connectingmodule" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_defensesign", get_defensesign_inv );
  cmn.AddSubscriber( "get_defensesign", get_defensesign_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl2badge2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl2badge2" ] = {
    type = "get",
    get_obj = "spr_hangar_lvl2badge2",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_lvl2badge2_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl2badge2", "spr_hangar_lvl2badge2" );
    ObjSet("inv_bag_star_light",  { alp = 1 });
  
  end;
  local get_lvl2badge2_end = function ()
  
    ObjDelete( "gfx_hangar_lvl2badge2" );
  
  end;
  
  cmn.AddSubscriber( "get_lvl2badge2", get_lvl2badge2_inv );
  cmn.AddSubscriber( "get_lvl2badge2", get_lvl2badge2_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_turretmodule () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_turretmodule" ] = {
    type = "use",
    inv_obj = "inv_turretmodule",
    use_place = "obj_turret_module_1_hint",
    room = private.room_objname,
    zz = "zz_turret",
    zz_gate = "gzz_hangar_turret"
  };
  --------------------------------------------------------------------------------------------
  local use_turretmodule_inv = function ()
  
    interface.InventoryItemRemove( "inv_turretmodule" );
  
  end;
  local use_turretmodule_beg = function ()
  
    if cmn.IsEventDone("use_turretmodule2") then
      ObjDelete( "obj_turret_use_turretmodule" );
    end;
  
  end;
  local use_turretmodule_end = function ()
    
    ObjSet("anm_turret_module_1",  { alp = 1, frame = 0, playing = 0, animfunc = "func_clk_module" });
  
    if cmn.IsEventDone("use_turretmodule2") then
      ObjMultiSet( { {"anm_turret_start_mg", { alp = 1, frame = 300, input = true }},
                     {"spr_hangar_turret_module", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_turretmodule", use_turretmodule_beg, private.room_objname );
  cmn.AddSubscriber( "use_turretmodule", use_turretmodule_inv );
  cmn.AddSubscriber( "use_turretmodule", use_turretmodule_end, private.room_objname );
  cmn.AddSubscriber( "use_turretmodule_inv", use_turretmodule_inv, private.room_objname );
  cmn.AddSubscriber( "use_turretmodule_beg", use_turretmodule_beg, private.room_objname );
  cmn.AddSubscriber( "use_turretmodule_end", use_turretmodule_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_turretmodule2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_turretmodule2" ] = {
    type = "use",
    inv_obj = "inv_turretmodule2",
    use_place = "obj_turret_module_2_hint",
    room = private.room_objname,
    zz = "zz_turret",
    zz_gate = "gzz_hangar_turret"
  };
  --------------------------------------------------------------------------------------------
  local use_turretmodule2_inv = function ()
  
    interface.InventoryItemRemove( "inv_turretmodule2" );
  
  end;
  local use_turretmodule2_beg = function ()
  
    if cmn.IsEventDone("use_turretmodule") then
      ObjDelete( "obj_turret_use_turretmodule" );
    end;
  
  end;
  local use_turretmodule2_end = function ()
    
    ObjSet("anm_turret_module_2",  { alp = 1, frame = 0, playing = 0, animfunc = "func_clk_module_2" });
  
    if cmn.IsEventDone("use_turretmodule") then
      ObjMultiSet( { {"anm_turret_start_mg", { alp = 1, frame = 300, input = true }},
                     {"spr_hangar_turret_module", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_turretmodule2", use_turretmodule2_beg, private.room_objname );
  cmn.AddSubscriber( "use_turretmodule2", use_turretmodule2_inv );
  cmn.AddSubscriber( "use_turretmodule2", use_turretmodule2_end, private.room_objname );
  cmn.AddSubscriber( "use_turretmodule2_inv", use_turretmodule2_inv, private.room_objname );
  cmn.AddSubscriber( "use_turretmodule2_beg", use_turretmodule2_beg, private.room_objname );
  cmn.AddSubscriber( "use_turretmodule2_end", use_turretmodule2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_squarekey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_squarekey" ] = {
    type = "use",
    inv_obj = "inv_squarekey",
    use_place = "obj_turret_use_squarekey",
    room = private.room_objname,
    zz = "zz_turret",
    zz_gate = "gzz_hangar_turret"
  };
  --------------------------------------------------------------------------------------------
  local use_squarekey_inv = function ()
  
    interface.InventoryItemRemove( "inv_squarekey" );
  
  end;
  local use_squarekey_beg = function ()
  
    ObjDelete( "obj_turret_use_squarekey" );
    ObjDelete("anm_turret_clk_turret");
  
  end;
  local use_squarekey_end = function ()
  
    ObjDelete("anm_turret_use_key");
    ObjSet("obj_turret_use_turretmodule",  { alp = 1, input = 1 });
                     
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_squarekey", use_squarekey_beg, private.room_objname );
  cmn.AddSubscriber( "use_squarekey", use_squarekey_inv );
  cmn.AddSubscriber( "use_squarekey", use_squarekey_end, private.room_objname );
  cmn.AddSubscriber( "use_squarekey_inv", use_squarekey_inv, private.room_objname );
  cmn.AddSubscriber( "use_squarekey_beg", use_squarekey_beg, private.room_objname );
  cmn.AddSubscriber( "use_squarekey_end", use_squarekey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_accesstoshipcode () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_accesstoshipcode" ] = {
    type = "use",
    inv_obj = "inv_accesstoshipcode",
    use_place = "obj_connectingmodule_use_accesstoshipcode",
    room = private.room_objname,
    zz = "zz_connectingmodule",
    zz_gate = "gzz_hangar_connectingmodule"
  };
  --------------------------------------------------------------------------------------------
  local use_accesstoshipcode_inv = function ()
  
    interface.InventoryItemRemove( "inv_accesstoshipcode" );
  
  end;
  local use_accesstoshipcode_beg = function ()
  
    ObjDelete( "obj_connectingmodule_use_accesstoshipcode" );
  
  end;
  local use_accesstoshipcode_end = function ()
  
    ObjMultiSet( { {"spr_connectingmodule_code_paper", { alp = 1 }},
                   {"obj_connectingmodule_game", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_accesstoshipcode", use_accesstoshipcode_beg, private.room_objname );
  cmn.AddSubscriber( "use_accesstoshipcode", use_accesstoshipcode_inv );
  cmn.AddSubscriber( "use_accesstoshipcode", use_accesstoshipcode_end, private.room_objname );
  cmn.AddSubscriber( "use_accesstoshipcode_inv", use_accesstoshipcode_inv, private.room_objname );
  cmn.AddSubscriber( "use_accesstoshipcode_beg", use_accesstoshipcode_beg, private.room_objname );
  cmn.AddSubscriber( "use_accesstoshipcode_end", use_accesstoshipcode_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pressuresuit () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_pressuresuit" ] = {
    type = "use",
    inv_obj = "inv_pressuresuit",
    use_place = "obj_hangar_use_pressuresuit",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local use_pressuresuit_inv = function ()
  
    interface.InventoryItemRemove( "inv_pressuresuit" );
  
  end;
  local use_pressuresuit_beg = function ()
  
    ObjDelete( "obj_hangar_use_pressuresuit" );
    ObjDelete( "tmr_hangar_timer" );
  
  end;
  local use_pressuresuit_end = function ()
    
    ObjDelete( "spr_hangar_back_blur" );
    ObjDelete( "vid_hangar_puton_suit" );
  
    ObjMultiSet( { {"gzz_hangar_turret", { alp = 1, input = 1, active = 1 }},
                   {"gzz_hangar_connectingmodule", { alp = 1, input = 1, active = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pressuresuit", use_pressuresuit_beg, private.room_objname );
  cmn.AddSubscriber( "use_pressuresuit", use_pressuresuit_inv );
  cmn.AddSubscriber( "use_pressuresuit", use_pressuresuit_end, private.room_objname );
  cmn.AddSubscriber( "use_pressuresuit_inv", use_pressuresuit_inv, private.room_objname );
  cmn.AddSubscriber( "use_pressuresuit_beg", use_pressuresuit_beg, private.room_objname );
  cmn.AddSubscriber( "use_pressuresuit_end", use_pressuresuit_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_hangar () end;
  --------------------------------------------------------------------------------------------
  local opn_hangar = function ()
  
    int_map_impl.OpenRoom( "rm_hangar" );
    interface_impl.SetCurrentGlobalTask( 11 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_hangar", opn_hangar );
  --------------------------------------------------------------------------------------------
  -- function opn_hangarsuit () end;
  --------------------------------------------------------------------------------------------
  local opn_hangarsuit_loc = function ()
  
    ObjSet( "anm_hangar_jean", { alp = 1 } );
  
  end;
  local opn_hangarsuit_arm = function ()
  
    ObjDelete( "obj_armory_jean" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_hangarsuit", opn_hangarsuit_loc, private.room_objname );
  cmn.AddSubscriber( "opn_hangarsuit", opn_hangarsuit_arm, "rm_armory" );

end;
--********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_turret" );
  subroom.Define( "zz_connectingmodule" );

  function zz_turret.PreOpen()
    
    if cmn.IsEventDone( "use_turretmodule" ) and not cmn.IsEventDone( "win_turret" ) then
      cmn.MiniGameShow();
      cmn.Lock( 1 );
      private.zz_turret.DrawScene();
      private.zz_turret.CheckWin();
    end;

  end;

  function zz_turret.PreClose()
    
    if cmn.IsEventDone( "use_turretmodule" ) and not cmn.IsEventDone("win_turret") then
      cmn.MiniGameHide( "turret" );
    end;
    
  end;
  
  function zz_turret.Close()
    
    if cmn.IsEventDone("win_turret") then
      
      local func_after = function ()
        
        cmn.Lock( 0 );
        common_impl.PauseAchiev(0);
        cmn.CallEventHandler( "win_turret" );
        
        if cmn.IsEventDone("win_connectingmodule") then
          private.play_outro();
        end;
        
      end;
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_anim_loc_magnet_field_off");
      
      ObjDelete("anm_hangar_laser");
      ObjSet("anm_hangar_laser_2",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;
    
  end;

  function zz_connectingmodule.PreOpen()
    
    private.zz_connectingmodule.DrawScene();

    if cmn.IsEventDone( "use_accesstoshipcode" ) and not cmn.IsEventDone( "win_connectingmodule" ) then
      cmn.MiniGameShow();
      cmn.Lock( 1 );
      private.zz_connectingmodule.CheckWin();
    end;

    if cmn.IsEventDone( "win_connectingmodule" ) then
      ObjSet( "anm_connectingmodule_hud", { animfunc = "func_hud_on", endtrig = "", playing = true } );
      ObjSet( "anm_connectingmodule_lights", { animfunc = "func_lights_on", endtrig = "", playing = true } );
      ObjSet( "anm_connectingmodule_hologram", { animfunc = "func_hologram_on", endtrig = "", playing = true } );
    end;

  end;

  function zz_connectingmodule.PreClose()
    
    if cmn.IsEventDone( "use_accesstoshipcode" ) and not cmn.IsEventDone("win_connectingmodule") then
      cmn.MiniGameHide( "connectingmodule" );
    end;
    
  end;

end;
--*********************************************************************************************************************
function public.Load()

  if not(ng_global.progress[ ng_global.currentprogress ][ "win_turret" ].state) then 
    private.zz_turret.StartConditions();
  end;
  private.zz_turret.state = ng_global.progress[ ng_global.currentprogress ][ "win_turret" ].state;

  if not(ng_global.progress[ ng_global.currentprogress ][ "win_connectingmodule" ].state) then 
    private.zz_connectingmodule.StartConditions();
  end;
  private.zz_connectingmodule.state = ng_global.progress[ ng_global.currentprogress ][ "win_connectingmodule" ].state;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_hangar();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level2/audio/env/aud_rm_hangar_env");
  cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_rm_hangar_env");
  
  if not cmn.IsEventDone("use_pressuresuit") then
    private.hero_out();
  end;
  
  if cmn.IsEventDone("win_turret") and cmn.IsEventDone("win_connectingmodule") then
    cmn.Lock( 1 );
    ObjSet("rm_hangar",  { color_r = 0, color_g = 0, color_b = 0 });
  end;
  
  if cmn.IsEventDone("get_pressuresuit") and not cmn.IsEventDone("opn_hangarsuit") then
    cmn.SetEventDone("opn_hangarsuit");
    cmn.CallEventHandler("opn_hangarsuit");
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
  
  if not cmn.IsEventDone("use_pressuresuit") then
    ObjStopAnimate("obj_hangar_back", "pos_xy");
    ObjStopAnimate("obj_hangar_back", "ang");
    ObjStopAnimate("obj_hangar_back", "color_r");
    ObjStopAnimate("obj_hangar_back", "color_g");
    ObjStopAnimate("obj_hangar_back", "color_b");
  end;
  
end;
--*********************************************************************************************************************
function public.PreClose()
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_turretmodule()

  local item = "inv_turretmodule";

  if cmn.ApplyObj( item, "gzz_hangar_turret" ) and cmn.IsEventDone("use_pressuresuit") then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_turret" );

  elseif ( cmn.ApplyObj( item, "obj_turret_use_turretmodule" ) and cmn.IsEventDone("use_squarekey") ) then

    cmn.SetEventDone( "use_turretmodule" );
    cmn.CallEventHandler( "use_turretmodule_inv" );
    cmn.CallEventHandler( "use_turretmodule_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.CallEventHandler( "use_turretmodule_end" );

      if cmn.IsEventDone("use_turretmodule2") then
        cmn.MiniGameShow();
      end;
      
    end;
    
    local anm_game = function ()
      
      --cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/");
      ObjSet( "anm_turret_start_mg", { alp = 1, endtrig = func_after, playing = true } );
      
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_stuff_zz_turret");
    
    if cmn.IsEventDone("use_turretmodule2") then
      
      if not cmn.IsEventDone("get_shipsymbol") then
        public.get_shipsymbol();
      end;

      private.zz_turret.DrawScene();

      ObjSet( "anm_turret_module_1", { alp = 1, endtrig = anm_game, playing = true } );
      
    else 
      
      ObjSet( "anm_turret_module_1", { alp = 1, endtrig = func_after, playing = true } );
      
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_turretmodule2()

  local item = "inv_turretmodule2";

  if cmn.ApplyObj( item, "gzz_hangar_turret" ) and cmn.IsEventDone("use_pressuresuit") then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_turret" );

  elseif ( cmn.ApplyObj( item, "obj_turret_use_turretmodule" ) and cmn.IsEventDone("use_squarekey") ) then

    cmn.SetEventDone( "use_turretmodule2" );
    cmn.CallEventHandler( "use_turretmodule2_inv" );
    cmn.CallEventHandler( "use_turretmodule2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.CallEventHandler( "use_turretmodule2_end" );

      if cmn.IsEventDone("use_turretmodule") then
        cmn.MiniGameShow();
      end;
      
    end;
    
    local anm_game = function ()
      
      --cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/");
      ObjSet( "anm_turret_start_mg", { alp = 1, endtrig = func_after, playing = true } );
      
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_stuff_zz_turret");
    
    if cmn.IsEventDone("use_turretmodule") then
      
      if not cmn.IsEventDone("get_shipsymbol") then
        public.get_shipsymbol();
      end;

      private.zz_turret.DrawScene();

      ObjSet( "anm_turret_module_2", { alp = 1, endtrig = anm_game, playing = true } );
      
    else 
      
      ObjSet( "anm_turret_module_2", { alp = 1, endtrig = func_after, playing = true } );
      
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_squarekey()

  local item = "inv_squarekey";

  if cmn.ApplyObj( item, "gzz_hangar_turret" ) and cmn.IsEventDone("use_pressuresuit") then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_turret" );

  elseif ( cmn.ApplyObj( item, "obj_turret_use_squarekey" ) ) then

    cmn.CallEventHandler( "use_squarekey_inv" );
    cmn.CallEventHandler( "use_squarekey_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_squarekey" );
      cmn.CallEventHandler( "use_squarekey_end" );

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud__monitor_zz_turret_unscrew_cell");

    ObjSet("anm_turret_use_key",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_accesstoshipcode()

  local item = "inv_accesstoshipcode";

  if cmn.ApplyObj( item, "gzz_hangar_connectingmodule" ) and cmn.IsEventDone("use_pressuresuit") then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_connectingmodule" );

  elseif ( cmn.ApplyObj( item, "obj_connectingmodule_use_accesstoshipcode" ) ) then

    cmn.CallEventHandler( "use_accesstoshipcode_inv" );
    cmn.CallEventHandler( "use_accesstoshipcode_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_accesstoshipcode" );
      cmn.CallEventHandler( "use_accesstoshipcode_end" );

      cmn.MiniGameShow();
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_put_paper_zz_hangar");

    ObjAnimate( "spr_connectingmodule_code_paper", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pressuresuit()

  local item = "inv_pressuresuit";

  if ( cmn.ApplyObj( item, "obj_hangar_use_pressuresuit" ) ) then

    ObjSet( "tmr_hangar_timer", { playing = false, endtrig = "" } );

    cmn.CallEventHandler( "use_pressuresuit_inv" );
    cmn.CallEventHandler( "use_pressuresuit_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_pressuresuit" );
      cmn.CallEventHandler( "use_pressuresuit_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_scafandr_wear");

    ObjStopAnimate("obj_hangar_back", "pos_y");
    ObjStopAnimate("obj_hangar_back", "ang");
    ObjStopAnimate("obj_hangar_back", "color_r");
    ObjStopAnimate("obj_hangar_back", "color_g");
    ObjStopAnimate("obj_hangar_back", "color_b");
    ObjStopAnimate("spr_hangar_back_blur", "alp");
    
    local params = ObjGet("obj_hangar_back");
    local alf = ObjGet("spr_hangar_back_blur").alp;

    ObjAnimate( "obj_hangar_back", "pos_y", 0, 0, "", { 0, 0, params.pos_y,    3, 0, params.pos_y,    7, 0, 0 } );
    ObjAnimate( "obj_hangar_back", "ang", 0, 0, "", { 0, 0, params.ang,    3, 0, params.ang,    7, 0, 0 } );
    ObjAnimate( "obj_hangar_back", "color_r", 0, 0, "", { 0, 0, params.color_r,    3, 0, params.color_r,    7, 0, 1 } );
    ObjAnimate( "obj_hangar_back", "color_g", 0, 0, "", { 0, 0, params.color_r,    3, 0, params.color_r,    7, 0, 1 } );
    ObjAnimate( "obj_hangar_back", "color_b", 0, 0, "", { 0, 0, params.color_r,    3, 0, params.color_r,    7, 0, 1 } );
    
    ObjAnimate( "spr_hangar_back_blur", "alp", 0, 0, "", { 0, 0, alf,    3, 0, alf,    7, 0, 0 } );
    
    ObjAttach("vid_hangar_puton_suit", "rm_hangar");
    VidPlay("vid_hangar_puton_suit", func_after);

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_shipsymbol()

  cmn.SetEventDone( "get_shipsymbol" );
  cmn.CallEventHandler( "get_shipsymbol" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_defensesign()

  cmn.SetEventDone( "get_defensesign" );
  cmn.CallEventHandler( "get_defensesign" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  if cmn.IsEventDone( "win_connectingmodule" ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_lvl2badge2()
  
  cmn.SetEventDone( "get_lvl2badge2" );
  cmn.CallEventHandler( "get_lvl2badge2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_hangar()

  if not ( cmn.IsEventDone( "opn_hangar" ) ) then
    cmn.SetEventDone( "opn_hangar" );
    cmn.CallEventHandler("opn_hangar");
    cmn.ShowBbt( "hangar_open" );
    interface_impl.ShowGlobalTask();
  end;
  
  if cmn.IsEventDone("win_turret") and cmn.IsEventDone("win_connectingmodule") then
    private.play_outro();
  end;

end;
-----------------------------------------------------------------------------------
function private.hero_out()
  
  local kick_out = function ()
  
    cmn.ShowBbt( "hangar_cant_breath" );
    cmn.GotoRoom("rm_maindeck");
    
  end;
  
  ObjMultiSet( {
    {"obj_hangar_back", { pos_x = 0, pos_y = 0, ang = 0, color_r = 1, color_g = 1, color_b = 1 }},
    {"spr_hangar_back_blur", { alp = 0 }},
    {"tmr_hangar_timer",  { time = 6, playing = 1, endtrig =
    function ()
      --нужно для бота
      ObjSet( "tmr_hangar_timer", { time = 0.01, endtrig = kick_out, playing = true } );
    end }}
  } );
  
  ObjAnimate( "obj_hangar_back", "color_r", 0, 0, "", { 0, 0, 1,    6, 0, 0.3 } );
  ObjAnimate( "obj_hangar_back", "color_g", 0, 0, "", { 0, 0, 1,    6, 0, 0.3 } );
  ObjAnimate( "obj_hangar_back", "color_b", 0, 0, "", { 0, 0, 1,    6, 0, 0.3 } );
  
  ObjAnimate( "spr_hangar_back_blur", "alp", 0, 0, "", { 0, 0, 0,    6, 0, 1 } );
  
  ObjAnimate( "obj_hangar_back", "pos_y", 1, 0, "", 
  { 
    0,   0,   0,
    1.5, 0,   2,
    3, 0,   0,
    4.5, 0,  -2,
    6, 0,  0
  } );
 
  ObjAnimate( "obj_hangar_back", "ang", 1, 0, "", 
  { 
    0,  0,       0,
    2,  0,   0.005,
    3,  0,       0,
    4,  0,  -0.005,
    5, 0,       0
  } );
  
end;
-----------------------------------------------------------------------------------
function private.play_outro()
  
  local func_after = function ()
    
    cmn.LevelSwitch( "level3", 2 );
    ng_global.progress["std"].common.chapter = "level3";
    ng_global.progress[ "std" ].common.currentroom = "ho_apartment3";
    
    ObjSet("rm_hangar",  { color_r = 0, color_g = 0, color_b = 0 });
    --cmn.GotoRoom( "rm_endroom" );
    
  end;

  cmn.Lock( 0 );
  cmn.StopAllEnv();

  cmn.PlayFullscreenVideo( "assets/levels/level2/rm_hangar/vid_lvl2outro",
                           func_after,
                           "assets/levels/level2/audio/mus/aud_vid_lvl2outro_mus" );
    

end;
-----------------------------------------------------------------------------------
function public.touch_turret()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_monitor_zz_turret");
  
  cmn.ShowBbt( "obj_turret_use_squarekey" );
  
  ObjSet("anm_turret_clk_turret", { playing = true, endtrig = function() cmn.Lock(0); end });
  
end;
-----------------------------------------------------------------------------------
function public.touch_turret2()
  
  cmn.ShowBbt( "obj_turret_use_turretmodule" );
  
  if cmn.IsEventDone("use_turretmodule") then
  
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_stuff_zz_turret");
    
    ObjSet("anm_turret_module_1", { playing = true, endtrig = function() cmn.Lock(0); end });
      
  end;
    
  if cmn.IsEventDone("use_turretmodule2") then
  
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_stuff_zz_turret");
    
    ObjSet("anm_turret_module_2", { playing = true, endtrig = function() cmn.Lock(0); end });
      
  end;
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Turret *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_turret = {};
public.zz_turret = {};

function private.Init_Turret()

  private.zz_turret.right_1 = { 3, 4, 2, 5, 1 };  --правильные пару для левых источников
  private.zz_turret.right_2 = { 5, 3, 1, 2, 4 };  --правильные пару для правых источников

  -----------------------------------------------------------------------------------
  game.hint[ "win_turret" ] = {
    type = "win",
    room = "rm_hangar",
    zz = "zz_turret",
    zz_gate = "gzz_hangar_turret"
  };
  -----------------------------------------------------------------------------------
  local win_turret = function ()

    if cmn.IsEventDone( "win_turret" ) then
      
      ObjSet("fx_hangar_laser_2",  { active = 1, visible = 1 });
      
      ObjDelete( "gzz_hangar_turret" );
      ObjDelete( "anm_hangar_laser" );
      ObjDelete( "anm_hangar_laser_2" );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_turret", win_turret, "rm_hangar" );

end;
-----------------------------------------------------------------------------------
function private.zz_turret.StartConditions()

  --DbgTrace( "***StartConditions" );
  
  ng_global.progress[ ng_global.currentprogress ][ "win_turret" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_turret" ].state = { false, false, false, false, false, false };--[6] - last
  
end;
-----------------------------------------------------------------------------------
function public.zz_turret.Reset()

  --DbgTrace( "***Reset" );

  local is_reset = false;

  for i = 1, 5, 1 do
    if private.zz_turret.state[i] then

      --DbgTrace( "["..i.."] - ["..private.zz_turret.right_1[i].."] = ".. tostring(private.zz_turret.state[i]) );

      ObjMultiSet( {
        { "obj_turret_light1"..i, { input = true } },
        { "obj_turret_light2"..private.zz_turret.right_1[i], { input = true } }
      } );

      ObjAnimate( "spr_turret_light1"..i, "alp", 0, 0, "",      { 0, 0, 0,    0.3, 0, 1 } );
      ObjAnimate( "spr_turret_blue_light1"..i, "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
      ObjAnimate( "spr_turret_light2"..private.zz_turret.right_1[i], "alp", 0, 0, "",      { 0, 0, 0,    0.3, 0, 1 } );
      ObjAnimate( "spr_turret_blue_light2"..private.zz_turret.right_1[i], "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );

      ObjAnimate( "spr_turret_line_1"..i, "alp", 0, 0, "",      { 0, 0, 1,    0.3, 0, 0 } );
      ObjAnimate( "spr_turret_blue_line_1"..i, "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
      ObjAnimate( "spr_turret_line_2"..private.zz_turret.right_1[i], "alp", 0, 0, "",      { 0, 0, 1,    0.3, 0, 0 } );
      ObjAnimate( "spr_turret_blue_line_2"..private.zz_turret.right_1[i], "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
      ObjAnimate( "spr_turret_line_3"..i, "alp", 0, 0, "",      { 0, 0, 1,    0.3, 0, 0 } );
      ObjAnimate( "spr_turret_blue_line_3"..i, "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );

      private.zz_turret.state[i] = false;
      is_reset = true;

    end;
  end;

  if private.zz_turret.state[6] then
    --DbgTrace( "last = "..private.zz_turret.state[6][1].." "..private.zz_turret.state[6][2] );
    ObjAnimate( "spr_turret_line_"..private.zz_turret.state[6][1]..private.zz_turret.state[6][2], "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "spr_turret_light"..private.zz_turret.state[6][1]..private.zz_turret.state[6][2], "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
    ObjAnimate( "spr_turret_blue_light"..private.zz_turret.state[6][1]..private.zz_turret.state[6][2], "alp", 0, 0, "",{ 0, 0, 1,    0.3, 0, 0 } );
    private.zz_turret.state[6] = false;
    is_reset = true;
  end;

  if is_reset then
    cmn.Lock( 1 );
    ObjSet( "tmr_turret_animlock", { time = 0.3, endtrig = function () cmn.Lock( 0 ); end, playing = true } );
  end;

end;
-----------------------------------------------------------------------------------
function public.zz_turret.Skip()

  --DbgTrace( "***Skip" );

  cmn.Lock( 1 );

  ng_global.progress[ ng_global.currentprogress ][ "win_turret" ].skip = 1;

  for i = 1, 5, 1 do
    if not private.zz_turret.state[i] then

      --DbgTrace( "["..i.."] - ["..private.zz_turret.right_1[i].."] = ".. tostring(private.zz_turret.state[i]) );

      ObjMultiSet( {
        { "obj_turret_light1"..i, { input = false } },
        { "obj_turret_light2"..private.zz_turret.right_1[i], { input = false } }
      } );

      ObjAnimate( "spr_turret_light1"..i, "alp", 0, 0, "",      { 0, 0, 1,    0.3, 0, 0 } );
      ObjAnimate( "spr_turret_blue_light1"..i, "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
      ObjAnimate( "spr_turret_light2"..private.zz_turret.right_1[i], "alp", 0, 0, "",      { 0, 0, 1,    0.3, 0, 0 } );
      ObjAnimate( "spr_turret_blue_light2"..private.zz_turret.right_1[i], "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );

      ObjAnimate( "spr_turret_blue_line_1"..i, "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
      ObjAnimate( "spr_turret_blue_line_2"..private.zz_turret.right_1[i], "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
      ObjAnimate( "spr_turret_blue_line_3"..i, "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );

      private.zz_turret.state[i] = true;

    end;
  end;

  if private.zz_turret.state[6] then
    --DbgTrace( "last = "..private.zz_turret.state[6][1].." "..private.zz_turret.state[6][2] );
    ObjAnimate( "spr_turret_line_"..private.zz_turret.state[6][1]..private.zz_turret.state[6][2], "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
    private.zz_turret.state[6] = false;
  end;

  ObjSet( "tmr_turret_animlock", { time = 0.3, endtrig = private.zz_turret.CheckWin, playing = true } );

end;
-----------------------------------------------------------------------------------
function private.zz_turret.DrawScene()

  if private.zz_turret.draw_scene then
    return;
  end;
  private.zz_turret.draw_scene = true;

  --DbgTrace( "***DrawScene" );

  for i = 1, 5, 1 do
    --DbgTrace( "["..i.."] - ["..private.zz_turret.right_1[i].."] = ".. tostring(private.zz_turret.state[i]) );
    if private.zz_turret.state[i] then
      ObjMultiSet( {
        { "spr_turret_light1"..i, { alp = 0 } },
        { "spr_turret_blue_light1"..i, { alp = 1 } },
        { "spr_turret_light2"..private.zz_turret.right_1[i], { alp = 0 } },
        { "spr_turret_blue_light2"..private.zz_turret.right_1[i], { alp = 1 } },

        { "spr_turret_line_1"..i, { alp = 0 } },
        { "spr_turret_blue_line_1"..i, { alp = 1 } },
        { "spr_turret_line_2"..private.zz_turret.right_1[i], { alp = 0 } },
        { "spr_turret_blue_line_2"..private.zz_turret.right_1[i], { alp = 1 } },
        { "spr_turret_line_3"..i, { alp = 0 } },
        { "spr_turret_blue_line_3"..i, { alp = 1 } },

        { "obj_turret_light1"..i, { input = false } },
        { "obj_turret_light2"..private.zz_turret.right_1[i], { input = false } }
      } );
    else
      ObjMultiSet( {
        { "spr_turret_light1"..i, { alp = 1 } },
        { "spr_turret_blue_light1"..i, { alp = 0 } },
        { "spr_turret_light2"..private.zz_turret.right_1[i], { alp = 1 } },
        { "spr_turret_blue_light2"..private.zz_turret.right_1[i], { alp = 0 } },

        { "spr_turret_line_1"..i, { alp = 0 } },
        { "spr_turret_blue_line_1"..i, { alp = 0 } },
        { "spr_turret_line_2"..private.zz_turret.right_1[i], { alp = 0 } },
        { "spr_turret_blue_line_2"..private.zz_turret.right_1[i], { alp = 0 } },
        { "spr_turret_line_3"..i, { alp = 0 } },
        { "spr_turret_blue_line_3"..i, { alp = 0 } },

        { "obj_turret_light1"..i, { input = true } },
        { "obj_turret_light2"..private.zz_turret.right_1[i], { input = true } }
      } );
    end;
  end;

  if private.zz_turret.state[6] then
    --DbgTrace( "last = "..private.zz_turret.state[6][1].." "..private.zz_turret.state[6][2] );
    ObjMultiSet( {
      { "spr_turret_line_"..private.zz_turret.state[6][1]..private.zz_turret.state[6][2], { alp = 1 } },
      { "spr_turret_blue_light"..private.zz_turret.state[6][1]..private.zz_turret.state[6][2], { alp = 1 } },
      { "spr_turret_light"..private.zz_turret.state[6][1]..private.zz_turret.state[6][2], { alp = 0 } }
    } );
  end;

end;
-----------------------------------------------------------------------------------
function private.zz_turret.CheckWin()

  --DbgTrace( "***CheckWin" );

  for i = 1, 5, 1 do
    if not private.zz_turret.state[i] then
      --DbgTrace( "["..i.."] - ["..private.zz_turret.right_1[i].."] = ".. tostring(private.zz_turret.state[i]) );
      cmn.Lock( 0 );
      return;
    end;
  end;

  --DbgTrace( "WWWWWWWWWIIIIIIIIINNNNNNNNNNNNN" );

  common_impl.PauseAchiev(1);
  cmn.MiniGameHide("turret");

  ObjSet( "tmr_turret_animlock", { time = 1, endtrig = private.zz_turret.Win, playing = true } );

end;
-----------------------------------------------------------------------------------
function private.zz_turret.Win()

  cmn.Lock( 1 );
  ObjDelete( "gzz_hangar_turret" );
  --common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_turret" );
  --cmn.CallEventHandler( "win_turret" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_turret" ].skip == 0 and ng_global.noskipgames[ "win_turret" ] == nil then
    ng_global.noskipgames[ "win_turret" ] = 1;
    common_impl.CheckAchiev("mg");
  end;
  
  common.CloseSubRoom();

end;
-----------------------------------------------------------------------------------
function public.zz_turret.Click( num1, num2 )

  --DbgTrace( "***Click: "..num1.." "..num2 );

  cmn.Lock( 1 );

  if private.zz_turret.state[6] then

    if num1 == private.zz_turret.state[6][1] then

      ObjAnimate( "spr_turret_line_"..private.zz_turret.state[6][1]..private.zz_turret.state[6][2],      "alp", 0, 0, "",
        { 0, 0, 1,    0.3, 0, 0 } );
      ObjAnimate( "spr_turret_blue_light"..private.zz_turret.state[6][1]..private.zz_turret.state[6][2], "alp", 0, 0, "",
        { 0, 0, 1,    0.3, 0, 0 } );
      ObjAnimate( "spr_turret_light"..private.zz_turret.state[6][1]..private.zz_turret.state[6][2], "alp", 0, 0, function () cmn.Lock( 0 ); end,
        { 0, 0, 0,    0.3, 0, 1 } );

      if num2 == private.zz_turret.state[6][2] then
        private.zz_turret.state[6] = false;
      else

        private.zz_turret.state[6] = { num1, num2 };

        ObjAnimate( "spr_turret_line_"..num1..num2,      "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
        ObjAnimate( "spr_turret_blue_light"..num1..num2, "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
        ObjAnimate( "spr_turret_light"..num1..num2,      "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );

      end;

      cmn.PlayAudio( "snd", "assets/levels/level2/audio/sfx/aud_mmg_zz_turret_click" );

    else

      if private.zz_turret[ "right_"..num1 ][ num2 ] == private.zz_turret.state[6][2] then

        cmn.PlayAudio( "snd", "assets/levels/level2/audio/sfx/aud_mmg_zz_turret_right" );

        ObjMultiSet( {
          { "obj_turret_light"..num1..num2, { input = false } },
          { "obj_turret_light"..private.zz_turret.state[6][1]..private.zz_turret.state[6][2], { input = false } }
        } );

        ObjAnimate( "spr_turret_light"..num1..num2, "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
        ObjAnimate( "spr_turret_blue_light"..num1..num2, "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
        ObjAnimate( "spr_turret_blue_line_"..num1..num2, "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );

        ObjAnimate( "spr_turret_line_"..private.zz_turret.state[6][1]..private.zz_turret.state[6][2], "alp", 0, 0, "",
          { 0, 0, 1,    0.3, 0, 0 } );
        ObjAnimate( "spr_turret_blue_line_"..private.zz_turret.state[6][1]..private.zz_turret.state[6][2], "alp", 0, 0, "",
          { 0, 0, 0,    0.3, 0, 1 } );

        local pair = num1 == 1 and num2 or private.zz_turret.state[6][2];
        --DbgTrace( "pair = "..pair );

        private.zz_turret.state[pair] = true;

        ObjAnimate( "spr_turret_blue_line_3"..pair, "alp", 0, 0, private.zz_turret.CheckWin, { 0, 0, 0,    0.3, 0, 1 } );

      else

        cmn.PlayAudio( "snd", "assets/levels/level2/audio/sfx/aud_mmg_zz_turret_wrong" );

        ObjAnimate( "spr_turret_light"..num1..num2, "alp", 0, 0, function () cmn.Lock( 0 ); end,
          { 0, 0, 1,    0.15, 0, 1,    0.3, 0, 0,    0.45, 0, 1,    0.6, 0, 0,    0.75, 0, 1 } );

        ObjAnimate( "spr_turret_light"..private.zz_turret.state[6][1]..private.zz_turret.state[6][2], "alp", 0, 0, "",
          { 0, 0, 0,    0.15, 0, 1,    0.3, 0, 0,    0.45, 0, 1,    0.6, 0, 0,    0.75, 0, 1 } );
        ObjAnimate( "spr_turret_blue_light"..private.zz_turret.state[6][1]..private.zz_turret.state[6][2], "alp", 0, 0, "",
          { 0, 0, 1,    0.15, 0, 0 } );

        ObjAnimate( "spr_turret_line_"..private.zz_turret.state[6][1]..private.zz_turret.state[6][2], "alp", 0, 0, "",
          { 0, 0, 1,    0.3, 0, 0 } );

      end;

      private.zz_turret.state[6] = false;

    end;

  else

    cmn.PlayAudio( "snd", "assets/levels/level2/audio/sfx/aud_mmg_zz_turret_click" );

    private.zz_turret.state[6] = { num1, num2 };

    ObjAnimate( "spr_turret_line_"..num1..num2,      "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
    ObjAnimate( "spr_turret_blue_light"..num1..num2, "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
    ObjAnimate( "spr_turret_light"..num1..num2,      "alp", 0, 0, function () cmn.Lock( 0 ); end, { 0, 0, 1,    0.3, 0, 0 } );

  end;

end;
-----------------------------------------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Connectingmodule *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_connectingmodule = {};
public.zz_connectingmodule = {};

function private.Init_Connectingmodule()

  private.zz_connectingmodule.win_prog = {
    { false, true },
    { true, true, false, true, false, 1, 2 },
    { true },
    { true }
  };

  private.zz_connectingmodule.start_prog = {
    { true, false },
    { false, false, true, true, true, 2, 2 },
    { false },
    { false }
  };

  private.zz_connectingmodule.switch_pos_26 = { {192,-131}, {188,-112} };
  private.zz_connectingmodule.switch_pos_27 = { {178,-89}, {174,-70} };

  -----------------------------------------------------------------------------------
  game.hint[ "win_connectingmodule" ] = {
    type = "win",
    room = "rm_hangar",
    zz = "zz_connectingmodule",
    zz_gate = "gzz_hangar_connectingmodule"
  };
  -----------------------------------------------------------------------------------
  local win_connectingmodule = function ()

    if cmn.IsEventDone( "win_connectingmodule" ) then

      ObjMultiSet( {
        { "obj_connectingmodule_game", { input = false } },
        { "anm_hangar_ship", { alp = 1 } }
      } );

      if cmn.IsEventDone( "get_defensesign" ) then
        ObjDelete( "gzz_hangar_connectingmodule" );
      end;

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_connectingmodule", win_connectingmodule, "rm_hangar" );

end;
-----------------------------------------------------------------------------------
function private.zz_connectingmodule.StartConditions()

  --DbgTrace( "***StartConditions" );

  ng_global.progress[ ng_global.currentprogress ][ "win_connectingmodule" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_connectingmodule" ].state = {
    stage = 1,
    need_reset = false,
    stage_prog = {
      { true, false },
      { false, false, true, true, true, 2, 2 },
      { false },
      { false }
    }
  };

end;
-----------------------------------------------------------------------------------
function public.zz_connectingmodule.Reset()

  --DbgTrace( "***Reset" );

  private.zz_connectingmodule.state.need_reset = false;

  local is_reset = false;

  for i = 1, 4, 1 do
    for j = 1, #private.zz_connectingmodule.state.stage_prog[i], 1 do
      if private.zz_connectingmodule.state.stage_prog[i][j] ~= private.zz_connectingmodule.start_prog[i][j] then

        --DbgTrace( 
        --  i.." "..j.." == "..
        --  tostring( private.zz_connectingmodule.state.stage_prog[i][j] ).." ~= "..
        --  tostring( private.zz_connectingmodule.start_prog[i][j] )
        --);

        is_reset = true;

        public.zz_connectingmodule.Click( i, j, true );

      end;
    end;
  end;

  private.zz_connectingmodule.state.stage = 1;

  if is_reset then
    cmn.Lock( 1 );
    ObjSet( "tmr_connectingmodule_animlock", { time = 0.15, endtrig = function () cmn.Lock( 0 ); end, playing = true } );
  else
    cmn.Lock( 0 );
  end;
  
  ObjSet("obj_connectingmodule_switch_101",{ input = true });
  ObjSet("obj_connectingmodule_switch_102",{ input = true });
  ObjSet("obj_connectingmodule_switch_103",{ input = true });

end;
-----------------------------------------------------------------------------------
function public.zz_connectingmodule.Skip()

  --DbgTrace( "***Skip" );

  cmn.Lock( 1 );

  ng_global.progress[ ng_global.currentprogress ][ "win_connectingmodule" ].skip = 1;

  for i = 1, 4, 1 do
    for j = 1, #private.zz_connectingmodule.state.stage_prog[i], 1 do
      if private.zz_connectingmodule.state.stage_prog[i][j] ~= private.zz_connectingmodule.win_prog[i][j] then

        --DbgTrace( 
        --  i.." "..j.." == "..
        --  tostring( private.zz_connectingmodule.state.stage_prog[i][j] ).." ~= "..
        --  tostring( private.zz_connectingmodule.win_prog[i][j] )
        --);

        public.zz_connectingmodule.Click( i, j, true );

      end;
    end;
  end;

  ObjSet( "tmr_connectingmodule_animlock", { time = 0.15, endtrig = private.zz_connectingmodule.CheckWin, playing = true } );

end;
-----------------------------------------------------------------------------------
function private.zz_connectingmodule.DrawScene()

  if private.zz_connectingmodule.draw_scene then
    return;
  end;
  private.zz_connectingmodule.draw_scene = true;

  --DbgTrace( "***DrawScene" );

  if private.zz_connectingmodule.state.need_reset then

    --DbgTrace( "need_reset" );

    private.zz_connectingmodule.StartConditions();
    private.zz_connectingmodule.state = ng_global.progress[ ng_global.currentprogress ][ "win_connectingmodule" ].state;

  end;

  for i = 1, 2, 1 do
    if private.zz_connectingmodule.state.stage_prog[1][i] then
      ObjMultiSet( {
        { "spr_connectingmodule_switch_on_1"..i, { alp = 1 } },
        { "spr_connectingmodule_switch_off_1"..i, { alp = 0 } }
      } );
    else
      ObjMultiSet( {
        { "spr_connectingmodule_switch_on_1"..i, { alp = 0 } },
        { "spr_connectingmodule_switch_off_1"..i, { alp = 1 } }
      } );
    end;
  end;

  for i = 1, 5, 1 do
    if private.zz_connectingmodule.state.stage_prog[2][i] then
      ObjMultiSet( {
        { "spr_connectingmodule_switch_on_2"..i, { alp = 1 } },
        { "spr_connectingmodule_switch_light_2"..i, { alp = 1 } },
        { "spr_connectingmodule_switch_off_2"..i, { alp = 0 } }
      } );
    else
      ObjMultiSet( {
        { "spr_connectingmodule_switch_on_2"..i, { alp = 0 } },
        { "spr_connectingmodule_switch_light_2"..i, { alp = 0 } },
        { "spr_connectingmodule_switch_off_2"..i, { alp = 1 } }
      } );
    end;
  end;

  for i = 6, 7, 1 do
    ObjSet( "spr_connectingmodule_switch_2"..i, {
      pos_x = private.zz_connectingmodule[ "switch_pos_2"..i ][ private.zz_connectingmodule.state.stage_prog[2][i] ][1],
      pos_y = private.zz_connectingmodule[ "switch_pos_2"..i ][ private.zz_connectingmodule.state.stage_prog[2][i] ][2]
    } );
  end;

  if private.zz_connectingmodule.state.stage_prog[3][1] then
    ObjSet( "spr_connectingmodule_switch_31", { ang = -1.44 } );
  else
    ObjSet( "spr_connectingmodule_switch_31", { ang = 0 } );
  end;

  if private.zz_connectingmodule.state.stage_prog[4][1] then
    ObjSet( "spr_connectingmodule_switch_41", { ang = -1.44 } );
  else
    ObjSet( "spr_connectingmodule_switch_41", { ang = 0 } );
  end;

end;
-----------------------------------------------------------------------------------
function private.zz_connectingmodule.CheckWin()

  --DbgTrace( "***CheckWin" );

  for i = 1, 4, 1 do
    for j = 1, #private.zz_connectingmodule.state.stage_prog[i], 1 do
      if private.zz_connectingmodule.state.stage_prog[i][j] ~= private.zz_connectingmodule.win_prog[i][j] then

        --DbgTrace( 
        --  i.." "..j.." == "..
        --  tostring( private.zz_connectingmodule.state.stage_prog[i][j] ).." ~= "..
        --  tostring( private.zz_connectingmodule.win_prog[i][j] )
        --);

        private.zz_connectingmodule.state.stage = i;

        cmn.Lock( 0 );

        return;

      end;
    end;
  end;

  --DbgTrace( "WWWWWWWWWIIIIIIIIINNNNNNNNNNNNN" );

  cmn.PlayAudio( "snd", "assets/levels/level2/audio/sfx/aud_mmgzz_hangar_win" );

  common_impl.PauseAchiev(1);
  cmn.MiniGameHide("connectingmodule");

  ObjSet( "anm_connectingmodule_lights", {
    playing = true,
    endtrig = function () ObjSet( "anm_connectingmodule_lights", { animfunc = "func_lights_on", endtrig = "", playing = true } ); end
  } );

  ObjSet( "anm_connectingmodule_hologram", {
    playing = true,
    endtrig = function () ObjSet( "anm_connectingmodule_hologram", { animfunc = "func_hologram_on", endtrig = "", playing = true } ); end
  } );

  ObjSet( "anm_connectingmodule_hud", { endtrig = private.zz_connectingmodule.Win, playing = true } );

end;
-----------------------------------------------------------------------------------
function private.zz_connectingmodule.Win()

  cmn.Lock( 0 );
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_connectingmodule" );
  cmn.CallEventHandler( "win_connectingmodule" );

  ObjSet( "anm_connectingmodule_hud", { animfunc = "func_hud_on", endtrig = "", playing = true } );

  if ng_global.progress[ ng_global.currentprogress ][ "win_connectingmodule" ].skip == 0 and ng_global.noskipgames[ "win_connectingmodule" ] == nil then
    ng_global.noskipgames[ "win_connectingmodule" ] = 1;
    common_impl.CheckAchiev("mg");
  end;

  if cmn.IsEventDone( "get_defensesign" ) then
    common.CloseSubRoom();
  end;

  if cmn.IsEventDone("win_turret") then
    private.play_outro();
  end;
    
end;

  --private.zz_connectingmodule.win_prog = {
  --  { false, true },
  --  { true, true, false, true, false, 1, 2 },
  --  { true },
  --  { true }
  --};

  --private.zz_connectingmodule.start_prog = {
  --  { true, false },
  --  { false, false, true, true, true, 2, 2 },
  --  { false },
  --  { false }
  --};
-----------------------------------------------------------------------------------
function public.zz_connectingmodule.Click_port( num )
  if num == 101 then
    if private.zz_connectingmodule.state.stage_prog[1][1] ~= private.zz_connectingmodule.win_prog[1][1] then
      public.zz_connectingmodule.Click( 1, 1 );
    end;
    if private.zz_connectingmodule.state.stage_prog[1][2] ~= private.zz_connectingmodule.win_prog[1][2] then
      public.zz_connectingmodule.Click( 1, 2 );
    end;
    ObjSet("obj_connectingmodule_switch_101",{ input = false });
  elseif num == 102 then
    if private.zz_connectingmodule.state.stage_prog[2][1] ~= private.zz_connectingmodule.win_prog[2][1] then
      public.zz_connectingmodule.Click( 2, 1 );
    end;
    if private.zz_connectingmodule.state.stage_prog[2][2] ~= private.zz_connectingmodule.win_prog[2][2] then
      public.zz_connectingmodule.Click( 2, 2 );                                                   
    end;                                                                                          
    if private.zz_connectingmodule.state.stage_prog[2][3] ~= private.zz_connectingmodule.win_prog[2][3] then
      public.zz_connectingmodule.Click( 2, 3 );                                                   
    end;                                                                                          
    if private.zz_connectingmodule.state.stage_prog[2][5] ~= private.zz_connectingmodule.win_prog[2][5] then
      public.zz_connectingmodule.Click( 2, 5 );
    end;
    ObjSet("obj_connectingmodule_switch_102",{ input = false });
  elseif num == 103 then
    if private.zz_connectingmodule.state.stage_prog[2][6] ~= private.zz_connectingmodule.win_prog[2][6] then
      public.zz_connectingmodule.Click( 2, 6 );
    end;
    ObjSet("obj_connectingmodule_switch_103",{ input = false });
  end;
end;

-----------------------------------------------------------------------------------
function public.zz_connectingmodule.Click( stage, num, from_reset )

  --DbgTrace( "***Click: "..tostring(stage).." "..tostring(num).." "..tostring(from_reset) );

  if stage == 2 and num > 5 then

    local start_pos = private.zz_connectingmodule[ "switch_pos_2"..num ][ private.zz_connectingmodule.state.stage_prog[2][num] ];
    private.zz_connectingmodule.state.stage_prog[2][num] = private.zz_connectingmodule.state.stage_prog[2][num] == 1 and 2 or 1;
    local end_pos = private.zz_connectingmodule[ "switch_pos_2"..num ][ private.zz_connectingmodule.state.stage_prog[2][num] ];

    ObjAnimate( "spr_connectingmodule_switch_2"..num, "pos_xy", 0, 0, "", {
      0,    0, start_pos[1], start_pos[2],
      0.15, 0, end_pos[1],   end_pos[2]
    } );

  elseif stage == 3 or stage == 4 then

    private.zz_connectingmodule.state.stage_prog[stage][num] = not private.zz_connectingmodule.state.stage_prog[stage][num] and true or false;
    local ang = private.zz_connectingmodule.state.stage_prog[stage][num] and {0, -1.44} or {-1.44, 0};
    --DbgTrace( "ang = "..ang[1].." -> "..ang[2] );

    ObjAnimate( "spr_connectingmodule_switch_"..stage..num, "ang", 0, 0, "", { 0, 0, ang[1],   0.15, 0, ang[2] } );

  else

    private.zz_connectingmodule.state.stage_prog[stage][num] = not private.zz_connectingmodule.state.stage_prog[stage][num] and true or false;

    if private.zz_connectingmodule.state.stage_prog[stage][num] then
      ObjAnimate( "spr_connectingmodule_switch_off_"..stage..num, "alp", 0, 0, "", { 0, 0, 1,    0.15, 0, 0 } );
      ObjAnimate( "spr_connectingmodule_switch_on_"..stage..num,  "alp", 0, 0, "", { 0, 0, 0,    0.15, 0, 1 } );
    else
      ObjAnimate( "spr_connectingmodule_switch_off_"..stage..num, "alp", 0, 0, "", { 0, 0, 0,    0.15, 0, 1 } );
      ObjAnimate( "spr_connectingmodule_switch_on_"..stage..num,  "alp", 0, 0, "", { 0, 0, 1,    0.15, 0, 0 } );
    end;

    if stage == 2 and num < 6 then
      if private.zz_connectingmodule.state.stage_prog[stage][num] then
        ObjAnimate( "spr_connectingmodule_switch_light_2"..num, "alp", 0, 0, "", { 0, 0, 0,    0.15, 0, 1 } );
      else
        ObjAnimate( "spr_connectingmodule_switch_light_2"..num, "alp", 0, 0, "", { 0, 0, 1,    0.15, 0, 0 } );
      end;
    end;

  end;

  --DbgTrace( "state.stage == "..private.zz_connectingmodule.state.stage );
  --DbgTrace( tostring(private.zz_connectingmodule.state.stage_prog[stage][num]) );
  --DbgTrace( tostring(private.zz_connectingmodule.win_prog[stage][num]) );

  if from_reset then return end;

  cmn.Lock( 1 );

  local func_after;

  if private.zz_connectingmodule.state.stage_prog[stage][num] ~= private.zz_connectingmodule.win_prog[stage][num]
  or stage ~= private.zz_connectingmodule.state.stage then
    private.zz_connectingmodule.state.need_reset = true;
    func_after = public.zz_connectingmodule.Reset;
    cmn.PlayAudio( "snd", "assets/levels/level2/audio/sfx/aud_mmgzz_hangar_click_wrong_"..math.random( 1, 3 ) );
  else
    func_after = private.zz_connectingmodule.CheckWin;
    cmn.PlayAudio( "snd", "assets/levels/level2/audio/sfx/aud_mmgzz_hangar_click_right_"..math.random( 1, 3 ) );
  end;

  ObjSet( "tmr_connectingmodule_animlock", { time = 0.15, endtrig = func_after, playing = true } );

end;