-- name=rm_maindeck
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_maindeck";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Repairmodule();
  private.dlg_lipsync = "";
  private.module_found = false;
  --------------------------------------------------------------------------------------------
  -- function get_manipulatorbase () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_manipulatorbase" ] = {
    type = "get",
    get_obj = "spr_onboardcomputer_manipulatorbase",
    room = private.room_objname,
    zz = "zz_onboardcomputer",
    zz_gate = "gzz_maindeck_onboardcomputer"
  };
  --------------------------------------------------------------------------------------------
  local get_manipulatorbase_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_manipulatorbase", "spr_onboardcomputer_manipulatorbase" );
  
  end;
  local get_manipulatorbase_end = function ()
  
    ObjDelete( "gfx_onboardcomputer_manipulatorbase" );
    ObjDelete( "spr_onboardcomputer_manipulatorbase_sh" );
    
    ObjDelete( "spr_maindeck_boardpc_manipulator" );
  
  end;
  
  cmn.AddSubscriber( "get_manipulatorbase", get_manipulatorbase_inv );
  cmn.AddSubscriber( "get_manipulatorbase", get_manipulatorbase_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_manipulatormodule () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_manipulatormodule" ] = {
    type = "get",
    get_obj = "spr_pilotseat_manipulatormodule",
    room = private.room_objname,
    zz = "zz_pilotseat",
    zz_gate = "gzz_maindeck_pilotseat"
  };
  --------------------------------------------------------------------------------------------
  local get_manipulatormodule_inv = function ()
  
    interface.InventoryItemAdd( "inv_manipulatormodule", "spr_pilotseat_manipulatormodule" );
    ObjSet("inv_manipulatorbase_star_light",  { alp = 1 });
  
  end;
  local get_manipulatormodule_end = function ()
  
    ObjDelete( "gfx_pilotseat_manipulatormodule" );
    ObjDelete( "spr_pilotseat_manipulatormodule_sh" );
    
    ObjDelete( "spr_maindeck_pilot_claw" );
  
  end;
  
  cmn.AddSubscriber( "get_manipulatormodule", get_manipulatormodule_inv );
  cmn.AddSubscriber( "get_manipulatormodule", get_manipulatormodule_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_accesstoweaponcodes () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_accesstoweaponcodes" ] = {
    type = "get",
    get_obj = "spr_pilotseat_accesstoweaponcodes",
    room = private.room_objname,
    zz = "zz_pilotseat",
    zz_gate = "gzz_maindeck_pilotseat"
  };
  --------------------------------------------------------------------------------------------
  local get_accesstoweaponcodes_inv = function ()
  
    interface.InventoryItemAdd( "inv_accesstoweaponcodes", "spr_pilotseat_accesstoweaponcodes" );
  
  end;
  local get_accesstoweaponcodes_end = function ()
  
    ObjDelete( "gfx_pilotseat_accesstoweaponcodes" );
    
    ObjDelete( "spr_maindeck_pilot_codes_1" );
  
  end;
  
  cmn.AddSubscriber( "get_accesstoweaponcodes", get_accesstoweaponcodes_inv );
  cmn.AddSubscriber( "get_accesstoweaponcodes", get_accesstoweaponcodes_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_accesstoshipcode () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_accesstoshipcode" ] = {
    type = "get",
    get_obj = "spr_pilotseat_accesstoshipcode",
    room = private.room_objname,
    zz = "zz_pilotseat",
    zz_gate = "gzz_maindeck_pilotseat"
  };
  --------------------------------------------------------------------------------------------
  local get_accesstoshipcode_inv = function ()
  
    interface.InventoryItemAdd( "inv_accesstoshipcode", "spr_pilotseat_accesstoshipcode" );
    int_map_impl.DecreaseRoomTasks("rm_maindeck");
  
  end;
  local get_accesstoshipcode_end = function ()
  
    ObjDelete( "gfx_pilotseat_accesstoshipcode" );
    
    ObjDelete( "spr_maindeck_pilot_codes_2" );
    ObjDelete( "gzz_maindeck_pilotseat" );
  
  end;
  
  cmn.AddSubscriber( "get_accesstoshipcode", get_accesstoshipcode_inv );
  cmn.AddSubscriber( "get_accesstoshipcode", get_accesstoshipcode_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_manipulatorclaw () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_manipulatorclaw" ] = {
    type = "get",
    get_obj = "spr_rescuecapsule_manipulatorclaw",
    room = private.room_objname,
    zz = "zz_rescuecapsule",
    zz_gate = "gzz_maindeck_rescuecapsule"
  };
  --------------------------------------------------------------------------------------------
  local get_manipulatorclaw_inv = function ()
  
    interface.InventoryItemAdd( "inv_manipulatorclaw", "spr_rescuecapsule_manipulatorclaw" );
    ObjSet("inv_manipulatorbase_star_light",  { alp = 1 });
  
  end;
  local get_manipulatorclaw_end = function ()
  
    ObjDelete( "gfx_rescuecapsule_manipulatorclaw" );
    ObjDelete( "spr_rescuecapsule_manipulatorclaw_sh" );
    ObjDelete( "spr_rescuecapsule_manipulatorclaw_bl" );
    
    ObjDelete( "spr_maindeck_capsule_claw" );
  
  end;
  
  cmn.AddSubscriber( "get_manipulatorclaw", get_manipulatorclaw_inv );
  cmn.AddSubscriber( "get_manipulatorclaw", get_manipulatorclaw_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_robot () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_robot" ] = {
    type = "get",
    get_obj = "obj_repairmodule_robot",
    room = private.room_objname,
    zz = "zz_repairmodule",
    zz_gate = "gzz_maindeck_repairmodule"
  };
  --------------------------------------------------------------------------------------------
  local get_robot_inv = function ()
  
    interface.InventoryItemAdd( "inv_robot", "obj_repairmodule_robot" );
  
  end;
  local get_robot_end = function ()
  
    ObjDelete( "gfx_repairmodule_robot" );
    
    ObjDelete( "spr_maindeck_robot_2" );
    ObjDelete( "gzz_maindeck_repairmodule" );
  
  end;
  
  cmn.AddSubscriber( "get_robot", get_robot_inv );
  cmn.AddSubscriber( "get_robot", get_robot_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bomb () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_bomb" ] = {
    type = "get",
    get_obj = "spr_repairmodule_bombpart1",
    room = private.room_objname,
    zz = "zz_repairmodule",
    zz_gate = "gzz_maindeck_repairmodule"
  };
  --------------------------------------------------------------------------------------------
  local get_bomb_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_bomb", "spr_repairmodule_bombpart1" );
  
  end;
  local get_bomb_end = function ()
  
    ObjDelete( "gfx_repairmodule_bombpart1" );
    ObjDelete( "spr_repairmodule_bombpart1_sh_1" );
    
    ObjDelete( "spr_maindeck_robot_bomb" );
  
  end;
  
  cmn.AddSubscriber( "get_bomb", get_bomb_inv );
  cmn.AddSubscriber( "get_bomb", get_bomb_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bag () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_bag" ] = {
    type = "get",
    get_obj = "spr_repairmodule_bag",
    room = private.room_objname,
    zz = "zz_repairmodule",
    zz_gate = "gzz_maindeck_repairmodule"
  };
  --------------------------------------------------------------------------------------------
  local get_bag_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_bag", "spr_repairmodule_bag" );
  
  end;
  local get_bag_end = function ()
  
    ObjDelete( "gfx_repairmodule_bag" );
    ObjDelete( "spr_repairmodule_bag_sh_1" );
    ObjDelete( "spr_repairmodule_bag_sh_2" );
    ObjDelete( "spr_repairmodule_bag_sh_3" );
    ObjDelete( "spr_repairmodule_bag_2" );
    ObjDelete( "spr_repairmodule_bag_3" );
    
    ObjDelete( "spr_maindeck_robot_amulet" );
  
  end;
  
  cmn.AddSubscriber( "get_bag", get_bag_inv );
  cmn.AddSubscriber( "get_bag", get_bag_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_memorymodule () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_memorymodule" ] = {
    type = "get",
    get_obj = "spr_maindeck_memorymodule",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_memorymodule_inv = function ()
  
    interface.InventoryItemAdd( "inv_memorymodule", "spr_maindeck_memorymodule" );
  
  end;
  local get_memorymodule_end = function ()
  
    ObjDelete( "gfx_maindeck_memorymodule" );
    --ObjDelete( "gzz_maindeck_maindeck" );
  
  end;
  
  cmn.AddSubscriber( "get_memorymodule", get_memorymodule_inv );
  cmn.AddSubscriber( "get_memorymodule", get_memorymodule_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_bombpart1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_bombpart1" ] = {
      type = "get",
      get_obj = "spr_maindeck_bombpart1",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_bombpart1_inv = function ()
  
    interface.InventoryItemAdd( "inv_bombpart", "spr_maindeck_bombpart1", function () cmn.GetMultyObject( 'bombpart', 3 ); end );
    
    if cmn.CheckMultiObject( "bombpart", 3 ) then
      ObjSet("inv_bomb_star_light",  { alp = 1 });
    end;
  
  end;
  local get_bombpart1_mid = function ()
  
    ObjDelete( "gfx_maindeck_bombpart1" );
    ObjDelete( "spr_maindeck_bombpart1_sh" );
    
  end;
  local get_bombpart1_end = function ()
  
    ObjDelete( "obj_maindeck_dialog_jean4" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_bombpart1", get_bombpart1_inv );
  cmn.AddSubscriber( "get_bombpart1_inv", get_bombpart1_inv, private.room_objname );
  cmn.AddSubscriber( "get_bombpart1", get_bombpart1_mid, private.room_objname );
  cmn.AddSubscriber( "get_bombpart1_mid", get_bombpart1_mid, private.room_objname );
  cmn.AddSubscriber( "get_bombpart1", get_bombpart1_end, private.room_objname );
  cmn.AddSubscriber( "get_bombpart1_end", get_bombpart1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_researcher () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_researcher" ] = {
      type = "get",
      get_obj = "spr_maindeck_researcher",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_researcher = function ()
  
    ObjDelete( "obj_maindeck_dialog_ai" );
    ObjDelete( "obj_maindeck_use_researcher" );
    ObjAttach("obj_maindeck_researcher", "rm_maindeck");
  
    ObjSet( "obj_maindeck_researcher", { input = 1, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_researcher", get_researcher, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_eye () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_eye" ] = {
    type = "use",
    inv_obj = "inv_eye",
    use_place = "obj_onboardcomputer_use_eye",
    room = private.room_objname,
    zz = "zz_onboardcomputer",
    zz_gate = "gzz_maindeck_onboardcomputer"
  };
  --------------------------------------------------------------------------------------------
  local use_eye_inv = function ()
  
    interface.InventoryItemRemove( "inv_eye" );
  
  end;
  local use_eye_beg = function ()
  
    ObjDelete( "obj_onboardcomputer_use_eye" );
    ObjSet("spr_maindeck_boardpc_screen_1",  { alp = 1 });
  
  end;
  local use_eye_end = function ()
    
    ObjDelete( "vid_maindeck_dialog_ai_lipsync1" );
    ObjDelete( "vid_maindeck_dialog_ai_lipsync2" );
    
    ObjAttach("obj_maindeck_dialog_ai", "rm_maindeck");
  
    ObjMultiSet( { {"obj_maindeck_dialog_ai", { alp = 1, input = 1 }},
                   {"obj_maindeck_dialog_ai_hand_2", { alp = 1, input = 1 }},
                   {"anm_onboardcomputer_use_eye", { alp = 1, frame = 400 }},
                   {"spr_maindeck_dialog_ai_face", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_eye", use_eye_beg, private.room_objname );
  cmn.AddSubscriber( "use_eye", use_eye_inv );
  cmn.AddSubscriber( "use_eye", use_eye_end, private.room_objname );
  cmn.AddSubscriber( "use_eye_inv", use_eye_inv, private.room_objname );
  cmn.AddSubscriber( "use_eye_beg", use_eye_beg, private.room_objname );
  cmn.AddSubscriber( "use_eye_end", use_eye_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_memorymodule () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_memorymodule" ] = {
    type = "use",
    inv_obj = "inv_memorymodule",
    use_place = "obj_onboardcomputer_use_memorymodule",
    room = private.room_objname,
    zz = "zz_onboardcomputer",
    zz_gate = "gzz_maindeck_onboardcomputer"
  };
  --------------------------------------------------------------------------------------------
  local use_memorymodule_inv = function ()
  
    interface.InventoryItemRemove( "inv_memorymodule" );
    interface_impl.SetCurrentGlobalTask( 10 );
  
  end;
  local use_memorymodule_beg = function ()
  
    ObjDelete( "obj_onboardcomputer_use_memorymodule" );
    --ObjDelete( "anm_onboardcomputer_memory_touch" );
    ObjSet("gzz_maindeck_onboardcomputer",  { active = 0, alp = 0 });
  
  end;
  local use_memorymodule_end = function ()
  
    ObjDelete( "vid_onboardcomputer_aion" );
    ObjDelete( "anm_onboardcomputer_memory_touch" );
    
    ObjDelete( "spr_maindeck_boardpc_screen_1" );
    ObjDelete( "spr_maindeck_boardpc_base_1" );
    
    ObjDelete( "vid_maindeck_dialog_jean4_lipsync1" );
    ObjDelete( "vid_maindeck_dialog_jean4_lipsync2" );
    
    ObjDelete( "anm_maindeck_dialog_jean4_give" );
    ObjDelete( "anm_maindeck_dialog_jean4_hand_1" );
    
    ObjAttach("obj_maindeck_dialog_jean4", "rm_maindeck");
  
    ObjMultiSet( { {"obj_maindeck_dialog_jean4", { alp = 1, input = 1 }},
                   {"obj_maindeck_dialog_jean4_hand_2", { alp = 1, input = 1 }},
                   { "obj_maindeck_use_weapon", { input = 1, alp = 1 } },
                   {"anm_onboardcomputer_use_memorymodule", { alp = 1, frame = 300 }},
                   {"spr_onboardcomputer_screen_broken", { alp = 1 }},
                   {"spr_maindeck_boardpc_screen_2", { alp = 1 }},
                   {"spr_maindeck_boardpc_base_2", { alp = 1 }},
                   {"anm_maindeck_dialog_jean4_head", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_memorymodule", use_memorymodule_beg, private.room_objname );
  cmn.AddSubscriber( "use_memorymodule", use_memorymodule_inv );
  cmn.AddSubscriber( "use_memorymodule", use_memorymodule_end, private.room_objname );
  cmn.AddSubscriber( "use_memorymodule_inv", use_memorymodule_inv, private.room_objname );
  cmn.AddSubscriber( "use_memorymodule_beg", use_memorymodule_beg, private.room_objname );
  cmn.AddSubscriber( "use_memorymodule_end", use_memorymodule_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bracelet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_bracelet" ] = {
    type = "use",
    inv_obj = "inv_bracelet",
    use_place = "obj_pilotseat_use_bracelet",
    room = private.room_objname,
    zz = "zz_pilotseat",
    zz_gate = "gzz_maindeck_pilotseat"
  };
  --------------------------------------------------------------------------------------------
  local use_bracelet_inv = function ()
  
    interface.InventoryItemRemove( "inv_bracelet" );
  
  end;
  local use_bracelet_beg = function ()
  
    ObjDelete( "obj_pilotseat_use_bracelet" );
    ObjDelete( "anm_pilotseat_bracelet_touch" );
    ObjSet("obj_pilotseat_bracelet_open",  { alp = 1 });
  
  end;
  local use_bracelet_end = function ()
  
    ObjDelete( "spr_pilotseat_bracelet_closed" );
    ObjDelete( "spr_maindeck_pilot_bracelet_1" );
  
    ObjMultiSet( { {"obj_pilotseat_bracelet_open", { input = 1 }},
                   {"spr_pilotseat_bracelet_open", { alp = 1 }},
                   {"spr_pilotseat_bracelet_2", { alp = 1 }},
                   {"spr_maindeck_pilot_bracelet_2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bracelet", use_bracelet_beg, private.room_objname );
  cmn.AddSubscriber( "use_bracelet", use_bracelet_inv );
  cmn.AddSubscriber( "use_bracelet", use_bracelet_end, private.room_objname );
  cmn.AddSubscriber( "use_bracelet_inv", use_bracelet_inv, private.room_objname );
  cmn.AddSubscriber( "use_bracelet_beg", use_bracelet_beg, private.room_objname );
  cmn.AddSubscriber( "use_bracelet_end", use_bracelet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_shipsymbol () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_shipsymbol" ] = {
    type = "use",
    inv_obj = "inv_shipsymbol",
    use_place = "obj_pilotseat_use_shipsymbol",
    room = private.room_objname,
    zz = "zz_pilotseat",
    zz_gate = "gzz_maindeck_pilotseat"
  };
  --------------------------------------------------------------------------------------------
  local use_shipsymbol_inv = function ()
  
    interface.InventoryItemRemove( "inv_shipsymbol" );
  
  end;
  local use_shipsymbol_beg = function ()
  
    ObjDelete( "obj_pilotseat_use_shipsymbol" );
    
    if cmn.IsEventDone("use_shipsymbol2") then
      ObjSet("obj_pilotseat_box",  { alp = 1 });
    end;
  
  end;
  local use_shipsymbol_end = function ()
    
    if cmn.IsEventDone("use_shipsymbol2") then
      ObjDelete( "anm_pilotseat_box_touch" );
      ObjDelete( "spr_maindeck_pilot_box_1" );
    
      ObjMultiSet( { {"obj_pilotseat_box", { input = 1 }},
                     {"spr_pilotseat_box_open", { alp = 1 }},
                     {"spr_maindeck_pilot_box_2", { alp = 1 }} } );
    else 
      ObjSet("spr_pilotseat_ship_amulet",  { alp = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_shipsymbol", use_shipsymbol_beg, private.room_objname );
  cmn.AddSubscriber( "use_shipsymbol", use_shipsymbol_inv );
  cmn.AddSubscriber( "use_shipsymbol", use_shipsymbol_end, private.room_objname );
  cmn.AddSubscriber( "use_shipsymbol_inv", use_shipsymbol_inv, private.room_objname );
  cmn.AddSubscriber( "use_shipsymbol_beg", use_shipsymbol_beg, private.room_objname );
  cmn.AddSubscriber( "use_shipsymbol_end", use_shipsymbol_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_shipsymbol2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_shipsymbol2" ] = {
    type = "use",
    inv_obj = "inv_shipsymbol2",
    use_place = "obj_pilotseat_use_shipsymbol2",
    room = private.room_objname,
    zz = "zz_pilotseat",
    zz_gate = "gzz_maindeck_pilotseat"
  };
  --------------------------------------------------------------------------------------------
  local use_shipsymbol2_inv = function ()
  
    interface.InventoryItemRemove( "inv_shipsymbol2" );
  
  end;
  local use_shipsymbol2_beg = function ()
  
    ObjDelete( "obj_pilotseat_use_shipsymbol2" );
    
    if cmn.IsEventDone("use_shipsymbol") then
      ObjSet("obj_pilotseat_box",  { alp = 1 });
    end;
  
  end;
  local use_shipsymbol2_end = function ()
    
    if cmn.IsEventDone("use_shipsymbol") then
      ObjDelete( "anm_pilotseat_box_touch" );
      ObjDelete( "spr_maindeck_pilot_box_1" );
    
      ObjMultiSet( { {"obj_pilotseat_box", { input = 1 }},
                     {"spr_pilotseat_box_open", { alp = 1 }},
                     {"spr_maindeck_pilot_box_2", { alp = 1 }} } );
    else 
      ObjSet("spr_pilotseat_ship_amulet2",  { alp = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_shipsymbol2", use_shipsymbol2_beg, private.room_objname );
  cmn.AddSubscriber( "use_shipsymbol2", use_shipsymbol2_inv );
  cmn.AddSubscriber( "use_shipsymbol2", use_shipsymbol2_end, private.room_objname );
  cmn.AddSubscriber( "use_shipsymbol2_inv", use_shipsymbol2_inv, private.room_objname );
  cmn.AddSubscriber( "use_shipsymbol2_beg", use_shipsymbol2_beg, private.room_objname );
  cmn.AddSubscriber( "use_shipsymbol2_end", use_shipsymbol2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_robot () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_robot" ] = {
    type = "use",
    inv_obj = "inv_robot",
    use_place = "obj_rescuecapsule_use_robot",
    room = private.room_objname,
    zz = "zz_rescuecapsule",
    zz_gate = "gzz_maindeck_rescuecapsule"
  };
  --------------------------------------------------------------------------------------------
  local use_robot_inv = function ()
  
    interface.InventoryItemRemove( "inv_robot" );
  
  end;
  local use_robot_beg = function ()
  
    ObjDelete( "obj_rescuecapsule_use_robot" );
  
  end;
  local use_robot_end = function ()
  
    ObjDelete( "gzz_maindeck_rescuecapsule" );
    
    ObjMultiSet( { {"gho_maindeck_insiderescuecapsule", { input = 1, alp = 1, active = 1 }},
                   {"spr_maindeck_capsule_open", { alp = 1 }} } );
    
  end;
  local use_robot_end2 = function ()
  
    ObjDelete( "vid_rescuecapsule_use_robot" );
    ObjDelete( "vid_maindeck_droid_leave" );
    ObjSet("spr_maindeck_robot_3",  { alp = 1 });
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_robot", use_robot_beg, private.room_objname );
  cmn.AddSubscriber( "use_robot", use_robot_inv );
  cmn.AddSubscriber( "use_robot", use_robot_end, private.room_objname );
  cmn.AddSubscriber( "use_robot_inv", use_robot_inv, private.room_objname );
  cmn.AddSubscriber( "use_robot_beg", use_robot_beg, private.room_objname );
  cmn.AddSubscriber( "use_robot_end", use_robot_end, private.room_objname );
  cmn.AddSubscriber( "use_robot", use_robot_end2, private.room_objname );
  cmn.AddSubscriber( "use_robot_end2", use_robot_end2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_brain () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_brain" ] = {
    type = "use",
    inv_obj = "inv_brain",
    use_place = "obj_repairmodule_use_brain",
    room = private.room_objname,
    zz = "zz_repairmodule",
    zz_gate = "gzz_maindeck_repairmodule"
  };
  --------------------------------------------------------------------------------------------
  local use_brain_inv = function ()
  
    interface.InventoryItemRemove( "inv_brain" );
  
  end;
  local use_brain_beg = function ()
  
    ObjDelete( "obj_repairmodule_use_brain" );
    ObjDelete( "anm_repairmodule_robot_touch" );
  
  end;
  local use_brain_end = function ()
  
    ObjDelete( "anm_repairmodule_use_brain" );
    ObjMultiSet( { {"obj_repairmodule_robot", { alp = 1 }},
                   {"obj_repairmodule_game", { input = 1, alp = 1 }},
                   {"spr_maindeck_robot_brain", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_brain", use_brain_beg, private.room_objname );
  cmn.AddSubscriber( "use_brain", use_brain_inv );
  cmn.AddSubscriber( "use_brain", use_brain_end, private.room_objname );
  cmn.AddSubscriber( "use_brain_inv", use_brain_inv, private.room_objname );
  cmn.AddSubscriber( "use_brain_beg", use_brain_beg, private.room_objname );
  cmn.AddSubscriber( "use_brain_end", use_brain_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_researcher () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_researcher" ] = {
    type = "use",
    inv_obj = "inv_researcher",
    use_place = "obj_maindeck_use_researcher",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local use_researcher_inv = function ()
  
    interface.InventoryItemRemove( "inv_researcher" );
  
  end;
  local use_researcher_beg = function ()
  
    ObjDelete( "obj_maindeck_use_researcher" );
    ObjAttach("obj_maindeck_researcher", "rm_maindeck");
  
  end;
  local use_researcher_end = function ()
  
    ObjSet( "obj_maindeck_researcher", { input = 1, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_researcher", use_researcher_beg, private.room_objname );
  cmn.AddSubscriber( "use_researcher", use_researcher_inv );
  cmn.AddSubscriber( "use_researcher", use_researcher_end, private.room_objname );
  cmn.AddSubscriber( "use_researcher_inv", use_researcher_inv, private.room_objname );
  cmn.AddSubscriber( "use_researcher_beg", use_researcher_beg, private.room_objname );
  cmn.AddSubscriber( "use_researcher_end", use_researcher_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_researcherwin () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_researcherwin" ] = {
    type = "use",
    inv_obj = "obj_maindeck_researcher_2",
    use_place = "spr_maindeck_memorymodule",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local use_researcherwin = function ()
  
    ObjDelete("obj_maindeck_researcher");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_researcherwin", use_researcherwin, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_weapon () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_weapon" ] = {
    type = "use",
    inv_obj = "inv_weapon",
    use_place = "obj_maindeck_use_weapon",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local use_weapon_inv = function ()
  
    interface.InventoryItemRemove( "inv_weapon" );
  
  end;
  local use_weapon_beg = function ()
  
    ObjDelete( "obj_maindeck_use_weapon" );
  
  end;
  local use_weapon_end = function ()
    
    ObjDelete( "anm_maindeck_jean_1" );
    ObjDelete( "anm_maindeck_dialog_jean5_body_give" );
    
    ObjDelete( "vid_maindeck_dialog_jean5_lipsync1" );
  
    ObjAttach("obj_maindeck_dialog_jean5", "rm_maindeck");
  
    ObjMultiSet( { {"obj_maindeck_dialog_jean5", { alp = 1, input = 1 }},
                   {"obj_maindeck_dialog_jean5_hand_2", { alp = 1, input = 1 }},
                   {"anm_maindeck_dialog_jean5_hand_1_1", { alp = 0, frame = 0, playing = 0 }},
                   {"anm_maindeck_dialog_jean5_hand_2_1", { alp = 0, frame = 0, playing = 0 }},
                   {"anm_maindeck_dialog_jean5_head", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_weapon", use_weapon_beg, private.room_objname );
  cmn.AddSubscriber( "use_weapon", use_weapon_inv );
  cmn.AddSubscriber( "use_weapon", use_weapon_end, private.room_objname );
  cmn.AddSubscriber( "use_weapon_inv", use_weapon_inv, private.room_objname );
  cmn.AddSubscriber( "use_weapon_beg", use_weapon_beg, private.room_objname );
  cmn.AddSubscriber( "use_weapon_end", use_weapon_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_mandeckfirst () end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  local clk_mandeckfirst_beg = function ()
  
    ObjDelete( "obj_maindeck_clk_mandeckfirst" );
  
  end;
  local clk_mandeckfirst_mid = function ()
    
    ObjMultiSet( { { "gzz_maindeck_onboardcomputer", { event_mdown = function() cmn.GotoSubRoomMDown( "maindeck_onboardcomputer" ); end, event_mup = function() cmn.GotoSubRoomMUp( "maindeck_onboardcomputer", "zz_onboardcomputer", false, true ); end } },
                   { "gzz_maindeck_pilotseat", { event_mdown = function() cmn.GotoSubRoomMDown( "maindeck_pilotseat" ); end, event_mup = function() cmn.GotoSubRoomMUp( "maindeck_pilotseat", "zz_pilotseat", false, true ); end } },
                   { "gzz_maindeck_repairmodule", { event_mdown = function() cmn.GotoSubRoomMDown( "maindeck_repairmodule" ); end, event_mup = function() cmn.GotoSubRoomMUp( "maindeck_repairmodule", "zz_repairmodule", false, true ); end } },
                   { "gzz_maindeck_rescuecapsule", { event_mdown = function() cmn.GotoSubRoomMDown( "maindeck_rescuecapsule" ); end, event_mup = function() cmn.GotoSubRoomMUp( "maindeck_rescuecapsule", "zz_rescuecapsule" ); end } } } );
    
  end;
  local clk_mandeckfirst_end = function ()
    
    ObjDelete( "obj_maindeck_dialog_jean3" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_mandeckfirst", clk_mandeckfirst_beg, private.room_objname );
  cmn.AddSubscriber( "clk_mandeckfirst", clk_mandeckfirst_end, private.room_objname );
  cmn.AddSubscriber( "clk_mandeckfirst_beg", clk_mandeckfirst_beg, private.room_objname );
  cmn.AddSubscriber( "clk_mandeckfirst_end", clk_mandeckfirst_end, private.room_objname );
  cmn.AddSubscriber( "clk_mandeckfirst", clk_mandeckfirst_mid, private.room_objname );
  cmn.AddSubscriber( "clk_mandeckfirst_mid", clk_mandeckfirst_mid, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_openhelmet () end;
  --------------------------------------------------------------------------------------------
  local clk_openhelmet = function ()
  
    ObjDelete("spr_pilotseat_helmet_closed");
    ObjDelete("spr_maindeck_pilot_helmet_1");
    ObjDelete("spr_maindeck_pilot_helmet_1_2");
    
    ObjMultiSet( { {"spr_pilotseat_helmet_open", { alp = 1 }},
                   {"spr_maindeck_pilot_helmet_2", { alp = 1 }},
                   {"spr_maindeck_pilot_helmet_2_2", { alp = 1 }} } );
  
  end;
  local clk_openhelmet_mg = function ()
  
    ObjDelete("spr_breakthrough_pilot_helmet_1");
    ObjSet("spr_breakthrough_pilot_helmet_2",  { alp = 1 });    
  
  end;              
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_openhelmet", clk_openhelmet, private.room_objname );
  cmn.AddSubscriber( "clk_openhelmet", clk_openhelmet_mg, "mg_breakthrough" );
  
  --------------------------------------------------------------------------------------------
  -- function clk_chooseweapon () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_chooseweapon" ] = {
    type = "click",
    use_place = "spr_maindeck_weapon_1",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local clk_chooseweapon = function ()
  
    ObjDelete("obj_maindeck_dialog_jean5");
    ObjDelete("vid_maindeck_dialog_jean5_lipsync2");
    ObjSet( "gmg_maindeck_breakthrough", { input = 1, alp = 1, active = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_chooseweapon", clk_chooseweapon, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_maindeck () end;
  --------------------------------------------------------------------------------------------
  local opn_maindeck = function ()
  
    int_map_impl.OpenRoom( "rm_maindeck" );
    ObjDelete("obj_medicalsection_jean");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_maindeck", opn_maindeck );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_onboardcomputer" );
  subroom.Define( "zz_repairmodule" );
  subroom.Define( "zz_rescuecapsule" );
  
  function zz_rescuecapsule.Close()
    
    if cmn.IsEventDone("use_robot") then
      
      local func_after = function ()
        
        cmn.Lock( 0 );
        cmn.CallEventHandler( "use_robot_end2" );
        
      end;
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_driod_dissapears_loc");
      VidPlay("vid_maindeck_droid_leave", func_after);
      
    end;
    
  end;
  
  function zz_onboardcomputer.Close()
    
    cmn.HideNote( 0 );
    
    if cmn.IsEventDone("use_eye") and not cmn.IsEventDone("opn_maindeckdialog1") then
      cmn.SetEventDone("opn_maindeckdialog1");
      private.dialog_open( "ai" );
    end;
    
    if cmn.IsEventDone("use_memorymodule") and not cmn.IsEventDone("opn_maindeckdialog2") then
      
      cmn.SetEventDone("opn_maindeckdialog2");
      private.dialog_open( "jean4" );
      
    end;
    
  end;
                           
  function zz_repairmodule.PreOpen()
    
    if not(cmn.IsEventDone( "win_repairmodule" )) then
      private.zz_repairmodule.DrawScene();
    end;

  end;
  
  function zz_repairmodule.Open()
    
    if cmn.IsEventDone( "use_brain" ) and not(cmn.IsEventDone( "win_repairmodule" )) then
      cmn.MiniGameShow();
      private.zz_repairmodule.CheckWin();
    end;

  end;
  
  function zz_repairmodule.PreClose()
    
    if cmn.IsEventDone("use_brain") and not cmn.IsEventDone("win_repairmodule") then
      cmn.MiniGameHide("repairmodule");
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_repairmodule" ].state) then 
    private.zz_repairmodule.StartConditions();
  end;
  
  private.zz_repairmodule.state = ng_global.progress[ ng_global.currentprogress ][ "win_repairmodule" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_maindeck();
  
  if cmn.IsEventDone("use_memorymodule") and not cmn.IsEventDone("get_bomb") then
    --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    common_impl.current_dialog = "obj_maindeck_dialog_jean4";
    ObjSet("anm_maindeck_dialog_jean4_hand_2",  { playing = 1 });
  end;
  
  if cmn.IsEventDone("use_eye") and not cmn.IsEventDone("get_researcher") then
    --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    common_impl.current_dialog = "obj_maindeck_dialog_ai";
  end;
  
  if cmn.IsEventDone("use_weapon") and not cmn.IsEventDone("clk_chooseweapon") then
    --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    common_impl.current_dialog = "obj_maindeck_dialog_jean5";
    ObjSet("anm_maindeck_dialog_jean5_hand_2",  { playing = 1 });
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level2/audio/env/aud_rm_maindeck_env");
  cmn.PlayAudio("env", "assets/levels/level2/audio/env/aud_rm_maindeck_env");
  
  if cmn.IsEventDone("get_researcher") and not(cmn.IsEventDone("use_researcherwin")) then
    PlaySfx("assets/levels/level2/audio/sfx/aud_loop_scaner_loc", 1, "", 1);
  end;
  
  if ng_global.progress[ ng_global.currentprogress ][ "win_breakthrough" ].state[1] > 0 or cmn.IsEventDone("win_breakthrough") then
    ObjMultiSet( { {"anm_maindeck_hatch",  { frame = 300 }},
                   {"spr_maindeck_hatch_lock", { alp = 0 }} } );
  end;
                 
  if cmn.IsEventDone("use_weapon") and not cmn.IsEventDone("opn_armoryafterhangar") then
    ObjSet("anm_maindeck_jean_2_"..ng_global.progress[ ng_global.currentprogress ][ "win_breakthrough" ].state[3],  { alp = 1 });
  end;
  
  --анимация морф-оъекта
  if cmn.IsCollectableAvailible(7) then
    private.AnimMorphObject();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
  
  if cmn.IsEventDone("get_researcher") and not(cmn.IsEventDone("use_researcherwin")) then
    SndStop("assets/levels/level2/audio/sfx/aud_loop_scaner_loc", 0.5);
  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_eye()

  local item = "inv_eye";

  if cmn.ApplyObj( item, "gzz_maindeck_onboardcomputer" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_onboardcomputer", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_onboardcomputer_use_eye" ) ) then

    cmn.CallEventHandler( "use_eye_inv" );
    cmn.CallEventHandler( "use_eye_beg" );

    local func_after = function ()

      --cmn.Lock( 0 );

      cmn.SetEventDone( "use_eye" );
      --cmn.CallEventHandler( "use_eye_end" );
      
      common.CloseSubRoom();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_eye_1");

    ObjSet("anm_onboardcomputer_use_eye",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_memorymodule()

  local item = "inv_memorymodule";

  if cmn.ApplyObj( item, "gzz_maindeck_onboardcomputer" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_onboardcomputer", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_onboardcomputer_use_memorymodule" ) ) then

    cmn.CallEventHandler( "use_memorymodule_inv" );
    cmn.CallEventHandler( "use_memorymodule_beg" );

    local func_after = function ()

      --cmn.Lock( 0 );
      common_impl.PlayBackgroundMusic();

      cmn.SetEventDone( "use_memorymodule" );
      --cmn.CallEventHandler( "use_memorymodule_end" );
      
      common.CloseSubRoom();
    
    end;
    
    local anm_call_3 = function ()
    
      cmn.ShowDlgBbt( "vid_aion_phrase_3" );
      ObjSet("tmr_onboardcomputer_timer",  { time = 10, playing = 1, endtrig = func_after });
      
    end;
    
    local anm_call_2 = function ()
      
      cmn.ShowDlgBbt( "vid_aion_phrase_2" );
      ObjSet("tmr_onboardcomputer_timer",  { time = 13.8, playing = 1, endtrig = anm_call_3 });
      
    end;
    
    local anm_call_1 = function ()
      
      cmn.ShowDlgBbt( "vid_aion_phrase_1" );
      ObjSet("tmr_onboardcomputer_timer",  { time = 10.9, playing = 1, endtrig = anm_call_2 });
      
    end;
  
    local func_play = function ()
      
      VidPlay("vid_onboardcomputer_aion", "");
      
      cmn.PlayAudio("voc", "assets/levels/level2/audio/voc/aud_2_lvl_aion_1_voc");
      
      ObjSet("tmr_onboardcomputer_timer",  { time = 2.4, playing = 1, endtrig = anm_call_1 });
      
    end;

    cmn.Lock( 1 );
    cmn.StopAllMus();
    cmn.PlayAudio("snd", "assets/levels/level2/audio/mus/aud_vid_ondoardcomputer_mus");

    ObjAttach("vid_onboardcomputer_aion", "obj_onboardcomputer_back");
    ObjAnimate("vid_onboardcomputer_aion", "alp", 0, 0, func_play, { 0, 0, 0,   0.3, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bracelet()

  local item = "inv_bracelet";

  if cmn.ApplyObj( item, "gzz_maindeck_pilotseat" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_pilotseat", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_pilotseat_use_bracelet" ) ) then

    cmn.CallEventHandler( "use_bracelet_inv" );
    cmn.CallEventHandler( "use_bracelet_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_bracelet" );
      cmn.CallEventHandler( "use_bracelet_end" );
    
    end;
    
    local anm_open = function ()
      
      ObjAnimate("spr_pilotseat_bracelet_closed", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("spr_pilotseat_bracelet_open", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_suite_thing_pilot");

    ObjAnimate( "spr_pilotseat_bracelet_2", "alp", 0, 0, anm_open, { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_shipsymbol()

  local item = "inv_shipsymbol";

  if cmn.ApplyObj( item, "gzz_maindeck_pilotseat" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_pilotseat", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_pilotseat_use_shipsymbol" ) ) then

    cmn.CallEventHandler( "use_shipsymbol_inv" );
    cmn.CallEventHandler( "use_shipsymbol_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_shipsymbol" );
      cmn.CallEventHandler( "use_shipsymbol_end" );
    
    end;

    local anm_open = function ()
      
      ObjAnimate("anm_pilotseat_box_touch", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("spr_pilotseat_box_open", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
    local anm_push = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud__thing_zz_pilotseat_opens");
      
      ObjAnimate( "spr_pilotseat_ship_amulet", "scale_xy", 0, 0, anm_open,
      {
        0.0, 0, 1, 1, 
        0.15, 0, 0.9, 0.9,
        0.3, 0, 1, 1
      } );  
      
      ObjAnimate( "spr_pilotseat_ship_amulet2", "scale_xy", 0, 0, "",
      {
        0.0, 0, 1, 1, 
        0.15, 0, 0.9, 0.9,
        0.3, 0, 1, 1
      } );  
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_thing_zz_pilotseat");

    if cmn.IsEventDone("use_shipsymbol2") then
      ObjAnimate( "spr_pilotseat_ship_amulet", "alp", 0, 0, anm_push, { 0, 0, 0,    0.3, 0, 1,    0.5, 0, 1 } );
    else 
      ObjAnimate( "spr_pilotseat_ship_amulet", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_shipsymbol2()

  local item = "inv_shipsymbol2";

  if cmn.ApplyObj( item, "gzz_maindeck_pilotseat" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_pilotseat", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_pilotseat_use_shipsymbol2" ) ) then

    cmn.CallEventHandler( "use_shipsymbol2_inv" );
    cmn.CallEventHandler( "use_shipsymbol2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_shipsymbol2" );
      cmn.CallEventHandler( "use_shipsymbol2_end" );
    
    end;

    local anm_open = function ()
      
      ObjAnimate("anm_pilotseat_box_touch", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("spr_pilotseat_box_open", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
    local anm_push = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud__thing_zz_pilotseat_opens");
      
      ObjAnimate( "spr_pilotseat_ship_amulet", "scale_xy", 0, 0, anm_open,
      {
        0.0, 0, 1, 1, 
        0.15, 0, 0.9, 0.9,
        0.3, 0, 1, 1
      } );  
      
      ObjAnimate( "spr_pilotseat_ship_amulet2", "scale_xy", 0, 0, "",
      {
        0.0, 0, 1, 1, 
        0.15, 0, 0.9, 0.9,
        0.3, 0, 1, 1
      } );  
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_thing_zz_pilotseat");

    if cmn.IsEventDone("use_shipsymbol") then
      ObjAnimate( "spr_pilotseat_ship_amulet2", "alp", 0, 0, anm_push, { 0, 0, 0,    0.3, 0, 1,    0.5, 0, 1 } );
    else 
      ObjAnimate( "spr_pilotseat_ship_amulet2", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_robot()

  local item = "inv_robot";

  if cmn.ApplyObj( item, "gzz_maindeck_rescuecapsule" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_rescuecapsule" );

  elseif ( cmn.ApplyObj( item, "obj_rescuecapsule_use_robot" ) ) then

    cmn.CallEventHandler( "use_robot_inv" );
    cmn.CallEventHandler( "use_robot_beg" );

    local func_after = function ()

      --cmn.Lock( 0 );

      cmn.SetEventDone( "use_robot" );
      cmn.CallEventHandler( "use_robot_end" );
      
      ObjAttach("vid_maindeck_droid_leave", "rm_maindeck");
      
      common.CloseSubRoom();
    
    end;
    
    local func_play = function ()
      VidPlay("vid_rescuecapsule_use_robot", func_after);
    end;
    
    if not cmn.IsEventDone("get_manipulatorclaw") then
      public.get_manipulatorclaw();
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_droid_crash_glass_capsule");

    ObjAttach("vid_rescuecapsule_use_robot", "zz_rescuecapsule");
    ObjAnimate("vid_rescuecapsule_use_robot", "alp", 0, 0, func_play, { 0, 0, 0,   0.3, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_brain()

  local item = "inv_brain";

  if cmn.ApplyObj( item, "gzz_maindeck_repairmodule" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_repairmodule", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_repairmodule_use_brain" ) ) then
    
    if not cmn.IsEventDone("get_bomb") or not cmn.IsEventDone("get_bag") then
    
      cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
      
      if not cmn.IsEventDone("get_bomb") then
        cmn.SetEventDone( "get_bomb" );
        cmn.CallEventHandler( "get_bomb" );
      end;
      
      if not cmn.IsEventDone("get_bag") then
        cmn.SetEventDone( "get_bag" );
        cmn.CallEventHandler( "get_bag" );
      end;
      
    end;

    cmn.CallEventHandler( "use_brain_inv" );
    cmn.CallEventHandler( "use_brain_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_brain" );
      cmn.CallEventHandler( "use_brain_end" );
      
      cmn.MiniGameShow();
    
    end;
    
    local anm_game = function ()
      ObjAnimate("obj_repairmodule_game", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_insert_brain_droid");
    
    ObjSet("anm_repairmodule_use_brain",  { alp = 1, playing = 1, endtrig = anm_game });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_weapon()

  local item = "inv_weapon";

  if ( cmn.ApplyObj( item, "obj_maindeck_use_weapon" ) ) then

    cmn.CallEventHandler( "use_weapon_inv" );
    cmn.CallEventHandler( "use_weapon_beg" );

    local func_after = function ()

      --cmn.Lock( 0 );

      cmn.SetEventDone( "use_weapon" );
      --cmn.CallEventHandler( "use_weapon_end" );
      
      private.dialog_open( "jean5" );
    
    end;

    cmn.Lock( 1 );
    func_after();

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_manipulatorbase()

  cmn.SetEventDone( "get_manipulatorbase" );
  cmn.CallEventHandler( "get_manipulatorbase" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_manipulatormodule()

  cmn.SetEventDone( "get_manipulatormodule" );
  cmn.CallEventHandler( "get_manipulatormodule" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_accesstoweaponcodes()

  cmn.SetEventDone( "get_accesstoweaponcodes" );
  cmn.CallEventHandler( "get_accesstoweaponcodes" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_accesstoshipcode()

  cmn.SetEventDone( "get_accesstoshipcode" );
  cmn.CallEventHandler( "get_accesstoshipcode" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_manipulatorclaw()

  cmn.SetEventDone( "get_manipulatorclaw" );
  cmn.CallEventHandler( "get_manipulatorclaw" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_robot()

  cmn.SetEventDone( "get_robot" );
  cmn.CallEventHandler( "get_robot" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_bomb()

  cmn.SetEventDone( "get_bomb" );
  cmn.CallEventHandler( "get_bomb" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
end;
--------------------------------------------------------------------------------------------
function public.get_bag()
  
  ObjSet("spr_repairmodule_bag",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_bag" );
  cmn.CallEventHandler( "get_bag" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
end;
--------------------------------------------------------------------------------------------
function public.get_memorymodule()

  cmn.SetEventDone( "get_memorymodule" );
  cmn.CallEventHandler( "get_memorymodule" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_bombpart1()
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_bombpart1_end" );
    
    --common_impl.PlayBackgroundMusic();

  end;

  cmn.SetEventDone( "get_bombpart1" );
  cmn.CallEventHandler( "get_bombpart1_inv" );
  cmn.CallEventHandler( "get_bombpart1_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.current_dialog = "";
  
  cmn.Lock(1);
  ObjAnimate("obj_maindeck_dialog_jean4", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.5, 0, 0 });

end;
--------------------------------------------------------------------------------------------
function public.get_researcher()
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_researcher" );
    
    --common_impl.PlayBackgroundMusic();
    PlaySfx("assets/levels/level2/audio/sfx/aud_loop_scaner_loc", 1, "", 1);

  end;

  cmn.SetEventDone( "get_researcher" );
  --cmn.CallEventHandler( "get_researcher_inv" );
  --cmn.CallEventHandler( "get_researcher_mid" );

  --cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.current_dialog = "";
  ObjAttach("obj_maindeck_researcher", "rm_maindeck");
  
  cmn.Lock(1);
  ObjAnimate("obj_maindeck_dialog_ai", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
  ObjAnimate( "obj_maindeck_researcher", "alp", 0, 0, func_after_dlg, { 0, 0, 0,   0.5, 0, 0,    1, 0, 1 } );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_mandeckfirst()

  cmn.CallEventHandler( "clk_mandeckfirst_beg" );
  cmn.SetEventDone( "clk_mandeckfirst" );

  cmn.Lock( 1 );
  
  private.dialog_open( "jean3" );

end;
--------------------------------------------------------------------------------------------
function public.clk_openhelmet()

  cmn.SetEventDone( "clk_openhelmet" );

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_take_glass_pilot");
  
  local func_after = function ()
    
    cmn.Lock( 0 );
    cmn.CallEventHandler("clk_openhelmet");
    
    cmn.ShowBbt( "pilotseat_open_helmet" );
    
  end;
  
  ObjAnimate("spr_pilotseat_helmet_closed", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
  ObjAnimate("spr_pilotseat_helmet_open", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });

end;
--------------------------------------------------------------------------------------------
function public.clk_chooseweapon( num )
  
  common_impl.current_dialog = "";

  cmn.SetEventDone( "clk_chooseweapon" );
  ng_global.progress[ ng_global.currentprogress ][ "win_breakthrough" ].state[3] = num;
  ng_global.player_gun = num;
  
  ObjSet("anm_maindeck_jean_2_"..ng_global.progress[ ng_global.currentprogress ][ "win_breakthrough" ].state[3],  { alp = 1 });
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_choose_weapon");
  
  local func_after = function ()
    
    --cmn.Lock( 0 );
    cmn.CallEventHandler("clk_chooseweapon");
    
    cmn.GotoRoom("mg_breakthrough");
    
  end;
  
  local dlg_hide = function ()
    
    int_blackbartext.Hide();
    
    ObjDelete("vid_maindeck_dialog_jean5_lipsync2");
    ObjSet("anm_maindeck_dialog_jean5_head",  { alp = 1 });
    
    ObjAnimate("obj_maindeck_dialog_jean5", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
    
  end;
  
  local anm_voc = function ()
    
    ObjAttach("vid_maindeck_dialog_jean5_lipsync2", "obj_maindeck_dialog_jean5_pos");
    
    cmn.ShowDlgBbt( "dlg_jean5_phrase_2" );
    cmn.PlayAudio("voc", "assets/levels/level2/audio/voc/aud_2_lvl_jean_9_voc");
    
    if num == 1 then
      ObjAnimate("anm_maindeck_dialog_jean5_hand_1_1", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("anm_maindeck_dialog_jean5_hand_2_1", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 0,   0.6, 0, 1 });
    else 
      ObjAnimate("anm_maindeck_dialog_jean5_hand_2_1", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      ObjAnimate("anm_maindeck_dialog_jean5_hand_1_1", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 0,   0.6, 0, 1 });
    end;
  
    ObjMultiSet( { {"tmr_maindeck_dialog_jean5_timer", { time = 5, playing = 1, endtrig = dlg_hide }},
                   {"anm_maindeck_dialog_jean5_body_out_"..num, { alp = 1, playing = 1 }},
                   {"obj_maindeck_dialog_jean5_hand_2", { alp = 0 }},
                   {"anm_maindeck_dialog_jean5_hand_1_1", { playing = 1 }},
                   {"anm_maindeck_dialog_jean5_hand_2_1", { playing = 1 }},
                   {"vid_maindeck_dialog_jean5_lipsync2", { playing = 1 }},
                   {"anm_maindeck_dialog_jean5_head", { alp = 0 }} } );

  end;
  
  ObjAnimate("spr_maindeck_weapon_"..num, "alp", 0, 0, anm_voc, { 0, 0, 1,   0.3, 0, 0 });
  ObjAnimate("spr_maindeck_weapon_"..num.."_sh", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_maindeck()

  if not ( cmn.IsEventDone( "opn_maindeck" ) ) then
    cmn.SetEventDone( "opn_maindeck" );
    cmn.CallEventHandler("opn_maindeck");
    cmn.ShowBbt( "maindeck_open" );
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_random_env_2_mus_env");
  end;

end;
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_7_1", { alp = 1 }},
                 {"spr_col_7_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_7_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_7_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_7_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_7_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_7_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_7_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_rescuecapsule()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_broken_glass_capsule");
  
  cmn.ShowBbt( "obj_rescuecapsule_use_robot" );
  
  ObjSet( "anm_rescuecapsule_door_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_pilot_bracelet()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_thing_left_pilotseat");
  
  cmn.ShowBbt( "obj_pilotseat_use_bracelet" );
  
  ObjSet( "anm_pilotseat_bracelet_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_pilot_box()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_box_left_pilotseat");
  
  cmn.ShowBbt( "obj_pilotseat_use_shipsymbol" );
  
  ObjSet( "anm_pilotseat_box_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
    
  if cmn.IsEventDone("use_shipsymbol") then
    ObjAnimate("spr_pilotseat_ship_amulet", "pos_xy", 0, 0, "", { 0, 0, 7, 134,   0.25, 0, 8, 133,   0.5, 0, 7, 134 });
  end;
  
  if cmn.IsEventDone("use_shipsymbol2") then
    ObjAnimate("spr_pilotseat_ship_amulet2", "pos_xy", 0, 0, "", { 0, 0, 69, 148,   0.25, 0, 70, 147,   0.5, 0, 69, 148 });
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_robot()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_droid");
  
  cmn.ShowBbt( "obj_repairmodule_use_brain" );
  
  ObjSet( "anm_repairmodule_robot_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_memory_slot()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_xx_thing_zz_onboardcomputer");
  
  cmn.ShowBbt( "obj_onboardcomputer_use_memorymodule" );
  
  ObjSet( "anm_onboardcomputer_memory_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_open( name )
  
  --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
  
  common_impl.current_dialog = "obj_maindeck_dialog_"..name;
  
  local func_after = function() private.dialog_jean3_beg(); end;
  if name == "jean4" then
    func_after = function() private.dialog_jean4_beg(); end;
  elseif name == "jean5" then
    func_after = function() private.dialog_jean5_beg(); end;
  elseif name == "ai" then
    func_after = function() private.dialog_ai_beg(); end;
  end;
  
  ObjAttach("obj_maindeck_dialog_"..name, "rm_maindeck");
  ObjAnimate("obj_maindeck_dialog_"..name, "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_jean3_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "maindeck", "jean3", 2 );
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "clk_mandeckfirst_end" );
    common_impl.current_dialog = "";
    
    cmn.ShowBbt( "maindeck_after_dlg_jean3" );
    
  end;
  
  local anm_hide = function ()
    
    cmn.CallEventHandler("clk_mandeckfirst_mid");
    
    private.dlg_lipsync = "";
    ObjDelete("vid_maindeck_dialog_jean3_lipsync1");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_maindeck_dialog_jean3_timer",  { playing = 0 }},
                   {"anm_maindeck_dialog_jean3_head", { alp = 1 }} } );
    
    ObjAnimate("obj_maindeck_dialog_jean3", "alp", 0, 0, dialog_end, { 0, 0, 1,   0.6, 0, 0 });
    
  end;
  
  private.dlg_lipsync = "vid_maindeck_dialog_jean3_lipsync1";

  cmn.ShowDlgBbt( "dlg_jean3_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level2/audio/voc/aud_2_lvl_jean_5_voc");

  ObjMultiSet( { {"tmr_maindeck_dialog_jean3_timer", { time = 6, playing = 1, endtrig = anm_hide }},
                 {"vid_maindeck_dialog_jean3_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = anm_hide }},
                 {"obj_character_dialog_continue", { event_mup = anm_hide }} } );
  
end; 
--------------------------------------------------------------------------------------------
function private.dialog_jean4_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "maindeck", "jean4", 2 );
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "use_memorymodule_end" );
    
    cmn.ShowBbt( "maindeck_after_dlg_jean4" );
    interface_impl.ShowGlobalTask();
    int_diary.AddDiarypage( 15 );
    
    ObjSet("anm_maindeck_dialog_jean4_hand_2",  { playing = 1 });
    
  end;
  
  local anm_give = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_maindeck_dialog_jean4_lipsync2");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjAnimate("anm_maindeck_dialog_jean4_hand_1", "alp", 0, 0, "", { 0, 0, 1,   0.16, 0, 1,   0.3, 0, 0 });
    
    ObjMultiSet( { {"tmr_maindeck_dialog_jean4_timer",  { playing = 0 }},
                   {"anm_maindeck_dialog_jean4_give", { alp = 1, playing = 1, endtrig = dialog_end }},
                   {"anm_maindeck_dialog_jean4_head", { alp = 1 }} } );
    
  end;
  
  local jean_talks2 = function ()
  
    ObjDelete("vid_maindeck_dialog_jean4_lipsync1");
    ObjAttach("vid_maindeck_dialog_jean4_lipsync2", "obj_maindeck_dialog_jean4_pos");
  
    cmn.ShowDlgBbt( "dlg_jean4_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level2/audio/voc/aud_2_lvl_jean_7_voc");
    
    private.dlg_lipsync = "vid_maindeck_dialog_jean4_lipsync2";
    
    ObjMultiSet( { {"tmr_maindeck_dialog_jean4_timer", { endtrig = anm_give, time = 9, playing = 1 }},
                   {"vid_maindeck_dialog_jean4_lipsync2", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_give }},
                   {"obj_character_dialog_continue", { event_mup = anm_give }} } );
  
  end;

  private.dlg_lipsync = "vid_maindeck_dialog_jean4_lipsync1";

  cmn.ShowDlgBbt( "dlg_jean4_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level2/audio/voc/aud_2_lvl_jean_6_voc");

  ObjMultiSet( { {"tmr_maindeck_dialog_jean4_timer", { time = 6, playing = 1, endtrig = jean_talks2 }},
                 {"vid_maindeck_dialog_jean4_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = jean_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = jean_talks2 }} } );
  
end; 
--------------------------------------------------------------------------------------------
function private.dialog_jean5_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "maindeck", "jean5", 2 );
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "use_weapon_end" );
    cmn.ShowBbt( "maindeck_after_dlg_jean5" );
    
    ObjSet("anm_maindeck_dialog_jean5_hand_2",  { playing = 1 });
    
  end;
  
  local anm_give = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_maindeck_dialog_jean5_lipsync1");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjAnimate("anm_maindeck_dialog_jean5_hand_1_1", "alp", 0, 0, "", { 0, 0, 1,   0.6, 0, 1,   0.83, 0, 0 });
    ObjAnimate("anm_maindeck_dialog_jean5_hand_2_1", "alp", 0, 0, "", { 0, 0, 1,   0.16, 0, 1,   0.36, 0, 0 });
    
    ObjMultiSet( { {"tmr_maindeck_dialog_jean5_timer",  { playing = 0 }},
                   {"anm_maindeck_dialog_jean5_body_give", { alp = 1, playing = 1, endtrig = dialog_end }},
                   {"anm_maindeck_dialog_jean5_head", { alp = 1 }} } );
    
  end;
  
  private.dlg_lipsync = "vid_maindeck_dialog_jean5_lipsync1";

  cmn.ShowDlgBbt( "dlg_jean5_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level2/audio/voc/aud_2_lvl_jean_8_voc");

  ObjMultiSet( { {"tmr_maindeck_dialog_jean5_timer", { time = 3, playing = 1, endtrig = anm_give }},
                 {"vid_maindeck_dialog_jean5_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = anm_give }},
                 {"obj_character_dialog_continue", { event_mup = anm_give }} } );
  
end; 
--------------------------------------------------------------------------------------------
function private.dialog_ai_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "maindeck", "ai", 2 );
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "use_eye_end" );
    
    cmn.ShowBbt( "maindeck_after_dlg_ai" );
    
  end;
  
  local anm_give = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_maindeck_dialog_ai_lipsync2");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_maindeck_dialog_ai_timer",  { playing = 0 }},
                   {"spr_maindeck_dialog_ai_face", { alp = 1 }} } );
    
    ObjAnimate("obj_maindeck_dialog_ai_hand_2", "alp", 0, 0, dialog_end, { 0, 0, 0,   0.5, 0, 1 });
    
  end;
  
  local ai_talks2 = function ()
  
    ObjDelete("vid_maindeck_dialog_ai_lipsync1");
    ObjAttach("vid_maindeck_dialog_ai_lipsync2", "obj_maindeck_dialog_ai_head");
  
    cmn.ShowDlgBbt( "dlg_ai_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level2/audio/voc/aud_2_lvl_ships_ai_2_voc");
    
    private.dlg_lipsync = "vid_maindeck_dialog_ai_lipsync2";
    
    ObjMultiSet( { {"tmr_maindeck_dialog_ai_timer", { endtrig = anm_give, time = 6, playing = 1 }},
                   {"vid_maindeck_dialog_ai_lipsync2", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_give }},
                   {"obj_character_dialog_continue", { event_mup = anm_give }} } );
  
  end;

  private.dlg_lipsync = "vid_maindeck_dialog_ai_lipsync1";

  cmn.ShowDlgBbt( "dlg_ai_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level2/audio/voc/aud_2_lvl_ships_ai_1_voc");

  ObjMultiSet( { {"tmr_maindeck_dialog_ai_timer", { time = 8, playing = 1, endtrig = ai_talks2 }},
                 {"vid_maindeck_dialog_ai_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = ai_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = ai_talks2 }} } );
  
end; 
--------------------------------------------------------------------------------------------
function public.skip_dlg_jean3()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  common_impl.current_dialog = "";
  
  cmn.CallEventHandler("clk_mandeckfirst_mid");

  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "clk_mandeckfirst_end" );
    cmn.ShowBbt( "maindeck_after_dlg_jean3" );
    
  end;
  
  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    ObjSet("anm_maindeck_dialog_jean3_head",  { alp = 1 });
    private.dlg_lipsync = "";
  end;

  ObjSet("tmr_maindeck_dialog_jean3_timer",  { playing = 0 });
  
  common_impl.CharacterDialogButtonsHide();
  
  --common_impl.PlayBackgroundMusic();
  
  ObjAnimate("obj_maindeck_dialog_jean3", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.6, 0, 0 });
  
end;
--------------------------------------------------------------------------------------------
function public.skip_dlg_jean4()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "use_memorymodule_end" );
    cmn.ShowBbt( "maindeck_after_dlg_jean4" );
    interface_impl.ShowGlobalTask();
    int_diary.AddDiarypage( 15 );
    
    ObjSet("anm_maindeck_dialog_jean4_hand_2",  { playing = 1 });
    
  end;
  
  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    ObjSet("anm_maindeck_dialog_jean4_head",  { alp = 1 });
    private.dlg_lipsync = "";
  end;

  ObjSet("tmr_maindeck_dialog_jean4_timer",  { playing = 0 });
  
  common_impl.CharacterDialogButtonsHide();
  
  --common_impl.PlayBackgroundMusic();
  
  ObjAnimate("anm_maindeck_dialog_jean4_hand_1", "alp", 0, 0, "", { 0, 0, 1,   0.16, 0, 1,   0.3, 0, 0 });
  
  ObjMultiSet( { {"tmr_maindeck_dialog_jean4_timer",  { playing = 0 }},
                 {"anm_maindeck_dialog_jean4_give", { alp = 1, playing = 1, endtrig = func_after_dlg }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.skip_dlg_jean5()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "use_weapon_end" );
    cmn.ShowBbt( "maindeck_after_dlg_jean5" );
    
    ObjSet("anm_maindeck_dialog_jean5_hand_2",  { playing = 1 });
    
  end;
  
  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    ObjSet("anm_maindeck_dialog_jean5_head",  { alp = 1 });
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();
  
  --common_impl.PlayBackgroundMusic();
  
  ObjAnimate("anm_maindeck_dialog_jean5_hand_1_1", "alp", 0, 0, "", { 0, 0, 1,   0.6, 0, 1,   0.83, 0, 0 });
  ObjAnimate("anm_maindeck_dialog_jean5_hand_2_1", "alp", 0, 0, "", { 0, 0, 1,   0.16, 0, 1,   0.36, 0, 0 });
  
  ObjMultiSet( { {"tmr_maindeck_dialog_jean5_timer",  { playing = 0 }},
                 {"anm_maindeck_dialog_jean5_body_give", { alp = 1, playing = 1, endtrig = func_after_dlg }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.skip_dlg_ai()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "use_eye_end" );
    cmn.ShowBbt( "maindeck_after_dlg_ai" );
    
  end;
  
  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    ObjSet("spr_maindeck_dialog_ai_face",  { alp = 1 });
    private.dlg_lipsync = "";
  end;

  ObjSet("tmr_maindeck_dialog_ai_timer",  { playing = 0 });
  
  common_impl.CharacterDialogButtonsHide();
  
  --common_impl.PlayBackgroundMusic();
  
  ObjAnimate("obj_maindeck_dialog_ai_hand_2", "alp", 0, 0, func_after_dlg, { 0, 0, 0,   0.5, 0, 1 });
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Researcher *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.StartDrag()
  
  SetCursor(CURSOR_NULL);
  ObjStartDrag("obj_maindeck_drag");
  
end;
--------------------------------------------------------------------------------------------
function public.DragResearcher(drops)
  
  local curspos = GetZoomCursorPos();
  if (drops) then
    if  tostring(GetPlatform()) == "android" then
      curspos[2] = curspos[2] - 100;
    elseif tostring(GetPlatform()) == "ios" then
      if port.isTablet() == 0 then
        curspos[2] = curspos[2] - 75;
      else
        curspos[2] = curspos[2] - 50;
      end;
    end;
  end;
  curspos[1] = math.floor(curspos[1]);
  curspos[2] = math.floor(curspos[2]);
  
  local accuracy = 70;
  local borders = { {0, 1006}, {122, 580} };
  local win_pos = {774, 122};
  
  if curspos[1] < borders[1][1] then
    curspos[1] = borders[1][1];
  elseif curspos[1] > borders[1][2] then
    curspos[1] = borders[1][2];
  end;
  
  if curspos[2] < borders[2][1] then
    curspos[2] = borders[2][1];
  elseif curspos[2] > borders[2][2] then
    curspos[2] = borders[2][2];
  end;
  
  ObjMultiSet( { {"obj_maindeck_researcher_2", { pos_x = curspos[1], pos_y = curspos[2] }},
                 {"spr_maindeck_back_2", { croprect_x = curspos[1]-150, croprect_y = curspos[2]-130 }} } );
                 
  if ( (curspos[1] - win_pos[1])^2 + (curspos[2] - win_pos[2])^2 ) <= accuracy^2 then
    
    if not private.module_found then
    
      private.module_found = true;
      cmn.Lock( 1 );
      
      SndStop("assets/levels/level2/audio/sfx/aud_loop_scaner_loc", 0.5);
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_scaner_fix_obgect");
      
      cmn.SetEventDone("use_researcherwin");
      cmn.SetEventDone("get_memorymodule");
      
      local func_after = function ()
        
        cmn.Lock( 0 );
        cmn.CallEventHandler("use_researcherwin");
        
      end;
      
      local anm_end = function ()
        
        cmn.CallEventHandler("get_memorymodule");
        cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
        
        ObjAnimate("obj_maindeck_researcher", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
        
      end;
      
      ObjSet("obj_maindeck_researcher_2", { input = 0 });
      ObjStopDrag("obj_maindeck_drag");
      
      ObjAnimate("obj_maindeck_researcher_2", "pos_xy", 0, 0, anm_end, { 0, 0, curspos[1], curspos[2],    1, 0, win_pos[1], win_pos[2],    2, 0, win_pos[1], win_pos[2] });
      ObjAnimate("spr_maindeck_back_2", "croprect_x", 0, 0, "", { 0, 0, curspos[1]-150,     1, 0, win_pos[1]-150 });
      ObjAnimate("spr_maindeck_back_2", "croprect_y", 0, 0, "", { 0, 0, curspos[2]-130,     1, 0, win_pos[2]-130 });
      
      ObjSet("anm_maindeck_research_end",  { alp = 1, playing = 1 });
      
    end;
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.DropResearcher()
  
  SetCursor(CURSOR_DEFAULT);
  
  public.DragResearcher(true);
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Repairmodule *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_repairmodule = {};
public.zz_repairmodule = {};

function private.Init_Repairmodule()
  
  private.zz_repairmodule.chain_pos = {
    { -205, -148, -76, -4, 68, 141, 197 },
    { -179, -112, -58, -4, 68, 139, 198 }
  };
  
  private.zz_repairmodule.start = { {1, 5, 4, 2, 6, 3, 7}, {1, 3, 6, 4, 2, 5, 7} };
  private.zz_repairmodule.chosen = 0;
  -----------------------------------------------------------------------------------
  game.hint[ "win_repairmodule" ] = {
    type = "win",
    room = "rm_maindeck",
    zz = "zz_repairmodule",
    zz_gate = "gzz_maindeck_repairmodule"
  };
  -----------------------------------------------------------------------------------
  local win_repairmodule = function ()

    if cmn.IsEventDone( "win_repairmodule" ) then
      
      ObjDelete( "obj_repairmodule_game" );
      ObjDelete( "spr_maindeck_robot_1" );
      
      ObjMultiSet( { {"obj_repairmodule_robot", { input = 1 }},
                     {"anm_repairmodule_robot_active", { frame = 400 }},
                     {"gfx_repairmodule_robot", { active = 1, visible = 1 }},
                     {"spr_maindeck_robot_2", { alp = 1 }} } );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_repairmodule", win_repairmodule, "rm_maindeck" );
  
end;
--*********************************************************************************************************************
function private.zz_repairmodule.StartConditions()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_repairmodule" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_repairmodule" ].state = { {1, 5, 4, 2, 6, 3, 7}, {1, 3, 6, 4, 2, 5, 7}, 1 };
  
end;
-----------------------------------------------------------------------------------
function public.zz_repairmodule.Reset()
  
  local need_r = false;
  local stage = private.zz_repairmodule.state[3];
  
  for i = 1, 7, 1 do
    
    if private.zz_repairmodule.state[ stage ][i] ~= private.zz_repairmodule.start[ stage ][i] then
      
      if not need_r then
        need_r = true;
      end;
      
      local old = private.zz_repairmodule.chain_pos[ stage ][i];
      local new = 0;
      
      for j = 1, 7, 1 do
        
        if private.zz_repairmodule.state[ stage ][i] == private.zz_repairmodule.start[ stage ][j] then
          new = private.zz_repairmodule.chain_pos[ stage ][j];
          break;
        end;
        
      end;
      
      ObjAnimate("spr_repairmodule_chain_"..stage.."_"..private.zz_repairmodule.state[stage][i], "pos_x", 0, 0, "", { 0, 0, old,   0.5, 0, new });
      
    end;
    
  end;
  
  if private.zz_repairmodule.chosen > 0 and need_r then
    local chos = private.zz_repairmodule.chosen;
    private.zz_repairmodule.chosen = 0;
    ObjAnimate("spr_repairmodule_chain_"..stage.."_"..chos.."_select", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  elseif private.zz_repairmodule.chosen > 0 then
    cmn.Lock( 1 );
    local chos = private.zz_repairmodule.chosen;
    private.zz_repairmodule.chosen = 0;
    ObjAnimate("spr_repairmodule_chain_"..stage.."_"..chos.."_select", "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 1,   0.3, 0, 0 });
  end;
  
  if need_r then
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_droid_scheme_click");
    
    for i = 1, 7, 1 do
      private.zz_repairmodule.state[ stage ][i] = private.zz_repairmodule.start[ stage ][i];
    end;
    
    ObjSet("tmr_repairmodule_timer",  { time = 0.5, playing = 1, endtrig = function() cmn.Lock(0); end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_repairmodule.Skip()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_droid_scheme_click");
  
  local stage = private.zz_repairmodule.state[3];
  
  ng_global.progress[ ng_global.currentprogress ][ "win_repairmodule" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_repairmodule" ].state = { {1, 2, 3, 4, 5, 6, 7}, {1, 2, 3, 4, 5, 6, 7}, 2 };
  
  local anm_win = function ()
    
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("repairmodule");
    
    local anm_robot = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_droud_alive");
      ObjSet("anm_repairmodule_robot_active",  { playing = 1, endtrig = private.zz_repairmodule.Win });
      
    end;
    
    ObjAnimate("obj_repairmodule_game", "alp", 0, 0, anm_robot, { 0, 0, 1,   1.2, 0, 1,   1.7, 0, 0 });
    ObjAnimate("obj_repairmodule_stage_"..stage, "scale_xy", 0, 0, "", { 0, 0, 1, 1,   0.3, 0, 1.1, 1.1,   0.6, 0, 1, 1,   0.9, 0, 1.1, 1.1,   1.2, 0, 1, 1 });
    
  end;
  
  for i = 1, 7, 1 do
    
    if private.zz_repairmodule.state[ stage ][i] ~= i then
      
      local old = private.zz_repairmodule.chain_pos[ stage ][i];
      local new = private.zz_repairmodule.chain_pos[ stage ][ private.zz_repairmodule.state[ stage ][i] ];
      
      ObjAnimate("spr_repairmodule_chain_"..stage.."_"..private.zz_repairmodule.state[stage][i], "pos_x", 0, 0, "", { 0, 0, old,   0.5, 0, new });
      
    end;
    
  end;
  
  if private.zz_repairmodule.chosen > 0 then
    ObjAnimate("spr_repairmodule_chain_"..stage.."_"..private.zz_repairmodule.chosen.."_select", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  end;
  
  private.zz_repairmodule.state = ng_global.progress[ ng_global.currentprogress ][ "win_repairmodule" ].state;
  
  ObjSet("tmr_repairmodule_timer",  { time = 0.5, playing = 1, endtrig = anm_win });
  
end;
-----------------------------------------------------------------------------------
function private.zz_repairmodule.DrawScene()
  
  for i = 1, 2, 1 do
    
    if private.zz_repairmodule.state[3] == i then
      ObjSet("obj_repairmodule_stage_"..i,  { alp = 1, input = 1 });
    else 
      ObjSet("obj_repairmodule_stage_"..i,  { alp = 0, input = 0 });
    end;
    
  end;
  
  for i = 1, 2, 1 do
    for j = 1, 7, 1 do
      ObjSet("spr_repairmodule_chain_"..i.."_"..private.zz_repairmodule.state[i][j],  { pos_z = 0, pos_x = private.zz_repairmodule.chain_pos[i][j] });
    end;
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_repairmodule.FocusChain( num, inout )
  
  local stage = private.zz_repairmodule.state[3];
  local obj = "spr_repairmodule_chain_"..stage.."_"..num;
  local scale = ObjGet( obj ).scale_x;
  local tme = 0;
  local max_scale = 1.05;  
  local max_tme = 0.3;
  local end_scale = 1;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = ( ( scale - 1 ) * max_tme ) / ( max_scale - 1 );
  else 
    SetCursor(CURSOR_HAND);
    end_scale = max_scale;
    tme = ( ( max_scale - scale ) * max_tme ) / ( max_scale - 1 );
  end;
  
  if inout == 0 and private.zz_repairmodule.chosen ~= num then
    ObjSet(obj,  { pos_z = 0 });
  elseif inout == 0 and private.zz_repairmodule.chosen == num then
    ObjSet(obj,  { pos_z = 2 });
  elseif inout == 1 then
    ObjSet(obj,  { pos_z = 5 });
  end;

  ObjAnimate(obj, "scale_xy", 0, 0, "", { 0, 2, scale, scale,   tme, 2, end_scale, end_scale });
  
end;
-----------------------------------------------------------------------------------
function public.zz_repairmodule.ChoseChain( num )
  
  cmn.Lock( 1 );
  
  if private.zz_repairmodule.chosen == 0 then
    
    cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_droid_scheme_click");
    
    private.zz_repairmodule.chosen = num;
    private.zz_repairmodule.AnimChosen( num, 1, true );
    
  else 
    
    if private.zz_repairmodule.chosen ~= num then
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_droid_scheme_change");
    
      local old = private.zz_repairmodule.chosen;
      private.zz_repairmodule.chosen = 0;
      
      private.zz_repairmodule.SwapChain( old, num );
      private.zz_repairmodule.AnimChosen( old, 0 );
      
    else 
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_droid_scheme_click");
      
      private.zz_repairmodule.chosen = 0;
      private.zz_repairmodule.AnimChosen( num, 0, true );
      
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_repairmodule.AnimChosen( num, inout, lock )
  
  lock = lock or false;
  
  local stage = private.zz_repairmodule.state[3];
  local obj = "spr_repairmodule_chain_"..stage.."_"..num.."_select";
  local obj2 = "spr_repairmodule_chain_"..stage.."_"..num;
  local alf = ObjGet( obj ).alp;
  local tme = 0;
  local func_after = "";
  
  if lock then
    func_after = function() cmn.Lock(0); end;
  end;

  if inout == 0 then
    tme = alf * 0.3;
    ObjSet(obj2,  { pos_z = 0 });
  else 
    ObjSet(obj2,  { pos_z = 2 });
    tme = ( 1 - alf ) * 0.3;
  end;

  ObjAnimate(obj, "alp", 0, 0, func_after, { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function private.zz_repairmodule.SwapChain( old, new )
  
  local ind1 = private.zz_repairmodule.FindInd( old );
  local ind2 = private.zz_repairmodule.FindInd( new );
  local stage = private.zz_repairmodule.state[3];
  
  private.zz_repairmodule.state[ stage ][ind1] = new;
  private.zz_repairmodule.state[ stage ][ind2] = old;
  
  local old_pos = private.zz_repairmodule.chain_pos[ stage ][ ind1 ];
  local new_pos = private.zz_repairmodule.chain_pos[ stage ][ ind2 ];
  
  ObjAnimate("spr_repairmodule_chain_"..stage.."_"..old, "pos_x", 0, 0, private.zz_repairmodule.CheckWin, { 0, 0, old_pos,   0.5, 0, new_pos });
  ObjAnimate("spr_repairmodule_chain_"..stage.."_"..new, "pos_x", 0, 0, "", { 0, 0, new_pos,   0.5, 0, old_pos });
  
end;
-----------------------------------------------------------------------------------
function private.zz_repairmodule.FindInd( num )
  
  local ind = 0;
  
  for i = 1, 7, 1 do
    
    if private.zz_repairmodule.state[ private.zz_repairmodule.state[3] ][i] == num then
      ind = i;
      break;
    end;
    
  end;
  
  return ind;
  
end;
-----------------------------------------------------------------------------------
function private.zz_repairmodule.CheckWin()
  
  local win_flag = true;
  
  for i = 1, 7, 1 do
    
    if private.zz_repairmodule.state[ private.zz_repairmodule.state[3] ][i] ~= i then
      win_flag = false;
      break;
    end;
    
  end;
  
  if win_flag then
    
    cmn.Lock( 1 );
    
    if private.zz_repairmodule.state[3] == 2 then
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_droid_scheme_win");
    
      common_impl.PauseAchiev(1);
      cmn.MiniGameHide("repairmodule");
      
      local anm_robot = function ()
        
        cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_droud_alive");
        ObjSet("anm_repairmodule_robot_active",  { playing = 1, endtrig = private.zz_repairmodule.Win });
        
      end;
      
      ObjAnimate("obj_repairmodule_game", "alp", 0, 0, anm_robot, { 0, 0, 1,   1.2, 0, 1,   1.7, 0, 0 });
      ObjAnimate("obj_repairmodule_stage_2", "scale_xy", 0, 0, "", { 0, 0, 1, 1,   0.3, 0, 1.1, 1.1,   0.6, 0, 1, 1,   0.9, 0, 1.1, 1.1,   1.2, 0, 1, 1 });
      
    else 
      
      private.zz_repairmodule.state[3] = private.zz_repairmodule.state[3] + 1;
      
      local change_stage = function ()
        
        ObjMultiSet( { {"obj_repairmodule_stage_1", { input = 0 }},
                       {"obj_repairmodule_stage_2", { input = 1 }} } );
      
        ObjAnimate("obj_repairmodule_stage_2", "alp", 0, 0, function () cmn.Lock(0); end, { 0, 0, 0,   0.5, 0, 1 });
        ObjAnimate("obj_repairmodule_stage_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
        
      end;
      
      cmn.PlayAudio("snd", "assets/levels/level2/audio/sfx/aud_mmg_droid_scheme_win_level");
      
      ObjAnimate("obj_repairmodule_stage_1", "scale_xy", 0, 0, change_stage, { 0, 0, 1, 1,   0.3, 0, 1.1, 1.1,   0.6, 0, 1, 1,   0.9, 0, 1.1, 1.1,   1.2, 0, 1, 1 });
      
    end;
    
  else 
    cmn.Lock( 0 );
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_repairmodule.Win()
  
  cmn.Lock( 0 );
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_repairmodule" );
  cmn.CallEventHandler( "win_repairmodule" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_repairmodule" ].skip == 0 and ng_global.noskipgames[ "win_repairmodule" ] == nil then

    ng_global.noskipgames[ "win_repairmodule" ] = 1;
    common_impl.CheckAchiev("mg");

  end;
  
end;
--****************************************************************************************************************