-- name=mg_device
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_device";
  --------------------------------------------------------------------------------------------
  private.start = { 8, 5, 9, 1, 12, 2, 10, 4, 11, 3, 7, 6 };
  private.sign_pos = {
    {512, 80}, {647, 116}, {746, 215}, {782, 350}, {746, 485}, {647, 584},
    {512, 620}, {377, 584}, {278, 485}, {242, 350}, {278, 215}, {377, 116}
  };
  private.wait_for = {};
  --------------------------------------------------------------------------------------------
  -- function get_pattern1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_pattern1" ] = {
    type = "get",
    get_obj = "spr_device_pattern1",
    room = "rm_apocalypse3",
    zz = "mg_device",
    zz_gate = "gmg_apocalypse3_device"
  };
  --------------------------------------------------------------------------------------------
  local get_pattern1_inv = function ()
  
    interface.InventoryItemAdd( "inv_pattern1", "spr_device_pattern1" );
  
  end;
  local get_pattern1_end = function ()
  
    ObjDelete( "gfx_device_pattern1" );
    ObjDelete( "spr_device_pattern1_sh" );
  
  end;
  local get_pattern1_loc = function ()
  
    ObjDelete( "spr_apocalypse3_device_pattern" );
  
  end;
  
  cmn.AddSubscriber( "get_pattern1", get_pattern1_inv );
  cmn.AddSubscriber( "get_pattern1", get_pattern1_end, private.room_objname );
  cmn.AddSubscriber( "get_pattern1", get_pattern1_loc, "rm_apocalypse3" );
  --------------------------------------------------------------------------------------------
  -- function get_boxpart1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_boxpart1" ] = {
    type = "get",
    get_obj = "spr_device_boxpart1",
    room = "rm_apocalypse3",
    zz = "mg_device",
    zz_gate = "gmg_apocalypse3_device"
  };
  --------------------------------------------------------------------------------------------
  local get_boxpart1_inv = function ()
  
    interface.InventoryItemAdd( "inv_boxpart", "spr_device_boxpart1", function () cmn.GetMultyObject( 'boxpart', 4 ); end );
      
    if cmn.CheckMultiObject( "boxpart", 4 ) then
      ObjSet("inv_pandorasbox_star_light",  { alp = 1 });
    end;
  
  end;
  local get_boxpart1_end = function ()
  
    ObjDelete( "gfx_device_boxpart1" );
    ObjDelete( "spr_device_boxpart1_sh" );
  
  end;
  local get_boxpart1_loc = function ()
  
    ObjDelete( "spr_apocalypse3_device_boxpart" );
  
  end;
  
  cmn.AddSubscriber( "get_boxpart1", get_boxpart1_inv );
  cmn.AddSubscriber( "get_boxpart1", get_boxpart1_end, private.room_objname );
  cmn.AddSubscriber( "get_boxpart1", get_boxpart1_loc, "rm_apocalypse3" );
  
  --------------------------------------------------------------------------------------------
  -- function use_zodiacsign () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_zodiacsign" ] = {
    type = "use",
    inv_obj = "inv_zodiacsign",
    use_place = "obj_device_use_zodiacsign",
    room = "rm_apocalypse3",
    zz = "mg_device",
    zz_gate = "gmg_apocalypse3_device"
  };
  --------------------------------------------------------------------------------------------
  local use_zodiacsign_inv = function ()
  
    interface.InventoryItemRemove( "inv_zodiacsign" );
  
  end;
  local use_zodiacsign_beg = function ()
  
    ObjDelete( "obj_device_use_zodiacsign" );
  
  end;
  local use_zodiacsign_end = function ()
  
    ObjSet( "obj_device_game", { input = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_zodiacsign", use_zodiacsign_beg, private.room_objname );
  cmn.AddSubscriber( "use_zodiacsign", use_zodiacsign_inv );
  cmn.AddSubscriber( "use_zodiacsign", use_zodiacsign_end, private.room_objname );
  cmn.AddSubscriber( "use_zodiacsign_inv", use_zodiacsign_inv, private.room_objname );
  cmn.AddSubscriber( "use_zodiacsign_beg", use_zodiacsign_beg, private.room_objname );
  cmn.AddSubscriber( "use_zodiacsign_end", use_zodiacsign_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fang () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_fang" ] = {
    type = "use",
    inv_obj = "inv_fang",
    use_place = "obj_device_use_fang",
    room = "rm_apocalypse3",
    zz = "mg_device",
    zz_gate = "gmg_apocalypse3_device"
  };
  --------------------------------------------------------------------------------------------
  local use_fang_inv = function ()
  
    interface.InventoryItemRemove( "inv_fang" );
    interface_impl.SetCurrentGlobalTask( 19 );
  
  end;
  local use_fang_beg = function ()
  
    ObjDelete( "obj_device_use_fang" );
    --ObjDelete( "anm_device_book_touch" );
  
  end;
  local use_fang_end = function ()
  
    ObjDelete( "anm_device_book_touch" );
    ObjSet("anm_device_use_fang",  { alp = 1, frame = 400 });
  
  end;
  local use_fang_loc = function ()
  
    ObjDelete( "gmg_apocalypse3_device" );
    ObjDelete( "spr_apocalypse3_device_book_signs" );
    ObjSet("spr_apocalypse3_device_fang",  { alp = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fang", use_fang_beg, private.room_objname );
  cmn.AddSubscriber( "use_fang", use_fang_inv );
  cmn.AddSubscriber( "use_fang", use_fang_end, private.room_objname );
  cmn.AddSubscriber( "use_fang_inv", use_fang_inv, private.room_objname );
  cmn.AddSubscriber( "use_fang_beg", use_fang_beg, private.room_objname );
  cmn.AddSubscriber( "use_fang_end", use_fang_end, private.room_objname );
  cmn.AddSubscriber( "use_fang", use_fang_loc, "rm_apocalypse3" );
  cmn.AddSubscriber( "use_fang_loc", use_fang_loc, "rm_apocalypse3" );

  --------------------------------------------------------------------------------------------
  -- function win_device () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "win_device" ] = {
    type = "win",
    room = "rm_apocalypse3",
    zz = "mg_device",
    zz_gate = "gmg_apocalypse3_device"
  };
  --------------------------------------------------------------------------------------------
  local win_device = function ()

    if cmn.IsEventDone( "win_device" ) then
      ObjDelete("obj_device_game");
      ObjDelete("anm_device_piramyd_open");
      ObjSet( "obj_device_use_fang", { input = 1 } );
    end;

  end;
  local win_device_loc = function ()

    if cmn.IsEventDone( "win_device" ) then
      ObjDelete("spr_apocalypse3_device_dome");
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_device", win_device, "mg_device" );
  cmn.AddSubscriber( "win_device", win_device_loc, "rm_apocalypse3" );
  
end;
--*********************************************************************************************************************
function public.Load()

  if not ng_global.progress[ ng_global.currentprogress ][ "win_device" ].state or ng_global.currentprogress == "secret" then
    private.StartConditions();
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_device" ].state;

end;
--*********************************************************************************************************************
function public.Open() 

  if ng_global.currentprogress == "std" and cmn.IsEventDone("use_zodiacsign") and not(cmn.IsEventDone( "win_device" )) then
    cmn.MiniGameShow();
    private.CheckWin();
    cmn.StartTimePassing("mg_device");
  
  elseif ng_global.currentprogress == "secret" then
    rm_extra.MiniGameShow();
  end;

  if ng_global.currentprogress == "std" and cmn.IsEventDone("use_fang") then
    local movement = function ()
      cmn.GotoRoom("rm_debughall");
    end;
    cmn.Lock( 0 );
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level3/rm_apocalypse3/vid_lvl3return", movement, "assets/levels/level3/audio/mus/aud_vid_lvl3return_mus" );
  end;
  
  if ng_global.currentprogress == "secret" then
    cmn.PlayAudio("mus", "assets/levels/common/audio/aud_ho_game_2_mus", 1);
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level3/audio/env/aud_rm_device_env");
  cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_device_env");
  
  if ng_global.currentprogress == "std" then
    common.SetPreviousRoom( "rm_apocalypse3" );
  else 
    
    ObjDelete( "spr_device_pattern1" );
    ObjDelete( "spr_device_pattern1_sh" );
    
    ObjDelete( "spr_device_boxpart1" );
    ObjDelete( "spr_device_boxpart1_sh" );
    
    ObjDelete( "obj_device_use_zodiacsign" );
    
    ObjMultiSet( { {"obj_device_game", { input = 1 }},
                   {"anm_device_game", { alp = 1, playing = 1 }},
                   {"anm_device_piramyd_open", { alp = 1, frame = 0 }} } );
    
    private.StartConditions();
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_device" ].state;
    
    ObjSet("grm_device_apocalypse3",  { event_mdown = "", event_mup = rm_extra.GoToSecretroom, input = 1,
                                         event_menter = function () rm_extra.GateMouseEnter( "device_apocalypse3", CURSOR_DOWN, "extra" ); end, 
                                         event_mleave = function () common_impl.GateMouseLeave( "device_apocalypse3" ); end });
    
  end;
    
  private.DrawScene();
  
  if ng_global.currentprogress == "std" and cmn.IsEventDone("use_fang") then
    cmn.Lock( 1 );
    ObjSet("mg_device",  { color_r = 0, color_g = 0, color_b = 0, input = 0 });
  end;
  
  
  local autohide = interface.InventoryAutoHideGet();
  private.autohide = autohide;
  if (autohide == false) then
    MsgSend( Event_ButtonLock_Click, {} );
  end;
  interface.InventoryClose();
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
  
  if ng_global.currentprogress == "secret" then
    cmn.StopAllMus();
  end;

  if ng_global.currentprogress == "std" and cmn.IsEventDone("use_zodiacsign") and not(cmn.IsEventDone( "win_device" )) then
    cmn.MiniGameHide();
  elseif ng_global.currentprogress == "secret" and not(cmn.IsEventDone( "win_device" )) then
    rm_extra.MiniGameHide();
  end;
  
  
  if (private.autohide == false) and interface.InventoryAutoHideGet() == true then
    interface.InventoryOpen();
    MsgSend( Event_ButtonLock_Click, {} );
  end;
  
end;
--*********************************************************************************************************************
function public.Reset()
  
  local need_r = false;
  local table_r = {};
  local table_r2 = {};
  
  for i = 1, 12, 1 do
    
    if private.state[i] ~= private.start[i] and private.state[i] ~= i then
      
      if not need_r then
        need_r = true;
      end;
      
      table.insert( table_r, private.state[i] );
      ObjAnimate("spr_device_sign_"..private.state[i], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    elseif private.state[i] == i then
      
      if not need_r then
        need_r = true;
      end;
      
      table.insert( table_r, private.state[i] );
      table.insert( table_r2, private.state[i] );
      
    end;
    
  end;
  
  local anm_end = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zodiacs_put");
    
    for i = 1, #table_r, 1 do
      
      local pos = 0;
      for j = 1, 12, 1 do
        
        if private.start[j] == table_r[i] then
          pos = j;
          break;
        end;
        
      end;
      
      ObjAttach("spr_device_sign_"..table_r[i], "obj_device_sign_"..pos);
      ObjAnimate("spr_device_sign_"..table_r[i], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    for i = 1, #table_r2, 1 do
      
      ObjAnimate("anm_device_sign_"..table_r2[i], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    ObjSet("tmr_device_timer",  { time = 0.3, playing = 1, endtrig = function() private.DrawScene(); cmn.Lock(0); end });
    
  end;
  
  if need_r then
    
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zodiacs_take");
    
    private.StartConditions();
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_device" ].state;
    
    ObjSet("tmr_device_timer",  { time = 0.3, playing = 1, endtrig = anm_end });
    
  end;

end;
--*********************************************************************************************************************
function public.Skip()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zodiacs_take");
  
  ng_global.progress[ ng_global.currentprogress ][ "win_device" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_device" ].state = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12 };
  
  local table_r = {};
  
  for i = 1, 12, 1 do
    
    if private.state[i] ~= i then
      
      table.insert( table_r, private.state[i] );
      ObjAnimate("spr_device_sign_"..private.state[i], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  end;
  
  local anm_end_2 = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zodiacs_trangle_diss");
    
    for i = 1, #table_r, 1 do
      
      ObjSet("anm_device_sign_"..table_r[i],  { playing = 1 });
      
    end;
    
    ObjSet("tmr_device_timer",  { time = 1.6, playing = 1, endtrig = private.CheckWin });
    
  end;
  
  local anm_end = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zodiacs_put");
    
    for i = 1, #table_r, 1 do
      
      ObjAttach("spr_device_sign_"..table_r[i], "obj_device_sign_"..table_r[i]);
      ObjAnimate("spr_device_sign_"..table_r[i], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    ObjSet("tmr_device_timer",  { time = 0.3, playing = 1, endtrig = anm_end_2 });
    
  end;
  
  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_device" ].state;
    
  ObjSet("tmr_device_timer",  { time = 0.3, playing = 1, endtrig = anm_end });

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_zodiacsign()

  local item = "inv_zodiacsign";

  if ( cmn.ApplyObj( item, "obj_device_use_zodiacsign" ) and cmn.CheckMultiObject( "zodiacsign", 4 ) ) then

    cmn.CallEventHandler( "use_zodiacsign_inv" );
    cmn.CallEventHandler( "use_zodiacsign_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_zodiacsign" );
      cmn.CallEventHandler( "use_zodiacsign_end" );
      
      cmn.MiniGameShow();
      cmn.StartTimePassing("mg_device");
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_stuff_ball_zodiacs");

    ObjAnimate("spr_device_sign_2", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    ObjAnimate("spr_device_sign_7", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    ObjAnimate("spr_device_sign_9", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    ObjAnimate("spr_device_sign_11", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    
    ObjSet("tmr_device_timer",  { time = 0.3, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_fang()

  local item = "inv_fang";

  if ( cmn.ApplyObj( item, "obj_device_use_fang" ) and cmn.IsEventDone("win_device") ) then

    cmn.CallEventHandler( "use_fang_inv" );
    cmn.CallEventHandler( "use_fang_beg" );

    local movement = function ()
      ObjSet("mg_device",  { color_r = 0, color_g = 0, color_b = 0, input = 0 });
      cmn.GotoRoom("rm_debughall");
    end;

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_fang" );
      --cmn.CallEventHandler( "use_fang_end" );
      cmn.CallEventHandler("use_fang_loc");
      
      cmn.StopAllEnv();
      cmn.PlayFullscreenVideo( "assets/levels/level3/rm_apocalypse3/vid_lvl3return", movement, "assets/levels/level3/audio/mus/aud_vid_lvl3return_mus" );
    
    end;

    --cmn.Lock( 1 );
    --cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zodiacs_book");

    --ObjSet("anm_device_use_fang",  { alp = 1, playing = 1, endtrig = func_after });
    
    func_after();

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_pattern1()

  cmn.SetEventDone( "get_pattern1" );
  cmn.CallEventHandler( "get_pattern1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_boxpart1()

  cmn.SetEventDone( "get_boxpart1" );
  cmn.CallEventHandler( "get_boxpart1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.touch_book()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_book_evil");

  cmn.ShowBbt( "obj_device_use_fang" );
  
  ObjSet( "anm_device_book_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_device" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_device" ].state = { 8, 5, 9, 1, 12, 2, 10, 4, 11, 3, 7, 6 };

end;
-----------------------------------------------------------------------------------
function private.DrawScene()
  
  if ng_global.currentprogress == "std" and not cmn.IsEventDone("use_zodiacsign") then
    
    --for i = 1, 12, 1 do
    --  ObjSet("spr_device_sign_"..i,  { alp = 0 });
    --end;
  
    ObjMultiSet( { {"spr_device_sign_2", { alp = 0 }},
                   {"spr_device_sign_7", { alp = 0 }},
                   {"spr_device_sign_9", { alp = 0 }},
                   {"spr_device_sign_11", { alp = 0 }} } );
    
  end;

  for i = 1, 12, 1 do
    
    ObjAttach("spr_device_sign_"..private.state[i], "obj_device_sign_"..i);
    
    if private.state[i] ~= i then
      ObjSet("anm_device_sign_"..i,  { input = 1, alp = 1, frame = 0 });
    else 
      ObjSet("anm_device_sign_"..i,  { input = 0, alp = 0, frame = 0 });
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.FocusSign( num, inout )
  
  local obj = "spr_device_sign_"..num.."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_GET);
    tme = ( 1 - alf ) * 0.3;
  end;

  --ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
private.start_pos_drag = {};
-----------------------------------------------------------------------------------
function public.StartDrag( num, two_step )
  
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zodiacs_take");
  
  ObjAttach("spr_device_sign_"..num, "obj_device_fly");
  
  if not two_step then
    private.start_pos_drag.x = ObjGet("spr_device_sign_"..num).pos_x;
    private.start_pos_drag.y = ObjGet("spr_device_sign_"..num).pos_y;
  end;
  
end;
-----------------------------------------------------------------------------------
function public.DropSign( num, two_step )
  
  cmn.Lock( 1 );
  
  local place = 0;
  local ind = private.FindIndex( num );
  
  local pos = GetZoomCursorPos();
  if  tostring(GetPlatform()) == "android" then
      pos[2] = pos[2] - 100;
  elseif tostring(GetPlatform()) == "ios" then
    if port.isTablet() == 0 then
      pos[2] = pos[2] - 75;
    else
      pos[2] = pos[2] - 50;
    end;
  end;
  
  if (two_step) then
    pos[1] = 512;
    pos[2] = 384;
  end;
  
  local px = pos[1];
  local py = pos[2];
  
  local point_a, point_b = {}, {};
  point_a[1] = px;
  point_a[2] = py;
  
  for i = 1, #private.sign_pos, 1 do
    
    if private.CheckHit(px, py, i) and private.state[i] ~= i then
      place = i;
      break;
    end;
    
  end;
  
  if place > 0 then
    point_b[1] = private.sign_pos[ place ][1];
    point_b[2] = private.sign_pos[ place ][2];
  else 
    point_b[1] = private.sign_pos[ ind ][1];
    point_b[2] = private.sign_pos[ ind ][2];
  end;
  
  local len = common_impl.math.FindSegmentLength( point_a, point_b );
  local tme = 0.001 * len;
  
  if tme < 0.1 then
    tme = 0.1;
  elseif tme > 0.4 then
    tme = 0.4;
  end;
  
  if place == 0 or place == ind then
    
    ObjAnimate("spr_device_sign_"..num, "pos_xy", 0, 0, 
      function() 
        cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zodiacs_put");
        private.CheckStone( num, 0 ); 
      end, 
      { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] }
    );
    
  else 
    
    local num2 = private.state[ place ];
    private.state[ place ] = num;
    private.state[ ind ] = num2;
    
    ObjAnimate("spr_device_sign_"..num, "pos_xy", 0, 0, 
      function() 
        cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zodiacs_put");
        private.CheckStone( num, num2 ); 
      end, 
      { 0, 0, point_a[1], point_a[2],   tme, 0, point_b[1], point_b[2] }
    );
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.CheckStone( num1, num2 )
  
  num2 = num2 or 0;
  
  local pos = private.FindIndex( num1 );
  
  ObjSet("spr_device_sign_"..num1,  { pos_x = 0, pos_y = 0 });
  ObjAttach("spr_device_sign_"..num1, "obj_device_sign_"..pos);
  
  if num2 > 0 then
    --ObjStartDrag("spr_device_sign_"..num2);
    local number = num2;
    ObjAnimate("spr_device_sign_"..num2, "alp", 0, 0, function()
      public.StartDrag( number, true );
      public.DropSign( number, true );
      end, { 0, 0, 1,   0.25, 0, 1 });
  end;
  
  if private.state[num1] == num1 then
    
    table.insert( private.wait_for, num1 );
    private.AnimWinSign( num1 );
    
  elseif #private.wait_for == 0 then
    cmn.Lock(0);
  end;

end;
-----------------------------------------------------------------------------------
function private.AnimWinSign( sign )
  
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zodiacs_trangle_diss");
  
  local func_after = function ()
    
    local ind = 0;
    for i = 1, #private.wait_for, 1 do
      
      if private.wait_for[i] == sign then
        ind = i;
        break;
      end;
      
    end;
    
    table.remove( private.wait_for, ind );
    
    ObjSet("anm_device_sign_"..sign,  { alp = 0, playing = 0, frame = 0 });
    if #private.wait_for == 0 then
      private.CheckWin();
    end;
    
  end;
  
  ObjSet("anm_device_sign_"..sign,  { input = 0, playing = 1, endtrig = func_after });
  
end;
-----------------------------------------------------------------------------------
function private.FindIndex( sign )
  
  local ind = 0;
  
  for i = 1, 12, 1 do
    
    if private.state[i] == sign then
      ind = i;
      break;
    end;
    
  end;
  
  return ind;
  
end;
-----------------------------------------------------------------------------------
function private.CheckHit( px, py, num )
  
  local centr = {0, 0}; 
  local accuracy = 50;

  centr[1] = private.sign_pos[num][1];
  centr[2] = private.sign_pos[num][2];

  if ( (px - centr[1])^2 + (py - centr[2])^2 ) <= accuracy^2 then 
    return true;
  else
    return false;
  end; 
  
end;
-----------------------------------------------------------------------------------
function private.CheckWin()
  
  local win_flag = true;
  
  for i = 1, 12, 1 do
    
    if private.state[i] ~= i then
      win_flag = false;
      break;
    end;
    
  end;
  
  if win_flag then
    
    cmn.Lock(1);
    
    if ng_global.currentprogress == "std" then 
    
      cmn.MiniGameHide();

      common_impl.PauseAchiev( 1 );
      cmn.EndTimePassing( "mg_device" );
      
    else 
      
      rm_extra.MiniGameHide();
      int_dialog_secretroom.StopTimer();
      
    end;
    
    local anm_piramyd = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zodiacs_win_pyramide");
      ObjSet("anm_device_piramyd_open",  { playing = 1, endtrig = private.Win });
      if (private.autohide == false) then
        MsgSend( Event_ButtonLock_Click, {} );
      end;
      interface.InventoryOpen();
    end;
    
    ObjSet("tmr_device_timer",  { time = 1, playing = 1, endtrig = anm_piramyd });
    ObjAnimate("anm_device_game", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    
  else
    cmn.Lock(0);
  end;

end;
-----------------------------------------------------------------------------------
function private.Win()

  cmn.Lock(0);
  
  cmn.SetEventDone( "win_device" );
  
  if ng_global.currentprogress == "std" then
  
    cmn.CallEventHandler( "win_device" );

    if ng_global.progress[ ng_global.currentprogress ][ "win_device" ].skip == 0 and not ng_global.noskipgames[ "win_device" ] then

      ng_global.noskipgames[ "win_device" ] = 1;
      common_impl.CheckAchiev("mg");

    end;
    
    if ng_global.playedgames and not ng_global.playedgames[ "win_device" ] then
      ng_global.playedgames[ "win_device" ] = 1;
    end;

    common_impl.PauseAchiev( 0 );
    
  else 
    
    ObjSet("grm_device_apocalypse3",  { input = 0 });
    
    interface_impl.ShowStarsWindow();
    
  end;
  

end;
--**************************************************************************************************************