-- name=inventory3
--*********************************************************************************************************************
function public.Init()

  private.Init_Pandorasbox();
  --------------------------------------------------------------------------------------------
  -- function get_lvl3button3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl3button3" ] = {
    type = "get",
    get_obj = "spr_complex_repairbox_button3",
    room ="int_complex_inv",
    zz = "inv_complex_repairbox",
    zz_gate = "inv_repairbox"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl3button3_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl3button", "spr_complex_repairbox_button3", function () cmn.GetMultyObject( 'lvl3button', 3 ); end  );
      
    if not cmn.IsEventDone("get_repairamulet1") or cmn.IsEventDone("use_repairamulet1") then
      ObjSet("inv_repairbox_star_light",  { alp = 0 });
    end;
    
    ObjDelete( "gfx_complex_repairbox_button3" );
    ObjDelete( "spr_complex_repairbox_button3_sh" );
  
  end;
  cmn.AddSubscriber( "get_lvl3button3", get_lvl3button3_inv );
  --------------------------------------------------------------------------------------------
  -- function get_generatorbutton () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_generatorbutton" ] = {
    type = "get",
    get_obj = "spr_complex_repairbox_generatorbutton",
    room ="int_complex_inv",
    zz = "inv_complex_repairbox",
    zz_gate = "inv_repairbox"
  };
  --------------------------------------------------------------------------------------------
  local get_generatorbutton_inv = function ()
  
    if cmn.IsEventDone("get_lockedcard") then
      interface.InventoryItemRemove( "inv_repairbox" );
    end;
    interface.InventoryItemAdd( "inv_generatorbutton", "spr_complex_repairbox_generatorbutton" );
    
    ObjDelete( "gfx_complex_repairbox_generatorbutton" );
    ObjDelete( "spr_complex_repairbox_generatorbutton_sh" );
  
  end;
  cmn.AddSubscriber( "get_generatorbutton", get_generatorbutton_inv );
  --------------------------------------------------------------------------------------------
  -- function get_lockedcard () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lockedcard" ] = {
    type = "get",
    get_obj = "spr_complex_repairbox_lockedcard",
    room ="int_complex_inv",
    zz = "inv_complex_repairbox",
    zz_gate = "inv_repairbox"
  };
  --------------------------------------------------------------------------------------------
  local get_lockedcard_inv = function ()
  
    if cmn.IsEventDone("get_generatorbutton") then
      interface.InventoryItemRemove( "inv_repairbox" );
    end;
    interface.InventoryItemAdd( "inv_lockedcard", "spr_complex_repairbox_lockedcard" );
    
    ObjDelete( "gfx_complex_repairbox_lockedcard" );
    ObjDelete( "spr_complex_repairbox_lockedcard_sh" );
  
  end;
  cmn.AddSubscriber( "get_lockedcard", get_lockedcard_inv );

  --------------------------------------------------------------------------------------------
  -- function use_repairamulet2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_repairamulet2" ] = {
    type = "use",
    inv_obj = "inv_repairamulet2",
    use_place = "obj_complex_repairbox_use_repairamulet2",
    room = "int_complex_inv",
    zz = "inv_complex_repairbox",
    zz_gate = "inv_repairbox"
  };
  --------------------------------------------------------------------------------------------
  local use_repairamulet2_inv = function ()
  
    interface.InventoryItemRemove( "inv_repairamulet2" );
    if not cmn.IsEventDone("get_repairamulet1") then
      ObjSet("inv_repairbox_star_light",  { alp = 0 });
    end;
  
  end;
  local use_repairamulet2_beg = function ()
  
    ObjDelete( "obj_complex_repairbox_use_repairamulet2" );
  
  end;
  local use_repairamulet2_end = function ()
  
    if cmn.IsEventDone("use_repairamulet1") then
      ObjDelete( "anm_complex_repairbox_touch" );
      ObjSet( "obj_complex_repairbox_open", { input = 1, alp = 1 } );
    else 
      ObjSet( "spr_complex_repairbox_amulet_2", { alp = 1 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_repairamulet2", use_repairamulet2_beg, "inv_complex_repairbox" );
  cmn.AddSubscriber( "use_repairamulet2", use_repairamulet2_inv );
  cmn.AddSubscriber( "use_repairamulet2", use_repairamulet2_end, "inv_complex_repairbox" );
  cmn.AddSubscriber( "use_repairamulet2_inv", use_repairamulet2_inv, "inv_complex_repairbox" );
  cmn.AddSubscriber( "use_repairamulet2_beg", use_repairamulet2_beg, "inv_complex_repairbox" );
  cmn.AddSubscriber( "use_repairamulet2_end", use_repairamulet2_end, "inv_complex_repairbox" );
  --------------------------------------------------------------------------------------------
  -- function use_repairamulet1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_repairamulet1" ] = {
    type = "use",
    inv_obj = "inv_repairamulet1",
    use_place = "obj_complex_repairbox_use_repairamulet1",
    room = "int_complex_inv",
    zz = "inv_complex_repairbox",
    zz_gate = "inv_repairbox"
  };
  --------------------------------------------------------------------------------------------
  local use_repairamulet1_inv = function ()
  
    interface.InventoryItemRemove( "inv_repairamulet1" );
    if not cmn.IsEventDone("get_repairamulet2") then
      ObjSet("inv_repairbox_star_light",  { alp = 0 });
    end;
  
  end;
  local use_repairamulet1_beg = function ()
  
    ObjDelete( "obj_complex_repairbox_use_repairamulet1" );
  
  end;
  local use_repairamulet1_end = function ()
  
    if cmn.IsEventDone("use_repairamulet2") then
      ObjDelete( "anm_complex_repairbox_touch" );
      ObjSet( "obj_complex_repairbox_open", { input = 1, alp = 1 } );
    else 
      ObjSet( "spr_complex_repairbox_amulet_1", { alp = 1 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_repairamulet1", use_repairamulet1_beg, "inv_complex_repairbox" );
  cmn.AddSubscriber( "use_repairamulet1", use_repairamulet1_inv );
  cmn.AddSubscriber( "use_repairamulet1", use_repairamulet1_end, "inv_complex_repairbox" );
  cmn.AddSubscriber( "use_repairamulet1_inv", use_repairamulet1_inv, "inv_complex_repairbox" );
  cmn.AddSubscriber( "use_repairamulet1_beg", use_repairamulet1_beg, "inv_complex_repairbox" );
  cmn.AddSubscriber( "use_repairamulet1_end", use_repairamulet1_end, "inv_complex_repairbox" );

  --------------------------------------------------------------------------------------------
  -- function get_repairamulet1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_repairamulet1" ] = {
    type = "get",
    get_obj = "spr_complex_case_repairamulet1",
    room ="int_complex_inv",
    zz = "inv_complex_case",
    zz_gate = "inv_case"
  };
  --------------------------------------------------------------------------------------------
  local get_repairamulet1_inv = function ()
  
    interface.InventoryItemAdd( "inv_repairamulet1", "spr_complex_case_repairamulet1" );
    
    ObjSet("inv_case_star_light",  { alp = 0 });
    ObjSet("inv_repairbox_star_light",  { alp = 1 });
    
    ObjDelete( "gfx_complex_case_repairamulet1" );
    ObjDelete( "spr_complex_case_repairamulet1_sh" );
  
  end;
  cmn.AddSubscriber( "get_repairamulet1", get_repairamulet1_inv );
  --------------------------------------------------------------------------------------------
  -- function get_glove () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_glove" ] = {
    type = "get",
    get_obj = "spr_complex_case_glove",
    room ="int_complex_inv",
    zz = "inv_complex_case",
    zz_gate = "inv_case"
  };
  --------------------------------------------------------------------------------------------
  local get_glove_inv = function ()
  
    interface.InventoryItemRemove( "inv_case" );
    interface.InventoryItemAdd( "inv_glove", "spr_complex_case_glove" );
    
    ObjDelete( "gfx_complex_case_glove" );
  
  end;
  cmn.AddSubscriber( "get_glove", get_glove_inv );

  --------------------------------------------------------------------------------------------
  -- function use_tumbler1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_tumbler1" ] = {
    type = "use",
    inv_obj = "inv_tumbler1",
    use_place = "obj_complex_case_use_tumbler1",
    room = "int_complex_inv",
    zz = "inv_complex_case",
    zz_gate = "inv_case"
  };
  --------------------------------------------------------------------------------------------
  local use_tumbler1_inv = function ()
  
    interface.InventoryItemRemove( "inv_tumbler1" );
    if not cmn.IsEventDone("get_tumbler2") then
      ObjSet("inv_case_star_light",  { alp = 0 });
    end;
  
  end;
  local use_tumbler1_beg = function ()
  
    ObjDelete( "obj_complex_case_use_tumbler1" );
  
  end;
  local use_tumbler1_end = function ()
  
    if cmn.IsEventDone("use_tumbler2") then
      ObjDelete("anm_complex_case_touch");
      ObjMultiSet( { {"anm_complex_case_open", { alp = 1, frame = 300 }},
                     {"obj_complex_case_inside", { alp = 1, input = 1 }} } );
    else 
      ObjSet("spr_complex_case_tumbler1",  { alp = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tumbler1", use_tumbler1_beg, "inv_complex_case" );
  cmn.AddSubscriber( "use_tumbler1", use_tumbler1_inv );
  cmn.AddSubscriber( "use_tumbler1", use_tumbler1_end, "inv_complex_case" );
  cmn.AddSubscriber( "use_tumbler1_inv", use_tumbler1_inv, "inv_complex_case" );
  cmn.AddSubscriber( "use_tumbler1_beg", use_tumbler1_beg, "inv_complex_case" );
  cmn.AddSubscriber( "use_tumbler1_end", use_tumbler1_end, "inv_complex_case" );
  --------------------------------------------------------------------------------------------
  -- function use_tumbler2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_tumbler2" ] = {
    type = "use",
    inv_obj = "inv_tumbler2",
    use_place = "obj_complex_case_use_tumbler2",
    room = "int_complex_inv",
    zz = "inv_complex_case",
    zz_gate = "inv_case"
  };
  --------------------------------------------------------------------------------------------
  local use_tumbler2_inv = function ()
  
    interface.InventoryItemRemove( "inv_tumbler2" );
    if not cmn.IsEventDone("get_tumbler1") then
      ObjSet("inv_case_star_light",  { alp = 0 });
    end;
  
  end;
  local use_tumbler2_beg = function ()
  
    ObjDelete( "obj_complex_case_use_tumbler2" );
  
  end;
  local use_tumbler2_end = function ()
  
    if cmn.IsEventDone("use_tumbler1") then
      ObjDelete("anm_complex_case_touch");
      ObjMultiSet( { {"anm_complex_case_open", { alp = 1, frame = 300 }},
                     {"obj_complex_case_inside", { alp = 1, input = 1 }} } );
    else 
      ObjSet("spr_complex_case_tumbler2",  { alp = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tumbler2", use_tumbler2_beg, "inv_complex_case" );
  cmn.AddSubscriber( "use_tumbler2", use_tumbler2_inv );
  cmn.AddSubscriber( "use_tumbler2", use_tumbler2_end, "inv_complex_case" );
  cmn.AddSubscriber( "use_tumbler2_inv", use_tumbler2_inv, "inv_complex_case" );
  cmn.AddSubscriber( "use_tumbler2_beg", use_tumbler2_beg, "inv_complex_case" );
  cmn.AddSubscriber( "use_tumbler2_end", use_tumbler2_end, "inv_complex_case" );

  --------------------------------------------------------------------------------------------
  -- function get_carkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_carkey" ] = {
    type = "get",
    get_obj = "spr_complex_jack_carkey",
    room ="int_complex_inv",
    zz = "inv_complex_jack",
    zz_gate = "inv_jack"
  };
  --------------------------------------------------------------------------------------------
  local get_carkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_carkey", "spr_complex_jack_carkey" );
    
    if not cmn.IsEventDone("get_jackpart1") or cmn.IsEventDone("use_jackpart1") then
      ObjSet("inv_jack_star_light",  { alp = 0 });
    end;
    
    ObjDelete( "gfx_complex_jack_carkey" );
    ObjDelete( "spr_complex_jack_carkey_sh" );
  
  end;
  cmn.AddSubscriber( "get_carkey", get_carkey_inv );
  --------------------------------------------------------------------------------------------
  -- function get_workingjack () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_workingjack" ] = {
    type = "get",
    get_obj = "obj_complex_jack_workingjack",
    room ="int_complex_inv",
    zz = "inv_complex_jack",
    zz_gate = "inv_jack"
  };
  --------------------------------------------------------------------------------------------
  local get_workingjack_inv = function ()
  
    interface.InventoryItemRemove( "inv_jack" );
    interface.InventoryItemAdd( "inv_workingjack", "obj_complex_jack_workingjack" );
    
    ObjDelete( "gfx_complex_jack_workingjack" );
  
  end;
  cmn.AddSubscriber( "get_workingjack", get_workingjack_inv );

  --------------------------------------------------------------------------------------------
  -- function use_jackpart2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_jackpart2" ] = {
    type = "use",
    inv_obj = "inv_jackpart2",
    use_place = "obj_complex_jack_use_jackpart2",
    room = "int_complex_inv",
    zz = "inv_complex_jack",
    zz_gate = "inv_jack"
  };
  --------------------------------------------------------------------------------------------
  local use_jackpart2_inv = function ()
  
    interface.InventoryItemRemove( "inv_jackpart2" );
    
    if not cmn.IsEventDone("get_jackpart1") then
      ObjSet("inv_jack_star_light",  { alp = 0 });
    end;
  
  end;
  local use_jackpart2_beg = function ()
  
    ObjDelete( "obj_complex_jack_use_jackpart2" );
  
  end;
  local use_jackpart2_end = function ()
    
    ObjSet("obj_complex_jack_part_2",  { alp = 1 });
  
    if cmn.IsEventDone("use_jackpart1") then
      ObjMultiSet( { {"obj_complex_jack_workingjack", { input = 1 }},
                     {"gfx_complex_jack_workingjack", { active = 1, visible = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_jackpart2", use_jackpart2_beg, "inv_complex_jack" );
  cmn.AddSubscriber( "use_jackpart2", use_jackpart2_inv );
  cmn.AddSubscriber( "use_jackpart2", use_jackpart2_end, "inv_complex_jack" );
  cmn.AddSubscriber( "use_jackpart2_inv", use_jackpart2_inv, "inv_complex_jack" );
  cmn.AddSubscriber( "use_jackpart2_beg", use_jackpart2_beg, "inv_complex_jack" );
  cmn.AddSubscriber( "use_jackpart2_end", use_jackpart2_end, "inv_complex_jack" );
  --------------------------------------------------------------------------------------------
  -- function use_jackpart1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_jackpart1" ] = {
    type = "use",
    inv_obj = "inv_jackpart1",
    use_place = "obj_complex_jack_use_jackpart1",
    room = "int_complex_inv",
    zz = "inv_complex_jack",
    zz_gate = "inv_jack"
  };
  --------------------------------------------------------------------------------------------
  local use_jackpart1_inv = function ()
  
    interface.InventoryItemRemove( "inv_jackpart1" );
    
    if not cmn.IsEventDone("get_jackpart2") then
      ObjSet("inv_jack_star_light",  { alp = 0 });
    end;
  
  end;
  local use_jackpart1_beg = function ()
  
    ObjDelete( "obj_complex_jack_use_jackpart1" );
  
  end;
  local use_jackpart1_end = function ()
    
    ObjSet("obj_complex_jack_part_1",  { alp = 1 });
  
    if cmn.IsEventDone("use_jackpart2") then
      ObjMultiSet( { {"obj_complex_jack_workingjack", { input = 1 }},
                     {"gfx_complex_jack_workingjack", { active = 1, visible = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_jackpart1", use_jackpart1_beg, "inv_complex_jack" );
  cmn.AddSubscriber( "use_jackpart1", use_jackpart1_inv );
  cmn.AddSubscriber( "use_jackpart1", use_jackpart1_end, "inv_complex_jack" );
  cmn.AddSubscriber( "use_jackpart1_inv", use_jackpart1_inv, "inv_complex_jack" );
  cmn.AddSubscriber( "use_jackpart1_beg", use_jackpart1_beg, "inv_complex_jack" );
  cmn.AddSubscriber( "use_jackpart1_end", use_jackpart1_end, "inv_complex_jack" );

  --------------------------------------------------------------------------------------------
  -- function get_roundhandle () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_roundhandle" ] = {
    type = "get",
    get_obj = "spr_complex_lvl3bag_roundhandle",
    room ="int_complex_inv",
    zz = "inv_complex_lvl3bag",
    zz_gate = "inv_lvl3bag"
  };
  --------------------------------------------------------------------------------------------
  local get_roundhandle_inv = function ()
  
    interface.InventoryItemAdd( "inv_roundhandle", "spr_complex_lvl3bag_roundhandle" );
    
    ObjMultiSet( { {"inv_lvl3bag_star_light",  { alp = 0 }},
                   {"inv_lvl3bag", { res = "assets/levels/level3/rm_apocalypse2/zz_policevan/inv_lvl3bag_2" }} } );
    
    ObjDelete( "gfx_complex_lvl3bag_roundhandle" );
    ObjDelete( "spr_complex_lvl3bag_roundhandle_shadow" );
  
  end;
  cmn.AddSubscriber( "get_roundhandle", get_roundhandle_inv );
  --------------------------------------------------------------------------------------------
  -- function get_flashlight () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_flashlight" ] = {
    type = "get",
    get_obj = "spr_complex_lvl3bag_flashlight",
    room ="int_complex_inv",
    zz = "inv_complex_lvl3bag",
    zz_gate = "inv_lvl3bag"
  };
  --------------------------------------------------------------------------------------------
  local get_flashlight_inv = function ()
  
    if cmn.IsEventDone("get_policebadge") then
      interface.InventoryItemRemove( "inv_lvl3bag" );
    end;
    
    interface.InventoryItemAdd( "inv_flashlight", "spr_complex_lvl3bag_flashlight" );
    
    ObjDelete( "gfx_complex_lvl3bag_flashlight" );
    ObjDelete( "spr_complex_lvl3bag_flashlight_shadow" );
  
  end;
  cmn.AddSubscriber( "get_flashlight", get_flashlight_inv );
  --------------------------------------------------------------------------------------------
  -- function get_policebadge () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_policebadge" ] = {
    type = "get",
    get_obj = "spr_complex_lvl3bag_policebadge",
    room ="int_complex_inv",
    zz = "inv_complex_lvl3bag",
    zz_gate = "inv_lvl3bag"
  };
  --------------------------------------------------------------------------------------------
  local get_policebadge_inv = function ()
  
    if cmn.IsEventDone("get_flashlight") then
      interface.InventoryItemRemove( "inv_lvl3bag" );
    end;
    
    interface.InventoryItemAdd( "inv_policebadge", "spr_complex_lvl3bag_policebadge" );
    
    ObjDelete( "gfx_complex_lvl3bag_policebadge" );
    ObjDelete( "spr_complex_lvl3bag_policebadge_shadow" );
  
  end;
  cmn.AddSubscriber( "get_policebadge", get_policebadge_inv );

  --------------------------------------------------------------------------------------------
  -- function use_lvl3oil () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl3oil" ] = {
    type = "use",
    inv_obj = "inv_lvl3oil",
    use_place = "obj_complex_lvl3bag_use_lvl3oil",
    room = "int_complex_inv",
    zz = "inv_complex_lvl3bag",
    zz_gate = "inv_lvl3bag"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl3oil_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl3oil" );
  
  end;
  local use_lvl3oil_beg = function ()
  
    ObjDelete( "obj_complex_lvl3bag_use_lvl3oil" );
  
  end;
  local use_lvl3oil_end = function ()

    ObjMultiSet( {
      { "anm_complex_lvl3bag_bag", { animfunc = "func_opn_bag", frame = 300 } },
      { "spr_complex_lvl3bag_flashlight", { input = true } },
      { "spr_complex_lvl3bag_policebadge", { input = true } }
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl3oil", use_lvl3oil_beg, "inv_complex_lvl3bag" );
  cmn.AddSubscriber( "use_lvl3oil", use_lvl3oil_inv );
  cmn.AddSubscriber( "use_lvl3oil", use_lvl3oil_end, "inv_complex_lvl3bag" );
  cmn.AddSubscriber( "use_lvl3oil_inv", use_lvl3oil_inv, "inv_complex_lvl3bag" );
  cmn.AddSubscriber( "use_lvl3oil_beg", use_lvl3oil_beg, "inv_complex_lvl3bag" );
  cmn.AddSubscriber( "use_lvl3oil_end", use_lvl3oil_end, "inv_complex_lvl3bag" );

  --------------------------------------------------------------------------------------------
  -- function get_stoneoflight () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_stoneoflight" ] = {
    type = "get",
    get_obj = "obj_complex_pandorasbox_stoneoflight",
    room ="int_complex_inv",
    zz = "inv_complex_pandorasbox",
    zz_gate = "inv_pandorasbox"
  };
  --------------------------------------------------------------------------------------------
  local get_stoneoflight_inv = function ()
  
    interface.InventoryItemRemove( "inv_pandorasbox" );
    interface.InventoryItemAdd( "inv_stoneoflight", "obj_complex_pandorasbox_stoneoflight" );
    
    ObjDelete( "gfx_complex_pandorasbox_stoneoflight" );
  
  end;
  cmn.AddSubscriber( "get_stoneoflight", get_stoneoflight_inv );

  --------------------------------------------------------------------------------------------
  -- function use_boxpart () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_boxpart" ] = {
    type = "use",
    inv_obj = "inv_boxpart",
    use_place = "obj_complex_pandorasbox_use_boxpart",
    room = "int_complex_inv",
    zz = "inv_complex_pandorasbox",
    zz_gate = "inv_pandorasbox"
  };
  --------------------------------------------------------------------------------------------
  local use_boxpart_inv = function ()
  
    interface.InventoryItemRemove( "inv_boxpart" );
  
  end;
  local use_boxpart_beg = function ()
  
    ObjDelete( "obj_complex_pandorasbox_use_boxpart" );
    ObjAttach("obj_complex_pandorasbox_game", "inv_complex_pandorasbox");
    ObjSet("obj_complex_pandorasbox_game",  { pos_x = 0, pos_y = -1, anim_tag = "" });
  
  end;
  local use_boxpart_end = function ()
  
    ObjSet( "obj_complex_pandorasbox_game", { input = 1 } );
    
    for i = 1, 4, 1 do
      ObjSet("spr_complex_pandorasbox_slot_"..i,  { alp = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_boxpart", use_boxpart_beg, "inv_complex_pandorasbox" );
  cmn.AddSubscriber( "use_boxpart", use_boxpart_inv );
  cmn.AddSubscriber( "use_boxpart", use_boxpart_end, "inv_complex_pandorasbox" );
  cmn.AddSubscriber( "use_boxpart_inv", use_boxpart_inv, "inv_complex_pandorasbox" );
  cmn.AddSubscriber( "use_boxpart_beg", use_boxpart_beg, "inv_complex_pandorasbox" );
  cmn.AddSubscriber( "use_boxpart_end", use_boxpart_end, "inv_complex_pandorasbox" );

  --------------------------------------------------------------------------------------------
  -- function get_sunemblem () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_sunemblem" ] = {
    type = "get",
    get_obj = "spr_complex_figurine_sunemblem",
    room ="int_complex_inv",
    zz = "inv_complex_figurine",
    zz_gate = "inv_figurine"
  };
  --------------------------------------------------------------------------------------------
  local get_sunemblem_inv = function ()
  
    interface.InventoryItemRemove( "inv_figurine" );
    interface.InventoryItemAdd( "inv_sunemblem", "spr_complex_figurine_sunemblem" );
    
    ObjDelete( "gfx_complex_figurine_sunemblem" );
    ObjDelete( "spr_complex_figurine_sunemblem_sh" );
  
  end;
  cmn.AddSubscriber( "get_sunemblem", get_sunemblem_inv );
  
  --------------------------------------------------------------------------------------------
  -- function get_hacksaw2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_hacksaw2" ] = {
    type = "get",
    get_obj = "obj_complex_hacksaw_saw",
    room ="int_complex_inv",
    zz = "inv_complex_hacksaw",
    zz_gate = "inv_hacksaw"
  };
  --------------------------------------------------------------------------------------------
  local get_hacksaw2_inv = function ()
  
    interface.InventoryItemRemove( "inv_hacksaw" );
    interface.InventoryItemAdd( "inv_hacksaw2", "obj_complex_hacksaw_saw" );
    
    ObjDelete( "gfx_complex_figurine_hacksaw2" );
  
  end;
  cmn.AddSubscriber( "get_hacksaw2", get_hacksaw2_inv );
  
  --------------------------------------------------------------------------------------------
  -- function use_sawblade () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_sawblade" ] = {
    type = "use",
    inv_obj = "inv_sawblade",
    use_place = "obj_complex_hacksaw_use_sawblade",
    room = "int_complex_inv",
    zz = "inv_complex_hacksaw",
    zz_gate = "inv_hacksaw"
  };
  --------------------------------------------------------------------------------------------
  local use_sawblade_inv = function ()
  
    interface.InventoryItemRemove( "inv_sawblade" );
    
    if not cmn.IsEventDone("get_lvl3screw") then
      ObjSet("inv_hacksaw_star_light",  { alp = 0 });
    end;
  
  end;
  local use_sawblade_beg = function ()
  
    ObjDelete( "obj_complex_hacksaw_use_sawblade" );
  
  end;
  local use_sawblade_end = function ()
    
    ObjSet("spr_complex_hacksaw_blade",  { alp = 1 });
  
    if cmn.IsEventDone("use_lvl3screw") then
      ObjDelete( "spr_complex_hacksaw_screw" );
      ObjMultiSet( { {"obj_complex_hacksaw_saw", { input = 1 }},
                     {"gfx_complex_figurine_hacksaw2", { active = 1, visible = 1 }},
                     {"anm_complex_hacksaw_screw", { frame = 300 }} } );
    else
      ObjSet("obj_complex_hacksaw_use_lvl3screw",  { input = 1 }); 
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sawblade", use_sawblade_beg, "inv_complex_hacksaw" );
  cmn.AddSubscriber( "use_sawblade", use_sawblade_inv );
  cmn.AddSubscriber( "use_sawblade", use_sawblade_end, "inv_complex_hacksaw" );
  cmn.AddSubscriber( "use_sawblade_inv", use_sawblade_inv, "inv_complex_hacksaw" );
  cmn.AddSubscriber( "use_sawblade_beg", use_sawblade_beg, "inv_complex_hacksaw" );
  cmn.AddSubscriber( "use_sawblade_end", use_sawblade_end, "inv_complex_hacksaw" );
  --------------------------------------------------------------------------------------------
  -- function use_lvl3screw () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl3screw" ] = {
    type = "use",
    inv_obj = "inv_lvl3screw",
    use_place = "obj_complex_hacksaw_use_lvl3screw",
    room = "int_complex_inv",
    zz = "inv_complex_hacksaw",
    zz_gate = "inv_hacksaw"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl3screw_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl3screw" );
    
    if not cmn.IsEventDone("get_sawblade") then
      ObjSet("inv_hacksaw_star_light",  { alp = 0 });
    end;
  
  end;
  local use_lvl3screw_beg = function ()
  
    ObjDelete( "obj_complex_hacksaw_use_lvl3screw" );
  
  end;
  local use_lvl3screw_end = function ()
    
    if cmn.IsEventDone("use_sawblade") then
      ObjDelete( "spr_complex_hacksaw_screw" );
      ObjMultiSet( { {"obj_complex_hacksaw_saw", { input = 1 }},
                     {"gfx_complex_figurine_hacksaw2", { active = 1, visible = 1 }},
                     {"anm_complex_hacksaw_screw", { frame = 300 }} } );
    else
      ObjSet("spr_complex_hacksaw_screw",  { alp = 1 }); 
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl3screw", use_lvl3screw_beg, "inv_complex_hacksaw" );
  cmn.AddSubscriber( "use_lvl3screw", use_lvl3screw_inv );
  cmn.AddSubscriber( "use_lvl3screw", use_lvl3screw_end, "inv_complex_hacksaw" );
  cmn.AddSubscriber( "use_lvl3screw_inv", use_lvl3screw_inv, "inv_complex_hacksaw" );
  cmn.AddSubscriber( "use_lvl3screw_beg", use_lvl3screw_beg, "inv_complex_hacksaw" );
  cmn.AddSubscriber( "use_lvl3screw_end", use_lvl3screw_end, "inv_complex_hacksaw" );

  --port.  fix
  if port.isPortable() == 1 then
    port.InventoryPopupInit("inventory3_hub");
    port.VideoResizeInRoom("inventory3");
  end;
  
end;
--*********************************************************************************************************************
-- function *** CLOSE FUNC *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.inv_complex_repairbox_close()

  if not cmn.IsEventDone( "get_lvl3button3" ) then
    
    cmn.SetEventDone( "get_lvl3button3" );
    cmn.CallEventHandler( "get_lvl3button3", "inv_complex_repairbox" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;
  
  if cmn.IsEventDone("use_repairamulet1") and cmn.IsEventDone("use_repairamulet2") and 
  ( not cmn.IsEventDone("get_generatorbutton") or not cmn.IsEventDone("get_lockedcard") ) then
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
    
    if not cmn.IsEventDone("get_generatorbutton") then
      cmn.SetEventDone( "get_generatorbutton" );
      cmn.CallEventHandler( "get_generatorbutton", "inv_complex_repairbox" );
    end;
    
    if not cmn.IsEventDone("get_lockedcard") then
      cmn.SetEventDone( "get_lockedcard" );
      cmn.CallEventHandler( "get_lockedcard", "inv_complex_repairbox" );
    end;
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_case_close()

  if not cmn.IsEventDone( "get_repairamulet1" ) then
    
    cmn.SetEventDone( "get_repairamulet1" );
    cmn.CallEventHandler( "get_repairamulet1", "inv_complex_case" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;
  
  if cmn.IsEventDone("use_tumbler1") and cmn.IsEventDone("use_tumbler2") and not cmn.IsEventDone("get_glove") then
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
    
    cmn.SetEventDone( "get_glove" );
    cmn.CallEventHandler( "get_glove", "inv_complex_case" );
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_jack_close()

  if not cmn.IsEventDone( "get_carkey" ) then
    
    cmn.SetEventDone( "get_carkey" );
    cmn.CallEventHandler( "get_carkey", "inv_complex_jack" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;
  
  if cmn.IsEventDone("use_jackpart1") and cmn.IsEventDone("use_jackpart2") and not cmn.IsEventDone("get_workingjack") then
    
    cmn.SetEventDone( "get_workingjack" );
    cmn.CallEventHandler( "get_workingjack", "inv_complex_jack" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_lvl3bag_close()

  if not cmn.IsEventDone( "get_roundhandle" ) then
    
    cmn.SetEventDone( "get_roundhandle" );
    cmn.CallEventHandler( "get_roundhandle", "inv_complex_lvl3bag" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;
  
  if cmn.IsEventDone("use_lvl3oil") and ( not cmn.IsEventDone("get_policebadge") or not cmn.IsEventDone("get_flashlight") ) then
    
    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
    
    if not cmn.IsEventDone("get_policebadge") then
      cmn.SetEventDone( "get_policebadge" );
      cmn.CallEventHandler( "get_policebadge", "inv_complex_lvl3bag" );
    end;
    
    if not cmn.IsEventDone("get_flashlight") then
      cmn.SetEventDone( "get_flashlight" );
      cmn.CallEventHandler( "get_flashlight", "inv_complex_lvl3bag" );
    end;
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_pandorasbox_close()

  if cmn.IsEventDone("use_boxpart") and not cmn.IsEventDone("win_pandorasbox") then
    cmn.MiniGameHide("pandorasbox");
    local loc_name = GetCurrentRoom();
    cmn.StopAllEnv("assets/levels/level3/audio/env/aud_"..loc_name.."_env");
    cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_"..loc_name.."_env");
  end;
  
  if cmn.IsEventDone("win_pandorasbox") and not cmn.IsEventDone("get_stoneoflight") then
    
    cmn.SetEventDone( "get_stoneoflight" );
    cmn.CallEventHandler( "get_stoneoflight", "inv_complex_pandorasbox" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
    
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_figurine_close()

  if not cmn.IsEventDone( "get_sunemblem" ) then
    
    cmn.SetEventDone( "get_sunemblem" );
    cmn.CallEventHandler( "get_sunemblem", "inv_complex_figurine" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  end;
  
end;
--------------------------------------------------------------------------------------------
function public.inv_complex_hacksaw_close()
  
  if cmn.IsEventDone("use_sawblade") and cmn.IsEventDone("use_lvl3screw") and not cmn.IsEventDone("get_hacksaw2") then
    
    cmn.SetEventDone( "get_hacksaw2" );
    cmn.CallEventHandler( "get_hacksaw2", "inv_complex_hacksaw" );

    cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
    
  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_repairamulet2()

  local item = "inv_repairamulet2";

  if cmn.ObjIntersectCheck( item, "obj_complex_repairbox_use_repairamulet2" ) then

    cmn.CallEventHandler( "use_repairamulet2_inv", "inv_complex_repairbox" );
    cmn.CallEventHandler( "use_repairamulet2_beg", "inv_complex_repairbox" );

    local func_after = function ()

      cmn.SetEventDone( "use_repairamulet2" );
      cmn.CallEventHandler( "use_repairamulet2_end", "inv_complex_repairbox" );

      cmn.Lock( 0 );
    
    end;

    local anm_open = function ()
      
      ObjAnimate("anm_complex_repairbox_touch", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("obj_complex_repairbox_open", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
    local anm_push = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_inv_bag_1_open");
      
      ObjAnimate( "spr_complex_repairbox_amulet_1", "scale_xy", 0, 0, anm_open,
      {
        0.0, 0, 1, 1, 
        0.15, 0, 0.9, 0.9,
        0.3, 0, 1, 1
      } );  
      
      ObjAnimate( "spr_complex_repairbox_amulet_2", "scale_xy", 0, 0, "",
      {
        0.0, 0, 1, 1, 
        0.15, 0, 0.9, 0.9,
        0.3, 0, 1, 1
      } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_inv_bag_1_insert_2");
  
    if cmn.IsEventDone("use_repairamulet1") then
      if not cmn.IsEventDone("get_lvl3button3") then
        public.get_button3();
      end;
      ObjAnimate( "spr_complex_repairbox_amulet_2", "alp", 0, 0, anm_push, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_complex_repairbox_amulet_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;
  
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_repairamulet1()

  local item = "inv_repairamulet1";

  if cmn.ObjIntersectCheck( item, "obj_complex_repairbox_use_repairamulet1" ) then

    cmn.CallEventHandler( "use_repairamulet1_inv", "inv_complex_repairbox" );
    cmn.CallEventHandler( "use_repairamulet1_beg", "inv_complex_repairbox" );

    local func_after = function ()

      cmn.SetEventDone( "use_repairamulet1" );
      cmn.CallEventHandler( "use_repairamulet1_end", "inv_complex_repairbox" );

      cmn.Lock( 0 );
    
    end;
    
    local anm_open = function ()
      
      ObjAnimate("anm_complex_repairbox_touch", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("obj_complex_repairbox_open", "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
    local anm_push = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_inv_bag_1_open");
      
      ObjAnimate( "spr_complex_repairbox_amulet_1", "scale_xy", 0, 0, anm_open,
      {
        0.0, 0, 1, 1, 
        0.15, 0, 0.9, 0.9,
        0.3, 0, 1, 1
      } );  
      
      ObjAnimate( "spr_complex_repairbox_amulet_2", "scale_xy", 0, 0, "",
      {
        0.0, 0, 1, 1, 
        0.15, 0, 0.9, 0.9,
        0.3, 0, 1, 1
      } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_inv_bag_1_insert_1");
    
    if cmn.IsEventDone("use_repairamulet2") then
      if not cmn.IsEventDone("get_lvl3button3") then
        public.get_button3();
      end;
      ObjAnimate( "spr_complex_repairbox_amulet_1", "alp", 0, 0, anm_push, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_complex_repairbox_amulet_1", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;
  
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_tumbler1()
  
  local item = "inv_tumbler1";

  if cmn.ObjIntersectCheck( item, "obj_complex_case_use_tumbler1" ) then

    cmn.CallEventHandler( "use_tumbler1_inv", "inv_complex_case" );
    cmn.CallEventHandler( "use_tumbler1_beg", "inv_complex_case" );

    local func_after = function ()

      cmn.SetEventDone( "use_tumbler1" );
      cmn.CallEventHandler( "use_tumbler1_end", "inv_complex_case" );

      cmn.Lock( 0 );
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_case_handles_opens");
      ObjMultiSet( { {"anm_complex_case_open", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_complex_case_touch", { alp = 0 }},
                     {"obj_complex_case_inside", { alp = 1 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_case_handles_1");
  
    if cmn.IsEventDone("use_tumbler2") then
      ObjAnimate( "spr_complex_case_tumbler1", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,   0.5, 0, 1 } );
    else 
      ObjAnimate("spr_complex_case_tumbler1", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_tumbler2()

  local item = "inv_tumbler2";

  if cmn.ObjIntersectCheck( item, "obj_complex_case_use_tumbler2" ) then

    cmn.CallEventHandler( "use_tumbler2_inv", "inv_complex_case" );
    cmn.CallEventHandler( "use_tumbler2_beg", "inv_complex_case" );

    local func_after = function ()

      cmn.SetEventDone( "use_tumbler2" );
      cmn.CallEventHandler( "use_tumbler2_end", "inv_complex_case" );

      cmn.Lock( 0 );
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_case_handles_opens");
      ObjMultiSet( { {"anm_complex_case_open", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_complex_case_touch", { alp = 0 }},
                     {"obj_complex_case_inside", { alp = 1 }} } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_case_handles_1");
  
    if cmn.IsEventDone("use_tumbler1") then
      ObjAnimate( "spr_complex_case_tumbler2", "alp", 0, 0, anm_open, { 0, 0, 0,   0.3, 0, 1,   0.5, 0, 1 } );
    else 
      ObjAnimate( "spr_complex_case_tumbler2", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_jackpart2()

  local item = "inv_jackpart2";

  if cmn.ObjIntersectCheck( item, "obj_complex_jack_use_jackpart2" ) then

    cmn.CallEventHandler( "use_jackpart2_inv", "inv_complex_jack" );
    cmn.CallEventHandler( "use_jackpart2_beg", "inv_complex_jack" );

    local func_after = function ()

      cmn.SetEventDone( "use_jackpart2" );
      cmn.CallEventHandler( "use_jackpart2_end", "inv_complex_jack" );

      cmn.Lock( 0 );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_inv_stuff_car_insert");
    
    ObjAnimate("obj_complex_jack_part_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_jackpart1()

  local item = "inv_jackpart1";

  if cmn.ObjIntersectCheck( item, "obj_complex_jack_use_jackpart1" ) then

    cmn.CallEventHandler( "use_jackpart1_inv", "inv_complex_jack" );
    cmn.CallEventHandler( "use_jackpart1_beg", "inv_complex_jack" );

    local func_after = function ()

      cmn.SetEventDone( "use_jackpart1" );
      cmn.CallEventHandler( "use_jackpart1_end", "inv_complex_jack" );

      cmn.Lock( 0 );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_inv_stuff_2_car_insert");
    
    ObjAnimate("obj_complex_jack_part_1", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl3oil()

  local item = "inv_lvl3oil";

  if cmn.ObjIntersectCheck( item, "obj_complex_lvl3bag_use_lvl3oil" ) then

    cmn.CallEventHandler( "use_lvl3oil_inv", "inv_complex_lvl3bag" );
    cmn.CallEventHandler( "use_lvl3oil_beg", "inv_complex_lvl3bag" );

    local func_after2 = function ()

      cmn.SetEventDone( "use_lvl3oil" );
      cmn.CallEventHandler( "use_lvl3oil_end", "inv_complex_lvl3bag" );

      cmn.Lock( 0 );
    
    end;

    local func_after = function ()
      ObjSet( "anm_complex_lvl3bag_bag", { animfunc = "func_opn_bag", endtrig = func_after2, playing = true } );
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_oli_inv_bag");
  
    ObjSet( "anm_complex_lvl3bag_bag", { animfunc = "func_use_oil", endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_boxpart()

  local item = "inv_boxpart";

  if cmn.ObjIntersectCheck( item, "obj_complex_pandorasbox_use_boxpart" ) and cmn.CheckMultiObject( "boxpart", 4 ) then

    cmn.CallEventHandler( "use_boxpart_inv", "inv_complex_pandorasbox" );
    cmn.CallEventHandler( "use_boxpart_beg", "inv_complex_pandorasbox" );

    local func_after = function ()

      cmn.SetEventDone( "use_boxpart" );
      cmn.CallEventHandler( "use_boxpart_end", "inv_complex_pandorasbox" );

      cmn.Lock( 0 );
      cmn.MiniGameShow('pandorasbox');
      private.complex_pandorasbox.DrawScene();
      cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_colored_box_env");
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_4_colored_pieces");
  
    ObjAnimate("spr_complex_pandorasbox_slot_1", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    
    ObjAnimate("spr_complex_pandorasbox_slot_2", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 0,   0.6, 0, 1 });
    
    ObjAnimate("spr_complex_pandorasbox_slot_3", "alp", 0, 0, "", { 0, 0, 0,   0.6, 0, 0,   0.9, 0, 1 });
    
    ObjAnimate("spr_complex_pandorasbox_slot_4", "alp", 0, 0, func_after, { 0, 0, 0,   0.9, 0, 0,   1.2, 0, 1,   1.5, 0, 1 });
  
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_sawblade()

  local item = "inv_sawblade";

  if cmn.ObjIntersectCheck( item, "obj_complex_hacksaw_use_sawblade" ) then

    cmn.CallEventHandler( "use_sawblade_inv", "inv_complex_hacksaw" );
    cmn.CallEventHandler( "use_sawblade_beg", "inv_complex_hacksaw" );

    local func_after = function ()

      cmn.SetEventDone( "use_sawblade" );
      cmn.CallEventHandler( "use_sawblade_end", "inv_complex_hacksaw" );

      cmn.Lock( 0 );
    
    end;
    
    local anm_screw = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_inv_insert_saw_2");
      ObjAnimate("spr_complex_hacksaw_screw", "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0 });
      ObjSet("anm_complex_hacksaw_screw",  { playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_inv_insert_saw_1");
  
    if cmn.IsEventDone("use_lvl3screw") then
      ObjAnimate( "spr_complex_hacksaw_blade", "alp", 0, 0, anm_screw, { 0, 0, 0,   0.3, 0, 1 } );
    else 
      ObjAnimate( "spr_complex_hacksaw_blade", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl3screw()

  local item = "inv_lvl3screw";

  if cmn.ObjIntersectCheck( item, "obj_complex_hacksaw_use_lvl3screw" ) then

    cmn.CallEventHandler( "use_lvl3screw_inv", "inv_complex_hacksaw" );
    cmn.CallEventHandler( "use_lvl3screw_beg", "inv_complex_hacksaw" );

    local func_after = function ()

      cmn.SetEventDone( "use_lvl3screw" );
      cmn.CallEventHandler( "use_lvl3screw_end", "inv_complex_hacksaw" );

      cmn.Lock( 0 );
    
    end;
    
    cmn.Lock( 1 );
  
    if cmn.IsEventDone("use_sawblade") then
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_inv_insert_saw_2");
      ObjSet("anm_complex_hacksaw_screw",  { playing = 1, endtrig = func_after });
    else 
      ObjAnimate( "spr_complex_hacksaw_screw", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_button3()

  cmn.SetEventDone( "get_lvl3button3" );
  cmn.CallEventHandler( "get_lvl3button3", "inv_complex_repairbox" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_generatorbutton()

  cmn.SetEventDone( "get_generatorbutton" );
  cmn.CallEventHandler( "get_generatorbutton", "inv_complex_repairbox" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_lockedcard") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_lockedcard()

  cmn.SetEventDone( "get_lockedcard" );
  cmn.CallEventHandler( "get_lockedcard", "inv_complex_repairbox" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_generatorbutton") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_repairamulet1()

  cmn.SetEventDone( "get_repairamulet1" );
  cmn.CallEventHandler( "get_repairamulet1", "inv_complex_case" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_glove()

  cmn.SetEventDone( "get_glove" );
  cmn.CallEventHandler( "get_glove", "inv_complex_case" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_carkey()

  cmn.SetEventDone( "get_carkey" );
  cmn.CallEventHandler( "get_carkey", "inv_complex_jack" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_workingjack()

  cmn.SetEventDone( "get_workingjack" );
  cmn.CallEventHandler( "get_workingjack", "inv_complex_jack" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_roundhandle()
  
  ObjSet("spr_complex_lvl3bag_roundhandle",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_roundhandle" );
  cmn.CallEventHandler( "get_roundhandle", "inv_complex_lvl3bag" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_flashlight()

  cmn.SetEventDone( "get_flashlight" );
  cmn.CallEventHandler( "get_flashlight", "inv_complex_lvl3bag" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_policebadge") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_policebadge()

  cmn.SetEventDone( "get_policebadge" );
  cmn.CallEventHandler( "get_policebadge", "inv_complex_lvl3bag" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_flashlight") then
    common_impl.HideComplexItem();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_stoneoflight()

  cmn.SetEventDone( "get_stoneoflight" );
  cmn.CallEventHandler( "get_stoneoflight", "inv_complex_pandorasbox" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_sunemblem()

  cmn.SetEventDone( "get_sunemblem" );
  cmn.CallEventHandler( "get_sunemblem", "inv_complex_figurine" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.HideComplexItem();

end;
--------------------------------------------------------------------------------------------
function public.get_hacksaw2()

  cmn.SetEventDone( "get_hacksaw2" );
  cmn.CallEventHandler( "get_hacksaw2", "inv_complex_hacksaw" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.HideComplexItem();

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************

--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.opn_case()
  
  common_impl.ShowComplexItem( 'case' );

end;
--------------------------------------------------------------------------------------------
function public.opn_pandorasbox()
  
  --for mmg
  if not( ng_global.progress[ "std" ][ "win_pandorasbox" ].state ) then
    private.complex_pandorasbox.StartConditions();
  end;
  private.complex_pandorasbox.state = ng_global.progress[ "std" ][ "win_pandorasbox" ].state;

  if cmn.IsEventDone("use_boxpart") and not cmn.IsEventDone("win_pandorasbox") then
    cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_colored_box_env");
    private.complex_pandorasbox.DrawScene();
    cmn.MiniGameShow('pandorasbox');
    private.complex_pandorasbox.CheckWin();
  end;
  
  common_impl.ShowComplexItem( 'pandorasbox' );

end;
--------------------------------------------------------------------------------------------
function public.touch_lvl3bag()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_inv_bag_oli");

  cmn.ShowBbt( "obj_complex_lvl3bag_use_lvl3oil" );
  
  ObjSet( "anm_complex_lvl3bag_bag", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_repairbox()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_inv_bag_1");
  
  cmn.ShowBbt( "obj_complex_repairbox_use_repairamulet" );
  
  ObjSet("anm_complex_repairbox_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
  ObjAnimate("spr_complex_repairbox_amulet_1", "pos_y", 0, 0, "", { 0, 0, 473,   0.15, 0, 471,   0.3, 0, 473 });
  ObjAnimate("spr_complex_repairbox_amulet_2", "pos_y", 0, 0, "", { 0, 0, 470,   0.15, 0, 468,   0.3, 0, 470 });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_case()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_inv_bag_code");
  
  cmn.ShowBbt( "obj_complex_case_use_tumbler" );
  
  ObjSet("anm_complex_case_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
  ObjAnimate("spr_complex_case_tumbler1", "pos_y", 0, 0, "", { 0, 0, 418,   0.15, 0, 415,   0.3, 0, 418 });
  ObjAnimate("spr_complex_case_tumbler2", "pos_y", 0, 0, "", { 0, 0, 468,   0.15, 0, 465,   0.3, 0, 468 });
    
end;
--------------------------------------------------------------------------------------------
function public.touch_jack()
  
  cmn.Lock(1);
  
  cmn.ShowBbt( "obj_complex_jack_use_jackpart" );
  
  if not cmn.IsEventDone("use_jackpart1") or not cmn.IsEventDone("use_jackpart2") then
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_inv_stuff_car");
  end;
  
  if not cmn.IsEventDone("use_jackpart1") then
    ObjSet("anm_complex_jack_touch_1",  { playing = 1 });
  end;
    
  if not cmn.IsEventDone("use_jackpart2") then
    ObjSet("anm_complex_jack_touch_2",  { playing = 1 });
  end;
    
  ObjSet("tmr_complex_jack_timer",  { time = 0.3, playing = 1, endtrig = function() cmn.Lock(0); end });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_pandorasbox()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_colored_box");
  
  cmn.ShowBbt( "obj_complex_pandorasbox_use_boxpart" );
  
  ObjSet("anm_complex_pandorasbox_touch",  { playing = 1, endtrig = function() cmn.Lock(0); end });
    
  local k = {1, -1, 1};
    
  for i = 1, 3, 1 do
    ObjAnimate("obj_complex_pandorasbox_circle_"..i, "ang", 0, 0, "", { 0, 0, 0,   0.15, 0, k[i]*0.2,   0.3, 0, 0 });
  end;
    
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Pandorasbox *** () end;
--*********************************************************************************************************************
--********************************************************************************************************************
private.complex_pandorasbox = {};
public.complex_pandorasbox = {};

function private.Init_Pandorasbox()
  
  private.complex_pandorasbox.speed = 6;
  private.complex_pandorasbox.sides = { 1, -1, 1 };
  private.complex_pandorasbox.buttons = { {1, 2, 3}, {2, 0, 3, 1}, {2, 2, 0, 0, 2} };
  
  private.complex_pandorasbox.active = false;
  -----------------------------------------------------------------------------------
  local win_pandorasbox = function ()

    if cmn.IsEventDone( "win_pandorasbox" ) then

      ObjSet("obj_complex_pandorasbox_open",  { alp = 1, input = 1 });
      ObjDelete( "anm_complex_pandorasbox_touch" );
      ObjDelete( "obj_complex_pandorasbox_game" );
                     
    end;

  end;

  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_pandorasbox", win_pandorasbox, "inv_complex_pandorasbox" );

end;
--********************************************************************************************************************
function private.complex_pandorasbox.StartConditions()

  ng_global.progress[ "std" ][ "win_pandorasbox" ].skip = 0;
  ng_global.progress[ "std" ][ "win_pandorasbox" ].state = { { {0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0, 0}, 0 }, { 0, 0, 0, 0 } }; --[1] - energy pos, [2] - amulets

end;
-------------------------------------------------------------------------------------
function public.complex_pandorasbox.Reset()
  
  local need_r = false;
  
  if private.complex_pandorasbox.state[1][4] > 0 then
    
    need_r = true;
    ObjAnimate("spr_complex_pandorasbox_stone_"..private.complex_pandorasbox.state[1][4], "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    
    for i = 1, #private.complex_pandorasbox.state[1]-1, 1 do
      for j = 1, #private.complex_pandorasbox.state[1][i], 1 do
        
        if private.complex_pandorasbox.state[1][i][j] == 1 then
          ObjAnimate("spr_complex_pandorasbox_part_"..i.."_"..j, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
        end;
        
      end;
    end;
    
  end;
  
  for i = 1, 4, 1 do
    
    if private.complex_pandorasbox.state[2][i] == 1 then
      need_r = true;
      ObjAnimate("spr_complex_pandorasbox_center_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("spr_complex_pandorasbox_stone_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
    end;
    
  end;
  
  if need_r then
    
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mmg_colored_box_click");
    
    private.complex_pandorasbox.StartConditions();
    private.complex_pandorasbox.state = ng_global.progress[ "std" ][ "win_pandorasbox" ].state;
    
    ObjSet("tmr_complex_pandorasbox_timer",  { time = 0.5, playing = 1, endtrig = function() private.complex_pandorasbox.CheckInput(); cmn.Lock(0); end });
    
  end;
  
end;
-------------------------------------------------------------------------------------
function public.complex_pandorasbox.Skip()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mmg_colored_box_click");
  
  ng_global.progress[ "std" ][ "win_pandorasbox" ].skip = 1;
  ng_global.progress[ "std" ][ "win_pandorasbox" ].state = { { {0, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 0, 0}, 0 }, { 1, 1, 1, 1 } };
  
  for i = 1, #private.complex_pandorasbox.state[1]-1, 1 do
    for j = 1, #private.complex_pandorasbox.state[1][i], 1 do
      
      if private.complex_pandorasbox.state[1][i][j] == 1 then
        ObjAnimate("spr_complex_pandorasbox_part_"..i.."_"..j, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      end;
      
    end;
  end;
  
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mmg_colored_box_right_click");
  
  for i = 1, 4, 1 do
    
    if private.complex_pandorasbox.state[2][i] == 0 then
      ObjAnimate("spr_complex_pandorasbox_center_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.5, 0, 1 });
      if private.complex_pandorasbox.state[1][4] ~= i then
        ObjAnimate("spr_complex_pandorasbox_stone_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      end;
    end;
    
  end;
  
  private.complex_pandorasbox.state = ng_global.progress[ "std" ][ "win_pandorasbox" ].state;
   ObjSet("tmr_complex_pandorasbox_timer",  { time = 0.5, playing = 1, endtrig = private.complex_pandorasbox.CheckWin });
  
end;
-------------------------------------------------------------------------------------
function private.complex_pandorasbox.DrawScene()
  
  if private.complex_pandorasbox.state[1][4] > 0 then
    ObjSet("spr_complex_pandorasbox_stone_"..private.complex_pandorasbox.state[1][4],  { alp = 0 });
  end;
  
  for i = 1, #private.complex_pandorasbox.state[1]-1, 1 do
    for j = 1, #private.complex_pandorasbox.state[1][i], 1 do
      
      if private.complex_pandorasbox.state[1][i][j] == 1 then
        ObjSet("spr_complex_pandorasbox_part_"..i.."_"..j,  { alp = 1 });
      else 
        ObjSet("spr_complex_pandorasbox_part_"..i.."_"..j,  { alp = 0 });
      end;
      
    end;
  end;
  
  for i = 1, 3, 1 do
    
    if private.complex_pandorasbox.state[2][i] == 1 then
      ObjMultiSet( { {"spr_complex_pandorasbox_center_"..i, { alp = 1 }},
                     {"spr_complex_pandorasbox_stone_"..i, { alp = 0 }} } );
    else 
      ObjSet("spr_complex_pandorasbox_center_"..i,  { alp = 0 });
    end;
    
  end;
  
  private.complex_pandorasbox.CheckInput();
  
  if not private.complex_pandorasbox.active then
    
    private.complex_pandorasbox.active = true;
  
    for i = 1, 3, 1 do
      private.complex_pandorasbox.RotateCircle( i, private.complex_pandorasbox.sides[i] );
    end;
    
  end;
  
end;
-------------------------------------------------------------------------------------
function private.complex_pandorasbox.RotateCircle( num, side )
  
  ObjAnimate("obj_complex_pandorasbox_circle_"..num, "ang", 1, 0, "", { 0, 0, 0,   private.complex_pandorasbox.speed, 0, 2*math.pi*side });
  
end;
------------------------------------------------------------------------------
function public.complex_pandorasbox.FocusJewell( num, inout )
  
  local obj = "spr_complex_pandorasbox_stone_"..num.."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
    if tme > 0.2 then
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mmg_colored_box_arrow_crystal");
    end;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-------------------------------------------------------------------------------------
function public.complex_pandorasbox.ClickJewell( num )
  
  local found = false;
  
  for i = 1, #private.complex_pandorasbox.state[1][3], 1 do
    
    if ObjIntersect( "spr_complex_pandorasbox_part_3_"..i, "spr_complex_pandorasbox_slot_"..num.."_arrow" ) then
      found = true;
      private.complex_pandorasbox.state[1][3][i] = 1;
      ObjAnimate("spr_complex_pandorasbox_part_3_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      break;
    end;
    
  end;
  
  if found then
    
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mmg_colored_box_click");
  
    private.complex_pandorasbox.state[1][4] = num;
  
    ObjAnimate("spr_complex_pandorasbox_stone_"..num, "alp", 0, 0, function() cmn.Lock(0); private.complex_pandorasbox.CheckInput(); end, { 0, 0, 1,   0.3, 0, 0 });
      
  end;
  
end;
-------------------------------------------------------------------------------------
function public.complex_pandorasbox.ClickPart( ring, ind )
  
  local found = {0, 0};
  local found2 = {0, 0};
  
  if private.complex_pandorasbox.state[1][ring][ind] == 1 and private.complex_pandorasbox.buttons[ring][ind] ~= 0 then
    
    if  private.complex_pandorasbox.buttons[ring][ind] == 1 and ring ~= 3 then
      
      for i = 1, #private.complex_pandorasbox.state[1][ring+1], 1 do
        
        if ObjIntersect( "spr_complex_pandorasbox_part_"..ring.."_"..ind, "spr_complex_pandorasbox_part_"..(ring+1).."_"..i ) then
          found[1] = ring+1;
          found[2] = i;
          break;
        end;
        
      end;
      
    elseif  private.complex_pandorasbox.buttons[ring][ind] == 2 and ring == 1 then
      
      if ObjIntersect( "spr_complex_pandorasbox_part_"..ring.."_"..ind, "spr_complex_pandorasbox_center" ) then
        found[1] = 4;
        found[2] = private.complex_pandorasbox.state[1][4];
      end;
      
    elseif  private.complex_pandorasbox.buttons[ring][ind] == 2 and ring ~= 1 then
      
      for i = 1, #private.complex_pandorasbox.state[1][ring-1], 1 do
        
        if ObjIntersect( "spr_complex_pandorasbox_part_"..ring.."_"..ind, "spr_complex_pandorasbox_part_"..(ring-1).."_"..i ) then
          found[1] = ring-1;
          found[2] = i;
          break;
        end;
        
      end;
      
    elseif  private.complex_pandorasbox.buttons[ring][ind] == 3 and ring == 1 then
      
      if ObjIntersect( "spr_complex_pandorasbox_part_"..ring.."_"..ind, "spr_complex_pandorasbox_center" ) then
        found[1] = 4;
        found[2] = private.complex_pandorasbox.state[1][4];
      end;
      
      for i = 1, #private.complex_pandorasbox.state[1][ring+1], 1 do
        
        if ObjIntersect( "spr_complex_pandorasbox_part_"..ring.."_"..ind, "spr_complex_pandorasbox_part_"..(ring+1).."_"..i ) then
          found2[1] = ring-1;
          found2[2] = i;
          break;
        end;
        
      end;
      
    elseif private.complex_pandorasbox.buttons[ring][ind] == 3 and ring == 2 then
      
      for i = 1, #private.complex_pandorasbox.state[1][ring+1], 1 do
        
        if ObjIntersect( "spr_complex_pandorasbox_part_"..ring.."_"..ind, "spr_complex_pandorasbox_part_"..(ring+1).."_"..i ) then
          found[1] = ring+1;
          found[2] = i;
          break;
        end;
        
      end;
      
      for i = 1, #private.complex_pandorasbox.state[1][ring-1], 1 do
        
        if ObjIntersect( "spr_complex_pandorasbox_part_"..ring.."_"..ind, "spr_complex_pandorasbox_part_"..(ring-1).."_"..i ) then
          found2[1] = ring-1;
          found2[2] = i;
          break;
        end;
        
      end;
      
    end;
         
  end;
  
  --DbgTrace("public.complex_pandorasbox.ClickPart found[1]:"..tostring(found[1]).." found[2]:"..tostring(found[2]).." found2[1]:"..tostring(found2[1]).." found2[2]:"..tostring(found[2]));
  
  if found2[1] ~= 0 then
    
      local reset = false;
      
      cmn.Lock(1);
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mmg_colored_box_click");
      
      private.complex_pandorasbox.state[1][ ring ][ ind ] = 0;
      
      local func_after = function()
        cmn.Lock(0);
        private.complex_pandorasbox.CheckInput( reset );
        private.complex_pandorasbox.CheckWin();
      end;
      
      ObjAnimate("spr_complex_pandorasbox_part_"..ring.."_"..ind, "alp", 0, 0, func_after, { 0, 0, 1,   0.3, 0, 0 });
    
      if found2[1] < 4 and private.complex_pandorasbox.state[1][ found2[1] ][ found2[2] ] == 0 then
        private.complex_pandorasbox.state[1][ found2[1] ][ found2[2] ] = 1;
        ObjAnimate("spr_complex_pandorasbox_part_"..found2[1].."_"..found2[2], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      elseif found2[1] == 4 and private.complex_pandorasbox.state[2][ found[2] ] == 0 then
        reset = true;
        private.complex_pandorasbox.state[2][ found2[2] ] = 1;
        cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mmg_colored_box_right_click");
        ObjAnimate("spr_complex_pandorasbox_center_"..found2[2], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      end; 
   elseif found[1] ~= 0 then
    
    local reset = false;
    
    cmn.Lock(1);
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mmg_colored_box_click");
    
    private.complex_pandorasbox.state[1][ ring ][ ind ] = 0;
    
    local func_after = function()
      cmn.Lock(0);
      private.complex_pandorasbox.CheckInput( reset );
      private.complex_pandorasbox.CheckWin();
    end;
    
    ObjAnimate("spr_complex_pandorasbox_part_"..ring.."_"..ind, "alp", 0, 0, func_after, { 0, 0, 1,   0.3, 0, 0 });
    
    if found[1] < 4 and private.complex_pandorasbox.state[1][ found[1] ][ found[2] ] == 0 then
      private.complex_pandorasbox.state[1][ found[1] ][ found[2] ] = 1;
      ObjAnimate("spr_complex_pandorasbox_part_"..found[1].."_"..found[2], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    elseif found[1] == 4 and private.complex_pandorasbox.state[2][ found[2] ] == 0 then
      reset = true;
      private.complex_pandorasbox.state[2][ found[2] ] = 1;
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mmg_colored_box_right_click");
      ObjAnimate("spr_complex_pandorasbox_center_"..found[2], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    end;
  end;
  
end;
-----------------------------------------------------------------------------------
function private.complex_pandorasbox.CheckInput( need_r )
  
  local count = 0;
  need_r = need_r or false;
  
  if private.complex_pandorasbox.state[1][4] == 0 then
    
    count = count + 1;
    
    for i = 1, 4, 1 do
      if private.complex_pandorasbox.state[2][i] == 0 then
        ObjSet("spr_complex_pandorasbox_stone_"..i,  { input = 1 });
      else 
        ObjSet("spr_complex_pandorasbox_stone_"..i,  { input = 0 });
      end;
    end;
    
  else

    for i = 1, 4, 1 do
      ObjSet("spr_complex_pandorasbox_stone_"..i,  { input = 0 });
    end;
    
  end;
  
  for i = 1, #private.complex_pandorasbox.state[1]-1, 1 do
    for j = 1, #private.complex_pandorasbox.state[1][i], 1 do
      
      if private.complex_pandorasbox.state[1][i][j] == 1 and private.complex_pandorasbox.buttons[i][j] ~= 0 then
        count = count + 1;
        ObjSet("spr_complex_pandorasbox_part_"..i.."_"..j,  { input = 1 });
      else 
        ObjSet("spr_complex_pandorasbox_part_"..i.."_"..j,  { input = 0 });
      end;
      
    end;
  end;
  
  local reset_func = function ()
    
    local old = private.complex_pandorasbox.state[1][4];
    private.complex_pandorasbox.state[1][4] = 0;
    
    if old > 0 and not need_r then
      ObjAnimate("spr_complex_pandorasbox_stone_"..old, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
    end;
    
    for i = 1, 4, 1 do
      if private.complex_pandorasbox.state[2][i] == 0 then
        ObjSet("spr_complex_pandorasbox_stone_"..i,  { input = 1 });
      else 
        ObjSet("spr_complex_pandorasbox_stone_"..i,  { input = 0 });
      end;
    end;
    
    for i = 1, #private.complex_pandorasbox.state[1]-1, 1 do
      for j = 1, #private.complex_pandorasbox.state[1][i], 1 do
        
        if private.complex_pandorasbox.state[1][i][j] == 1 then
          private.complex_pandorasbox.state[1][i][j] = 0;
          ObjAnimate("spr_complex_pandorasbox_part_"..i.."_"..j, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
        end;
        
      end;
    end;
    
    ObjSet("tmr_complex_pandorasbox_timer",  { time = 0.3, playing = 1, endtrig = function() cmn.Lock( 0 ); end }); 
    
  end;
  
  --dead end
  if count == 0 then
    
    cmn.Lock(1);
    
    for i = 1, #private.complex_pandorasbox.state[1]-1, 1 do
      for j = 1, #private.complex_pandorasbox.state[1][i], 1 do
        
        if private.complex_pandorasbox.state[1][i][j] == 1 then
          ObjAnimate("spr_complex_pandorasbox_part_"..i.."_"..j, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 1,   0.5, 0, 0,  0.7, 0, 1,
                                                                                  0.9, 0, 0,   1.1, 0, 1 });
        end;
        
      end;
    end;
    
    ObjSet("tmr_complex_pandorasbox_timer",  { time = 1.1, playing = 1, endtrig = reset_func });    

  elseif need_r then
    
    cmn.Lock(1);
    reset_func();
                                                                          
  end;
  
end;
-----------------------------------------------------------------------------------
function private.complex_pandorasbox.CheckWin()
  
  local win_flag = true;
  
  for i = 1, 4, 1 do
    
    if private.complex_pandorasbox.state[2][i] == 0 then
      win_flag = false;
      break;
    end;
    
  end;
  
  if win_flag then
    
    cmn.Lock(1);
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("pandorasbox");
    
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mmg_colored_box_win");
    
    ObjSet("obj_complex_pandorasbox_open",  { alp = 1 });
    ObjAnimate("anm_complex_pandorasbox_touch", "alp", 0, 0, private.complex_pandorasbox.Win_end, { 0, 0, 1,   1, 0, 1,   1.5, 0, 0 });
    ObjAnimate("obj_complex_pandorasbox_game", "alp", 0, 0, "", { 0, 0, 1,   1, 0, 1,   1.5, 0, 0 });
    
  end; 
  
end;
-----------------------------------------------------------------------------------
function private.complex_pandorasbox.Win_end()

  common_impl.PauseAchiev(0);
  
  local loc_name = GetCurrentRoom();
  cmn.StopAllEnv("assets/levels/level3/audio/env/aud_"..loc_name.."_env");
  cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_"..loc_name.."_env");

  cmn.SetEventDone( "win_pandorasbox" );
  cmn.CallEventHandler( "win_pandorasbox", "inv_complex_pandorasbox" );

  if ng_global.progress[ "std" ][ "win_pandorasbox" ].skip == 0 and ng_global.noskipgames[ "win_pandorasbox" ] == nil then

    ng_global.noskipgames[ "win_pandorasbox" ] = 1;
    common_impl.CheckAchiev("mg");

  end;

  cmn.Lock(0);

end;
--*******************************************************************************************************************