-- name=rm_apocalypse1
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_apocalypse1";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  --------------------------------------------------------------------------------------------
  -- function get_jackpart2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_jackpart2" ] = {
    type = "get",
    get_obj = "spr_oldcar_jackpart2",
    room = private.room_objname,
    zz = "zz_oldcar",
    zz_gate = "gzz_apocalypse1_oldcar"
  };
  --------------------------------------------------------------------------------------------
  local get_jackpart2_inv = function ()
  
    interface.InventoryItemAdd( "inv_jackpart2", "spr_oldcar_jackpart2" );
    ObjSet("inv_jack_star_light",  { alp = 1 });
  
  end;
  local get_jackpart2_end = function ()
  
    ObjDelete( "gfx_oldcar_jackpart2" );
    ObjDelete( "spr_oldcar_jackpart2_sh" );
    
    ObjDelete( "spr_apocalypse1_oldcar_jackpart" );
  
  end;
  
  cmn.AddSubscriber( "get_jackpart2", get_jackpart2_inv );
  cmn.AddSubscriber( "get_jackpart2", get_jackpart2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl3wrench () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl3wrench" ] = {
    type = "get",
    get_obj = "spr_oldcar_lvl3wrench",
    room = private.room_objname,
    zz = "zz_oldcar",
    zz_gate = "gzz_apocalypse1_oldcar"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl3wrench_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl3wrench", "spr_oldcar_lvl3wrench" );
  
  end;
  local get_lvl3wrench_end = function ()
  
    ObjDelete( "gfx_oldcar_lvl3wrench" );
    ObjDelete( "spr_oldcar_lvl3wrench_sh" );
    
    ObjDelete( "spr_apocalypse1_oldcar_wrench" );
  
  end;
  
  cmn.AddSubscriber( "get_lvl3wrench", get_lvl3wrench_inv );
  cmn.AddSubscriber( "get_lvl3wrench", get_lvl3wrench_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_jack () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_jack" ] = {
    type = "get",
    get_obj = "spr_debris_jack",
    room = private.room_objname,
    zz = "zz_debris",
    zz_gate = "gzz_apocalypse1_debris"
  };
  --------------------------------------------------------------------------------------------
  local get_jack_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_jack", "spr_debris_jack" );
    ObjSet("inv_jack_star_light",  { alp = 1 });
  
  end;
  local get_jack_end = function ()
  
    ObjDelete( "gfx_debris_jack" );
    ObjDelete( "spr_debris_jack_sh" );
    
    ObjDelete( "spr_apocalypse1_debris_jackpart" );
  
  end;
  
  cmn.AddSubscriber( "get_jack", get_jack_inv );
  cmn.AddSubscriber( "get_jack", get_jack_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crowbar () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_crowbar" ] = {
    type = "get",
    get_obj = "spr_debris_crowbar",
    room = private.room_objname,
    zz = "zz_debris",
    zz_gate = "gzz_apocalypse1_debris"
  };
  --------------------------------------------------------------------------------------------
  local get_crowbar_inv = function ()
  
    interface.InventoryItemAdd( "inv_crowbar", "spr_debris_crowbar" );
  
  end;
  local get_crowbar_end = function ()
  
    ObjDelete( "gfx_debris_crowbar" );
    ObjDelete( "spr_debris_crowbar_sh" );
    ObjDelete( "spr_apocalypse1_debris_crowbar" );
  
  end;
  
  cmn.AddSubscriber( "get_crowbar", get_crowbar_inv );
  cmn.AddSubscriber( "get_crowbar", get_crowbar_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_emptycan () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_emptycan" ] = {
    type = "get",
    get_obj = "spr_debris_emptycan",
    room = private.room_objname,
    zz = "zz_debris",
    zz_gate = "gzz_apocalypse1_debris"
  };
  --------------------------------------------------------------------------------------------
  local get_emptycan_inv = function ()
  
    interface.InventoryItemAdd( "inv_emptycan", "spr_debris_emptycan" );
  
  end;
  local get_emptycan_end = function ()
  
    ObjDelete( "gfx_debris_emptycan" );
    ObjDelete( "spr_debris_emptycan_sh" );
    ObjDelete( "spr_debris_emptycan_bl" );
    
    ObjDelete( "spr_apocalypse1_debris_can" );
  
  end;
  
  cmn.AddSubscriber( "get_emptycan", get_emptycan_inv );
  cmn.AddSubscriber( "get_emptycan", get_emptycan_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_canofgasoline () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_canofgasoline" ] = {
    type = "get",
    get_obj = "spr_motocycle_canofgasoline",
    room = private.room_objname,
    zz = "zz_motocycle",
    zz_gate = "gzz_apocalypse1_motocycle"
  };
  --------------------------------------------------------------------------------------------
  local get_canofgasoline_inv = function ()
  
    interface.InventoryItemAdd( "inv_canofgasoline", "spr_motocycle_canofgasoline" );
  
  end;
  local get_canofgasoline_end = function ()
  
    ObjDelete( "gfx_motocycle_canofgasoline" );
    ObjDelete( "spr_apocalypse1_moto_can" );
  
  end;
  
  cmn.AddSubscriber( "get_canofgasoline", get_canofgasoline_inv );
  cmn.AddSubscriber( "get_canofgasoline", get_canofgasoline_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_jackpart1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_jackpart1" ] = {
    type = "get",
    get_obj = "spr_motocycle_jackpart1",
    room = private.room_objname,
    zz = "zz_motocycle",
    zz_gate = "gzz_apocalypse1_motocycle"
  };
  --------------------------------------------------------------------------------------------
  local get_jackpart1_inv = function ()
  
    interface.InventoryItemAdd( "inv_jackpart1", "spr_motocycle_jackpart1" );
    ObjSet("inv_jack_star_light",  { alp = 1 });
  
  end;
  local get_jackpart1_end = function ()
  
    ObjDelete( "gfx_motocycle_jackpart1" );
    ObjDelete( "spr_motocycle_jackpart1_sh" );
    
    ObjDelete( "spr_apocalypse1_moto_jack" );
  
  end;
  
  cmn.AddSubscriber( "get_jackpart1", get_jackpart1_inv );
  cmn.AddSubscriber( "get_jackpart1", get_jackpart1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pattern3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_pattern3" ] = {
    type = "get",
    get_obj = "spr_motocycle_pattern3",
    room = private.room_objname,
    zz = "zz_motocycle",
    zz_gate = "gzz_apocalypse1_motocycle"
  };
  --------------------------------------------------------------------------------------------
  local get_pattern3_inv = function ()
  
    interface.InventoryItemAdd( "inv_pattern3", "spr_motocycle_pattern3" );
  
  end;
  local get_pattern3_end = function ()
  
    ObjDelete( "gfx_motocycle_pattern3" );
    ObjDelete( "spr_motocycle_pattern3_sh" );
    ObjDelete( "spr_apocalypse1_moto_sign" );
    
    if cmn.IsEventDone("get_lvl3oil") then
      ObjSet("gzz_apocalypse1_motocycle",  { active = 0, alp = 0 });
    end;
  
  end;
  
  cmn.AddSubscriber( "get_pattern3", get_pattern3_inv );
  cmn.AddSubscriber( "get_pattern3", get_pattern3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl3oil () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl3oil" ] = {
    type = "get",
    get_obj = "spr_motocycle_lvl3oil",
    room = private.room_objname,
    zz = "zz_motocycle",
    zz_gate = "gzz_apocalypse1_motocycle"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl3oil_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl3oil", "spr_motocycle_lvl3oil" );
    ObjSet("inv_lvl3bag_star_light",  { alp = 1 });
  
  end;
  local get_lvl3oil_end = function ()
  
    ObjDelete( "gfx_motocycle_lvl3oil" );
    ObjDelete( "anm_motocycle_use_oilcan" );

    if cmn.IsEventDone("get_pattern3") then
      ObjSet("gzz_apocalypse1_motocycle",  { active = 0, alp = 0 });
    end;
  
  end;
  
  cmn.AddSubscriber( "get_lvl3oil", get_lvl3oil_inv );
  cmn.AddSubscriber( "get_lvl3oil", get_lvl3oil_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pruners () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_pruners" ] = {
    type = "get",
    get_obj = "spr_bench_pruners",
    room = private.room_objname,
    zz = "zz_bench",
    zz_gate = "gzz_apocalypse1_bench"
  };
  --------------------------------------------------------------------------------------------
  local get_pruners_inv = function ()
  
    interface.InventoryItemAdd( "inv_pruners", "spr_bench_pruners" );
  
  end;
  local get_pruners_end = function ()
  
    ObjDelete( "gfx_bench_pruners" );
    ObjDelete( "spr_bench_pruners_sh" );
    ObjDelete( "spr_bench_pruners_bl" );
    
    ObjDelete( "spr_apocalypse1_bench_pruners" );
  
  end;
  
  cmn.AddSubscriber( "get_pruners", get_pruners_inv );
  cmn.AddSubscriber( "get_pruners", get_pruners_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hose () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_hose" ] = {
    type = "get",
    get_obj = "spr_bench_hose",
    room = private.room_objname,
    zz = "zz_bench",
    zz_gate = "gzz_apocalypse1_bench"
  };
  --------------------------------------------------------------------------------------------
  local get_hose_inv = function ()
  
    interface.InventoryItemAdd( "inv_hose", "spr_bench_hose" );
  
  end;
  local get_hose_end = function ()
  
    ObjDelete( "gfx_bench_hose" );
    ObjDelete( "spr_bench_hose_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_hose", get_hose_inv );
  cmn.AddSubscriber( "get_hose", get_hose_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_spideramulet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_spideramulet" ] = {
    type = "get",
    get_obj = "spr_bench_spideramulet",
    room = private.room_objname,
    zz = "zz_bench",
    zz_gate = "gzz_apocalypse1_bench"
  };
  --------------------------------------------------------------------------------------------
  local get_spideramulet_inv = function ()
  
    interface.InventoryItemAdd( "inv_spideramulet", "spr_bench_spideramulet" );
  
  end;
  local get_spideramulet_end = function ()
  
    ObjDelete( "gfx_bench_spideramulet" );
    ObjDelete( "spr_bench_spideramulet_sh" );
    
    ObjDelete( "spr_apocalypse1_bench_spider" );
  
  end;
  
  cmn.AddSubscriber( "get_spideramulet", get_spideramulet_inv );
  cmn.AddSubscriber( "get_spideramulet", get_spideramulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tweezers () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_tweezers" ] = {
    type = "get",
    get_obj = "spr_bench_tweezers",
    room = private.room_objname,
    zz = "zz_bench",
    zz_gate = "gzz_apocalypse1_bench"
  };
  --------------------------------------------------------------------------------------------
  local get_tweezers_inv = function ()
  
    interface.InventoryItemAdd( "inv_tweezers", "spr_bench_tweezers" );
  
  end;
  local get_tweezers_end = function ()
  
    ObjDelete( "gfx_bench_tweezers" );
    ObjDelete( "spr_bench_tweezers_sh" );
    
    ObjDelete( "spr_apocalypse1_bench_tweezers" );
  
  end;
  
  cmn.AddSubscriber( "get_tweezers", get_tweezers_inv );
  cmn.AddSubscriber( "get_tweezers", get_tweezers_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_warrior1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_warrior1" ] = {
    type = "get",
    get_obj = "spr_bench_warrior1",
    room = private.room_objname,
    zz = "zz_bench",
    zz_gate = "gzz_apocalypse1_bench"
  };
  --------------------------------------------------------------------------------------------
  local get_warrior1_inv = function ()
  
    interface.InventoryItemAdd( "inv_warrior1", "spr_bench_warrior1" );
  
  end;
  local get_warrior1_end = function ()
  
    ObjDelete( "gfx_bench_warrior1" );
    ObjDelete( "spr_bench_warrior1_sh" );
    
    ObjDelete( "spr_apocalypse1_bench_warrior" );
  
  end;
  
  cmn.AddSubscriber( "get_warrior1", get_warrior1_inv );
  cmn.AddSubscriber( "get_warrior1", get_warrior1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pandorasbox () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_pandorasbox" ] = {
    type = "get",
    get_obj = "spr_bench_pandorasbox",
    room = private.room_objname,
    zz = "zz_bench",
    zz_gate = "gzz_apocalypse1_bench"
  };
  --------------------------------------------------------------------------------------------
  local get_pandorasbox_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_pandorasbox", "spr_bench_pandorasbox" );
  
  end;
  local get_pandorasbox_end = function ()
  
    ObjDelete( "gfx_bench_pandorasbox" );
    ObjDelete( "spr_bench_pandorasbox_sh" );
    
    ObjDelete( "spr_apocalypse1_bench_pandora" );
  
  end;
  
  cmn.AddSubscriber( "get_pandorasbox", get_pandorasbox_inv );
  cmn.AddSubscriber( "get_pandorasbox", get_pandorasbox_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_zodiacsign1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_zodiacsign1" ] = {
    type = "get",
    get_obj = "spr_bench_zodiacsign5",
    room = private.room_objname,
    zz = "zz_bench",
    zz_gate = "gzz_apocalypse1_bench"
  };
  --------------------------------------------------------------------------------------------
  local get_zodiacsign1_inv = function ()
  
    interface.InventoryItemAdd( "inv_zodiacsign", "spr_bench_zodiacsign5", function () cmn.GetMultyObject( 'zodiacsign', 4 ); end );
    int_map_impl.DecreaseRoomTasks("rm_apocalypse1");
  
  end;
  local get_zodiacsign1_end = function ()
  
    ObjSet( "gzz_apocalypse1_bench", { active = false, alp = 0 } );
  
  end;
  
  cmn.AddSubscriber( "get_zodiacsign1", get_zodiacsign1_inv );
  cmn.AddSubscriber( "get_zodiacsign1", get_zodiacsign1_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_carkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_carkey" ] = {
    type = "use",
    inv_obj = "inv_carkey",
    use_place = "obj_oldcar_use_carkey",
    room = private.room_objname,
    zz = "zz_oldcar",
    zz_gate = "gzz_apocalypse1_oldcar"
  };
  --------------------------------------------------------------------------------------------
  local use_carkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_carkey" );
  
  end;
  local use_carkey_beg = function ()
  
    ObjDelete( "obj_oldcar_use_carkey" );
    ObjDelete( "anm_oldcar_door_touch" );
    ObjSet("obj_oldcar_open",  { alp = 1 });
  
  end;
  local use_carkey_end = function ()
    
    ObjDelete( "spr_apocalypse1_oldcar_cover_1" );
  
    ObjMultiSet( { {"anm_oldcar_use_key", { alp = 1, frame = 300, pos_z = -1 }},
                   {"obj_oldcar_open", { input = 1 }},
                   {"spr_apocalypse1_oldcar_cover_2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_carkey", use_carkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_carkey", use_carkey_inv );
  cmn.AddSubscriber( "use_carkey", use_carkey_end, private.room_objname );
  cmn.AddSubscriber( "use_carkey_inv", use_carkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_carkey_beg", use_carkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_carkey_end", use_carkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_canofgasoline () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_canofgasoline" ] = {
    type = "use",
    inv_obj = "inv_canofgasoline",
    use_place = "obj_oldcar_use_canofgasoline",
    room = private.room_objname,
    zz = "zz_oldcar",
    zz_gate = "gzz_apocalypse1_oldcar"
  };
  --------------------------------------------------------------------------------------------
  local use_canofgasoline_inv = function ()
  
    interface.InventoryItemRemove( "inv_canofgasoline" );
  
  end;
  local use_canofgasoline_beg = function ()
  
    ObjDelete( "obj_oldcar_use_canofgasoline" );
  
  end;
  local use_canofgasoline_end = function ()
  
    ObjMultiSet( { {"anm_oldcar_use_can", { alp = 1, frame = 300 }},
                   {"obj_oldcar_clk_oldcarhandle", { input = 1 }},
                   {"spr_apocalypse1_oldcar_cup", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_canofgasoline", use_canofgasoline_beg, private.room_objname );
  cmn.AddSubscriber( "use_canofgasoline", use_canofgasoline_inv );
  cmn.AddSubscriber( "use_canofgasoline", use_canofgasoline_end, private.room_objname );
  cmn.AddSubscriber( "use_canofgasoline_inv", use_canofgasoline_inv, private.room_objname );
  cmn.AddSubscriber( "use_canofgasoline_beg", use_canofgasoline_beg, private.room_objname );
  cmn.AddSubscriber( "use_canofgasoline_end", use_canofgasoline_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_prunersdebris () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_prunersdebris" ] = {
    type = "use",
    inv_obj = "inv_pruners",
    use_place = "obj_debris_use_pruners",
    room = private.room_objname,
    zz = "zz_debris",
    zz_gate = "gzz_apocalypse1_debris"
  };
  --------------------------------------------------------------------------------------------
  local use_pruners_inv1 = function ()
  
    if cmn.IsEventDone("use_prunersmoto") then
      interface.InventoryItemRemove( "inv_pruners" );
    end;
  
  end;
  local use_pruners_beg1 = function ()
  
    ObjDelete( "obj_debris_use_pruners" );
    ObjDelete( "anm_debris_ivy" );
    ObjSet("spr_debris_ivy_1",  { alp = 1 });
  
  end;
  local use_pruners_end1 = function ()
    
    ObjDelete( "spr_apocalypse1_debris_ivy" );
    
    ObjMultiSet( { {"anm_debris_ivy_cut", { frame = 300, alp = 1 }},
                   {"obj_debris_use_workingjack", { input = 1 }},
                   {"spr_debris_emptycan", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_prunersdebris", use_pruners_beg1, private.room_objname );
  cmn.AddSubscriber( "use_prunersdebris", use_pruners_inv1 );
  cmn.AddSubscriber( "use_prunersdebris", use_pruners_end1, private.room_objname );
  cmn.AddSubscriber( "use_pruners_inv1", use_pruners_inv1, private.room_objname );
  cmn.AddSubscriber( "use_pruners_beg1", use_pruners_beg1, private.room_objname );
  cmn.AddSubscriber( "use_pruners_end1", use_pruners_end1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_workingjack () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_workingjack" ] = {
    type = "use",
    inv_obj = "inv_workingjack",
    use_place = "obj_debris_use_workingjack",
    room = private.room_objname,
    zz = "zz_debris",
    zz_gate = "gzz_apocalypse1_debris"
  };
  --------------------------------------------------------------------------------------------
  local use_workingjack_inv = function ()
  
    interface.InventoryItemRemove( "inv_workingjack" );
  
  end;
  local use_workingjack_beg = function ()
  
    ObjDelete( "obj_debris_use_workingjack" );
    ObjDelete( "anm_debris_car_touch" );
  
  end;
  local use_workingjack_end = function ()
    
    ObjDelete( "anm_debris_use_jack" );
    ObjDelete( "obj_apocalypse1_debris_1" );
  
    ObjMultiSet( { {"anm_debris_use_hook", { alp = 1 }},
                   {"spr_debris_crowbar", { input = 1 }},
                   {"obj_apocalypse1_debris_2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_workingjack", use_workingjack_beg, private.room_objname );
  cmn.AddSubscriber( "use_workingjack", use_workingjack_inv );
  cmn.AddSubscriber( "use_workingjack", use_workingjack_end, private.room_objname );
  cmn.AddSubscriber( "use_workingjack_inv", use_workingjack_inv, private.room_objname );
  cmn.AddSubscriber( "use_workingjack_beg", use_workingjack_beg, private.room_objname );
  cmn.AddSubscriber( "use_workingjack_end", use_workingjack_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl3wrench () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl3wrench" ] = {
    type = "use",
    inv_obj = "inv_lvl3wrench",
    use_place = "obj_motocycle_use_lvl3wrench",
    room = private.room_objname,
    zz = "zz_motocycle",
    zz_gate = "gzz_apocalypse1_motocycle"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl3wrench_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl3wrench" );
  
  end;
  local use_lvl3wrench_beg = function ()
  
    ObjDelete( "obj_motocycle_use_lvl3wrench" );
  
  end;
  local use_lvl3wrench_end = function ()
    
    ObjDelete("anm_motocycle_cup_touch");
    ObjDelete("anm_motocycle_use_wrench");
    
    ObjDelete("spr_apocalypse1_moto_cup");
    
    if cmn.IsEventDone("use_hose") and cmn.IsEventDone("use_emptycan") then
      ObjDelete("obj_motocycle_emptycan");
      ObjSet( "anm_motocycle_get_gas", { input = 1, alp = 1, frame = 300 } );
    else 
      ObjMultiSet( { {"obj_motocycle_use_emptycan",  { input = 1 }},
                     {"obj_motocycle_use_hose", { input = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl3wrench", use_lvl3wrench_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl3wrench", use_lvl3wrench_inv );
  cmn.AddSubscriber( "use_lvl3wrench", use_lvl3wrench_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl3wrench_inv", use_lvl3wrench_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl3wrench_beg", use_lvl3wrench_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl3wrench_end", use_lvl3wrench_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_prunersmoto () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_prunersmoto" ] = {
    type = "use",
    inv_obj = "inv_pruners",
    use_place = "obj_motocycle_use_pruners",
    room = private.room_objname,
    zz = "zz_motocycle",
    zz_gate = "gzz_apocalypse1_motocycle"
  };
  --------------------------------------------------------------------------------------------
  local use_pruners_inv2 = function ()
  
    if cmn.IsEventDone("use_prunersdebris") then
      interface.InventoryItemRemove( "inv_pruners" );
    end;
  
  end;
  local use_pruners_beg2 = function ()
  
    ObjDelete( "obj_motocycle_use_pruners" );
    ObjDelete( "anm_motocycle_ivy" );
    ObjDelete( "anm_motocycle_ivy_touch" );
  
  end;
  local use_pruners_end2 = function ()
    
    ObjDelete( "spr_apocalypse1_moto_ivy" );
  
    ObjMultiSet( { {"spr_motocycle_jackpart1", { input = 1 }},
                   {"spr_motocycle_pattern3", { input = 1 }},
                   {"anm_motocycle_ivy_cut", { alp = 1, frame = 200 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_prunersmoto", use_pruners_beg2, private.room_objname );
  cmn.AddSubscriber( "use_prunersmoto", use_pruners_inv2 );
  cmn.AddSubscriber( "use_prunersmoto", use_pruners_end2, private.room_objname );
  cmn.AddSubscriber( "use_pruners_inv2", use_pruners_inv2, private.room_objname );
  cmn.AddSubscriber( "use_pruners_beg2", use_pruners_beg2, private.room_objname );
  cmn.AddSubscriber( "use_pruners_end2", use_pruners_end2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hose () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_hose" ] = {
    type = "use",
    inv_obj = "inv_hose",
    use_place = "obj_motocycle_use_hose",
    room = private.room_objname,
    zz = "zz_motocycle",
    zz_gate = "gzz_apocalypse1_motocycle"
  };
  --------------------------------------------------------------------------------------------
  local use_hose_inv = function ()
  
    interface.InventoryItemRemove( "inv_hose" );
  
  end;
  local use_hose_beg = function ()
  
    ObjDelete( "obj_motocycle_use_hose" );
  
  end;
  local use_hose_end = function ()
  
    if cmn.IsEventDone("use_lvl3wrench") and cmn.IsEventDone("use_emptycan") then
      ObjDelete("obj_motocycle_emptycan");
      ObjDelete("spr_apocalypse1_moto_hose");
      ObjSet( "anm_motocycle_get_gas", { input = 1, alp = 1, frame = 300 } );
    else 
      ObjMultiSet( { {"spr_motocycle_hose",  { alp = 1 }},
                     {"spr_apocalypse1_moto_hose", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hose", use_hose_beg, private.room_objname );
  cmn.AddSubscriber( "use_hose", use_hose_inv );
  cmn.AddSubscriber( "use_hose", use_hose_end, private.room_objname );
  cmn.AddSubscriber( "use_hose_inv", use_hose_inv, private.room_objname );
  cmn.AddSubscriber( "use_hose_beg", use_hose_beg, private.room_objname );
  cmn.AddSubscriber( "use_hose_end", use_hose_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_oilcan () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_oilcan" ] = {
    type = "use",
    inv_obj = "inv_oilcan",
    use_place = "obj_motocycle_use_oilcan",
    room = private.room_objname,
    zz = "zz_motocycle",
    zz_gate = "gzz_apocalypse1_motocycle"
  };
  --------------------------------------------------------------------------------------------
  local use_oilcan_inv = function ()
  
    interface.InventoryItemRemove( "inv_oilcan" );
  
  end;
  local use_oilcan_beg = function ()
  
    ObjDelete( "obj_motocycle_use_oilcan" );
  
  end;
  local use_oilcan_end = function ()
  
    --ObjSet( "spr_motocycle_lvl3oil", { input = 1, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_oilcan", use_oilcan_beg, private.room_objname );
  cmn.AddSubscriber( "use_oilcan", use_oilcan_inv );
  cmn.AddSubscriber( "use_oilcan", use_oilcan_end, private.room_objname );
  cmn.AddSubscriber( "use_oilcan_inv", use_oilcan_inv, private.room_objname );
  cmn.AddSubscriber( "use_oilcan_beg", use_oilcan_beg, private.room_objname );
  cmn.AddSubscriber( "use_oilcan_end", use_oilcan_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_emptycan () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_emptycan" ] = {
    type = "use",
    inv_obj = "inv_emptycan",
    use_place = "obj_motocycle_use_emptycan",
    room = private.room_objname,
    zz = "zz_motocycle",
    zz_gate = "gzz_apocalypse1_motocycle"
  };
  --------------------------------------------------------------------------------------------
  local use_emptycan_inv = function ()
  
    interface.InventoryItemRemove( "inv_emptycan" );
  
  end;
  local use_emptycan_beg = function ()
  
    ObjDelete( "obj_motocycle_use_emptycan" );
  
  end;
  local use_emptycan_end = function ()
    
    ObjSet("spr_apocalypse1_moto_can", { alp = 1 });
  
    if cmn.IsEventDone("use_lvl3wrench") and cmn.IsEventDone("use_hose") then
      ObjDelete("obj_motocycle_emptycan");
      ObjDelete("spr_apocalypse1_moto_hose");
      ObjSet( "anm_motocycle_get_gas", { input = 1, alp = 1, frame = 300 } );
    else 
      ObjSet("spr_motocycle_can", { alp = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_emptycan", use_emptycan_beg, private.room_objname );
  cmn.AddSubscriber( "use_emptycan", use_emptycan_inv );
  cmn.AddSubscriber( "use_emptycan", use_emptycan_end, private.room_objname );
  cmn.AddSubscriber( "use_emptycan_inv", use_emptycan_inv, private.room_objname );
  cmn.AddSubscriber( "use_emptycan_beg", use_emptycan_beg, private.room_objname );
  cmn.AddSubscriber( "use_emptycan_end", use_emptycan_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crowbar () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_crowbar" ] = {
    type = "use",
    inv_obj = "inv_crowbar",
    use_place = "obj_bench_use_crowbar",
    room = private.room_objname,
    zz = "zz_bench",
    zz_gate = "gzz_apocalypse1_bench"
  };
  --------------------------------------------------------------------------------------------
  local use_crowbar_inv = function ()
  
    interface.InventoryItemRemove( "inv_crowbar" );
  
  end;
  local use_crowbar_beg = function ()
  
    ObjDelete( "obj_bench_use_crowbar" );
    ObjDelete( "anm_bench_boards_touch" );
  
  end;
  local use_crowbar_end = function ()
  
    ObjDelete( "anm_bench_use_crowbar" );
    ObjDelete( "spr_apocalypse1_bench_boards" );
    
    ObjSet( "obj_bench_inside", { input = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crowbar", use_crowbar_beg, private.room_objname );
  cmn.AddSubscriber( "use_crowbar", use_crowbar_inv );
  cmn.AddSubscriber( "use_crowbar", use_crowbar_end, private.room_objname );
  cmn.AddSubscriber( "use_crowbar_inv", use_crowbar_inv, private.room_objname );
  cmn.AddSubscriber( "use_crowbar_beg", use_crowbar_beg, private.room_objname );
  cmn.AddSubscriber( "use_crowbar_end", use_crowbar_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_roundhandle () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_roundhandle" ] = {
    type = "use",
    inv_obj = "inv_roundhandle",
    use_place = "obj_bench_use_roundhandle",
    room = private.room_objname,
    zz = "zz_bench",
    zz_gate = "gzz_apocalypse1_bench"
  };
  --------------------------------------------------------------------------------------------
  local use_roundhandle_inv = function ()
  
    interface.InventoryItemRemove( "inv_roundhandle" );
  
  end;
  local use_roundhandle_beg = function ()
  
    ObjDelete( "obj_bench_use_roundhandle" );
    ObjDelete( "anm_bench_box_touch" );
  
  end;
  local use_roundhandle_end = function ()
    
    ObjDelete( "spr_apocalypse1_bench_box_closed" );
  
    ObjMultiSet( { {"anm_bench_box_open", { input = 1, alp = 1, frame = 300 }},
                   {"spr_apocalypse1_bench_box_open", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_roundhandle", use_roundhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_roundhandle", use_roundhandle_inv );
  cmn.AddSubscriber( "use_roundhandle", use_roundhandle_end, private.room_objname );
  cmn.AddSubscriber( "use_roundhandle_inv", use_roundhandle_inv, private.room_objname );
  cmn.AddSubscriber( "use_roundhandle_beg", use_roundhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_roundhandle_end", use_roundhandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_skullamulet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_skullamulet" ] = {
    type = "use",
    inv_obj = "inv_skullamulet",
    use_place = "obj_bench_use_skullamulet",
    room = private.room_objname,
    zz = "zz_bench",
    zz_gate = "gzz_apocalypse1_bench"
  };
  --------------------------------------------------------------------------------------------
  local use_skullamulet_inv = function ()
  
    interface.InventoryItemRemove( "inv_skullamulet" );
  
  end;
  local use_skullamulet_beg = function ()
  
    ObjDelete( "obj_bench_use_skullamulet" );
    ObjDelete( "anm_bench_skulls_touch" );
  
  end;
  local use_skullamulet_end = function ()
  
    ObjDelete( "spr_apocalypse1_bench_skull_1" );
  
    ObjMultiSet( { {"anm_bench_skull_use", { input = 1, alp = 1, frame = 300 }},
                   {"spr_apocalypse1_bench_skull_2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_skullamulet", use_skullamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_skullamulet", use_skullamulet_inv );
  cmn.AddSubscriber( "use_skullamulet", use_skullamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_skullamulet_inv", use_skullamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_skullamulet_beg", use_skullamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_skullamulet_end", use_skullamulet_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_goreseye1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_goreseye1" ] = {
    type = "use",
    inv_obj = "inv_goreseye",
    use_place = "obj_bench_use_goreseye5",
    room = private.room_objname,
    zz = "zz_bench",
    zz_gate = "gzz_apocalypse1_bench"
  };
  --------------------------------------------------------------------------------------------
  local use_goreseye1_inv = function ()
  
    if private.check_goreseye(1) then
      interface.InventoryItemRemove( "inv_goreseye" );
    end;
  
  end;
  local use_goreseye1_beg = function ()
  
    ObjDelete( "obj_bench_use_goreseye5" );
    ObjDelete( "anm_bench_zodiacsign5" );
  
  end;
  local use_goreseye1_end = function ()
  
    ObjSet( "spr_bench_zodiacsign5_glow", { alp = 1 } );
    ObjDelete( "anm_bench_use_eye" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_goreseye1", use_goreseye1_beg, private.room_objname );
  cmn.AddSubscriber( "use_goreseye1", use_goreseye1_inv );
  cmn.AddSubscriber( "use_goreseye1", use_goreseye1_end, private.room_objname );
  cmn.AddSubscriber( "use_goreseye1_inv", use_goreseye1_inv, private.room_objname );
  cmn.AddSubscriber( "use_goreseye1_beg", use_goreseye1_beg, private.room_objname );
  cmn.AddSubscriber( "use_goreseye1_end", use_goreseye1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_goreseye3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_goreseye3" ] = {
    type = "use",
    inv_obj = "inv_goreseye",
    use_place = "obj_fracture_use_goreseye7",
    room = "rm_apocalypse2",
    zz = "zz_fracture",
    zz_gate = "gzz_apocalypse2_fracture"
  };
  --------------------------------------------------------------------------------------------
  local use_goreseye3_inv = function ()
  
    if private.check_goreseye(3) then
      interface.InventoryItemRemove( "inv_goreseye" );
    end;
  
  end;
  local use_goreseye3_beg = function ()
  
    ObjDelete( "obj_fracture_use_goreseye7" );
    ObjDelete( "anm_fracture_zodiacsign7" );
  
  end;
  local use_goreseye3_end = function ()
  
    ObjSet( "spr_fracture_zodiacsign7_glow", { alp = 1 } );
    ObjDelete( "anm_fracture_use_eye" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_goreseye3", use_goreseye3_beg, "rm_apocalypse2" );
  cmn.AddSubscriber( "use_goreseye3", use_goreseye3_inv );
  cmn.AddSubscriber( "use_goreseye3", use_goreseye3_end, "rm_apocalypse2" );
  cmn.AddSubscriber( "use_goreseye3_inv", use_goreseye3_inv, "rm_apocalypse2" );
  cmn.AddSubscriber( "use_goreseye3_beg", use_goreseye3_beg, "rm_apocalypse2" );
  cmn.AddSubscriber( "use_goreseye3_end", use_goreseye3_end, "rm_apocalypse2" );
  --------------------------------------------------------------------------------------------
  -- function use_goreseye2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_goreseye2" ] = {
    type = "use",
    inv_obj = "inv_goreseye",
    use_place = "obj_oldfountain_use_goreseye8",
    room = "rm_apocalypse2",
    zz = "zz_oldfountain",
    zz_gate = "gzz_apocalypse2_oldfountain"
  };
  --------------------------------------------------------------------------------------------
  local use_goreseye2_inv = function ()
  
    if private.check_goreseye(2) then
      interface.InventoryItemRemove( "inv_goreseye" );
    end;
  
  end;
  local use_goreseye2_beg = function ()
  
    ObjDelete( "obj_oldfountain_use_goreseye8" );
    ObjDelete( "anm_oldfountain_zodiacsign8" );
  
  end;
  local use_goreseye2_end = function ()
  
    ObjSet( "spr_oldfountain_zodiacsign8_glow", { alp = 1 } );
    ObjDelete( "anm_oldfountain_use_eye" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_goreseye2", use_goreseye2_beg, "rm_apocalypse2" );
  cmn.AddSubscriber( "use_goreseye2", use_goreseye2_inv );
  cmn.AddSubscriber( "use_goreseye2", use_goreseye2_end, "rm_apocalypse2" );
  cmn.AddSubscriber( "use_goreseye2_inv", use_goreseye2_inv, "rm_apocalypse2" );
  cmn.AddSubscriber( "use_goreseye2_beg", use_goreseye2_beg, "rm_apocalypse2" );
  cmn.AddSubscriber( "use_goreseye2_end", use_goreseye2_end, "rm_apocalypse2" );
  --------------------------------------------------------------------------------------------
  -- function use_goreseye4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_goreseye4" ] = {
    type = "use",
    inv_obj = "inv_goreseye",
    use_place = "obj_sarcophagus_use_goreseye10",
    room = "rm_apocalypse3",
    zz = "zz_sarcophagus",
    zz_gate = "gzz_apocalypse3_sarcophagus"
  };
  --------------------------------------------------------------------------------------------
  local use_goreseye4_inv = function ()
  
    if private.check_goreseye(4) then
      interface.InventoryItemRemove( "inv_goreseye" );
    end;
  
  end;
  local use_goreseye4_beg = function ()
  
    ObjDelete( "obj_sarcophagus_use_goreseye10" );
    ObjDelete( "anm_sarcophagus_zodiacsign10" );
  
  end;
  local use_goreseye4_end = function ()
  
    ObjSet( "spr_sarcophagus_zodiacsign10_glow", { alp = 1 } );
    ObjDelete( "anm_sarcophagus_use_eye" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_goreseye4", use_goreseye4_beg, "rm_apocalypse3" );
  cmn.AddSubscriber( "use_goreseye4", use_goreseye4_inv );
  cmn.AddSubscriber( "use_goreseye4", use_goreseye4_end, "rm_apocalypse3" );
  cmn.AddSubscriber( "use_goreseye4_inv", use_goreseye4_inv, "rm_apocalypse3" );
  cmn.AddSubscriber( "use_goreseye4_beg", use_goreseye4_beg, "rm_apocalypse3" );
  cmn.AddSubscriber( "use_goreseye4_end", use_goreseye4_end, "rm_apocalypse3" );
  
  --------------------------------------------------------------------------------------------
  -- function clk_opencartank () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_opencartank" ] = {
    type = "click",
    use_place = "obj_oldcar_clk_opencartank",
    room = private.room_objname,
    zz = "zz_oldcar",
    zz_gate = "gzz_apocalypse1_oldcar"
  };
  --------------------------------------------------------------------------------------------
  local clk_opencartank = function ()
    
    ObjDelete("obj_oldcar_clk_opencartank");
    ObjDelete("anm_oldcar_opn_gas");
  
    ObjMultiSet( { {"obj_oldcar_use_canofgasoline",  { input = 1 }},
                   {"spr_apocalypse1_oldcar_cup", { alp = 0 }} } );
  
  end;
  cmn.AddSubscriber( "clk_opencartank", clk_opencartank, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_adjusthook () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_adjusthook" ] = {
    type = "click",
    use_place = "spr_debris_hook",
    room = private.room_objname,
    zz = "zz_debris",
    zz_gate = "gzz_apocalypse1_debris"
  };
  --------------------------------------------------------------------------------------------
  local clk_adjusthook = function ()
    
    ObjDelete( "spr_debris_hook" );
    
    ObjDelete( "gzz_apocalypse1_debris" );
    ObjDelete( "obj_apocalypse1_debris_bbt" );
    ObjDelete( "obj_apocalypse1_debris" );
    ObjDelete( "anm_apocalypse1_hook_2" );
    
    ObjMultiSet( { {"grm_apocalypse1_apocalypse2", { input = 1, alp = 1 }},
                   {"anm_apocalypse1_use_hook", { alp = 1, frame = 300 }} } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_apocalypse1_apocalypse2_focus");
    end;
  end;
  cmn.AddSubscriber( "clk_adjusthook", clk_adjusthook, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_oldcarhandle () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_oldcarhandle" ] = {
    type = "click",
    use_place = "obj_oldcar_clk_oldcarhandle",
    room = private.room_objname,
    zz = "zz_oldcar",
    zz_gate = "gzz_apocalypse1_oldcar"
  };
  --------------------------------------------------------------------------------------------
  local clk_oldcarhandle = function ()
    
    ObjDelete( "anm_apocalypse1_hook" );
    ObjDelete( "obj_oldcar_clk_oldcarhandle" );
    
    ObjDelete( "gzz_apocalypse1_oldcar" );
    
    ObjMultiSet( { {"spr_debris_hook", { input = 1, alp = 1 }},
                   {"anm_apocalypse1_hook_2", { alp = 1, frame = 300 }},
                   {"spr_apocalypse1_oldcar_light", { alp = 1 }},
                   {"spr_oldcar_handle_green", { alp = 1 }},
                   {"spr_oldcar_handle", { pos_x = 35, pos_y = -113 }} } );
    
  end;
  cmn.AddSubscriber( "clk_oldcarhandle", clk_oldcarhandle, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_apocalypse1 () end;
  --------------------------------------------------------------------------------------------
  local opn_apocalypse1 = function ()
  
    int_map_impl.OpenRoom( "rm_apocalypse1" );
    int_map_impl.BlockRoom( "rm_office" );
    int_map_impl.BlockRoom( "rm_laboratory" );
    int_map_impl.BlockRoom( "rm_debughall" );
    interface_impl.SetCurrentGlobalTask( 16 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_apocalypse1", opn_apocalypse1 );
  --------------------------------------------------------------------------------------------
  -- function opn_debris () end;
  --------------------------------------------------------------------------------------------
  local opn_debris = function ()
  
    ObjDelete("vid_debris_deer");
    ObjDelete("anm_apocalypse1_deer");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_debris", opn_debris, private.room_objname );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_debris" );
  subroom.Define( "zz_motocycle" );
  subroom.Define( "zz_bench" );
  subroom.Define( "zz_oldcar" );
  
  function zz_motocycle.PreOpen()
    
    cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_zz_motocycle_env");
    
  end;
  
  function zz_motocycle.PreClose()
    
    cmn.StopAllEnv("assets/levels/level3/audio/env/aud_rm_apocalypse1_env");
    cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_apocalypse1_env");
    
  end;

  function zz_motocycle.Close()
    cmn.HideNote( 0 );
  end;
  
  function zz_bench.PreOpen()
    
    if (cmn.IsEventDone("get_goreseye")) and not(cmn.IsEventDone("use_goreseye1")) then

      ObjAnimate( "inv_goreseye", "pos_xy", 1, 0, "",
      { 
        0.0, 0,  0, 0,
        0.1, 0,  3, -2,
        0.2, 0, -3, -4,
        0.3, 0,  3, -6,
        0.4, 0, -3, -8,
        0.5, 0,  0, -10,
        0.6, 0,  3, -8,
        0.7, 0, -3, -6,
        0.8, 0,  3, -4,
        0.9, 0, -3, -2,
        1.0, 0,  0, 0
      } );

      --ObjSet("inv_goreseye_fx", { active = 1, visible = 1 } );

      int_inventory_impl.ShowAnim( "show" );

    end;
    
  end;
  
  function zz_bench.PreClose()
    
    if (cmn.IsEventDone("get_goreseye")) and not(cmn.IsEventDone("use_goreseye1")) then
      ObjStopAnimate( "inv_goreseye", "pos_xy" );
      ObjMultiSet( { {"inv_goreseye", { pos_x = 0, pos_y = 0 }},
                     {"inv_goreseye_fx", { active = 0, visible = 0 }} } );
    end;
    
  end;
  
  function zz_bench.Close()
    cmn.HideNote( 0 );
  end;
  
  function zz_debris.PreOpen()
    
    if not cmn.IsEventDone("opn_debris") then
      cmn.Lock( 1 );
    end;
    
  end;
  
  function zz_debris.Open()
    
    if not cmn.IsEventDone("opn_debris") then
      
      local func_after = function ()

        cmn.Lock( 0 );
        cmn.CallEventHandler( "opn_debris" );
        
        cmn.ShowBbt( "debris_after_jumpscare" );
        
      end;
      
      local func_hide = function ()
        ObjAnimate("vid_debris_deer", "alp", 0, 0, func_after, { 0, 0, 1,   0.3, 0, 0 });
      end;
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_fawn_killer");
      cmn.SetEventDone( "opn_debris" );
      VidPlay("vid_debris_deer", func_hide);
      
    end;
    
  end;
  
  function zz_debris.Close()
    
    if cmn.IsEventDone("clk_adjusthook") and not cmn.IsEventDone("opn_apocalypse1hook") then
      
      local func_after = function ()

        cmn.Lock( 0 );
        cmn.CallEventHandler( "clk_adjusthook" );
        
        cmn.ShowBbt( "apocalypse1_after_debris" );
        
      end;
      
      cmn.SetEventDone( "opn_apocalypse1hook" );
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_pull_up_cars_loc");
      ObjSet("anm_apocalypse1_use_hook",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;
    
  end;
  
  function zz_oldcar.Close()
    
    if cmn.IsEventDone("clk_oldcarhandle") and not cmn.IsEventDone("opn_apocalypse1hook2") then
      
      local func_after = function ()

        cmn.Lock( 0 );
        cmn.CallEventHandler( "clk_oldcarhandle" );
        
      end;
      
      cmn.SetEventDone( "opn_apocalypse1hook2" );
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_loc_car_pickup");
      ObjSet("anm_apocalypse1_hook_2",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_apocalypse1();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level3/audio/env/aud_rm_apocalypse1_env");
  cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_apocalypse1_env");
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_carkey()

  local item = "inv_carkey";

  if cmn.ApplyObj( item, "gzz_apocalypse1_oldcar" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_oldcar" );

  elseif ( cmn.ApplyObj( item, "obj_oldcar_use_carkey" ) ) then

    cmn.CallEventHandler( "use_carkey_inv" );
    cmn.CallEventHandler( "use_carkey_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_carkey" );
      cmn.CallEventHandler( "use_carkey_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_key_safe_opens");

    ObjSet("anm_oldcar_use_key",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_canofgasoline()

  local item = "inv_canofgasoline";

  if cmn.ApplyObj( item, "gzz_apocalypse1_oldcar" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_oldcar" );

  elseif ( cmn.ApplyObj( item, "obj_oldcar_use_canofgasoline" ) ) then

    cmn.CallEventHandler( "use_canofgasoline_inv" );
    
    if cmn.IsEventDone("clk_opencartank") then
      private.use_canofgasoline_end();
    else 
      public.clk_opencartank(2);
    end;
    
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function private.use_canofgasoline_end()

  cmn.CallEventHandler( "use_canofgasoline_beg" );

  local func_after = function ()

    cmn.Lock( 0 );

    cmn.SetEventDone( "use_canofgasoline" );
    cmn.CallEventHandler( "use_canofgasoline_end" );
    
  end;

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_leave_gasoline_red");

  ObjSet("anm_oldcar_use_can",  { alp = 1, playing = 1, endtrig = func_after });

end;
--------------------------------------------------------------------------------------------
function public.use_pruners()

  local item = "inv_pruners";

  if cmn.ApplyObj( item, "gzz_apocalypse1_debris" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_debris" );

  elseif ( cmn.ApplyObj( item, "obj_debris_use_pruners" ) ) then

    cmn.CallEventHandler( "use_pruners_inv1" );
    cmn.CallEventHandler( "use_pruners_beg1" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_prunersdebris" );
      cmn.CallEventHandler( "use_pruners_end1" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_cut_leaves_zz_debris");

    ObjSet( "anm_debris_ivy_cut", { alp = 1, playing = 1, endtrig = func_after } );
    
  elseif cmn.ApplyObj( item, "gzz_apocalypse1_motocycle" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_motocycle", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_motocycle_use_pruners" ) ) then

    cmn.CallEventHandler( "use_pruners_inv2" );
    cmn.CallEventHandler( "use_pruners_beg2" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_prunersmoto" );
      cmn.CallEventHandler( "use_pruners_end2" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_cut_leaves_zz_motocycle");

    ObjSet("anm_motocycle_ivy_cut",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_workingjack()

  local item = "inv_workingjack";

  if cmn.ApplyObj( item, "gzz_apocalypse1_debris" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_debris" );

  elseif ( cmn.ApplyObj( item, "obj_debris_use_workingjack" ) and cmn.IsEventDone("use_prunersdebris") ) then

    cmn.CallEventHandler( "use_workingjack_inv" );
    cmn.CallEventHandler( "use_workingjack_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_workingjack" );
      cmn.CallEventHandler( "use_workingjack_end" );
    
    end;
    
    if not cmn.IsEventDone("get_emptycan") then
      public.get_emptycan();
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_put_up_car");

    ObjSet("anm_debris_use_jack",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl3wrench()

  local item = "inv_lvl3wrench";

  if cmn.ApplyObj( item, "gzz_apocalypse1_motocycle" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_motocycle", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_motocycle_use_lvl3wrench" ) ) then

    cmn.CallEventHandler( "use_lvl3wrench_inv" );
    cmn.CallEventHandler( "use_lvl3wrench_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl3wrench" );
      cmn.CallEventHandler( "use_lvl3wrench_end" );
    
    end;
    
    local anm_gasoline = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_take_gasoline_red");
      
      ObjDelete("obj_motocycle_emptycan");
      
      ObjSet("anm_motocycle_get_gas",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;
    
    local anm_wrench = function ()
      
      ObjDelete("anm_motocycle_cup_touch");
      
      if cmn.IsEventDone("use_hose") and cmn.IsEventDone("use_emptycan") then
        ObjSet("anm_motocycle_use_wrench",  { alp = 1, playing = 1, endtrig = anm_gasoline });
      else 
        ObjSet("anm_motocycle_use_wrench",  { alp = 1, playing = 1, endtrig = func_after });
      end;
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_screw_handle_moto");
    
    ObjAnimate( "obj_motocycle_cup_wrench", "alp", 0, 0, anm_wrench, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_hose()

  local item = "inv_hose";

  if cmn.ApplyObj( item, "gzz_apocalypse1_motocycle" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_motocycle", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_motocycle_use_hose" ) or cmn.ApplyObj( item, "spr_motocycle_can" ) ) then

    cmn.CallEventHandler( "use_hose_inv" );
    cmn.CallEventHandler( "use_hose_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_hose" );
      cmn.CallEventHandler( "use_hose_end" );
    
    end;
    
    local anm_gasoline = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_take_gasoline_red");
      
      ObjDelete("obj_motocycle_emptycan");
      
      ObjSet("anm_motocycle_get_gas",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );

    if cmn.IsEventDone("use_emptycan") and cmn.IsEventDone("use_lvl3wrench") then
      ObjAnimate( "spr_motocycle_hose", "alp", 0, 0, anm_gasoline, { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_motocycle_hose", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_oilcan()

  local item = "inv_oilcan";

  if cmn.ApplyObj( item, "gzz_apocalypse1_motocycle" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_motocycle", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_motocycle_use_oilcan" ) ) then

    cmn.CallEventHandler( "use_oilcan_inv" );
    cmn.CallEventHandler( "use_oilcan_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_oilcan" );
      cmn.CallEventHandler( "use_oilcan_end" );
      
      public.get_lvl3oil();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_take_oli_moto");

    ObjSet("anm_motocycle_use_oilcan",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_emptycan()

  local item = "inv_emptycan";

  if cmn.ApplyObj( item, "gzz_apocalypse1_motocycle" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_motocycle", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_motocycle_use_emptycan" ) or cmn.ApplyObj( item, "spr_motocycle_can" ) ) then

    cmn.CallEventHandler( "use_emptycan_inv" );
    cmn.CallEventHandler( "use_emptycan_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_emptycan" );
      cmn.CallEventHandler( "use_emptycan_end" );
    
    end;

    local anm_gasoline = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_take_gasoline_red");
      
      ObjDelete("obj_motocycle_emptycan");
      
      ObjSet("anm_motocycle_get_gas",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );

    if cmn.IsEventDone("use_hose") and cmn.IsEventDone("use_lvl3wrench") then
      ObjAnimate( "spr_motocycle_can", "alp", 0, 0, anm_gasoline, { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_motocycle_can", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_crowbar()

  local item = "inv_crowbar";

  if cmn.ApplyObj( item, "gzz_apocalypse1_bench" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_bench", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_bench_use_crowbar" ) ) then

    cmn.CallEventHandler( "use_crowbar_inv" );
    cmn.CallEventHandler( "use_crowbar_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_crowbar" );
      cmn.CallEventHandler( "use_crowbar_end" );
    
    end;
    
    local anm_alp = function ()
      ObjAnimate("anm_bench_use_crowbar", "alp", 0, 0, func_after, { 0, 0, 1,   0.3, 0, 0 });
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_leave_woods");
    
    if not cmn.IsEventDone("get_pruners") then
      public.get_pruners();
    end;

    ObjSet("anm_bench_use_crowbar",  { alp = 1, playing = 1, endtrig = anm_alp });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_roundhandle()

  local item = "inv_roundhandle";

  if cmn.ApplyObj( item, "gzz_apocalypse1_bench" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_bench", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_bench_use_roundhandle" ) and cmn.IsEventDone("use_crowbar") ) then

    cmn.CallEventHandler( "use_roundhandle_inv" );
    cmn.CallEventHandler( "use_roundhandle_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_roundhandle" );
      cmn.CallEventHandler( "use_roundhandle_end" );
    
    end;
    
    if not cmn.IsEventDone("get_pandorasbox") then
      public.get_pandorasbox();
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_open_box_zz_bench");

    ObjSet("anm_bench_box_open",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_skullamulet()

  local item = "inv_skullamulet";

  if cmn.ApplyObj( item, "gzz_apocalypse1_bench" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_bench", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_bench_use_skullamulet" ) and cmn.IsEventDone("use_crowbar") ) then

    cmn.CallEventHandler( "use_skullamulet_inv" );
    cmn.CallEventHandler( "use_skullamulet_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_skullamulet" );
      cmn.CallEventHandler( "use_skullamulet_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_missed_skull");

    ObjSet("anm_bench_skull_use",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_goreseye()

  local item = "inv_goreseye";

  if cmn.ApplyObj( item, "gzz_apocalypse1_bench" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_bench", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_bench_use_goreseye5" ) ) then

    cmn.CallEventHandler( "use_goreseye1_inv" );
    cmn.CallEventHandler( "use_goreseye1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_goreseye1" );
      cmn.CallEventHandler( "use_goreseye1_end" );
      
      public.get_zodiacsign5();
    
    end;
    
    ObjStopAnimate( "inv_goreseye", "pos_xy" );
    ObjMultiSet( { {"inv_goreseye", { pos_x = 0, pos_y = 0 }},
                   {"inv_goreseye_fx", { active = 0, visible = 0 }} } );

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_use_12_pieces_amulet");

    ObjMultiSet( { {"anm_bench_use_eye", { alp = 1, playing = 1, endtrig = func_after }},
                   {"spr_bench_zodiacsign5", { alp = 0 }} } );
    
  elseif cmn.ApplyObj( item, "gzz_apocalypse2_fracture" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_fracture" );

  elseif ( cmn.ApplyObj( item, "obj_fracture_use_goreseye7" ) ) then

    cmn.CallEventHandler( "use_goreseye3_inv" );
    cmn.CallEventHandler( "use_goreseye3_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_goreseye3" );
      cmn.CallEventHandler( "use_goreseye3_end" );
      
      rm_apocalypse2.get_zodiacsign7();
    
    end;
    
    ObjStopAnimate( "inv_goreseye", "pos_xy" );
    ObjMultiSet( { {"inv_goreseye", { pos_x = 0, pos_y = 0 }},
                   {"inv_goreseye_fx", { active = 0, visible = 0 }} } );

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_use_12_pieces_amulet");

    ObjMultiSet( { {"anm_fracture_use_eye", { alp = 1, playing = 1, endtrig = func_after }},
                   {"spr_fracture_zodiacsign7", { alp = 0 }} } );

  elseif cmn.ApplyObj( item, "gzz_apocalypse2_oldfountain" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_oldfountain" );

  elseif ( cmn.ApplyObj( item, "obj_oldfountain_use_goreseye8" ) ) then

    cmn.CallEventHandler( "use_goreseye2_inv" );
    cmn.CallEventHandler( "use_goreseye2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_goreseye2" );
      cmn.CallEventHandler( "use_goreseye2_end" );
      
      rm_apocalypse2.get_zodiacsign8();
    
    end;
    
    ObjStopAnimate( "inv_goreseye", "pos_xy" );
    ObjMultiSet( { {"inv_goreseye", { pos_x = 0, pos_y = 0 }},
                   {"inv_goreseye_fx", { active = 0, visible = 0 }} } );

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_use_12_pieces_amulet");

    ObjMultiSet( { {"anm_oldfountain_use_eye", { alp = 1, playing = 1, endtrig = func_after }},
                   {"spr_oldfountain_zodiacsign8", { alp = 0 }} } );

  elseif cmn.ApplyObj( item, "gzz_apocalypse2_policevan" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_policevan", false, false, true );

  elseif cmn.ApplyObj( item, "gzz_apocalypse3_sarcophagus" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_sarcophagus", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_sarcophagus_use_goreseye10" ) ) then

    cmn.CallEventHandler( "use_goreseye4_inv" );
    cmn.CallEventHandler( "use_goreseye4_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_goreseye4" );
      cmn.CallEventHandler( "use_goreseye4_end" );
      
      rm_apocalypse3.get_zodiacsign10();
    
    end;
    
    ObjStopAnimate( "inv_goreseye", "pos_xy" );
    ObjMultiSet( { {"inv_goreseye", { pos_x = 0, pos_y = 0 }},
                   {"inv_goreseye_fx", { active = 0, visible = 0 }} } );

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_use_12_pieces_amulet");

    ObjMultiSet( { {"anm_sarcophagus_use_eye", { alp = 1, playing = 1, endtrig = func_after }},
                   {"spr_sarcophagus_zodiacsign10", { alp = 0 }} } );

  
  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_jackpart2()

  cmn.SetEventDone( "get_jackpart2" );
  cmn.CallEventHandler( "get_jackpart2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_lvl3wrench()

  cmn.SetEventDone( "get_lvl3wrench" );
  cmn.CallEventHandler( "get_lvl3wrench" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_jackpart1()

  cmn.SetEventDone( "get_jackpart1" );
  cmn.CallEventHandler( "get_jackpart1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_crowbar()

  cmn.SetEventDone( "get_crowbar" );
  cmn.CallEventHandler( "get_crowbar" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_emptycan()

  cmn.SetEventDone( "get_emptycan" );
  cmn.CallEventHandler( "get_emptycan" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_canofgasoline()
  
  ObjSet("spr_motocycle_canofgasoline",  { ang = 0.2036 });

  cmn.SetEventDone( "get_canofgasoline" );
  cmn.CallEventHandler( "get_canofgasoline" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_jack()

  cmn.SetEventDone( "get_jack" );
  cmn.CallEventHandler( "get_jack" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_pattern3()

  cmn.SetEventDone( "get_pattern3" );
  cmn.CallEventHandler( "get_pattern3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_lvl3oil") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_lvl3oil()
  
  ObjMultiSet( { {"spr_motocycle_lvl3oil",  { ang = -0.1231 }},
                 {"spr_motocycle_lvl3oil_2", { alp = 1 }},
                 {"spr_motocycle_lvl3oil_3", { alp = 1 }} } );

  cmn.SetEventDone( "get_lvl3oil" );
  cmn.CallEventHandler( "get_lvl3oil" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_pattern3") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_pruners()

  cmn.SetEventDone( "get_pruners" );
  cmn.CallEventHandler( "get_pruners" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_hose()

  cmn.SetEventDone( "get_hose" );
  cmn.CallEventHandler( "get_hose" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_spideramulet()
  
  ObjSet("spr_bench_spideramulet",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_spideramulet" );
  cmn.CallEventHandler( "get_spideramulet" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_tweezers()

  cmn.SetEventDone( "get_tweezers" );
  cmn.CallEventHandler( "get_tweezers" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_warrior1()

  cmn.SetEventDone( "get_warrior1" );
  cmn.CallEventHandler( "get_warrior1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_pandorasbox()

  cmn.SetEventDone( "get_pandorasbox" );
  cmn.CallEventHandler( "get_pandorasbox" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_zodiacsign5()
  
  ObjSet( "spr_bench_zodiacsign5", { alp = 1 } );

  cmn.SetEventDone( "get_zodiacsign1" );
  cmn.CallEventHandler( "get_zodiacsign1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_opencartank( num )
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_click_zz_oldcar_unscrew");

  local func_after = function ()

    cmn.SetEventDone( "clk_opencartank" );
    cmn.CallEventHandler( "clk_opencartank" );

    if num == 1 then
      cmn.Lock(0);
    else 
      private.use_canofgasoline_end();
    end;
    
  end;
  
  ObjSet("anm_oldcar_opn_gas",  { alp = 1, playing = 1, endtrig = func_after });
  
end;
--------------------------------------------------------------------------------------------
function public.clk_adjusthook()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_pull_up_cars");

  local func_after = function ()

    cmn.SetEventDone( "clk_adjusthook" );
    
    ObjDelete( "gzz_apocalypse1_debris" );
    
    ObjMultiSet( { {"anm_apocalypse1_use_hook", { alp = 1 }},
                   {"obj_apocalypse1_debris", { alp = 0 }},
                   {"anm_apocalypse1_hook_2", { alp = 0 }} } );

    common.CloseSubRoom();
    
  end;
  
  ObjSet("anm_debris_use_hook",  { alp = 1, playing = 1, endtrig = func_after });
  ObjAnimate("spr_debris_hook", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
end;
--------------------------------------------------------------------------------------------
function public.clk_oldcarhandle()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_click_handle_gasoline");

  local func_after = function ()

    cmn.SetEventDone( "clk_oldcarhandle" );
    
    ObjMultiSet( { {"anm_apocalypse1_hook_2", { alp = 1 }},
                   {"anm_apocalypse1_hook", { alp = 0 }} } );


    common.CloseSubRoom();
    
  end;
  
  local anm_light = function ()
    ObjAnimate("spr_oldcar_handle_green", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });
  end;
  
  ObjAnimate("spr_oldcar_handle", "pos_xy", 0, 0, anm_light, { 0, 0, 68, -11,   0.5, 0, 35, -113 });
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_apocalypse1()

  if not ( cmn.IsEventDone( "opn_apocalypse1" ) ) then
    cmn.SetEventDone( "opn_apocalypse1" );
    cmn.CallEventHandler("opn_apocalypse1");
    cmn.ShowBbt( "apocalypse1_open" );
    interface_impl.ShowGlobalTask();
    int_diary.AddDiarypage( 19 );
    cmn.PlayAudio("mus", "assets/levels/level1/audio/mus/aud_first_appear_mus", 0, false, 76);
  end;

end;
--------------------------------------------------------------------------------------------
function private.check_goreseye( num )

  local check = true;
  
  for i = 1, 4, 1 do
    
    if i ~= num and not cmn.IsEventDone("use_goreseye"..i) then
      check = false;
      break;
    end;
    
  end;
  
  return check;

end;
--------------------------------------------------------------------------------------------
function public.touch_car_door()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_metal_safe");

  cmn.ShowBbt( "obj_oldcar_use_carkey" );
  
  ObjSet( "anm_oldcar_door_touch", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_moto_tank()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_handle_zz_motocycle");

  cmn.ShowBbt( "obj_motocycle_use_lvl3wrench" );
  
  ObjSet( "anm_motocycle_cup_touch", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_moto_ivy()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_leaves_zz_motocycle");
  
  local func_after = function ()
    
    cmn.Lock( 0 );
    
    ObjMultiSet( { {"anm_motocycle_ivy_touch", { alp = 0 }},
                   {"anm_motocycle_ivy", { alp = 1, playing = 1 }} } );
    
  end;

  cmn.ShowBbt( "obj_motocycle_use_pruners" );
  
  ObjMultiSet( { {"anm_motocycle_ivy_touch", { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_motocycle_ivy", { alp = 0, playing = 0, frame = 0 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_bench_boards()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_woods_zz_bench");

  cmn.ShowBbt( "obj_bench_use_crowbar" );
  
  ObjSet( "anm_bench_boards_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
    
  if not cmn.IsEventDone("get_pruners") then
    public.get_pruners();
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_bench_skulls()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_turtle");

  cmn.ShowBbt( "obj_bench_use_skullamulet" );
  
  ObjSet( "anm_bench_skulls_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_bench_box()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_bag_zz_bench");

  cmn.ShowBbt( "obj_bench_use_roundhandle" );
  
  ObjSet( "anm_bench_box_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
    
  if not cmn.IsEventDone("get_pandorasbox") then
    public.get_pandorasbox();
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_debris_ivy()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_leaves_zz_debris");
  
  local func_after = function ()
    
    cmn.Lock(0);
    ObjSet( "anm_debris_ivy", { frame = 0, animfunc = "func_anm_ivy", playing = 1, endtrig = "" } );
    
  end;

  cmn.ShowBbt( "obj_debris_use_pruners" );
  
  ObjSet( "anm_debris_ivy", { frame = 0, animfunc = "func_clk_ivy", playing = 1, endtrig = func_after } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_debris_car()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_car_broken");

  cmn.ShowBbt( "obj_debris_use_workingjack" );
  
  if not cmn.IsEventDone("get_emptycan") then
    public.get_emptycan();
  end;
  
  ObjSet( "anm_debris_car_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--*********************************************************************************************************************