-- name=rm_apocalypse2
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_apocalypse2";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Fracture();
  --------------------------------------------------------------------------------------------
  -- function get_diamond () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_diamond" ] = {
    type = "get",
    get_obj = "spr_fracture_diamond",
    room = private.room_objname,
    zz = "zz_fracture",
    zz_gate = "gzz_apocalypse2_fracture"
  };
  --------------------------------------------------------------------------------------------
  local get_diamond_inv = function ()
  
    interface.InventoryItemAdd( "inv_diamond", "spr_fracture_diamond" );
  
  end;
  local get_diamond_end = function ()
  
    ObjDelete( "gfx_fracture_diamond" );
    ObjDelete( "spr_fracture_diamond_sh" );

    ObjDelete( "spr_apocalypse2_fracture_diamond" );
  
  end;
  
  cmn.AddSubscriber( "get_diamond", get_diamond_inv );
  cmn.AddSubscriber( "get_diamond", get_diamond_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_museumheart () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_museumheart" ] = {
    type = "get",
    get_obj = "spr_fracture_museumheart",
    room = private.room_objname,
    zz = "zz_fracture",
    zz_gate = "gzz_apocalypse2_fracture"
  };
  --------------------------------------------------------------------------------------------
  local get_museumheart_inv = function ()
  
    interface.InventoryItemAdd( "inv_museumheart", "spr_fracture_museumheart" );
  
  end;
  local get_museumheart_end = function ()
  
    ObjDelete( "gfx_fracture_museumheart" );
    ObjDelete( "spr_fracture_museumheart_sh" );

    ObjDelete( "spr_apocalypse2_fracture_rune_light" );
  
  end;
  
  cmn.AddSubscriber( "get_museumheart", get_museumheart_inv );
  cmn.AddSubscriber( "get_museumheart", get_museumheart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mask2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_mask2" ] = {
    type = "get",
    get_obj = "spr_fracture_mask2",
    room = private.room_objname,
    zz = "zz_fracture",
    zz_gate = "gzz_apocalypse2_fracture"
  };
  --------------------------------------------------------------------------------------------
  local get_mask2_inv = function ()
  
    interface.InventoryItemAdd( "inv_mask2", "spr_fracture_mask2" );
  
  end;
  local get_mask2_end = function ()
  
    ObjDelete( "gfx_fracture_mask2" );
    ObjDelete( "spr_fracture_mask2_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_mask2", get_mask2_inv );
  cmn.AddSubscriber( "get_mask2", get_mask2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_zodiacsign3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_zodiacsign3" ] = {
    type = "get",
    get_obj = "spr_fracture_zodiacsign7",
    room = private.room_objname,
    zz = "zz_fracture",
    zz_gate = "gzz_apocalypse2_fracture"
  };
  --------------------------------------------------------------------------------------------
  local get_zodiacsign3_inv = function ()
  
    interface.InventoryItemAdd( "inv_zodiacsign", "spr_fracture_zodiacsign7", function () cmn.GetMultyObject( 'zodiacsign', 4 ); end );
    int_map_impl.DecreaseRoomTasks("rm_apocalypse2");
  
  end;
  local get_zodiacsign3_end = function ()
  
    ObjDelete( "gzz_apocalypse2_fracture" );
  
  end;
  
  cmn.AddSubscriber( "get_zodiacsign3", get_zodiacsign3_inv );
  cmn.AddSubscriber( "get_zodiacsign3", get_zodiacsign3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bowlofwater () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_bowlofwater" ] = {
    type = "get",
    get_obj = "spr_oldfountain_bowlofwater",
    room = private.room_objname,
    zz = "zz_oldfountain",
    zz_gate = "gzz_apocalypse2_oldfountain"
  };
  --------------------------------------------------------------------------------------------
  local get_bowlofwater_inv = function ()
  
    interface.InventoryItemAdd( "inv_bowlofwater", "spr_oldfountain_bowlofwater" );
  
  end;
  local get_bowlofwater_end = function ()
  
    ObjDelete( "gfx_oldfountain_bowlofwater" );
    ObjDelete( "anm_oldfountain_use_bowl" );
  
  end;
  
  cmn.AddSubscriber( "get_bowlofwater", get_bowlofwater_inv );
  cmn.AddSubscriber( "get_bowlofwater", get_bowlofwater_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_moonemblem () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_moonemblem" ] = {
    type = "get",
    get_obj = "spr_oldfountain_moonemblem",
    room = private.room_objname,
    zz = "zz_oldfountain",
    zz_gate = "gzz_apocalypse2_oldfountain"
  };
  --------------------------------------------------------------------------------------------
  local get_moonemblem_inv = function ()
  
    interface.InventoryItemAdd( "inv_moonemblem", "spr_oldfountain_moonemblem" );
  
  end;
  local get_moonemblem_end = function ()
  
    ObjDelete( "gfx_oldfountain_moonemblem" );
    ObjDelete( "anm_oldfountain_use_net" );
  
  end;
  
  cmn.AddSubscriber( "get_moonemblem", get_moonemblem_inv );
  cmn.AddSubscriber( "get_moonemblem", get_moonemblem_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_boxpart4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_boxpart4" ] = {
    type = "get",
    get_obj = "spr_oldfountain_boxpart4",
    room = private.room_objname,
    zz = "zz_oldfountain",
    zz_gate = "gzz_apocalypse2_oldfountain"
  };
  --------------------------------------------------------------------------------------------
  local get_boxpart4_inv = function ()
  
    interface.InventoryItemAdd( "inv_boxpart", "spr_oldfountain_boxpart4", function () cmn.GetMultyObject( 'boxpart', 4 ); end );
      
    if cmn.CheckMultiObject( "boxpart", 4 ) then
      ObjSet("inv_pandorasbox_star_light",  { alp = 1 });
    end;
  
  end;
  local get_boxpart4_end = function ()
  
    ObjDelete( "gfx_oldfountain_boxpart4" );
    ObjDelete( "spr_oldfountain_boxpart4_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_boxpart4", get_boxpart4_inv );
  cmn.AddSubscriber( "get_boxpart4", get_boxpart4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_zodiacsign2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_zodiacsign2" ] = {
    type = "get",
    get_obj = "spr_oldfountain_zodiacsign8",
    room = private.room_objname,
    zz = "zz_oldfountain",
    zz_gate = "gzz_apocalypse2_oldfountain"
  };
  --------------------------------------------------------------------------------------------
  local get_zodiacsign2_inv = function ()
  
    interface.InventoryItemAdd( "inv_zodiacsign", "spr_oldfountain_zodiacsign8", function () cmn.GetMultyObject( 'zodiacsign', 4 ); end );
    int_map_impl.DecreaseRoomTasks("rm_apocalypse2");
  
  end;
  local get_zodiacsign2_end = function ()
  
    ObjDelete( "gzz_apocalypse2_oldfountain" );
  
  end;
  
  cmn.AddSubscriber( "get_zodiacsign2", get_zodiacsign2_inv );
  cmn.AddSubscriber( "get_zodiacsign2", get_zodiacsign2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl3gun () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl3gun" ] = {
    type = "get",
    get_obj = "spr_policevan_lvl3gun",
    room = private.room_objname,
    zz = "zz_policevan",
    zz_gate = "gzz_apocalypse2_policevan"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl3gun_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl3gun", "spr_policevan_lvl3gun" );
  
  end;
  local get_lvl3gun_end = function ()
  
    ObjDelete( "gfx_policevan_lvl3gun" );
    ObjDelete( "spr_policevan_lvl3gun_sh" );
    
    if cmn.IsEventDone("get_mask3") then
      ObjSet("gzz_apocalypse2_policevan",  { active = 0, alp = 0 });
    end;
  
  end;
  
  cmn.AddSubscriber( "get_lvl3gun", get_lvl3gun_inv );
  cmn.AddSubscriber( "get_lvl3gun", get_lvl3gun_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mask3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_mask3" ] = {
    type = "get",
    get_obj = "spr_policevan_mask3",
    room = private.room_objname,
    zz = "zz_policevan",
    zz_gate = "gzz_apocalypse2_policevan"
  };
  --------------------------------------------------------------------------------------------
  local get_mask3_inv = function ()
  
    interface.InventoryItemAdd( "inv_mask3", "spr_policevan_mask3" );
  
  end;
  local get_mask3_end = function ()
  
    ObjDelete( "gfx_policevan_mask3" );
    ObjDelete( "spr_policevan_mask3_sh" );
    
    if cmn.IsEventDone("get_lvl3gun") then
      ObjSet("gzz_apocalypse2_policevan",  { active = 0, alp = 0 });
    end;
  
  end;
  
  cmn.AddSubscriber( "get_mask3", get_mask3_inv );
  cmn.AddSubscriber( "get_mask3", get_mask3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl3bag () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl3bag" ] = {
    type = "get",
    get_obj = "spr_policevan_lvl3bag",
    room = private.room_objname,
    zz = "zz_policevan",
    zz_gate = "gzz_apocalypse2_policevan"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl3bag_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_lvl3bag", "spr_policevan_lvl3bag" );
  
  end;
  local get_lvl3bag_end = function ()
  
    ObjDelete( "gfx_policevan_lvl3bag" );
    ObjDelete( "spr_policevan_lvl3bag_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_lvl3bag", get_lvl3bag_inv );
  cmn.AddSubscriber( "get_lvl3bag", get_lvl3bag_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_oilcan () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_oilcan" ] = {
    type = "get",
    get_obj = "spr_museumdoors_oilcan",
    room = private.room_objname,
    zz = "zz_museumdoors",
    zz_gate = "gzz_apocalypse2_museumdoors"
  };
  --------------------------------------------------------------------------------------------
  local get_oilcan_inv = function ()
  
    interface.InventoryItemAdd( "inv_oilcan", "spr_museumdoors_oilcan" );
  
  end;
  local get_oilcan_end = function ()
  
    ObjDelete( "gfx_museumdoors_oilcan" );
    ObjDelete( "spr_museumdoors_oilcan_sh" );

    ObjDelete( "spr_apocalypse2_museumdoors_oil_can" );
  
  end;
  
  cmn.AddSubscriber( "get_oilcan", get_oilcan_inv );
  cmn.AddSubscriber( "get_oilcan", get_oilcan_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl3bowl () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl3bowl" ] = {
    type = "get",
    get_obj = "spr_museumdoors_lvl3bowl",
    room = private.room_objname,
    zz = "zz_museumdoors",
    zz_gate = "gzz_apocalypse2_museumdoors"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl3bowl_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl3bowl", "spr_museumdoors_lvl3bowl" );
  
  end;
  local get_lvl3bowl_end = function ()
  
    ObjDelete( "gfx_museumdoors_lvl3bowl" );
    ObjDelete( "spr_museumdoors_lvl3bowl_sh" );

    ObjDelete( "spr_apocalypse2_museumdoors_bowl" );
  
  end;
  
  cmn.AddSubscriber( "get_lvl3bowl", get_lvl3bowl_inv );
  cmn.AddSubscriber( "get_lvl3bowl", get_lvl3bowl_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_bowlofwater () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_bowlofwater" ] = {
    type = "use",
    inv_obj = "inv_bowlofwater",
    use_place = "obj_fracture_use_bowlofwater",
    room = private.room_objname,
    zz = "zz_fracture",
    zz_gate = "gzz_apocalypse2_fracture"
  };
  --------------------------------------------------------------------------------------------
  local use_bowlofwater_inv = function ()
  
    interface.InventoryItemRemove( "inv_bowlofwater" );
  
  end;
  local use_bowlofwater_beg = function ()
  
    ObjDelete( "obj_fracture_use_bowlofwater" );
  
  end;
  local use_bowlofwater_end = function ()
  
    ObjDelete( "vid_fracture_fire" );
    ObjDelete( "vid_fracture_use_water" );

    ObjDelete( "spr_apocalypse2_fracture_fire" );
    ObjDelete( "fx_apocalypse2_p_fire" );
    
    ObjMultiSet( {
      { "obj_fracture_under_fire", { input = 1, alp = 1 } },
      { "spr_apocalypse2_fracture_diamond", { alp = 1 } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bowlofwater", use_bowlofwater_beg, private.room_objname );
  cmn.AddSubscriber( "use_bowlofwater", use_bowlofwater_inv );
  cmn.AddSubscriber( "use_bowlofwater", use_bowlofwater_end, private.room_objname );
  cmn.AddSubscriber( "use_bowlofwater_inv", use_bowlofwater_inv, private.room_objname );
  cmn.AddSubscriber( "use_bowlofwater_beg", use_bowlofwater_beg, private.room_objname );
  cmn.AddSubscriber( "use_bowlofwater_end", use_bowlofwater_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_flashlight () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_flashlight" ] = {
    type = "use",
    inv_obj = "inv_flashlight",
    use_place = "obj_fracture_use_flashlight",
    room = private.room_objname,
    zz = "zz_fracture",
    zz_gate = "gzz_apocalypse2_fracture"
  };
  --------------------------------------------------------------------------------------------
  local use_flashlight_inv = function ()
  
    interface.InventoryItemRemove( "inv_flashlight" );
  
  end;
  local use_flashlight_beg = function ()
  
    ObjDelete( "obj_fracture_use_flashlight" );
  
  end;
  local use_flashlight_end = function ()
    
    ObjAttach("fx_fracture_darkness", "obj_fracture_light_1");
    
    ObjDelete( "spr_fracture_diamond_sh" );

    ObjDelete( "obj_apocalypse2_fracture_dark" );
    ObjDelete( "anm_fracture_shadow_come" );
    ObjDelete( "obj_fracture_dark_1" );
    
    ObjMultiSet( { {"obj_fracture_flashlight", { alp = 1 }},
                   {"obj_fracture_light_1", { alp = 1 }},
                   {"obj_fracture_use_lvl3gun", { input = 1 }},
                   {"obj_fracture_shadow", { alp = 1 }},
                   {"anm_fracture_shadow", { alp = 1 }},
                   {"obj_apocalypse2_fracture_light", { alp = 1 }},
                   {"anm_apocalypse2_fracture_fearful_man", { alp = 1 }},
                   {"fx_fracture_darkness", { pos_z = 2 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_flashlight", use_flashlight_beg, private.room_objname );
  cmn.AddSubscriber( "use_flashlight", use_flashlight_inv );
  cmn.AddSubscriber( "use_flashlight", use_flashlight_end, private.room_objname );
  cmn.AddSubscriber( "use_flashlight_inv", use_flashlight_inv, private.room_objname );
  cmn.AddSubscriber( "use_flashlight_beg", use_flashlight_beg, private.room_objname );
  cmn.AddSubscriber( "use_flashlight_end", use_flashlight_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl3gun () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl3gun" ] = {
    type = "use",
    inv_obj = "inv_lvl3gun",
    use_place = "obj_fracture_use_lvl3gun",
    room = private.room_objname,
    zz = "zz_fracture",
    zz_gate = "gzz_apocalypse2_fracture"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl3gun_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl3gun" );
  
  end;
  local use_lvl3gun_beg = function ()
  
    ObjDelete( "obj_fracture_use_lvl3gun" );
  
  end;
  local use_lvl3gun_end = function ()
    
    ObjMultiSet( { {"spr_fracture_aim", { alp = 1 }},
                   {"obj_fracture_gun", { alp = 1 }},
                   {"obj_fracture_game_2", { alp = 1 }},
                   {"obj_fracture_game", { input = 1 }},
                   {"spr_fracture_hole_1", { input = 1 }},
                   {"spr_fracture_hole_2", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl3gun", use_lvl3gun_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl3gun", use_lvl3gun_inv );
  cmn.AddSubscriber( "use_lvl3gun", use_lvl3gun_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl3gun_inv", use_lvl3gun_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl3gun_beg", use_lvl3gun_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl3gun_end", use_lvl3gun_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_stoneoflight () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_stoneoflight" ] = {
    type = "use",
    inv_obj = "inv_stoneoflight",
    use_place = "obj_fracture_use_stoneoflight",
    room = private.room_objname,
    zz = "zz_fracture",
    zz_gate = "gzz_apocalypse2_fracture"
  };
  --------------------------------------------------------------------------------------------
  local use_stoneoflight_inv = function ()
  
    interface.InventoryItemRemove( "inv_stoneoflight" );
  
  end;
  local use_stoneoflight_beg = function ()
  
    ObjDelete( "obj_fracture_use_stoneoflight" );
    ObjDelete( "obj_fracture_dark_2" );
  
  end;
  local use_stoneoflight_end = function ()
  
    ObjDelete( "fx_fracture_darkness" );
    
    ObjMultiSet( {
      { "anm_fracture_lightstone_use", { input = 1, alp = 1, frame = 300 } },
      { "spr_apocalypse2_fracture_lightstone", { alp = 1 } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_stoneoflight", use_stoneoflight_beg, private.room_objname );
  cmn.AddSubscriber( "use_stoneoflight", use_stoneoflight_inv );
  cmn.AddSubscriber( "use_stoneoflight", use_stoneoflight_end, private.room_objname );
  cmn.AddSubscriber( "use_stoneoflight_inv", use_stoneoflight_inv, private.room_objname );
  cmn.AddSubscriber( "use_stoneoflight_beg", use_stoneoflight_beg, private.room_objname );
  cmn.AddSubscriber( "use_stoneoflight_end", use_stoneoflight_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl3bowl () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl3bowl" ] = {
    type = "use",
    inv_obj = "inv_lvl3bowl",
    use_place = "obj_oldfountain_use_lvl3bowl",
    room = private.room_objname,
    zz = "zz_oldfountain",
    zz_gate = "gzz_apocalypse2_oldfountain"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl3bowl_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl3bowl" );
  
  end;
  local use_lvl3bowl_beg = function ()
  
    ObjDelete( "obj_oldfountain_use_lvl3bowl" );
  
  end;
  local use_lvl3bowl_end = function ()
  
    --ObjSet( "spr_oldfountain_bowlofwater", { input = 1, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl3bowl", use_lvl3bowl_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl3bowl", use_lvl3bowl_inv );
  cmn.AddSubscriber( "use_lvl3bowl", use_lvl3bowl_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl3bowl_inv", use_lvl3bowl_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl3bowl_beg", use_lvl3bowl_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl3bowl_end", use_lvl3bowl_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_scoopnet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_scoopnet" ] = {
    type = "use",
    inv_obj = "inv_scoopnet",
    use_place = "obj_oldfountain_use_scoopnet",
    room = private.room_objname,
    zz = "zz_oldfountain",
    zz_gate = "gzz_apocalypse2_oldfountain"
  };
  --------------------------------------------------------------------------------------------
  local use_scoopnet_inv = function ()
  
    interface.InventoryItemRemove( "inv_scoopnet" );
  
  end;
  local use_scoopnet_beg = function ()
  
    ObjDelete( "obj_oldfountain_use_scoopnet" );
    ObjDelete( "spr_oldfountain_moonemblem_sh" );
    ObjDelete( "spr_oldfountain_moonemblem_2" );
  
  end;
  local use_scoopnet_end = function ()
  
    --ObjSet( "spr_oldfountain_moonemblem", { input = 1, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scoopnet", use_scoopnet_beg, private.room_objname );
  cmn.AddSubscriber( "use_scoopnet", use_scoopnet_inv );
  cmn.AddSubscriber( "use_scoopnet", use_scoopnet_end, private.room_objname );
  cmn.AddSubscriber( "use_scoopnet_inv", use_scoopnet_inv, private.room_objname );
  cmn.AddSubscriber( "use_scoopnet_beg", use_scoopnet_beg, private.room_objname );
  cmn.AddSubscriber( "use_scoopnet_end", use_scoopnet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl3valve () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl3valve" ] = {
    type = "use",
    inv_obj = "inv_lvl3valve",
    use_place = "obj_oldfountain_use_lvl3valve",
    room = private.room_objname,
    zz = "zz_oldfountain",
    zz_gate = "gzz_apocalypse2_oldfountain"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl3valve_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl3valve" );
  
  end;
  local use_lvl3valve_beg = function ()
  
    ObjDelete( "obj_oldfountain_use_lvl3valve" );
  
  end;
  local use_lvl3valve_end = function ()
  
    ObjDelete("obj_oldfountain_water");
    ObjDelete("anm_oldfountain_water_3");

    ObjDelete( "anm_apocalypse2_oldfountain_water" );
    
    ObjMultiSet( { {"anm_oldfountain_water_out", { alp = 1, input = 1, frame = 300 }},
                   {"anm_oldfountain_use_valve", { alp = 1, frame = 300 }},
                   {"spr_apocalypse2_oldfountain_valve", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl3valve", use_lvl3valve_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl3valve", use_lvl3valve_inv );
  cmn.AddSubscriber( "use_lvl3valve", use_lvl3valve_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl3valve_inv", use_lvl3valve_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl3valve_beg", use_lvl3valve_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl3valve_end", use_lvl3valve_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_diamond () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_diamond" ] = {
    type = "use",
    inv_obj = "inv_diamond",
    use_place = "obj_policevan_use_diamond",
    room = private.room_objname,
    zz = "zz_policevan",
    zz_gate = "gzz_apocalypse2_policevan"
  };
  --------------------------------------------------------------------------------------------
  local use_diamond_inv = function ()
  
    interface.InventoryItemRemove( "inv_diamond" );
  
  end;
  local use_diamond_beg = function ()
  
    ObjDelete( "obj_policevan_use_diamond" );
  
  end;
  local use_diamond_end = function ()

    ObjMultiSet( { {"anm_policevan_use_diamond", { alp = 1, frame = 300 }},
                   {"obj_policevan_inside", { input = 1 }},
                   {"spr_apocalypse2_policevan_open_window", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_diamond", use_diamond_beg, private.room_objname );
  cmn.AddSubscriber( "use_diamond", use_diamond_inv );
  cmn.AddSubscriber( "use_diamond", use_diamond_end, private.room_objname );
  cmn.AddSubscriber( "use_diamond_inv", use_diamond_inv, private.room_objname );
  cmn.AddSubscriber( "use_diamond_beg", use_diamond_beg, private.room_objname );
  cmn.AddSubscriber( "use_diamond_end", use_diamond_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_policebadge () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_policebadge" ] = {
    type = "use",
    inv_obj = "inv_policebadge",
    use_place = "obj_policevan_use_policebadge",
    room = private.room_objname,
    zz = "zz_policevan",
    zz_gate = "gzz_apocalypse2_policevan"
  };
  --------------------------------------------------------------------------------------------
  local use_policebadge_inv = function ()
  
    interface.InventoryItemRemove( "inv_policebadge" );
  
  end;
  local use_policebadge_beg = function ()
  
    ObjDelete( "obj_policevan_use_policebadge" );
    ObjDelete( "anm_policevan_cover_touch" );
  
  end;
  local use_policebadge_end = function ()
  
    ObjSet( "anm_policevan_cover_open", { input = 1, alp = 1, frame = 300 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_policebadge", use_policebadge_beg, private.room_objname );
  cmn.AddSubscriber( "use_policebadge", use_policebadge_inv );
  cmn.AddSubscriber( "use_policebadge", use_policebadge_end, private.room_objname );
  cmn.AddSubscriber( "use_policebadge_inv", use_policebadge_inv, private.room_objname );
  cmn.AddSubscriber( "use_policebadge_beg", use_policebadge_beg, private.room_objname );
  cmn.AddSubscriber( "use_policebadge_end", use_policebadge_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spideramulet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_spideramulet" ] = {
    type = "use",
    inv_obj = "inv_spideramulet",
    use_place = "obj_museumdoors_use_spideramulet",
    room = private.room_objname,
    zz = "zz_museumdoors",
    zz_gate = "gzz_apocalypse2_museumdoors"
  };
  --------------------------------------------------------------------------------------------
  local use_spideramulet_inv = function ()
  
    interface.InventoryItemRemove( "inv_spideramulet" );
  
  end;
  local use_spideramulet_beg = function ()
  
    ObjDelete( "obj_museumdoors_use_spideramulet" );
    ObjDelete( "anm_museumdoors_net" );
    ObjDelete( "anm_museumdoors_net_touch" );
  
  end;
  local use_spideramulet_end = function ()

    ObjDelete( "spr_apocalypse2_museumdoors_net" );
  
    ObjMultiSet( { {"spr_museumdoors_oilcan", { input = 1 }},
                   {"obj_museumdoors_use_museumheart", { input = 1 }},
                   {"anm_museumdoors_use_spider", { alp = 1, frame = 400 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_spideramulet", use_spideramulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_spideramulet", use_spideramulet_inv );
  cmn.AddSubscriber( "use_spideramulet", use_spideramulet_end, private.room_objname );
  cmn.AddSubscriber( "use_spideramulet_inv", use_spideramulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_spideramulet_beg", use_spideramulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_spideramulet_end", use_spideramulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_museumheart () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_museumheart" ] = {
    type = "use",
    inv_obj = "inv_museumheart",
    use_place = "obj_museumdoors_use_museumheart",
    room = private.room_objname,
    zz = "zz_museumdoors",
    zz_gate = "gzz_apocalypse2_museumdoors"
  };
  --------------------------------------------------------------------------------------------
  local use_museumheart_inv = function ()
  
    interface.InventoryItemRemove( "inv_museumheart" );
  
  end;
  local use_museumheart_beg = function ()
  
    ObjDelete( "obj_museumdoors_use_museumheart" );
  
  end;
  local use_museumheart_end = function ()
  
    ObjDelete( "gzz_apocalypse2_museumdoors" );

    ObjMultiSet( {
      { "gmg_apocalypse2_onmuseumdoors", { input = 1, alp = 1, active = 1 } },
      { "spr_apocalypse2_museumdoors_circule", { alp = 1 } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_museumheart", use_museumheart_beg, private.room_objname );
  cmn.AddSubscriber( "use_museumheart", use_museumheart_inv );
  cmn.AddSubscriber( "use_museumheart", use_museumheart_end, private.room_objname );
  cmn.AddSubscriber( "use_museumheart_inv", use_museumheart_inv, private.room_objname );
  cmn.AddSubscriber( "use_museumheart_beg", use_museumheart_beg, private.room_objname );
  cmn.AddSubscriber( "use_museumheart_end", use_museumheart_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_stoneoflight () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_stoneoflight" ] = {
      type = "click",
      use_place = "obj_fracture_clk_stoneoflight",
      room = private.room_objname,
      zz = "zz_fracture",
      zz_gate = "gzz_apocalypse2_fracture"
  };
  --------------------------------------------------------------------------------------------
  local clk_stoneoflight = function ()
  
    ObjMultiSet( { {"obj_fracture_use_stoneoflight",  { input = 1 }},
                   {"anm_fracture_lightstone_use", { alp = 1 }} } );

    ObjDelete( "obj_fracture_clk_stoneoflight" );
    ObjDelete( "anm_fracture_broken_stone" );

    ObjDelete( "spr_apocalypse2_fracture_crystal_broken" );

  end;
  
  cmn.AddSubscriber( "clk_stoneoflight", clk_stoneoflight, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function opn_apocalypse2 () end;
  --------------------------------------------------------------------------------------------
  local opn_apocalypse2 = function ()
  
    int_map_impl.OpenRoom( "rm_apocalypse2" );
    interface_impl.SetCurrentGlobalTask( 17 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_apocalypse2", opn_apocalypse2 );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_fracture" );
  subroom.Define( "zz_policevan" );
  subroom.Define( "zz_oldfountain" );
  
  function zz_policevan.Close()
    cmn.HideNote( 0 );
  end;
  
  function zz_fracture.PreOpen()
    
    if not cmn.IsEventDone("use_bowlofwater") then
      cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_fire_zz_facture_env");
    else 
      cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_coals_after_fire_env");
    end;
    
    if cmn.IsEventDone("use_flashlight") and not cmn.IsEventDone("use_lvl3gun") then
      cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_zz_facture_monster_env");
      private.zz_fracture.PlayShadow();
    end;
    
    if cmn.IsEventDone( "use_lvl3gun" ) and cmn.IsEventDone("use_flashlight") and not(cmn.IsEventDone( "win_fracture" )) then
      private.zz_fracture.DrawScene();
    end;
    
    if (cmn.IsEventDone("get_goreseye")) and not(cmn.IsEventDone("use_goreseye3")) then

      ObjAnimate( "inv_goreseye", "pos_xy", 1, 0, "",
      { 
        0.0, 0,  0, 0,
        0.1, 0,  3, -2,
        0.2, 0, -3, -4,
        0.3, 0,  3, -6,
        0.4, 0, -3, -8,
        0.5, 0,  0, -10,
        0.6, 0,  3, -8,
        0.7, 0, -3, -6,
        0.8, 0,  3, -4,
        0.9, 0, -3, -2,
        1.0, 0,  0, 0
      } );

      --ObjSet("inv_goreseye_fx", { active = 1, visible = 1 } );

      int_inventory_impl.ShowAnim( "show" );

    end;

  end;
  
  function zz_fracture.Open()
    
    if cmn.IsEventDone( "use_lvl3gun" ) and cmn.IsEventDone("use_flashlight") and not(cmn.IsEventDone( "win_fracture" )) then
      cmn.MiniGameShow();
      if private.zz_fracture.frame > 0 then
        ObjSet("anm_fracture_shadow",  { frame = private.zz_fracture.frame, playing = 1 });
      end;
      private.zz_fracture.CheckWin();
    end;

  end;
  
  function zz_fracture.PreClose()
    
    cmn.StopAllEnv("assets/levels/level3/audio/env/aud_rm_apocalypse2_env");
    cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_apocalypse2_env");
    
    if cmn.IsEventDone("use_lvl3gun") and cmn.IsEventDone("use_flashlight") and not cmn.IsEventDone("win_fracture") then
      private.zz_fracture.frame = ObjGet("anm_fracture_shadow").frame;
      ObjSet("anm_fracture_shadow",  { playing = 0 });
      cmn.MiniGameHide("fracture");
    end;
    
    if (cmn.IsEventDone("get_goreseye")) and not(cmn.IsEventDone("use_goreseye3")) then
      ObjStopAnimate( "inv_goreseye", "pos_xy" );
      ObjMultiSet( { {"inv_goreseye", { pos_x = 0, pos_y = 0 }},
                     {"inv_goreseye_fx", { active = 0, visible = 0 }} } );
    end;
    
  end;
                 
  function zz_oldfountain.PreOpen()
    
    if (cmn.IsEventDone("get_goreseye")) and not(cmn.IsEventDone("use_goreseye2")) then

      ObjAnimate( "inv_goreseye", "pos_xy", 1, 0, "",
      { 
        0.0, 0,  0, 0,
        0.1, 0,  3, -2,
        0.2, 0, -3, -4,
        0.3, 0,  3, -6,
        0.4, 0, -3, -8,
        0.5, 0,  0, -10,
        0.6, 0,  3, -8,
        0.7, 0, -3, -6,
        0.8, 0,  3, -4,
        0.9, 0, -3, -2,
        1.0, 0,  0, 0
      } );

      --ObjSet("inv_goreseye_fx", { active = 1, visible = 1 } );

      int_inventory_impl.ShowAnim( "show" );

    end;
    
  end;
  
  function zz_oldfountain.PreClose()
    
    if (cmn.IsEventDone("get_goreseye")) and not(cmn.IsEventDone("use_goreseye2")) then
      ObjStopAnimate( "inv_goreseye", "pos_xy" );
      ObjMultiSet( { {"inv_goreseye", { pos_x = 0, pos_y = 0 }},
                     {"inv_goreseye_fx", { active = 0, visible = 0 }} } );
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load()

  if not(ng_global.progress[ ng_global.currentprogress ][ "win_fracture" ].state) then 
    private.zz_fracture.StartConditions();
  end;
  
  private.zz_fracture.state = ng_global.progress[ ng_global.currentprogress ][ "win_fracture" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_apocalypse2();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level3/audio/env/aud_rm_apocalypse2_env");
  cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_apocalypse2_env");
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_bowlofwater()

  local item = "inv_bowlofwater";

  if cmn.ApplyObj( item, "gzz_apocalypse2_fracture" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_fracture" );

  elseif ( cmn.ApplyObj( item, "obj_fracture_use_bowlofwater" ) ) then

    cmn.CallEventHandler( "use_bowlofwater_inv" );
    cmn.CallEventHandler( "use_bowlofwater_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_bowlofwater" );
      cmn.CallEventHandler( "use_bowlofwater_end" );
      
      cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_coals_after_fire_env");
    
    end;
    
    cmn.StopAllEnv("assets/levels/level3/audio/env/aud_rm_apocalypse2_env");
    cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_apocalypse2_env");

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_fire_off_water");

    ObjAttach("vid_fracture_use_water", "zz_fracture");
    VidPlay("vid_fracture_use_water", func_after);
    
    ObjAnimate("vid_fracture_fire", "alp", 0, 0, "", { 0, 0, 1,   2.04, 0, 1,   3.04, 0, 0 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_flashlight()

  local item = "inv_flashlight";

  if cmn.ApplyObj( item, "gzz_apocalypse2_fracture" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_fracture" );

  elseif ( cmn.ApplyObj( item, "obj_fracture_use_flashlight" ) and cmn.IsEventDone("use_bowlofwater") ) then

    cmn.CallEventHandler( "use_flashlight_inv" );
    cmn.CallEventHandler( "use_flashlight_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_flashlight" );
      cmn.CallEventHandler( "use_flashlight_end" );
      
      cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_zz_facture_monster_env");
      ObjSet("anm_fracture_shadow",  { playing = 1, endtrig = private.zz_fracture.PlayShadow });
    
    end;
    
    local anm_shadow = function ()
      
      ObjAttach("fx_fracture_darkness", "obj_fracture_light_1");
      
      ObjAnimate("obj_fracture_shadow", "alp", 0, 0, "", { 0, 0, 0,   0.1, 0, 1 });
      ObjSet("anm_fracture_shadow_come",  { playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_flash_zz_facture");

    ObjAnimate( "obj_fracture_light_1", "alp", 0, 0, anm_shadow, { 0, 0, 0,    0.3, 0, 0,   0.5, 0, 0.5,   0.8, 0, 0.2,  1.1, 0, 0.8,  1.4, 0, 0.7,  1.7, 0, 1  } );
    ObjAnimate( "obj_fracture_flashlight", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
    
    if not cmn.IsEventDone("get_diamond") then
      ObjAnimate( "spr_fracture_diamond_sh", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 0,   0.5, 0, 0.5,   0.8, 0, 0.2,  1.1, 0, 0.8,  1.4, 0, 0.7,  1.7, 0, 1  } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl3gun()

  local item = "inv_lvl3gun";

  if cmn.ApplyObj( item, "gzz_apocalypse2_fracture" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_fracture" );

  elseif ( cmn.ApplyObj( item, "obj_fracture_use_lvl3gun" ) and cmn.IsEventDone("use_bowlofwater") and cmn.IsEventDone("use_flashlight") ) then

    cmn.CallEventHandler( "use_lvl3gun_inv" );
    cmn.CallEventHandler( "use_lvl3gun_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl3gun" );
      cmn.CallEventHandler( "use_lvl3gun_end" );
      
      cmn.MiniGameShow();
      private.zz_fracture.SetShadow();
    
    end;
    
    local anm_shadow = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_monster_rise_orchestra_mmg_1");
      
      cmn.StopAllEnv("assets/levels/level3/audio/env/aud_rm_apocalypse2_env");
      cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_apocalypse2_env");
      cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_coals_after_fire_env");
      
      SetCursor(CURSOR_NULL);
      ObjSet("anm_fracture_shadow",  { endtrig = "" });
      ObjAnimate("obj_fracture_shadow", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
      ObjAnimate("obj_fracture_game_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_take_pistol_mmg");
    
    private.zz_fracture.AimTarget();
    
    ObjAnimate("obj_fracture_gun", "alp", 0, 0, anm_shadow, { 0, 0, 0,   0.3, 0, 1 });
    ObjAnimate("spr_fracture_aim", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_stoneoflight()

  local item = "inv_stoneoflight";

  if cmn.ApplyObj( item, "gzz_apocalypse2_fracture" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_fracture" );

  elseif ( cmn.ApplyObj( item, "obj_fracture_use_stoneoflight" ) and cmn.IsEventDone("use_bowlofwater") and cmn.IsEventDone("clk_stoneoflight") ) then

    cmn.CallEventHandler( "use_stoneoflight_inv" );
    private.use_stoneoflight_end();
    
  elseif ( cmn.ApplyObj( item, "obj_fracture_use_stoneoflight" ) and cmn.IsEventDone("use_bowlofwater") and not cmn.IsEventDone("clk_stoneoflight") ) then

    cmn.CallEventHandler( "use_stoneoflight_inv" );
    public.clk_stoneoflight(2);

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function private.use_stoneoflight_end()

  cmn.CallEventHandler( "use_stoneoflight_beg" );

  local func_after = function ()

    cmn.Lock( 0 );

    cmn.SetEventDone( "use_stoneoflight" );
    cmn.CallEventHandler( "use_stoneoflight_end" );
  
  end;

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_use_stuff_mask");

  ObjSet("anm_fracture_lightstone_use",  { alp = 1, playing = 1, endtrig = func_after });
  ObjAnimate("fx_fracture_darkness", "alp", 0, 0, "", { 0, 0, 1,   0.55, 0, 1,   0.68, 0, 0 });
  
end;
--------------------------------------------------------------------------------------------
function public.use_lvl3bowl()

  local item = "inv_lvl3bowl";

  if cmn.ApplyObj( item, "gzz_apocalypse2_oldfountain" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_oldfountain" );

  elseif ( cmn.ApplyObj( item, "obj_oldfountain_use_lvl3bowl" ) ) then

    cmn.CallEventHandler( "use_lvl3bowl_inv" );
    cmn.CallEventHandler( "use_lvl3bowl_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl3bowl" );
      cmn.CallEventHandler( "use_lvl3bowl_end" );
      
      public.get_bowlofwater();
      ObjSet("spr_oldfountain_water_bl",  { alp = 0.83 });
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_take_water_zz_oldfountain");

    ObjMultiSet( { {"anm_oldfountain_use_bowl",  { alp = 1, playing = 1, endtrig = func_after }},
                   {"spr_oldfountain_water_bl", { alp = 0 }} } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_scoopnet()

  local item = "inv_scoopnet";

  if cmn.ApplyObj( item, "gzz_apocalypse2_oldfountain" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_oldfountain" );

  elseif ( cmn.ApplyObj( item, "obj_oldfountain_use_scoopnet" ) ) then

    cmn.CallEventHandler( "use_scoopnet_inv" );
    cmn.CallEventHandler( "use_scoopnet_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_scoopnet" );
      cmn.CallEventHandler( "use_scoopnet_end" );
      
      public.get_moonemblem();
      ObjSet("spr_oldfountain_water_bl",  { alp = 0.83 });
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_take_amulet_fountain");

    ObjMultiSet( { {"anm_oldfountain_use_net",  { alp = 1, playing = 1, endtrig = func_after }},
                   {"spr_oldfountain_water_bl", { alp = 0 }} } )

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl3valve()

  local item = "inv_lvl3valve";

  if cmn.ApplyObj( item, "gzz_apocalypse2_oldfountain" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_oldfountain" );

  elseif ( cmn.ApplyObj( item, "obj_oldfountain_use_lvl3valve" ) ) then

    cmn.CallEventHandler( "use_lvl3valve_inv" );
    cmn.CallEventHandler( "use_lvl3valve_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl3valve" );
      cmn.CallEventHandler( "use_lvl3valve_end" );
    
    end;
    
    local anm_water = function ()
      
      ObjDelete("obj_oldfountain_water");
      ObjDelete("anm_oldfountain_water_3");
    
      ObjSet("anm_oldfountain_water_out",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zz_oldfountain_screw");

    ObjSet("anm_oldfountain_use_valve",  { alp = 1, playing = 1, endtrig = anm_water });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_diamond()

  local item = "inv_diamond";

  if cmn.ApplyObj( item, "gzz_apocalypse2_policevan" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_policevan", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_policevan_use_diamond" ) ) then

    cmn.CallEventHandler( "use_diamond_inv" );
    cmn.CallEventHandler( "use_diamond_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_diamond" );
      cmn.CallEventHandler( "use_diamond_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_make_hole_glass_car");

    ObjSet("anm_policevan_use_diamond",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_policebadge()

  local item = "inv_policebadge";

  if cmn.ApplyObj( item, "gzz_apocalypse2_policevan" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_policevan", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_policevan_use_policebadge" ) and cmn.IsEventDone("use_diamond") ) then

    cmn.CallEventHandler( "use_policebadge_inv" );
    cmn.CallEventHandler( "use_policebadge_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_policebadge" );
      cmn.CallEventHandler( "use_policebadge_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_jetton_police");

    ObjSet("anm_policevan_cover_open",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_spideramulet()

  local item = "inv_spideramulet";

  if cmn.ApplyObj( item, "gzz_apocalypse2_museumdoors" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_museumdoors" );

  elseif ( cmn.ApplyObj( item, "obj_museumdoors_use_spideramulet" ) ) then

    cmn.CallEventHandler( "use_spideramulet_inv" );
    cmn.CallEventHandler( "use_spideramulet_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_spideramulet" );
      cmn.CallEventHandler( "use_spideramulet_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_spider_cut_off_web");

    ObjSet("anm_museumdoors_use_spider",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_museumheart()

  local item = "inv_museumheart";

  if cmn.ApplyObj( item, "gzz_apocalypse2_museumdoors" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_museumdoors" );

  elseif ( cmn.ApplyObj( item, "obj_museumdoors_use_museumheart" ) and cmn.IsEventDone("use_spideramulet") ) then

    cmn.CallEventHandler( "use_museumheart_inv" );
    cmn.CallEventHandler( "use_museumheart_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_museumheart" );
      cmn.CallEventHandler( "use_museumheart_end" );
      
      common.CloseSubRoom();
      cmn.GotoRoom("mg_onmuseumdoors");
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_insert_stuff_stones_broken");

    ObjSet("anm_museumdoors_rune_use",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_diamond()

  cmn.SetEventDone( "get_diamond" );
  cmn.CallEventHandler( "get_diamond" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_museumheart()

  cmn.SetEventDone( "get_museumheart" );
  cmn.CallEventHandler( "get_museumheart" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_mask2()

  cmn.SetEventDone( "get_mask2" );
  cmn.CallEventHandler( "get_mask2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_zodiacsign7()
  
  ObjSet( "spr_fracture_zodiacsign7", { alp = 1 } );

  cmn.SetEventDone( "get_zodiacsign3" );
  cmn.CallEventHandler( "get_zodiacsign3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_bowlofwater()
  
  ObjMultiSet( { {"spr_oldfountain_bowlofwater", { ang = -0.0939 }},
                 {"spr_oldfountain_bowlofwater_2", { alp = 1 }} } );

  cmn.SetEventDone( "get_bowlofwater" );
  cmn.CallEventHandler( "get_bowlofwater" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_moonemblem()
  
  ObjSet("spr_oldfountain_moonemblem",  { ang = -0.247 });

  cmn.SetEventDone( "get_moonemblem" );
  cmn.CallEventHandler( "get_moonemblem" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_boxpart4()

  cmn.SetEventDone( "get_boxpart4" );
  cmn.CallEventHandler( "get_boxpart4" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_zodiacsign8()
  
  ObjSet( "spr_oldfountain_zodiacsign8", { alp = 1 } );

  cmn.SetEventDone( "get_zodiacsign2" );
  cmn.CallEventHandler( "get_zodiacsign2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_lvl3gun()

  cmn.SetEventDone( "get_lvl3gun" );
  cmn.CallEventHandler( "get_lvl3gun" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_mask3") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_mask3()

  cmn.SetEventDone( "get_mask3" );
  cmn.CallEventHandler( "get_mask3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_lvl3gun") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_lvl3bag()

  cmn.SetEventDone( "get_lvl3bag" );
  cmn.CallEventHandler( "get_lvl3bag" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if not cmn.IsEventDone("get_mask3") then
    cmn.SetEventDone( "get_mask3" );
    cmn.CallEventHandler( "get_mask3" );
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_oilcan()

  cmn.SetEventDone( "get_oilcan" );
  cmn.CallEventHandler( "get_oilcan" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_lvl3bowl()

  cmn.SetEventDone( "get_lvl3bowl" );
  cmn.CallEventHandler( "get_lvl3bowl" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_stoneoflight(num)

  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_crystal_take_1");

  local func_after = function ()

    cmn.SetEventDone( "clk_stoneoflight" );
    cmn.CallEventHandler( "clk_stoneoflight" );

    if num == 1 then
      cmn.Lock(0);
    else 
      private.use_stoneoflight_end();
    end;

  end;
  
  ObjSet("anm_fracture_broken_stone",  { playing = 1, endtrig = func_after });
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_apocalypse2()

  if not ( cmn.IsEventDone( "opn_apocalypse2" ) ) then
    cmn.SetEventDone( "opn_apocalypse2" );
    cmn.CallEventHandler("opn_apocalypse2");
    cmn.ShowBbt( "apocalypse2_open" );
    interface_impl.ShowGlobalTask();
    cmn.PlayAudio("mus", "assets/levels/level1/audio/mus/aud_mus_scare_1", 0, false, 123);
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_shadow()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_monster_1");
  
  local func_after = function ()
    
    cmn.Lock(0);
    ObjSet( "anm_fracture_shadow", { frame = 0, animfunc = "fearful_man_stay", playing = 1, endtrig = "" } );
    
  end;

  cmn.ShowBbt( "obj_fracture_use_lvl3gun" );
  
  ObjSet( "anm_fracture_shadow", { frame = 0, animfunc = "fearful_man_attack", playing = 1, endtrig = func_after } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_car_cover()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_inside_car");

  cmn.ShowBbt( "obj_policevan_use_policebadge" );
  
  ObjSet( "anm_policevan_cover_touch", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_doors_web()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_web_zz_museumdoors");
  
  local func_after = function ()
    
    cmn.Lock( 0 );
    
    ObjMultiSet( { {"anm_museumdoors_net_touch", { alp = 0 }},
                   {"anm_museumdoors_net", { alp = 1, playing = 1 }} } );
    
  end;
                 
  if not cmn.IsEventDone("get_lvl3bowl") then
    public.get_lvl3bowl();
  end;               

  cmn.ShowBbt( "obj_museumdoors_use_spideramulet" );
  
  ObjMultiSet( { {"anm_museumdoors_net_touch", { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_museumdoors_net", { alp = 0, playing = 0, frame = 0 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_museum_door()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_mmg_stones_zz_museumdoors");

  cmn.ShowBbt( "obj_museumdoors_use_museumheart" );
  
  ObjSet( "anm_museumdoors_door_touch", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Fracture *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_fracture = {};
public.zz_fracture = {};

function private.Init_Fracture()
  
  private.zz_fracture.active = false;
  private.zz_fracture.hp_size = 296;
  
  private.zz_fracture.anims = { "fearful_man_stay", "fearful_man_attack", "fearful_man_protection" };
  private.zz_fracture.sh_pos = { {-123, 23}, {25, 7}, {190, 63} };
  
  private.zz_fracture.speed = { 2, 2.5, 3, 4 };
  private.zz_fracture.pull = { 1, 2, 3 };
  private.zz_fracture.frame = 0;
  -----------------------------------------------------------------------------------
  game.hint[ "win_fracture" ] = {
    type = "win",
    room = "rm_apocalypse2",
    zz = "zz_fracture",
    zz_gate = "gzz_apocalypse2_fracture"
  };
  -----------------------------------------------------------------------------------
  local win_fracture = function ()

    if cmn.IsEventDone( "win_fracture" ) then
      
      ObjDelete( "obj_fracture_game" );
      ObjDelete( "obj_fracture_game_2" );
      ObjDelete( "spr_fracture_aim" );
      ObjDelete( "obj_fracture_gun" );
      ObjDelete( "anm_fracture_damage" );

      ObjDelete( "anm_apocalypse2_fracture_fearful_man" );
      
      ObjMultiSet( { {"obj_fracture_light_1", { input = 1 }},
                     {"spr_fracture_hole_1", { input = 0 }},
                     {"spr_fracture_hole_2", { input = 0 }} } );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_fracture", win_fracture, "rm_apocalypse2" );
  
end;
--*********************************************************************************************************************
function private.zz_fracture.StartConditions()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_fracture" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_fracture" ].state = { 4, 4 };
  
end;
-----------------------------------------------------------------------------------
function public.zz_fracture.Reset()
  
  local need_r = false;
  
  if private.zz_fracture.state[1] < 4 then
    
    need_r = true;
    
    local old = -math.floor(private.zz_fracture.hp_size*private.zz_fracture.state[1]/4);
    local new = -private.zz_fracture.hp_size;
    ObjAnimate("spr_fracture_game_hp_1", "croprect_y", 0, 0, "", { 0, 0, old,   0.5, 0, new });
    
  end;
  
  if private.zz_fracture.state[2] < 4 then
    
    need_r = true;
    
    local old = -math.floor(private.zz_fracture.hp_size*private.zz_fracture.state[2]/4);
    local new = -private.zz_fracture.hp_size;
    ObjAnimate("spr_fracture_game_hp_2", "croprect_y", 0, 0, "", { 0, 0, old,   0.5, 0, new });
    
  end;
  
  if need_r then
    
    cmn.StopAllEnv("assets/levels/level3/audio/env/aud_rm_apocalypse2_env");
    cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_apocalypse2_env");
    cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_coals_after_fire_env");
    
    cmn.Lock( 1 );
    private.zz_fracture.StartConditions();
    private.zz_fracture.state = ng_global.progress[ ng_global.currentprogress ][ "win_fracture" ].state;
    
    ObjMultiSet( { {"tmr_fracture_timer",  { playing = 1, endtrig = function() cmn.Lock(0); private.zz_fracture.SetShadow(); end }},
                   {"anm_fracture_shadow", { endtrig = "" }} } );
    
    if private.zz_fracture.active then
      ObjAnimate("obj_fracture_shadow", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_fracture.Skip()
  
  cmn.Lock( 1 );
  
  cmn.StopAllEnv("assets/levels/level3/audio/env/aud_rm_apocalypse2_env");
  cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_apocalypse2_env");
  cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_coals_after_fire_env");
  
  ng_global.progress[ ng_global.currentprogress ][ "win_fracture" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_fracture" ].state = { 4, 0 };
  
  private.zz_fracture.state = ng_global.progress[ ng_global.currentprogress ][ "win_fracture" ].state;
  
  ObjMultiSet( { {"tmr_fracture_timer",  { playing = 0, endtrig = "" }},
                 {"anm_fracture_shadow", { endtrig = "" }} } );
  
  if private.zz_fracture.active then
    ObjAnimate("obj_fracture_game", "alp", 0, 0, private.zz_fracture.CheckWin, { 0, 0, 1,   0.3, 0, 0 });
  else 
    private.zz_fracture.CheckWin();
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_fracture.DrawScene()
  
  ObjMultiSet( { {"spr_fracture_game_hp_1", { croprect_y = -math.floor(private.zz_fracture.hp_size*private.zz_fracture.state[1]/4) }},
                 {"spr_fracture_game_hp_2", { croprect_y = -math.floor(private.zz_fracture.hp_size*private.zz_fracture.state[2]/4) }} } );
  
  private.zz_fracture.AimTarget();
  
  if not private.zz_fracture.active then
    ObjSet("obj_fracture_shadow",  { alp = 0 });
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_fracture.ShadowAttack()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_monster_hits_mmg");
  
  private.zz_fracture.active = false;
  private.zz_fracture.state[1] = private.zz_fracture.state[1] - 1;
  
  local func_after = function ()
    
    cmn.StopAllEnv("assets/levels/level3/audio/env/aud_rm_apocalypse2_env");
    cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_apocalypse2_env");
    cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_coals_after_fire_env");
    
    ObjSet("anm_fracture_shadow",  { frame = 0, animfunc = private.zz_fracture.anims[1], playing = 1, endtrig = "" });
    ObjAnimate("obj_fracture_shadow", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    
    local old = -math.floor(private.zz_fracture.hp_size*(private.zz_fracture.state[1]+1)/4);
    local new = -math.floor(private.zz_fracture.hp_size*private.zz_fracture.state[1]/4);
    ObjAnimate("spr_fracture_game_hp_1", "croprect_y", 0, 0, private.zz_fracture.CheckWin, { 0, 0, old,   0.5, 0, new });
    
  end;
  
  ObjMultiSet( { {"anm_fracture_shadow",  { frame = 0, animfunc = private.zz_fracture.anims[2], playing = 1, endtrig = func_after }},
                 {"anm_fracture_damage", { playing = 1 }},
                 {"obj_fracture_shadow", { input = 0 }} } );
  
end;
-----------------------------------------------------------------------------------
function private.zz_fracture.SetShadow()
  
  local anm_act = function ()
    
    --local act = math.random(1, 2);
    
    --if act == 1 then
      private.zz_fracture.ShadowAttack();
    --else 
    --  
    --  ObjSet("obj_fracture_shadow",  { input = 0 });
    --  ObjAnimate("obj_fracture_shadow", "alp", 0, 0, private.zz_fracture.SetShadow, { 0, 0, 1,   0.3, 0, 0 });
    --  
    --end;
    
  end;
  
  local set_input = function ()
    ObjSet("obj_fracture_shadow",  { input = 1 });
  end;
  
  local anm_appear = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_monster_appears_mmg");
    cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_zz_facture_monster_env");
    
    private.zz_fracture.active = true;
    
    local len = #private.zz_fracture.pull;
    local ind = math.random(1, len);
    local pos = private.zz_fracture.pull[ind];
    
    if len > 1 then
      table.remove( private.zz_fracture.pull, ind );
    else 
      private.zz_fracture.pull = { 1, 2, 3 };
    end;
    
    ObjAnimate("obj_fracture_shadow", "alp", 0, 0, set_input, { 0, 0, 0,   0.3, 0, 1 });
    
    ObjMultiSet( { {"obj_fracture_shadow",  { pos_x = private.zz_fracture.sh_pos[pos][1], pos_y = private.zz_fracture.sh_pos[pos][2] }},
                   {"anm_fracture_shadow", { frame = 0, playing = 1, endtrig = anm_act }} } );
    
  end;
  
  local stage = private.zz_fracture.state[2];
  ObjSet("tmr_fracture_timer",  { time = private.zz_fracture.speed[stage], playing = 1, endtrig = anm_appear });
  
end;
-----------------------------------------------------------------------------------
function private.zz_fracture.AimTarget()
  
  local curs = GetZoomCursorPos();
  curs[1] = math.floor(curs[1]) - ObjGet("zz_fracture").pos_x;
  curs[2] = math.floor(curs[2]) - ObjGet("zz_fracture").pos_y;
  
  local weap_pos = curs[1];
  
  if curs[1] < -300 then
    curs[1] = -300;
  elseif curs[1] > 300 then
    curs[1] = 300;
  end;
  
  if curs[2] < -250 then
    curs[2] = -250;
  elseif curs[2] > 250 then
    curs[2] = 250;
  end;
  
  if weap_pos < -270 then
    weap_pos = -270;
  elseif weap_pos > 117 then
    weap_pos = 117;
  end;
  
  ObjMultiSet( { {"spr_fracture_aim", { pos_x = curs[1], pos_y = curs[2] }},
                 {"obj_fracture_gun", { pos_x = weap_pos }},
                 {"tmr_fracture_timer_aim", { time = 0.01, playing = 1, endtrig = private.zz_fracture.AimTarget }} } );
  
end;
-----------------------------------------------------------------------------------
function public.zz_fracture.ShootShadow()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_shot_monster_right");
  
  private.zz_fracture.active = false;
  private.zz_fracture.state[2] = private.zz_fracture.state[2] - 1;
  
  if private.zz_fracture.state[2] > 0 then
    local snd = 5-private.zz_fracture.state[2];
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_monster_rise_orchestra_mmg_"..snd);
  end;
  
  local func_after = function ()
    
    cmn.StopAllEnv("assets/levels/level3/audio/env/aud_rm_apocalypse2_env");
    cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_apocalypse2_env");
    cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_coals_after_fire_env");
    
    ObjMultiSet( { {"anm_fracture_shadow",  { frame = 0, animfunc = private.zz_fracture.anims[1], playing = 0, endtrig = "" }},
                   {"obj_fracture_shadow", { alp = 0 }} } );
    
    private.zz_fracture.CheckWin();
    
  end;
  
  local old = -math.floor(private.zz_fracture.hp_size*(private.zz_fracture.state[2]+1)/4);
  local new = -math.floor(private.zz_fracture.hp_size*private.zz_fracture.state[2]/4);
  ObjAnimate("spr_fracture_game_hp_2", "croprect_y", 0, 0, "", { 0, 0, old,   0.5, 0, new });
  
  local reset_gun = function ()
    ObjSet("anm_fracture_gun",  { frame = 0 });
  end;
  
  ObjMultiSet( { {"anm_fracture_shadow",  { frame = 0, animfunc = private.zz_fracture.anims[3], playing = 1, endtrig = func_after }},
                 {"obj_fracture_shadow", { input = 0 }} ,
                 {"anm_fracture_gun", { playing = 1, endtrig = reset_gun }}} );
  
end;
-----------------------------------------------------------------------------------
function private.zz_fracture.PlayShadow()
  
  ObjSet("anm_fracture_shadow",  { playing = 1, endtrig = private.zz_fracture.PlayShadow });
  
end;
-----------------------------------------------------------------------------------
function private.zz_fracture.CheckWin()
  
  if private.zz_fracture.state[2] == 0 then
    
    cmn.Lock( 1 );
    SetCursor( CURSOR_DEFAULT );
    
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_win_mmg_monster");
    
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("fracture");
    
    ObjAnimate("spr_fracture_aim", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 1,   1, 0, 0 });
    ObjAnimate("obj_fracture_game_2", "alp", 0, 0, private.zz_fracture.Win, { 0, 0, 1,   0.5, 0, 1,   1, 0, 0 });
    ObjAnimate("obj_fracture_gun", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 1,   1, 0, 0 });
    
  elseif private.zz_fracture.state[1] == 0 then
    public.zz_fracture.Reset();
  else
    
    cmn.Lock( 0 );
    
    if not private.zz_fracture.active then
      private.zz_fracture.SetShadow();
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_fracture.Win()
  
  cmn.Lock( 0 );
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_fracture" );
  cmn.CallEventHandler( "win_fracture" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_fracture" ].skip == 0 and ng_global.noskipgames[ "win_fracture" ] == nil then

    ng_global.noskipgames[ "win_fracture" ] = 1;
    common_impl.CheckAchiev("mg");

  end;
  
end;
--*********************************************************************************************************************
