-- name=rm_apocalypse3
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_apocalypse3";
  --------------------------------------------------------------------------------------------
  private.dlg_lipsync = "";
  private.Init_Subroom();
  --------------------------------------------------------------------------------------------
  -- function get_scoopnet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_scoopnet" ] = {
    type = "get",
    get_obj = "spr_sarcophagus_scoopnet",
    room = private.room_objname,
    zz = "zz_sarcophagus",
    zz_gate = "gzz_apocalypse3_sarcophagus"
  };
  --------------------------------------------------------------------------------------------
  local get_scoopnet_inv = function ()
  
    interface.InventoryItemAdd( "inv_scoopnet", "spr_sarcophagus_scoopnet" );
  
  end;
  local get_scoopnet_end = function ()
  
    ObjDelete( "spr_sarcophagus_scoopnet_sh" );
    ObjDelete( "gfx_sarcophagus_scoopnet" );
    ObjDelete( "spr_sarcophagus_scoopnet_bl" );
    
    ObjDelete( "spr_apocalypse3_sarcophagus_scoopnet" );
  
  end;
  
  cmn.AddSubscriber( "get_scoopnet", get_scoopnet_inv );
  cmn.AddSubscriber( "get_scoopnet", get_scoopnet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_heart () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_heart" ] = {
    type = "get",
    get_obj = "obj_sarcophagus_heart",
    room = private.room_objname,
    zz = "zz_sarcophagus",
    zz_gate = "gzz_apocalypse3_sarcophagus"
  };
  --------------------------------------------------------------------------------------------
  local get_heart_inv = function ()
  
    interface.InventoryItemAdd( "inv_heart", "obj_sarcophagus_heart" );
  
  end;
  local get_heart_end = function ()
  
    ObjDelete( "gfx_sarcophagus_heart" );
    ObjDelete( "spr_sarcophagus_heart_shadow" );
    
    ObjDelete( "spr_apocalypse3_sarcophagus_heart" );
  
  end;
  
  cmn.AddSubscriber( "get_heart", get_heart_inv );
  cmn.AddSubscriber( "get_heart", get_heart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pattern2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_pattern2" ] = {
    type = "get",
    get_obj = "spr_sarcophagus_pattern2",
    room = private.room_objname,
    zz = "zz_sarcophagus",
    zz_gate = "gzz_apocalypse3_sarcophagus"
  };
  --------------------------------------------------------------------------------------------
  local get_pattern2_inv = function ()
  
    interface.InventoryItemAdd( "inv_pattern2", "spr_sarcophagus_pattern2" );
  
  end;
  local get_pattern2_end = function ()
  
    ObjDelete( "gfx_sarcophagus_pattern2" );
    ObjDelete( "spr_apocalypse3_sarcophagus_pattern" );
  
  end;
  
  cmn.AddSubscriber( "get_pattern2", get_pattern2_inv );
  cmn.AddSubscriber( "get_pattern2", get_pattern2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_warrior2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_warrior2" ] = {
    type = "get",
    get_obj = "spr_sarcophagus_warrior2",
    room = private.room_objname,
    zz = "zz_sarcophagus",
    zz_gate = "gzz_apocalypse3_sarcophagus"
  };
  --------------------------------------------------------------------------------------------
  local get_warrior2_inv = function ()
  
    interface.InventoryItemAdd( "inv_warrior2", "spr_sarcophagus_warrior2" );
  
  end;
  local get_warrior2_end = function ()
  
    ObjDelete( "gfx_sarcophagus_warrior2" );
    ObjDelete( "spr_sarcophagus_warrior2_sh" );
    
    ObjDelete( "spr_apocalypse3_sarcophagus_card" );
    
    if cmn.IsEventDone("get_zodiacsign4") then
      ObjSet( "gzz_apocalypse3_sarcophagus", { active = false, input = true, alp = 0 } );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_warrior2", get_warrior2_inv );
  cmn.AddSubscriber( "get_warrior2", get_warrior2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_zodiacsign4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_zodiacsign4" ] = {
    type = "get",
    get_obj = "spr_sarcophagus_zodiacsign10",
    room = private.room_objname,
    zz = "zz_sarcophagus",
    zz_gate = "gzz_apocalypse3_sarcophagus"
  };
  --------------------------------------------------------------------------------------------
  local get_zodiacsign4_inv = function ()
  
    interface.InventoryItemAdd( "inv_zodiacsign", "spr_sarcophagus_zodiacsign10", function () cmn.GetMultyObject( 'zodiacsign', 4 ); end );
  
  end;
  local get_zodiacsign4_end = function ()
    
    if cmn.IsEventDone("get_warrior2") then
      ObjSet( "gzz_apocalypse3_sarcophagus", { active = false, input = true, alp = 0 } );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_zodiacsign4", get_zodiacsign4_inv );
  cmn.AddSubscriber( "get_zodiacsign4", get_zodiacsign4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl3valve () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl3valve" ] = {
    type = "get",
    get_obj = "spr_showcase_lvl3valve",
    room = private.room_objname,
    zz = "zz_showcase",
    zz_gate = "gzz_apocalypse3_showcase"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl3valve_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl3valve", "spr_showcase_lvl3valve" );
  
  end;
  local get_lvl3valve_end = function ()
  
    ObjDelete( "gfx_showcase_lvl3valve" );
    ObjDelete( "spr_showcase_lvl3valve_sh" );
    
    ObjDelete( "spr_apocalypse3_showcase_valve" );
    ObjDelete( "gzz_apocalypse3_showcase" );
    
  end;
  
  cmn.AddSubscriber( "get_lvl3valve", get_lvl3valve_inv );
  cmn.AddSubscriber( "get_lvl3valve", get_lvl3valve_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mask1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_mask1" ] = {
    type = "get",
    get_obj = "spr_showcase_mask1",
    room = private.room_objname,
    zz = "zz_showcase",
    zz_gate = "gzz_apocalypse3_showcase"
  };
  --------------------------------------------------------------------------------------------
  local get_mask1_inv = function ()
  
    interface.InventoryItemAdd( "inv_mask1", "spr_showcase_mask1" );
  
  end;
  local get_mask1_end = function ()
  
    ObjDelete( "gfx_showcase_mask1" );
    ObjDelete( "spr_showcase_mask1_shadow" );
    
    ObjDelete( "spr_apocalypse3_showcase_mask" );
  
  end;
  
  cmn.AddSubscriber( "get_mask1", get_mask1_inv );
  cmn.AddSubscriber( "get_mask1", get_mask1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tuningfork () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_tuningfork" ] = {
    type = "get",
    get_obj = "spr_showcase_tuningfork",
    room = private.room_objname,
    zz = "zz_showcase",
    zz_gate = "gzz_apocalypse3_showcase"
  };
  --------------------------------------------------------------------------------------------
  local get_tuningfork_inv = function ()
  
    interface.InventoryItemAdd( "inv_tuningfork", "spr_showcase_tuningfork" );
  
  end;
  local get_tuningfork_end = function ()
  
    ObjDelete( "gfx_showcase_tuningfork" );
    ObjDelete( "spr_showcase_tuningfork_sh" );
    
    ObjDelete( "spr_apocalypse3_showcase_fork" );
  
  end;
  
  cmn.AddSubscriber( "get_tuningfork", get_tuningfork_inv );
  cmn.AddSubscriber( "get_tuningfork", get_tuningfork_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_boxpart2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_boxpart2" ] = {
    type = "get",
    get_obj = "spr_showcase_boxpart2",
    room = private.room_objname,
    zz = "zz_showcase",
    zz_gate = "gzz_apocalypse3_showcase"
  };
  --------------------------------------------------------------------------------------------
  local get_boxpart2_inv = function ()
  
    interface.InventoryItemAdd( "inv_boxpart", "spr_showcase_boxpart2", function () cmn.GetMultyObject( 'boxpart', 4 ); end );
      
    if cmn.CheckMultiObject( "boxpart", 4 ) then
      ObjSet("inv_pandorasbox_star_light",  { alp = 1 });
    end;
  
  end;
  local get_boxpart2_end = function ()
  
    ObjDelete( "gfx_showcase_boxpart2" );
    ObjDelete( "spr_showcase_boxpart2_sh" );
    
    ObjDelete( "spr_apocalypse3_showcase_boxpart" );
  
  end;
  
  cmn.AddSubscriber( "get_boxpart2", get_boxpart2_inv );
  cmn.AddSubscriber( "get_boxpart2", get_boxpart2_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_skullamulet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_skullamulet" ] = {
    type = "get",
    get_obj = "spr_showpiece_skullamulet",
    room = private.room_objname,
    zz = "zz_showpiece",
    zz_gate = "gzz_apocalypse3_showpiece"
  };
  --------------------------------------------------------------------------------------------
  local get_skullamulet_inv = function ()
  
    interface.InventoryItemAdd( "inv_skullamulet", "spr_showpiece_skullamulet" );
      
  end;
  local get_skullamulet_end = function ()
  
    ObjDelete( "gfx_showpiece_skullamulet" );
    ObjDelete( "spr_showpiece_skullamulet_shadow" );
    
    ObjDelete( "spr_apocalypse3_showpiece_skull" );
  
  end;
  
  cmn.AddSubscriber( "get_skullamulet", get_skullamulet_inv );
  cmn.AddSubscriber( "get_skullamulet", get_skullamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mask4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_mask4" ] = {
    type = "get",
    get_obj = "spr_showpiece_mask4",
    room = private.room_objname,
    zz = "zz_showpiece",
    zz_gate = "gzz_apocalypse3_showpiece"
  };
  --------------------------------------------------------------------------------------------
  local get_mask4_inv = function ()
  
    interface.InventoryItemAdd( "inv_mask4", "spr_showpiece_mask4" );
      
  end;
  local get_mask4_end = function ()
  
    ObjDelete( "gfx_showpiece_mask4" );
    ObjDelete( "spr_showpiece_mask4_sh" );
    
    ObjDelete( "spr_apocalypse3_showpiece_mask" );
  
  end;
  
  cmn.AddSubscriber( "get_mask4", get_mask4_inv );
  cmn.AddSubscriber( "get_mask4", get_mask4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_boxpart3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_boxpart3" ] = {
    type = "get",
    get_obj = "spr_showpiece_boxpart3",
    room = private.room_objname,
    zz = "zz_showpiece",
    zz_gate = "gzz_apocalypse3_showpiece"
  };
  --------------------------------------------------------------------------------------------
  local get_boxpart3_inv = function ()
  
    interface.InventoryItemAdd( "inv_boxpart", "spr_showpiece_boxpart3", function () cmn.GetMultyObject( 'boxpart', 4 ); end );
      
    if cmn.CheckMultiObject( "boxpart", 4 ) then
      ObjSet("inv_pandorasbox_star_light",  { alp = 1 });
    end;
  
  end;
  local get_boxpart3_end = function ()
  
    ObjDelete( "gfx_showpiece_boxpart3" );
    ObjDelete( "spr_showpiece_boxpart3_sh" );
    
    ObjDelete( "spr_apocalypse3_showpiece_boxpart" );
  
  end;
  
  cmn.AddSubscriber( "get_boxpart3", get_boxpart3_inv );
  cmn.AddSubscriber( "get_boxpart3", get_boxpart3_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_figurine () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_figurine" ] = {
      type = "get",
      get_obj = "spr_apocalypse3_figurine",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_figurine_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_figurine", "spr_apocalypse3_figurine" );
  
  end;
  local get_figurine_mid = function ()
  
    ObjDelete( "gfx_apocalypse3_figurine" );
    
    ObjSet("obj_apocalypse3_use_heart",  { alp = 1 });
  
  end;
  local get_figurine_end = function ()
  
    ObjDelete( "obj_apocalypse3_dialog_naya1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_figurine", get_figurine_inv );
  cmn.AddSubscriber( "get_figurine_inv", get_figurine_inv, private.room_objname );
  cmn.AddSubscriber( "get_figurine", get_figurine_mid, private.room_objname );
  cmn.AddSubscriber( "get_figurine_mid", get_figurine_mid, private.room_objname );
  cmn.AddSubscriber( "get_figurine", get_figurine_end, private.room_objname );
  cmn.AddSubscriber( "get_figurine_end", get_figurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_goreseye () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_goreseye" ] = {
      type = "get",
      get_obj = "obj_apocalypse3_goreseye_hint",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_goreseye_inv = function ()
  
    interface.InventoryItemAdd( "inv_goreseye", "spr_apocalypse3_goreseye" );
  
  end;
  local get_goreseye_mid = function ()
  
    ObjDelete( "gfx_apocalypse3_goreseye" );
    
  end;
  local get_goreseye_end = function ()
  
    ObjDelete( "obj_apocalypse3_dialog_naya2" );
  
  end;
  local get_goreseye_loc_1 = function ()
  
    ObjDelete( "obj_bench_sign_bbt" );
    ObjSet("obj_bench_use_goreseye5",  { input = 1 });
  
  end;
  local get_goreseye_loc_2 = function ()
    
    ObjDelete( "obj_fracture_sign_bbt" );
    ObjDelete( "obj_oldfountain_sign_bbt" );
  
    ObjMultiSet( { {"obj_fracture_use_goreseye7", { input = 1 }},
                   {"obj_oldfountain_use_goreseye8", { input = 1 }} } );
  
  end;
  local get_goreseye_loc_3 = function ()
    
    ObjDelete( "obj_sarcophagus_sign_bbt" );
    ObjSet("obj_sarcophagus_use_goreseye10",  { input = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_goreseye", get_goreseye_inv );
  cmn.AddSubscriber( "get_goreseye_inv", get_goreseye_inv, private.room_objname );
  cmn.AddSubscriber( "get_goreseye", get_goreseye_mid, private.room_objname );
  cmn.AddSubscriber( "get_goreseye_mid", get_goreseye_mid, private.room_objname );
  cmn.AddSubscriber( "get_goreseye", get_goreseye_end, private.room_objname );
  cmn.AddSubscriber( "get_goreseye_end", get_goreseye_end, private.room_objname );
  
  cmn.AddSubscriber( "get_goreseye", get_goreseye_loc_1, "rm_apocalypse1" );
  cmn.AddSubscriber( "get_goreseye_loc_1", get_goreseye_loc_1, "rm_apocalypse1" );
  cmn.AddSubscriber( "get_goreseye", get_goreseye_loc_2, "rm_apocalypse2" );
  cmn.AddSubscriber( "get_goreseye_loc_2", get_goreseye_loc_2, "rm_apocalypse2" );
  cmn.AddSubscriber( "get_goreseye", get_goreseye_loc_3, private.room_objname );
  cmn.AddSubscriber( "get_goreseye_loc_3", get_goreseye_loc_3, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_tweezers () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_tweezers" ] = {
    type = "use",
    inv_obj = "inv_tweezers",
    use_place = "obj_sarcophagus_use_tweezers",
    room = private.room_objname,
    zz = "zz_sarcophagus",
    zz_gate = "gzz_apocalypse3_sarcophagus"
  };
  --------------------------------------------------------------------------------------------
  local use_tweezers_inv = function ()
  
    interface.InventoryItemRemove( "inv_tweezers" );
  
  end;
  local use_tweezers_beg = function ()
  
    ObjDelete( "obj_sarcophagus_use_tweezers" );
    ObjDelete( "anm_sarcophagus_pattern_touch" );
  
  end;
  local use_tweezers_end = function ()
  
    ObjDelete( "anm_sarcophagus_tweezers_use" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tweezers", use_tweezers_beg, private.room_objname );
  cmn.AddSubscriber( "use_tweezers", use_tweezers_inv );
  cmn.AddSubscriber( "use_tweezers", use_tweezers_end, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_inv", use_tweezers_inv, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_beg", use_tweezers_beg, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_end", use_tweezers_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mask2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_mask2" ] = {
    type = "use",
    inv_obj = "inv_mask2",
    use_place = "obj_sarcophagus_use_mask2",
    room = private.room_objname,
    zz = "zz_sarcophagus",
    zz_gate = "gzz_apocalypse3_sarcophagus"
  };
  --------------------------------------------------------------------------------------------
  local use_mask2_inv = function ()
  
    interface.InventoryItemRemove( "inv_mask2" );
  
  end;
  local use_mask2_beg = function ()
  
    ObjDelete( "obj_sarcophagus_use_mask2" );
    if cmn.IsEventDone("use_mask1") and cmn.IsEventDone("use_mask3") and cmn.IsEventDone("use_mask4") then
      ObjSet("obj_sarcophagus_inside",  { alp = 1 });
    end;
  
  end;
  local use_mask2_end = function ()
    
    if cmn.IsEventDone("use_mask1") and cmn.IsEventDone("use_mask3") and cmn.IsEventDone("use_mask4") then
      ObjDelete( "obj_sarcophagus_closed" );
      ObjDelete( "obj_apocalypse3_sarcophagus_face" );
      ObjMultiSet( { {"obj_sarcophagus_inside", { input = 1 }},
                     {"spr_sarcophagus_open", { alp = 1 }},
                     {"spr_apocalypse3_sarcophagus", { alp = 1 }} } );
    else
      ObjMultiSet( { {"spr_sarcophagus_mask_2",  { alp = 1 }},
                     {"spr_apocalypse3_sarcophagus_face_2", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mask2", use_mask2_beg, private.room_objname );
  cmn.AddSubscriber( "use_mask2", use_mask2_inv );
  cmn.AddSubscriber( "use_mask2", use_mask2_end, private.room_objname );
  cmn.AddSubscriber( "use_mask2_inv", use_mask2_inv, private.room_objname );
  cmn.AddSubscriber( "use_mask2_beg", use_mask2_beg, private.room_objname );
  cmn.AddSubscriber( "use_mask2_end", use_mask2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mask1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_mask1" ] = {
    type = "use",
    inv_obj = "inv_mask1",
    use_place = "obj_sarcophagus_use_mask1",
    room = private.room_objname,
    zz = "zz_sarcophagus",
    zz_gate = "gzz_apocalypse3_sarcophagus"
  };
  --------------------------------------------------------------------------------------------
  local use_mask1_inv = function ()
  
    interface.InventoryItemRemove( "inv_mask1" );
  
  end;
  local use_mask1_beg = function ()
  
    ObjDelete( "obj_sarcophagus_use_mask1" );
    if cmn.IsEventDone("use_mask2") and cmn.IsEventDone("use_mask3") and cmn.IsEventDone("use_mask4") then
      ObjSet("obj_sarcophagus_inside",  { alp = 1 });
    end;
  
  end;
  local use_mask1_end = function ()
    
    if cmn.IsEventDone("use_mask2") and cmn.IsEventDone("use_mask3") and cmn.IsEventDone("use_mask4") then
      ObjDelete( "obj_sarcophagus_closed" );
      ObjDelete( "obj_apocalypse3_sarcophagus_face" );
      ObjMultiSet( { {"obj_sarcophagus_inside", { input = 1 }},
                     {"spr_sarcophagus_open", { alp = 1 }},
                     {"spr_apocalypse3_sarcophagus", { alp = 1 }} } );
    else
      ObjMultiSet( { {"spr_sarcophagus_mask_1",  { alp = 1 }},
                     {"spr_apocalypse3_sarcophagus_face_1", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mask1", use_mask1_beg, private.room_objname );
  cmn.AddSubscriber( "use_mask1", use_mask1_inv );
  cmn.AddSubscriber( "use_mask1", use_mask1_end, private.room_objname );
  cmn.AddSubscriber( "use_mask1_inv", use_mask1_inv, private.room_objname );
  cmn.AddSubscriber( "use_mask1_beg", use_mask1_beg, private.room_objname );
  cmn.AddSubscriber( "use_mask1_end", use_mask1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mask3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_mask3" ] = {
    type = "use",
    inv_obj = "inv_mask3",
    use_place = "obj_sarcophagus_use_mask3",
    room = private.room_objname,
    zz = "zz_sarcophagus",
    zz_gate = "gzz_apocalypse3_sarcophagus"
  };
  --------------------------------------------------------------------------------------------
  local use_mask3_inv = function ()
  
    interface.InventoryItemRemove( "inv_mask3" );
  
  end;
  local use_mask3_beg = function ()
  
    ObjDelete( "obj_sarcophagus_use_mask3" );
    if cmn.IsEventDone("use_mask2") and cmn.IsEventDone("use_mask1") and cmn.IsEventDone("use_mask4") then
      ObjSet("obj_sarcophagus_inside",  { alp = 1 });
    end;
  
  end;
  local use_mask3_end = function ()
    
    if cmn.IsEventDone("use_mask2") and cmn.IsEventDone("use_mask1") and cmn.IsEventDone("use_mask4") then
      ObjDelete( "obj_sarcophagus_closed" );
      ObjDelete( "obj_apocalypse3_sarcophagus_face" );
      ObjMultiSet( { {"obj_sarcophagus_inside", { input = 1 }},
                     {"spr_sarcophagus_open", { alp = 1 }},
                     {"spr_apocalypse3_sarcophagus", { alp = 1 }} } );
    else
      ObjMultiSet( { {"spr_sarcophagus_mask_3",  { alp = 1 }},
                     {"spr_apocalypse3_sarcophagus_face_3", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mask3", use_mask3_beg, private.room_objname );
  cmn.AddSubscriber( "use_mask3", use_mask3_inv );
  cmn.AddSubscriber( "use_mask3", use_mask3_end, private.room_objname );
  cmn.AddSubscriber( "use_mask3_inv", use_mask3_inv, private.room_objname );
  cmn.AddSubscriber( "use_mask3_beg", use_mask3_beg, private.room_objname );
  cmn.AddSubscriber( "use_mask3_end", use_mask3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mask4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_mask4" ] = {
    type = "use",
    inv_obj = "inv_mask4",
    use_place = "obj_sarcophagus_use_mask4",
    room = private.room_objname,
    zz = "zz_sarcophagus",
    zz_gate = "gzz_apocalypse3_sarcophagus"
  };
  --------------------------------------------------------------------------------------------
  local use_mask4_inv = function ()
  
    interface.InventoryItemRemove( "inv_mask4" );
  
  end;
  local use_mask4_beg = function ()
  
    ObjDelete( "obj_sarcophagus_use_mask4" );
    if cmn.IsEventDone("use_mask2") and cmn.IsEventDone("use_mask1") and cmn.IsEventDone("use_mask3") then
      ObjSet("obj_sarcophagus_inside",  { alp = 1 });
    end;
  
  end;
  local use_mask4_end = function ()
    
    if cmn.IsEventDone("use_mask2") and cmn.IsEventDone("use_mask1") and cmn.IsEventDone("use_mask3") then
      ObjDelete( "obj_sarcophagus_closed" );
      ObjDelete( "obj_apocalypse3_sarcophagus_face" );
      ObjMultiSet( { {"obj_sarcophagus_inside", { input = 1 }},
                     {"spr_sarcophagus_open", { alp = 1 }},
                     {"spr_apocalypse3_sarcophagus", { alp = 1 }} } );
    else
      ObjMultiSet( { {"spr_sarcophagus_mask_4",  { alp = 1 }},
                     {"spr_apocalypse3_sarcophagus_face_4", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mask4", use_mask4_beg, private.room_objname );
  cmn.AddSubscriber( "use_mask4", use_mask4_inv );
  cmn.AddSubscriber( "use_mask4", use_mask4_end, private.room_objname );
  cmn.AddSubscriber( "use_mask4_inv", use_mask4_inv, private.room_objname );
  cmn.AddSubscriber( "use_mask4_beg", use_mask4_beg, private.room_objname );
  cmn.AddSubscriber( "use_mask4_end", use_mask4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_moonemblem () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_moonemblem" ] = {
    type = "use",
    inv_obj = "inv_moonemblem",
    use_place = "obj_showcase_use_moonemblem",
    room = private.room_objname,
    zz = "zz_showcase",
    zz_gate = "gzz_apocalypse3_showcase"
  };
  --------------------------------------------------------------------------------------------
  local use_moonemblem_inv = function ()
  
    interface.InventoryItemRemove( "inv_moonemblem" );
  
  end;
  local use_moonemblem_beg = function ()
  
    ObjDelete( "obj_showcase_use_moonemblem" );
  
  end;
  local use_moonemblem_end = function ()
  
    if cmn.IsEventDone("use_sunemblem") then
      ObjDelete("anm_showcase_sun");
      ObjDelete("anm_showcase_moon");
      ObjDelete("anm_showcase_glass_touch");
      ObjDelete("spr_apocalypse3_showcase_case_1");
      ObjMultiSet( { {"anm_showcase_glass_open",  { alp = 1, frame = 300 }},
                     {"obj_showcase_inside", { input = 1 }},
                     {"spr_apocalypse3_showcase_case_2", { alp = 1 }} } );
    else
      ObjMultiSet( { {"anm_showcase_moon",  { alp = 1, frame = 0, animfunc = "func_clk_moon", endtrig = "", pos_z = 6 }},
                     {"spr_apocalypse3_showcase_moon", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_moonemblem", use_moonemblem_beg, private.room_objname );
  cmn.AddSubscriber( "use_moonemblem", use_moonemblem_inv );
  cmn.AddSubscriber( "use_moonemblem", use_moonemblem_end, private.room_objname );
  cmn.AddSubscriber( "use_moonemblem_inv", use_moonemblem_inv, private.room_objname );
  cmn.AddSubscriber( "use_moonemblem_beg", use_moonemblem_beg, private.room_objname );
  cmn.AddSubscriber( "use_moonemblem_end", use_moonemblem_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pattern2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_pattern2" ] = {
    type = "use",
    inv_obj = "inv_pattern2",
    use_place = "obj_showcase_use_pattern2",
    room = private.room_objname,
    zz = "zz_showcase",
    zz_gate = "gzz_apocalypse3_showcase"
  };
  --------------------------------------------------------------------------------------------
  local use_pattern2_inv = function ()
  
    interface.InventoryItemRemove( "inv_pattern2" );
  
  end;
  local use_pattern2_beg = function ()
  
    ObjDelete( "obj_showcase_use_pattern2" );
    if cmn.IsEventDone("use_pattern1") then
      ObjSet( "obj_showcase_inside_box", { alp = 1 } );
    end;
  
  end;
  local use_pattern2_end = function ()
  
    if cmn.IsEventDone("use_pattern1") and cmn.IsEventDone("use_pattern3") then
      ObjDelete( "anm_showcase_box_touch" );
      ObjDelete( "anm_showcase_pattern_1" );
      ObjDelete( "spr_apocalypse3_showcase_box_closed" );
      ObjMultiSet( { {"obj_showcase_inside_box", { input = 1 }},
                     {"spr_showcase_box_open", { alp = 1 }},
                     {"spr_apocalypse3_showcase_box_open", { alp = 1 }} } );
    else
      ObjMultiSet( { {"anm_showcase_pattern_2",  { alp = 1, frame = 300 }},
                     {"spr_apocalypse3_showcase_pattern_2", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pattern2", use_pattern2_beg, private.room_objname );
  cmn.AddSubscriber( "use_pattern2", use_pattern2_inv );
  cmn.AddSubscriber( "use_pattern2", use_pattern2_end, private.room_objname );
  cmn.AddSubscriber( "use_pattern2_inv", use_pattern2_inv, private.room_objname );
  cmn.AddSubscriber( "use_pattern2_beg", use_pattern2_beg, private.room_objname );
  cmn.AddSubscriber( "use_pattern2_end", use_pattern2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sunemblem () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_sunemblem" ] = {
    type = "use",
    inv_obj = "inv_sunemblem",
    use_place = "obj_showcase_use_sunemblem",
    room = private.room_objname,
    zz = "zz_showcase",
    zz_gate = "gzz_apocalypse3_showcase"
  };
  --------------------------------------------------------------------------------------------
  local use_sunemblem_inv = function ()
  
    interface.InventoryItemRemove( "inv_sunemblem" );
  
  end;
  local use_sunemblem_beg = function ()
  
    ObjDelete( "obj_showcase_use_sunemblem" );
  
  end;
  local use_sunemblem_end = function ()
  
    if cmn.IsEventDone("use_moonemblem") then
      ObjDelete("anm_showcase_sun");
      ObjDelete("anm_showcase_moon");
      ObjDelete("anm_showcase_glass_touch");
      ObjDelete("spr_apocalypse3_showcase_case_1");
      ObjMultiSet( { {"anm_showcase_glass_open",  { alp = 1, frame = 300 }},
                     {"obj_showcase_inside", { input = 1 }},
                     {"spr_apocalypse3_showcase_case_2", { alp = 1 }} } );
    else
      ObjMultiSet( { {"anm_showcase_sun",  { alp = 1, frame = 0, animfunc = "func_clk_sun", endtrig = "", pos_z = 6 }},
                     {"spr_apocalypse3_showcase_sun", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sunemblem", use_sunemblem_beg, private.room_objname );
  cmn.AddSubscriber( "use_sunemblem", use_sunemblem_inv );
  cmn.AddSubscriber( "use_sunemblem", use_sunemblem_end, private.room_objname );
  cmn.AddSubscriber( "use_sunemblem_inv", use_sunemblem_inv, private.room_objname );
  cmn.AddSubscriber( "use_sunemblem_beg", use_sunemblem_beg, private.room_objname );
  cmn.AddSubscriber( "use_sunemblem_end", use_sunemblem_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pattern1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_pattern1" ] = {
    type = "use",
    inv_obj = "inv_pattern1",
    use_place = "obj_showcase_use_pattern1",
    room = private.room_objname,
    zz = "zz_showcase",
    zz_gate = "gzz_apocalypse3_showcase"
  };
  --------------------------------------------------------------------------------------------
  local use_pattern1_inv = function ()
  
    interface.InventoryItemRemove( "inv_pattern1" );
  
  end;
  local use_pattern1_beg = function ()
  
    ObjDelete( "obj_showcase_use_pattern1" );
    if cmn.IsEventDone("use_pattern2") then
      ObjSet( "obj_showcase_inside_box", { alp = 1 } );
    end;
  
  end;
  local use_pattern1_end = function ()
    
    ObjMultiSet( { {"anm_showcase_pattern_1",  { alp = 1, frame = 300 }},
                   {"spr_apocalypse3_showcase_pattern_1", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_pattern2") and cmn.IsEventDone("use_pattern3") then
      ObjDelete( "anm_showcase_box_touch" );
      ObjDelete( "anm_showcase_pattern_1" );
      ObjDelete( "spr_apocalypse3_showcase_box_closed" );
      ObjMultiSet( { {"obj_showcase_inside_box", { input = 1 }},
                     {"spr_showcase_box_open", { alp = 1 }},
                     {"spr_apocalypse3_showcase_box_open", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pattern1", use_pattern1_beg, private.room_objname );
  cmn.AddSubscriber( "use_pattern1", use_pattern1_inv );
  cmn.AddSubscriber( "use_pattern1", use_pattern1_end, private.room_objname );
  cmn.AddSubscriber( "use_pattern1_inv", use_pattern1_inv, private.room_objname );
  cmn.AddSubscriber( "use_pattern1_beg", use_pattern1_beg, private.room_objname );
  cmn.AddSubscriber( "use_pattern1_end", use_pattern1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pattern3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_pattern3" ] = {
    type = "use",
    inv_obj = "inv_pattern3",
    use_place = "obj_showcase_use_pattern3",
    room = private.room_objname,
    zz = "zz_showcase",
    zz_gate = "gzz_apocalypse3_showcase"
  };
  --------------------------------------------------------------------------------------------
  local use_pattern3_inv = function ()
  
    interface.InventoryItemRemove( "inv_pattern3" );
  
  end;
  local use_pattern3_beg = function ()
  
    ObjDelete( "obj_showcase_use_pattern3" );
    if cmn.IsEventDone("use_pattern2") then
      ObjSet( "obj_showcase_inside_box", { alp = 1 } );
    end;
  
  end;
  local use_pattern3_end = function ()
    
    ObjMultiSet( { {"anm_showcase_pattern_3",  { alp = 1, frame = 300 }},
                   {"spr_apocalypse3_showcase_pattern_3", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_pattern1") and cmn.IsEventDone("use_pattern2") then
      ObjDelete( "anm_showcase_box_touch" );
      ObjDelete( "anm_showcase_pattern_1" );
      ObjDelete( "spr_apocalypse3_showcase_box_closed" );
      ObjMultiSet( { {"obj_showcase_inside_box", { input = 1 }},
                     {"spr_showcase_box_open", { alp = 1 }},
                     {"spr_apocalypse3_showcase_box_open", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pattern3", use_pattern3_beg, private.room_objname );
  cmn.AddSubscriber( "use_pattern3", use_pattern3_inv );
  cmn.AddSubscriber( "use_pattern3", use_pattern3_end, private.room_objname );
  cmn.AddSubscriber( "use_pattern3_inv", use_pattern3_inv, private.room_objname );
  cmn.AddSubscriber( "use_pattern3_beg", use_pattern3_beg, private.room_objname );
  cmn.AddSubscriber( "use_pattern3_end", use_pattern3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_warrior1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_warrior1" ] = {
    type = "use",
    inv_obj = "inv_warrior1",
    use_place = "obj_showpiece_use_groundkeepersmap",
    room = private.room_objname,
    zz = "zz_showpiece",
    zz_gate = "gzz_apocalypse3_showpiece"
  };
  --------------------------------------------------------------------------------------------
  local use_warrior1_inv = function ()
  
    interface.InventoryItemRemove( "inv_warrior1" );
  
  end;
  local use_warrior1_beg = function ()
  
    if cmn.IsEventDone("use_warrior2") then
      ObjDelete( "obj_showpiece_use_groundkeepersmap" );
      ObjDelete( "obj_showpiece_use_groundkeepersmap_2" );
    end;
  
  end;
  local use_warrior1_end = function ()
    
    ObjSet("spr_apocalypse3_showpiece_warrior1",  { alp = 1 });
    
    if cmn.IsEventDone("use_warrior2") then
    
      ObjDelete( "spr_apocalypse3_showpiece_dome" );
      ObjDelete( "anm_showpiece_use_warrior1" );
      ObjDelete( "anm_showpiece_use_warrior2" );
      ObjDelete( "anm_showpiece_table" );

      ObjMultiSet( {
        { "gho_apocalypse3_installation", { active = 1, input = 1, alp = 1 } },
        { "gzz_apocalypse3_showpiece",  { active = 0, input = 0, alp = 0 } },
        { "anm_showpiece_table_open", { alp = 1, frame = 300 } }
      } );
      
    else 
      ObjSet("anm_showpiece_use_warrior1",  { alp = 1, frame = 300, pos_z = 3 });
    end;
      
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_warrior1", use_warrior1_beg, private.room_objname );
  cmn.AddSubscriber( "use_warrior1", use_warrior1_inv );
  cmn.AddSubscriber( "use_warrior1", use_warrior1_end, private.room_objname );
  cmn.AddSubscriber( "use_warrior1_inv", use_warrior1_inv, private.room_objname );
  cmn.AddSubscriber( "use_warrior1_beg", use_warrior1_beg, private.room_objname );
  cmn.AddSubscriber( "use_warrior1_end", use_warrior1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_warrior2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_warrior2" ] = {
    type = "use",
    inv_obj = "inv_warrior2",
    use_place = "obj_showpiece_use_groundkeepersmap",
    room = private.room_objname,
    zz = "zz_showpiece",
    zz_gate = "gzz_apocalypse3_showpiece"
  };
  --------------------------------------------------------------------------------------------
  local use_warrior2_inv = function ()
  
    interface.InventoryItemRemove( "inv_warrior2" );
  
  end;
  local use_warrior2_beg = function ()
  
    if cmn.IsEventDone("use_warrior1") then
      ObjDelete( "obj_showpiece_use_groundkeepersmap" );
      ObjDelete( "obj_showpiece_use_groundkeepersmap_2" );
    end;
  
  end;
  local use_warrior2_end = function ()
    
    ObjSet("spr_apocalypse3_showpiece_warrior2",  { alp = 1 });
    
    if cmn.IsEventDone("use_warrior1") then
    
      ObjDelete( "spr_apocalypse3_showpiece_dome" );
      ObjDelete( "anm_showpiece_use_warrior1" );
      ObjDelete( "anm_showpiece_use_warrior2" );
      ObjDelete( "anm_showpiece_table" );

      ObjMultiSet( {
        { "gho_apocalypse3_installation", { active = 1, input = 1, alp = 1 } },
        { "gzz_apocalypse3_showpiece",  { active = 0, input = 0, alp = 0 } },
        { "anm_showpiece_table_open", { alp = 1, frame = 300 } }
      } );
      
    else 
      ObjSet("anm_showpiece_use_warrior2",  { alp = 1, frame = 300, pos_z = 3 });
    end;
      
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_warrior2", use_warrior2_beg, private.room_objname );
  cmn.AddSubscriber( "use_warrior2", use_warrior2_inv );
  cmn.AddSubscriber( "use_warrior2", use_warrior2_end, private.room_objname );
  cmn.AddSubscriber( "use_warrior2_inv", use_warrior2_inv, private.room_objname );
  cmn.AddSubscriber( "use_warrior2_beg", use_warrior2_beg, private.room_objname );
  cmn.AddSubscriber( "use_warrior2_end", use_warrior2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tuningfork () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_tuningfork" ] = {
    type = "use",
    inv_obj = "inv_tuningfork",
    use_place = "obj_showpiece_use_tuningfork",
    room = private.room_objname,
    zz = "zz_showpiece",
    zz_gate = "gzz_apocalypse3_showpiece"
  };
  --------------------------------------------------------------------------------------------
  local use_tuningfork_inv = function ()
  
    interface.InventoryItemRemove( "inv_tuningfork" );
  
  end;
  local use_tuningfork_beg = function ()
  
    ObjDelete( "obj_showpiece_use_tuningfork" );

    ObjMultiSet( {
      { "obj_showpiece_skullamulet", { anim_tag = "tag_skullamulet" } },
      { "spr_showpiece_skullamulet", { anim_tag = "tag_skullamulet" } },
      { "obj_showpiece_skullamulet_shadow", { anim_tag = "tag_skullamulet_shadow" } },
      { "obj_showpiece_boxpart3", { anim_tag = "tag_boxpart3" } },
      { "spr_showpiece_boxpart3", { anim_tag = "tag_boxpart3" } },
      { "obj_showpiece_boxpart3_sh", { anim_tag = "tag_boxpart3_shadow" } }
    } );
  
  end;
  local use_tuningfork_end = function ()
    
    ObjDelete( "spr_apocalypse3_showpiece_glass_1" );
  
    ObjMultiSet( {
      { "anm_showpiece_box", { animfunc = "func_tuningfork_use", frame = 300, input = 1 } },
      { "spr_apocalypse3_showpiece_glass_2", { alp = 1 } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tuningfork", use_tuningfork_beg, private.room_objname );
  cmn.AddSubscriber( "use_tuningfork", use_tuningfork_inv );
  cmn.AddSubscriber( "use_tuningfork", use_tuningfork_end, private.room_objname );
  cmn.AddSubscriber( "use_tuningfork_inv", use_tuningfork_inv, private.room_objname );
  cmn.AddSubscriber( "use_tuningfork_beg", use_tuningfork_beg, private.room_objname );
  cmn.AddSubscriber( "use_tuningfork_end", use_tuningfork_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_heart () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_heart" ] = {
    type = "use",
    inv_obj = "inv_heart",
    use_place = "obj_apocalypse3_use_heart",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local use_heart_inv = function ()
  
    interface.InventoryItemRemove( "inv_heart" );
  
  end;
  local use_heart_beg = function ()
  
    ObjDelete( "obj_apocalypse3_use_heart" );
  
  end;
  local use_heart_end = function ()
    
    ObjDelete( "vid_apocalypse3_dialog_naya2_lipsync1" );
    ObjDelete( "vid_apocalypse3_dialog_naya2_lipsync2" );
    ObjDelete( "vid_apocalypse3_dialog_naya2_lipsync3" );
  
    ObjDelete( "anm_apocalypse3_dialog_naya2_hand_1" );
    ObjDelete( "anm_apocalypse3_dialog_naya2_hand_give" );
    
    ObjAttach("obj_apocalypse3_dialog_naya2", "rm_apocalypse3");
    
    ObjMultiSet( { {"obj_apocalypse3_dialog_naya2", { alp = 1, input = 1 }},
                   {"obj_apocalypse3_dialog_naya2_hand_2", { alp = 1, input = 1 }},
                   {"anm_apocalypse3_dialog_naya2_head", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_heart", use_heart_beg, private.room_objname );
  cmn.AddSubscriber( "use_heart", use_heart_inv );
  cmn.AddSubscriber( "use_heart", use_heart_end, private.room_objname );
  cmn.AddSubscriber( "use_heart_inv", use_heart_inv, private.room_objname );
  cmn.AddSubscriber( "use_heart_beg", use_heart_beg, private.room_objname );
  cmn.AddSubscriber( "use_heart_end", use_heart_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_dlgnayastart () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_dlgnayastart" ] = {
    type = "click",
    use_place = "obj_apocalypse3_clk_dlgnayastart",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local clk_dlgnayastart_beg = function ()
  
    ObjDelete( "obj_apocalypse3_clk_dlgnayastart" );
  
  end;
  local clk_dlgnayastart_end = function ()
    
    ObjDelete( "anm_apocalypse3_dialog_naya1_hand_1" );
    ObjDelete( "anm_apocalypse3_dialog_naya1_hand_give" );
    
    ObjDelete( "vid_apocalypse3_dialog_naya1_lipsync1" );
    ObjDelete( "vid_apocalypse3_dialog_naya1_lipsync2" );
  
    ObjAttach("obj_apocalypse3_dialog_naya1", "rm_apocalypse3");
    
    ObjMultiSet( { {"obj_apocalypse3_dialog_naya1", { alp = 1, input = 1 }},
                   {"obj_apocalypse3_dialog_naya1_hand_2", { alp = 1, input = 1 }},
                   {"obj_apocalypse3_use_heart", { alp = 1, input = 1 }},
                   {"anm_apocalypse3_dialog_naya1_head", { alp = 1 }},
                   {"gzz_apocalypse3_sarcophagus", { event_mdown = function() cmn.GotoSubRoomMDown( "apocalypse3_sarcophagus" ); end, event_mup = function() cmn.GotoSubRoomMUp( "apocalypse3_sarcophagus", "zz_sarcophagus", false, true ); end } },
                   {"gzz_apocalypse3_showcase", { event_mdown = function() cmn.GotoSubRoomMDown( "apocalypse3_showcase" ); end, event_mup = function() cmn.GotoSubRoomMUp( "apocalypse3_showcase", "zz_showcase" ); end } },
                   {"gzz_apocalypse3_showpiece", { event_mdown = function() cmn.GotoSubRoomMDown( "apocalypse3_showpiece" ); end, event_mup = function() cmn.GotoSubRoomMUp( "apocalypse3_showpiece", "zz_showpiece", false, true ); end } },
                   {"gmg_apocalypse3_device", { event_mdown = function() cmn.GotoRoomMDown( "apocalypse3_device" ); end, event_mup = function() cmn.GotoRoomMUp( "apocalypse3_device", "mg_device" ); end } } } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_dlgnayastart", clk_dlgnayastart_beg, private.room_objname );
  cmn.AddSubscriber( "clk_dlgnayastart", clk_dlgnayastart_end, private.room_objname );
  cmn.AddSubscriber( "clk_dlgnayastart_beg", clk_dlgnayastart_beg, private.room_objname );
  cmn.AddSubscriber( "clk_dlgnayastart_end", clk_dlgnayastart_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_apocalypse3 () end;
  --------------------------------------------------------------------------------------------
  local opn_apocalypse3 = function ()
  
    int_map_impl.OpenRoom( "rm_apocalypse3" );
    interface_impl.SetCurrentGlobalTask( 18 );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_apocalypse3", opn_apocalypse3 );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_showpiece" );
  subroom.Define( "zz_sarcophagus" );

  function zz_showpiece.Close()
    cmn.HideNote( 0 );
  end;

  function zz_sarcophagus.Close()
    cmn.HideNote( 0 );
  end;
  
  function zz_sarcophagus.PreOpen()
    
    if (cmn.IsEventDone("get_goreseye")) and not(cmn.IsEventDone("use_goreseye4")) then

      ObjAnimate( "inv_goreseye", "pos_xy", 1, 0, "",
      { 
        0.0, 0,  0, 0,
        0.1, 0,  3, -2,
        0.2, 0, -3, -4,
        0.3, 0,  3, -6,
        0.4, 0, -3, -8,
        0.5, 0,  0, -10,
        0.6, 0,  3, -8,
        0.7, 0, -3, -6,
        0.8, 0,  3, -4,
        0.9, 0, -3, -2,
        1.0, 0,  0, 0
      } );

      --ObjSet("inv_goreseye_fx", { active = 1, visible = 1 } );

      int_inventory_impl.ShowAnim( "show" );

    end;
    
  end;
  
  function zz_sarcophagus.PreClose()
    
    if (cmn.IsEventDone("get_goreseye")) and not(cmn.IsEventDone("use_goreseye4")) then
      ObjStopAnimate( "inv_goreseye", "pos_xy" );
      ObjMultiSet( { {"inv_goreseye", { pos_x = 0, pos_y = 0 }},
                     {"inv_goreseye_fx", { active = 0, visible = 0 }} } );
    end;
    
  end;

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_apocalypse3();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level3/audio/env/aud_rm_apocalypse3_env");
  cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_apocalypse3_env");
  
  if cmn.IsEventDone("use_fang") then
    cmn.Lock( 1 );
    ObjSet("rm_apocalypse3",  { color_r = 0, color_g = 0, color_b = 0, input = 0 });
  end;
  
  if cmn.IsEventDone("clk_dlgnayastart") and not cmn.IsEventDone("get_figurine") then
    --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    common_impl.current_dialog = "obj_apocalypse3_dialog_naya1";
    ObjSet("anm_apocalypse3_dialog_naya1_hand_2",  { playing = 1 });
  end;
  
  if cmn.IsEventDone("use_heart") and not cmn.IsEventDone("get_goreseye") then
    --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    common_impl.current_dialog = "obj_apocalypse3_dialog_naya2";
    ObjSet("anm_apocalypse3_dialog_naya2_hand_2",  { playing = 1 });
  end;
  
  if cmn.IsEventDone("win_installation") or ng_global.progress[ ng_global.currentprogress ][ "win_installation" ].stage[1] > 10 then
    ObjMultiSet( { {"spr_apocalypse3_showpiece_ho", { alp = 1 }},
                   {"spr_apocalypse3_showpiece_ho_fang", { alp = 1 }} } );
  end;
                 
  --анимация морф-оъекта
  if cmn.IsCollectableAvailible(4) then
    private.AnimMorphObject();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_tweezers()

  local item = "inv_tweezers";

  if cmn.ApplyObj( item, "gzz_apocalypse3_sarcophagus" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_sarcophagus", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_sarcophagus_use_tweezers" ) ) then

    ObjAttach( "obj_sarcophagus_pattern2", "anm_sarcophagus_tweezers_use" );

    cmn.CallEventHandler( "use_tweezers_inv" );
    cmn.CallEventHandler( "use_tweezers_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      public.get_pattern2();

      cmn.SetEventDone( "use_tweezers" );
      cmn.CallEventHandler( "use_tweezers_end" );
      
    end;

    cmn.Lock( 1 );
    
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_take_stuff_zz_sarchofagus");

    ObjMultiSet( {
      { "obj_sarcophagus_pattern2", { anim_tag = "tag_pattern_5" } },
      { "spr_sarcophagus_pattern2", { anim_tag = "tag_pattern_5" } },
      { "anm_sarcophagus_tweezers_use", { endtrig = func_after, playing = true, alp = 1 } }
    } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_mask2()

  local item = "inv_mask2";

  if cmn.ApplyObj( item, "gzz_apocalypse3_sarcophagus" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_sarcophagus", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_sarcophagus_use_mask2" ) ) then

    cmn.CallEventHandler( "use_mask2_inv" );
    cmn.CallEventHandler( "use_mask2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_mask2" );
      cmn.CallEventHandler( "use_mask2_end" );
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zz_sarchofagus_opens");
      
      ObjAnimate("spr_sarcophagus_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("obj_sarcophagus_closed", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_left_face_zz_sarchofagus");

    if cmn.IsEventDone("use_mask1") and cmn.IsEventDone("use_mask3") and cmn.IsEventDone("use_mask4") then
      ObjAnimate( "spr_sarcophagus_mask_2", "alp", 0, 0, anm_open, { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_sarcophagus_mask_2", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_mask1()

  local item = "inv_mask1";

  if cmn.ApplyObj( item, "gzz_apocalypse3_sarcophagus" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_sarcophagus", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_sarcophagus_use_mask1" ) ) then

    cmn.CallEventHandler( "use_mask1_inv" );
    cmn.CallEventHandler( "use_mask1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_mask1" );
      cmn.CallEventHandler( "use_mask1_end" );
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zz_sarchofagus_opens");
      
      ObjAnimate("spr_sarcophagus_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("obj_sarcophagus_closed", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_half_face");

    if cmn.IsEventDone("use_mask2") and cmn.IsEventDone("use_mask3") and cmn.IsEventDone("use_mask4") then
      ObjAnimate( "spr_sarcophagus_mask_1", "alp", 0, 0, anm_open, { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_sarcophagus_mask_1", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_mask3()

  local item = "inv_mask3";

  if cmn.ApplyObj( item, "gzz_apocalypse3_sarcophagus" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_sarcophagus", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_sarcophagus_use_mask3" ) ) then

    cmn.CallEventHandler( "use_mask3_inv" );
    cmn.CallEventHandler( "use_mask3_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_mask3" );
      cmn.CallEventHandler( "use_mask3_end" );
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zz_sarchofagus_opens");
      
      ObjAnimate("spr_sarcophagus_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("obj_sarcophagus_closed", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_half_face");

    if cmn.IsEventDone("use_mask2") and cmn.IsEventDone("use_mask1") and cmn.IsEventDone("use_mask4") then
      ObjAnimate( "spr_sarcophagus_mask_3", "alp", 0, 0, anm_open, { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_sarcophagus_mask_3", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_mask4()

  local item = "inv_mask4";

  if cmn.ApplyObj( item, "gzz_apocalypse3_sarcophagus" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_sarcophagus", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_sarcophagus_use_mask4" ) ) then

    cmn.CallEventHandler( "use_mask4_inv" );
    cmn.CallEventHandler( "use_mask4_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_mask4" );
      cmn.CallEventHandler( "use_mask4_end" );
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zz_sarchofagus_opens");
      
      ObjAnimate("spr_sarcophagus_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("obj_sarcophagus_closed", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_half_face");

    if cmn.IsEventDone("use_mask2") and cmn.IsEventDone("use_mask1") and cmn.IsEventDone("use_mask3") then
      ObjAnimate( "spr_sarcophagus_mask_4", "alp", 0, 0, anm_open, { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_sarcophagus_mask_4", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_moonemblem()

  local item = "inv_moonemblem";

  if cmn.ApplyObj( item, "gzz_apocalypse3_showcase" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_showcase" );

  elseif ( cmn.ApplyObj( item, "obj_showcase_use_moonemblem" ) ) then

    cmn.CallEventHandler( "use_moonemblem_inv" );
    cmn.CallEventHandler( "use_moonemblem_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_moonemblem" );
      cmn.CallEventHandler( "use_moonemblem_end" );
      
      if cmn.IsEventDone("use_sunemblem") then
        cmn.SetEventDone("use_moonsunemblems");
      end;
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zz_showcase_opens_1");
      
      ObjDelete("anm_showcase_sun");
      ObjDelete("anm_showcase_moon");
      ObjDelete("anm_showcase_glass_touch");
      ObjSet("anm_showcase_glass_open",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_halfmonth_zz_showcase");

    if cmn.IsEventDone("use_sunemblem") then
      ObjSet("anm_showcase_moon",  { alp = 1, playing = 1, endtrig = anm_open });
    else 
      ObjSet("anm_showcase_moon",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pattern2()

  local item = "inv_pattern2";

  if cmn.ApplyObj( item, "gzz_apocalypse3_showcase" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_showcase" );

  elseif ( cmn.ApplyObj( item, "obj_showcase_use_pattern2" ) and cmn.IsEventDone("use_moonsunemblems") ) then

    cmn.CallEventHandler( "use_pattern2_inv" );
    cmn.CallEventHandler( "use_pattern2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_pattern2" );
      cmn.CallEventHandler( "use_pattern2_end" );
    
    end;

    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zz_showcase_opens_box");
      
      ObjAnimate("spr_showcase_box_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("anm_showcase_box_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("anm_showcase_pattern_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_second_stuff_zz_showcase");

    if cmn.IsEventDone("use_pattern1") and cmn.IsEventDone("use_pattern3") then
      ObjSet("anm_showcase_pattern_2",  { alp = 1, playing = 1, endtrig = anm_open });
    else 
      ObjSet("anm_showcase_pattern_2",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_sunemblem()

  local item = "inv_sunemblem";

  if cmn.ApplyObj( item, "gzz_apocalypse3_showcase" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_showcase" );

  elseif ( cmn.ApplyObj( item, "obj_showcase_use_sunemblem" ) ) then

    cmn.CallEventHandler( "use_sunemblem_inv" );
    cmn.CallEventHandler( "use_sunemblem_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_sunemblem" );
      cmn.CallEventHandler( "use_sunemblem_end" );
      
      if cmn.IsEventDone("use_moonemblem") then
        cmn.SetEventDone("use_moonsunemblems");
      end;
    
    end;

    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zz_showcase_opens_1");
      
      ObjDelete("anm_showcase_sun");
      ObjDelete("anm_showcase_moon");
      ObjDelete("anm_showcase_glass_touch");
      ObjSet("anm_showcase_glass_open",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_sun_zz_showcase");

    if cmn.IsEventDone("use_moonemblem") then
      ObjSet("anm_showcase_sun",  { alp = 1, playing = 1, endtrig = anm_open });
    else 
      ObjSet("anm_showcase_sun",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pattern1()

  local item = "inv_pattern1";

  if cmn.ApplyObj( item, "gzz_apocalypse3_showcase" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_showcase" );

  elseif ( cmn.ApplyObj( item, "obj_showcase_use_pattern1" ) and cmn.IsEventDone("use_moonsunemblems") ) then

    cmn.CallEventHandler( "use_pattern1_inv" );
    cmn.CallEventHandler( "use_pattern1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_pattern1" );
      cmn.CallEventHandler( "use_pattern1_end" );
    
    end;

    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zz_showcase_opens_box");
      
      ObjAnimate("spr_showcase_box_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("anm_showcase_box_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("anm_showcase_pattern_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_first_part_box_zz_showcase");

    if cmn.IsEventDone("use_pattern2") and cmn.IsEventDone("use_pattern3") then
      ObjSet("anm_showcase_pattern_1",  { alp = 1, playing = 1, endtrig = anm_open });
    else 
      ObjSet("anm_showcase_pattern_1",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pattern3()

  local item = "inv_pattern3";

  if cmn.ApplyObj( item, "gzz_apocalypse3_showcase" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_showcase" );

  elseif ( cmn.ApplyObj( item, "obj_showcase_use_pattern3" ) and cmn.IsEventDone("use_moonsunemblems") ) then

    cmn.CallEventHandler( "use_pattern3_inv" );
    cmn.CallEventHandler( "use_pattern3_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_pattern3" );
      cmn.CallEventHandler( "use_pattern3_end" );
    
    end;

    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zz_showcase_opens_box");
      
      ObjAnimate("spr_showcase_box_open", "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
      ObjAnimate("anm_showcase_box_touch", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      ObjAnimate("anm_showcase_pattern_1", "alp", 0, 0, "", { 0, 0, 1,   0.5, 0, 0 });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_first_part_box_zz_showcase");

    if cmn.IsEventDone("use_pattern1") and cmn.IsEventDone("use_pattern2") then
      ObjSet("anm_showcase_pattern_3",  { alp = 1, playing = 1, endtrig = anm_open });
    else 
      ObjSet("anm_showcase_pattern_3",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_warrior1()

  local item = "inv_warrior1";

  if cmn.ApplyObj( item, "gzz_apocalypse3_showpiece" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_showpiece", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_showpiece_use_groundkeepersmap" ) and cmn.ApplyObj( item, "obj_showpiece_use_groundkeepersmap_2" ) ) then

    cmn.CallEventHandler( "use_warrior1_inv" );
    cmn.CallEventHandler( "use_warrior1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_warrior1" );
      cmn.CallEventHandler( "use_warrior1_end" );
      
      if cmn.IsEventDone("use_warrior2") then
        common.CloseSubRoom();
      end;
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_inserc_card_zz_showpiece");
      
      ObjDelete( "anm_showpiece_use_warrior1" );
      ObjDelete( "anm_showpiece_use_warrior2" );
      ObjDelete( "anm_showpiece_table" );
      
      ObjSet("anm_showpiece_table_open",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zz_showpiece_insert_solider");

    if cmn.IsEventDone("use_warrior2") then
      ObjSet("anm_showpiece_use_warrior1",  { alp = 1, playing = 1, endtrig = anm_open });
    else 
      ObjSet("anm_showpiece_use_warrior1",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_warrior2()

  local item = "inv_warrior2";

  if cmn.ApplyObj( item, "gzz_apocalypse3_showpiece" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_showpiece", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_showpiece_use_groundkeepersmap" ) and cmn.ApplyObj( item, "obj_showpiece_use_groundkeepersmap_2" ) ) then

    cmn.CallEventHandler( "use_warrior2_inv" );
    cmn.CallEventHandler( "use_warrior2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_warrior2" );
      cmn.CallEventHandler( "use_warrior2_end" );
      
      if cmn.IsEventDone("use_warrior1") then
        common.CloseSubRoom();
      end;
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_inserc_card_zz_showpiece");
      
      ObjDelete( "anm_showpiece_use_warrior1" );
      ObjDelete( "anm_showpiece_use_warrior2" );
      ObjDelete( "anm_showpiece_table" );
      
      ObjSet("anm_showpiece_table_open",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zz_showpiece_insert_solider");

    if cmn.IsEventDone("use_warrior1") then
      ObjSet("anm_showpiece_use_warrior2",  { alp = 1, playing = 1, endtrig = anm_open });
    else 
      ObjSet("anm_showpiece_use_warrior2",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_tuningfork()

  local item = "inv_tuningfork";

  if cmn.ApplyObj( item, "gzz_apocalypse3_showpiece" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_showpiece", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_showpiece_use_tuningfork" ) ) then

    cmn.CallEventHandler( "use_tuningfork_inv" );
    cmn.CallEventHandler( "use_tuningfork_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_tuningfork" );
      cmn.CallEventHandler( "use_tuningfork_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_hit_camertone");

    ObjSet( "anm_showpiece_box", { animfunc = "func_tuningfork_use", endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_heart()

  local item = "inv_heart";

  if ( cmn.ApplyObj( item, "obj_apocalypse3_use_heart" ) ) then

    cmn.CallEventHandler( "use_heart_inv" );
    cmn.CallEventHandler( "use_heart_beg" );

    local func_after = function ()

      --cmn.Lock( 0 );

      cmn.SetEventDone( "use_heart" );
      --cmn.CallEventHandler( "use_heart_end" );
      
      public.dialog_naya_open( 2 );
    
    end;

    cmn.Lock( 1 );

    func_after();

    --ObjAnimate( "spr_apocalypse3_", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_scoopnet()

  cmn.SetEventDone( "get_scoopnet" );
  cmn.CallEventHandler( "get_scoopnet" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_heart()

  cmn.SetEventDone( "get_heart" );
  cmn.CallEventHandler( "get_heart" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_pattern2()

  cmn.SetEventDone( "get_pattern2" );
  cmn.CallEventHandler( "get_pattern2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_warrior2()

  cmn.SetEventDone( "get_warrior2" );
  cmn.CallEventHandler( "get_warrior2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_zodiacsign4") then
    common.CloseSubRoom();
  end;

  iOS_RateMe();
end;
--------------------------------------------------------------------------------------------
function public.get_zodiacsign10()
  
  ObjSet( "spr_sarcophagus_zodiacsign10", { alp = 1 } );

  cmn.SetEventDone( "get_zodiacsign4" );
  cmn.CallEventHandler( "get_zodiacsign4" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_warrior2") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_lvl3valve()

  cmn.SetEventDone( "get_lvl3valve" );
  cmn.CallEventHandler( "get_lvl3valve" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();
  
end;
--------------------------------------------------------------------------------------------
function public.get_mask1()

  cmn.SetEventDone( "get_mask1" );
  cmn.CallEventHandler( "get_mask1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
end;
--------------------------------------------------------------------------------------------
function public.get_tuningfork()

  cmn.SetEventDone( "get_tuningfork" );
  cmn.CallEventHandler( "get_tuningfork" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_boxpart2()

  cmn.SetEventDone( "get_boxpart2" );
  cmn.CallEventHandler( "get_boxpart2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_skullamulet()

  cmn.SetEventDone( "get_skullamulet" );
  cmn.CallEventHandler( "get_skullamulet" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_boxpart3()

  cmn.SetEventDone( "get_boxpart3" );
  cmn.CallEventHandler( "get_boxpart3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_mask4()

  cmn.SetEventDone( "get_mask4" );
  cmn.CallEventHandler( "get_mask4" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_figurine()
  
  ObjSet("spr_apocalypse3_figurine",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_figurine_end" );
    
    --common_impl.PlayBackgroundMusic();

  end;

  cmn.SetEventDone( "get_figurine" );
  cmn.CallEventHandler( "get_figurine_inv" );
  cmn.CallEventHandler( "get_figurine_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.current_dialog = "";
  
  cmn.Lock(1);
  ObjAnimate("obj_apocalypse3_dialog_naya1", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.5, 0, 0 });

end;
--------------------------------------------------------------------------------------------
function public.get_goreseye()
  
  ObjSet("spr_apocalypse3_goreseye",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_goreseye_end" );
    
    cmn.CallEventHandler("get_goreseye_loc_1");
    cmn.CallEventHandler("get_goreseye_loc_2");
    cmn.CallEventHandler("get_goreseye_loc_3");
    
    --common_impl.PlayBackgroundMusic();

  end;

  cmn.SetEventDone( "get_goreseye" );
  cmn.CallEventHandler( "get_goreseye_inv" );
  cmn.CallEventHandler( "get_goreseye_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.current_dialog = "";
  
  cmn.Lock(1);
  ObjAnimate("obj_apocalypse3_dialog_naya2", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.5, 0, 0 });

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_dlgnayastart()

  cmn.CallEventHandler( "clk_dlgnayastart_beg" );
  cmn.SetEventDone( "clk_dlgnayastart" );
    
  cmn.Lock( 1 );
  
  public.dialog_naya_open( 1 );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_apocalypse3()

  if not ( cmn.IsEventDone( "opn_apocalypse3" ) ) then
    cmn.SetEventDone( "opn_apocalypse3" );
    cmn.CallEventHandler("opn_apocalypse3");
    cmn.ShowBbt( "apocalypse3_open" );
    interface_impl.ShowGlobalTask();
    cmn.PlayAudio("mus", "assets/levels/level1/audio/mus/aud_mus_scare_1", 0, false, 123);
  end;
  
  if cmn.IsEventDone("use_fang") then
    local movement = function ()
      cmn.GotoRoom("rm_debughall");
    end;
    cmn.Lock( 0 );
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level3/rm_apocalypse3/vid_lvl3return", movement, "assets/levels/level3/audio/mus/aud_vid_lvl3return_mus" );
  end;

end;
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_4_1", { alp = 1 }},
                 {"spr_col_4_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_4_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_4_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_4_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_4_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_4_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_4_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_showpiece_box()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_down_glass");

  cmn.ShowBbt( "obj_showpiece_use_tuningfork" );
  
  ObjSet( "anm_showpiece_box", { playing = true, endtrig = function() cmn.Lock(0); end } );

end;
--------------------------------------------------------------------------------------------
function public.touch_showpiece_table()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_upper_glass");

  cmn.ShowBbt( "obj_showpiece_use_groundkeepersmap" );
  
  ObjSet( "anm_showpiece_table", { playing = true, endtrig = function() cmn.Lock(0); end } );

end;
--------------------------------------------------------------------------------------------
function public.touch_showcase()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_zz_showcase_hole");

  cmn.ShowBbt( "obj_showcase_use_emblems" );
  
  ObjSet( "anm_showcase_glass_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
    
  if cmn.IsEventDone("use_moonemblem") then
    ObjSet( "anm_showcase_moon", { playing = 1 } );
  end;
  
  if cmn.IsEventDone("use_sunemblem") then
    ObjSet( "anm_showcase_sun", { playing = 1 } );
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_showcase_box()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zz_showcase_box");

  cmn.ShowBbt( "obj_showcase_use_pattern" );
  
  ObjSet( "anm_showcase_box_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
    
  if cmn.IsEventDone("use_pattern2") then
    ObjSet( "anm_showcase_pattern_2", { playing = 1 } );
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_sarcophagus_pattern()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_stuff_zz_sarchofagus");

  cmn.ShowBbt( "obj_sarcophagus_use_tweezers" );
  
  ObjSet( "anm_sarcophagus_pattern_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );

end;
--------------------------------------------------------------------------------------------
function public.dialog_naya_open( num )
  
  --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
  
  local func_after = function() private.dialog_naya1_beg(); end;
  if num == 2 then
    func_after = function() private.dialog_naya2_beg(); end;
  end;
  
  ObjAttach("obj_apocalypse3_dialog_naya"..num, "rm_apocalypse3");
  ObjAnimate("obj_apocalypse3_dialog_naya"..num, "alp", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_naya1_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "apocalypse3", "naya1", 2 );
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "clk_dlgnayastart_end" );
    cmn.ShowBbt( "apocalypse3_after_dialog_1" );
    
    ObjSet("anm_apocalypse3_dialog_naya1_hand_2",  { playing = 1 });
    int_diary.AddDiarypage( 20 );
    
  end;
  
  local anm_hand = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_apocalypse3_dialog_naya1_lipsync2");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_apocalypse3_dialog_naya1_timer",  { playing = 0 }},
                   {"anm_apocalypse3_dialog_naya1_hand_give", { alp = 1, playing = 1, endtrig = dialog_end }},
                   {"anm_apocalypse3_dialog_naya1_hand_1", { alp = 0, playing = 0 }},
                   {"anm_apocalypse3_dialog_naya1_head", { alp = 1 }} } );
    
  end;
  
  local naya_talks2 = function ()
  
    ObjDelete("vid_apocalypse3_dialog_naya1_lipsync1");
    ObjAttach("vid_apocalypse3_dialog_naya1_lipsync2", "obj_apocalypse3_dialog_naya1");
  
    cmn.ShowDlgBbt( "dlg_apocalypse3_naya1_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_naya_2_voc");
    
    private.dlg_lipsync = "vid_apocalypse3_dialog_naya1_lipsync2";
    
    ObjMultiSet( { {"tmr_apocalypse3_dialog_naya1_timer", { endtrig = anm_hand, time = 7, playing = 1 }},
                   {"vid_apocalypse3_dialog_naya1_lipsync2", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_hand }},
                   {"obj_character_dialog_continue", { event_mup = anm_hand }} } );
  
  end;

  private.dlg_lipsync = "vid_apocalypse3_dialog_naya1_lipsync1";

  cmn.ShowDlgBbt( "dlg_apocalypse3_naya1_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_naya_1_voc");

  ObjMultiSet( { {"tmr_apocalypse3_dialog_naya1_timer", { time = 7, playing = 1, endtrig = naya_talks2 }},
                 {"vid_apocalypse3_dialog_naya1_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = naya_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = naya_talks2 }} } );
  
end; 
--------------------------------------------------------------------------------------------
function private.dialog_naya2_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "apocalypse3", "naya2", 2 );
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "use_heart_end" );
    cmn.ShowBbt( "apocalypse3_after_dialog_2" );
    
    ObjSet("anm_apocalypse3_dialog_naya2_hand_2",  { playing = 1 });
    
  end;
  
  local anm_hand = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_apocalypse3_dialog_naya2_lipsync3");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_apocalypse3_dialog_naya2_timer",  { playing = 0 }},
                   {"anm_apocalypse3_dialog_naya2_hand_give", { alp = 1, playing = 1, endtrig = dialog_end }},
                   {"anm_apocalypse3_dialog_naya2_hand_1", { alp = 0, playing = 0 }},
                   {"anm_apocalypse3_dialog_naya2_head", { alp = 1 }} } );
    
  end;
  
  local naya_talks3 = function ()
  
    ObjDelete("vid_apocalypse3_dialog_naya2_lipsync2");
    ObjAttach("vid_apocalypse3_dialog_naya2_lipsync3", "obj_apocalypse3_dialog_naya2");
  
    cmn.ShowDlgBbt( "dlg_apocalypse3_naya2_phrase_3" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_naya_5_voc");
    
    private.dlg_lipsync = "vid_apocalypse3_dialog_naya2_lipsync3";
    
    ObjMultiSet( { {"tmr_apocalypse3_dialog_naya2_timer", { endtrig = anm_hand, time = 10, playing = 1 }},
                   {"vid_apocalypse3_dialog_naya2_lipsync3", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_hand }},
                   {"obj_character_dialog_continue", { event_mup = anm_hand }} } );
  
  end;
  
  local naya_talks2 = function ()
  
    ObjDelete("vid_apocalypse3_dialog_naya2_lipsync1");
    ObjAttach("vid_apocalypse3_dialog_naya2_lipsync2", "obj_apocalypse3_dialog_naya2");
  
    cmn.ShowDlgBbt( "dlg_apocalypse3_naya2_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_naya_4_voc");
    
    private.dlg_lipsync = "vid_apocalypse3_dialog_naya2_lipsync2";
    
    ObjMultiSet( { {"tmr_apocalypse3_dialog_naya2_timer", { endtrig = naya_talks3, time = 9, playing = 1 }},
                   {"vid_apocalypse3_dialog_naya2_lipsync2", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = naya_talks3 }},
                   {"obj_character_dialog_continue", { event_mup = naya_talks3 }} } );
  
  end;

  private.dlg_lipsync = "vid_apocalypse3_dialog_naya2_lipsync1";

  cmn.ShowDlgBbt( "dlg_apocalypse3_naya2_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_naya_3_voc");

  ObjMultiSet( { {"tmr_apocalypse3_dialog_naya2_timer", { time = 8, playing = 1, endtrig = naya_talks2 }},
                 {"vid_apocalypse3_dialog_naya2_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = naya_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = naya_talks2 }} } );
  
end; 
--------------------------------------------------------------------------------------------
function public.skip_dlg_naya1()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "clk_dlgnayastart_end" );
    cmn.ShowBbt( "apocalypse3_after_dialog_1" );
    
    ObjSet("anm_apocalypse3_dialog_naya1_hand_2",  { playing = 1 });
    int_diary.AddDiarypage( 20 );
    
  end;
  
  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    ObjSet("anm_apocalypse3_dialog_naya1_head",  { alp = 1 });
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();
  
  --common_impl.PlayBackgroundMusic();
  
  ObjMultiSet( { {"tmr_apocalypse3_dialog_naya1_timer",  { playing = 0 }},
                 {"anm_apocalypse3_dialog_naya1_hand_give", { alp = 1, playing = 1, endtrig = func_after_dlg }},
                 {"anm_apocalypse3_dialog_naya1_hand_1", { alp = 0, playing = 0 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.skip_dlg_naya2()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "use_heart_end" );
    cmn.ShowBbt( "apocalypse3_after_dialog_2" );
    
    ObjSet("anm_apocalypse3_dialog_naya2_hand_2",  { playing = 1 });
    
  end;
  
  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    ObjSet("anm_apocalypse3_dialog_naya2_head",  { alp = 1 });
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();
  
  --common_impl.PlayBackgroundMusic();
  
  ObjMultiSet( { {"tmr_apocalypse3_dialog_naya2_timer",  { playing = 0 }},
                 {"anm_apocalypse3_dialog_naya2_hand_give", { alp = 1, playing = 1, endtrig = func_after_dlg }},
                 {"anm_apocalypse3_dialog_naya2_hand_1", { alp = 0, playing = 0 }} } );
  
end;
--*********************************************************************************************************************