-- name=rm_debughall
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_debughall";
  --------------------------------------------------------------------------------------------
  private.dlg_lipsync = "";
  private.Init_Subroom();
  private.Init_Pyramide();
  --------------------------------------------------------------------------------------------
  -- function get_money () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_money" ] = {
    type = "get",
    get_obj = "spr_vrcapsule_money",
    room = private.room_objname,
    zz = "zz_vrcapsule",
    zz_gate = "gzz_debughall_vrcapsule"
  };
  --------------------------------------------------------------------------------------------
  local get_money_inv = function ()
  
    interface.InventoryItemAdd( "inv_money", "spr_vrcapsule_money" );
  
  end;
  local get_money_end = function ()
  
    ObjDelete( "gfx_vrcapsule_money" );
    ObjDelete( "spr_vrcapsule_money_sh" );
    
    ObjDelete( "spr_debughall_capsule_coin" );
  
  end;
  
  cmn.AddSubscriber( "get_money", get_money_inv );
  cmn.AddSubscriber( "get_money", get_money_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_worldnucleus () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_worldnucleus" ] = {
    type = "get",
    get_obj = "spr_pyramide_worldnucleus",
    room = private.room_objname,
    zz = "zz_pyramide",
    zz_gate = "gzz_debughall_pyramide"
  };
  --------------------------------------------------------------------------------------------
  local get_worldnucleus_inv = function ()
  
    interface.InventoryItemAdd( "inv_worldnucleus", "spr_pyramide_worldnucleus" );
  
  end;
  local get_worldnucleus_end = function ()
  
    ObjDelete( "gfx_pyramide_worldnucleus" );
    ObjDelete( "spr_pyramide_worldnucleus_sh" );
    
    ObjDelete( "gzz_debughall_pyramide" );
  
  end;
  
  cmn.AddSubscriber( "get_worldnucleus", get_worldnucleus_inv );
  cmn.AddSubscriber( "get_worldnucleus", get_worldnucleus_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_disk () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_disk" ] = {
    type = "get",
    get_obj = "spr_hallsafe_disk",
    room = private.room_objname,
    zz = "zz_hallsafe",
    zz_gate = "gzz_debughall_hallsafe"
  };
  --------------------------------------------------------------------------------------------
  local get_disk_inv = function ()
  
    interface.InventoryItemAdd( "inv_disk", "spr_hallsafe_disk" );
  
  end;
  local get_disk_end = function ()
  
    ObjDelete( "gfx_hallsafe_disk" );
    ObjDelete( "spr_hallsafe_disk_sh" );
    
    ObjDelete( "spr_debughall_box_disk" );
    
    if cmn.IsEventDone("get_reader") then
      ObjSet("gzz_debughall_hallsafe",  { active = 0, alp = 0 });
    end;
  
  end;
  
  cmn.AddSubscriber( "get_disk", get_disk_inv );
  cmn.AddSubscriber( "get_disk", get_disk_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_reader () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_reader" ] = {
    type = "get",
    get_obj = "spr_hallsafe_reader",
    room = private.room_objname,
    zz = "zz_hallsafe",
    zz_gate = "gzz_debughall_hallsafe"
  };
  --------------------------------------------------------------------------------------------
  local get_reader_inv = function ()
  
    interface.InventoryItemAdd( "inv_reader", "spr_hallsafe_reader" );
  
  end;
  local get_reader_end = function ()
  
    ObjDelete( "gfx_hallsafe_reader" );
    ObjDelete( "spr_hallsafe_reader_sh" );
    
    ObjDelete( "spr_debughall_box_reader" );
    
    if cmn.IsEventDone("get_disk") then
      ObjSet("gzz_debughall_hallsafe",  { active = 0, alp = 0 });
    end;
  
  end;
  
  cmn.AddSubscriber( "get_reader", get_reader_inv );
  cmn.AddSubscriber( "get_reader", get_reader_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tumbler2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_tumbler2" ] = {
    type = "get",
    get_obj = "spr_hallsafe_tumbler2",
    room = private.room_objname,
    zz = "zz_hallsafe",
    zz_gate = "gzz_debughall_hallsafe"
  };
  --------------------------------------------------------------------------------------------
  local get_tumbler2_inv = function ()
  
    interface.InventoryItemAdd( "inv_tumbler2", "spr_hallsafe_tumbler2" );
    ObjSet("inv_case_star_light",  { alp = 1 });
  
  end;
  local get_tumbler2_end = function ()
  
    ObjDelete( "gfx_hallsafe_tumbler2" );
    ObjDelete( "spr_hallsafe_tumbler2_sh" );
    
    ObjDelete( "spr_debughall_tumbler" );
  
  end;
  
  cmn.AddSubscriber( "get_tumbler2", get_tumbler2_inv );
  cmn.AddSubscriber( "get_tumbler2", get_tumbler2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_case () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_case" ] = {
    type = "get",
    get_obj = "spr_debughall_case",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_case_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_case", "spr_debughall_case" );
    ObjDelete( "spr_laboratory_hall_case" );
  
  end;
  local get_case_end = function ()
  
    ObjDelete( "gfx_debughall_case" );
    ObjDelete( "spr_debughall_case_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_case", get_case_inv );
  cmn.AddSubscriber( "get_case", get_case_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_aionsworld () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_aionsworld" ] = {
    type = "use",
    inv_obj = "inv_aionsworld",
    use_place = "obj_vrcapsule_use_aionsworld",
    room = private.room_objname,
    zz = "zz_vrcapsule",
    zz_gate = "gzz_debughall_vrcapsule"
  };
  --------------------------------------------------------------------------------------------
  local use_aionsworld_inv = function ()
  
    interface.InventoryItemRemove( "inv_aionsworld" );
    int_map_impl.DecreaseRoomTasks("rm_debughall");
  
  end;
  local use_aionsworld_beg = function ()
  
    ObjDelete( "obj_vrcapsule_use_aionsworld" );
  
  end;
  local use_aionsworld_end = function ()
  
    ObjSet("spr_debughall_ball_2",  { alp = 1 });
    ObjDelete( "gzz_debughall_vrcapsule" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_aionsworld", use_aionsworld_beg, private.room_objname );
  cmn.AddSubscriber( "use_aionsworld", use_aionsworld_inv );
  cmn.AddSubscriber( "use_aionsworld", use_aionsworld_end, private.room_objname );
  cmn.AddSubscriber( "use_aionsworld_inv", use_aionsworld_inv, private.room_objname );
  cmn.AddSubscriber( "use_aionsworld_beg", use_aionsworld_beg, private.room_objname );
  cmn.AddSubscriber( "use_aionsworld_end", use_aionsworld_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_capsuleactivator () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_capsuleactivator" ] = {
    type = "use",
    inv_obj = "inv_capsuleactivator",
    use_place = "obj_vrcapsule_use_capsuleactivator",
    room = private.room_objname,
    zz = "zz_vrcapsule",
    zz_gate = "gzz_debughall_vrcapsule"
  };
  --------------------------------------------------------------------------------------------
  local use_capsuleactivator_inv = function ()
  
    interface.InventoryItemRemove( "inv_capsuleactivator" );
  
  end;
  local use_capsuleactivator_beg = function ()
  
    ObjDelete( "obj_vrcapsule_use_capsuleactivator" );
    ObjDelete( "anm_vrcapsule_doors_touch" );
  
  end;
  local use_capsuleactivator_end = function ()
  
    ObjMultiSet( { {"spr_vrcapsule_money", { input = 1 }},
                   {"obj_vrcapsule_clk_oldnucleus", { input = 1 }},
                   {"anm_vrcapsule_use_activator", { alp = 1, frame = 300 }},
                   {"spr_debughall_capsule_door_1", { pos_x = 155 }},
                   {"spr_debughall_capsule_door_2", { pos_x = 186 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_capsuleactivator", use_capsuleactivator_beg, private.room_objname );
  cmn.AddSubscriber( "use_capsuleactivator", use_capsuleactivator_inv );
  cmn.AddSubscriber( "use_capsuleactivator", use_capsuleactivator_end, private.room_objname );
  cmn.AddSubscriber( "use_capsuleactivator_inv", use_capsuleactivator_inv, private.room_objname );
  cmn.AddSubscriber( "use_capsuleactivator_beg", use_capsuleactivator_beg, private.room_objname );
  cmn.AddSubscriber( "use_capsuleactivator_end", use_capsuleactivator_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pyramid () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_pyramid" ] = {
    type = "use",
    inv_obj = "inv_pyramid",
    use_place = "obj_pyramide_use_pyramid",
    room = private.room_objname,
    zz = "zz_pyramide",
    zz_gate = "gzz_debughall_pyramide"
  };
  --------------------------------------------------------------------------------------------
  local use_pyramid_inv = function ()
  
    interface.InventoryItemRemove( "inv_pyramid" );
  
  end;
  local use_pyramid_beg = function ()
  
    ObjDelete( "obj_pyramide_use_pyramid" );
    ObjDelete( "anm_pyramide_pyramid_touch" );
  
  end;
  local use_pyramid_end = function ()
  
    ObjMultiSet( { {"obj_pyramide_tip", { alp = 1 }},
                   {"obj_pyramide_game", { input = 1 }},
                   {"spr_debughall_piramyd", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pyramid", use_pyramid_beg, private.room_objname );
  cmn.AddSubscriber( "use_pyramid", use_pyramid_inv );
  cmn.AddSubscriber( "use_pyramid", use_pyramid_end, private.room_objname );
  cmn.AddSubscriber( "use_pyramid_inv", use_pyramid_inv, private.room_objname );
  cmn.AddSubscriber( "use_pyramid_beg", use_pyramid_beg, private.room_objname );
  cmn.AddSubscriber( "use_pyramid_end", use_pyramid_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hacksaw2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_hacksaw2" ] = {
    type = "use",
    inv_obj = "inv_hacksaw2",
    use_place = "obj_hallsafe_use_hacksaw",
    room = private.room_objname,
    zz = "zz_hallsafe",
    zz_gate = "gzz_debughall_hallsafe"
  };
  --------------------------------------------------------------------------------------------
  local use_hacksaw2_inv = function ()
  
    interface.InventoryItemRemove( "inv_hacksaw2" );
  
  end;
  local use_hacksaw2_beg = function ()
  
    ObjDelete( "obj_hallsafe_use_hacksaw" );
    ObjDelete( "anm_hallsafe_door_touch" );
    ObjSet( "obj_hallsafe_safe", { alp = 1 } );
  
  end;
  local use_hacksaw2_end = function ()
    
    ObjDelete( "spr_debughall_door_closed" );
    ObjDelete( "anm_hallsafe_door_open" );
  
    ObjMultiSet( { {"obj_hallsafe_safe", { input = 1 }},
                   {"spr_debughall_door_open", { alp = 1 }} } );
  
  end;
  local use_hacksaw2_loc = function ()
    
    ObjSet("spr_laboratory_hall_safe_2",  { alp = 1 });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hacksaw2", use_hacksaw2_beg, private.room_objname );
  cmn.AddSubscriber( "use_hacksaw2", use_hacksaw2_inv );
  cmn.AddSubscriber( "use_hacksaw2", use_hacksaw2_end, private.room_objname );
  cmn.AddSubscriber( "use_hacksaw2_inv", use_hacksaw2_inv, private.room_objname );
  cmn.AddSubscriber( "use_hacksaw2_beg", use_hacksaw2_beg, private.room_objname );
  cmn.AddSubscriber( "use_hacksaw2_end", use_hacksaw2_end, private.room_objname );
  cmn.AddSubscriber( "use_hacksaw2", use_hacksaw2_loc, "rm_laboratory" );
  cmn.AddSubscriber( "use_hacksaw2_loc", use_hacksaw2_loc, "rm_laboratory" );
  --------------------------------------------------------------------------------------------
  -- function use_nayaspicture () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_nayaspicture" ] = {
    type = "use",
    inv_obj = "inv_nayaspicture",
    use_place = "obj_hallsafe_use_nayaspicture",
    room = private.room_objname,
    zz = "zz_hallsafe",
    zz_gate = "gzz_debughall_hallsafe"
  };
  --------------------------------------------------------------------------------------------
  local use_nayaspicture_inv = function ()
  
    interface.InventoryItemRemove( "inv_nayaspicture" );
  
  end;
  local use_nayaspicture_beg = function ()
  
    ObjDelete( "obj_hallsafe_use_nayaspicture" );
  
  end;
  local use_nayaspicture_end = function ()
    
    ObjSet("spr_hallsafe_nayapic",  { alp = 1 });
    
    if cmn.IsEventDone("use_victorspicture") then
      ObjDelete( "anm_hallsafe_box_touch" );
      ObjDelete( "spr_debughall_box_closed" );
      ObjMultiSet( { {"anm_hallsafe_box_open",  { alp = 1, input = 1, frame = 300 }},
                     {"spr_debughall_box_open", { alp = 1 }} } );
    else 
      ObjSet("spr_debughall_box_naya",  { alp = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_nayaspicture", use_nayaspicture_beg, private.room_objname );
  cmn.AddSubscriber( "use_nayaspicture", use_nayaspicture_inv );
  cmn.AddSubscriber( "use_nayaspicture", use_nayaspicture_end, private.room_objname );
  cmn.AddSubscriber( "use_nayaspicture_inv", use_nayaspicture_inv, private.room_objname );
  cmn.AddSubscriber( "use_nayaspicture_beg", use_nayaspicture_beg, private.room_objname );
  cmn.AddSubscriber( "use_nayaspicture_end", use_nayaspicture_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_victorspicture () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_victorspicture" ] = {
    type = "use",
    inv_obj = "inv_victorspicture",
    use_place = "obj_hallsafe_use_victorspicture",
    room = private.room_objname,
    zz = "zz_hallsafe",
    zz_gate = "gzz_debughall_hallsafe"
  };
  --------------------------------------------------------------------------------------------
  local use_victorspicture_inv = function ()
  
    interface.InventoryItemRemove( "inv_victorspicture" );
  
  end;
  local use_victorspicture_beg = function ()
  
    ObjDelete( "obj_hallsafe_use_victorspicture" );
  
  end;
  local use_victorspicture_end = function ()
    
    if cmn.IsEventDone("use_nayaspicture") then
      ObjDelete( "anm_hallsafe_box_touch" );
      ObjDelete( "spr_debughall_box_closed" );
      ObjMultiSet( { {"anm_hallsafe_box_open",  { alp = 1, input = 1, frame = 300 }},
                     {"spr_debughall_box_open", { alp = 1 }} } );
    else
      ObjMultiSet( { {"spr_hallsafe_victorpic",  { alp = 1 }},
                     {"spr_debughall_box_victor", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_victorspicture", use_victorspicture_beg, private.room_objname );
  cmn.AddSubscriber( "use_victorspicture", use_victorspicture_inv );
  cmn.AddSubscriber( "use_victorspicture", use_victorspicture_end, private.room_objname );
  cmn.AddSubscriber( "use_victorspicture_inv", use_victorspicture_inv, private.room_objname );
  cmn.AddSubscriber( "use_victorspicture_beg", use_victorspicture_beg, private.room_objname );
  cmn.AddSubscriber( "use_victorspicture_end", use_victorspicture_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_oldnucleus () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_oldnucleus" ] = {
      type = "click",
      use_place = "obj_vrcapsule_clk_oldnucleus",
      room = private.room_objname,
      zz = "zz_vrcapsule",
      zz_gate = "gzz_debughall_vrcapsule"
  };
  --------------------------------------------------------------------------------------------
  local clk_oldnucleus = function ()
  
    ObjSet("obj_vrcapsule_use_aionsworld",  { input = 1 });

    ObjDelete( "obj_vrcapsule_clk_oldnucleus" );
    ObjDelete( "anm_vrcapsule_broken_ball" );
    
    ObjDelete( "spr_debughall_ball_1" );

  end;
  
  cmn.AddSubscriber( "clk_oldnucleus", clk_oldnucleus, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_debughall () end;
  --------------------------------------------------------------------------------------------
  local opn_debughall = function ()
  
    int_map_impl.OpenRoom( "rm_debughall" );
    interface_impl.SetCurrentGlobalTask( 14 );
  
  end;
  local opn_debughall_loc = function ()
  
    ObjSet("spr_laboratory_hall_robot_2",  { alp = 1});    
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_debughall", opn_debughall );
  cmn.AddSubscriber( "opn_debughall", opn_debughall_loc, "rm_laboratory" );
  --------------------------------------------------------------------------------------------
  -- function opn_debughallaftervr () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "opn_debughallaftervr" ] = {
    type = "click",
    use_place = "grm_debughall_aion",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local opn_debughallaftervr_map = function ()
    
    int_map_impl.OpenRoom( "rm_office" );
    int_map_impl.OpenRoom( "rm_laboratory" );
    int_map_impl.OpenRoom( "rm_debughall" );
    int_map_impl.BlockRoom( "rm_apocalypse1" );
    int_map_impl.BlockRoom( "rm_apocalypse2" );
    int_map_impl.BlockRoom( "rm_apocalypse3" );
    
  end;
  local opn_debughallaftervr = function ()
  
    ObjDelete("obj_debughall_dialog_friends");
    ObjMultiSet( { {"grm_debughall_aion", { alp = 1, input = 1 }},
                   {"obj_debughall_friends", { alp = 1 }},
                   {"spr_debughall_core_open", { alp = 1 }} } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_debughall_aion_focus");
    end;
  end;
  local opn_debughallaftervr_loc = function ()
  
    ObjDelete("spr_office_friends");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_debughallaftervr", opn_debughallaftervr, private.room_objname );
  cmn.AddSubscriber( "opn_debughallaftervr", opn_debughallaftervr_map );
  cmn.AddSubscriber( "opn_debughallaftervr", opn_debughallaftervr_loc, "rm_office" );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_pyramide" );
  subroom.Define( "zz_hallsafe" );
  
  function zz_hallsafe.Close()
    cmn.HideNote( 0 );
  end;
  
  function zz_pyramide.PreOpen()
    
    if not(cmn.IsEventDone( "win_pyramide" )) then
      private.zz_pyramide.DrawScene();
    end;

  end;
  
  function zz_pyramide.Open()
    
    if cmn.IsEventDone( "use_pyramid" ) and not(cmn.IsEventDone( "win_pyramide" )) then
      cmn.MiniGameShow();
      private.zz_pyramide.CheckWin();
    end;

  end;
  
  function zz_pyramide.PreClose()
    
    if cmn.IsEventDone("use_pyramid") and not cmn.IsEventDone("win_pyramide") then
      cmn.MiniGameHide("pyramide");
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_pyramide" ].state) then 
    private.zz_pyramide.StartConditions();
  end;
  
  private.zz_pyramide.state = ng_global.progress[ ng_global.currentprogress ][ "win_pyramide" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_debughall();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level3/audio/env/aud_rm_debughall_env");
  cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_debughall_env");
  
  if not cmn.IsEventDone("opn_robotready") then
    cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_debughall_magnet_field_env");
  end;
  
  if ( cmn.IsEventDone("use_aionsworld") and not cmn.IsEventDone("opn_apocalypse1") )
  or not cmn.IsEventDone("opn_debughall") then
    cmn.Lock( 1 );
    ObjSet("rm_debughall",  { color_r = 0, color_g = 0, color_b = 0 });
  else 
    ObjSet("rm_debughall",  { color_r = 1, color_g = 1, color_b = 1 });
  end;
  
  if cmn.IsEventDone("use_fang") and not cmn.IsEventDone("opn_debughallaftervr") then
    cmn.Lock( 1 );
    ObjMultiSet( { {"obj_debughall_friends", { alp = 1 }},
                   {"spr_debughall_core_open", { alp = 1 }} } );
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_aionsworld()

  local item = "inv_aionsworld";

  if cmn.ApplyObj( item, "gzz_debughall_vrcapsule" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_vrcapsule" );

  elseif ( cmn.ApplyObj( item, "obj_vrcapsule_use_aionsworld" ) and cmn.IsEventDone("clk_oldnucleus") ) then

    cmn.CallEventHandler( "use_aionsworld_inv" );
    private.use_aionsworld_end();
    
  elseif ( cmn.ApplyObj( item, "obj_vrcapsule_use_aionsworld" ) and not cmn.IsEventDone("clk_oldnucleus") ) then

    cmn.CallEventHandler( "use_aionsworld_inv" );
    public.clk_oldnucleus(2);

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function private.use_aionsworld_end()

  cmn.CallEventHandler( "use_aionsworld_beg" );
    
  local movement = function ()
    ObjSet("rm_debughall",  { color_r = 0, color_g = 0, color_b = 0 });
    cmn.GotoRoom("rm_apocalypse1");
  end;

  local func_after = function ()

    cmn.Lock( 0 );

    cmn.SetEventDone( "use_aionsworld" );
    cmn.CallEventHandler( "use_aionsworld_end" );
    
    common.CloseSubRoom();
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level3/rm_debughall/vid_immersion", movement, "assets/levels/level3/audio/mus/aud_vid_immersion_mus" );
  
  end;

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_ball_zz_vrcapsule");

  ObjSet("anm_vrcapsule_use_world",  { alp = 1, playing = 1, endtrig = func_after });
  
end;
--------------------------------------------------------------------------------------------
function public.use_capsuleactivator()

  local item = "inv_capsuleactivator";

  if cmn.ApplyObj( item, "gzz_debughall_vrcapsule" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_vrcapsule" );

  elseif ( cmn.ApplyObj( item, "obj_vrcapsule_use_capsuleactivator" ) ) then

    cmn.CallEventHandler( "use_capsuleactivator_inv" );
    cmn.CallEventHandler( "use_capsuleactivator_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_capsuleactivator" );
      cmn.CallEventHandler( "use_capsuleactivator_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_disk_glass_open");

    ObjSet("anm_vrcapsule_use_activator",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pyramid()

  local item = "inv_pyramid";

  if cmn.ApplyObj( item, "gzz_debughall_pyramide" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_pyramide" );

  elseif ( cmn.ApplyObj( item, "obj_pyramide_use_pyramid" ) ) then

    cmn.CallEventHandler( "use_pyramid_inv" );
    cmn.CallEventHandler( "use_pyramid_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_pyramid" );
      cmn.CallEventHandler( "use_pyramid_end" );
      
      cmn.MiniGameShow();
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_pyramide_mmg");

    ObjAnimate( "obj_pyramide_tip", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_hacksaw2()

  local item = "inv_hacksaw2";

  if cmn.ApplyObj( item, "gzz_debughall_hallsafe" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_hallsafe", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_hallsafe_use_hacksaw" ) ) then

    cmn.CallEventHandler( "use_hacksaw2_inv" );
    cmn.CallEventHandler( "use_hacksaw2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_hacksaw2" );
      cmn.CallEventHandler( "use_hacksaw2_end" );
      cmn.CallEventHandler( "use_hacksaw2_loc" );
    
    end;
    
    local anm_open = function ()
      ObjAnimate("anm_hallsafe_door_open", "alp", 0, 0, func_after, { 0, 0, 1,   0.5, 0, 0 });
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zz_hallsafe_cut_saw");

    ObjSet("anm_hallsafe_door_open",  { alp = 1, playing = 1, endtrig = anm_open });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_nayaspicture()

  local item = "inv_nayaspicture";

  if cmn.ApplyObj( item, "gzz_debughall_hallsafe" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_hallsafe", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_hallsafe_use_nayaspicture" ) ) then

    cmn.CallEventHandler( "use_nayaspicture_inv" );
    cmn.CallEventHandler( "use_nayaspicture_beg" );

    local func_after = function ()

      cmn.Lock( 0 );
      cmn.ShowBbt( "hallsafe_after_flashback" );

      cmn.SetEventDone( "use_nayaspicture" );
      cmn.CallEventHandler( "use_nayaspicture_end" );
    
    end;
    
    local anm_open = function ()
      
      cmn.Lock( 1 );
      cmn.PlayAudio("mus", "assets/levels/common/audio/aud_random_env_8_mus_env");
      cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_laboratory_env");
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_naya_cube_opens");
      
      ObjMultiSet( { {"anm_hallsafe_box_open", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_hallsafe_box_touch", { alp = 0 }} } );
      
    end;
                   
    local play_flashback = function ()
      
      cmn.Lock( 0 );
      cmn.StopAllEnv();
      cmn.PlayFullscreenVideo( "assets/levels/level3/rm_debughall/zz_hallsafe/vid_flashback_3", anm_open, "assets/levels/level3/audio/mus/aud_vid_flashback_3_mus", "assets/levels/level3/audio/voc/aud_lvl_3_victorstein_5_voc" );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_naya_cube_stuff");

    if cmn.IsEventDone("use_victorspicture") then
      ObjAnimate("spr_hallsafe_nayapic", "alp", 0, 0, play_flashback, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });
    else 
      ObjAnimate("spr_hallsafe_nayapic", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_victorspicture()

  local item = "inv_victorspicture";

  if cmn.ApplyObj( item, "gzz_debughall_hallsafe" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_hallsafe", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_hallsafe_use_victorspicture" ) ) then

    cmn.CallEventHandler( "use_victorspicture_inv" );
    cmn.CallEventHandler( "use_victorspicture_beg" );

    local func_after = function ()

      cmn.Lock( 0 );
      cmn.ShowBbt( "hallsafe_after_flashback" );

      cmn.SetEventDone( "use_victorspicture" );
      cmn.CallEventHandler( "use_victorspicture_end" );
    
    end;
    
    local anm_open = function ()
      
      cmn.Lock( 1 );
      cmn.PlayAudio("mus", "assets/levels/common/audio/aud_random_env_8_mus_env");
      cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_laboratory_env");
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_naya_cube_opens");
      
      ObjMultiSet( { {"anm_hallsafe_box_open", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_hallsafe_box_touch", { alp = 0 }} } );
      
    end;
                   
    local play_flashback = function ()
      
      cmn.Lock( 0 );
      cmn.StopAllEnv();
      cmn.PlayFullscreenVideo( "assets/levels/level3/rm_debughall/zz_hallsafe/vid_flashback_3", anm_open, "assets/levels/level3/audio/mus/aud_vid_flashback_3_mus", "assets/levels/level3/audio/voc/aud_lvl_3_victorstein_5_voc" );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_naya_cube_stuff");

    if cmn.IsEventDone("use_nayaspicture") then
      ObjAnimate("spr_hallsafe_victorpic", "alp", 0, 0, play_flashback, { 0, 0, 0,   0.3, 0, 1,   0.6, 0, 1 });
    else 
      ObjAnimate("spr_hallsafe_victorpic", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 1 });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_money()

  cmn.SetEventDone( "get_money" );
  cmn.CallEventHandler( "get_money" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_worldnucleus()

  cmn.SetEventDone( "get_worldnucleus" );
  cmn.CallEventHandler( "get_worldnucleus" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_tumbler2()

  cmn.SetEventDone( "get_tumbler2" );
  cmn.CallEventHandler( "get_tumbler2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_disk()

  cmn.SetEventDone( "get_disk" );
  cmn.CallEventHandler( "get_disk" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_reader") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_reader()

  cmn.SetEventDone( "get_reader" );
  cmn.CallEventHandler( "get_reader" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_disk") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_case()

  cmn.SetEventDone( "get_case" );
  cmn.CallEventHandler( "get_case" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_oldnucleus(num)

  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_take_ball");

  local func_after = function ()

    cmn.SetEventDone( "clk_oldnucleus" );
    cmn.CallEventHandler( "clk_oldnucleus" );

    if num == 1 then
      cmn.Lock(0);
    else 
      private.use_aionsworld_end();
    end;

  end;
  
  ObjSet("anm_vrcapsule_broken_ball",  { playing = 1, endtrig = func_after });
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_debughall()

  if not ( cmn.IsEventDone( "opn_debughall" ) ) then
    
    local func_after = function ()
      
      ObjSet("rm_debughall",  { color_r = 1, color_g = 1, color_b = 1 });
      
      cmn.SetEventDone( "opn_debughall" );
      cmn.CallEventHandler("opn_debughall");
      cmn.ShowBbt( "debughall_open" );
      interface_impl.ShowGlobalTask();
      
      cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_debughall_env");
      cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_debughall_magnet_field_env");
      
      cmn.PlayAudio("mus", "assets/levels/common/audio/aud_danger_low_mus", 0, false, 96);
      
    end;
    
    cmn.Lock( 0 );
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level3/rm_debughall/vid_robot", func_after, "assets/levels/level3/audio/mus/aud_vid_robot_mus" );
    
  end;
  
  if cmn.IsEventDone("use_aionsworld") and not cmn.IsEventDone("opn_apocalypse1") then
    local movement = function ()
      cmn.GotoRoom("rm_apocalypse1");
    end;
    cmn.Lock( 0 );
    cmn.StopAllEnv();
    cmn.PlayFullscreenVideo( "assets/levels/level3/rm_debughall/vid_immersion", movement, "assets/levels/level3/audio/mus/aud_vid_immersion_mus" );
  end;
  
  if cmn.IsEventDone("use_fang") and not cmn.IsEventDone("opn_debughallaftervr") then
    cmn.SetEventDone("opn_debughallaftervr");
    ObjAttach("obj_debughall_dialog_friends", "rm_debughall");
    ObjAnimate("obj_debughall_dialog_friends", "alp", 0, 0, private.dialog_friends_beg, { 0, 0, 0,   0.5, 0, 1 });
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_pyramid()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_mmg_pyramide");

  cmn.ShowBbt( "obj_pyramide_use_pyramid" );
  
  ObjSet( "anm_pyramide_pyramid_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_safe()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_zz_hallsafe_right");

  cmn.ShowBbt( "obj_hallsafe_use_hacksaw" );
  
  ObjSet( "anm_hallsafe_door_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_safe_box()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_box_zz_hallsafe");
  
  if not cmn.IsEventDone("get_tumbler2") then
    public.get_tumbler2();
  end;

  cmn.ShowBbt( "obj_hallsafe_use_picture" );
  
  ObjSet( "anm_hallsafe_box_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_capsule()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_glass_cup");

  cmn.ShowBbt( "obj_vrcapsule_use_capsuleactivator" );
  
  ObjSet( "anm_vrcapsule_doors_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_capsule_place()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_zz_vrcapsule_opened");

  cmn.ShowBbt( "obj_vrcapsule_use_aionsworld" );
  
  ObjSet( "anm_vrcapsule_place_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_friends_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "debughall", "friends", 2 );
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "opn_debughallaftervr" );
    common_impl.current_dialog = "";
    
    cmn.ShowBbt( "debughall_after_dlg_friends" );
    interface_impl.ShowGlobalTask();
    int_diary.AddDiarypage( 21 );
    
  end;
  
  local anm_hide = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_debughall_dialog_friends_jean_lipsync");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_debughall_dialog_friends_timer",  { playing = 0 }},
                   {"anm_debughall_dialog_friends_jean_head", { alp = 1 }} } );
    
    ObjAnimate("obj_debughall_dialog_friends", "alp", 0, 0, dialog_end, { 0, 0, 1,   0.6, 0, 0 });
    
  end;
  
  local friends_talks2 = function ()
    
    ObjDelete("vid_debughall_dialog_friends_stephen_lipsync");
    ObjAttach("vid_debughall_dialog_friends_jean_lipsync", "obj_debughall_dialog_friends_jean_head");
    private.dlg_lipsync = "vid_debughall_dialog_friends_jean_lipsync";
  
    cmn.ShowDlgBbt( "dlg_friends_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_jean_1_voc");
    
    ObjMultiSet( { {"tmr_debughall_dialog_friends_timer", { endtrig = anm_hide, time = 6, playing = 1 }},
                   {"vid_debughall_dialog_friends_jean_lipsync", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_hide }},
                   {"obj_character_dialog_continue", { event_mup = anm_hide }},
                   {"anm_debughall_dialog_friends_jean_head", { alp = 0 }},
                   {"anm_debughall_dialog_friends_stephen_head", { alp = 1 }} } );
  
  end;
  
  private.dlg_lipsync = "vid_debughall_dialog_friends_stephen_lipsync";

  cmn.ShowDlgBbt( "dlg_friends_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_stephen_1_voc");

  ObjMultiSet( { {"tmr_debughall_dialog_friends_timer", { time = 7, playing = 1, endtrig = friends_talks2 }},
                 {"vid_debughall_dialog_friends_stephen_lipsync", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = friends_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = friends_talks2 }} } );
  
end; 
--------------------------------------------------------------------------------------------
function public.skip_dlg_friends()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  common_impl.current_dialog = "";
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "opn_debughallaftervr" );
    
    cmn.ShowBbt( "debughall_after_dlg_friends" );
    interface_impl.ShowGlobalTask();
    int_diary.AddDiarypage( 21 );
    
  end;
  
  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    ObjMultiSet( { {"anm_debughall_dialog_friends_jean_head", { alp = 1 }},
                   {"anm_debughall_dialog_friends_stephen_head", { alp = 1 }} } );
    private.dlg_lipsync = "";
  end;

  ObjSet("tmr_debughall_dialog_friends_timer",  { playing = 0 });
  
  common_impl.CharacterDialogButtonsHide();
  
  --common_impl.PlayBackgroundMusic();
  
  ObjAnimate("obj_debughall_dialog_friends", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.6, 0, 0 });
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Pyramide *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_pyramide = {};
public.zz_pyramide = {};

function private.Init_Pyramide()
  
  private.zz_pyramide.pos = {
    {-3, 6}, {-2, -118}, {-120, -30}, {-79, 110}, {72, 112}, {117, -30}, 
    {-2, -217}, {-215, -59}, {-138, 190}, {130, 193}, {215, -63}
  };
  
  private.zz_pyramide.buttons_connect = {
    {1, 2, 3}, {1, 3, 4}, {1, 4, 5}, {1, 5, 6}, {1, 6, 2},
    {2, 7, 8, 3}, {3, 8, 9, 4}, {4, 9, 10, 5}, {5, 10, 11, 6}, {6, 11, 7, 2}
  };
  
  private.zz_pyramide.start = { 1, 10, 2, 7, 9, 5, 4, 11, 3, 6, 8 };
  -----------------------------------------------------------------------------------
  game.hint[ "win_pyramide" ] = {
    type = "win",
    room = "rm_debughall",
    zz = "zz_pyramide",
    zz_gate = "gzz_debughall_pyramide"
  };
  -----------------------------------------------------------------------------------
  local win_pyramide = function ()

    if cmn.IsEventDone( "win_pyramide" ) then
      
      ObjDelete( "obj_pyramide_tip" );
      ObjDelete( "obj_pyramide_lights" );
      ObjDelete( "obj_pyramide_layer_2" );
      ObjDelete( "anm_pyramide_pyramid_win" );
      ObjDelete( "spr_debughall_piramyd" );
      
      ObjMultiSet( { {"anm_pyramide_pyramid_open",  { alp = 1, input = 1, frame = 400 }},
                     {"obj_pyramide_game", { input = 0 }},
                     {"spr_debughall_piramyd_2", { alp = 1 }} } );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_pyramide", win_pyramide, "rm_debughall" );
  
end;
--*********************************************************************************************************************
function private.zz_pyramide.StartConditions()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_pyramide" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_pyramide" ].state = { 1, 10, 2, 7, 9, 5, 4, 11, 3, 6, 8 };
  
end;
-----------------------------------------------------------------------------------
function public.zz_pyramide.Reset()
  
  local need_r = false
  local table_r = {};
  
  for i = 1, 11, 1 do
    
    if private.zz_pyramide.start[i] ~= private.zz_pyramide.state[i] then
      
      if not need_r then
        need_r = true;
      end;
      
      table.insert( table_r, private.zz_pyramide.state[i] );
      ObjAnimate("spr_pyramide_part_"..private.zz_pyramide.state[i], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  end;
  
  for i = 2, 6, 1 do
    
    if private.zz_pyramide.state[i] == i and private.zz_pyramide.state[i+5] == i+5 then
      ObjAnimate("spr_pyramide_ray_"..(i-1), "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    end;
    
  end;
  
  local anm_end = function ()
    
    for i = 1, #table_r, 1 do
      
      local pos = 0;
      for j = 1, 11, 1 do
        
        if private.zz_pyramide.start[j] == table_r[i] then
          pos = j;
          break;
        end;
        
      end;
      
      ObjMultiSet( { {"spr_pyramide_part_"..table_r[i].."_light",  { alp = 0 }},
                     {"spr_pyramide_part_"..table_r[i], { pos_x = private.zz_pyramide.pos[ pos ][1], pos_y = private.zz_pyramide.pos[ pos ][2] }} } );
                     
      ObjAnimate("spr_pyramide_part_"..table_r[i], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    ObjSet("tmr_pyramide_timer",  { time = 0.3, playing = 1, endtrig = function() cmn.Lock(0); end });
    
  end;
    
  if need_r then
  
    cmn.Lock(1);
    private.zz_pyramide.StartConditions();
    private.zz_pyramide.state = ng_global.progress[ ng_global.currentprogress ][ "win_pyramide" ].state;
    
    ObjSet("tmr_pyramide_timer",  { time = 0.3, playing = 1, endtrig = anm_end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_pyramide.Skip()
  
  cmn.Lock(1);
  local table_r = {};
  
  ng_global.progress[ ng_global.currentprogress ][ "win_pyramide" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_pyramide" ].state = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 };
  
  for i = 1, 11, 1 do
    
    if private.zz_pyramide.state[i] ~= i then
      
      table.insert( table_r, private.zz_pyramide.state[i] );
      ObjAnimate("spr_pyramide_part_"..private.zz_pyramide.state[i], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  end;
  
  for i = 2, 6, 1 do
    
    if private.zz_pyramide.state[i] ~= i or private.zz_pyramide.state[i+5] ~= i+5 then
      ObjAnimate("spr_pyramide_ray_"..(i-1), "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 0,   0.6, 0, 1 });
    end;
    
  end;
  
  local anm_end = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mmg_pyramide_right");
    
    for i = 1, #table_r, 1 do
      
      ObjMultiSet( { {"spr_pyramide_part_"..table_r[i].."_light",  { alp = 1 }},
                     {"spr_pyramide_part_"..table_r[i], { pos_x = private.zz_pyramide.pos[ table_r[i] ][1], pos_y = private.zz_pyramide.pos[ table_r[i] ][2] }} } );
      
      ObjAnimate("spr_pyramide_part_"..table_r[i], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    ObjSet("tmr_pyramide_timer",  { time = 0.3, playing = 1, endtrig = private.zz_pyramide.CheckWin });
    
  end;
  
  private.zz_pyramide.state = ng_global.progress[ ng_global.currentprogress ][ "win_pyramide" ].state;
    
  ObjSet("tmr_pyramide_timer",  { time = 0.3, playing = 1, endtrig = anm_end });
  
end;
-----------------------------------------------------------------------------------
function private.zz_pyramide.DrawScene()
  
  for i = 1, 11, 1 do
    
    ObjSet("spr_pyramide_part_"..private.zz_pyramide.state[i],  { pos_x = private.zz_pyramide.pos[i][1], pos_y = private.zz_pyramide.pos[i][2] });
    
    if private.zz_pyramide.state[i] == i then
      ObjSet("spr_pyramide_part_"..private.zz_pyramide.state[i].."_light",  { alp = 1 });
    end;
    
  end;
  
  for i = 2, 6, 1 do
    
    if private.zz_pyramide.state[i] == i and private.zz_pyramide.state[i+5] == i+5 then
      ObjSet("spr_pyramide_ray_"..(i-1),  { alp = 1 });
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_pyramide.FocusButton( num, inout )
  
  local obj = "spr_pyramide_button_"..num.."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.zz_pyramide.ClickButton( num )
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mmg_pyramide_click");
  
  local places = private.zz_pyramide.buttons_connect[num];
  local new = {};
  local parts = {};
  local was_lit = {};
  
  local old_state = {};
  for i = 1, 11, 1 do
    table.insert( old_state, private.zz_pyramide.state[i] );
  end;
  
  for i = 1, #places, 1 do
    
    table.insert( parts, private.zz_pyramide.state[ places[i] ] );
    
    if i < #places then
      table.insert( new, places[i+1] );
    else 
      table.insert( new, places[1] );
    end;
    
    if places[i] == private.zz_pyramide.state[ places[i] ] then
      table.insert( was_lit, 1 );
    else 
      table.insert( was_lit, 0 );
    end;
    
  end;
  
  for i = 1, #places, 1 do
    
    if i > 1 then
      private.zz_pyramide.state[ places[i] ] = parts[i-1];
    else 
      private.zz_pyramide.state[ places[i] ] = parts[ #places ];
    end;
    
  end;
  
  for i = 1, #places, 1 do
    
    ObjAnimate("spr_pyramide_part_"..parts[i], "pos_xy", 0, 0, "", { 
        0, 0, private.zz_pyramide.pos[ places[i] ][1], private.zz_pyramide.pos[ places[i] ][2],
      0.5, 0, private.zz_pyramide.pos[ new[i] ][1], private.zz_pyramide.pos[ new[i] ][2] 
    });
    
    if was_lit[i] == 1 then
      
      local secp = 0;
      local pair = 0;
      
      if parts[i] <= 6 then
        secp = parts[i] + 5;
        pair = parts[i] - 1;
      else 
        secp = parts[i] - 5;
        pair = secp - 1;
      end;
      
      ObjAnimate("spr_pyramide_part_"..parts[i].."_light", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
      if old_state[ secp ] == secp then
        ObjAnimate("spr_pyramide_ray_"..pair, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      end;
      
    end;
    
  end;
    
  local anm_lights = function ()
    
    local flag = false;
    
    for i = 1, #places, 1 do
    
      if new[i] == private.zz_pyramide.state[ new[i] ] then
        
        local secp = 0;
        local pair = 0;
        
        flag = true;
        ObjAnimate("spr_pyramide_part_"..new[i].."_light", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
        
        if new[i] <= 6 then
          secp = new[i] + 5;
          pair = new[i] - 1;
        else 
          secp = new[i] - 5;
          pair = secp - 1;
        end;
        
        if secp == private.zz_pyramide.state[ secp ] then
          ObjAnimate("spr_pyramide_ray_"..pair, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
        end;
        
      end;
      
    end;
    
    if flag then
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mmg_pyramide_right");
      ObjSet("tmr_pyramide_timer",  { time = 0.3, playing = 1, endtrig = private.zz_pyramide.CheckWin });
    else 
      private.zz_pyramide.CheckWin();
    end;
    
  end;
  
  ObjAnimate("spr_pyramide_button_"..num, "alp", 0, 0, "", { 0, 0, 0,   0.15, 0, 1,   0.3, 0, 0 });
  
  ObjSet("tmr_pyramide_timer",  { time = 0.5, playing = 1, endtrig = anm_lights });
  
end;
-----------------------------------------------------------------------------------
function private.zz_pyramide.CheckWin()
  
  local win_flag = true;
  
  for i = 1, 11, 1 do
    
    if private.zz_pyramide.state[i] ~= i then
      win_flag = false;
      break;
    end;
    
  end;
  
  if win_flag then
    
    cmn.Lock( 1 );
    
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mmg_pyramide_win");
    
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("pyramide");
    
    local anm_open = function ()
      
      ObjMultiSet( { {"anm_pyramide_pyramid_open", { alp = 1, playing = 1, endtrig = private.zz_pyramide.Win }},
                     {"obj_pyramide_tip", { alp = 0 }},
                     {"anm_pyramide_pyramid_win", { alp = 0 }} } );
      
    end;
    
    local anm_win = function ()
      ObjSet("anm_pyramide_pyramid_win",  { playing = 1, endtrig = anm_open });
    end;

    cmn.Lock( 1 );

    ObjAnimate( "anm_pyramide_pyramid_win", "alp", 0, 0, anm_win, { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );
    ObjAnimate( "obj_pyramide_lights", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 1,    0.6, 0, 0 } );
    
  else
    cmn.Lock(0);
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_pyramide.Win()
  
  cmn.Lock( 0 );
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_pyramide" );
  cmn.CallEventHandler( "win_pyramide" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_pyramide" ].skip == 0 and ng_global.noskipgames[ "win_pyramide" ] == nil then

    ng_global.noskipgames[ "win_pyramide" ] = 1;
    common_impl.CheckAchiev("mg");

  end;
  
end;
--**************************************************************************************************************