-- name=rm_office
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_office";
  --------------------------------------------------------------------------------------------
  private.dlg_lipsync = "";

  private.Init_Subroom();
  private.Init_Panel3();
  --------------------------------------------------------------------------------------------
  -- function get_lvl3button2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl3button2" ] = {
    type = "get",
    get_obj = "spr_panel3_button2",
    room = private.room_objname,
    zz = "zz_panel3",
    zz_gate = "gzz_office_panel3"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl3button2_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl3button", "spr_panel3_button2", function () cmn.GetMultyObject( 'lvl3button', 3 ); end );
  
  end;
  local get_lvl3button2_end = function ()
  
    ObjDelete( "gfx_panel3_button2" );
    ObjDelete( "spr_panel3_button2_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_lvl3button2", get_lvl3button2_inv );
  cmn.AddSubscriber( "get_lvl3button2", get_lvl3button2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coin1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_coin1" ] = {
    type = "get",
    get_obj = "spr_panel3_coin1",
    room = private.room_objname,
    zz = "zz_panel3",
    zz_gate = "gzz_office_panel3"
  };
  --------------------------------------------------------------------------------------------
  local get_coin1_inv = function ()
  
    interface.InventoryItemAdd( "inv_coin", "spr_panel3_coin1", function () cmn.GetMultyObject( 'coin', 3 ); end );

  end;
  local get_coin1_end = function ()
  
    ObjDelete( "gfx_panel3_coin1" );
    ObjDelete( "spr_panel3_coin1_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_coin1", get_coin1_inv );
  cmn.AddSubscriber( "get_coin1", get_coin1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_masterkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_masterkey" ] = {
    type = "get",
    get_obj = "spr_receptiondesk_masterkey",
    room = private.room_objname,
    zz = "zz_receptiondesk",
    zz_gate = "gzz_office_receptiondesk"
  };
  --------------------------------------------------------------------------------------------
  local get_masterkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_masterkey", "spr_receptiondesk_masterkey" );
  
  end;
  local get_masterkey_end = function ()

    ObjDelete( "spr_receptiondesk_masterkey_sh" );
    ObjDelete( "gfx_receptiondesk_masterkey" );

  end;
  
  cmn.AddSubscriber( "get_masterkey", get_masterkey_inv );
  cmn.AddSubscriber( "get_masterkey", get_masterkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_magnetkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_magnetkey" ] = {
    type = "get",
    get_obj = "spr_machine_magnetkey",
    room = private.room_objname,
    zz = "zz_machine",
    zz_gate = "gzz_office_machine"
  };
  --------------------------------------------------------------------------------------------
  local get_magnetkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_magnetkey", "spr_machine_magnetkey" );
  
  end;
  local get_magnetkey_end = function ()
  
    ObjDelete( "gfx_machine_magnetkey" );
    ObjDelete( "spr_machine_magnetkey_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_magnetkey", get_magnetkey_inv );
  cmn.AddSubscriber( "get_magnetkey", get_magnetkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_securityemblem3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_securityemblem3" ] = {
    type = "get",
    get_obj = "spr_machine_securityemblem3",
    room = private.room_objname,
    zz = "zz_machine",
    zz_gate = "gzz_office_machine"
  };
  --------------------------------------------------------------------------------------------
  local get_securityemblem3_inv = function ()

    interface.InventoryItemAdd( "inv_securityemblem", "spr_machine_securityemblem3", function () cmn.GetMultyObject( 'securityemblem', 3 ); end );
  
  end;
  local get_securityemblem3_end = function ()
  
    ObjDelete( "gfx_machine_securityemblem3" );
    ObjDelete( "spr_machine_securityemblem3_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_securityemblem3", get_securityemblem3_inv );
  cmn.AddSubscriber( "get_securityemblem3", get_securityemblem3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_flashcard () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_flashcard" ] = {
    type = "get",
    get_obj = "spr_machine_flashcard",
    room = private.room_objname,
    zz = "zz_machine",
    zz_gate = "gzz_office_machine"
  };
  --------------------------------------------------------------------------------------------
  local get_flashcard_inv = function ()
  
    interface.InventoryItemAdd( "inv_flashcard", "spr_machine_flashcard" );
  
  end;
  local get_flashcard_end = function ()
  
    ObjDelete( "gfx_machine_flashcard" );
    ObjDelete( "spr_machine_flashcard_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_flashcard", get_flashcard_inv );
  cmn.AddSubscriber( "get_flashcard", get_flashcard_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pyramid () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_pyramid" ] = {
    type = "get",
    get_obj = "spr_machine_pyramid",
    room = private.room_objname,
    zz = "zz_machine",
    zz_gate = "gzz_office_machine"
  };
  --------------------------------------------------------------------------------------------
  local get_pyramid_inv = function ()
  
    interface.InventoryItemAdd( "inv_pyramid", "spr_machine_pyramid" );
    int_map_impl.DecreaseRoomTasks("rm_office");
  
  end;
  local get_pyramid_end = function ()
  
    ObjDelete( "gfx_machine_pyramid" );
    ObjDelete( "spr_machine_pyramid_shadow" );
    ObjDelete( "gzz_office_machine" );
  
  end;
  
  cmn.AddSubscriber( "get_pyramid", get_pyramid_inv );
  cmn.AddSubscriber( "get_pyramid", get_pyramid_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl3screw () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl3screw" ] = {
    type = "get",
    get_obj = "spr_machine_lvl3screw",
    room = private.room_objname,
    zz = "zz_machine",
    zz_gate = "gzz_office_machine"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl3screw_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl3screw", "spr_machine_lvl3screw" );
    ObjSet("inv_hacksaw_star_light",  { alp = 1 });
  
  end;
  local get_lvl3screw_end = function ()
    
  end;
  
  cmn.AddSubscriber( "get_lvl3screw", get_lvl3screw_inv );
  cmn.AddSubscriber( "get_lvl3screw", get_lvl3screw_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_capsuleactivator () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_capsuleactivator" ] = {
    type = "get",
    get_obj = "spr_receptiondesk_unlockedcard",
    room = private.room_objname,
    zz = "zz_receptiondesk",
    zz_gate = "gzz_office_receptiondesk"
  };
  --------------------------------------------------------------------------------------------
  local get_capsuleactivator_inv = function ()
  
    interface.InventoryItemAdd( "inv_capsuleactivator", "spr_receptiondesk_unlockedcard" );
  
  end;
  local get_capsuleactivator_end = function ()
  
    ObjAttach("obj_receptiondesk_unlockedcard_light", "anm_receptiondesk_use_key")
    ObjDelete( "gfx_receptiondesk_unlockedcard" );
    ObjSet( "gzz_office_receptiondesk", { active = false, alp = 0 } );

    ObjDelete( "spr_office_receptiondesk_unlockedcard" );
    ObjDelete( "spr_office_receptiondesk_lockedcard" );

  end;
  
  cmn.AddSubscriber( "get_capsuleactivator", get_capsuleactivator_inv );
  cmn.AddSubscriber( "get_capsuleactivator", get_capsuleactivator_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_microchip () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_microchip" ] = {
    type = "get",
    get_obj = "spr_receptiondesk_microchip",
    room = private.room_objname,
    zz = "zz_receptiondesk",
    zz_gate = "gzz_office_receptiondesk"
  };
  --------------------------------------------------------------------------------------------
  local get_microchip_inv = function ()
  
    interface.InventoryItemAdd( "inv_microchip", "spr_receptiondesk_microchip" );
  
  end;
  local get_microchip_end = function ()
  
    ObjDelete( "gfx_receptiondesk_microchip" );
    ObjDelete( "spr_receptiondesk_microchip_shadow" );

    ObjDelete( "spr_office_receptiondesk_chip" );
  
  end;
  
  cmn.AddSubscriber( "get_microchip", get_microchip_inv );
  cmn.AddSubscriber( "get_microchip", get_microchip_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_repairbox () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_repairbox" ] = {
    type = "get",
    get_obj = "spr_receptiondesk_repairbox",
    room = private.room_objname,
    zz = "zz_receptiondesk",
    zz_gate = "gzz_office_receptiondesk"
  };
  --------------------------------------------------------------------------------------------
  local get_repairbox_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_repairbox", "spr_receptiondesk_repairbox" );
  
  end;
  local get_repairbox_end = function ()
  
    ObjDelete( "gfx_receptiondesk_repairbox" );
    ObjDelete( "spr_receptiondesk_repairbox_sh" );
    
    ObjDelete( "spr_office_repairbox" );
  
  end;
  
  cmn.AddSubscriber( "get_repairbox", get_repairbox_inv );
  cmn.AddSubscriber( "get_repairbox", get_repairbox_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl3button1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl3button1" ] = {
    type = "get",
    get_obj = "spr_securitypanel_button1",
    room = private.room_objname,
    zz = "zz_securitypanel",
    zz_gate = "gzz_office_securitypanel"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl3button1_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl3button", "spr_securitypanel_button1", function () cmn.GetMultyObject( 'lvl3button', 3 ); end );
  
  end;
  local get_lvl3button1_end = function ()
  
    ObjDelete( "gfx_securitypanel_button1" );
    ObjDelete( "spr_securitypanel_button1_shadow" );
  
    ObjDelete("spr_office_panel_button");
    
  end;
  
  cmn.AddSubscriber( "get_lvl3button1", get_lvl3button1_inv );
  cmn.AddSubscriber( "get_lvl3button1", get_lvl3button1_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_lvl3wires () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl3wires" ] = {
    type = "get",
    get_obj = "spr_securitypanel_lvl3wires",
    room = private.room_objname,
    zz = "zz_securitypanel",
    zz_gate = "gzz_office_securitypanel"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl3wires_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl3wires", "spr_securitypanel_lvl3wires" );

  end;
  local get_lvl3wires_end = function ()
  
    ObjDelete( "gfx_securitypanel_lvl3wires" );
    ObjDelete( "spr_securitypanel_lvl3wires_shadow" );

    ObjDelete( "spr_office_panel_wires" );
    
    if cmn.IsEventDone("use_securityemblem") and ObjGet("gzz_office_securitypanel") then
      ObjDelete( "gzz_office_securitypanel" );
    end;
    
  end;
  
  cmn.AddSubscriber( "get_lvl3wires", get_lvl3wires_inv );
  cmn.AddSubscriber( "get_lvl3wires", get_lvl3wires_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_nayaspicture () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_nayaspicture" ] = {
      type = "get",
      get_obj = "spr_office_nayaspicture",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_nayaspicture_inv = function ()
  
    interface.InventoryItemAdd( "inv_nayaspicture", "spr_office_nayaspicture" );
  
  end;
  local get_nayaspicture_mid = function ()
  
    ObjDelete( "gfx_office_nayaspicture" );
    ObjDelete( "spr_office_nayaspicture_sh" );
    
  end;
  local get_nayaspicture_end = function ()
  
    ObjDelete( "obj_office_dialog_victor1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_nayaspicture", get_nayaspicture_inv );
  cmn.AddSubscriber( "get_nayaspicture_inv", get_nayaspicture_inv, private.room_objname );
  cmn.AddSubscriber( "get_nayaspicture", get_nayaspicture_mid, private.room_objname );
  cmn.AddSubscriber( "get_nayaspicture_mid", get_nayaspicture_mid, private.room_objname );
  cmn.AddSubscriber( "get_nayaspicture", get_nayaspicture_end, private.room_objname );
  cmn.AddSubscriber( "get_nayaspicture_end", get_nayaspicture_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_microchip () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_microchip" ] = {
    type = "use",
    inv_obj = "inv_microchip",
    use_place = "obj_panel3_use_microchip",
    room = private.room_objname,
    zz = "zz_panel3",
    zz_gate = "gzz_office_panel3"
  };
  --------------------------------------------------------------------------------------------
  local use_microchip_inv = function ()
  
    interface.InventoryItemRemove( "inv_microchip" );
  
  end;
  local use_microchip_beg = function ()
  
    ObjDelete( "obj_panel3_use_microchip" );
  
  end;
  local use_microchip_end = function ()

    ObjSet( "anm_panel3_chip", { animfunc = "anm_chip", frame = 64 } ); --animfunc = "anm_chip", 

    if ( cmn.IsEventDone( "use_masterkey" ) ) then

      ObjDelete( "txt_panel3_access" );

      ObjMultiSet( {
        { "spr_panel3_monitor", { alp = 1 } },
        { "obj_panel3_game", { alp = 1, input = true } }
      } );

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_microchip", use_microchip_beg, private.room_objname );
  cmn.AddSubscriber( "use_microchip", use_microchip_inv );
  cmn.AddSubscriber( "use_microchip", use_microchip_end, private.room_objname );
  cmn.AddSubscriber( "use_microchip_inv", use_microchip_inv, private.room_objname );
  cmn.AddSubscriber( "use_microchip_beg", use_microchip_beg, private.room_objname );
  cmn.AddSubscriber( "use_microchip_end", use_microchip_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_masterkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_masterkey" ] = {
    type = "use",
    inv_obj = "inv_masterkey",
    use_place = "obj_panel3_use_masterkey",
    room = private.room_objname,
    zz = "zz_panel3",
    zz_gate = "gzz_office_panel3"
  };
  --------------------------------------------------------------------------------------------
  local use_masterkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_masterkey" );
  
  end;
  local use_masterkey_beg = function ()
  
    ObjDelete( "obj_panel3_use_masterkey" );
  
  end;
  local use_masterkey_end = function ()
  
    ObjSet( "anm_panel3_door", { animfunc = "anm_key", frame = 56 } ); -- animfunc = "anm_key",

    if ( cmn.IsEventDone( "use_microchip" ) ) then

      ObjDelete( "txt_panel3_access" );

      ObjMultiSet( {
        { "spr_panel3_monitor", { alp = 1 } },
        { "obj_panel3_game", { alp = 1, input = true } }
      } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_masterkey", use_masterkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_masterkey", use_masterkey_inv );
  cmn.AddSubscriber( "use_masterkey", use_masterkey_end, private.room_objname );
  cmn.AddSubscriber( "use_masterkey_inv", use_masterkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_masterkey_beg", use_masterkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_masterkey_end", use_masterkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_magnet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_magnet" ] = {
    type = "use",
    inv_obj = "inv_magnet",
    use_place = "obj_machine_use_magnet",
    room = private.room_objname,
    zz = "zz_machine",
    zz_gate = "gzz_office_machine"
  };
  --------------------------------------------------------------------------------------------
  local use_magnet_inv = function ()
  
    interface.InventoryItemRemove( "inv_magnet" );
  
  end;
  local use_magnet_beg = function ()
  
    ObjDelete( "obj_machine_use_magnet" );
    ObjDelete( "spr_machine_glass" );
    ObjDelete( "gfx_machine_lvl3screw" );
  
  end;
  local use_magnet_end = function ()
  
    ObjSet( "anm_machine_key", { animfunc = "func_use_magnet", frame = 300 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magnet", use_magnet_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnet", use_magnet_inv );
  cmn.AddSubscriber( "use_magnet", use_magnet_end, private.room_objname );
  cmn.AddSubscriber( "use_magnet_inv", use_magnet_inv, private.room_objname );
  cmn.AddSubscriber( "use_magnet_beg", use_magnet_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnet_end", use_magnet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_money () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_money" ] = {
    type = "use",
    inv_obj = "inv_money",
    use_place = "obj_machine_use_money",
    room = private.room_objname,
    zz = "zz_machine",
    zz_gate = "gzz_office_machine"
  };
  --------------------------------------------------------------------------------------------
  local use_money_inv = function ()
  
    interface.InventoryItemRemove( "inv_money" );
  
  end;
  local use_money_beg = function ()
  
    ObjDelete( "obj_machine_use_money" );

    ObjMultiSet( {
      { "obj_machine_pyramid", { anim_tag = "tag_pyramid1" } },
      { "spr_machine_pyramid", { anim_tag = "tag_pyramid1" } }
    } );
  
  end;
  local use_money_end = function ()
  
    ObjMultiSet( {
      { "spr_machine_pyramid", { input = true } },
      { "anm_machine_pyramid", { animfunc = "func_use_money", frame = 300 } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_money", use_money_beg, private.room_objname );
  cmn.AddSubscriber( "use_money", use_money_inv );
  cmn.AddSubscriber( "use_money", use_money_end, private.room_objname );
  cmn.AddSubscriber( "use_money_inv", use_money_inv, private.room_objname );
  cmn.AddSubscriber( "use_money_beg", use_money_beg, private.room_objname );
  cmn.AddSubscriber( "use_money_end", use_money_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_coin () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_coin" ] = {
    type = "use",
    inv_obj = "inv_coin",
    use_place = "obj_machine_use_coin",
    room = private.room_objname,
    zz = "zz_machine",
    zz_gate = "gzz_office_machine"
  };
  --------------------------------------------------------------------------------------------
  local use_coin_inv = function ()
  
    interface.InventoryItemRemove( "inv_coin" );
  
  end;
  local use_coin_beg = function ()
  
    ObjDelete( "obj_machine_use_coin" );

    ObjMultiSet( {
      { "obj_machine_flashcard", { anim_tag = "tag_flashcard1" } },
      { "spr_machine_flashcard", { anim_tag = "tag_flashcard1" } }
    } );
  
  end;
  local use_coin_end = function ()
  
    ObjMultiSet( {
      { "spr_machine_flashcard", { input = true } },
      { "anm_machine_flashcard", { animfunc = "funk_use_coin_2", frame = 300 } },
      { "anm_machine_flashcard_2", { frame = 300 } }
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_coin", use_coin_beg, private.room_objname );
  cmn.AddSubscriber( "use_coin", use_coin_inv );
  cmn.AddSubscriber( "use_coin", use_coin_end, private.room_objname );
  cmn.AddSubscriber( "use_coin_inv", use_coin_inv, private.room_objname );
  cmn.AddSubscriber( "use_coin_beg", use_coin_beg, private.room_objname );
  cmn.AddSubscriber( "use_coin_end", use_coin_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lockedcard () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lockedcard" ] = {
    type = "use",
    inv_obj = "inv_lockedcard",
    use_place = "obj_receptiondesk_use_lockedcard",
    room = private.room_objname,
    zz = "zz_receptiondesk",
    zz_gate = "gzz_office_receptiondesk"
  };
  --------------------------------------------------------------------------------------------
  local use_lockedcard_inv = function ()
  
    interface.InventoryItemRemove( "inv_lockedcard" );
  
  end;
  local use_lockedcard_beg = function ()
  
    ObjDelete( "obj_receptiondesk_use_lockedcard" );
    
  end;
  local use_lockedcard_end = function ()
  
    if ( cmn.IsEventDone( "use_reader" ) ) then
      ObjDelete( "obj_receptiondesk_key_1" );
      ObjMultiSet( { 
        {"anm_receptiondesk_use_key", { input = 1, alp = 1, frame = 300 }},
        {"gfx_receptiondesk_unlockedcard", { active = 1, visible = 1 }},
        { "spr_office_receptiondesk_lockedcard", { alp = 0 } },
        { "spr_office_receptiondesk_unlockedcard", { alp = 1 } }
      } );
    else
      ObjMultiSet( {
        { "obj_receptiondesk_key_1", { alp = 1 } },
        { "spr_office_receptiondesk_lockedcard", { alp = 1 } },
        { "spr_office_receptiondesk_unlockedcard", { alp = 0 } }
      } );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lockedcard", use_lockedcard_beg, private.room_objname );
  cmn.AddSubscriber( "use_lockedcard", use_lockedcard_inv );
  cmn.AddSubscriber( "use_lockedcard", use_lockedcard_end, private.room_objname );
  cmn.AddSubscriber( "use_lockedcard_inv", use_lockedcard_inv, private.room_objname );
  cmn.AddSubscriber( "use_lockedcard_beg", use_lockedcard_beg, private.room_objname );
  cmn.AddSubscriber( "use_lockedcard_end", use_lockedcard_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl3button () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl3button" ] = {
    type = "use",
    inv_obj = "inv_lvl3button",
    use_place = "obj_receptiondesk_use_button",
    room = private.room_objname,
    zz = "zz_receptiondesk",
    zz_gate = "gzz_office_receptiondesk"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl3button_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl3button" );
  
  end;
  local use_lvl3button_beg = function ()
  
    ObjDelete( "obj_receptiondesk_use_button" );

    ObjDelete( "anm_receptiondesk_safe" );
    ObjDelete( "obj_receptiondesk_red_light_safe" );
  
  end;
  local use_lvl3button_end = function ()
  
    ObjSet( "anm_receptiondesk_button_use", { input = 1, alp = 1, frame = 300, pos_z = 4 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl3button", use_lvl3button_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl3button", use_lvl3button_inv );
  cmn.AddSubscriber( "use_lvl3button", use_lvl3button_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl3button_inv", use_lvl3button_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl3button_beg", use_lvl3button_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl3button_end", use_lvl3button_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_reader () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_reader" ] = {
    type = "use",
    inv_obj = "inv_reader",
    use_place = "obj_receptiondesk_use_reader",
    room = private.room_objname,
    zz = "zz_receptiondesk",
    zz_gate = "gzz_office_receptiondesk"
  };
  --------------------------------------------------------------------------------------------
  local use_reader_inv = function ()
  
    interface.InventoryItemRemove( "inv_reader" );
  
  end;
  local use_reader_beg = function ()
  
    ObjDelete( "obj_receptiondesk_use_reader" );
  
  end;
  local use_reader_end = function ()
    
    ObjDelete( "anm_receptiondesk_use_reader" );
    ObjDelete( "obj_receptiondesk_pc_1" );

    ObjMultiSet( {
      { "obj_receptiondesk_pc_2", { alp = 1 } },
      { "spr_office_receptiondesk_reader", { alp = 1 } }
    } );

    if ( cmn.IsEventDone( "use_lockedcard" ) ) then
      ObjDelete( "obj_receptiondesk_key_1" );
      ObjMultiSet( { {"anm_receptiondesk_use_key", { input = 1, alp = 1, frame = 300 }},
                     {"gfx_receptiondesk_unlockedcard", { active = 1, visible = 1 }},
                     { "spr_office_receptiondesk_lockedcard", { alp = 0 } },
                     { "spr_office_receptiondesk_unlockedcard", { alp = 1 } } } );
    else 
      ObjMultiSet( { {"anm_receptiondesk_use_key", { alp = 1 }},
                     {"obj_receptiondesk_use_lockedcard", { input = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_reader", use_reader_beg, private.room_objname );
  cmn.AddSubscriber( "use_reader", use_reader_inv );
  cmn.AddSubscriber( "use_reader", use_reader_end, private.room_objname );
  cmn.AddSubscriber( "use_reader_inv", use_reader_inv, private.room_objname );
  cmn.AddSubscriber( "use_reader_beg", use_reader_beg, private.room_objname );
  cmn.AddSubscriber( "use_reader_end", use_reader_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_magnetkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_magnetkey" ] = {
    type = "use",
    inv_obj = "inv_magnetkey",
    use_place = "obj_securitypanel_use_magnetkey",
    room = private.room_objname,
    zz = "zz_securitypanel",
    zz_gate = "gzz_office_securitypanel"
  };
  --------------------------------------------------------------------------------------------
  local use_magnetkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_magnetkey" );
  
  end;
  local use_magnetkey_beg = function ()
  
    ObjDelete( "obj_securitypanel_use_magnetkey" );
  
  end;
  local use_magnetkey_end = function ()
    
    ObjDelete( "vid_securitypanel_explosion" );
  
    ObjMultiSet( {
      { "spr_securitypanel_button1", { input = true } },
      { "spr_securitypanel_lvl3wires", { input = true } },
      { "anm_securitypanel_card", { animfunc = "func_use_card", frame = 300 } },
      { "obj_securitypanel_keyboard_display_2", { alp = 1 } },
      { "obj_office_panel_explode", { alp = 1 } }
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magnetkey", use_magnetkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnetkey", use_magnetkey_inv );
  cmn.AddSubscriber( "use_magnetkey", use_magnetkey_end, private.room_objname );
  cmn.AddSubscriber( "use_magnetkey_inv", use_magnetkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_magnetkey_beg", use_magnetkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnetkey_end", use_magnetkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_securityemblem () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_securityemblem" ] = {
    type = "use",
    inv_obj = "inv_securityemblem",
    use_place = "obj_securitypanel_use_securityemblem",
    room = private.room_objname,
    zz = "zz_securitypanel",
    zz_gate = "gzz_office_securitypanel"
  };
  --------------------------------------------------------------------------------------------
  local use_securityemblem_inv = function ()
  
    interface.InventoryItemRemove( "inv_securityemblem" );
  
  end;
  local use_securityemblem_beg = function ()
  
    ObjDelete( "obj_securitypanel_use_securityemblem" );
  
  end;
  local use_securityemblem_end = function ()

    if cmn.IsEventDone("get_lvl3wires") and ObjGet("gzz_office_securitypanel") then
      ObjDelete( "gzz_office_securitypanel" );
    end;
    
    ObjMultiSet( { {"gmg_office_tosecuritypanel", { input = 1, alp = 1, active = true }},
                   {"spr_office_panel_game", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_securityemblem", use_securityemblem_beg, private.room_objname );
  cmn.AddSubscriber( "use_securityemblem", use_securityemblem_inv );
  cmn.AddSubscriber( "use_securityemblem", use_securityemblem_end, private.room_objname );
  cmn.AddSubscriber( "use_securityemblem_inv", use_securityemblem_inv, private.room_objname );
  cmn.AddSubscriber( "use_securityemblem_beg", use_securityemblem_beg, private.room_objname );
  cmn.AddSubscriber( "use_securityemblem_end", use_securityemblem_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_officefirstclk () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_officefirstclk" ] = {
    type = "click",
    use_place = "obj_office_clk_officefirstclk",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local clk_officefirstclk_task = function ()
    interface_impl.SetCurrentGlobalTask( 13 );
  end;
  local clk_officefirstclk_beg = function ()
  
    ObjDelete( "obj_office_clk_officefirstclk" );
  
  end;
  local clk_officefirstclk_end = function ()
    
    ObjAttach("obj_office_dialog_victor1", "rm_office");
    
    ObjDelete( "anm_office_dialog_victor1_hand_give" );
    
    ObjDelete( "vid_office_dialog_victor1_lipsync1" );
    ObjDelete( "vid_office_dialog_victor1_lipsync2" );
    ObjDelete( "vid_office_dialog_victor1_lipsync3" );
    ObjDelete( "vid_office_dialog_victor1_lipsync4" );

    ObjMultiSet( {
      {"obj_office_dialog_victor1", { alp = 1, input = 1 }},
      {"obj_office_dialog_victor1_hand_2", { alp = 1, input = 1 }},
      {"obj_office_dialog_victor1_head", { alp = 1 }},
      { "gzz_office_panel3", { event_mdown = 'cmn.GotoSubRoomMDown( "office_panel3" );', event_mup = 'cmn.GotoSubRoomMUp( "office_panel3", "zz_panel3" );' } },
      { "gzz_office_machine", { event_mdown = 'cmn.GotoSubRoomMDown( "office_machine" );', event_mup = 'cmn.GotoSubRoomMUp( "office_machine", "zz_machine" );' } },
      { "gzz_office_receptiondesk", { event_mdown = 'cmn.GotoSubRoomMDown( "office_receptiondesk" );', event_mup = 'cmn.GotoSubRoomMUp( "office_receptiondesk", "zz_receptiondesk", false, true );' } },
      { "gzz_office_securitypanel", { event_mdown = 'cmn.GotoSubRoomMDown( "office_securitypanel" );', event_mup = 'cmn.GotoSubRoomMUp( "office_securitypanel", "zz_securitypanel" );' } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_officefirstclk", clk_officefirstclk_beg, private.room_objname );
  cmn.AddSubscriber( "clk_officefirstclk", clk_officefirstclk_end, private.room_objname );
  cmn.AddSubscriber( "clk_officefirstclk_beg", clk_officefirstclk_beg, private.room_objname );
  cmn.AddSubscriber( "clk_officefirstclk_end", clk_officefirstclk_end, private.room_objname );
  cmn.AddSubscriber( "clk_officefirstclk", clk_officefirstclk_task );
  cmn.AddSubscriber( "clk_officefirstclk_task", clk_officefirstclk_task );

  --------------------------------------------------------------------------------------------
  -- function opn_office () end;
  --------------------------------------------------------------------------------------------
  local opn_office = function ()
  
    --int_map_impl.OpenRoom( "rm_office" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_office", opn_office );

end;
--********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_panel3" );
  subroom.Define( "zz_receptiondesk" );
  
  function zz_receptiondesk.Close()
    cmn.HideNote( 0 );
  end;

  function zz_panel3.PreOpen()
    
    if cmn.IsEventDone( "use_microchip" ) and cmn.IsEventDone( "use_masterkey" ) and not cmn.IsEventDone( "win_panel3" ) then
      cmn.MiniGameShow();
      private.zz_panel3.DrawScene();
      private.zz_panel3.CheckWin();
    end;

  end;
  
  function zz_panel3.PreClose()
    
    if cmn.IsEventDone( "use_microchip" ) and cmn.IsEventDone( "use_masterkey" ) and not cmn.IsEventDone( "win_panel3" ) then
      cmn.MiniGameHide( "panel3" );
    end;
    
  end;

end;
--*********************************************************************************************************************
function public.Load()

  if not(ng_global.progress[ ng_global.currentprogress ][ "win_panel3" ].state) then 
    private.zz_panel3.StartConditions();
  end;
  private.zz_panel3.state = ng_global.progress[ ng_global.currentprogress ][ "win_panel3" ].state;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_office();
  
  if cmn.IsEventDone("clk_officefirstclk") and not cmn.IsEventDone("get_nayaspicture") then
    --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    common_impl.current_dialog = "obj_office_dialog_victor1";
    ObjSet("anm_office_dialog_victor1_hand_2",  { playing = 1 });
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level3/audio/env/aud_rm_office_env");
  cmn.PlayAudio("env", "assets/levels/level3/audio/env/aud_rm_office_env");
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_microchip()

  local item = "inv_microchip";

  if cmn.ApplyObj( item, "gzz_office_panel3" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_panel3" );

  elseif ( cmn.ApplyObj( item, "obj_panel3_use_microchip" ) ) then

    cmn.CallEventHandler( "use_microchip_inv" );
    cmn.CallEventHandler( "use_microchip_beg" );

    local func_after2 = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_microchip" );
      cmn.CallEventHandler( "use_microchip_end" );
      
      if ( cmn.IsEventDone( "use_masterkey" ) ) then
        ObjSet( "obj_panel3_back", { pos_x = 0, pos_y = 0, scale_x = 1, scale_y = 1 } );
        cmn.MiniGameShow();
      end;
    
    end;

    local func_after = function ()
      
      if ( cmn.IsEventDone( "use_masterkey" ) ) then

        private.zz_panel3.DrawScene();

        local func_game = function ()
          ObjAnimate( "obj_panel3_game", "alp", 0, 0, _, { 0, 0, 0,    0.5, 0, 1 } );
          port.callFuncTimer(0.5,func_after2);
        end;

        local anm_zoom = function ()
          ObjAnimate( "obj_panel3_back", "scale_xy", 0, 0, _, { 0, 0, 1, 1,    0.8, 0, 1.5, 1.5 } );
          ObjAnimate( "obj_panel3_back", "pos_xy",   0, 0, _,        { 0, 0, 0, 0,    0.8, 0, 126, 126 } );
          port.callFuncTimer(0.8,func_game);
        end;

        ObjAnimate( "spr_panel3_monitor", "alp", 0, 0, _, { 0, 0, 0,    0.3, 0, 1 } );
        ObjAnimate( "txt_panel3_access", "alp", 0, 0, _, { 0, 0, 1,    0.3, 0, 0 } );
        port.callFuncTimer(0.3,anm_zoom);
        
      else
        func_after2();
      end;

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_coin_zz_panel3_card");
    
   
    
   --ObjSet( "anm_panel3_chip", { animfunc = "anm_chip", endtrig = func_after, playing = true } );
   ObjSet( "anm_panel3_chip_clone", { alp = 1, visible = true, endtrig = func_after, playing = true } );
   ObjSet( "anm_panel3_chip", {alp=0});
   
  else

    cmn.WrongApply();  

  end;

end;

--------------------------------------------------------------------------------------------
function public.use_masterkey()

  local item = "inv_masterkey";

  if cmn.ApplyObj( item, "gzz_office_panel3" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_panel3" );

  elseif ( cmn.ApplyObj( item, "obj_panel3_use_masterkey" ) ) then

    cmn.CallEventHandler( "use_masterkey_inv" );
    cmn.CallEventHandler( "use_masterkey_beg" );

    local func_after2 = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_masterkey" );
      cmn.CallEventHandler( "use_masterkey_end" );

      if ( cmn.IsEventDone( "use_microchip" ) ) then
        ObjSet( "obj_panel3_back", { pos_x = 0, pos_y = 0, scale_x = 1, scale_y = 1 } );
        cmn.MiniGameShow();
      end;

    end;

    local func_after = function ()

      if ( cmn.IsEventDone( "use_microchip" ) ) then

        private.zz_panel3.DrawScene();

        local func_game = function ()
          ObjAnimate( "obj_panel3_game", "alp", 0, 0, _, { 0, 0, 0,    0.5, 0, 1 } );
          port.callFuncTimer(0.5,func_after2);
        end;

        local anm_zoom = function ()
          ObjAnimate( "obj_panel3_back", "scale_xy", 0, 0, _, { 0, 0, 1, 1,    0.8, 0, 1.5, 1.5 } );
          ObjAnimate( "obj_panel3_back", "pos_xy",   0, 0, _,        { 0, 0, 0, 0,    0.8, 0, 126, 126 } );
          port.callFuncTimer(0.8,func_game);
        end;

        ObjAnimate( "spr_panel3_monitor", "alp", 0, 0, _, { 0, 0, 0,    0.3, 0, 1 } );
        ObjAnimate( "txt_panel3_access", "alp", 0, 0, _, { 0, 0, 1,    0.3, 0, 0 } );
        port.callFuncTimer(0.3,anm_zoom);
      else
        func_after2();
      end;

    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_key_hole_zz_panel3");

    --ObjSet( "anm_panel3_door", { animfunc = "anm_key", endtrig = func_after, playing = true } );
    ObjSet( "anm_panel3_door_clone", { alp = 1, visible = true, endtrig = func_after, playing = true } );
    ObjSet( "anm_panel3_door", { alp = 0 });
  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_magnet()

  local item = "inv_magnet";

  if cmn.ApplyObj( item, "gzz_office_machine" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_machine" );

  elseif ( cmn.ApplyObj( item, "obj_machine_use_magnet" ) ) then

    cmn.CallEventHandler( "use_magnet_inv" );
    cmn.CallEventHandler( "use_magnet_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_magnet" );
      cmn.CallEventHandler( "use_magnet_end" );

      public.get_lvl3screw();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_take_magnet_key");

    ObjSet( "anm_machine_key", { animfunc = "func_use_magnet", endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_money()

  local item = "inv_money";

  if cmn.ApplyObj( item, "gzz_office_machine" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_machine" );

  elseif ( cmn.ApplyObj( item, "obj_machine_use_money" ) ) then

    cmn.CallEventHandler( "use_money_inv" );
    cmn.CallEventHandler( "use_money_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_money" );
      cmn.CallEventHandler( "use_money_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_money_1");

    ObjSet( "anm_machine_pyramid", { animfunc = "func_use_money", endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_coin()

  local item = "inv_coin";

  if cmn.ApplyObj( item, "gzz_office_machine" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_machine" );

  elseif ( cmn.ApplyObj( item, "obj_machine_use_coin" ) and cmn.CheckMultiObject( "coin", 3 ) ) then

    cmn.CallEventHandler( "use_coin_inv" );
    cmn.CallEventHandler( "use_coin_beg" );

    local func_after2 = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_coin" );
      cmn.CallEventHandler( "use_coin_end" );
    
    end;

    local func_after = function ()
      ObjSet( "anm_machine_flashcard", { animfunc = "funk_use_coin_2", endtrig = func_after2, playing = true } );
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_coins_broken_machine");

    ObjSet( "anm_machine_flashcard_2", { endtrig = func_after, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lockedcard()

  local item = "inv_lockedcard";

  if cmn.ApplyObj( item, "gzz_office_receptiondesk" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_receptiondesk", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_receptiondesk_use_lockedcard" ) ) then

    cmn.CallEventHandler( "use_lockedcard_inv" );
    cmn.CallEventHandler( "use_lockedcard_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lockedcard" );
      cmn.CallEventHandler( "use_lockedcard_end" );
    
    end;

    cmn.Lock( 1 );

    if cmn.IsEventDone("use_reader") then
      ObjSet("anm_receptiondesk_use_key",  { alp = 1, playing = 1, endtrig = func_after });
    else 
      cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_put_stuff_table_zz_receptiondesk");
      ObjAnimate( "obj_receptiondesk_key_1", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_button()

  local item = "inv_lvl3button";

  if cmn.ApplyObj( item, "gzz_office_receptiondesk" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_receptiondesk", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_receptiondesk_use_button" ) and cmn.CheckMultiObject( "lvl3button", 3 ) ) then

    cmn.CallEventHandler( "use_lvl3button_inv" );
    cmn.CallEventHandler( "use_lvl3button_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl3button" );
      cmn.CallEventHandler( "use_lvl3button_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_numeral_1");

    ObjSet("anm_receptiondesk_button_use",  { playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_reader()

  local item = "inv_reader";

  if cmn.ApplyObj( item, "gzz_office_receptiondesk" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_receptiondesk", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_receptiondesk_use_reader" ) ) then

    cmn.CallEventHandler( "use_reader_inv" );
    cmn.CallEventHandler( "use_reader_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_reader" );
      cmn.CallEventHandler( "use_reader_end" );
    
    end;
    
    local anm_card = function ()
      
      ObjAnimate("obj_receptiondesk_key_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
      ObjMultiSet( { {"anm_receptiondesk_use_key", { alp = 1, playing = 1, endtrig = func_after }},
                     {"anm_receptiondesk_use_reader", { alp = 0 }} } );
      
    end;
                   
    local anm_pc = function ()
      
      ObjAnimate("obj_receptiondesk_pc_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
      if cmn.IsEventDone("use_lockedcard") then
        ObjAnimate("obj_receptiondesk_pc_2", "alp", 0, 0, anm_card, { 0, 0, 0,   0.3, 0, 0,   0.6, 0, 1 });
      else 
        ObjAnimate("obj_receptiondesk_pc_2", "alp", 0, 0, func_after, { 0, 0, 0,   0.3, 0, 0,   0.6, 0, 1 });
      end;
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_divide_devices_insert_key");

    ObjSet("anm_receptiondesk_use_reader",  { alp = 1, playing = 1, endtrig = anm_pc });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_magnetkey()

  local item = "inv_magnetkey";

  if cmn.ApplyObj( item, "gzz_office_securitypanel" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_securitypanel" );

  elseif ( cmn.ApplyObj( item, "obj_securitypanel_use_magnetkey" ) ) then

    cmn.CallEventHandler( "use_magnetkey_inv" );
    cmn.CallEventHandler( "use_magnetkey_beg" );

    local func_after2 = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_magnetkey" );
      cmn.CallEventHandler( "use_magnetkey_end" );
      
      cmn.ShowBbt( "securitypanel_after_explosion" );
    
    end;

    local explode = function ()
      
      ObjAttach("vid_securitypanel_explosion", "zz_securitypanel");
      VidPlay("vid_securitypanel_explosion", func_after2);
      
      ObjAnimate( "obj_securitypanel_keyboard_display_2", "alp", 0, 0, "", { 0, 0, 0,    2, 0, 0,    2.5, 0, 1 } );
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_insert_card_zz_securitypanel");

    ObjSet( "anm_securitypanel_card", { animfunc = "func_use_card", endtrig = explode, playing = true } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_securityemblem()

  local item = "inv_securityemblem";

  if cmn.ApplyObj( item, "gzz_office_securitypanel" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_securitypanel" );

  elseif ( cmn.ApplyObj( item, "obj_securitypanel_use_securityemblem" ) and cmn.CheckMultiObject( "securityemblem", 3 ) ) then

    cmn.CallEventHandler( "use_securityemblem_inv" );
    cmn.CallEventHandler( "use_securityemblem_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_securityemblem" );
      cmn.CallEventHandler( "use_securityemblem_end" );

      common.CloseSubRoom();
      cmn.GotoRoom("mg_tosecuritypanel");
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mg_tosecuritypanel_begin");

    ObjAnimate( "obj_securitypanel_security_signs", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_button2()

  cmn.SetEventDone( "get_lvl3button2" );
  cmn.CallEventHandler( "get_lvl3button2" );

  if ( not cmn.IsEventDone( "get_coin1" ) ) then
    cmn.SetEventDone( "get_coin1" );
    cmn.CallEventHandler( "get_coin1" );
  end;

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_coin1()

  cmn.SetEventDone( "get_coin1" );
  cmn.CallEventHandler( "get_coin1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_masterkey()

  cmn.SetEventDone( "get_masterkey" );
  cmn.CallEventHandler( "get_masterkey" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_magnetkey()

  cmn.SetEventDone( "get_magnetkey" );
  cmn.CallEventHandler( "get_magnetkey" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_securityemblem3()

  cmn.SetEventDone( "get_securityemblem3" );
  cmn.CallEventHandler( "get_securityemblem3" );

  if ( not cmn.IsEventDone( "get_magnetkey" ) ) then
    cmn.SetEventDone( "get_magnetkey" );
    cmn.CallEventHandler( "get_magnetkey" );
  end;

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_flashcard()

  ObjSet( "spr_machine_flashcard", { ang = -1.1195 } );-- -0.1545

  cmn.SetEventDone( "get_flashcard" );
  cmn.CallEventHandler( "get_flashcard" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_pyramid()

  ObjSet( "spr_machine_pyramid", { ang = -2.4965 } );

  cmn.SetEventDone( "get_pyramid" );
  cmn.CallEventHandler( "get_pyramid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_lvl3screw()

  ObjSet( "spr_machine_lvl3screw", { ang = 0.8781 } );

  cmn.SetEventDone( "get_lvl3screw" );
  cmn.CallEventHandler( "get_lvl3screw" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_capsuleactivator()

  ObjMultiSet( { {"spr_receptiondesk_unlockedcard", { ang = -0.0629 }},
                 {"spr_receptiondesk_unlockedcard_2", { alp = 1 }} } );

  cmn.SetEventDone( "get_capsuleactivator" );
  cmn.CallEventHandler( "get_capsuleactivator" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_microchip()

  cmn.SetEventDone( "get_microchip" );
  cmn.CallEventHandler( "get_microchip" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_repairbox()

  cmn.SetEventDone( "get_repairbox" );
  cmn.CallEventHandler( "get_repairbox" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_button1()

  cmn.SetEventDone( "get_lvl3button1" );
  cmn.CallEventHandler( "get_lvl3button1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_lvl3wires()

  cmn.SetEventDone( "get_lvl3wires" );
  cmn.CallEventHandler( "get_lvl3wires" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_nayaspicture()
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_nayaspicture_end" );
    
    --common_impl.PlayBackgroundMusic();

  end;

  cmn.SetEventDone( "get_nayaspicture" );
  cmn.CallEventHandler( "get_nayaspicture_inv" );
  cmn.CallEventHandler( "get_nayaspicture_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.current_dialog = "";
  
  cmn.Lock(1);
  ObjAnimate("obj_office_dialog_victor1", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.5, 0, 0 });

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_officefirstclk()

  cmn.CallEventHandler( "clk_officefirstclk_beg" );
  cmn.SetEventDone("clk_officefirstclk");
  
  cmn.Lock( 1 );
  
  ObjAttach("obj_office_dialog_victor1", "rm_office");
  ObjAnimate("obj_office_dialog_victor1", "alp", 0, 0, private.dialog_victor1_beg, { 0, 0, 0,   0.5, 0, 1 });

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_office()

  if not ( cmn.IsEventDone( "opn_office" ) ) then
    cmn.SetEventDone( "opn_office" );
    cmn.CallEventHandler("opn_office");
    cmn.ShowBbt( "office_open" );
    int_diary.AddDiarypage( 16 );
  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_securitypanel_card()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_card_hole_zz_securitypanel");

  cmn.ShowBbt( "obj_securitypanel_use_magnetkey" );
  
  ObjSet( "anm_securitypanel_card", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_desk_pc( num )
  
  cmn.Lock(1);

  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_connect_the_reader");
  
  if num == 1 then
    cmn.ShowBbt( "obj_receptiondesk_use_reader" );
  else 
    cmn.ShowBbt( "obj_receptiondesk_use_lockedcard" );
  end;

  ObjAnimate("txt_receptiondesk_pc_"..num, "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 1,   0.2, 0, 0,    0.4, 0, 1,     0.6, 0, 0,    0.8, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_desk_safe()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_safe_without_buttons");

  cmn.ShowBbt( "obj_receptiondesk_use_button" );
  
  ObjSet( "anm_receptiondesk_safe", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_machine_key()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_key_zz_machine");

  cmn.ShowBbt( "obj_machine_use_magnet" );
  
  ObjSet( "anm_machine_key", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_machine_flashcard()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_spring_zz_machine");

  cmn.ShowBbt( "obj_machine_use_coin" );
  
  ObjSet( "anm_machine_flashcard", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_machine_pyramid()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_spring_zz_machine");

  cmn.ShowBbt( "obj_machine_use_money" );
  
  ObjSet( "anm_machine_pyramid", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_panel3_door()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_key_hole_zz_panel3");

  cmn.ShowBbt( "obj_panel3_use_masterkey" );
  
  ObjSet( "anm_panel3_door", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_panel3_chip()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_xx_processor_1");

  cmn.ShowBbt( "obj_panel3_use_microchip" );
  
  ObjSet( "anm_panel3_chip", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_panel_door()
  
  cmn.Lock(1);

  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_denied_zz_panel3");
  
  cmn.ShowBbt( "obj_panel3_use_" );

  ObjAnimate("txt_panel3_access", "alp", 0, 0, function() cmn.Lock(0); end, { 0, 0, 1,   0.2, 0, 0,    0.4, 0, 1,     0.6, 0, 0,    0.8, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_victor1_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "office", "victor1", 2 );
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "clk_officefirstclk_end" );
    cmn.CallEventHandler("clk_officefirstclk_task");
    cmn.ShowBbt( "office_after_dialog" );
    interface_impl.ShowGlobalTask();
    
    ObjSet("anm_office_dialog_victor1_hand_2",  { playing = 1 });
    int_diary.AddDiarypage( 17 );
    
  end;
  
  local anm_hand = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_office_dialog_victor1_lipsync4");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_office_dialog_victor1_timer",  { playing = 0 }},
                   {"anm_office_dialog_victor1_hand_give", { alp = 1, playing = 1, endtrig = dialog_end }},
                   {"obj_office_dialog_victor1_head", { alp = 1 }} } );
    
  end;
                 
  local victor_talks4 = function ()
  
    ObjDelete("vid_office_dialog_victor1_lipsync3");
    ObjAttach("vid_office_dialog_victor1_lipsync4", "obj_office_dialog_victor1");
  
    cmn.ShowDlgBbt( "dlg_office_victor1_phrase_4" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_victorstein_4_voc");
    
    private.dlg_lipsync = "vid_office_dialog_victor1_lipsync4";
    
    ObjMultiSet( { {"tmr_office_dialog_victor1_timer", { endtrig = anm_hand, time = 12, playing = 1 }},
                   {"vid_office_dialog_victor1_lipsync4", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_hand }},
                   {"obj_character_dialog_continue", { event_mup = anm_hand }} } );
  
  end;
      
  local victor_talks3 = function ()
  
    ObjDelete("vid_office_dialog_victor1_lipsync2");
    ObjAttach("vid_office_dialog_victor1_lipsync3", "obj_office_dialog_victor1");
  
    cmn.ShowDlgBbt( "dlg_office_victor1_phrase_3" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_victorstein_3_voc");
    
    private.dlg_lipsync = "vid_office_dialog_victor1_lipsync3";
    
    ObjMultiSet( { {"tmr_office_dialog_victor1_timer", { endtrig = victor_talks4, time = 8, playing = 1 }},
                   {"vid_office_dialog_victor1_lipsync3", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = victor_talks4 }},
                   {"obj_character_dialog_continue", { event_mup = victor_talks4 }} } );
  
  end;
  
  local victor_talks2 = function ()
  
    ObjDelete("vid_office_dialog_victor1_lipsync1");
    ObjAttach("vid_office_dialog_victor1_lipsync2", "obj_office_dialog_victor1");
  
    cmn.ShowDlgBbt( "dlg_office_victor1_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_victorstein_2_voc");
    
    private.dlg_lipsync = "vid_office_dialog_victor1_lipsync2";
    
    ObjMultiSet( { {"tmr_office_dialog_victor1_timer", { endtrig = victor_talks3, time = 8, playing = 1 }},
                   {"vid_office_dialog_victor1_lipsync2", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = victor_talks3 }},
                   {"obj_character_dialog_continue", { event_mup = victor_talks3 }} } );
  
  end;

 private.dlg_lipsync = "vid_office_dialog_victor1_lipsync1";

  cmn.ShowDlgBbt( "dlg_office_victor1_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level3/audio/voc/aud_lvl_3_victorstein_1_voc");

  ObjMultiSet( { {"tmr_office_dialog_victor1_timer", { time = 9, playing = 1, endtrig = victor_talks2 }},
                 {"vid_office_dialog_victor1_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = victor_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = victor_talks2 }} } );
  
end; 
--------------------------------------------------------------------------------------------
function public.skip_dlg_victor1()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "clk_officefirstclk_end" );
    cmn.CallEventHandler("clk_officefirstclk_task");
    cmn.ShowBbt( "office_after_dialog" );
    interface_impl.ShowGlobalTask();
    
    ObjSet("anm_office_dialog_victor1_hand_2",  { playing = 1 });
    int_diary.AddDiarypage( 17 );
    
  end;
  
  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    ObjSet("obj_office_dialog_victor1_head",  { alp = 1 });
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();
  
  --common_impl.PlayBackgroundMusic();
  
  ObjMultiSet( { {"tmr_office_dialog_victor1_timer",  { playing = 0 }},
                 {"anm_office_dialog_victor1_hand_give", { alp = 1, playing = 1, endtrig = func_after_dlg }} } );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Panel3 *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_panel3 = {};
public.zz_panel3 = {};

function private.Init_Panel3()

  private.zz_panel3.cir_win_sum = { 12, 13, 15 };

  private.zz_panel3.start_cir_state = {
    { {4,5}, {5,3}, {3,4}, {3,1}, {1,3} },
    { {4,2}, {1,5}, {1,1}, {5,2}, {2,5} },
    { {2,1}, {5,1}, {1,4}, {1,2}, {2,1} }
  };

  private.zz_panel3.win_cir_state = {
    { {2,5}, {5,3}, {3,1}, {1,1}, {1,2} },
    { {2,1}, {1,5}, {5,1}, {1,4}, {4,2} },
    { {4,5}, {5,2}, {2,1}, {1,3}, {3,4} }
  };

  -----------------------------------------------------------------------------------
  game.hint[ "win_panel3" ] = {
    type = "win",
    room = "rm_office",
    zz = "zz_panel3",
    zz_gate = "gzz_office_panel3"
  };
  -----------------------------------------------------------------------------------
  local win_panel3 = function ()

    if cmn.IsEventDone( "win_panel3" ) then

      ObjDelete( "gzz_office_panel3" );
  
      ObjMultiSet( { {"grm_office_laboratory", { input = 1, alp = 1 }},
                     {"spr_office_door_open_1", { alp = 1 }} } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_office_laboratory_focus");
      end;
    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_panel3", win_panel3, "rm_office" );

end;
-----------------------------------------------------------------------------------
function private.zz_panel3.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_panel3" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_panel3" ].state = {
    cir = {
      { {4,5}, {5,3}, {3,4}, {3,1}, {1,3} },
      { {4,2}, {1,5}, {1,1}, {5,2}, {2,5} },
      { {2,1}, {5,1}, {1,4}, {1,2}, {2,1} }

      --{ {6,6}, {6,6}, {6,6}, {6,6}, {6,6} },
      --{ {6,6}, {6,6}, {6,6}, {6,6}, {6,6} },
      --{ {6,6}, {6,6}, {6,6}, {6,6}, {6,6} }
    },
    last_btn = {0,0}
  };

end;
-----------------------------------------------------------------------------------
function public.zz_panel3.Reset()

  --DbgTrace( "***Reset" );

  local is_reset = false;
  local last_btn = private.zz_panel3.state.last_btn;

  if last_btn[1] ~= 0 then
    is_reset = true;
  else
    for i = 1, 3, 1 do
      for j = 1, 5, 1 do
        if private.zz_panel3.state.cir[i][j][1] ~= private.zz_panel3.start_cir_state[i][j][1]
        or private.zz_panel3.state.cir[i][j][2] ~= private.zz_panel3.start_cir_state[i][j][2] then
          --DbgTrace(
          --  i..j.." == "..private.zz_panel3.state.cir[i][j][1]..private.zz_panel3.state.cir[i][j][2]..
          --  " ~= "..private.zz_panel3.start_cir_state[i][j][1]..private.zz_panel3.start_cir_state[i][j][2]
          --);
          is_reset = true;
          break;
        end;
      end;
    end;
  end;

  if not is_reset then
    return;
  end;

  cmn.Lock( 1 );

  private.zz_panel3.StartConditions();
  private.zz_panel3.state = ng_global.progress[ ng_global.currentprogress ][ "win_panel3" ].state;

  local func_after = function () 

    if last_btn[1] ~= 0 then
      ObjSet( "spr_panel3_btn"..last_btn[1]..last_btn[2], { alp = 0 } );
    end;

    for i = 1, 3, 1 do
      private.zz_panel3.DrawCircle( i );
    end;

    ObjAnimate( "obj_panel3_cir1", "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );
    ObjAnimate( "obj_panel3_cir2", "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );
    ObjAnimate( "obj_panel3_cir3", "alp", 0, 0, function () cmn.Lock( 0 ); end, { 0, 0, 0,    0.2, 0, 1 } );

  end;

  ObjAnimate( "obj_panel3_cir1", "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );
  ObjAnimate( "obj_panel3_cir2", "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );
  ObjAnimate( "obj_panel3_cir3", "alp", 0, 0, func_after, { 0, 0, 1,    0.2, 0, 0 } );

end;
-----------------------------------------------------------------------------------
function public.zz_panel3.Skip()

  --DbgTrace( "***Skip" );

  cmn.Lock( 1 );

  local last_btn = private.zz_panel3.state.last_btn;

  ng_global.progress[ ng_global.currentprogress ][ "win_panel3" ].skip = 1;
  private.zz_panel3.state.cir = private.zz_panel3.win_cir_state;
  private.zz_panel3.state.last_btn = {0,0};

  local func_after = function () 

    if last_btn[1] ~= 0 then
      ObjSet( "spr_panel3_btn"..last_btn[1]..last_btn[2], { alp = 0 } );
    end;

    for i = 1, 3, 1 do
      private.zz_panel3.DrawCircle( i );
    end;

    ObjAnimate( "obj_panel3_cir1", "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );
    ObjAnimate( "obj_panel3_cir2", "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );
    ObjAnimate( "obj_panel3_cir3", "alp", 0, 0, private.zz_panel3.CheckWin, { 0, 0, 0,    0.2, 0, 1 } );

  end;

  ObjAnimate( "obj_panel3_cir1", "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );
  ObjAnimate( "obj_panel3_cir2", "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );
  ObjAnimate( "obj_panel3_cir3", "alp", 0, 0, func_after, { 0, 0, 1,    0.2, 0, 0 } );

end;
-----------------------------------------------------------------------------------
function private.zz_panel3.DrawScene()

  if private.zz_panel3.draw_scene_done then
    return;
  end;
  private.zz_panel3.draw_scene_done = true;

  --DbgTrace( "***DrawScene" );

  for i = 1, 3, 1 do
    private.zz_panel3.DrawCircle( i );
  end;

  if private.zz_panel3.state.last_btn[1] ~= 0 then
    ObjSet( "spr_panel3_btn"..private.zz_panel3.state.last_btn[1]..private.zz_panel3.state.last_btn[2], { alp = 1 } );
  end;

end;
-----------------------------------------------------------------------------------
function private.zz_panel3.DrawCircle( i )

  --DbgTrace( "***DrawCircle "..i );

  local btn_state;

  for j = 1, 5, 1 do
    btn_state = private.zz_panel3.state.cir[i][j];
    ObjMultiSet( {
      { "txt_panel3_btn"..i..j.."_1", { text = btn_state[1] } },
      { "txt_panel3_btn"..i..j.."_2", { text = btn_state[2] } }
    } );
  end;

  ----------------

  local cir_sum = 0;

  if private.zz_panel3.state.cir[i][5][2] == private.zz_panel3.state.cir[i][1][1] then
    cir_sum = cir_sum + private.zz_panel3.state.cir[i][1][1];
    ObjSet( "spr_panel3_lamp_"..i..1, { alp = 1 } );
  else
    ObjSet( "spr_panel3_lamp_"..i..1, { alp = 0 } );
  end;

  for j = 2, 5, 1 do
    if private.zz_panel3.state.cir[i][j-1][2] == private.zz_panel3.state.cir[i][j][1] then
      cir_sum = cir_sum + private.zz_panel3.state.cir[i][j][1];
      ObjSet( "spr_panel3_lamp_"..i..j, { alp = 1 } );
    else
      ObjSet( "spr_panel3_lamp_"..i..j, { alp = 0 } );
    end;
  end;

  ---------------

  local green_first = cir_sum > private.zz_panel3.cir_win_sum[i] and ( cir_sum - private.zz_panel3.cir_win_sum[i] + 1 ) or 1;

  for r = 1, green_first - 1, 1 do
    --DbgTrace( i..r.."r+ g-" );
    ObjSet( "spr_panel3_red_"..i..r,   { alp = 1 } );
    ObjSet( "spr_panel3_green_"..i..r, { alp = 0 } );
  end;

  for g = green_first, (cir_sum <= private.zz_panel3.cir_win_sum[i]) and cir_sum or private.zz_panel3.cir_win_sum[i], 1 do
    --DbgTrace( i..g.."g+ r-" );
    ObjSet( "spr_panel3_green_"..i..g, { alp = 1 } );
    ObjSet( "spr_panel3_red_"..i..g,   { alp = 0 } );
  end;

  for g = cir_sum+1, private.zz_panel3.cir_win_sum[i], 1 do
    --DbgTrace( i..g.."g- r-" );
    ObjSet( "spr_panel3_green_"..i..g, { alp = 0 } );
    ObjSet( "spr_panel3_red_"..i..g,   { alp = 0 } );
  end;

end;
-----------------------------------------------------------------------------------
function private.zz_panel3.CheckWin()

  --DbgTrace( "***CheckWin" );

  local cir_sum = 0;

  for i = 1, 3, 1 do

    cir_sum = 0;

    if private.zz_panel3.state.cir[i][5][2] == private.zz_panel3.state.cir[i][1][1] then
      cir_sum = cir_sum + private.zz_panel3.state.cir[i][1][1];
    end;

    for j = 2, 5, 1 do
      if private.zz_panel3.state.cir[i][j-1][2] == private.zz_panel3.state.cir[i][j][1] then
        cir_sum = cir_sum + private.zz_panel3.state.cir[i][j][1];
      end;
    end;

    if cir_sum ~= private.zz_panel3.cir_win_sum[i] then
      --DbgTrace( "cir_sum "..i.." = "..cir_sum.." ~= "..private.zz_panel3.cir_win_sum[i] );
      cmn.Lock( 0 );
      return;
    end;

  end;

  cmn.Lock( 1 );

  local func_after = function () 

    ObjAnimate( "spr_panel3_cir1", "pos_xy", 0, 0, "", { 0, 0, -109, -80,    2, 0, -376, -363 } );
    ObjAnimate( "spr_panel3_cir1", "ang",    0, 0, "", { 0, 0, 0,       2, 0, -3 } );

    ObjAnimate( "spr_panel3_cir2", "pos_xy", 0, 0, "", { 0, 0, 108, -80,    2, 0, 358, -363 } );
    ObjAnimate( "spr_panel3_cir2", "ang",    0, 0, "", { 0, 0, 0,       2, 0, 3 } );

    ObjAnimate( "spr_panel3_cir3", "pos_y",  0, 0, "", { 0, 0, 103,       2, 0, 377 } );
    ObjAnimate( "spr_panel3_cir3", "ang",    0, 0, "", { 0, 0, 0,       2, 0, 3 } );

    ObjAnimate( "txt_panel3_open", "alp", 0, 0, private.zz_panel3.Win, { 0, 0, 0,    2, 0, 0,    2.5, 0, 1,    2.8, 0, 1 } );

  end;

  ObjSet( "tmr_panel3_anim_lock", { time = 0.5, endtrig = func_after, playing = true } );

  --DbgTrace( "WWWWWIIIIINNNNNN" );
  
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mmg_numeral_1_win");
  
  common_impl.PauseAchiev(1);
  cmn.MiniGameHide("panel3");

end;
-----------------------------------------------------------------------------------
function private.zz_panel3.Win()
  
  cmn.Lock( 0 );
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_panel3" );
  cmn.CallEventHandler( "win_panel3" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_panel3" ].skip == 0 and ng_global.noskipgames[ "win_panel3" ] == nil then

    ng_global.noskipgames[ "win_panel3" ] = 1;
    common_impl.CheckAchiev("mg");

  end;
  
  common.CloseSubRoom();

end;
-----------------------------------------------------------------------------------
function public.zz_panel3.Focus( cir, num, inout )

  --DbgTrace( "***Focus: "..cir.." "..num.." "..inout );

  local obj = "spr_panel3_btn"..cir..num.."_glow";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.2;
  else
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.2;
  end;

  ObjAnimate( obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout } );

end;
-----------------------------------------------------------------------------------
function public.zz_panel3.Click( cir, num )

  --DbgTrace( "***Click: "..cir.." "..num );

  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level3/audio/sfx/aud_mmg_numeral_1_click");

  local last_btn = private.zz_panel3.state.last_btn;


  if last_btn[1] == 0 then

    private.zz_panel3.state.last_btn = {cir,num};

    ObjAnimate( "spr_panel3_btn"..cir..num, "alp", 0, 0, function () cmn.Lock( 0 ); end, { 0, 0, 0,    0.2, 0, 1 } );

  else

    private.zz_panel3.state.last_btn = {0,0};

    if last_btn[1] == cir and last_btn[2] == num then

      ObjAnimate( "spr_panel3_btn"..cir..num, "alp", 0, 0, function () cmn.Lock( 0 ); end, { 0, 0, 1,    0.2, 0, 0 } );

    else

      local state_cir = private.zz_panel3.state.cir;

      local btn_left_num  = ( num == 1 ) and 5 or num-1;
      local btn_right_num = ( num == 5 ) and 1 or num+1;
      local btn_lamp_1_state = state_cir[cir][btn_left_num][2] == state_cir[cir][num][1];
      local btn_lamp_2_state = state_cir[cir][num][2] == state_cir[cir][btn_right_num][1];

      local last_btn_left_num  = ( last_btn[2] == 1 ) and 5 or last_btn[2]-1;
      local last_btn_right_num = ( last_btn[2] == 5 ) and 1 or last_btn[2]+1;
      local last_btn_lamp_1_state = state_cir[ last_btn[1] ][ last_btn_left_num ][2] == state_cir[ last_btn[1] ][ last_btn[2] ][1];
      local last_btn_lamp_2_state = state_cir[ last_btn[1] ][ last_btn[2] ][2] == state_cir[ last_btn[1] ][ last_btn_right_num ][1];

      --DbgTrace( "btn_lamp_state = "..tostring(btn_lamp_1_state).." "..tostring(btn_lamp_2_state) );
      --DbgTrace( "last_btn_lamp_state = "..tostring(last_btn_lamp_1_state).." "..tostring(last_btn_lamp_2_state) );

      -------------
      local cir_sum = 0;
      if state_cir[cir][5][2] == state_cir[cir][1][1] then
        cir_sum = cir_sum + state_cir[cir][1][1];
      end;
      for j = 2, 5, 1 do
        if state_cir[cir][j-1][2] == state_cir[cir][j][1] then
          cir_sum = cir_sum + state_cir[cir][j][1];
        end;
      end;
      local green_first = cir_sum > private.zz_panel3.cir_win_sum[cir] and ( cir_sum - private.zz_panel3.cir_win_sum[cir] + 1 ) or 1;
      -------------
      local last_cir_sum = 0;
      local last_green_first;
      if last_btn[1] ~= cir then

        if state_cir[ last_btn[1] ][5][2] == state_cir[ last_btn[1] ][1][1] then
          last_cir_sum = last_cir_sum + state_cir[ last_btn[1] ][1][1];
        end;
        for j = 2, 5, 1 do
          if state_cir[ last_btn[1] ][j-1][2] == state_cir[ last_btn[1] ][j][1] then
            last_cir_sum = last_cir_sum + state_cir[ last_btn[1] ][j][1];
          end;
        end;
        last_green_first = last_cir_sum > private.zz_panel3.cir_win_sum[ last_btn[1] ] and ( last_cir_sum - private.zz_panel3.cir_win_sum[ last_btn[1] ] + 1 ) or 1;

      end;
      -------------

      local func_after = function ()

        local new_btn_lamp_1_state = state_cir[cir][btn_left_num][2] == state_cir[cir][num][1];
        local new_btn_lamp_2_state = state_cir[cir][num][2] == state_cir[cir][btn_right_num][1];
        local new_last_btn_lamp_1_state = state_cir[ last_btn[1] ][ last_btn_left_num ][2] == state_cir[ last_btn[1] ][ last_btn[2] ][1];
        local new_last_btn_lamp_2_state = state_cir[ last_btn[1] ][ last_btn[2] ][2] == state_cir[ last_btn[1] ][ last_btn_right_num ][1];

        --DbgTrace( "new_btn_lamp_state = "..tostring(new_btn_lamp_1_state).." "..tostring(new_btn_lamp_2_state) );
        --DbgTrace( "new_last_btn_lamp_state = "..tostring(new_last_btn_lamp_1_state).." "..tostring(new_last_btn_lamp_2_state) );

        if         btn_lamp_1_state and not new_btn_lamp_1_state then
          ObjAnimate( "spr_panel3_lamp_"..cir..num, "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );
        elseif not btn_lamp_1_state and     new_btn_lamp_1_state then
          ObjAnimate( "spr_panel3_lamp_"..cir..num, "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );
        end;

        if         btn_lamp_2_state and not new_btn_lamp_2_state then
          ObjAnimate( "spr_panel3_lamp_"..cir..btn_right_num, "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );
        elseif not btn_lamp_2_state and     new_btn_lamp_2_state then
          ObjAnimate( "spr_panel3_lamp_"..cir..btn_right_num, "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );
        end;
        --------------
        if         last_btn_lamp_1_state and not new_last_btn_lamp_1_state then
          ObjAnimate( "spr_panel3_lamp_"..last_btn[1]..last_btn[2], "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );
        elseif not last_btn_lamp_1_state and     new_last_btn_lamp_1_state then
          ObjAnimate( "spr_panel3_lamp_"..last_btn[1]..last_btn[2], "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );
        end;

        if         last_btn_lamp_2_state and not new_last_btn_lamp_2_state then
          ObjAnimate( "spr_panel3_lamp_"..last_btn[1]..last_btn_right_num, "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );
        elseif not last_btn_lamp_2_state and     new_last_btn_lamp_2_state then
          ObjAnimate( "spr_panel3_lamp_"..last_btn[1]..last_btn_right_num, "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );
        end;
        --------------

        private.zz_panel3.ChangeLines( cir, cir_sum, green_first );

        if last_btn[1] ~= cir then 
          private.zz_panel3.ChangeLines( last_btn[1], last_cir_sum, last_green_first ); 
        end;

        --------------

        ObjMultiSet( {
          { "txt_panel3_btn"..cir..num.."_1", { text = state_cir[cir][num][1] } },
          { "txt_panel3_btn"..cir..num.."_2", { text = state_cir[cir][num][2] } },
          { "txt_panel3_btn"..last_btn[1]..last_btn[2].."_1", { text = state_cir[last_btn[1] ][last_btn[2] ][1] } },
          { "txt_panel3_btn"..last_btn[1]..last_btn[2].."_2", { text = state_cir[last_btn[1] ][last_btn[2] ][2] } }
        } );

        ObjSet( "spr_panel3_btn"..last_btn[1]..last_btn[2], { alp = 0 } );

        ObjAnimate( "obj_panel3_btn"..cir..num, "alp", 0, 0, private.zz_panel3.CheckWin, { 0, 0, 0,    0.2, 0, 1 } );
        ObjAnimate( "obj_panel3_btn"..last_btn[1]..last_btn[2], "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );

      end;

      local last_btn_state_1 = state_cir[ last_btn[1] ][ last_btn[2] ][1];
      local last_btn_state_2 = state_cir[ last_btn[1] ][ last_btn[2] ][2];

      state_cir[ last_btn[1] ][ last_btn[2] ][1] = state_cir[ cir ][ num ][1];
      state_cir[ last_btn[1] ][ last_btn[2] ][2] = state_cir[ cir ][ num ][2];

      state_cir[ cir ][ num ][1] = last_btn_state_1;
      state_cir[ cir ][ num ][2] = last_btn_state_2;

      ObjAnimate( "obj_panel3_btn"..cir..num, "alp", 0, 0, func_after, { 0, 0, 1,    0.2, 0, 0 } );
      ObjAnimate( "obj_panel3_btn"..last_btn[1]..last_btn[2], "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );

    end;

  end;

end;
-----------------------------------------------------------------------------------
function private.zz_panel3.ChangeLines( cir, cir_sum, green_first )

  --DbgTrace( "***ChangeLines "..cir );

  local state_cir = private.zz_panel3.state.cir;

  local new_cir_sum = 0;
  if state_cir[cir][5][2] == state_cir[cir][1][1] then
    new_cir_sum = new_cir_sum + state_cir[cir][1][1];
  end;
  for j = 2, 5, 1 do
    if state_cir[cir][j-1][2] == state_cir[cir][j][1] then
      new_cir_sum = new_cir_sum + state_cir[cir][j][1];
    end;
  end;

  if cir_sum ~= new_cir_sum then

    local new_green_first = new_cir_sum > private.zz_panel3.cir_win_sum[cir] and ( new_cir_sum - private.zz_panel3.cir_win_sum[cir] + 1 ) or 1;

    --DbgTrace( "cir_sum "..cir_sum.." -> "..new_cir_sum );
    --DbgTrace( "green_first "..green_first.." -> "..new_green_first );

    if cir_sum < new_cir_sum then

      for g = cir_sum+1, (new_cir_sum <= private.zz_panel3.cir_win_sum[cir]) and new_cir_sum or private.zz_panel3.cir_win_sum[cir], 1 do
        --DbgTrace( g.."g+" );
        ObjAnimate( "spr_panel3_green_"..cir..g, "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );
      end;

      for g = green_first, new_green_first-1, 1 do
        --DbgTrace( g.."g-" );
        ObjAnimate( "spr_panel3_green_"..cir..g, "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );
        --DbgTrace( g.."r+" );
        ObjAnimate( "spr_panel3_red_"..cir..g, "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );
      end;

    elseif cir_sum > new_cir_sum then

      for g = green_first-1, new_green_first, -1 do
        --DbgTrace( g.."g+" );
        ObjAnimate( "spr_panel3_green_"..cir..g, "alp", 0, 0, "", { 0, 0, 0,    0.2, 0, 1 } );
        --DbgTrace( g.."r-" );
        ObjAnimate( "spr_panel3_red_"..cir..g, "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );
      end;

      for g = (cir_sum <= private.zz_panel3.cir_win_sum[cir]) and cir_sum or private.zz_panel3.cir_win_sum[cir], new_cir_sum+1, -1 do
        --DbgTrace( g.."g-" );
        ObjAnimate( "spr_panel3_green_"..cir..g, "alp", 0, 0, "", { 0, 0, 1,    0.2, 0, 0 } );
      end;

    end;

  end;

end;
--*********************************************************************************************************************
