-- name=mg_ingamingmachine
--*********************************************************************************************************************
-- Дамир zhestb Мавляветдинов 19.10.16
--*********************************************************************************************************************
function public.Init()

  private.is_move = false;  --движемся
  private.is_map_open = false;  --открыта мапа
  private.is_touch_door = false;

  private.ground_start_pos = {-384,-256}; --позиция хаба земли
  private.cube_size = 256;  --размер ячейки земли

  private.cube_on_screan = {7,5}; --маскимальное количество ячеек на экране
  private.player_cube = {4,3};  --ячейка на которой находиться моделька ирока изночально на экране
  private.last_cube = {7,5};  --последнии ячейки по x,y на экране изночально
  private.first_cube = {1,1};  --первые ячейки по x,y на экране изночально
  private.cube_pos_inc = {0,0}; --смещение ячеек относительно хаба земли

  private.cube_sprite = { "wall", "floor" };  --спрайты ячеек

  private.cur_player_place = {2,20};  --положение игрока на мапе
  private.player_radius = 70; --радиус модельки игрока (в расчетах мг игрок считаеться кругом)

  private.map = { --мапа
  --  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21
    { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }, --  1
    { 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 1, 1, 1, 0 }, --  2
    { 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 1, 1, 0 }, --  3
    { 0, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 0, 0, 1, 0, 0 }, --  4
    { 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0 }, --  5
    { 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 0, 0 }, --  6
    { 0, 1, 1, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0 }, --  7
    { 0, 0, 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0 }, --  8
    { 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0 }, --  9
    { 0, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 0, 0, 0 }, -- 10
    { 0, 1, 0, 0, 0, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0 }, -- 11
    { 0, 1, 0, 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0 }, -- 12
    { 0, 1, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 0, 0 }, -- 13
    { 0, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0 }, -- 14
    { 0, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 0 }, -- 15
    { 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0 }, -- 16
    { 0, 0, 0, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0 }, -- 17
    { 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 1, 0, 1, 0, 0, 0 }, -- 18
    { 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0 }, -- 19
    { 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }, -- 20
    { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }  -- 21
  };

  private.key = {5,9};  --положение ключа на мапе
  private.use_key_place = {19,6};  --место использования ключа на мапе
  private.door = {19,5};  --положение двери на мапе
  private.finish = {19,3};  --положение выйгришной ячейки на мапе
  private.checkpoints = { {6,18}, {12,18}, {2,13}, {16,11}, {9,4} };  --положение чекпоинтов на мапе

  private.clown = {  --положение клоунов на мапе
    {
      { {4,17}, {5,17}, {6,17} },
      { {2,15}, {2,14}, {2,13}, {2,12} },
      { {13,17}, {13,18}, {13,19} },
      { {16,19}, {16,18}, {16,17}, {16,16}, {17,16}, {18,16} },
      { {16,12}, {17,12}, {18,12} },
      { {12,10}, {12,11}, {12,12} },
      { {9,6}, {10,6}, {11,6}, {12,6} },
      { {10,4}, {9,4}, {8,4}, {7,4} },
      { {14,4}, {15,4}, {16,4} }
    },
    {
      { {4,13}, {4,14}, {4,15}, {5,15}, {6,15}, {7,15} },
      { {10,18}, {11,18}, {12,18} },
      { {10,12}, {10,11}, {10,10}, {9,10}, {8,10}, {8,11}, {8,12}, {9,12}, {10,12} },
      { {4,5}, {4,4}, {3,4}, {2,4} }
    }
  };

  private.clown_speed = { 1, 2 };  --скорость клоунов

  private.healthpoint = {--23   --положение хилок на мапе
    { 2, 2}, {16, 2}, { 6, 4}, { 6, 5}, { 7, 7}, {13, 8}, { 3,10}, { 4,10}, {18,10}, {12,11}, {14,13},
    {10,13}, { 6,13}, {20,15}, {13,15}, {12,15}, { 4,16}, {18,17}, {11,18}, {18,18}, {14,19}, { 8,20}, { 9,20}
  };

  private.map_size = #private.map;  --размер мапы

  private.move_aud_timer = 0;
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_ingamingmachine";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_vhstape () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_vhstape" ] = {
    type = "get",
    get_obj = "spr_ingamingmachine_vhstape",
    room = "rm_cellar",
    zz = "mg_ingamingmachine",
    zz_gate = "gmg_cellar_ingamingmachine"
  };
  --------------------------------------------------------------------------------------------
  local get_vhstape_inv = function ()
  
    interface.InventoryItemAdd( "inv_vhstape", "spr_ingamingmachine_vhstape" );
  
  end;
  local get_vhstape_end = function ()
  
    ObjDelete( "gfx_ingamingmachine_vhstape" );
  
  end;
  local get_vhstape_loc = function ()
  
    ObjDelete( "gmg_cellar_ingamingmachine" );
  
  end;
  cmn.AddSubscriber( "get_vhstape", get_vhstape_inv );
  cmn.AddSubscriber( "get_vhstape", get_vhstape_end, private.room_objname );
  cmn.AddSubscriber( "get_vhstape", get_vhstape_loc, "rm_cellar" );

  --------------------------------------------------------------------------------------------
  -- function win_ingamingmachine () end;
  --------------------------------------------------------------------------------------------
  --game.hint[ "win_ingamingmachine" ] = {
  --  type = "win",
  --  room = "rm_cellar",
  --  zz = "mg_ingamingmachine",
  --  zz_gate = "gmg_cellar_ingamingmachine"
  --};
  --------------------------------------------------------------------------------------------
  local win_ingamingmachine = function ()

    if cmn.IsEventDone( "win_ingamingmachine" ) then

      ObjMultiSet( {
        { "anm_ingamingmachine_box", { frame = 300 } },
        { "obj_ingamingmachine_player", { ang = 1.5708, input = false, pos_y = 640 } },
        { "anm_ingamingmachine_map", { alp = 0, input = false } },
        { "obj_ingamingmachine_hp_hub", { alp = 0 } },
        { "spr_ingamingmachine_vhstape", { input = true } }
      } );

    end;

  end;
--  local win_ingamingmachine_loc = function ()
--
--  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_ingamingmachine", win_ingamingmachine, "mg_ingamingmachine" );
--  cmn.AddSubscriber( "win_ingamingmachine", win_ingamingmachine_loc, "rm_cellar" );
  
end;
--*********************************************************************************************************************
function public.Load()

  if not ng_global.progress[ ng_global.currentprogress ][ "win_ingamingmachine" ].state or ng_global.currentprogress == "secret" then
    private.StartConditions();
  end;

  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_ingamingmachine" ].state;

end;
--*********************************************************************************************************************
function public.Open() 

  cmn.PlayAudio("mus", "assets/levels/level1/audio/mus/aud_bells_mus", 1);
  
  if ng_global.currentprogress == "ext" and not cmn.IsEventDone( "win_ingamingmachine" ) and not private.state.is_finish then
    cmn.MiniGameShow();
    cmn.StartTimePassing("mg_ingamingmachine");
  elseif ng_global.currentprogress == "secret" then
    rm_extra.MiniGameShow();
  end;

  if private.is_move then
    SndPlay( "assets/levels/level4/audio/sfx/aud_mg_imaginmachine_loop_elephant", "sfx", 1, 0, 0.5 );
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level4/audio/env/aud_rm_cellar_env");
  cmn.PlayAudio("env", "assets/levels/level4/audio/env/aud_rm_cellar_env");

  if ng_global.currentprogress == "ext" then

    common.SetPreviousRoom( "rm_cellar" );

    if not cmn.IsEventDone( "win_ingamingmachine" ) then
      interface.WidgetSetVisible( "InterfaceWidget_Inventory", false, true );
      interface.WidgetSetInput( "InterfaceWidget_Inventory", 0 );
    end;

  else 
    
    private.StartConditions();
    private.state = ng_global.progress[ ng_global.currentprogress ][ "win_ingamingmachine" ].state;

    private.is_draw_scene_done = false;
    private.is_move = false;
    private.is_map_open = false;
    private.is_touch_door = false;
    private.last_cube = {7,5};
    private.first_cube = {1,1};

    ObjStopAnimate( "obj_ingamingmachine_ground", "pos_xy" );

    ObjMultiSet( {
      { "tmr_ingamingmachine_move", { playing = false } },
      { "grm_ingamingmachine_cellar", {
        event_mdown = "",
        event_mup = rm_extra.GoToSecretroom,
        input = 1,
        event_menter = function () rm_extra.GateMouseEnter( "ingamingmachine_cellar", CURSOR_DOWN, "extra" ); end, 
        event_mleave = function () common_impl.GateMouseLeave( "ingamingmachine_cellar" ); end
      } },
      { "obj_ingamingmachine_player", { pos_y = 384, input = true } },
      { "anm_ingamingmachine_map", { alp = 1, input = true } },
      { "obj_ingamingmachine_hp_hub", { alp = 1 } },
      { "anm_ingamingmachine_health", { frame = 0, playing = false } },
      { "anm_ingamingmachine_damage", { frame = 0, playing = false } }
    } );
    
  end;
  
  private.DrawScene();
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  SndStop("assets/levels/level4/audio/sfx/aud_mg_imaginmachine_loop_elephant", 0.5);
  
  cmn.StopAllMus();
  
  if ng_global.currentprogress == "ext" then
    common_impl.PlayBackgroundMusic();
  end;

  if ng_global.currentprogress == "ext" and not(cmn.IsEventDone( "win_ingamingmachine" )) then

    cmn.MiniGameHide();

    interface.WidgetSetVisible( "InterfaceWidget_Inventory", true, true );
    interface.WidgetSetInput( "InterfaceWidget_Inventory", 1 );

  elseif ng_global.currentprogress == "secret" and not(cmn.IsEventDone( "win_ingamingmachine" )) then
    rm_extra.MiniGameHide();
  end;
  
end;
--*********************************************************************************************************************
function public.Reset( is_die_anm )

  if not private.state.is_start then
    return;
  end;

  --DbgTrace( "***Reset" );

  cmn.Lock( 1 );

  local tme_die_anm = is_die_anm and 1.3 or 0;

  private.StartConditions();
  private.state = ng_global.progress[ ng_global.currentprogress ][ "win_ingamingmachine" ].state;

  private.is_move = false;
  private.is_map_open = false;
  private.is_touch_door = false;

  private.last_cube = {7,5};
  private.first_cube = {1,1};

  ObjStopAnimate( "obj_ingamingmachine_ground", "pos_xy" );
  ObjSet( "tmr_ingamingmachine_move", { playing = false } );

  local func_after = function ()

    private.DrawScene( true );

    ObjAnimate( "spr_ingamingmachine_black", "alp", 0, 0, function () cmn.Lock( 0 ); end, { 0, 0, 1,    0.1, 0, 1,    0.6, 0, 0 } );

  end;

  ObjAnimate( "spr_ingamingmachine_black", "alp", 0, 0, func_after, {
    0, 0, 0,
    tme_die_anm, 0, 0,
    0.5+tme_die_anm, 0, 1,
    0.6+tme_die_anm, 0, 1
  } );

  SndStop("assets/levels/level4/audio/sfx/aud_mg_imaginmachine_loop_elephant", 0.5);

end;
--*********************************************************************************************************************
function public.Skip()

  --DbgTrace( "***Skip" );

  cmn.Lock( 1 );

  ng_global.progress[ ng_global.currentprogress ][ "win_ingamingmachine" ].skip = 1;

  private.state.is_finish = true;

  private.is_move = false;
  private.is_map_open = false;

  private.last_cube = {7,5};
  private.first_cube = {1,1};

  ObjStopAnimate( "obj_ingamingmachine_ground", "pos_xy" );
  ObjSet( "tmr_ingamingmachine_move", { playing = false } );

  local func_after = function ()

    private.DrawScene( true );

    ObjAnimate( "spr_ingamingmachine_black", "alp", 0, 0, "", { 0, 0, 1,    0.5, 0, 0 } );

  end;

  ObjAnimate( "spr_ingamingmachine_black", "alp", 0, 0, func_after, { 0, 0, 0,    0.5, 0, 1,    0.7, 0, 1 } );

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_vhstape()

  cmn.SetEventDone( "get_vhstape" );
  cmn.CallEventHandler( "get_vhstape" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  cmn.GotoRoom("rm_cellar");

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
function private.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_ingamingmachine" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_ingamingmachine" ].state = {
    cur_checkpoint = {2,20},  --последний чекпоинт
    clowns = {  --активность клоунов (одноразовые)
      {true,true,true,true,true,true,true,true,true},
      {true,true,true,true}
    },
    healthpoints = {--23  --активность хилок (одноразовые)
      true, true, true, true, true, true, true, true, true, true, true, 
      true, true, true, true, true, true, true, true, true, true, true, true
    },
    hp = 100, --жизни игрока
    get_key = false,  --ключ взят
    use_key = false,  --ключ использован
    is_finish = false,  --игра пройдена
    is_start = false  --игра начата
  };

end;
-----------------------------------------------------------------------------------
function private.DrawScene( is_reset )

  if private.is_draw_scene_done and not is_reset then
    return; --только при первом входе или резете
  end;
  private.is_draw_scene_done = true;

  --DbgTrace( "***DrawScene" );

  if private.state.is_finish then
    private.cur_player_place[1] = 19; --если игра пройдена показываем финиш, иначе последний чекпоинт
    private.cur_player_place[2] = 3;
  else
    private.cur_player_place[1] = private.state.cur_checkpoint[1];
    private.cur_player_place[2] = private.state.cur_checkpoint[2];
  end;

  private.cube_pos_inc[1] = (private.cur_player_place[1] - private.player_cube[1]) * private.cube_size;
  private.cube_pos_inc[2] = (private.cur_player_place[2] - private.player_cube[2]) * private.cube_size;

  --DbgTrace( "cur_player_place = "..private.cur_player_place[1].." "..private.cur_player_place[2] );
  --DbgTrace( "cube_pos_inc = "..private.cube_pos_inc[1].." "..private.cube_pos_inc[2] );

  local cube11_on_screan = {  --положение крайней левой верхней ячейки экрана на мапе
    private.cur_player_place[1] - private.player_cube[1] + 1,
    private.cur_player_place[2] - private.player_cube[2] + 1
  };

  --DbgTrace( "cube11_on_screan = "..cube11_on_screan[1].." "..cube11_on_screan[2] );

  local cube_res;
  local cube_place;

  for i = 1, private.cube_on_screan[2], 1 do
    for j = 1, private.cube_on_screan[1], 1 do

      cube_place = { (cube11_on_screan[1] + j - 1), (cube11_on_screan[2] + i - 1) };

      if (cube_place[1] < 1) or (cube_place[2] < 1) or (cube_place[1] > private.map_size) or (cube_place[2] > private.map_size) then
        cube_res = private.cube_sprite[1];  --за пределами мапы стена
      else
        cube_res = private.cube_sprite[ private.map[ cube_place[2] ][ cube_place[1] ] + 1 ];
      end;

      --DbgTrace(
      --  i..j.." = "..cube_place[1].." "..cube_place[2].." "..cube_res
      --  --(j*private.cube_size - private.cube_size/2 + private.cube_pos_inc[1]).." "..
      --  --(i*private.cube_size - private.cube_size/2 + private.cube_pos_inc[2])
      --);

      ObjSet( "spr_ingamingmachine_ground_"..i..j, {
        res = "assets/levels/level4/mg_ingamingmachine/"..cube_res,
        pos_x = (j*private.cube_size - private.cube_size/2 + private.cube_pos_inc[1]),
        pos_y = (i*private.cube_size - private.cube_size/2 + private.cube_pos_inc[2])
      } );

    end;
  end;

  ObjStopAnimate( "spr_ingamingmachine_hp", "scale_y" );

  ObjMultiSet( {
    { "spr_ingamingmachine_button", {
      pos_x = private.finish[1]*private.cube_size - private.cube_size/2, 
      pos_y = private.finish[2]*private.cube_size - private.cube_size/2
    } },
    { "spr_ingamingmachine_hp", { scale_y = private.state.hp/100 } },
    { "anm_ingamingmachine_player", { alp = 1 } },
    { "anm_ingamingmachine_player_die", { frame = 0 } }
  } );

  -----------------------------------checkpoints

  for i = 1, #private.checkpoints, 1 do

    --DbgTrace(
    --  "checkpoint"..private.checkpoints[i][1].."_"..private.checkpoints[i][2]
    --  .." "..(private.checkpoints[i][1]*private.cube_size - private.cube_size/2)
    --  .." "..(private.checkpoints[i][2]*private.cube_size - private.cube_size/2)
    --);

    ObjSet( "anm_ingamingmachine_checkpoint_"..private.checkpoints[i][1].."_"..private.checkpoints[i][2], { 
      pos_x = private.checkpoints[i][1]*private.cube_size - private.cube_size/2, 
      pos_y = private.checkpoints[i][2]*private.cube_size - private.cube_size/2
    } );

  end;

  -----------------------------------key

  ObjStopAnimate( "spr_ingamingmachine_key", "alp" );
  ObjStopAnimate( "spr_ingamingmachine_player_key", "alp" );
  ObjStopAnimate( "spr_ingamingmachine_player_move_key", "alp" );

  if private.state.get_key then

    ObjMultiSet( {
      { "spr_ingamingmachine_key", { visible = false, active = false, alp = 0 } },
      { "spr_ingamingmachine_player_key", { alp = 1 } },
      { "spr_ingamingmachine_player_move_key", { alp = 1 } }
    } );

  else

    ObjMultiSet( {
      { "spr_ingamingmachine_key", {
        visible = true, active = true, alp = 1,
        pos_x = private.key[1]*private.cube_size - private.cube_size/2, 
        pos_y = private.key[2]*private.cube_size - private.cube_size/2
      } },
      { "spr_ingamingmachine_player_key", { alp = 0 } },
      { "spr_ingamingmachine_player_move_key", { alp = 0 } }
    } );

  end;

  -----------------------------------door

  ObjMultiSet( {
    { "obj_ingamingmachine_door", {
      pos_x = private.door[1]*private.cube_size - private.cube_size/2, 
      pos_y = private.door[2]*private.cube_size - private.cube_size/2
    } }
  } );

  if private.state.use_key then

    private.map[ private.door[2] ][ private.door[1] ] = 1;

    ObjMultiSet( {
      { "spr_ingamingmachine_player_key", { alp = 0 } },
      { "spr_ingamingmachine_player_move_key", { alp = 0 } },
      { "anm_ingamingmachine_door", { animfunc = "func_gate_use_key", endtrig = "", playing = false, frame = 300 } }
    } );

  else

    ObjSet( "anm_ingamingmachine_door", { animfunc = "func_gate_touch", endtrig = "", playing = false, frame = 0 } );

    private.map[ private.door[2] ][ private.door[1] ] = 0;

  end;

  -----------------------------------healthpoint

  for i = 1, #private.healthpoint, 1 do

    --DbgTrace(
    --  "healthpoint_"..i.." "..private.healthpoint[i][1].."_"..private.healthpoint[i][2]
    --  .." "..(private.healthpoint[i][1]*private.cube_size - private.cube_size/2)
    --  .." "..(private.healthpoint[i][2]*private.cube_size - private.cube_size/2)
    --  .." "..tostring(private.state.healthpoints[i])
    --);

    if private.state.healthpoints[i] then

      ObjStopAnimate( "spr_ingamingmachine_healthpoint_"..i, "alp" );

      ObjSet( "spr_ingamingmachine_healthpoint_"..i, {
        visible = true, active = true, alp = 1,
        pos_x = private.healthpoint[i][1]*private.cube_size - private.cube_size/2, 
        pos_y = private.healthpoint[i][2]*private.cube_size - private.cube_size/2
      } );

    else
      ObjSet( "spr_ingamingmachine_healthpoint_"..i, { visible = false, active = false, alp = 0 } );
    end;

  end;

  -----------------------------------clown

  local clown_road;
  local clown_tme;

  for i = 1, #private.clown, 1 do
    for j = 1, #private.clown[i], 1 do

      if private.state.clowns[i][j] then

        clown_road = {};
        clown_tme = 0;

        for x = 1, #private.clown[i][j], 1 do --собираем маршрут
          table.insert( clown_road, clown_tme );
          table.insert( clown_road, 0 );
          table.insert( clown_road, (private.clown[i][j][x][1]*private.cube_size - private.cube_size/2) );
          table.insert( clown_road, (private.clown[i][j][x][2]*private.cube_size - private.cube_size/2) );
          clown_tme = clown_tme + private.clown_speed[i];
        end;

        for x = #private.clown[i][j]-1, 1, -1 do  --маршрут обратно
          table.insert( clown_road, clown_tme );
          table.insert( clown_road, 0 );
          table.insert( clown_road, (private.clown[i][j][x][1]*private.cube_size - private.cube_size/2) );
          table.insert( clown_road, (private.clown[i][j][x][2]*private.cube_size - private.cube_size/2) );
          clown_tme = clown_tme + private.clown_speed[i];
        end;

        --DbgTrace( "clown"..i.."_"..j.."_road:" );
        --cmn.LogTrace( clown_road );

        ObjStopAnimate( "anm_ingamingmachine_clown_"..i.."_"..j, "pos_xy" );
        ObjStopAnimate( "anm_ingamingmachine_clown_"..i.."_"..j, "alp" );

        ObjSet( "anm_ingamingmachine_clown_"..i.."_"..j, {
          pos_x = clown_road[3], pos_y = clown_road[4],
          playing = true, visible = true, active = true, alp = 1
        } );

        ObjAnimate( "anm_ingamingmachine_clown_"..i.."_"..j, "pos_xy", 1, 0, "", clown_road );

      else

        ObjSet( "anm_ingamingmachine_clown_"..i.."_"..j, { playing = false, visible = false, active = false, alp = 0 } );

      end;

    end;
  end;

  -----------------------------------

  if cmn.IsEventDone( "win_ingamingmachine" ) then

    ObjMultiSet( {
      { "anm_ingamingmachine_box", { frame = 300, playing = false } },
      { "spr_ingamingmachine_button_on", { alp = 0 } },
      { "obj_ingamingmachine_ground", { pos_x = -4224, pos_y = -14 } }
    } );

  else

    ObjMultiSet( {
      { "anm_ingamingmachine_box", { frame = 0, playing = false } },
      { "spr_ingamingmachine_button_on", { alp = 1 } },
      { "anm_ingamingmachine_map", { pos_y = -544 } }
    } );

    if private.state.is_finish then --форсквит при аним выйгриша / скип
      ObjMultiSet( {
        { "obj_ingamingmachine_ground", { pos_x = -4224, pos_y = -270 } },
        { "obj_ingamingmachine_player", { ang = 1.5708, input = false } },
        { "anm_ingamingmachine_player", { animfunc = "func_elephant", playing = false, frame = 0 } }
      } );
      private.Win( -4224, -270 );
    else
      ObjMultiSet( {
        { "obj_ingamingmachine_ground", {
          pos_x = private.ground_start_pos[1] - private.cube_pos_inc[1],
          pos_y = private.ground_start_pos[2] - private.cube_pos_inc[2]
        } },
        { "obj_ingamingmachine_player", { ang = 0 } },
        { "anm_ingamingmachine_player", { animfunc = "func_elephant", playing = false, frame = 0 } }
      } );

      if private.state.is_start then
        ObjSet( "tmr_ingamingmachine_move", { playing = true } );--чтоб проходила проверка на клоунов после перезахода в игру
      end;
    end;

  end;

end;
-----------------------------------------------------------------------------------
function private.CheckWin()

  --DbgTrace( "***CheckWin" );

end;
-----------------------------------------------------------------------------------
function private.WinEnd()

  --DbgTrace( "***WinEnd" );

  cmn.Lock( 0 );

  cmn.SetEventDone( "win_ingamingmachine" );
  
  if ng_global.currentprogress == "ext" then
  
    cmn.CallEventHandler( "win_ingamingmachine" );

    interface.WidgetSetVisible( "InterfaceWidget_Inventory", true, true );
    interface.WidgetSetInput( "InterfaceWidget_Inventory", 1 );

    if ng_global.progress[ ng_global.currentprogress ][ "win_ingamingmachine" ].skip == 0
    and not ng_global.noskipgames[ "win_ingamingmachine" ] then
      ng_global.noskipgames[ "win_ingamingmachine" ] = 1;
      common_impl.CheckAchiev("mg");
    end;
    
    if ng_global.playedgames and not ng_global.playedgames[ "win_ingamingmachine" ] then
      ng_global.playedgames[ "win_ingamingmachine" ] = 1;
    end;

    common_impl.PauseAchiev( 0 );
    
  else 

    ObjMultiSet( {
      { "grm_ingamingmachine_cellar", { input = 0 } },
      { "anm_ingamingmachine_map", { input = false } }
    } );
    
    interface_impl.ShowStarsWindow();
    
  end;

end;
-----------------------------------------------------------------------------------
function private.Win( ground_pos_x, ground_pos_y )

  --DbgTrace( "***Win" );

  cmn.Lock( 1 );
  
  if ng_global.currentprogress == "ext" then

    cmn.MiniGameHide();

    common_impl.PauseAchiev( 1 );
    cmn.EndTimePassing( "mg_ingamingmachine" );
    
  else 
    
    rm_extra.MiniGameHide();
    int_dialog_secretroom.StopTimer();
    
  end;

  local func_after = function ()

    ObjSet( "anm_ingamingmachine_box", { endtrig = private.WinEnd, playing = true } );

    ObjAnimate( "obj_ingamingmachine_ground", "pos_y", 0, 0, "", {
      0, 0, -270,
      1, 0, -14
    } );

    ObjAnimate( "obj_ingamingmachine_player", "pos_y", 0, 0, "", {
      0, 0, 384,
      1, 0, 640
    } );

    ObjAnimate( "anm_ingamingmachine_map", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "obj_ingamingmachine_hp_hub", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );

  end;

  ObjAnimate( "obj_ingamingmachine_player", "ang", 0, 0, "", {
    0.0, 0, ObjGet( "obj_ingamingmachine_player" ).ang,
    0.5, 0, 1.5708
  } );

  ObjAnimate( "obj_ingamingmachine_ground", "pos_xy", 0, 0, --передвигаем камеру к коробке
  function ()
    ObjSet( "anm_ingamingmachine_player", { animfunc = "func_elephant", playing = false } );
    SndStop("assets/levels/level4/audio/sfx/aud_mg_imaginmachine_loop_elephant", 0.5);
  end,
  {
    0.0, 0, ground_pos_x, ground_pos_y,
    0.5, 0, -4224, -270
  } );

  ObjAnimate( "spr_ingamingmachine_button_on", "alp", 0, 0, func_after, { 0, 0, 1,    0.5, 0, 1,    0.8, 0, 0 } );

  cmn.PlayAudio( "snd", "assets/levels/level4/audio/sfx/aud_mg_imaginmachine_win" );

end;
-----------------------------------------------------------------------------------
function public.MapClick()

  --DbgTrace( "***MapClick" );

  private.is_map_open = not private.is_map_open;

  cmn.Lock( 1 );
  local func_after = function () cmn.Lock( 0 ); end;

  if private.is_map_open then

    if private.is_move then
      public.PlayerClick();
    end;

    ObjSet( "spr_ingamingmachine_map_player", {
      pos_x = (private.cur_player_place[1]-2)*25,
      pos_y = (private.cur_player_place[2]-2)*25
    } );

    ObjAnimate( "anm_ingamingmachine_map", "pos_y", 0, 0, func_after, { 0, 0, -544,    0.5, 0, 0 } );

  else
    ObjAnimate( "anm_ingamingmachine_map", "pos_y", 0, 0, func_after, { 0, 0, 0,    0.5, 0, -544 } );
  end;

end;
-----------------------------------------------------------------------------------
function public.PlayerClick()

  --DbgTrace( "***PlayerClick" );

  private.is_move = not private.is_move;
  private.state.is_start = true;

  ObjSet( "tmr_ingamingmachine_move", { playing = true } );

  if private.is_move then

    ObjSet( "anm_ingamingmachine_player", { animfunc = "func_elephant_on", playing = true } );

    cmn.PlayAudio( "snd", "assets/levels/level4/audio/sfx/aud_mg_imaginmachine_on_elephant" );

    SndPlay( "assets/levels/level4/audio/sfx/aud_mg_imaginmachine_loop_elephant", "sfx", 1, 0, 0.5 );

  else

    ObjSet( "anm_ingamingmachine_player", { animfunc = "func_elephant", playing = false } );
    ObjStopAnimate( "obj_ingamingmachine_ground", "pos_xy" );

    cmn.PlayAudio( "snd", "assets/levels/level4/audio/sfx/aud_mg_imaginmachine_off_elephant" );

    SndStop("assets/levels/level4/audio/sfx/aud_mg_imaginmachine_loop_elephant", 0.5);

  end;

end;
-----------------------------------------------------------------------------------
function private.CheckClowns( ground_pos_x, ground_pos_y )  --проверка пересечения с клоунами

  --DbgTrace( "***CheckClowns" );

  local player_pos = {
    (private.player_cube[1]-0.5)*private.cube_size - (ground_pos_x - private.ground_start_pos[1]),
    (private.player_cube[2]-0.5)*private.cube_size - (ground_pos_y - private.ground_start_pos[2])
  };

  for i = 1, #private.clown, 1 do
    for j = 1, #private.clown[i], 1 do

      if private.state.clowns[i][j] then

        for x = 1, #private.clown[i][j], 1 do --x - точки маршрута клоуна

          if private.cur_player_place[1] == private.clown[i][j][x][1] and private.cur_player_place[2] == private.clown[i][j][x][2] then

            local clown_name = "anm_ingamingmachine_clown_"..i.."_"..j;
            local clown_params = ObjGet( clown_name );
            local clown_pos = {clown_params.pos_x, clown_params.pos_y};

            local len_to_clown = cmn.math.FindSegmentLength( player_pos, clown_pos ); --ростояние до клоуна

            if len_to_clown < private.player_radius*2 then

              --DbgTrace( "len_to_clown"..i.."_"..j.." "..len_to_clown );

              private.state.clowns[i][j] = false;
              local old_state_hp = private.state.hp;
              private.state.hp = private.state.hp - i*10 > 0 and private.state.hp - i*10 or 0;

              ObjSet( "anm_ingamingmachine_damage", { frame = 0, playing = true } );

              PartSysRestart( "fx_ingamingmachine_clown_die" );--..i.."_"..j
              ObjSet( "fx_ingamingmachine_clown_die", {--..i.."_"..j
                active = true,
                pos_x = clown_params.pos_x,
                pos_y = clown_params.pos_y
              } );

              ObjAnimate("spr_ingamingmachine_hp", "scale_y", 0, 0, "", {0, 0, old_state_hp/100,    0.15, 0, private.state.hp/100});

              ObjStopAnimate(clown_name, "pos_xy");
              ObjAnimate(
                clown_name, "alp", 0, 0,
                function ()
                  --DbgTrace( "stop "..clown_name );
                  --ObjStopAnimate(clown_name, "pos_xy");
                  ObjSet( clown_name, { playing = false, visible = false, active = false } );
                end,
                { 0, 0, 1,    0.3, 0, 0 }
              );

              cmn.PlayAudio( "snd", "assets/levels/level4/audio/sfx/aud_mg_imaginmachine_monster_touch" );

              if private.state.hp <= 0 then --умерли
                public.Reset( true );
                ObjAnimate( "anm_ingamingmachine_player", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
                ObjSet( "anm_ingamingmachine_player_die", { frame = 0, playing = true } );
              end;

            end;

            return;

          end;

        end;

      end;

    end;
  end;

end;
-----------------------------------------------------------------------------------
function private.CheckCheckpoints( ground_pos_x, ground_pos_y ) --проверка пересечения с обьектами

  --DbgTrace( "***CheckCheckpoints" );

  local player_pos = {
    (private.player_cube[1]-0.5)*private.cube_size - (ground_pos_x - private.ground_start_pos[1]),
    (private.player_cube[2]-0.5)*private.cube_size - (ground_pos_y - private.ground_start_pos[2])
  };

  for i = 1, #private.checkpoints, 1 do

    if private.cur_player_place[1] == private.checkpoints[i][1] and private.cur_player_place[2] == private.checkpoints[i][2] then

      if private.state.cur_checkpoint[1] == private.checkpoints[i][1] and private.state.cur_checkpoint[2] == private.checkpoints[i][2] then
        break;
      end;

      local checkpoint_pos = {
        (private.checkpoints[i][1]*private.cube_size - private.cube_size/2),
        (private.checkpoints[i][2]*private.cube_size - private.cube_size/2)
      };

      local len_to_checkpoint = cmn.math.FindSegmentLength( player_pos, checkpoint_pos );

      if len_to_checkpoint < private.player_radius then

        --DbgTrace( "чекпоинт_"..private.checkpoints[i][1].."_"..private.checkpoints[i][2].." - "..len_to_checkpoint );

        private.state.cur_checkpoint[1] = private.checkpoints[i][1];
        private.state.cur_checkpoint[2] = private.checkpoints[i][2];

        ObjSet( "anm_ingamingmachine_checkpoint_"..private.checkpoints[i][1].."_"..private.checkpoints[i][2], { frame = 0, playing = true } );

        cmn.PlayAudio( "snd", "assets/levels/level4/audio/sfx/aud_mg_imaginmachine_bubbles" );

      end;

      break;

    end;

  end;

  -----------------------------------healthpoint

  if private.state.hp < 100 then --если игрок здоров хилки не беруться
    for i = 1, #private.healthpoint, 1 do
      if private.cur_player_place[1] == private.healthpoint[i][1] and private.cur_player_place[2] == private.healthpoint[i][2] then
        if private.state.healthpoints[i] then

          local healthpoint_pos = {
            (private.healthpoint[i][1]*private.cube_size - private.cube_size/2),
            (private.healthpoint[i][2]*private.cube_size - private.cube_size/2)
          };

          local len_to_healthpoint = cmn.math.FindSegmentLength( player_pos, healthpoint_pos );

          if len_to_healthpoint < private.player_radius then

            --DbgTrace( "healthpoint_"..i.." - "..len_to_healthpoint );

            private.state.healthpoints[i] = false;
            private.state.hp = private.state.hp + 5;

            ObjSet( "anm_ingamingmachine_health", { frame = 0, playing = true } );

            ObjAnimate( "spr_ingamingmachine_hp", "scale_y", 0, 0, "", { 0, 0, (private.state.hp - 5)/100,    0.15, 0, private.state.hp/100 } );

            local healthpoint_name = "spr_ingamingmachine_healthpoint_"..i;

            ObjAnimate(
              healthpoint_name, "alp", 0, 0,
              function () ObjSet( healthpoint_name, { visible = false, active = false, alp = 0 } ); end,
              { 0, 0, 1,    0.3, 0, 0 }
            );

            cmn.PlayAudio( "snd", "assets/levels/level4/audio/sfx/aud_mg_imaginmachine_health" );

          end;

          break;

        else
          break;
        end;
      end;
    end;
  end;

  -----------------------------------key

  if not private.state.get_key then

    if private.cur_player_place[1] == private.key[1] and private.cur_player_place[2] == private.key[2] then

      local key_pos = {
        (private.key[1]*private.cube_size - private.cube_size/2),
        (private.key[2]*private.cube_size - private.cube_size/2)
      };

      local len_to_key = cmn.math.FindSegmentLength( player_pos, key_pos );

      if len_to_key < private.player_radius then

        --DbgTrace( "key - "..len_to_key );

        private.state.get_key = true;

        ObjAnimate( "spr_ingamingmachine_player_key", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
        ObjAnimate( "spr_ingamingmachine_player_move_key", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );

        ObjAnimate(
          "spr_ingamingmachine_key", "alp", 0, 0,
          function () ObjSet( "spr_ingamingmachine_key", { visible = false, active = false, alp = 0 } ); end,
          { 0, 0, 1,    0.3, 0, 0 }
        );

        cmn.PlayAudio( "snd", "assets/levels/level4/audio/sfx/aud_mg_imaginmachine_key" );

      end;

    elseif not private.is_touch_door
    and private.cur_player_place[1] == private.use_key_place[1]
    and private.cur_player_place[2] == private.use_key_place[2] then

      local door_pos_y = private.use_key_place[2]*private.cube_size - private.cube_size;
      local len_to_door_y = player_pos[2] - door_pos_y;

      if len_to_door_y <= private.player_radius then

        --DbgTrace( "touch door "..len_to_door_y );

        private.is_touch_door = true;

        ObjSet( "anm_ingamingmachine_door", {
          animfunc = "func_gate_touch",
          endtrig = function () private.is_touch_door = false; end,
          playing = true
        } );

      end;

    end;

  elseif private.state.get_key and not private.state.use_key then

    if private.cur_player_place[1] == private.use_key_place[1] and private.cur_player_place[2] == private.use_key_place[2] then

      --DbgTrace( "use_key_place" );

      private.state.use_key = true;

      ObjAnimate( "spr_ingamingmachine_player_key", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );
      ObjAnimate( "spr_ingamingmachine_player_move_key", "alp", 0, 0, "", { 0, 0, 1,    0.3, 0, 0 } );

      ObjSet( "anm_ingamingmachine_door", {
        animfunc = "func_gate_use_key",
        playing = true,
        endtrig = function () private.map[ private.door[2] ][ private.door[1] ] = 1; end
      } );

      cmn.PlayAudio( "snd", "assets/levels/level4/audio/sfx/aud_mg_imaginmachine_open_gates" );

    end;

  elseif private.state.get_key and private.state.use_key then

    if private.cur_player_place[1] == private.finish[1] and private.cur_player_place[2] == private.finish[2] then

      --DbgTrace( "finish" );

      private.state.is_finish = true;

      private.is_move = false;

      ObjStopAnimate( "obj_ingamingmachine_ground", "pos_xy" );

      ObjSet( "obj_ingamingmachine_player", { input = false } );

      private.Win( ground_pos_x, ground_pos_y );

    end;

  end;

end;
-----------------------------------------------------------------------------------
function public.PlayerMove()

  --DbgTrace( "***PlayerMove" );

  ObjSet( "tmr_ingamingmachine_move", { playing = true } );

  local ground_parametrs = ObjGet( "obj_ingamingmachine_ground" );

  private.CheckClowns( ground_parametrs.pos_x, ground_parametrs.pos_y );

  if not private.is_move then
    return;
  end;

  local cursor_pos = GetZoomCursorPos();
  cursor_pos[1] = cursor_pos[1] - 512;
  cursor_pos[2] = cursor_pos[2] - 384;

  ObjSet( "obj_ingamingmachine_player", { ang = -math.atan2(cursor_pos[2], cursor_pos[1]) } );

  local player_end_pos_x = ground_parametrs.pos_x - cursor_pos[1];
  local player_end_pos_y = ground_parametrs.pos_y - cursor_pos[2];

  local new_player_place = {  --новая позиция игрока на мапе
    math.floor(private.player_cube[1]+0.5-((ground_parametrs.pos_x - private.ground_start_pos[1]) / private.cube_size)),
    math.floor(private.player_cube[2]+0.5-((ground_parametrs.pos_y - private.ground_start_pos[2]) / private.cube_size))
  };

  local new_player_pos = {  --новая позиция x,y игрока (земли)
    (private.player_cube[1]-0.5)*private.cube_size - (ground_parametrs.pos_x - private.ground_start_pos[1]),
    (private.player_cube[2]-0.5)*private.cube_size - (ground_parametrs.pos_y - private.ground_start_pos[2])
  };

  --DbgTrace( new_player_place[1].." "..new_player_place[2].." = "..new_player_pos[1].." "..new_player_pos[2] );

  if private.map[ new_player_place[2] ][ new_player_place[1] - 1 ] == 0 then  --проверки пересечения со стенами и углами

    local cur_cube_border_pos = (new_player_place[1] - 1) * private.cube_size;
    local len_to_border = new_player_pos[1] - cur_cube_border_pos;
    --DbgTrace( (new_player_place[1] - 1).." "..(new_player_place[2]).." слева стена "..len_to_border );

    if len_to_border < private.player_radius and player_end_pos_x > ground_parametrs.pos_x then
      player_end_pos_x = ground_parametrs.pos_x - (private.player_radius - len_to_border) ;
      --DbgTrace( ground_parametrs.pos_x.." -> "..player_end_pos_x );
    end;

  else  --если нет стены то проверяем углы

    if private.map[ new_player_place[2] - 1 ][ new_player_place[1] - 1 ] == 0 then

      local corner_pos = { ((new_player_place[1] - 1) * private.cube_size), ((new_player_place[2] - 1) * private.cube_size) };
      local len_to_corner = cmn.math.FindSegmentLength( new_player_pos, corner_pos );

      if len_to_corner < private.player_radius and player_end_pos_y > ground_parametrs.pos_y then
        player_end_pos_y = ground_parametrs.pos_y - (private.player_radius - len_to_corner) ;
        --DbgTrace( "player_end_pos_y "..ground_parametrs.pos_y.." -> "..player_end_pos_y );
      end;

    end;

    if private.map[ new_player_place[2] + 1 ][ new_player_place[1] - 1 ] == 0 then

      local corner_pos = { ((new_player_place[1] - 1) * private.cube_size), (new_player_place[2] * private.cube_size) };
      local len_to_corner = cmn.math.FindSegmentLength( new_player_pos, corner_pos );

      if len_to_corner < private.player_radius and player_end_pos_y < ground_parametrs.pos_y then
        player_end_pos_y = ground_parametrs.pos_y + (private.player_radius - len_to_corner) ;
        --DbgTrace( "player_end_pos_y "..ground_parametrs.pos_y.." -> "..player_end_pos_y );
      end;

    end;

  end;

  --------------------------------------------------------

  if private.map[ new_player_place[2] ][ new_player_place[1] + 1 ] == 0 then

    local cur_cube_border_pos = new_player_place[1] * private.cube_size;
    local len_to_border = cur_cube_border_pos - new_player_pos[1];

    --DbgTrace( (new_player_place[1] + 1).." "..(new_player_place[2]).." справа стена "..len_to_border );

    if len_to_border < private.player_radius and player_end_pos_x < ground_parametrs.pos_x then
      player_end_pos_x = ground_parametrs.pos_x + (private.player_radius - len_to_border) ;
      --DbgTrace( ground_parametrs.pos_x.." -> "..player_end_pos_x );
    end;

  else

    if private.map[ new_player_place[2] - 1 ][ new_player_place[1] + 1 ] == 0 then

      local corner_pos = { (new_player_place[1] * private.cube_size), ((new_player_place[2] - 1) * private.cube_size) };
      local len_to_corner = cmn.math.FindSegmentLength( new_player_pos, corner_pos );

      if len_to_corner < private.player_radius and player_end_pos_y > ground_parametrs.pos_y then
        player_end_pos_y = ground_parametrs.pos_y - (private.player_radius - len_to_corner) ;
        --DbgTrace( "player_end_pos_y "..ground_parametrs.pos_y.." -> "..player_end_pos_y );
      end;

    end;

    if private.map[ new_player_place[2] + 1 ][ new_player_place[1] + 1 ] == 0 then

      local corner_pos = { (new_player_place[1] * private.cube_size), (new_player_place[2] * private.cube_size) };
      local len_to_corner = cmn.math.FindSegmentLength( new_player_pos, corner_pos );

      if len_to_corner < private.player_radius and player_end_pos_y < ground_parametrs.pos_y then
        player_end_pos_y = ground_parametrs.pos_y + (private.player_radius - len_to_corner) ;
        --DbgTrace( "player_end_pos_y "..ground_parametrs.pos_y.." -> "..player_end_pos_y );
      end;

    end;

  end;

  -----------------------------------------

  if private.map[ new_player_place[2] - 1 ][ new_player_place[1] ] == 0 then

    local cur_cube_border_pos = (new_player_place[2] - 1) * private.cube_size;
    local len_to_border = new_player_pos[2] - cur_cube_border_pos;

    --DbgTrace( (new_player_place[1]).." "..(new_player_place[2] - 1).." сверху стена "..len_to_border );

    if len_to_border < private.player_radius and player_end_pos_y > ground_parametrs.pos_y then
      player_end_pos_y = ground_parametrs.pos_y - (private.player_radius - len_to_border) ;
      --DbgTrace( ground_parametrs.pos_y.." -> "..player_end_pos_y );
    end;

  else

    if private.map[ new_player_place[2] - 1 ][ new_player_place[1] - 1 ] == 0 then

      local corner_pos = { ((new_player_place[1] - 1) * private.cube_size), ((new_player_place[2] - 1) * private.cube_size) };
      local len_to_corner = cmn.math.FindSegmentLength( new_player_pos, corner_pos );

      if len_to_corner < private.player_radius and player_end_pos_x > ground_parametrs.pos_x then
        player_end_pos_x = ground_parametrs.pos_x - (private.player_radius - len_to_corner) ;
        --DbgTrace( "player_end_pos_x "..ground_parametrs.pos_x.." -> "..player_end_pos_x );
      end;

    end;

    if private.map[ new_player_place[2] - 1 ][ new_player_place[1] + 1 ] == 0 then

      local corner_pos = { (new_player_place[1] * private.cube_size), ((new_player_place[2] - 1) * private.cube_size) };
      local len_to_corner = cmn.math.FindSegmentLength( new_player_pos, corner_pos );

      if len_to_corner < private.player_radius and player_end_pos_x < ground_parametrs.pos_x then
        player_end_pos_x = ground_parametrs.pos_x + (private.player_radius - len_to_corner) ;
        --DbgTrace( "player_end_pos_x "..ground_parametrs.pos_x.." -> "..player_end_pos_x );
      end;

    end;

  end;

  --------------------------------------------------------

  if private.map[ new_player_place[2] + 1 ][ new_player_place[1] ] == 0 then

    local cur_cube_border_pos = new_player_place[2] * private.cube_size;
    local len_to_border = cur_cube_border_pos - new_player_pos[2];

    --DbgTrace( (new_player_place[1]).." "..(new_player_place[2]+1).." снизу стена "..len_to_border );

    if len_to_border < private.player_radius and player_end_pos_y < ground_parametrs.pos_y then
      player_end_pos_y = ground_parametrs.pos_y + (private.player_radius - len_to_border) ;
      --DbgTrace( ground_parametrs.pos_y.." -> "..player_end_pos_y );
    end;

  else

    if private.map[ new_player_place[2] + 1 ][ new_player_place[1] - 1 ] == 0 then

      local corner_pos = { ((new_player_place[1] - 1) * private.cube_size), ((new_player_place[2]) * private.cube_size) };
      local len_to_corner = cmn.math.FindSegmentLength( new_player_pos, corner_pos );

      if len_to_corner < private.player_radius and player_end_pos_x > ground_parametrs.pos_x then
        player_end_pos_x = ground_parametrs.pos_x - (private.player_radius - len_to_corner) ;
        --DbgTrace( "player_end_pos_x "..ground_parametrs.pos_x.." -> "..player_end_pos_x );
      end;

    end;

    if private.map[ new_player_place[2] + 1 ][ new_player_place[1] + 1 ] == 0 then

      local corner_pos = { (new_player_place[1] * private.cube_size), ((new_player_place[2]) * private.cube_size) };
      local len_to_corner = cmn.math.FindSegmentLength( new_player_pos, corner_pos );

      if len_to_corner < private.player_radius and player_end_pos_x < ground_parametrs.pos_x then
        player_end_pos_x = ground_parametrs.pos_x + (private.player_radius - len_to_corner) ;
        --DbgTrace( "player_end_pos_x "..ground_parametrs.pos_x.." -> "..player_end_pos_x );
      end;

    end;

  end;

  ObjAnimate( "obj_ingamingmachine_ground", "pos_xy", 0, 0, "", {
    0, 0, ground_parametrs.pos_x, ground_parametrs.pos_y,
    1, 0, player_end_pos_x, player_end_pos_y
  } );

  local start_to_end_len = cmn.math.FindSegmentLength( {ground_parametrs.pos_x, ground_parametrs.pos_y}, {player_end_pos_x, player_end_pos_y} );
  --  0 - 800 len
  --150 -  50 ms
  local move_aud_time = (-(start_to_end_len * 100 / 800) + 150)/1000;

  if private.move_aud_timer > move_aud_time then
    cmn.PlayAudio( "snd", "assets/levels/level4/audio/sfx/aud_mg_imaginmachine_mech_"..math.random( 1, 4 ) );
    private.move_aud_timer = 0;
  end;
  private.move_aud_timer = private.move_aud_timer + 0.0166667;
  ---------------------------------------
  ---------------------------------------

  --if (new_player_place[1] ~= private.cur_player_place[1] )
  --or (new_player_place[2] ~= private.cur_player_place[2] ) then
  --  --DbgTrace( "new_player_place "..new_player_place[1].." "..new_player_place[2] );
  --  --DbgTrace( "cube_pos_inc = "..private.cube_pos_inc[1].." "..private.cube_pos_inc[2] );
  --end;

  if (new_player_place[1] ~= private.cur_player_place[1] ) then --перемещение ячеек земли

    local new_cube_pos_x;
    local cube_res;
    local cube_place;
    local x = private.first_cube[2];
    --local cube11_on_screan = { new_player_place[1] - private.player_cube[1] + 1, new_player_place[2] - private.player_cube[2] + 1 };
    local cube11_on_screan = { new_player_place[1] - private.player_cube[1] + 1, private.cur_player_place[2] - private.player_cube[2] + 1 };
    --положение крайней левой верхней ячейки экрана на мапе
    --DbgTrace( "cube11_on_screan = "..cube11_on_screan[1].." "..cube11_on_screan[2] );

    if (new_player_place[1] < private.cur_player_place[1] ) then

      new_cube_pos_x = private.cube_pos_inc[1] - private.cube_size/2;
      private.cube_pos_inc[1] = private.cube_pos_inc[1] - private.cube_size;

      for i = 1, private.cube_on_screan[2], 1 do

        cube_place = { (cube11_on_screan[1]), (cube11_on_screan[2] + i - 1) };
        if (cube_place[1] < 1) or (cube_place[2] < 1) or (cube_place[1] > private.map_size) or (cube_place[2] > private.map_size) then
          cube_res = private.cube_sprite[1];
        else
          cube_res = private.cube_sprite[ private.map[ cube_place[2] ][ cube_place[1] ] + 1 ];
        end;
        --DbgTrace(x..private.last_cube[1].." = "..cube_place[1].." "..cube_place[2].." "..cube_res.." -> "..new_cube_pos_x);

        ObjSet( "spr_ingamingmachine_ground_"..x..private.last_cube[1], {
          pos_x = new_cube_pos_x,
          res = "assets/levels/level4/mg_ingamingmachine/"..cube_res
        } );

        x = x + 1 <= private.cube_on_screan[2] and x + 1 or 1;

      end;

      private.last_cube[1] = private.last_cube[1] - 1 > 0 and private.last_cube[1] - 1 or private.cube_on_screan[1];
      private.first_cube[1] = private.first_cube[1] - 1 > 0 and private.first_cube[1] - 1 or private.cube_on_screan[1];

    else--if (new_player_place[1] > private.cur_player_place[1] ) then

      new_cube_pos_x = private.cube_size*private.cube_on_screan[1] + private.cube_size/2 + private.cube_pos_inc[1];
      private.cube_pos_inc[1] = private.cube_pos_inc[1] + private.cube_size;

      for i = 1, private.cube_on_screan[2], 1 do

        cube_place = { (cube11_on_screan[1] + private.cube_on_screan[1] - 1), (cube11_on_screan[2] + i - 1) };
        if (cube_place[1] < 1) or (cube_place[2] < 1) or (cube_place[1] > private.map_size) or (cube_place[2] > private.map_size) then
          cube_res = private.cube_sprite[1];
        else
          cube_res = private.cube_sprite[ private.map[ cube_place[2] ][ cube_place[1] ] + 1 ];
        end;
        --DbgTrace(x..private.first_cube[1].." = "..cube_place[1].." "..cube_place[2].." "..cube_res.." -> "..new_cube_pos_x);

        ObjSet( "spr_ingamingmachine_ground_"..x..private.first_cube[1], {
          pos_x = new_cube_pos_x,
          res = "assets/levels/level4/mg_ingamingmachine/"..cube_res
        } );

        x = x + 1 <= private.cube_on_screan[2] and x + 1 or 1;

      end;

      private.last_cube[1]  = private.last_cube[1]  + 1 <= private.cube_on_screan[1] and private.last_cube[1]  + 1 or 1;
      private.first_cube[1] = private.first_cube[1] + 1 <= private.cube_on_screan[1] and private.first_cube[1] + 1 or 1;

    end;

    private.cur_player_place[1] = new_player_place[1];

  end;

  if (new_player_place[2] ~= private.cur_player_place[2] ) then

    local new_cube_pos_y;
    local cube_res;
    local cube_place;
    local x = private.first_cube[1];
    local cube11_on_screan = { new_player_place[1] - private.player_cube[1] + 1, new_player_place[2] - private.player_cube[2] + 1 };
    --DbgTrace( "cube11_on_screan = "..cube11_on_screan[1].." "..cube11_on_screan[2] );

    if (new_player_place[2] < private.cur_player_place[2] ) then

      new_cube_pos_y = private.cube_pos_inc[2] - private.cube_size/2;
      private.cube_pos_inc[2] = private.cube_pos_inc[2] - private.cube_size;

      for i = 1, private.cube_on_screan[1], 1 do

        cube_place = { (cube11_on_screan[1] + i - 1), (cube11_on_screan[2]) };
        if (cube_place[1] < 1) or (cube_place[2] < 1) or (cube_place[1] > private.map_size) or (cube_place[2] > private.map_size) then
          cube_res = private.cube_sprite[1];
        else
          cube_res = private.cube_sprite[ private.map[ cube_place[2] ][ cube_place[1] ] + 1 ];
        end;
        --DbgTrace(private.last_cube[2]..x.." = "..cube_place[1].." "..cube_place[2].." "..cube_res.." -> "..new_cube_pos_y);

        ObjSet( "spr_ingamingmachine_ground_"..private.last_cube[2]..x, {
          pos_y = new_cube_pos_y,
          res = "assets/levels/level4/mg_ingamingmachine/"..cube_res
        } );

        x = x + 1 <= private.cube_on_screan[1] and x + 1 or 1;

      end;

      private.last_cube[2] = private.last_cube[2] - 1 > 0 and private.last_cube[2] - 1 or private.cube_on_screan[2];
      private.first_cube[2] = private.first_cube[2] - 1 > 0 and private.first_cube[2] - 1 or private.cube_on_screan[2];

    else--if (new_player_place[2] > private.cur_player_place[2] ) then

      new_cube_pos_y = private.cube_size*private.cube_on_screan[2] + private.cube_size/2 + private.cube_pos_inc[2];
      private.cube_pos_inc[2] = private.cube_pos_inc[2] + private.cube_size;

      for i = 1, private.cube_on_screan[1], 1 do

        cube_place = { (cube11_on_screan[1] + i - 1), (cube11_on_screan[2] + private.cube_on_screan[2] - 1) };
        if (cube_place[1] < 1) or (cube_place[2] < 1) or (cube_place[1] > private.map_size) or (cube_place[2] > private.map_size) then
          cube_res = private.cube_sprite[1];
        else
          cube_res = private.cube_sprite[ private.map[ cube_place[2] ][ cube_place[1] ] + 1 ];
        end;
        --DbgTrace(private.first_cube[2]..x.." = "..cube_place[1].." "..cube_place[2].." "..cube_res.." -> "..new_cube_pos_y);

        ObjSet( "spr_ingamingmachine_ground_"..private.first_cube[2]..x, {
          pos_y = new_cube_pos_y,
          res = "assets/levels/level4/mg_ingamingmachine/"..cube_res
        } );

        x = x + 1 <= private.cube_on_screan[1] and x + 1 or 1;

      end;

      private.last_cube[2] = private.last_cube[2] + 1 <= private.cube_on_screan[2] and private.last_cube[2] + 1 or 1;
      private.first_cube[2] = private.first_cube[2] + 1 <= private.cube_on_screan[2] and private.first_cube[2] + 1 or 1;

    end;

    private.cur_player_place[2] = new_player_place[2];

  end;

  private.CheckCheckpoints( ground_parametrs.pos_x, ground_parametrs.pos_y );

end;
--*********************************************************************************************************************