-- name=rm_nayasroom
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_nayasroom";
  --------------------------------------------------------------------------------------------
  private.dlg_lipsync = "";
  private.Init_Subroom();
  private.Init_Piano();
  --------------------------------------------------------------------------------------------
  -- function get_musicnote3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_musicnote3" ] = {
    type = "get",
    get_obj = "spr_littlebox_musicnote3",
    room = private.room_objname,
    zz = "zz_littlebox",
    zz_gate = "gzz_nayasroom_littlebox"
  };
  --------------------------------------------------------------------------------------------
  local get_musicnote3_inv = function ()
  
    interface.InventoryItemAdd( "inv_musicnote3", "spr_littlebox_musicnote3" );
  
  end;
  local get_musicnote3_end = function ()
  
    ObjDelete( "gfx_littlebox_musicnote3" );
    ObjDelete( "spr_littlebox_musicnote3_sh" );
    ObjDelete( "spr_nayasroom_box_note" );
  
  end;
  
  cmn.AddSubscriber( "get_musicnote3", get_musicnote3_inv );
  cmn.AddSubscriber( "get_musicnote3", get_musicnote3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_toysword () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_toysword" ] = {
    type = "get",
    get_obj = "spr_nayasbed_toysword",
    room = private.room_objname,
    zz = "zz_nayasbed",
    zz_gate = "gzz_nayasroom_nayasbed"
  };
  --------------------------------------------------------------------------------------------
  local get_toysword_inv = function ()
  
    interface.InventoryItemAdd( "inv_toysword", "spr_nayasbed_toysword" );
  
  end;
  local get_toysword_end = function ()
  
    ObjDelete( "gfx_nayasbed_toysword" );
    ObjDelete( "spr_nayasroom_bed_sword_2" );
    ObjDelete( "gzz_nayasroom_nayasbed" );
  
  end;
  
  cmn.AddSubscriber( "get_toysword", get_toysword_inv );
  cmn.AddSubscriber( "get_toysword", get_toysword_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_angel1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_angel1" ] = {
    type = "get",
    get_obj = "spr_nayasbed_angel1",
    room = private.room_objname,
    zz = "zz_nayasbed",
    zz_gate = "gzz_nayasroom_nayasbed"
  };
  --------------------------------------------------------------------------------------------
  local get_angel1_inv = function ()
  
    interface.InventoryItemAdd( "inv_angel1", "spr_nayasbed_angel1" );
  
  end;
  local get_angel1_end = function ()
  
    ObjDelete( "gfx_nayasbed_angel1" );
    ObjDelete( "spr_nayasbed_angel1_sh" );
    ObjDelete( "spr_nayasbed_angel1_sh_2" );
    ObjDelete( "spr_nayasroom_bed_angel_2" );
  
  end;
  
  cmn.AddSubscriber( "get_angel1", get_angel1_inv );
  cmn.AddSubscriber( "get_angel1", get_angel1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_developer () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_developer" ] = {
    type = "get",
    get_obj = "spr_highmirror_developer",
    room = private.room_objname,
    zz = "zz_highmirror",
    zz_gate = "gzz_nayasroom_highmirror"
  };
  --------------------------------------------------------------------------------------------
  local get_developer_inv = function ()
  
    interface.InventoryItemAdd( "inv_developer", "spr_highmirror_developer" );
  
  end;
  local get_developer_end = function ()
  
    ObjDelete( "gfx_highmirror_developer" );
    ObjDelete( "spr_highmirror_developer_sh" );
    ObjDelete( "spr_nayasroom_mirror_bottle" );
  
  end;
  
  cmn.AddSubscriber( "get_developer", get_developer_inv );
  cmn.AddSubscriber( "get_developer", get_developer_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_drawerhandle () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_drawerhandle" ] = {
    type = "get",
    get_obj = "spr_highmirror_drawerhandle",
    room = private.room_objname,
    zz = "zz_highmirror",
    zz_gate = "gzz_nayasroom_highmirror"
  };
  --------------------------------------------------------------------------------------------
  local get_drawerhandle_inv = function ()
  
    interface.InventoryItemAdd( "inv_drawerhandle", "spr_highmirror_drawerhandle" );
  
  end;
  local get_drawerhandle_end = function ()
  
    ObjDelete( "gfx_highmirror_drawerhandle" );
    ObjDelete( "spr_highmirror_drawerhandle_sh" );
    ObjDelete( "spr_nayasroom_mirror_handle" );
  
  end;
  
  cmn.AddSubscriber( "get_drawerhandle", get_drawerhandle_inv );
  cmn.AddSubscriber( "get_drawerhandle", get_drawerhandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ballerina () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_ballerina" ] = {
    type = "get",
    get_obj = "spr_highmirror_ballerina",
    room = private.room_objname,
    zz = "zz_highmirror",
    zz_gate = "gzz_nayasroom_highmirror"
  };
  --------------------------------------------------------------------------------------------
  local get_ballerina_inv = function ()
  
    interface.InventoryItemAdd( "inv_ballerina", "spr_highmirror_ballerina" );
  
  end;
  local get_ballerina_end = function ()
  
    ObjDelete( "gfx_highmirror_ballerina" );
    ObjDelete( "spr_highmirror_ballerina_sh" );
    ObjDelete( "spr_nayasroom_mirror_ballerine" );
    ObjDelete( "gzz_nayasroom_highmirror" );
  
  end;
  
  cmn.AddSubscriber( "get_ballerina", get_ballerina_inv );
  cmn.AddSubscriber( "get_ballerina", get_ballerina_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sapphire () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_sapphire" ] = {
    type = "get",
    get_obj = "spr_piano_sapphire",
    room = private.room_objname,
    zz = "zz_piano",
    zz_gate = "gzz_nayasroom_piano"
  };
  --------------------------------------------------------------------------------------------
  local get_sapphire_inv = function ()
  
    interface.InventoryItemAdd( "inv_sapphire", "spr_piano_sapphire" );
    ObjSet("inv_egg_star_light",  { alp = 1 });
  
  end;
  local get_sapphire_end = function ()
  
    ObjDelete( "spr_piano_sapphire_shadow" );
    ObjDelete( "gfx_piano_sapphire" );
    ObjDelete( "spr_nayasroom_piano_gem" );
    
    if cmn.IsEventDone("get_heartpart2") then
      ObjDelete( "gzz_nayasroom_piano" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_sapphire", get_sapphire_inv );
  cmn.AddSubscriber( "get_sapphire", get_sapphire_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_battery2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_battery2" ] = {
    type = "get",
    get_obj = "spr_piano_battery2",
    room = private.room_objname,
    zz = "zz_piano",
    zz_gate = "gzz_nayasroom_piano"
  };
  --------------------------------------------------------------------------------------------
  local get_battery2_inv = function ()
  
    interface.InventoryItemAdd( "inv_battery2", "spr_piano_battery2" );
    ObjSet( "inv_lvl4flashlight_star_light", { alp = 1 } );
  
  end;
  local get_battery2_end = function ()
  
    ObjDelete( "gfx_piano_battery2" );
    ObjDelete( "spr_piano_battery2_shadow" );
    ObjDelete( "spr_nayasroom_piano_battery" );
  
  end;
  
  cmn.AddSubscriber( "get_battery2", get_battery2_inv );
  cmn.AddSubscriber( "get_battery2", get_battery2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_heartpart2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_heartpart2" ] = {
    type = "get",
    get_obj = "spr_piano_heartpart2",
    room = private.room_objname,
    zz = "zz_piano",
    zz_gate = "gzz_nayasroom_piano"
  };
  --------------------------------------------------------------------------------------------
  local get_heartpart2_inv = function ()
  
    interface.InventoryItemAdd( "inv_heartpart2", "spr_piano_heartpart2" );
  
  end;
  local get_heartpart2_end = function ()
  
    ObjDelete( "gfx_piano_heartpart2" );
    
    if cmn.IsEventDone("get_sapphire") then
      ObjDelete( "gzz_nayasroom_piano" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_heartpart2", get_heartpart2_inv );
  cmn.AddSubscriber( "get_heartpart2", get_heartpart2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_letter8 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_letter8" ] = {
    type = "get",
    get_obj = "spr_nayasroom_letter8",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_letter8_inv = function ()
  
    interface.InventoryItemAdd( "inv_letter", "spr_nayasroom_letter8", function () cmn.GetMultyObject( 'letter', 9 ); end );
  
  end;
  local get_letter8_end = function ()
  
    ObjDelete( "gfx_nayasroom_letter8" );
  
  end;
  
  cmn.AddSubscriber( "get_letter8", get_letter8_inv );
  cmn.AddSubscriber( "get_letter8", get_letter8_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_lvl4bulb () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl4bulb" ] = {
      type = "get",
      get_obj = "spr_nayasroom_lvl4bulb",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_lvl4bulb_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl4bulb", "spr_nayasroom_lvl4bulb" );
    ObjSet( "inv_lvl4flashlight_star_light", { alp = 1 } );
  
  end;
  local get_lvl4bulb_mid = function ()
  
    ObjDelete( "gfx_nayasroom_lvl4bulb" );
    ObjDelete( "spr_nayasroom_lvl4bulb_sh" );
    
  end;
  local get_lvl4bulb_end = function ()
  
    ObjDelete( "obj_nayasroom_dialog_victor2" );
    ObjDelete( "anm_nayasroom_victor_out" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_lvl4bulb", get_lvl4bulb_inv );
  cmn.AddSubscriber( "get_lvl4bulb_inv", get_lvl4bulb_inv, private.room_objname );
  cmn.AddSubscriber( "get_lvl4bulb", get_lvl4bulb_mid, private.room_objname );
  cmn.AddSubscriber( "get_lvl4bulb_mid", get_lvl4bulb_mid, private.room_objname );
  cmn.AddSubscriber( "get_lvl4bulb", get_lvl4bulb_end, private.room_objname );
  cmn.AddSubscriber( "get_lvl4bulb_end", get_lvl4bulb_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_heartpart4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_heartpart4" ] = {
    type = "use",
    inv_obj = "inv_heartpart4",
    use_place = "obj_littlebox_use_heartpart4",
    room = private.room_objname,
    zz = "zz_littlebox",
    zz_gate = "gzz_nayasroom_littlebox"
  };
  --------------------------------------------------------------------------------------------
  local use_heartpart4_inv = function ()
  
    interface.InventoryItemRemove( "inv_heartpart4" );
  
  end;
  local use_heartpart4_beg = function ()
  
    ObjDelete( "obj_littlebox_use_heartpart4" );
  
  end;
  local use_heartpart4_end = function ()
  
    if cmn.IsEventDone("use_heartpart1") and cmn.IsEventDone("use_heartpart2") and cmn.IsEventDone("use_heartpart3") then
      ObjDelete( "gzz_nayasroom_littlebox" );
      ObjDelete( "spr_nayasroom_box_closed" );
      ObjMultiSet( { {"gmg_nayasroom_memories", { input = 1, alp = 1, active = 1 }},
                     {"spr_nayasroom_box_open", { alp = 1 }} } );
    else 
      ObjMultiSet( { {"spr_littlebox_heartpart4",  { alp = 1 }},
                     {"spr_nayasroom_box_heart_4",  { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_heartpart4", use_heartpart4_beg, private.room_objname );
  cmn.AddSubscriber( "use_heartpart4", use_heartpart4_inv );
  cmn.AddSubscriber( "use_heartpart4", use_heartpart4_end, private.room_objname );
  cmn.AddSubscriber( "use_heartpart4_inv", use_heartpart4_inv, private.room_objname );
  cmn.AddSubscriber( "use_heartpart4_beg", use_heartpart4_beg, private.room_objname );
  cmn.AddSubscriber( "use_heartpart4_end", use_heartpart4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_heartpart3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_heartpart3" ] = {
    type = "use",
    inv_obj = "inv_heartpart3",
    use_place = "obj_littlebox_use_heartpart3",
    room = private.room_objname,
    zz = "zz_littlebox",
    zz_gate = "gzz_nayasroom_littlebox"
  };
  --------------------------------------------------------------------------------------------
  local use_heartpart3_inv = function ()
  
    interface.InventoryItemRemove( "inv_heartpart3" );
  
  end;
  local use_heartpart3_beg = function ()
  
    ObjDelete( "obj_littlebox_use_heartpart3" );
  
  end;
  local use_heartpart3_end = function ()
  
    if cmn.IsEventDone("use_heartpart1") and cmn.IsEventDone("use_heartpart2") and cmn.IsEventDone("use_heartpart4") then
      ObjDelete( "gzz_nayasroom_littlebox" );
      ObjDelete( "spr_nayasroom_box_closed" );
      ObjMultiSet( { {"gmg_nayasroom_memories", { input = 1, alp = 1, active = 1 }},
                     {"spr_nayasroom_box_open", { alp = 1 }} } );
    else 
      ObjMultiSet( { {"spr_littlebox_heartpart3",  { alp = 1 }},
                     {"spr_nayasroom_box_heart_3",  { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_heartpart3", use_heartpart3_beg, private.room_objname );
  cmn.AddSubscriber( "use_heartpart3", use_heartpart3_inv );
  cmn.AddSubscriber( "use_heartpart3", use_heartpart3_end, private.room_objname );
  cmn.AddSubscriber( "use_heartpart3_inv", use_heartpart3_inv, private.room_objname );
  cmn.AddSubscriber( "use_heartpart3_beg", use_heartpart3_beg, private.room_objname );
  cmn.AddSubscriber( "use_heartpart3_end", use_heartpart3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_heartpart1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_heartpart1" ] = {
    type = "use",
    inv_obj = "inv_heartpart1",
    use_place = "obj_littlebox_use_heartpart1",
    room = private.room_objname,
    zz = "zz_littlebox",
    zz_gate = "gzz_nayasroom_littlebox"
  };
  --------------------------------------------------------------------------------------------
  local use_heartpart1_inv = function ()
  
    interface.InventoryItemRemove( "inv_heartpart1" );
  
  end;
  local use_heartpart1_beg = function ()
  
    ObjDelete( "obj_littlebox_use_heartpart1" );
  
  end;
  local use_heartpart1_end = function ()
  
    if cmn.IsEventDone("use_heartpart4") and cmn.IsEventDone("use_heartpart2") and cmn.IsEventDone("use_heartpart3") then
      ObjDelete( "gzz_nayasroom_littlebox" );
      ObjDelete( "spr_nayasroom_box_closed" );
      ObjMultiSet( { {"gmg_nayasroom_memories", { input = 1, alp = 1, active = 1 }},
                     {"spr_nayasroom_box_open", { alp = 1 }} } );
    else 
      ObjMultiSet( { {"spr_littlebox_heartpart1",  { alp = 1 }},
                     {"spr_nayasroom_box_heart_1",  { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_heartpart1", use_heartpart1_beg, private.room_objname );
  cmn.AddSubscriber( "use_heartpart1", use_heartpart1_inv );
  cmn.AddSubscriber( "use_heartpart1", use_heartpart1_end, private.room_objname );
  cmn.AddSubscriber( "use_heartpart1_inv", use_heartpart1_inv, private.room_objname );
  cmn.AddSubscriber( "use_heartpart1_beg", use_heartpart1_beg, private.room_objname );
  cmn.AddSubscriber( "use_heartpart1_end", use_heartpart1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_heartpart2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_heartpart2" ] = {
    type = "use",
    inv_obj = "inv_heartpart2",
    use_place = "obj_littlebox_use_heartpart2",
    room = private.room_objname,
    zz = "zz_littlebox",
    zz_gate = "gzz_nayasroom_littlebox"
  };
  --------------------------------------------------------------------------------------------
  local use_heartpart2_inv = function ()
  
    interface.InventoryItemRemove( "inv_heartpart2" );
  
  end;
  local use_heartpart2_beg = function ()
  
    ObjDelete( "obj_littlebox_use_heartpart2" );
  
  end;
  local use_heartpart2_end = function ()
  
    if cmn.IsEventDone("use_heartpart1") and cmn.IsEventDone("use_heartpart4") and cmn.IsEventDone("use_heartpart3") then
      ObjDelete( "gzz_nayasroom_littlebox" );
      ObjDelete( "spr_nayasroom_box_closed" );
      ObjMultiSet( { {"gmg_nayasroom_memories", { input = 1, alp = 1, active = 1 }},
                     {"spr_nayasroom_box_open", { alp = 1 }} } );
    else 
      ObjMultiSet( { {"spr_littlebox_heartpart2",  { alp = 1 }},
                     {"spr_nayasroom_box_heart_2",  { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_heartpart2", use_heartpart2_beg, private.room_objname );
  cmn.AddSubscriber( "use_heartpart2", use_heartpart2_inv );
  cmn.AddSubscriber( "use_heartpart2", use_heartpart2_end, private.room_objname );
  cmn.AddSubscriber( "use_heartpart2_inv", use_heartpart2_inv, private.room_objname );
  cmn.AddSubscriber( "use_heartpart2_beg", use_heartpart2_beg, private.room_objname );
  cmn.AddSubscriber( "use_heartpart2_end", use_heartpart2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl4wire () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl4wire" ] = {
    type = "use",
    inv_obj = "inv_lvl4wire",
    use_place = "obj_nayasbed_use_lvl4wire",
    room = private.room_objname,
    zz = "zz_nayasbed",
    zz_gate = "gzz_nayasroom_nayasbed"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl4wire_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl4wire" );
  
  end;
  local use_lvl4wire_beg = function ()
  
    ObjDelete( "obj_nayasbed_use_lvl4wire" );
    ObjDelete( "anm_nayasbed_toysword_touch" );
  
  end;
  local use_lvl4wire_end = function ()
  
    --ObjSet( "spr_nayasbed_toysword", { input = 1, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl4wire", use_lvl4wire_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4wire", use_lvl4wire_inv );
  cmn.AddSubscriber( "use_lvl4wire", use_lvl4wire_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl4wire_inv", use_lvl4wire_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl4wire_beg", use_lvl4wire_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4wire_end", use_lvl4wire_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fixedflashlight () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_fixedflashlight" ] = {
    type = "use",
    inv_obj = "inv_fixedflashlight",
    use_place = "obj_nayasbed_use_fixedflashlight",
    room = private.room_objname,
    zz = "zz_nayasbed",
    zz_gate = "gzz_nayasroom_nayasbed"
  };
  --------------------------------------------------------------------------------------------
  local use_fixedflashlight_inv = function ()
  
    interface.InventoryItemRemove( "inv_fixedflashlight" );
  
  end;
  local use_fixedflashlight_beg = function ()
  
    ObjDelete( "obj_nayasbed_use_fixedflashlight" );
    ObjDelete( "obj_nayasbed_dark" );
  
  end;
  local use_fixedflashlight_end = function ()
    
    ObjDelete( "anm_nayasbed_use_flashlight" );
    ObjDelete( "spr_nayasroom_bed_sword_1" );
    ObjDelete( "spr_nayasroom_bed_angel_1" );
  
    ObjMultiSet( { {"obj_nayasbed_light",  { alp = 1, input = 1 }},
                   {"spr_nayasroom_bed_sword_2", { alp = 1 }},
                   {"spr_nayasroom_bed_angel_2", { alp = 1 }},
                   {"spr_nayasroom_bed_light", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fixedflashlight", use_fixedflashlight_beg, private.room_objname );
  cmn.AddSubscriber( "use_fixedflashlight", use_fixedflashlight_inv );
  cmn.AddSubscriber( "use_fixedflashlight", use_fixedflashlight_end, private.room_objname );
  cmn.AddSubscriber( "use_fixedflashlight_inv", use_fixedflashlight_inv, private.room_objname );
  cmn.AddSubscriber( "use_fixedflashlight_beg", use_fixedflashlight_beg, private.room_objname );
  cmn.AddSubscriber( "use_fixedflashlight_end", use_fixedflashlight_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_windupkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_windupkey" ] = {
    type = "use",
    inv_obj = "inv_windupkey",
    use_place = "obj_highmirror_use_windupkey",
    room = private.room_objname,
    zz = "zz_highmirror",
    zz_gate = "gzz_nayasroom_highmirror"
  };
  --------------------------------------------------------------------------------------------
  local use_windupkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_windupkey" );
  
  end;
  local use_windupkey_beg = function ()
  
    ObjDelete( "obj_highmirror_use_windupkey" );
    ObjDelete( "anm_highmirror_box_touch" );
  
  end;
  local use_windupkey_end = function ()
  
    ObjDelete( "spr_nayasroom_mirror_box_1" );

    ObjMultiSet( { {"anm_highmirror_box_open", { input = 1, alp = 1, frame = 300 }},
                   {"spr_nayasroom_mirror_box_2", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_windupkey", use_windupkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_windupkey", use_windupkey_inv );
  cmn.AddSubscriber( "use_windupkey", use_windupkey_end, private.room_objname );
  cmn.AddSubscriber( "use_windupkey_inv", use_windupkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_windupkey_beg", use_windupkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_windupkey_end", use_windupkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_angel1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_angel1" ] = {
    type = "use",
    inv_obj = "inv_angel1",
    use_place = "obj_highmirror_use_angel1",
    room = private.room_objname,
    zz = "zz_highmirror",
    zz_gate = "gzz_nayasroom_highmirror"
  };
  --------------------------------------------------------------------------------------------
  local use_angel1_inv = function ()
  
    interface.InventoryItemRemove( "inv_angel1" );
  
  end;
  local use_angel1_beg = function ()
  
    ObjDelete( "obj_highmirror_use_angel1" );
  
  end;
  local use_angel1_end = function ()
    
    ObjMultiSet( { {"anm_highmirror_angel_1", { alp = 1, frame = 300 }},
                   {"spr_nayasroom_angel_1", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_angel2") then
      ObjDelete( "anm_highmirror_mirror_touch" );
      ObjMultiSet( { {"anm_highmirror_mirror_turn", { input = 1, alp = 1, frame = 300 }},
                     {"spr_nayasroom_mirror_2", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_angel1", use_angel1_beg, private.room_objname );
  cmn.AddSubscriber( "use_angel1", use_angel1_inv );
  cmn.AddSubscriber( "use_angel1", use_angel1_end, private.room_objname );
  cmn.AddSubscriber( "use_angel1_inv", use_angel1_inv, private.room_objname );
  cmn.AddSubscriber( "use_angel1_beg", use_angel1_beg, private.room_objname );
  cmn.AddSubscriber( "use_angel1_end", use_angel1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_angel2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_angel2" ] = {
    type = "use",
    inv_obj = "inv_angel2",
    use_place = "obj_highmirror_use_angel2",
    room = private.room_objname,
    zz = "zz_highmirror",
    zz_gate = "gzz_nayasroom_highmirror"
  };
  --------------------------------------------------------------------------------------------
  local use_angel2_inv = function ()
  
    interface.InventoryItemRemove( "inv_angel2" );
  
  end;
  local use_angel2_beg = function ()
  
    ObjDelete( "obj_highmirror_use_angel2" );
  
  end;
  local use_angel2_end = function ()
    
    ObjMultiSet( { {"anm_highmirror_angel_2", { alp = 1, frame = 300 }},
                   {"spr_nayasroom_angel_2", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_angel1") then
      ObjDelete( "anm_highmirror_mirror_touch" );
      ObjMultiSet( { {"anm_highmirror_mirror_turn", { input = 1, alp = 1, frame = 300 }},
                     {"spr_nayasroom_mirror_2", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_angel2", use_angel2_beg, private.room_objname );
  cmn.AddSubscriber( "use_angel2", use_angel2_inv );
  cmn.AddSubscriber( "use_angel2", use_angel2_end, private.room_objname );
  cmn.AddSubscriber( "use_angel2_inv", use_angel2_inv, private.room_objname );
  cmn.AddSubscriber( "use_angel2_beg", use_angel2_beg, private.room_objname );
  cmn.AddSubscriber( "use_angel2_end", use_angel2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_musicnote2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_musicnote2" ] = {
    type = "use",
    inv_obj = "inv_musicnote2",
    use_place = "obj_piano_use_musicnote2",
    room = private.room_objname,
    zz = "zz_piano",
    zz_gate = "gzz_nayasroom_piano"
  };
  --------------------------------------------------------------------------------------------
  local use_musicnote2_inv = function ()
  
    interface.InventoryItemRemove( "inv_musicnote2" );
  
  end;
  local use_musicnote2_beg = function ()
  
    ObjDelete( "obj_piano_use_musicnote2" );
  
  end;
  local use_musicnote2_end = function ()
  
    ObjMultiSet( { {"spr_piano_musicnote2", { alp = 1 }},
                   {"spr_nayasroom_piano_note_2", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_musicnote1") and cmn.IsEventDone("use_musicnote3") then
      ObjDelete( "anm_piano_cover" );
      ObjDelete( "obj_piano_touch_cover" );
      ObjDelete( "spr_nayasroom_piano_closed" );
      ObjMultiSet( {
        { "obj_piano_inside", { input = true } },
        { "obj_piano_cover_open", { alp = 1 } },
        { "spr_nayasroom_piano_open", { alp = 1 } }
      } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_musicnote2", use_musicnote2_beg, private.room_objname );
  cmn.AddSubscriber( "use_musicnote2", use_musicnote2_inv );
  cmn.AddSubscriber( "use_musicnote2", use_musicnote2_end, private.room_objname );
  cmn.AddSubscriber( "use_musicnote2_inv", use_musicnote2_inv, private.room_objname );
  cmn.AddSubscriber( "use_musicnote2_beg", use_musicnote2_beg, private.room_objname );
  cmn.AddSubscriber( "use_musicnote2_end", use_musicnote2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_musicnote3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_musicnote3" ] = {
    type = "use",
    inv_obj = "inv_musicnote3",
    use_place = "obj_piano_use_musicnote3",
    room = private.room_objname,
    zz = "zz_piano",
    zz_gate = "gzz_nayasroom_piano"
  };
  --------------------------------------------------------------------------------------------
  local use_musicnote3_inv = function ()
  
    interface.InventoryItemRemove( "inv_musicnote3" );
  
  end;
  local use_musicnote3_beg = function ()
  
    ObjDelete( "obj_piano_use_musicnote3" );
  
  end;
  local use_musicnote3_end = function ()
  
    ObjMultiSet( { {"spr_piano_musicnote3", { alp = 1 }},
                   {"spr_nayasroom_piano_note_3", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_musicnote2") and cmn.IsEventDone("use_musicnote1") then
      ObjDelete( "anm_piano_cover" );
      ObjDelete( "obj_piano_touch_cover" );
      ObjDelete( "spr_nayasroom_piano_closed" );
      ObjMultiSet( {
        { "obj_piano_inside", { input = true } },
        { "obj_piano_cover_open", { alp = 1 } },
        { "spr_nayasroom_piano_open", { alp = 1 } }
      } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_musicnote3", use_musicnote3_beg, private.room_objname );
  cmn.AddSubscriber( "use_musicnote3", use_musicnote3_inv );
  cmn.AddSubscriber( "use_musicnote3", use_musicnote3_end, private.room_objname );
  cmn.AddSubscriber( "use_musicnote3_inv", use_musicnote3_inv, private.room_objname );
  cmn.AddSubscriber( "use_musicnote3_beg", use_musicnote3_beg, private.room_objname );
  cmn.AddSubscriber( "use_musicnote3_end", use_musicnote3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_musicnote1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_musicnote1" ] = {
    type = "use",
    inv_obj = "inv_musicnote1",
    use_place = "obj_piano_use_musicnote1",
    room = private.room_objname,
    zz = "zz_piano",
    zz_gate = "gzz_nayasroom_piano"
  };
  --------------------------------------------------------------------------------------------
  local use_musicnote1_inv = function ()
  
    interface.InventoryItemRemove( "inv_musicnote1" );
  
  end;
  local use_musicnote1_beg = function ()
  
    ObjDelete( "obj_piano_use_musicnote1" );
  
  end;
  local use_musicnote1_end = function ()

    ObjMultiSet( { {"spr_piano_musicnote1", { alp = 1 }},
                   {"spr_nayasroom_piano_note_1", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_musicnote2") and cmn.IsEventDone("use_musicnote3") then
      ObjDelete( "anm_piano_cover" );
      ObjDelete( "obj_piano_touch_cover" );
      ObjDelete( "spr_nayasroom_piano_closed" );
      ObjMultiSet( {
        { "obj_piano_inside", { input = true } },
        { "obj_piano_cover_open", { alp = 1 } },
        { "spr_nayasroom_piano_open", { alp = 1 } }
      } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_musicnote1", use_musicnote1_beg, private.room_objname );
  cmn.AddSubscriber( "use_musicnote1", use_musicnote1_inv );
  cmn.AddSubscriber( "use_musicnote1", use_musicnote1_end, private.room_objname );
  cmn.AddSubscriber( "use_musicnote1_inv", use_musicnote1_inv, private.room_objname );
  cmn.AddSubscriber( "use_musicnote1_beg", use_musicnote1_beg, private.room_objname );
  cmn.AddSubscriber( "use_musicnote1_end", use_musicnote1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_notesheet () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_notesheet" ] = {
    type = "use",
    inv_obj = "inv_notesheet",
    use_place = "obj_piano_use_notesheet",
    room = private.room_objname,
    zz = "zz_piano",
    zz_gate = "gzz_nayasroom_piano"
  };
  --------------------------------------------------------------------------------------------
  local use_notesheet_inv = function ()
  
    interface.InventoryItemRemove( "inv_notesheet" );
  
  end;
  local use_notesheet_beg = function ()
  
    ObjDelete( "obj_piano_use_notesheet" );
  
  end;
  local use_notesheet_end = function ()
  
    ObjMultiSet( {
      { "obj_piano_paper", { alp = 1 } },
      { "obj_piano_notes", { alp = 1, input = true } },
      { "spr_nayasroom_piano_sheet", { alp = 1 } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_notesheet", use_notesheet_beg, private.room_objname );
  cmn.AddSubscriber( "use_notesheet", use_notesheet_inv );
  cmn.AddSubscriber( "use_notesheet", use_notesheet_end, private.room_objname );
  cmn.AddSubscriber( "use_notesheet_inv", use_notesheet_inv, private.room_objname );
  cmn.AddSubscriber( "use_notesheet_beg", use_notesheet_beg, private.room_objname );
  cmn.AddSubscriber( "use_notesheet_end", use_notesheet_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_nayasroomfirst () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "clk_nayasroomfirst" ] = {
    type = "click",
    use_place = "obj_nayasroom_clk_nayasroomfirst",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local clk_nayasroomfirst_beg = function ()
  
    ObjDelete( "obj_nayasroom_clk_nayasroomfirst" );
  
  end;
  local clk_nayasroomfirst_end = function ()
    
    ObjDelete( "anm_nayasroom_victor" );
    ObjDelete( "anm_nayasroom_dialog_victor1_hand_give" );
    
    ObjDelete( "vid_nayasroom_dialog_victor2_lipsync1" );
    ObjDelete( "vid_nayasroom_dialog_victor2_lipsync2" );
    
    ObjAttach("obj_nayasroom_dialog_victor2", "rm_nayasroom");
    
    ObjMultiSet( { {"obj_nayasroom_dialog_victor2", { alp = 1, input = 1 }},
                   {"obj_nayasroom_dialog_victor2_hand_2", { alp = 1, input = 1 }},
                   {"anm_nayasroom_victor_out", { alp = 1 }},
                   {"anm_nayasroom_dialog_victor2_eyes", { alp = 1 }} } );

    ObjMultiSet( {
      { "gzz_nayasroom_littlebox", { event_mdown = "cmn.GotoSubRoomMDown( 'nayasroom_littlebox' );", event_mup = "cmn.GotoSubRoomMUp( 'nayasroom_littlebox', 'zz_littlebox' );" } },
      { "gzz_nayasroom_nayasbed", { event_mdown = "cmn.GotoSubRoomMDown( 'nayasroom_nayasbed' );", event_mup = "cmn.GotoSubRoomMUp( 'nayasroom_nayasbed', 'zz_nayasbed' );" } },
      { "gzz_nayasroom_highmirror", { event_mdown = "cmn.GotoSubRoomMDown( 'nayasroom_highmirror' );", event_mup = "cmn.GotoSubRoomMUp( 'nayasroom_highmirror', 'zz_highmirror', false, true );" } },
      { "gzz_nayasroom_piano", { event_mdown = "cmn.GotoSubRoomMDown( 'nayasroom_piano' );", event_mup = "cmn.GotoSubRoomMUp( 'nayasroom_piano', 'zz_piano' );" } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_nayasroomfirst", clk_nayasroomfirst_beg, private.room_objname );
  cmn.AddSubscriber( "clk_nayasroomfirst", clk_nayasroomfirst_end, private.room_objname );
  cmn.AddSubscriber( "clk_nayasroomfirst_beg", clk_nayasroomfirst_beg, private.room_objname );
  cmn.AddSubscriber( "clk_nayasroomfirst_end", clk_nayasroomfirst_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function opn_nayasroom () end;
  --------------------------------------------------------------------------------------------
  local opn_nayasroom = function ()
  
    int_map_impl.OpenRoom( "rm_nayasroom" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_nayasroom", opn_nayasroom );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_piano" );

  function zz_piano.PreOpen()
    
    if cmn.IsEventDone( "use_notesheet" ) then

      private.zz_piano.DrawScene();

      if not cmn.IsEventDone( "win_piano" ) then
        cmn.MiniGameShow();
        private.zz_piano.CheckWin( true );
        ObjSet( "tmr_piano_check_notes", { time = 0.461538, playing = true } );
      end;

    end;

  end;
  
  function zz_piano.PreClose()
    
    if cmn.IsEventDone( "use_notesheet" ) and not cmn.IsEventDone("win_piano") then
      ObjSet( "tmr_piano_check_notes", { playing = false } );
      cmn.MiniGameHide( "piano" );
    end;
    
  end;

end;
--*********************************************************************************************************************
function public.Load()

  if not(ng_global.progress[ ng_global.currentprogress ][ "win_piano" ].state) then 
    private.zz_piano.StartConditions();
  end;
  private.zz_piano.state = ng_global.progress[ ng_global.currentprogress ][ "win_piano" ].state;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_nayasroom();
  
  if cmn.IsEventDone("clk_nayasroomfirst") and not cmn.IsEventDone("get_lvl4bulb") then
    --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    common_impl.current_dialog = "obj_nayasroom_dialog_victor2";
    ObjSet("anm_nayasroom_dialog_victor2_hand_2",  { playing = 1 });
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level4/audio/env/aud_rm_nayaroom_env");
  cmn.PlayAudio("env", "assets/levels/level4/audio/env/aud_rm_nayaroom_env");
  
  --анимация морф-оъекта
  if cmn.IsCollectableAvailible(12) then
    private.AnimMorphObject();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_heartpart4()

  local item = "inv_heartpart4";

  if cmn.ApplyObj( item, "gzz_nayasroom_littlebox" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_littlebox" );

  elseif ( cmn.ApplyObj( item, "obj_littlebox_use_heartpart4" ) ) then

    cmn.CallEventHandler( "use_heartpart4_inv" );
    cmn.CallEventHandler( "use_heartpart4_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_heartpart4" );
      cmn.CallEventHandler( "use_heartpart4_end" );
      
      if cmn.IsEventDone("use_heartpart1") and cmn.IsEventDone("use_heartpart2") and cmn.IsEventDone("use_heartpart3") then
        common.CloseSubRoom();
        cmn.GotoRoom("mg_memories");
        cmn.ShowBbt( "memories_open" );
      end;
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_heart_box_opens");
      
      ObjDelete("obj_littlebox_box");
      ObjDelete("anm_littlebox_box_touch");
      ObjSet("anm_littlebox_box_open",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_part_heart_box");

    if cmn.IsEventDone("use_heartpart1") and cmn.IsEventDone("use_heartpart2") and cmn.IsEventDone("use_heartpart3") then
      ObjAnimate( "spr_littlebox_heartpart4", "alp", 0, 0, anm_open, { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_littlebox_heartpart4", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_heartpart3()

  local item = "inv_heartpart3";

  if cmn.ApplyObj( item, "gzz_nayasroom_littlebox" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_littlebox" );

  elseif ( cmn.ApplyObj( item, "obj_littlebox_use_heartpart3" ) ) then

    cmn.CallEventHandler( "use_heartpart3_inv" );
    cmn.CallEventHandler( "use_heartpart3_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_heartpart3" );
      cmn.CallEventHandler( "use_heartpart3_end" );
      
      if cmn.IsEventDone("use_heartpart1") and cmn.IsEventDone("use_heartpart2") and cmn.IsEventDone("use_heartpart4") then
        common.CloseSubRoom();
        cmn.GotoRoom("mg_memories");
        cmn.ShowBbt( "memories_open" );
      end;
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_heart_box_opens");
      
      ObjDelete("obj_littlebox_box");
      ObjDelete("anm_littlebox_box_touch");
      ObjSet("anm_littlebox_box_open",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_part_heart_box");

    if cmn.IsEventDone("use_heartpart1") and cmn.IsEventDone("use_heartpart2") and cmn.IsEventDone("use_heartpart4") then
      ObjAnimate( "spr_littlebox_heartpart3", "alp", 0, 0, anm_open, { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_littlebox_heartpart3", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_heartpart1()

  local item = "inv_heartpart1";

  if cmn.ApplyObj( item, "gzz_nayasroom_littlebox" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_littlebox" );

  elseif ( cmn.ApplyObj( item, "obj_littlebox_use_heartpart1" ) ) then

    cmn.CallEventHandler( "use_heartpart1_inv" );
    cmn.CallEventHandler( "use_heartpart1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_heartpart1" );
      cmn.CallEventHandler( "use_heartpart1_end" );
      
      if cmn.IsEventDone("use_heartpart3") and cmn.IsEventDone("use_heartpart2") and cmn.IsEventDone("use_heartpart4") then
        common.CloseSubRoom();
        cmn.GotoRoom("mg_memories");
        cmn.ShowBbt( "memories_open" );
      end;
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_heart_box_opens");
      
      ObjDelete("obj_littlebox_box");
      ObjDelete("anm_littlebox_box_touch");
      ObjSet("anm_littlebox_box_open",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_part_heart_box");

    if cmn.IsEventDone("use_heartpart4") and cmn.IsEventDone("use_heartpart2") and cmn.IsEventDone("use_heartpart3") then
      ObjAnimate( "spr_littlebox_heartpart1", "alp", 0, 0, anm_open, { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_littlebox_heartpart1", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_heartpart2()

  local item = "inv_heartpart2";

  if cmn.ApplyObj( item, "gzz_nayasroom_littlebox" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_littlebox" );

  elseif ( cmn.ApplyObj( item, "obj_littlebox_use_heartpart2" ) ) then

    cmn.CallEventHandler( "use_heartpart2_inv" );
    cmn.CallEventHandler( "use_heartpart2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_heartpart2" );
      cmn.CallEventHandler( "use_heartpart2_end" );
      
      if cmn.IsEventDone("use_heartpart1") and cmn.IsEventDone("use_heartpart3") and cmn.IsEventDone("use_heartpart4") then
        common.CloseSubRoom();
        cmn.GotoRoom("mg_memories");
        cmn.ShowBbt( "memories_open" );
      end;
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_heart_box_opens");
      
      ObjDelete("obj_littlebox_box");
      ObjDelete("anm_littlebox_box_touch");
      ObjSet("anm_littlebox_box_open",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_part_heart_box");

    if cmn.IsEventDone("use_heartpart1") and cmn.IsEventDone("use_heartpart4") and cmn.IsEventDone("use_heartpart3") then
      ObjAnimate( "spr_littlebox_heartpart2", "alp", 0, 0, anm_open, { 0, 0, 0,    0.3, 0, 1,    0.6, 0, 1 } );
    else 
      ObjAnimate( "spr_littlebox_heartpart2", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl4wire()

  local item = "inv_lvl4wire";

  if cmn.ApplyObj( item, "gzz_nayasroom_nayasbed" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_nayasbed" );

  elseif ( cmn.ApplyObj( item, "obj_nayasbed_use_lvl4wire" ) and cmn.IsEventDone("use_fixedflashlight") ) then

    cmn.CallEventHandler( "use_lvl4wire_inv" );
    cmn.CallEventHandler( "use_lvl4wire_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl4wire" );
      cmn.CallEventHandler( "use_lvl4wire_end" );
      
      public.get_toysword();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_take_figure_bed_rope");

    ObjSet("anm_nayasbed_use_wire",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_fixedflashlight()

  local item = "inv_fixedflashlight";

  if cmn.ApplyObj( item, "gzz_nayasroom_nayasbed" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_nayasbed" );

  elseif ( cmn.ApplyObj( item, "obj_nayasbed_use_fixedflashlight" ) ) then

    cmn.CallEventHandler( "use_fixedflashlight_inv" );
    cmn.CallEventHandler( "use_fixedflashlight_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_fixedflashlight" );
      cmn.CallEventHandler( "use_fixedflashlight_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_put_lamp_bed");

    ObjSet("anm_nayasbed_use_flashlight",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_windupkey()

  local item = "inv_windupkey";

  if cmn.ApplyObj( item, "gzz_nayasroom_highmirror" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_highmirror", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_highmirror_use_windupkey" ) ) then

    cmn.CallEventHandler( "use_windupkey_inv" );
    cmn.CallEventHandler( "use_windupkey_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_windupkey" );
      cmn.CallEventHandler( "use_windupkey_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_key_pink_box");

    ObjSet("anm_highmirror_box_open",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_angel1()

  local item = "inv_angel1";

  if cmn.ApplyObj( item, "gzz_nayasroom_highmirror" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_highmirror", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_highmirror_use_angel1" ) ) then

    cmn.CallEventHandler( "use_angel1_inv" );
    cmn.CallEventHandler( "use_angel1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_angel1" );
      cmn.CallEventHandler( "use_angel1_end" );
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mirror_opens_zz_nighmirror");
      
      ObjDelete("anm_highmirror_mirror_touch");
      ObjSet("anm_highmirror_mirror_turn",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_zz_nighmirror_stuff");

    if cmn.IsEventDone("use_angel2") then
      ObjSet("anm_highmirror_angel_1",  { alp = 1, playing = 1, endtrig = anm_open });
    else 
      ObjSet("anm_highmirror_angel_1",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_angel2()

  local item = "inv_angel2";

  if cmn.ApplyObj( item, "gzz_nayasroom_highmirror" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_highmirror", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_highmirror_use_angel2" ) ) then

    cmn.CallEventHandler( "use_angel2_inv" );
    cmn.CallEventHandler( "use_angel2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_angel2" );
      cmn.CallEventHandler( "use_angel2_end" );
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mirror_opens_zz_nighmirror");
      
      ObjDelete("anm_highmirror_mirror_touch");
      ObjSet("anm_highmirror_mirror_turn",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_zz_nighmirror_stuff");

    if cmn.IsEventDone("use_angel1") then
      ObjSet("anm_highmirror_angel_2",  { alp = 1, playing = 1, endtrig = anm_open });
    else 
      ObjSet("anm_highmirror_angel_2",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_musicnote2()

  local item = "inv_musicnote2";

  if cmn.ApplyObj( item, "gzz_nayasroom_piano" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_piano" );

  elseif ( cmn.ApplyObj( item, "obj_piano_use_musicnote2" ) ) then

    cmn.CallEventHandler( "use_musicnote2_inv" );
    cmn.CallEventHandler( "use_musicnote2_beg" );

    local func_after2 = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_musicnote2" );
      cmn.CallEventHandler( "use_musicnote2_end" );
    
    end;

    local func_after = function ()
      if cmn.IsEventDone("use_musicnote1") and cmn.IsEventDone("use_musicnote3") then
        if not cmn.IsEventDone( "get_sapphire" ) then
          rm_nayasroom.get_sapphire();
        end;
        cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_piano_opens_note");
        ObjAnimate( "obj_piano_cover_open", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
        ObjAnimate( "anm_piano_cover", "alp", 0, 0, func_after2, { 0, 0, 1,    0.3, 0, 0 } );
      else 
        func_after2();
      end;
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_nsert_note_piano");

    ObjAnimate( "spr_piano_musicnote2", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_musicnote3()

  local item = "inv_musicnote3";

  if cmn.ApplyObj( item, "gzz_nayasroom_piano" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_piano" );

  elseif ( cmn.ApplyObj( item, "obj_piano_use_musicnote3" ) ) then

    cmn.CallEventHandler( "use_musicnote3_inv" );
    cmn.CallEventHandler( "use_musicnote3_beg" );

    local func_after2 = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_musicnote3" );
      cmn.CallEventHandler( "use_musicnote3_end" );
    
    end;

    local func_after = function ()
      if cmn.IsEventDone("use_musicnote1") and cmn.IsEventDone("use_musicnote2") then
        if not cmn.IsEventDone( "get_sapphire" ) then
          rm_nayasroom.get_sapphire();
        end;
        cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_piano_opens_note");
        ObjAnimate( "obj_piano_cover_open", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
        ObjAnimate( "anm_piano_cover", "alp", 0, 0, func_after2, { 0, 0, 1,    0.3, 0, 0 } );
      else 
        func_after2();
      end;
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_nsert_note_piano");

    ObjAnimate( "spr_piano_musicnote3", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_musicnote1()

  local item = "inv_musicnote1";

  if cmn.ApplyObj( item, "gzz_nayasroom_piano" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_piano" );

  elseif ( cmn.ApplyObj( item, "obj_piano_use_musicnote1" ) ) then

    cmn.CallEventHandler( "use_musicnote1_inv" );
    cmn.CallEventHandler( "use_musicnote1_beg" );

    local func_after2 = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_musicnote1" );
      cmn.CallEventHandler( "use_musicnote1_end" );
    
    end;

    local func_after = function ()
      if cmn.IsEventDone("use_musicnote2") and cmn.IsEventDone("use_musicnote3") then
        if not cmn.IsEventDone( "get_sapphire" ) then
          rm_nayasroom.get_sapphire();
        end;
        cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_piano_opens_note");
        ObjAnimate( "obj_piano_cover_open", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
        ObjAnimate( "anm_piano_cover", "alp", 0, 0, func_after2, { 0, 0, 1,    0.3, 0, 0 } );
      else 
        func_after2();
      end;
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_nsert_note_piano");

    ObjAnimate( "spr_piano_musicnote1", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_notesheet()

  local item = "inv_notesheet";

  if cmn.ApplyObj( item, "gzz_nayasroom_piano" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_piano" );

  elseif ( cmn.ApplyObj( item, "obj_piano_use_notesheet" ) ) then

    cmn.CallEventHandler( "use_notesheet_inv" );
    cmn.CallEventHandler( "use_notesheet_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_notesheet" );
      cmn.CallEventHandler( "use_notesheet_end" );

      cmn.MiniGameShow();
      ObjSet( "tmr_piano_check_notes", { time = 0.461538, playing = true } );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_put_paper_piano");

    private.zz_piano.DrawScene();

    ObjAnimate( "obj_piano_paper", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );
    ObjAnimate( "obj_piano_notes", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 0,    0.6, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_musicnote3()

  cmn.SetEventDone( "get_musicnote3" );
  cmn.CallEventHandler( "get_musicnote3" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_toysword()
  
  ObjSet("spr_nayasbed_toysword",  { ang = 0.5493 });

  cmn.SetEventDone( "get_toysword" );
  cmn.CallEventHandler( "get_toysword" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_angel1()

  cmn.SetEventDone( "get_angel1" );
  cmn.CallEventHandler( "get_angel1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_developer()

  cmn.SetEventDone( "get_developer" );
  cmn.CallEventHandler( "get_developer" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_drawerhandle()

  cmn.SetEventDone( "get_drawerhandle" );
  cmn.CallEventHandler( "get_drawerhandle" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_ballerina()

  cmn.SetEventDone( "get_ballerina" );
  cmn.CallEventHandler( "get_ballerina" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_sapphire()

  cmn.SetEventDone( "get_sapphire" );
  cmn.CallEventHandler( "get_sapphire" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_heartpart2") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_battery2()

  cmn.SetEventDone( "get_battery2" );
  cmn.CallEventHandler( "get_battery2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_heartpart2()

  cmn.SetEventDone( "get_heartpart2" );
  cmn.CallEventHandler( "get_heartpart2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  if cmn.IsEventDone("get_sapphire") then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function public.get_letter8()

  cmn.SetEventDone( "get_letter8" );
  cmn.CallEventHandler( "get_letter8" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_lvl4bulb()
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_lvl4bulb_end" );
    
    --common_impl.PlayBackgroundMusic();

  end;
  
  local anm_out = function ()
    
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_victor_diss");
    ObjSet("anm_nayasroom_victor_out",  { playing = 1, endtrig = func_after_dlg });
    
  end;

  cmn.SetEventDone( "get_lvl4bulb" );
  cmn.CallEventHandler( "get_lvl4bulb_inv" );
  cmn.CallEventHandler( "get_lvl4bulb_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.current_dialog = "";
  
  cmn.Lock(1);
  ObjAnimate("obj_nayasroom_dialog_victor2", "alp", 0, 0, anm_out, { 0, 0, 1,   0.5, 0, 0 });

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_nayasroomfirst()

  cmn.CallEventHandler( "clk_nayasroomfirst_beg" );
  cmn.SetEventDone( "clk_nayasroomfirst" );
    
  ObjAttach("obj_nayasroom_dialog_victor2", "rm_nayasroom");
  ObjAnimate("obj_nayasroom_dialog_victor2", "alp", 0, 0, private.dialog_victor2_beg, { 0, 0, 0,   0.5, 0, 1 });

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_nayasroom()

  if not ( cmn.IsEventDone( "opn_nayasroom" ) ) then
    cmn.SetEventDone( "opn_nayasroom" );
    cmn.CallEventHandler("opn_nayasroom");
    cmn.ShowBbt( "nayasroom_open" );
    interface_impl.SetCurrentGlobalTask( 24 );
  end;

end;
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_12_1", { alp = 1 }},
                 {"spr_col_12_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_12_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_12_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_12_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_12_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_12_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_12_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_piano_cover()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_piano");
  
  ObjSet( "anm_piano_cover", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_littlebox()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_heart_box");
  
  cmn.ShowBbt( "obj_littlebox_use_heartpart" );
  
  ObjSet( "anm_littlebox_box_touch", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_bed_angel()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_figure_darkness");
  
  cmn.ShowBbt( "obj_nayasbed_use_fixedflashlight" );
  
  ObjSet( "anm_nayasbed_angel_touch", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_bed_sword()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_sable");
  
  cmn.ShowBbt( "obj_nayasbed_use_lvl4wire" );
  
  ObjSet( "anm_nayasbed_toysword_touch", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_mirror()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_zz_nighmirror");
  
  cmn.ShowBbt( "obj_highmirror_use_angel" );
  
  ObjSet( "anm_highmirror_mirror_touch", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_mirror_box()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_pink_box");
  
  cmn.ShowBbt( "obj_highmirror_use_windupkey" );
  
  ObjSet( "anm_highmirror_box_touch", { playing = true, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_victor2_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "nayasroom", "victor2", 2 );
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "clk_nayasroomfirst_end" );

    cmn.ShowBbt( "nayasroom_after_dialog" );
    int_diary.AddDiarypage( 27 );
    
    ObjSet("anm_nayasroom_dialog_victor2_hand_2",  { playing = 1 });
    
  end;
  
  local anm_hand = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_nayasroom_dialog_victor2_lipsync2");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_nayasroom_dialog_victor2_timer",  { playing = 0 }},
                   {"anm_nayasroom_dialog_victor2_hand_give", { alp = 1, playing = 1, endtrig = dialog_end }},
                   {"anm_nayasroom_dialog_victor2_eyes", { alp = 1 }} } );
    
  end;
                 
  local victor_talks2 = function ()
  
    ObjDelete("vid_nayasroom_dialog_victor2_lipsync1");
    ObjAttach("vid_nayasroom_dialog_victor2_lipsync2", "obj_nayasroom_dialog_victor2");
  
    cmn.ShowDlgBbt( "dlg_nayasroom_victor2_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level4/audio/voc/aud_4_lvl_victor_7_voc");
    
    private.dlg_lipsync = "vid_nayasroom_dialog_victor2_lipsync2";
    
    ObjMultiSet( { {"tmr_nayasroom_dialog_victor2_timer", { endtrig = anm_hand, time = 4, playing = 1 }},
                   {"vid_nayasroom_dialog_victor2_lipsync2", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_hand }},
                   {"obj_character_dialog_continue", { event_mup = anm_hand }} } );
  
  end;

  private.dlg_lipsync = "vid_nayasroom_dialog_victor2_lipsync1";

  cmn.ShowDlgBbt( "dlg_nayasroom_victor2_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level4/audio/voc/aud_4_lvl_victor_6_voc");

  ObjMultiSet( { {"tmr_nayasroom_dialog_victor2_timer", { time = 13, playing = 1, endtrig = victor_talks2 }},
                 {"vid_nayasroom_dialog_victor2_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = victor_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = victor_talks2 }} } );
  
end; 
--------------------------------------------------------------------------------------------
function public.skip_dlg_victor2()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "clk_nayasroomfirst_end" );

    cmn.ShowBbt( "nayasroom_after_dialog" );
    int_diary.AddDiarypage( 27 );
    
    ObjSet("anm_nayasroom_dialog_victor2_hand_2",  { playing = 1 });
    
  end;
  
  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    ObjSet("anm_nayasroom_dialog_victor2_eyes",  { alp = 1 });
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();
  
  --common_impl.PlayBackgroundMusic();
  
  ObjMultiSet( { {"tmr_nayasroom_dialog_victor2_timer",  { playing = 0 }},
                 {"anm_nayasroom_dialog_victor2_hand_give", { alp = 1, playing = 1, endtrig = func_after_dlg }} } );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Piano *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_piano = {};
public.zz_piano = {};

function private.Init_Piano()

  private.zz_piano.drag_note = 0;

  private.zz_piano.note_pos = {
    { {-120,-197}, {-124,-173}, {-128,-150}, {-132,-126}, {-136,-102} },
    { { -74,-190}, { -78,-166}, { -82,-142}, { -86,-119}, { -90, -95} },
    { { -29,-183}, { -33,-159}, { -37,-135}, { -41,-112}, { -45, -88} },
    { {  17,-176}, {  14,-152}, {  10,-128}, {   6,-104}, {   2, -81} },
    { {  63,-169}, {  60,-145}, {  56,-121}, {  52, -97}, {  48, -73} },
    { { 109,-162}, { 106,-137}, { 102,-114}, {  98, -90}, {  94, -66} },
    { { 156,-155}, { 153,-130}, { 149,-106}, { 145, -83}, { 141, -59} },
    { { 202,-147}, { 199,-123}, { 195,-100}, { 191, -76}, { 187, -52} }
  };

  private.zz_piano.checked_note = 1;

  private.zz_piano.right_notes_sum = 0;

  private.zz_piano.win_notes_place = {5,3,1,3,2,3,4,3};
  private.zz_piano.start_notes_place = {1,5,4,2,4,1,2,5};

  private.zz_piano.notes_aud = {"a","g","f","e","d"};
  -----------------------------------------------------------------------------------
  game.hint[ "win_piano" ] = {
    type = "win",
    room = "rm_nayasroom",
    zz = "zz_piano",
    zz_gate = "gzz_nayasroom_piano"
  };
  -----------------------------------------------------------------------------------
  local win_piano = function ()

    if cmn.IsEventDone( "win_piano" ) then

      ObjMultiSet( {
        { "anm_piano_pianokey", { frame = 300 } },
        { "spr_piano_heartpart2", { input = true } },
        { "spr_nayasroom_piano_win", { alp = 1 } }
      } );

    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_piano", win_piano, "rm_nayasroom" );

end;
-----------------------------------------------------------------------------------
function private.zz_piano.StartConditions()

  ng_global.progress[ ng_global.currentprogress ][ "win_piano" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_piano" ].state = {
    notes_place = {1,5,4,2,4,1,2,5},
    notes_state = {false,false,false,false,false,false,false,false},
  };

end;
-----------------------------------------------------------------------------------
function public.zz_piano.Reset()

  local is_reset = false;

  for i = 1, 8, 1 do
    if private.zz_piano.state.notes_place[i] ~= private.zz_piano.start_notes_place[i] then
      is_reset = true;
      break;
    end;
  end;

  if not is_reset then
    return;
  end;

  --DbgTrace( "***Reset" );

  cmn.Lock( 1 );

  ObjSet( "tmr_piano_check_notes", { playing = false } );

  private.zz_piano.checked_note = 1;
  private.zz_piano.right_notes_sum = 0;

  private.zz_piano.StartConditions();
  private.zz_piano.state = ng_global.progress[ ng_global.currentprogress ][ "win_piano" ].state;

  local func_after = function ()

    private.zz_piano.DrawScene( true );

    ObjAnimate( "obj_piano_notes", "alp", 0, 0,
      function ()
        ObjSet( "tmr_piano_check_notes", { time = 0.461538, playing = true } );
        cmn.Lock( 0 );
      end,
      { 0, 0, 0,    0.3, 0, 1 }
    );

  end;

  ObjAnimate( "obj_piano_notes", "alp", 0, 0, func_after, { 0, 0, 1,    0.3, 0, 0 } );
  
end;
-----------------------------------------------------------------------------------
function public.zz_piano.Skip()

  --DbgTrace( "***Skip" );

  ng_global.progress[ ng_global.currentprogress ][ "win_piano" ].skip = 1;

  cmn.Lock( 1 );

  ObjSet( "tmr_piano_check_notes", { playing = false } );

  private.zz_piano.checked_note = 1;
  private.zz_piano.right_notes_sum = 0;

  private.zz_piano.state.notes_place = {5,3,1,3,2,3,4,3};
  private.zz_piano.state.notes_state = {true,true,true,true,true,true,true,true};

  local func_after = function ()

    private.zz_piano.DrawScene( true );

    ObjAnimate( "obj_piano_notes", "alp", 0, 0,
      function ()
        ObjSet( "tmr_piano_check_notes", { time = 0.461538, playing = true } );
      end,
      { 0, 0, 0,    0.3, 0, 1 }
    );

  end;

  ObjAnimate( "obj_piano_notes", "alp", 0, 0, func_after, { 0, 0, 1,    0.3, 0, 0 } );

end;
-----------------------------------------------------------------------------------
function private.zz_piano.DrawScene( is_reset )

  if private.zz_piano.is_draw_scene and not is_reset then
    return;
  end;
  private.zz_piano.is_draw_scene = true;

  --DbgTrace( "***DrawScene" );

  for i = 1, 8, 1 do

    ObjSet( "obj_piano_note_"..i, {
      pos_x = private.zz_piano.note_pos[ i ][ private.zz_piano.state.notes_place[i] ][ 1 ],
      pos_y = private.zz_piano.note_pos[ i ][ private.zz_piano.state.notes_place[i] ][ 2 ]
    } );

    if private.zz_piano.state.notes_state[ i ] then
      ObjMultiSet( {
        { "obj_piano_note_get_"..i, { input = false } },
        { "spr_piano_note_"..i, { alp = 0 } },
        { "spr_piano_note_"..i.."_right", { alp = 1 } }
      } );
    else
      ObjMultiSet( {
        { "obj_piano_note_get_"..i, { input = true } },
        { "spr_piano_note_"..i, { alp = 1 } },
        { "spr_piano_note_"..i.."_right", { alp = 0 } }
      } );
    end;

  end;

end;
-----------------------------------------------------------------------------------
function private.zz_piano.CheckWin( force )

  --DbgTrace( "***CheckWin" );

  for i = 1, 8, 1 do
    if not private.zz_piano.state.notes_state[ i ] then
      return;
    end;
  end;

  --DbgTrace( "WWWWWIIIIINNNNNN" );

  cmn.Lock( 1 );

  if force then
    return;
  end;

  ObjSet( "tmr_piano_check_notes", { playing = false } );

  common_impl.PauseAchiev(1);
  cmn.MiniGameHide("piano");
  
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_piano_opens");

  ObjSet( "anm_piano_pianokey", { endtrig = private.zz_piano.Win, playing = true } );

end;
-----------------------------------------------------------------------------------
function private.zz_piano.Win()

  cmn.Lock( 0 );
  
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_piano" );
  cmn.CallEventHandler( "win_piano" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_piano" ].skip == 0 and ng_global.noskipgames[ "win_piano" ] == nil then
    ng_global.noskipgames[ "win_piano" ] = 1;
    common_impl.CheckAchiev("mg");
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_piano.NoteMDown( num )

  --DbgTrace( "***NoteMDown" );

  private.zz_piano.drag_note = num;

  iOS_NeedDrag(0);
  ObjStartDrag( "obj_piano_note_drag" );

end;
-----------------------------------------------------------------------------------
function public.zz_piano.NoteMEnter()

  --DbgTrace( "***NoteMEnter" );

  SetCursor( CURSOR_GET );

end;
-----------------------------------------------------------------------------------
function public.zz_piano.NoteMLeave()

  --DbgTrace( "***NoteMLeave" );

  SetCursor( CURSOR_DEFAULT );

end;
-----------------------------------------------------------------------------------
function public.zz_piano.NoteDrag()

  --DbgTrace( "***NoteDrag" );

  SetCursor( CURSOR_DEFAULT );

  local cursor_pos = GetZoomCursorPos();

  local note_pos_x = cursor_pos[1] - game.zz_end_pos.zz_piano[1];
  local note_pos_y = cursor_pos[2] - game.zz_end_pos.zz_piano[2];

  if note_pos_y < private.zz_piano.note_pos[ private.zz_piano.drag_note ][1][2] then
    note_pos_y = private.zz_piano.note_pos[ private.zz_piano.drag_note ][1][2];
  elseif note_pos_y > private.zz_piano.note_pos[ private.zz_piano.drag_note ][5][2] then
    note_pos_y = private.zz_piano.note_pos[ private.zz_piano.drag_note ][5][2];
  end;

  local note_pos_x2 = cmn.math.FindLineIntersection(
    private.zz_piano.note_pos[ private.zz_piano.drag_note ][1], private.zz_piano.note_pos[ private.zz_piano.drag_note ][5],
    {note_pos_x - 1000, note_pos_y}, {note_pos_x + 1000, note_pos_y}
  )[1];

  --DbgTrace( "note_pos_x2 = "..note_pos_x2 );

  ObjSet( "obj_piano_note_"..private.zz_piano.drag_note, { pos_x = note_pos_x2, pos_y = note_pos_y } );

end;
-----------------------------------------------------------------------------------
function public.zz_piano.NoteDragDrop()

  --DbgTrace( "***NoteDragDrop" );

  cmn.Lock( 1 );

  local note_params = ObjGet( "obj_piano_note_"..private.zz_piano.drag_note );


  local new_place = 0;

  local min_len_to_place = 10000;
  local new_min_len_to_place;

  for i = 1, 5, 1 do

    new_min_len_to_place = cmn.math.FindSegmentLength( 
      {note_params.pos_x, note_params.pos_y}, 
      private.zz_piano.note_pos[ private.zz_piano.drag_note ][i]
    );

    if new_min_len_to_place < min_len_to_place then
      min_len_to_place = new_min_len_to_place;
      new_place = i;
    end;

  end;

  --DbgTrace( "new_place = "..new_place );

  ObjAnimate( "obj_piano_note_"..private.zz_piano.drag_note, "pos_xy", 0, 0, function () cmn.Lock( 0 ); end, {
    0,    0, note_params.pos_x, note_params.pos_y,
    0.15, 0, private.zz_piano.note_pos[ private.zz_piano.drag_note ][new_place][1], private.zz_piano.note_pos[ private.zz_piano.drag_note ][new_place][2]
  } );

  private.zz_piano.state.notes_place[ private.zz_piano.drag_note ] = new_place;
  private.zz_piano.drag_note = 0;

  iOS_NeedDrag(1);
end;
-----------------------------------------------------------------------------------
function public.zz_piano.CheckNote()

  --DbgTrace( "***CheckNote "..private.zz_piano.checked_note );

  ObjSet( "tmr_piano_check_notes", { time = 0.461538, playing = true } );

  if private.zz_piano.drag_note ~= private.zz_piano.checked_note then

    local notes_place     = private.zz_piano.state.notes_place[ private.zz_piano.checked_note ];
    local win_notes_place = private.zz_piano.win_notes_place[ private.zz_piano.checked_note ];
    local color_res = math.abs( win_notes_place - notes_place ) + 1;

    ObjSet( "spr_piano_note_"..private.zz_piano.checked_note.."_color", { res = "assets/levels/level4/rm_nayasroom/zz_piano/note_"..color_res } );

    ObjAnimate( "spr_piano_note_"..private.zz_piano.checked_note.."_color", "alp", 0, 0, "", { 0, 0, 0,   0.15, 0, 1,   0.2, 0, 1,   0.35, 0, 0 } );

    cmn.PlayAudio( "snd", "assets/levels/level4/audio/sfx/aud_naya_melody_"..private.zz_piano.notes_aud[notes_place] );

    if color_res == 1 then

      private.zz_piano.right_notes_sum = private.zz_piano.right_notes_sum + 1;

      if not private.zz_piano.state.notes_state[ private.zz_piano.checked_note ] then

        private.zz_piano.state.notes_state[ private.zz_piano.checked_note ] = true;

        ObjSet( "obj_piano_note_get_"..private.zz_piano.checked_note, { input = false } );
        ObjAnimate( "spr_piano_note_"..private.zz_piano.checked_note,           "alp", 0, 0, "", { 0, 0, 1,    0.15, 0, 0 } );
        ObjAnimate( "spr_piano_note_"..private.zz_piano.checked_note.."_right", "alp", 0, 0, "", { 0, 0, 0,    0.15, 0, 1 } );

      end;

      if private.zz_piano.right_notes_sum == 8 then
        private.zz_piano.CheckWin();
      end;

    else
      private.zz_piano.right_notes_sum = 0;
    end;

  else
    private.zz_piano.right_notes_sum = 0;
  end;

  --DbgTrace( "right_notes_sum = "..private.zz_piano.right_notes_sum );

  private.zz_piano.checked_note = private.zz_piano.checked_note + 1 < 9 and private.zz_piano.checked_note + 1 or 1;

end;
--*********************************************************************************************************************
