-- name=rm_nearhouse
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_nearhouse";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.Init_Housedoor();
  --------------------------------------------------------------------------------------------
  -- function get_glassshard () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_glassshard" ] = {
    type = "get",
    get_obj = "spr_housedoor_glassshard",
    room = private.room_objname,
    zz = "zz_housedoor",
    zz_gate = "gzz_nearhouse_housedoor"
  };
  --------------------------------------------------------------------------------------------
  local get_glassshard_inv = function ()
  
    interface.InventoryItemAdd( "inv_glassshard", "spr_housedoor_glassshard" );
  
  end;
  local get_glassshard_end = function ()
  
    ObjDelete( "gfx_housedoor_glassshard" );
    ObjDelete( "anm_housedoor_take_glass" );

    ObjDelete( "spr_nearhouse_housedoor_glassshard" );
  
  end;
  
  cmn.AddSubscriber( "get_glassshard", get_glassshard_inv );
  cmn.AddSubscriber( "get_glassshard", get_glassshard_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_dogpaw () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_dogpaw" ] = {
    type = "get",
    get_obj = "obj_housedoor_dogpaw",
    room = private.room_objname,
    zz = "zz_housedoor",
    zz_gate = "gzz_nearhouse_housedoor"
  };
  --------------------------------------------------------------------------------------------
  local get_dogpaw_inv = function ()
  
    interface.InventoryItemAdd( "inv_dogpaw", "obj_housedoor_dogpaw" );
  
  end;
  local get_dogpaw_end = function ()
  
    ObjDelete( "gfx_housedoor_dogpaw" );
    ObjDelete( "spr_housedoor_dogpaw_sh" );

    ObjDelete( "spr_nearhouse_housedoor_dogpaw" );
  
  end;
  
  cmn.AddSubscriber( "get_dogpaw", get_dogpaw_inv );
  cmn.AddSubscriber( "get_dogpaw", get_dogpaw_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wateringcan () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_wateringcan" ] = {
    type = "get",
    get_obj = "spr_nearcellar_wateringcan",
    room = private.room_objname,
    zz = "zz_nearcellar",
    zz_gate = "gzz_nearhouse_nearcellar"
  };
  --------------------------------------------------------------------------------------------
  local get_wateringcan_inv = function ()
  
    interface.InventoryItemAdd( "inv_wateringcan", "spr_nearcellar_wateringcan" );
  
  end;
  local get_wateringcan_end = function ()
  
    ObjDelete( "gfx_nearcellar_wateringcan" );
    ObjDelete( "spr_nearcellar_wateringcan_sh" );
  
    ObjDelete( "spr_nearhouse_nearcellar_can" );

  end;
  
  cmn.AddSubscriber( "get_wateringcan", get_wateringcan_inv );
  cmn.AddSubscriber( "get_wateringcan", get_wateringcan_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_codewheel () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_codewheel" ] = {
    type = "get",
    get_obj = "spr_nearcellar_codewheel",
    room = private.room_objname,
    zz = "zz_nearcellar",
    zz_gate = "gzz_nearhouse_nearcellar"
  };
  --------------------------------------------------------------------------------------------
  local get_codewheel_inv = function ()
  
    interface.InventoryItemAdd( "inv_codewheel", "spr_nearcellar_codewheel" );
    ObjSet("inv_diary_star_light",  { alp = 1 });
  
  end;
  local get_codewheel_end = function ()
  
    ObjDelete( "gfx_nearcellar_codewheel" );
    ObjDelete( "anm_nearcellar_use_rod" );
  
  end;
  
  cmn.AddSubscriber( "get_codewheel", get_codewheel_inv );
  cmn.AddSubscriber( "get_codewheel", get_codewheel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_apple () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_apple" ] = {
    type = "get",
    get_obj = "spr_doghouse_apple",
    room = private.room_objname,
    zz = "zz_doghouse",
    zz_gate = "gzz_nearhouse_doghouse"
  };
  --------------------------------------------------------------------------------------------
  local get_apple_inv = function ()
  
    interface.InventoryItemAdd( "inv_apple", "spr_doghouse_apple" );
  
  end;
  local get_apple_end = function ()
  
    ObjDelete( "gfx_doghouse_apple" );
    ObjDelete( "spr_doghouse_apple_sh" );
    ObjDelete( "spr_doghouse_apple_bl" );

    ObjDelete( "spr_nearhouse_doghouse_apple" );
  
  end;
  
  cmn.AddSubscriber( "get_apple", get_apple_inv );
  cmn.AddSubscriber( "get_apple", get_apple_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_doorfigurine2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_doorfigurine2" ] = {
    type = "get",
    get_obj = "spr_doghouse_doorfigurine2",
    room = private.room_objname,
    zz = "zz_doghouse",
    zz_gate = "gzz_nearhouse_doghouse"
  };
  --------------------------------------------------------------------------------------------
  local get_doorfigurine2_inv = function ()
  
    interface.InventoryItemAdd( "inv_doorfigurine2", "spr_doghouse_doorfigurine2" );
  
  end;
  local get_doorfigurine2_end = function ()
  
    ObjDelete( "gfx_doghouse_doorfigurine2" );
    ObjDelete( "obj_doghouse_dog_1" );

    ObjMultiSet( { {"anm_doghouse_dog_2", { alp = 1 }},
                   {"obj_doghouse_use_bone", { input = 1 }} } );

    ObjDelete( "spr_nearhouse_doghouse_doorfigurine2" );
  
  end;
  
  cmn.AddSubscriber( "get_doorfigurine2", get_doorfigurine2_inv );
  cmn.AddSubscriber( "get_doorfigurine2", get_doorfigurine2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_machinepart1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_machinepart1" ] = {
    type = "get",
    get_obj = "spr_doghouse_machinepart1",
    room = private.room_objname,
    zz = "zz_doghouse",
    zz_gate = "gzz_nearhouse_doghouse"
  };
  --------------------------------------------------------------------------------------------
  local get_machinepart1_inv = function ()
  
    interface.InventoryItemAdd( "inv_machinepart1", "spr_doghouse_machinepart1" );
  
  end;
  local get_machinepart1_end = function ()
  
    ObjDelete( "gfx_doghouse_machinepart1" );
    ObjDelete( "anm_doghouse_use_bone" );

    ObjDelete( "spr_nearhouse_doghouse_machinepart1" );
    
    ObjMultiSet( { {"anm_doghouse_dog_2", { alp = 1 }},
                   {"obj_doghouse_use_medallion", { input = 1 }},
                   {"obj_doghouse_bone", { alp = 1 }} } );
  
  end;
  
  cmn.AddSubscriber( "get_machinepart1", get_machinepart1_inv );
  cmn.AddSubscriber( "get_machinepart1", get_machinepart1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_whistle () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_whistle" ] = {
    type = "get",
    get_obj = "spr_doghouse_whistle",
    room = private.room_objname,
    zz = "zz_doghouse",
    zz_gate = "gzz_nearhouse_doghouse"
  };
  --------------------------------------------------------------------------------------------
  local get_whistle_inv = function ()
  
    interface.InventoryItemAdd( "inv_whistle", "spr_doghouse_whistle" );
    int_map_impl.DecreaseRoomTasks("rm_nearhouse");
  
  end;
  local get_whistle_end = function ()
  
    ObjDelete( "gfx_doghouse_whistle" );
    ObjDelete( "anm_doghouse_use_medalion" );

    ObjDelete( "spr_nearhouse_doghouse_whistle" );

    ObjMultiSet( { {"anm_doghouse_dog_2", { alp = 1 }},
                   {"gzz_nearhouse_doghouse", { active = 0, visible = 0 }} } );
  
  end;
  
  cmn.AddSubscriber( "get_whistle", get_whistle_inv );
  cmn.AddSubscriber( "get_whistle", get_whistle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_handkerchief () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_handkerchief" ] = {
    type = "get",
    get_obj = "spr_flowerbed_handkerchief",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_nearhouse_flowerbed"
  };
  --------------------------------------------------------------------------------------------
  local get_handkerchief_inv = function ()
  
    interface.InventoryItemAdd( "inv_handkerchief", "spr_flowerbed_handkerchief" );
  
  end;
  local get_handkerchief_end = function ()
  
    ObjDelete( "gfx_flowerbed_handkerchief" );
    ObjDelete( "spr_flowerbed_handkerchief_sh" );

    ObjDelete( "spr_nearhouse_flowerbed_handker_chief" );
  
  end;
  
  cmn.AddSubscriber( "get_handkerchief", get_handkerchief_inv );
  cmn.AddSubscriber( "get_handkerchief", get_handkerchief_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_doorfigurine1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_doorfigurine1" ] = {
    type = "get",
    get_obj = "spr_flowerbed_doorfigurine1",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_nearhouse_flowerbed"
  };
  --------------------------------------------------------------------------------------------
  local get_doorfigurine1_inv = function ()
  
    interface.InventoryItemAdd( "inv_doorfigurine1", "spr_flowerbed_doorfigurine1" );
  
  end;
  local get_doorfigurine1_end = function ()
  
    ObjDelete( "gfx_flowerbed_doorfigurine1" );
    ObjDelete( "spr_flowerbed_doorfigurine1_sh" );

    ObjDelete( "spr_nearhouse_flowerbed_doorfigurine_1" );
  
  end;
  
  cmn.AddSubscriber( "get_doorfigurine1", get_doorfigurine1_inv );
  cmn.AddSubscriber( "get_doorfigurine1", get_doorfigurine1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ingredients2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_ingredients2" ] = {
    type = "get",
    get_obj = "spr_flowerbed_ingredients2",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_nearhouse_flowerbed"
  };
  --------------------------------------------------------------------------------------------
  local get_ingredients2_inv = function ()
  
    interface.InventoryItemAdd( "inv_ingredients2", "spr_flowerbed_ingredients2" );
  
  end;
  local get_ingredients2_end = function ()
  
    ObjDelete( "gfx_flowerbed_ingredients2" );
    ObjDelete( "spr_nearhouse_flowerbed_ingredients2" );
  
  end;
  
  cmn.AddSubscriber( "get_ingredients2", get_ingredients2_inv );
  cmn.AddSubscriber( "get_ingredients2", get_ingredients2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_letter5 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_letter5" ] = {
    type = "get",
    get_obj = "spr_nearhouse_letter5",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_letter5_inv = function ()
  
    interface.InventoryItemAdd( "inv_letter", "spr_nearhouse_letter5", function () cmn.GetMultyObject( 'letter', 9 ); end );
    int_map_impl.DecreaseRoomTasks("rm_nearhouse");
  
  end;
  local get_letter5_end = function ()
  
    ObjDelete( "gfx_nearhouse_letter5" );
    ObjDelete( "spr_nearhouse_letter5_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_letter5", get_letter5_inv );
  cmn.AddSubscriber( "get_letter5", get_letter5_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_handkerchief () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_handkerchief" ] = {
    type = "use",
    inv_obj = "inv_handkerchief",
    use_place = "obj_housedoor_use_handkerchief",
    room = private.room_objname,
    zz = "zz_housedoor",
    zz_gate = "gzz_nearhouse_housedoor"
  };
  --------------------------------------------------------------------------------------------
  local use_handkerchief_inv = function ()
  
    interface.InventoryItemRemove( "inv_handkerchief" );
  
  end;
  local use_handkerchief_beg = function ()
  
    ObjDelete( "obj_housedoor_use_handkerchief" );
    ObjDelete( "anm_housedoor_glass_touch" );
  
  end;
  local use_handkerchief_end = function ()
  
    --ObjSet( "spr_housedoor_glassshard", { input = 1, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_handkerchief", use_handkerchief_beg, private.room_objname );
  cmn.AddSubscriber( "use_handkerchief", use_handkerchief_inv );
  cmn.AddSubscriber( "use_handkerchief", use_handkerchief_end, private.room_objname );
  cmn.AddSubscriber( "use_handkerchief_inv", use_handkerchief_inv, private.room_objname );
  cmn.AddSubscriber( "use_handkerchief_beg", use_handkerchief_beg, private.room_objname );
  cmn.AddSubscriber( "use_handkerchief_end", use_handkerchief_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_doorfigurine1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_doorfigurine1" ] = {
    type = "use",
    inv_obj = "inv_doorfigurine1",
    use_place = "obj_housedoor_use_doorfigurine1",
    room = private.room_objname,
    zz = "zz_housedoor",
    zz_gate = "gzz_nearhouse_housedoor"
  };
  --------------------------------------------------------------------------------------------
  local use_doorfigurine1_inv = function ()
  
    interface.InventoryItemRemove( "inv_doorfigurine1" );
  
  end;
  local use_doorfigurine1_beg = function ()
  
    ObjDelete( "obj_housedoor_use_doorfigurine1" );
  
  end;
  local use_doorfigurine1_end = function ()
    
    ObjMultiSet( {
      { "spr_housedoor_button_1", { alp = 1 } },
      { "spr_nearhouse_housedoor_doorfigurine_1", { alp = 1 } }
    } );
  
    if cmn.IsEventDone("use_doorfigurine2") then
      ObjSet( "anm_housedoor_door_touch", { input = 1 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_doorfigurine1", use_doorfigurine1_beg, private.room_objname );
  cmn.AddSubscriber( "use_doorfigurine1", use_doorfigurine1_inv );
  cmn.AddSubscriber( "use_doorfigurine1", use_doorfigurine1_end, private.room_objname );
  cmn.AddSubscriber( "use_doorfigurine1_inv", use_doorfigurine1_inv, private.room_objname );
  cmn.AddSubscriber( "use_doorfigurine1_beg", use_doorfigurine1_beg, private.room_objname );
  cmn.AddSubscriber( "use_doorfigurine1_end", use_doorfigurine1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_doorfigurine2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_doorfigurine2" ] = {
    type = "use",
    inv_obj = "inv_doorfigurine2",
    use_place = "obj_housedoor_use_doorfigurine2",
    room = private.room_objname,
    zz = "zz_housedoor",
    zz_gate = "gzz_nearhouse_housedoor"
  };
  --------------------------------------------------------------------------------------------
  local use_doorfigurine2_inv = function ()
  
    interface.InventoryItemRemove( "inv_doorfigurine2" );
  
  end;
  local use_doorfigurine2_beg = function ()
  
    ObjDelete( "obj_housedoor_use_doorfigurine2" );
  
  end;
  local use_doorfigurine2_end = function ()
    
    ObjMultiSet( {
      { "spr_housedoor_button_2", { alp = 1 } },
      { "spr_nearhouse_housedoor_doorfigurine_2", { alp = 1 } }
    } );
  
    if cmn.IsEventDone("use_doorfigurine1") then
      ObjSet( "anm_housedoor_door_touch", { input = 1 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_doorfigurine2", use_doorfigurine2_beg, private.room_objname );
  cmn.AddSubscriber( "use_doorfigurine2", use_doorfigurine2_inv );
  cmn.AddSubscriber( "use_doorfigurine2", use_doorfigurine2_end, private.room_objname );
  cmn.AddSubscriber( "use_doorfigurine2_inv", use_doorfigurine2_inv, private.room_objname );
  cmn.AddSubscriber( "use_doorfigurine2_beg", use_doorfigurine2_beg, private.room_objname );
  cmn.AddSubscriber( "use_doorfigurine2_end", use_doorfigurine2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_toyfishingpole () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_toyfishingpole" ] = {
    type = "use",
    inv_obj = "inv_toyfishingpole",
    use_place = "obj_nearcellar_use_toyfishingpole",
    room = private.room_objname,
    zz = "zz_nearcellar",
    zz_gate = "gzz_nearhouse_nearcellar"
  };
  --------------------------------------------------------------------------------------------
  local use_toyfishingpole_inv = function ()
  
    interface.InventoryItemRemove( "inv_toyfishingpole" );
  
  end;
  local use_toyfishingpole_beg = function ()
  
    ObjDelete( "obj_nearcellar_use_toyfishingpole" );
    ObjDelete( "anm_nearcellar_amulet_touch" );
  
  end;
  local use_toyfishingpole_end = function ()
  
    --ObjSet( "spr_nearcellar_codewheel", { input = 1, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_toyfishingpole", use_toyfishingpole_beg, private.room_objname );
  cmn.AddSubscriber( "use_toyfishingpole", use_toyfishingpole_inv );
  cmn.AddSubscriber( "use_toyfishingpole", use_toyfishingpole_end, private.room_objname );
  cmn.AddSubscriber( "use_toyfishingpole_inv", use_toyfishingpole_inv, private.room_objname );
  cmn.AddSubscriber( "use_toyfishingpole_beg", use_toyfishingpole_beg, private.room_objname );
  cmn.AddSubscriber( "use_toyfishingpole_end", use_toyfishingpole_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cellarkey () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_cellarkey" ] = {
    type = "use",
    inv_obj = "inv_cellarkey",
    use_place = "obj_nearcellar_use_cellarkey",
    room = private.room_objname,
    zz = "zz_nearcellar",
    zz_gate = "gzz_nearhouse_nearcellar"
  };
  --------------------------------------------------------------------------------------------
  local use_cellarkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_cellarkey" );
    common_impl.ChangeRoomMiniback( "rm_cellar", false );
  
  end;
  local use_cellarkey_beg = function ()
  
    ObjDelete( "obj_nearcellar_use_cellarkey" );
    ObjDelete( "anm_nearcellar_door_touch" );
  
  end;
  local use_cellarkey_end = function ()
  
    ObjDelete( "gzz_nearhouse_nearcellar" );

    ObjDelete( "spr_nearhouse_nearcellar_door" );

    ObjMultiSet( {
      { "grm_nearhouse_cellar", { input = 1, alp = 1 } },
      { "spr_nearhouse_nearcellar_door_open", { alp = 1 } }
    } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_nearhouse_cellar_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cellarkey", use_cellarkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_cellarkey", use_cellarkey_inv );
  cmn.AddSubscriber( "use_cellarkey", use_cellarkey_end, private.room_objname );
  cmn.AddSubscriber( "use_cellarkey_inv", use_cellarkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_cellarkey_beg", use_cellarkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_cellarkey_end", use_cellarkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_needdle () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_needdle" ] = {
    type = "use",
    inv_obj = "inv_needdle",
    use_place = "obj_doghouse_use_needdle",
    room = private.room_objname,
    zz = "zz_doghouse",
    zz_gate = "gzz_nearhouse_doghouse"
  };
  --------------------------------------------------------------------------------------------
  local use_needdle_inv = function ()
  
    interface.InventoryItemRemove( "inv_needdle" );
  
  end;
  local use_needdle_beg = function ()
  
    ObjDelete( "obj_doghouse_use_needdle" );
  
  end;
  local use_needdle_end = function ()
  
    if cmn.IsEventDone("use_clothbutton") and cmn.IsEventDone("use_dogpaw") then
      ObjDelete("anm_doghouse_dog_touch");
      ObjDelete("anm_doghouse_dog_sew");
      ObjDelete("anm_doghouse_use_needle");
      ObjDelete("anm_doghouse_use_button_1");
      ObjDelete("anm_doghouse_use_button_2");
      ObjDelete("anm_doghouse_use_paw");

      ObjDelete( "obj_nearhouse_doghouse_dog" );

      ObjMultiSet( {
        { "anm_doghouse_dog_give", { input = 1, alp = 1, frame = 300 } },
        { "obj_nearhouse_doghouse_dog_2", { alp = 1 } }
      } );

    else 
      ObjSet( "anm_doghouse_use_needle", { frame = 300, pos_z = 2 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_needdle", use_needdle_beg, private.room_objname );
  cmn.AddSubscriber( "use_needdle", use_needdle_inv );
  cmn.AddSubscriber( "use_needdle", use_needdle_end, private.room_objname );
  cmn.AddSubscriber( "use_needdle_inv", use_needdle_inv, private.room_objname );
  cmn.AddSubscriber( "use_needdle_beg", use_needdle_beg, private.room_objname );
  cmn.AddSubscriber( "use_needdle_end", use_needdle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_clothbutton () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_clothbutton" ] = {
    type = "use",
    inv_obj = "inv_clothbutton",
    use_place = "obj_doghouse_use_clothbutton",
    room = private.room_objname,
    zz = "zz_doghouse",
    zz_gate = "gzz_nearhouse_doghouse"
  };
  --------------------------------------------------------------------------------------------
  local use_clothbutton_inv = function ()
  
    interface.InventoryItemRemove( "inv_clothbutton" );
  
  end;
  local use_clothbutton_beg = function ()
  
    ObjDelete( "obj_doghouse_use_clothbutton" );
  
  end;
  local use_clothbutton_end = function ()

    ObjSet( "spr_nearhouse_doghouse_clothbutton_ceparate", { alp = 1 } );
  
    if cmn.IsEventDone("use_needdle") and cmn.IsEventDone("use_dogpaw") then
      ObjDelete("anm_doghouse_dog_touch");
      ObjDelete("anm_doghouse_dog_sew");
      ObjDelete("anm_doghouse_use_needle");
      ObjDelete("anm_doghouse_use_button_1");
      ObjDelete("anm_doghouse_use_button_2");
      ObjDelete("anm_doghouse_use_paw");

      ObjDelete( "obj_nearhouse_doghouse_dog" );

      ObjMultiSet( {
        { "anm_doghouse_dog_give", { input = 1, alp = 1, frame = 300 } },
        { "obj_nearhouse_doghouse_dog_2", { alp = 1 } }
      } );

    else 
      ObjMultiSet( { {"anm_doghouse_use_button_1", { frame = 300, pos_z = 2 }},
                     {"anm_doghouse_use_button_2", { frame = 300, pos_z = 3 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_clothbutton", use_clothbutton_beg, private.room_objname );
  cmn.AddSubscriber( "use_clothbutton", use_clothbutton_inv );
  cmn.AddSubscriber( "use_clothbutton", use_clothbutton_end, private.room_objname );
  cmn.AddSubscriber( "use_clothbutton_inv", use_clothbutton_inv, private.room_objname );
  cmn.AddSubscriber( "use_clothbutton_beg", use_clothbutton_beg, private.room_objname );
  cmn.AddSubscriber( "use_clothbutton_end", use_clothbutton_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_dogpaw () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_dogpaw" ] = {
    type = "use",
    inv_obj = "inv_dogpaw",
    use_place = "obj_doghouse_use_dogpaw",
    room = private.room_objname,
    zz = "zz_doghouse",
    zz_gate = "gzz_nearhouse_doghouse"
  };
  --------------------------------------------------------------------------------------------
  local use_dogpaw_inv = function ()
  
    interface.InventoryItemRemove( "inv_dogpaw" );
  
  end;
  local use_dogpaw_beg = function ()
  
    ObjDelete( "obj_doghouse_use_dogpaw" );
  
  end;
  local use_dogpaw_end = function ()

    ObjSet( "spr_nearhouse_doghouse_paw_ceparate", { alp = 1 } );
  
    if cmn.IsEventDone("use_needdle") and cmn.IsEventDone("use_clothbutton") then
      ObjDelete("anm_doghouse_dog_touch");
      ObjDelete("anm_doghouse_dog_sew");
      ObjDelete("anm_doghouse_use_needle");
      ObjDelete("anm_doghouse_use_button_1");
      ObjDelete("anm_doghouse_use_button_2");
      ObjDelete("anm_doghouse_use_paw");

      ObjDelete( "obj_nearhouse_doghouse_dog" );

      ObjMultiSet( {
        { "anm_doghouse_dog_give", { input = 1, alp = 1, frame = 300 } },
        { "obj_nearhouse_doghouse_dog_2", { alp = 1 } }
      } );

    else 
      ObjSet( "anm_doghouse_use_paw", { frame = 300, pos_z = 2 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_dogpaw", use_dogpaw_beg, private.room_objname );
  cmn.AddSubscriber( "use_dogpaw", use_dogpaw_inv );
  cmn.AddSubscriber( "use_dogpaw", use_dogpaw_end, private.room_objname );
  cmn.AddSubscriber( "use_dogpaw_inv", use_dogpaw_inv, private.room_objname );
  cmn.AddSubscriber( "use_dogpaw_beg", use_dogpaw_beg, private.room_objname );
  cmn.AddSubscriber( "use_dogpaw_end", use_dogpaw_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bone () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_bone" ] = {
    type = "use",
    inv_obj = "inv_bone",
    use_place = "obj_doghouse_use_bone",
    room = private.room_objname,
    zz = "zz_doghouse",
    zz_gate = "gzz_nearhouse_doghouse"
  };
  --------------------------------------------------------------------------------------------
  local use_bone_inv = function ()
  
    interface.InventoryItemRemove( "inv_bone" );
  
  end;
  local use_bone_beg = function ()
  
    ObjDelete( "obj_doghouse_use_bone" );
    ObjSet("anm_doghouse_dog_2",  { alp = 0 });
  
  end;
  local use_bone_end = function ()
  
    ObjMultiSet( {
      { "anm_doghouse_use_bone", { input = 1, alp = 1, frame = 300 } },
      { "spr_nearhouse_doghouse_machinepart1", { alp = 1 } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bone", use_bone_beg, private.room_objname );
  cmn.AddSubscriber( "use_bone", use_bone_inv );
  cmn.AddSubscriber( "use_bone", use_bone_end, private.room_objname );
  cmn.AddSubscriber( "use_bone_inv", use_bone_inv, private.room_objname );
  cmn.AddSubscriber( "use_bone_beg", use_bone_beg, private.room_objname );
  cmn.AddSubscriber( "use_bone_end", use_bone_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_medallion () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_medallion" ] = {
    type = "use",
    inv_obj = "inv_medallion",
    use_place = "obj_doghouse_use_medallion",
    room = private.room_objname,
    zz = "zz_doghouse",
    zz_gate = "gzz_nearhouse_doghouse"
  };
  --------------------------------------------------------------------------------------------
  local use_medallion_inv = function ()
  
    interface.InventoryItemRemove( "inv_medallion" );
  
  end;
  local use_medallion_beg = function ()
  
    ObjDelete( "obj_doghouse_use_medallion" );
    ObjDelete( "anm_doghouse_dog_2_touch" );
    ObjSet("anm_doghouse_dog_2",  { alp = 0 });
  
  end;
  local use_medallion_end = function ()
  
    ObjMultiSet( {
      { "anm_doghouse_use_medalion", { input = 1, alp = 1, frame = 300 } },
      { "spr_nearhouse_doghouse_name_badge", { alp = 1 } },
      { "spr_nearhouse_doghouse_whistle", { alp = 1 } },
      { "spr_doghouse_dog_badge", { alp = 1 } },
      { "spr_doghouse_dog_badge_sh", { alp = 1 } },
      { "spr_doghouse_dog_badge_bl", { alp = 1 } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_medallion", use_medallion_beg, private.room_objname );
  cmn.AddSubscriber( "use_medallion", use_medallion_inv );
  cmn.AddSubscriber( "use_medallion", use_medallion_end, private.room_objname );
  cmn.AddSubscriber( "use_medallion_inv", use_medallion_inv, private.room_objname );
  cmn.AddSubscriber( "use_medallion_beg", use_medallion_beg, private.room_objname );
  cmn.AddSubscriber( "use_medallion_end", use_medallion_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fullwateringcan () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_fullwateringcan" ] = {
    type = "use",
    inv_obj = "inv_fullwateringcan",
    use_place = "obj_flowerbed_use_fullwateringcan",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_nearhouse_flowerbed"
  };
  --------------------------------------------------------------------------------------------
  local use_fullwateringcan_inv = function ()
  
    interface.InventoryItemRemove( "inv_fullwateringcan" );
  
  end;
  local use_fullwateringcan_beg = function ()
  
    ObjDelete( "obj_flowerbed_use_fullwateringcan" );
    ObjDelete( "anm_flowerbed_flower_touch" );
  
  end;
  local use_fullwateringcan_end = function ()
  
    ObjDelete( "spr_nearhouse_flowerbed_flower_closed" );

    ObjMultiSet( {
      { "anm_flowerbed_use_water", { input = 1, alp = 1, frame = 300, pos_z = 2 } },
      { "spr_nearhouse_flowerbed_flower_opnd", { alp = 1 } },
      { "spr_nearhouse_flowerbed_doorfigurine_1", { alp = 1 } }
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fullwateringcan", use_fullwateringcan_beg, private.room_objname );
  cmn.AddSubscriber( "use_fullwateringcan", use_fullwateringcan_inv );
  cmn.AddSubscriber( "use_fullwateringcan", use_fullwateringcan_end, private.room_objname );
  cmn.AddSubscriber( "use_fullwateringcan_inv", use_fullwateringcan_inv, private.room_objname );
  cmn.AddSubscriber( "use_fullwateringcan_beg", use_fullwateringcan_beg, private.room_objname );
  cmn.AddSubscriber( "use_fullwateringcan_end", use_fullwateringcan_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_seeds () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_seeds" ] = {
    type = "use",
    inv_obj = "inv_seeds",
    use_place = "obj_flowerbed_use_seeds",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_nearhouse_flowerbed"
  };
  --------------------------------------------------------------------------------------------
  local use_seeds_inv = function ()
  
    interface.InventoryItemRemove( "inv_seeds" );
  
  end;
  local use_seeds_beg = function ()
  
    ObjDelete( "obj_flowerbed_use_seeds" );
  
  end;
  local use_seeds_end = function ()
  
    ObjMultiSet( { {"anm_flowerbed_seeds",  { alp = 1, frame = 0, animfunc = "func_clk_seeds" }},
                   {"obj_flowerbed_use_potion", { input = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_seeds", use_seeds_beg, private.room_objname );
  cmn.AddSubscriber( "use_seeds", use_seeds_inv );
  cmn.AddSubscriber( "use_seeds", use_seeds_end, private.room_objname );
  cmn.AddSubscriber( "use_seeds_inv", use_seeds_inv, private.room_objname );
  cmn.AddSubscriber( "use_seeds_beg", use_seeds_beg, private.room_objname );
  cmn.AddSubscriber( "use_seeds_end", use_seeds_end, private.room_objname );


  --------------------------------------------------------------------------------------------
  -- function opn_nearhouse () end;
  --------------------------------------------------------------------------------------------
  local opn_nearhouse = function ()
  
    int_map_impl.OpenRoom( "rm_nearhouse" );
    interface_impl.SetCurrentGlobalTask( 22 );
  
  end;
  local opn_nearhouse_end = function ()
    ObjDelete( "anm_nearhouse_man_in_window" );
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_nearhouse", opn_nearhouse );
  cmn.AddSubscriber( "opn_nearhouse", opn_nearhouse_end, "rm_nearhouse" );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_housedoor" );
  subroom.Define( "zz_doghouse" );
  subroom.Define( "zz_flowerbed" );

  function zz_flowerbed.Close()

    if cmn.IsEventDone( "use_potionflowerbed" ) then

      local func_after = function ()

        cmn.CallEventHandler( "use_potion_end2" );

        cmn.Lock( 0 );

      end;

      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_loc_tree_grows");
      ObjSet( "anm_nearhouse_tree_growup", { endtrig = func_after, playing = true } );

    end;

  end;
  
  function zz_doghouse.PreOpen()
    
    if cmn.IsEventDone( "get_doorfigurine2" ) and not cmn.IsEventDone("use_bone")
    or cmn.IsEventDone( "get_machinepart1" ) and not cmn.IsEventDone("use_medallion")
    or cmn.IsEventDone("get_whistle") then
      ObjSet("anm_doghouse_dog_2",  { playing = 1 });
    end;

  end;
  
  function zz_doghouse.Close()
    cmn.HideNote( 0 );
  end;
  
  function zz_housedoor.PreOpen()
    
    if not(cmn.IsEventDone( "win_housedoor" )) then
      private.zz_housedoor.DrawScene();
    end;

  end;
  
  function zz_housedoor.Open()
    
    if cmn.IsEventDone( "use_doorfigurine1" ) and cmn.IsEventDone("use_doorfigurine2") and not(cmn.IsEventDone( "win_housedoor" )) then
      cmn.MiniGameShow();
      private.zz_housedoor.CheckWin();
    end;

  end;
  
  function zz_housedoor.PreClose()
    
    if cmn.IsEventDone( "use_doorfigurine1" ) and cmn.IsEventDone("use_doorfigurine2") and not cmn.IsEventDone("win_housedoor") then
      cmn.MiniGameHide("housedoor");
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_housedoor" ].state) then 
    private.zz_housedoor.StartConditions();
  end;
  
  private.zz_housedoor.state = ng_global.progress[ ng_global.currentprogress ][ "win_housedoor" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_nearhouse();

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level4/audio/env/aud_rm_nearhouse_env");
  cmn.PlayAudio("env", "assets/levels/level4/audio/env/aud_rm_nearhouse_env");

  if not ( cmn.IsEventDone( "opn_nearhouse" ) ) then
    cmn.Lock( 1 );
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_handkerchief()

  local item = "inv_handkerchief";

  if cmn.ApplyObj( item, "gzz_nearhouse_housedoor" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_housedoor" );

  elseif ( cmn.ApplyObj( item, "obj_housedoor_use_handkerchief" ) ) then

    cmn.CallEventHandler( "use_handkerchief_inv" );
    cmn.CallEventHandler( "use_handkerchief_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_handkerchief" );
      cmn.CallEventHandler( "use_handkerchief_end" );
      
      public.get_glassshard();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_take_glass_cloth");

    ObjSet("anm_housedoor_take_glass",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_doorfigurine1()

  local item = "inv_doorfigurine1";

  if cmn.ApplyObj( item, "gzz_nearhouse_housedoor" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_housedoor" );

  elseif ( cmn.ApplyObj( item, "obj_housedoor_use_doorfigurine1" ) ) then

    cmn.CallEventHandler( "use_doorfigurine1_inv" );
    cmn.CallEventHandler( "use_doorfigurine1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_doorfigurine1" );
      cmn.CallEventHandler( "use_doorfigurine1_end" );
      
      if cmn.IsEventDone("use_doorfigurine2") then
        cmn.MiniGameShow();
      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_stuff_zz_housedoor");

    ObjAnimate( "spr_housedoor_button_1", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_doorfigurine2()

  local item = "inv_doorfigurine2";

  if cmn.ApplyObj( item, "gzz_nearhouse_housedoor" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_housedoor" );

  elseif ( cmn.ApplyObj( item, "obj_housedoor_use_doorfigurine2" ) ) then

    cmn.CallEventHandler( "use_doorfigurine2_inv" );
    cmn.CallEventHandler( "use_doorfigurine2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_doorfigurine2" );
      cmn.CallEventHandler( "use_doorfigurine2_end" );
      
      if cmn.IsEventDone("use_doorfigurine1") then
        cmn.MiniGameShow();
      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_stuff_zz_housedoor");

    ObjAnimate( "spr_housedoor_button_2", "alp", 0, 0, func_after, { 0, 0, 0,    0.3, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_toyfishingpole()

  local item = "inv_toyfishingpole";

  if cmn.ApplyObj( item, "gzz_nearhouse_nearcellar" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_nearcellar" );

  elseif ( cmn.ApplyObj( item, "obj_nearcellar_use_toyfishingpole" ) ) then

    cmn.CallEventHandler( "use_toyfishingpole_inv" );
    cmn.CallEventHandler( "use_toyfishingpole_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_toyfishingpole" );
      cmn.CallEventHandler( "use_toyfishingpole_end" );
      
      public.get_codewheel();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_butterfly_take");

    ObjSet("anm_nearcellar_use_rod",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_cellarkey()

  local item = "inv_cellarkey";

  if cmn.ApplyObj( item, "gzz_nearhouse_nearcellar" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_nearcellar" );

  elseif ( cmn.ApplyObj( item, "obj_nearcellar_use_cellarkey" ) ) then

    cmn.CallEventHandler( "use_cellarkey_inv" );
    cmn.CallEventHandler( "use_cellarkey_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_cellarkey" );
      cmn.CallEventHandler( "use_cellarkey_end" );
      
      common.CloseSubRoom();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_open_lock_key_zz_nearcellar");

    ObjSet("anm_nearcellar_use_key",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_needdle()

  local item = "inv_needdle";

  if cmn.ApplyObj( item, "gzz_nearhouse_doghouse" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_doghouse", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_doghouse_use_needdle" ) ) then

    cmn.CallEventHandler( "use_needdle_inv" );
    cmn.CallEventHandler( "use_needdle_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_needdle" );
      cmn.CallEventHandler( "use_needdle_end" );
    
    end;
    
    local anm_give = function ()
      
      ObjDelete("anm_doghouse_dog_sew");
      ObjSet("anm_doghouse_dog_give",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;
    
    local anm_sew = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_anim_repair_dog");
      
      ObjDelete("anm_doghouse_dog_touch");
      ObjDelete("anm_doghouse_use_needle");
      ObjDelete("anm_doghouse_use_button_1");
      ObjDelete("anm_doghouse_use_button_2");
      ObjDelete("anm_doghouse_use_paw");
      
      ObjSet("anm_doghouse_dog_sew",  { alp = 1, playing = 1, endtrig = anm_give });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_put_needle_dog");

    if cmn.IsEventDone("use_clothbutton") and cmn.IsEventDone("use_dogpaw") then
      ObjSet("anm_doghouse_use_needle",  { alp = 1, playing = 1, endtrig = anm_sew });
    else 
      ObjSet("anm_doghouse_use_needle",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_clothbutton()

  local item = "inv_clothbutton";

  if cmn.ApplyObj( item, "gzz_nearhouse_doghouse" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_doghouse", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_doghouse_use_clothbutton" ) and cmn.CheckMultiObject( "clothbutton", 2 ) ) then

    cmn.CallEventHandler( "use_clothbutton_inv" );
    cmn.CallEventHandler( "use_clothbutton_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_clothbutton" );
      cmn.CallEventHandler( "use_clothbutton_end" );
    
    end;
    
    local anm_give = function ()
      
      ObjDelete("anm_doghouse_dog_sew");
      ObjSet("anm_doghouse_dog_give",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;
    
    local anm_sew = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_anim_repair_dog");
      
      ObjDelete("anm_doghouse_dog_touch");
      ObjDelete("anm_doghouse_use_needle");
      ObjDelete("anm_doghouse_use_button_1");
      ObjDelete("anm_doghouse_use_button_2");
      ObjDelete("anm_doghouse_use_paw");
      
      ObjSet("anm_doghouse_dog_sew",  { alp = 1, playing = 1, endtrig = anm_give });
      
    end;
    
    local anm_button2 = function ()
      
      if cmn.IsEventDone("use_needdle") and cmn.IsEventDone("use_dogpaw") then
        ObjSet("anm_doghouse_use_button_2",  { alp = 1, playing = 1, endtrig = anm_sew });
      else 
        ObjSet("anm_doghouse_use_button_2",  { alp = 1, playing = 1, endtrig = func_after });
      end;
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_put_button_dog");

    ObjSet("anm_doghouse_use_button_1",  { alp = 1, playing = 1, endtrig = anm_button2 });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_dogpaw()

  local item = "inv_dogpaw";

  if cmn.ApplyObj( item, "gzz_nearhouse_doghouse" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_doghouse", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_doghouse_use_dogpaw" ) ) then

    cmn.CallEventHandler( "use_dogpaw_inv" );
    cmn.CallEventHandler( "use_dogpaw_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_dogpaw" );
      cmn.CallEventHandler( "use_dogpaw_end" );
    
    end;
    
    local anm_give = function ()
      
      ObjDelete("anm_doghouse_dog_sew");
      ObjSet("anm_doghouse_dog_give",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;
    
    local anm_sew = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_anim_repair_dog");
      
      ObjDelete("anm_doghouse_dog_touch");
      ObjDelete("anm_doghouse_use_needle");
      ObjDelete("anm_doghouse_use_button_1");
      ObjDelete("anm_doghouse_use_button_2");
      ObjDelete("anm_doghouse_use_paw");
      
      ObjSet("anm_doghouse_dog_sew",  { alp = 1, playing = 1, endtrig = anm_give });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_put_hand_dog");

    if cmn.IsEventDone("use_needdle") and cmn.IsEventDone("use_clothbutton") then
      ObjSet("anm_doghouse_use_paw",  { alp = 1, playing = 1, endtrig = anm_sew });
    else 
      ObjSet("anm_doghouse_use_paw",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bone()

  local item = "inv_bone";

  if cmn.ApplyObj( item, "gzz_nearhouse_doghouse" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_doghouse", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_doghouse_use_bone" ) ) then

    cmn.CallEventHandler( "use_bone_inv" );
    cmn.CallEventHandler( "use_bone_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_bone" );
      cmn.CallEventHandler( "use_bone_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_take_bone_dog");

    ObjSet("anm_doghouse_use_bone",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_medallion()

  local item = "inv_medallion";

  if cmn.ApplyObj( item, "gzz_nearhouse_doghouse" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_doghouse", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_doghouse_use_medallion" ) ) then

    cmn.CallEventHandler( "use_medallion_inv" );
    cmn.CallEventHandler( "use_medallion_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_medallion" );
      cmn.CallEventHandler( "use_medallion_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_take_collar_dog");

    ObjSet("anm_doghouse_use_medalion",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_fullwateringcan()

  local item = "inv_fullwateringcan";

  if cmn.ApplyObj( item, "gzz_nearhouse_flowerbed" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_flowerbed", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_flowerbed_use_fullwateringcan" ) ) then
    
    if not cmn.IsEventDone("get_handkerchief") then
      public.get_handkerchief();
    end;

    cmn.CallEventHandler( "use_fullwateringcan_inv" );
    cmn.CallEventHandler( "use_fullwateringcan_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_fullwateringcan" );
      cmn.CallEventHandler( "use_fullwateringcan_end" );
    
    end;
    
    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_spill_flower");

    ObjSet("anm_flowerbed_use_water",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_seeds()

  local item = "inv_seeds";

  if cmn.ApplyObj( item, "gzz_nearhouse_flowerbed" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_flowerbed", false, false, true );

  elseif ( cmn.ApplyObj( item, "obj_flowerbed_use_seeds" ) ) then

    cmn.CallEventHandler( "use_seeds_inv" );
    cmn.CallEventHandler( "use_seeds_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_seeds" );
      cmn.CallEventHandler( "use_seeds_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_drop_ground");

    ObjSet("anm_flowerbed_seeds",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_glassshard()

  cmn.SetEventDone( "get_glassshard" );
  cmn.CallEventHandler( "get_glassshard" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_dogpaw()

  cmn.SetEventDone( "get_dogpaw" );
  cmn.CallEventHandler( "get_dogpaw" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_wateringcan()

  cmn.SetEventDone( "get_wateringcan" );
  cmn.CallEventHandler( "get_wateringcan" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_codewheel()
  
  ObjSet("spr_nearcellar_codewheel",  { ang = -0.7165 });

  cmn.SetEventDone( "get_codewheel" );
  cmn.CallEventHandler( "get_codewheel" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_apple()

  cmn.SetEventDone( "get_apple" );
  cmn.CallEventHandler( "get_apple" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_doorfigurine2()
  
  ObjSet("anm_doghouse_dog_2",  { playing = 1 });

  cmn.SetEventDone( "get_doorfigurine2" );
  cmn.CallEventHandler( "get_doorfigurine2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_machinepart1()
  
  ObjSet("anm_doghouse_dog_2",  { playing = 1 });
  ObjSet("spr_doghouse_machinepart1",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_machinepart1" );
  cmn.CallEventHandler( "get_machinepart1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_whistle()
  
  ObjSet("spr_doghouse_whistle",  { ang = 2.5724 });

  cmn.SetEventDone( "get_whistle" );
  cmn.CallEventHandler( "get_whistle" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_handkerchief()

  cmn.SetEventDone( "get_handkerchief" );
  cmn.CallEventHandler( "get_handkerchief" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_doorfigurine1()
  
  ObjSet("spr_flowerbed_doorfigurine1",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0, ang = -0.2269 });

  cmn.SetEventDone( "get_doorfigurine1" );
  cmn.CallEventHandler( "get_doorfigurine1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_ingredients2()

  cmn.SetEventDone( "get_ingredients2" );
  cmn.CallEventHandler( "get_ingredients2" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_letter5()

  cmn.SetEventDone( "get_letter5" );
  cmn.CallEventHandler( "get_letter5" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_nearhouse()

  if not ( cmn.IsEventDone( "opn_nearhouse" ) ) then

    local func_after = function ()

      cmn.ShowBbt( "nearhouse_open" );
      interface_impl.ShowGlobalTask();

      cmn.CallEventHandler("opn_nearhouse");

      cmn.Lock( 0 );

    end;

    cmn.SetEventDone( "opn_nearhouse" );
    int_diary.AddDiarypage( 25 );

    ObjSet( "anm_nearhouse_man_in_window", { endtrig = func_after, playing = true } );

    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_anim_loc_creature_house");

  end;

end;
--------------------------------------------------------------------------------------------
function public.touch_flowerbed_flower()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_flowers_zz_flowerbed");

  cmn.ShowBbt( "obj_flowerbed_use_fullwateringcan" );
  
  ObjSet( "anm_flowerbed_flower_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_flowerbed_seeds()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_ground_zz_flowerbed");

  cmn.ShowBbt( "obj_flowerbed_use_potion" );
  
  ObjSet( "anm_flowerbed_seeds", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_cellar_amulet()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_butterfly");

  cmn.ShowBbt( "obj_nearcellar_use_toyfishingpole" );
  
  ObjSet( "anm_nearcellar_amulet_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_cellar_door()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_lock_zz_nearcellar");

  cmn.ShowBbt( "obj_nearcellar_use_cellarkey" );
  
  ObjSet( "anm_nearcellar_door_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_house_door()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_door_zz_housedoor");

  cmn.ShowBbt( "obj_housedoor_use_doorfigurine" );
  
  ObjSet( "anm_housedoor_door_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
    
  if not cmn.IsEventDone("get_glassshard") then
    ObjAnimate("anm_housedoor_glass_touch", "pos_x", 0, 0, "", { 0, 0, 0,   0.2, 0, 2,   0.4, 0, 0 });
  end;
  
  if not cmn.IsEventDone("get_dogpaw") then
    ObjAnimate("obj_housedoor_dogpaw", "pos_x", 0, 0, "", { 0, 0, 171,   0.2, 0, 173,   0.4, 0, 171 });
  end;
  
end;
--------------------------------------------------------------------------------------------
function public.touch_house_shard()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_glass_zz_housedoor");

  cmn.ShowBbt( "obj_housedoor_use_handkerchief" );
  
  ObjSet( "anm_housedoor_glass_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_dog_1()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_dog_zz_doghouse");

  cmn.ShowBbt( "obj_doghouse_use_dogparts" );
  
  ObjSet( "anm_doghouse_dog_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_dog_2( num )
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_dog_repaired_zz_doghouse_"..math.random(1, 3));
  
  local func_after = function ()
    
    cmn.Lock( 0 );
    
    ObjMultiSet( { {"anm_doghouse_dog_2_touch", { alp = 0 }},
                   {"anm_doghouse_dog_2", { alp = 1, playing = 1 }} } );
    
  end;

  if num == 1 then
    cmn.ShowBbt( "obj_doghouse_use_bone" );
  else 
    cmn.ShowBbt( "obj_doghouse_use_medallion" );
  end;
  
  ObjMultiSet( { {"anm_doghouse_dog_2_touch", { alp = 1, playing = 1, endtrig = func_after }},
                 {"anm_doghouse_dog_2", { alp = 0, playing = 0 }} } );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Housedoor *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_housedoor = {};
public.zz_housedoor = {};

function private.Init_Housedoor()
  
  private.zz_housedoor.rings = {{1, 5}, {6, 9}};
  private.zz_housedoor.pic_pos = {
    {0, 92}, {-88, 28}, {-54, -74}, {54, -74}, {88, 28}, {88, -28}, {54, 74}, {-54, 74}, {-88, -28}
  };
  
  private.zz_housedoor.start = { 3, 9, 1, 6, 7, 4, 5, 8, 2 };
  -----------------------------------------------------------------------------------
  game.hint[ "win_housedoor" ] = {
    type = "win",
    room = "rm_nearhouse",
    zz = "zz_housedoor",
    zz_gate = "gzz_nearhouse_housedoor"
  };
  -----------------------------------------------------------------------------------
  local win_housedoor = function ()

    if cmn.IsEventDone( "win_housedoor" ) then

      ObjDelete( "gzz_nearhouse_housedoor" );

      ObjDelete( "obj_nearhouse_housedoor_close_door" );

      ObjMultiSet( {
        { "grm_nearhouse_inhouse", { input = 1, alp = 1 } },
        { "spr_nearhouse_housedoor_open_door", { alp = 1 } }
      } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_nearhouse_inhouse_focus");
      end;
    
    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_housedoor", win_housedoor, "rm_nearhouse" );
  
end;
--*********************************************************************************************************************
function private.zz_housedoor.StartConditions()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_housedoor" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_housedoor" ].state = { 3, 9, 1, 6, 7, 4, 5, 8, 2 };
  
end;
-----------------------------------------------------------------------------------
function public.zz_housedoor.Reset()
  
  local need_r = false;
  local table_r = {};
  
  for i = 1, 9, 1 do
    
    if private.zz_housedoor.state[i] ~= private.zz_housedoor.start[i] then
      
      need_r = true;
      table.insert(table_r, private.zz_housedoor.state[i]);
      
      ObjAnimate("spr_housedoor_figure_"..private.zz_housedoor.state[i], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  end;
  
  local anm_end = function ()
    
    private.zz_housedoor.DrawScene();
    
    for i = 1, #table_r, 1 do
      
      ObjAnimate("spr_housedoor_figure_"..table_r[i], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    ObjSet("tmr_housedoor_timer",  { time = 0.3, playing = 1, endtrig = function() cmn.Lock(0); end });
    
  end;
  
  if need_r then
    
    cmn.Lock(1);
    private.zz_housedoor.StartConditions();
    private.zz_housedoor.state = ng_global.progress[ ng_global.currentprogress ][ "win_housedoor" ].state;
    
    ObjSet("tmr_housedoor_timer",  { time = 0.3, playing = 1, endtrig = anm_end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_housedoor.Skip()
  
  cmn.Lock(1);
  
  ng_global.progress[ ng_global.currentprogress ][ "win_housedoor" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_housedoor" ].state = { 1, 2, 3, 4, 5, 6, 7, 8, 9 };
  
  local table_r = {};
  
  for i = 1, 9, 1 do
    
    if private.zz_housedoor.state[i] ~= i then
      
      table.insert(table_r, private.zz_housedoor.state[i]);
      
      ObjAnimate("spr_housedoor_figure_"..private.zz_housedoor.state[i], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  end;
  
  local anm_end = function ()
    
    private.zz_housedoor.DrawScene();
    
    for i = 1, #table_r, 1 do
      
      ObjAnimate("spr_housedoor_figure_"..table_r[i], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    ObjSet("tmr_housedoor_timer",  { time = 0.3, playing = 1, endtrig = private.zz_housedoor.CheckWin });
    
  end;
  
  private.zz_housedoor.state = ng_global.progress[ ng_global.currentprogress ][ "win_housedoor" ].state;
  
  ObjSet("tmr_housedoor_timer",  { time = 0.3, playing = 1, endtrig = anm_end });
  
end;
-----------------------------------------------------------------------------------
function private.zz_housedoor.DrawScene()
  
  for i = 1, 2, 1 do
    
    ObjSet("obj_housedoor_ring_"..i,  { ang = 0 });
    
    for j = private.zz_housedoor.rings[i][1], private.zz_housedoor.rings[i][2], 1 do
      ObjAttach("spr_housedoor_figure_"..private.zz_housedoor.state[j], "obj_housedoor_ring_"..i);
      ObjSet("spr_housedoor_figure_"..private.zz_housedoor.state[j],
      { ang = 0,
        pos_x = private.zz_housedoor.pic_pos[j][1],
        pos_y = private.zz_housedoor.pic_pos[j][2]
      });
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_housedoor.FocusButton( num, inout )
  
  local obj = "spr_housedoor_button_"..num.."_focus";
  local alf = ObjGet( obj ).alp;
  local tme = 0;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = alf * 0.3;
  else 
    SetCursor(CURSOR_HAND);
    tme = ( 1 - alf ) * 0.3;
  end;

  ObjAnimate(obj, "alp", 0, 0, "", { 0, 2, alf,   tme, 2, inout });
  
end;
-----------------------------------------------------------------------------------
function public.zz_housedoor.ClickButton( num )
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_closed_door_click");
  
  local table_m = {};
  
  local func_after = function ()
    
    private.zz_housedoor.DrawScene();
    private.zz_housedoor.CheckWin();
    
  end;
  
  if num == 2 then
    
    table.insert(table_m, private.zz_housedoor.state[1]);
    for i = 6, 9, 1 do
      table.insert(table_m, private.zz_housedoor.state[i]);
    end;
    
    for i = 6, 8, 1 do
      private.zz_housedoor.state[i] = table_m[i-3];
    end;
    private.zz_housedoor.state[9] = table_m[1];
    private.zz_housedoor.state[1] = table_m[2];
    
    ObjAttach("spr_housedoor_figure_"..table_m[1], "obj_housedoor_ring_2");
    ObjSet("spr_housedoor_figure_"..table_m[1],  { pos_y = -private.zz_housedoor.pic_pos[1][2] });
    
  else 
    
    for i = 1, 5, 1 do
      table.insert(table_m, private.zz_housedoor.state[i]);
    end;
    
    for i = 1, 4, 1 do
      private.zz_housedoor.state[i] = table_m[i+1];
    end;
    private.zz_housedoor.state[5] = table_m[1];
    
  end;
  
  for i = 1, 5, 1 do
    ObjAnimate("spr_housedoor_figure_"..table_m[i], "ang", 0, 0, "", { 0, 0, 0,   0.5, 0, -2*math.pi/5 });
  end;
  
  ObjAnimate("obj_housedoor_ring_"..num, "ang", 0, 0, func_after, { 0, 0, 0,   0.5, 0, 2*math.pi/5 });
  
  ObjAnimate( "spr_housedoor_button_"..num, "scale_xy", 0, 0, "", { 0, 0, 1, 1,  0.15, 0, 0.9, 0.9,   0.3, 0, 1, 1 } ); 
  
end;
-----------------------------------------------------------------------------------
function private.zz_housedoor.CheckWin()
  
  local win_flag = true;
  
  for i = 1, 5, 1 do
    
    if private.zz_housedoor.state[i] > 5 then
      win_flag = false;
      break;
    end;
    
  end;
  
  if win_flag and private.zz_housedoor.state[1] == 1 then
    
    cmn.Lock( 1 );
    
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_closed_door_win");
    
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("housedoor");
    
    local anm_win = function ()
      
      ObjSet("obj_housedoor_game",  { anim_tag = "tag_mmg_2" });
      ObjAttach("obj_housedoor_game", "anm_housedoor_door_open");
      
      ObjDelete("anm_housedoor_door_touch");
      
      ObjSet("anm_housedoor_door_open",  { alp = 1, playing = 1, endtrig = private.zz_housedoor.Win });
      
    end;
    
    cmn.Lock( 1 );

    ObjSet("tmr_housedoor_timer",  { time = 1, playing = 1, endtrig = anm_win });
    
  else
    cmn.Lock(0);
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_housedoor.Win()
  
  cmn.Lock( 0 );
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_housedoor" );
  cmn.CallEventHandler( "win_housedoor" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_housedoor" ].skip == 0 and ng_global.noskipgames[ "win_housedoor" ] == nil then

    ng_global.noskipgames[ "win_housedoor" ] = 1;
    common_impl.CheckAchiev("mg");

  end;
  
  common.CloseSubRoom();
  
end;
--****************************************************************************************************************