-- name=rm_oldchapel
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_oldchapel";
  --------------------------------------------------------------------------------------------
  private.dlg_lipsync = "";
  private.Init_Subroom();
  private.Init_Statue();
  --------------------------------------------------------------------------------------------
  -- function get_lvl4rope () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl4rope" ] = {
    type = "get",
    get_obj = "spr_statue_lvl4rope",
    room = private.room_objname,
    zz = "zz_statue",
    zz_gate = "gzz_oldchapel_statue"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl4rope_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_lvl4rope", "spr_statue_lvl4rope" );
  
  end;
  local get_lvl4rope_end = function ()
  
    ObjDelete( "gfx_statue_lvl4rope" );
    ObjDelete( "spr_statue_lvl4rope_sh" );
    ObjDelete( "spr_oldchapel_queen_rope" );
  
  end;
  
  cmn.AddSubscriber( "get_lvl4rope", get_lvl4rope_inv );
  cmn.AddSubscriber( "get_lvl4rope", get_lvl4rope_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mirrorshard1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_mirrorshard1" ] = {
    type = "get",
    get_obj = "spr_statue_mirrorshard1",
    room = private.room_objname,
    zz = "zz_statue",
    zz_gate = "gzz_oldchapel_statue"
  };
  --------------------------------------------------------------------------------------------
  local get_mirrorshard1_inv = function ()
  
    interface.InventoryItemAdd( "inv_mirrorshard1", "spr_statue_mirrorshard1" );
  
  end;
  local get_mirrorshard1_end = function ()
  
    ObjDelete( "gfx_statue_mirrorshard1" );
    ObjDelete( "spr_statue_mirrorshard1_sh" );
    ObjDelete( "spr_oldchapel_statue_shard" );
  
  end;
  local get_mirrorshard1_loc = function ()
    
    ObjDelete( "anm_oldchapel_dialog_faceless_hand_1" );
    ObjDelete( "anm_oldchapel_dialog_faceless_give" );
    ObjDelete( "spr_oldchapel_dialog_faceless_necklace" );
    
    ObjAttach("obj_oldchapel_dialog_faceless", "rm_oldchapel");
    
    ObjMultiSet( { {"obj_oldchapel_dialog_faceless", { alp = 1, input = 1 }},
                   {"obj_oldchapel_dialog_faceless_hand_2", { alp = 1, input = 1 }} } );
  
  end;
  cmn.AddSubscriber( "get_mirrorshard1", get_mirrorshard1_inv );
  cmn.AddSubscriber( "get_mirrorshard1", get_mirrorshard1_end, private.room_objname );
  cmn.AddSubscriber( "get_mirrorshard1", get_mirrorshard1_loc, private.room_objname );
  cmn.AddSubscriber( "get_mirrorshard1_inv", get_mirrorshard1_inv );
  cmn.AddSubscriber( "get_mirrorshard1_end", get_mirrorshard1_end, private.room_objname );
  cmn.AddSubscriber( "get_mirrorshard1_loc", get_mirrorshard1_loc, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_frozenpart () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_frozenpart" ] = {
    type = "get",
    get_obj = "spr_mirror_frozenpart",
    room = private.room_objname,
    zz = "zz_mirror",
    zz_gate = "gzz_oldchapel_mirror"
  };
  --------------------------------------------------------------------------------------------
  local get_frozenpart_inv = function ()
  
    interface.InventoryItemAdd( "inv_frozenpart", "spr_mirror_frozenpart" );
  
  end;
  local get_frozenpart_end = function ()
  
    ObjDelete( "gfx_mirror_frozenpart" );
    ObjDelete( "spr_mirror_frozenpart_sh" );
    ObjDelete( "spr_oldchapel_mirror_part" );
  
  end;
  
  cmn.AddSubscriber( "get_frozenpart", get_frozenpart_inv );
  cmn.AddSubscriber( "get_frozenpart", get_frozenpart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_egg () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_egg" ] = {
    type = "get",
    get_obj = "spr_mirror_egg",
    room = private.room_objname,
    zz = "zz_mirror",
    zz_gate = "gzz_oldchapel_mirror"
  };
  --------------------------------------------------------------------------------------------
  local get_egg_inv = function ()
  
    common_impl.InventoryComplexItemAdd( "inv_egg", "spr_mirror_egg" );
  
  end;
  local get_egg_end = function ()
  
    ObjDelete( "gfx_mirror_egg" );
    ObjDelete( "spr_mirror_egg_sh" );
    ObjDelete( "spr_oldchapel_mirror_egg" );
  
  end;
  
  cmn.AddSubscriber( "get_egg", get_egg_inv );
  cmn.AddSubscriber( "get_egg", get_egg_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_phoenix () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_phoenix" ] = {
    type = "get",
    get_obj = "spr_basrelief_phoenix",
    room = private.room_objname,
    zz = "zz_basrelief",
    zz_gate = "gzz_oldchapel_basrelief"
  };
  --------------------------------------------------------------------------------------------
  local get_phoenix_inv = function ()
  
    interface.InventoryItemAdd( "inv_phoenix", "spr_basrelief_phoenix" );
  
  end;
  local get_phoenix_end = function ()
  
    ObjDelete( "gfx_basrelief_phoenix" );
    ObjDelete( "spr_oldchapel_bas_phoenix" );
    ObjDelete( "gzz_oldchapel_basrelief" );
  
  end;
  
  cmn.AddSubscriber( "get_phoenix", get_phoenix_inv );
  cmn.AddSubscriber( "get_phoenix", get_phoenix_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lvl4hook () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_lvl4hook" ] = {
    type = "get",
    get_obj = "spr_basrelief_lvl4hook",
    room = private.room_objname,
    zz = "zz_basrelief",
    zz_gate = "gzz_oldchapel_basrelief"
  };
  --------------------------------------------------------------------------------------------
  local get_lvl4hook_inv = function ()
  
    interface.InventoryItemAdd( "inv_lvl4hook", "spr_basrelief_lvl4hook" );
    ObjSet("inv_lvl4rope_star_light",  { alp = 1 });
  
  end;
  local get_lvl4hook_end = function ()
  
    ObjDelete( "gfx_basrelief_lvl4hook" );
    ObjDelete( "spr_basrelief_lvl4hook_sh" );
    ObjDelete( "spr_oldchapel_bas_hook" );
  
  end;
  
  cmn.AddSubscriber( "get_lvl4hook", get_lvl4hook_inv );
  cmn.AddSubscriber( "get_lvl4hook", get_lvl4hook_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_statuering1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_statuering1" ] = {
    type = "get",
    get_obj = "spr_basrelief_statuering1",
    room = private.room_objname,
    zz = "zz_basrelief",
    zz_gate = "gzz_oldchapel_basrelief"
  };
  --------------------------------------------------------------------------------------------
  local get_statuering1_inv = function ()
  
    interface.InventoryItemAdd( "inv_statuering1", "spr_basrelief_statuering1" );
  
  end;
  local get_statuering1_end = function ()
  
    ObjDelete( "gfx_basrelief_statuering1" );
    ObjDelete( "spr_basrelief_statuering1_sh" );
    ObjDelete( "spr_oldchapel_bas_ring" );
  
  end;
  
  cmn.AddSubscriber( "get_statuering1", get_statuering1_inv );
  cmn.AddSubscriber( "get_statuering1", get_statuering1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stick () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_stick" ] = {
    type = "get",
    get_obj = "spr_basrelief_stick",
    room = private.room_objname,
    zz = "zz_basrelief",
    zz_gate = "gzz_oldchapel_basrelief"
  };
  --------------------------------------------------------------------------------------------
  local get_stick_inv = function ()
  
    interface.InventoryItemAdd( "inv_stick", "spr_basrelief_stick" );
  
  end;
  local get_stick_end = function ()
  
    ObjDelete( "gfx_basrelief_stick" );
    ObjDelete( "spr_basrelief_stick_sh" );
    ObjDelete( "spr_oldchapel_bas_stick" );
  
  end;
  
  cmn.AddSubscriber( "get_stick", get_stick_inv );
  cmn.AddSubscriber( "get_stick", get_stick_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_letter4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_letter4" ] = {
    type = "get",
    get_obj = "spr_oldchapel_letter4",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_letter4_inv = function ()
  
    interface.InventoryItemAdd( "inv_letter", "spr_oldchapel_letter4", function () cmn.GetMultyObject( 'letter', 9 ); end );
    int_map_impl.DecreaseRoomTasks("rm_oldchapel");
  
  end;
  local get_letter4_end = function ()
  
    ObjDelete( "gfx_oldchapel_letter4" );
    ObjDelete( "spr_oldchapel_letter4_sh" );
  
  end;
  
  cmn.AddSubscriber( "get_letter4", get_letter4_inv );
  cmn.AddSubscriber( "get_letter4", get_letter4_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_necklace () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_necklace" ] = {
      type = "get",
      get_obj = "spr_oldchapel_necklace",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_necklace_inv = function ()
  
    interface.InventoryItemAdd( "inv_necklace", "spr_oldchapel_necklace" );
  
  end;
  local get_necklace_mid = function ()
  
    ObjDelete( "gfx_oldchapel_necklace" );
    ObjDelete( "spr_oldchapel_necklace_sh" );
    ObjDelete( "spr_oldchapel_statue_neclace" );
    
  end;
  local get_necklace_end = function ()
  
    ObjDelete( "obj_oldchapel_dialog_faceless" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_necklace", get_necklace_inv );
  cmn.AddSubscriber( "get_necklace_inv", get_necklace_inv, private.room_objname );
  cmn.AddSubscriber( "get_necklace", get_necklace_mid, private.room_objname );
  cmn.AddSubscriber( "get_necklace_mid", get_necklace_mid, private.room_objname );
  cmn.AddSubscriber( "get_necklace", get_necklace_end, private.room_objname );
  cmn.AddSubscriber( "get_necklace_end", get_necklace_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_guidingline () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "get_guidingline" ] = {
      type = "get",
      get_obj = "spr_oldchapel_guidingline",
      room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_guidingline_inv = function ()
  
    interface.InventoryItemAdd( "inv_guidingline", "spr_oldchapel_guidingline" );
  
  end;
  local get_guidingline_mid = function ()
  
    ObjDelete( "gfx_oldchapel_guidingline" );
    ObjDelete( "spr_oldchapel_guidingline_sh" );
    
  end;
  local get_guidingline_end = function ()
  
    ObjDelete( "obj_oldchapel_dialog_queen" );
    ObjDelete( "anm_oldchapel_queen_out" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_guidingline", get_guidingline_inv );
  cmn.AddSubscriber( "get_guidingline_inv", get_guidingline_inv, private.room_objname );
  cmn.AddSubscriber( "get_guidingline", get_guidingline_mid, private.room_objname );
  cmn.AddSubscriber( "get_guidingline_mid", get_guidingline_mid, private.room_objname );
  cmn.AddSubscriber( "get_guidingline", get_guidingline_end, private.room_objname );
  cmn.AddSubscriber( "get_guidingline_end", get_guidingline_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_statuering3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_statuering3" ] = {
    type = "use",
    inv_obj = "inv_statuering3",
    use_place = "obj_statue_use_statuering3",
    room = private.room_objname,
    zz = "zz_statue",
    zz_gate = "gzz_oldchapel_statue"
  };
  --------------------------------------------------------------------------------------------
  local use_statuering3_inv = function ()
  
    interface.InventoryItemRemove( "inv_statuering3" );
  
  end;
  local use_statuering3_beg = function ()
  
    ObjDelete( "obj_statue_use_statuering3" );
  
  end;
  local use_statuering3_end = function ()
    
    ObjMultiSet( { {"obj_statue_ring_8", { alp = 1 }},
                   {"spr_statue_chains_3_0", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_statuering1") and cmn.IsEventDone("use_statuering2") then
      ObjSet("obj_statue_game",  { input = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_statuering3", use_statuering3_beg, private.room_objname );
  cmn.AddSubscriber( "use_statuering3", use_statuering3_inv );
  cmn.AddSubscriber( "use_statuering3", use_statuering3_end, private.room_objname );
  cmn.AddSubscriber( "use_statuering3_inv", use_statuering3_inv, private.room_objname );
  cmn.AddSubscriber( "use_statuering3_beg", use_statuering3_beg, private.room_objname );
  cmn.AddSubscriber( "use_statuering3_end", use_statuering3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_statuering1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_statuering1" ] = {
    type = "use",
    inv_obj = "inv_statuering1",
    use_place = "obj_statue_use_statuering1",
    room = private.room_objname,
    zz = "zz_statue",
    zz_gate = "gzz_oldchapel_statue"
  };
  --------------------------------------------------------------------------------------------
  local use_statuering1_inv = function ()
  
    interface.InventoryItemRemove( "inv_statuering1" );
  
  end;
  local use_statuering1_beg = function ()
  
    ObjDelete( "obj_statue_use_statuering1" );
  
  end;
  local use_statuering1_end = function ()
    
    ObjMultiSet( { {"obj_statue_ring_3", { alp = 1 }},
                   {"spr_statue_chains_2_0", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_statuering3") and cmn.IsEventDone("use_statuering2") then
      ObjSet("obj_statue_game",  { input = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_statuering1", use_statuering1_beg, private.room_objname );
  cmn.AddSubscriber( "use_statuering1", use_statuering1_inv );
  cmn.AddSubscriber( "use_statuering1", use_statuering1_end, private.room_objname );
  cmn.AddSubscriber( "use_statuering1_inv", use_statuering1_inv, private.room_objname );
  cmn.AddSubscriber( "use_statuering1_beg", use_statuering1_beg, private.room_objname );
  cmn.AddSubscriber( "use_statuering1_end", use_statuering1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_statuering2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_statuering2" ] = {
    type = "use",
    inv_obj = "inv_statuering2",
    use_place = "obj_statue_use_statuering2",
    room = private.room_objname,
    zz = "zz_statue",
    zz_gate = "gzz_oldchapel_statue"
  };
  --------------------------------------------------------------------------------------------
  local use_statuering2_inv = function ()
  
    interface.InventoryItemRemove( "inv_statuering2" );
  
  end;
  local use_statuering2_beg = function ()
  
    ObjDelete( "obj_statue_use_statuering2" );
  
  end;
  local use_statuering2_end = function ()
    
    ObjMultiSet( { {"obj_statue_ring_2", { alp = 1 }},
                   {"spr_statue_chains_1_0", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_statuering1") and cmn.IsEventDone("use_statuering3") then
      ObjSet("obj_statue_game",  { input = 1 });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_statuering2", use_statuering2_beg, private.room_objname );
  cmn.AddSubscriber( "use_statuering2", use_statuering2_inv );
  cmn.AddSubscriber( "use_statuering2", use_statuering2_end, private.room_objname );
  cmn.AddSubscriber( "use_statuering2_inv", use_statuering2_inv, private.room_objname );
  cmn.AddSubscriber( "use_statuering2_beg", use_statuering2_beg, private.room_objname );
  cmn.AddSubscriber( "use_statuering2_end", use_statuering2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_statueface () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_statueface" ] = {
    type = "use",
    inv_obj = "inv_statueface",
    use_place = "obj_statue_use_statueface",
    room = private.room_objname,
    zz = "zz_statue",
    zz_gate = "gzz_oldchapel_statue"
  };
  --------------------------------------------------------------------------------------------
  local use_statueface_inv = function ()
  
    interface.InventoryItemRemove( "inv_statueface" );
    int_map_impl.DecreaseRoomTasks("rm_oldchapel");
  
  end;
  local use_statueface_beg = function ()
  
    ObjDelete( "obj_statue_use_statueface" );
    ObjDelete( "obj_oldchapel_statue" );
    ObjDelete( "gzz_oldchapel_statue" );
  
  end;
  local use_statueface_end = function ()
    
    ObjDelete( "obj_oldchapel_queen" );
    ObjDelete( "anm_oldchapel_queen_transform" );
    ObjDelete( "anm_oldchapel_dialog_queen_hand_1" );
    ObjDelete( "anm_oldchapel_dialog_queen_hand_give" );
    
    ObjDelete( "vid_oldchapel_dialog_queen_lipsync1" );
    ObjDelete( "vid_oldchapel_dialog_queen_lipsync2" );
    
    ObjAttach("obj_oldchapel_dialog_queen", "rm_oldchapel");
    
    ObjMultiSet( { {"obj_oldchapel_dialog_queen", { alp = 1, input = 1 }},
                   {"obj_oldchapel_dialog_queen_hand_2", { alp = 1, input = 1 }},
                   {"anm_oldchapel_queen_out", { alp = 1 }},
                   {"anm_oldchapel_dialog_queen_head", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_statueface", use_statueface_beg, private.room_objname );
  cmn.AddSubscriber( "use_statueface", use_statueface_inv );
  cmn.AddSubscriber( "use_statueface", use_statueface_end, private.room_objname );
  cmn.AddSubscriber( "use_statueface_inv", use_statueface_inv, private.room_objname );
  cmn.AddSubscriber( "use_statueface_beg", use_statueface_beg, private.room_objname );
  cmn.AddSubscriber( "use_statueface_end", use_statueface_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lvl4firenecklace () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_lvl4firenecklace" ] = {
    type = "use",
    inv_obj = "inv_lvl4firenecklace",
    use_place = "obj_mirror_use_lvl4firenecklace",
    room = private.room_objname,
    zz = "zz_mirror",
    zz_gate = "gzz_oldchapel_mirror"
  };
  --------------------------------------------------------------------------------------------
  local use_lvl4firenecklace_inv = function ()
  
    interface.InventoryItemRemove( "inv_lvl4firenecklace" );
  
  end;
  local use_lvl4firenecklace_beg = function ()
  
    ObjDelete( "obj_mirror_use_lvl4firenecklace" );
    ObjDelete( "obj_mirror_egg_touch" );
    ObjDelete( "anm_mirror_egg_touch" );
  
  end;
  local use_lvl4firenecklace_end = function ()
    
    ObjDelete( "spr_oldchapel_mirror_ice" );
  
    ObjMultiSet( { {"anm_mirror_use_necklace", { alp = 1, frame = 300 }},
                   {"spr_oldchapel_mirror_necklace", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lvl4firenecklace", use_lvl4firenecklace_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4firenecklace", use_lvl4firenecklace_inv );
  cmn.AddSubscriber( "use_lvl4firenecklace", use_lvl4firenecklace_end, private.room_objname );
  cmn.AddSubscriber( "use_lvl4firenecklace_inv", use_lvl4firenecklace_inv, private.room_objname );
  cmn.AddSubscriber( "use_lvl4firenecklace_beg", use_lvl4firenecklace_beg, private.room_objname );
  cmn.AddSubscriber( "use_lvl4firenecklace_end", use_lvl4firenecklace_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mirrorshard4 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_mirrorshard4" ] = {
    type = "use",
    inv_obj = "inv_mirrorshard4",
    use_place = "obj_mirror_use_mirrorshard4",
    room = private.room_objname,
    zz = "zz_mirror",
    zz_gate = "gzz_oldchapel_mirror"
  };
  --------------------------------------------------------------------------------------------
  local use_mirrorshard4_inv = function ()
  
    interface.InventoryItemRemove( "inv_mirrorshard4" );
  
  end;
  local use_mirrorshard4_beg = function ()
  
    ObjDelete( "obj_mirror_use_mirrorshard4" );
  
  end;
  local use_mirrorshard4_end = function ()
    
    ObjMultiSet( { {"anm_mirror_use_shard_4",  { alp = 1, frame = 300, pos_z = 6 }},
                   {"spr_oldchapel_mirror_shard_4", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_mirrorshard1") and cmn.IsEventDone("use_mirrorshard2") and cmn.IsEventDone("use_mirrorshard3") then
      ObjSet( "gho_oldchapel_inmirror", { input = 1, alp = 1, active = 1 } );
      ObjDelete( "gzz_oldchapel_mirror" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mirrorshard4", use_mirrorshard4_beg, private.room_objname );
  cmn.AddSubscriber( "use_mirrorshard4", use_mirrorshard4_inv );
  cmn.AddSubscriber( "use_mirrorshard4", use_mirrorshard4_end, private.room_objname );
  cmn.AddSubscriber( "use_mirrorshard4_inv", use_mirrorshard4_inv, private.room_objname );
  cmn.AddSubscriber( "use_mirrorshard4_beg", use_mirrorshard4_beg, private.room_objname );
  cmn.AddSubscriber( "use_mirrorshard4_end", use_mirrorshard4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mirrorshard1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_mirrorshard1" ] = {
    type = "use",
    inv_obj = "inv_mirrorshard1",
    use_place = "obj_mirror_use_mirrorshard1",
    room = private.room_objname,
    zz = "zz_mirror",
    zz_gate = "gzz_oldchapel_mirror"
  };
  --------------------------------------------------------------------------------------------
  local use_mirrorshard1_inv = function ()
  
    interface.InventoryItemRemove( "inv_mirrorshard1" );
  
  end;
  local use_mirrorshard1_beg = function ()
  
    ObjDelete( "obj_mirror_use_mirrorshard1" );
  
  end;
  local use_mirrorshard1_end = function ()
    
    ObjMultiSet( { {"anm_mirror_use_shard_1",  { alp = 1, frame = 300, pos_z = 7 }},
                   {"spr_oldchapel_mirror_shard_1", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_mirrorshard4") and cmn.IsEventDone("use_mirrorshard2") and cmn.IsEventDone("use_mirrorshard3") then
      ObjSet( "gho_oldchapel_inmirror", { input = 1, alp = 1, active = 1 } );
      ObjDelete( "gzz_oldchapel_mirror" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mirrorshard1", use_mirrorshard1_beg, private.room_objname );
  cmn.AddSubscriber( "use_mirrorshard1", use_mirrorshard1_inv );
  cmn.AddSubscriber( "use_mirrorshard1", use_mirrorshard1_end, private.room_objname );
  cmn.AddSubscriber( "use_mirrorshard1_inv", use_mirrorshard1_inv, private.room_objname );
  cmn.AddSubscriber( "use_mirrorshard1_beg", use_mirrorshard1_beg, private.room_objname );
  cmn.AddSubscriber( "use_mirrorshard1_end", use_mirrorshard1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mirrorshard2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_mirrorshard2" ] = {
    type = "use",
    inv_obj = "inv_mirrorshard2",
    use_place = "obj_mirror_use_mirrorshard2",
    room = private.room_objname,
    zz = "zz_mirror",
    zz_gate = "gzz_oldchapel_mirror"
  };
  --------------------------------------------------------------------------------------------
  local use_mirrorshard2_inv = function ()
  
    interface.InventoryItemRemove( "inv_mirrorshard2" );
  
  end;
  local use_mirrorshard2_beg = function ()
  
    ObjDelete( "obj_mirror_use_mirrorshard2" );
  
  end;
  local use_mirrorshard2_end = function ()
    
    ObjMultiSet( { {"anm_mirror_use_shard_2",  { alp = 1, frame = 300, pos_z = 8 }},
                   {"spr_oldchapel_mirror_shard_2", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_mirrorshard1") and cmn.IsEventDone("use_mirrorshard4") and cmn.IsEventDone("use_mirrorshard3") then
      ObjSet( "gho_oldchapel_inmirror", { input = 1, alp = 1, active = 1 } );
      ObjDelete( "gzz_oldchapel_mirror" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mirrorshard2", use_mirrorshard2_beg, private.room_objname );
  cmn.AddSubscriber( "use_mirrorshard2", use_mirrorshard2_inv );
  cmn.AddSubscriber( "use_mirrorshard2", use_mirrorshard2_end, private.room_objname );
  cmn.AddSubscriber( "use_mirrorshard2_inv", use_mirrorshard2_inv, private.room_objname );
  cmn.AddSubscriber( "use_mirrorshard2_beg", use_mirrorshard2_beg, private.room_objname );
  cmn.AddSubscriber( "use_mirrorshard2_end", use_mirrorshard2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mirrorshard3 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_mirrorshard3" ] = {
    type = "use",
    inv_obj = "inv_mirrorshard3",
    use_place = "obj_mirror_use_mirrorshard3",
    room = private.room_objname,
    zz = "zz_mirror",
    zz_gate = "gzz_oldchapel_mirror"
  };
  --------------------------------------------------------------------------------------------
  local use_mirrorshard3_inv = function ()
  
    interface.InventoryItemRemove( "inv_mirrorshard3" );
  
  end;
  local use_mirrorshard3_beg = function ()
  
    ObjDelete( "obj_mirror_use_mirrorshard3" );
  
  end;
  local use_mirrorshard3_end = function ()
    
    ObjMultiSet( { {"anm_mirror_use_shard_3",  { alp = 1, frame = 300, pos_z = 5 }},
                   {"spr_oldchapel_mirror_shard_3", { alp = 1 }} } );
  
    if cmn.IsEventDone("use_mirrorshard1") and cmn.IsEventDone("use_mirrorshard2") and cmn.IsEventDone("use_mirrorshard4") then
      ObjSet( "gho_oldchapel_inmirror", { input = 1, alp = 1, active = 1 } );
      ObjDelete( "gzz_oldchapel_mirror" );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mirrorshard3", use_mirrorshard3_beg, private.room_objname );
  cmn.AddSubscriber( "use_mirrorshard3", use_mirrorshard3_inv );
  cmn.AddSubscriber( "use_mirrorshard3", use_mirrorshard3_end, private.room_objname );
  cmn.AddSubscriber( "use_mirrorshard3_inv", use_mirrorshard3_inv, private.room_objname );
  cmn.AddSubscriber( "use_mirrorshard3_beg", use_mirrorshard3_beg, private.room_objname );
  cmn.AddSubscriber( "use_mirrorshard3_end", use_mirrorshard3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_basreliefpart2 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_basreliefpart2" ] = {
    type = "use",
    inv_obj = "inv_basreliefpart2",
    use_place = "obj_basrelief_use_basreliefpart2",
    room = private.room_objname,
    zz = "zz_basrelief",
    zz_gate = "gzz_oldchapel_basrelief"
  };
  --------------------------------------------------------------------------------------------
  local use_basreliefpart2_inv = function ()
  
    interface.InventoryItemRemove( "inv_basreliefpart2" );
  
  end;
  local use_basreliefpart2_beg = function ()
  
    ObjDelete( "obj_basrelief_use_basreliefpart2" );
    
    if cmn.IsEventDone("use_basreliefpart1") then
      ObjSet("obj_basrelief_inside",  { alp = 1 });
    end;
  
  end;
  local use_basreliefpart2_end = function ()
    
    ObjDelete( "anm_basrelief_use_part_2" );
  
    if cmn.IsEventDone("use_basreliefpart1") then
      ObjAttach("anm_basrelief_use_ravenfigurine", "zz_basrelief");
      ObjDelete( "anm_basrelief_door_touch" );
      ObjDelete( "spr_oldchapel_bas_cover" );
      ObjMultiSet( { {"obj_basrelief_inside", { input = 1 }},
                     {"anm_basrelief_door_open", { alp = 1, frame = 300 }} } );
    else
      ObjMultiSet( { {"spr_basrelief_part_2", { alp = 1 }},
                     {"spr_oldchapel_bas_part2", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_basreliefpart2", use_basreliefpart2_beg, private.room_objname );
  cmn.AddSubscriber( "use_basreliefpart2", use_basreliefpart2_inv );
  cmn.AddSubscriber( "use_basreliefpart2", use_basreliefpart2_end, private.room_objname );
  cmn.AddSubscriber( "use_basreliefpart2_inv", use_basreliefpart2_inv, private.room_objname );
  cmn.AddSubscriber( "use_basreliefpart2_beg", use_basreliefpart2_beg, private.room_objname );
  cmn.AddSubscriber( "use_basreliefpart2_end", use_basreliefpart2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_basreliefpart1 () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_basreliefpart1" ] = {
    type = "use",
    inv_obj = "inv_basreliefpart1",
    use_place = "obj_basrelief_use_basreliefpart1",
    room = private.room_objname,
    zz = "zz_basrelief",
    zz_gate = "gzz_oldchapel_basrelief"
  };
  --------------------------------------------------------------------------------------------
  local use_basreliefpart1_inv = function ()
  
    interface.InventoryItemRemove( "inv_basreliefpart1" );
  
  end;
  local use_basreliefpart1_beg = function ()
  
    ObjDelete( "obj_basrelief_use_basreliefpart1" );
    
    if cmn.IsEventDone("use_basreliefpart2") then
      ObjSet("obj_basrelief_inside",  { alp = 1 });
    end;
  
  end;
  local use_basreliefpart1_end = function ()
    
    ObjDelete( "anm_basrelief_use_part_1" );
  
    if cmn.IsEventDone("use_basreliefpart2") then
      ObjAttach("anm_basrelief_use_ravenfigurine", "zz_basrelief");
      ObjDelete( "anm_basrelief_door_touch" );
      ObjDelete( "spr_oldchapel_bas_cover" );
      ObjMultiSet( { {"obj_basrelief_inside", { input = 1 }},
                     {"anm_basrelief_door_open", { alp = 1, frame = 300 }} } );
    else
      ObjMultiSet( { {"spr_basrelief_part_1", { alp = 1 }},
                     {"spr_oldchapel_bas_part1", { alp = 1 }} } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_basreliefpart1", use_basreliefpart1_beg, private.room_objname );
  cmn.AddSubscriber( "use_basreliefpart1", use_basreliefpart1_inv );
  cmn.AddSubscriber( "use_basreliefpart1", use_basreliefpart1_end, private.room_objname );
  cmn.AddSubscriber( "use_basreliefpart1_inv", use_basreliefpart1_inv, private.room_objname );
  cmn.AddSubscriber( "use_basreliefpart1_beg", use_basreliefpart1_beg, private.room_objname );
  cmn.AddSubscriber( "use_basreliefpart1_end", use_basreliefpart1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ravenfigurine () end;
  --------------------------------------------------------------------------------------------
  game.hint[ "use_ravenfigurine" ] = {
    type = "use",
    inv_obj = "inv_ravenfigurine",
    use_place = "obj_basrelief_use_ravenfigurine",
    room = private.room_objname,
    zz = "zz_basrelief",
    zz_gate = "gzz_oldchapel_basrelief"
  };
  --------------------------------------------------------------------------------------------
  local use_ravenfigurine_inv = function ()
  
    interface.InventoryItemRemove( "inv_ravenfigurine" );
  
  end;
  local use_ravenfigurine_beg = function ()
  
    ObjDelete( "obj_basrelief_use_ravenfigurine" );
  
  end;
  local use_ravenfigurine_end = function ()
  
    ObjMultiSet( { {"anm_basrelief_use_ravenfigurine", { input = 1, alp = 1, frame = 300 }},
                   {"spr_oldchapel_bas_phoenix", { alp = 1 }} } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ravenfigurine", use_ravenfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_ravenfigurine", use_ravenfigurine_inv );
  cmn.AddSubscriber( "use_ravenfigurine", use_ravenfigurine_end, private.room_objname );
  cmn.AddSubscriber( "use_ravenfigurine_inv", use_ravenfigurine_inv, private.room_objname );
  cmn.AddSubscriber( "use_ravenfigurine_beg", use_ravenfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_ravenfigurine_end", use_ravenfigurine_end, private.room_objname );


  --------------------------------------------------------------------------------------------
  -- function opn_oldchapel () end;
  --------------------------------------------------------------------------------------------
  local opn_oldchapel = function ()
  
    int_map_impl.OpenRoom( "rm_oldchapel" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_oldchapel", opn_oldchapel );

end;
--********************************************************************************************************************
function private.Init_Subroom()
  
  subroom.Define( "zz_statue" );
  
  function zz_statue.PreOpen()
    
    if not(cmn.IsEventDone( "win_statue" )) then
      private.zz_statue.DrawScene();
    end;

  end;
  
  function zz_statue.Open()
    
    if cmn.IsEventDone( "use_statuering1" ) and cmn.IsEventDone("use_statuering2") and cmn.IsEventDone("use_statuering3") and not(cmn.IsEventDone( "win_statue" )) then
      cmn.MiniGameShow();
      private.zz_statue.CheckWin();
    end;

  end;
  
  function zz_statue.PreClose()
    
    if cmn.IsEventDone( "use_statuering1" ) and cmn.IsEventDone("use_statuering2") and cmn.IsEventDone("use_statuering3") and not cmn.IsEventDone("win_statue") then
      cmn.MiniGameHide("statue");
    end;
    
  end;
  
  function zz_statue.Close()
    
    if cmn.IsEventDone("get_mirrorshard1") and not cmn.IsEventDone("opn_oldchapeldialog1") then
      
      cmn.SetEventDone("opn_oldchapeldialog1");
      
      ObjAttach("obj_oldchapel_dialog_faceless", "rm_oldchapel");
      ObjAnimate("obj_oldchapel_dialog_faceless", "alp", 0, 0, private.dialog_faceless_beg, { 0, 0, 0,   0.5, 0, 1 });
      
    end;
    
    if cmn.IsEventDone("use_statueface") and not cmn.IsEventDone("opn_oldchapeldialog2") then
      
      cmn.SetEventDone("opn_oldchapeldialog2");
      
      local func_after = function ()
      
        ObjAttach("obj_oldchapel_dialog_queen", "rm_oldchapel");
        ObjAnimate("obj_oldchapel_dialog_queen", "alp", 0, 0, private.dialog_queen_beg, { 0, 0, 0,   0.5, 0, 1 });
        
      end;
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_loc_queen_change");
      ObjSet("anm_oldchapel_queen_transform",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load()
  
  if not(ng_global.progress[ ng_global.currentprogress ][ "win_statue" ].state) then 
    private.zz_statue.StartConditions();
  end;
  
  private.zz_statue.state = ng_global.progress[ ng_global.currentprogress ][ "win_statue" ].state;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_oldchapel();
  
  if cmn.IsEventDone("get_mirrorshard1") and not cmn.IsEventDone("get_necklace") then
    --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    common_impl.current_dialog = "obj_oldchapel_dialog_faceless";
    ObjSet("anm_oldchapel_dialog_faceless_hand_2",  { playing = 1 });
  end;
  
  if cmn.IsEventDone("use_statueface") and not cmn.IsEventDone("get_guidingline") then
    --cmn.PlayAudio("mus", "assets/levels/common/audio/aud_dialog_theme_mus", 1);
    common_impl.current_dialog = "obj_oldchapel_dialog_queen";
    ObjSet("anm_oldchapel_dialog_queen_hand_2",  { playing = 1 });
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  cmn.StopAllEnv("assets/levels/level4/audio/env/aud_rm_oldchapel_env");
  cmn.PlayAudio("env", "assets/levels/level4/audio/env/aud_rm_oldchapel_env");
  
  --анимация морф-оъекта
  if cmn.IsCollectableAvailible(10) then
    private.AnimMorphObject();
  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_statuering3()

  local item = "inv_statuering3";

  if cmn.ApplyObj( item, "gzz_oldchapel_statue" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_statue" );

  elseif ( cmn.ApplyObj( item, "obj_statue_use_statuering3" ) ) then

    cmn.CallEventHandler( "use_statuering3_inv" );
    cmn.CallEventHandler( "use_statuering3_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_statuering3" );
      cmn.CallEventHandler( "use_statuering3_end" );
      
      if cmn.IsEventDone("use_statuering1") and cmn.IsEventDone("use_statuering2") then
        cmn.MiniGameShow();
      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_zz_statue_ring");

    ObjAnimate( "obj_statue_ring_8", "alp", 0, 0, func_after, { 0, 0, 0,    0.5, 0, 1 } );
    ObjAnimate( "spr_statue_chains_3_0", "alp", 0, 0, "", { 0, 0, 0,    0.5, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_statuering1()

  local item = "inv_statuering1";

  if cmn.ApplyObj( item, "gzz_oldchapel_statue" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_statue" );

  elseif ( cmn.ApplyObj( item, "obj_statue_use_statuering1" ) ) then

    cmn.CallEventHandler( "use_statuering1_inv" );
    cmn.CallEventHandler( "use_statuering1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_statuering1" );
      cmn.CallEventHandler( "use_statuering1_end" );
      
      if cmn.IsEventDone("use_statuering3") and cmn.IsEventDone("use_statuering2") then
        cmn.MiniGameShow();
      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_zz_statue_ring");

    ObjAnimate( "obj_statue_ring_3", "alp", 0, 0, func_after, { 0, 0, 0,    0.5, 0, 1 } );
    ObjAnimate( "spr_statue_chains_2_0", "alp", 0, 0, "", { 0, 0, 0,    0.5, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_statuering2()

  local item = "inv_statuering2";

  if cmn.ApplyObj( item, "gzz_oldchapel_statue" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_statue" );

  elseif ( cmn.ApplyObj( item, "obj_statue_use_statuering2" ) ) then

    cmn.CallEventHandler( "use_statuering2_inv" );
    cmn.CallEventHandler( "use_statuering2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_statuering2" );
      cmn.CallEventHandler( "use_statuering2_end" );
      
      if cmn.IsEventDone("use_statuering1") and cmn.IsEventDone("use_statuering3") then
        cmn.MiniGameShow();
      end;
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_zz_statue_ring");

    ObjAnimate( "obj_statue_ring_2", "alp", 0, 0, func_after, { 0, 0, 0,    0.5, 0, 1 } );
    ObjAnimate( "spr_statue_chains_1_0", "alp", 0, 0, "", { 0, 0, 0,    0.5, 0, 1 } );

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_statueface()

  local item = "inv_statueface";

  if cmn.ApplyObj( item, "gzz_oldchapel_statue" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_statue" );

  elseif ( cmn.ApplyObj( item, "obj_statue_use_statueface" ) ) then

    cmn.CallEventHandler( "use_statueface_inv" );
    cmn.CallEventHandler( "use_statueface_beg" );

    local func_after = function ()

      --cmn.Lock( 0 );

      cmn.SetEventDone( "use_statueface" );
      --cmn.CallEventHandler( "use_statueface_end" );
      
      ObjSet("anm_oldchapel_queen_transform",  { alp = 1 });
      
      common.CloseSubRoom();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_wear_mask_zz_statue");

    ObjSet("anm_statue_use_statueface",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lvl4firenecklace()

  local item = "inv_lvl4firenecklace";

  if cmn.ApplyObj( item, "gzz_oldchapel_mirror" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_mirror" );

  elseif ( cmn.ApplyObj( item, "obj_mirror_use_lvl4firenecklace" ) ) then

    cmn.CallEventHandler( "use_lvl4firenecklace_inv" );
    cmn.CallEventHandler( "use_lvl4firenecklace_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_lvl4firenecklace" );
      cmn.CallEventHandler( "use_lvl4firenecklace_end" );
      
      public.get_egg();
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_wear_necklace");

    ObjSet("anm_mirror_use_necklace",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_mirrorshard4()

  local item = "inv_mirrorshard4";

  if cmn.ApplyObj( item, "gzz_oldchapel_mirror" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_mirror" );

  elseif ( cmn.ApplyObj( item, "obj_mirror_use_mirrorshard4" ) ) then

    cmn.CallEventHandler( "use_mirrorshard4_inv" );
    cmn.CallEventHandler( "use_mirrorshard4_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_mirrorshard4" );
      cmn.CallEventHandler( "use_mirrorshard4_end" );
      
      if cmn.IsEventDone("use_mirrorshard1") and cmn.IsEventDone("use_mirrorshard2") and cmn.IsEventDone("use_mirrorshard3") then
        common.CloseSubRoom();
      end;
    
    end;
    
    if cmn.IsEventDone("use_lvl4firenecklace") and not cmn.IsEventDone("get_egg") then
      public.get_egg();
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_mirror_piece");

    ObjSet("anm_mirror_use_shard_4",  { pos_z = 10, alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_mirrorshard1()

  local item = "inv_mirrorshard1";

  if cmn.ApplyObj( item, "gzz_oldchapel_mirror" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_mirror" );

  elseif ( cmn.ApplyObj( item, "obj_mirror_use_mirrorshard1" ) ) then

    cmn.CallEventHandler( "use_mirrorshard1_inv" );
    cmn.CallEventHandler( "use_mirrorshard1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_mirrorshard1" );
      cmn.CallEventHandler( "use_mirrorshard1_end" );
      
      if cmn.IsEventDone("use_mirrorshard4") and cmn.IsEventDone("use_mirrorshard2") and cmn.IsEventDone("use_mirrorshard3") then
        common.CloseSubRoom();
      end;
    
    end;
    
    if cmn.IsEventDone("use_lvl4firenecklace") and not cmn.IsEventDone("get_egg") then
      public.get_egg();
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_mirror_piece");

    ObjSet("anm_mirror_use_shard_1",  { pos_z = 10, alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_mirrorshard2()

  local item = "inv_mirrorshard2";

  if cmn.ApplyObj( item, "gzz_oldchapel_mirror" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_mirror" );

  elseif ( cmn.ApplyObj( item, "obj_mirror_use_mirrorshard2" ) ) then

    cmn.CallEventHandler( "use_mirrorshard2_inv" );
    cmn.CallEventHandler( "use_mirrorshard2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_mirrorshard2" );
      cmn.CallEventHandler( "use_mirrorshard2_end" );
      
      if cmn.IsEventDone("use_mirrorshard1") and cmn.IsEventDone("use_mirrorshard4") and cmn.IsEventDone("use_mirrorshard3") then
        common.CloseSubRoom();
      end;
    
    end;
    
    if cmn.IsEventDone("use_lvl4firenecklace") and not cmn.IsEventDone("get_egg") then
      public.get_egg();
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_mirror_piece");

    ObjSet("anm_mirror_use_shard_2",  { pos_z = 10, alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_mirrorshard3()

  local item = "inv_mirrorshard3";

  if cmn.ApplyObj( item, "gzz_oldchapel_mirror" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_mirror" );

  elseif ( cmn.ApplyObj( item, "obj_mirror_use_mirrorshard3" ) ) then

    cmn.CallEventHandler( "use_mirrorshard3_inv" );
    cmn.CallEventHandler( "use_mirrorshard3_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_mirrorshard3" );
      cmn.CallEventHandler( "use_mirrorshard3_end" );
      
      if cmn.IsEventDone("use_mirrorshard1") and cmn.IsEventDone("use_mirrorshard2") and cmn.IsEventDone("use_mirrorshard4") then
        common.CloseSubRoom();
      end;
    
    end;
    
    if cmn.IsEventDone("use_lvl4firenecklace") and not cmn.IsEventDone("get_egg") then
      public.get_egg();
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_mirror_piece");

    ObjSet("anm_mirror_use_shard_3",  { pos_z = 10, alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_basreliefpart2()

  local item = "inv_basreliefpart2";

  if cmn.ApplyObj( item, "gzz_oldchapel_basrelief" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_basrelief" );

  elseif ( cmn.ApplyObj( item, "obj_basrelief_use_basreliefpart2" ) ) then

    cmn.CallEventHandler( "use_basreliefpart2_inv" );
    cmn.CallEventHandler( "use_basreliefpart2_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_basreliefpart2" );
      cmn.CallEventHandler( "use_basreliefpart2_end" );
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_fresco_opens");
      
      ObjDelete("anm_basrelief_door_touch");
      ObjDelete("anm_basrelief_use_part_2");
      ObjSet("anm_basrelief_door_open",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_zz_basrelief_left");

    if cmn.IsEventDone("use_basreliefpart1") then
      ObjSet("anm_basrelief_use_part_2",  { alp = 1, playing = 1, endtrig = anm_open });
    else
      ObjSet("anm_basrelief_use_part_2",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_basreliefpart1()

  local item = "inv_basreliefpart1";

  if cmn.ApplyObj( item, "gzz_oldchapel_basrelief" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_basrelief" );

  elseif ( cmn.ApplyObj( item, "obj_basrelief_use_basreliefpart1" ) ) then

    cmn.CallEventHandler( "use_basreliefpart1_inv" );
    cmn.CallEventHandler( "use_basreliefpart1_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_basreliefpart1" );
      cmn.CallEventHandler( "use_basreliefpart1_end" );
    
    end;
    
    local anm_open = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_fresco_opens");
      
      ObjDelete("anm_basrelief_door_touch");
      ObjDelete("anm_basrelief_use_part_1");
      ObjSet("anm_basrelief_door_open",  { alp = 1, playing = 1, endtrig = func_after });
      
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_zz_basrelief_right");

    if cmn.IsEventDone("use_basreliefpart2") then
      ObjSet("anm_basrelief_use_part_1",  { alp = 1, playing = 1, endtrig = anm_open });
    else
      ObjSet("anm_basrelief_use_part_1",  { alp = 1, playing = 1, endtrig = func_after });
    end;

  else

    cmn.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_ravenfigurine()

  local item = "inv_ravenfigurine";

  if cmn.ApplyObj( item, "gzz_oldchapel_basrelief" ) then

    --interface.ObjDoNotDrop();
    cmn.GotoSubRoom( "zz_basrelief" );

  elseif ( cmn.ApplyObj( item, "obj_basrelief_use_ravenfigurine" ) ) then

    cmn.CallEventHandler( "use_ravenfigurine_inv" );
    cmn.CallEventHandler( "use_ravenfigurine_beg" );

    local func_after = function ()

      cmn.Lock( 0 );

      cmn.SetEventDone( "use_ravenfigurine" );
      cmn.CallEventHandler( "use_ravenfigurine_end" );
    
    end;

    cmn.Lock( 1 );
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_insert_crow_zz_basrelief");

    ObjSet("anm_basrelief_use_ravenfigurine",  { alp = 1, playing = 1, endtrig = func_after });

  else

    cmn.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.get_lvl4rope()

  cmn.SetEventDone( "get_lvl4rope" );
  cmn.CallEventHandler( "get_lvl4rope" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_mirrorshard1()

  cmn.SetEventDone( "get_mirrorshard1" );
  cmn.CallEventHandler( "get_mirrorshard1_inv" );
  cmn.CallEventHandler( "get_mirrorshard1_end" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  cmn.Lock( 1 );
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_frozenpart()

  cmn.SetEventDone( "get_frozenpart" );
  cmn.CallEventHandler( "get_frozenpart" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_egg()
  
  ObjSet("spr_mirror_egg",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_egg" );
  cmn.CallEventHandler( "get_egg" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_phoenix()
  
  ObjSet("spr_basrelief_phoenix",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });

  cmn.SetEventDone( "get_phoenix" );
  cmn.CallEventHandler( "get_phoenix" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function public.get_lvl4hook()

  cmn.SetEventDone( "get_lvl4hook" );
  cmn.CallEventHandler( "get_lvl4hook" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_statuering1()

  cmn.SetEventDone( "get_statuering1" );
  cmn.CallEventHandler( "get_statuering1" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_stick()

  cmn.SetEventDone( "get_stick" );
  cmn.CallEventHandler( "get_stick" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_letter4()

  cmn.SetEventDone( "get_letter4" );
  cmn.CallEventHandler( "get_letter4" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );

end;
--------------------------------------------------------------------------------------------
function public.get_necklace()
  
  ObjSet("spr_oldchapel_necklace",  { pos_x = 0, pos_y = 0, drawoff_x = 0, drawoff_y = 0 });
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_necklace_end" );
    
    --common_impl.PlayBackgroundMusic();

  end;

  cmn.SetEventDone( "get_necklace" );
  cmn.CallEventHandler( "get_necklace_inv" );
  cmn.CallEventHandler( "get_necklace_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.current_dialog = "";
  
  cmn.Lock(1);
  ObjAnimate("obj_oldchapel_dialog_faceless", "alp", 0, 0, func_after_dlg, { 0, 0, 1,   0.5, 0, 0 });

end;
--------------------------------------------------------------------------------------------
function public.get_guidingline()
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_guidingline_end" );
    
    --common_impl.PlayBackgroundMusic();

  end;
  
  local anm_out = function ()
    
    ObjSet("anm_oldchapel_queen_out",  { playing = 1, endtrig = func_after_dlg });

    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_black_queen_diss");

  end;

  cmn.SetEventDone( "get_guidingline" );
  cmn.CallEventHandler( "get_guidingline_inv" );
  cmn.CallEventHandler( "get_guidingline_mid" );

  cmn.PlayAudio( "snd", "assets/levels/common/audio/aud_take_stuff_game_1" );
  
  common_impl.current_dialog = "";
  
  cmn.Lock(1);
  ObjAnimate("obj_oldchapel_dialog_queen", "alp", 0, 0, anm_out, { 0, 0, 1,   0.5, 0, 0 });

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_oldchapel()

  if not ( cmn.IsEventDone( "opn_oldchapel" ) ) then
    cmn.SetEventDone( "opn_oldchapel" );
    cmn.CallEventHandler("opn_oldchapel");
    cmn.ShowBbt( "oldchapel_open" );
  end;

end;
--------------------------------------------------------------------------------------------
function private.AnimMorphObject()
  
  ObjMultiSet( { {"spr_col_10_1", { alp = 1 }},
                 {"spr_col_10_2", { alp = 0 }} } );
                 
  ObjStopAnimate("spr_col_10_2", "alp");
  
  local change_state2 = function ()
  
    ObjAnimate("spr_col_10_2", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    ObjAnimate("spr_col_10_1", "alp", 0, 0, private.AnimMorphObject, { 0, 0, 0,   0.3, 0, 1 });
  
  end;
  
  local change_state1 = function ()
  
    ObjAnimate("spr_col_10_2", "alp", 0, 0, change_state2, { 0, 0, 0,   0.3, 0, 1,   5, 0, 1 });
    ObjAnimate("spr_col_10_1", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  
  end;
  
  ObjAnimate("spr_col_10_1", "alp", 0, 0, change_state1, { 0, 0, 1,   5, 0, 1 });
  
end;
--------------------------------------------------------------------------------------------
function public.touch_mirror_egg()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_frozen_egg");

  cmn.ShowBbt( "obj_mirror_egg_touch" );
  
  ObjSet( "anm_mirror_egg_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_basrelief()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_broken_fresco");

  cmn.ShowBbt( "obj_basrelief_use_basreliefpart" );
  
  ObjSet( "anm_basrelief_door_touch", { playing = 1, endtrig = function() cmn.Lock(0); end } );
  
end;
--------------------------------------------------------------------------------------------
function public.touch_statue_hands()
  
  cmn.Lock( 1 );
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_xx_statue_hands");

  cmn.ShowBbt( "obj_statue_use_statuering" );
  
  ObjAnimate("obj_statue_hand_1", "pos_x", 0, 0, function() cmn.Lock(0); end, { 0, 0, 0,   0.2, 0, -10,   0.4, 0, 0 });
  ObjAnimate("obj_statue_hand_2", "pos_x", 0, 0, "", { 0, 0, 0,   0.2, 0, 10,   0.4, 0, 0 });
  
end;
--------------------------------------------------------------------------------------------
function private.dialog_faceless_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "oldchapel", "faceless", 2 );
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "get_mirrorshard1_loc" );

    cmn.ShowBbt( "oldchapel_after_dialog_1" );
    
    ObjMultiSet( { {"anm_oldchapel_dialog_faceless_hand_2", { playing = 1 }},
                   {"anm_oldchapel_dialog_faceless_body", { alp = 1, playing = 1 }} } );
    
  end;
  
  local anm_hand = function ()
    
    private.dlg_lipsync = "";
    --ObjDelete("vid_oldchapel_dialog_faceless_lipsync2");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_oldchapel_dialog_faceless_timer",  { playing = 0 }},
                   {"anm_oldchapel_dialog_faceless_give", { alp = 1, playing = 1, endtrig = dialog_end }},
                   {"anm_oldchapel_dialog_faceless_body", { alp = 0, playing = 0 }},
                   {"anm_oldchapel_dialog_faceless_hand_1", { alp = 0, playing = 0 }} } );
    
  end;
                 
  local queen_talks2 = function ()
  
    --ObjDelete("vid_oldchapel_dialog_faceless_lipsync1");
    --ObjAttach("vid_oldchapel_dialog_faceless_lipsync2", "obj_oldchapel_dialog_faceless");
  
    cmn.ShowDlgBbt( "dlg_oldchapel_faceless_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level4/audio/voc/aud_4_lvl_blackqueen_2_voc");
    
    --private.dlg_lipsync = "vid_oldchapel_dialog_faceless_lipsync2";
    
    ObjMultiSet( { {"tmr_oldchapel_dialog_faceless_timer", { endtrig = anm_hand, time = 5, playing = 1 }},
                   --{"vid_oldchapel_dialog_faceless_lipsync2", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_hand }},
                   {"obj_character_dialog_continue", { event_mup = anm_hand }} } );
  
  end;

  --private.dlg_lipsync = "vid_oldchapel_dialog_faceless_lipsync1";

  cmn.ShowDlgBbt( "dlg_oldchapel_faceless_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level4/audio/voc/aud_4_lvl_blackqueen_1_voc");

  ObjMultiSet( { {"tmr_oldchapel_dialog_faceless_timer", { time = 8, playing = 1, endtrig = queen_talks2 }},
                 --{"vid_oldchapel_dialog_faceless_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = queen_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = queen_talks2 }} } );
  
end; 
--------------------------------------------------------------------------------------------
function private.dialog_queen_beg()
  
  cmn.Lock(0);
  interface.InterfaceSetInput( false );  
  
  common_impl.CharacterDialogButtonsShow( "oldchapel", "queen", 2 );
  
  local dialog_end = function ()
  
    interface.InterfaceSetInput( true );
    
    cmn.CallEventHandler( "use_statueface_end" );

    cmn.ShowBbt( "oldchapel_after_dialog_2" );
    int_diary.AddDiarypage( 23 );
    
    ObjMultiSet( { {"anm_oldchapel_dialog_queen_hand_2", { playing = 1 }},
                   {"anm_oldchapel_dialog_queen_body", { alp = 1, playing = 1 }},
                   {"anm_oldchapel_dialog_queen_body_2", { alp = 1, playing = 1 }} } );
    
  end;
  
  local anm_hand = function ()
    
    private.dlg_lipsync = "";
    ObjDelete("vid_oldchapel_dialog_queen_lipsync2");
    
    int_blackbartext.Hide();
    common_impl.CharacterDialogButtonsHide();
    SndStop( common_impl.audio.voc, 0.5 );
    
    ObjMultiSet( { {"tmr_oldchapel_dialog_queen_timer",  { playing = 0 }},
                   {"anm_oldchapel_dialog_queen_hand_1", { alp = 0, playing = 0 }},
                   {"anm_oldchapel_dialog_queen_body", { alp = 0, playing = 0 }},
                   {"anm_oldchapel_dialog_queen_body_2", { alp = 0, playing = 0 }},
                   {"anm_oldchapel_dialog_queen_hand_give", { alp = 1, playing = 1, endtrig = dialog_end }},
                   {"anm_oldchapel_dialog_queen_head", { alp = 1 }} } );
    
  end;
                 
  local queen_talks2 = function ()
  
    ObjDelete("vid_oldchapel_dialog_queen_lipsync1");
    ObjAttach("vid_oldchapel_dialog_queen_lipsync2", "obj_oldchapel_dialog_queen");
  
    cmn.ShowDlgBbt( "dlg_oldchapel_queen_phrase_2" );
    SndStop( common_impl.audio.voc, 0.5 );
    cmn.PlayAudio("voc", "assets/levels/level4/audio/voc/aud_4_lvl_blackqueen_4_voc");
    
    private.dlg_lipsync = "vid_oldchapel_dialog_queens_lipsync2";
    
    ObjMultiSet( { {"tmr_oldchapel_dialog_queen_timer", { endtrig = anm_hand, time = 4, playing = 1 }},
                   {"vid_oldchapel_dialog_queen_lipsync2", { playing = 1 }},
                   {"spr_character_dialog_continue", { event_mup = anm_hand }},
                   {"obj_character_dialog_continue", { event_mup = anm_hand }} } );
  
  end;

  private.dlg_lipsync = "vid_oldchapel_dialog_queen_lipsync1";

  cmn.ShowDlgBbt( "dlg_oldchapel_queen_phrase_1" );
  cmn.PlayAudio("voc", "assets/levels/level4/audio/voc/aud_4_lvl_blackqueen_3_voc");

  ObjMultiSet( { {"tmr_oldchapel_dialog_queen_timer", { time = 5, playing = 1, endtrig = queen_talks2 }},
                 {"vid_oldchapel_dialog_queen_lipsync1", { playing = 1 }},
                 {"spr_character_dialog_continue", { event_mup = queen_talks2 }},
                 {"obj_character_dialog_continue", { event_mup = queen_talks2 }} } );
  
end;
--------------------------------------------------------------------------------------------
function public.skip_dlg_faceless()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "get_mirrorshard1_loc" );

    cmn.ShowBbt( "oldchapel_after_dialog_1" );
    
    ObjMultiSet( { {"anm_oldchapel_dialog_faceless_hand_2", { playing = 1 }},
                   {"anm_oldchapel_dialog_faceless_body", { alp = 1, playing = 1 }} } );
    
  end;
  
  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    --ObjDelete(private.dlg_lipsync);
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();
  
  --common_impl.PlayBackgroundMusic();
  
  ObjMultiSet( { {"tmr_oldchapel_dialog_faceless_timer",  { playing = 0 }},
                 {"anm_oldchapel_dialog_faceless_give", { alp = 1, playing = 1, endtrig = func_after_dlg }},
                 {"anm_oldchapel_dialog_faceless_body", { alp = 0, playing = 0 }},
                 {"anm_oldchapel_dialog_faceless_hand_1", { alp = 0, playing = 0 }} } );;
  
end;
--------------------------------------------------------------------------------------------
function public.skip_dlg_queen()

  cmn.PlayAudio("snd", "assets/levels/common/audio/aud_menu_clk");
  
  interface.InterfaceSetInput( true );
  cmn.Lock(1);
  
  local func_after_dlg = function ()

    cmn.Lock(0);
    cmn.CallEventHandler( "use_statueface_end" );

    cmn.ShowBbt( "oldchapel_after_dialog_2" );
    int_diary.AddDiarypage( 23 );
    
    ObjMultiSet( { {"anm_oldchapel_dialog_queen_hand_2", { playing = 1 }},
                   {"anm_oldchapel_dialog_queen_body", { alp = 1, playing = 1 }},
                   {"anm_oldchapel_dialog_queen_body_2", { alp = 1, playing = 1 }} } );
    
  end;
  
  int_blackbartext.Hide();
  SndStop( common_impl.audio.voc, 1 );

  --стоп липсинка
  if (private.dlg_lipsync ~= "") then
    ObjDelete(private.dlg_lipsync);
    ObjSet("anm_oldchapel_dialog_queen_head",  { alp = 1 });
    private.dlg_lipsync = "";
  end;

  common_impl.CharacterDialogButtonsHide();
  
  --common_impl.PlayBackgroundMusic();
  
  ObjMultiSet( { {"tmr_oldchapel_dialog_queen_timer",  { playing = 0 }},
                 {"anm_oldchapel_dialog_queen_hand_1", { alp = 0, playing = 0 }},
                 {"anm_oldchapel_dialog_queen_body", { alp = 0, playing = 0 }},
                 {"anm_oldchapel_dialog_queen_body_2", { alp = 0, playing = 0 }},
                 {"anm_oldchapel_dialog_queen_hand_give", { alp = 1, playing = 1, endtrig = func_after_dlg }} } );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG_Statue *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.zz_statue = {};
public.zz_statue = {};

function private.Init_Statue()
  
  private.zz_statue.chosen = 0;
  private.zz_statue.start = { 7, 6, 5, 1, 2, 8, 3, 4 };

  private.zz_statue.chains_connect = { 
    { {1}, {2,3}, {4,5}, {6}, {7}, {8,9}, {10,11}, {12} },
    { {1,2}, {3,4}, {5,6}, {7,8}, {9,10}, {11,12} } 
  }; --[1] - connections with rings, [2] - connections with symbols

  private.zz_statue.additive_chains = { 
    { {2, 2} }, { {1, 1}, {3, 4} }, { {2, 3}, {4, 6} }, { {3, 5} },
    { {6, 8} }, { {5, 7}, {7, 10} }, { {6, 9}, {8, 12} }, { {7, 11} }
  }; --posible positions of rings
  
  private.zz_statue.win_chains = { 
    {1}, {2, 3}, {4, 5}, {6}, {7}, {8, 9}, {10, 11}, {12}
  };
  -----------------------------------------------------------------------------------
  game.hint[ "win_statue" ] = {
    type = "win",
    room = "rm_oldchapel",
    zz = "zz_statue",
    zz_gate = "gzz_oldchapel_statue"
  };
  -----------------------------------------------------------------------------------
  local win_statue = function ()

    if cmn.IsEventDone( "win_statue" ) then
      ObjDelete("obj_statue_game");
      ObjDelete("spr_oldchapel_statue_hands_1");
      ObjMultiSet( { {"spr_statue_mirrorshard1", { input = 1 }},
                     {"obj_statue_use_statueface", { input = 1 }},
                     {"spr_oldchapel_statue_hands_2", { alp = 1 }} } );
    end;

  end;
  -----------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_statue", win_statue, "rm_oldchapel" );
  
end;
--*********************************************************************************************************************
function private.zz_statue.StartConditions()
  
  ng_global.progress[ ng_global.currentprogress ][ "win_statue" ].skip = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_statue" ].state = { 7, 6, 5, 1, 2, 8, 3, 4 };
  
end;
-----------------------------------------------------------------------------------
function public.zz_statue.Reset()
  
  local need_r = false;
  local table_r = {};
  local old_chains = private.zz_statue.GetChains();
  
  for i = 1, 8, 1 do
    
    if private.zz_statue.state[i] ~= private.zz_statue.start[i] then
      
      if not need_r then
        need_r = true;
      end;
      
      table.insert( table_r, private.zz_statue.state[i] );
      ObjAnimate("spr_statue_ring_pic_"..private.zz_statue.state[i], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  end;
  
  for i = 1, 12, 1 do
    
    if old_chains[i] == 1 then
      ObjAnimate("spr_statue_chain_"..i, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    end;
    
  end;
  
  if private.zz_statue.chosen > 0 and need_r then
    ObjAnimate("spr_statue_ring_pic_"..private.zz_statue.chosen.."_select", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
    private.zz_statue.chosen = 0;
  elseif private.zz_statue.chosen > 0 then
    cmn.Lock( 1 );
    ObjAnimate("spr_statue_ring_pic_"..private.zz_statue.chosen.."_select", "alp", 0, 0, function () cmn.Lock(0); end, { 0, 0, 1,   0.3, 0, 0 });
    private.zz_statue.chosen = 0;
  end;
  
  local anm_end = function ()
    
    for i = 1, #table_r, 1 do
      
      local pos = 0;
      for j = 1, 8, 1 do
        
        if private.zz_statue.start[j] == table_r[i] then
          pos = j;
          break;
        end;
        
      end;
      
      ObjAttach("spr_statue_ring_pic_"..table_r[i], "obj_statue_ring_"..pos);
      ObjSet("spr_statue_ring_pic_"..table_r[i].."_win",  { alp = 0 });
      ObjAnimate("spr_statue_ring_pic_"..table_r[i], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    ObjSet("tmr_statue_timer",  { time = 0.3, playing = 1, endtrig = function() private.zz_statue.DrawScene(); cmn.Lock(0); end });
    
  end;
  
  if need_r then
    
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_hands_reset");
    
    cmn.Lock( 1 );
    private.zz_statue.StartConditions();
    private.zz_statue.state = ng_global.progress[ ng_global.currentprogress ][ "win_statue" ].state;
    
    ObjSet("tmr_statue_timer",  { time = 0.3, playing = 1, endtrig = anm_end });
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_statue.Skip()
  
  cmn.Lock(1);
  cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_hands_skip");
  
  ng_global.progress[ ng_global.currentprogress ][ "win_statue" ].skip = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_statue" ].state = { 1, 2, 3, 4, 5, 6, 7, 8 };
  
  local table_r = {};
  local old_chains = private.zz_statue.GetChains();
  
  for i = 1, 8, 1 do
    
    if private.zz_statue.state[i] ~= i then
      
      table.insert( table_r, private.zz_statue.state[i] );
      ObjAnimate("spr_statue_ring_pic_"..private.zz_statue.state[i], "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
      
    end;
    
  end;
  
  local anm_end = function ()
    
    for i = 1, 12, 1 do
      
      if old_chains[i] == 0 then
        ObjAnimate("spr_statue_chain_"..i, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      end;
      
    end;
    
    for i = 1, #table_r, 1 do
      
      ObjAttach("spr_statue_ring_pic_"..table_r[i], "obj_statue_ring_"..table_r[i]);
      ObjSet("spr_statue_ring_pic_"..table_r[i].."_win",  { alp = 1 });
      ObjAnimate("spr_statue_ring_pic_"..table_r[i], "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
      
    end;
    
    ObjSet("tmr_statue_timer",  { time = 0.3, playing = 1, endtrig = private.zz_statue.CheckWin });
    
  end;
  
  if private.zz_statue.chosen > 0 then
    ObjAnimate("spr_statue_ring_pic_"..private.zz_statue.chosen.."_select", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  end;
  
  private.zz_statue.state = ng_global.progress[ ng_global.currentprogress ][ "win_statue" ].state;
    
  ObjSet("tmr_statue_timer",  { time = 0.3, playing = 1, endtrig = anm_end });
  
end;
-----------------------------------------------------------------------------------
function private.zz_statue.DrawScene()
  
  local chains = private.zz_statue.GetChains();
  
  for i = 1, 8, 1 do
  
    ObjAttach("spr_statue_ring_pic_"..private.zz_statue.state[i], "obj_statue_ring_"..i);
    
    if (private.zz_statue.state[i] == i) then
      ObjMultiSet( { {"obj_state_place_"..i, { input = 0 }},
                     {"spr_statue_ring_pic_"..i.."_win", { alp = 1 }} } );
    else
      ObjMultiSet( { {"obj_state_place_"..i, { input = 1 }},
                     {"spr_statue_ring_pic_"..i.."_win", { alp = 0 }} } );
    end;
    
  end;

  for i = 1, 12, 1 do
    
    if (chains[i] == 1) then
      ObjSet("spr_statue_chain_"..i,  { alp = 1 });
    end;
    
  end;
  
end;
-----------------------------------------------------------------------------------
function public.zz_statue.FocusRing( num, inout )
  
  local pic = private.zz_statue.state[num];
  local obj = "spr_statue_ring_pic_"..pic;
  local scale = ObjGet( obj ).scale_x;
  local tme = 0;
  local max_scale = 1.15;  
  local max_tme = 0.3;
  local end_scale = 1;

  if inout == 0 then
    SetCursor(CURSOR_DEFAULT);
    tme = ( ( scale - 1 ) * max_tme ) / ( max_scale - 1 );
  else 
    SetCursor(CURSOR_HAND);
    end_scale = max_scale;
    tme = ( ( max_scale - scale ) * max_tme ) / ( max_scale - 1 );
    if tme > 0.2 then
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_hands_arrow_"..math.random(1,3));
    end;
  end;

  ObjAnimate(obj, "scale_xy", 0, 0, "", { 0, 2, scale, scale,   tme, 2, end_scale, end_scale });
  
end;
-----------------------------------------------------------------------------------
function public.zz_statue.ClickRing( place )

  cmn.Lock( 1 );
  
  local num = private.zz_statue.state[place];

  --change ring places
  if private.zz_statue.chosen ~= 0 then

    --cancel chosen ring
    if private.zz_statue.chosen == num then
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_hands_click");

      private.zz_statue.chosen = 0;
      ObjAnimate("spr_statue_ring_pic_"..num.."_select", "alp", 0, 0, function () cmn.Lock(0); end, { 0, 0, 1,   0.3, 0, 0 });

    else 
        
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_hands_change");
        
      local chains = private.zz_statue.GetChains();

      local first_ring = private.zz_statue.chosen;
      local first_ring_pos = private.zz_statue.FindIndex( first_ring );
      local second_ring_pos = private.zz_statue.FindIndex( num );

      private.zz_statue.chosen = 0;
      private.zz_statue.state[first_ring_pos] = num;
      private.zz_statue.state[second_ring_pos] = first_ring;

      local change_ring_places = function ()
        
        ObjAttach("spr_statue_ring_pic_"..num, "obj_statue_ring_"..first_ring_pos);
        ObjAttach("spr_statue_ring_pic_"..first_ring, "obj_statue_ring_"..second_ring_pos);
        
        ObjMultiSet( { {"spr_statue_ring_pic_"..first_ring.."_select",  { alp = 0 }},
                       {"spr_statue_ring_pic_"..num, { scale_x = 1, scale_y = 1 }} } );

        ObjAnimate("spr_statue_ring_pic_"..num, "alp", 0, 0, function () private.zz_statue.CheckRings( first_ring, num, first_ring_pos, second_ring_pos, chains ); end, { 0, 0, 0,   0.3, 0, 1 });
        ObjAnimate("spr_statue_ring_pic_"..first_ring, "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });

      end;

      ObjAnimate("spr_statue_ring_pic_"..num, "alp", 0, 0, change_ring_places, { 0, 0, 1,   0.3, 0, 0 });
      ObjAnimate("spr_statue_ring_pic_"..first_ring, "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });

    end;

  --choose ring
  else 
  
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_hands_click");

    private.zz_statue.chosen = num;
    ObjAnimate("spr_statue_ring_pic_"..num.."_select", "alp", 0, 0, function () cmn.Lock(0); end, { 0, 0, 0,   0.3, 0, 1 });

  end;

end;
-----------------------------------------------------------------------------------
--light up chains and symbols
function private.zz_statue.CheckRings( ring1, ring2, old_pos1, old_pos2, old_chains )

  local new_chains = private.zz_statue.GetChains();
  local flag = false;
  local sfx_flag = false;
  
  if ring1 == old_pos2 then
    flag = true;
    sfx_flag = true;
    ObjSet("obj_state_place_"..ring1,  { input = 0 });
    ObjAnimate("spr_statue_ring_pic_"..ring1.."_win", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
  elseif ring1 == old_pos1 then
    flag = true;
    ObjAnimate("spr_statue_ring_pic_"..ring1.."_win", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  end;
  
  if ring2 == old_pos1 then
    flag = true;
    sfx_flag = true;
    ObjSet("obj_state_place_"..ring2,  { input = 0 });
    ObjAnimate("spr_statue_ring_pic_"..ring2.."_win", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 });
  elseif ring2 == old_pos2 then
    flag = true;
    ObjAnimate("spr_statue_ring_pic_"..ring2.."_win", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 });
  end;
  
  for i = 1, 12, 1 do
    
    if old_chains[i] ~= new_chains[i] then
      
      flag = true;
      ObjAnimate("spr_statue_chain_"..i, "alp", 0, 0, "", { 0, 0, old_chains[i],   0.3, 0, new_chains[i] });
      
    end;
    
  end;
  
  if sfx_flag then
    cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_hands_right");
  end;
  
  if flag then
    ObjSet("tmr_statue_timer",  { time = 0.3, playing = 1, endtrig = private.zz_statue.CheckWin });
  else
    private.zz_statue.CheckWin();
  end;

end;
-----------------------------------------------------------------------------------
function private.zz_statue.GetChains()
  
  local chains = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  
  for i = 1, 8, 1 do
    
    if private.zz_statue.state[i] == i then
      
      for j = 1, #private.zz_statue.win_chains[i], 1 do
        
        chains[ private.zz_statue.win_chains[i][j] ] = 1;
        
      end;
      
    else 
      
      for j = 1, #private.zz_statue.additive_chains[ private.zz_statue.state[i] ], 1 do
      
        if i == private.zz_statue.additive_chains[ private.zz_statue.state[i] ][j][1] then
          chains[ private.zz_statue.additive_chains[ private.zz_statue.state[i] ][j][2] ] = 1;
        end;
        
      end;
      
    end;

  end;
  
  return chains;
  
end;
-----------------------------------------------------------------------------------
function private.zz_statue.FindIndex( ring )
  
  local ind = 0;
  
  for i = 1, 8, 1 do
    
    if private.zz_statue.state[i] == ring then
      ind = i;
      break;
    end;
    
  end;
  
  return ind;
  
end;
-----------------------------------------------------------------------------------
function private.zz_statue.CheckWin()
  
  local win_flag = true;
  
  for i = 1, 8, 1 do
    
    if private.zz_statue.state[i] ~= i then
      win_flag = false;
      break;
    end;
    
  end;
  
  if win_flag then
    
    cmn.Lock( 1 );
    
    common_impl.PauseAchiev(1);
    cmn.MiniGameHide("statue");
    
    local anm_win_2 = function ()
      
      ObjAnimate("obj_statue_hand_1", "pos_xy", 0, 0, private.zz_statue.Win, { 0, 0, -10, 0,   1, 0, -141, 468 });
      ObjAnimate("obj_statue_hand_2", "pos_xy", 0, 0, "", { 0, 0, 10, 0,   1, 0, 164, 468 });
      
    end;
    
    local anm_win = function ()
      
      cmn.PlayAudio("snd", "assets/levels/level4/audio/sfx/aud_mmg_hands_win");
      
      ObjAnimate("obj_statue_hand_1", "pos_x", 0, 0, anm_win_2, { 0, 0, 0,   0.5, 0, -10 });
      ObjAnimate("obj_statue_hand_2", "pos_x", 0, 0, "", { 0, 0, 0,   0.5, 0, 10 });
      
    end;

    cmn.Lock( 1 );

    ObjSet("tmr_statue_timer",  { time = 1, playing = 1, endtrig = anm_win });
    
  else
    cmn.Lock(0);
  end;
  
end;
-----------------------------------------------------------------------------------
function private.zz_statue.Win()
  
  cmn.Lock( 0 );
  common_impl.PauseAchiev(0);

  cmn.SetEventDone( "win_statue" );
  cmn.CallEventHandler( "win_statue" );

  if ng_global.progress[ ng_global.currentprogress ][ "win_statue" ].skip == 0 and ng_global.noskipgames[ "win_statue" ] == nil then

    ng_global.noskipgames[ "win_statue" ] = 1;
    common_impl.CheckAchiev("mg");

  end;
  
end;
--**************************************************************************************************************